//! moment.js
//! version : 2.29.4
//! authors : Tim Wood, Iskren Chernev, Moment.js contributors
//! license : MIT
//! momentjs.com
function decode(t){let e=t.toLowerCase(),n=e.lastIndexOf("1"),i=e.substring(0,n),r=e.substring(n+1,e.length-6),o=e.substring(e.length-6,e.length);if(!verify_checksum(i,bech32ToFiveBitArray(r+o)))throw"Malformed request: checksum is incorrect";return{human_readable_part:decodeHumanReadablePart(i),data:decodeData(r,i),checksum:o}}function decodeHumanReadablePart(t){let e;if(["lnbc","lntb","lnbcrt","lnsb"].forEach((n=>{t.substring(0,n.length)===n&&(e=n)})),null==e)throw"Malformed request: unknown prefix";let n=decodeAmount(t.substring(e.length,t.length));return{prefix:e,amount:n}}function decodeData(t,e){let n=t.substring(0,7),i=bech32ToInt(n),r=t.substring(t.length-104,t.length),o=t.substring(7,t.length-104),a=decodeTags(o),s=bech32ToFiveBitArray(n+o);return s=fiveBitArrayTo8BitArray(s,!0),s=textToHexString(e).concat(byteArrayToHexString(s)),{time_stamp:i,tags:a,signature:decodeSignature(r),signing_data:s}}function decodeSignature(t){let e=fiveBitArrayTo8BitArray(bech32ToFiveBitArray(t)),n=e[e.length-1];return{r:byteArrayToHexString(e.slice(0,32)),s:byteArrayToHexString(e.slice(32,e.length-1)),recovery_flag:n}}function decodeAmount(t){let e=t.charAt(t.length-1),n=t.substring(0,t.length-1);if("0"===n.substring(0,1))throw"Malformed request: amount cannot contain leading zeros";if(n=Number(n),n<0||!Number.isInteger(n))throw"Malformed request: amount must be a positive decimal integer";switch(e){case"":return"Any amount";case"p":return n/10;case"n":return 100*n;case"u":return 1e5*n;case"m":return 1e8*n;default:throw"Malformed request: undefined amount multiplier"}}function decodeTags(t){let e=extractTags(t),n=[];return e.forEach((t=>n.push(decodeTag(t.type,t.length,t.data)))),n}function extractTags(t){let e=[];for(;t.length>0;){let n=t.charAt(0),i=bech32ToInt(t.substring(1,3)),r=t.substring(3,i+3);e.push({type:n,length:i,data:r}),t=t.substring(3+i,t.length)}return e}function decodeTag(t,e,n){switch(t){case"p":if(52!==e)break;return{type:t,length:e,description:"payment_hash",value:byteArrayToHexString(fiveBitArrayTo8BitArray(bech32ToFiveBitArray(n)))};case"d":return{type:t,length:e,description:"description",value:bech32ToUTF8String(n)};case"n":if(53!==e)break;return{type:t,length:e,description:"payee_public_key",value:byteArrayToHexString(fiveBitArrayTo8BitArray(bech32ToFiveBitArray(n)))};case"h":if(52!==e)break;return{type:t,length:e,description:"description_hash",value:n};case"x":return{type:t,length:e,description:"expiry",value:bech32ToInt(n)};case"c":return{type:t,length:e,description:"min_final_cltv_expiry",value:bech32ToInt(n)};case"f":let i=bech32ToFiveBitArray(n.charAt(0))[0];if(i<0||i>18)break;return{type:t,length:e,description:"fallback_address",value:{version:i,fallback_address:n=n.substring(1,n.length)}};case"r":let r=(n=fiveBitArrayTo8BitArray(bech32ToFiveBitArray(n))).slice(0,33),o=n.slice(33,41),a=n.slice(41,45),s=n.slice(45,49),l=n.slice(49,51);return{type:t,length:e,description:"routing_information",value:{public_key:byteArrayToHexString(r),short_channel_id:byteArrayToHexString(o),fee_base_msat:byteArrayToInt(a),fee_proportional_millionths:byteArrayToInt(s),cltv_expiry_delta:byteArrayToInt(l)}}}}function polymod(t){let e=[996825010,642813549,513874426,1027748829,705979059],n=1;return t.forEach((t=>{let i=n>>25;n=(33554431&n)<<5^t;for(let t=0;t<5;t++)n^=1==(i>>t&1)?e[t]:0})),n}function expand(t){let e=[];for(let n=0;n<t.length;n++)e.push(t.charCodeAt(n)>>5);e.push(0);for(let n=0;n<t.length;n++)e.push(31&t.charCodeAt(n));return e}function verify_checksum(t,e){return 1===polymod((t=expand(t)).concat(e))}!function(t,e){"object"==typeof exports&&"undefined"!=typeof module?module.exports=e():"function"==typeof define&&define.amd?define(e):t.moment=e()}(this,(function(){"use strict";var t,e;function n(){return t.apply(null,arguments)}function i(t){return t instanceof Array||"[object Array]"===Object.prototype.toString.call(t)}function r(t){return null!=t&&"[object Object]"===Object.prototype.toString.call(t)}function o(t,e){return Object.prototype.hasOwnProperty.call(t,e)}function a(t){if(Object.getOwnPropertyNames)return 0===Object.getOwnPropertyNames(t).length;var e;for(e in t)if(o(t,e))return!1;return!0}function s(t){return void 0===t}function l(t){return"number"==typeof t||"[object Number]"===Object.prototype.toString.call(t)}function c(t){return t instanceof Date||"[object Date]"===Object.prototype.toString.call(t)}function u(t,e){var n,i=[],r=t.length;for(n=0;n<r;++n)i.push(e(t[n],n));return i}function d(t,e){for(var n in e)o(e,n)&&(t[n]=e[n]);return o(e,"toString")&&(t.toString=e.toString),o(e,"valueOf")&&(t.valueOf=e.valueOf),t}function h(t,e,n,i){return Ae(t,e,n,i,!0).utc()}function f(t){return null==t._pf&&(t._pf={empty:!1,unusedTokens:[],unusedInput:[],overflow:-2,charsLeftOver:0,nullInput:!1,invalidEra:null,invalidMonth:null,invalidFormat:!1,userInvalidated:!1,iso:!1,parsedDateParts:[],era:null,meridiem:null,rfc2822:!1,weekdayMismatch:!1}),t._pf}function p(t){if(null==t._isValid){var n=f(t),i=e.call(n.parsedDateParts,(function(t){return null!=t})),r=!isNaN(t._d.getTime())&&n.overflow<0&&!n.empty&&!n.invalidEra&&!n.invalidMonth&&!n.invalidWeekday&&!n.weekdayMismatch&&!n.nullInput&&!n.invalidFormat&&!n.userInvalidated&&(!n.meridiem||n.meridiem&&i);if(t._strict&&(r=r&&0===n.charsLeftOver&&0===n.unusedTokens.length&&void 0===n.bigHour),null!=Object.isFrozen&&Object.isFrozen(t))return r;t._isValid=r}return t._isValid}function m(t){var e=h(NaN);return null!=t?d(f(e),t):f(e).userInvalidated=!0,e}e=Array.prototype.some?Array.prototype.some:function(t){var e,n=Object(this),i=n.length>>>0;for(e=0;e<i;e++)if(e in n&&t.call(this,n[e],e,n))return!0;return!1};var v=n.momentProperties=[],g=!1;function y(t,e){var n,i,r,o=v.length;if(s(e._isAMomentObject)||(t._isAMomentObject=e._isAMomentObject),s(e._i)||(t._i=e._i),s(e._f)||(t._f=e._f),s(e._l)||(t._l=e._l),s(e._strict)||(t._strict=e._strict),s(e._tzm)||(t._tzm=e._tzm),s(e._isUTC)||(t._isUTC=e._isUTC),s(e._offset)||(t._offset=e._offset),s(e._pf)||(t._pf=f(e)),s(e._locale)||(t._locale=e._locale),o>0)for(n=0;n<o;n++)s(r=e[i=v[n]])||(t[i]=r);return t}function _(t){y(this,t),this._d=new Date(null!=t._d?t._d.getTime():NaN),this.isValid()||(this._d=new Date(NaN)),!1===g&&(g=!0,n.updateOffset(this),g=!1)}function b(t){return t instanceof _||null!=t&&null!=t._isAMomentObject}function w(t){!1===n.suppressDeprecationWarnings&&"undefined"!=typeof console&&console.warn&&console.warn("Deprecation warning: "+t)}function k(t,e){var i=!0;return d((function(){if(null!=n.deprecationHandler&&n.deprecationHandler(null,t),i){var r,a,s,l=[],c=arguments.length;for(a=0;a<c;a++){if(r="","object"==typeof arguments[a]){for(s in r+="\n["+a+"] ",arguments[0])o(arguments[0],s)&&(r+=s+": "+arguments[0][s]+", ");r=r.slice(0,-2)}else r=arguments[a];l.push(r)}w(t+"\nArguments: "+Array.prototype.slice.call(l).join("")+"\n"+(new Error).stack),i=!1}return e.apply(this,arguments)}),e)}var x,C={};function S(t,e){null!=n.deprecationHandler&&n.deprecationHandler(t,e),C[t]||(w(e),C[t]=!0)}function M(t){return"undefined"!=typeof Function&&t instanceof Function||"[object Function]"===Object.prototype.toString.call(t)}function T(t,e){var n,i=d({},t);for(n in e)o(e,n)&&(r(t[n])&&r(e[n])?(i[n]={},d(i[n],t[n]),d(i[n],e[n])):null!=e[n]?i[n]=e[n]:delete i[n]);for(n in t)o(t,n)&&!o(e,n)&&r(t[n])&&(i[n]=d({},i[n]));return i}function P(t){null!=t&&this.set(t)}n.suppressDeprecationWarnings=!1,n.deprecationHandler=null,x=Object.keys?Object.keys:function(t){var e,n=[];for(e in t)o(t,e)&&n.push(e);return n};function O(t,e,n){var i=""+Math.abs(t),r=e-i.length;return(t>=0?n?"+":"":"-")+Math.pow(10,Math.max(0,r)).toString().substr(1)+i}var B=/(\[[^\[]*\])|(\\)?([Hh]mm(ss)?|Mo|MM?M?M?|Do|DDDo|DD?D?D?|ddd?d?|do?|w[o|w]?|W[o|W]?|Qo?|N{1,5}|YYYYYY|YYYYY|YYYY|YY|y{2,4}|yo?|gg(ggg?)?|GG(GGG?)?|e|E|a|A|hh?|HH?|kk?|mm?|ss?|S{1,9}|x|X|zz?|ZZ?|.)/g,E=/(\[[^\[]*\])|(\\)?(LTS|LT|LL?L?L?|l{1,4})/g,A={},D={};function L(t,e,n,i){var r=i;"string"==typeof i&&(r=function(){return this[i]()}),t&&(D[t]=r),e&&(D[e[0]]=function(){return O(r.apply(this,arguments),e[1],e[2])}),n&&(D[n]=function(){return this.localeData().ordinal(r.apply(this,arguments),t)})}function q(t,e){return t.isValid()?(e=R(e,t.localeData()),A[e]=A[e]||function(t){var e,n,i,r=t.match(B);for(e=0,n=r.length;e<n;e++)D[r[e]]?r[e]=D[r[e]]:r[e]=(i=r[e]).match(/\[[\s\S]/)?i.replace(/^\[|\]$/g,""):i.replace(/\\/g,"");return function(e){var i,o="";for(i=0;i<n;i++)o+=M(r[i])?r[i].call(e,t):r[i];return o}}(e),A[e](t)):t.localeData().invalidDate()}function R(t,e){var n=5;function i(t){return e.longDateFormat(t)||t}for(E.lastIndex=0;n>=0&&E.test(t);)t=t.replace(E,i),E.lastIndex=0,n-=1;return t}var I={};function N(t,e){var n=t.toLowerCase();I[n]=I[n+"s"]=I[e]=t}function F(t){return"string"==typeof t?I[t]||I[t.toLowerCase()]:void 0}function $(t){var e,n,i={};for(n in t)o(t,n)&&(e=F(n))&&(i[e]=t[n]);return i}var j={};function z(t,e){j[t]=e}function V(t){return t%4==0&&t%100!=0||t%400==0}function H(t){return t<0?Math.ceil(t)||0:Math.floor(t)}function W(t){var e=+t,n=0;return 0!==e&&isFinite(e)&&(n=H(e)),n}function U(t,e){return function(i){return null!=i?(Q(this,t,i),n.updateOffset(this,e),this):Y(this,t)}}function Y(t,e){return t.isValid()?t._d["get"+(t._isUTC?"UTC":"")+e]():NaN}function Q(t,e,n){t.isValid()&&!isNaN(n)&&("FullYear"===e&&V(t.year())&&1===t.month()&&29===t.date()?(n=W(n),t._d["set"+(t._isUTC?"UTC":"")+e](n,t.month(),Ot(n,t.month()))):t._d["set"+(t._isUTC?"UTC":"")+e](n))}var G,K=/\d/,J=/\d\d/,Z=/\d{3}/,X=/\d{4}/,tt=/[+-]?\d{6}/,et=/\d\d?/,nt=/\d\d\d\d?/,it=/\d\d\d\d\d\d?/,rt=/\d{1,3}/,ot=/\d{1,4}/,at=/[+-]?\d{1,6}/,st=/\d+/,lt=/[+-]?\d+/,ct=/Z|[+-]\d\d:?\d\d/gi,ut=/Z|[+-]\d\d(?::?\d\d)?/gi,dt=/[0-9]{0,256}['a-z\u00A0-\u05FF\u0700-\uD7FF\uF900-\uFDCF\uFDF0-\uFF07\uFF10-\uFFEF]{1,256}|[\u0600-\u06FF\/]{1,256}(\s*?[\u0600-\u06FF]{1,256}){1,2}/i;function ht(t,e,n){G[t]=M(e)?e:function(t,i){return t&&n?n:e}}function ft(t,e){return o(G,t)?G[t](e._strict,e._locale):new RegExp(pt(t.replace("\\","").replace(/\\(\[)|\\(\])|\[([^\]\[]*)\]|\\(.)/g,(function(t,e,n,i,r){return e||n||i||r}))))}function pt(t){return t.replace(/[-\/\\^$*+?.()|[\]{}]/g,"\\$&")}G={};var mt={};function vt(t,e){var n,i,r=e;for("string"==typeof t&&(t=[t]),l(e)&&(r=function(t,n){n[e]=W(t)}),i=t.length,n=0;n<i;n++)mt[t[n]]=r}function gt(t,e){vt(t,(function(t,n,i,r){i._w=i._w||{},e(t,i._w,i,r)}))}function yt(t,e,n){null!=e&&o(mt,t)&&mt[t](e,n._a,n,t)}var _t,bt=0,wt=1,kt=2,xt=3,Ct=4,St=5,Mt=6,Tt=7,Pt=8;function Ot(t,e){if(isNaN(t)||isNaN(e))return NaN;var n,i=(e%(n=12)+n)%n;return t+=(e-i)/12,1===i?V(t)?29:28:31-i%7%2}_t=Array.prototype.indexOf?Array.prototype.indexOf:function(t){var e;for(e=0;e<this.length;++e)if(this[e]===t)return e;return-1},L("M",["MM",2],"Mo",(function(){return this.month()+1})),L("MMM",0,0,(function(t){return this.localeData().monthsShort(this,t)})),L("MMMM",0,0,(function(t){return this.localeData().months(this,t)})),N("month","M"),z("month",8),ht("M",et),ht("MM",et,J),ht("MMM",(function(t,e){return e.monthsShortRegex(t)})),ht("MMMM",(function(t,e){return e.monthsRegex(t)})),vt(["M","MM"],(function(t,e){e[wt]=W(t)-1})),vt(["MMM","MMMM"],(function(t,e,n,i){var r=n._locale.monthsParse(t,i,n._strict);null!=r?e[wt]=r:f(n).invalidMonth=t}));var Bt="January_February_March_April_May_June_July_August_September_October_November_December".split("_"),Et="Jan_Feb_Mar_Apr_May_Jun_Jul_Aug_Sep_Oct_Nov_Dec".split("_"),At=/D[oD]?(\[[^\[\]]*\]|\s)+MMMM?/,Dt=dt,Lt=dt;function qt(t,e,n){var i,r,o,a=t.toLocaleLowerCase();if(!this._monthsParse)for(this._monthsParse=[],this._longMonthsParse=[],this._shortMonthsParse=[],i=0;i<12;++i)o=h([2e3,i]),this._shortMonthsParse[i]=this.monthsShort(o,"").toLocaleLowerCase(),this._longMonthsParse[i]=this.months(o,"").toLocaleLowerCase();return n?"MMM"===e?-1!==(r=_t.call(this._shortMonthsParse,a))?r:null:-1!==(r=_t.call(this._longMonthsParse,a))?r:null:"MMM"===e?-1!==(r=_t.call(this._shortMonthsParse,a))||-1!==(r=_t.call(this._longMonthsParse,a))?r:null:-1!==(r=_t.call(this._longMonthsParse,a))||-1!==(r=_t.call(this._shortMonthsParse,a))?r:null}function Rt(t,e){var n;if(!t.isValid())return t;if("string"==typeof e)if(/^\d+$/.test(e))e=W(e);else if(!l(e=t.localeData().monthsParse(e)))return t;return n=Math.min(t.date(),Ot(t.year(),e)),t._d["set"+(t._isUTC?"UTC":"")+"Month"](e,n),t}function It(t){return null!=t?(Rt(this,t),n.updateOffset(this,!0),this):Y(this,"Month")}function Nt(){function t(t,e){return e.length-t.length}var e,n,i=[],r=[],o=[];for(e=0;e<12;e++)n=h([2e3,e]),i.push(this.monthsShort(n,"")),r.push(this.months(n,"")),o.push(this.months(n,"")),o.push(this.monthsShort(n,""));for(i.sort(t),r.sort(t),o.sort(t),e=0;e<12;e++)i[e]=pt(i[e]),r[e]=pt(r[e]);for(e=0;e<24;e++)o[e]=pt(o[e]);this._monthsRegex=new RegExp("^("+o.join("|")+")","i"),this._monthsShortRegex=this._monthsRegex,this._monthsStrictRegex=new RegExp("^("+r.join("|")+")","i"),this._monthsShortStrictRegex=new RegExp("^("+i.join("|")+")","i")}function Ft(t){return V(t)?366:365}L("Y",0,0,(function(){var t=this.year();return t<=9999?O(t,4):"+"+t})),L(0,["YY",2],0,(function(){return this.year()%100})),L(0,["YYYY",4],0,"year"),L(0,["YYYYY",5],0,"year"),L(0,["YYYYYY",6,!0],0,"year"),N("year","y"),z("year",1),ht("Y",lt),ht("YY",et,J),ht("YYYY",ot,X),ht("YYYYY",at,tt),ht("YYYYYY",at,tt),vt(["YYYYY","YYYYYY"],bt),vt("YYYY",(function(t,e){e[bt]=2===t.length?n.parseTwoDigitYear(t):W(t)})),vt("YY",(function(t,e){e[bt]=n.parseTwoDigitYear(t)})),vt("Y",(function(t,e){e[bt]=parseInt(t,10)})),n.parseTwoDigitYear=function(t){return W(t)+(W(t)>68?1900:2e3)};var $t=U("FullYear",!0);function jt(t,e,n,i,r,o,a){var s;return t<100&&t>=0?(s=new Date(t+400,e,n,i,r,o,a),isFinite(s.getFullYear())&&s.setFullYear(t)):s=new Date(t,e,n,i,r,o,a),s}function zt(t){var e,n;return t<100&&t>=0?((n=Array.prototype.slice.call(arguments))[0]=t+400,e=new Date(Date.UTC.apply(null,n)),isFinite(e.getUTCFullYear())&&e.setUTCFullYear(t)):e=new Date(Date.UTC.apply(null,arguments)),e}function Vt(t,e,n){var i=7+e-n;return-((7+zt(t,0,i).getUTCDay()-e)%7)+i-1}function Ht(t,e,n,i,r){var o,a,s=1+7*(e-1)+(7+n-i)%7+Vt(t,i,r);return s<=0?a=Ft(o=t-1)+s:s>Ft(t)?(o=t+1,a=s-Ft(t)):(o=t,a=s),{year:o,dayOfYear:a}}function Wt(t,e,n){var i,r,o=Vt(t.year(),e,n),a=Math.floor((t.dayOfYear()-o-1)/7)+1;return a<1?i=a+Ut(r=t.year()-1,e,n):a>Ut(t.year(),e,n)?(i=a-Ut(t.year(),e,n),r=t.year()+1):(r=t.year(),i=a),{week:i,year:r}}function Ut(t,e,n){var i=Vt(t,e,n),r=Vt(t+1,e,n);return(Ft(t)-i+r)/7}L("w",["ww",2],"wo","week"),L("W",["WW",2],"Wo","isoWeek"),N("week","w"),N("isoWeek","W"),z("week",5),z("isoWeek",5),ht("w",et),ht("ww",et,J),ht("W",et),ht("WW",et,J),gt(["w","ww","W","WW"],(function(t,e,n,i){e[i.substr(0,1)]=W(t)}));function Yt(t,e){return t.slice(e,7).concat(t.slice(0,e))}L("d",0,"do","day"),L("dd",0,0,(function(t){return this.localeData().weekdaysMin(this,t)})),L("ddd",0,0,(function(t){return this.localeData().weekdaysShort(this,t)})),L("dddd",0,0,(function(t){return this.localeData().weekdays(this,t)})),L("e",0,0,"weekday"),L("E",0,0,"isoWeekday"),N("day","d"),N("weekday","e"),N("isoWeekday","E"),z("day",11),z("weekday",11),z("isoWeekday",11),ht("d",et),ht("e",et),ht("E",et),ht("dd",(function(t,e){return e.weekdaysMinRegex(t)})),ht("ddd",(function(t,e){return e.weekdaysShortRegex(t)})),ht("dddd",(function(t,e){return e.weekdaysRegex(t)})),gt(["dd","ddd","dddd"],(function(t,e,n,i){var r=n._locale.weekdaysParse(t,i,n._strict);null!=r?e.d=r:f(n).invalidWeekday=t})),gt(["d","e","E"],(function(t,e,n,i){e[i]=W(t)}));var Qt="Sunday_Monday_Tuesday_Wednesday_Thursday_Friday_Saturday".split("_"),Gt="Sun_Mon_Tue_Wed_Thu_Fri_Sat".split("_"),Kt="Su_Mo_Tu_We_Th_Fr_Sa".split("_"),Jt=dt,Zt=dt,Xt=dt;function te(t,e,n){var i,r,o,a=t.toLocaleLowerCase();if(!this._weekdaysParse)for(this._weekdaysParse=[],this._shortWeekdaysParse=[],this._minWeekdaysParse=[],i=0;i<7;++i)o=h([2e3,1]).day(i),this._minWeekdaysParse[i]=this.weekdaysMin(o,"").toLocaleLowerCase(),this._shortWeekdaysParse[i]=this.weekdaysShort(o,"").toLocaleLowerCase(),this._weekdaysParse[i]=this.weekdays(o,"").toLocaleLowerCase();return n?"dddd"===e?-1!==(r=_t.call(this._weekdaysParse,a))?r:null:"ddd"===e?-1!==(r=_t.call(this._shortWeekdaysParse,a))?r:null:-1!==(r=_t.call(this._minWeekdaysParse,a))?r:null:"dddd"===e?-1!==(r=_t.call(this._weekdaysParse,a))||-1!==(r=_t.call(this._shortWeekdaysParse,a))||-1!==(r=_t.call(this._minWeekdaysParse,a))?r:null:"ddd"===e?-1!==(r=_t.call(this._shortWeekdaysParse,a))||-1!==(r=_t.call(this._weekdaysParse,a))||-1!==(r=_t.call(this._minWeekdaysParse,a))?r:null:-1!==(r=_t.call(this._minWeekdaysParse,a))||-1!==(r=_t.call(this._weekdaysParse,a))||-1!==(r=_t.call(this._shortWeekdaysParse,a))?r:null}function ee(){function t(t,e){return e.length-t.length}var e,n,i,r,o,a=[],s=[],l=[],c=[];for(e=0;e<7;e++)n=h([2e3,1]).day(e),i=pt(this.weekdaysMin(n,"")),r=pt(this.weekdaysShort(n,"")),o=pt(this.weekdays(n,"")),a.push(i),s.push(r),l.push(o),c.push(i),c.push(r),c.push(o);a.sort(t),s.sort(t),l.sort(t),c.sort(t),this._weekdaysRegex=new RegExp("^("+c.join("|")+")","i"),this._weekdaysShortRegex=this._weekdaysRegex,this._weekdaysMinRegex=this._weekdaysRegex,this._weekdaysStrictRegex=new RegExp("^("+l.join("|")+")","i"),this._weekdaysShortStrictRegex=new RegExp("^("+s.join("|")+")","i"),this._weekdaysMinStrictRegex=new RegExp("^("+a.join("|")+")","i")}function ne(){return this.hours()%12||12}function ie(t,e){L(t,0,0,(function(){return this.localeData().meridiem(this.hours(),this.minutes(),e)}))}function re(t,e){return e._meridiemParse}L("H",["HH",2],0,"hour"),L("h",["hh",2],0,ne),L("k",["kk",2],0,(function(){return this.hours()||24})),L("hmm",0,0,(function(){return""+ne.apply(this)+O(this.minutes(),2)})),L("hmmss",0,0,(function(){return""+ne.apply(this)+O(this.minutes(),2)+O(this.seconds(),2)})),L("Hmm",0,0,(function(){return""+this.hours()+O(this.minutes(),2)})),L("Hmmss",0,0,(function(){return""+this.hours()+O(this.minutes(),2)+O(this.seconds(),2)})),ie("a",!0),ie("A",!1),N("hour","h"),z("hour",13),ht("a",re),ht("A",re),ht("H",et),ht("h",et),ht("k",et),ht("HH",et,J),ht("hh",et,J),ht("kk",et,J),ht("hmm",nt),ht("hmmss",it),ht("Hmm",nt),ht("Hmmss",it),vt(["H","HH"],xt),vt(["k","kk"],(function(t,e,n){var i=W(t);e[xt]=24===i?0:i})),vt(["a","A"],(function(t,e,n){n._isPm=n._locale.isPM(t),n._meridiem=t})),vt(["h","hh"],(function(t,e,n){e[xt]=W(t),f(n).bigHour=!0})),vt("hmm",(function(t,e,n){var i=t.length-2;e[xt]=W(t.substr(0,i)),e[Ct]=W(t.substr(i)),f(n).bigHour=!0})),vt("hmmss",(function(t,e,n){var i=t.length-4,r=t.length-2;e[xt]=W(t.substr(0,i)),e[Ct]=W(t.substr(i,2)),e[St]=W(t.substr(r)),f(n).bigHour=!0})),vt("Hmm",(function(t,e,n){var i=t.length-2;e[xt]=W(t.substr(0,i)),e[Ct]=W(t.substr(i))})),vt("Hmmss",(function(t,e,n){var i=t.length-4,r=t.length-2;e[xt]=W(t.substr(0,i)),e[Ct]=W(t.substr(i,2)),e[St]=W(t.substr(r))}));var oe=U("Hours",!0);var ae,se={calendar:{sameDay:"[Today at] LT",nextDay:"[Tomorrow at] LT",nextWeek:"dddd [at] LT",lastDay:"[Yesterday at] LT",lastWeek:"[Last] dddd [at] LT",sameElse:"L"},longDateFormat:{LTS:"h:mm:ss A",LT:"h:mm A",L:"MM/DD/YYYY",LL:"MMMM D, YYYY",LLL:"MMMM D, YYYY h:mm A",LLLL:"dddd, MMMM D, YYYY h:mm A"},invalidDate:"Invalid date",ordinal:"%d",dayOfMonthOrdinalParse:/\d{1,2}/,relativeTime:{future:"in %s",past:"%s ago",s:"a few seconds",ss:"%d seconds",m:"a minute",mm:"%d minutes",h:"an hour",hh:"%d hours",d:"a day",dd:"%d days",w:"a week",ww:"%d weeks",M:"a month",MM:"%d months",y:"a year",yy:"%d years"},months:Bt,monthsShort:Et,week:{dow:0,doy:6},weekdays:Qt,weekdaysMin:Kt,weekdaysShort:Gt,meridiemParse:/[ap]\.?m?\.?/i},le={},ce={};function ue(t,e){var n,i=Math.min(t.length,e.length);for(n=0;n<i;n+=1)if(t[n]!==e[n])return n;return i}function de(t){return t?t.toLowerCase().replace("_","-"):t}function he(t){var e=null;if(void 0===le[t]&&"undefined"!=typeof module&&module&&module.exports&&function(t){return null!=t.match("^[^/\\\\]*$")}(t))try{e=ae._abbr,require("./locale/"+t),fe(e)}catch(e){le[t]=null}return le[t]}function fe(t,e){var n;return t&&((n=s(e)?me(t):pe(t,e))?ae=n:"undefined"!=typeof console&&console.warn&&console.warn("Locale "+t+" not found. Did you forget to load it?")),ae._abbr}function pe(t,e){if(null!==e){var n,i=se;if(e.abbr=t,null!=le[t])S("defineLocaleOverride","use moment.updateLocale(localeName, config) to change an existing locale. moment.defineLocale(localeName, config) should only be used for creating a new locale See http://momentjs.com/guides/#/warnings/define-locale/ for more info."),i=le[t]._config;else if(null!=e.parentLocale)if(null!=le[e.parentLocale])i=le[e.parentLocale]._config;else{if(null==(n=he(e.parentLocale)))return ce[e.parentLocale]||(ce[e.parentLocale]=[]),ce[e.parentLocale].push({name:t,config:e}),null;i=n._config}return le[t]=new P(T(i,e)),ce[t]&&ce[t].forEach((function(t){pe(t.name,t.config)})),fe(t),le[t]}return delete le[t],null}function me(t){var e;if(t&&t._locale&&t._locale._abbr&&(t=t._locale._abbr),!t)return ae;if(!i(t)){if(e=he(t))return e;t=[t]}return function(t){for(var e,n,i,r,o=0;o<t.length;){for(e=(r=de(t[o]).split("-")).length,n=(n=de(t[o+1]))?n.split("-"):null;e>0;){if(i=he(r.slice(0,e).join("-")))return i;if(n&&n.length>=e&&ue(r,n)>=e-1)break;e--}o++}return ae}(t)}function ve(t){var e,n=t._a;return n&&-2===f(t).overflow&&(e=n[wt]<0||n[wt]>11?wt:n[kt]<1||n[kt]>Ot(n[bt],n[wt])?kt:n[xt]<0||n[xt]>24||24===n[xt]&&(0!==n[Ct]||0!==n[St]||0!==n[Mt])?xt:n[Ct]<0||n[Ct]>59?Ct:n[St]<0||n[St]>59?St:n[Mt]<0||n[Mt]>999?Mt:-1,f(t)._overflowDayOfYear&&(e<bt||e>kt)&&(e=kt),f(t)._overflowWeeks&&-1===e&&(e=Tt),f(t)._overflowWeekday&&-1===e&&(e=Pt),f(t).overflow=e),t}var ge=/^\s*((?:[+-]\d{6}|\d{4})-(?:\d\d-\d\d|W\d\d-\d|W\d\d|\d\d\d|\d\d))(?:(T| )(\d\d(?::\d\d(?::\d\d(?:[.,]\d+)?)?)?)([+-]\d\d(?::?\d\d)?|\s*Z)?)?$/,ye=/^\s*((?:[+-]\d{6}|\d{4})(?:\d\d\d\d|W\d\d\d|W\d\d|\d\d\d|\d\d|))(?:(T| )(\d\d(?:\d\d(?:\d\d(?:[.,]\d+)?)?)?)([+-]\d\d(?::?\d\d)?|\s*Z)?)?$/,_e=/Z|[+-]\d\d(?::?\d\d)?/,be=[["YYYYYY-MM-DD",/[+-]\d{6}-\d\d-\d\d/],["YYYY-MM-DD",/\d{4}-\d\d-\d\d/],["GGGG-[W]WW-E",/\d{4}-W\d\d-\d/],["GGGG-[W]WW",/\d{4}-W\d\d/,!1],["YYYY-DDD",/\d{4}-\d{3}/],["YYYY-MM",/\d{4}-\d\d/,!1],["YYYYYYMMDD",/[+-]\d{10}/],["YYYYMMDD",/\d{8}/],["GGGG[W]WWE",/\d{4}W\d{3}/],["GGGG[W]WW",/\d{4}W\d{2}/,!1],["YYYYDDD",/\d{7}/],["YYYYMM",/\d{6}/,!1],["YYYY",/\d{4}/,!1]],we=[["HH:mm:ss.SSSS",/\d\d:\d\d:\d\d\.\d+/],["HH:mm:ss,SSSS",/\d\d:\d\d:\d\d,\d+/],["HH:mm:ss",/\d\d:\d\d:\d\d/],["HH:mm",/\d\d:\d\d/],["HHmmss.SSSS",/\d\d\d\d\d\d\.\d+/],["HHmmss,SSSS",/\d\d\d\d\d\d,\d+/],["HHmmss",/\d\d\d\d\d\d/],["HHmm",/\d\d\d\d/],["HH",/\d\d/]],ke=/^\/?Date\((-?\d+)/i,xe=/^(?:(Mon|Tue|Wed|Thu|Fri|Sat|Sun),?\s)?(\d{1,2})\s(Jan|Feb|Mar|Apr|May|Jun|Jul|Aug|Sep|Oct|Nov|Dec)\s(\d{2,4})\s(\d\d):(\d\d)(?::(\d\d))?\s(?:(UT|GMT|[ECMP][SD]T)|([Zz])|([+-]\d{4}))$/,Ce={UT:0,GMT:0,EDT:-240,EST:-300,CDT:-300,CST:-360,MDT:-360,MST:-420,PDT:-420,PST:-480};function Se(t){var e,n,i,r,o,a,s=t._i,l=ge.exec(s)||ye.exec(s),c=be.length,u=we.length;if(l){for(f(t).iso=!0,e=0,n=c;e<n;e++)if(be[e][1].exec(l[1])){r=be[e][0],i=!1!==be[e][2];break}if(null==r)return void(t._isValid=!1);if(l[3]){for(e=0,n=u;e<n;e++)if(we[e][1].exec(l[3])){o=(l[2]||" ")+we[e][0];break}if(null==o)return void(t._isValid=!1)}if(!i&&null!=o)return void(t._isValid=!1);if(l[4]){if(!_e.exec(l[4]))return void(t._isValid=!1);a="Z"}t._f=r+(o||"")+(a||""),Be(t)}else t._isValid=!1}function Me(t){var e=parseInt(t,10);return e<=49?2e3+e:e<=999?1900+e:e}function Te(t){var e,n,i,r,o,a,s,l,c=xe.exec(t._i.replace(/\([^()]*\)|[\n\t]/g," ").replace(/(\s\s+)/g," ").replace(/^\s\s*/,"").replace(/\s\s*$/,""));if(c){if(n=c[4],i=c[3],r=c[2],o=c[5],a=c[6],s=c[7],l=[Me(n),Et.indexOf(i),parseInt(r,10),parseInt(o,10),parseInt(a,10)],s&&l.push(parseInt(s,10)),e=l,!function(t,e,n){return!t||Gt.indexOf(t)===new Date(e[0],e[1],e[2]).getDay()||(f(n).weekdayMismatch=!0,n._isValid=!1,!1)}(c[1],e,t))return;t._a=e,t._tzm=function(t,e,n){if(t)return Ce[t];if(e)return 0;var i=parseInt(n,10),r=i%100;return(i-r)/100*60+r}(c[8],c[9],c[10]),t._d=zt.apply(null,t._a),t._d.setUTCMinutes(t._d.getUTCMinutes()-t._tzm),f(t).rfc2822=!0}else t._isValid=!1}function Pe(t,e,n){return null!=t?t:null!=e?e:n}function Oe(t){var e,i,r,o,a,s=[];if(!t._d){for(r=function(t){var e=new Date(n.now());return t._useUTC?[e.getUTCFullYear(),e.getUTCMonth(),e.getUTCDate()]:[e.getFullYear(),e.getMonth(),e.getDate()]}(t),t._w&&null==t._a[kt]&&null==t._a[wt]&&function(t){var e,n,i,r,o,a,s,l,c;e=t._w,null!=e.GG||null!=e.W||null!=e.E?(o=1,a=4,n=Pe(e.GG,t._a[bt],Wt(De(),1,4).year),i=Pe(e.W,1),((r=Pe(e.E,1))<1||r>7)&&(l=!0)):(o=t._locale._week.dow,a=t._locale._week.doy,c=Wt(De(),o,a),n=Pe(e.gg,t._a[bt],c.year),i=Pe(e.w,c.week),null!=e.d?((r=e.d)<0||r>6)&&(l=!0):null!=e.e?(r=e.e+o,(e.e<0||e.e>6)&&(l=!0)):r=o);i<1||i>Ut(n,o,a)?f(t)._overflowWeeks=!0:null!=l?f(t)._overflowWeekday=!0:(s=Ht(n,i,r,o,a),t._a[bt]=s.year,t._dayOfYear=s.dayOfYear)}(t),null!=t._dayOfYear&&(a=Pe(t._a[bt],r[bt]),(t._dayOfYear>Ft(a)||0===t._dayOfYear)&&(f(t)._overflowDayOfYear=!0),i=zt(a,0,t._dayOfYear),t._a[wt]=i.getUTCMonth(),t._a[kt]=i.getUTCDate()),e=0;e<3&&null==t._a[e];++e)t._a[e]=s[e]=r[e];for(;e<7;e++)t._a[e]=s[e]=null==t._a[e]?2===e?1:0:t._a[e];24===t._a[xt]&&0===t._a[Ct]&&0===t._a[St]&&0===t._a[Mt]&&(t._nextDay=!0,t._a[xt]=0),t._d=(t._useUTC?zt:jt).apply(null,s),o=t._useUTC?t._d.getUTCDay():t._d.getDay(),null!=t._tzm&&t._d.setUTCMinutes(t._d.getUTCMinutes()-t._tzm),t._nextDay&&(t._a[xt]=24),t._w&&void 0!==t._w.d&&t._w.d!==o&&(f(t).weekdayMismatch=!0)}}function Be(t){if(t._f!==n.ISO_8601)if(t._f!==n.RFC_2822){t._a=[],f(t).empty=!0;var e,i,r,o,a,s,l,c=""+t._i,u=c.length,d=0;for(l=(r=R(t._f,t._locale).match(B)||[]).length,e=0;e<l;e++)o=r[e],(i=(c.match(ft(o,t))||[])[0])&&((a=c.substr(0,c.indexOf(i))).length>0&&f(t).unusedInput.push(a),c=c.slice(c.indexOf(i)+i.length),d+=i.length),D[o]?(i?f(t).empty=!1:f(t).unusedTokens.push(o),yt(o,i,t)):t._strict&&!i&&f(t).unusedTokens.push(o);f(t).charsLeftOver=u-d,c.length>0&&f(t).unusedInput.push(c),t._a[xt]<=12&&!0===f(t).bigHour&&t._a[xt]>0&&(f(t).bigHour=void 0),f(t).parsedDateParts=t._a.slice(0),f(t).meridiem=t._meridiem,t._a[xt]=function(t,e,n){var i;if(null==n)return e;return null!=t.meridiemHour?t.meridiemHour(e,n):null!=t.isPM?((i=t.isPM(n))&&e<12&&(e+=12),i||12!==e||(e=0),e):e}(t._locale,t._a[xt],t._meridiem),null!==(s=f(t).era)&&(t._a[bt]=t._locale.erasConvertYear(s,t._a[bt])),Oe(t),ve(t)}else Te(t);else Se(t)}function Ee(t){var e=t._i,o=t._f;return t._locale=t._locale||me(t._l),null===e||void 0===o&&""===e?m({nullInput:!0}):("string"==typeof e&&(t._i=e=t._locale.preparse(e)),b(e)?new _(ve(e)):(c(e)?t._d=e:i(o)?function(t){var e,n,i,r,o,a,s=!1,l=t._f.length;if(0===l)return f(t).invalidFormat=!0,void(t._d=new Date(NaN));for(r=0;r<l;r++)o=0,a=!1,e=y({},t),null!=t._useUTC&&(e._useUTC=t._useUTC),e._f=t._f[r],Be(e),p(e)&&(a=!0),o+=f(e).charsLeftOver,o+=10*f(e).unusedTokens.length,f(e).score=o,s?o<i&&(i=o,n=e):(null==i||o<i||a)&&(i=o,n=e,a&&(s=!0));d(t,n||e)}(t):o?Be(t):function(t){var e=t._i;s(e)?t._d=new Date(n.now()):c(e)?t._d=new Date(e.valueOf()):"string"==typeof e?function(t){var e=ke.exec(t._i);null===e?(Se(t),!1===t._isValid&&(delete t._isValid,Te(t),!1===t._isValid&&(delete t._isValid,t._strict?t._isValid=!1:n.createFromInputFallback(t)))):t._d=new Date(+e[1])}(t):i(e)?(t._a=u(e.slice(0),(function(t){return parseInt(t,10)})),Oe(t)):r(e)?function(t){if(!t._d){var e=$(t._i),n=void 0===e.day?e.date:e.day;t._a=u([e.year,e.month,n,e.hour,e.minute,e.second,e.millisecond],(function(t){return t&&parseInt(t,10)})),Oe(t)}}(t):l(e)?t._d=new Date(e):n.createFromInputFallback(t)}(t),p(t)||(t._d=null),t))}function Ae(t,e,n,o,s){var l,c={};return!0!==e&&!1!==e||(o=e,e=void 0),!0!==n&&!1!==n||(o=n,n=void 0),(r(t)&&a(t)||i(t)&&0===t.length)&&(t=void 0),c._isAMomentObject=!0,c._useUTC=c._isUTC=s,c._l=n,c._i=t,c._f=e,c._strict=o,(l=new _(ve(Ee(c))))._nextDay&&(l.add(1,"d"),l._nextDay=void 0),l}function De(t,e,n,i){return Ae(t,e,n,i,!1)}n.createFromInputFallback=k("value provided is not in a recognized RFC2822 or ISO format. moment construction falls back to js Date(), which is not reliable across all browsers and versions. Non RFC2822/ISO date formats are discouraged. Please refer to http://momentjs.com/guides/#/warnings/js-date/ for more info.",(function(t){t._d=new Date(t._i+(t._useUTC?" UTC":""))})),n.ISO_8601=function(){},n.RFC_2822=function(){};var Le=k("moment().min is deprecated, use moment.max instead. http://momentjs.com/guides/#/warnings/min-max/",(function(){var t=De.apply(null,arguments);return this.isValid()&&t.isValid()?t<this?this:t:m()})),qe=k("moment().max is deprecated, use moment.min instead. http://momentjs.com/guides/#/warnings/min-max/",(function(){var t=De.apply(null,arguments);return this.isValid()&&t.isValid()?t>this?this:t:m()}));function Re(t,e){var n,r;if(1===e.length&&i(e[0])&&(e=e[0]),!e.length)return De();for(n=e[0],r=1;r<e.length;++r)e[r].isValid()&&!e[r][t](n)||(n=e[r]);return n}var Ie=["year","quarter","month","week","day","hour","minute","second","millisecond"];function Ne(t){var e=$(t),n=e.year||0,i=e.quarter||0,r=e.month||0,a=e.week||e.isoWeek||0,s=e.day||0,l=e.hour||0,c=e.minute||0,u=e.second||0,d=e.millisecond||0;this._isValid=function(t){var e,n,i=!1,r=Ie.length;for(e in t)if(o(t,e)&&(-1===_t.call(Ie,e)||null!=t[e]&&isNaN(t[e])))return!1;for(n=0;n<r;++n)if(t[Ie[n]]){if(i)return!1;parseFloat(t[Ie[n]])!==W(t[Ie[n]])&&(i=!0)}return!0}(e),this._milliseconds=+d+1e3*u+6e4*c+1e3*l*60*60,this._days=+s+7*a,this._months=+r+3*i+12*n,this._data={},this._locale=me(),this._bubble()}function Fe(t){return t instanceof Ne}function $e(t){return t<0?-1*Math.round(-1*t):Math.round(t)}function je(t,e){L(t,0,0,(function(){var t=this.utcOffset(),n="+";return t<0&&(t=-t,n="-"),n+O(~~(t/60),2)+e+O(~~t%60,2)}))}je("Z",":"),je("ZZ",""),ht("Z",ut),ht("ZZ",ut),vt(["Z","ZZ"],(function(t,e,n){n._useUTC=!0,n._tzm=Ve(ut,t)}));var ze=/([\+\-]|\d\d)/gi;function Ve(t,e){var n,i,r=(e||"").match(t);return null===r?null:0===(i=60*(n=((r[r.length-1]||[])+"").match(ze)||["-",0,0])[1]+W(n[2]))?0:"+"===n[0]?i:-i}function He(t,e){var i,r;return e._isUTC?(i=e.clone(),r=(b(t)||c(t)?t.valueOf():De(t).valueOf())-i.valueOf(),i._d.setTime(i._d.valueOf()+r),n.updateOffset(i,!1),i):De(t).local()}function We(t){return-Math.round(t._d.getTimezoneOffset())}function Ue(){return!!this.isValid()&&(this._isUTC&&0===this._offset)}n.updateOffset=function(){};var Ye=/^(-|\+)?(?:(\d*)[. ])?(\d+):(\d+)(?::(\d+)(\.\d*)?)?$/,Qe=/^(-|\+)?P(?:([-+]?[0-9,.]*)Y)?(?:([-+]?[0-9,.]*)M)?(?:([-+]?[0-9,.]*)W)?(?:([-+]?[0-9,.]*)D)?(?:T(?:([-+]?[0-9,.]*)H)?(?:([-+]?[0-9,.]*)M)?(?:([-+]?[0-9,.]*)S)?)?$/;function Ge(t,e){var n,i,r,a=t,s=null;return Fe(t)?a={ms:t._milliseconds,d:t._days,M:t._months}:l(t)||!isNaN(+t)?(a={},e?a[e]=+t:a.milliseconds=+t):(s=Ye.exec(t))?(n="-"===s[1]?-1:1,a={y:0,d:W(s[kt])*n,h:W(s[xt])*n,m:W(s[Ct])*n,s:W(s[St])*n,ms:W($e(1e3*s[Mt]))*n}):(s=Qe.exec(t))?(n="-"===s[1]?-1:1,a={y:Ke(s[2],n),M:Ke(s[3],n),w:Ke(s[4],n),d:Ke(s[5],n),h:Ke(s[6],n),m:Ke(s[7],n),s:Ke(s[8],n)}):null==a?a={}:"object"==typeof a&&("from"in a||"to"in a)&&(r=function(t,e){var n;if(!t.isValid()||!e.isValid())return{milliseconds:0,months:0};e=He(e,t),t.isBefore(e)?n=Je(t,e):((n=Je(e,t)).milliseconds=-n.milliseconds,n.months=-n.months);return n}(De(a.from),De(a.to)),(a={}).ms=r.milliseconds,a.M=r.months),i=new Ne(a),Fe(t)&&o(t,"_locale")&&(i._locale=t._locale),Fe(t)&&o(t,"_isValid")&&(i._isValid=t._isValid),i}function Ke(t,e){var n=t&&parseFloat(t.replace(",","."));return(isNaN(n)?0:n)*e}function Je(t,e){var n={};return n.months=e.month()-t.month()+12*(e.year()-t.year()),t.clone().add(n.months,"M").isAfter(e)&&--n.months,n.milliseconds=+e-+t.clone().add(n.months,"M"),n}function Ze(t,e){return function(n,i){var r;return null===i||isNaN(+i)||(S(e,"moment()."+e+"(period, number) is deprecated. Please use moment()."+e+"(number, period). See http://momentjs.com/guides/#/warnings/add-inverted-param/ for more info."),r=n,n=i,i=r),Xe(this,Ge(n,i),t),this}}function Xe(t,e,i,r){var o=e._milliseconds,a=$e(e._days),s=$e(e._months);t.isValid()&&(r=null==r||r,s&&Rt(t,Y(t,"Month")+s*i),a&&Q(t,"Date",Y(t,"Date")+a*i),o&&t._d.setTime(t._d.valueOf()+o*i),r&&n.updateOffset(t,a||s))}Ge.fn=Ne.prototype,Ge.invalid=function(){return Ge(NaN)};var tn=Ze(1,"add"),en=Ze(-1,"subtract");function nn(t){return"string"==typeof t||t instanceof String}function rn(t){return b(t)||c(t)||nn(t)||l(t)||function(t){var e=i(t),n=!1;e&&(n=0===t.filter((function(e){return!l(e)&&nn(t)})).length);return e&&n}(t)||function(t){var e,n,i=r(t)&&!a(t),s=!1,l=["years","year","y","months","month","M","days","day","d","dates","date","D","hours","hour","h","minutes","minute","m","seconds","second","s","milliseconds","millisecond","ms"],c=l.length;for(e=0;e<c;e+=1)n=l[e],s=s||o(t,n);return i&&s}(t)||null==t}function on(t,e){if(t.date()<e.date())return-on(e,t);var n=12*(e.year()-t.year())+(e.month()-t.month()),i=t.clone().add(n,"months");return-(n+(e-i<0?(e-i)/(i-t.clone().add(n-1,"months")):(e-i)/(t.clone().add(n+1,"months")-i)))||0}function an(t){var e;return void 0===t?this._locale._abbr:(null!=(e=me(t))&&(this._locale=e),this)}n.defaultFormat="YYYY-MM-DDTHH:mm:ssZ",n.defaultFormatUtc="YYYY-MM-DDTHH:mm:ss[Z]";var sn=k("moment().lang() is deprecated. Instead, use moment().localeData() to get the language configuration. Use moment().locale() to change languages.",(function(t){return void 0===t?this.localeData():this.locale(t)}));function ln(){return this._locale}var cn=1e3,un=6e4,dn=36e5,hn=126227808e5;function fn(t,e){return(t%e+e)%e}function pn(t,e,n){return t<100&&t>=0?new Date(t+400,e,n)-hn:new Date(t,e,n).valueOf()}function mn(t,e,n){return t<100&&t>=0?Date.UTC(t+400,e,n)-hn:Date.UTC(t,e,n)}function vn(t,e){return e.erasAbbrRegex(t)}function gn(){var t,e,n=[],i=[],r=[],o=[],a=this.eras();for(t=0,e=a.length;t<e;++t)i.push(pt(a[t].name)),n.push(pt(a[t].abbr)),r.push(pt(a[t].narrow)),o.push(pt(a[t].name)),o.push(pt(a[t].abbr)),o.push(pt(a[t].narrow));this._erasRegex=new RegExp("^("+o.join("|")+")","i"),this._erasNameRegex=new RegExp("^("+i.join("|")+")","i"),this._erasAbbrRegex=new RegExp("^("+n.join("|")+")","i"),this._erasNarrowRegex=new RegExp("^("+r.join("|")+")","i")}function yn(t,e){L(0,[t,t.length],0,e)}function _n(t,e,n,i,r){var o;return null==t?Wt(this,i,r).year:(e>(o=Ut(t,i,r))&&(e=o),bn.call(this,t,e,n,i,r))}function bn(t,e,n,i,r){var o=Ht(t,e,n,i,r),a=zt(o.year,0,o.dayOfYear);return this.year(a.getUTCFullYear()),this.month(a.getUTCMonth()),this.date(a.getUTCDate()),this}L("N",0,0,"eraAbbr"),L("NN",0,0,"eraAbbr"),L("NNN",0,0,"eraAbbr"),L("NNNN",0,0,"eraName"),L("NNNNN",0,0,"eraNarrow"),L("y",["y",1],"yo","eraYear"),L("y",["yy",2],0,"eraYear"),L("y",["yyy",3],0,"eraYear"),L("y",["yyyy",4],0,"eraYear"),ht("N",vn),ht("NN",vn),ht("NNN",vn),ht("NNNN",(function(t,e){return e.erasNameRegex(t)})),ht("NNNNN",(function(t,e){return e.erasNarrowRegex(t)})),vt(["N","NN","NNN","NNNN","NNNNN"],(function(t,e,n,i){var r=n._locale.erasParse(t,i,n._strict);r?f(n).era=r:f(n).invalidEra=t})),ht("y",st),ht("yy",st),ht("yyy",st),ht("yyyy",st),ht("yo",(function(t,e){return e._eraYearOrdinalRegex||st})),vt(["y","yy","yyy","yyyy"],bt),vt(["yo"],(function(t,e,n,i){var r;n._locale._eraYearOrdinalRegex&&(r=t.match(n._locale._eraYearOrdinalRegex)),n._locale.eraYearOrdinalParse?e[bt]=n._locale.eraYearOrdinalParse(t,r):e[bt]=parseInt(t,10)})),L(0,["gg",2],0,(function(){return this.weekYear()%100})),L(0,["GG",2],0,(function(){return this.isoWeekYear()%100})),yn("gggg","weekYear"),yn("ggggg","weekYear"),yn("GGGG","isoWeekYear"),yn("GGGGG","isoWeekYear"),N("weekYear","gg"),N("isoWeekYear","GG"),z("weekYear",1),z("isoWeekYear",1),ht("G",lt),ht("g",lt),ht("GG",et,J),ht("gg",et,J),ht("GGGG",ot,X),ht("gggg",ot,X),ht("GGGGG",at,tt),ht("ggggg",at,tt),gt(["gggg","ggggg","GGGG","GGGGG"],(function(t,e,n,i){e[i.substr(0,2)]=W(t)})),gt(["gg","GG"],(function(t,e,i,r){e[r]=n.parseTwoDigitYear(t)})),L("Q",0,"Qo","quarter"),N("quarter","Q"),z("quarter",7),ht("Q",K),vt("Q",(function(t,e){e[wt]=3*(W(t)-1)})),L("D",["DD",2],"Do","date"),N("date","D"),z("date",9),ht("D",et),ht("DD",et,J),ht("Do",(function(t,e){return t?e._dayOfMonthOrdinalParse||e._ordinalParse:e._dayOfMonthOrdinalParseLenient})),vt(["D","DD"],kt),vt("Do",(function(t,e){e[kt]=W(t.match(et)[0])}));var wn=U("Date",!0);L("DDD",["DDDD",3],"DDDo","dayOfYear"),N("dayOfYear","DDD"),z("dayOfYear",4),ht("DDD",rt),ht("DDDD",Z),vt(["DDD","DDDD"],(function(t,e,n){n._dayOfYear=W(t)})),L("m",["mm",2],0,"minute"),N("minute","m"),z("minute",14),ht("m",et),ht("mm",et,J),vt(["m","mm"],Ct);var kn=U("Minutes",!1);L("s",["ss",2],0,"second"),N("second","s"),z("second",15),ht("s",et),ht("ss",et,J),vt(["s","ss"],St);var xn,Cn,Sn=U("Seconds",!1);for(L("S",0,0,(function(){return~~(this.millisecond()/100)})),L(0,["SS",2],0,(function(){return~~(this.millisecond()/10)})),L(0,["SSS",3],0,"millisecond"),L(0,["SSSS",4],0,(function(){return 10*this.millisecond()})),L(0,["SSSSS",5],0,(function(){return 100*this.millisecond()})),L(0,["SSSSSS",6],0,(function(){return 1e3*this.millisecond()})),L(0,["SSSSSSS",7],0,(function(){return 1e4*this.millisecond()})),L(0,["SSSSSSSS",8],0,(function(){return 1e5*this.millisecond()})),L(0,["SSSSSSSSS",9],0,(function(){return 1e6*this.millisecond()})),N("millisecond","ms"),z("millisecond",16),ht("S",rt,K),ht("SS",rt,J),ht("SSS",rt,Z),xn="SSSS";xn.length<=9;xn+="S")ht(xn,st);function Mn(t,e){e[Mt]=W(1e3*("0."+t))}for(xn="S";xn.length<=9;xn+="S")vt(xn,Mn);Cn=U("Milliseconds",!1),L("z",0,0,"zoneAbbr"),L("zz",0,0,"zoneName");var Tn=_.prototype;function Pn(t){return t}Tn.add=tn,Tn.calendar=function(t,e){1===arguments.length&&(arguments[0]?rn(arguments[0])?(t=arguments[0],e=void 0):function(t){var e,n=r(t)&&!a(t),i=!1,s=["sameDay","nextDay","lastDay","nextWeek","lastWeek","sameElse"];for(e=0;e<s.length;e+=1)i=i||o(t,s[e]);return n&&i}(arguments[0])&&(e=arguments[0],t=void 0):(t=void 0,e=void 0));var i=t||De(),s=He(i,this).startOf("day"),l=n.calendarFormat(this,s)||"sameElse",c=e&&(M(e[l])?e[l].call(this,i):e[l]);return this.format(c||this.localeData().calendar(l,this,De(i)))},Tn.clone=function(){return new _(this)},Tn.diff=function(t,e,n){var i,r,o;if(!this.isValid())return NaN;if(!(i=He(t,this)).isValid())return NaN;switch(r=6e4*(i.utcOffset()-this.utcOffset()),e=F(e)){case"year":o=on(this,i)/12;break;case"month":o=on(this,i);break;case"quarter":o=on(this,i)/3;break;case"second":o=(this-i)/1e3;break;case"minute":o=(this-i)/6e4;break;case"hour":o=(this-i)/36e5;break;case"day":o=(this-i-r)/864e5;break;case"week":o=(this-i-r)/6048e5;break;default:o=this-i}return n?o:H(o)},Tn.endOf=function(t){var e,i;if(void 0===(t=F(t))||"millisecond"===t||!this.isValid())return this;switch(i=this._isUTC?mn:pn,t){case"year":e=i(this.year()+1,0,1)-1;break;case"quarter":e=i(this.year(),this.month()-this.month()%3+3,1)-1;break;case"month":e=i(this.year(),this.month()+1,1)-1;break;case"week":e=i(this.year(),this.month(),this.date()-this.weekday()+7)-1;break;case"isoWeek":e=i(this.year(),this.month(),this.date()-(this.isoWeekday()-1)+7)-1;break;case"day":case"date":e=i(this.year(),this.month(),this.date()+1)-1;break;case"hour":e=this._d.valueOf(),e+=dn-fn(e+(this._isUTC?0:this.utcOffset()*un),dn)-1;break;case"minute":e=this._d.valueOf(),e+=un-fn(e,un)-1;break;case"second":e=this._d.valueOf(),e+=cn-fn(e,cn)-1}return this._d.setTime(e),n.updateOffset(this,!0),this},Tn.format=function(t){t||(t=this.isUtc()?n.defaultFormatUtc:n.defaultFormat);var e=q(this,t);return this.localeData().postformat(e)},Tn.from=function(t,e){return this.isValid()&&(b(t)&&t.isValid()||De(t).isValid())?Ge({to:this,from:t}).locale(this.locale()).humanize(!e):this.localeData().invalidDate()},Tn.fromNow=function(t){return this.from(De(),t)},Tn.to=function(t,e){return this.isValid()&&(b(t)&&t.isValid()||De(t).isValid())?Ge({from:this,to:t}).locale(this.locale()).humanize(!e):this.localeData().invalidDate()},Tn.toNow=function(t){return this.to(De(),t)},Tn.get=function(t){return M(this[t=F(t)])?this[t]():this},Tn.invalidAt=function(){return f(this).overflow},Tn.isAfter=function(t,e){var n=b(t)?t:De(t);return!(!this.isValid()||!n.isValid())&&("millisecond"===(e=F(e)||"millisecond")?this.valueOf()>n.valueOf():n.valueOf()<this.clone().startOf(e).valueOf())},Tn.isBefore=function(t,e){var n=b(t)?t:De(t);return!(!this.isValid()||!n.isValid())&&("millisecond"===(e=F(e)||"millisecond")?this.valueOf()<n.valueOf():this.clone().endOf(e).valueOf()<n.valueOf())},Tn.isBetween=function(t,e,n,i){var r=b(t)?t:De(t),o=b(e)?e:De(e);return!!(this.isValid()&&r.isValid()&&o.isValid())&&(("("===(i=i||"()")[0]?this.isAfter(r,n):!this.isBefore(r,n))&&(")"===i[1]?this.isBefore(o,n):!this.isAfter(o,n)))},Tn.isSame=function(t,e){var n,i=b(t)?t:De(t);return!(!this.isValid()||!i.isValid())&&("millisecond"===(e=F(e)||"millisecond")?this.valueOf()===i.valueOf():(n=i.valueOf(),this.clone().startOf(e).valueOf()<=n&&n<=this.clone().endOf(e).valueOf()))},Tn.isSameOrAfter=function(t,e){return this.isSame(t,e)||this.isAfter(t,e)},Tn.isSameOrBefore=function(t,e){return this.isSame(t,e)||this.isBefore(t,e)},Tn.isValid=function(){return p(this)},Tn.lang=sn,Tn.locale=an,Tn.localeData=ln,Tn.max=qe,Tn.min=Le,Tn.parsingFlags=function(){return d({},f(this))},Tn.set=function(t,e){if("object"==typeof t){var n,i=function(t){var e,n=[];for(e in t)o(t,e)&&n.push({unit:e,priority:j[e]});return n.sort((function(t,e){return t.priority-e.priority})),n}(t=$(t)),r=i.length;for(n=0;n<r;n++)this[i[n].unit](t[i[n].unit])}else if(M(this[t=F(t)]))return this[t](e);return this},Tn.startOf=function(t){var e,i;if(void 0===(t=F(t))||"millisecond"===t||!this.isValid())return this;switch(i=this._isUTC?mn:pn,t){case"year":e=i(this.year(),0,1);break;case"quarter":e=i(this.year(),this.month()-this.month()%3,1);break;case"month":e=i(this.year(),this.month(),1);break;case"week":e=i(this.year(),this.month(),this.date()-this.weekday());break;case"isoWeek":e=i(this.year(),this.month(),this.date()-(this.isoWeekday()-1));break;case"day":case"date":e=i(this.year(),this.month(),this.date());break;case"hour":e=this._d.valueOf(),e-=fn(e+(this._isUTC?0:this.utcOffset()*un),dn);break;case"minute":e=this._d.valueOf(),e-=fn(e,un);break;case"second":e=this._d.valueOf(),e-=fn(e,cn)}return this._d.setTime(e),n.updateOffset(this,!0),this},Tn.subtract=en,Tn.toArray=function(){var t=this;return[t.year(),t.month(),t.date(),t.hour(),t.minute(),t.second(),t.millisecond()]},Tn.toObject=function(){var t=this;return{years:t.year(),months:t.month(),date:t.date(),hours:t.hours(),minutes:t.minutes(),seconds:t.seconds(),milliseconds:t.milliseconds()}},Tn.toDate=function(){return new Date(this.valueOf())},Tn.toISOString=function(t){if(!this.isValid())return null;var e=!0!==t,n=e?this.clone().utc():this;return n.year()<0||n.year()>9999?q(n,e?"YYYYYY-MM-DD[T]HH:mm:ss.SSS[Z]":"YYYYYY-MM-DD[T]HH:mm:ss.SSSZ"):M(Date.prototype.toISOString)?e?this.toDate().toISOString():new Date(this.valueOf()+60*this.utcOffset()*1e3).toISOString().replace("Z",q(n,"Z")):q(n,e?"YYYY-MM-DD[T]HH:mm:ss.SSS[Z]":"YYYY-MM-DD[T]HH:mm:ss.SSSZ")},Tn.inspect=function(){if(!this.isValid())return"moment.invalid(/* "+this._i+" */)";var t,e,n,i="moment",r="";return this.isLocal()||(i=0===this.utcOffset()?"moment.utc":"moment.parseZone",r="Z"),t="["+i+'("]',e=0<=this.year()&&this.year()<=9999?"YYYY":"YYYYYY","-MM-DD[T]HH:mm:ss.SSS",n=r+'[")]',this.format(t+e+"-MM-DD[T]HH:mm:ss.SSS"+n)},"undefined"!=typeof Symbol&&null!=Symbol.for&&(Tn[Symbol.for("nodejs.util.inspect.custom")]=function(){return"Moment<"+this.format()+">"}),Tn.toJSON=function(){return this.isValid()?this.toISOString():null},Tn.toString=function(){return this.clone().locale("en").format("ddd MMM DD YYYY HH:mm:ss [GMT]ZZ")},Tn.unix=function(){return Math.floor(this.valueOf()/1e3)},Tn.valueOf=function(){return this._d.valueOf()-6e4*(this._offset||0)},Tn.creationData=function(){return{input:this._i,format:this._f,locale:this._locale,isUTC:this._isUTC,strict:this._strict}},Tn.eraName=function(){var t,e,n,i=this.localeData().eras();for(t=0,e=i.length;t<e;++t){if(n=this.clone().startOf("day").valueOf(),i[t].since<=n&&n<=i[t].until)return i[t].name;if(i[t].until<=n&&n<=i[t].since)return i[t].name}return""},Tn.eraNarrow=function(){var t,e,n,i=this.localeData().eras();for(t=0,e=i.length;t<e;++t){if(n=this.clone().startOf("day").valueOf(),i[t].since<=n&&n<=i[t].until)return i[t].narrow;if(i[t].until<=n&&n<=i[t].since)return i[t].narrow}return""},Tn.eraAbbr=function(){var t,e,n,i=this.localeData().eras();for(t=0,e=i.length;t<e;++t){if(n=this.clone().startOf("day").valueOf(),i[t].since<=n&&n<=i[t].until)return i[t].abbr;if(i[t].until<=n&&n<=i[t].since)return i[t].abbr}return""},Tn.eraYear=function(){var t,e,i,r,o=this.localeData().eras();for(t=0,e=o.length;t<e;++t)if(i=o[t].since<=o[t].until?1:-1,r=this.clone().startOf("day").valueOf(),o[t].since<=r&&r<=o[t].until||o[t].until<=r&&r<=o[t].since)return(this.year()-n(o[t].since).year())*i+o[t].offset;return this.year()},Tn.year=$t,Tn.isLeapYear=function(){return V(this.year())},Tn.weekYear=function(t){return _n.call(this,t,this.week(),this.weekday(),this.localeData()._week.dow,this.localeData()._week.doy)},Tn.isoWeekYear=function(t){return _n.call(this,t,this.isoWeek(),this.isoWeekday(),1,4)},Tn.quarter=Tn.quarters=function(t){return null==t?Math.ceil((this.month()+1)/3):this.month(3*(t-1)+this.month()%3)},Tn.month=It,Tn.daysInMonth=function(){return Ot(this.year(),this.month())},Tn.week=Tn.weeks=function(t){var e=this.localeData().week(this);return null==t?e:this.add(7*(t-e),"d")},Tn.isoWeek=Tn.isoWeeks=function(t){var e=Wt(this,1,4).week;return null==t?e:this.add(7*(t-e),"d")},Tn.weeksInYear=function(){var t=this.localeData()._week;return Ut(this.year(),t.dow,t.doy)},Tn.weeksInWeekYear=function(){var t=this.localeData()._week;return Ut(this.weekYear(),t.dow,t.doy)},Tn.isoWeeksInYear=function(){return Ut(this.year(),1,4)},Tn.isoWeeksInISOWeekYear=function(){return Ut(this.isoWeekYear(),1,4)},Tn.date=wn,Tn.day=Tn.days=function(t){if(!this.isValid())return null!=t?this:NaN;var e=this._isUTC?this._d.getUTCDay():this._d.getDay();return null!=t?(t=function(t,e){return"string"!=typeof t?t:isNaN(t)?"number"==typeof(t=e.weekdaysParse(t))?t:null:parseInt(t,10)}(t,this.localeData()),this.add(t-e,"d")):e},Tn.weekday=function(t){if(!this.isValid())return null!=t?this:NaN;var e=(this.day()+7-this.localeData()._week.dow)%7;return null==t?e:this.add(t-e,"d")},Tn.isoWeekday=function(t){if(!this.isValid())return null!=t?this:NaN;if(null!=t){var e=function(t,e){return"string"==typeof t?e.weekdaysParse(t)%7||7:isNaN(t)?null:t}(t,this.localeData());return this.day(this.day()%7?e:e-7)}return this.day()||7},Tn.dayOfYear=function(t){var e=Math.round((this.clone().startOf("day")-this.clone().startOf("year"))/864e5)+1;return null==t?e:this.add(t-e,"d")},Tn.hour=Tn.hours=oe,Tn.minute=Tn.minutes=kn,Tn.second=Tn.seconds=Sn,Tn.millisecond=Tn.milliseconds=Cn,Tn.utcOffset=function(t,e,i){var r,o=this._offset||0;if(!this.isValid())return null!=t?this:NaN;if(null!=t){if("string"==typeof t){if(null===(t=Ve(ut,t)))return this}else Math.abs(t)<16&&!i&&(t*=60);return!this._isUTC&&e&&(r=We(this)),this._offset=t,this._isUTC=!0,null!=r&&this.add(r,"m"),o!==t&&(!e||this._changeInProgress?Xe(this,Ge(t-o,"m"),1,!1):this._changeInProgress||(this._changeInProgress=!0,n.updateOffset(this,!0),this._changeInProgress=null)),this}return this._isUTC?o:We(this)},Tn.utc=function(t){return this.utcOffset(0,t)},Tn.local=function(t){return this._isUTC&&(this.utcOffset(0,t),this._isUTC=!1,t&&this.subtract(We(this),"m")),this},Tn.parseZone=function(){if(null!=this._tzm)this.utcOffset(this._tzm,!1,!0);else if("string"==typeof this._i){var t=Ve(ct,this._i);null!=t?this.utcOffset(t):this.utcOffset(0,!0)}return this},Tn.hasAlignedHourOffset=function(t){return!!this.isValid()&&(t=t?De(t).utcOffset():0,(this.utcOffset()-t)%60==0)},Tn.isDST=function(){return this.utcOffset()>this.clone().month(0).utcOffset()||this.utcOffset()>this.clone().month(5).utcOffset()},Tn.isLocal=function(){return!!this.isValid()&&!this._isUTC},Tn.isUtcOffset=function(){return!!this.isValid()&&this._isUTC},Tn.isUtc=Ue,Tn.isUTC=Ue,Tn.zoneAbbr=function(){return this._isUTC?"UTC":""},Tn.zoneName=function(){return this._isUTC?"Coordinated Universal Time":""},Tn.dates=k("dates accessor is deprecated. Use date instead.",wn),Tn.months=k("months accessor is deprecated. Use month instead",It),Tn.years=k("years accessor is deprecated. Use year instead",$t),Tn.zone=k("moment().zone is deprecated, use moment().utcOffset instead. http://momentjs.com/guides/#/warnings/zone/",(function(t,e){return null!=t?("string"!=typeof t&&(t=-t),this.utcOffset(t,e),this):-this.utcOffset()})),Tn.isDSTShifted=k("isDSTShifted is deprecated. See http://momentjs.com/guides/#/warnings/dst-shifted/ for more information",(function(){if(!s(this._isDSTShifted))return this._isDSTShifted;var t,e={};return y(e,this),(e=Ee(e))._a?(t=e._isUTC?h(e._a):De(e._a),this._isDSTShifted=this.isValid()&&function(t,e,n){var i,r=Math.min(t.length,e.length),o=Math.abs(t.length-e.length),a=0;for(i=0;i<r;i++)(n&&t[i]!==e[i]||!n&&W(t[i])!==W(e[i]))&&a++;return a+o}(e._a,t.toArray())>0):this._isDSTShifted=!1,this._isDSTShifted}));var On=P.prototype;function Bn(t,e,n,i){var r=me(),o=h().set(i,e);return r[n](o,t)}function En(t,e,n){if(l(t)&&(e=t,t=void 0),t=t||"",null!=e)return Bn(t,e,n,"month");var i,r=[];for(i=0;i<12;i++)r[i]=Bn(t,i,n,"month");return r}function An(t,e,n,i){"boolean"==typeof t?(l(e)&&(n=e,e=void 0),e=e||""):(n=e=t,t=!1,l(e)&&(n=e,e=void 0),e=e||"");var r,o=me(),a=t?o._week.dow:0,s=[];if(null!=n)return Bn(e,(n+a)%7,i,"day");for(r=0;r<7;r++)s[r]=Bn(e,(r+a)%7,i,"day");return s}On.calendar=function(t,e,n){var i=this._calendar[t]||this._calendar.sameElse;return M(i)?i.call(e,n):i},On.longDateFormat=function(t){var e=this._longDateFormat[t],n=this._longDateFormat[t.toUpperCase()];return e||!n?e:(this._longDateFormat[t]=n.match(B).map((function(t){return"MMMM"===t||"MM"===t||"DD"===t||"dddd"===t?t.slice(1):t})).join(""),this._longDateFormat[t])},On.invalidDate=function(){return this._invalidDate},On.ordinal=function(t){return this._ordinal.replace("%d",t)},On.preparse=Pn,On.postformat=Pn,On.relativeTime=function(t,e,n,i){var r=this._relativeTime[n];return M(r)?r(t,e,n,i):r.replace(/%d/i,t)},On.pastFuture=function(t,e){var n=this._relativeTime[t>0?"future":"past"];return M(n)?n(e):n.replace(/%s/i,e)},On.set=function(t){var e,n;for(n in t)o(t,n)&&(M(e=t[n])?this[n]=e:this["_"+n]=e);this._config=t,this._dayOfMonthOrdinalParseLenient=new RegExp((this._dayOfMonthOrdinalParse.source||this._ordinalParse.source)+"|"+/\d{1,2}/.source)},On.eras=function(t,e){var i,r,o,a=this._eras||me("en")._eras;for(i=0,r=a.length;i<r;++i){if("string"==typeof a[i].since)o=n(a[i].since).startOf("day"),a[i].since=o.valueOf();switch(typeof a[i].until){case"undefined":a[i].until=1/0;break;case"string":o=n(a[i].until).startOf("day").valueOf(),a[i].until=o.valueOf()}}return a},On.erasParse=function(t,e,n){var i,r,o,a,s,l=this.eras();for(t=t.toUpperCase(),i=0,r=l.length;i<r;++i)if(o=l[i].name.toUpperCase(),a=l[i].abbr.toUpperCase(),s=l[i].narrow.toUpperCase(),n)switch(e){case"N":case"NN":case"NNN":if(a===t)return l[i];break;case"NNNN":if(o===t)return l[i];break;case"NNNNN":if(s===t)return l[i]}else if([o,a,s].indexOf(t)>=0)return l[i]},On.erasConvertYear=function(t,e){var i=t.since<=t.until?1:-1;return void 0===e?n(t.since).year():n(t.since).year()+(e-t.offset)*i},On.erasAbbrRegex=function(t){return o(this,"_erasAbbrRegex")||gn.call(this),t?this._erasAbbrRegex:this._erasRegex},On.erasNameRegex=function(t){return o(this,"_erasNameRegex")||gn.call(this),t?this._erasNameRegex:this._erasRegex},On.erasNarrowRegex=function(t){return o(this,"_erasNarrowRegex")||gn.call(this),t?this._erasNarrowRegex:this._erasRegex},On.months=function(t,e){return t?i(this._months)?this._months[t.month()]:this._months[(this._months.isFormat||At).test(e)?"format":"standalone"][t.month()]:i(this._months)?this._months:this._months.standalone},On.monthsShort=function(t,e){return t?i(this._monthsShort)?this._monthsShort[t.month()]:this._monthsShort[At.test(e)?"format":"standalone"][t.month()]:i(this._monthsShort)?this._monthsShort:this._monthsShort.standalone},On.monthsParse=function(t,e,n){var i,r,o;if(this._monthsParseExact)return qt.call(this,t,e,n);for(this._monthsParse||(this._monthsParse=[],this._longMonthsParse=[],this._shortMonthsParse=[]),i=0;i<12;i++){if(r=h([2e3,i]),n&&!this._longMonthsParse[i]&&(this._longMonthsParse[i]=new RegExp("^"+this.months(r,"").replace(".","")+"$","i"),this._shortMonthsParse[i]=new RegExp("^"+this.monthsShort(r,"").replace(".","")+"$","i")),n||this._monthsParse[i]||(o="^"+this.months(r,"")+"|^"+this.monthsShort(r,""),this._monthsParse[i]=new RegExp(o.replace(".",""),"i")),n&&"MMMM"===e&&this._longMonthsParse[i].test(t))return i;if(n&&"MMM"===e&&this._shortMonthsParse[i].test(t))return i;if(!n&&this._monthsParse[i].test(t))return i}},On.monthsRegex=function(t){return this._monthsParseExact?(o(this,"_monthsRegex")||Nt.call(this),t?this._monthsStrictRegex:this._monthsRegex):(o(this,"_monthsRegex")||(this._monthsRegex=Lt),this._monthsStrictRegex&&t?this._monthsStrictRegex:this._monthsRegex)},On.monthsShortRegex=function(t){return this._monthsParseExact?(o(this,"_monthsRegex")||Nt.call(this),t?this._monthsShortStrictRegex:this._monthsShortRegex):(o(this,"_monthsShortRegex")||(this._monthsShortRegex=Dt),this._monthsShortStrictRegex&&t?this._monthsShortStrictRegex:this._monthsShortRegex)},On.week=function(t){return Wt(t,this._week.dow,this._week.doy).week},On.firstDayOfYear=function(){return this._week.doy},On.firstDayOfWeek=function(){return this._week.dow},On.weekdays=function(t,e){var n=i(this._weekdays)?this._weekdays:this._weekdays[t&&!0!==t&&this._weekdays.isFormat.test(e)?"format":"standalone"];return!0===t?Yt(n,this._week.dow):t?n[t.day()]:n},On.weekdaysMin=function(t){return!0===t?Yt(this._weekdaysMin,this._week.dow):t?this._weekdaysMin[t.day()]:this._weekdaysMin},On.weekdaysShort=function(t){return!0===t?Yt(this._weekdaysShort,this._week.dow):t?this._weekdaysShort[t.day()]:this._weekdaysShort},On.weekdaysParse=function(t,e,n){var i,r,o;if(this._weekdaysParseExact)return te.call(this,t,e,n);for(this._weekdaysParse||(this._weekdaysParse=[],this._minWeekdaysParse=[],this._shortWeekdaysParse=[],this._fullWeekdaysParse=[]),i=0;i<7;i++){if(r=h([2e3,1]).day(i),n&&!this._fullWeekdaysParse[i]&&(this._fullWeekdaysParse[i]=new RegExp("^"+this.weekdays(r,"").replace(".","\\.?")+"$","i"),this._shortWeekdaysParse[i]=new RegExp("^"+this.weekdaysShort(r,"").replace(".","\\.?")+"$","i"),this._minWeekdaysParse[i]=new RegExp("^"+this.weekdaysMin(r,"").replace(".","\\.?")+"$","i")),this._weekdaysParse[i]||(o="^"+this.weekdays(r,"")+"|^"+this.weekdaysShort(r,"")+"|^"+this.weekdaysMin(r,""),this._weekdaysParse[i]=new RegExp(o.replace(".",""),"i")),n&&"dddd"===e&&this._fullWeekdaysParse[i].test(t))return i;if(n&&"ddd"===e&&this._shortWeekdaysParse[i].test(t))return i;if(n&&"dd"===e&&this._minWeekdaysParse[i].test(t))return i;if(!n&&this._weekdaysParse[i].test(t))return i}},On.weekdaysRegex=function(t){return this._weekdaysParseExact?(o(this,"_weekdaysRegex")||ee.call(this),t?this._weekdaysStrictRegex:this._weekdaysRegex):(o(this,"_weekdaysRegex")||(this._weekdaysRegex=Jt),this._weekdaysStrictRegex&&t?this._weekdaysStrictRegex:this._weekdaysRegex)},On.weekdaysShortRegex=function(t){return this._weekdaysParseExact?(o(this,"_weekdaysRegex")||ee.call(this),t?this._weekdaysShortStrictRegex:this._weekdaysShortRegex):(o(this,"_weekdaysShortRegex")||(this._weekdaysShortRegex=Zt),this._weekdaysShortStrictRegex&&t?this._weekdaysShortStrictRegex:this._weekdaysShortRegex)},On.weekdaysMinRegex=function(t){return this._weekdaysParseExact?(o(this,"_weekdaysRegex")||ee.call(this),t?this._weekdaysMinStrictRegex:this._weekdaysMinRegex):(o(this,"_weekdaysMinRegex")||(this._weekdaysMinRegex=Xt),this._weekdaysMinStrictRegex&&t?this._weekdaysMinStrictRegex:this._weekdaysMinRegex)},On.isPM=function(t){return"p"===(t+"").toLowerCase().charAt(0)},On.meridiem=function(t,e,n){return t>11?n?"pm":"PM":n?"am":"AM"},fe("en",{eras:[{since:"0001-01-01",until:1/0,offset:1,name:"Anno Domini",narrow:"AD",abbr:"AD"},{since:"0000-12-31",until:-1/0,offset:1,name:"Before Christ",narrow:"BC",abbr:"BC"}],dayOfMonthOrdinalParse:/\d{1,2}(th|st|nd|rd)/,ordinal:function(t){var e=t%10;return t+(1===W(t%100/10)?"th":1===e?"st":2===e?"nd":3===e?"rd":"th")}}),n.lang=k("moment.lang is deprecated. Use moment.locale instead.",fe),n.langData=k("moment.langData is deprecated. Use moment.localeData instead.",me);var Dn=Math.abs;function Ln(t,e,n,i){var r=Ge(e,n);return t._milliseconds+=i*r._milliseconds,t._days+=i*r._days,t._months+=i*r._months,t._bubble()}function qn(t){return t<0?Math.floor(t):Math.ceil(t)}function Rn(t){return 4800*t/146097}function In(t){return 146097*t/4800}function Nn(t){return function(){return this.as(t)}}var Fn=Nn("ms"),$n=Nn("s"),jn=Nn("m"),zn=Nn("h"),Vn=Nn("d"),Hn=Nn("w"),Wn=Nn("M"),Un=Nn("Q"),Yn=Nn("y");function Qn(t){return function(){return this.isValid()?this._data[t]:NaN}}var Gn=Qn("milliseconds"),Kn=Qn("seconds"),Jn=Qn("minutes"),Zn=Qn("hours"),Xn=Qn("days"),ti=Qn("months"),ei=Qn("years");var ni=Math.round,ii={ss:44,s:45,m:45,h:22,d:26,w:null,M:11};function ri(t,e,n,i,r){return r.relativeTime(e||1,!!n,t,i)}var oi=Math.abs;function ai(t){return(t>0)-(t<0)||+t}function si(){if(!this.isValid())return this.localeData().invalidDate();var t,e,n,i,r,o,a,s,l=oi(this._milliseconds)/1e3,c=oi(this._days),u=oi(this._months),d=this.asSeconds();return d?(t=H(l/60),e=H(t/60),l%=60,t%=60,n=H(u/12),u%=12,i=l?l.toFixed(3).replace(/\.?0+$/,""):"",r=d<0?"-":"",o=ai(this._months)!==ai(d)?"-":"",a=ai(this._days)!==ai(d)?"-":"",s=ai(this._milliseconds)!==ai(d)?"-":"",r+"P"+(n?o+n+"Y":"")+(u?o+u+"M":"")+(c?a+c+"D":"")+(e||t||l?"T":"")+(e?s+e+"H":"")+(t?s+t+"M":"")+(l?s+i+"S":"")):"P0D"}var li=Ne.prototype;return li.isValid=function(){return this._isValid},li.abs=function(){var t=this._data;return this._milliseconds=Dn(this._milliseconds),this._days=Dn(this._days),this._months=Dn(this._months),t.milliseconds=Dn(t.milliseconds),t.seconds=Dn(t.seconds),t.minutes=Dn(t.minutes),t.hours=Dn(t.hours),t.months=Dn(t.months),t.years=Dn(t.years),this},li.add=function(t,e){return Ln(this,t,e,1)},li.subtract=function(t,e){return Ln(this,t,e,-1)},li.as=function(t){if(!this.isValid())return NaN;var e,n,i=this._milliseconds;if("month"===(t=F(t))||"quarter"===t||"year"===t)switch(e=this._days+i/864e5,n=this._months+Rn(e),t){case"month":return n;case"quarter":return n/3;case"year":return n/12}else switch(e=this._days+Math.round(In(this._months)),t){case"week":return e/7+i/6048e5;case"day":return e+i/864e5;case"hour":return 24*e+i/36e5;case"minute":return 1440*e+i/6e4;case"second":return 86400*e+i/1e3;case"millisecond":return Math.floor(864e5*e)+i;default:throw new Error("Unknown unit "+t)}},li.asMilliseconds=Fn,li.asSeconds=$n,li.asMinutes=jn,li.asHours=zn,li.asDays=Vn,li.asWeeks=Hn,li.asMonths=Wn,li.asQuarters=Un,li.asYears=Yn,li.valueOf=function(){return this.isValid()?this._milliseconds+864e5*this._days+this._months%12*2592e6+31536e6*W(this._months/12):NaN},li._bubble=function(){var t,e,n,i,r,o=this._milliseconds,a=this._days,s=this._months,l=this._data;return o>=0&&a>=0&&s>=0||o<=0&&a<=0&&s<=0||(o+=864e5*qn(In(s)+a),a=0,s=0),l.milliseconds=o%1e3,t=H(o/1e3),l.seconds=t%60,e=H(t/60),l.minutes=e%60,n=H(e/60),l.hours=n%24,a+=H(n/24),s+=r=H(Rn(a)),a-=qn(In(r)),i=H(s/12),s%=12,l.days=a,l.months=s,l.years=i,this},li.clone=function(){return Ge(this)},li.get=function(t){return t=F(t),this.isValid()?this[t+"s"]():NaN},li.milliseconds=Gn,li.seconds=Kn,li.minutes=Jn,li.hours=Zn,li.days=Xn,li.weeks=function(){return H(this.days()/7)},li.months=ti,li.years=ei,li.humanize=function(t,e){if(!this.isValid())return this.localeData().invalidDate();var n,i,r=!1,o=ii;return"object"==typeof t&&(e=t,t=!1),"boolean"==typeof t&&(r=t),"object"==typeof e&&(o=Object.assign({},ii,e),null!=e.s&&null==e.ss&&(o.ss=e.s-1)),i=function(t,e,n,i){var r=Ge(t).abs(),o=ni(r.as("s")),a=ni(r.as("m")),s=ni(r.as("h")),l=ni(r.as("d")),c=ni(r.as("M")),u=ni(r.as("w")),d=ni(r.as("y")),h=o<=n.ss&&["s",o]||o<n.s&&["ss",o]||a<=1&&["m"]||a<n.m&&["mm",a]||s<=1&&["h"]||s<n.h&&["hh",s]||l<=1&&["d"]||l<n.d&&["dd",l];return null!=n.w&&(h=h||u<=1&&["w"]||u<n.w&&["ww",u]),(h=h||c<=1&&["M"]||c<n.M&&["MM",c]||d<=1&&["y"]||["yy",d])[2]=e,h[3]=+t>0,h[4]=i,ri.apply(null,h)}(this,!r,o,n=this.localeData()),r&&(i=n.pastFuture(+this,i)),n.postformat(i)},li.toISOString=si,li.toString=si,li.toJSON=si,li.locale=an,li.localeData=ln,li.toIsoString=k("toIsoString() is deprecated. Please use toISOString() instead (notice the capitals)",si),li.lang=sn,L("X",0,0,"unix"),L("x",0,0,"valueOf"),ht("x",lt),ht("X",/[+-]?\d+(\.\d{1,3})?/),vt("X",(function(t,e,n){n._d=new Date(1e3*parseFloat(t))})),vt("x",(function(t,e,n){n._d=new Date(W(t))})),
//! moment.js
n.version="2.29.4",t=De,n.fn=Tn,n.min=function(){return Re("isBefore",[].slice.call(arguments,0))},n.max=function(){return Re("isAfter",[].slice.call(arguments,0))},n.now=function(){return Date.now?Date.now():+new Date},n.utc=h,n.unix=function(t){return De(1e3*t)},n.months=function(t,e){return En(t,e,"months")},n.isDate=c,n.locale=fe,n.invalid=m,n.duration=Ge,n.isMoment=b,n.weekdays=function(t,e,n){return An(t,e,n,"weekdays")},n.parseZone=function(){return De.apply(null,arguments).parseZone()},n.localeData=me,n.isDuration=Fe,n.monthsShort=function(t,e){return En(t,e,"monthsShort")},n.weekdaysMin=function(t,e,n){return An(t,e,n,"weekdaysMin")},n.defineLocale=pe,n.updateLocale=function(t,e){if(null!=e){var n,i,r=se;null!=le[t]&&null!=le[t].parentLocale?le[t].set(T(le[t]._config,e)):(null!=(i=he(t))&&(r=i._config),e=T(r,e),null==i&&(e.abbr=t),(n=new P(e)).parentLocale=le[t],le[t]=n),fe(t)}else null!=le[t]&&(null!=le[t].parentLocale?(le[t]=le[t].parentLocale,t===fe()&&fe(t)):null!=le[t]&&delete le[t]);return le[t]},n.locales=function(){return x(le)},n.weekdaysShort=function(t,e,n){return An(t,e,n,"weekdaysShort")},n.normalizeUnits=F,n.relativeTimeRounding=function(t){return void 0===t?ni:"function"==typeof t&&(ni=t,!0)},n.relativeTimeThreshold=function(t,e){return void 0!==ii[t]&&(void 0===e?ii[t]:(ii[t]=e,"s"===t&&(ii.ss=e-1),!0))},n.calendarFormat=function(t,e){var n=t.diff(e,"days",!0);return n<-6?"sameElse":n<-1?"lastWeek":n<0?"lastDay":n<1?"sameDay":n<2?"nextDay":n<7?"nextWeek":"sameElse"},n.prototype=Tn,n.HTML5_FMT={DATETIME_LOCAL:"YYYY-MM-DDTHH:mm",DATETIME_LOCAL_SECONDS:"YYYY-MM-DDTHH:mm:ss",DATETIME_LOCAL_MS:"YYYY-MM-DDTHH:mm:ss.SSS",DATE:"YYYY-MM-DD",TIME:"HH:mm",TIME_SECONDS:"HH:mm:ss",TIME_MS:"HH:mm:ss.SSS",WEEK:"GGGG-[W]WW",MONTH:"YYYY-MM"},n})),function(t,e){"object"==typeof exports&&"undefined"!=typeof module?module.exports=e():"function"==typeof define&&define.amd?define("underscore",e):(t="undefined"!=typeof globalThis?globalThis:t||self,function(){var n=t._,i=t._=e();i.noConflict=function(){return t._=n,i}}())}(this,(function(){var t="1.13.6",e="object"==typeof self&&self.self===self&&self||"object"==typeof global&&global.global===global&&global||Function("return this")()||{},n=Array.prototype,i=Object.prototype,r="undefined"!=typeof Symbol?Symbol.prototype:null,o=n.push,a=n.slice,s=i.toString,l=i.hasOwnProperty,c="undefined"!=typeof ArrayBuffer,u="undefined"!=typeof DataView,d=Array.isArray,h=Object.keys,f=Object.create,p=c&&ArrayBuffer.isView,m=isNaN,v=isFinite,g=!{toString:null}.propertyIsEnumerable("toString"),y=["valueOf","isPrototypeOf","toString","propertyIsEnumerable","hasOwnProperty","toLocaleString"],_=Math.pow(2,53)-1;function b(t,e){return e=null==e?t.length-1:+e,function(){for(var n=Math.max(arguments.length-e,0),i=Array(n),r=0;r<n;r++)i[r]=arguments[r+e];switch(e){case 0:return t.call(this,i);case 1:return t.call(this,arguments[0],i);case 2:return t.call(this,arguments[0],arguments[1],i)}var o=Array(e+1);for(r=0;r<e;r++)o[r]=arguments[r];return o[e]=i,t.apply(this,o)}}function w(t){var e=typeof t;return"function"===e||"object"===e&&!!t}function k(t){return void 0===t}function x(t){return!0===t||!1===t||"[object Boolean]"===s.call(t)}function C(t){var e="[object "+t+"]";return function(t){return s.call(t)===e}}var S=C("String"),M=C("Number"),T=C("Date"),P=C("RegExp"),O=C("Error"),B=C("Symbol"),E=C("ArrayBuffer"),A=C("Function"),D=e.document&&e.document.childNodes;"function"!=typeof/./&&"object"!=typeof Int8Array&&"function"!=typeof D&&(A=function(t){return"function"==typeof t||!1});var L=A,q=C("Object"),R=u&&q(new DataView(new ArrayBuffer(8))),I="undefined"!=typeof Map&&q(new Map),N=C("DataView");var F=R?function(t){return null!=t&&L(t.getInt8)&&E(t.buffer)}:N,$=d||C("Array");function j(t,e){return null!=t&&l.call(t,e)}var z=C("Arguments");!function(){z(arguments)||(z=function(t){return j(t,"callee")})}();var V=z;function H(t){return M(t)&&m(t)}function W(t){return function(){return t}}function U(t){return function(e){var n=t(e);return"number"==typeof n&&n>=0&&n<=_}}function Y(t){return function(e){return null==e?void 0:e[t]}}var Q=Y("byteLength"),G=U(Q),K=/\[object ((I|Ui)nt(8|16|32)|Float(32|64)|Uint8Clamped|Big(I|Ui)nt64)Array\]/;var J=c?function(t){return p?p(t)&&!F(t):G(t)&&K.test(s.call(t))}:W(!1),Z=Y("length");function X(t,e){e=function(t){for(var e={},n=t.length,i=0;i<n;++i)e[t[i]]=!0;return{contains:function(t){return!0===e[t]},push:function(n){return e[n]=!0,t.push(n)}}}(e);var n=y.length,r=t.constructor,o=L(r)&&r.prototype||i,a="constructor";for(j(t,a)&&!e.contains(a)&&e.push(a);n--;)(a=y[n])in t&&t[a]!==o[a]&&!e.contains(a)&&e.push(a)}function tt(t){if(!w(t))return[];if(h)return h(t);var e=[];for(var n in t)j(t,n)&&e.push(n);return g&&X(t,e),e}function et(t,e){var n=tt(e),i=n.length;if(null==t)return!i;for(var r=Object(t),o=0;o<i;o++){var a=n[o];if(e[a]!==r[a]||!(a in r))return!1}return!0}function nt(t){return t instanceof nt?t:this instanceof nt?void(this._wrapped=t):new nt(t)}function it(t){return new Uint8Array(t.buffer||t,t.byteOffset||0,Q(t))}nt.VERSION=t,nt.prototype.value=function(){return this._wrapped},nt.prototype.valueOf=nt.prototype.toJSON=nt.prototype.value,nt.prototype.toString=function(){return String(this._wrapped)};var rt="[object DataView]";function ot(t,e,n,i){if(t===e)return 0!==t||1/t==1/e;if(null==t||null==e)return!1;if(t!=t)return e!=e;var r=typeof t;return("function"===r||"object"===r||"object"==typeof e)&&at(t,e,n,i)}function at(t,e,n,i){t instanceof nt&&(t=t._wrapped),e instanceof nt&&(e=e._wrapped);var o=s.call(t);if(o!==s.call(e))return!1;if(R&&"[object Object]"==o&&F(t)){if(!F(e))return!1;o=rt}switch(o){case"[object RegExp]":case"[object String]":return""+t==""+e;case"[object Number]":return+t!=+t?+e!=+e:0==+t?1/+t==1/e:+t==+e;case"[object Date]":case"[object Boolean]":return+t==+e;case"[object Symbol]":return r.valueOf.call(t)===r.valueOf.call(e);case"[object ArrayBuffer]":case rt:return at(it(t),it(e),n,i)}var a="[object Array]"===o;if(!a&&J(t)){if(Q(t)!==Q(e))return!1;if(t.buffer===e.buffer&&t.byteOffset===e.byteOffset)return!0;a=!0}if(!a){if("object"!=typeof t||"object"!=typeof e)return!1;var l=t.constructor,c=e.constructor;if(l!==c&&!(L(l)&&l instanceof l&&L(c)&&c instanceof c)&&"constructor"in t&&"constructor"in e)return!1}i=i||[];for(var u=(n=n||[]).length;u--;)if(n[u]===t)return i[u]===e;if(n.push(t),i.push(e),a){if((u=t.length)!==e.length)return!1;for(;u--;)if(!ot(t[u],e[u],n,i))return!1}else{var d,h=tt(t);if(u=h.length,tt(e).length!==u)return!1;for(;u--;)if(!j(e,d=h[u])||!ot(t[d],e[d],n,i))return!1}return n.pop(),i.pop(),!0}function st(t){if(!w(t))return[];var e=[];for(var n in t)e.push(n);return g&&X(t,e),e}function lt(t){var e=Z(t);return function(n){if(null==n)return!1;var i=st(n);if(Z(i))return!1;for(var r=0;r<e;r++)if(!L(n[t[r]]))return!1;return t!==ft||!L(n[ct])}}var ct="forEach",ut=["clear","delete"],dt=["get","has","set"],ht=ut.concat(ct,dt),ft=ut.concat(dt),pt=["add"].concat(ut,ct,"has"),mt=I?lt(ht):C("Map"),vt=I?lt(ft):C("WeakMap"),gt=I?lt(pt):C("Set"),yt=C("WeakSet");function _t(t){for(var e=tt(t),n=e.length,i=Array(n),r=0;r<n;r++)i[r]=t[e[r]];return i}function bt(t){for(var e={},n=tt(t),i=0,r=n.length;i<r;i++)e[t[n[i]]]=n[i];return e}function wt(t){var e=[];for(var n in t)L(t[n])&&e.push(n);return e.sort()}function kt(t,e){return function(n){var i=arguments.length;if(e&&(n=Object(n)),i<2||null==n)return n;for(var r=1;r<i;r++)for(var o=arguments[r],a=t(o),s=a.length,l=0;l<s;l++){var c=a[l];e&&void 0!==n[c]||(n[c]=o[c])}return n}}var xt=kt(st),Ct=kt(tt),St=kt(st,!0);function Mt(t){if(!w(t))return{};if(f)return f(t);var e=function(){};e.prototype=t;var n=new e;return e.prototype=null,n}function Tt(t){return $(t)?t:[t]}function Pt(t){return nt.toPath(t)}function Ot(t,e){for(var n=e.length,i=0;i<n;i++){if(null==t)return;t=t[e[i]]}return n?t:void 0}function Bt(t,e,n){var i=Ot(t,Pt(e));return k(i)?n:i}function Et(t){return t}function At(t){return t=Ct({},t),function(e){return et(e,t)}}function Dt(t){return t=Pt(t),function(e){return Ot(e,t)}}function Lt(t,e,n){if(void 0===e)return t;switch(null==n?3:n){case 1:return function(n){return t.call(e,n)};case 3:return function(n,i,r){return t.call(e,n,i,r)};case 4:return function(n,i,r,o){return t.call(e,n,i,r,o)}}return function(){return t.apply(e,arguments)}}function qt(t,e,n){return null==t?Et:L(t)?Lt(t,e,n):w(t)&&!$(t)?At(t):Dt(t)}function Rt(t,e){return qt(t,e,1/0)}function It(t,e,n){return nt.iteratee!==Rt?nt.iteratee(t,e):qt(t,e,n)}function Nt(){}function Ft(t,e){return null==e&&(e=t,t=0),t+Math.floor(Math.random()*(e-t+1))}nt.toPath=Tt,nt.iteratee=Rt;var $t=Date.now||function(){return(new Date).getTime()};function jt(t){var e=function(e){return t[e]},n="(?:"+tt(t).join("|")+")",i=RegExp(n),r=RegExp(n,"g");return function(t){return t=null==t?"":""+t,i.test(t)?t.replace(r,e):t}}var zt={"&":"&amp;","<":"&lt;",">":"&gt;",'"':"&quot;","'":"&#x27;","`":"&#x60;"},Vt=jt(zt),Ht=jt(bt(zt)),Wt=nt.templateSettings={evaluate:/<%([\s\S]+?)%>/g,interpolate:/<%=([\s\S]+?)%>/g,escape:/<%-([\s\S]+?)%>/g},Ut=/(.)^/,Yt={"'":"'","\\":"\\","\r":"r","\n":"n","\u2028":"u2028","\u2029":"u2029"},Qt=/\\|'|\r|\n|\u2028|\u2029/g;function Gt(t){return"\\"+Yt[t]}var Kt=/^\s*(\w|\$)+\s*$/;var Jt=0;function Zt(t,e,n,i,r){if(!(i instanceof e))return t.apply(n,r);var o=Mt(t.prototype),a=t.apply(o,r);return w(a)?a:o}var Xt=b((function(t,e){var n=Xt.placeholder,i=function(){for(var r=0,o=e.length,a=Array(o),s=0;s<o;s++)a[s]=e[s]===n?arguments[r++]:e[s];for(;r<arguments.length;)a.push(arguments[r++]);return Zt(t,i,this,this,a)};return i}));Xt.placeholder=nt;var te=b((function(t,e,n){if(!L(t))throw new TypeError("Bind must be called on a function");var i=b((function(r){return Zt(t,i,e,this,n.concat(r))}));return i})),ee=U(Z);function ne(t,e,n,i){if(i=i||[],e||0===e){if(e<=0)return i.concat(t)}else e=1/0;for(var r=i.length,o=0,a=Z(t);o<a;o++){var s=t[o];if(ee(s)&&($(s)||V(s)))if(e>1)ne(s,e-1,n,i),r=i.length;else for(var l=0,c=s.length;l<c;)i[r++]=s[l++];else n||(i[r++]=s)}return i}var ie=b((function(t,e){var n=(e=ne(e,!1,!1)).length;if(n<1)throw new Error("bindAll must be passed function names");for(;n--;){var i=e[n];t[i]=te(t[i],t)}return t}));var re=b((function(t,e,n){return setTimeout((function(){return t.apply(null,n)}),e)})),oe=Xt(re,nt,1);function ae(t){return function(){return!t.apply(this,arguments)}}function se(t,e){var n;return function(){return--t>0&&(n=e.apply(this,arguments)),t<=1&&(e=null),n}}var le=Xt(se,2);function ce(t,e,n){e=It(e,n);for(var i,r=tt(t),o=0,a=r.length;o<a;o++)if(e(t[i=r[o]],i,t))return i}function ue(t){return function(e,n,i){n=It(n,i);for(var r=Z(e),o=t>0?0:r-1;o>=0&&o<r;o+=t)if(n(e[o],o,e))return o;return-1}}var de=ue(1),he=ue(-1);function fe(t,e,n,i){for(var r=(n=It(n,i,1))(e),o=0,a=Z(t);o<a;){var s=Math.floor((o+a)/2);n(t[s])<r?o=s+1:a=s}return o}function pe(t,e,n){return function(i,r,o){var s=0,l=Z(i);if("number"==typeof o)t>0?s=o>=0?o:Math.max(o+l,s):l=o>=0?Math.min(o+1,l):o+l+1;else if(n&&o&&l)return i[o=n(i,r)]===r?o:-1;if(r!=r)return(o=e(a.call(i,s,l),H))>=0?o+s:-1;for(o=t>0?s:l-1;o>=0&&o<l;o+=t)if(i[o]===r)return o;return-1}}var me=pe(1,de,fe),ve=pe(-1,he);function ge(t,e,n){var i=(ee(t)?de:ce)(t,e,n);if(void 0!==i&&-1!==i)return t[i]}function ye(t,e,n){var i,r;if(e=Lt(e,n),ee(t))for(i=0,r=t.length;i<r;i++)e(t[i],i,t);else{var o=tt(t);for(i=0,r=o.length;i<r;i++)e(t[o[i]],o[i],t)}return t}function _e(t,e,n){e=It(e,n);for(var i=!ee(t)&&tt(t),r=(i||t).length,o=Array(r),a=0;a<r;a++){var s=i?i[a]:a;o[a]=e(t[s],s,t)}return o}function be(t){return function(e,n,i,r){var o=arguments.length>=3;return function(e,n,i,r){var o=!ee(e)&&tt(e),a=(o||e).length,s=t>0?0:a-1;for(r||(i=e[o?o[s]:s],s+=t);s>=0&&s<a;s+=t){var l=o?o[s]:s;i=n(i,e[l],l,e)}return i}(e,Lt(n,r,4),i,o)}}var we=be(1),ke=be(-1);function xe(t,e,n){var i=[];return e=It(e,n),ye(t,(function(t,n,r){e(t,n,r)&&i.push(t)})),i}function Ce(t,e,n){e=It(e,n);for(var i=!ee(t)&&tt(t),r=(i||t).length,o=0;o<r;o++){var a=i?i[o]:o;if(!e(t[a],a,t))return!1}return!0}function Se(t,e,n){e=It(e,n);for(var i=!ee(t)&&tt(t),r=(i||t).length,o=0;o<r;o++){var a=i?i[o]:o;if(e(t[a],a,t))return!0}return!1}function Me(t,e,n,i){return ee(t)||(t=_t(t)),("number"!=typeof n||i)&&(n=0),me(t,e,n)>=0}var Te=b((function(t,e,n){var i,r;return L(e)?r=e:(e=Pt(e),i=e.slice(0,-1),e=e[e.length-1]),_e(t,(function(t){var o=r;if(!o){if(i&&i.length&&(t=Ot(t,i)),null==t)return;o=t[e]}return null==o?o:o.apply(t,n)}))}));function Pe(t,e){return _e(t,Dt(e))}function Oe(t,e,n){var i,r,o=-1/0,a=-1/0;if(null==e||"number"==typeof e&&"object"!=typeof t[0]&&null!=t)for(var s=0,l=(t=ee(t)?t:_t(t)).length;s<l;s++)null!=(i=t[s])&&i>o&&(o=i);else e=It(e,n),ye(t,(function(t,n,i){((r=e(t,n,i))>a||r===-1/0&&o===-1/0)&&(o=t,a=r)}));return o}var Be=/[^\ud800-\udfff]|[\ud800-\udbff][\udc00-\udfff]|[\ud800-\udfff]/g;function Ee(t){return t?$(t)?a.call(t):S(t)?t.match(Be):ee(t)?_e(t,Et):_t(t):[]}function Ae(t,e,n){if(null==e||n)return ee(t)||(t=_t(t)),t[Ft(t.length-1)];var i=Ee(t),r=Z(i);e=Math.max(Math.min(e,r),0);for(var o=r-1,a=0;a<e;a++){var s=Ft(a,o),l=i[a];i[a]=i[s],i[s]=l}return i.slice(0,e)}function De(t,e){return function(n,i,r){var o=e?[[],[]]:{};return i=It(i,r),ye(n,(function(e,r){var a=i(e,r,n);t(o,e,a)})),o}}var Le=De((function(t,e,n){j(t,n)?t[n].push(e):t[n]=[e]})),qe=De((function(t,e,n){t[n]=e})),Re=De((function(t,e,n){j(t,n)?t[n]++:t[n]=1})),Ie=De((function(t,e,n){t[n?0:1].push(e)}),!0);function Ne(t,e,n){return e in n}var Fe=b((function(t,e){var n={},i=e[0];if(null==t)return n;L(i)?(e.length>1&&(i=Lt(i,e[1])),e=st(t)):(i=Ne,e=ne(e,!1,!1),t=Object(t));for(var r=0,o=e.length;r<o;r++){var a=e[r],s=t[a];i(s,a,t)&&(n[a]=s)}return n})),$e=b((function(t,e){var n,i=e[0];return L(i)?(i=ae(i),e.length>1&&(n=e[1])):(e=_e(ne(e,!1,!1),String),i=function(t,n){return!Me(e,n)}),Fe(t,i,n)}));function je(t,e,n){return a.call(t,0,Math.max(0,t.length-(null==e||n?1:e)))}function ze(t,e,n){return null==t||t.length<1?null==e||n?void 0:[]:null==e||n?t[0]:je(t,t.length-e)}function Ve(t,e,n){return a.call(t,null==e||n?1:e)}var He=b((function(t,e){return e=ne(e,!0,!0),xe(t,(function(t){return!Me(e,t)}))})),We=b((function(t,e){return He(t,e)}));function Ue(t,e,n,i){x(e)||(i=n,n=e,e=!1),null!=n&&(n=It(n,i));for(var r=[],o=[],a=0,s=Z(t);a<s;a++){var l=t[a],c=n?n(l,a,t):l;e&&!n?(a&&o===c||r.push(l),o=c):n?Me(o,c)||(o.push(c),r.push(l)):Me(r,l)||r.push(l)}return r}var Ye=b((function(t){return Ue(ne(t,!0,!0))}));function Qe(t){for(var e=t&&Oe(t,Z).length||0,n=Array(e),i=0;i<e;i++)n[i]=Pe(t,i);return n}var Ge=b(Qe);function Ke(t,e){return t._chain?nt(e).chain():e}function Je(t){return ye(wt(t),(function(e){var n=nt[e]=t[e];nt.prototype[e]=function(){var t=[this._wrapped];return o.apply(t,arguments),Ke(this,n.apply(nt,t))}})),nt}ye(["pop","push","reverse","shift","sort","splice","unshift"],(function(t){var e=n[t];nt.prototype[t]=function(){var n=this._wrapped;return null!=n&&(e.apply(n,arguments),"shift"!==t&&"splice"!==t||0!==n.length||delete n[0]),Ke(this,n)}})),ye(["concat","join","slice"],(function(t){var e=n[t];nt.prototype[t]=function(){var t=this._wrapped;return null!=t&&(t=e.apply(t,arguments)),Ke(this,t)}}));var Ze={__proto__:null,VERSION:t,restArguments:b,isObject:w,isNull:function(t){return null===t},isUndefined:k,isBoolean:x,isElement:function(t){return!(!t||1!==t.nodeType)},isString:S,isNumber:M,isDate:T,isRegExp:P,isError:O,isSymbol:B,isArrayBuffer:E,isDataView:F,isArray:$,isFunction:L,isArguments:V,isFinite:function(t){return!B(t)&&v(t)&&!isNaN(parseFloat(t))},isNaN:H,isTypedArray:J,isEmpty:function(t){if(null==t)return!0;var e=Z(t);return"number"==typeof e&&($(t)||S(t)||V(t))?0===e:0===Z(tt(t))},isMatch:et,isEqual:function(t,e){return ot(t,e)},isMap:mt,isWeakMap:vt,isSet:gt,isWeakSet:yt,keys:tt,allKeys:st,values:_t,pairs:function(t){for(var e=tt(t),n=e.length,i=Array(n),r=0;r<n;r++)i[r]=[e[r],t[e[r]]];return i},invert:bt,functions:wt,methods:wt,extend:xt,extendOwn:Ct,assign:Ct,defaults:St,create:function(t,e){var n=Mt(t);return e&&Ct(n,e),n},clone:function(t){return w(t)?$(t)?t.slice():xt({},t):t},tap:function(t,e){return e(t),t},get:Bt,has:function(t,e){for(var n=(e=Pt(e)).length,i=0;i<n;i++){var r=e[i];if(!j(t,r))return!1;t=t[r]}return!!n},mapObject:function(t,e,n){e=It(e,n);for(var i=tt(t),r=i.length,o={},a=0;a<r;a++){var s=i[a];o[s]=e(t[s],s,t)}return o},identity:Et,constant:W,noop:Nt,toPath:Tt,property:Dt,propertyOf:function(t){return null==t?Nt:function(e){return Bt(t,e)}},matcher:At,matches:At,times:function(t,e,n){var i=Array(Math.max(0,t));e=Lt(e,n,1);for(var r=0;r<t;r++)i[r]=e(r);return i},random:Ft,now:$t,escape:Vt,unescape:Ht,templateSettings:Wt,template:function(t,e,n){!e&&n&&(e=n),e=St({},e,nt.templateSettings);var i=RegExp([(e.escape||Ut).source,(e.interpolate||Ut).source,(e.evaluate||Ut).source].join("|")+"|$","g"),r=0,o="__p+='";t.replace(i,(function(e,n,i,a,s){return o+=t.slice(r,s).replace(Qt,Gt),r=s+e.length,n?o+="'+\n((__t=("+n+"))==null?'':_.escape(__t))+\n'":i?o+="'+\n((__t=("+i+"))==null?'':__t)+\n'":a&&(o+="';\n"+a+"\n__p+='"),e})),o+="';\n";var a,s=e.variable;if(s){if(!Kt.test(s))throw new Error("variable is not a bare identifier: "+s)}else o="with(obj||{}){\n"+o+"}\n",s="obj";o="var __t,__p='',__j=Array.prototype.join,print=function(){__p+=__j.call(arguments,'');};\n"+o+"return __p;\n";try{a=new Function(s,"_",o)}catch(t){throw t.source=o,t}var l=function(t){return a.call(this,t,nt)};return l.source="function("+s+"){\n"+o+"}",l},result:function(t,e,n){var i=(e=Pt(e)).length;if(!i)return L(n)?n.call(t):n;for(var r=0;r<i;r++){var o=null==t?void 0:t[e[r]];void 0===o&&(o=n,r=i),t=L(o)?o.call(t):o}return t},uniqueId:function(t){var e=++Jt+"";return t?t+e:e},chain:function(t){var e=nt(t);return e._chain=!0,e},iteratee:Rt,partial:Xt,bind:te,bindAll:ie,memoize:function(t,e){var n=function(i){var r=n.cache,o=""+(e?e.apply(this,arguments):i);return j(r,o)||(r[o]=t.apply(this,arguments)),r[o]};return n.cache={},n},delay:re,defer:oe,throttle:function(t,e,n){var i,r,o,a,s=0;n||(n={});var l=function(){s=!1===n.leading?0:$t(),i=null,a=t.apply(r,o),i||(r=o=null)},c=function(){var c=$t();s||!1!==n.leading||(s=c);var u=e-(c-s);return r=this,o=arguments,u<=0||u>e?(i&&(clearTimeout(i),i=null),s=c,a=t.apply(r,o),i||(r=o=null)):i||!1===n.trailing||(i=setTimeout(l,u)),a};return c.cancel=function(){clearTimeout(i),s=0,i=r=o=null},c},debounce:function(t,e,n){var i,r,o,a,s,l=function(){var c=$t()-r;e>c?i=setTimeout(l,e-c):(i=null,n||(a=t.apply(s,o)),i||(o=s=null))},c=b((function(c){return s=this,o=c,r=$t(),i||(i=setTimeout(l,e),n&&(a=t.apply(s,o))),a}));return c.cancel=function(){clearTimeout(i),i=o=s=null},c},wrap:function(t,e){return Xt(e,t)},negate:ae,compose:function(){var t=arguments,e=t.length-1;return function(){for(var n=e,i=t[e].apply(this,arguments);n--;)i=t[n].call(this,i);return i}},after:function(t,e){return function(){if(--t<1)return e.apply(this,arguments)}},before:se,once:le,findKey:ce,findIndex:de,findLastIndex:he,sortedIndex:fe,indexOf:me,lastIndexOf:ve,find:ge,detect:ge,findWhere:function(t,e){return ge(t,At(e))},each:ye,forEach:ye,map:_e,collect:_e,reduce:we,foldl:we,inject:we,reduceRight:ke,foldr:ke,filter:xe,select:xe,reject:function(t,e,n){return xe(t,ae(It(e)),n)},every:Ce,all:Ce,some:Se,any:Se,contains:Me,includes:Me,include:Me,invoke:Te,pluck:Pe,where:function(t,e){return xe(t,At(e))},max:Oe,min:function(t,e,n){var i,r,o=1/0,a=1/0;if(null==e||"number"==typeof e&&"object"!=typeof t[0]&&null!=t)for(var s=0,l=(t=ee(t)?t:_t(t)).length;s<l;s++)null!=(i=t[s])&&i<o&&(o=i);else e=It(e,n),ye(t,(function(t,n,i){((r=e(t,n,i))<a||r===1/0&&o===1/0)&&(o=t,a=r)}));return o},shuffle:function(t){return Ae(t,1/0)},sample:Ae,sortBy:function(t,e,n){var i=0;return e=It(e,n),Pe(_e(t,(function(t,n,r){return{value:t,index:i++,criteria:e(t,n,r)}})).sort((function(t,e){var n=t.criteria,i=e.criteria;if(n!==i){if(n>i||void 0===n)return 1;if(n<i||void 0===i)return-1}return t.index-e.index})),"value")},groupBy:Le,indexBy:qe,countBy:Re,partition:Ie,toArray:Ee,size:function(t){return null==t?0:ee(t)?t.length:tt(t).length},pick:Fe,omit:$e,first:ze,head:ze,take:ze,initial:je,last:function(t,e,n){return null==t||t.length<1?null==e||n?void 0:[]:null==e||n?t[t.length-1]:Ve(t,Math.max(0,t.length-e))},rest:Ve,tail:Ve,drop:Ve,compact:function(t){return xe(t,Boolean)},flatten:function(t,e){return ne(t,e,!1)},without:We,uniq:Ue,unique:Ue,union:Ye,intersection:function(t){for(var e=[],n=arguments.length,i=0,r=Z(t);i<r;i++){var o=t[i];if(!Me(e,o)){var a;for(a=1;a<n&&Me(arguments[a],o);a++);a===n&&e.push(o)}}return e},difference:He,unzip:Qe,transpose:Qe,zip:Ge,object:function(t,e){for(var n={},i=0,r=Z(t);i<r;i++)e?n[t[i]]=e[i]:n[t[i][0]]=t[i][1];return n},range:function(t,e,n){null==e&&(e=t||0,t=0),n||(n=e<t?-1:1);for(var i=Math.max(Math.ceil((e-t)/n),0),r=Array(i),o=0;o<i;o++,t+=n)r[o]=t;return r},chunk:function(t,e){if(null==e||e<1)return[];for(var n=[],i=0,r=t.length;i<r;)n.push(a.call(t,i,i+=e));return n},mixin:Je,default:nt},Xe=Je(Ze);return Xe._=Xe,Xe})),function(t,e){"object"==typeof exports&&"undefined"!=typeof module?module.exports=e():"function"==typeof define&&define.amd?define(e):(t="undefined"!=typeof globalThis?globalThis:t||self).axios=e()}(this,(function(){"use strict";function t(e){return t="function"==typeof Symbol&&"symbol"==typeof Symbol.iterator?function(t){return typeof t}:function(t){return t&&"function"==typeof Symbol&&t.constructor===Symbol&&t!==Symbol.prototype?"symbol":typeof t},t(e)}function e(t,e){if(!(t instanceof e))throw new TypeError("Cannot call a class as a function")}function n(t,e){for(var n=0;n<e.length;n++){var i=e[n];i.enumerable=i.enumerable||!1,i.configurable=!0,"value"in i&&(i.writable=!0),Object.defineProperty(t,i.key,i)}}function i(t,e,i){return e&&n(t.prototype,e),i&&n(t,i),Object.defineProperty(t,"prototype",{writable:!1}),t}function r(t,e){return function(t){if(Array.isArray(t))return t}(t)||function(t,e){var n=null==t?null:"undefined"!=typeof Symbol&&t[Symbol.iterator]||t["@@iterator"];if(null==n)return;var i,r,o=[],a=!0,s=!1;try{for(n=n.call(t);!(a=(i=n.next()).done)&&(o.push(i.value),!e||o.length!==e);a=!0);}catch(t){s=!0,r=t}finally{try{a||null==n.return||n.return()}finally{if(s)throw r}}return o}(t,e)||function(t,e){if(!t)return;if("string"==typeof t)return o(t,e);var n=Object.prototype.toString.call(t).slice(8,-1);"Object"===n&&t.constructor&&(n=t.constructor.name);if("Map"===n||"Set"===n)return Array.from(t);if("Arguments"===n||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n))return o(t,e)}(t,e)||function(){throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.")}()}function o(t,e){(null==e||e>t.length)&&(e=t.length);for(var n=0,i=new Array(e);n<e;n++)i[n]=t[n];return i}function a(t,e){return function(){return t.apply(e,arguments)}}var s,l=Object.prototype.toString,c=Object.getPrototypeOf,u=(s=Object.create(null),function(t){var e=l.call(t);return s[e]||(s[e]=e.slice(8,-1).toLowerCase())}),d=function(t){return t=t.toLowerCase(),function(e){return u(e)===t}},h=function(e){return function(n){return t(n)===e}},f=Array.isArray,p=h("undefined");var m=d("ArrayBuffer");var v=h("string"),g=h("function"),y=h("number"),_=function(e){return null!==e&&"object"===t(e)},b=function(t){if("object"!==u(t))return!1;var e=c(t);return!(null!==e&&e!==Object.prototype&&null!==Object.getPrototypeOf(e)||Symbol.toStringTag in t||Symbol.iterator in t)},w=d("Date"),k=d("File"),x=d("Blob"),C=d("FileList"),S=d("URLSearchParams");function M(e,n){var i,r,o=(arguments.length>2&&void 0!==arguments[2]?arguments[2]:{}).allOwnKeys,a=void 0!==o&&o;if(null!=e)if("object"!==t(e)&&(e=[e]),f(e))for(i=0,r=e.length;i<r;i++)n.call(null,e[i],i,e);else{var s,l=a?Object.getOwnPropertyNames(e):Object.keys(e),c=l.length;for(i=0;i<c;i++)s=l[i],n.call(null,e[s],s,e)}}function T(t,e){e=e.toLowerCase();for(var n,i=Object.keys(t),r=i.length;r-- >0;)if(e===(n=i[r]).toLowerCase())return n;return null}var P="undefined"!=typeof globalThis?globalThis:"undefined"!=typeof self?self:"undefined"!=typeof window?window:global,O=function(t){return!p(t)&&t!==P};var B,E=(B="undefined"!=typeof Uint8Array&&c(Uint8Array),function(t){return B&&t instanceof B}),A=d("HTMLFormElement"),D=function(t){var e=Object.prototype.hasOwnProperty;return function(t,n){return e.call(t,n)}}(),L=d("RegExp"),q=function(t,e){var n=Object.getOwnPropertyDescriptors(t),i={};M(n,(function(n,r){!1!==e(n,r,t)&&(i[r]=n)})),Object.defineProperties(t,i)},R="abcdefghijklmnopqrstuvwxyz",I="0123456789",N={DIGIT:I,ALPHA:R,ALPHA_DIGIT:R+R.toUpperCase()+I};var F={isArray:f,isArrayBuffer:m,isBuffer:function(t){return null!==t&&!p(t)&&null!==t.constructor&&!p(t.constructor)&&g(t.constructor.isBuffer)&&t.constructor.isBuffer(t)},isFormData:function(t){var e="[object FormData]";return t&&("function"==typeof FormData&&t instanceof FormData||l.call(t)===e||g(t.toString)&&t.toString()===e)},isArrayBufferView:function(t){return"undefined"!=typeof ArrayBuffer&&ArrayBuffer.isView?ArrayBuffer.isView(t):t&&t.buffer&&m(t.buffer)},isString:v,isNumber:y,isBoolean:function(t){return!0===t||!1===t},isObject:_,isPlainObject:b,isUndefined:p,isDate:w,isFile:k,isBlob:x,isRegExp:L,isFunction:g,isStream:function(t){return _(t)&&g(t.pipe)},isURLSearchParams:S,isTypedArray:E,isFileList:C,forEach:M,merge:function t(){for(var e=(O(this)&&this||{}).caseless,n={},i=function(i,r){var o=e&&T(n,r)||r;b(n[o])&&b(i)?n[o]=t(n[o],i):b(i)?n[o]=t({},i):f(i)?n[o]=i.slice():n[o]=i},r=0,o=arguments.length;r<o;r++)arguments[r]&&M(arguments[r],i);return n},extend:function(t,e,n){return M(e,(function(e,i){n&&g(e)?t[i]=a(e,n):t[i]=e}),{allOwnKeys:(arguments.length>3&&void 0!==arguments[3]?arguments[3]:{}).allOwnKeys}),t},trim:function(t){return t.trim?t.trim():t.replace(/^[\s\uFEFF\xA0]+|[\s\uFEFF\xA0]+$/g,"")},stripBOM:function(t){return 65279===t.charCodeAt(0)&&(t=t.slice(1)),t},inherits:function(t,e,n,i){t.prototype=Object.create(e.prototype,i),t.prototype.constructor=t,Object.defineProperty(t,"super",{value:e.prototype}),n&&Object.assign(t.prototype,n)},toFlatObject:function(t,e,n,i){var r,o,a,s={};if(e=e||{},null==t)return e;do{for(o=(r=Object.getOwnPropertyNames(t)).length;o-- >0;)a=r[o],i&&!i(a,t,e)||s[a]||(e[a]=t[a],s[a]=!0);t=!1!==n&&c(t)}while(t&&(!n||n(t,e))&&t!==Object.prototype);return e},kindOf:u,kindOfTest:d,endsWith:function(t,e,n){t=String(t),(void 0===n||n>t.length)&&(n=t.length),n-=e.length;var i=t.indexOf(e,n);return-1!==i&&i===n},toArray:function(t){if(!t)return null;if(f(t))return t;var e=t.length;if(!y(e))return null;for(var n=new Array(e);e-- >0;)n[e]=t[e];return n},forEachEntry:function(t,e){for(var n,i=(t&&t[Symbol.iterator]).call(t);(n=i.next())&&!n.done;){var r=n.value;e.call(t,r[0],r[1])}},matchAll:function(t,e){for(var n,i=[];null!==(n=t.exec(e));)i.push(n);return i},isHTMLForm:A,hasOwnProperty:D,hasOwnProp:D,reduceDescriptors:q,freezeMethods:function(t){q(t,(function(e,n){if(g(t)&&-1!==["arguments","caller","callee"].indexOf(n))return!1;var i=t[n];g(i)&&(e.enumerable=!1,"writable"in e?e.writable=!1:e.set||(e.set=function(){throw Error("Can not rewrite read-only method '"+n+"'")}))}))},toObjectSet:function(t,e){var n={},i=function(t){t.forEach((function(t){n[t]=!0}))};return f(t)?i(t):i(String(t).split(e)),n},toCamelCase:function(t){return t.toLowerCase().replace(/[-_\s]([a-z\d])(\w*)/g,(function(t,e,n){return e.toUpperCase()+n}))},noop:function(){},toFiniteNumber:function(t,e){return t=+t,Number.isFinite(t)?t:e},findKey:T,global:P,isContextDefined:O,ALPHABET:N,generateString:function(){for(var t=arguments.length>0&&void 0!==arguments[0]?arguments[0]:16,e=arguments.length>1&&void 0!==arguments[1]?arguments[1]:N.ALPHA_DIGIT,n="",i=e.length;t--;)n+=e[Math.random()*i|0];return n},isSpecCompliantForm:function(t){return!!(t&&g(t.append)&&"FormData"===t[Symbol.toStringTag]&&t[Symbol.iterator])},toJSONObject:function(t){var e=new Array(10);return function t(n,i){if(_(n)){if(e.indexOf(n)>=0)return;if(!("toJSON"in n)){e[i]=n;var r=f(n)?[]:{};return M(n,(function(e,n){var o=t(e,i+1);!p(o)&&(r[n]=o)})),e[i]=void 0,r}}return n}(t,0)}};function $(t,e,n,i,r){Error.call(this),Error.captureStackTrace?Error.captureStackTrace(this,this.constructor):this.stack=(new Error).stack,this.message=t,this.name="AxiosError",e&&(this.code=e),n&&(this.config=n),i&&(this.request=i),r&&(this.response=r)}F.inherits($,Error,{toJSON:function(){return{message:this.message,name:this.name,description:this.description,number:this.number,fileName:this.fileName,lineNumber:this.lineNumber,columnNumber:this.columnNumber,stack:this.stack,config:F.toJSONObject(this.config),code:this.code,status:this.response&&this.response.status?this.response.status:null}}});var j=$.prototype,z={};["ERR_BAD_OPTION_VALUE","ERR_BAD_OPTION","ECONNABORTED","ETIMEDOUT","ERR_NETWORK","ERR_FR_TOO_MANY_REDIRECTS","ERR_DEPRECATED","ERR_BAD_RESPONSE","ERR_BAD_REQUEST","ERR_CANCELED","ERR_NOT_SUPPORT","ERR_INVALID_URL"].forEach((function(t){z[t]={value:t}})),Object.defineProperties($,z),Object.defineProperty(j,"isAxiosError",{value:!0}),$.from=function(t,e,n,i,r,o){var a=Object.create(j);return F.toFlatObject(t,a,(function(t){return t!==Error.prototype}),(function(t){return"isAxiosError"!==t})),$.call(a,t.message,e,n,i,r),a.cause=t,a.name=t.name,o&&Object.assign(a,o),a};function V(t){return F.isPlainObject(t)||F.isArray(t)}function H(t){return F.endsWith(t,"[]")?t.slice(0,-2):t}function W(t,e,n){return t?t.concat(e).map((function(t,e){return t=H(t),!n&&e?"["+t+"]":t})).join(n?".":""):e}var U=F.toFlatObject(F,{},null,(function(t){return/^is[A-Z]/.test(t)}));function Y(e,n,i){if(!F.isObject(e))throw new TypeError("target must be an object");n=n||new FormData;var r=(i=F.toFlatObject(i,{metaTokens:!0,dots:!1,indexes:!1},!1,(function(t,e){return!F.isUndefined(e[t])}))).metaTokens,o=i.visitor||u,a=i.dots,s=i.indexes,l=(i.Blob||"undefined"!=typeof Blob&&Blob)&&F.isSpecCompliantForm(n);if(!F.isFunction(o))throw new TypeError("visitor must be a function");function c(t){if(null===t)return"";if(F.isDate(t))return t.toISOString();if(!l&&F.isBlob(t))throw new $("Blob is not supported. Use a Buffer instead.");return F.isArrayBuffer(t)||F.isTypedArray(t)?l&&"function"==typeof Blob?new Blob([t]):Buffer.from(t):t}function u(e,i,o){var l=e;if(e&&!o&&"object"===t(e))if(F.endsWith(i,"{}"))i=r?i:i.slice(0,-2),e=JSON.stringify(e);else if(F.isArray(e)&&function(t){return F.isArray(t)&&!t.some(V)}(e)||(F.isFileList(e)||F.endsWith(i,"[]"))&&(l=F.toArray(e)))return i=H(i),l.forEach((function(t,e){!F.isUndefined(t)&&null!==t&&n.append(!0===s?W([i],e,a):null===s?i:i+"[]",c(t))})),!1;return!!V(e)||(n.append(W(o,i,a),c(e)),!1)}var d=[],h=Object.assign(U,{defaultVisitor:u,convertValue:c,isVisitable:V});if(!F.isObject(e))throw new TypeError("data must be an object");return function t(e,i){if(!F.isUndefined(e)){if(-1!==d.indexOf(e))throw Error("Circular reference detected in "+i.join("."));d.push(e),F.forEach(e,(function(e,r){!0===(!(F.isUndefined(e)||null===e)&&o.call(n,e,F.isString(r)?r.trim():r,i,h))&&t(e,i?i.concat(r):[r])})),d.pop()}}(e),n}function Q(t){var e={"!":"%21","'":"%27","(":"%28",")":"%29","~":"%7E","%20":"+","%00":"\0"};return encodeURIComponent(t).replace(/[!'()~]|%20|%00/g,(function(t){return e[t]}))}function G(t,e){this._pairs=[],t&&Y(t,this,e)}var K=G.prototype;function J(t){return encodeURIComponent(t).replace(/%3A/gi,":").replace(/%24/g,"$").replace(/%2C/gi,",").replace(/%20/g,"+").replace(/%5B/gi,"[").replace(/%5D/gi,"]")}function Z(t,e,n){if(!e)return t;var i,r=n&&n.encode||J,o=n&&n.serialize;if(i=o?o(e,n):F.isURLSearchParams(e)?e.toString():new G(e,n).toString(r)){var a=t.indexOf("#");-1!==a&&(t=t.slice(0,a)),t+=(-1===t.indexOf("?")?"?":"&")+i}return t}K.append=function(t,e){this._pairs.push([t,e])},K.toString=function(t){var e=t?function(e){return t.call(this,e,Q)}:Q;return this._pairs.map((function(t){return e(t[0])+"="+e(t[1])}),"").join("&")};var X,tt=function(){function t(){e(this,t),this.handlers=[]}return i(t,[{key:"use",value:function(t,e,n){return this.handlers.push({fulfilled:t,rejected:e,synchronous:!!n&&n.synchronous,runWhen:n?n.runWhen:null}),this.handlers.length-1}},{key:"eject",value:function(t){this.handlers[t]&&(this.handlers[t]=null)}},{key:"clear",value:function(){this.handlers&&(this.handlers=[])}},{key:"forEach",value:function(t){F.forEach(this.handlers,(function(e){null!==e&&t(e)}))}}]),t}(),et={silentJSONParsing:!0,forcedJSONParsing:!0,clarifyTimeoutError:!1},nt={isBrowser:!0,classes:{URLSearchParams:"undefined"!=typeof URLSearchParams?URLSearchParams:G,FormData:"undefined"!=typeof FormData?FormData:null,Blob:"undefined"!=typeof Blob?Blob:null},isStandardBrowserEnv:("undefined"==typeof navigator||"ReactNative"!==(X=navigator.product)&&"NativeScript"!==X&&"NS"!==X)&&"undefined"!=typeof window&&"undefined"!=typeof document,isStandardBrowserWebWorkerEnv:"undefined"!=typeof WorkerGlobalScope&&self instanceof WorkerGlobalScope&&"function"==typeof self.importScripts,protocols:["http","https","file","blob","url","data"]};function it(t){function e(t,n,i,r){var o=t[r++],a=Number.isFinite(+o),s=r>=t.length;return o=!o&&F.isArray(i)?i.length:o,s?(F.hasOwnProp(i,o)?i[o]=[i[o],n]:i[o]=n,!a):(i[o]&&F.isObject(i[o])||(i[o]=[]),e(t,n,i[o],r)&&F.isArray(i[o])&&(i[o]=function(t){var e,n,i={},r=Object.keys(t),o=r.length;for(e=0;e<o;e++)i[n=r[e]]=t[n];return i}(i[o])),!a)}if(F.isFormData(t)&&F.isFunction(t.entries)){var n={};return F.forEachEntry(t,(function(t,i){e(function(t){return F.matchAll(/\w+|\[(\w*)]/g,t).map((function(t){return"[]"===t[0]?"":t[1]||t[0]}))}(t),i,n,0)})),n}return null}var rt={"Content-Type":void 0};var ot={transitional:et,adapter:["xhr","http"],transformRequest:[function(t,e){var n,i=e.getContentType()||"",r=i.indexOf("application/json")>-1,o=F.isObject(t);if(o&&F.isHTMLForm(t)&&(t=new FormData(t)),F.isFormData(t))return r&&r?JSON.stringify(it(t)):t;if(F.isArrayBuffer(t)||F.isBuffer(t)||F.isStream(t)||F.isFile(t)||F.isBlob(t))return t;if(F.isArrayBufferView(t))return t.buffer;if(F.isURLSearchParams(t))return e.setContentType("application/x-www-form-urlencoded;charset=utf-8",!1),t.toString();if(o){if(i.indexOf("application/x-www-form-urlencoded")>-1)return function(t,e){return Y(t,new nt.classes.URLSearchParams,Object.assign({visitor:function(t,e,n,i){return nt.isNode&&F.isBuffer(t)?(this.append(e,t.toString("base64")),!1):i.defaultVisitor.apply(this,arguments)}},e))}(t,this.formSerializer).toString();if((n=F.isFileList(t))||i.indexOf("multipart/form-data")>-1){var a=this.env&&this.env.FormData;return Y(n?{"files[]":t}:t,a&&new a,this.formSerializer)}}return o||r?(e.setContentType("application/json",!1),function(t,e,n){if(F.isString(t))try{return(e||JSON.parse)(t),F.trim(t)}catch(t){if("SyntaxError"!==t.name)throw t}return(n||JSON.stringify)(t)}(t)):t}],transformResponse:[function(t){var e=this.transitional||ot.transitional,n=e&&e.forcedJSONParsing,i="json"===this.responseType;if(t&&F.isString(t)&&(n&&!this.responseType||i)){var r=!(e&&e.silentJSONParsing)&&i;try{return JSON.parse(t)}catch(t){if(r){if("SyntaxError"===t.name)throw $.from(t,$.ERR_BAD_RESPONSE,this,null,this.response);throw t}}}return t}],timeout:0,xsrfCookieName:"XSRF-TOKEN",xsrfHeaderName:"X-XSRF-TOKEN",maxContentLength:-1,maxBodyLength:-1,env:{FormData:nt.classes.FormData,Blob:nt.classes.Blob},validateStatus:function(t){return t>=200&&t<300},headers:{common:{Accept:"application/json, text/plain, */*"}}};F.forEach(["delete","get","head"],(function(t){ot.headers[t]={}})),F.forEach(["post","put","patch"],(function(t){ot.headers[t]=F.merge(rt)}));var at=ot,st=F.toObjectSet(["age","authorization","content-length","content-type","etag","expires","from","host","if-modified-since","if-unmodified-since","last-modified","location","max-forwards","proxy-authorization","referer","retry-after","user-agent"]),lt=Symbol("internals");function ct(t){return t&&String(t).trim().toLowerCase()}function ut(t){return!1===t||null==t?t:F.isArray(t)?t.map(ut):String(t)}function dt(t,e,n,i,r){return F.isFunction(i)?i.call(this,e,n):(r&&(e=n),F.isString(e)?F.isString(i)?-1!==e.indexOf(i):F.isRegExp(i)?i.test(e):void 0:void 0)}var ht=function(t,n){function o(t){e(this,o),t&&this.set(t)}return i(o,[{key:"set",value:function(t,e,n){var i=this;function r(t,e,n){var r=ct(e);if(!r)throw new Error("header name must be a non-empty string");var o=F.findKey(i,r);(!o||void 0===i[o]||!0===n||void 0===n&&!1!==i[o])&&(i[o||e]=ut(t))}var o,a,s,l,c,u=function(t,e){return F.forEach(t,(function(t,n){return r(t,n,e)}))};return F.isPlainObject(t)||t instanceof this.constructor?u(t,e):F.isString(t)&&(t=t.trim())&&!/^[-_a-zA-Z]+$/.test(t.trim())?u((c={},(o=t)&&o.split("\n").forEach((function(t){l=t.indexOf(":"),a=t.substring(0,l).trim().toLowerCase(),s=t.substring(l+1).trim(),!a||c[a]&&st[a]||("set-cookie"===a?c[a]?c[a].push(s):c[a]=[s]:c[a]=c[a]?c[a]+", "+s:s)})),c),e):null!=t&&r(e,t,n),this}},{key:"get",value:function(t,e){if(t=ct(t)){var n=F.findKey(this,t);if(n){var i=this[n];if(!e)return i;if(!0===e)return function(t){for(var e,n=Object.create(null),i=/([^\s,;=]+)\s*(?:=\s*([^,;]+))?/g;e=i.exec(t);)n[e[1]]=e[2];return n}(i);if(F.isFunction(e))return e.call(this,i,n);if(F.isRegExp(e))return e.exec(i);throw new TypeError("parser must be boolean|regexp|function")}}}},{key:"has",value:function(t,e){if(t=ct(t)){var n=F.findKey(this,t);return!(!n||void 0===this[n]||e&&!dt(0,this[n],n,e))}return!1}},{key:"delete",value:function(t,e){var n=this,i=!1;function r(t){if(t=ct(t)){var r=F.findKey(n,t);!r||e&&!dt(0,n[r],r,e)||(delete n[r],i=!0)}}return F.isArray(t)?t.forEach(r):r(t),i}},{key:"clear",value:function(t){for(var e=Object.keys(this),n=e.length,i=!1;n--;){var r=e[n];t&&!dt(0,this[r],r,t,!0)||(delete this[r],i=!0)}return i}},{key:"normalize",value:function(t){var e=this,n={};return F.forEach(this,(function(i,r){var o=F.findKey(n,r);if(o)return e[o]=ut(i),void delete e[r];var a=t?function(t){return t.trim().toLowerCase().replace(/([a-z\d])(\w*)/g,(function(t,e,n){return e.toUpperCase()+n}))}(r):String(r).trim();a!==r&&delete e[r],e[a]=ut(i),n[a]=!0})),this}},{key:"concat",value:function(){for(var t,e=arguments.length,n=new Array(e),i=0;i<e;i++)n[i]=arguments[i];return(t=this.constructor).concat.apply(t,[this].concat(n))}},{key:"toJSON",value:function(t){var e=Object.create(null);return F.forEach(this,(function(n,i){null!=n&&!1!==n&&(e[i]=t&&F.isArray(n)?n.join(", "):n)})),e}},{key:Symbol.iterator,value:function(){return Object.entries(this.toJSON())[Symbol.iterator]()}},{key:"toString",value:function(){return Object.entries(this.toJSON()).map((function(t){var e=r(t,2);return e[0]+": "+e[1]})).join("\n")}},{key:Symbol.toStringTag,get:function(){return"AxiosHeaders"}}],[{key:"from",value:function(t){return t instanceof this?t:new this(t)}},{key:"concat",value:function(t){for(var e=new this(t),n=arguments.length,i=new Array(n>1?n-1:0),r=1;r<n;r++)i[r-1]=arguments[r];return i.forEach((function(t){return e.set(t)})),e}},{key:"accessor",value:function(t){var e=(this[lt]=this[lt]={accessors:{}}).accessors,n=this.prototype;function i(t){var i=ct(t);e[i]||(!function(t,e){var n=F.toCamelCase(" "+e);["get","set","has"].forEach((function(i){Object.defineProperty(t,i+n,{value:function(t,n,r){return this[i].call(this,e,t,n,r)},configurable:!0})}))}(n,t),e[i]=!0)}return F.isArray(t)?t.forEach(i):i(t),this}}]),o}();ht.accessor(["Content-Type","Content-Length","Accept","Accept-Encoding","User-Agent","Authorization"]),F.freezeMethods(ht.prototype),F.freezeMethods(ht);var ft=ht;function pt(t,e){var n=this||at,i=e||n,r=ft.from(i.headers),o=i.data;return F.forEach(t,(function(t){o=t.call(n,o,r.normalize(),e?e.status:void 0)})),r.normalize(),o}function mt(t){return!(!t||!t.__CANCEL__)}function vt(t,e,n){$.call(this,null==t?"canceled":t,$.ERR_CANCELED,e,n),this.name="CanceledError"}F.inherits(vt,$,{__CANCEL__:!0});var gt=nt.isStandardBrowserEnv?{write:function(t,e,n,i,r,o){var a=[];a.push(t+"="+encodeURIComponent(e)),F.isNumber(n)&&a.push("expires="+new Date(n).toGMTString()),F.isString(i)&&a.push("path="+i),F.isString(r)&&a.push("domain="+r),!0===o&&a.push("secure"),document.cookie=a.join("; ")},read:function(t){var e=document.cookie.match(new RegExp("(^|;\\s*)("+t+")=([^;]*)"));return e?decodeURIComponent(e[3]):null},remove:function(t){this.write(t,"",Date.now()-864e5)}}:{write:function(){},read:function(){return null},remove:function(){}};function yt(t,e){return t&&!/^([a-z][a-z\d+\-.]*:)?\/\//i.test(e)?function(t,e){return e?t.replace(/\/+$/,"")+"/"+e.replace(/^\/+/,""):t}(t,e):e}var _t=nt.isStandardBrowserEnv?function(){var t,e=/(msie|trident)/i.test(navigator.userAgent),n=document.createElement("a");function i(t){var i=t;return e&&(n.setAttribute("href",i),i=n.href),n.setAttribute("href",i),{href:n.href,protocol:n.protocol?n.protocol.replace(/:$/,""):"",host:n.host,search:n.search?n.search.replace(/^\?/,""):"",hash:n.hash?n.hash.replace(/^#/,""):"",hostname:n.hostname,port:n.port,pathname:"/"===n.pathname.charAt(0)?n.pathname:"/"+n.pathname}}return t=i(window.location.href),function(e){var n=F.isString(e)?i(e):e;return n.protocol===t.protocol&&n.host===t.host}}():function(){return!0};function bt(t,e){var n=0,i=function(t,e){t=t||10;var n,i=new Array(t),r=new Array(t),o=0,a=0;return e=void 0!==e?e:1e3,function(s){var l=Date.now(),c=r[a];n||(n=l),i[o]=s,r[o]=l;for(var u=a,d=0;u!==o;)d+=i[u++],u%=t;if((o=(o+1)%t)===a&&(a=(a+1)%t),!(l-n<e)){var h=c&&l-c;return h?Math.round(1e3*d/h):void 0}}}(50,250);return function(r){var o=r.loaded,a=r.lengthComputable?r.total:void 0,s=o-n,l=i(s);n=o;var c={loaded:o,total:a,progress:a?o/a:void 0,bytes:s,rate:l||void 0,estimated:l&&a&&o<=a?(a-o)/l:void 0,event:r};c[e?"download":"upload"]=!0,t(c)}}var wt={http:null,xhr:"undefined"!=typeof XMLHttpRequest&&function(t){return new Promise((function(e,n){var i,r=t.data,o=ft.from(t.headers).normalize(),a=t.responseType;function s(){t.cancelToken&&t.cancelToken.unsubscribe(i),t.signal&&t.signal.removeEventListener("abort",i)}F.isFormData(r)&&(nt.isStandardBrowserEnv||nt.isStandardBrowserWebWorkerEnv)&&o.setContentType(!1);var l=new XMLHttpRequest;if(t.auth){var c=t.auth.username||"",u=t.auth.password?unescape(encodeURIComponent(t.auth.password)):"";o.set("Authorization","Basic "+btoa(c+":"+u))}var d=yt(t.baseURL,t.url);function h(){if(l){var i=ft.from("getAllResponseHeaders"in l&&l.getAllResponseHeaders());!function(t,e,n){var i=n.config.validateStatus;n.status&&i&&!i(n.status)?e(new $("Request failed with status code "+n.status,[$.ERR_BAD_REQUEST,$.ERR_BAD_RESPONSE][Math.floor(n.status/100)-4],n.config,n.request,n)):t(n)}((function(t){e(t),s()}),(function(t){n(t),s()}),{data:a&&"text"!==a&&"json"!==a?l.response:l.responseText,status:l.status,statusText:l.statusText,headers:i,config:t,request:l}),l=null}}if(l.open(t.method.toUpperCase(),Z(d,t.params,t.paramsSerializer),!0),l.timeout=t.timeout,"onloadend"in l?l.onloadend=h:l.onreadystatechange=function(){l&&4===l.readyState&&(0!==l.status||l.responseURL&&0===l.responseURL.indexOf("file:"))&&setTimeout(h)},l.onabort=function(){l&&(n(new $("Request aborted",$.ECONNABORTED,t,l)),l=null)},l.onerror=function(){n(new $("Network Error",$.ERR_NETWORK,t,l)),l=null},l.ontimeout=function(){var e=t.timeout?"timeout of "+t.timeout+"ms exceeded":"timeout exceeded",i=t.transitional||et;t.timeoutErrorMessage&&(e=t.timeoutErrorMessage),n(new $(e,i.clarifyTimeoutError?$.ETIMEDOUT:$.ECONNABORTED,t,l)),l=null},nt.isStandardBrowserEnv){var f=(t.withCredentials||_t(d))&&t.xsrfCookieName&&gt.read(t.xsrfCookieName);f&&o.set(t.xsrfHeaderName,f)}void 0===r&&o.setContentType(null),"setRequestHeader"in l&&F.forEach(o.toJSON(),(function(t,e){l.setRequestHeader(e,t)})),F.isUndefined(t.withCredentials)||(l.withCredentials=!!t.withCredentials),a&&"json"!==a&&(l.responseType=t.responseType),"function"==typeof t.onDownloadProgress&&l.addEventListener("progress",bt(t.onDownloadProgress,!0)),"function"==typeof t.onUploadProgress&&l.upload&&l.upload.addEventListener("progress",bt(t.onUploadProgress)),(t.cancelToken||t.signal)&&(i=function(e){l&&(n(!e||e.type?new vt(null,t,l):e),l.abort(),l=null)},t.cancelToken&&t.cancelToken.subscribe(i),t.signal&&(t.signal.aborted?i():t.signal.addEventListener("abort",i)));var p,m=(p=/^([-+\w]{1,25})(:?\/\/|:)/.exec(d))&&p[1]||"";m&&-1===nt.protocols.indexOf(m)?n(new $("Unsupported protocol "+m+":",$.ERR_BAD_REQUEST,t)):l.send(r||null)}))}};F.forEach(wt,(function(t,e){if(t){try{Object.defineProperty(t,"name",{value:e})}catch(t){}Object.defineProperty(t,"adapterName",{value:e})}}));var kt=function(t){for(var e,n,i=(t=F.isArray(t)?t:[t]).length,r=0;r<i&&(e=t[r],!(n=F.isString(e)?wt[e.toLowerCase()]:e));r++);if(!n){if(!1===n)throw new $("Adapter ".concat(e," is not supported by the environment"),"ERR_NOT_SUPPORT");throw new Error(F.hasOwnProp(wt,e)?"Adapter '".concat(e,"' is not available in the build"):"Unknown adapter '".concat(e,"'"))}if(!F.isFunction(n))throw new TypeError("adapter is not a function");return n};function xt(t){if(t.cancelToken&&t.cancelToken.throwIfRequested(),t.signal&&t.signal.aborted)throw new vt(null,t)}function Ct(t){return xt(t),t.headers=ft.from(t.headers),t.data=pt.call(t,t.transformRequest),-1!==["post","put","patch"].indexOf(t.method)&&t.headers.setContentType("application/x-www-form-urlencoded",!1),kt(t.adapter||at.adapter)(t).then((function(e){return xt(t),e.data=pt.call(t,t.transformResponse,e),e.headers=ft.from(e.headers),e}),(function(e){return mt(e)||(xt(t),e&&e.response&&(e.response.data=pt.call(t,t.transformResponse,e.response),e.response.headers=ft.from(e.response.headers))),Promise.reject(e)}))}var St=function(t){return t instanceof ft?t.toJSON():t};function Mt(t,e){e=e||{};var n={};function i(t,e,n){return F.isPlainObject(t)&&F.isPlainObject(e)?F.merge.call({caseless:n},t,e):F.isPlainObject(e)?F.merge({},e):F.isArray(e)?e.slice():e}function r(t,e,n){return F.isUndefined(e)?F.isUndefined(t)?void 0:i(void 0,t,n):i(t,e,n)}function o(t,e){if(!F.isUndefined(e))return i(void 0,e)}function a(t,e){return F.isUndefined(e)?F.isUndefined(t)?void 0:i(void 0,t):i(void 0,e)}function s(n,r,o){return o in e?i(n,r):o in t?i(void 0,n):void 0}var l={url:o,method:o,data:o,baseURL:a,transformRequest:a,transformResponse:a,paramsSerializer:a,timeout:a,timeoutMessage:a,withCredentials:a,adapter:a,responseType:a,xsrfCookieName:a,xsrfHeaderName:a,onUploadProgress:a,onDownloadProgress:a,decompress:a,maxContentLength:a,maxBodyLength:a,beforeRedirect:a,transport:a,httpAgent:a,httpsAgent:a,cancelToken:a,socketPath:a,responseEncoding:a,validateStatus:s,headers:function(t,e){return r(St(t),St(e),!0)}};return F.forEach(Object.keys(t).concat(Object.keys(e)),(function(i){var o=l[i]||r,a=o(t[i],e[i],i);F.isUndefined(a)&&o!==s||(n[i]=a)})),n}var Tt="1.3.4",Pt={};["object","boolean","number","function","string","symbol"].forEach((function(e,n){Pt[e]=function(i){return t(i)===e||"a"+(n<1?"n ":" ")+e}}));var Ot={};Pt.transitional=function(t,e,n){function i(t,e){return"[Axios v1.3.4] Transitional option '"+t+"'"+e+(n?". "+n:"")}return function(n,r,o){if(!1===t)throw new $(i(r," has been removed"+(e?" in "+e:"")),$.ERR_DEPRECATED);return e&&!Ot[r]&&(Ot[r]=!0,console.warn(i(r," has been deprecated since v"+e+" and will be removed in the near future"))),!t||t(n,r,o)}};var Bt={assertOptions:function(e,n,i){if("object"!==t(e))throw new $("options must be an object",$.ERR_BAD_OPTION_VALUE);for(var r=Object.keys(e),o=r.length;o-- >0;){var a=r[o],s=n[a];if(s){var l=e[a],c=void 0===l||s(l,a,e);if(!0!==c)throw new $("option "+a+" must be "+c,$.ERR_BAD_OPTION_VALUE)}else if(!0!==i)throw new $("Unknown option "+a,$.ERR_BAD_OPTION)}},validators:Pt},Et=Bt.validators,At=function(){function t(n){e(this,t),this.defaults=n,this.interceptors={request:new tt,response:new tt}}return i(t,[{key:"request",value:function(t,e){"string"==typeof t?(e=e||{}).url=t:e=t||{};var n,i=e=Mt(this.defaults,e),r=i.transitional,o=i.paramsSerializer,a=i.headers;void 0!==r&&Bt.assertOptions(r,{silentJSONParsing:Et.transitional(Et.boolean),forcedJSONParsing:Et.transitional(Et.boolean),clarifyTimeoutError:Et.transitional(Et.boolean)},!1),void 0!==o&&Bt.assertOptions(o,{encode:Et.function,serialize:Et.function},!0),e.method=(e.method||this.defaults.method||"get").toLowerCase(),(n=a&&F.merge(a.common,a[e.method]))&&F.forEach(["delete","get","head","post","put","patch","common"],(function(t){delete a[t]})),e.headers=ft.concat(n,a);var s=[],l=!0;this.interceptors.request.forEach((function(t){"function"==typeof t.runWhen&&!1===t.runWhen(e)||(l=l&&t.synchronous,s.unshift(t.fulfilled,t.rejected))}));var c,u=[];this.interceptors.response.forEach((function(t){u.push(t.fulfilled,t.rejected)}));var d,h=0;if(!l){var f=[Ct.bind(this),void 0];for(f.unshift.apply(f,s),f.push.apply(f,u),d=f.length,c=Promise.resolve(e);h<d;)c=c.then(f[h++],f[h++]);return c}d=s.length;var p=e;for(h=0;h<d;){var m=s[h++],v=s[h++];try{p=m(p)}catch(t){v.call(this,t);break}}try{c=Ct.call(this,p)}catch(t){return Promise.reject(t)}for(h=0,d=u.length;h<d;)c=c.then(u[h++],u[h++]);return c}},{key:"getUri",value:function(t){return Z(yt((t=Mt(this.defaults,t)).baseURL,t.url),t.params,t.paramsSerializer)}}]),t}();F.forEach(["delete","get","head","options"],(function(t){At.prototype[t]=function(e,n){return this.request(Mt(n||{},{method:t,url:e,data:(n||{}).data}))}})),F.forEach(["post","put","patch"],(function(t){function e(e){return function(n,i,r){return this.request(Mt(r||{},{method:t,headers:e?{"Content-Type":"multipart/form-data"}:{},url:n,data:i}))}}At.prototype[t]=e(),At.prototype[t+"Form"]=e(!0)}));var Dt=At,Lt=function(){function t(n){if(e(this,t),"function"!=typeof n)throw new TypeError("executor must be a function.");var i;this.promise=new Promise((function(t){i=t}));var r=this;this.promise.then((function(t){if(r._listeners){for(var e=r._listeners.length;e-- >0;)r._listeners[e](t);r._listeners=null}})),this.promise.then=function(t){var e,n=new Promise((function(t){r.subscribe(t),e=t})).then(t);return n.cancel=function(){r.unsubscribe(e)},n},n((function(t,e,n){r.reason||(r.reason=new vt(t,e,n),i(r.reason))}))}return i(t,[{key:"throwIfRequested",value:function(){if(this.reason)throw this.reason}},{key:"subscribe",value:function(t){this.reason?t(this.reason):this._listeners?this._listeners.push(t):this._listeners=[t]}},{key:"unsubscribe",value:function(t){if(this._listeners){var e=this._listeners.indexOf(t);-1!==e&&this._listeners.splice(e,1)}}}],[{key:"source",value:function(){var e;return{token:new t((function(t){e=t})),cancel:e}}}]),t}();var qt={Continue:100,SwitchingProtocols:101,Processing:102,EarlyHints:103,Ok:200,Created:201,Accepted:202,NonAuthoritativeInformation:203,NoContent:204,ResetContent:205,PartialContent:206,MultiStatus:207,AlreadyReported:208,ImUsed:226,MultipleChoices:300,MovedPermanently:301,Found:302,SeeOther:303,NotModified:304,UseProxy:305,Unused:306,TemporaryRedirect:307,PermanentRedirect:308,BadRequest:400,Unauthorized:401,PaymentRequired:402,Forbidden:403,NotFound:404,MethodNotAllowed:405,NotAcceptable:406,ProxyAuthenticationRequired:407,RequestTimeout:408,Conflict:409,Gone:410,LengthRequired:411,PreconditionFailed:412,PayloadTooLarge:413,UriTooLong:414,UnsupportedMediaType:415,RangeNotSatisfiable:416,ExpectationFailed:417,ImATeapot:418,MisdirectedRequest:421,UnprocessableEntity:422,Locked:423,FailedDependency:424,TooEarly:425,UpgradeRequired:426,PreconditionRequired:428,TooManyRequests:429,RequestHeaderFieldsTooLarge:431,UnavailableForLegalReasons:451,InternalServerError:500,NotImplemented:501,BadGateway:502,ServiceUnavailable:503,GatewayTimeout:504,HttpVersionNotSupported:505,VariantAlsoNegotiates:506,InsufficientStorage:507,LoopDetected:508,NotExtended:510,NetworkAuthenticationRequired:511};Object.entries(qt).forEach((function(t){var e=r(t,2),n=e[0],i=e[1];qt[i]=n}));var Rt=qt;var It=function t(e){var n=new Dt(e),i=a(Dt.prototype.request,n);return F.extend(i,Dt.prototype,n,{allOwnKeys:!0}),F.extend(i,n,null,{allOwnKeys:!0}),i.create=function(n){return t(Mt(e,n))},i}(at);return It.Axios=Dt,It.CanceledError=vt,It.CancelToken=Lt,It.isCancel=mt,It.VERSION=Tt,It.toFormData=Y,It.AxiosError=$,It.Cancel=It.CanceledError,It.all=function(t){return Promise.all(t)},It.spread=function(t){return function(e){return t.apply(null,e)}},It.isAxiosError=function(t){return F.isObject(t)&&!0===t.isAxiosError},It.mergeConfig=Mt,It.AxiosHeaders=ft,It.formToJSON=function(t){return it(F.isHTMLForm(t)?new FormData(t):t)},It.HttpStatusCode=Rt,It.default=It,It})),
/*!
 * Vue.js v2.6.12
 * (c) 2014-2020 Evan You
 * Released under the MIT License.
 */
function(t,e){"object"==typeof exports&&"undefined"!=typeof module?module.exports=e():"function"==typeof define&&define.amd?define(e):(t=t||self).Vue=e()}(this,(function(){"use strict";var t=Object.freeze({});function e(t){return null==t}function n(t){return null!=t}function i(t){return!0===t}function r(t){return"string"==typeof t||"number"==typeof t||"symbol"==typeof t||"boolean"==typeof t}function o(t){return null!==t&&"object"==typeof t}var a=Object.prototype.toString;function s(t){return a.call(t).slice(8,-1)}function l(t){return"[object Object]"===a.call(t)}function c(t){return"[object RegExp]"===a.call(t)}function u(t){var e=parseFloat(String(t));return e>=0&&Math.floor(e)===e&&isFinite(t)}function d(t){return n(t)&&"function"==typeof t.then&&"function"==typeof t.catch}function h(t){return null==t?"":Array.isArray(t)||l(t)&&t.toString===a?JSON.stringify(t,null,2):String(t)}function f(t){var e=parseFloat(t);return isNaN(e)?t:e}function p(t,e){for(var n=Object.create(null),i=t.split(","),r=0;r<i.length;r++)n[i[r]]=!0;return e?function(t){return n[t.toLowerCase()]}:function(t){return n[t]}}var m=p("slot,component",!0),v=p("key,ref,slot,slot-scope,is");function g(t,e){if(t.length){var n=t.indexOf(e);if(n>-1)return t.splice(n,1)}}var y=Object.prototype.hasOwnProperty;function _(t,e){return y.call(t,e)}function b(t){var e=Object.create(null);return function(n){return e[n]||(e[n]=t(n))}}var w=/-(\w)/g,k=b((function(t){return t.replace(w,(function(t,e){return e?e.toUpperCase():""}))})),x=b((function(t){return t.charAt(0).toUpperCase()+t.slice(1)})),C=/\B([A-Z])/g,S=b((function(t){return t.replace(C,"-$1").toLowerCase()}));var M=Function.prototype.bind?function(t,e){return t.bind(e)}:function(t,e){function n(n){var i=arguments.length;return i?i>1?t.apply(e,arguments):t.call(e,n):t.call(e)}return n._length=t.length,n};function T(t,e){e=e||0;for(var n=t.length-e,i=new Array(n);n--;)i[n]=t[n+e];return i}function P(t,e){for(var n in e)t[n]=e[n];return t}function O(t){for(var e={},n=0;n<t.length;n++)t[n]&&P(e,t[n]);return e}function B(t,e,n){}var E=function(t,e,n){return!1},A=function(t){return t};function D(t,e){if(t===e)return!0;var n=o(t),i=o(e);if(!n||!i)return!n&&!i&&String(t)===String(e);try{var r=Array.isArray(t),a=Array.isArray(e);if(r&&a)return t.length===e.length&&t.every((function(t,n){return D(t,e[n])}));if(t instanceof Date&&e instanceof Date)return t.getTime()===e.getTime();if(r||a)return!1;var s=Object.keys(t),l=Object.keys(e);return s.length===l.length&&s.every((function(n){return D(t[n],e[n])}))}catch(t){return!1}}function L(t,e){for(var n=0;n<t.length;n++)if(D(t[n],e))return n;return-1}function q(t){var e=!1;return function(){e||(e=!0,t.apply(this,arguments))}}var R="data-server-rendered",I=["component","directive","filter"],N=["beforeCreate","created","beforeMount","mounted","beforeUpdate","updated","beforeDestroy","destroyed","activated","deactivated","errorCaptured","serverPrefetch"],F={optionMergeStrategies:Object.create(null),silent:!1,productionTip:!0,devtools:!0,performance:!1,errorHandler:null,warnHandler:null,ignoredElements:[],keyCodes:Object.create(null),isReservedTag:E,isReservedAttr:E,isUnknownElement:E,getTagNamespace:B,parsePlatformTagName:A,mustUseProp:E,async:!0,_lifecycleHooks:N},$=/a-zA-Z\u00B7\u00C0-\u00D6\u00D8-\u00F6\u00F8-\u037D\u037F-\u1FFF\u200C-\u200D\u203F-\u2040\u2070-\u218F\u2C00-\u2FEF\u3001-\uD7FF\uF900-\uFDCF\uFDF0-\uFFFD/;function j(t){var e=(t+"").charCodeAt(0);return 36===e||95===e}function z(t,e,n,i){Object.defineProperty(t,e,{value:n,enumerable:!!i,writable:!0,configurable:!0})}var V=new RegExp("[^"+$.source+".$_\\d]");var H,W="__proto__"in{},U="undefined"!=typeof window,Y="undefined"!=typeof WXEnvironment&&!!WXEnvironment.platform,Q=Y&&WXEnvironment.platform.toLowerCase(),G=U&&window.navigator.userAgent.toLowerCase(),K=G&&/msie|trident/.test(G),J=G&&G.indexOf("msie 9.0")>0,Z=G&&G.indexOf("edge/")>0,X=(G&&G.indexOf("android"),G&&/iphone|ipad|ipod|ios/.test(G)||"ios"===Q),tt=(G&&/chrome\/\d+/.test(G),G&&/phantomjs/.test(G),G&&G.match(/firefox\/(\d+)/)),et={}.watch,nt=!1;if(U)try{var it={};Object.defineProperty(it,"passive",{get:function(){nt=!0}}),window.addEventListener("test-passive",null,it)}catch(t){}var rt=function(){return void 0===H&&(H=!U&&!Y&&"undefined"!=typeof global&&(global.process&&"server"===global.process.env.VUE_ENV)),H},ot=U&&window.__VUE_DEVTOOLS_GLOBAL_HOOK__;function at(t){return"function"==typeof t&&/native code/.test(t.toString())}var st,lt="undefined"!=typeof Symbol&&at(Symbol)&&"undefined"!=typeof Reflect&&at(Reflect.ownKeys);st="undefined"!=typeof Set&&at(Set)?Set:function(){function t(){this.set=Object.create(null)}return t.prototype.has=function(t){return!0===this.set[t]},t.prototype.add=function(t){this.set[t]=!0},t.prototype.clear=function(){this.set=Object.create(null)},t}();var ct=B,ut=B,dt=B,ht=B,ft="undefined"!=typeof console,pt=/(?:^|[-_])(\w)/g;ct=function(t,e){var n=e?dt(e):"";F.warnHandler?F.warnHandler.call(null,t,e,n):ft&&!F.silent&&console.error("[Vue warn]: "+t+n)},ut=function(t,e){ft&&!F.silent&&console.warn("[Vue tip]: "+t+(e?dt(e):""))},ht=function(t,e){if(t.$root===t)return"<Root>";var n="function"==typeof t&&null!=t.cid?t.options:t._isVue?t.$options||t.constructor.options:t,i=n.name||n._componentTag,r=n.__file;if(!i&&r){var o=r.match(/([^/\\]+)\.vue$/);i=o&&o[1]}return(i?"<"+function(t){return t.replace(pt,(function(t){return t.toUpperCase()})).replace(/[-_]/g,"")}(i)+">":"<Anonymous>")+(r&&!1!==e?" at "+r:"")};dt=function(t){if(t._isVue&&t.$parent){for(var e=[],n=0;t;){if(e.length>0){var i=e[e.length-1];if(i.constructor===t.constructor){n++,t=t.$parent;continue}n>0&&(e[e.length-1]=[i,n],n=0)}e.push(t),t=t.$parent}return"\n\nfound in\n\n"+e.map((function(t,e){return""+(0===e?"---\x3e ":function(t,e){for(var n="";e;)e%2==1&&(n+=t),e>1&&(t+=t),e>>=1;return n}(" ",5+2*e))+(Array.isArray(t)?ht(t[0])+"... ("+t[1]+" recursive calls)":ht(t))})).join("\n")}return"\n\n(found in "+ht(t)+")"};var mt=0,vt=function(){this.id=mt++,this.subs=[]};vt.prototype.addSub=function(t){this.subs.push(t)},vt.prototype.removeSub=function(t){g(this.subs,t)},vt.prototype.depend=function(){vt.target&&vt.target.addDep(this)},vt.prototype.notify=function(){var t=this.subs.slice();F.async||t.sort((function(t,e){return t.id-e.id}));for(var e=0,n=t.length;e<n;e++)t[e].update()},vt.target=null;var gt=[];function yt(t){gt.push(t),vt.target=t}function _t(){gt.pop(),vt.target=gt[gt.length-1]}var bt=function(t,e,n,i,r,o,a,s){this.tag=t,this.data=e,this.children=n,this.text=i,this.elm=r,this.ns=void 0,this.context=o,this.fnContext=void 0,this.fnOptions=void 0,this.fnScopeId=void 0,this.key=e&&e.key,this.componentOptions=a,this.componentInstance=void 0,this.parent=void 0,this.raw=!1,this.isStatic=!1,this.isRootInsert=!0,this.isComment=!1,this.isCloned=!1,this.isOnce=!1,this.asyncFactory=s,this.asyncMeta=void 0,this.isAsyncPlaceholder=!1},wt={child:{configurable:!0}};wt.child.get=function(){return this.componentInstance},Object.defineProperties(bt.prototype,wt);var kt=function(t){void 0===t&&(t="");var e=new bt;return e.text=t,e.isComment=!0,e};function xt(t){return new bt(void 0,void 0,void 0,String(t))}function Ct(t){var e=new bt(t.tag,t.data,t.children&&t.children.slice(),t.text,t.elm,t.context,t.componentOptions,t.asyncFactory);return e.ns=t.ns,e.isStatic=t.isStatic,e.key=t.key,e.isComment=t.isComment,e.fnContext=t.fnContext,e.fnOptions=t.fnOptions,e.fnScopeId=t.fnScopeId,e.asyncMeta=t.asyncMeta,e.isCloned=!0,e}var St=Array.prototype,Mt=Object.create(St);["push","pop","shift","unshift","splice","sort","reverse"].forEach((function(t){var e=St[t];z(Mt,t,(function(){for(var n=[],i=arguments.length;i--;)n[i]=arguments[i];var r,o=e.apply(this,n),a=this.__ob__;switch(t){case"push":case"unshift":r=n;break;case"splice":r=n.slice(2)}return r&&a.observeArray(r),a.dep.notify(),o}))}));var Tt=Object.getOwnPropertyNames(Mt),Pt=!0;function Ot(t){Pt=t}var Bt=function(t){this.value=t,this.dep=new vt,this.vmCount=0,z(t,"__ob__",this),Array.isArray(t)?(W?function(t,e){t.__proto__=e}(t,Mt):function(t,e,n){for(var i=0,r=n.length;i<r;i++){var o=n[i];z(t,o,e[o])}}(t,Mt,Tt),this.observeArray(t)):this.walk(t)};function Et(t,e){var n;if(o(t)&&!(t instanceof bt))return _(t,"__ob__")&&t.__ob__ instanceof Bt?n=t.__ob__:Pt&&!rt()&&(Array.isArray(t)||l(t))&&Object.isExtensible(t)&&!t._isVue&&(n=new Bt(t)),e&&n&&n.vmCount++,n}function At(t,e,n,i,r){var o=new vt,a=Object.getOwnPropertyDescriptor(t,e);if(!a||!1!==a.configurable){var s=a&&a.get,l=a&&a.set;s&&!l||2!==arguments.length||(n=t[e]);var c=!r&&Et(n);Object.defineProperty(t,e,{enumerable:!0,configurable:!0,get:function(){var e=s?s.call(t):n;return vt.target&&(o.depend(),c&&(c.dep.depend(),Array.isArray(e)&&qt(e))),e},set:function(e){var a=s?s.call(t):n;e===a||e!=e&&a!=a||(i&&i(),s&&!l||(l?l.call(t,e):n=e,c=!r&&Et(e),o.notify()))}})}}function Dt(t,n,i){if((e(t)||r(t))&&ct("Cannot set reactive property on undefined, null, or primitive value: "+t),Array.isArray(t)&&u(n))return t.length=Math.max(t.length,n),t.splice(n,1,i),i;if(n in t&&!(n in Object.prototype))return t[n]=i,i;var o=t.__ob__;return t._isVue||o&&o.vmCount?(ct("Avoid adding reactive properties to a Vue instance or its root $data at runtime - declare it upfront in the data option."),i):o?(At(o.value,n,i),o.dep.notify(),i):(t[n]=i,i)}function Lt(t,n){if((e(t)||r(t))&&ct("Cannot delete reactive property on undefined, null, or primitive value: "+t),Array.isArray(t)&&u(n))t.splice(n,1);else{var i=t.__ob__;t._isVue||i&&i.vmCount?ct("Avoid deleting properties on a Vue instance or its root $data - just set it to null."):_(t,n)&&(delete t[n],i&&i.dep.notify())}}function qt(t){for(var e=void 0,n=0,i=t.length;n<i;n++)(e=t[n])&&e.__ob__&&e.__ob__.dep.depend(),Array.isArray(e)&&qt(e)}Bt.prototype.walk=function(t){for(var e=Object.keys(t),n=0;n<e.length;n++)At(t,e[n])},Bt.prototype.observeArray=function(t){for(var e=0,n=t.length;e<n;e++)Et(t[e])};var Rt=F.optionMergeStrategies;function It(t,e){if(!e)return t;for(var n,i,r,o=lt?Reflect.ownKeys(e):Object.keys(e),a=0;a<o.length;a++)"__ob__"!==(n=o[a])&&(i=t[n],r=e[n],_(t,n)?i!==r&&l(i)&&l(r)&&It(i,r):Dt(t,n,r));return t}function Nt(t,e,n){return n?function(){var i="function"==typeof e?e.call(n,n):e,r="function"==typeof t?t.call(n,n):t;return i?It(i,r):r}:e?t?function(){return It("function"==typeof e?e.call(this,this):e,"function"==typeof t?t.call(this,this):t)}:e:t}function Ft(t,e){var n=e?t?t.concat(e):Array.isArray(e)?e:[e]:t;return n?function(t){for(var e=[],n=0;n<t.length;n++)-1===e.indexOf(t[n])&&e.push(t[n]);return e}(n):n}function $t(t,e,n,i){var r=Object.create(t||null);return e?(Vt(i,e,n),P(r,e)):r}Rt.el=Rt.propsData=function(t,e,n,i){return n||ct('option "'+i+'" can only be used during instance creation with the `new` keyword.'),jt(t,e)},Rt.data=function(t,e,n){return n?Nt(t,e,n):e&&"function"!=typeof e?(ct('The "data" option should be a function that returns a per-instance value in component definitions.',n),t):Nt(t,e)},N.forEach((function(t){Rt[t]=Ft})),I.forEach((function(t){Rt[t+"s"]=$t})),Rt.watch=function(t,e,n,i){if(t===et&&(t=void 0),e===et&&(e=void 0),!e)return Object.create(t||null);if(Vt(i,e,n),!t)return e;var r={};for(var o in P(r,t),e){var a=r[o],s=e[o];a&&!Array.isArray(a)&&(a=[a]),r[o]=a?a.concat(s):Array.isArray(s)?s:[s]}return r},Rt.props=Rt.methods=Rt.inject=Rt.computed=function(t,e,n,i){if(e&&Vt(i,e,n),!t)return e;var r=Object.create(null);return P(r,t),e&&P(r,e),r},Rt.provide=Nt;var jt=function(t,e){return void 0===e?t:e};function zt(t){new RegExp("^[a-zA-Z][\\-\\.0-9_"+$.source+"]*$").test(t)||ct('Invalid component name: "'+t+'". Component names should conform to valid custom element name in html5 specification.'),(m(t)||F.isReservedTag(t))&&ct("Do not use built-in or reserved HTML elements as component id: "+t)}function Vt(t,e,n){l(e)||ct('Invalid value for option "'+t+'": expected an Object, but got '+s(e)+".",n)}function Ht(t,e,n){if(function(t){for(var e in t.components)zt(e)}(e),"function"==typeof e&&(e=e.options),function(t,e){var n=t.props;if(n){var i,r,o={};if(Array.isArray(n))for(i=n.length;i--;)"string"==typeof(r=n[i])?o[k(r)]={type:null}:ct("props must be strings when using array syntax.");else if(l(n))for(var a in n)r=n[a],o[k(a)]=l(r)?r:{type:r};else ct('Invalid value for option "props": expected an Array or an Object, but got '+s(n)+".",e);t.props=o}}(e,n),function(t,e){var n=t.inject;if(n){var i=t.inject={};if(Array.isArray(n))for(var r=0;r<n.length;r++)i[n[r]]={from:n[r]};else if(l(n))for(var o in n){var a=n[o];i[o]=l(a)?P({from:o},a):{from:a}}else ct('Invalid value for option "inject": expected an Array or an Object, but got '+s(n)+".",e)}}(e,n),function(t){var e=t.directives;if(e)for(var n in e){var i=e[n];"function"==typeof i&&(e[n]={bind:i,update:i})}}(e),!e._base&&(e.extends&&(t=Ht(t,e.extends,n)),e.mixins))for(var i=0,r=e.mixins.length;i<r;i++)t=Ht(t,e.mixins[i],n);var o,a={};for(o in t)c(o);for(o in e)_(t,o)||c(o);function c(i){var r=Rt[i]||jt;a[i]=r(t[i],e[i],n,i)}return a}function Wt(t,e,n,i){if("string"==typeof n){var r=t[e];if(_(r,n))return r[n];var o=k(n);if(_(r,o))return r[o];var a=x(o);if(_(r,a))return r[a];var s=r[n]||r[o]||r[a];return i&&!s&&ct("Failed to resolve "+e.slice(0,-1)+": "+n,t),s}}function Ut(t,e,n,i){var r=e[t],a=!_(n,t),l=n[t],c=Jt(Boolean,r.type);if(c>-1)if(a&&!_(r,"default"))l=!1;else if(""===l||l===S(t)){var u=Jt(String,r.type);(u<0||c<u)&&(l=!0)}if(void 0===l){l=function(t,e,n){if(!_(e,"default"))return;var i=e.default;o(i)&&ct('Invalid default value for prop "'+n+'": Props with type Object/Array must use a factory function to return the default value.',t);if(t&&t.$options.propsData&&void 0===t.$options.propsData[n]&&void 0!==t._props[n])return t._props[n];return"function"==typeof i&&"Function"!==Gt(e.type)?i.call(t):i}(i,r,t);var d=Pt;Ot(!0),Et(l),Ot(d)}return function(t,e,n,i,r){if(t.required&&r)return void ct('Missing required prop: "'+e+'"',i);if(null==n&&!t.required)return;var o=t.type,a=!o||!0===o,l=[];if(o){Array.isArray(o)||(o=[o]);for(var c=0;c<o.length&&!a;c++){var u=Qt(n,o[c]);l.push(u.expectedType||""),a=u.valid}}if(!a)return void ct(function(t,e,n){var i='Invalid prop: type check failed for prop "'+t+'". Expected '+n.map(x).join(", "),r=n[0],o=s(e),a=Zt(e,r),l=Zt(e,o);1===n.length&&Xt(r)&&!function(){var t=[],e=arguments.length;for(;e--;)t[e]=arguments[e];return t.some((function(t){return"boolean"===t.toLowerCase()}))}(r,o)&&(i+=" with value "+a);i+=", got "+o+" ",Xt(o)&&(i+="with value "+l+".");return i}(e,n,l),i);var d=t.validator;d&&(d(n)||ct('Invalid prop: custom validator check failed for prop "'+e+'".',i))}(r,t,l,i,a),l}var Yt=/^(String|Number|Boolean|Function|Symbol)$/;function Qt(t,e){var n,i=Gt(e);if(Yt.test(i)){var r=typeof t;(n=r===i.toLowerCase())||"object"!==r||(n=t instanceof e)}else n="Object"===i?l(t):"Array"===i?Array.isArray(t):t instanceof e;return{valid:n,expectedType:i}}function Gt(t){var e=t&&t.toString().match(/^\s*function (\w+)/);return e?e[1]:""}function Kt(t,e){return Gt(t)===Gt(e)}function Jt(t,e){if(!Array.isArray(e))return Kt(e,t)?0:-1;for(var n=0,i=e.length;n<i;n++)if(Kt(e[n],t))return n;return-1}function Zt(t,e){return"String"===e?'"'+t+'"':"Number"===e?""+Number(t):""+t}function Xt(t){return["string","number","boolean"].some((function(e){return t.toLowerCase()===e}))}function te(t,e,n){yt();try{if(e)for(var i=e;i=i.$parent;){var r=i.$options.errorCaptured;if(r)for(var o=0;o<r.length;o++)try{if(!1===r[o].call(i,t,e,n))return}catch(t){ne(t,i,"errorCaptured hook")}}ne(t,e,n)}finally{_t()}}function ee(t,e,n,i,r){var o;try{(o=n?t.apply(e,n):t.call(e))&&!o._isVue&&d(o)&&!o._handled&&(o.catch((function(t){return te(t,i,r+" (Promise/async)")})),o._handled=!0)}catch(t){te(t,i,r)}return o}function ne(t,e,n){if(F.errorHandler)try{return F.errorHandler.call(null,t,e,n)}catch(e){e!==t&&ie(e,null,"config.errorHandler")}ie(t,e,n)}function ie(t,e,n){if(ct("Error in "+n+': "'+t.toString()+'"',e),!U&&!Y||"undefined"==typeof console)throw t;console.error(t)}var re,oe,ae,se=!1,le=[],ce=!1;function ue(){ce=!1;var t=le.slice(0);le.length=0;for(var e=0;e<t.length;e++)t[e]()}if("undefined"!=typeof Promise&&at(Promise)){var de=Promise.resolve();re=function(){de.then(ue),X&&setTimeout(B)},se=!0}else if(K||"undefined"==typeof MutationObserver||!at(MutationObserver)&&"[object MutationObserverConstructor]"!==MutationObserver.toString())re="undefined"!=typeof setImmediate&&at(setImmediate)?function(){setImmediate(ue)}:function(){setTimeout(ue,0)};else{var he=1,fe=new MutationObserver(ue),pe=document.createTextNode(String(he));fe.observe(pe,{characterData:!0}),re=function(){he=(he+1)%2,pe.data=String(he)},se=!0}function me(t,e){var n;if(le.push((function(){if(t)try{t.call(e)}catch(t){te(t,e,"nextTick")}else n&&n(e)})),ce||(ce=!0,re()),!t&&"undefined"!=typeof Promise)return new Promise((function(t){n=t}))}var ve,ge=U&&window.performance;ge&&ge.mark&&ge.measure&&ge.clearMarks&&ge.clearMeasures&&(oe=function(t){return ge.mark(t)},ae=function(t,e,n){ge.measure(t,e,n),ge.clearMarks(e),ge.clearMarks(n)});var ye=p("Infinity,undefined,NaN,isFinite,isNaN,parseFloat,parseInt,decodeURI,decodeURIComponent,encodeURI,encodeURIComponent,Math,Number,Date,Array,Object,Boolean,String,RegExp,Map,Set,JSON,Intl,require"),_e=function(t,e){ct('Property or method "'+e+'" is not defined on the instance but referenced during render. Make sure that this property is reactive, either in the data option, or for class-based components, by initializing the property. See: https://vuejs.org/v2/guide/reactivity.html#Declaring-Reactive-Properties.',t)},be=function(t,e){ct('Property "'+e+'" must be accessed with "$data.'+e+'" because properties starting with "$" or "_" are not proxied in the Vue instance to prevent conflicts with Vue internals. See: https://vuejs.org/v2/api/#data',t)},we="undefined"!=typeof Proxy&&at(Proxy);if(we){var ke=p("stop,prevent,self,ctrl,shift,alt,meta,exact");F.keyCodes=new Proxy(F.keyCodes,{set:function(t,e,n){return ke(e)?(ct("Avoid overwriting built-in modifier in config.keyCodes: ."+e),!1):(t[e]=n,!0)}})}var xe={has:function(t,e){var n=e in t,i=ye(e)||"string"==typeof e&&"_"===e.charAt(0)&&!(e in t.$data);return n||i||(e in t.$data?be(t,e):_e(t,e)),n||!i}},Ce={get:function(t,e){return"string"!=typeof e||e in t||(e in t.$data?be(t,e):_e(t,e)),t[e]}};ve=function(t){if(we){var e=t.$options,n=e.render&&e.render._withStripped?Ce:xe;t._renderProxy=new Proxy(t,n)}else t._renderProxy=t};var Se=new st;function Me(t){Te(t,Se),Se.clear()}function Te(t,e){var n,i,r=Array.isArray(t);if(!(!r&&!o(t)||Object.isFrozen(t)||t instanceof bt)){if(t.__ob__){var a=t.__ob__.dep.id;if(e.has(a))return;e.add(a)}if(r)for(n=t.length;n--;)Te(t[n],e);else for(n=(i=Object.keys(t)).length;n--;)Te(t[i[n]],e)}}var Pe=b((function(t){var e="&"===t.charAt(0),n="~"===(t=e?t.slice(1):t).charAt(0),i="!"===(t=n?t.slice(1):t).charAt(0);return{name:t=i?t.slice(1):t,once:n,capture:i,passive:e}}));function Oe(t,e){function n(){var t=arguments,i=n.fns;if(!Array.isArray(i))return ee(i,null,arguments,e,"v-on handler");for(var r=i.slice(),o=0;o<r.length;o++)ee(r[o],null,t,e,"v-on handler")}return n.fns=t,n}function Be(t,n,r,o,a,s){var l,c,u,d;for(l in t)c=t[l],u=n[l],d=Pe(l),e(c)?ct('Invalid handler for event "'+d.name+'": got '+String(c),s):e(u)?(e(c.fns)&&(c=t[l]=Oe(c,s)),i(d.once)&&(c=t[l]=a(d.name,c,d.capture)),r(d.name,c,d.capture,d.passive,d.params)):c!==u&&(u.fns=c,t[l]=u);for(l in n)e(t[l])&&o((d=Pe(l)).name,n[l],d.capture)}function Ee(t,r,o){var a;t instanceof bt&&(t=t.data.hook||(t.data.hook={}));var s=t[r];function l(){o.apply(this,arguments),g(a.fns,l)}e(s)?a=Oe([l]):n(s.fns)&&i(s.merged)?(a=s).fns.push(l):a=Oe([s,l]),a.merged=!0,t[r]=a}function Ae(t,e,i,r,o){if(n(e)){if(_(e,i))return t[i]=e[i],o||delete e[i],!0;if(_(e,r))return t[i]=e[r],o||delete e[r],!0}return!1}function De(t){return r(t)?[xt(t)]:Array.isArray(t)?qe(t):void 0}function Le(t){return n(t)&&n(t.text)&&!1===t.isComment}function qe(t,o){var a,s,l,c,u=[];for(a=0;a<t.length;a++)e(s=t[a])||"boolean"==typeof s||(c=u[l=u.length-1],Array.isArray(s)?s.length>0&&(Le((s=qe(s,(o||"")+"_"+a))[0])&&Le(c)&&(u[l]=xt(c.text+s[0].text),s.shift()),u.push.apply(u,s)):r(s)?Le(c)?u[l]=xt(c.text+s):""!==s&&u.push(xt(s)):Le(s)&&Le(c)?u[l]=xt(c.text+s.text):(i(t._isVList)&&n(s.tag)&&e(s.key)&&n(o)&&(s.key="__vlist"+o+"_"+a+"__"),u.push(s)));return u}function Re(t,e){if(t){for(var n=Object.create(null),i=lt?Reflect.ownKeys(t):Object.keys(t),r=0;r<i.length;r++){var o=i[r];if("__ob__"!==o){for(var a=t[o].from,s=e;s;){if(s._provided&&_(s._provided,a)){n[o]=s._provided[a];break}s=s.$parent}if(!s)if("default"in t[o]){var l=t[o].default;n[o]="function"==typeof l?l.call(e):l}else ct('Injection "'+o+'" not found',e)}}return n}}function Ie(t,e){if(!t||!t.length)return{};for(var n={},i=0,r=t.length;i<r;i++){var o=t[i],a=o.data;if(a&&a.attrs&&a.attrs.slot&&delete a.attrs.slot,o.context!==e&&o.fnContext!==e||!a||null==a.slot)(n.default||(n.default=[])).push(o);else{var s=a.slot,l=n[s]||(n[s]=[]);"template"===o.tag?l.push.apply(l,o.children||[]):l.push(o)}}for(var c in n)n[c].every(Ne)&&delete n[c];return n}function Ne(t){return t.isComment&&!t.asyncFactory||" "===t.text}function Fe(e,n,i){var r,o=Object.keys(n).length>0,a=e?!!e.$stable:!o,s=e&&e.$key;if(e){if(e._normalized)return e._normalized;if(a&&i&&i!==t&&s===i.$key&&!o&&!i.$hasNormal)return i;for(var l in r={},e)e[l]&&"$"!==l[0]&&(r[l]=$e(n,l,e[l]))}else r={};for(var c in n)c in r||(r[c]=je(n,c));return e&&Object.isExtensible(e)&&(e._normalized=r),z(r,"$stable",a),z(r,"$key",s),z(r,"$hasNormal",o),r}function $e(t,e,n){var i=function(){var t=arguments.length?n.apply(null,arguments):n({});return(t=t&&"object"==typeof t&&!Array.isArray(t)?[t]:De(t))&&(0===t.length||1===t.length&&t[0].isComment)?void 0:t};return n.proxy&&Object.defineProperty(t,e,{get:i,enumerable:!0,configurable:!0}),i}function je(t,e){return function(){return t[e]}}function ze(t,e){var i,r,a,s,l;if(Array.isArray(t)||"string"==typeof t)for(i=new Array(t.length),r=0,a=t.length;r<a;r++)i[r]=e(t[r],r);else if("number"==typeof t)for(i=new Array(t),r=0;r<t;r++)i[r]=e(r+1,r);else if(o(t))if(lt&&t[Symbol.iterator]){i=[];for(var c=t[Symbol.iterator](),u=c.next();!u.done;)i.push(e(u.value,i.length)),u=c.next()}else for(s=Object.keys(t),i=new Array(s.length),r=0,a=s.length;r<a;r++)l=s[r],i[r]=e(t[l],l,r);return n(i)||(i=[]),i._isVList=!0,i}function Ve(t,e,n,i){var r,a=this.$scopedSlots[t];a?(n=n||{},i&&(o(i)||ct("slot v-bind without argument expects an Object",this),n=P(P({},i),n)),r=a(n)||e):r=this.$slots[t]||e;var s=n&&n.slot;return s?this.$createElement("template",{slot:s},r):r}function He(t){return Wt(this.$options,"filters",t,!0)||A}function We(t,e){return Array.isArray(t)?-1===t.indexOf(e):t!==e}function Ue(t,e,n,i,r){var o=F.keyCodes[e]||n;return r&&i&&!F.keyCodes[e]?We(r,i):o?We(o,t):i?S(i)!==e:void 0}function Ye(t,e,n,i,r){if(n)if(o(n)){var a;Array.isArray(n)&&(n=O(n));var s=function(o){if("class"===o||"style"===o||v(o))a=t;else{var s=t.attrs&&t.attrs.type;a=i||F.mustUseProp(e,s,o)?t.domProps||(t.domProps={}):t.attrs||(t.attrs={})}var l=k(o),c=S(o);l in a||c in a||(a[o]=n[o],r&&((t.on||(t.on={}))["update:"+o]=function(t){n[o]=t}))};for(var l in n)s(l)}else ct("v-bind without argument expects an Object or Array value",this);return t}function Qe(t,e){var n=this._staticTrees||(this._staticTrees=[]),i=n[t];return i&&!e||Ke(i=n[t]=this.$options.staticRenderFns[t].call(this._renderProxy,null,this),"__static__"+t,!1),i}function Ge(t,e,n){return Ke(t,"__once__"+e+(n?"_"+n:""),!0),t}function Ke(t,e,n){if(Array.isArray(t))for(var i=0;i<t.length;i++)t[i]&&"string"!=typeof t[i]&&Je(t[i],e+"_"+i,n);else Je(t,e,n)}function Je(t,e,n){t.isStatic=!0,t.key=e,t.isOnce=n}function Ze(t,e){if(e)if(l(e)){var n=t.on=t.on?P({},t.on):{};for(var i in e){var r=n[i],o=e[i];n[i]=r?[].concat(r,o):o}}else ct("v-on without argument expects an Object value",this);return t}function Xe(t,e,n,i){e=e||{$stable:!n};for(var r=0;r<t.length;r++){var o=t[r];Array.isArray(o)?Xe(o,e,n):o&&(o.proxy&&(o.fn.proxy=!0),e[o.key]=o.fn)}return i&&(e.$key=i),e}function tn(t,e){for(var n=0;n<e.length;n+=2){var i=e[n];"string"==typeof i&&i?t[e[n]]=e[n+1]:""!==i&&null!==i&&ct("Invalid value for dynamic directive argument (expected string or null): "+i,this)}return t}function en(t,e){return"string"==typeof t?e+t:t}function nn(t){t._o=Ge,t._n=f,t._s=h,t._l=ze,t._t=Ve,t._q=D,t._i=L,t._m=Qe,t._f=He,t._k=Ue,t._b=Ye,t._v=xt,t._e=kt,t._u=Xe,t._g=Ze,t._d=tn,t._p=en}function rn(e,n,r,o,a){var s,l=this,c=a.options;_(o,"_uid")?(s=Object.create(o))._original=o:(s=o,o=o._original);var u=i(c._compiled),d=!u;this.data=e,this.props=n,this.children=r,this.parent=o,this.listeners=e.on||t,this.injections=Re(c.inject,o),this.slots=function(){return l.$slots||Fe(e.scopedSlots,l.$slots=Ie(r,o)),l.$slots},Object.defineProperty(this,"scopedSlots",{enumerable:!0,get:function(){return Fe(e.scopedSlots,this.slots())}}),u&&(this.$options=c,this.$slots=this.slots(),this.$scopedSlots=Fe(e.scopedSlots,this.$slots)),c._scopeId?this._c=function(t,e,n,i){var r=fn(s,t,e,n,i,d);return r&&!Array.isArray(r)&&(r.fnScopeId=c._scopeId,r.fnContext=o),r}:this._c=function(t,e,n,i){return fn(s,t,e,n,i,d)}}function on(t,e,n,i,r){var o=Ct(t);return o.fnContext=n,o.fnOptions=i,(o.devtoolsMeta=o.devtoolsMeta||{}).renderContext=r,e.slot&&((o.data||(o.data={})).slot=e.slot),o}function an(t,e){for(var n in e)t[k(n)]=e[n]}nn(rn.prototype);var sn={init:function(t,e){if(t.componentInstance&&!t.componentInstance._isDestroyed&&t.data.keepAlive){var i=t;sn.prepatch(i,i)}else{(t.componentInstance=function(t,e){var i={_isComponent:!0,_parentVnode:t,parent:e},r=t.data.inlineTemplate;n(r)&&(i.render=r.render,i.staticRenderFns=r.staticRenderFns);return new t.componentOptions.Ctor(i)}(t,Cn)).$mount(e?t.elm:void 0,e)}},prepatch:function(e,n){var i=n.componentOptions;!function(e,n,i,r,o){Sn=!0;var a=r.data.scopedSlots,s=e.$scopedSlots,l=!!(a&&!a.$stable||s!==t&&!s.$stable||a&&e.$scopedSlots.$key!==a.$key),c=!!(o||e.$options._renderChildren||l);e.$options._parentVnode=r,e.$vnode=r,e._vnode&&(e._vnode.parent=r);if(e.$options._renderChildren=o,e.$attrs=r.data.attrs||t,e.$listeners=i||t,n&&e.$options.props){Ot(!1);for(var u=e._props,d=e.$options._propKeys||[],h=0;h<d.length;h++){var f=d[h],p=e.$options.props;u[f]=Ut(f,p,n,e)}Ot(!0),e.$options.propsData=n}i=i||t;var m=e.$options._parentListeners;e.$options._parentListeners=i,xn(e,i,m),c&&(e.$slots=Ie(o,r.context),e.$forceUpdate());Sn=!1}(n.componentInstance=e.componentInstance,i.propsData,i.listeners,n,i.children)},insert:function(t){var e,n=t.context,i=t.componentInstance;i._isMounted||(i._isMounted=!0,Bn(i,"mounted")),t.data.keepAlive&&(n._isMounted?((e=i)._inactive=!1,Dn.push(e)):Pn(i,!0))},destroy:function(t){var e=t.componentInstance;e._isDestroyed||(t.data.keepAlive?On(e,!0):e.$destroy())}},ln=Object.keys(sn);function cn(r,a,s,l,c){if(!e(r)){var u=s.$options._base;if(o(r)&&(r=u.extend(r)),"function"==typeof r){var h;if(e(r.cid)&&(r=function(t,r){if(i(t.error)&&n(t.errorComp))return t.errorComp;if(n(t.resolved))return t.resolved;var a=vn;a&&n(t.owners)&&-1===t.owners.indexOf(a)&&t.owners.push(a);if(i(t.loading)&&n(t.loadingComp))return t.loadingComp;if(a&&!n(t.owners)){var s=t.owners=[a],l=!0,c=null,u=null;a.$on("hook:destroyed",(function(){return g(s,a)}));var h=function(t){for(var e=0,n=s.length;e<n;e++)s[e].$forceUpdate();t&&(s.length=0,null!==c&&(clearTimeout(c),c=null),null!==u&&(clearTimeout(u),u=null))},f=q((function(e){t.resolved=gn(e,r),l?s.length=0:h(!0)})),p=q((function(e){ct("Failed to resolve async component: "+String(t)+(e?"\nReason: "+e:"")),n(t.errorComp)&&(t.error=!0,h(!0))})),m=t(f,p);return o(m)&&(d(m)?e(t.resolved)&&m.then(f,p):d(m.component)&&(m.component.then(f,p),n(m.error)&&(t.errorComp=gn(m.error,r)),n(m.loading)&&(t.loadingComp=gn(m.loading,r),0===m.delay?t.loading=!0:c=setTimeout((function(){c=null,e(t.resolved)&&e(t.error)&&(t.loading=!0,h(!1))}),m.delay||200)),n(m.timeout)&&(u=setTimeout((function(){u=null,e(t.resolved)&&p("timeout ("+m.timeout+"ms)")}),m.timeout)))),l=!1,t.loading?t.loadingComp:t.resolved}}(h=r,u),void 0===r))return function(t,e,n,i,r){var o=kt();return o.asyncFactory=t,o.asyncMeta={data:e,context:n,children:i,tag:r},o}(h,a,s,l,c);a=a||{},ti(r),n(a.model)&&function(t,e){var i=t.model&&t.model.prop||"value",r=t.model&&t.model.event||"input";(e.attrs||(e.attrs={}))[i]=e.model.value;var o=e.on||(e.on={}),a=o[r],s=e.model.callback;n(a)?(Array.isArray(a)?-1===a.indexOf(s):a!==s)&&(o[r]=[s].concat(a)):o[r]=s}(r.options,a);var f=function(t,i,r){var o=i.options.props;if(!e(o)){var a={},s=t.attrs,l=t.props;if(n(s)||n(l))for(var c in o){var u=S(c),d=c.toLowerCase();c!==d&&s&&_(s,d)&&ut('Prop "'+d+'" is passed to component '+ht(r||i)+', but the declared prop name is "'+c+'". Note that HTML attributes are case-insensitive and camelCased props need to use their kebab-case equivalents when using in-DOM templates. You should probably use "'+u+'" instead of "'+c+'".'),Ae(a,l,c,u,!0)||Ae(a,s,c,u,!1)}return a}}(a,r,c);if(i(r.options.functional))return function(e,i,r,o,a){var s=e.options,l={},c=s.props;if(n(c))for(var u in c)l[u]=Ut(u,c,i||t);else n(r.attrs)&&an(l,r.attrs),n(r.props)&&an(l,r.props);var d=new rn(r,l,a,o,e),h=s.render.call(null,d._c,d);if(h instanceof bt)return on(h,r,d.parent,s,d);if(Array.isArray(h)){for(var f=De(h)||[],p=new Array(f.length),m=0;m<f.length;m++)p[m]=on(f[m],r,d.parent,s,d);return p}}(r,f,a,s,l);var p=a.on;if(a.on=a.nativeOn,i(r.options.abstract)){var m=a.slot;a={},m&&(a.slot=m)}!function(t){for(var e=t.hook||(t.hook={}),n=0;n<ln.length;n++){var i=ln[n],r=e[i],o=sn[i];r===o||r&&r._merged||(e[i]=r?un(o,r):o)}}(a);var v=r.options.name||c;return new bt("vue-component-"+r.cid+(v?"-"+v:""),a,void 0,void 0,void 0,s,{Ctor:r,propsData:f,listeners:p,tag:c,children:l},h)}ct("Invalid Component definition: "+String(r),s)}}function un(t,e){var n=function(n,i){t(n,i),e(n,i)};return n._merged=!0,n}var dn=1,hn=2;function fn(t,e,a,s,l,c){return(Array.isArray(a)||r(a))&&(l=s,s=a,a=void 0),i(c)&&(l=hn),function(t,e,i,a,s){if(n(i)&&n(i.__ob__))return ct("Avoid using observed data object as vnode data: "+JSON.stringify(i)+"\nAlways create fresh vnode data objects in each render!",t),kt();n(i)&&n(i.is)&&(e=i.is);if(!e)return kt();n(i)&&n(i.key)&&!r(i.key)&&ct("Avoid using non-primitive value as key, use string/number value instead.",t);Array.isArray(a)&&"function"==typeof a[0]&&((i=i||{}).scopedSlots={default:a[0]},a.length=0);s===hn?a=De(a):s===dn&&(a=function(t){for(var e=0;e<t.length;e++)if(Array.isArray(t[e]))return Array.prototype.concat.apply([],t);return t}(a));var l,c;if("string"==typeof e){var u;c=t.$vnode&&t.$vnode.ns||F.getTagNamespace(e),F.isReservedTag(e)?(n(i)&&n(i.nativeOn)&&ct("The .native modifier for v-on is only valid on components but it was used on <"+e+">.",t),l=new bt(F.parsePlatformTagName(e),i,a,void 0,void 0,t)):l=i&&i.pre||!n(u=Wt(t.$options,"components",e))?new bt(e,i,a,void 0,void 0,t):cn(u,i,t,a,e)}else l=cn(e,i,t,a);return Array.isArray(l)?l:n(l)?(n(c)&&pn(l,c),n(i)&&function(t){o(t.style)&&Me(t.style);o(t.class)&&Me(t.class)}(i),l):kt()}(t,e,a,s,l)}function pn(t,r,o){if(t.ns=r,"foreignObject"===t.tag&&(r=void 0,o=!0),n(t.children))for(var a=0,s=t.children.length;a<s;a++){var l=t.children[a];n(l.tag)&&(e(l.ns)||i(o)&&"svg"!==l.tag)&&pn(l,r,o)}}var mn,vn=null;function gn(t,e){return(t.__esModule||lt&&"Module"===t[Symbol.toStringTag])&&(t=t.default),o(t)?e.extend(t):t}function yn(t){return t.isComment&&t.asyncFactory}function _n(t){if(Array.isArray(t))for(var e=0;e<t.length;e++){var i=t[e];if(n(i)&&(n(i.componentOptions)||yn(i)))return i}}function bn(t,e){mn.$on(t,e)}function wn(t,e){mn.$off(t,e)}function kn(t,e){var n=mn;return function i(){null!==e.apply(null,arguments)&&n.$off(t,i)}}function xn(t,e,n){mn=t,Be(e,n||{},bn,wn,kn,t),mn=void 0}var Cn=null,Sn=!1;function Mn(t){var e=Cn;return Cn=t,function(){Cn=e}}function Tn(t){for(;t&&(t=t.$parent);)if(t._inactive)return!0;return!1}function Pn(t,e){if(e){if(t._directInactive=!1,Tn(t))return}else if(t._directInactive)return;if(t._inactive||null===t._inactive){t._inactive=!1;for(var n=0;n<t.$children.length;n++)Pn(t.$children[n]);Bn(t,"activated")}}function On(t,e){if(!(e&&(t._directInactive=!0,Tn(t))||t._inactive)){t._inactive=!0;for(var n=0;n<t.$children.length;n++)On(t.$children[n]);Bn(t,"deactivated")}}function Bn(t,e){yt();var n=t.$options[e],i=e+" hook";if(n)for(var r=0,o=n.length;r<o;r++)ee(n[r],t,null,t,i);t._hasHookEvent&&t.$emit("hook:"+e),_t()}var En=100,An=[],Dn=[],Ln={},qn={},Rn=!1,In=!1,Nn=0;var Fn=0,$n=Date.now;if(U&&!K){var jn=window.performance;jn&&"function"==typeof jn.now&&$n()>document.createEvent("Event").timeStamp&&($n=function(){return jn.now()})}function zn(){var t,e;for(Fn=$n(),In=!0,An.sort((function(t,e){return t.id-e.id})),Nn=0;Nn<An.length;Nn++)if((t=An[Nn]).before&&t.before(),e=t.id,Ln[e]=null,t.run(),null!=Ln[e]&&(qn[e]=(qn[e]||0)+1,qn[e]>En)){ct("You may have an infinite update loop "+(t.user?'in watcher with expression "'+t.expression+'"':"in a component render function."),t.vm);break}var n=Dn.slice(),i=An.slice();Nn=An.length=Dn.length=0,Ln={},qn={},Rn=In=!1,function(t){for(var e=0;e<t.length;e++)t[e]._inactive=!0,Pn(t[e],!0)}(n),function(t){var e=t.length;for(;e--;){var n=t[e],i=n.vm;i._watcher===n&&i._isMounted&&!i._isDestroyed&&Bn(i,"updated")}}(i),ot&&F.devtools&&ot.emit("flush")}var Vn=0,Hn=function(t,e,n,i,r){this.vm=t,r&&(t._watcher=this),t._watchers.push(this),i?(this.deep=!!i.deep,this.user=!!i.user,this.lazy=!!i.lazy,this.sync=!!i.sync,this.before=i.before):this.deep=this.user=this.lazy=this.sync=!1,this.cb=n,this.id=++Vn,this.active=!0,this.dirty=this.lazy,this.deps=[],this.newDeps=[],this.depIds=new st,this.newDepIds=new st,this.expression=e.toString(),"function"==typeof e?this.getter=e:(this.getter=function(t){if(!V.test(t)){var e=t.split(".");return function(t){for(var n=0;n<e.length;n++){if(!t)return;t=t[e[n]]}return t}}}(e),this.getter||(this.getter=B,ct('Failed watching path: "'+e+'" Watcher only accepts simple dot-delimited paths. For full control, use a function instead.',t))),this.value=this.lazy?void 0:this.get()};Hn.prototype.get=function(){var t;yt(this);var e=this.vm;try{t=this.getter.call(e,e)}catch(t){if(!this.user)throw t;te(t,e,'getter for watcher "'+this.expression+'"')}finally{this.deep&&Me(t),_t(),this.cleanupDeps()}return t},Hn.prototype.addDep=function(t){var e=t.id;this.newDepIds.has(e)||(this.newDepIds.add(e),this.newDeps.push(t),this.depIds.has(e)||t.addSub(this))},Hn.prototype.cleanupDeps=function(){for(var t=this.deps.length;t--;){var e=this.deps[t];this.newDepIds.has(e.id)||e.removeSub(this)}var n=this.depIds;this.depIds=this.newDepIds,this.newDepIds=n,this.newDepIds.clear(),n=this.deps,this.deps=this.newDeps,this.newDeps=n,this.newDeps.length=0},Hn.prototype.update=function(){this.lazy?this.dirty=!0:this.sync?this.run():function(t){var e=t.id;if(null==Ln[e]){if(Ln[e]=!0,In){for(var n=An.length-1;n>Nn&&An[n].id>t.id;)n--;An.splice(n+1,0,t)}else An.push(t);if(!Rn){if(Rn=!0,!F.async)return void zn();me(zn)}}}(this)},Hn.prototype.run=function(){if(this.active){var t=this.get();if(t!==this.value||o(t)||this.deep){var e=this.value;if(this.value=t,this.user)try{this.cb.call(this.vm,t,e)}catch(t){te(t,this.vm,'callback for watcher "'+this.expression+'"')}else this.cb.call(this.vm,t,e)}}},Hn.prototype.evaluate=function(){this.value=this.get(),this.dirty=!1},Hn.prototype.depend=function(){for(var t=this.deps.length;t--;)this.deps[t].depend()},Hn.prototype.teardown=function(){if(this.active){this.vm._isBeingDestroyed||g(this.vm._watchers,this);for(var t=this.deps.length;t--;)this.deps[t].removeSub(this);this.active=!1}};var Wn={enumerable:!0,configurable:!0,get:B,set:B};function Un(t,e,n){Wn.get=function(){return this[e][n]},Wn.set=function(t){this[e][n]=t},Object.defineProperty(t,n,Wn)}function Yn(t){t._watchers=[];var e=t.$options;e.props&&function(t,e){var n=t.$options.propsData||{},i=t._props={},r=t.$options._propKeys=[],o=!t.$parent;o||Ot(!1);var a=function(a){r.push(a);var s=Ut(a,e,n,t),l=S(a);(v(l)||F.isReservedAttr(l))&&ct('"'+l+'" is a reserved attribute and cannot be used as component prop.',t),At(i,a,s,(function(){o||Sn||ct("Avoid mutating a prop directly since the value will be overwritten whenever the parent component re-renders. Instead, use a data or computed property based on the prop's value. Prop being mutated: \""+a+'"',t)})),a in t||Un(t,"_props",a)};for(var s in e)a(s);Ot(!0)}(t,e.props),e.methods&&function(t,e){var n=t.$options.props;for(var i in e)"function"!=typeof e[i]&&ct('Method "'+i+'" has type "'+typeof e[i]+'" in the component definition. Did you reference the function correctly?',t),n&&_(n,i)&&ct('Method "'+i+'" has already been defined as a prop.',t),i in t&&j(i)&&ct('Method "'+i+'" conflicts with an existing Vue instance method. Avoid defining component methods that start with _ or $.'),t[i]="function"!=typeof e[i]?B:M(e[i],t)}(t,e.methods),e.data?function(t){var e=t.$options.data;e=t._data="function"==typeof e?function(t,e){yt();try{return t.call(e,e)}catch(t){return te(t,e,"data()"),{}}finally{_t()}}(e,t):e||{},l(e)||(e={},ct("data functions should return an object:\nhttps://vuejs.org/v2/guide/components.html#data-Must-Be-a-Function",t));var n=Object.keys(e),i=t.$options.props,r=t.$options.methods,o=n.length;for(;o--;){var a=n[o];r&&_(r,a)&&ct('Method "'+a+'" has already been defined as a data property.',t),i&&_(i,a)?ct('The data property "'+a+'" is already declared as a prop. Use prop default value instead.',t):j(a)||Un(t,"_data",a)}Et(e,!0)}(t):Et(t._data={},!0),e.computed&&function(t,e){var n=t._computedWatchers=Object.create(null),i=rt();for(var r in e){var o=e[r],a="function"==typeof o?o:o.get;null==a&&ct('Getter is missing for computed property "'+r+'".',t),i||(n[r]=new Hn(t,a||B,B,Qn)),r in t?r in t.$data?ct('The computed property "'+r+'" is already defined in data.',t):t.$options.props&&r in t.$options.props&&ct('The computed property "'+r+'" is already defined as a prop.',t):Gn(t,r,o)}}(t,e.computed),e.watch&&e.watch!==et&&function(t,e){for(var n in e){var i=e[n];if(Array.isArray(i))for(var r=0;r<i.length;r++)Zn(t,n,i[r]);else Zn(t,n,i)}}(t,e.watch)}var Qn={lazy:!0};function Gn(t,e,n){var i=!rt();"function"==typeof n?(Wn.get=i?Kn(e):Jn(n),Wn.set=B):(Wn.get=n.get?i&&!1!==n.cache?Kn(e):Jn(n.get):B,Wn.set=n.set||B),Wn.set===B&&(Wn.set=function(){ct('Computed property "'+e+'" was assigned to but it has no setter.',this)}),Object.defineProperty(t,e,Wn)}function Kn(t){return function(){var e=this._computedWatchers&&this._computedWatchers[t];if(e)return e.dirty&&e.evaluate(),vt.target&&e.depend(),e.value}}function Jn(t){return function(){return t.call(this,this)}}function Zn(t,e,n,i){return l(n)&&(i=n,n=n.handler),"string"==typeof n&&(n=t[n]),t.$watch(e,n,i)}var Xn=0;function ti(t){var e=t.options;if(t.super){var n=ti(t.super);if(n!==t.superOptions){t.superOptions=n;var i=function(t){var e,n=t.options,i=t.sealedOptions;for(var r in n)n[r]!==i[r]&&(e||(e={}),e[r]=n[r]);return e}(t);i&&P(t.extendOptions,i),(e=t.options=Ht(n,t.extendOptions)).name&&(e.components[e.name]=t)}}return e}function ei(t){this instanceof ei||ct("Vue is a constructor and should be called with the `new` keyword"),this._init(t)}function ni(t){t.cid=0;var e=1;t.extend=function(t){t=t||{};var n=this,i=n.cid,r=t._Ctor||(t._Ctor={});if(r[i])return r[i];var o=t.name||n.options.name;o&&zt(o);var a=function(t){this._init(t)};return(a.prototype=Object.create(n.prototype)).constructor=a,a.cid=e++,a.options=Ht(n.options,t),a.super=n,a.options.props&&function(t){var e=t.options.props;for(var n in e)Un(t.prototype,"_props",n)}(a),a.options.computed&&function(t){var e=t.options.computed;for(var n in e)Gn(t.prototype,n,e[n])}(a),a.extend=n.extend,a.mixin=n.mixin,a.use=n.use,I.forEach((function(t){a[t]=n[t]})),o&&(a.options.components[o]=a),a.superOptions=n.options,a.extendOptions=t,a.sealedOptions=P({},a.options),r[i]=a,a}}function ii(t){return t&&(t.Ctor.options.name||t.tag)}function ri(t,e){return Array.isArray(t)?t.indexOf(e)>-1:"string"==typeof t?t.split(",").indexOf(e)>-1:!!c(t)&&t.test(e)}function oi(t,e){var n=t.cache,i=t.keys,r=t._vnode;for(var o in n){var a=n[o];if(a){var s=ii(a.componentOptions);s&&!e(s)&&ai(n,o,i,r)}}}function ai(t,e,n,i){var r=t[e];!r||i&&r.tag===i.tag||r.componentInstance.$destroy(),t[e]=null,g(n,e)}!function(e){e.prototype._init=function(e){var n,i,r=this;r._uid=Xn++,F.performance&&oe&&(n="vue-perf-start:"+r._uid,i="vue-perf-end:"+r._uid,oe(n)),r._isVue=!0,e&&e._isComponent?function(t,e){var n=t.$options=Object.create(t.constructor.options),i=e._parentVnode;n.parent=e.parent,n._parentVnode=i;var r=i.componentOptions;n.propsData=r.propsData,n._parentListeners=r.listeners,n._renderChildren=r.children,n._componentTag=r.tag,e.render&&(n.render=e.render,n.staticRenderFns=e.staticRenderFns)}(r,e):r.$options=Ht(ti(r.constructor),e||{},r),ve(r),r._self=r,function(t){var e=t.$options,n=e.parent;if(n&&!e.abstract){for(;n.$options.abstract&&n.$parent;)n=n.$parent;n.$children.push(t)}t.$parent=n,t.$root=n?n.$root:t,t.$children=[],t.$refs={},t._watcher=null,t._inactive=null,t._directInactive=!1,t._isMounted=!1,t._isDestroyed=!1,t._isBeingDestroyed=!1}(r),function(t){t._events=Object.create(null),t._hasHookEvent=!1;var e=t.$options._parentListeners;e&&xn(t,e)}(r),function(e){e._vnode=null,e._staticTrees=null;var n=e.$options,i=e.$vnode=n._parentVnode,r=i&&i.context;e.$slots=Ie(n._renderChildren,r),e.$scopedSlots=t,e._c=function(t,n,i,r){return fn(e,t,n,i,r,!1)},e.$createElement=function(t,n,i,r){return fn(e,t,n,i,r,!0)};var o=i&&i.data;At(e,"$attrs",o&&o.attrs||t,(function(){!Sn&&ct("$attrs is readonly.",e)}),!0),At(e,"$listeners",n._parentListeners||t,(function(){!Sn&&ct("$listeners is readonly.",e)}),!0)}(r),Bn(r,"beforeCreate"),function(t){var e=Re(t.$options.inject,t);e&&(Ot(!1),Object.keys(e).forEach((function(n){At(t,n,e[n],(function(){ct('Avoid mutating an injected value directly since the changes will be overwritten whenever the provided component re-renders. injection being mutated: "'+n+'"',t)}))})),Ot(!0))}(r),Yn(r),function(t){var e=t.$options.provide;e&&(t._provided="function"==typeof e?e.call(t):e)}(r),Bn(r,"created"),F.performance&&oe&&(r._name=ht(r,!1),oe(i),ae("vue "+r._name+" init",n,i)),r.$options.el&&r.$mount(r.$options.el)}}(ei),function(t){var e={get:function(){return this._data}},n={get:function(){return this._props}};e.set=function(){ct("Avoid replacing instance root $data. Use nested data properties instead.",this)},n.set=function(){ct("$props is readonly.",this)},Object.defineProperty(t.prototype,"$data",e),Object.defineProperty(t.prototype,"$props",n),t.prototype.$set=Dt,t.prototype.$delete=Lt,t.prototype.$watch=function(t,e,n){var i=this;if(l(e))return Zn(i,t,e,n);(n=n||{}).user=!0;var r=new Hn(i,t,e,n);if(n.immediate)try{e.call(i,r.value)}catch(t){te(t,i,'callback for immediate watcher "'+r.expression+'"')}return function(){r.teardown()}}}(ei),function(t){var e=/^hook:/;t.prototype.$on=function(t,n){var i=this;if(Array.isArray(t))for(var r=0,o=t.length;r<o;r++)i.$on(t[r],n);else(i._events[t]||(i._events[t]=[])).push(n),e.test(t)&&(i._hasHookEvent=!0);return i},t.prototype.$once=function(t,e){var n=this;function i(){n.$off(t,i),e.apply(n,arguments)}return i.fn=e,n.$on(t,i),n},t.prototype.$off=function(t,e){var n=this;if(!arguments.length)return n._events=Object.create(null),n;if(Array.isArray(t)){for(var i=0,r=t.length;i<r;i++)n.$off(t[i],e);return n}var o,a=n._events[t];if(!a)return n;if(!e)return n._events[t]=null,n;for(var s=a.length;s--;)if((o=a[s])===e||o.fn===e){a.splice(s,1);break}return n},t.prototype.$emit=function(t){var e=this,n=t.toLowerCase();n!==t&&e._events[n]&&ut('Event "'+n+'" is emitted in component '+ht(e)+' but the handler is registered for "'+t+'". Note that HTML attributes are case-insensitive and you cannot use v-on to listen to camelCase events when using in-DOM templates. You should probably use "'+S(t)+'" instead of "'+t+'".');var i=e._events[t];if(i){i=i.length>1?T(i):i;for(var r=T(arguments,1),o='event handler for "'+t+'"',a=0,s=i.length;a<s;a++)ee(i[a],e,r,e,o)}return e}}(ei),function(t){t.prototype._update=function(t,e){var n=this,i=n.$el,r=n._vnode,o=Mn(n);n._vnode=t,n.$el=r?n.__patch__(r,t):n.__patch__(n.$el,t,e,!1),o(),i&&(i.__vue__=null),n.$el&&(n.$el.__vue__=n),n.$vnode&&n.$parent&&n.$vnode===n.$parent._vnode&&(n.$parent.$el=n.$el)},t.prototype.$forceUpdate=function(){this._watcher&&this._watcher.update()},t.prototype.$destroy=function(){var t=this;if(!t._isBeingDestroyed){Bn(t,"beforeDestroy"),t._isBeingDestroyed=!0;var e=t.$parent;!e||e._isBeingDestroyed||t.$options.abstract||g(e.$children,t),t._watcher&&t._watcher.teardown();for(var n=t._watchers.length;n--;)t._watchers[n].teardown();t._data.__ob__&&t._data.__ob__.vmCount--,t._isDestroyed=!0,t.__patch__(t._vnode,null),Bn(t,"destroyed"),t.$off(),t.$el&&(t.$el.__vue__=null),t.$vnode&&(t.$vnode.parent=null)}}}(ei),function(t){nn(t.prototype),t.prototype.$nextTick=function(t){return me(t,this)},t.prototype._render=function(){var t,e=this,n=e.$options,i=n.render,r=n._parentVnode;r&&(e.$scopedSlots=Fe(r.data.scopedSlots,e.$slots,e.$scopedSlots)),e.$vnode=r;try{vn=e,t=i.call(e._renderProxy,e.$createElement)}catch(n){if(te(n,e,"render"),e.$options.renderError)try{t=e.$options.renderError.call(e._renderProxy,e.$createElement,n)}catch(n){te(n,e,"renderError"),t=e._vnode}else t=e._vnode}finally{vn=null}return Array.isArray(t)&&1===t.length&&(t=t[0]),t instanceof bt||(Array.isArray(t)&&ct("Multiple root nodes returned from render function. Render function should return a single root node.",e),t=kt()),t.parent=r,t}}(ei);var si=[String,RegExp,Array],li={KeepAlive:{name:"keep-alive",abstract:!0,props:{include:si,exclude:si,max:[String,Number]},created:function(){this.cache=Object.create(null),this.keys=[]},destroyed:function(){for(var t in this.cache)ai(this.cache,t,this.keys)},mounted:function(){var t=this;this.$watch("include",(function(e){oi(t,(function(t){return ri(e,t)}))})),this.$watch("exclude",(function(e){oi(t,(function(t){return!ri(e,t)}))}))},render:function(){var t=this.$slots.default,e=_n(t),n=e&&e.componentOptions;if(n){var i=ii(n),r=this.include,o=this.exclude;if(r&&(!i||!ri(r,i))||o&&i&&ri(o,i))return e;var a=this.cache,s=this.keys,l=null==e.key?n.Ctor.cid+(n.tag?"::"+n.tag:""):e.key;a[l]?(e.componentInstance=a[l].componentInstance,g(s,l),s.push(l)):(a[l]=e,s.push(l),this.max&&s.length>parseInt(this.max)&&ai(a,s[0],s,this._vnode)),e.data.keepAlive=!0}return e||t&&t[0]}}};!function(t){var e={get:function(){return F},set:function(){ct("Do not replace the Vue.config object, set individual fields instead.")}};Object.defineProperty(t,"config",e),t.util={warn:ct,extend:P,mergeOptions:Ht,defineReactive:At},t.set=Dt,t.delete=Lt,t.nextTick=me,t.observable=function(t){return Et(t),t},t.options=Object.create(null),I.forEach((function(e){t.options[e+"s"]=Object.create(null)})),t.options._base=t,P(t.options.components,li),function(t){t.use=function(t){var e=this._installedPlugins||(this._installedPlugins=[]);if(e.indexOf(t)>-1)return this;var n=T(arguments,1);return n.unshift(this),"function"==typeof t.install?t.install.apply(t,n):"function"==typeof t&&t.apply(null,n),e.push(t),this}}(t),function(t){t.mixin=function(t){return this.options=Ht(this.options,t),this}}(t),ni(t),function(t){I.forEach((function(e){t[e]=function(t,n){return n?("component"===e&&zt(t),"component"===e&&l(n)&&(n.name=n.name||t,n=this.options._base.extend(n)),"directive"===e&&"function"==typeof n&&(n={bind:n,update:n}),this.options[e+"s"][t]=n,n):this.options[e+"s"][t]}}))}(t)}(ei),Object.defineProperty(ei.prototype,"$isServer",{get:rt}),Object.defineProperty(ei.prototype,"$ssrContext",{get:function(){return this.$vnode&&this.$vnode.ssrContext}}),Object.defineProperty(ei,"FunctionalRenderContext",{value:rn}),ei.version="2.6.12";var ci=p("style,class"),ui=p("input,textarea,option,select,progress"),di=function(t,e,n){return"value"===n&&ui(t)&&"button"!==e||"selected"===n&&"option"===t||"checked"===n&&"input"===t||"muted"===n&&"video"===t},hi=p("contenteditable,draggable,spellcheck"),fi=p("events,caret,typing,plaintext-only"),pi=function(t,e){return _i(e)||"false"===e?"false":"contenteditable"===t&&fi(e)?e:"true"},mi=p("allowfullscreen,async,autofocus,autoplay,checked,compact,controls,declare,default,defaultchecked,defaultmuted,defaultselected,defer,disabled,enabled,formnovalidate,hidden,indeterminate,inert,ismap,itemscope,loop,multiple,muted,nohref,noresize,noshade,novalidate,nowrap,open,pauseonexit,readonly,required,reversed,scoped,seamless,selected,sortable,translate,truespeed,typemustmatch,visible"),vi="http://www.w3.org/1999/xlink",gi=function(t){return":"===t.charAt(5)&&"xlink"===t.slice(0,5)},yi=function(t){return gi(t)?t.slice(6,t.length):""},_i=function(t){return null==t||!1===t};function bi(t){for(var e=t.data,i=t,r=t;n(r.componentInstance);)(r=r.componentInstance._vnode)&&r.data&&(e=wi(r.data,e));for(;n(i=i.parent);)i&&i.data&&(e=wi(e,i.data));return function(t,e){if(n(t)||n(e))return ki(t,xi(e));return""}(e.staticClass,e.class)}function wi(t,e){return{staticClass:ki(t.staticClass,e.staticClass),class:n(t.class)?[t.class,e.class]:e.class}}function ki(t,e){return t?e?t+" "+e:t:e||""}function xi(t){return Array.isArray(t)?function(t){for(var e,i="",r=0,o=t.length;r<o;r++)n(e=xi(t[r]))&&""!==e&&(i&&(i+=" "),i+=e);return i}(t):o(t)?function(t){var e="";for(var n in t)t[n]&&(e&&(e+=" "),e+=n);return e}(t):"string"==typeof t?t:""}var Ci={svg:"http://www.w3.org/2000/svg",math:"http://www.w3.org/1998/Math/MathML"},Si=p("html,body,base,head,link,meta,style,title,address,article,aside,footer,header,h1,h2,h3,h4,h5,h6,hgroup,nav,section,div,dd,dl,dt,figcaption,figure,picture,hr,img,li,main,ol,p,pre,ul,a,b,abbr,bdi,bdo,br,cite,code,data,dfn,em,i,kbd,mark,q,rp,rt,rtc,ruby,s,samp,small,span,strong,sub,sup,time,u,var,wbr,area,audio,map,track,video,embed,object,param,source,canvas,script,noscript,del,ins,caption,col,colgroup,table,thead,tbody,td,th,tr,button,datalist,fieldset,form,input,label,legend,meter,optgroup,option,output,progress,select,textarea,details,dialog,menu,menuitem,summary,content,element,shadow,template,blockquote,iframe,tfoot"),Mi=p("svg,animate,circle,clippath,cursor,defs,desc,ellipse,filter,font-face,foreignObject,g,glyph,image,line,marker,mask,missing-glyph,path,pattern,polygon,polyline,rect,switch,symbol,text,textpath,tspan,use,view",!0),Ti=function(t){return Si(t)||Mi(t)};function Pi(t){return Mi(t)?"svg":"math"===t?"math":void 0}var Oi=Object.create(null);var Bi=p("text,number,password,search,email,tel,url");function Ei(t){if("string"==typeof t){var e=document.querySelector(t);return e||(ct("Cannot find element: "+t),document.createElement("div"))}return t}var Ai=Object.freeze({createElement:function(t,e){var n=document.createElement(t);return"select"!==t||e.data&&e.data.attrs&&void 0!==e.data.attrs.multiple&&n.setAttribute("multiple","multiple"),n},createElementNS:function(t,e){return document.createElementNS(Ci[t],e)},createTextNode:function(t){return document.createTextNode(t)},createComment:function(t){return document.createComment(t)},insertBefore:function(t,e,n){t.insertBefore(e,n)},removeChild:function(t,e){t.removeChild(e)},appendChild:function(t,e){t.appendChild(e)},parentNode:function(t){return t.parentNode},nextSibling:function(t){return t.nextSibling},tagName:function(t){return t.tagName},setTextContent:function(t,e){t.textContent=e},setStyleScope:function(t,e){t.setAttribute(e,"")}}),Di={create:function(t,e){Li(e)},update:function(t,e){t.data.ref!==e.data.ref&&(Li(t,!0),Li(e))},destroy:function(t){Li(t,!0)}};function Li(t,e){var i=t.data.ref;if(n(i)){var r=t.context,o=t.componentInstance||t.elm,a=r.$refs;e?Array.isArray(a[i])?g(a[i],o):a[i]===o&&(a[i]=void 0):t.data.refInFor?Array.isArray(a[i])?a[i].indexOf(o)<0&&a[i].push(o):a[i]=[o]:a[i]=o}}var qi=new bt("",{},[]),Ri=["create","activate","update","remove","destroy"];function Ii(t,r){return t.key===r.key&&(t.tag===r.tag&&t.isComment===r.isComment&&n(t.data)===n(r.data)&&function(t,e){if("input"!==t.tag)return!0;var i,r=n(i=t.data)&&n(i=i.attrs)&&i.type,o=n(i=e.data)&&n(i=i.attrs)&&i.type;return r===o||Bi(r)&&Bi(o)}(t,r)||i(t.isAsyncPlaceholder)&&t.asyncFactory===r.asyncFactory&&e(r.asyncFactory.error))}function Ni(t,e,i){var r,o,a={};for(r=e;r<=i;++r)n(o=t[r].key)&&(a[o]=r);return a}var Fi={create:$i,update:$i,destroy:function(t){$i(t,qi)}};function $i(t,e){(t.data.directives||e.data.directives)&&function(t,e){var n,i,r,o=t===qi,a=e===qi,s=zi(t.data.directives,t.context),l=zi(e.data.directives,e.context),c=[],u=[];for(n in l)i=s[n],r=l[n],i?(r.oldValue=i.value,r.oldArg=i.arg,Hi(r,"update",e,t),r.def&&r.def.componentUpdated&&u.push(r)):(Hi(r,"bind",e,t),r.def&&r.def.inserted&&c.push(r));if(c.length){var d=function(){for(var n=0;n<c.length;n++)Hi(c[n],"inserted",e,t)};o?Ee(e,"insert",d):d()}u.length&&Ee(e,"postpatch",(function(){for(var n=0;n<u.length;n++)Hi(u[n],"componentUpdated",e,t)}));if(!o)for(n in s)l[n]||Hi(s[n],"unbind",t,t,a)}(t,e)}var ji=Object.create(null);function zi(t,e){var n,i,r=Object.create(null);if(!t)return r;for(n=0;n<t.length;n++)(i=t[n]).modifiers||(i.modifiers=ji),r[Vi(i)]=i,i.def=Wt(e.$options,"directives",i.name,!0);return r}function Vi(t){return t.rawName||t.name+"."+Object.keys(t.modifiers||{}).join(".")}function Hi(t,e,n,i,r){var o=t.def&&t.def[e];if(o)try{o(n.elm,t,n,i,r)}catch(i){te(i,n.context,"directive "+t.name+" "+e+" hook")}}var Wi=[Di,Fi];function Ui(t,i){var r=i.componentOptions;if(!(n(r)&&!1===r.Ctor.options.inheritAttrs||e(t.data.attrs)&&e(i.data.attrs))){var o,a,s=i.elm,l=t.data.attrs||{},c=i.data.attrs||{};for(o in n(c.__ob__)&&(c=i.data.attrs=P({},c)),c)a=c[o],l[o]!==a&&Yi(s,o,a);for(o in(K||Z)&&c.value!==l.value&&Yi(s,"value",c.value),l)e(c[o])&&(gi(o)?s.removeAttributeNS(vi,yi(o)):hi(o)||s.removeAttribute(o))}}function Yi(t,e,n){t.tagName.indexOf("-")>-1?Qi(t,e,n):mi(e)?_i(n)?t.removeAttribute(e):(n="allowfullscreen"===e&&"EMBED"===t.tagName?"true":e,t.setAttribute(e,n)):hi(e)?t.setAttribute(e,pi(e,n)):gi(e)?_i(n)?t.removeAttributeNS(vi,yi(e)):t.setAttributeNS(vi,e,n):Qi(t,e,n)}function Qi(t,e,n){if(_i(n))t.removeAttribute(e);else{if(K&&!J&&"TEXTAREA"===t.tagName&&"placeholder"===e&&""!==n&&!t.__ieph){var i=function(e){e.stopImmediatePropagation(),t.removeEventListener("input",i)};t.addEventListener("input",i),t.__ieph=!0}t.setAttribute(e,n)}}var Gi={create:Ui,update:Ui};function Ki(t,i){var r=i.elm,o=i.data,a=t.data;if(!(e(o.staticClass)&&e(o.class)&&(e(a)||e(a.staticClass)&&e(a.class)))){var s=bi(i),l=r._transitionClasses;n(l)&&(s=ki(s,xi(l))),s!==r._prevClass&&(r.setAttribute("class",s),r._prevClass=s)}}var Ji,Zi,Xi,tr,er,nr,ir,rr={create:Ki,update:Ki},or=/[\w).+\-_$\]]/;function ar(t){var e,n,i,r,o,a=!1,s=!1,l=!1,c=!1,u=0,d=0,h=0,f=0;for(i=0;i<t.length;i++)if(n=e,e=t.charCodeAt(i),a)39===e&&92!==n&&(a=!1);else if(s)34===e&&92!==n&&(s=!1);else if(l)96===e&&92!==n&&(l=!1);else if(c)47===e&&92!==n&&(c=!1);else if(124!==e||124===t.charCodeAt(i+1)||124===t.charCodeAt(i-1)||u||d||h){switch(e){case 34:s=!0;break;case 39:a=!0;break;case 96:l=!0;break;case 40:h++;break;case 41:h--;break;case 91:d++;break;case 93:d--;break;case 123:u++;break;case 125:u--}if(47===e){for(var p=i-1,m=void 0;p>=0&&" "===(m=t.charAt(p));p--);m&&or.test(m)||(c=!0)}}else void 0===r?(f=i+1,r=t.slice(0,i).trim()):v();function v(){(o||(o=[])).push(t.slice(f,i).trim()),f=i+1}if(void 0===r?r=t.slice(0,i).trim():0!==f&&v(),o)for(i=0;i<o.length;i++)r=sr(r,o[i]);return r}function sr(t,e){var n=e.indexOf("(");if(n<0)return'_f("'+e+'")('+t+")";var i=e.slice(0,n),r=e.slice(n+1);return'_f("'+i+'")('+t+(")"!==r?","+r:r)}function lr(t,e){console.error("[Vue compiler]: "+t)}function cr(t,e){return t?t.map((function(t){return t[e]})).filter((function(t){return t})):[]}function ur(t,e,n,i,r){(t.props||(t.props=[])).push(br({name:e,value:n,dynamic:r},i)),t.plain=!1}function dr(t,e,n,i,r){(r?t.dynamicAttrs||(t.dynamicAttrs=[]):t.attrs||(t.attrs=[])).push(br({name:e,value:n,dynamic:r},i)),t.plain=!1}function hr(t,e,n,i){t.attrsMap[e]=n,t.attrsList.push(br({name:e,value:n},i))}function fr(t,e,n,i,r,o,a,s){(t.directives||(t.directives=[])).push(br({name:e,rawName:n,value:i,arg:r,isDynamicArg:o,modifiers:a},s)),t.plain=!1}function pr(t,e,n){return n?"_p("+e+',"'+t+'")':t+e}function mr(e,n,i,r,o,a,s,l){var c;r=r||t,a&&r.prevent&&r.passive&&a("passive and prevent can't be used together. Passive handler can't prevent default event.",s),r.right?l?n="("+n+")==='click'?'contextmenu':("+n+")":"click"===n&&(n="contextmenu",delete r.right):r.middle&&(l?n="("+n+")==='click'?'mouseup':("+n+")":"click"===n&&(n="mouseup")),r.capture&&(delete r.capture,n=pr("!",n,l)),r.once&&(delete r.once,n=pr("~",n,l)),r.passive&&(delete r.passive,n=pr("&",n,l)),r.native?(delete r.native,c=e.nativeEvents||(e.nativeEvents={})):c=e.events||(e.events={});var u=br({value:i.trim(),dynamic:l},s);r!==t&&(u.modifiers=r);var d=c[n];Array.isArray(d)?o?d.unshift(u):d.push(u):c[n]=d?o?[u,d]:[d,u]:u,e.plain=!1}function vr(t,e){return t.rawAttrsMap[":"+e]||t.rawAttrsMap["v-bind:"+e]||t.rawAttrsMap[e]}function gr(t,e,n){var i=yr(t,":"+e)||yr(t,"v-bind:"+e);if(null!=i)return ar(i);if(!1!==n){var r=yr(t,e);if(null!=r)return JSON.stringify(r)}}function yr(t,e,n){var i;if(null!=(i=t.attrsMap[e]))for(var r=t.attrsList,o=0,a=r.length;o<a;o++)if(r[o].name===e){r.splice(o,1);break}return n&&delete t.attrsMap[e],i}function _r(t,e){for(var n=t.attrsList,i=0,r=n.length;i<r;i++){var o=n[i];if(e.test(o.name))return n.splice(i,1),o}}function br(t,e){return e&&(null!=e.start&&(t.start=e.start),null!=e.end&&(t.end=e.end)),t}function wr(t,e,n){var i=n||{},r=i.number,o="$$v",a=o;i.trim&&(a="(typeof $$v === 'string'? $$v.trim(): $$v)"),r&&(a="_n("+a+")");var s=kr(e,a);t.model={value:"("+e+")",expression:JSON.stringify(e),callback:"function ($$v) {"+s+"}"}}function kr(t,e){var n=function(t){if(t=t.trim(),Ji=t.length,t.indexOf("[")<0||t.lastIndexOf("]")<Ji-1)return(tr=t.lastIndexOf("."))>-1?{exp:t.slice(0,tr),key:'"'+t.slice(tr+1)+'"'}:{exp:t,key:null};Zi=t,tr=er=nr=0;for(;!Cr();)Sr(Xi=xr())?Tr(Xi):91===Xi&&Mr(Xi);return{exp:t.slice(0,er),key:t.slice(er+1,nr)}}(t);return null===n.key?t+"="+e:"$set("+n.exp+", "+n.key+", "+e+")"}function xr(){return Zi.charCodeAt(++tr)}function Cr(){return tr>=Ji}function Sr(t){return 34===t||39===t}function Mr(t){var e=1;for(er=tr;!Cr();)if(Sr(t=xr()))Tr(t);else if(91===t&&e++,93===t&&e--,0===e){nr=tr;break}}function Tr(t){for(var e=t;!Cr()&&(t=xr())!==e;);}var Pr,Or="__r",Br="__c";function Er(t,e,n){var i=Pr;return function r(){null!==e.apply(null,arguments)&&Lr(t,r,n,i)}}var Ar=se&&!(tt&&Number(tt[1])<=53);function Dr(t,e,n,i){if(Ar){var r=Fn,o=e;e=o._wrapper=function(t){if(t.target===t.currentTarget||t.timeStamp>=r||t.timeStamp<=0||t.target.ownerDocument!==document)return o.apply(this,arguments)}}Pr.addEventListener(t,e,nt?{capture:n,passive:i}:n)}function Lr(t,e,n,i){(i||Pr).removeEventListener(t,e._wrapper||e,n)}function qr(t,i){if(!e(t.data.on)||!e(i.data.on)){var r=i.data.on||{},o=t.data.on||{};Pr=i.elm,function(t){if(n(t[Or])){var e=K?"change":"input";t[e]=[].concat(t[Or],t[e]||[]),delete t[Or]}n(t[Br])&&(t.change=[].concat(t[Br],t.change||[]),delete t[Br])}(r),Be(r,o,Dr,Lr,Er,i.context),Pr=void 0}}var Rr,Ir={create:qr,update:qr};function Nr(t,i){if(!e(t.data.domProps)||!e(i.data.domProps)){var r,o,a=i.elm,s=t.data.domProps||{},l=i.data.domProps||{};for(r in n(l.__ob__)&&(l=i.data.domProps=P({},l)),s)r in l||(a[r]="");for(r in l){if(o=l[r],"textContent"===r||"innerHTML"===r){if(i.children&&(i.children.length=0),o===s[r])continue;1===a.childNodes.length&&a.removeChild(a.childNodes[0])}if("value"===r&&"PROGRESS"!==a.tagName){a._value=o;var c=e(o)?"":String(o);Fr(a,c)&&(a.value=c)}else if("innerHTML"===r&&Mi(a.tagName)&&e(a.innerHTML)){(Rr=Rr||document.createElement("div")).innerHTML="<svg>"+o+"</svg>";for(var u=Rr.firstChild;a.firstChild;)a.removeChild(a.firstChild);for(;u.firstChild;)a.appendChild(u.firstChild)}else if(o!==s[r])try{a[r]=o}catch(t){}}}}function Fr(t,e){return!t.composing&&("OPTION"===t.tagName||function(t,e){var n=!0;try{n=document.activeElement!==t}catch(t){}return n&&t.value!==e}(t,e)||function(t,e){var i=t.value,r=t._vModifiers;if(n(r)){if(r.number)return f(i)!==f(e);if(r.trim)return i.trim()!==e.trim()}return i!==e}(t,e))}var $r={create:Nr,update:Nr},jr=b((function(t){var e={},n=/:(.+)/;return t.split(/;(?![^(]*\))/g).forEach((function(t){if(t){var i=t.split(n);i.length>1&&(e[i[0].trim()]=i[1].trim())}})),e}));function zr(t){var e=Vr(t.style);return t.staticStyle?P(t.staticStyle,e):e}function Vr(t){return Array.isArray(t)?O(t):"string"==typeof t?jr(t):t}var Hr,Wr=/^--/,Ur=/\s*!important$/,Yr=function(t,e,n){if(Wr.test(e))t.style.setProperty(e,n);else if(Ur.test(n))t.style.setProperty(S(e),n.replace(Ur,""),"important");else{var i=Gr(e);if(Array.isArray(n))for(var r=0,o=n.length;r<o;r++)t.style[i]=n[r];else t.style[i]=n}},Qr=["Webkit","Moz","ms"],Gr=b((function(t){if(Hr=Hr||document.createElement("div").style,"filter"!==(t=k(t))&&t in Hr)return t;for(var e=t.charAt(0).toUpperCase()+t.slice(1),n=0;n<Qr.length;n++){var i=Qr[n]+e;if(i in Hr)return i}}));function Kr(t,i){var r=i.data,o=t.data;if(!(e(r.staticStyle)&&e(r.style)&&e(o.staticStyle)&&e(o.style))){var a,s,l=i.elm,c=o.staticStyle,u=o.normalizedStyle||o.style||{},d=c||u,h=Vr(i.data.style)||{};i.data.normalizedStyle=n(h.__ob__)?P({},h):h;var f=function(t,e){var n,i={};if(e)for(var r=t;r.componentInstance;)(r=r.componentInstance._vnode)&&r.data&&(n=zr(r.data))&&P(i,n);(n=zr(t.data))&&P(i,n);for(var o=t;o=o.parent;)o.data&&(n=zr(o.data))&&P(i,n);return i}(i,!0);for(s in d)e(f[s])&&Yr(l,s,"");for(s in f)(a=f[s])!==d[s]&&Yr(l,s,null==a?"":a)}}var Jr={create:Kr,update:Kr},Zr=/\s+/;function Xr(t,e){if(e&&(e=e.trim()))if(t.classList)e.indexOf(" ")>-1?e.split(Zr).forEach((function(e){return t.classList.add(e)})):t.classList.add(e);else{var n=" "+(t.getAttribute("class")||"")+" ";n.indexOf(" "+e+" ")<0&&t.setAttribute("class",(n+e).trim())}}function to(t,e){if(e&&(e=e.trim()))if(t.classList)e.indexOf(" ")>-1?e.split(Zr).forEach((function(e){return t.classList.remove(e)})):t.classList.remove(e),t.classList.length||t.removeAttribute("class");else{for(var n=" "+(t.getAttribute("class")||"")+" ",i=" "+e+" ";n.indexOf(i)>=0;)n=n.replace(i," ");(n=n.trim())?t.setAttribute("class",n):t.removeAttribute("class")}}function eo(t){if(t){if("object"==typeof t){var e={};return!1!==t.css&&P(e,no(t.name||"v")),P(e,t),e}return"string"==typeof t?no(t):void 0}}var no=b((function(t){return{enterClass:t+"-enter",enterToClass:t+"-enter-to",enterActiveClass:t+"-enter-active",leaveClass:t+"-leave",leaveToClass:t+"-leave-to",leaveActiveClass:t+"-leave-active"}})),io=U&&!J,ro="transition",oo="animation",ao="transition",so="transitionend",lo="animation",co="animationend";io&&(void 0===window.ontransitionend&&void 0!==window.onwebkittransitionend&&(ao="WebkitTransition",so="webkitTransitionEnd"),void 0===window.onanimationend&&void 0!==window.onwebkitanimationend&&(lo="WebkitAnimation",co="webkitAnimationEnd"));var uo=U?window.requestAnimationFrame?window.requestAnimationFrame.bind(window):setTimeout:function(t){return t()};function ho(t){uo((function(){uo(t)}))}function fo(t,e){var n=t._transitionClasses||(t._transitionClasses=[]);n.indexOf(e)<0&&(n.push(e),Xr(t,e))}function po(t,e){t._transitionClasses&&g(t._transitionClasses,e),to(t,e)}function mo(t,e,n){var i=go(t,e),r=i.type,o=i.timeout,a=i.propCount;if(!r)return n();var s=r===ro?so:co,l=0,c=function(){t.removeEventListener(s,u),n()},u=function(e){e.target===t&&++l>=a&&c()};setTimeout((function(){l<a&&c()}),o+1),t.addEventListener(s,u)}var vo=/\b(transform|all)(,|$)/;function go(t,e){var n,i=window.getComputedStyle(t),r=(i[ao+"Delay"]||"").split(", "),o=(i[ao+"Duration"]||"").split(", "),a=yo(r,o),s=(i[lo+"Delay"]||"").split(", "),l=(i[lo+"Duration"]||"").split(", "),c=yo(s,l),u=0,d=0;return e===ro?a>0&&(n=ro,u=a,d=o.length):e===oo?c>0&&(n=oo,u=c,d=l.length):d=(n=(u=Math.max(a,c))>0?a>c?ro:oo:null)?n===ro?o.length:l.length:0,{type:n,timeout:u,propCount:d,hasTransform:n===ro&&vo.test(i[ao+"Property"])}}function yo(t,e){for(;t.length<e.length;)t=t.concat(t);return Math.max.apply(null,e.map((function(e,n){return _o(e)+_o(t[n])})))}function _o(t){return 1e3*Number(t.slice(0,-1).replace(",","."))}function bo(t,i){var r=t.elm;n(r._leaveCb)&&(r._leaveCb.cancelled=!0,r._leaveCb());var a=eo(t.data.transition);if(!e(a)&&!n(r._enterCb)&&1===r.nodeType){for(var s=a.css,l=a.type,c=a.enterClass,u=a.enterToClass,d=a.enterActiveClass,h=a.appearClass,p=a.appearToClass,m=a.appearActiveClass,v=a.beforeEnter,g=a.enter,y=a.afterEnter,_=a.enterCancelled,b=a.beforeAppear,w=a.appear,k=a.afterAppear,x=a.appearCancelled,C=a.duration,S=Cn,M=Cn.$vnode;M&&M.parent;)S=M.context,M=M.parent;var T=!S._isMounted||!t.isRootInsert;if(!T||w||""===w){var P=T&&h?h:c,O=T&&m?m:d,B=T&&p?p:u,E=T&&b||v,A=T&&"function"==typeof w?w:g,D=T&&k||y,L=T&&x||_,R=f(o(C)?C.enter:C);null!=R&&ko(R,"enter",t);var I=!1!==s&&!J,N=Co(A),F=r._enterCb=q((function(){I&&(po(r,B),po(r,O)),F.cancelled?(I&&po(r,P),L&&L(r)):D&&D(r),r._enterCb=null}));t.data.show||Ee(t,"insert",(function(){var e=r.parentNode,n=e&&e._pending&&e._pending[t.key];n&&n.tag===t.tag&&n.elm._leaveCb&&n.elm._leaveCb(),A&&A(r,F)})),E&&E(r),I&&(fo(r,P),fo(r,O),ho((function(){po(r,P),F.cancelled||(fo(r,B),N||(xo(R)?setTimeout(F,R):mo(r,l,F)))}))),t.data.show&&(i&&i(),A&&A(r,F)),I||N||F()}}}function wo(t,i){var r=t.elm;n(r._enterCb)&&(r._enterCb.cancelled=!0,r._enterCb());var a=eo(t.data.transition);if(e(a)||1!==r.nodeType)return i();if(!n(r._leaveCb)){var s=a.css,l=a.type,c=a.leaveClass,u=a.leaveToClass,d=a.leaveActiveClass,h=a.beforeLeave,p=a.leave,m=a.afterLeave,v=a.leaveCancelled,g=a.delayLeave,y=a.duration,_=!1!==s&&!J,b=Co(p),w=f(o(y)?y.leave:y);n(w)&&ko(w,"leave",t);var k=r._leaveCb=q((function(){r.parentNode&&r.parentNode._pending&&(r.parentNode._pending[t.key]=null),_&&(po(r,u),po(r,d)),k.cancelled?(_&&po(r,c),v&&v(r)):(i(),m&&m(r)),r._leaveCb=null}));g?g(x):x()}function x(){k.cancelled||(!t.data.show&&r.parentNode&&((r.parentNode._pending||(r.parentNode._pending={}))[t.key]=t),h&&h(r),_&&(fo(r,c),fo(r,d),ho((function(){po(r,c),k.cancelled||(fo(r,u),b||(xo(w)?setTimeout(k,w):mo(r,l,k)))}))),p&&p(r,k),_||b||k())}}function ko(t,e,n){"number"!=typeof t?ct("<transition> explicit "+e+" duration is not a valid number - got "+JSON.stringify(t)+".",n.context):isNaN(t)&&ct("<transition> explicit "+e+" duration is NaN - the duration expression might be incorrect.",n.context)}function xo(t){return"number"==typeof t&&!isNaN(t)}function Co(t){if(e(t))return!1;var i=t.fns;return n(i)?Co(Array.isArray(i)?i[0]:i):(t._length||t.length)>1}function So(t,e){!0!==e.data.show&&bo(e)}var Mo=function(t){var o,a,s={},l=t.modules,u=t.nodeOps;for(o=0;o<Ri.length;++o)for(s[Ri[o]]=[],a=0;a<l.length;++a)n(l[a][Ri[o]])&&s[Ri[o]].push(l[a][Ri[o]]);function d(t){var e=u.parentNode(t);n(e)&&u.removeChild(e,t)}function h(t,e){return!e&&!t.ns&&!(F.ignoredElements.length&&F.ignoredElements.some((function(e){return c(e)?e.test(t.tag):e===t.tag})))&&F.isUnknownElement(t.tag)}var f=0;function m(t,e,r,o,a,l,c){if(n(t.elm)&&n(l)&&(t=l[c]=Ct(t)),t.isRootInsert=!a,!function(t,e,r,o){var a=t.data;if(n(a)){var l=n(t.componentInstance)&&a.keepAlive;if(n(a=a.hook)&&n(a=a.init)&&a(t,!1),n(t.componentInstance))return v(t,e),g(r,t.elm,o),i(l)&&function(t,e,i,r){var o,a=t;for(;a.componentInstance;)if(n(o=(a=a.componentInstance._vnode).data)&&n(o=o.transition)){for(o=0;o<s.activate.length;++o)s.activate[o](qi,a);e.push(a);break}g(i,t.elm,r)}(t,e,r,o),!0}}(t,e,r,o)){var d=t.data,p=t.children,m=t.tag;n(m)?(d&&d.pre&&f++,h(t,f)&&ct("Unknown custom element: <"+m+'> - did you register the component correctly? For recursive components, make sure to provide the "name" option.',t.context),t.elm=t.ns?u.createElementNS(t.ns,m):u.createElement(m,t),w(t),y(t,p,e),n(d)&&b(t,e),g(r,t.elm,o),d&&d.pre&&f--):i(t.isComment)?(t.elm=u.createComment(t.text),g(r,t.elm,o)):(t.elm=u.createTextNode(t.text),g(r,t.elm,o))}}function v(t,e){n(t.data.pendingInsert)&&(e.push.apply(e,t.data.pendingInsert),t.data.pendingInsert=null),t.elm=t.componentInstance.$el,_(t)?(b(t,e),w(t)):(Li(t),e.push(t))}function g(t,e,i){n(t)&&(n(i)?u.parentNode(i)===t&&u.insertBefore(t,e,i):u.appendChild(t,e))}function y(t,e,n){if(Array.isArray(e)){M(e);for(var i=0;i<e.length;++i)m(e[i],n,t.elm,null,!0,e,i)}else r(t.text)&&u.appendChild(t.elm,u.createTextNode(String(t.text)))}function _(t){for(;t.componentInstance;)t=t.componentInstance._vnode;return n(t.tag)}function b(t,e){for(var i=0;i<s.create.length;++i)s.create[i](qi,t);n(o=t.data.hook)&&(n(o.create)&&o.create(qi,t),n(o.insert)&&e.push(t))}function w(t){var e;if(n(e=t.fnScopeId))u.setStyleScope(t.elm,e);else for(var i=t;i;)n(e=i.context)&&n(e=e.$options._scopeId)&&u.setStyleScope(t.elm,e),i=i.parent;n(e=Cn)&&e!==t.context&&e!==t.fnContext&&n(e=e.$options._scopeId)&&u.setStyleScope(t.elm,e)}function k(t,e,n,i,r,o){for(;i<=r;++i)m(n[i],o,t,e,!1,n,i)}function x(t){var e,i,r=t.data;if(n(r))for(n(e=r.hook)&&n(e=e.destroy)&&e(t),e=0;e<s.destroy.length;++e)s.destroy[e](t);if(n(e=t.children))for(i=0;i<t.children.length;++i)x(t.children[i])}function C(t,e,i){for(;e<=i;++e){var r=t[e];n(r)&&(n(r.tag)?(S(r),x(r)):d(r.elm))}}function S(t,e){if(n(e)||n(t.data)){var i,r=s.remove.length+1;for(n(e)?e.listeners+=r:e=function(t,e){function n(){0==--n.listeners&&d(t)}return n.listeners=e,n}(t.elm,r),n(i=t.componentInstance)&&n(i=i._vnode)&&n(i.data)&&S(i,e),i=0;i<s.remove.length;++i)s.remove[i](t,e);n(i=t.data.hook)&&n(i=i.remove)?i(t,e):e()}else d(t.elm)}function M(t){for(var e={},i=0;i<t.length;i++){var r=t[i],o=r.key;n(o)&&(e[o]?ct("Duplicate keys detected: '"+o+"'. This may cause an update error.",r.context):e[o]=!0)}}function T(t,e,i,r){for(var o=i;o<r;o++){var a=e[o];if(n(a)&&Ii(t,a))return o}}function P(t,r,o,a,l,c){if(t!==r){n(r.elm)&&n(a)&&(r=a[l]=Ct(r));var d=r.elm=t.elm;if(i(t.isAsyncPlaceholder))n(r.asyncFactory.resolved)?A(t.elm,r,o):r.isAsyncPlaceholder=!0;else if(i(r.isStatic)&&i(t.isStatic)&&r.key===t.key&&(i(r.isCloned)||i(r.isOnce)))r.componentInstance=t.componentInstance;else{var h,f=r.data;n(f)&&n(h=f.hook)&&n(h=h.prepatch)&&h(t,r);var p=t.children,v=r.children;if(n(f)&&_(r)){for(h=0;h<s.update.length;++h)s.update[h](t,r);n(h=f.hook)&&n(h=h.update)&&h(t,r)}e(r.text)?n(p)&&n(v)?p!==v&&function(t,i,r,o,a){var s,l,c,d=0,h=0,f=i.length-1,p=i[0],v=i[f],g=r.length-1,y=r[0],_=r[g],b=!a;for(M(r);d<=f&&h<=g;)e(p)?p=i[++d]:e(v)?v=i[--f]:Ii(p,y)?(P(p,y,o,r,h),p=i[++d],y=r[++h]):Ii(v,_)?(P(v,_,o,r,g),v=i[--f],_=r[--g]):Ii(p,_)?(P(p,_,o,r,g),b&&u.insertBefore(t,p.elm,u.nextSibling(v.elm)),p=i[++d],_=r[--g]):Ii(v,y)?(P(v,y,o,r,h),b&&u.insertBefore(t,v.elm,p.elm),v=i[--f],y=r[++h]):(e(s)&&(s=Ni(i,d,f)),e(l=n(y.key)?s[y.key]:T(y,i,d,f))?m(y,o,t,p.elm,!1,r,h):Ii(c=i[l],y)?(P(c,y,o,r,h),i[l]=void 0,b&&u.insertBefore(t,c.elm,p.elm)):m(y,o,t,p.elm,!1,r,h),y=r[++h]);d>f?k(t,e(r[g+1])?null:r[g+1].elm,r,h,g,o):h>g&&C(i,d,f)}(d,p,v,o,c):n(v)?(M(v),n(t.text)&&u.setTextContent(d,""),k(d,null,v,0,v.length-1,o)):n(p)?C(p,0,p.length-1):n(t.text)&&u.setTextContent(d,""):t.text!==r.text&&u.setTextContent(d,r.text),n(f)&&n(h=f.hook)&&n(h=h.postpatch)&&h(t,r)}}}function O(t,e,r){if(i(r)&&n(t.parent))t.parent.data.pendingInsert=e;else for(var o=0;o<e.length;++o)e[o].data.hook.insert(e[o])}var B=!1,E=p("attrs,class,staticClass,staticStyle,key");function A(t,e,r,o){var a,s=e.tag,l=e.data,c=e.children;if(o=o||l&&l.pre,e.elm=t,i(e.isComment)&&n(e.asyncFactory))return e.isAsyncPlaceholder=!0,!0;if(!function(t,e,i){return n(e.tag)?0===e.tag.indexOf("vue-component")||!h(e,i)&&e.tag.toLowerCase()===(t.tagName&&t.tagName.toLowerCase()):t.nodeType===(e.isComment?8:3)}(t,e,o))return!1;if(n(l)&&(n(a=l.hook)&&n(a=a.init)&&a(e,!0),n(a=e.componentInstance)))return v(e,r),!0;if(n(s)){if(n(c))if(t.hasChildNodes())if(n(a=l)&&n(a=a.domProps)&&n(a=a.innerHTML)){if(a!==t.innerHTML)return"undefined"==typeof console||B||(B=!0,console.warn("Parent: ",t),console.warn("server innerHTML: ",a),console.warn("client innerHTML: ",t.innerHTML)),!1}else{for(var u=!0,d=t.firstChild,f=0;f<c.length;f++){if(!d||!A(d,c[f],r,o)){u=!1;break}d=d.nextSibling}if(!u||d)return"undefined"==typeof console||B||(B=!0,console.warn("Parent: ",t),console.warn("Mismatching childNodes vs. VNodes: ",t.childNodes,c)),!1}else y(e,c,r);if(n(l)){var p=!1;for(var m in l)if(!E(m)){p=!0,b(e,r);break}!p&&l.class&&Me(l.class)}}else t.data!==e.text&&(t.data=e.text);return!0}return function(t,r,o,a){if(!e(r)){var l,c=!1,d=[];if(e(t))c=!0,m(r,d);else{var h=n(t.nodeType);if(!h&&Ii(t,r))P(t,r,d,null,null,a);else{if(h){if(1===t.nodeType&&t.hasAttribute(R)&&(t.removeAttribute(R),o=!0),i(o)){if(A(t,r,d))return O(r,d,!0),t;ct("The client-side rendered virtual DOM tree is not matching server-rendered content. This is likely caused by incorrect HTML markup, for example nesting block-level elements inside <p>, or missing <tbody>. Bailing hydration and performing full client-side render.")}l=t,t=new bt(u.tagName(l).toLowerCase(),{},[],void 0,l)}var f=t.elm,p=u.parentNode(f);if(m(r,d,f._leaveCb?null:p,u.nextSibling(f)),n(r.parent))for(var v=r.parent,g=_(r);v;){for(var y=0;y<s.destroy.length;++y)s.destroy[y](v);if(v.elm=r.elm,g){for(var b=0;b<s.create.length;++b)s.create[b](qi,v);var w=v.data.hook.insert;if(w.merged)for(var k=1;k<w.fns.length;k++)w.fns[k]()}else Li(v);v=v.parent}n(p)?C([t],0,0):n(t.tag)&&x(t)}}return O(r,d,c),r.elm}n(t)&&x(t)}}({nodeOps:Ai,modules:[Gi,rr,Ir,$r,Jr,U?{create:So,activate:So,remove:function(t,e){!0!==t.data.show?wo(t,e):e()}}:{}].concat(Wi)});J&&document.addEventListener("selectionchange",(function(){var t=document.activeElement;t&&t.vmodel&&Lo(t,"input")}));var To={inserted:function(t,e,n,i){"select"===n.tag?(i.elm&&!i.elm._vOptions?Ee(n,"postpatch",(function(){To.componentUpdated(t,e,n)})):Po(t,e,n.context),t._vOptions=[].map.call(t.options,Eo)):("textarea"===n.tag||Bi(t.type))&&(t._vModifiers=e.modifiers,e.modifiers.lazy||(t.addEventListener("compositionstart",Ao),t.addEventListener("compositionend",Do),t.addEventListener("change",Do),J&&(t.vmodel=!0)))},componentUpdated:function(t,e,n){if("select"===n.tag){Po(t,e,n.context);var i=t._vOptions,r=t._vOptions=[].map.call(t.options,Eo);if(r.some((function(t,e){return!D(t,i[e])})))(t.multiple?e.value.some((function(t){return Bo(t,r)})):e.value!==e.oldValue&&Bo(e.value,r))&&Lo(t,"change")}}};function Po(t,e,n){Oo(t,e,n),(K||Z)&&setTimeout((function(){Oo(t,e,n)}),0)}function Oo(t,e,n){var i=e.value,r=t.multiple;if(!r||Array.isArray(i)){for(var o,a,s=0,l=t.options.length;s<l;s++)if(a=t.options[s],r)o=L(i,Eo(a))>-1,a.selected!==o&&(a.selected=o);else if(D(Eo(a),i))return void(t.selectedIndex!==s&&(t.selectedIndex=s));r||(t.selectedIndex=-1)}else ct('<select multiple v-model="'+e.expression+'"> expects an Array value for its binding, but got '+Object.prototype.toString.call(i).slice(8,-1),n)}function Bo(t,e){return e.every((function(e){return!D(e,t)}))}function Eo(t){return"_value"in t?t._value:t.value}function Ao(t){t.target.composing=!0}function Do(t){t.target.composing&&(t.target.composing=!1,Lo(t.target,"input"))}function Lo(t,e){var n=document.createEvent("HTMLEvents");n.initEvent(e,!0,!0),t.dispatchEvent(n)}function qo(t){return!t.componentInstance||t.data&&t.data.transition?t:qo(t.componentInstance._vnode)}var Ro={bind:function(t,e,n){var i=e.value,r=(n=qo(n)).data&&n.data.transition,o=t.__vOriginalDisplay="none"===t.style.display?"":t.style.display;i&&r?(n.data.show=!0,bo(n,(function(){t.style.display=o}))):t.style.display=i?o:"none"},update:function(t,e,n){var i=e.value;!i!=!e.oldValue&&((n=qo(n)).data&&n.data.transition?(n.data.show=!0,i?bo(n,(function(){t.style.display=t.__vOriginalDisplay})):wo(n,(function(){t.style.display="none"}))):t.style.display=i?t.__vOriginalDisplay:"none")},unbind:function(t,e,n,i,r){r||(t.style.display=t.__vOriginalDisplay)}},Io={model:To,show:Ro},No={name:String,appear:Boolean,css:Boolean,mode:String,type:String,enterClass:String,leaveClass:String,enterToClass:String,leaveToClass:String,enterActiveClass:String,leaveActiveClass:String,appearClass:String,appearActiveClass:String,appearToClass:String,duration:[Number,String,Object]};function Fo(t){var e=t&&t.componentOptions;return e&&e.Ctor.options.abstract?Fo(_n(e.children)):t}function $o(t){var e={},n=t.$options;for(var i in n.propsData)e[i]=t[i];var r=n._parentListeners;for(var o in r)e[k(o)]=r[o];return e}function jo(t,e){if(/\d-keep-alive$/.test(e.tag))return t("keep-alive",{props:e.componentOptions.propsData})}var zo=function(t){return t.tag||yn(t)},Vo=function(t){return"show"===t.name},Ho={name:"transition",props:No,abstract:!0,render:function(t){var e=this,n=this.$slots.default;if(n&&(n=n.filter(zo)).length){n.length>1&&ct("<transition> can only be used on a single element. Use <transition-group> for lists.",this.$parent);var i=this.mode;i&&"in-out"!==i&&"out-in"!==i&&ct("invalid <transition> mode: "+i,this.$parent);var o=n[0];if(function(t){for(;t=t.parent;)if(t.data.transition)return!0}(this.$vnode))return o;var a=Fo(o);if(!a)return o;if(this._leaving)return jo(t,o);var s="__transition-"+this._uid+"-";a.key=null==a.key?a.isComment?s+"comment":s+a.tag:r(a.key)?0===String(a.key).indexOf(s)?a.key:s+a.key:a.key;var l=(a.data||(a.data={})).transition=$o(this),c=this._vnode,u=Fo(c);if(a.data.directives&&a.data.directives.some(Vo)&&(a.data.show=!0),u&&u.data&&!function(t,e){return e.key===t.key&&e.tag===t.tag}(a,u)&&!yn(u)&&(!u.componentInstance||!u.componentInstance._vnode.isComment)){var d=u.data.transition=P({},l);if("out-in"===i)return this._leaving=!0,Ee(d,"afterLeave",(function(){e._leaving=!1,e.$forceUpdate()})),jo(t,o);if("in-out"===i){if(yn(a))return c;var h,f=function(){h()};Ee(l,"afterEnter",f),Ee(l,"enterCancelled",f),Ee(d,"delayLeave",(function(t){h=t}))}}return o}}},Wo=P({tag:String,moveClass:String},No);delete Wo.mode;var Uo={props:Wo,beforeMount:function(){var t=this,e=this._update;this._update=function(n,i){var r=Mn(t);t.__patch__(t._vnode,t.kept,!1,!0),t._vnode=t.kept,r(),e.call(t,n,i)}},render:function(t){for(var e=this.tag||this.$vnode.data.tag||"span",n=Object.create(null),i=this.prevChildren=this.children,r=this.$slots.default||[],o=this.children=[],a=$o(this),s=0;s<r.length;s++){var l=r[s];if(l.tag)if(null!=l.key&&0!==String(l.key).indexOf("__vlist"))o.push(l),n[l.key]=l,(l.data||(l.data={})).transition=a;else{var c=l.componentOptions,u=c?c.Ctor.options.name||c.tag||"":l.tag;ct("<transition-group> children must be keyed: <"+u+">")}}if(i){for(var d=[],h=[],f=0;f<i.length;f++){var p=i[f];p.data.transition=a,p.data.pos=p.elm.getBoundingClientRect(),n[p.key]?d.push(p):h.push(p)}this.kept=t(e,null,d),this.removed=h}return t(e,null,o)},updated:function(){var t=this.prevChildren,e=this.moveClass||(this.name||"v")+"-move";t.length&&this.hasMove(t[0].elm,e)&&(t.forEach(Yo),t.forEach(Qo),t.forEach(Go),this._reflow=document.body.offsetHeight,t.forEach((function(t){if(t.data.moved){var n=t.elm,i=n.style;fo(n,e),i.transform=i.WebkitTransform=i.transitionDuration="",n.addEventListener(so,n._moveCb=function t(i){i&&i.target!==n||i&&!/transform$/.test(i.propertyName)||(n.removeEventListener(so,t),n._moveCb=null,po(n,e))})}})))},methods:{hasMove:function(t,e){if(!io)return!1;if(this._hasMove)return this._hasMove;var n=t.cloneNode();t._transitionClasses&&t._transitionClasses.forEach((function(t){to(n,t)})),Xr(n,e),n.style.display="none",this.$el.appendChild(n);var i=go(n);return this.$el.removeChild(n),this._hasMove=i.hasTransform}}};function Yo(t){t.elm._moveCb&&t.elm._moveCb(),t.elm._enterCb&&t.elm._enterCb()}function Qo(t){t.data.newPos=t.elm.getBoundingClientRect()}function Go(t){var e=t.data.pos,n=t.data.newPos,i=e.left-n.left,r=e.top-n.top;if(i||r){t.data.moved=!0;var o=t.elm.style;o.transform=o.WebkitTransform="translate("+i+"px,"+r+"px)",o.transitionDuration="0s"}}var Ko={Transition:Ho,TransitionGroup:Uo};ei.config.mustUseProp=di,ei.config.isReservedTag=Ti,ei.config.isReservedAttr=ci,ei.config.getTagNamespace=Pi,ei.config.isUnknownElement=function(t){if(!U)return!0;if(Ti(t))return!1;if(t=t.toLowerCase(),null!=Oi[t])return Oi[t];var e=document.createElement(t);return t.indexOf("-")>-1?Oi[t]=e.constructor===window.HTMLUnknownElement||e.constructor===window.HTMLElement:Oi[t]=/HTMLUnknownElement/.test(e.toString())},P(ei.options.directives,Io),P(ei.options.components,Ko),ei.prototype.__patch__=U?Mo:B,ei.prototype.$mount=function(t,e){return function(t,e,n){var i;return t.$el=e,t.$options.render||(t.$options.render=kt,t.$options.template&&"#"!==t.$options.template.charAt(0)||t.$options.el||e?ct("You are using the runtime-only build of Vue where the template compiler is not available. Either pre-compile the templates into render functions, or use the compiler-included build.",t):ct("Failed to mount component: template or render function not defined.",t)),Bn(t,"beforeMount"),i=F.performance&&oe?function(){var e=t._name,i=t._uid,r="vue-perf-start:"+i,o="vue-perf-end:"+i;oe(r);var a=t._render();oe(o),ae("vue "+e+" render",r,o),oe(r),t._update(a,n),oe(o),ae("vue "+e+" patch",r,o)}:function(){t._update(t._render(),n)},new Hn(t,i,B,{before:function(){t._isMounted&&!t._isDestroyed&&Bn(t,"beforeUpdate")}},!0),n=!1,null==t.$vnode&&(t._isMounted=!0,Bn(t,"mounted")),t}(this,t=t&&U?Ei(t):void 0,e)},U&&setTimeout((function(){F.devtools&&(ot?ot.emit("init",ei):console[console.info?"info":"log"]("Download the Vue Devtools extension for a better development experience:\nhttps://github.com/vuejs/vue-devtools")),!1!==F.productionTip&&"undefined"!=typeof console&&console[console.info?"info":"log"]("You are running Vue in development mode.\nMake sure to turn on production mode when deploying for production.\nSee more tips at https://vuejs.org/guide/deployment.html")}),0);var Jo=/\{\{((?:.|\r?\n)+?)\}\}/g,Zo=/[-.*+?^${}()|[\]\/\\]/g,Xo=b((function(t){var e=t[0].replace(Zo,"\\$&"),n=t[1].replace(Zo,"\\$&");return new RegExp(e+"((?:.|\\n)+?)"+n,"g")}));function ta(t,e){var n=e?Xo(e):Jo;if(n.test(t)){for(var i,r,o,a=[],s=[],l=n.lastIndex=0;i=n.exec(t);){(r=i.index)>l&&(s.push(o=t.slice(l,r)),a.push(JSON.stringify(o)));var c=ar(i[1].trim());a.push("_s("+c+")"),s.push({"@binding":c}),l=r+i[0].length}return l<t.length&&(s.push(o=t.slice(l)),a.push(JSON.stringify(o))),{expression:a.join("+"),tokens:s}}}var ea={staticKeys:["staticClass"],transformNode:function(t,e){var n=e.warn||lr,i=yr(t,"class");i&&ta(i,e.delimiters)&&n('class="'+i+'": Interpolation inside attributes has been removed. Use v-bind or the colon shorthand instead. For example, instead of <div class="{{ val }}">, use <div :class="val">.',t.rawAttrsMap.class),i&&(t.staticClass=JSON.stringify(i));var r=gr(t,"class",!1);r&&(t.classBinding=r)},genData:function(t){var e="";return t.staticClass&&(e+="staticClass:"+t.staticClass+","),t.classBinding&&(e+="class:"+t.classBinding+","),e}};var na,ia={staticKeys:["staticStyle"],transformNode:function(t,e){var n=e.warn||lr,i=yr(t,"style");i&&(ta(i,e.delimiters)&&n('style="'+i+'": Interpolation inside attributes has been removed. Use v-bind or the colon shorthand instead. For example, instead of <div style="{{ val }}">, use <div :style="val">.',t.rawAttrsMap.style),t.staticStyle=JSON.stringify(jr(i)));var r=gr(t,"style",!1);r&&(t.styleBinding=r)},genData:function(t){var e="";return t.staticStyle&&(e+="staticStyle:"+t.staticStyle+","),t.styleBinding&&(e+="style:("+t.styleBinding+"),"),e}},ra=function(t){return(na=na||document.createElement("div")).innerHTML=t,na.textContent},oa=p("area,base,br,col,embed,frame,hr,img,input,isindex,keygen,link,meta,param,source,track,wbr"),aa=p("colgroup,dd,dt,li,options,p,td,tfoot,th,thead,tr,source"),sa=p("address,article,aside,base,blockquote,body,caption,col,colgroup,dd,details,dialog,div,dl,dt,fieldset,figcaption,figure,footer,form,h1,h2,h3,h4,h5,h6,head,header,hgroup,hr,html,legend,li,menuitem,meta,optgroup,option,param,rp,rt,source,style,summary,tbody,td,tfoot,th,thead,title,tr,track"),la=/^\s*([^\s"'<>\/=]+)(?:\s*(=)\s*(?:"([^"]*)"+|'([^']*)'+|([^\s"'=<>`]+)))?/,ca=/^\s*((?:v-[\w-]+:|@|:|#)\[[^=]+\][^\s"'<>\/=]*)(?:\s*(=)\s*(?:"([^"]*)"+|'([^']*)'+|([^\s"'=<>`]+)))?/,ua="[a-zA-Z_][\\-\\.0-9_a-zA-Z"+$.source+"]*",da="((?:"+ua+"\\:)?"+ua+")",ha=new RegExp("^<"+da),fa=/^\s*(\/?)>/,pa=new RegExp("^<\\/"+da+"[^>]*>"),ma=/^<!DOCTYPE [^>]+>/i,va=/^<!\--/,ga=/^<!\[/,ya=p("script,style,textarea",!0),_a={},ba={"&lt;":"<","&gt;":">","&quot;":'"',"&amp;":"&","&#10;":"\n","&#9;":"\t","&#39;":"'"},wa=/&(?:lt|gt|quot|amp|#39);/g,ka=/&(?:lt|gt|quot|amp|#39|#10|#9);/g,xa=p("pre,textarea",!0),Ca=function(t,e){return t&&xa(t)&&"\n"===e[0]};function Sa(t,e){var n=e?ka:wa;return t.replace(n,(function(t){return ba[t]}))}var Ma,Ta,Pa,Oa,Ba,Ea,Aa,Da,La,qa=/^@|^v-on:/,Ra=/^v-|^@|^:|^#/,Ia=/([\s\S]*?)\s+(?:in|of)\s+([\s\S]*)/,Na=/,([^,\}\]]*)(?:,([^,\}\]]*))?$/,Fa=/^\(|\)$/g,$a=/^\[.*\]$/,ja=/:(.*)$/,za=/^:|^\.|^v-bind:/,Va=/\.[^.\]]+(?=[^\]]*$)/g,Ha=/^v-slot(:|$)|^#/,Wa=/[\r\n]/,Ua=/\s+/g,Ya=/[\s"'<>\/=]/,Qa=b(ra),Ga="_empty_";function Ka(t,e,n){return{type:1,tag:t,attrsList:e,attrsMap:is(e),rawAttrsMap:{},parent:n,children:[]}}function Ja(t,e){Ma=e.warn||lr,Ea=e.isPreTag||E,Aa=e.mustUseProp||E,Da=e.getTagNamespace||E;var n=e.isReservedTag||E;La=function(t){return!!t.component||!n(t.tag)},Pa=cr(e.modules,"transformNode"),Oa=cr(e.modules,"preTransformNode"),Ba=cr(e.modules,"postTransformNode"),Ta=e.delimiters;var i,r,o=[],a=!1!==e.preserveWhitespace,s=e.whitespace,l=!1,c=!1,u=!1;function d(t,e){u||(u=!0,Ma(t,e))}function h(t){if(f(t),l||t.processed||(t=Za(t,e)),o.length||t===i||(i.if&&(t.elseif||t.else)?(p(t),ts(i,{exp:t.elseif,block:t})):d("Component template should contain exactly one root element. If you are using v-if on multiple elements, use v-else-if to chain them instead.",{start:t.start})),r&&!t.forbidden)if(t.elseif||t.else)a=t,s=function(t){for(var e=t.length;e--;){if(1===t[e].type)return t[e];" "!==t[e].text&&Ma('text "'+t[e].text.trim()+'" between v-if and v-else(-if) will be ignored.',t[e]),t.pop()}}(r.children),s&&s.if?ts(s,{exp:a.elseif,block:a}):Ma("v-"+(a.elseif?'else-if="'+a.elseif+'"':"else")+" used on element <"+a.tag+"> without corresponding v-if.",a.rawAttrsMap[a.elseif?"v-else-if":"v-else"]);else{if(t.slotScope){var n=t.slotTarget||'"default"';(r.scopedSlots||(r.scopedSlots={}))[n]=t}r.children.push(t),t.parent=r}var a,s;t.children=t.children.filter((function(t){return!t.slotScope})),f(t),t.pre&&(l=!1),Ea(t.tag)&&(c=!1);for(var u=0;u<Ba.length;u++)Ba[u](t,e)}function f(t){if(!c)for(var e;(e=t.children[t.children.length-1])&&3===e.type&&" "===e.text;)t.children.pop()}function p(t){"slot"!==t.tag&&"template"!==t.tag||d("Cannot use <"+t.tag+"> as component root element because it may contain multiple nodes.",{start:t.start}),t.attrsMap.hasOwnProperty("v-for")&&d("Cannot use v-for on stateful component root element because it renders multiple elements.",t.rawAttrsMap["v-for"])}return function(t,e){for(var n,i,r=[],o=e.expectHTML,a=e.isUnaryTag||E,s=e.canBeLeftOpenTag||E,l=0;t;){if(n=t,i&&ya(i)){var c=0,u=i.toLowerCase(),d=_a[u]||(_a[u]=new RegExp("([\\s\\S]*?)(</"+u+"[^>]*>)","i")),h=t.replace(d,(function(t,n,i){return c=i.length,ya(u)||"noscript"===u||(n=n.replace(/<!\--([\s\S]*?)-->/g,"$1").replace(/<!\[CDATA\[([\s\S]*?)]]>/g,"$1")),Ca(u,n)&&(n=n.slice(1)),e.chars&&e.chars(n),""}));l+=t.length-h.length,t=h,M(u,l-c,l)}else{var f=t.indexOf("<");if(0===f){if(va.test(t)){var p=t.indexOf("--\x3e");if(p>=0){e.shouldKeepComment&&e.comment(t.substring(4,p),l,l+p+3),x(p+3);continue}}if(ga.test(t)){var m=t.indexOf("]>");if(m>=0){x(m+2);continue}}var v=t.match(ma);if(v){x(v[0].length);continue}var g=t.match(pa);if(g){var y=l;x(g[0].length),M(g[1],y,l);continue}var _=C();if(_){S(_),Ca(_.tagName,t)&&x(1);continue}}var b=void 0,w=void 0,k=void 0;if(f>=0){for(w=t.slice(f);!(pa.test(w)||ha.test(w)||va.test(w)||ga.test(w)||(k=w.indexOf("<",1))<0);)f+=k,w=t.slice(f);b=t.substring(0,f)}f<0&&(b=t),b&&x(b.length),e.chars&&b&&e.chars(b,l-b.length,l)}if(t===n){e.chars&&e.chars(t),!r.length&&e.warn&&e.warn('Mal-formatted tag at end of template: "'+t+'"',{start:l+t.length});break}}function x(e){l+=e,t=t.substring(e)}function C(){var e=t.match(ha);if(e){var n,i,r={tagName:e[1],attrs:[],start:l};for(x(e[0].length);!(n=t.match(fa))&&(i=t.match(ca)||t.match(la));)i.start=l,x(i[0].length),i.end=l,r.attrs.push(i);if(n)return r.unarySlash=n[1],x(n[0].length),r.end=l,r}}function S(t){var n=t.tagName,l=t.unarySlash;o&&("p"===i&&sa(n)&&M(i),s(n)&&i===n&&M(n));for(var c=a(n)||!!l,u=t.attrs.length,d=new Array(u),h=0;h<u;h++){var f=t.attrs[h],p=f[3]||f[4]||f[5]||"",m="a"===n&&"href"===f[1]?e.shouldDecodeNewlinesForHref:e.shouldDecodeNewlines;d[h]={name:f[1],value:Sa(p,m)},e.outputSourceRange&&(d[h].start=f.start+f[0].match(/^\s*/).length,d[h].end=f.end)}c||(r.push({tag:n,lowerCasedTag:n.toLowerCase(),attrs:d,start:t.start,end:t.end}),i=n),e.start&&e.start(n,d,c,t.start,t.end)}function M(t,n,o){var a,s;if(null==n&&(n=l),null==o&&(o=l),t)for(s=t.toLowerCase(),a=r.length-1;a>=0&&r[a].lowerCasedTag!==s;a--);else a=0;if(a>=0){for(var c=r.length-1;c>=a;c--)(c>a||!t&&e.warn)&&e.warn("tag <"+r[c].tag+"> has no matching end tag.",{start:r[c].start,end:r[c].end}),e.end&&e.end(r[c].tag,n,o);r.length=a,i=a&&r[a-1].tag}else"br"===s?e.start&&e.start(t,[],!0,n,o):"p"===s&&(e.start&&e.start(t,[],!1,n,o),e.end&&e.end(t,n,o))}M()}(t,{warn:Ma,expectHTML:e.expectHTML,isUnaryTag:e.isUnaryTag,canBeLeftOpenTag:e.canBeLeftOpenTag,shouldDecodeNewlines:e.shouldDecodeNewlines,shouldDecodeNewlinesForHref:e.shouldDecodeNewlinesForHref,shouldKeepComment:e.comments,outputSourceRange:e.outputSourceRange,start:function(t,n,a,s,u){var d=r&&r.ns||Da(t);K&&"svg"===d&&(n=function(t){for(var e=[],n=0;n<t.length;n++){var i=t[n];rs.test(i.name)||(i.name=i.name.replace(os,""),e.push(i))}return e}(n));var f,m=Ka(t,n,r);d&&(m.ns=d),e.outputSourceRange&&(m.start=s,m.end=u,m.rawAttrsMap=m.attrsList.reduce((function(t,e){return t[e.name]=e,t}),{})),n.forEach((function(t){Ya.test(t.name)&&Ma("Invalid dynamic argument expression: attribute names cannot contain spaces, quotes, <, >, / or =.",{start:t.start+t.name.indexOf("["),end:t.start+t.name.length})})),"style"!==(f=m).tag&&("script"!==f.tag||f.attrsMap.type&&"text/javascript"!==f.attrsMap.type)||rt()||(m.forbidden=!0,Ma("Templates should only be responsible for mapping the state to the UI. Avoid placing tags with side-effects in your templates, such as <"+t+">, as they will not be parsed.",{start:m.start}));for(var v=0;v<Oa.length;v++)m=Oa[v](m,e)||m;l||(!function(t){null!=yr(t,"v-pre")&&(t.pre=!0)}(m),m.pre&&(l=!0)),Ea(m.tag)&&(c=!0),l?function(t){var e=t.attrsList,n=e.length;if(n)for(var i=t.attrs=new Array(n),r=0;r<n;r++)i[r]={name:e[r].name,value:JSON.stringify(e[r].value)},null!=e[r].start&&(i[r].start=e[r].start,i[r].end=e[r].end);else t.pre||(t.plain=!0)}(m):m.processed||(Xa(m),function(t){var e=yr(t,"v-if");if(e)t.if=e,ts(t,{exp:e,block:t});else{null!=yr(t,"v-else")&&(t.else=!0);var n=yr(t,"v-else-if");n&&(t.elseif=n)}}(m),function(t){var e=yr(t,"v-once");null!=e&&(t.once=!0)}(m)),i||p(i=m),a?h(m):(r=m,o.push(m))},end:function(t,n,i){var a=o[o.length-1];o.length-=1,r=o[o.length-1],e.outputSourceRange&&(a.end=i),h(a)},chars:function(n,i,o){if(r){if(!K||"textarea"!==r.tag||r.attrsMap.placeholder!==n){var u,h,f,p=r.children;if(n=c||n.trim()?"script"===(u=r).tag||"style"===u.tag?n:Qa(n):p.length?s?"condense"===s&&Wa.test(n)?"":" ":a?" ":"":"")c||"condense"!==s||(n=n.replace(Ua," ")),!l&&" "!==n&&(h=ta(n,Ta))?f={type:2,expression:h.expression,tokens:h.tokens,text:n}:" "===n&&p.length&&" "===p[p.length-1].text||(f={type:3,text:n}),f&&(e.outputSourceRange&&(f.start=i,f.end=o),p.push(f))}}else n===t?d("Component template requires a root element, rather than just text.",{start:i}):(n=n.trim())&&d('text "'+n+'" outside root element will be ignored.',{start:i})},comment:function(t,n,i){if(r){var o={type:3,text:t,isComment:!0};e.outputSourceRange&&(o.start=n,o.end=i),r.children.push(o)}}}),i}function Za(t,e){var n;!function(t){var e=gr(t,"key");if(e){if("template"===t.tag&&Ma("<template> cannot be keyed. Place the key on real elements instead.",vr(t,"key")),t.for){var n=t.iterator2||t.iterator1,i=t.parent;n&&n===e&&i&&"transition-group"===i.tag&&Ma("Do not use v-for index as key on <transition-group> children, this is the same as not using keys.",vr(t,"key"),!0)}t.key=e}}(t),t.plain=!t.key&&!t.scopedSlots&&!t.attrsList.length,function(t){var e=gr(t,"ref");e&&(t.ref=e,t.refInFor=function(t){var e=t;for(;e;){if(void 0!==e.for)return!0;e=e.parent}return!1}(t))}(t),function(t){var e;"template"===t.tag?((e=yr(t,"scope"))&&Ma('the "scope" attribute for scoped slots have been deprecated and replaced by "slot-scope" since 2.5. The new "slot-scope" attribute can also be used on plain elements in addition to <template> to denote scoped slots.',t.rawAttrsMap.scope,!0),t.slotScope=e||yr(t,"slot-scope")):(e=yr(t,"slot-scope"))&&(t.attrsMap["v-for"]&&Ma("Ambiguous combined usage of slot-scope and v-for on <"+t.tag+"> (v-for takes higher priority). Use a wrapper <template> for the scoped slot to make it clearer.",t.rawAttrsMap["slot-scope"],!0),t.slotScope=e);var n=gr(t,"slot");n&&(t.slotTarget='""'===n?'"default"':n,t.slotTargetDynamic=!(!t.attrsMap[":slot"]&&!t.attrsMap["v-bind:slot"]),"template"===t.tag||t.slotScope||dr(t,"slot",n,vr(t,"slot")));if("template"===t.tag){var i=_r(t,Ha);if(i){(t.slotTarget||t.slotScope)&&Ma("Unexpected mixed usage of different slot syntaxes.",t),t.parent&&!La(t.parent)&&Ma("<template v-slot> can only appear at the root level inside the receiving component",t);var r=es(i),o=r.name,a=r.dynamic;t.slotTarget=o,t.slotTargetDynamic=a,t.slotScope=i.value||Ga}}else{var s=_r(t,Ha);if(s){La(t)||Ma("v-slot can only be used on components or <template>.",s),(t.slotScope||t.slotTarget)&&Ma("Unexpected mixed usage of different slot syntaxes.",t),t.scopedSlots&&Ma("To avoid scope ambiguity, the default slot should also use <template> syntax when there are other named slots.",s);var l=t.scopedSlots||(t.scopedSlots={}),c=es(s),u=c.name,d=c.dynamic,h=l[u]=Ka("template",[],t);h.slotTarget=u,h.slotTargetDynamic=d,h.children=t.children.filter((function(t){if(!t.slotScope)return t.parent=h,!0})),h.slotScope=s.value||Ga,t.children=[],t.plain=!1}}}(t),"slot"===(n=t).tag&&(n.slotName=gr(n,"name"),n.key&&Ma("`key` does not work on <slot> because slots are abstract outlets and can possibly expand into multiple elements. Use the key on a wrapping element instead.",vr(n,"key"))),function(t){var e;(e=gr(t,"is"))&&(t.component=e);null!=yr(t,"inline-template")&&(t.inlineTemplate=!0)}(t);for(var i=0;i<Pa.length;i++)t=Pa[i](t,e)||t;return function(t){var e,n,i,r,o,a,s,l,c=t.attrsList;for(e=0,n=c.length;e<n;e++){if(i=r=c[e].name,o=c[e].value,Ra.test(i))if(t.hasBindings=!0,(a=ns(i.replace(Ra,"")))&&(i=i.replace(Va,"")),za.test(i))i=i.replace(za,""),o=ar(o),(l=$a.test(i))&&(i=i.slice(1,-1)),0===o.trim().length&&Ma('The value for a v-bind expression cannot be empty. Found in "v-bind:'+i+'"'),a&&(a.prop&&!l&&"innerHtml"===(i=k(i))&&(i="innerHTML"),a.camel&&!l&&(i=k(i)),a.sync&&(s=kr(o,"$event"),l?mr(t,'"update:"+('+i+")",s,null,!1,Ma,c[e],!0):(mr(t,"update:"+k(i),s,null,!1,Ma,c[e]),S(i)!==k(i)&&mr(t,"update:"+S(i),s,null,!1,Ma,c[e])))),a&&a.prop||!t.component&&Aa(t.tag,t.attrsMap.type,i)?ur(t,i,o,c[e],l):dr(t,i,o,c[e],l);else if(qa.test(i))i=i.replace(qa,""),(l=$a.test(i))&&(i=i.slice(1,-1)),mr(t,i,o,a,!1,Ma,c[e],l);else{var u=(i=i.replace(Ra,"")).match(ja),d=u&&u[1];l=!1,d&&(i=i.slice(0,-(d.length+1)),$a.test(d)&&(d=d.slice(1,-1),l=!0)),fr(t,i,r,o,d,l,a,c[e]),"model"===i&&as(t,o)}else ta(o,Ta)&&Ma(i+'="'+o+'": Interpolation inside attributes has been removed. Use v-bind or the colon shorthand instead. For example, instead of <div id="{{ val }}">, use <div :id="val">.',c[e]),dr(t,i,JSON.stringify(o),c[e]),!t.component&&"muted"===i&&Aa(t.tag,t.attrsMap.type,i)&&ur(t,i,"true",c[e])}}(t),t}function Xa(t){var e;if(e=yr(t,"v-for")){var n=function(t){var e=t.match(Ia);if(!e)return;var n={};n.for=e[2].trim();var i=e[1].trim().replace(Fa,""),r=i.match(Na);r?(n.alias=i.replace(Na,"").trim(),n.iterator1=r[1].trim(),r[2]&&(n.iterator2=r[2].trim())):n.alias=i;return n}(e);n?P(t,n):Ma("Invalid v-for expression: "+e,t.rawAttrsMap["v-for"])}}function ts(t,e){t.ifConditions||(t.ifConditions=[]),t.ifConditions.push(e)}function es(t){var e=t.name.replace(Ha,"");return e||("#"!==t.name[0]?e="default":Ma("v-slot shorthand syntax requires a slot name.",t)),$a.test(e)?{name:e.slice(1,-1),dynamic:!0}:{name:'"'+e+'"',dynamic:!1}}function ns(t){var e=t.match(Va);if(e){var n={};return e.forEach((function(t){n[t.slice(1)]=!0})),n}}function is(t){for(var e={},n=0,i=t.length;n<i;n++)!e[t[n].name]||K||Z||Ma("duplicate attribute: "+t[n].name,t[n]),e[t[n].name]=t[n].value;return e}var rs=/^xmlns:NS\d+/,os=/^NS\d+:/;function as(t,e){for(var n=t;n;)n.for&&n.alias===e&&Ma("<"+t.tag+' v-model="'+e+'">: You are binding v-model directly to a v-for iteration alias. This will not be able to modify the v-for source array because writing to the alias is like modifying a function local variable. Consider using an array of objects and use v-model on an object property instead.',t.rawAttrsMap["v-model"]),n=n.parent}function ss(t){return Ka(t.tag,t.attrsList.slice(),t.parent)}var ls=[ea,ia,{preTransformNode:function(t,e){if("input"===t.tag){var n,i=t.attrsMap;if(!i["v-model"])return;if((i[":type"]||i["v-bind:type"])&&(n=gr(t,"type")),i.type||n||!i["v-bind"]||(n="("+i["v-bind"]+").type"),n){var r=yr(t,"v-if",!0),o=r?"&&("+r+")":"",a=null!=yr(t,"v-else",!0),s=yr(t,"v-else-if",!0),l=ss(t);Xa(l),hr(l,"type","checkbox"),Za(l,e),l.processed=!0,l.if="("+n+")==='checkbox'"+o,ts(l,{exp:l.if,block:l});var c=ss(t);yr(c,"v-for",!0),hr(c,"type","radio"),Za(c,e),ts(l,{exp:"("+n+")==='radio'"+o,block:c});var u=ss(t);return yr(u,"v-for",!0),hr(u,":type",n),Za(u,e),ts(l,{exp:r,block:u}),a?l.else=!0:s&&(l.elseif=s),l}}}}];var cs,us,ds={model:function(t,e,n){ir=n;var i=e.value,r=e.modifiers,o=t.tag,a=t.attrsMap.type;if("input"===o&&"file"===a&&ir("<"+t.tag+' v-model="'+i+'" type="file">:\nFile inputs are read only. Use a v-on:change listener instead.',t.rawAttrsMap["v-model"]),t.component)return wr(t,i,r),!1;if("select"===o)!function(t,e,n){var i=n&&n.number,r='var $$selectedVal = Array.prototype.filter.call($event.target.options,function(o){return o.selected}).map(function(o){var val = "_value" in o ? o._value : o.value;return '+(i?"_n(val)":"val")+"});";r=r+" "+kr(e,"$event.target.multiple ? $$selectedVal : $$selectedVal[0]"),mr(t,"change",r,null,!0)}(t,i,r);else if("input"===o&&"checkbox"===a)!function(t,e,n){var i=n&&n.number,r=gr(t,"value")||"null",o=gr(t,"true-value")||"true",a=gr(t,"false-value")||"false";ur(t,"checked","Array.isArray("+e+")?_i("+e+","+r+")>-1"+("true"===o?":("+e+")":":_q("+e+","+o+")")),mr(t,"change","var $$a="+e+",$$el=$event.target,$$c=$$el.checked?("+o+"):("+a+");if(Array.isArray($$a)){var $$v="+(i?"_n("+r+")":r)+",$$i=_i($$a,$$v);if($$el.checked){$$i<0&&("+kr(e,"$$a.concat([$$v])")+")}else{$$i>-1&&("+kr(e,"$$a.slice(0,$$i).concat($$a.slice($$i+1))")+")}}else{"+kr(e,"$$c")+"}",null,!0)}(t,i,r);else if("input"===o&&"radio"===a)!function(t,e,n){var i=n&&n.number,r=gr(t,"value")||"null";ur(t,"checked","_q("+e+","+(r=i?"_n("+r+")":r)+")"),mr(t,"change",kr(e,r),null,!0)}(t,i,r);else if("input"===o||"textarea"===o)!function(t,e,n){var i=t.attrsMap.type,r=t.attrsMap["v-bind:value"]||t.attrsMap[":value"],o=t.attrsMap["v-bind:type"]||t.attrsMap[":type"];if(r&&!o){var a=t.attrsMap["v-bind:value"]?"v-bind:value":":value";ir(a+'="'+r+'" conflicts with v-model on the same element because the latter already expands to a value binding internally',t.rawAttrsMap[a])}var s=n||{},l=s.lazy,c=s.number,u=s.trim,d=!l&&"range"!==i,h=l?"change":"range"===i?Or:"input",f="$event.target.value";u&&(f="$event.target.value.trim()");c&&(f="_n("+f+")");var p=kr(e,f);d&&(p="if($event.target.composing)return;"+p);ur(t,"value","("+e+")"),mr(t,h,p,null,!0),(u||c)&&mr(t,"blur","$forceUpdate()")}(t,i,r);else{if(!F.isReservedTag(o))return wr(t,i,r),!1;ir("<"+t.tag+' v-model="'+i+"\">: v-model is not supported on this element type. If you are working with contenteditable, it's recommended to wrap a library dedicated for that purpose inside a custom component.",t.rawAttrsMap["v-model"])}return!0},text:function(t,e){e.value&&ur(t,"textContent","_s("+e.value+")",e)},html:function(t,e){e.value&&ur(t,"innerHTML","_s("+e.value+")",e)}},hs={expectHTML:!0,modules:ls,directives:ds,isPreTag:function(t){return"pre"===t},isUnaryTag:oa,mustUseProp:di,canBeLeftOpenTag:aa,isReservedTag:Ti,getTagNamespace:Pi,staticKeys:function(t){return t.reduce((function(t,e){return t.concat(e.staticKeys||[])}),[]).join(",")}(ls)},fs=b((function(t){return p("type,tag,attrsList,attrsMap,plain,parent,children,attrs,start,end,rawAttrsMap"+(t?","+t:""))}));function ps(t,e){t&&(cs=fs(e.staticKeys||""),us=e.isReservedTag||E,ms(t),vs(t,!1))}function ms(t){if(t.static=function(t){if(2===t.type)return!1;if(3===t.type)return!0;return!(!t.pre&&(t.hasBindings||t.if||t.for||m(t.tag)||!us(t.tag)||function(t){for(;t.parent;){if("template"!==(t=t.parent).tag)return!1;if(t.for)return!0}return!1}(t)||!Object.keys(t).every(cs)))}(t),1===t.type){if(!us(t.tag)&&"slot"!==t.tag&&null==t.attrsMap["inline-template"])return;for(var e=0,n=t.children.length;e<n;e++){var i=t.children[e];ms(i),i.static||(t.static=!1)}if(t.ifConditions)for(var r=1,o=t.ifConditions.length;r<o;r++){var a=t.ifConditions[r].block;ms(a),a.static||(t.static=!1)}}}function vs(t,e){if(1===t.type){if((t.static||t.once)&&(t.staticInFor=e),t.static&&t.children.length&&(1!==t.children.length||3!==t.children[0].type))return void(t.staticRoot=!0);if(t.staticRoot=!1,t.children)for(var n=0,i=t.children.length;n<i;n++)vs(t.children[n],e||!!t.for);if(t.ifConditions)for(var r=1,o=t.ifConditions.length;r<o;r++)vs(t.ifConditions[r].block,e)}}var gs=/^([\w$_]+|\([^)]*?\))\s*=>|^function(?:\s+[\w$]+)?\s*\(/,ys=/\([^)]*?\);*$/,_s=/^[A-Za-z_$][\w$]*(?:\.[A-Za-z_$][\w$]*|\['[^']*?']|\["[^"]*?"]|\[\d+]|\[[A-Za-z_$][\w$]*])*$/,bs={esc:27,tab:9,enter:13,space:32,up:38,left:37,right:39,down:40,delete:[8,46]},ws={esc:["Esc","Escape"],tab:"Tab",enter:"Enter",space:[" ","Spacebar"],up:["Up","ArrowUp"],left:["Left","ArrowLeft"],right:["Right","ArrowRight"],down:["Down","ArrowDown"],delete:["Backspace","Delete","Del"]},ks=function(t){return"if("+t+")return null;"},xs={stop:"$event.stopPropagation();",prevent:"$event.preventDefault();",self:ks("$event.target !== $event.currentTarget"),ctrl:ks("!$event.ctrlKey"),shift:ks("!$event.shiftKey"),alt:ks("!$event.altKey"),meta:ks("!$event.metaKey"),left:ks("'button' in $event && $event.button !== 0"),middle:ks("'button' in $event && $event.button !== 1"),right:ks("'button' in $event && $event.button !== 2")};function Cs(t,e){var n=e?"nativeOn:":"on:",i="",r="";for(var o in t){var a=Ss(t[o]);t[o]&&t[o].dynamic?r+=o+","+a+",":i+='"'+o+'":'+a+","}return i="{"+i.slice(0,-1)+"}",r?n+"_d("+i+",["+r.slice(0,-1)+"])":n+i}function Ss(t){if(!t)return"function(){}";if(Array.isArray(t))return"["+t.map((function(t){return Ss(t)})).join(",")+"]";var e=_s.test(t.value),n=gs.test(t.value),i=_s.test(t.value.replace(ys,""));if(t.modifiers){var r="",o="",a=[];for(var s in t.modifiers)if(xs[s])o+=xs[s],bs[s]&&a.push(s);else if("exact"===s){var l=t.modifiers;o+=ks(["ctrl","shift","alt","meta"].filter((function(t){return!l[t]})).map((function(t){return"$event."+t+"Key"})).join("||"))}else a.push(s);return a.length&&(r+=function(t){return"if(!$event.type.indexOf('key')&&"+t.map(Ms).join("&&")+")return null;"}(a)),o&&(r+=o),"function($event){"+r+(e?"return "+t.value+"($event)":n?"return ("+t.value+")($event)":i?"return "+t.value:t.value)+"}"}return e||n?t.value:"function($event){"+(i?"return "+t.value:t.value)+"}"}function Ms(t){var e=parseInt(t,10);if(e)return"$event.keyCode!=="+e;var n=bs[t],i=ws[t];return"_k($event.keyCode,"+JSON.stringify(t)+","+JSON.stringify(n)+",$event.key,"+JSON.stringify(i)+")"}var Ts={on:function(t,e){e.modifiers&&ct("v-on without argument does not support modifiers."),t.wrapListeners=function(t){return"_g("+t+","+e.value+")"}},bind:function(t,e){t.wrapData=function(n){return"_b("+n+",'"+t.tag+"',"+e.value+","+(e.modifiers&&e.modifiers.prop?"true":"false")+(e.modifiers&&e.modifiers.sync?",true":"")+")"}},cloak:B},Ps=function(t){this.options=t,this.warn=t.warn||lr,this.transforms=cr(t.modules,"transformCode"),this.dataGenFns=cr(t.modules,"genData"),this.directives=P(P({},Ts),t.directives);var e=t.isReservedTag||E;this.maybeComponent=function(t){return!!t.component||!e(t.tag)},this.onceId=0,this.staticRenderFns=[],this.pre=!1};function Os(t,e){var n=new Ps(e);return{render:"with(this){return "+(t?Bs(t,n):'_c("div")')+"}",staticRenderFns:n.staticRenderFns}}function Bs(t,e){if(t.parent&&(t.pre=t.pre||t.parent.pre),t.staticRoot&&!t.staticProcessed)return Es(t,e);if(t.once&&!t.onceProcessed)return As(t,e);if(t.for&&!t.forProcessed)return qs(t,e);if(t.if&&!t.ifProcessed)return Ds(t,e);if("template"!==t.tag||t.slotTarget||e.pre){if("slot"===t.tag)return function(t,e){var n=t.slotName||'"default"',i=Fs(t,e),r="_t("+n+(i?","+i:""),o=t.attrs||t.dynamicAttrs?zs((t.attrs||[]).concat(t.dynamicAttrs||[]).map((function(t){return{name:k(t.name),value:t.value,dynamic:t.dynamic}}))):null,a=t.attrsMap["v-bind"];!o&&!a||i||(r+=",null");o&&(r+=","+o);a&&(r+=(o?"":",null")+","+a);return r+")"}(t,e);var n;if(t.component)n=function(t,e,n){var i=e.inlineTemplate?null:Fs(e,n,!0);return"_c("+t+","+Rs(e,n)+(i?","+i:"")+")"}(t.component,t,e);else{var i;(!t.plain||t.pre&&e.maybeComponent(t))&&(i=Rs(t,e));var r=t.inlineTemplate?null:Fs(t,e,!0);n="_c('"+t.tag+"'"+(i?","+i:"")+(r?","+r:"")+")"}for(var o=0;o<e.transforms.length;o++)n=e.transforms[o](t,n);return n}return Fs(t,e)||"void 0"}function Es(t,e){t.staticProcessed=!0;var n=e.pre;return t.pre&&(e.pre=t.pre),e.staticRenderFns.push("with(this){return "+Bs(t,e)+"}"),e.pre=n,"_m("+(e.staticRenderFns.length-1)+(t.staticInFor?",true":"")+")"}function As(t,e){if(t.onceProcessed=!0,t.if&&!t.ifProcessed)return Ds(t,e);if(t.staticInFor){for(var n="",i=t.parent;i;){if(i.for){n=i.key;break}i=i.parent}return n?"_o("+Bs(t,e)+","+e.onceId+++","+n+")":(e.warn("v-once can only be used inside v-for that is keyed. ",t.rawAttrsMap["v-once"]),Bs(t,e))}return Es(t,e)}function Ds(t,e,n,i){return t.ifProcessed=!0,Ls(t.ifConditions.slice(),e,n,i)}function Ls(t,e,n,i){if(!t.length)return i||"_e()";var r=t.shift();return r.exp?"("+r.exp+")?"+o(r.block)+":"+Ls(t,e,n,i):""+o(r.block);function o(t){return n?n(t,e):t.once?As(t,e):Bs(t,e)}}function qs(t,e,n,i){var r=t.for,o=t.alias,a=t.iterator1?","+t.iterator1:"",s=t.iterator2?","+t.iterator2:"";return e.maybeComponent(t)&&"slot"!==t.tag&&"template"!==t.tag&&!t.key&&e.warn("<"+t.tag+' v-for="'+o+" in "+r+'">: component lists rendered with v-for should have explicit keys. See https://vuejs.org/guide/list.html#key for more info.',t.rawAttrsMap["v-for"],!0),t.forProcessed=!0,(i||"_l")+"(("+r+"),function("+o+a+s+"){return "+(n||Bs)(t,e)+"})"}function Rs(t,e){var n="{",i=function(t,e){var n=t.directives;if(!n)return;var i,r,o,a,s="directives:[",l=!1;for(i=0,r=n.length;i<r;i++){o=n[i],a=!0;var c=e.directives[o.name];c&&(a=!!c(t,o,e.warn)),a&&(l=!0,s+='{name:"'+o.name+'",rawName:"'+o.rawName+'"'+(o.value?",value:("+o.value+"),expression:"+JSON.stringify(o.value):"")+(o.arg?",arg:"+(o.isDynamicArg?o.arg:'"'+o.arg+'"'):"")+(o.modifiers?",modifiers:"+JSON.stringify(o.modifiers):"")+"},")}if(l)return s.slice(0,-1)+"]"}(t,e);i&&(n+=i+","),t.key&&(n+="key:"+t.key+","),t.ref&&(n+="ref:"+t.ref+","),t.refInFor&&(n+="refInFor:true,"),t.pre&&(n+="pre:true,"),t.component&&(n+='tag:"'+t.tag+'",');for(var r=0;r<e.dataGenFns.length;r++)n+=e.dataGenFns[r](t);if(t.attrs&&(n+="attrs:"+zs(t.attrs)+","),t.props&&(n+="domProps:"+zs(t.props)+","),t.events&&(n+=Cs(t.events,!1)+","),t.nativeEvents&&(n+=Cs(t.nativeEvents,!0)+","),t.slotTarget&&!t.slotScope&&(n+="slot:"+t.slotTarget+","),t.scopedSlots&&(n+=function(t,e,n){var i=t.for||Object.keys(e).some((function(t){var n=e[t];return n.slotTargetDynamic||n.if||n.for||Is(n)})),r=!!t.if;if(!i)for(var o=t.parent;o;){if(o.slotScope&&o.slotScope!==Ga||o.for){i=!0;break}o.if&&(r=!0),o=o.parent}var a=Object.keys(e).map((function(t){return Ns(e[t],n)})).join(",");return"scopedSlots:_u(["+a+"]"+(i?",null,true":"")+(!i&&r?",null,false,"+function(t){var e=5381,n=t.length;for(;n;)e=33*e^t.charCodeAt(--n);return e>>>0}(a):"")+")"}(t,t.scopedSlots,e)+","),t.model&&(n+="model:{value:"+t.model.value+",callback:"+t.model.callback+",expression:"+t.model.expression+"},"),t.inlineTemplate){var o=function(t,e){var n=t.children[0];1===t.children.length&&1===n.type||e.warn("Inline-template components must have exactly one child element.",{start:t.start});if(n&&1===n.type){var i=Os(n,e.options);return"inlineTemplate:{render:function(){"+i.render+"},staticRenderFns:["+i.staticRenderFns.map((function(t){return"function(){"+t+"}"})).join(",")+"]}"}}(t,e);o&&(n+=o+",")}return n=n.replace(/,$/,"")+"}",t.dynamicAttrs&&(n="_b("+n+',"'+t.tag+'",'+zs(t.dynamicAttrs)+")"),t.wrapData&&(n=t.wrapData(n)),t.wrapListeners&&(n=t.wrapListeners(n)),n}function Is(t){return 1===t.type&&("slot"===t.tag||t.children.some(Is))}function Ns(t,e){var n=t.attrsMap["slot-scope"];if(t.if&&!t.ifProcessed&&!n)return Ds(t,e,Ns,"null");if(t.for&&!t.forProcessed)return qs(t,e,Ns);var i=t.slotScope===Ga?"":String(t.slotScope),r="function("+i+"){return "+("template"===t.tag?t.if&&n?"("+t.if+")?"+(Fs(t,e)||"undefined")+":undefined":Fs(t,e)||"undefined":Bs(t,e))+"}",o=i?"":",proxy:true";return"{key:"+(t.slotTarget||'"default"')+",fn:"+r+o+"}"}function Fs(t,e,n,i,r){var o=t.children;if(o.length){var a=o[0];if(1===o.length&&a.for&&"template"!==a.tag&&"slot"!==a.tag){var s=n?e.maybeComponent(a)?",1":",0":"";return""+(i||Bs)(a,e)+s}var l=n?function(t,e){for(var n=0,i=0;i<t.length;i++){var r=t[i];if(1===r.type){if($s(r)||r.ifConditions&&r.ifConditions.some((function(t){return $s(t.block)}))){n=2;break}(e(r)||r.ifConditions&&r.ifConditions.some((function(t){return e(t.block)})))&&(n=1)}}return n}(o,e.maybeComponent):0,c=r||js;return"["+o.map((function(t){return c(t,e)})).join(",")+"]"+(l?","+l:"")}}function $s(t){return void 0!==t.for||"template"===t.tag||"slot"===t.tag}function js(t,e){return 1===t.type?Bs(t,e):3===t.type&&t.isComment?function(t){return"_e("+JSON.stringify(t.text)+")"}(t):function(t){return"_v("+(2===t.type?t.expression:Vs(JSON.stringify(t.text)))+")"}(t)}function zs(t){for(var e="",n="",i=0;i<t.length;i++){var r=t[i],o=Vs(r.value);r.dynamic?n+=r.name+","+o+",":e+='"'+r.name+'":'+o+","}return e="{"+e.slice(0,-1)+"}",n?"_d("+e+",["+n.slice(0,-1)+"])":e}function Vs(t){return t.replace(/\u2028/g,"\\u2028").replace(/\u2029/g,"\\u2029")}var Hs=new RegExp("\\b"+"do,if,for,let,new,try,var,case,else,with,await,break,catch,class,const,super,throw,while,yield,delete,export,import,return,switch,default,extends,finally,continue,debugger,function,arguments".split(",").join("\\b|\\b")+"\\b"),Ws=new RegExp("\\b"+"delete,typeof,void".split(",").join("\\s*\\([^\\)]*\\)|\\b")+"\\s*\\([^\\)]*\\)"),Us=/'(?:[^'\\]|\\.)*'|"(?:[^"\\]|\\.)*"|`(?:[^`\\]|\\.)*\$\{|\}(?:[^`\\]|\\.)*`|`(?:[^`\\]|\\.)*`/g;function Ys(t,e){t&&Qs(t,e)}function Qs(t,e){if(1===t.type){for(var n in t.attrsMap)if(Ra.test(n)){var i=t.attrsMap[n];if(i){var r=t.rawAttrsMap[n];"v-for"===n?Ks(t,'v-for="'+i+'"',e,r):"v-slot"===n||"#"===n[0]?Xs(i,n+'="'+i+'"',e,r):qa.test(n)?Gs(i,n+'="'+i+'"',e,r):Zs(i,n+'="'+i+'"',e,r)}}if(t.children)for(var o=0;o<t.children.length;o++)Qs(t.children[o],e)}else 2===t.type&&Zs(t.expression,t.text,e,t)}function Gs(t,e,n,i){var r=t.replace(Us,""),o=r.match(Ws);o&&"$"!==r.charAt(o.index-1)&&n('avoid using JavaScript unary operator as property name: "'+o[0]+'" in expression '+e.trim(),i),Zs(t,e,n,i)}function Ks(t,e,n,i){Zs(t.for||"",e,n,i),Js(t.alias,"v-for alias",e,n,i),Js(t.iterator1,"v-for iterator",e,n,i),Js(t.iterator2,"v-for iterator",e,n,i)}function Js(t,e,n,i,r){if("string"==typeof t)try{new Function("var "+t+"=_")}catch(o){i("invalid "+e+' "'+t+'" in expression: '+n.trim(),r)}}function Zs(t,e,n,i){try{new Function("return "+t)}catch(o){var r=t.replace(Us,"").match(Hs);n(r?'avoid using JavaScript keyword as property name: "'+r[0]+'"\n  Raw expression: '+e.trim():"invalid expression: "+o.message+" in\n\n    "+t+"\n\n  Raw expression: "+e.trim()+"\n",i)}}function Xs(t,e,n,i){try{new Function(t,"")}catch(r){n("invalid function parameter expression: "+r.message+" in\n\n    "+t+"\n\n  Raw expression: "+e.trim()+"\n",i)}}var tl=2;function el(t,e){var n="";if(e>0)for(;1&e&&(n+=t),!((e>>>=1)<=0);)t+=t;return n}function nl(t,e){try{return new Function(t)}catch(n){return e.push({err:n,code:t}),B}}function il(t){var e=Object.create(null);return function(n,i,r){var o=(i=P({},i)).warn||ct;delete i.warn;try{new Function("return 1")}catch(t){t.toString().match(/unsafe-eval|CSP/)&&o("It seems you are using the standalone build of Vue.js in an environment with Content Security Policy that prohibits unsafe-eval. The template compiler cannot work in this environment. Consider relaxing the policy to allow unsafe-eval or pre-compiling your templates into render functions.")}var a=i.delimiters?String(i.delimiters)+n:n;if(e[a])return e[a];var s=t(n,i);s.errors&&s.errors.length&&(i.outputSourceRange?s.errors.forEach((function(t){o("Error compiling template:\n\n"+t.msg+"\n\n"+function(t,e,n){void 0===e&&(e=0),void 0===n&&(n=t.length);for(var i=t.split(/\r?\n/),r=0,o=[],a=0;a<i.length;a++)if((r+=i[a].length+1)>=e){for(var s=a-tl;s<=a+tl||n>r;s++)if(!(s<0||s>=i.length)){o.push(""+(s+1)+el(" ",3-String(s+1).length)+"|  "+i[s]);var l=i[s].length;if(s===a){var c=e-(r-l)+1,u=n>r?l-c:n-e;o.push("   |  "+el(" ",c)+el("^",u))}else if(s>a){if(n>r){var d=Math.min(n-r,l);o.push("   |  "+el("^",d))}r+=l+1}}break}return o.join("\n")}(n,t.start,t.end),r)})):o("Error compiling template:\n\n"+n+"\n\n"+s.errors.map((function(t){return"- "+t})).join("\n")+"\n",r)),s.tips&&s.tips.length&&(i.outputSourceRange?s.tips.forEach((function(t){return ut(t.msg,r)})):s.tips.forEach((function(t){return ut(t,r)})));var l={},c=[];return l.render=nl(s.render,c),l.staticRenderFns=s.staticRenderFns.map((function(t){return nl(t,c)})),s.errors&&s.errors.length||!c.length||o("Failed to generate render function:\n\n"+c.map((function(t){var e=t.err,n=t.code;return e.toString()+" in\n\n"+n+"\n"})).join("\n"),r),e[a]=l}}var rl,ol,al=(rl=function(t,e){var n=Ja(t.trim(),e);!1!==e.optimize&&ps(n,e);var i=Os(n,e);return{ast:n,render:i.render,staticRenderFns:i.staticRenderFns}},function(t){function e(e,n){var i=Object.create(t),r=[],o=[],a=function(t,e,n){(n?o:r).push(t)};if(n){if(n.outputSourceRange){var s=e.match(/^\s*/)[0].length;a=function(t,e,n){var i={msg:t};e&&(null!=e.start&&(i.start=e.start+s),null!=e.end&&(i.end=e.end+s)),(n?o:r).push(i)}}for(var l in n.modules&&(i.modules=(t.modules||[]).concat(n.modules)),n.directives&&(i.directives=P(Object.create(t.directives||null),n.directives)),n)"modules"!==l&&"directives"!==l&&(i[l]=n[l])}i.warn=a;var c=rl(e.trim(),i);return Ys(c.ast,a),c.errors=r,c.tips=o,c}return{compile:e,compileToFunctions:il(e)}}),sl=al(hs),ll=(sl.compile,sl.compileToFunctions);function cl(t){return(ol=ol||document.createElement("div")).innerHTML=t?'<a href="\n"/>':'<div a="\n"/>',ol.innerHTML.indexOf("&#10;")>0}var ul=!!U&&cl(!1),dl=!!U&&cl(!0),hl=b((function(t){var e=Ei(t);return e&&e.innerHTML})),fl=ei.prototype.$mount;return ei.prototype.$mount=function(t,e){if((t=t&&Ei(t))===document.body||t===document.documentElement)return ct("Do not mount Vue to <html> or <body> - mount to normal elements instead."),this;var n=this.$options;if(!n.render){var i=n.template;if(i)if("string"==typeof i)"#"===i.charAt(0)&&((i=hl(i))||ct("Template element not found or is empty: "+n.template,this));else{if(!i.nodeType)return ct("invalid template option:"+i,this),this;i=i.innerHTML}else t&&(i=function(t){if(t.outerHTML)return t.outerHTML;var e=document.createElement("div");return e.appendChild(t.cloneNode(!0)),e.innerHTML}(t));if(i){F.performance&&oe&&oe("compile");var r=ll(i,{outputSourceRange:!0,shouldDecodeNewlines:ul,shouldDecodeNewlinesForHref:dl,delimiters:n.delimiters,comments:n.comments},this),o=r.render,a=r.staticRenderFns;n.render=o,n.staticRenderFns=a,F.performance&&oe&&(oe("compile end"),ae("vue "+this._name+" compile","compile","compile end"))}}return fl.call(this,t,e)},ei.compile=ll,ei})),
/*!
  * vue-router v3.4.3
  * (c) 2020 Evan You
  * @license MIT
  */
function(t,e){"object"==typeof exports&&"undefined"!=typeof module?module.exports=e():"function"==typeof define&&define.amd?define(e):(t=t||self).VueRouter=e()}(this,(function(){"use strict";function t(t,e){if(!t)throw new Error("[vue-router] "+e)}function e(t,e){t||"undefined"!=typeof console&&console.warn("[vue-router] "+e)}function n(t,e){for(var n in e)t[n]=e[n];return t}var i={name:"RouterView",functional:!0,props:{name:{type:String,default:"default"}},render:function(t,e){var i=e.props,o=e.children,a=e.parent,s=e.data;s.routerView=!0;for(var l=a.$createElement,c=i.name,u=a.$route,d=a._routerViewCache||(a._routerViewCache={}),h=0,f=!1;a&&a._routerRoot!==a;){var p=a.$vnode?a.$vnode.data:{};p.routerView&&h++,p.keepAlive&&a._directInactive&&a._inactive&&(f=!0),a=a.$parent}if(s.routerViewDepth=h,f){var m=d[c],v=m&&m.component;return v?(m.configProps&&r(v,s,m.route,m.configProps),l(v,s,o)):l()}var g=u.matched[h],y=g&&g.components[c];if(!g||!y)return d[c]=null,l();d[c]={component:y},s.registerRouteInstance=function(t,e){var n=g.instances[c];(e&&n!==t||!e&&n===t)&&(g.instances[c]=e)},(s.hook||(s.hook={})).prepatch=function(t,e){g.instances[c]=e.componentInstance},s.hook.init=function(t){t.data.keepAlive&&t.componentInstance&&t.componentInstance!==g.instances[c]&&(g.instances[c]=t.componentInstance)};var _=g.props&&g.props[c];return _&&(n(d[c],{route:u,configProps:_}),r(y,s,u,_)),l(y,s,o)}};function r(t,i,r,o){var a=i.props=function(t,n){switch(typeof n){case"undefined":return;case"object":return n;case"function":return n(t);case"boolean":return n?t.params:void 0;default:e(!1,'props in "'+t.path+'" is a '+typeof n+", expecting an object, function or boolean.")}}(r,o);if(a){a=i.props=n({},a);var s=i.attrs=i.attrs||{};for(var l in a)t.props&&l in t.props||(s[l]=a[l],delete a[l])}}var o=/[!'()*]/g,a=function(t){return"%"+t.charCodeAt(0).toString(16)},s=/%2C/g,l=function(t){return encodeURIComponent(t).replace(o,a).replace(s,",")},c=decodeURIComponent;var u=function(t){return null==t||"object"==typeof t?t:String(t)};function d(t){var e={};return(t=t.trim().replace(/^(\?|#|&)/,""))?(t.split("&").forEach((function(t){var n=t.replace(/\+/g," ").split("="),i=c(n.shift()),r=n.length>0?c(n.join("=")):null;void 0===e[i]?e[i]=r:Array.isArray(e[i])?e[i].push(r):e[i]=[e[i],r]})),e):e}function h(t){var e=t?Object.keys(t).map((function(e){var n=t[e];if(void 0===n)return"";if(null===n)return l(e);if(Array.isArray(n)){var i=[];return n.forEach((function(t){void 0!==t&&(null===t?i.push(l(e)):i.push(l(e)+"="+l(t)))})),i.join("&")}return l(e)+"="+l(n)})).filter((function(t){return t.length>0})).join("&"):null;return e?"?"+e:""}var f=/\/?$/;function p(t,e,n,i){var r=i&&i.options.stringifyQuery,o=e.query||{};try{o=m(o)}catch(t){}var a={name:e.name||t&&t.name,meta:t&&t.meta||{},path:e.path||"/",hash:e.hash||"",query:o,params:e.params||{},fullPath:y(e,r),matched:t?g(t):[]};return n&&(a.redirectedFrom=y(n,r)),Object.freeze(a)}function m(t){if(Array.isArray(t))return t.map(m);if(t&&"object"==typeof t){var e={};for(var n in t)e[n]=m(t[n]);return e}return t}var v=p(null,{path:"/"});function g(t){for(var e=[];t;)e.unshift(t),t=t.parent;return e}function y(t,e){var n=t.path,i=t.query;void 0===i&&(i={});var r=t.hash;return void 0===r&&(r=""),(n||"/")+(e||h)(i)+r}function _(t,e){return e===v?t===e:!!e&&(t.path&&e.path?t.path.replace(f,"")===e.path.replace(f,"")&&t.hash===e.hash&&b(t.query,e.query):!(!t.name||!e.name)&&(t.name===e.name&&t.hash===e.hash&&b(t.query,e.query)&&b(t.params,e.params)))}function b(t,e){if(void 0===t&&(t={}),void 0===e&&(e={}),!t||!e)return t===e;var n=Object.keys(t),i=Object.keys(e);return n.length===i.length&&n.every((function(n){var i=t[n],r=e[n];return null==i||null==r?i===r:"object"==typeof i&&"object"==typeof r?b(i,r):String(i)===String(r)}))}function w(t,e,n){var i=t.charAt(0);if("/"===i)return t;if("?"===i||"#"===i)return e+t;var r=e.split("/");n&&r[r.length-1]||r.pop();for(var o=t.replace(/^\//,"").split("/"),a=0;a<o.length;a++){var s=o[a];".."===s?r.pop():"."!==s&&r.push(s)}return""!==r[0]&&r.unshift(""),r.join("/")}function k(t){return t.replace(/\/\//g,"/")}var x=Array.isArray||function(t){return"[object Array]"==Object.prototype.toString.call(t)},C=N,S=B,M=function(t,e){return A(B(t,e),e)},T=A,P=I,O=new RegExp(["(\\\\.)","([\\/.])?(?:(?:\\:(\\w+)(?:\\(((?:\\\\.|[^\\\\()])+)\\))?|\\(((?:\\\\.|[^\\\\()])+)\\))([+*?])?|(\\*))"].join("|"),"g");function B(t,e){for(var n,i=[],r=0,o=0,a="",s=e&&e.delimiter||"/";null!=(n=O.exec(t));){var l=n[0],c=n[1],u=n.index;if(a+=t.slice(o,u),o=u+l.length,c)a+=c[1];else{var d=t[o],h=n[2],f=n[3],p=n[4],m=n[5],v=n[6],g=n[7];a&&(i.push(a),a="");var y=null!=h&&null!=d&&d!==h,_="+"===v||"*"===v,b="?"===v||"*"===v,w=n[2]||s,k=p||m;i.push({name:f||r++,prefix:h||"",delimiter:w,optional:b,repeat:_,partial:y,asterisk:!!g,pattern:k?L(k):g?".*":"[^"+D(w)+"]+?"})}}return o<t.length&&(a+=t.substr(o)),a&&i.push(a),i}function E(t){return encodeURI(t).replace(/[\/?#]/g,(function(t){return"%"+t.charCodeAt(0).toString(16).toUpperCase()}))}function A(t,e){for(var n=new Array(t.length),i=0;i<t.length;i++)"object"==typeof t[i]&&(n[i]=new RegExp("^(?:"+t[i].pattern+")$",R(e)));return function(e,i){for(var r="",o=e||{},a=(i||{}).pretty?E:encodeURIComponent,s=0;s<t.length;s++){var l=t[s];if("string"!=typeof l){var c,u=o[l.name];if(null==u){if(l.optional){l.partial&&(r+=l.prefix);continue}throw new TypeError('Expected "'+l.name+'" to be defined')}if(x(u)){if(!l.repeat)throw new TypeError('Expected "'+l.name+'" to not repeat, but received `'+JSON.stringify(u)+"`");if(0===u.length){if(l.optional)continue;throw new TypeError('Expected "'+l.name+'" to not be empty')}for(var d=0;d<u.length;d++){if(c=a(u[d]),!n[s].test(c))throw new TypeError('Expected all "'+l.name+'" to match "'+l.pattern+'", but received `'+JSON.stringify(c)+"`");r+=(0===d?l.prefix:l.delimiter)+c}}else{if(c=l.asterisk?encodeURI(u).replace(/[?#]/g,(function(t){return"%"+t.charCodeAt(0).toString(16).toUpperCase()})):a(u),!n[s].test(c))throw new TypeError('Expected "'+l.name+'" to match "'+l.pattern+'", but received "'+c+'"');r+=l.prefix+c}}else r+=l}return r}}function D(t){return t.replace(/([.+*?=^!:${}()[\]|\/\\])/g,"\\$1")}function L(t){return t.replace(/([=!:$\/()])/g,"\\$1")}function q(t,e){return t.keys=e,t}function R(t){return t&&t.sensitive?"":"i"}function I(t,e,n){x(e)||(n=e||n,e=[]);for(var i=(n=n||{}).strict,r=!1!==n.end,o="",a=0;a<t.length;a++){var s=t[a];if("string"==typeof s)o+=D(s);else{var l=D(s.prefix),c="(?:"+s.pattern+")";e.push(s),s.repeat&&(c+="(?:"+l+c+")*"),o+=c=s.optional?s.partial?l+"("+c+")?":"(?:"+l+"("+c+"))?":l+"("+c+")"}}var u=D(n.delimiter||"/"),d=o.slice(-u.length)===u;return i||(o=(d?o.slice(0,-u.length):o)+"(?:"+u+"(?=$))?"),o+=r?"$":i&&d?"":"(?="+u+"|$)",q(new RegExp("^"+o,R(n)),e)}function N(t,e,n){return x(e)||(n=e||n,e=[]),n=n||{},t instanceof RegExp?function(t,e){var n=t.source.match(/\((?!\?)/g);if(n)for(var i=0;i<n.length;i++)e.push({name:i,prefix:null,delimiter:null,optional:!1,repeat:!1,partial:!1,asterisk:!1,pattern:null});return q(t,e)}(t,e):x(t)?function(t,e,n){for(var i=[],r=0;r<t.length;r++)i.push(N(t[r],e,n).source);return q(new RegExp("(?:"+i.join("|")+")",R(n)),e)}(t,e,n):function(t,e,n){return I(B(t,n),e,n)}(t,e,n)}C.parse=S,C.compile=M,C.tokensToFunction=T,C.tokensToRegExp=P;var F=Object.create(null);function $(t,n,i){n=n||{};try{var r=F[t]||(F[t]=C.compile(t));return"string"==typeof n.pathMatch&&(n[0]=n.pathMatch),r(n,{pretty:!0})}catch(t){return e("string"==typeof n.pathMatch,"missing param for "+i+": "+t.message),""}finally{delete n[0]}}function j(t,i,r,o){var a="string"==typeof t?{path:t}:t;if(a._normalized)return a;if(a.name){var s=(a=n({},t)).params;return s&&"object"==typeof s&&(a.params=n({},s)),a}if(!a.path&&a.params&&i){(a=n({},a))._normalized=!0;var l=n(n({},i.params),a.params);if(i.name)a.name=i.name,a.params=l;else if(i.matched.length){var c=i.matched[i.matched.length-1].path;a.path=$(c,l,"path "+i.path)}else e(!1,"relative params navigation requires a current route.");return a}var h=function(t){var e="",n="",i=t.indexOf("#");i>=0&&(e=t.slice(i),t=t.slice(0,i));var r=t.indexOf("?");return r>=0&&(n=t.slice(r+1),t=t.slice(0,r)),{path:t,query:n,hash:e}}(a.path||""),f=i&&i.path||"/",p=h.path?w(h.path,f,r||a.append):f,m=function(t,n,i){void 0===n&&(n={});var r,o=i||d;try{r=o(t||"")}catch(t){e(!1,t.message),r={}}for(var a in n){var s=n[a];r[a]=Array.isArray(s)?s.map(u):u(s)}return r}(h.query,a.query,o&&o.options.parseQuery),v=a.hash||h.hash;return v&&"#"!==v.charAt(0)&&(v="#"+v),{_normalized:!0,path:p,query:m,hash:v}}var z,V=function(){},H={name:"RouterLink",props:{to:{type:[String,Object],required:!0},tag:{type:String,default:"a"},exact:Boolean,append:Boolean,replace:Boolean,activeClass:String,exactActiveClass:String,ariaCurrentValue:{type:String,default:"page"},event:{type:[String,Array],default:"click"}},render:function(t){var i=this,r=this.$router,o=this.$route,a=r.resolve(this.to,o,this.append),s=a.location,l=a.route,c=a.href,u={},d=r.options.linkActiveClass,h=r.options.linkExactActiveClass,m=null==d?"router-link-active":d,v=null==h?"router-link-exact-active":h,g=null==this.activeClass?m:this.activeClass,y=null==this.exactActiveClass?v:this.exactActiveClass,b=l.redirectedFrom?p(null,j(l.redirectedFrom),null,r):l;u[y]=_(o,b),u[g]=this.exact?u[y]:function(t,e){return 0===t.path.replace(f,"/").indexOf(e.path.replace(f,"/"))&&(!e.hash||t.hash===e.hash)&&function(t,e){for(var n in e)if(!(n in t))return!1;return!0}(t.query,e.query)}(o,b);var w=u[y]?this.ariaCurrentValue:null,k=function(t){W(t)&&(i.replace?r.replace(s,V):r.push(s,V))},x={click:W};Array.isArray(this.event)?this.event.forEach((function(t){x[t]=k})):x[this.event]=k;var C={class:u},S=!this.$scopedSlots.$hasNormal&&this.$scopedSlots.default&&this.$scopedSlots.default({href:c,route:l,navigate:k,isActive:u[g],isExactActive:u[y]});if(S){if(1===S.length)return S[0];if(S.length>1||!S.length)return e(!1,'RouterLink with to="'+this.to+"\" is trying to use a scoped slot but it didn't provide exactly one child. Wrapping the content with a span element."),0===S.length?t():t("span",{},S)}if("a"===this.tag)C.on=x,C.attrs={href:c,"aria-current":w};else{var M=U(this.$slots.default);if(M){M.isStatic=!1;var T=M.data=n({},M.data);for(var P in T.on=T.on||{},T.on){var O=T.on[P];P in x&&(T.on[P]=Array.isArray(O)?O:[O])}for(var B in x)B in T.on?T.on[B].push(x[B]):T.on[B]=k;var E=M.data.attrs=n({},M.data.attrs);E.href=c,E["aria-current"]=w}else C.on=x}return t(this.tag,C,this.$slots.default)}};function W(t){if(!(t.metaKey||t.altKey||t.ctrlKey||t.shiftKey||t.defaultPrevented||void 0!==t.button&&0!==t.button)){if(t.currentTarget&&t.currentTarget.getAttribute){var e=t.currentTarget.getAttribute("target");if(/\b_blank\b/i.test(e))return}return t.preventDefault&&t.preventDefault(),!0}}function U(t){if(t)for(var e,n=0;n<t.length;n++){if("a"===(e=t[n]).tag)return e;if(e.children&&(e=U(e.children)))return e}}function Y(t){if(!Y.installed||z!==t){Y.installed=!0,z=t;var e=function(t){return void 0!==t},n=function(t,n){var i=t.$options._parentVnode;e(i)&&e(i=i.data)&&e(i=i.registerRouteInstance)&&i(t,n)};t.mixin({beforeCreate:function(){e(this.$options.router)?(this._routerRoot=this,this._router=this.$options.router,this._router.init(this),t.util.defineReactive(this,"_route",this._router.history.current)):this._routerRoot=this.$parent&&this.$parent._routerRoot||this,n(this,this)},destroyed:function(){n(this)}}),Object.defineProperty(t.prototype,"$router",{get:function(){return this._routerRoot._router}}),Object.defineProperty(t.prototype,"$route",{get:function(){return this._routerRoot._route}}),t.component("RouterView",i),t.component("RouterLink",H);var r=t.config.optionMergeStrategies;r.beforeRouteEnter=r.beforeRouteLeave=r.beforeRouteUpdate=r.created}}var Q="undefined"!=typeof window;function G(t,n,i,r){var o=n||[],a=i||Object.create(null),s=r||Object.create(null);t.forEach((function(t){K(o,a,s,t)}));for(var l=0,c=o.length;l<c;l++)"*"===o[l]&&(o.push(o.splice(l,1)[0]),c--,l--);var u=o.filter((function(t){return t&&"*"!==t.charAt(0)&&"/"!==t.charAt(0)}));u.length>0&&e(!1,"Non-nested routes must include a leading slash character. Fix the following routes: \n"+u.map((function(t){return"- "+t})).join("\n"));return{pathList:o,pathMap:a,nameMap:s}}function K(n,i,r,o,a,s){var l=o.path,c=o.name;t(null!=l,'"path" is required in a route configuration.'),t("string"!=typeof o.component,'route config "component" for path: '+String(l||c)+" cannot be a string id. Use an actual component instead.");var u=o.pathToRegexpOptions||{},d=function(t,e,n){n||(t=t.replace(/\/$/,""));if("/"===t[0])return t;if(null==e)return t;return k(e.path+"/"+t)}(l,a,u.strict);"boolean"==typeof o.caseSensitive&&(u.sensitive=o.caseSensitive);var h={path:d,regex:J(d,u),components:o.components||{default:o.component},instances:{},name:c,parent:a,matchAs:s,redirect:o.redirect,beforeEnter:o.beforeEnter,meta:o.meta||{},props:null==o.props?{}:o.components?o.props:{default:o.props}};if(o.children&&(o.name&&!o.redirect&&o.children.some((function(t){return/^\/?$/.test(t.path)}))&&e(!1,"Named Route '"+o.name+"' has a default child route. When navigating to this named route (:to=\"{name: '"+o.name+"'\"), the default child route will not be rendered. Remove the name from this route and use the name of the default child route for named links instead."),o.children.forEach((function(t){var e=s?k(s+"/"+t.path):void 0;K(n,i,r,t,h,e)}))),i[h.path]||(n.push(h.path),i[h.path]=h),void 0!==o.alias)for(var f=Array.isArray(o.alias)?o.alias:[o.alias],p=0;p<f.length;++p){var m=f[p];if(m!==l){var v={path:m,children:o.children};K(n,i,r,v,a,h.path||"/")}else e(!1,'Found an alias with the same value as the path: "'+l+'". You have to remove that alias. It will be ignored in development.')}c&&(r[c]?s||e(!1,'Duplicate named routes definition: { name: "'+c+'", path: "'+h.path+'" }'):r[c]=h)}function J(t,n){var i=C(t,[],n),r=Object.create(null);return i.keys.forEach((function(n){e(!r[n.name],'Duplicate param keys in route with path: "'+t+'"'),r[n.name]=!0})),i}function Z(n,i){var r=G(n),o=r.pathList,a=r.pathMap,s=r.nameMap;function l(t,n,r){var l=j(t,n,!1,i),c=l.name;if(c){var d=s[c];if(e(d,"Route with name '"+c+"' does not exist"),!d)return u(null,l);var h=d.regex.keys.filter((function(t){return!t.optional})).map((function(t){return t.name}));if("object"!=typeof l.params&&(l.params={}),n&&"object"==typeof n.params)for(var f in n.params)!(f in l.params)&&h.indexOf(f)>-1&&(l.params[f]=n.params[f]);return l.path=$(d.path,l.params,'named route "'+c+'"'),u(d,l,r)}if(l.path){l.params={};for(var p=0;p<o.length;p++){var m=o[p],v=a[m];if(X(v.regex,l.path,l.params))return u(v,l,r)}}return u(null,l)}function c(n,r){var o=n.redirect,a="function"==typeof o?o(p(n,r,null,i)):o;if("string"==typeof a&&(a={path:a}),!a||"object"!=typeof a)return e(!1,"invalid redirect option: "+JSON.stringify(a)),u(null,r);var c=a,d=c.name,h=c.path,f=r.query,m=r.hash,v=r.params;if(f=c.hasOwnProperty("query")?c.query:f,m=c.hasOwnProperty("hash")?c.hash:m,v=c.hasOwnProperty("params")?c.params:v,d)return t(s[d],'redirect failed: named route "'+d+'" not found.'),l({_normalized:!0,name:d,query:f,hash:m,params:v},void 0,r);if(h){var g=function(t,e){return w(t,e.parent?e.parent.path:"/",!0)}(h,n);return l({_normalized:!0,path:$(g,v,'redirect route with path "'+g+'"'),query:f,hash:m},void 0,r)}return e(!1,"invalid redirect option: "+JSON.stringify(a)),u(null,r)}function u(t,e,n){return t&&t.redirect?c(t,n||e):t&&t.matchAs?function(t,e,n){var i=l({_normalized:!0,path:$(n,e.params,'aliased route with path "'+n+'"')});if(i){var r=i.matched,o=r[r.length-1];return e.params=i.params,u(o,e)}return u(null,e)}(0,e,t.matchAs):p(t,e,n,i)}return{match:l,addRoutes:function(t){G(t,o,a,s)}}}function X(t,e,n){var i=e.match(t);if(!i)return!1;if(!n)return!0;for(var r=1,o=i.length;r<o;++r){var a=t.keys[r-1],s="string"==typeof i[r]?decodeURIComponent(i[r]):i[r];a&&(n[a.name||"pathMatch"]=s)}return!0}var tt=Q&&window.performance&&window.performance.now?window.performance:Date;function et(){return tt.now().toFixed(3)}var nt=et();function it(){return nt}function rt(t){return nt=t}var ot=Object.create(null);function at(){"scrollRestoration"in window.history&&(window.history.scrollRestoration="manual");var t=window.location.protocol+"//"+window.location.host,e=window.location.href.replace(t,""),i=n({},window.history.state);return i.key=it(),window.history.replaceState(i,"",e),window.addEventListener("popstate",ct),function(){window.removeEventListener("popstate",ct)}}function st(e,n,i,r){if(e.app){var o=e.options.scrollBehavior;o&&(t("function"==typeof o,"scrollBehavior must be a function"),e.app.$nextTick((function(){var a=function(){var t=it();if(t)return ot[t]}(),s=o.call(e,n,i,r?a:null);s&&("function"==typeof s.then?s.then((function(t){pt(t,a)})).catch((function(e){t(!1,e.toString())})):pt(s,a))})))}}function lt(){var t=it();t&&(ot[t]={x:window.pageXOffset,y:window.pageYOffset})}function ct(t){lt(),t.state&&t.state.key&&rt(t.state.key)}function ut(t){return ht(t.x)||ht(t.y)}function dt(t){return{x:ht(t.x)?t.x:window.pageXOffset,y:ht(t.y)?t.y:window.pageYOffset}}function ht(t){return"number"==typeof t}var ft=/^#\d/;function pt(t,e){var n="object"==typeof t;if(n&&"string"==typeof t.selector){var i=ft.test(t.selector)?document.getElementById(t.selector.slice(1)):document.querySelector(t.selector);if(i){var r=t.offset&&"object"==typeof t.offset?t.offset:{};e=function(t,e){var n=document.documentElement.getBoundingClientRect(),i=t.getBoundingClientRect();return{x:i.left-n.left-e.x,y:i.top-n.top-e.y}}(i,r=function(t){return{x:ht(t.x)?t.x:0,y:ht(t.y)?t.y:0}}(r))}else ut(t)&&(e=dt(t))}else n&&ut(t)&&(e=dt(t));e&&window.scrollTo(e.x,e.y)}var mt,vt=Q&&((-1===(mt=window.navigator.userAgent).indexOf("Android 2.")&&-1===mt.indexOf("Android 4.0")||-1===mt.indexOf("Mobile Safari")||-1!==mt.indexOf("Chrome")||-1!==mt.indexOf("Windows Phone"))&&window.history&&"function"==typeof window.history.pushState);function gt(t,e){lt();var i=window.history;try{if(e){var r=n({},i.state);r.key=it(),i.replaceState(r,"",t)}else i.pushState({key:rt(et())},"",t)}catch(n){window.location[e?"replace":"assign"](t)}}function yt(t){gt(t,!0)}function _t(t,e,n){var i=function(r){r>=t.length?n():t[r]?e(t[r],(function(){i(r+1)})):i(r+1)};i(0)}var bt={redirected:2,aborted:4,cancelled:8,duplicated:16};function wt(t,e){return xt(t,e,bt.redirected,'Redirected when going from "'+t.fullPath+'" to "'+function(t){if("string"==typeof t)return t;if("path"in t)return t.path;var e={};return Ct.forEach((function(n){n in t&&(e[n]=t[n])})),JSON.stringify(e,null,2)}(e)+'" via a navigation guard.')}function kt(t,e){return xt(t,e,bt.cancelled,'Navigation cancelled from "'+t.fullPath+'" to "'+e.fullPath+'" with a new navigation.')}function xt(t,e,n,i){var r=new Error(i);return r._isRouter=!0,r.from=t,r.to=e,r.type=n,r}var Ct=["params","query","hash"];function St(t){return Object.prototype.toString.call(t).indexOf("Error")>-1}function Mt(t,e){return St(t)&&t._isRouter&&(null==e||t.type===e)}function Tt(t){return function(n,i,r){var o=!1,a=0,s=null;Pt(t,(function(t,n,i,l){if("function"==typeof t&&void 0===t.cid){o=!0,a++;var c,u=Et((function(e){(function(t){return t.__esModule||Bt&&"Module"===t[Symbol.toStringTag]})(e)&&(e=e.default),t.resolved="function"==typeof e?e:z.extend(e),i.components[l]=e,--a<=0&&r()})),d=Et((function(t){var n="Failed to resolve async component "+l+": "+t;e(!1,n),s||(s=St(t)?t:new Error(n),r(s))}));try{c=t(u,d)}catch(t){d(t)}if(c)if("function"==typeof c.then)c.then(u,d);else{var h=c.component;h&&"function"==typeof h.then&&h.then(u,d)}}})),o||r()}}function Pt(t,e){return Ot(t.map((function(t){return Object.keys(t.components).map((function(n){return e(t.components[n],t.instances[n],t,n)}))})))}function Ot(t){return Array.prototype.concat.apply([],t)}var Bt="function"==typeof Symbol&&"symbol"==typeof Symbol.toStringTag;function Et(t){var e=!1;return function(){for(var n=[],i=arguments.length;i--;)n[i]=arguments[i];if(!e)return e=!0,t.apply(this,n)}}var At=function(t,e){this.router=t,this.base=function(t){if(!t)if(Q){var e=document.querySelector("base");t=(t=e&&e.getAttribute("href")||"/").replace(/^https?:\/\/[^\/]+/,"")}else t="/";"/"!==t.charAt(0)&&(t="/"+t);return t.replace(/\/$/,"")}(e),this.current=v,this.pending=null,this.ready=!1,this.readyCbs=[],this.readyErrorCbs=[],this.errorCbs=[],this.listeners=[]};function Dt(t,e,n,i){var r=Pt(t,(function(t,i,r,o){var a=function(t,e){"function"!=typeof t&&(t=z.extend(t));return t.options[e]}(t,e);if(a)return Array.isArray(a)?a.map((function(t){return n(t,i,r,o)})):n(a,i,r,o)}));return Ot(i?r.reverse():r)}function Lt(t,e){if(e)return function(){return t.apply(e,arguments)}}function qt(t,e,n,i){e[n]&&!e[n]._isBeingDestroyed?t(e[n]):i()&&setTimeout((function(){qt(t,e,n,i)}),16)}At.prototype.listen=function(t){this.cb=t},At.prototype.onReady=function(t,e){this.ready?t():(this.readyCbs.push(t),e&&this.readyErrorCbs.push(e))},At.prototype.onError=function(t){this.errorCbs.push(t)},At.prototype.transitionTo=function(t,e,n){var i,r=this;try{i=this.router.match(t,this.current)}catch(t){throw this.errorCbs.forEach((function(e){e(t)})),t}this.confirmTransition(i,(function(){var t=r.current;r.updateRoute(i),e&&e(i),r.ensureURL(),r.router.afterHooks.forEach((function(e){e&&e(i,t)})),r.ready||(r.ready=!0,r.readyCbs.forEach((function(t){t(i)})))}),(function(t){n&&n(t),t&&!r.ready&&(r.ready=!0,Mt(t,bt.redirected)?r.readyCbs.forEach((function(t){t(i)})):r.readyErrorCbs.forEach((function(e){e(t)})))}))},At.prototype.confirmTransition=function(t,n,i){var r,o,a=this,s=this.current,l=function(t){!Mt(t)&&St(t)&&(a.errorCbs.length?a.errorCbs.forEach((function(e){e(t)})):(e(!1,"uncaught error during route navigation:"),console.error(t))),i&&i(t)},c=t.matched.length-1,u=s.matched.length-1;if(_(t,s)&&c===u&&t.matched[c]===s.matched[u])return this.ensureURL(),l(((o=xt(r=s,t,bt.duplicated,'Avoided redundant navigation to current location: "'+r.fullPath+'".')).name="NavigationDuplicated",o));var d=function(t,e){var n,i=Math.max(t.length,e.length);for(n=0;n<i&&t[n]===e[n];n++);return{updated:e.slice(0,n),activated:e.slice(n),deactivated:t.slice(n)}}(this.current.matched,t.matched),h=d.updated,f=d.deactivated,p=d.activated,m=[].concat(function(t){return Dt(t,"beforeRouteLeave",Lt,!0)}(f),this.router.beforeHooks,function(t){return Dt(t,"beforeRouteUpdate",Lt)}(h),p.map((function(t){return t.beforeEnter})),Tt(p));this.pending=t;var v=function(e,n){if(a.pending!==t)return l(kt(s,t));try{e(t,s,(function(e){!1===e?(a.ensureURL(!0),l(function(t,e){return xt(t,e,bt.aborted,'Navigation aborted from "'+t.fullPath+'" to "'+e.fullPath+'" via a navigation guard.')}(s,t))):St(e)?(a.ensureURL(!0),l(e)):"string"==typeof e||"object"==typeof e&&("string"==typeof e.path||"string"==typeof e.name)?(l(wt(s,t)),"object"==typeof e&&e.replace?a.replace(e):a.push(e)):n(e)}))}catch(t){l(t)}};_t(m,v,(function(){var e=[],i=function(t,e,n){return Dt(t,"beforeRouteEnter",(function(t,i,r,o){return function(t,e,n,i,r){return function(o,a,s){return t(o,a,(function(t){"function"==typeof t&&i.push((function(){qt(t,e.instances,n,r)})),s(t)}))}}(t,r,o,e,n)}))}(p,e,(function(){return a.current===t}));_t(i.concat(a.router.resolveHooks),v,(function(){if(a.pending!==t)return l(kt(s,t));a.pending=null,n(t),a.router.app&&a.router.app.$nextTick((function(){e.forEach((function(t){t()}))}))}))}))},At.prototype.updateRoute=function(t){this.current=t,this.cb&&this.cb(t)},At.prototype.setupListeners=function(){},At.prototype.teardownListeners=function(){this.listeners.forEach((function(t){t()})),this.listeners=[]};var Rt=function(t){function e(e,n){t.call(this,e,n),this._startLocation=It(this.base)}return t&&(e.__proto__=t),e.prototype=Object.create(t&&t.prototype),e.prototype.constructor=e,e.prototype.setupListeners=function(){var t=this;if(!(this.listeners.length>0)){var e=this.router,n=e.options.scrollBehavior,i=vt&&n;i&&this.listeners.push(at());var r=function(){var n=t.current,r=It(t.base);t.current===v&&r===t._startLocation||t.transitionTo(r,(function(t){i&&st(e,t,n,!0)}))};window.addEventListener("popstate",r),this.listeners.push((function(){window.removeEventListener("popstate",r)}))}},e.prototype.go=function(t){window.history.go(t)},e.prototype.push=function(t,e,n){var i=this,r=this.current;this.transitionTo(t,(function(t){gt(k(i.base+t.fullPath)),st(i.router,t,r,!1),e&&e(t)}),n)},e.prototype.replace=function(t,e,n){var i=this,r=this.current;this.transitionTo(t,(function(t){yt(k(i.base+t.fullPath)),st(i.router,t,r,!1),e&&e(t)}),n)},e.prototype.ensureURL=function(t){if(It(this.base)!==this.current.fullPath){var e=k(this.base+this.current.fullPath);t?gt(e):yt(e)}},e.prototype.getCurrentLocation=function(){return It(this.base)},e}(At);function It(t){var e=decodeURI(window.location.pathname);return t&&0===e.toLowerCase().indexOf(t.toLowerCase())&&(e=e.slice(t.length)),(e||"/")+window.location.search+window.location.hash}var Nt=function(t){function e(e,n,i){t.call(this,e,n),i&&function(t){var e=It(t);if(!/^\/#/.test(e))return window.location.replace(k(t+"/#"+e)),!0}(this.base)||Ft()}return t&&(e.__proto__=t),e.prototype=Object.create(t&&t.prototype),e.prototype.constructor=e,e.prototype.setupListeners=function(){var t=this;if(!(this.listeners.length>0)){var e=this.router.options.scrollBehavior,n=vt&&e;n&&this.listeners.push(at());var i=function(){var e=t.current;Ft()&&t.transitionTo($t(),(function(i){n&&st(t.router,i,e,!0),vt||Vt(i.fullPath)}))},r=vt?"popstate":"hashchange";window.addEventListener(r,i),this.listeners.push((function(){window.removeEventListener(r,i)}))}},e.prototype.push=function(t,e,n){var i=this,r=this.current;this.transitionTo(t,(function(t){zt(t.fullPath),st(i.router,t,r,!1),e&&e(t)}),n)},e.prototype.replace=function(t,e,n){var i=this,r=this.current;this.transitionTo(t,(function(t){Vt(t.fullPath),st(i.router,t,r,!1),e&&e(t)}),n)},e.prototype.go=function(t){window.history.go(t)},e.prototype.ensureURL=function(t){var e=this.current.fullPath;$t()!==e&&(t?zt(e):Vt(e))},e.prototype.getCurrentLocation=function(){return $t()},e}(At);function Ft(){var t=$t();return"/"===t.charAt(0)||(Vt("/"+t),!1)}function $t(){var t=window.location.href,e=t.indexOf("#");if(e<0)return"";var n=(t=t.slice(e+1)).indexOf("?");if(n<0){var i=t.indexOf("#");t=i>-1?decodeURI(t.slice(0,i))+t.slice(i):decodeURI(t)}else t=decodeURI(t.slice(0,n))+t.slice(n);return t}function jt(t){var e=window.location.href,n=e.indexOf("#");return(n>=0?e.slice(0,n):e)+"#"+t}function zt(t){vt?gt(jt(t)):window.location.hash=t}function Vt(t){vt?yt(jt(t)):window.location.replace(jt(t))}var Ht=function(t){function e(e,n){t.call(this,e,n),this.stack=[],this.index=-1}return t&&(e.__proto__=t),e.prototype=Object.create(t&&t.prototype),e.prototype.constructor=e,e.prototype.push=function(t,e,n){var i=this;this.transitionTo(t,(function(t){i.stack=i.stack.slice(0,i.index+1).concat(t),i.index++,e&&e(t)}),n)},e.prototype.replace=function(t,e,n){var i=this;this.transitionTo(t,(function(t){i.stack=i.stack.slice(0,i.index).concat(t),e&&e(t)}),n)},e.prototype.go=function(t){var e=this,n=this.index+t;if(!(n<0||n>=this.stack.length)){var i=this.stack[n];this.confirmTransition(i,(function(){e.index=n,e.updateRoute(i)}),(function(t){Mt(t,bt.duplicated)&&(e.index=n)}))}},e.prototype.getCurrentLocation=function(){var t=this.stack[this.stack.length-1];return t?t.fullPath:"/"},e.prototype.ensureURL=function(){},e}(At),Wt=function(e){void 0===e&&(e={}),this.app=null,this.apps=[],this.options=e,this.beforeHooks=[],this.resolveHooks=[],this.afterHooks=[],this.matcher=Z(e.routes||[],this);var n=e.mode||"hash";switch(this.fallback="history"===n&&!vt&&!1!==e.fallback,this.fallback&&(n="hash"),Q||(n="abstract"),this.mode=n,n){case"history":this.history=new Rt(this,e.base);break;case"hash":this.history=new Nt(this,e.base,this.fallback);break;case"abstract":this.history=new Ht(this,e.base);break;default:t(!1,"invalid mode: "+n)}},Ut={currentRoute:{configurable:!0}};function Yt(t,e){return t.push(e),function(){var n=t.indexOf(e);n>-1&&t.splice(n,1)}}return Wt.prototype.match=function(t,e,n){return this.matcher.match(t,e,n)},Ut.currentRoute.get=function(){return this.history&&this.history.current},Wt.prototype.init=function(e){var n=this;if(t(Y.installed,"not installed. Make sure to call `Vue.use(VueRouter)` before creating root instance."),this.apps.push(e),e.$once("hook:destroyed",(function(){var t=n.apps.indexOf(e);t>-1&&n.apps.splice(t,1),n.app===e&&(n.app=n.apps[0]||null),n.app||n.history.teardownListeners()})),!this.app){this.app=e;var i=this.history;if(i instanceof Rt||i instanceof Nt){var r=function(t){i.setupListeners(),function(t){var e=i.current,r=n.options.scrollBehavior;vt&&r&&"fullPath"in t&&st(n,t,e,!1)}(t)};i.transitionTo(i.getCurrentLocation(),r,r)}i.listen((function(t){n.apps.forEach((function(e){e._route=t}))}))}},Wt.prototype.beforeEach=function(t){return Yt(this.beforeHooks,t)},Wt.prototype.beforeResolve=function(t){return Yt(this.resolveHooks,t)},Wt.prototype.afterEach=function(t){return Yt(this.afterHooks,t)},Wt.prototype.onReady=function(t,e){this.history.onReady(t,e)},Wt.prototype.onError=function(t){this.history.onError(t)},Wt.prototype.push=function(t,e,n){var i=this;if(!e&&!n&&"undefined"!=typeof Promise)return new Promise((function(e,n){i.history.push(t,e,n)}));this.history.push(t,e,n)},Wt.prototype.replace=function(t,e,n){var i=this;if(!e&&!n&&"undefined"!=typeof Promise)return new Promise((function(e,n){i.history.replace(t,e,n)}));this.history.replace(t,e,n)},Wt.prototype.go=function(t){this.history.go(t)},Wt.prototype.back=function(){this.go(-1)},Wt.prototype.forward=function(){this.go(1)},Wt.prototype.getMatchedComponents=function(t){var e=t?t.matched?t:this.resolve(t).route:this.currentRoute;return e?[].concat.apply([],e.matched.map((function(t){return Object.keys(t.components).map((function(e){return t.components[e]}))}))):[]},Wt.prototype.resolve=function(t,e,n){var i=j(t,e=e||this.history.current,n,this),r=this.match(i,e),o=r.redirectedFrom||r.fullPath,a=function(t,e,n){var i="hash"===n?"#"+e:e;return t?k(t+"/"+i):i}(this.history.base,o,this.mode);return{location:i,route:r,href:a,normalizedTo:i,resolved:r}},Wt.prototype.addRoutes=function(t){this.matcher.addRoutes(t),this.history.current!==v&&this.history.transitionTo(this.history.getCurrentLocation())},Object.defineProperties(Wt.prototype,Ut),Wt.install=Y,Wt.version="3.4.3",Wt.isNavigationFailure=Mt,Wt.NavigationFailureType=bt,Q&&window.Vue&&window.Vue.use(Wt),Wt})),function(t,e){"object"==typeof exports&&"object"==typeof module?module.exports=e():"function"==typeof define&&define.amd?define([],e):"object"==typeof exports?exports.VueQrcodeReader=e():t.VueQrcodeReader=e()}("undefined"!=typeof self?self:this,(function(){return function(t){function e(i){if(n[i])return n[i].exports;var r=n[i]={i:i,l:!1,exports:{}};return t[i].call(r.exports,r,r.exports,e),r.l=!0,r.exports}var n={};return e.m=t,e.c=n,e.d=function(t,n,i){e.o(t,n)||Object.defineProperty(t,n,{configurable:!1,enumerable:!0,get:i})},e.n=function(t){var n=t&&t.__esModule?function(){return t.default}:function(){return t};return e.d(n,"a",n),n},e.o=function(t,e){return Object.prototype.hasOwnProperty.call(t,e)},e.p="",e(e.s=70)}([function(t,e){var n=t.exports={version:"2.6.5"};"number"==typeof __e&&(__e=n)},function(t,e){var n=t.exports="undefined"!=typeof window&&window.Math==Math?window:"undefined"!=typeof self&&self.Math==Math?self:Function("return this")();"number"==typeof __g&&(__g=n)},function(t,e,n){var i=n(34)("wks"),r=n(23),o=n(1).Symbol,a="function"==typeof o;(t.exports=function(t){return i[t]||(i[t]=a&&o[t]||(a?o:r)("Symbol."+t))}).store=i},function(t,e,n){var i=n(1),r=n(0),o=n(13),a=n(9),s=n(10),l=function(t,e,n){var c,u,d,h=t&l.F,f=t&l.G,p=t&l.S,m=t&l.P,v=t&l.B,g=t&l.W,y=f?r:r[e]||(r[e]={}),_=y.prototype,b=f?i:p?i[e]:(i[e]||{}).prototype;for(c in f&&(n=e),n)(u=!h&&b&&void 0!==b[c])&&s(y,c)||(d=u?b[c]:n[c],y[c]=f&&"function"!=typeof b[c]?n[c]:v&&u?o(d,i):g&&b[c]==d?function(t){var e=function(e,n,i){if(this instanceof t){switch(arguments.length){case 0:return new t;case 1:return new t(e);case 2:return new t(e,n)}return new t(e,n,i)}return t.apply(this,arguments)};return e.prototype=t.prototype,e}(d):m&&"function"==typeof d?o(Function.call,d):d,m&&((y.virtual||(y.virtual={}))[c]=d,t&l.R&&_&&!_[c]&&a(_,c,d)))};l.F=1,l.G=2,l.S=4,l.P=8,l.B=16,l.W=32,l.U=64,l.R=128,t.exports=l},function(t,e,n){var i=n(7);t.exports=function(t){if(!i(t))throw TypeError(t+" is not an object!");return t}},function(t,e,n){var i=n(4),r=n(51),o=n(29),a=Object.defineProperty;e.f=n(8)?Object.defineProperty:function(t,e,n){if(i(t),e=o(e,!0),i(n),r)try{return a(t,e,n)}catch(t){}if("get"in n||"set"in n)throw TypeError("Accessors not supported!");return"value"in n&&(t[e]=n.value),t}},function(t,e,n){"use strict";function i(t,e,n){var i=t.match(e);return i&&i.length>=n&&parseInt(i[n],10)}var r=!0,o=!0;t.exports={extractVersion:i,wrapPeerConnectionEvent:function(t,e,n){if(t.RTCPeerConnection){var i=t.RTCPeerConnection.prototype,r=i.addEventListener;i.addEventListener=function(t,i){if(t!==e)return r.apply(this,arguments);var o=function(t){var e=n(t);e&&i(e)};return this._eventMap=this._eventMap||{},this._eventMap[i]=o,r.apply(this,[t,o])};var o=i.removeEventListener;i.removeEventListener=function(t,n){if(t!==e||!this._eventMap||!this._eventMap[n])return o.apply(this,arguments);var i=this._eventMap[n];return delete this._eventMap[n],o.apply(this,[t,i])},Object.defineProperty(i,"on"+e,{get:function(){return this["_on"+e]},set:function(t){this["_on"+e]&&(this.removeEventListener(e,this["_on"+e]),delete this["_on"+e]),t&&this.addEventListener(e,this["_on"+e]=t)},enumerable:!0,configurable:!0})}},disableLog:function(t){return"boolean"!=typeof t?new Error("Argument type: "+typeof t+". Please use a boolean."):(r=t,t?"adapter.js logging disabled":"adapter.js logging enabled")},disableWarnings:function(t){return"boolean"!=typeof t?new Error("Argument type: "+typeof t+". Please use a boolean."):(o=!t,"adapter.js deprecation warnings "+(t?"disabled":"enabled"))},log:function(){if("object"==typeof window){if(r)return;"undefined"!=typeof console&&"function"==typeof console.log&&console.log.apply(console,arguments)}},deprecated:function(t,e){o&&console.warn(t+" is deprecated, please use "+e+" instead.")},detectBrowser:function(t){var e=t&&t.navigator,n={browser:null,version:null};if(void 0===t||!t.navigator)return n.browser="Not a browser.",n;if(e.mozGetUserMedia)n.browser="firefox",n.version=i(e.userAgent,/Firefox\/(\d+)\./,1);else if(e.webkitGetUserMedia)n.browser="chrome",n.version=i(e.userAgent,/Chrom(e|ium)\/(\d+)\./,2);else if(e.mediaDevices&&e.userAgent.match(/Edge\/(\d+).(\d+)$/))n.browser="edge",n.version=i(e.userAgent,/Edge\/(\d+).(\d+)$/,2);else{if(!t.RTCPeerConnection||!e.userAgent.match(/AppleWebKit\/(\d+)\./))return n.browser="Not a supported browser.",n;n.browser="safari",n.version=i(e.userAgent,/AppleWebKit\/(\d+)\./,1)}return n}}},function(t,e){t.exports=function(t){return"object"==typeof t?null!==t:"function"==typeof t}},function(t,e,n){t.exports=!n(18)((function(){return 7!=Object.defineProperty({},"a",{get:function(){return 7}}).a}))},function(t,e,n){var i=n(5),r=n(19);t.exports=n(8)?function(t,e,n){return i.f(t,e,r(1,n))}:function(t,e,n){return t[e]=n,t}},function(t,e){var n={}.hasOwnProperty;t.exports=function(t,e){return n.call(t,e)}},function(t,e,n){t.exports=n(95)},function(t,e,n){"use strict";e.__esModule=!0;var i=function(t){return t&&t.__esModule?t:{default:t}}(n(48));e.default=function(t){return function(){var e=t.apply(this,arguments);return new i.default((function(t,n){return function r(o,a){try{var s=e[o](a),l=s.value}catch(t){return void n(t)}if(!s.done)return i.default.resolve(l).then((function(t){r("next",t)}),(function(t){r("throw",t)}));t(l)}("next")}))}}},function(t,e,n){var i=n(22);t.exports=function(t,e,n){if(i(t),void 0===e)return t;switch(n){case 1:return function(n){return t.call(e,n)};case 2:return function(n,i){return t.call(e,n,i)};case 3:return function(n,i,r){return t.call(e,n,i,r)}}return function(){return t.apply(e,arguments)}}},function(t,e){t.exports={}},function(t,e,n){var i=n(79),r=n(27);t.exports=function(t){return i(r(t))}},function(t,e,n){"use strict";var i=n(76)(!0);n(50)(String,"String",(function(t){this._t=String(t),this._i=0}),(function(){var t,e=this._t,n=this._i;return n>=e.length?{value:void 0,done:!0}:(t=i(e,n),this._i+=t.length,{value:t,done:!1})}))},function(t,e){t.exports=!0},function(t,e){t.exports=function(t){try{return!!t()}catch(t){return!0}}},function(t,e){t.exports=function(t,e){return{enumerable:!(1&t),configurable:!(2&t),writable:!(4&t),value:e}}},function(t,e){var n={}.toString;t.exports=function(t){return n.call(t).slice(8,-1)}},function(t,e){t.exports=function(t,e,n,i){var r,o=t=t||{},a=typeof t.default;"object"!==a&&"function"!==a||(r=t,o=t.default);var s="function"==typeof o?o.options:o;if(e&&(s.render=e.render,s.staticRenderFns=e.staticRenderFns),n&&(s._scopeId=n),i){var l=s.computed||(s.computed={});Object.keys(i).forEach((function(t){var e=i[t];l[t]=function(){return e}}))}return{esModule:r,exports:o,options:s}}},function(t,e){t.exports=function(t){if("function"!=typeof t)throw TypeError(t+" is not a function!");return t}},function(t,e){var n=0,i=Math.random();t.exports=function(t){return"Symbol(".concat(void 0===t?"":t,")_",(++n+i).toString(36))}},function(t,e,n){var i=n(5).f,r=n(10),o=n(2)("toStringTag");t.exports=function(t,e,n){t&&!r(t=n?t:t.prototype,o)&&i(t,o,{configurable:!0,value:e})}},function(t,e,n){n(82);for(var i=n(1),r=n(9),o=n(14),a=n(2)("toStringTag"),s="CSSRuleList,CSSStyleDeclaration,CSSValueList,ClientRectList,DOMRectList,DOMStringList,DOMTokenList,DataTransferItemList,FileList,HTMLAllCollection,HTMLCollection,HTMLFormElement,HTMLSelectElement,MediaList,MimeTypeArray,NamedNodeMap,NodeList,PaintRequestList,Plugin,PluginArray,SVGLengthList,SVGNumberList,SVGPathSegList,SVGPointList,SVGStringList,SVGTransformList,SourceBufferList,StyleSheetList,TextTrackCueList,TextTrackList,TouchList".split(","),l=0;l<s.length;l++){var c=s[l],u=i[c],d=u&&u.prototype;d&&!d[a]&&r(d,a,c),o[c]=o.Array}},function(t,e){var n=Math.ceil,i=Math.floor;t.exports=function(t){return isNaN(t=+t)?0:(t>0?i:n)(t)}},function(t,e){t.exports=function(t){if(null==t)throw TypeError("Can't call method on  "+t);return t}},function(t,e,n){var i=n(7),r=n(1).document,o=i(r)&&i(r.createElement);t.exports=function(t){return o?r.createElement(t):{}}},function(t,e,n){var i=n(7);t.exports=function(t,e){if(!i(t))return t;var n,r;if(e&&"function"==typeof(n=t.toString)&&!i(r=n.call(t)))return r;if("function"==typeof(n=t.valueOf)&&!i(r=n.call(t)))return r;if(!e&&"function"==typeof(n=t.toString)&&!i(r=n.call(t)))return r;throw TypeError("Can't convert object to primitive value")}},function(t,e,n){var i=n(4),r=n(78),o=n(35),a=n(33)("IE_PROTO"),s=function(){},l=function(){var t,e=n(28)("iframe"),i=o.length;for(e.style.display="none",n(54).appendChild(e),e.src="javascript:",(t=e.contentWindow.document).open(),t.write("<script>document.F=Object<\/script>"),t.close(),l=t.F;i--;)delete l.prototype[o[i]];return l()};t.exports=Object.create||function(t,e){var n;return null!==t?(s.prototype=i(t),n=new s,s.prototype=null,n[a]=t):n=l(),void 0===e?n:r(n,e)}},function(t,e,n){var i=n(53),r=n(35);t.exports=Object.keys||function(t){return i(t,r)}},function(t,e,n){var i=n(26),r=Math.min;t.exports=function(t){return t>0?r(i(t),9007199254740991):0}},function(t,e,n){var i=n(34)("keys"),r=n(23);t.exports=function(t){return i[t]||(i[t]=r(t))}},function(t,e,n){var i=n(0),r=n(1),o=r["__core-js_shared__"]||(r["__core-js_shared__"]={});(t.exports=function(t,e){return o[t]||(o[t]=void 0!==e?e:{})})("versions",[]).push({version:i.version,mode:n(17)?"pure":"global",copyright:"© 2019 Denis Pushkarev (zloirock.ru)"})},function(t,e){t.exports="constructor,hasOwnProperty,isPrototypeOf,propertyIsEnumerable,toLocaleString,toString,valueOf".split(",")},function(t,e,n){var i=n(27);t.exports=function(t){return Object(i(t))}},function(t,e,n){var i=n(20),r=n(2)("toStringTag"),o="Arguments"==i(function(){return arguments}());t.exports=function(t){var e,n,a;return void 0===t?"Undefined":null===t?"Null":"string"==typeof(n=function(t,e){try{return t[e]}catch(t){}}(e=Object(t),r))?n:o?i(e):"Object"==(a=i(e))&&"function"==typeof e.callee?"Arguments":a}},function(t,e,n){var i=n(37),r=n(2)("iterator"),o=n(14);t.exports=n(0).getIteratorMethod=function(t){if(null!=t)return t[r]||t["@@iterator"]||o[i(t)]}},function(t,e,n){"use strict";function i(t){var e,n;this.promise=new t((function(t,i){if(void 0!==e||void 0!==n)throw TypeError("Bad Promise constructor");e=t,n=i})),this.resolve=r(e),this.reject=r(n)}var r=n(22);t.exports.f=function(t){return new i(t)}},function(t,e,n){"use strict";n.d(e,"b",(function(){return l})),e.a=function(t,e,n){var i=n.detectHandler,r=n.locateHandler,o=n.minDelay,a=null,s=null,l=performance.now(),c=new t,u=!1,d=!0;return c.onmessage=function(t){u=!1;var e=t.data,n=e.content,o=e.location;null!==n&&n!==a&&i(t.data),o!==s&&r(o),a=n||a,s=o},function t(n){if(d){if(window.requestAnimationFrame(t),n-l>=o&&(l=n,!1===u)){u=!0;var i=e.captureFrame();c.postMessage(i,[i.data.buffer])}}else c.terminate()}(),function(){d=!1}};var i=n(11),r=n.n(i),o=n(12),a=n.n(o),s=n(41),l=function(){var t=a()(r.a.mark((function t(e,n){var i,o;return r.a.wrap((function(t){for(;;)switch(t.prev=t.next){case 0:return(i=new e).postMessage(n,[n.data.buffer]),t.next=4,Object(s.a)(i,"message");case 4:return o=t.sent,i.terminate(),t.abrupt("return",o.data);case 7:case"end":return t.stop()}}),t,this)})));return function(e,n){return t.apply(this,arguments)}}()},function(t,e,n){"use strict";function i(t,e,n){var i,r;void 0===n&&(n="error");var o=new Promise((function(t,e){i=t,r=e}));return t.addEventListener(e,i),t.addEventListener(n,r),o.finally((function(){t.removeEventListener(e,i),t.removeEventListener(n,r)})),o}n.d(e,"a",(function(){return i}))},function(t,e,n){e.f=n(2)},function(t,e,n){var i=n(1),r=n(0),o=n(17),a=n(42),s=n(5).f;t.exports=function(t){var e=r.Symbol||(r.Symbol=o?{}:i.Symbol||{});"_"==t.charAt(0)||t in e||s(e,t,{value:a.f(t)})}},function(t,e){e.f={}.propertyIsEnumerable},function(t,e,n){"use strict";function i(t,e,n){var i=Math.min(1,d.width/e,d.height/n),r=i*e,o=i*n;return h.drawImage(t,0,0,r,o),h.getImageData(0,0,r,o)}function r(t){return i(t,t.naturalWidth,t.naturalHeight)}e.c=function(t){return i(t,t.videoWidth,t.videoHeight)},n.d(e,"b",(function(){return f})),n.d(e,"a",(function(){return p}));var o=n(11),a=n.n(o),s=n(12),l=n.n(s),c=n(64),u=n(41),d=document.createElement("canvas"),h=d.getContext("2d");d.width=1920,d.height=1080;var f=function(){var t=l()(a.a.mark((function t(e){var n;return a.a.wrap((function(t){for(;;)switch(t.prev=t.next){case 0:if(!e.startsWith("http")||!1!==e.includes(location.host)){t.next=2;break}throw new c.b;case 2:return(n=document.createElement("img")).src=e,t.next=6,Object(u.a)(n,"load");case 6:return t.abrupt("return",r(n));case 7:case"end":return t.stop()}}),t,this)})));return function(e){return t.apply(this,arguments)}}(),p=function(){var t=l()(a.a.mark((function t(e){var n,i,r;return a.a.wrap((function(t){for(;;)switch(t.prev=t.next){case 0:if(!/image.*/.test(e.type)){t.next=10;break}return(n=new FileReader).readAsDataURL(e),t.next=5,Object(u.a)(n,"load");case 5:return i=t.sent,r=i.target.result,t.abrupt("return",f(r));case 10:throw new c.a;case 11:case"end":return t.stop()}}),t,this)})));return function(e){return t.apply(this,arguments)}}()},function(t,e,n){var i=n(21)(n(147),null,null,null);t.exports=i.exports},function(t,e,n){t.exports=function(){return n(148)('!function(o){function e(t){if(r[t])return r[t].exports;var c=r[t]={i:t,l:!1,exports:{}};return o[t].call(c.exports,c,c.exports,e),c.l=!0,c.exports}var r={};e.m=o,e.c=r,e.d=function(o,r,t){e.o(o,r)||Object.defineProperty(o,r,{configurable:!1,enumerable:!0,get:t})},e.n=function(o){var r=o&&o.__esModule?function(){return o.default}:function(){return o};return e.d(r,"a",r),r},e.o=function(o,e){return Object.prototype.hasOwnProperty.call(o,e)},e.p="",e(e.s=0)}([function(o,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var t=r(1),c=r.n(t);self.addEventListener("message",function(o){var e=o.data,r=c()(e.data,e.width,e.height,{inversionAttempts:"dontInvert"}),t=null,s=null;null!==r&&(t=r.data,s=r.location);var a={content:t,location:s,imageData:e};self.postMessage(a,[e.data.buffer])})},function(o,e,r){!function(e,r){o.exports=r()}("undefined"!=typeof self&&self,function(){return function(o){function e(t){if(r[t])return r[t].exports;var c=r[t]={i:t,l:!1,exports:{}};return o[t].call(c.exports,c,c.exports,e),c.l=!0,c.exports}var r={};return e.m=o,e.c=r,e.d=function(o,r,t){e.o(o,r)||Object.defineProperty(o,r,{configurable:!1,enumerable:!0,get:t})},e.n=function(o){var r=o&&o.__esModule?function(){return o.default}:function(){return o};return e.d(r,"a",r),r},e.o=function(o,e){return Object.prototype.hasOwnProperty.call(o,e)},e.p="",e(e.s=3)}([function(o,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var t=function(){function o(o,e){this.width=e,this.height=o.length/e,this.data=o}return o.createEmpty=function(e,r){return new o(new Uint8ClampedArray(e*r),e)},o.prototype.get=function(o,e){return!(o<0||o>=this.width||e<0||e>=this.height)&&!!this.data[e*this.width+o]},o.prototype.set=function(o,e,r){this.data[e*this.width+o]=r?1:0},o.prototype.setRegion=function(o,e,r,t,c){for(var s=e;s<e+t;s++)for(var a=o;a<o+r;a++)this.set(a,s,!!c)},o}();e.BitMatrix=t},function(o,e,r){"use strict";function t(o,e){return o^e}Object.defineProperty(e,"__esModule",{value:!0});var c=r(2);e.addOrSubtractGF=t;var s=function(){function o(o,e,r){this.primitive=o,this.size=e,this.generatorBase=r,this.expTable=new Array(this.size),this.logTable=new Array(this.size);for(var t=1,s=0;s<this.size;s++)this.expTable[s]=t,(t*=2)>=this.size&&(t=(t^this.primitive)&this.size-1);for(var s=0;s<this.size-1;s++)this.logTable[this.expTable[s]]=s;this.zero=new c.default(this,Uint8ClampedArray.from([0])),this.one=new c.default(this,Uint8ClampedArray.from([1]))}return o.prototype.multiply=function(o,e){return 0===o||0===e?0:this.expTable[(this.logTable[o]+this.logTable[e])%(this.size-1)]},o.prototype.inverse=function(o){if(0===o)throw new Error("Can\'t invert 0");return this.expTable[this.size-this.logTable[o]-1]},o.prototype.buildMonomial=function(o,e){if(o<0)throw new Error("Invalid monomial degree less than 0");if(0===e)return this.zero;var r=new Uint8ClampedArray(o+1);return r[0]=e,new c.default(this,r)},o.prototype.log=function(o){if(0===o)throw new Error("Can\'t take log(0)");return this.logTable[o]},o.prototype.exp=function(o){return this.expTable[o]},o}();e.default=s},function(o,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var t=r(1),c=function(){function o(o,e){if(0===e.length)throw new Error("No coefficients.");this.field=o;var r=e.length;if(r>1&&0===e[0]){for(var t=1;t<r&&0===e[t];)t++;if(t===r)this.coefficients=o.zero.coefficients;else{this.coefficients=new Uint8ClampedArray(r-t);for(var c=0;c<this.coefficients.length;c++)this.coefficients[c]=e[t+c]}}else this.coefficients=e}return o.prototype.degree=function(){return this.coefficients.length-1},o.prototype.isZero=function(){return 0===this.coefficients[0]},o.prototype.getCoefficient=function(o){return this.coefficients[this.coefficients.length-1-o]},o.prototype.addOrSubtract=function(e){if(this.isZero())return e;if(e.isZero())return this;var r=this.coefficients,c=e.coefficients;r.length>c.length&&(d=[c,r],r=d[0],c=d[1]);for(var s=new Uint8ClampedArray(c.length),a=c.length-r.length,n=0;n<a;n++)s[n]=c[n];for(var n=a;n<c.length;n++)s[n]=t.addOrSubtractGF(r[n-a],c[n]);return new o(this.field,s);var d},o.prototype.multiply=function(e){if(0===e)return this.field.zero;if(1===e)return this;for(var r=this.coefficients.length,t=new Uint8ClampedArray(r),c=0;c<r;c++)t[c]=this.field.multiply(this.coefficients[c],e);return new o(this.field,t)},o.prototype.multiplyPoly=function(e){if(this.isZero()||e.isZero())return this.field.zero;for(var r=this.coefficients,c=r.length,s=e.coefficients,a=s.length,n=new Uint8ClampedArray(c+a-1),d=0;d<c;d++)for(var l=r[d],i=0;i<a;i++)n[d+i]=t.addOrSubtractGF(n[d+i],this.field.multiply(l,s[i]));return new o(this.field,n)},o.prototype.multiplyByMonomial=function(e,r){if(e<0)throw new Error("Invalid degree less than 0");if(0===r)return this.field.zero;for(var t=this.coefficients.length,c=new Uint8ClampedArray(t+e),s=0;s<t;s++)c[s]=this.field.multiply(this.coefficients[s],r);return new o(this.field,c)},o.prototype.evaluateAt=function(o){var e=0;if(0===o)return this.getCoefficient(0);var r=this.coefficients.length;if(1===o)return this.coefficients.forEach(function(o){e=t.addOrSubtractGF(e,o)}),e;e=this.coefficients[0];for(var c=1;c<r;c++)e=t.addOrSubtractGF(this.field.multiply(o,e),this.coefficients[c]);return e},o}();e.default=c},function(o,e,r){"use strict";function t(o){var e=d.locate(o);if(!e)return null;var r=n.extract(o,e),t=a.decode(r.matrix);return t?{binaryData:t.bytes,data:t.text,chunks:t.chunks,location:{topRightCorner:r.mappingFunction(e.dimension,0),topLeftCorner:r.mappingFunction(0,0),bottomRightCorner:r.mappingFunction(e.dimension,e.dimension),bottomLeftCorner:r.mappingFunction(0,e.dimension),topRightFinderPattern:e.topRight,topLeftFinderPattern:e.topLeft,bottomLeftFinderPattern:e.bottomLeft,bottomRightAlignmentPattern:e.alignmentPattern}}:null}function c(o,e,r,c){void 0===c&&(c={});var a=l;Object.keys(a||{}).forEach(function(o){a[o]=c[o]||a[o]});var n="attemptBoth"===a.inversionAttempts||"invertFirst"===a.inversionAttempts,d="onlyInvert"===a.inversionAttempts||"invertFirst"===a.inversionAttempts,i=s.binarize(o,e,r,n),B=i.binarized,k=i.inverted,u=t(d?k:B);return u||"attemptBoth"!==a.inversionAttempts&&"invertFirst"!==a.inversionAttempts||(u=t(d?B:k)),u}Object.defineProperty(e,"__esModule",{value:!0});var s=r(4),a=r(5),n=r(11),d=r(12),l={inversionAttempts:"attemptBoth"};c.default=c,e.default=c},function(o,e,r){"use strict";function t(o,e,r){return o<e?e:o>r?r:o}function c(o,e,r,c){if(o.length!==e*r*4)throw new Error("Malformed data passed to binarizer.");for(var l=new d(e,r),i=0;i<e;i++)for(var B=0;B<r;B++){var k=o[4*(B*e+i)+0],u=o[4*(B*e+i)+1],C=o[4*(B*e+i)+2];l.set(i,B,.2126*k+.7152*u+.0722*C)}for(var m=Math.ceil(e/a),f=Math.ceil(r/a),w=new d(m,f),P=0;P<f;P++)for(var v=0;v<m;v++){for(var h=0,p=1/0,b=0,B=0;B<a;B++)for(var i=0;i<a;i++){var y=l.get(v*a+i,P*a+B);h+=y,p=Math.min(p,y),b=Math.max(b,y)}var g=h/Math.pow(a,2);if(b-p<=n&&(g=p/2,P>0&&v>0)){var x=(w.get(v,P-1)+2*w.get(v-1,P)+w.get(v-1,P-1))/4;p<x&&(g=x)}w.set(v,P,g)}var M=s.BitMatrix.createEmpty(e,r),L=null;c&&(L=s.BitMatrix.createEmpty(e,r));for(var P=0;P<f;P++)for(var v=0;v<m;v++){for(var N=t(v,2,m-3),I=t(P,2,f-3),h=0,O=-2;O<=2;O++)for(var z=-2;z<=2;z++)h+=w.get(N+O,I+z);for(var S=h/25,O=0;O<a;O++)for(var z=0;z<a;z++){var i=v*a+O,B=P*a+z,X=l.get(i,B);M.set(i,B,X<=S),c&&L.set(i,B,!(X<=S))}}return c?{binarized:M,inverted:L}:{binarized:M}}Object.defineProperty(e,"__esModule",{value:!0});var s=r(0),a=8,n=24,d=function(){function o(o,e){this.width=o,this.data=new Uint8ClampedArray(o*e)}return o.prototype.get=function(o,e){return this.data[e*this.width+o]},o.prototype.set=function(o,e,r){this.data[e*this.width+o]=r},o}();e.binarize=c},function(o,e,r){"use strict";function t(o,e){for(var r=o^e,t=0;r;)t++,r&=r-1;return t}function c(o,e){return e<<1|o}function s(o){var e=17+4*o.versionNumber,r=k.BitMatrix.createEmpty(e,e);r.setRegion(0,0,9,9,!0),r.setRegion(e-8,0,8,9,!0),r.setRegion(0,e-8,9,8,!0);for(var t=0,c=o.alignmentPatternCenters;t<c.length;t++)for(var s=c[t],a=0,n=o.alignmentPatternCenters;a<n.length;a++){var d=n[a];6===s&&6===d||6===s&&d===e-7||s===e-7&&6===d||r.setRegion(s-2,d-2,5,5,!0)}return r.setRegion(6,9,1,e-17,!0),r.setRegion(9,6,e-17,1,!0),o.versionNumber>6&&(r.setRegion(e-11,0,3,6,!0),r.setRegion(0,e-11,6,3,!0)),r}function a(o,e,r){for(var t=w[r.dataMask],a=o.height,n=s(e),d=[],l=0,i=0,B=!0,k=a-1;k>0;k-=2){6===k&&k--;for(var u=0;u<a;u++)for(var C=B?a-1-u:u,m=0;m<2;m++){var f=k-m;if(!n.get(f,C)){i++;var P=o.get(f,C);t({y:C,x:f})&&(P=!P),l=c(P,l),8===i&&(d.push(l),i=0,l=0)}}B=!B}return d}function n(o){var e=o.height,r=Math.floor((e-17)/4);if(r<=6)return m.VERSIONS[r-1];for(var s=0,a=5;a>=0;a--)for(var n=e-9;n>=e-11;n--)s=c(o.get(n,a),s);for(var d=0,n=5;n>=0;n--)for(var a=e-9;a>=e-11;a--)d=c(o.get(n,a),d);for(var l,i=1/0,B=0,k=m.VERSIONS;B<k.length;B++){var u=k[B];if(u.infoBits===s||u.infoBits===d)return u;var C=t(s,u.infoBits);C<i&&(l=u,i=C),C=t(d,u.infoBits),C<i&&(l=u,i=C)}return i<=3?l:void 0}function d(o){for(var e=0,r=0;r<=8;r++)6!==r&&(e=c(o.get(r,8),e));for(var s=7;s>=0;s--)6!==s&&(e=c(o.get(8,s),e));for(var a=o.height,n=0,s=a-1;s>=a-7;s--)n=c(o.get(8,s),n);for(var r=a-8;r<a;r++)n=c(o.get(r,8),n);for(var d=1/0,l=null,i=0,B=f;i<B.length;i++){var k=B[i],u=k.bits,C=k.formatInfo;if(u===e||u===n)return C;var m=t(e,u);m<d&&(l=C,d=m),e!==n&&(m=t(n,u))<d&&(l=C,d=m)}return d<=3?l:null}function l(o,e,r){var t=e.errorCorrectionLevels[r],c=[],s=0;if(t.ecBlocks.forEach(function(o){for(var e=0;e<o.numBlocks;e++)c.push({numDataCodewords:o.dataCodewordsPerBlock,codewords:[]}),s+=o.dataCodewordsPerBlock+t.ecCodewordsPerBlock}),o.length<s)return null;o=o.slice(0,s);for(var a=t.ecBlocks[0].dataCodewordsPerBlock,n=0;n<a;n++)for(var d=0,l=c;d<l.length;d++){var i=l[d];i.codewords.push(o.shift())}if(t.ecBlocks.length>1)for(var B=t.ecBlocks[0].numBlocks,k=t.ecBlocks[1].numBlocks,n=0;n<k;n++)c[B+n].codewords.push(o.shift());for(;o.length>0;)for(var u=0,C=c;u<C.length;u++){var i=C[u];i.codewords.push(o.shift())}return c}function i(o){var e=n(o);if(!e)return null;var r=d(o);if(!r)return null;var t=a(o,e,r),c=l(t,e,r.errorCorrectionLevel);if(!c)return null;for(var s=c.reduce(function(o,e){return o+e.numDataCodewords},0),i=new Uint8ClampedArray(s),B=0,k=0,m=c;k<m.length;k++){var f=m[k],w=C.decode(f.codewords,f.codewords.length-f.numDataCodewords);if(!w)return null;for(var P=0;P<f.numDataCodewords;P++)i[B++]=w[P]}try{return u.decode(i,e.versionNumber)}catch(o){return null}}function B(o){if(null==o)return null;var e=i(o);if(e)return e;for(var r=0;r<o.width;r++)for(var t=r+1;t<o.height;t++)o.get(r,t)!==o.get(t,r)&&(o.set(r,t,!o.get(r,t)),o.set(t,r,!o.get(t,r)));return i(o)}Object.defineProperty(e,"__esModule",{value:!0});var k=r(0),u=r(6),C=r(9),m=r(10),f=[{bits:21522,formatInfo:{errorCorrectionLevel:1,dataMask:0}},{bits:20773,formatInfo:{errorCorrectionLevel:1,dataMask:1}},{bits:24188,formatInfo:{errorCorrectionLevel:1,dataMask:2}},{bits:23371,formatInfo:{errorCorrectionLevel:1,dataMask:3}},{bits:17913,formatInfo:{errorCorrectionLevel:1,dataMask:4}},{bits:16590,formatInfo:{errorCorrectionLevel:1,dataMask:5}},{bits:20375,formatInfo:{errorCorrectionLevel:1,dataMask:6}},{bits:19104,formatInfo:{errorCorrectionLevel:1,dataMask:7}},{bits:30660,formatInfo:{errorCorrectionLevel:0,dataMask:0}},{bits:29427,formatInfo:{errorCorrectionLevel:0,dataMask:1}},{bits:32170,formatInfo:{errorCorrectionLevel:0,dataMask:2}},{bits:30877,formatInfo:{errorCorrectionLevel:0,dataMask:3}},{bits:26159,formatInfo:{errorCorrectionLevel:0,dataMask:4}},{bits:25368,formatInfo:{errorCorrectionLevel:0,dataMask:5}},{bits:27713,formatInfo:{errorCorrectionLevel:0,dataMask:6}},{bits:26998,formatInfo:{errorCorrectionLevel:0,dataMask:7}},{bits:5769,formatInfo:{errorCorrectionLevel:3,dataMask:0}},{bits:5054,formatInfo:{errorCorrectionLevel:3,dataMask:1}},{bits:7399,formatInfo:{errorCorrectionLevel:3,dataMask:2}},{bits:6608,formatInfo:{errorCorrectionLevel:3,dataMask:3}},{bits:1890,formatInfo:{errorCorrectionLevel:3,dataMask:4}},{bits:597,formatInfo:{errorCorrectionLevel:3,dataMask:5}},{bits:3340,formatInfo:{errorCorrectionLevel:3,dataMask:6}},{bits:2107,formatInfo:{errorCorrectionLevel:3,dataMask:7}},{bits:13663,formatInfo:{errorCorrectionLevel:2,dataMask:0}},{bits:12392,formatInfo:{errorCorrectionLevel:2,dataMask:1}},{bits:16177,formatInfo:{errorCorrectionLevel:2,dataMask:2}},{bits:14854,formatInfo:{errorCorrectionLevel:2,dataMask:3}},{bits:9396,formatInfo:{errorCorrectionLevel:2,dataMask:4}},{bits:8579,formatInfo:{errorCorrectionLevel:2,dataMask:5}},{bits:11994,formatInfo:{errorCorrectionLevel:2,dataMask:6}},{bits:11245,formatInfo:{errorCorrectionLevel:2,dataMask:7}}],w=[function(o){return(o.y+o.x)%2==0},function(o){return o.y%2==0},function(o){return o.x%3==0},function(o){return(o.y+o.x)%3==0},function(o){return(Math.floor(o.y/2)+Math.floor(o.x/3))%2==0},function(o){return o.x*o.y%2+o.x*o.y%3==0},function(o){return(o.y*o.x%2+o.y*o.x%3)%2==0},function(o){return((o.y+o.x)%2+o.y*o.x%3)%2==0}];e.decode=B},function(o,e,r){"use strict";function t(o,e){for(var r=[],t="",c=[10,12,14][e],s=o.readBits(c);s>=3;){var a=o.readBits(10);if(a>=1e3)throw new Error("Invalid numeric value above 999");var n=Math.floor(a/100),d=Math.floor(a/10)%10,l=a%10;r.push(48+n,48+d,48+l),t+=n.toString()+d.toString()+l.toString(),s-=3}if(2===s){var a=o.readBits(7);if(a>=100)throw new Error("Invalid numeric value above 99");var n=Math.floor(a/10),d=a%10;r.push(48+n,48+d),t+=n.toString()+d.toString()}else if(1===s){var a=o.readBits(4);if(a>=10)throw new Error("Invalid numeric value above 9");r.push(48+a),t+=a.toString()}return{bytes:r,text:t}}function c(o,e){for(var r=[],t="",c=[9,11,13][e],s=o.readBits(c);s>=2;){var a=o.readBits(11),n=Math.floor(a/45),d=a%45;r.push(k[n].charCodeAt(0),k[d].charCodeAt(0)),t+=k[n]+k[d],s-=2}if(1===s){var n=o.readBits(6);r.push(k[n].charCodeAt(0)),t+=k[n]}return{bytes:r,text:t}}function s(o,e){for(var r=[],t="",c=[8,16,16][e],s=o.readBits(c),a=0;a<s;a++){var n=o.readBits(8);r.push(n)}try{t+=decodeURIComponent(r.map(function(o){return"%"+("0"+o.toString(16)).substr(-2)}).join(""))}catch(o){}return{bytes:r,text:t}}function a(o,e){for(var r=[],t="",c=[8,10,12][e],s=o.readBits(c),a=0;a<s;a++){var n=o.readBits(13),d=Math.floor(n/192)<<8|n%192;d+=d<7936?33088:49472,r.push(d>>8,255&d),t+=String.fromCharCode(i.shiftJISTable[d])}return{bytes:r,text:t}}function n(o,e){for(var r=new l.BitStream(o),n=e<=9?0:e<=26?1:2,i={text:"",bytes:[],chunks:[]};r.available()>=4;){var k=r.readBits(4);if(k===B.Terminator)return i;if(k===B.ECI)0===r.readBits(1)?i.chunks.push({type:d.ECI,assignmentNumber:r.readBits(7)}):0===r.readBits(1)?i.chunks.push({type:d.ECI,assignmentNumber:r.readBits(14)}):0===r.readBits(1)?i.chunks.push({type:d.ECI,assignmentNumber:r.readBits(21)}):i.chunks.push({type:d.ECI,assignmentNumber:-1});else if(k===B.Numeric){var u=t(r,n);i.text+=u.text,(w=i.bytes).push.apply(w,u.bytes),i.chunks.push({type:d.Numeric,text:u.text})}else if(k===B.Alphanumeric){var C=c(r,n);i.text+=C.text,(P=i.bytes).push.apply(P,C.bytes),i.chunks.push({type:d.Alphanumeric,text:C.text})}else if(k===B.Byte){var m=s(r,n);i.text+=m.text,(v=i.bytes).push.apply(v,m.bytes),i.chunks.push({type:d.Byte,bytes:m.bytes,text:m.text})}else if(k===B.Kanji){var f=a(r,n);i.text+=f.text,(h=i.bytes).push.apply(h,f.bytes),i.chunks.push({type:d.Kanji,bytes:f.bytes,text:f.text})}}var w,P,v,h}Object.defineProperty(e,"__esModule",{value:!0});var d,l=r(7),i=r(8);!function(o){o.Numeric="numeric",o.Alphanumeric="alphanumeric",o.Byte="byte",o.Kanji="kanji",o.ECI="eci"}(d=e.Mode||(e.Mode={}));var B;!function(o){o[o.Terminator=0]="Terminator",o[o.Numeric=1]="Numeric",o[o.Alphanumeric=2]="Alphanumeric",o[o.Byte=4]="Byte",o[o.Kanji=8]="Kanji",o[o.ECI=7]="ECI"}(B||(B={}));var k=["0","1","2","3","4","5","6","7","8","9","A","B","C","D","E","F","G","H","I","J","K","L","M","N","O","P","Q","R","S","T","U","V","W","X","Y","Z"," ","$","%","*","+","-",".","/",":"];e.decode=n},function(o,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var t=function(){function o(o){this.byteOffset=0,this.bitOffset=0,this.bytes=o}return o.prototype.readBits=function(o){if(o<1||o>32||o>this.available())throw new Error("Cannot read "+o.toString()+" bits");var e=0;if(this.bitOffset>0){var r=8-this.bitOffset,t=o<r?o:r,c=r-t,s=255>>8-t<<c;e=(this.bytes[this.byteOffset]&s)>>c,o-=t,this.bitOffset+=t,8===this.bitOffset&&(this.bitOffset=0,this.byteOffset++)}if(o>0){for(;o>=8;)e=e<<8|255&this.bytes[this.byteOffset],this.byteOffset++,o-=8;if(o>0){var c=8-o,s=255>>c<<c;e=e<<o|(this.bytes[this.byteOffset]&s)>>c,this.bitOffset+=o}}return e},o.prototype.available=function(){return 8*(this.bytes.length-this.byteOffset)-this.bitOffset},o}();e.BitStream=t},function(o,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.shiftJISTable={32:32,33:33,34:34,35:35,36:36,37:37,38:38,39:39,40:40,41:41,42:42,43:43,44:44,45:45,46:46,47:47,48:48,49:49,50:50,51:51,52:52,53:53,54:54,55:55,56:56,57:57,58:58,59:59,60:60,61:61,62:62,63:63,64:64,65:65,66:66,67:67,68:68,69:69,70:70,71:71,72:72,73:73,74:74,75:75,76:76,77:77,78:78,79:79,80:80,81:81,82:82,83:83,84:84,85:85,86:86,87:87,88:88,89:89,90:90,91:91,92:165,93:93,94:94,95:95,96:96,97:97,98:98,99:99,100:100,101:101,102:102,103:103,104:104,105:105,106:106,107:107,108:108,109:109,110:110,111:111,112:112,113:113,114:114,115:115,116:116,117:117,118:118,119:119,120:120,121:121,122:122,123:123,124:124,125:125,126:8254,33088:12288,33089:12289,33090:12290,33091:65292,33092:65294,33093:12539,33094:65306,33095:65307,33096:65311,33097:65281,33098:12443,33099:12444,33100:180,33101:65344,33102:168,33103:65342,33104:65507,33105:65343,33106:12541,33107:12542,33108:12445,33109:12446,33110:12291,33111:20189,33112:12293,33113:12294,33114:12295,33115:12540,33116:8213,33117:8208,33118:65295,33119:92,33120:12316,33121:8214,33122:65372,33123:8230,33124:8229,33125:8216,33126:8217,33127:8220,33128:8221,33129:65288,33130:65289,33131:12308,33132:12309,33133:65339,33134:65341,33135:65371,33136:65373,33137:12296,33138:12297,33139:12298,33140:12299,33141:12300,33142:12301,33143:12302,33144:12303,33145:12304,33146:12305,33147:65291,33148:8722,33149:177,33150:215,33152:247,33153:65309,33154:8800,33155:65308,33156:65310,33157:8806,33158:8807,33159:8734,33160:8756,33161:9794,33162:9792,33163:176,33164:8242,33165:8243,33166:8451,33167:65509,33168:65284,33169:162,33170:163,33171:65285,33172:65283,33173:65286,33174:65290,33175:65312,33176:167,33177:9734,33178:9733,33179:9675,33180:9679,33181:9678,33182:9671,33183:9670,33184:9633,33185:9632,33186:9651,33187:9650,33188:9661,33189:9660,33190:8251,33191:12306,33192:8594,33193:8592,33194:8593,33195:8595,33196:12307,33208:8712,33209:8715,33210:8838,33211:8839,33212:8834,33213:8835,33214:8746,33215:8745,33224:8743,33225:8744,33226:172,33227:8658,33228:8660,33229:8704,33230:8707,33242:8736,33243:8869,33244:8978,33245:8706,33246:8711,33247:8801,33248:8786,33249:8810,33250:8811,33251:8730,33252:8765,33253:8733,33254:8757,33255:8747,33256:8748,33264:8491,33265:8240,33266:9839,33267:9837,33268:9834,33269:8224,33270:8225,33271:182,33276:9711,33359:65296,33360:65297,33361:65298,33362:65299,33363:65300,33364:65301,33365:65302,33366:65303,33367:65304,33368:65305,33376:65313,33377:65314,33378:65315,33379:65316,33380:65317,33381:65318,33382:65319,33383:65320,33384:65321,33385:65322,33386:65323,33387:65324,33388:65325,33389:65326,33390:65327,33391:65328,33392:65329,33393:65330,33394:65331,33395:65332,33396:65333,33397:65334,33398:65335,33399:65336,33400:65337,33401:65338,33409:65345,33410:65346,33411:65347,33412:65348,33413:65349,33414:65350,33415:65351,33416:65352,33417:65353,33418:65354,33419:65355,33420:65356,33421:65357,33422:65358,33423:65359,33424:65360,33425:65361,33426:65362,33427:65363,33428:65364,33429:65365,33430:65366,33431:65367,33432:65368,33433:65369,33434:65370,33439:12353,33440:12354,33441:12355,33442:12356,33443:12357,33444:12358,33445:12359,33446:12360,33447:12361,33448:12362,33449:12363,33450:12364,33451:12365,33452:12366,33453:12367,33454:12368,33455:12369,33456:12370,33457:12371,33458:12372,33459:12373,33460:12374,33461:12375,33462:12376,33463:12377,33464:12378,33465:12379,33466:12380,33467:12381,33468:12382,33469:12383,33470:12384,33471:12385,33472:12386,33473:12387,33474:12388,33475:12389,33476:12390,33477:12391,33478:12392,33479:12393,33480:12394,33481:12395,33482:12396,33483:12397,33484:12398,33485:12399,33486:12400,33487:12401,33488:12402,33489:12403,33490:12404,33491:12405,33492:12406,33493:12407,33494:12408,33495:12409,33496:12410,33497:12411,33498:12412,33499:12413,33500:12414,33501:12415,33502:12416,33503:12417,33504:12418,33505:12419,33506:12420,33507:12421,33508:12422,33509:12423,33510:12424,33511:12425,33512:12426,33513:12427,33514:12428,33515:12429,33516:12430,33517:12431,33518:12432,33519:12433,33520:12434,33521:12435,33600:12449,33601:12450,33602:12451,33603:12452,33604:12453,33605:12454,33606:12455,33607:12456,33608:12457,33609:12458,33610:12459,33611:12460,33612:12461,33613:12462,33614:12463,33615:12464,33616:12465,33617:12466,33618:12467,33619:12468,33620:12469,33621:12470,33622:12471,33623:12472,33624:12473,33625:12474,33626:12475,33627:12476,33628:12477,33629:12478,33630:12479,33631:12480,33632:12481,33633:12482,33634:12483,33635:12484,33636:12485,33637:12486,33638:12487,33639:12488,33640:12489,33641:12490,33642:12491,33643:12492,33644:12493,33645:12494,33646:12495,33647:12496,33648:12497,33649:12498,33650:12499,33651:12500,33652:12501,33653:12502,33654:12503,33655:12504,33656:12505,33657:12506,33658:12507,33659:12508,33660:12509,33661:12510,33662:12511,33664:12512,33665:12513,33666:12514,33667:12515,33668:12516,33669:12517,33670:12518,33671:12519,33672:12520,33673:12521,33674:12522,33675:12523,33676:12524,33677:12525,33678:12526,33679:12527,33680:12528,33681:12529,33682:12530,33683:12531,33684:12532,33685:12533,33686:12534,33695:913,33696:914,33697:915,33698:916,33699:917,33700:918,33701:919,33702:920,33703:921,33704:922,33705:923,33706:924,33707:925,33708:926,33709:927,33710:928,33711:929,33712:931,33713:932,33714:933,33715:934,33716:935,33717:936,33718:937,33727:945,33728:946,33729:947,33730:948,33731:949,33732:950,33733:951,33734:952,33735:953,33736:954,33737:955,33738:956,33739:957,33740:958,33741:959,33742:960,33743:961,33744:963,33745:964,33746:965,33747:966,33748:967,33749:968,33750:969,33856:1040,33857:1041,33858:1042,33859:1043,33860:1044,33861:1045,33862:1025,33863:1046,33864:1047,33865:1048,33866:1049,33867:1050,33868:1051,33869:1052,33870:1053,33871:1054,33872:1055,33873:1056,33874:1057,33875:1058,33876:1059,33877:1060,33878:1061,33879:1062,33880:1063,33881:1064,33882:1065,33883:1066,33884:1067,33885:1068,33886:1069,33887:1070,33888:1071,33904:1072,33905:1073,33906:1074,33907:1075,33908:1076,33909:1077,33910:1105,33911:1078,33912:1079,33913:1080,33914:1081,33915:1082,33916:1083,33917:1084,33918:1085,33920:1086,33921:1087,33922:1088,33923:1089,33924:1090,33925:1091,33926:1092,33927:1093,33928:1094,33929:1095,33930:1096,33931:1097,33932:1098,33933:1099,33934:1100,33935:1101,33936:1102,33937:1103,33951:9472,33952:9474,33953:9484,33954:9488,33955:9496,33956:9492,33957:9500,33958:9516,33959:9508,33960:9524,33961:9532,33962:9473,33963:9475,33964:9487,33965:9491,33966:9499,33967:9495,33968:9507,33969:9523,33970:9515,33971:9531,33972:9547,33973:9504,33974:9519,33975:9512,33976:9527,33977:9535,33978:9501,33979:9520,33980:9509,33981:9528,33982:9538,34975:20124,34976:21782,34977:23043,34978:38463,34979:21696,34980:24859,34981:25384,34982:23030,34983:36898,34984:33909,34985:33564,34986:31312,34987:24746,34988:25569,34989:28197,34990:26093,34991:33894,34992:33446,34993:39925,34994:26771,34995:22311,34996:26017,34997:25201,34998:23451,34999:22992,35e3:34427,35001:39156,35002:32098,35003:32190,35004:39822,35005:25110,35006:31903,35007:34999,35008:23433,35009:24245,35010:25353,35011:26263,35012:26696,35013:38343,35014:38797,35015:26447,35016:20197,35017:20234,35018:20301,35019:20381,35020:20553,35021:22258,35022:22839,35023:22996,35024:23041,35025:23561,35026:24799,35027:24847,35028:24944,35029:26131,35030:26885,35031:28858,35032:30031,35033:30064,35034:31227,35035:32173,35036:32239,35037:32963,35038:33806,35039:34915,35040:35586,35041:36949,35042:36986,35043:21307,35044:20117,35045:20133,35046:22495,35047:32946,35048:37057,35049:30959,35050:19968,35051:22769,35052:28322,35053:36920,35054:31282,35055:33576,35056:33419,35057:39983,35058:20801,35059:21360,35060:21693,35061:21729,35062:22240,35063:23035,35064:24341,35065:39154,35066:28139,35067:32996,35068:34093,35136:38498,35137:38512,35138:38560,35139:38907,35140:21515,35141:21491,35142:23431,35143:28879,35144:32701,35145:36802,35146:38632,35147:21359,35148:40284,35149:31418,35150:19985,35151:30867,35152:33276,35153:28198,35154:22040,35155:21764,35156:27421,35157:34074,35158:39995,35159:23013,35160:21417,35161:28006,35162:29916,35163:38287,35164:22082,35165:20113,35166:36939,35167:38642,35168:33615,35169:39180,35170:21473,35171:21942,35172:23344,35173:24433,35174:26144,35175:26355,35176:26628,35177:27704,35178:27891,35179:27945,35180:29787,35181:30408,35182:31310,35183:38964,35184:33521,35185:34907,35186:35424,35187:37613,35188:28082,35189:30123,35190:30410,35191:39365,35192:24742,35193:35585,35194:36234,35195:38322,35196:27022,35197:21421,35198:20870,35200:22290,35201:22576,35202:22852,35203:23476,35204:24310,35205:24616,35206:25513,35207:25588,35208:27839,35209:28436,35210:28814,35211:28948,35212:29017,35213:29141,35214:29503,35215:32257,35216:33398,35217:33489,35218:34199,35219:36960,35220:37467,35221:40219,35222:22633,35223:26044,35224:27738,35225:29989,35226:20985,35227:22830,35228:22885,35229:24448,35230:24540,35231:25276,35232:26106,35233:27178,35234:27431,35235:27572,35236:29579,35237:32705,35238:35158,35239:40236,35240:40206,35241:40644,35242:23713,35243:27798,35244:33659,35245:20740,35246:23627,35247:25014,35248:33222,35249:26742,35250:29281,35251:20057,35252:20474,35253:21368,35254:24681,35255:28201,35256:31311,35257:38899,35258:19979,35259:21270,35260:20206,35261:20309,35262:20285,35263:20385,35264:20339,35265:21152,35266:21487,35267:22025,35268:22799,35269:23233,35270:23478,35271:23521,35272:31185,35273:26247,35274:26524,35275:26550,35276:27468,35277:27827,35278:28779,35279:29634,35280:31117,35281:31166,35282:31292,35283:31623,35284:33457,35285:33499,35286:33540,35287:33655,35288:33775,35289:33747,35290:34662,35291:35506,35292:22057,35293:36008,35294:36838,35295:36942,35296:38686,35297:34442,35298:20420,35299:23784,35300:25105,35301:29273,35302:30011,35303:33253,35304:33469,35305:34558,35306:36032,35307:38597,35308:39187,35309:39381,35310:20171,35311:20250,35312:35299,35313:22238,35314:22602,35315:22730,35316:24315,35317:24555,35318:24618,35319:24724,35320:24674,35321:25040,35322:25106,35323:25296,35324:25913,35392:39745,35393:26214,35394:26800,35395:28023,35396:28784,35397:30028,35398:30342,35399:32117,35400:33445,35401:34809,35402:38283,35403:38542,35404:35997,35405:20977,35406:21182,35407:22806,35408:21683,35409:23475,35410:23830,35411:24936,35412:27010,35413:28079,35414:30861,35415:33995,35416:34903,35417:35442,35418:37799,35419:39608,35420:28012,35421:39336,35422:34521,35423:22435,35424:26623,35425:34510,35426:37390,35427:21123,35428:22151,35429:21508,35430:24275,35431:25313,35432:25785,35433:26684,35434:26680,35435:27579,35436:29554,35437:30906,35438:31339,35439:35226,35440:35282,35441:36203,35442:36611,35443:37101,35444:38307,35445:38548,35446:38761,35447:23398,35448:23731,35449:27005,35450:38989,35451:38990,35452:25499,35453:31520,35454:27179,35456:27263,35457:26806,35458:39949,35459:28511,35460:21106,35461:21917,35462:24688,35463:25324,35464:27963,35465:28167,35466:28369,35467:33883,35468:35088,35469:36676,35470:19988,35471:39993,35472:21494,35473:26907,35474:27194,35475:38788,35476:26666,35477:20828,35478:31427,35479:33970,35480:37340,35481:37772,35482:22107,35483:40232,35484:26658,35485:33541,35486:33841,35487:31909,35488:21e3,35489:33477,35490:29926,35491:20094,35492:20355,35493:20896,35494:23506,35495:21002,35496:21208,35497:21223,35498:24059,35499:21914,35500:22570,35501:23014,35502:23436,35503:23448,35504:23515,35505:24178,35506:24185,35507:24739,35508:24863,35509:24931,35510:25022,35511:25563,35512:25954,35513:26577,35514:26707,35515:26874,35516:27454,35517:27475,35518:27735,35519:28450,35520:28567,35521:28485,35522:29872,35523:29976,35524:30435,35525:30475,35526:31487,35527:31649,35528:31777,35529:32233,35530:32566,35531:32752,35532:32925,35533:33382,35534:33694,35535:35251,35536:35532,35537:36011,35538:36996,35539:37969,35540:38291,35541:38289,35542:38306,35543:38501,35544:38867,35545:39208,35546:33304,35547:20024,35548:21547,35549:23736,35550:24012,35551:29609,35552:30284,35553:30524,35554:23721,35555:32747,35556:36107,35557:38593,35558:38929,35559:38996,35560:39e3,35561:20225,35562:20238,35563:21361,35564:21916,35565:22120,35566:22522,35567:22855,35568:23305,35569:23492,35570:23696,35571:24076,35572:24190,35573:24524,35574:25582,35575:26426,35576:26071,35577:26082,35578:26399,35579:26827,35580:26820,35648:27231,35649:24112,35650:27589,35651:27671,35652:27773,35653:30079,35654:31048,35655:23395,35656:31232,35657:32e3,35658:24509,35659:35215,35660:35352,35661:36020,35662:36215,35663:36556,35664:36637,35665:39138,35666:39438,35667:39740,35668:20096,35669:20605,35670:20736,35671:22931,35672:23452,35673:25135,35674:25216,35675:25836,35676:27450,35677:29344,35678:30097,35679:31047,35680:32681,35681:34811,35682:35516,35683:35696,35684:25516,35685:33738,35686:38816,35687:21513,35688:21507,35689:21931,35690:26708,35691:27224,35692:35440,35693:30759,35694:26485,35695:40653,35696:21364,35697:23458,35698:33050,35699:34384,35700:36870,35701:19992,35702:20037,35703:20167,35704:20241,35705:21450,35706:21560,35707:23470,35708:24339,35709:24613,35710:25937,35712:26429,35713:27714,35714:27762,35715:27875,35716:28792,35717:29699,35718:31350,35719:31406,35720:31496,35721:32026,35722:31998,35723:32102,35724:26087,35725:29275,35726:21435,35727:23621,35728:24040,35729:25298,35730:25312,35731:25369,35732:28192,35733:34394,35734:35377,35735:36317,35736:37624,35737:28417,35738:31142,35739:39770,35740:20136,35741:20139,35742:20140,35743:20379,35744:20384,35745:20689,35746:20807,35747:31478,35748:20849,35749:20982,35750:21332,35751:21281,35752:21375,35753:21483,35754:21932,35755:22659,35756:23777,35757:24375,35758:24394,35759:24623,35760:24656,35761:24685,35762:25375,35763:25945,35764:27211,35765:27841,35766:29378,35767:29421,35768:30703,35769:33016,35770:33029,35771:33288,35772:34126,35773:37111,35774:37857,35775:38911,35776:39255,35777:39514,35778:20208,35779:20957,35780:23597,35781:26241,35782:26989,35783:23616,35784:26354,35785:26997,35786:29577,35787:26704,35788:31873,35789:20677,35790:21220,35791:22343,35792:24062,35793:37670,35794:26020,35795:27427,35796:27453,35797:29748,35798:31105,35799:31165,35800:31563,35801:32202,35802:33465,35803:33740,35804:34943,35805:35167,35806:35641,35807:36817,35808:37329,35809:21535,35810:37504,35811:20061,35812:20534,35813:21477,35814:21306,35815:29399,35816:29590,35817:30697,35818:33510,35819:36527,35820:39366,35821:39368,35822:39378,35823:20855,35824:24858,35825:34398,35826:21936,35827:31354,35828:20598,35829:23507,35830:36935,35831:38533,35832:20018,35833:27355,35834:37351,35835:23633,35836:23624,35904:25496,35905:31391,35906:27795,35907:38772,35908:36705,35909:31402,35910:29066,35911:38536,35912:31874,35913:26647,35914:32368,35915:26705,35916:37740,35917:21234,35918:21531,35919:34219,35920:35347,35921:32676,35922:36557,35923:37089,35924:21350,35925:34952,35926:31041,35927:20418,35928:20670,35929:21009,35930:20804,35931:21843,35932:22317,35933:29674,35934:22411,35935:22865,35936:24418,35937:24452,35938:24693,35939:24950,35940:24935,35941:25001,35942:25522,35943:25658,35944:25964,35945:26223,35946:26690,35947:28179,35948:30054,35949:31293,35950:31995,35951:32076,35952:32153,35953:32331,35954:32619,35955:33550,35956:33610,35957:34509,35958:35336,35959:35427,35960:35686,35961:36605,35962:38938,35963:40335,35964:33464,35965:36814,35966:39912,35968:21127,35969:25119,35970:25731,35971:28608,35972:38553,35973:26689,35974:20625,35975:27424,35976:27770,35977:28500,35978:31348,35979:32080,35980:34880,35981:35363,35982:26376,35983:20214,35984:20537,35985:20518,35986:20581,35987:20860,35988:21048,35989:21091,35990:21927,35991:22287,35992:22533,35993:23244,35994:24314,35995:25010,35996:25080,35997:25331,35998:25458,35999:26908,36e3:27177,36001:29309,36002:29356,36003:29486,36004:30740,36005:30831,36006:32121,36007:30476,36008:32937,36009:35211,36010:35609,36011:36066,36012:36562,36013:36963,36014:37749,36015:38522,36016:38997,36017:39443,36018:40568,36019:20803,36020:21407,36021:21427,36022:24187,36023:24358,36024:28187,36025:28304,36026:29572,36027:29694,36028:32067,36029:33335,36030:35328,36031:35578,36032:38480,36033:20046,36034:20491,36035:21476,36036:21628,36037:22266,36038:22993,36039:23396,36040:24049,36041:24235,36042:24359,36043:25144,36044:25925,36045:26543,36046:28246,36047:29392,36048:31946,36049:34996,36050:32929,36051:32993,36052:33776,36053:34382,36054:35463,36055:36328,36056:37431,36057:38599,36058:39015,36059:40723,36060:20116,36061:20114,36062:20237,36063:21320,36064:21577,36065:21566,36066:23087,36067:24460,36068:24481,36069:24735,36070:26791,36071:27278,36072:29786,36073:30849,36074:35486,36075:35492,36076:35703,36077:37264,36078:20062,36079:39881,36080:20132,36081:20348,36082:20399,36083:20505,36084:20502,36085:20809,36086:20844,36087:21151,36088:21177,36089:21246,36090:21402,36091:21475,36092:21521,36160:21518,36161:21897,36162:22353,36163:22434,36164:22909,36165:23380,36166:23389,36167:23439,36168:24037,36169:24039,36170:24055,36171:24184,36172:24195,36173:24218,36174:24247,36175:24344,36176:24658,36177:24908,36178:25239,36179:25304,36180:25511,36181:25915,36182:26114,36183:26179,36184:26356,36185:26477,36186:26657,36187:26775,36188:27083,36189:27743,36190:27946,36191:28009,36192:28207,36193:28317,36194:30002,36195:30343,36196:30828,36197:31295,36198:31968,36199:32005,36200:32024,36201:32094,36202:32177,36203:32789,36204:32771,36205:32943,36206:32945,36207:33108,36208:33167,36209:33322,36210:33618,36211:34892,36212:34913,36213:35611,36214:36002,36215:36092,36216:37066,36217:37237,36218:37489,36219:30783,36220:37628,36221:38308,36222:38477,36224:38917,36225:39321,36226:39640,36227:40251,36228:21083,36229:21163,36230:21495,36231:21512,36232:22741,36233:25335,36234:28640,36235:35946,36236:36703,36237:40633,36238:20811,36239:21051,36240:21578,36241:22269,36242:31296,36243:37239,36244:40288,36245:40658,36246:29508,36247:28425,36248:33136,36249:29969,36250:24573,36251:24794,36252:39592,36253:29403,36254:36796,36255:27492,36256:38915,36257:20170,36258:22256,36259:22372,36260:22718,36261:23130,36262:24680,36263:25031,36264:26127,36265:26118,36266:26681,36267:26801,36268:28151,36269:30165,36270:32058,36271:33390,36272:39746,36273:20123,36274:20304,36275:21449,36276:21766,36277:23919,36278:24038,36279:24046,36280:26619,36281:27801,36282:29811,36283:30722,36284:35408,36285:37782,36286:35039,36287:22352,36288:24231,36289:25387,36290:20661,36291:20652,36292:20877,36293:26368,36294:21705,36295:22622,36296:22971,36297:23472,36298:24425,36299:25165,36300:25505,36301:26685,36302:27507,36303:28168,36304:28797,36305:37319,36306:29312,36307:30741,36308:30758,36309:31085,36310:25998,36311:32048,36312:33756,36313:35009,36314:36617,36315:38555,36316:21092,36317:22312,36318:26448,36319:32618,36320:36001,36321:20916,36322:22338,36323:38442,36324:22586,36325:27018,36326:32948,36327:21682,36328:23822,36329:22524,36330:30869,36331:40442,36332:20316,36333:21066,36334:21643,36335:25662,36336:26152,36337:26388,36338:26613,36339:31364,36340:31574,36341:32034,36342:37679,36343:26716,36344:39853,36345:31545,36346:21273,36347:20874,36348:21047,36416:23519,36417:25334,36418:25774,36419:25830,36420:26413,36421:27578,36422:34217,36423:38609,36424:30352,36425:39894,36426:25420,36427:37638,36428:39851,36429:30399,36430:26194,36431:19977,36432:20632,36433:21442,36434:23665,36435:24808,36436:25746,36437:25955,36438:26719,36439:29158,36440:29642,36441:29987,36442:31639,36443:32386,36444:34453,36445:35715,36446:36059,36447:37240,36448:39184,36449:26028,36450:26283,36451:27531,36452:20181,36453:20180,36454:20282,36455:20351,36456:21050,36457:21496,36458:21490,36459:21987,36460:22235,36461:22763,36462:22987,36463:22985,36464:23039,36465:23376,36466:23629,36467:24066,36468:24107,36469:24535,36470:24605,36471:25351,36472:25903,36473:23388,36474:26031,36475:26045,36476:26088,36477:26525,36478:27490,36480:27515,36481:27663,36482:29509,36483:31049,36484:31169,36485:31992,36486:32025,36487:32043,36488:32930,36489:33026,36490:33267,36491:35222,36492:35422,36493:35433,36494:35430,36495:35468,36496:35566,36497:36039,36498:36060,36499:38604,36500:39164,36501:27503,36502:20107,36503:20284,36504:20365,36505:20816,36506:23383,36507:23546,36508:24904,36509:25345,36510:26178,36511:27425,36512:28363,36513:27835,36514:29246,36515:29885,36516:30164,36517:30913,36518:31034,36519:32780,36520:32819,36521:33258,36522:33940,36523:36766,36524:27728,36525:40575,36526:24335,36527:35672,36528:40235,36529:31482,36530:36600,36531:23437,36532:38635,36533:19971,36534:21489,36535:22519,36536:22833,36537:23241,36538:23460,36539:24713,36540:28287,36541:28422,36542:30142,36543:36074,36544:23455,36545:34048,36546:31712,36547:20594,36548:26612,36549:33437,36550:23649,36551:34122,36552:32286,36553:33294,36554:20889,36555:23556,36556:25448,36557:36198,36558:26012,36559:29038,36560:31038,36561:32023,36562:32773,36563:35613,36564:36554,36565:36974,36566:34503,36567:37034,36568:20511,36569:21242,36570:23610,36571:26451,36572:28796,36573:29237,36574:37196,36575:37320,36576:37675,36577:33509,36578:23490,36579:24369,36580:24825,36581:20027,36582:21462,36583:23432,36584:25163,36585:26417,36586:27530,36587:29417,36588:29664,36589:31278,36590:33131,36591:36259,36592:37202,36593:39318,36594:20754,36595:21463,36596:21610,36597:23551,36598:25480,36599:27193,36600:32172,36601:38656,36602:22234,36603:21454,36604:21608,36672:23447,36673:23601,36674:24030,36675:20462,36676:24833,36677:25342,36678:27954,36679:31168,36680:31179,36681:32066,36682:32333,36683:32722,36684:33261,36685:33311,36686:33936,36687:34886,36688:35186,36689:35728,36690:36468,36691:36655,36692:36913,36693:37195,36694:37228,36695:38598,36696:37276,36697:20160,36698:20303,36699:20805,36700:21313,36701:24467,36702:25102,36703:26580,36704:27713,36705:28171,36706:29539,36707:32294,36708:37325,36709:37507,36710:21460,36711:22809,36712:23487,36713:28113,36714:31069,36715:32302,36716:31899,36717:22654,36718:29087,36719:20986,36720:34899,36721:36848,36722:20426,36723:23803,36724:26149,36725:30636,36726:31459,36727:33308,36728:39423,36729:20934,36730:24490,36731:26092,36732:26991,36733:27529,36734:28147,36736:28310,36737:28516,36738:30462,36739:32020,36740:24033,36741:36981,36742:37255,36743:38918,36744:20966,36745:21021,36746:25152,36747:26257,36748:26329,36749:28186,36750:24246,36751:32210,36752:32626,36753:26360,36754:34223,36755:34295,36756:35576,36757:21161,36758:21465,36759:22899,36760:24207,36761:24464,36762:24661,36763:37604,36764:38500,36765:20663,36766:20767,36767:21213,36768:21280,36769:21319,36770:21484,36771:21736,36772:21830,36773:21809,36774:22039,36775:22888,36776:22974,36777:23100,36778:23477,36779:23558,36780:23567,36781:23569,36782:23578,36783:24196,36784:24202,36785:24288,36786:24432,36787:25215,36788:25220,36789:25307,36790:25484,36791:25463,36792:26119,36793:26124,36794:26157,36795:26230,36796:26494,36797:26786,36798:27167,36799:27189,36800:27836,36801:28040,36802:28169,36803:28248,36804:28988,36805:28966,36806:29031,36807:30151,36808:30465,36809:30813,36810:30977,36811:31077,36812:31216,36813:31456,36814:31505,36815:31911,36816:32057,36817:32918,36818:33750,36819:33931,36820:34121,36821:34909,36822:35059,36823:35359,36824:35388,36825:35412,36826:35443,36827:35937,36828:36062,36829:37284,36830:37478,36831:37758,36832:37912,36833:38556,36834:38808,36835:19978,36836:19976,36837:19998,36838:20055,36839:20887,36840:21104,36841:22478,36842:22580,36843:22732,36844:23330,36845:24120,36846:24773,36847:25854,36848:26465,36849:26454,36850:27972,36851:29366,36852:30067,36853:31331,36854:33976,36855:35698,36856:37304,36857:37664,36858:22065,36859:22516,36860:39166,36928:25325,36929:26893,36930:27542,36931:29165,36932:32340,36933:32887,36934:33394,36935:35302,36936:39135,36937:34645,36938:36785,36939:23611,36940:20280,36941:20449,36942:20405,36943:21767,36944:23072,36945:23517,36946:23529,36947:24515,36948:24910,36949:25391,36950:26032,36951:26187,36952:26862,36953:27035,36954:28024,36955:28145,36956:30003,36957:30137,36958:30495,36959:31070,36960:31206,36961:32051,36962:33251,36963:33455,36964:34218,36965:35242,36966:35386,36967:36523,36968:36763,36969:36914,36970:37341,36971:38663,36972:20154,36973:20161,36974:20995,36975:22645,36976:22764,36977:23563,36978:29978,36979:23613,36980:33102,36981:35338,36982:36805,36983:38499,36984:38765,36985:31525,36986:35535,36987:38920,36988:37218,36989:22259,36990:21416,36992:36887,36993:21561,36994:22402,36995:24101,36996:25512,36997:27700,36998:28810,36999:30561,37e3:31883,37001:32736,37002:34928,37003:36930,37004:37204,37005:37648,37006:37656,37007:38543,37008:29790,37009:39620,37010:23815,37011:23913,37012:25968,37013:26530,37014:36264,37015:38619,37016:25454,37017:26441,37018:26905,37019:33733,37020:38935,37021:38592,37022:35070,37023:28548,37024:25722,37025:23544,37026:19990,37027:28716,37028:30045,37029:26159,37030:20932,37031:21046,37032:21218,37033:22995,37034:24449,37035:24615,37036:25104,37037:25919,37038:25972,37039:26143,37040:26228,37041:26866,37042:26646,37043:27491,37044:28165,37045:29298,37046:29983,37047:30427,37048:31934,37049:32854,37050:22768,37051:35069,37052:35199,37053:35488,37054:35475,37055:35531,37056:36893,37057:37266,37058:38738,37059:38745,37060:25993,37061:31246,37062:33030,37063:38587,37064:24109,37065:24796,37066:25114,37067:26021,37068:26132,37069:26512,37070:30707,37071:31309,37072:31821,37073:32318,37074:33034,37075:36012,37076:36196,37077:36321,37078:36447,37079:30889,37080:20999,37081:25305,37082:25509,37083:25666,37084:25240,37085:35373,37086:31363,37087:31680,37088:35500,37089:38634,37090:32118,37091:33292,37092:34633,37093:20185,37094:20808,37095:21315,37096:21344,37097:23459,37098:23554,37099:23574,37100:24029,37101:25126,37102:25159,37103:25776,37104:26643,37105:26676,37106:27849,37107:27973,37108:27927,37109:26579,37110:28508,37111:29006,37112:29053,37113:26059,37114:31359,37115:31661,37116:32218,37184:32330,37185:32680,37186:33146,37187:33307,37188:33337,37189:34214,37190:35438,37191:36046,37192:36341,37193:36984,37194:36983,37195:37549,37196:37521,37197:38275,37198:39854,37199:21069,37200:21892,37201:28472,37202:28982,37203:20840,37204:31109,37205:32341,37206:33203,37207:31950,37208:22092,37209:22609,37210:23720,37211:25514,37212:26366,37213:26365,37214:26970,37215:29401,37216:30095,37217:30094,37218:30990,37219:31062,37220:31199,37221:31895,37222:32032,37223:32068,37224:34311,37225:35380,37226:38459,37227:36961,37228:40736,37229:20711,37230:21109,37231:21452,37232:21474,37233:20489,37234:21930,37235:22766,37236:22863,37237:29245,37238:23435,37239:23652,37240:21277,37241:24803,37242:24819,37243:25436,37244:25475,37245:25407,37246:25531,37248:25805,37249:26089,37250:26361,37251:24035,37252:27085,37253:27133,37254:28437,37255:29157,37256:20105,37257:30185,37258:30456,37259:31379,37260:31967,37261:32207,37262:32156,37263:32865,37264:33609,37265:33624,37266:33900,37267:33980,37268:34299,37269:35013,37270:36208,37271:36865,37272:36973,37273:37783,37274:38684,37275:39442,37276:20687,37277:22679,37278:24974,37279:33235,37280:34101,37281:36104,37282:36896,37283:20419,37284:20596,37285:21063,37286:21363,37287:24687,37288:25417,37289:26463,37290:28204,37291:36275,37292:36895,37293:20439,37294:23646,37295:36042,37296:26063,37297:32154,37298:21330,37299:34966,37300:20854,37301:25539,37302:23384,37303:23403,37304:23562,37305:25613,37306:26449,37307:36956,37308:20182,37309:22810,37310:22826,37311:27760,37312:35409,37313:21822,37314:22549,37315:22949,37316:24816,37317:25171,37318:26561,37319:33333,37320:26965,37321:38464,37322:39364,37323:39464,37324:20307,37325:22534,37326:23550,37327:32784,37328:23729,37329:24111,37330:24453,37331:24608,37332:24907,37333:25140,37334:26367,37335:27888,37336:28382,37337:32974,37338:33151,37339:33492,37340:34955,37341:36024,37342:36864,37343:36910,37344:38538,37345:40667,37346:39899,37347:20195,37348:21488,37349:22823,37350:31532,37351:37261,37352:38988,37353:40441,37354:28381,37355:28711,37356:21331,37357:21828,37358:23429,37359:25176,37360:25246,37361:25299,37362:27810,37363:28655,37364:29730,37365:35351,37366:37944,37367:28609,37368:35582,37369:33592,37370:20967,37371:34552,37372:21482,37440:21481,37441:20294,37442:36948,37443:36784,37444:22890,37445:33073,37446:24061,37447:31466,37448:36799,37449:26842,37450:35895,37451:29432,37452:40008,37453:27197,37454:35504,37455:20025,37456:21336,37457:22022,37458:22374,37459:25285,37460:25506,37461:26086,37462:27470,37463:28129,37464:28251,37465:28845,37466:30701,37467:31471,37468:31658,37469:32187,37470:32829,37471:32966,37472:34507,37473:35477,37474:37723,37475:22243,37476:22727,37477:24382,37478:26029,37479:26262,37480:27264,37481:27573,37482:30007,37483:35527,37484:20516,37485:30693,37486:22320,37487:24347,37488:24677,37489:26234,37490:27744,37491:30196,37492:31258,37493:32622,37494:33268,37495:34584,37496:36933,37497:39347,37498:31689,37499:30044,37500:31481,37501:31569,37502:33988,37504:36880,37505:31209,37506:31378,37507:33590,37508:23265,37509:30528,37510:20013,37511:20210,37512:23449,37513:24544,37514:25277,37515:26172,37516:26609,37517:27880,37518:34411,37519:34935,37520:35387,37521:37198,37522:37619,37523:39376,37524:27159,37525:28710,37526:29482,37527:33511,37528:33879,37529:36015,37530:19969,37531:20806,37532:20939,37533:21899,37534:23541,37535:24086,37536:24115,37537:24193,37538:24340,37539:24373,37540:24427,37541:24500,37542:25074,37543:25361,37544:26274,37545:26397,37546:28526,37547:29266,37548:30010,37549:30522,37550:32884,37551:33081,37552:33144,37553:34678,37554:35519,37555:35548,37556:36229,37557:36339,37558:37530,37559:38263,37560:38914,37561:40165,37562:21189,37563:25431,37564:30452,37565:26389,37566:27784,37567:29645,37568:36035,37569:37806,37570:38515,37571:27941,37572:22684,37573:26894,37574:27084,37575:36861,37576:37786,37577:30171,37578:36890,37579:22618,37580:26626,37581:25524,37582:27131,37583:20291,37584:28460,37585:26584,37586:36795,37587:34086,37588:32180,37589:37716,37590:26943,37591:28528,37592:22378,37593:22775,37594:23340,37595:32044,37596:29226,37597:21514,37598:37347,37599:40372,37600:20141,37601:20302,37602:20572,37603:20597,37604:21059,37605:35998,37606:21576,37607:22564,37608:23450,37609:24093,37610:24213,37611:24237,37612:24311,37613:24351,37614:24716,37615:25269,37616:25402,37617:25552,37618:26799,37619:27712,37620:30855,37621:31118,37622:31243,37623:32224,37624:33351,37625:35330,37626:35558,37627:36420,37628:36883,37696:37048,37697:37165,37698:37336,37699:40718,37700:27877,37701:25688,37702:25826,37703:25973,37704:28404,37705:30340,37706:31515,37707:36969,37708:37841,37709:28346,37710:21746,37711:24505,37712:25764,37713:36685,37714:36845,37715:37444,37716:20856,37717:22635,37718:22825,37719:23637,37720:24215,37721:28155,37722:32399,37723:29980,37724:36028,37725:36578,37726:39003,37727:28857,37728:20253,37729:27583,37730:28593,37731:3e4,37732:38651,37733:20814,37734:21520,37735:22581,37736:22615,37737:22956,37738:23648,37739:24466,37740:26007,37741:26460,37742:28193,37743:30331,37744:33759,37745:36077,37746:36884,37747:37117,37748:37709,37749:30757,37750:30778,37751:21162,37752:24230,37753:22303,37754:22900,37755:24594,37756:20498,37757:20826,37758:20908,37760:20941,37761:20992,37762:21776,37763:22612,37764:22616,37765:22871,37766:23445,37767:23798,37768:23947,37769:24764,37770:25237,37771:25645,37772:26481,37773:26691,37774:26812,37775:26847,37776:30423,37777:28120,37778:28271,37779:28059,37780:28783,37781:29128,37782:24403,37783:30168,37784:31095,37785:31561,37786:31572,37787:31570,37788:31958,37789:32113,37790:21040,37791:33891,37792:34153,37793:34276,37794:35342,37795:35588,37796:35910,37797:36367,37798:36867,37799:36879,37800:37913,37801:38518,37802:38957,37803:39472,37804:38360,37805:20685,37806:21205,37807:21516,37808:22530,37809:23566,37810:24999,37811:25758,37812:27934,37813:30643,37814:31461,37815:33012,37816:33796,37817:36947,37818:37509,37819:23776,37820:40199,37821:21311,37822:24471,37823:24499,37824:28060,37825:29305,37826:30563,37827:31167,37828:31716,37829:27602,37830:29420,37831:35501,37832:26627,37833:27233,37834:20984,37835:31361,37836:26932,37837:23626,37838:40182,37839:33515,37840:23493,37841:37193,37842:28702,37843:22136,37844:23663,37845:24775,37846:25958,37847:27788,37848:35930,37849:36929,37850:38931,37851:21585,37852:26311,37853:37389,37854:22856,37855:37027,37856:20869,37857:20045,37858:20970,37859:34201,37860:35598,37861:28760,37862:25466,37863:37707,37864:26978,37865:39348,37866:32260,37867:30071,37868:21335,37869:26976,37870:36575,37871:38627,37872:27741,37873:20108,37874:23612,37875:24336,37876:36841,37877:21250,37878:36049,37879:32905,37880:34425,37881:24319,37882:26085,37883:20083,37884:20837,37952:22914,37953:23615,37954:38894,37955:20219,37956:22922,37957:24525,37958:35469,37959:28641,37960:31152,37961:31074,37962:23527,37963:33905,37964:29483,37965:29105,37966:24180,37967:24565,37968:25467,37969:25754,37970:29123,37971:31896,37972:20035,37973:24316,37974:20043,37975:22492,37976:22178,37977:24745,37978:28611,37979:32013,37980:33021,37981:33075,37982:33215,37983:36786,37984:35223,37985:34468,37986:24052,37987:25226,37988:25773,37989:35207,37990:26487,37991:27874,37992:27966,37993:29750,37994:30772,37995:23110,37996:32629,37997:33453,37998:39340,37999:20467,38e3:24259,38001:25309,38002:25490,38003:25943,38004:26479,38005:30403,38006:29260,38007:32972,38008:32954,38009:36649,38010:37197,38011:20493,38012:22521,38013:23186,38014:26757,38016:26995,38017:29028,38018:29437,38019:36023,38020:22770,38021:36064,38022:38506,38023:36889,38024:34687,38025:31204,38026:30695,38027:33833,38028:20271,38029:21093,38030:21338,38031:25293,38032:26575,38033:27850,38034:30333,38035:31636,38036:31893,38037:33334,38038:34180,38039:36843,38040:26333,38041:28448,38042:29190,38043:32283,38044:33707,38045:39361,38046:40614,38047:20989,38048:31665,38049:30834,38050:31672,38051:32903,38052:31560,38053:27368,38054:24161,38055:32908,38056:30033,38057:30048,38058:20843,38059:37474,38060:28300,38061:30330,38062:37271,38063:39658,38064:20240,38065:32624,38066:25244,38067:31567,38068:38309,38069:40169,38070:22138,38071:22617,38072:34532,38073:38588,38074:20276,38075:21028,38076:21322,38077:21453,38078:21467,38079:24070,38080:25644,38081:26001,38082:26495,38083:27710,38084:27726,38085:29256,38086:29359,38087:29677,38088:30036,38089:32321,38090:33324,38091:34281,38092:36009,38093:31684,38094:37318,38095:29033,38096:38930,38097:39151,38098:25405,38099:26217,38100:30058,38101:30436,38102:30928,38103:34115,38104:34542,38105:21290,38106:21329,38107:21542,38108:22915,38109:24199,38110:24444,38111:24754,38112:25161,38113:25209,38114:25259,38115:26e3,38116:27604,38117:27852,38118:30130,38119:30382,38120:30865,38121:31192,38122:32203,38123:32631,38124:32933,38125:34987,38126:35513,38127:36027,38128:36991,38129:38750,38130:39131,38131:27147,38132:31800,38133:20633,38134:23614,38135:24494,38136:26503,38137:27608,38138:29749,38139:30473,38140:32654,38208:40763,38209:26570,38210:31255,38211:21305,38212:30091,38213:39661,38214:24422,38215:33181,38216:33777,38217:32920,38218:24380,38219:24517,38220:30050,38221:31558,38222:36924,38223:26727,38224:23019,38225:23195,38226:32016,38227:30334,38228:35628,38229:20469,38230:24426,38231:27161,38232:27703,38233:28418,38234:29922,38235:31080,38236:34920,38237:35413,38238:35961,38239:24287,38240:25551,38241:30149,38242:31186,38243:33495,38244:37672,38245:37618,38246:33948,38247:34541,38248:39981,38249:21697,38250:24428,38251:25996,38252:27996,38253:28693,38254:36007,38255:36051,38256:38971,38257:25935,38258:29942,38259:19981,38260:20184,38261:22496,38262:22827,38263:23142,38264:23500,38265:20904,38266:24067,38267:24220,38268:24598,38269:25206,38270:25975,38272:26023,38273:26222,38274:28014,38275:29238,38276:31526,38277:33104,38278:33178,38279:33433,38280:35676,38281:36e3,38282:36070,38283:36212,38284:38428,38285:38468,38286:20398,38287:25771,38288:27494,38289:33310,38290:33889,38291:34154,38292:37096,38293:23553,38294:26963,38295:39080,38296:33914,38297:34135,38298:20239,38299:21103,38300:24489,38301:24133,38302:26381,38303:31119,38304:33145,38305:35079,38306:35206,38307:28149,38308:24343,38309:25173,38310:27832,38311:20175,38312:29289,38313:39826,38314:20998,38315:21563,38316:22132,38317:22707,38318:24996,38319:25198,38320:28954,38321:22894,38322:31881,38323:31966,38324:32027,38325:38640,38326:25991,38327:32862,38328:19993,38329:20341,38330:20853,38331:22592,38332:24163,38333:24179,38334:24330,38335:26564,38336:20006,38337:34109,38338:38281,38339:38491,38340:31859,38341:38913,38342:20731,38343:22721,38344:30294,38345:30887,38346:21029,38347:30629,38348:34065,38349:31622,38350:20559,38351:22793,38352:29255,38353:31687,38354:32232,38355:36794,38356:36820,38357:36941,38358:20415,38359:21193,38360:23081,38361:24321,38362:38829,38363:20445,38364:33303,38365:37610,38366:22275,38367:25429,38368:27497,38369:29995,38370:35036,38371:36628,38372:31298,38373:21215,38374:22675,38375:24917,38376:25098,38377:26286,38378:27597,38379:31807,38380:33769,38381:20515,38382:20472,38383:21253,38384:21574,38385:22577,38386:22857,38387:23453,38388:23792,38389:23791,38390:23849,38391:24214,38392:25265,38393:25447,38394:25918,38395:26041,38396:26379,38464:27861,38465:27873,38466:28921,38467:30770,38468:32299,38469:32990,38470:33459,38471:33804,38472:34028,38473:34562,38474:35090,38475:35370,38476:35914,38477:37030,38478:37586,38479:39165,38480:40179,38481:40300,38482:20047,38483:20129,38484:20621,38485:21078,38486:22346,38487:22952,38488:24125,38489:24536,38490:24537,38491:25151,38492:26292,38493:26395,38494:26576,38495:26834,38496:20882,38497:32033,38498:32938,38499:33192,38500:35584,38501:35980,38502:36031,38503:37502,38504:38450,38505:21536,38506:38956,38507:21271,38508:20693,38509:21340,38510:22696,38511:25778,38512:26420,38513:29287,38514:30566,38515:31302,38516:37350,38517:21187,38518:27809,38519:27526,38520:22528,38521:24140,38522:22868,38523:26412,38524:32763,38525:20961,38526:30406,38528:25705,38529:30952,38530:39764,38531:40635,38532:22475,38533:22969,38534:26151,38535:26522,38536:27598,38537:21737,38538:27097,38539:24149,38540:33180,38541:26517,38542:39850,38543:26622,38544:40018,38545:26717,38546:20134,38547:20451,38548:21448,38549:25273,38550:26411,38551:27819,38552:36804,38553:20397,38554:32365,38555:40639,38556:19975,38557:24930,38558:28288,38559:28459,38560:34067,38561:21619,38562:26410,38563:39749,38564:24051,38565:31637,38566:23724,38567:23494,38568:34588,38569:28234,38570:34001,38571:31252,38572:33032,38573:22937,38574:31885,38575:27665,38576:30496,38577:21209,38578:22818,38579:28961,38580:29279,38581:30683,38582:38695,38583:40289,38584:26891,38585:23167,38586:23064,38587:20901,38588:21517,38589:21629,38590:26126,38591:30431,38592:36855,38593:37528,38594:40180,38595:23018,38596:29277,38597:28357,38598:20813,38599:26825,38600:32191,38601:32236,38602:38754,38603:40634,38604:25720,38605:27169,38606:33538,38607:22916,38608:23391,38609:27611,38610:29467,38611:30450,38612:32178,38613:32791,38614:33945,38615:20786,38616:26408,38617:40665,38618:30446,38619:26466,38620:21247,38621:39173,38622:23588,38623:25147,38624:31870,38625:36016,38626:21839,38627:24758,38628:32011,38629:38272,38630:21249,38631:20063,38632:20918,38633:22812,38634:29242,38635:32822,38636:37326,38637:24357,38638:30690,38639:21380,38640:24441,38641:32004,38642:34220,38643:35379,38644:36493,38645:38742,38646:26611,38647:34222,38648:37971,38649:24841,38650:24840,38651:27833,38652:30290,38720:35565,38721:36664,38722:21807,38723:20305,38724:20778,38725:21191,38726:21451,38727:23461,38728:24189,38729:24736,38730:24962,38731:25558,38732:26377,38733:26586,38734:28263,38735:28044,38736:29494,38737:29495,38738:30001,38739:31056,38740:35029,38741:35480,38742:36938,38743:37009,38744:37109,38745:38596,38746:34701,38747:22805,38748:20104,38749:20313,38750:19982,38751:35465,38752:36671,38753:38928,38754:20653,38755:24188,38756:22934,38757:23481,38758:24248,38759:25562,38760:25594,38761:25793,38762:26332,38763:26954,38764:27096,38765:27915,38766:28342,38767:29076,38768:29992,38769:31407,38770:32650,38771:32768,38772:33865,38773:33993,38774:35201,38775:35617,38776:36362,38777:36965,38778:38525,38779:39178,38780:24958,38781:25233,38782:27442,38784:27779,38785:28020,38786:32716,38787:32764,38788:28096,38789:32645,38790:34746,38791:35064,38792:26469,38793:33713,38794:38972,38795:38647,38796:27931,38797:32097,38798:33853,38799:37226,38800:20081,38801:21365,38802:23888,38803:27396,38804:28651,38805:34253,38806:34349,38807:35239,38808:21033,38809:21519,38810:23653,38811:26446,38812:26792,38813:29702,38814:29827,38815:30178,38816:35023,38817:35041,38818:37324,38819:38626,38820:38520,38821:24459,38822:29575,38823:31435,38824:33870,38825:25504,38826:30053,38827:21129,38828:27969,38829:28316,38830:29705,38831:30041,38832:30827,38833:31890,38834:38534,38835:31452,38836:40845,38837:20406,38838:24942,38839:26053,38840:34396,38841:20102,38842:20142,38843:20698,38844:20001,38845:20940,38846:23534,38847:26009,38848:26753,38849:28092,38850:29471,38851:30274,38852:30637,38853:31260,38854:31975,38855:33391,38856:35538,38857:36988,38858:37327,38859:38517,38860:38936,38861:21147,38862:32209,38863:20523,38864:21400,38865:26519,38866:28107,38867:29136,38868:29747,38869:33256,38870:36650,38871:38563,38872:40023,38873:40607,38874:29792,38875:22593,38876:28057,38877:32047,38878:39006,38879:20196,38880:20278,38881:20363,38882:20919,38883:21169,38884:23994,38885:24604,38886:29618,38887:31036,38888:33491,38889:37428,38890:38583,38891:38646,38892:38666,38893:40599,38894:40802,38895:26278,38896:27508,38897:21015,38898:21155,38899:28872,38900:35010,38901:24265,38902:24651,38903:24976,38904:28451,38905:29001,38906:31806,38907:32244,38908:32879,38976:34030,38977:36899,38978:37676,38979:21570,38980:39791,38981:27347,38982:28809,38983:36034,38984:36335,38985:38706,38986:21172,38987:23105,38988:24266,38989:24324,38990:26391,38991:27004,38992:27028,38993:28010,38994:28431,38995:29282,38996:29436,38997:31725,38998:32769,38999:32894,39e3:34635,39001:37070,39002:20845,39003:40595,39004:31108,39005:32907,39006:37682,39007:35542,39008:20525,39009:21644,39010:35441,39011:27498,39012:36036,39013:33031,39014:24785,39015:26528,39016:40434,39017:20121,39018:20120,39019:39952,39020:35435,39021:34241,39022:34152,39023:26880,39024:28286,39025:30871,39026:33109,39071:24332,39072:19984,39073:19989,39074:20010,39075:20017,39076:20022,39077:20028,39078:20031,39079:20034,39080:20054,39081:20056,39082:20098,39083:20101,39084:35947,39085:20106,39086:33298,39087:24333,39088:20110,39089:20126,39090:20127,39091:20128,39092:20130,39093:20144,39094:20147,39095:20150,39096:20174,39097:20173,39098:20164,39099:20166,39100:20162,39101:20183,39102:20190,39103:20205,39104:20191,39105:20215,39106:20233,39107:20314,39108:20272,39109:20315,39110:20317,39111:20311,39112:20295,39113:20342,39114:20360,39115:20367,39116:20376,39117:20347,39118:20329,39119:20336,39120:20369,39121:20335,39122:20358,39123:20374,39124:20760,39125:20436,39126:20447,39127:20430,39128:20440,39129:20443,39130:20433,39131:20442,39132:20432,39133:20452,39134:20453,39135:20506,39136:20520,39137:20500,39138:20522,39139:20517,39140:20485,39141:20252,39142:20470,39143:20513,39144:20521,39145:20524,39146:20478,39147:20463,39148:20497,39149:20486,39150:20547,39151:20551,39152:26371,39153:20565,39154:20560,39155:20552,39156:20570,39157:20566,39158:20588,39159:20600,39160:20608,39161:20634,39162:20613,39163:20660,39164:20658,39232:20681,39233:20682,39234:20659,39235:20674,39236:20694,39237:20702,39238:20709,39239:20717,39240:20707,39241:20718,39242:20729,39243:20725,39244:20745,39245:20737,39246:20738,39247:20758,39248:20757,39249:20756,39250:20762,39251:20769,39252:20794,39253:20791,39254:20796,39255:20795,39256:20799,39257:20800,39258:20818,39259:20812,39260:20820,39261:20834,39262:31480,39263:20841,39264:20842,39265:20846,39266:20864,39267:20866,39268:22232,39269:20876,39270:20873,39271:20879,39272:20881,39273:20883,39274:20885,39275:20886,39276:20900,39277:20902,39278:20898,39279:20905,39280:20906,39281:20907,39282:20915,39283:20913,39284:20914,39285:20912,39286:20917,39287:20925,39288:20933,39289:20937,39290:20955,39291:20960,39292:34389,39293:20969,39294:20973,39296:20976,39297:20981,39298:20990,39299:20996,39300:21003,39301:21012,39302:21006,39303:21031,39304:21034,39305:21038,39306:21043,39307:21049,39308:21071,39309:21060,39310:21067,39311:21068,39312:21086,39313:21076,39314:21098,39315:21108,39316:21097,39317:21107,39318:21119,39319:21117,39320:21133,39321:21140,39322:21138,39323:21105,39324:21128,39325:21137,39326:36776,39327:36775,39328:21164,39329:21165,39330:21180,39331:21173,39332:21185,39333:21197,39334:21207,39335:21214,39336:21219,39337:21222,39338:39149,39339:21216,39340:21235,39341:21237,39342:21240,39343:21241,39344:21254,39345:21256,39346:30008,39347:21261,39348:21264,39349:21263,39350:21269,39351:21274,39352:21283,39353:21295,39354:21297,39355:21299,39356:21304,39357:21312,39358:21318,39359:21317,39360:19991,39361:21321,39362:21325,39363:20950,39364:21342,39365:21353,39366:21358,39367:22808,39368:21371,39369:21367,39370:21378,39371:21398,39372:21408,39373:21414,39374:21413,39375:21422,39376:21424,39377:21430,39378:21443,39379:31762,39380:38617,39381:21471,39382:26364,39383:29166,39384:21486,39385:21480,39386:21485,39387:21498,39388:21505,39389:21565,39390:21568,39391:21548,39392:21549,39393:21564,39394:21550,39395:21558,39396:21545,39397:21533,39398:21582,39399:21647,39400:21621,39401:21646,39402:21599,39403:21617,39404:21623,39405:21616,39406:21650,39407:21627,39408:21632,39409:21622,39410:21636,39411:21648,39412:21638,39413:21703,39414:21666,39415:21688,39416:21669,39417:21676,39418:21700,39419:21704,39420:21672,39488:21675,39489:21698,39490:21668,39491:21694,39492:21692,39493:21720,39494:21733,39495:21734,39496:21775,39497:21780,39498:21757,39499:21742,39500:21741,39501:21754,39502:21730,39503:21817,39504:21824,39505:21859,39506:21836,39507:21806,39508:21852,39509:21829,39510:21846,39511:21847,39512:21816,39513:21811,39514:21853,39515:21913,39516:21888,39517:21679,39518:21898,39519:21919,39520:21883,39521:21886,39522:21912,39523:21918,39524:21934,39525:21884,39526:21891,39527:21929,39528:21895,39529:21928,39530:21978,39531:21957,39532:21983,39533:21956,39534:21980,39535:21988,39536:21972,39537:22036,39538:22007,39539:22038,39540:22014,39541:22013,39542:22043,39543:22009,39544:22094,39545:22096,39546:29151,39547:22068,39548:22070,39549:22066,39550:22072,39552:22123,39553:22116,39554:22063,39555:22124,39556:22122,39557:22150,39558:22144,39559:22154,39560:22176,39561:22164,39562:22159,39563:22181,39564:22190,39565:22198,39566:22196,39567:22210,39568:22204,39569:22209,39570:22211,39571:22208,39572:22216,39573:22222,39574:22225,39575:22227,39576:22231,39577:22254,39578:22265,39579:22272,39580:22271,39581:22276,39582:22281,39583:22280,39584:22283,39585:22285,39586:22291,39587:22296,39588:22294,39589:21959,39590:22300,39591:22310,39592:22327,39593:22328,39594:22350,39595:22331,39596:22336,39597:22351,39598:22377,39599:22464,39600:22408,39601:22369,39602:22399,39603:22409,39604:22419,39605:22432,39606:22451,39607:22436,39608:22442,39609:22448,39610:22467,39611:22470,39612:22484,39613:22482,39614:22483,39615:22538,39616:22486,39617:22499,39618:22539,39619:22553,39620:22557,39621:22642,39622:22561,39623:22626,39624:22603,39625:22640,39626:27584,39627:22610,39628:22589,39629:22649,39630:22661,39631:22713,39632:22687,39633:22699,39634:22714,39635:22750,39636:22715,39637:22712,39638:22702,39639:22725,39640:22739,39641:22737,39642:22743,39643:22745,39644:22744,39645:22757,39646:22748,39647:22756,39648:22751,39649:22767,39650:22778,39651:22777,39652:22779,39653:22780,39654:22781,39655:22786,39656:22794,39657:22800,39658:22811,39659:26790,39660:22821,39661:22828,39662:22829,39663:22834,39664:22840,39665:22846,39666:31442,39667:22869,39668:22864,39669:22862,39670:22874,39671:22872,39672:22882,39673:22880,39674:22887,39675:22892,39676:22889,39744:22904,39745:22913,39746:22941,39747:20318,39748:20395,39749:22947,39750:22962,39751:22982,39752:23016,39753:23004,39754:22925,39755:23001,39756:23002,39757:23077,39758:23071,39759:23057,39760:23068,39761:23049,39762:23066,39763:23104,39764:23148,39765:23113,39766:23093,39767:23094,39768:23138,39769:23146,39770:23194,39771:23228,39772:23230,39773:23243,39774:23234,39775:23229,39776:23267,39777:23255,39778:23270,39779:23273,39780:23254,39781:23290,39782:23291,39783:23308,39784:23307,39785:23318,39786:23346,39787:23248,39788:23338,39789:23350,39790:23358,39791:23363,39792:23365,39793:23360,39794:23377,39795:23381,39796:23386,39797:23387,39798:23397,39799:23401,39800:23408,39801:23411,39802:23413,39803:23416,39804:25992,39805:23418,39806:23424,39808:23427,39809:23462,39810:23480,39811:23491,39812:23495,39813:23497,39814:23508,39815:23504,39816:23524,39817:23526,39818:23522,39819:23518,39820:23525,39821:23531,39822:23536,39823:23542,39824:23539,39825:23557,39826:23559,39827:23560,39828:23565,39829:23571,39830:23584,39831:23586,39832:23592,39833:23608,39834:23609,39835:23617,39836:23622,39837:23630,39838:23635,39839:23632,39840:23631,39841:23409,39842:23660,39843:23662,39844:20066,39845:23670,39846:23673,39847:23692,39848:23697,39849:23700,39850:22939,39851:23723,39852:23739,39853:23734,39854:23740,39855:23735,39856:23749,39857:23742,39858:23751,39859:23769,39860:23785,39861:23805,39862:23802,39863:23789,39864:23948,39865:23786,39866:23819,39867:23829,39868:23831,39869:23900,39870:23839,39871:23835,39872:23825,39873:23828,39874:23842,39875:23834,39876:23833,39877:23832,39878:23884,39879:23890,39880:23886,39881:23883,39882:23916,39883:23923,39884:23926,39885:23943,39886:23940,39887:23938,39888:23970,39889:23965,39890:23980,39891:23982,39892:23997,39893:23952,39894:23991,39895:23996,39896:24009,39897:24013,39898:24019,39899:24018,39900:24022,39901:24027,39902:24043,39903:24050,39904:24053,39905:24075,39906:24090,39907:24089,39908:24081,39909:24091,39910:24118,39911:24119,39912:24132,39913:24131,39914:24128,39915:24142,39916:24151,39917:24148,39918:24159,39919:24162,39920:24164,39921:24135,39922:24181,39923:24182,39924:24186,39925:40636,39926:24191,39927:24224,39928:24257,39929:24258,39930:24264,39931:24272,39932:24271,4e4:24278,40001:24291,40002:24285,40003:24282,40004:24283,40005:24290,40006:24289,40007:24296,40008:24297,40009:24300,40010:24305,40011:24307,40012:24304,40013:24308,40014:24312,40015:24318,40016:24323,40017:24329,40018:24413,40019:24412,40020:24331,40021:24337,40022:24342,40023:24361,40024:24365,40025:24376,40026:24385,40027:24392,40028:24396,40029:24398,40030:24367,40031:24401,40032:24406,40033:24407,40034:24409,40035:24417,40036:24429,40037:24435,40038:24439,40039:24451,40040:24450,40041:24447,40042:24458,40043:24456,40044:24465,40045:24455,40046:24478,40047:24473,40048:24472,40049:24480,40050:24488,40051:24493,40052:24508,40053:24534,40054:24571,40055:24548,40056:24568,40057:24561,40058:24541,40059:24755,40060:24575,40061:24609,40062:24672,40064:24601,40065:24592,40066:24617,40067:24590,40068:24625,40069:24603,40070:24597,40071:24619,40072:24614,40073:24591,40074:24634,40075:24666,40076:24641,40077:24682,40078:24695,40079:24671,40080:24650,40081:24646,40082:24653,40083:24675,40084:24643,40085:24676,40086:24642,40087:24684,40088:24683,40089:24665,40090:24705,40091:24717,40092:24807,40093:24707,40094:24730,40095:24708,40096:24731,40097:24726,40098:24727,40099:24722,40100:24743,40101:24715,40102:24801,40103:24760,40104:24800,40105:24787,40106:24756,40107:24560,40108:24765,40109:24774,40110:24757,40111:24792,40112:24909,40113:24853,40114:24838,40115:24822,40116:24823,40117:24832,40118:24820,40119:24826,40120:24835,40121:24865,40122:24827,40123:24817,40124:24845,40125:24846,40126:24903,40127:24894,40128:24872,40129:24871,40130:24906,40131:24895,40132:24892,40133:24876,40134:24884,40135:24893,40136:24898,40137:24900,40138:24947,40139:24951,40140:24920,40141:24921,40142:24922,40143:24939,40144:24948,40145:24943,40146:24933,40147:24945,40148:24927,40149:24925,40150:24915,40151:24949,40152:24985,40153:24982,40154:24967,40155:25004,40156:24980,40157:24986,40158:24970,40159:24977,40160:25003,40161:25006,40162:25036,40163:25034,40164:25033,40165:25079,40166:25032,40167:25027,40168:25030,40169:25018,40170:25035,40171:32633,40172:25037,40173:25062,40174:25059,40175:25078,40176:25082,40177:25076,40178:25087,40179:25085,40180:25084,40181:25086,40182:25088,40183:25096,40184:25097,40185:25101,40186:25100,40187:25108,40188:25115,40256:25118,40257:25121,40258:25130,40259:25134,40260:25136,40261:25138,40262:25139,40263:25153,40264:25166,40265:25182,40266:25187,40267:25179,40268:25184,40269:25192,40270:25212,40271:25218,40272:25225,40273:25214,40274:25234,40275:25235,40276:25238,40277:25300,40278:25219,40279:25236,40280:25303,40281:25297,40282:25275,40283:25295,40284:25343,40285:25286,40286:25812,40287:25288,40288:25308,40289:25292,40290:25290,40291:25282,40292:25287,40293:25243,40294:25289,40295:25356,40296:25326,40297:25329,40298:25383,40299:25346,40300:25352,40301:25327,40302:25333,40303:25424,40304:25406,40305:25421,40306:25628,40307:25423,40308:25494,40309:25486,40310:25472,40311:25515,40312:25462,40313:25507,40314:25487,40315:25481,40316:25503,40317:25525,40318:25451,40320:25449,40321:25534,40322:25577,40323:25536,40324:25542,40325:25571,40326:25545,40327:25554,40328:25590,40329:25540,40330:25622,40331:25652,40332:25606,40333:25619,40334:25638,40335:25654,40336:25885,40337:25623,40338:25640,40339:25615,40340:25703,40341:25711,40342:25718,40343:25678,40344:25898,40345:25749,40346:25747,40347:25765,40348:25769,40349:25736,40350:25788,40351:25818,40352:25810,40353:25797,40354:25799,40355:25787,40356:25816,40357:25794,40358:25841,40359:25831,40360:33289,40361:25824,40362:25825,40363:25260,40364:25827,40365:25839,40366:25900,40367:25846,40368:25844,40369:25842,40370:25850,40371:25856,40372:25853,40373:25880,40374:25884,40375:25861,40376:25892,40377:25891,40378:25899,40379:25908,40380:25909,40381:25911,40382:25910,40383:25912,40384:30027,40385:25928,40386:25942,40387:25941,40388:25933,40389:25944,40390:25950,40391:25949,40392:25970,40393:25976,40394:25986,40395:25987,40396:35722,40397:26011,40398:26015,40399:26027,40400:26039,40401:26051,40402:26054,40403:26049,40404:26052,40405:26060,40406:26066,40407:26075,40408:26073,40409:26080,40410:26081,40411:26097,40412:26482,40413:26122,40414:26115,40415:26107,40416:26483,40417:26165,40418:26166,40419:26164,40420:26140,40421:26191,40422:26180,40423:26185,40424:26177,40425:26206,40426:26205,40427:26212,40428:26215,40429:26216,40430:26207,40431:26210,40432:26224,40433:26243,40434:26248,40435:26254,40436:26249,40437:26244,40438:26264,40439:26269,40440:26305,40441:26297,40442:26313,40443:26302,40444:26300,40512:26308,40513:26296,40514:26326,40515:26330,40516:26336,40517:26175,40518:26342,40519:26345,40520:26352,40521:26357,40522:26359,40523:26383,40524:26390,40525:26398,40526:26406,40527:26407,40528:38712,40529:26414,40530:26431,40531:26422,40532:26433,40533:26424,40534:26423,40535:26438,40536:26462,40537:26464,40538:26457,40539:26467,40540:26468,40541:26505,40542:26480,40543:26537,40544:26492,40545:26474,40546:26508,40547:26507,40548:26534,40549:26529,40550:26501,40551:26551,40552:26607,40553:26548,40554:26604,40555:26547,40556:26601,40557:26552,40558:26596,40559:26590,40560:26589,40561:26594,40562:26606,40563:26553,40564:26574,40565:26566,40566:26599,40567:27292,40568:26654,40569:26694,40570:26665,40571:26688,40572:26701,40573:26674,40574:26702,40576:26803,40577:26667,40578:26713,40579:26723,40580:26743,40581:26751,40582:26783,40583:26767,40584:26797,40585:26772,40586:26781,40587:26779,40588:26755,40589:27310,40590:26809,40591:26740,40592:26805,40593:26784,40594:26810,40595:26895,40596:26765,40597:26750,40598:26881,40599:26826,40600:26888,40601:26840,40602:26914,40603:26918,40604:26849,40605:26892,40606:26829,40607:26836,40608:26855,40609:26837,40610:26934,40611:26898,40612:26884,40613:26839,40614:26851,40615:26917,40616:26873,40617:26848,40618:26863,40619:26920,40620:26922,40621:26906,40622:26915,40623:26913,40624:26822,40625:27001,40626:26999,40627:26972,40628:27e3,40629:26987,40630:26964,40631:27006,40632:26990,40633:26937,40634:26996,40635:26941,40636:26969,40637:26928,40638:26977,40639:26974,40640:26973,40641:27009,40642:26986,40643:27058,40644:27054,40645:27088,40646:27071,40647:27073,40648:27091,40649:27070,40650:27086,40651:23528,40652:27082,40653:27101,40654:27067,40655:27075,40656:27047,40657:27182,40658:27025,40659:27040,40660:27036,40661:27029,40662:27060,40663:27102,40664:27112,40665:27138,40666:27163,40667:27135,40668:27402,40669:27129,40670:27122,40671:27111,40672:27141,40673:27057,40674:27166,40675:27117,40676:27156,40677:27115,40678:27146,40679:27154,40680:27329,40681:27171,40682:27155,40683:27204,40684:27148,40685:27250,40686:27190,40687:27256,40688:27207,40689:27234,40690:27225,40691:27238,40692:27208,40693:27192,40694:27170,40695:27280,40696:27277,40697:27296,40698:27268,40699:27298,40700:27299,40768:27287,40769:34327,40770:27323,40771:27331,40772:27330,40773:27320,40774:27315,40775:27308,40776:27358,40777:27345,40778:27359,40779:27306,40780:27354,40781:27370,40782:27387,40783:27397,40784:34326,40785:27386,40786:27410,40787:27414,40788:39729,40789:27423,40790:27448,40791:27447,40792:30428,40793:27449,40794:39150,40795:27463,40796:27459,40797:27465,40798:27472,40799:27481,40800:27476,40801:27483,40802:27487,40803:27489,40804:27512,40805:27513,40806:27519,40807:27520,40808:27524,40809:27523,40810:27533,40811:27544,40812:27541,40813:27550,40814:27556,40815:27562,40816:27563,40817:27567,40818:27570,40819:27569,40820:27571,40821:27575,40822:27580,40823:27590,40824:27595,40825:27603,40826:27615,40827:27628,40828:27627,40829:27635,40830:27631,40832:40638,40833:27656,40834:27667,40835:27668,40836:27675,40837:27684,40838:27683,40839:27742,40840:27733,40841:27746,40842:27754,40843:27778,40844:27789,40845:27802,40846:27777,40847:27803,40848:27774,40849:27752,40850:27763,40851:27794,40852:27792,40853:27844,40854:27889,40855:27859,40856:27837,40857:27863,40858:27845,40859:27869,40860:27822,40861:27825,40862:27838,40863:27834,40864:27867,40865:27887,40866:27865,40867:27882,40868:27935,40869:34893,40870:27958,40871:27947,40872:27965,40873:27960,40874:27929,40875:27957,40876:27955,40877:27922,40878:27916,40879:28003,40880:28051,40881:28004,40882:27994,40883:28025,40884:27993,40885:28046,40886:28053,40887:28644,40888:28037,40889:28153,40890:28181,40891:28170,40892:28085,40893:28103,40894:28134,40895:28088,40896:28102,40897:28140,40898:28126,40899:28108,40900:28136,40901:28114,40902:28101,40903:28154,40904:28121,40905:28132,40906:28117,40907:28138,40908:28142,40909:28205,40910:28270,40911:28206,40912:28185,40913:28274,40914:28255,40915:28222,40916:28195,40917:28267,40918:28203,40919:28278,40920:28237,40921:28191,40922:28227,40923:28218,40924:28238,40925:28196,40926:28415,40927:28189,40928:28216,40929:28290,40930:28330,40931:28312,40932:28361,40933:28343,40934:28371,40935:28349,40936:28335,40937:28356,40938:28338,40939:28372,40940:28373,40941:28303,40942:28325,40943:28354,40944:28319,40945:28481,40946:28433,40947:28748,40948:28396,40949:28408,40950:28414,40951:28479,40952:28402,40953:28465,40954:28399,40955:28466,40956:28364,161:65377,162:65378,163:65379,164:65380,165:65381,166:65382,167:65383,168:65384,169:65385,170:65386,171:65387,172:65388,173:65389,174:65390,175:65391,176:65392,177:65393,178:65394,179:65395,180:65396,181:65397,182:65398,183:65399,184:65400,185:65401,186:65402,187:65403,188:65404,189:65405,190:65406,191:65407,192:65408,193:65409,194:65410,195:65411,196:65412,197:65413,198:65414,199:65415,200:65416,201:65417,202:65418,203:65419,204:65420,205:65421,206:65422,207:65423,208:65424,209:65425,210:65426,211:65427,212:65428,213:65429,214:65430,215:65431,216:65432,217:65433,218:65434,219:65435,220:65436,221:65437,222:65438,223:65439,57408:28478,57409:28435,57410:28407,57411:28550,57412:28538,57413:28536,57414:28545,57415:28544,57416:28527,57417:28507,57418:28659,57419:28525,57420:28546,57421:28540,57422:28504,57423:28558,57424:28561,57425:28610,57426:28518,57427:28595,57428:28579,57429:28577,57430:28580,57431:28601,57432:28614,57433:28586,57434:28639,57435:28629,57436:28652,57437:28628,57438:28632,57439:28657,57440:28654,57441:28635,57442:28681,57443:28683,57444:28666,57445:28689,57446:28673,57447:28687,57448:28670,57449:28699,57450:28698,57451:28532,57452:28701,57453:28696,57454:28703,57455:28720,57456:28734,57457:28722,57458:28753,57459:28771,57460:28825,57461:28818,57462:28847,57463:28913,57464:28844,57465:28856,57466:28851,57467:28846,57468:28895,57469:28875,57470:28893,57472:28889,57473:28937,57474:28925,57475:28956,57476:28953,57477:29029,57478:29013,57479:29064,57480:29030,57481:29026,57482:29004,57483:29014,57484:29036,57485:29071,57486:29179,57487:29060,57488:29077,57489:29096,57490:29100,57491:29143,57492:29113,57493:29118,57494:29138,57495:29129,57496:29140,57497:29134,57498:29152,57499:29164,57500:29159,57501:29173,57502:29180,57503:29177,57504:29183,57505:29197,57506:29200,57507:29211,57508:29224,57509:29229,57510:29228,57511:29232,57512:29234,57513:29243,57514:29244,57515:29247,57516:29248,57517:29254,57518:29259,57519:29272,57520:29300,57521:29310,57522:29314,57523:29313,57524:29319,57525:29330,57526:29334,57527:29346,57528:29351,57529:29369,57530:29362,57531:29379,57532:29382,57533:29380,57534:29390,57535:29394,57536:29410,57537:29408,57538:29409,57539:29433,57540:29431,57541:20495,57542:29463,57543:29450,57544:29468,57545:29462,57546:29469,57547:29492,57548:29487,57549:29481,57550:29477,57551:29502,57552:29518,57553:29519,57554:40664,57555:29527,57556:29546,57557:29544,57558:29552,57559:29560,57560:29557,57561:29563,57562:29562,57563:29640,57564:29619,57565:29646,57566:29627,57567:29632,57568:29669,57569:29678,57570:29662,57571:29858,57572:29701,57573:29807,57574:29733,57575:29688,57576:29746,57577:29754,57578:29781,57579:29759,57580:29791,57581:29785,57582:29761,57583:29788,57584:29801,57585:29808,57586:29795,57587:29802,57588:29814,57589:29822,57590:29835,57591:29854,57592:29863,57593:29898,57594:29903,57595:29908,57596:29681,57664:29920,57665:29923,57666:29927,57667:29929,57668:29934,57669:29938,57670:29936,57671:29937,57672:29944,57673:29943,57674:29956,57675:29955,57676:29957,57677:29964,57678:29966,57679:29965,57680:29973,57681:29971,57682:29982,57683:29990,57684:29996,57685:30012,57686:30020,57687:30029,57688:30026,57689:30025,57690:30043,57691:30022,57692:30042,57693:30057,57694:30052,57695:30055,57696:30059,57697:30061,57698:30072,57699:30070,57700:30086,57701:30087,57702:30068,57703:30090,57704:30089,57705:30082,57706:30100,57707:30106,57708:30109,57709:30117,57710:30115,57711:30146,57712:30131,57713:30147,57714:30133,57715:30141,57716:30136,57717:30140,57718:30129,57719:30157,57720:30154,57721:30162,57722:30169,57723:30179,57724:30174,57725:30206,57726:30207,57728:30204,57729:30209,57730:30192,57731:30202,57732:30194,57733:30195,57734:30219,57735:30221,57736:30217,57737:30239,57738:30247,57739:30240,57740:30241,57741:30242,57742:30244,57743:30260,57744:30256,57745:30267,57746:30279,57747:30280,57748:30278,57749:30300,57750:30296,57751:30305,57752:30306,57753:30312,57754:30313,57755:30314,57756:30311,57757:30316,57758:30320,57759:30322,57760:30326,57761:30328,57762:30332,57763:30336,57764:30339,57765:30344,57766:30347,57767:30350,57768:30358,57769:30355,57770:30361,57771:30362,57772:30384,57773:30388,57774:30392,57775:30393,57776:30394,57777:30402,57778:30413,57779:30422,57780:30418,57781:30430,57782:30433,57783:30437,57784:30439,57785:30442,57786:34351,57787:30459,57788:30472,57789:30471,57790:30468,57791:30505,57792:30500,57793:30494,57794:30501,57795:30502,57796:30491,57797:30519,57798:30520,57799:30535,57800:30554,57801:30568,57802:30571,57803:30555,57804:30565,57805:30591,57806:30590,57807:30585,57808:30606,57809:30603,57810:30609,57811:30624,57812:30622,57813:30640,57814:30646,57815:30649,57816:30655,57817:30652,57818:30653,57819:30651,57820:30663,57821:30669,57822:30679,57823:30682,57824:30684,57825:30691,57826:30702,57827:30716,57828:30732,57829:30738,57830:31014,57831:30752,57832:31018,57833:30789,57834:30862,57835:30836,57836:30854,57837:30844,57838:30874,57839:30860,57840:30883,57841:30901,57842:30890,57843:30895,57844:30929,57845:30918,57846:30923,57847:30932,57848:30910,57849:30908,57850:30917,57851:30922,57852:30956,57920:30951,57921:30938,57922:30973,57923:30964,57924:30983,57925:30994,57926:30993,57927:31001,57928:31020,57929:31019,57930:31040,57931:31072,57932:31063,57933:31071,57934:31066,57935:31061,57936:31059,57937:31098,57938:31103,57939:31114,57940:31133,57941:31143,57942:40779,57943:31146,57944:31150,57945:31155,57946:31161,57947:31162,57948:31177,57949:31189,57950:31207,57951:31212,57952:31201,57953:31203,57954:31240,57955:31245,57956:31256,57957:31257,57958:31264,57959:31263,57960:31104,57961:31281,57962:31291,57963:31294,57964:31287,57965:31299,57966:31319,57967:31305,57968:31329,57969:31330,57970:31337,57971:40861,57972:31344,57973:31353,57974:31357,57975:31368,57976:31383,57977:31381,57978:31384,57979:31382,57980:31401,57981:31432,57982:31408,57984:31414,57985:31429,57986:31428,57987:31423,57988:36995,57989:31431,57990:31434,57991:31437,57992:31439,57993:31445,57994:31443,57995:31449,57996:31450,57997:31453,57998:31457,57999:31458,58e3:31462,58001:31469,58002:31472,58003:31490,58004:31503,58005:31498,58006:31494,58007:31539,58008:31512,58009:31513,58010:31518,58011:31541,58012:31528,58013:31542,58014:31568,58015:31610,58016:31492,58017:31565,58018:31499,58019:31564,58020:31557,58021:31605,58022:31589,58023:31604,58024:31591,58025:31600,58026:31601,58027:31596,58028:31598,58029:31645,58030:31640,58031:31647,58032:31629,58033:31644,58034:31642,58035:31627,58036:31634,58037:31631,58038:31581,58039:31641,58040:31691,58041:31681,58042:31692,58043:31695,58044:31668,58045:31686,58046:31709,58047:31721,58048:31761,58049:31764,58050:31718,58051:31717,58052:31840,58053:31744,58054:31751,58055:31763,58056:31731,58057:31735,58058:31767,58059:31757,58060:31734,58061:31779,58062:31783,58063:31786,58064:31775,58065:31799,58066:31787,58067:31805,58068:31820,58069:31811,58070:31828,58071:31823,58072:31808,58073:31824,58074:31832,58075:31839,58076:31844,58077:31830,58078:31845,58079:31852,58080:31861,58081:31875,58082:31888,58083:31908,58084:31917,58085:31906,58086:31915,58087:31905,58088:31912,58089:31923,58090:31922,58091:31921,58092:31918,58093:31929,58094:31933,58095:31936,58096:31941,58097:31938,58098:31960,58099:31954,58100:31964,58101:31970,58102:39739,58103:31983,58104:31986,58105:31988,58106:31990,58107:31994,58108:32006,58176:32002,58177:32028,58178:32021,58179:32010,58180:32069,58181:32075,58182:32046,58183:32050,58184:32063,58185:32053,58186:32070,58187:32115,58188:32086,58189:32078,58190:32114,58191:32104,58192:32110,58193:32079,58194:32099,58195:32147,58196:32137,58197:32091,58198:32143,58199:32125,58200:32155,58201:32186,58202:32174,58203:32163,58204:32181,58205:32199,58206:32189,58207:32171,58208:32317,58209:32162,58210:32175,58211:32220,58212:32184,58213:32159,58214:32176,58215:32216,58216:32221,58217:32228,58218:32222,58219:32251,58220:32242,58221:32225,58222:32261,58223:32266,58224:32291,58225:32289,58226:32274,58227:32305,58228:32287,58229:32265,58230:32267,58231:32290,58232:32326,58233:32358,58234:32315,58235:32309,58236:32313,58237:32323,58238:32311,58240:32306,58241:32314,58242:32359,58243:32349,58244:32342,58245:32350,58246:32345,58247:32346,58248:32377,58249:32362,58250:32361,58251:32380,58252:32379,58253:32387,58254:32213,58255:32381,58256:36782,58257:32383,58258:32392,58259:32393,58260:32396,58261:32402,58262:32400,58263:32403,58264:32404,58265:32406,58266:32398,58267:32411,58268:32412,58269:32568,58270:32570,58271:32581,58272:32588,58273:32589,58274:32590,58275:32592,58276:32593,58277:32597,58278:32596,58279:32600,58280:32607,58281:32608,58282:32616,58283:32617,58284:32615,58285:32632,58286:32642,58287:32646,58288:32643,58289:32648,58290:32647,58291:32652,58292:32660,58293:32670,58294:32669,58295:32666,58296:32675,58297:32687,58298:32690,58299:32697,58300:32686,58301:32694,58302:32696,58303:35697,58304:32709,58305:32710,58306:32714,58307:32725,58308:32724,58309:32737,58310:32742,58311:32745,58312:32755,58313:32761,58314:39132,58315:32774,58316:32772,58317:32779,58318:32786,58319:32792,58320:32793,58321:32796,58322:32801,58323:32808,58324:32831,58325:32827,58326:32842,58327:32838,58328:32850,58329:32856,58330:32858,58331:32863,58332:32866,58333:32872,58334:32883,58335:32882,58336:32880,58337:32886,58338:32889,58339:32893,58340:32895,58341:32900,58342:32902,58343:32901,58344:32923,58345:32915,58346:32922,58347:32941,58348:20880,58349:32940,58350:32987,58351:32997,58352:32985,58353:32989,58354:32964,58355:32986,58356:32982,58357:33033,58358:33007,58359:33009,58360:33051,58361:33065,58362:33059,58363:33071,58364:33099,58432:38539,58433:33094,58434:33086,58435:33107,58436:33105,58437:33020,58438:33137,58439:33134,58440:33125,58441:33126,58442:33140,58443:33155,58444:33160,58445:33162,58446:33152,58447:33154,58448:33184,58449:33173,58450:33188,58451:33187,58452:33119,58453:33171,58454:33193,58455:33200,58456:33205,58457:33214,58458:33208,58459:33213,58460:33216,58461:33218,58462:33210,58463:33225,58464:33229,58465:33233,58466:33241,58467:33240,58468:33224,58469:33242,58470:33247,58471:33248,58472:33255,58473:33274,58474:33275,58475:33278,58476:33281,58477:33282,58478:33285,58479:33287,58480:33290,58481:33293,58482:33296,58483:33302,58484:33321,58485:33323,58486:33336,58487:33331,58488:33344,58489:33369,58490:33368,58491:33373,58492:33370,58493:33375,58494:33380,58496:33378,58497:33384,58498:33386,58499:33387,58500:33326,58501:33393,58502:33399,58503:33400,58504:33406,58505:33421,58506:33426,58507:33451,58508:33439,58509:33467,58510:33452,58511:33505,58512:33507,58513:33503,58514:33490,58515:33524,58516:33523,58517:33530,58518:33683,58519:33539,58520:33531,58521:33529,58522:33502,58523:33542,58524:33500,58525:33545,58526:33497,58527:33589,58528:33588,58529:33558,58530:33586,58531:33585,58532:33600,58533:33593,58534:33616,58535:33605,58536:33583,58537:33579,58538:33559,58539:33560,58540:33669,58541:33690,58542:33706,58543:33695,58544:33698,58545:33686,58546:33571,58547:33678,58548:33671,58549:33674,58550:33660,58551:33717,58552:33651,58553:33653,58554:33696,58555:33673,58556:33704,58557:33780,58558:33811,58559:33771,58560:33742,58561:33789,58562:33795,58563:33752,58564:33803,58565:33729,58566:33783,58567:33799,58568:33760,58569:33778,58570:33805,58571:33826,58572:33824,58573:33725,58574:33848,58575:34054,58576:33787,58577:33901,58578:33834,58579:33852,58580:34138,58581:33924,58582:33911,58583:33899,58584:33965,58585:33902,58586:33922,58587:33897,58588:33862,58589:33836,58590:33903,58591:33913,58592:33845,58593:33994,58594:33890,58595:33977,58596:33983,58597:33951,58598:34009,58599:33997,58600:33979,58601:34010,58602:34e3,58603:33985,58604:33990,58605:34006,58606:33953,58607:34081,58608:34047,58609:34036,58610:34071,58611:34072,58612:34092,58613:34079,58614:34069,58615:34068,58616:34044,58617:34112,58618:34147,58619:34136,58620:34120,58688:34113,58689:34306,58690:34123,58691:34133,58692:34176,58693:34212,58694:34184,58695:34193,58696:34186,58697:34216,58698:34157,58699:34196,58700:34203,58701:34282,58702:34183,58703:34204,58704:34167,58705:34174,58706:34192,58707:34249,58708:34234,58709:34255,58710:34233,58711:34256,58712:34261,58713:34269,58714:34277,58715:34268,58716:34297,58717:34314,58718:34323,58719:34315,58720:34302,58721:34298,58722:34310,58723:34338,58724:34330,58725:34352,58726:34367,58727:34381,58728:20053,58729:34388,58730:34399,58731:34407,58732:34417,58733:34451,58734:34467,58735:34473,58736:34474,58737:34443,58738:34444,58739:34486,58740:34479,58741:34500,58742:34502,58743:34480,58744:34505,58745:34851,58746:34475,58747:34516,58748:34526,58749:34537,58750:34540,58752:34527,58753:34523,58754:34543,58755:34578,58756:34566,58757:34568,58758:34560,58759:34563,58760:34555,58761:34577,58762:34569,58763:34573,58764:34553,58765:34570,58766:34612,58767:34623,58768:34615,58769:34619,58770:34597,58771:34601,58772:34586,58773:34656,58774:34655,58775:34680,58776:34636,58777:34638,58778:34676,58779:34647,58780:34664,58781:34670,58782:34649,58783:34643,58784:34659,58785:34666,58786:34821,58787:34722,58788:34719,58789:34690,58790:34735,58791:34763,58792:34749,58793:34752,58794:34768,58795:38614,58796:34731,58797:34756,58798:34739,58799:34759,58800:34758,58801:34747,58802:34799,58803:34802,58804:34784,58805:34831,58806:34829,58807:34814,58808:34806,58809:34807,58810:34830,58811:34770,58812:34833,58813:34838,58814:34837,58815:34850,58816:34849,58817:34865,58818:34870,58819:34873,58820:34855,58821:34875,58822:34884,58823:34882,58824:34898,58825:34905,58826:34910,58827:34914,58828:34923,58829:34945,58830:34942,58831:34974,58832:34933,58833:34941,58834:34997,58835:34930,58836:34946,58837:34967,58838:34962,58839:34990,58840:34969,58841:34978,58842:34957,58843:34980,58844:34992,58845:35007,58846:34993,58847:35011,58848:35012,58849:35028,58850:35032,58851:35033,58852:35037,58853:35065,58854:35074,58855:35068,58856:35060,58857:35048,58858:35058,58859:35076,58860:35084,58861:35082,58862:35091,58863:35139,58864:35102,58865:35109,58866:35114,58867:35115,58868:35137,58869:35140,58870:35131,58871:35126,58872:35128,58873:35148,58874:35101,58875:35168,58876:35166,58944:35174,58945:35172,58946:35181,58947:35178,58948:35183,58949:35188,58950:35191,58951:35198,58952:35203,58953:35208,58954:35210,58955:35219,58956:35224,58957:35233,58958:35241,58959:35238,58960:35244,58961:35247,58962:35250,58963:35258,58964:35261,58965:35263,58966:35264,58967:35290,58968:35292,58969:35293,58970:35303,58971:35316,58972:35320,58973:35331,58974:35350,58975:35344,58976:35340,58977:35355,58978:35357,58979:35365,58980:35382,58981:35393,58982:35419,58983:35410,58984:35398,58985:35400,58986:35452,58987:35437,58988:35436,58989:35426,58990:35461,58991:35458,58992:35460,58993:35496,58994:35489,58995:35473,58996:35493,58997:35494,58998:35482,58999:35491,59e3:35524,59001:35533,59002:35522,59003:35546,59004:35563,59005:35571,59006:35559,59008:35556,59009:35569,59010:35604,59011:35552,59012:35554,59013:35575,59014:35550,59015:35547,59016:35596,59017:35591,59018:35610,59019:35553,59020:35606,59021:35600,59022:35607,59023:35616,59024:35635,59025:38827,59026:35622,59027:35627,59028:35646,59029:35624,59030:35649,59031:35660,59032:35663,59033:35662,59034:35657,59035:35670,59036:35675,59037:35674,59038:35691,59039:35679,59040:35692,59041:35695,59042:35700,59043:35709,59044:35712,59045:35724,59046:35726,59047:35730,59048:35731,59049:35734,59050:35737,59051:35738,59052:35898,59053:35905,59054:35903,59055:35912,59056:35916,59057:35918,59058:35920,59059:35925,59060:35938,59061:35948,59062:35960,59063:35962,59064:35970,59065:35977,59066:35973,59067:35978,59068:35981,59069:35982,59070:35988,59071:35964,59072:35992,59073:25117,59074:36013,59075:36010,59076:36029,59077:36018,59078:36019,59079:36014,59080:36022,59081:36040,59082:36033,59083:36068,59084:36067,59085:36058,59086:36093,59087:36090,59088:36091,59089:36100,59090:36101,59091:36106,59092:36103,59093:36111,59094:36109,59095:36112,59096:40782,59097:36115,59098:36045,59099:36116,59100:36118,59101:36199,59102:36205,59103:36209,59104:36211,59105:36225,59106:36249,59107:36290,59108:36286,59109:36282,59110:36303,59111:36314,59112:36310,59113:36300,59114:36315,59115:36299,59116:36330,59117:36331,59118:36319,59119:36323,59120:36348,59121:36360,59122:36361,59123:36351,59124:36381,59125:36382,59126:36368,59127:36383,59128:36418,59129:36405,59130:36400,59131:36404,59132:36426,59200:36423,59201:36425,59202:36428,59203:36432,59204:36424,59205:36441,59206:36452,59207:36448,59208:36394,59209:36451,59210:36437,59211:36470,59212:36466,59213:36476,59214:36481,59215:36487,59216:36485,59217:36484,59218:36491,59219:36490,59220:36499,59221:36497,59222:36500,59223:36505,59224:36522,59225:36513,59226:36524,59227:36528,59228:36550,59229:36529,59230:36542,59231:36549,59232:36552,59233:36555,59234:36571,59235:36579,59236:36604,59237:36603,59238:36587,59239:36606,59240:36618,59241:36613,59242:36629,59243:36626,59244:36633,59245:36627,59246:36636,59247:36639,59248:36635,59249:36620,59250:36646,59251:36659,59252:36667,59253:36665,59254:36677,59255:36674,59256:36670,59257:36684,59258:36681,59259:36678,59260:36686,59261:36695,59262:36700,59264:36706,59265:36707,59266:36708,59267:36764,59268:36767,59269:36771,59270:36781,59271:36783,59272:36791,59273:36826,59274:36837,59275:36834,59276:36842,59277:36847,59278:36999,59279:36852,59280:36869,59281:36857,59282:36858,59283:36881,59284:36885,59285:36897,59286:36877,59287:36894,59288:36886,59289:36875,59290:36903,59291:36918,59292:36917,59293:36921,59294:36856,59295:36943,59296:36944,59297:36945,59298:36946,59299:36878,59300:36937,59301:36926,59302:36950,59303:36952,59304:36958,59305:36968,59306:36975,59307:36982,59308:38568,59309:36978,59310:36994,59311:36989,59312:36993,59313:36992,59314:37002,59315:37001,59316:37007,59317:37032,59318:37039,59319:37041,59320:37045,59321:37090,59322:37092,59323:25160,59324:37083,59325:37122,59326:37138,59327:37145,59328:37170,59329:37168,59330:37194,59331:37206,59332:37208,59333:37219,59334:37221,59335:37225,59336:37235,59337:37234,59338:37259,59339:37257,59340:37250,59341:37282,59342:37291,59343:37295,59344:37290,59345:37301,59346:37300,59347:37306,59348:37312,59349:37313,59350:37321,59351:37323,59352:37328,59353:37334,59354:37343,59355:37345,59356:37339,59357:37372,59358:37365,59359:37366,59360:37406,59361:37375,59362:37396,59363:37420,59364:37397,59365:37393,59366:37470,59367:37463,59368:37445,59369:37449,59370:37476,59371:37448,59372:37525,59373:37439,59374:37451,59375:37456,59376:37532,59377:37526,59378:37523,59379:37531,59380:37466,59381:37583,59382:37561,59383:37559,59384:37609,59385:37647,59386:37626,59387:37700,59388:37678,59456:37657,59457:37666,59458:37658,59459:37667,59460:37690,59461:37685,59462:37691,59463:37724,59464:37728,59465:37756,59466:37742,59467:37718,59468:37808,59469:37804,59470:37805,59471:37780,59472:37817,59473:37846,59474:37847,59475:37864,59476:37861,59477:37848,59478:37827,59479:37853,59480:37840,59481:37832,59482:37860,59483:37914,59484:37908,59485:37907,59486:37891,59487:37895,59488:37904,59489:37942,59490:37931,59491:37941,59492:37921,59493:37946,59494:37953,59495:37970,59496:37956,59497:37979,59498:37984,59499:37986,59500:37982,59501:37994,59502:37417,59503:38e3,59504:38005,59505:38007,59506:38013,59507:37978,59508:38012,59509:38014,59510:38017,59511:38015,59512:38274,59513:38279,59514:38282,59515:38292,59516:38294,59517:38296,59518:38297,59520:38304,59521:38312,59522:38311,59523:38317,59524:38332,59525:38331,59526:38329,59527:38334,59528:38346,59529:28662,59530:38339,59531:38349,59532:38348,59533:38357,59534:38356,59535:38358,59536:38364,59537:38369,59538:38373,59539:38370,59540:38433,59541:38440,59542:38446,59543:38447,59544:38466,59545:38476,59546:38479,59547:38475,59548:38519,59549:38492,59550:38494,59551:38493,59552:38495,59553:38502,59554:38514,59555:38508,59556:38541,59557:38552,59558:38549,59559:38551,59560:38570,59561:38567,59562:38577,59563:38578,59564:38576,59565:38580,59566:38582,59567:38584,59568:38585,59569:38606,59570:38603,59571:38601,59572:38605,59573:35149,59574:38620,59575:38669,59576:38613,59577:38649,59578:38660,59579:38662,59580:38664,59581:38675,59582:38670,59583:38673,59584:38671,59585:38678,59586:38681,59587:38692,59588:38698,59589:38704,59590:38713,59591:38717,59592:38718,59593:38724,59594:38726,59595:38728,59596:38722,59597:38729,59598:38748,59599:38752,59600:38756,59601:38758,59602:38760,59603:21202,59604:38763,59605:38769,59606:38777,59607:38789,59608:38780,59609:38785,59610:38778,59611:38790,59612:38795,59613:38799,59614:38800,59615:38812,59616:38824,59617:38822,59618:38819,59619:38835,59620:38836,59621:38851,59622:38854,59623:38856,59624:38859,59625:38876,59626:38893,59627:40783,59628:38898,59629:31455,59630:38902,59631:38901,59632:38927,59633:38924,59634:38968,59635:38948,59636:38945,59637:38967,59638:38973,59639:38982,59640:38991,59641:38987,59642:39019,59643:39023,59644:39024,59712:39025,59713:39028,59714:39027,59715:39082,59716:39087,59717:39089,59718:39094,59719:39108,59720:39107,59721:39110,59722:39145,59723:39147,59724:39171,59725:39177,59726:39186,59727:39188,59728:39192,59729:39201,59730:39197,59731:39198,59732:39204,59733:39200,59734:39212,59735:39214,59736:39229,59737:39230,59738:39234,59739:39241,59740:39237,59741:39248,59742:39243,59743:39249,59744:39250,59745:39244,59746:39253,59747:39319,59748:39320,59749:39333,59750:39341,59751:39342,59752:39356,59753:39391,59754:39387,59755:39389,59756:39384,59757:39377,59758:39405,59759:39406,59760:39409,59761:39410,59762:39419,59763:39416,59764:39425,59765:39439,59766:39429,59767:39394,59768:39449,59769:39467,59770:39479,59771:39493,59772:39490,59773:39488,59774:39491,59776:39486,59777:39509,59778:39501,59779:39515,59780:39511,59781:39519,59782:39522,59783:39525,59784:39524,59785:39529,59786:39531,59787:39530,59788:39597,59789:39600,59790:39612,59791:39616,59792:39631,59793:39633,59794:39635,59795:39636,59796:39646,59797:39647,59798:39650,59799:39651,59800:39654,59801:39663,59802:39659,59803:39662,59804:39668,59805:39665,59806:39671,59807:39675,59808:39686,59809:39704,59810:39706,59811:39711,59812:39714,59813:39715,59814:39717,59815:39719,59816:39720,59817:39721,59818:39722,59819:39726,59820:39727,59821:39730,59822:39748,59823:39747,59824:39759,59825:39757,59826:39758,59827:39761,59828:39768,59829:39796,59830:39827,59831:39811,59832:39825,59833:39830,59834:39831,59835:39839,59836:39840,59837:39848,59838:39860,59839:39872,59840:39882,59841:39865,59842:39878,59843:39887,59844:39889,59845:39890,59846:39907,59847:39906,59848:39908,59849:39892,59850:39905,59851:39994,59852:39922,59853:39921,59854:39920,59855:39957,59856:39956,59857:39945,59858:39955,59859:39948,59860:39942,59861:39944,59862:39954,59863:39946,59864:39940,59865:39982,59866:39963,59867:39973,59868:39972,59869:39969,59870:39984,59871:40007,59872:39986,59873:40006,59874:39998,59875:40026,59876:40032,59877:40039,59878:40054,59879:40056,59880:40167,59881:40172,59882:40176,59883:40201,59884:40200,59885:40171,59886:40195,59887:40198,59888:40234,59889:40230,59890:40367,59891:40227,59892:40223,59893:40260,59894:40213,59895:40210,59896:40257,59897:40255,59898:40254,59899:40262,59900:40264,59968:40285,59969:40286,59970:40292,59971:40273,59972:40272,59973:40281,59974:40306,59975:40329,59976:40327,59977:40363,59978:40303,59979:40314,59980:40346,59981:40356,59982:40361,59983:40370,59984:40388,59985:40385,59986:40379,59987:40376,59988:40378,59989:40390,59990:40399,59991:40386,59992:40409,59993:40403,59994:40440,59995:40422,59996:40429,59997:40431,59998:40445,59999:40474,6e4:40475,60001:40478,60002:40565,60003:40569,60004:40573,60005:40577,60006:40584,60007:40587,60008:40588,60009:40594,60010:40597,60011:40593,60012:40605,60013:40613,60014:40617,60015:40632,60016:40618,60017:40621,60018:38753,60019:40652,60020:40654,60021:40655,60022:40656,60023:40660,60024:40668,60025:40670,60026:40669,60027:40672,60028:40677,60029:40680,60030:40687,60032:40692,60033:40694,60034:40695,60035:40697,60036:40699,60037:40700,60038:40701,60039:40711,60040:40712,60041:30391,60042:40725,60043:40737,60044:40748,60045:40766,60046:40778,60047:40786,60048:40788,60049:40803,60050:40799,60051:40800,60052:40801,60053:40806,60054:40807,60055:40812,60056:40810,60057:40823,60058:40818,60059:40822,60060:40853,60061:40860,60062:40864,60063:22575,60064:27079,60065:36953,60066:29796,60067:20956,60068:29081}},function(o,e,r){"use strict";function t(o,e,r,t){e.degree()<r.degree()&&(w=[r,e],e=w[0],r=w[1]);for(var c=e,s=r,a=o.zero,n=o.one;s.degree()>=t/2;){var d=c,l=a;if(c=s,a=n,c.isZero())return null;s=d;for(var i=o.zero,B=c.getCoefficient(c.degree()),k=o.inverse(B);s.degree()>=c.degree()&&!s.isZero();){var u=s.degree()-c.degree(),C=o.multiply(s.getCoefficient(s.degree()),k);i=i.addOrSubtract(o.buildMonomial(u,C)),s=s.addOrSubtract(c.multiplyByMonomial(u,C))}if(n=i.multiplyPoly(a).addOrSubtract(l),s.degree()>=c.degree())return null}var m=n.getCoefficient(0);if(0===m)return null;var f=o.inverse(m);return[n.multiply(f),s.multiply(f)];var w}function c(o,e){var r=e.degree();if(1===r)return[e.getCoefficient(1)];for(var t=new Array(r),c=0,s=1;s<o.size&&c<r;s++)0===e.evaluateAt(s)&&(t[c]=o.inverse(s),c++);return c!==r?null:t}function s(o,e,r){for(var t=r.length,c=new Array(t),s=0;s<t;s++){for(var a=o.inverse(r[s]),d=1,l=0;l<t;l++)s!==l&&(d=o.multiply(d,n.addOrSubtractGF(1,o.multiply(r[l],a))));c[s]=o.multiply(e.evaluateAt(a),o.inverse(d)),0!==o.generatorBase&&(c[s]=o.multiply(c[s],a))}return c}function a(o,e){var r=new Uint8ClampedArray(o.length);r.set(o);for(var a=new n.default(285,256,0),l=new d.default(a,r),i=new Uint8ClampedArray(e),B=!1,k=0;k<e;k++){var u=l.evaluateAt(a.exp(k+a.generatorBase));i[i.length-1-k]=u,0!==u&&(B=!0)}if(!B)return r;var C=new d.default(a,i),m=t(a,a.buildMonomial(e,1),C,e);if(null===m)return null;var f=c(a,m[0]);if(null==f)return null;for(var w=s(a,m[1],f),P=0;P<f.length;P++){var v=r.length-1-a.log(f[P]);if(v<0)return null;r[v]=n.addOrSubtractGF(r[v],w[P])}return r}Object.defineProperty(e,"__esModule",{value:!0});var n=r(1),d=r(2);e.decode=a},function(o,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.VERSIONS=[{infoBits:null,versionNumber:1,alignmentPatternCenters:[],errorCorrectionLevels:[{ecCodewordsPerBlock:7,ecBlocks:[{numBlocks:1,dataCodewordsPerBlock:19}]},{ecCodewordsPerBlock:10,ecBlocks:[{numBlocks:1,dataCodewordsPerBlock:16}]},{ecCodewordsPerBlock:13,ecBlocks:[{numBlocks:1,dataCodewordsPerBlock:13}]},{ecCodewordsPerBlock:17,ecBlocks:[{numBlocks:1,dataCodewordsPerBlock:9}]}]},{infoBits:null,versionNumber:2,alignmentPatternCenters:[6,18],errorCorrectionLevels:[{ecCodewordsPerBlock:10,ecBlocks:[{numBlocks:1,dataCodewordsPerBlock:34}]},{ecCodewordsPerBlock:16,ecBlocks:[{numBlocks:1,dataCodewordsPerBlock:28}]},{ecCodewordsPerBlock:22,ecBlocks:[{numBlocks:1,dataCodewordsPerBlock:22}]},{ecCodewordsPerBlock:28,ecBlocks:[{numBlocks:1,dataCodewordsPerBlock:16}]}]},{infoBits:null,versionNumber:3,alignmentPatternCenters:[6,22],errorCorrectionLevels:[{ecCodewordsPerBlock:15,ecBlocks:[{numBlocks:1,dataCodewordsPerBlock:55}]},{ecCodewordsPerBlock:26,ecBlocks:[{numBlocks:1,dataCodewordsPerBlock:44}]},{ecCodewordsPerBlock:18,ecBlocks:[{numBlocks:2,dataCodewordsPerBlock:17}]},{ecCodewordsPerBlock:22,ecBlocks:[{numBlocks:2,dataCodewordsPerBlock:13}]}]},{infoBits:null,versionNumber:4,alignmentPatternCenters:[6,26],errorCorrectionLevels:[{ecCodewordsPerBlock:20,ecBlocks:[{numBlocks:1,dataCodewordsPerBlock:80}]},{ecCodewordsPerBlock:18,ecBlocks:[{numBlocks:2,dataCodewordsPerBlock:32}]},{ecCodewordsPerBlock:26,ecBlocks:[{numBlocks:2,dataCodewordsPerBlock:24}]},{ecCodewordsPerBlock:16,ecBlocks:[{numBlocks:4,dataCodewordsPerBlock:9}]}]},{infoBits:null,versionNumber:5,alignmentPatternCenters:[6,30],errorCorrectionLevels:[{ecCodewordsPerBlock:26,ecBlocks:[{numBlocks:1,dataCodewordsPerBlock:108}]},{ecCodewordsPerBlock:24,ecBlocks:[{numBlocks:2,dataCodewordsPerBlock:43}]},{ecCodewordsPerBlock:18,ecBlocks:[{numBlocks:2,dataCodewordsPerBlock:15},{numBlocks:2,dataCodewordsPerBlock:16}]},{ecCodewordsPerBlock:22,ecBlocks:[{numBlocks:2,dataCodewordsPerBlock:11},{numBlocks:2,dataCodewordsPerBlock:12}]}]},{infoBits:null,versionNumber:6,alignmentPatternCenters:[6,34],errorCorrectionLevels:[{ecCodewordsPerBlock:18,ecBlocks:[{numBlocks:2,dataCodewordsPerBlock:68}]},{ecCodewordsPerBlock:16,ecBlocks:[{numBlocks:4,dataCodewordsPerBlock:27}]},{ecCodewordsPerBlock:24,ecBlocks:[{numBlocks:4,dataCodewordsPerBlock:19}]},{ecCodewordsPerBlock:28,ecBlocks:[{numBlocks:4,dataCodewordsPerBlock:15}]}]},{infoBits:31892,versionNumber:7,alignmentPatternCenters:[6,22,38],errorCorrectionLevels:[{ecCodewordsPerBlock:20,ecBlocks:[{numBlocks:2,dataCodewordsPerBlock:78}]},{ecCodewordsPerBlock:18,ecBlocks:[{numBlocks:4,dataCodewordsPerBlock:31}]},{ecCodewordsPerBlock:18,ecBlocks:[{numBlocks:2,dataCodewordsPerBlock:14},{numBlocks:4,dataCodewordsPerBlock:15}]},{ecCodewordsPerBlock:26,ecBlocks:[{numBlocks:4,dataCodewordsPerBlock:13},{numBlocks:1,dataCodewordsPerBlock:14}]}]},{infoBits:34236,versionNumber:8,alignmentPatternCenters:[6,24,42],errorCorrectionLevels:[{ecCodewordsPerBlock:24,ecBlocks:[{numBlocks:2,dataCodewordsPerBlock:97}]},{ecCodewordsPerBlock:22,ecBlocks:[{numBlocks:2,dataCodewordsPerBlock:38},{numBlocks:2,dataCodewordsPerBlock:39}]},{ecCodewordsPerBlock:22,ecBlocks:[{numBlocks:4,dataCodewordsPerBlock:18},{numBlocks:2,dataCodewordsPerBlock:19}]},{ecCodewordsPerBlock:26,ecBlocks:[{numBlocks:4,dataCodewordsPerBlock:14},{numBlocks:2,dataCodewordsPerBlock:15}]}]},{infoBits:39577,versionNumber:9,alignmentPatternCenters:[6,26,46],errorCorrectionLevels:[{ecCodewordsPerBlock:30,ecBlocks:[{numBlocks:2,dataCodewordsPerBlock:116}]},{ecCodewordsPerBlock:22,ecBlocks:[{numBlocks:3,dataCodewordsPerBlock:36},{numBlocks:2,dataCodewordsPerBlock:37}]},{ecCodewordsPerBlock:20,ecBlocks:[{numBlocks:4,dataCodewordsPerBlock:16},{numBlocks:4,dataCodewordsPerBlock:17}]},{ecCodewordsPerBlock:24,ecBlocks:[{numBlocks:4,dataCodewordsPerBlock:12},{numBlocks:4,dataCodewordsPerBlock:13}]}]},{infoBits:42195,versionNumber:10,alignmentPatternCenters:[6,28,50],errorCorrectionLevels:[{ecCodewordsPerBlock:18,ecBlocks:[{numBlocks:2,dataCodewordsPerBlock:68},{numBlocks:2,dataCodewordsPerBlock:69}]},{ecCodewordsPerBlock:26,ecBlocks:[{numBlocks:4,dataCodewordsPerBlock:43},{numBlocks:1,dataCodewordsPerBlock:44}]},{ecCodewordsPerBlock:24,ecBlocks:[{numBlocks:6,dataCodewordsPerBlock:19},{numBlocks:2,dataCodewordsPerBlock:20}]},{ecCodewordsPerBlock:28,ecBlocks:[{numBlocks:6,dataCodewordsPerBlock:15},{numBlocks:2,dataCodewordsPerBlock:16}]}]},{infoBits:48118,versionNumber:11,alignmentPatternCenters:[6,30,54],errorCorrectionLevels:[{ecCodewordsPerBlock:20,ecBlocks:[{numBlocks:4,dataCodewordsPerBlock:81}]},{ecCodewordsPerBlock:30,ecBlocks:[{numBlocks:1,dataCodewordsPerBlock:50},{numBlocks:4,dataCodewordsPerBlock:51}]},{ecCodewordsPerBlock:28,ecBlocks:[{numBlocks:4,dataCodewordsPerBlock:22},{numBlocks:4,dataCodewordsPerBlock:23}]},{ecCodewordsPerBlock:24,ecBlocks:[{numBlocks:3,dataCodewordsPerBlock:12},{numBlocks:8,dataCodewordsPerBlock:13}]}]},{infoBits:51042,versionNumber:12,alignmentPatternCenters:[6,32,58],errorCorrectionLevels:[{ecCodewordsPerBlock:24,ecBlocks:[{numBlocks:2,dataCodewordsPerBlock:92},{numBlocks:2,dataCodewordsPerBlock:93}]},{ecCodewordsPerBlock:22,ecBlocks:[{numBlocks:6,dataCodewordsPerBlock:36},{numBlocks:2,dataCodewordsPerBlock:37}]},{ecCodewordsPerBlock:26,ecBlocks:[{numBlocks:4,dataCodewordsPerBlock:20},{numBlocks:6,dataCodewordsPerBlock:21}]},{ecCodewordsPerBlock:28,ecBlocks:[{numBlocks:7,dataCodewordsPerBlock:14},{numBlocks:4,dataCodewordsPerBlock:15}]}]},{infoBits:55367,versionNumber:13,alignmentPatternCenters:[6,34,62],errorCorrectionLevels:[{ecCodewordsPerBlock:26,ecBlocks:[{numBlocks:4,dataCodewordsPerBlock:107}]},{ecCodewordsPerBlock:22,ecBlocks:[{numBlocks:8,dataCodewordsPerBlock:37},{numBlocks:1,dataCodewordsPerBlock:38}]},{ecCodewordsPerBlock:24,ecBlocks:[{numBlocks:8,dataCodewordsPerBlock:20},{numBlocks:4,dataCodewordsPerBlock:21}]},{ecCodewordsPerBlock:22,ecBlocks:[{numBlocks:12,dataCodewordsPerBlock:11},{numBlocks:4,dataCodewordsPerBlock:12}]}]},{infoBits:58893,versionNumber:14,alignmentPatternCenters:[6,26,46,66],errorCorrectionLevels:[{ecCodewordsPerBlock:30,ecBlocks:[{numBlocks:3,dataCodewordsPerBlock:115},{numBlocks:1,dataCodewordsPerBlock:116}]},{ecCodewordsPerBlock:24,ecBlocks:[{numBlocks:4,dataCodewordsPerBlock:40},{numBlocks:5,dataCodewordsPerBlock:41}]},{ecCodewordsPerBlock:20,ecBlocks:[{numBlocks:11,dataCodewordsPerBlock:16},{numBlocks:5,dataCodewordsPerBlock:17}]},{ecCodewordsPerBlock:24,ecBlocks:[{numBlocks:11,dataCodewordsPerBlock:12},{numBlocks:5,dataCodewordsPerBlock:13}]}]},{infoBits:63784,versionNumber:15,alignmentPatternCenters:[6,26,48,70],errorCorrectionLevels:[{ecCodewordsPerBlock:22,ecBlocks:[{numBlocks:5,dataCodewordsPerBlock:87},{numBlocks:1,dataCodewordsPerBlock:88}]},{ecCodewordsPerBlock:24,ecBlocks:[{numBlocks:5,dataCodewordsPerBlock:41},{numBlocks:5,dataCodewordsPerBlock:42}]},{ecCodewordsPerBlock:30,ecBlocks:[{numBlocks:5,dataCodewordsPerBlock:24},{numBlocks:7,dataCodewordsPerBlock:25}]},{ecCodewordsPerBlock:24,ecBlocks:[{numBlocks:11,dataCodewordsPerBlock:12},{numBlocks:7,dataCodewordsPerBlock:13}]}]},{infoBits:68472,versionNumber:16,alignmentPatternCenters:[6,26,50,74],errorCorrectionLevels:[{ecCodewordsPerBlock:24,ecBlocks:[{numBlocks:5,dataCodewordsPerBlock:98},{numBlocks:1,dataCodewordsPerBlock:99}]},{ecCodewordsPerBlock:28,ecBlocks:[{numBlocks:7,dataCodewordsPerBlock:45},{numBlocks:3,dataCodewordsPerBlock:46}]},{ecCodewordsPerBlock:24,ecBlocks:[{numBlocks:15,dataCodewordsPerBlock:19},{numBlocks:2,dataCodewordsPerBlock:20}]},{ecCodewordsPerBlock:30,ecBlocks:[{numBlocks:3,dataCodewordsPerBlock:15},{numBlocks:13,dataCodewordsPerBlock:16}]}]},{infoBits:70749,versionNumber:17,alignmentPatternCenters:[6,30,54,78],errorCorrectionLevels:[{ecCodewordsPerBlock:28,ecBlocks:[{numBlocks:1,dataCodewordsPerBlock:107},{numBlocks:5,dataCodewordsPerBlock:108}]},{ecCodewordsPerBlock:28,ecBlocks:[{numBlocks:10,dataCodewordsPerBlock:46},{numBlocks:1,dataCodewordsPerBlock:47}]},{ecCodewordsPerBlock:28,ecBlocks:[{numBlocks:1,dataCodewordsPerBlock:22},{numBlocks:15,dataCodewordsPerBlock:23}]},{ecCodewordsPerBlock:28,ecBlocks:[{numBlocks:2,dataCodewordsPerBlock:14},{numBlocks:17,dataCodewordsPerBlock:15}]}]},{infoBits:76311,versionNumber:18,alignmentPatternCenters:[6,30,56,82],errorCorrectionLevels:[{ecCodewordsPerBlock:30,ecBlocks:[{numBlocks:5,dataCodewordsPerBlock:120},{numBlocks:1,dataCodewordsPerBlock:121}]},{ecCodewordsPerBlock:26,ecBlocks:[{numBlocks:9,dataCodewordsPerBlock:43},{numBlocks:4,dataCodewordsPerBlock:44}]},{ecCodewordsPerBlock:28,ecBlocks:[{numBlocks:17,dataCodewordsPerBlock:22},{numBlocks:1,dataCodewordsPerBlock:23}]},{ecCodewordsPerBlock:28,ecBlocks:[{numBlocks:2,dataCodewordsPerBlock:14},{numBlocks:19,dataCodewordsPerBlock:15}]}]},{infoBits:79154,versionNumber:19,alignmentPatternCenters:[6,30,58,86],errorCorrectionLevels:[{ecCodewordsPerBlock:28,ecBlocks:[{numBlocks:3,dataCodewordsPerBlock:113},{numBlocks:4,dataCodewordsPerBlock:114}]},{ecCodewordsPerBlock:26,ecBlocks:[{numBlocks:3,dataCodewordsPerBlock:44},{numBlocks:11,dataCodewordsPerBlock:45}]},{ecCodewordsPerBlock:26,ecBlocks:[{numBlocks:17,dataCodewordsPerBlock:21},{numBlocks:4,dataCodewordsPerBlock:22}]},{ecCodewordsPerBlock:26,ecBlocks:[{numBlocks:9,dataCodewordsPerBlock:13},{numBlocks:16,dataCodewordsPerBlock:14}]}]},{infoBits:84390,versionNumber:20,alignmentPatternCenters:[6,34,62,90],errorCorrectionLevels:[{ecCodewordsPerBlock:28,ecBlocks:[{numBlocks:3,dataCodewordsPerBlock:107},{numBlocks:5,dataCodewordsPerBlock:108}]},{ecCodewordsPerBlock:26,ecBlocks:[{numBlocks:3,dataCodewordsPerBlock:41},{numBlocks:13,dataCodewordsPerBlock:42}]},{ecCodewordsPerBlock:30,ecBlocks:[{numBlocks:15,dataCodewordsPerBlock:24},{numBlocks:5,dataCodewordsPerBlock:25}]},{ecCodewordsPerBlock:28,ecBlocks:[{numBlocks:15,dataCodewordsPerBlock:15},{numBlocks:10,dataCodewordsPerBlock:16}]}]},{infoBits:87683,versionNumber:21,alignmentPatternCenters:[6,28,50,72,94],errorCorrectionLevels:[{ecCodewordsPerBlock:28,ecBlocks:[{numBlocks:4,dataCodewordsPerBlock:116},{numBlocks:4,dataCodewordsPerBlock:117}]},{ecCodewordsPerBlock:26,ecBlocks:[{numBlocks:17,dataCodewordsPerBlock:42}]},{ecCodewordsPerBlock:28,ecBlocks:[{numBlocks:17,dataCodewordsPerBlock:22},{numBlocks:6,dataCodewordsPerBlock:23}]},{ecCodewordsPerBlock:30,ecBlocks:[{numBlocks:19,dataCodewordsPerBlock:16},{numBlocks:6,dataCodewordsPerBlock:17}]}]},{infoBits:92361,versionNumber:22,alignmentPatternCenters:[6,26,50,74,98],errorCorrectionLevels:[{ecCodewordsPerBlock:28,ecBlocks:[{numBlocks:2,dataCodewordsPerBlock:111},{numBlocks:7,dataCodewordsPerBlock:112}]},{ecCodewordsPerBlock:28,ecBlocks:[{numBlocks:17,dataCodewordsPerBlock:46}]},{ecCodewordsPerBlock:30,ecBlocks:[{numBlocks:7,dataCodewordsPerBlock:24},{numBlocks:16,dataCodewordsPerBlock:25}]},{ecCodewordsPerBlock:24,ecBlocks:[{numBlocks:34,dataCodewordsPerBlock:13}]}]},{infoBits:96236,versionNumber:23,alignmentPatternCenters:[6,30,54,74,102],errorCorrectionLevels:[{ecCodewordsPerBlock:30,ecBlocks:[{numBlocks:4,dataCodewordsPerBlock:121},{numBlocks:5,dataCodewordsPerBlock:122}]},{ecCodewordsPerBlock:28,ecBlocks:[{numBlocks:4,dataCodewordsPerBlock:47},{numBlocks:14,dataCodewordsPerBlock:48}]},{ecCodewordsPerBlock:30,ecBlocks:[{numBlocks:11,dataCodewordsPerBlock:24},{numBlocks:14,dataCodewordsPerBlock:25}]},{ecCodewordsPerBlock:30,ecBlocks:[{numBlocks:16,dataCodewordsPerBlock:15},{numBlocks:14,dataCodewordsPerBlock:16}]}]},{infoBits:102084,versionNumber:24,alignmentPatternCenters:[6,28,54,80,106],errorCorrectionLevels:[{ecCodewordsPerBlock:30,ecBlocks:[{numBlocks:6,dataCodewordsPerBlock:117},{numBlocks:4,dataCodewordsPerBlock:118}]},{ecCodewordsPerBlock:28,ecBlocks:[{numBlocks:6,dataCodewordsPerBlock:45},{numBlocks:14,dataCodewordsPerBlock:46}]},{ecCodewordsPerBlock:30,ecBlocks:[{numBlocks:11,dataCodewordsPerBlock:24},{numBlocks:16,dataCodewordsPerBlock:25}]},{ecCodewordsPerBlock:30,ecBlocks:[{numBlocks:30,dataCodewordsPerBlock:16},{numBlocks:2,dataCodewordsPerBlock:17}]}]},{infoBits:102881,versionNumber:25,alignmentPatternCenters:[6,32,58,84,110],errorCorrectionLevels:[{ecCodewordsPerBlock:26,ecBlocks:[{numBlocks:8,dataCodewordsPerBlock:106},{numBlocks:4,dataCodewordsPerBlock:107}]},{ecCodewordsPerBlock:28,ecBlocks:[{numBlocks:8,dataCodewordsPerBlock:47},{numBlocks:13,dataCodewordsPerBlock:48}]},{ecCodewordsPerBlock:30,ecBlocks:[{numBlocks:7,dataCodewordsPerBlock:24},{numBlocks:22,dataCodewordsPerBlock:25}]},{ecCodewordsPerBlock:30,ecBlocks:[{numBlocks:22,dataCodewordsPerBlock:15},{numBlocks:13,dataCodewordsPerBlock:16}]}]},{infoBits:110507,versionNumber:26,alignmentPatternCenters:[6,30,58,86,114],errorCorrectionLevels:[{ecCodewordsPerBlock:28,ecBlocks:[{numBlocks:10,dataCodewordsPerBlock:114},{numBlocks:2,dataCodewordsPerBlock:115}]},{ecCodewordsPerBlock:28,ecBlocks:[{numBlocks:19,dataCodewordsPerBlock:46},{numBlocks:4,dataCodewordsPerBlock:47}]},{ecCodewordsPerBlock:28,ecBlocks:[{numBlocks:28,dataCodewordsPerBlock:22},{numBlocks:6,dataCodewordsPerBlock:23}]},{ecCodewordsPerBlock:30,ecBlocks:[{numBlocks:33,dataCodewordsPerBlock:16},{numBlocks:4,dataCodewordsPerBlock:17}]}]},{infoBits:110734,versionNumber:27,alignmentPatternCenters:[6,34,62,90,118],errorCorrectionLevels:[{ecCodewordsPerBlock:30,ecBlocks:[{numBlocks:8,dataCodewordsPerBlock:122},{numBlocks:4,dataCodewordsPerBlock:123}]},{ecCodewordsPerBlock:28,ecBlocks:[{numBlocks:22,dataCodewordsPerBlock:45},{numBlocks:3,dataCodewordsPerBlock:46}]},{ecCodewordsPerBlock:30,ecBlocks:[{numBlocks:8,dataCodewordsPerBlock:23},{numBlocks:26,dataCodewordsPerBlock:24}]},{ecCodewordsPerBlock:30,ecBlocks:[{numBlocks:12,dataCodewordsPerBlock:15},{numBlocks:28,dataCodewordsPerBlock:16}]}]},{infoBits:117786,versionNumber:28,alignmentPatternCenters:[6,26,50,74,98,122],errorCorrectionLevels:[{ecCodewordsPerBlock:30,ecBlocks:[{numBlocks:3,dataCodewordsPerBlock:117},{numBlocks:10,dataCodewordsPerBlock:118}]},{ecCodewordsPerBlock:28,ecBlocks:[{numBlocks:3,dataCodewordsPerBlock:45},{numBlocks:23,dataCodewordsPerBlock:46}]},{ecCodewordsPerBlock:30,ecBlocks:[{numBlocks:4,dataCodewordsPerBlock:24},{numBlocks:31,dataCodewordsPerBlock:25}]},{ecCodewordsPerBlock:30,ecBlocks:[{numBlocks:11,dataCodewordsPerBlock:15},{numBlocks:31,dataCodewordsPerBlock:16}]}]},{infoBits:119615,versionNumber:29,alignmentPatternCenters:[6,30,54,78,102,126],errorCorrectionLevels:[{ecCodewordsPerBlock:30,ecBlocks:[{numBlocks:7,dataCodewordsPerBlock:116},{numBlocks:7,dataCodewordsPerBlock:117}]},{ecCodewordsPerBlock:28,ecBlocks:[{numBlocks:21,dataCodewordsPerBlock:45},{numBlocks:7,dataCodewordsPerBlock:46}]},{ecCodewordsPerBlock:30,ecBlocks:[{numBlocks:1,dataCodewordsPerBlock:23},{numBlocks:37,dataCodewordsPerBlock:24}]},{ecCodewordsPerBlock:30,ecBlocks:[{numBlocks:19,dataCodewordsPerBlock:15},{numBlocks:26,dataCodewordsPerBlock:16}]}]},{infoBits:126325,versionNumber:30,alignmentPatternCenters:[6,26,52,78,104,130],errorCorrectionLevels:[{ecCodewordsPerBlock:30,ecBlocks:[{numBlocks:5,dataCodewordsPerBlock:115},{numBlocks:10,dataCodewordsPerBlock:116}]},{ecCodewordsPerBlock:28,ecBlocks:[{numBlocks:19,dataCodewordsPerBlock:47},{numBlocks:10,dataCodewordsPerBlock:48}]},{ecCodewordsPerBlock:30,ecBlocks:[{numBlocks:15,dataCodewordsPerBlock:24},{numBlocks:25,dataCodewordsPerBlock:25}]},{ecCodewordsPerBlock:30,ecBlocks:[{numBlocks:23,dataCodewordsPerBlock:15},{numBlocks:25,dataCodewordsPerBlock:16}]}]},{infoBits:127568,versionNumber:31,alignmentPatternCenters:[6,30,56,82,108,134],errorCorrectionLevels:[{ecCodewordsPerBlock:30,ecBlocks:[{numBlocks:13,dataCodewordsPerBlock:115},{numBlocks:3,dataCodewordsPerBlock:116}]},{ecCodewordsPerBlock:28,ecBlocks:[{numBlocks:2,dataCodewordsPerBlock:46},{numBlocks:29,dataCodewordsPerBlock:47}]},{ecCodewordsPerBlock:30,ecBlocks:[{numBlocks:42,dataCodewordsPerBlock:24},{numBlocks:1,dataCodewordsPerBlock:25}]},{ecCodewordsPerBlock:30,ecBlocks:[{numBlocks:23,dataCodewordsPerBlock:15},{numBlocks:28,dataCodewordsPerBlock:16}]}]},{infoBits:133589,versionNumber:32,alignmentPatternCenters:[6,34,60,86,112,138],errorCorrectionLevels:[{ecCodewordsPerBlock:30,ecBlocks:[{numBlocks:17,dataCodewordsPerBlock:115}]},{ecCodewordsPerBlock:28,ecBlocks:[{numBlocks:10,dataCodewordsPerBlock:46},{numBlocks:23,dataCodewordsPerBlock:47}]},{ecCodewordsPerBlock:30,ecBlocks:[{numBlocks:10,dataCodewordsPerBlock:24},{numBlocks:35,dataCodewordsPerBlock:25}]},{ecCodewordsPerBlock:30,ecBlocks:[{numBlocks:19,dataCodewordsPerBlock:15},{numBlocks:35,dataCodewordsPerBlock:16}]}]},{infoBits:136944,versionNumber:33,alignmentPatternCenters:[6,30,58,86,114,142],errorCorrectionLevels:[{ecCodewordsPerBlock:30,ecBlocks:[{numBlocks:17,dataCodewordsPerBlock:115},{numBlocks:1,dataCodewordsPerBlock:116}]},{ecCodewordsPerBlock:28,ecBlocks:[{numBlocks:14,dataCodewordsPerBlock:46},{numBlocks:21,dataCodewordsPerBlock:47}]},{ecCodewordsPerBlock:30,ecBlocks:[{numBlocks:29,dataCodewordsPerBlock:24},{numBlocks:19,dataCodewordsPerBlock:25}]},{ecCodewordsPerBlock:30,ecBlocks:[{numBlocks:11,dataCodewordsPerBlock:15},{numBlocks:46,dataCodewordsPerBlock:16}]}]},{infoBits:141498,versionNumber:34,alignmentPatternCenters:[6,34,62,90,118,146],errorCorrectionLevels:[{ecCodewordsPerBlock:30,ecBlocks:[{numBlocks:13,dataCodewordsPerBlock:115},{numBlocks:6,dataCodewordsPerBlock:116}]},{ecCodewordsPerBlock:28,ecBlocks:[{numBlocks:14,dataCodewordsPerBlock:46},{numBlocks:23,dataCodewordsPerBlock:47}]},{ecCodewordsPerBlock:30,ecBlocks:[{numBlocks:44,dataCodewordsPerBlock:24},{numBlocks:7,dataCodewordsPerBlock:25}]},{ecCodewordsPerBlock:30,ecBlocks:[{numBlocks:59,dataCodewordsPerBlock:16},{numBlocks:1,dataCodewordsPerBlock:17}]}]},{infoBits:145311,versionNumber:35,alignmentPatternCenters:[6,30,54,78,102,126,150],errorCorrectionLevels:[{ecCodewordsPerBlock:30,ecBlocks:[{numBlocks:12,dataCodewordsPerBlock:121},{numBlocks:7,dataCodewordsPerBlock:122}]},{ecCodewordsPerBlock:28,ecBlocks:[{numBlocks:12,dataCodewordsPerBlock:47},{numBlocks:26,dataCodewordsPerBlock:48}]},{ecCodewordsPerBlock:30,ecBlocks:[{numBlocks:39,dataCodewordsPerBlock:24},{numBlocks:14,dataCodewordsPerBlock:25}]},{ecCodewordsPerBlock:30,ecBlocks:[{numBlocks:22,dataCodewordsPerBlock:15},{numBlocks:41,dataCodewordsPerBlock:16}]}]},{infoBits:150283,versionNumber:36,alignmentPatternCenters:[6,24,50,76,102,128,154],errorCorrectionLevels:[{ecCodewordsPerBlock:30,ecBlocks:[{numBlocks:6,dataCodewordsPerBlock:121},{numBlocks:14,dataCodewordsPerBlock:122}]},{ecCodewordsPerBlock:28,ecBlocks:[{numBlocks:6,dataCodewordsPerBlock:47},{numBlocks:34,dataCodewordsPerBlock:48}]},{ecCodewordsPerBlock:30,ecBlocks:[{numBlocks:46,dataCodewordsPerBlock:24},{numBlocks:10,dataCodewordsPerBlock:25}]},{ecCodewordsPerBlock:30,ecBlocks:[{numBlocks:2,dataCodewordsPerBlock:15},{numBlocks:64,dataCodewordsPerBlock:16}]}]},{infoBits:152622,versionNumber:37,alignmentPatternCenters:[6,28,54,80,106,132,158],errorCorrectionLevels:[{ecCodewordsPerBlock:30,ecBlocks:[{numBlocks:17,dataCodewordsPerBlock:122},{numBlocks:4,dataCodewordsPerBlock:123}]},{ecCodewordsPerBlock:28,ecBlocks:[{numBlocks:29,dataCodewordsPerBlock:46},{numBlocks:14,dataCodewordsPerBlock:47}]},{ecCodewordsPerBlock:30,ecBlocks:[{numBlocks:49,dataCodewordsPerBlock:24},{numBlocks:10,dataCodewordsPerBlock:25}]},{ecCodewordsPerBlock:30,ecBlocks:[{numBlocks:24,dataCodewordsPerBlock:15},{numBlocks:46,dataCodewordsPerBlock:16}]}]},{infoBits:158308,versionNumber:38,alignmentPatternCenters:[6,32,58,84,110,136,162],errorCorrectionLevels:[{ecCodewordsPerBlock:30,ecBlocks:[{numBlocks:4,dataCodewordsPerBlock:122},{numBlocks:18,dataCodewordsPerBlock:123}]},{ecCodewordsPerBlock:28,ecBlocks:[{numBlocks:13,dataCodewordsPerBlock:46},{numBlocks:32,dataCodewordsPerBlock:47}]},{ecCodewordsPerBlock:30,ecBlocks:[{numBlocks:48,dataCodewordsPerBlock:24},{numBlocks:14,dataCodewordsPerBlock:25}]},{ecCodewordsPerBlock:30,ecBlocks:[{numBlocks:42,dataCodewordsPerBlock:15},{numBlocks:32,dataCodewordsPerBlock:16}]}]},{infoBits:161089,versionNumber:39,alignmentPatternCenters:[6,26,54,82,110,138,166],errorCorrectionLevels:[{ecCodewordsPerBlock:30,ecBlocks:[{numBlocks:20,dataCodewordsPerBlock:117},{numBlocks:4,dataCodewordsPerBlock:118}]},{ecCodewordsPerBlock:28,ecBlocks:[{numBlocks:40,dataCodewordsPerBlock:47},{numBlocks:7,dataCodewordsPerBlock:48}]},{ecCodewordsPerBlock:30,ecBlocks:[{numBlocks:43,dataCodewordsPerBlock:24},{numBlocks:22,dataCodewordsPerBlock:25}]},{ecCodewordsPerBlock:30,ecBlocks:[{numBlocks:10,dataCodewordsPerBlock:15},{numBlocks:67,dataCodewordsPerBlock:16}]}]},{infoBits:167017,versionNumber:40,alignmentPatternCenters:[6,30,58,86,114,142,170],errorCorrectionLevels:[{ecCodewordsPerBlock:30,ecBlocks:[{numBlocks:19,dataCodewordsPerBlock:118},{numBlocks:6,dataCodewordsPerBlock:119}]},{ecCodewordsPerBlock:28,ecBlocks:[{numBlocks:18,dataCodewordsPerBlock:47},{numBlocks:31,dataCodewordsPerBlock:48}]},{ecCodewordsPerBlock:30,ecBlocks:[{numBlocks:34,dataCodewordsPerBlock:24},{numBlocks:34,dataCodewordsPerBlock:25}]},{ecCodewordsPerBlock:30,ecBlocks:[{numBlocks:20,dataCodewordsPerBlock:15},{numBlocks:61,dataCodewordsPerBlock:16}]}]}]},function(o,e,r){"use strict";function t(o,e,r,t){var c=o.x-e.x+r.x-t.x,s=o.y-e.y+r.y-t.y;if(0===c&&0===s)return{a11:e.x-o.x,a12:e.y-o.y,a13:0,a21:r.x-e.x,a22:r.y-e.y,a23:0,a31:o.x,a32:o.y,a33:1};var a=e.x-r.x,n=t.x-r.x,d=e.y-r.y,l=t.y-r.y,i=a*l-n*d,B=(c*l-n*s)/i,k=(a*s-c*d)/i;return{a11:e.x-o.x+B*e.x,a12:e.y-o.y+B*e.y,a13:B,a21:t.x-o.x+k*t.x,a22:t.y-o.y+k*t.y,a23:k,a31:o.x,a32:o.y,a33:1}}function c(o,e,r,c){var s=t(o,e,r,c);return{a11:s.a22*s.a33-s.a23*s.a32,a12:s.a13*s.a32-s.a12*s.a33,a13:s.a12*s.a23-s.a13*s.a22,a21:s.a23*s.a31-s.a21*s.a33,a22:s.a11*s.a33-s.a13*s.a31,a23:s.a13*s.a21-s.a11*s.a23,a31:s.a21*s.a32-s.a22*s.a31,a32:s.a12*s.a31-s.a11*s.a32,a33:s.a11*s.a22-s.a12*s.a21}}function s(o,e){return{a11:o.a11*e.a11+o.a21*e.a12+o.a31*e.a13,a12:o.a12*e.a11+o.a22*e.a12+o.a32*e.a13,a13:o.a13*e.a11+o.a23*e.a12+o.a33*e.a13,a21:o.a11*e.a21+o.a21*e.a22+o.a31*e.a23,a22:o.a12*e.a21+o.a22*e.a22+o.a32*e.a23,a23:o.a13*e.a21+o.a23*e.a22+o.a33*e.a23,a31:o.a11*e.a31+o.a21*e.a32+o.a31*e.a33,a32:o.a12*e.a31+o.a22*e.a32+o.a32*e.a33,a33:o.a13*e.a31+o.a23*e.a32+o.a33*e.a33}}function a(o,e){for(var r=c({x:3.5,y:3.5},{x:e.dimension-3.5,y:3.5},{x:e.dimension-6.5,y:e.dimension-6.5},{x:3.5,y:e.dimension-3.5}),a=t(e.topLeft,e.topRight,e.alignmentPattern,e.bottomLeft),d=s(a,r),l=n.BitMatrix.createEmpty(e.dimension,e.dimension),i=function(o,e){var r=d.a13*o+d.a23*e+d.a33;return{x:(d.a11*o+d.a21*e+d.a31)/r,y:(d.a12*o+d.a22*e+d.a32)/r}},B=0;B<e.dimension;B++)for(var k=0;k<e.dimension;k++){var u=k+.5,C=B+.5,m=i(u,C);l.set(k,B,o.get(Math.floor(m.x),Math.floor(m.y)))}return{matrix:l,mappingFunction:i}}Object.defineProperty(e,"__esModule",{value:!0});var n=r(0);e.extract=a},function(o,e,r){"use strict";function t(o){return o.reduce(function(o,e){return o+e})}function c(o,e,r){var t,c,s,a=C(o,e),n=C(e,r),d=C(o,r);return n>=a&&n>=d?(l=[e,o,r],t=l[0],c=l[1],s=l[2]):d>=n&&d>=a?(i=[o,e,r],t=i[0],c=i[1],s=i[2]):(B=[o,r,e],t=B[0],c=B[1],s=B[2]),(s.x-c.x)*(t.y-c.y)-(s.y-c.y)*(t.x-c.x)<0&&(k=[s,t],t=k[0],s=k[1]),{bottomLeft:t,topLeft:c,topRight:s};var l,i,B,k}function s(o,e,r,c){var s=(t(n(o,r,c,5))/7+t(n(o,e,c,5))/7+t(n(r,o,c,5))/7+t(n(e,o,c,5))/7)/4;if(s<1)throw new Error("Invalid module size");var a=Math.round(C(o,e)/s),d=Math.round(C(o,r)/s),l=Math.floor((a+d)/2)+7;switch(l%4){case 0:l++;break;case 2:l--}return{dimension:l,moduleSize:s}}function a(o,e,r,t){var c,s,a,n,d=[{x:Math.floor(o.x),y:Math.floor(o.y)}],l=Math.abs(e.y-o.y)>Math.abs(e.x-o.x);l?(c=Math.floor(o.y),s=Math.floor(o.x),a=Math.floor(e.y),n=Math.floor(e.x)):(c=Math.floor(o.x),s=Math.floor(o.y),a=Math.floor(e.x),n=Math.floor(e.y));for(var i=Math.abs(a-c),B=Math.abs(n-s),k=Math.floor(-i/2),u=c<a?1:-1,m=s<n?1:-1,f=!0,w=c,P=s;w!==a+u;w+=u){var v=l?P:w,h=l?w:P;if(r.get(v,h)!==f&&(f=!f,d.push({x:v,y:h}),d.length===t+1))break;if((k+=B)>0){if(P===n)break;P+=m,k-=i}}for(var p=[],b=0;b<t;b++)d[b]&&d[b+1]?p.push(C(d[b],d[b+1])):p.push(0);return p}function n(o,e,r,t){var c=e.y-o.y,s=e.x-o.x,n=a(o,e,r,Math.ceil(t/2)),d=a(o,{x:o.x-s,y:o.y-c},r,Math.ceil(t/2)),l=n.shift()+d.shift()-1;return(i=d.concat(l)).concat.apply(i,n);var i}function d(o,e){var r=t(o)/t(e),c=0;return e.forEach(function(e,t){c+=Math.pow(o[t]-e*r,2)}),{averageSize:r,error:c}}function l(o,e,r){try{var t=n(o,{x:-1,y:o.y},r,e.length),c=n(o,{x:o.x,y:-1},r,e.length),s={x:Math.max(0,o.x-o.y)-1,y:Math.max(0,o.y-o.x)-1},a=n(o,s,r,e.length),l={x:Math.min(r.width,o.x+o.y)+1,y:Math.min(r.height,o.y+o.x)+1},i=n(o,l,r,e.length),B=d(t,e),k=d(c,e),u=d(a,e),C=d(i,e),m=Math.sqrt(B.error*B.error+k.error*k.error+u.error*u.error+C.error*C.error),f=(B.averageSize+k.averageSize+u.averageSize+C.averageSize)/4;return m+(Math.pow(B.averageSize-f,2)+Math.pow(k.averageSize-f,2)+Math.pow(u.averageSize-f,2)+Math.pow(C.averageSize-f,2))/f}catch(o){return 1/0}}function i(o){for(var e=[],r=[],a=[],n=[],d=0;d<=o.height;d++)!function(c){for(var s=0,d=!1,l=[0,0,0,0,0],i=-1;i<=o.width;i++)!function(e){var a=o.get(e,c);if(a===d)s++;else{l=[l[1],l[2],l[3],l[4],s],s=1,d=a;var i=t(l)/7,B=Math.abs(l[0]-i)<i&&Math.abs(l[1]-i)<i&&Math.abs(l[2]-3*i)<3*i&&Math.abs(l[3]-i)<i&&Math.abs(l[4]-i)<i&&!a,C=t(l.slice(-3))/3,m=Math.abs(l[2]-C)<C&&Math.abs(l[3]-C)<C&&Math.abs(l[4]-C)<C&&a;if(B){var f=e-l[3]-l[4],w=f-l[2],P={startX:w,endX:f,y:c},v=r.filter(function(o){return w>=o.bottom.startX&&w<=o.bottom.endX||f>=o.bottom.startX&&w<=o.bottom.endX||w<=o.bottom.startX&&f>=o.bottom.endX&&l[2]/(o.bottom.endX-o.bottom.startX)<u&&l[2]/(o.bottom.endX-o.bottom.startX)>k});v.length>0?v[0].bottom=P:r.push({top:P,bottom:P})}if(m){var h=e-l[4],p=h-l[3],P={startX:p,y:c,endX:h},v=n.filter(function(o){return p>=o.bottom.startX&&p<=o.bottom.endX||h>=o.bottom.startX&&p<=o.bottom.endX||p<=o.bottom.startX&&h>=o.bottom.endX&&l[2]/(o.bottom.endX-o.bottom.startX)<u&&l[2]/(o.bottom.endX-o.bottom.startX)>k});v.length>0?v[0].bottom=P:n.push({top:P,bottom:P})}}}(i);e.push.apply(e,r.filter(function(o){return o.bottom.y!==c&&o.bottom.y-o.top.y>=2})),r=r.filter(function(o){return o.bottom.y===c}),a.push.apply(a,n.filter(function(o){return o.bottom.y!==c})),n=n.filter(function(o){return o.bottom.y===c})}(d);e.push.apply(e,r.filter(function(o){return o.bottom.y-o.top.y>=2})),a.push.apply(a,n);var i=e.filter(function(o){return o.bottom.y-o.top.y>=2}).map(function(e){var r=(e.top.startX+e.top.endX+e.bottom.startX+e.bottom.endX)/4,c=(e.top.y+e.bottom.y+1)/2;if(o.get(Math.round(r),Math.round(c))){var s=[e.top.endX-e.top.startX,e.bottom.endX-e.bottom.startX,e.bottom.y-e.top.y+1],a=t(s)/s.length;return{score:l({x:Math.round(r),y:Math.round(c)},[1,1,3,1,1],o),x:r,y:c,size:a}}}).filter(function(o){return!!o}).sort(function(o,e){return o.score-e.score}).map(function(o,e,r){if(e>B)return null;var t=r.filter(function(o,r){return e!==r}).map(function(e){return{x:e.x,y:e.y,score:e.score+Math.pow(e.size-o.size,2)/o.size,size:e.size}}).sort(function(o,e){return o.score-e.score});if(t.length<2)return null;var c=o.score+t[0].score+t[1].score;return{points:[o].concat(t.slice(0,2)),score:c}}).filter(function(o){return!!o}).sort(function(o,e){return o.score-e.score});if(0===i.length)return null;var m,f,w=c(i[0].points[0],i[0].points[1],i[0].points[2]),P=w.topRight,v=w.topLeft,h=w.bottomLeft;try{L=s(v,P,h,o),m=L.dimension,f=L.moduleSize}catch(o){return null}var p={x:P.x-v.x+h.x,y:P.y-v.y+h.y},b=(C(v,h)+C(v,P))/2/f,y=1-3/b,g={x:v.x+y*(p.x-v.x),y:v.y+y*(p.y-v.y)},x=a.map(function(e){var r=(e.top.startX+e.top.endX+e.bottom.startX+e.bottom.endX)/4,c=(e.top.y+e.bottom.y+1)/2;if(o.get(Math.floor(r),Math.floor(c))){var s=[e.top.endX-e.top.startX,e.bottom.endX-e.bottom.startX,e.bottom.y-e.top.y+1];t(s);return{x:r,y:c,score:l({x:Math.floor(r),y:Math.floor(c)},[1,1,1],o)+C({x:r,y:c},g)}}}).filter(function(o){return!!o}).sort(function(o,e){return o.score-e.score}),M=b>=15&&x.length?x[0]:g;return{alignmentPattern:{x:M.x,y:M.y},bottomLeft:{x:h.x,y:h.y},dimension:m,topLeft:{x:v.x,y:v.y},topRight:{x:P.x,y:P.y}};var L}Object.defineProperty(e,"__esModule",{value:!0});var B=4,k=.5,u=1.5,C=function(o,e){return Math.sqrt(Math.pow(e.x-o.x,2)+Math.pow(e.y-o.y,2))};e.locate=i}]).default})}]);',null)}},function(t,e,n){t.exports={default:n(75),__esModule:!0}},function(t,e){},function(t,e,n){"use strict";var i=n(17),r=n(3),o=n(52),a=n(9),s=n(14),l=n(77),c=n(24),u=n(55),d=n(2)("iterator"),h=!([].keys&&"next"in[].keys()),f=function(){return this};t.exports=function(t,e,n,p,m,v,g){l(n,e,p);var y,_,b,w=function(t){if(!h&&t in S)return S[t];switch(t){case"keys":case"values":return function(){return new n(this,t)}}return function(){return new n(this,t)}},k=e+" Iterator",x="values"==m,C=!1,S=t.prototype,M=S[d]||S["@@iterator"]||m&&S[m],T=M||w(m),P=m?x?w("entries"):T:void 0,O="Array"==e&&S.entries||M;if(O&&(b=u(O.call(new t)))!==Object.prototype&&b.next&&(c(b,k,!0),i||"function"==typeof b[d]||a(b,d,f)),x&&M&&"values"!==M.name&&(C=!0,T=function(){return M.call(this)}),i&&!g||!h&&!C&&S[d]||a(S,d,T),s[e]=T,s[k]=f,m)if(y={values:x?T:w("values"),keys:v?T:w("keys"),entries:P},g)for(_ in y)_ in S||o(S,_,y[_]);else r(r.P+r.F*(h||C),e,y);return y}},function(t,e,n){t.exports=!n(8)&&!n(18)((function(){return 7!=Object.defineProperty(n(28)("div"),"a",{get:function(){return 7}}).a}))},function(t,e,n){t.exports=n(9)},function(t,e,n){var i=n(10),r=n(15),o=n(80)(!1),a=n(33)("IE_PROTO");t.exports=function(t,e){var n,s=r(t),l=0,c=[];for(n in s)n!=a&&i(s,n)&&c.push(n);for(;e.length>l;)i(s,n=e[l++])&&(~o(c,n)||c.push(n));return c}},function(t,e,n){var i=n(1).document;t.exports=i&&i.documentElement},function(t,e,n){var i=n(10),r=n(36),o=n(33)("IE_PROTO"),a=Object.prototype;t.exports=Object.getPrototypeOf||function(t){return t=r(t),i(t,o)?t[o]:"function"==typeof t.constructor&&t instanceof t.constructor?t.constructor.prototype:t instanceof Object?a:null}},function(t,e,n){var i=n(4);t.exports=function(t,e,n,r){try{return r?e(i(n)[0],n[1]):e(n)}catch(e){var o=t.return;throw void 0!==o&&i(o.call(t)),e}}},function(t,e,n){var i=n(14),r=n(2)("iterator"),o=Array.prototype;t.exports=function(t){return void 0!==t&&(i.Array===t||o[r]===t)}},function(t,e,n){var i=n(4),r=n(22),o=n(2)("species");t.exports=function(t,e){var n,a=i(t).constructor;return void 0===a||null==(n=i(a)[o])?e:r(n)}},function(t,e,n){var i,r,o,a=n(13),s=n(88),l=n(54),c=n(28),u=n(1),d=u.process,h=u.setImmediate,f=u.clearImmediate,p=u.MessageChannel,m=u.Dispatch,v=0,g={},y=function(){var t=+this;if(g.hasOwnProperty(t)){var e=g[t];delete g[t],e()}},_=function(t){y.call(t.data)};h&&f||(h=function(t){for(var e=[],n=1;arguments.length>n;)e.push(arguments[n++]);return g[++v]=function(){s("function"==typeof t?t:Function(t),e)},i(v),v},f=function(t){delete g[t]},"process"==n(20)(d)?i=function(t){d.nextTick(a(y,t,1))}:m&&m.now?i=function(t){m.now(a(y,t,1))}:p?(o=(r=new p).port2,r.port1.onmessage=_,i=a(o.postMessage,o,1)):u.addEventListener&&"function"==typeof postMessage&&!u.importScripts?(i=function(t){u.postMessage(t+"","*")},u.addEventListener("message",_,!1)):i="onreadystatechange"in c("script")?function(t){l.appendChild(c("script")).onreadystatechange=function(){l.removeChild(this),y.call(t)}}:function(t){setTimeout(a(y,t,1),0)}),t.exports={set:h,clear:f}},function(t,e){t.exports=function(t){try{return{e:!1,v:t()}}catch(t){return{e:!0,v:t}}}},function(t,e,n){var i=n(4),r=n(7),o=n(39);t.exports=function(t,e){if(i(t),r(e)&&e.constructor===t)return e;var n=o.f(t);return(0,n.resolve)(e),n.promise}},function(t,e,n){var i=n(2)("iterator"),r=!1;try{var o=[7][i]();o.return=function(){r=!0},Array.from(o,(function(){throw 2}))}catch(t){}t.exports=function(t,e){if(!e&&!r)return!1;var n=!1;try{var o=[7],a=o[i]();a.next=function(){return{done:n=!0}},o[i]=function(){return a},t(o)}catch(t){}return n}},function(t,e,n){"use strict";e.__esModule=!0,e.default=function(t,e){if(!(t instanceof e))throw new TypeError("Cannot call a class as a function")}},function(t,e,n){"use strict";n.d(e,"b",(function(){return d})),n.d(e,"a",(function(){return h})),n.d(e,"d",(function(){return f})),n.d(e,"c",(function(){return p}));var i=n(123),r=n.n(i),o=n(63),a=n.n(o),s=n(127),l=n.n(s),c=n(139),u=n.n(c),d=function(t){function e(){a()(this,e);var t=l()(this,(e.__proto__||r()(e)).call(this,"can't process cross-origin image"));return t.name="DropImageFetchError",t}return u()(e,t),e}(Error),h=function(t){function e(){a()(this,e);var t=l()(this,(e.__proto__||r()(e)).call(this,"drag-and-dropped file is not of type image and can't be decoded"));return t.name="DropImageDecodeError",t}return u()(e,t),e}(Error),f=function(t){function e(){a()(this,e);var t=l()(this,(e.__proto__||r()(e)).call(this,"this browser has no Stream API support"));return t.name="StreamApiNotSupportedError",t}return u()(e,t),e}(Error),p=function(t){function e(){a()(this,e);var t=l()(this,(e.__proto__||r()(e)).call(this,"camera access is only permitted in secure context. Use HTTPS or localhost rather than HTTP."));return t.name="InsecureContextError",t}return u()(e,t),e}(Error)},function(t,e,n){"use strict";function i(t){return t&&t.__esModule?t:{default:t}}e.__esModule=!0;var r=i(n(128)),o=i(n(130)),a="function"==typeof o.default&&"symbol"==typeof r.default?function(t){return typeof t}:function(t){return t&&"function"==typeof o.default&&t.constructor===o.default&&t!==o.default.prototype?"symbol":typeof t};e.default="function"==typeof o.default&&"symbol"===a(r.default)?function(t){return void 0===t?"undefined":a(t)}:function(t){return t&&"function"==typeof o.default&&t.constructor===o.default&&t!==o.default.prototype?"symbol":void 0===t?"undefined":a(t)}},function(t,e){e.f=Object.getOwnPropertySymbols},function(t,e,n){var i=n(53),r=n(35).concat("length","prototype");e.f=Object.getOwnPropertyNames||function(t){return i(t,r)}},function(t,e,n){var i=n(44),r=n(19),o=n(15),a=n(29),s=n(10),l=n(51),c=Object.getOwnPropertyDescriptor;e.f=n(8)?c:function(t,e){if(t=o(t),e=a(e,!0),l)try{return c(t,e)}catch(t){}if(s(t,e))return r(!i.f.call(t,e),t[e])}},function(t,e,n){"use strict";e.__esModule=!0;var i=function(t){return t&&t.__esModule?t:{default:t}}(n(152));e.default=function(t){if(Array.isArray(t)){for(var e=0,n=Array(t.length);e<t.length;e++)n[e]=t[e];return n}return(0,i.default)(t)}},function(t,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),function(t){function i(t){t.component("qrcode-stream",o.a),t.component("qrcode-capture",s.a),t.component("qrcode-drop-zone",c.a)}e.install=i;var r=n(72),o=n.n(r),a=n(150),s=n.n(a),l=n(157),c=n.n(l);n.d(e,"QrcodeStream",(function(){return o.a})),n.d(e,"QrcodeCapture",(function(){return s.a})),n.d(e,"QrcodeDropZone",(function(){return c.a}));var u={install:i};e.default=u;var d=null;"undefined"!=typeof window?d=window.Vue:void 0!==t&&(d=t.Vue),d&&d.use(u)}.call(e,n(71))},function(t,e){var n;n=function(){return this}();try{n=n||Function("return this")()||(0,eval)("this")}catch(t){"object"==typeof window&&(n=window)}t.exports=n},function(t,e,n){n(73);var i=n(21)(n(74),n(149),"data-v-1f90552a",null);t.exports=i.exports},function(t,e){},function(t,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var i=n(48),r=n.n(i),o=n(11),a=n.n(o),s=n(12),l=n.n(s),c=n(40),u=n(97),d=n(98),h=n(46),f=n.n(h),p=n(47),m=n.n(p);e.default={name:"qrcode-stream",mixins:[f.a],props:{camera:{type:String,default:"auto",validator:function(t){return["auto","rear","front","off"].includes(t)}},torch:{type:Boolean,default:!1},track:{type:[Function,Boolean],default:!0},worker:{type:Function,default:m.a}},data:function(){return{cameraInstance:null,destroyed:!1,stopScanning:function(){}}},computed:{shouldStream:function(){return!1===this.destroyed&&"off"!==this.camera},shouldScan:function(){return!0===this.shouldStream&&null!==this.cameraInstance},scanInterval:function(){return!1===this.track?500:40},trackRepaintFunction:function(){return!0===this.track?Object(u.a)({color:"#ff0000"}):!1===this.track?void 0:this.track},constraints:function(){var t={audio:!1,video:{width:{min:360,ideal:640,max:1920},height:{min:240,ideal:480,max:1080}}};switch(this.camera){case"auto":return t.video.facingMode={ideal:"environment"},t;case"rear":return t.video.facingMode={exact:"environment"},t;case"front":return t.video.facingMode={exact:"user"},t;default:return}}},watch:{shouldStream:function(t){if(!t){var e=this.cameraInstance.captureFrame();this.paintPauseFrame(e)}},shouldScan:function(t){t?(this.clearPauseFrame(),this.clearTrackingLayer(),this.startScanning()):this.stopScanning()},torch:function(){this.$emit("init",this.init())},constraints:function(){this.$emit("init",this.init())}},mounted:function(){this.$emit("init",this.init())},beforeDestroy:function(){this.beforeResetCamera(),this.stopScanning(),this.destroyed=!0},methods:{init:function(){var t=this;return l()(a.a.mark((function e(){return a.a.wrap((function(e){for(;;)switch(e.prev=e.next){case 0:if(t.beforeResetCamera(),void 0!==t.constraints){e.next=5;break}t.cameraInstance=null,e.next=9;break;case 5:return e.next=7,Object(d.a)(t.constraints,t.$refs.video,{torch:t.torch});case 7:t.cameraInstance=e.sent,t.destroyed&&t.cameraInstance.stop();case 9:case"end":return e.stop()}}),e,t)})))()},startScanning:function(){var t=this;this.stopScanning=Object(c.a)(this.worker,this.cameraInstance,{detectHandler:function(e){t.onDetect(r.a.resolve(e))},locateHandler:this.onLocate,minDelay:this.scanInterval})},beforeResetCamera:function(){null!==this.cameraInstance&&(this.cameraInstance.stop(),this.cameraInstance=null)},onLocate:function(t){void 0===this.trackRepaintFunction||null===t?this.clearTrackingLayer():this.repaintTrackingLayer(t)},repaintTrackingLayer:function(t){var e=this,n=this.$refs.video,i=this.$refs.trackingLayer,r=i.getContext("2d"),o=n.offsetWidth,a=n.offsetHeight,s=n.videoWidth,l=n.videoHeight,c=Math.max(o/s,a/l),u=s*c,d=l*c,h=u/s,f=d/l,p=(o-u)/2,m=(a-d)/2,v={};for(var g in t)v[g]={x:Math.floor(t[g].x*h+p),y:Math.floor(t[g].y*f+m)};window.requestAnimationFrame((function(){i.width=o,i.height=a,e.trackRepaintFunction(v,r)}))},clearTrackingLayer:function(){var t=this.$refs.trackingLayer,e=t.getContext("2d");window.requestAnimationFrame((function(){e.clearRect(0,0,t.width,t.height)}))},paintPauseFrame:function(t){var e=this.$refs.pauseFrame,n=e.getContext("2d");window.requestAnimationFrame((function(){e.width=t.width,e.height=t.height,n.putImageData(t,0,0)}))},clearPauseFrame:function(){var t=this.$refs.pauseFrame,e=t.getContext("2d");window.requestAnimationFrame((function(){e.clearRect(0,0,t.width,t.height)}))}}}},function(t,e,n){n(49),n(16),n(25),n(85),n(93),n(94),t.exports=n(0).Promise},function(t,e,n){var i=n(26),r=n(27);t.exports=function(t){return function(e,n){var o,a,s=String(r(e)),l=i(n),c=s.length;return l<0||l>=c?t?"":void 0:(o=s.charCodeAt(l))<55296||o>56319||l+1===c||(a=s.charCodeAt(l+1))<56320||a>57343?t?s.charAt(l):o:t?s.slice(l,l+2):a-56320+(o-55296<<10)+65536}}},function(t,e,n){"use strict";var i=n(30),r=n(19),o=n(24),a={};n(9)(a,n(2)("iterator"),(function(){return this})),t.exports=function(t,e,n){t.prototype=i(a,{next:r(1,n)}),o(t,e+" Iterator")}},function(t,e,n){var i=n(5),r=n(4),o=n(31);t.exports=n(8)?Object.defineProperties:function(t,e){r(t);for(var n,a=o(e),s=a.length,l=0;s>l;)i.f(t,n=a[l++],e[n]);return t}},function(t,e,n){var i=n(20);t.exports=Object("z").propertyIsEnumerable(0)?Object:function(t){return"String"==i(t)?t.split(""):Object(t)}},function(t,e,n){var i=n(15),r=n(32),o=n(81);t.exports=function(t){return function(e,n,a){var s,l=i(e),c=r(l.length),u=o(a,c);if(t&&n!=n){for(;c>u;)if((s=l[u++])!=s)return!0}else for(;c>u;u++)if((t||u in l)&&l[u]===n)return t||u||0;return!t&&-1}}},function(t,e,n){var i=n(26),r=Math.max,o=Math.min;t.exports=function(t,e){return(t=i(t))<0?r(t+e,0):o(t,e)}},function(t,e,n){"use strict";var i=n(83),r=n(84),o=n(14),a=n(15);t.exports=n(50)(Array,"Array",(function(t,e){this._t=a(t),this._i=0,this._k=e}),(function(){var t=this._t,e=this._k,n=this._i++;return!t||n>=t.length?(this._t=void 0,r(1)):r(0,"keys"==e?n:"values"==e?t[n]:[n,t[n]])}),"values"),o.Arguments=o.Array,i("keys"),i("values"),i("entries")},function(t,e){t.exports=function(){}},function(t,e){t.exports=function(t,e){return{value:e,done:!!t}}},function(t,e,n){"use strict";var i,r,o,a,s=n(17),l=n(1),c=n(13),u=n(37),d=n(3),h=n(7),f=n(22),p=n(86),m=n(87),v=n(58),g=n(59).set,y=n(89)(),_=n(39),b=n(60),w=n(90),k=n(61),x=l.TypeError,C=l.process,S=C&&C.versions,M=S&&S.v8||"",T=l.Promise,P="process"==u(C),O=function(){},B=r=_.f,E=!!function(){try{var t=T.resolve(1),e=(t.constructor={})[n(2)("species")]=function(t){t(O,O)};return(P||"function"==typeof PromiseRejectionEvent)&&t.then(O)instanceof e&&0!==M.indexOf("6.6")&&-1===w.indexOf("Chrome/66")}catch(t){}}(),A=function(t){var e;return!(!h(t)||"function"!=typeof(e=t.then))&&e},D=function(t,e){if(!t._n){t._n=!0;var n=t._c;y((function(){for(var i=t._v,r=1==t._s,o=0;n.length>o;)!function(e){var n,o,a,s=r?e.ok:e.fail,l=e.resolve,c=e.reject,u=e.domain;try{s?(r||(2==t._h&&R(t),t._h=1),!0===s?n=i:(u&&u.enter(),n=s(i),u&&(u.exit(),a=!0)),n===e.promise?c(x("Promise-chain cycle")):(o=A(n))?o.call(n,l,c):l(n)):c(i)}catch(t){u&&!a&&u.exit(),c(t)}}(n[o++]);t._c=[],t._n=!1,e&&!t._h&&L(t)}))}},L=function(t){g.call(l,(function(){var e,n,i,r=t._v,o=q(t);if(o&&(e=b((function(){P?C.emit("unhandledRejection",r,t):(n=l.onunhandledrejection)?n({promise:t,reason:r}):(i=l.console)&&i.error&&i.error("Unhandled promise rejection",r)})),t._h=P||q(t)?2:1),t._a=void 0,o&&e.e)throw e.v}))},q=function(t){return 1!==t._h&&0===(t._a||t._c).length},R=function(t){g.call(l,(function(){var e;P?C.emit("rejectionHandled",t):(e=l.onrejectionhandled)&&e({promise:t,reason:t._v})}))},I=function(t){var e=this;e._d||(e._d=!0,(e=e._w||e)._v=t,e._s=2,e._a||(e._a=e._c.slice()),D(e,!0))},N=function(t){var e,n=this;if(!n._d){n._d=!0,n=n._w||n;try{if(n===t)throw x("Promise can't be resolved itself");(e=A(t))?y((function(){var i={_w:n,_d:!1};try{e.call(t,c(N,i,1),c(I,i,1))}catch(t){I.call(i,t)}})):(n._v=t,n._s=1,D(n,!1))}catch(t){I.call({_w:n,_d:!1},t)}}};E||(T=function(t){p(this,T,"Promise","_h"),f(t),i.call(this);try{t(c(N,this,1),c(I,this,1))}catch(t){I.call(this,t)}},(i=function(t){this._c=[],this._a=void 0,this._s=0,this._d=!1,this._v=void 0,this._h=0,this._n=!1}).prototype=n(91)(T.prototype,{then:function(t,e){var n=B(v(this,T));return n.ok="function"!=typeof t||t,n.fail="function"==typeof e&&e,n.domain=P?C.domain:void 0,this._c.push(n),this._a&&this._a.push(n),this._s&&D(this,!1),n.promise},catch:function(t){return this.then(void 0,t)}}),o=function(){var t=new i;this.promise=t,this.resolve=c(N,t,1),this.reject=c(I,t,1)},_.f=B=function(t){return t===T||t===a?new o(t):r(t)}),d(d.G+d.W+d.F*!E,{Promise:T}),n(24)(T,"Promise"),n(92)("Promise"),a=n(0).Promise,d(d.S+d.F*!E,"Promise",{reject:function(t){var e=B(this);return(0,e.reject)(t),e.promise}}),d(d.S+d.F*(s||!E),"Promise",{resolve:function(t){return k(s&&this===a?T:this,t)}}),d(d.S+d.F*!(E&&n(62)((function(t){T.all(t).catch(O)}))),"Promise",{all:function(t){var e=this,n=B(e),i=n.resolve,r=n.reject,o=b((function(){var n=[],o=0,a=1;m(t,!1,(function(t){var s=o++,l=!1;n.push(void 0),a++,e.resolve(t).then((function(t){l||(l=!0,n[s]=t,--a||i(n))}),r)})),--a||i(n)}));return o.e&&r(o.v),n.promise},race:function(t){var e=this,n=B(e),i=n.reject,r=b((function(){m(t,!1,(function(t){e.resolve(t).then(n.resolve,i)}))}));return r.e&&i(r.v),n.promise}})},function(t,e){t.exports=function(t,e,n,i){if(!(t instanceof e)||void 0!==i&&i in t)throw TypeError(n+": incorrect invocation!");return t}},function(t,e,n){var i=n(13),r=n(56),o=n(57),a=n(4),s=n(32),l=n(38),c={},u={};e=t.exports=function(t,e,n,d,h){var f,p,m,v,g=h?function(){return t}:l(t),y=i(n,d,e?2:1),_=0;if("function"!=typeof g)throw TypeError(t+" is not iterable!");if(o(g)){for(f=s(t.length);f>_;_++)if((v=e?y(a(p=t[_])[0],p[1]):y(t[_]))===c||v===u)return v}else for(m=g.call(t);!(p=m.next()).done;)if((v=r(m,y,p.value,e))===c||v===u)return v};e.BREAK=c,e.RETURN=u},function(t,e){t.exports=function(t,e,n){var i=void 0===n;switch(e.length){case 0:return i?t():t.call(n);case 1:return i?t(e[0]):t.call(n,e[0]);case 2:return i?t(e[0],e[1]):t.call(n,e[0],e[1]);case 3:return i?t(e[0],e[1],e[2]):t.call(n,e[0],e[1],e[2]);case 4:return i?t(e[0],e[1],e[2],e[3]):t.call(n,e[0],e[1],e[2],e[3])}return t.apply(n,e)}},function(t,e,n){var i=n(1),r=n(59).set,o=i.MutationObserver||i.WebKitMutationObserver,a=i.process,s=i.Promise,l="process"==n(20)(a);t.exports=function(){var t,e,n,c=function(){var i,r;for(l&&(i=a.domain)&&i.exit();t;){r=t.fn,t=t.next;try{r()}catch(i){throw t?n():e=void 0,i}}e=void 0,i&&i.enter()};if(l)n=function(){a.nextTick(c)};else if(!o||i.navigator&&i.navigator.standalone)if(s&&s.resolve){var u=s.resolve(void 0);n=function(){u.then(c)}}else n=function(){r.call(i,c)};else{var d=!0,h=document.createTextNode("");new o(c).observe(h,{characterData:!0}),n=function(){h.data=d=!d}}return function(i){var r={fn:i,next:void 0};e&&(e.next=r),t||(t=r,n()),e=r}}},function(t,e,n){var i=n(1).navigator;t.exports=i&&i.userAgent||""},function(t,e,n){var i=n(9);t.exports=function(t,e,n){for(var r in e)n&&t[r]?t[r]=e[r]:i(t,r,e[r]);return t}},function(t,e,n){"use strict";var i=n(1),r=n(0),o=n(5),a=n(8),s=n(2)("species");t.exports=function(t){var e="function"==typeof r[t]?r[t]:i[t];a&&e&&!e[s]&&o.f(e,s,{configurable:!0,get:function(){return this}})}},function(t,e,n){"use strict";var i=n(3),r=n(0),o=n(1),a=n(58),s=n(61);i(i.P+i.R,"Promise",{finally:function(t){var e=a(this,r.Promise||o.Promise),n="function"==typeof t;return this.then(n?function(n){return s(e,t()).then((function(){return n}))}:t,n?function(n){return s(e,t()).then((function(){throw n}))}:t)}})},function(t,e,n){"use strict";var i=n(3),r=n(39),o=n(60);i(i.S,"Promise",{try:function(t){var e=r.f(this),n=o(t);return(n.e?e.reject:e.resolve)(n.v),e.promise}})},function(t,e,n){var i=function(){return this}()||Function("return this")(),r=i.regeneratorRuntime&&Object.getOwnPropertyNames(i).indexOf("regeneratorRuntime")>=0,o=r&&i.regeneratorRuntime;if(i.regeneratorRuntime=void 0,t.exports=n(96),r)i.regeneratorRuntime=o;else try{delete i.regeneratorRuntime}catch(t){i.regeneratorRuntime=void 0}},function(t,e){!function(e){"use strict";function n(t,e,n,i){var o=e&&e.prototype instanceof r?e:r,a=Object.create(o.prototype),s=new f(i||[]);return a._invoke=c(t,n,s),a}function i(t,e,n){try{return{type:"normal",arg:t.call(e,n)}}catch(t){return{type:"throw",arg:t}}}function r(){}function o(){}function a(){}function s(t){["next","throw","return"].forEach((function(e){t[e]=function(t){return this._invoke(e,t)}}))}function l(t){function e(n,r,o,a){var s=i(t[n],t,r);if("throw"!==s.type){var l=s.arg,c=l.value;return c&&"object"==typeof c&&y.call(c,"__await")?Promise.resolve(c.__await).then((function(t){e("next",t,o,a)}),(function(t){e("throw",t,o,a)})):Promise.resolve(c).then((function(t){l.value=t,o(l)}),a)}a(s.arg)}var n;this._invoke=function(t,i){function r(){return new Promise((function(n,r){e(t,i,n,r)}))}return n=n?n.then(r,r):r()}}function c(t,e,n){var r=S;return function(o,a){if(r===T)throw new Error("Generator is already running");if(r===P){if("throw"===o)throw a;return m()}for(n.method=o,n.arg=a;;){var s=n.delegate;if(s){var l=u(s,n);if(l){if(l===O)continue;return l}}if("next"===n.method)n.sent=n._sent=n.arg;else if("throw"===n.method){if(r===S)throw r=P,n.arg;n.dispatchException(n.arg)}else"return"===n.method&&n.abrupt("return",n.arg);r=T;var c=i(t,e,n);if("normal"===c.type){if(r=n.done?P:M,c.arg===O)continue;return{value:c.arg,done:n.done}}"throw"===c.type&&(r=P,n.method="throw",n.arg=c.arg)}}}function u(t,e){var n=t.iterator[e.method];if(n===v){if(e.delegate=null,"throw"===e.method){if(t.iterator.return&&(e.method="return",e.arg=v,u(t,e),"throw"===e.method))return O;e.method="throw",e.arg=new TypeError("The iterator does not provide a 'throw' method")}return O}var r=i(n,t.iterator,e.arg);if("throw"===r.type)return e.method="throw",e.arg=r.arg,e.delegate=null,O;var o=r.arg;return o?o.done?(e[t.resultName]=o.value,e.next=t.nextLoc,"return"!==e.method&&(e.method="next",e.arg=v),e.delegate=null,O):o:(e.method="throw",e.arg=new TypeError("iterator result is not an object"),e.delegate=null,O)}function d(t){var e={tryLoc:t[0]};1 in t&&(e.catchLoc=t[1]),2 in t&&(e.finallyLoc=t[2],e.afterLoc=t[3]),this.tryEntries.push(e)}function h(t){var e=t.completion||{};e.type="normal",delete e.arg,t.completion=e}function f(t){this.tryEntries=[{tryLoc:"root"}],t.forEach(d,this),this.reset(!0)}function p(t){if(t){var e=t[b];if(e)return e.call(t);if("function"==typeof t.next)return t;if(!isNaN(t.length)){var n=-1,i=function e(){for(;++n<t.length;)if(y.call(t,n))return e.value=t[n],e.done=!1,e;return e.value=v,e.done=!0,e};return i.next=i}}return{next:m}}function m(){return{value:v,done:!0}}var v,g=Object.prototype,y=g.hasOwnProperty,_="function"==typeof Symbol?Symbol:{},b=_.iterator||"@@iterator",w=_.asyncIterator||"@@asyncIterator",k=_.toStringTag||"@@toStringTag",x="object"==typeof t,C=e.regeneratorRuntime;if(C)x&&(t.exports=C);else{(C=e.regeneratorRuntime=x?t.exports:{}).wrap=n;var S="suspendedStart",M="suspendedYield",T="executing",P="completed",O={},B={};B[b]=function(){return this};var E=Object.getPrototypeOf,A=E&&E(E(p([])));A&&A!==g&&y.call(A,b)&&(B=A);var D=a.prototype=r.prototype=Object.create(B);o.prototype=D.constructor=a,a.constructor=o,a[k]=o.displayName="GeneratorFunction",C.isGeneratorFunction=function(t){var e="function"==typeof t&&t.constructor;return!!e&&(e===o||"GeneratorFunction"===(e.displayName||e.name))},C.mark=function(t){return Object.setPrototypeOf?Object.setPrototypeOf(t,a):(t.__proto__=a,k in t||(t[k]="GeneratorFunction")),t.prototype=Object.create(D),t},C.awrap=function(t){return{__await:t}},s(l.prototype),l.prototype[w]=function(){return this},C.AsyncIterator=l,C.async=function(t,e,i,r){var o=new l(n(t,e,i,r));return C.isGeneratorFunction(e)?o:o.next().then((function(t){return t.done?t.value:o.next()}))},s(D),D[k]="Generator",D[b]=function(){return this},D.toString=function(){return"[object Generator]"},C.keys=function(t){var e=[];for(var n in t)e.push(n);return e.reverse(),function n(){for(;e.length;){var i=e.pop();if(i in t)return n.value=i,n.done=!1,n}return n.done=!0,n}},C.values=p,f.prototype={constructor:f,reset:function(t){if(this.prev=0,this.next=0,this.sent=this._sent=v,this.done=!1,this.delegate=null,this.method="next",this.arg=v,this.tryEntries.forEach(h),!t)for(var e in this)"t"===e.charAt(0)&&y.call(this,e)&&!isNaN(+e.slice(1))&&(this[e]=v)},stop:function(){this.done=!0;var t=this.tryEntries[0].completion;if("throw"===t.type)throw t.arg;return this.rval},dispatchException:function(t){function e(e,i){return o.type="throw",o.arg=t,n.next=e,i&&(n.method="next",n.arg=v),!!i}if(this.done)throw t;for(var n=this,i=this.tryEntries.length-1;i>=0;--i){var r=this.tryEntries[i],o=r.completion;if("root"===r.tryLoc)return e("end");if(r.tryLoc<=this.prev){var a=y.call(r,"catchLoc"),s=y.call(r,"finallyLoc");if(a&&s){if(this.prev<r.catchLoc)return e(r.catchLoc,!0);if(this.prev<r.finallyLoc)return e(r.finallyLoc)}else if(a){if(this.prev<r.catchLoc)return e(r.catchLoc,!0)}else{if(!s)throw new Error("try statement without catch or finally");if(this.prev<r.finallyLoc)return e(r.finallyLoc)}}}},abrupt:function(t,e){for(var n=this.tryEntries.length-1;n>=0;--n){var i=this.tryEntries[n];if(i.tryLoc<=this.prev&&y.call(i,"finallyLoc")&&this.prev<i.finallyLoc){var r=i;break}}r&&("break"===t||"continue"===t)&&r.tryLoc<=e&&e<=r.finallyLoc&&(r=null);var o=r?r.completion:{};return o.type=t,o.arg=e,r?(this.method="next",this.next=r.finallyLoc,O):this.complete(o)},complete:function(t,e){if("throw"===t.type)throw t.arg;return"break"===t.type||"continue"===t.type?this.next=t.arg:"return"===t.type?(this.rval=this.arg=t.arg,this.method="return",this.next="end"):"normal"===t.type&&e&&(this.next=e),O},finish:function(t){for(var e=this.tryEntries.length-1;e>=0;--e){var n=this.tryEntries[e];if(n.finallyLoc===t)return this.complete(n.completion,n.afterLoc),h(n),O}},catch:function(t){for(var e=this.tryEntries.length-1;e>=0;--e){var n=this.tryEntries[e];if(n.tryLoc===t){var i=n.completion;if("throw"===i.type){var r=i.arg;h(n)}return r}}throw new Error("illegal catch attempt")},delegateYield:function(t,e,n){return this.delegate={iterator:p(t),resultName:e,nextLoc:n},"next"===this.method&&(this.arg=v),O}}}}(function(){return this}()||Function("return this")())},function(t,e,n){"use strict";e.a=function(t){var e=t.color;return function(t,n){var i=t.topLeftCorner,r=t.topRightCorner,o=t.bottomLeftCorner,a=t.bottomRightCorner;n.strokeStyle=e,n.beginPath(),n.moveTo(i.x,i.y),n.lineTo(o.x,o.y),n.lineTo(a.x,a.y),n.lineTo(r.x,r.y),n.lineTo(i.x,i.y),n.closePath(),n.stroke()}}},function(t,e,n){"use strict";var i=n(11),r=n.n(i),o=n(99),a=n.n(o),s=n(12),l=n.n(s),c=n(63),u=n.n(c),d=n(106),h=n.n(d),f=n(110),p=n.n(f),m=n(64),v=n(45),g=n(41),y=function(){function t(e,n){u()(this,t),this.videoEl=e,this.stream=n}return h()(t,[{key:"stop",value:function(){this.stream.getTracks().forEach((function(t){return t.stop()}))}},{key:"captureFrame",value:function(){return Object(v.c)(this.videoEl)}}]),t}(),_=!0!==window.isSecureContext,b=!(navigator&&(navigator.getUserMedia||navigator.mediaDevices&&navigator.mediaDevices.getUserMedia)),w=!1;e.a=function(){var t=l()(r.a.mark((function t(e,n,i){var o,s,l,c;return r.a.wrap((function(t){for(;;)switch(t.prev=t.next){case 0:if(!_){t.next=2;break}throw new m.c;case 2:if(!b){t.next=4;break}throw new m.d;case 4:return!1===w&&(p()({window:window}),w=!0),t.next=7,navigator.mediaDevices.getUserMedia(e);case 7:return o=t.sent,void 0!==n.srcObject?n.srcObject=o:void 0!==n.mozSrcObject?n.mozSrcObject=o:window.URL.createObjectURL?n.src=window.URL.createObjectURL(o):window.webkitURL?n.src=window.webkitURL.createObjectURL(o):n.src=o,t.next=11,Object(g.a)(n,"loadeddata");case 11:if(!i.torch){t.next=21;break}return s=o.getVideoTracks(),l=a()(s,1),c=l[0],t.prev=13,t.next=16,c.applyConstraints({advanced:[{torch:!0}]});case 16:t.next=21;break;case 18:t.prev=18,t.t0=t.catch(13),console.warn("device does not support torch capability");case 21:return t.abrupt("return",new y(n,o));case 22:case"end":return t.stop()}}),t,this,[[13,18]])})));return function(e,n,i){return t.apply(this,arguments)}}()},function(t,e,n){"use strict";function i(t){return t&&t.__esModule?t:{default:t}}e.__esModule=!0;var r=i(n(100)),o=i(n(103));e.default=function(t,e){if(Array.isArray(t))return t;if((0,r.default)(Object(t)))return function(t,e){var n=[],i=!0,r=!1,a=void 0;try{for(var s,l=(0,o.default)(t);!(i=(s=l.next()).done)&&(n.push(s.value),!e||n.length!==e);i=!0);}catch(t){r=!0,a=t}finally{try{!i&&l.return&&l.return()}finally{if(r)throw a}}return n}(t,e);throw new TypeError("Invalid attempt to destructure non-iterable instance")}},function(t,e,n){t.exports={default:n(101),__esModule:!0}},function(t,e,n){n(25),n(16),t.exports=n(102)},function(t,e,n){var i=n(37),r=n(2)("iterator"),o=n(14);t.exports=n(0).isIterable=function(t){var e=Object(t);return void 0!==e[r]||"@@iterator"in e||o.hasOwnProperty(i(e))}},function(t,e,n){t.exports={default:n(104),__esModule:!0}},function(t,e,n){n(25),n(16),t.exports=n(105)},function(t,e,n){var i=n(4),r=n(38);t.exports=n(0).getIterator=function(t){var e=r(t);if("function"!=typeof e)throw TypeError(t+" is not iterable!");return i(e.call(t))}},function(t,e,n){"use strict";e.__esModule=!0;var i=function(t){return t&&t.__esModule?t:{default:t}}(n(107));e.default=function(){function t(t,e){for(var n=0;n<e.length;n++){var r=e[n];r.enumerable=r.enumerable||!1,r.configurable=!0,"value"in r&&(r.writable=!0),(0,i.default)(t,r.key,r)}}return function(e,n,i){return n&&t(e.prototype,n),i&&t(e,i),e}}()},function(t,e,n){t.exports={default:n(108),__esModule:!0}},function(t,e,n){n(109);var i=n(0).Object;t.exports=function(t,e,n){return i.defineProperty(t,e,n)}},function(t,e,n){var i=n(3);i(i.S+i.F*!n(8),"Object",{defineProperty:n(5).f})},function(t,e,n){"use strict";var i=n(6);t.exports=function(t,e){var r=t&&t.window,o={shimChrome:!0,shimFirefox:!0,shimEdge:!0,shimSafari:!0};for(var a in e)hasOwnProperty.call(e,a)&&(o[a]=e[a]);var s=i.log,l=i.detectBrowser(r),c=n(111)||null,u=n(113)||null,d=n(118)||null,h=n(120)||null,f=n(121)||null,p={browserDetails:l,commonShim:f,extractVersion:i.extractVersion,disableLog:i.disableLog,disableWarnings:i.disableWarnings};switch(l.browser){case"chrome":if(!c||!c.shimPeerConnection||!o.shimChrome)return s("Chrome shim is not included in this adapter release."),p;s("adapter.js shimming chrome."),p.browserShim=c,f.shimCreateObjectURL(r),c.shimGetUserMedia(r),c.shimMediaStream(r),c.shimSourceObject(r),c.shimPeerConnection(r),c.shimOnTrack(r),c.shimAddTrackRemoveTrack(r),c.shimGetSendersWithDtmf(r),c.shimSenderReceiverGetStats(r),c.fixNegotiationNeeded(r),f.shimRTCIceCandidate(r),f.shimMaxMessageSize(r),f.shimSendThrowTypeError(r);break;case"firefox":if(!d||!d.shimPeerConnection||!o.shimFirefox)return s("Firefox shim is not included in this adapter release."),p;s("adapter.js shimming firefox."),p.browserShim=d,f.shimCreateObjectURL(r),d.shimGetUserMedia(r),d.shimSourceObject(r),d.shimPeerConnection(r),d.shimOnTrack(r),d.shimRemoveStream(r),d.shimSenderGetStats(r),d.shimReceiverGetStats(r),d.shimRTCDataChannel(r),f.shimRTCIceCandidate(r),f.shimMaxMessageSize(r),f.shimSendThrowTypeError(r);break;case"edge":if(!u||!u.shimPeerConnection||!o.shimEdge)return s("MS edge shim is not included in this adapter release."),p;s("adapter.js shimming edge."),p.browserShim=u,f.shimCreateObjectURL(r),u.shimGetUserMedia(r),u.shimPeerConnection(r),u.shimReplaceTrack(r),u.shimGetDisplayMedia(r),f.shimMaxMessageSize(r),f.shimSendThrowTypeError(r);break;case"safari":if(!h||!o.shimSafari)return s("Safari shim is not included in this adapter release."),p;s("adapter.js shimming safari."),p.browserShim=h,f.shimCreateObjectURL(r),h.shimRTCIceServerUrls(r),h.shimCreateOfferLegacy(r),h.shimCallbacksAPI(r),h.shimLocalStreamsAPI(r),h.shimRemoteStreamsAPI(r),h.shimTrackEventTransceiver(r),h.shimGetUserMedia(r),f.shimRTCIceCandidate(r),f.shimMaxMessageSize(r),f.shimSendThrowTypeError(r);break;default:s("Unsupported browser!")}return p}},function(t,e,n){"use strict";function i(t,e,n){e&&!n.has(e.id)&&(n.set(e.id,e),Object.keys(e).forEach((function(r){r.endsWith("Id")?i(t,t.get(e[r]),n):r.endsWith("Ids")&&e[r].forEach((function(e){i(t,t.get(e),n)}))})))}function r(t,e,n){var r=n?"outbound-rtp":"inbound-rtp",o=new Map;if(null===e)return o;var a=[];return t.forEach((function(t){"track"===t.type&&t.trackIdentifier===e.id&&a.push(t)})),a.forEach((function(e){t.forEach((function(n){n.type===r&&n.trackId===e.id&&i(t,n,o)}))})),o}var o=n(6),a=o.log;t.exports={shimGetUserMedia:n(112),shimMediaStream:function(t){t.MediaStream=t.MediaStream||t.webkitMediaStream},shimOnTrack:function(t){if("object"!=typeof t||!t.RTCPeerConnection||"ontrack"in t.RTCPeerConnection.prototype)o.wrapPeerConnectionEvent(t,"track",(function(t){return t.transceiver||Object.defineProperty(t,"transceiver",{value:{receiver:t.receiver}}),t}));else{Object.defineProperty(t.RTCPeerConnection.prototype,"ontrack",{get:function(){return this._ontrack},set:function(t){this._ontrack&&this.removeEventListener("track",this._ontrack),this.addEventListener("track",this._ontrack=t)},enumerable:!0,configurable:!0});var e=t.RTCPeerConnection.prototype.setRemoteDescription;t.RTCPeerConnection.prototype.setRemoteDescription=function(){var n=this;return n._ontrackpoly||(n._ontrackpoly=function(e){e.stream.addEventListener("addtrack",(function(i){var r;r=t.RTCPeerConnection.prototype.getReceivers?n.getReceivers().find((function(t){return t.track&&t.track.id===i.track.id})):{track:i.track};var o=new Event("track");o.track=i.track,o.receiver=r,o.transceiver={receiver:r},o.streams=[e.stream],n.dispatchEvent(o)})),e.stream.getTracks().forEach((function(i){var r;r=t.RTCPeerConnection.prototype.getReceivers?n.getReceivers().find((function(t){return t.track&&t.track.id===i.id})):{track:i};var o=new Event("track");o.track=i,o.receiver=r,o.transceiver={receiver:r},o.streams=[e.stream],n.dispatchEvent(o)}))},n.addEventListener("addstream",n._ontrackpoly)),e.apply(n,arguments)}}},shimGetSendersWithDtmf:function(t){if("object"==typeof t&&t.RTCPeerConnection&&!("getSenders"in t.RTCPeerConnection.prototype)&&"createDTMFSender"in t.RTCPeerConnection.prototype){var e=function(t,e){return{track:e,get dtmf(){return void 0===this._dtmf&&("audio"===e.kind?this._dtmf=t.createDTMFSender(e):this._dtmf=null),this._dtmf},_pc:t}};if(!t.RTCPeerConnection.prototype.getSenders){t.RTCPeerConnection.prototype.getSenders=function(){return this._senders=this._senders||[],this._senders.slice()};var n=t.RTCPeerConnection.prototype.addTrack;t.RTCPeerConnection.prototype.addTrack=function(t,i){var r=this,o=n.apply(r,arguments);return o||(o=e(r,t),r._senders.push(o)),o};var i=t.RTCPeerConnection.prototype.removeTrack;t.RTCPeerConnection.prototype.removeTrack=function(t){var e=this;i.apply(e,arguments);var n=e._senders.indexOf(t);-1!==n&&e._senders.splice(n,1)}}var r=t.RTCPeerConnection.prototype.addStream;t.RTCPeerConnection.prototype.addStream=function(t){var n=this;n._senders=n._senders||[],r.apply(n,[t]),t.getTracks().forEach((function(t){n._senders.push(e(n,t))}))};var o=t.RTCPeerConnection.prototype.removeStream;t.RTCPeerConnection.prototype.removeStream=function(t){var e=this;e._senders=e._senders||[],o.apply(e,[t]),t.getTracks().forEach((function(t){var n=e._senders.find((function(e){return e.track===t}));n&&e._senders.splice(e._senders.indexOf(n),1)}))}}else if("object"==typeof t&&t.RTCPeerConnection&&"getSenders"in t.RTCPeerConnection.prototype&&"createDTMFSender"in t.RTCPeerConnection.prototype&&t.RTCRtpSender&&!("dtmf"in t.RTCRtpSender.prototype)){var a=t.RTCPeerConnection.prototype.getSenders;t.RTCPeerConnection.prototype.getSenders=function(){var t=this,e=a.apply(t,[]);return e.forEach((function(e){e._pc=t})),e},Object.defineProperty(t.RTCRtpSender.prototype,"dtmf",{get:function(){return void 0===this._dtmf&&("audio"===this.track.kind?this._dtmf=this._pc.createDTMFSender(this.track):this._dtmf=null),this._dtmf}})}},shimSenderReceiverGetStats:function(t){if("object"==typeof t&&t.RTCPeerConnection&&t.RTCRtpSender&&t.RTCRtpReceiver){if(!("getStats"in t.RTCRtpSender.prototype)){var e=t.RTCPeerConnection.prototype.getSenders;e&&(t.RTCPeerConnection.prototype.getSenders=function(){var t=this,n=e.apply(t,[]);return n.forEach((function(e){e._pc=t})),n});var n=t.RTCPeerConnection.prototype.addTrack;n&&(t.RTCPeerConnection.prototype.addTrack=function(){var t=n.apply(this,arguments);return t._pc=this,t}),t.RTCRtpSender.prototype.getStats=function(){var t=this;return this._pc.getStats().then((function(e){return r(e,t.track,!0)}))}}if(!("getStats"in t.RTCRtpReceiver.prototype)){var i=t.RTCPeerConnection.prototype.getReceivers;i&&(t.RTCPeerConnection.prototype.getReceivers=function(){var t=this,e=i.apply(t,[]);return e.forEach((function(e){e._pc=t})),e}),o.wrapPeerConnectionEvent(t,"track",(function(t){return t.receiver._pc=t.srcElement,t})),t.RTCRtpReceiver.prototype.getStats=function(){var t=this;return this._pc.getStats().then((function(e){return r(e,t.track,!1)}))}}if("getStats"in t.RTCRtpSender.prototype&&"getStats"in t.RTCRtpReceiver.prototype){var a=t.RTCPeerConnection.prototype.getStats;t.RTCPeerConnection.prototype.getStats=function(){var e=this;if(arguments.length>0&&arguments[0]instanceof t.MediaStreamTrack){var n,i,r,o=arguments[0];return e.getSenders().forEach((function(t){t.track===o&&(n?r=!0:n=t)})),e.getReceivers().forEach((function(t){return t.track===o&&(i?r=!0:i=t),t.track===o})),r||n&&i?Promise.reject(new DOMException("There are more than one sender or receiver for the track.","InvalidAccessError")):n?n.getStats():i?i.getStats():Promise.reject(new DOMException("There is no sender or receiver for the track.","InvalidAccessError"))}return a.apply(e,arguments)}}}},shimSourceObject:function(t){var e=t&&t.URL;"object"==typeof t&&(!t.HTMLMediaElement||"srcObject"in t.HTMLMediaElement.prototype||Object.defineProperty(t.HTMLMediaElement.prototype,"srcObject",{get:function(){return this._srcObject},set:function(t){var n=this;this._srcObject=t,this.src&&e.revokeObjectURL(this.src),t?(this.src=e.createObjectURL(t),t.addEventListener("addtrack",(function(){n.src&&e.revokeObjectURL(n.src),n.src=e.createObjectURL(t)})),t.addEventListener("removetrack",(function(){n.src&&e.revokeObjectURL(n.src),n.src=e.createObjectURL(t)}))):this.src=""}}))},shimAddTrackRemoveTrackWithNative:function(t){t.RTCPeerConnection.prototype.getLocalStreams=function(){var t=this;return this._shimmedLocalStreams=this._shimmedLocalStreams||{},Object.keys(this._shimmedLocalStreams).map((function(e){return t._shimmedLocalStreams[e][0]}))};var e=t.RTCPeerConnection.prototype.addTrack;t.RTCPeerConnection.prototype.addTrack=function(t,n){if(!n)return e.apply(this,arguments);this._shimmedLocalStreams=this._shimmedLocalStreams||{};var i=e.apply(this,arguments);return this._shimmedLocalStreams[n.id]?-1===this._shimmedLocalStreams[n.id].indexOf(i)&&this._shimmedLocalStreams[n.id].push(i):this._shimmedLocalStreams[n.id]=[n,i],i};var n=t.RTCPeerConnection.prototype.addStream;t.RTCPeerConnection.prototype.addStream=function(t){var e=this;this._shimmedLocalStreams=this._shimmedLocalStreams||{},t.getTracks().forEach((function(t){if(e.getSenders().find((function(e){return e.track===t})))throw new DOMException("Track already exists.","InvalidAccessError")}));var i=e.getSenders();n.apply(this,arguments);var r=e.getSenders().filter((function(t){return-1===i.indexOf(t)}));this._shimmedLocalStreams[t.id]=[t].concat(r)};var i=t.RTCPeerConnection.prototype.removeStream;t.RTCPeerConnection.prototype.removeStream=function(t){return this._shimmedLocalStreams=this._shimmedLocalStreams||{},delete this._shimmedLocalStreams[t.id],i.apply(this,arguments)};var r=t.RTCPeerConnection.prototype.removeTrack;t.RTCPeerConnection.prototype.removeTrack=function(t){var e=this;return this._shimmedLocalStreams=this._shimmedLocalStreams||{},t&&Object.keys(this._shimmedLocalStreams).forEach((function(n){var i=e._shimmedLocalStreams[n].indexOf(t);-1!==i&&e._shimmedLocalStreams[n].splice(i,1),1===e._shimmedLocalStreams[n].length&&delete e._shimmedLocalStreams[n]})),r.apply(this,arguments)}},shimAddTrackRemoveTrack:function(t){function e(t,e){var n=e.sdp;return Object.keys(t._reverseStreams||[]).forEach((function(e){var i=t._reverseStreams[e],r=t._streams[i.id];n=n.replace(new RegExp(r.id,"g"),i.id)})),new RTCSessionDescription({type:e.type,sdp:n})}if(t.RTCPeerConnection){var n=o.detectBrowser(t);if(t.RTCPeerConnection.prototype.addTrack&&n.version>=65)return this.shimAddTrackRemoveTrackWithNative(t);var i=t.RTCPeerConnection.prototype.getLocalStreams;t.RTCPeerConnection.prototype.getLocalStreams=function(){var t=this,e=i.apply(this);return t._reverseStreams=t._reverseStreams||{},e.map((function(e){return t._reverseStreams[e.id]}))};var r=t.RTCPeerConnection.prototype.addStream;t.RTCPeerConnection.prototype.addStream=function(e){var n=this;if(n._streams=n._streams||{},n._reverseStreams=n._reverseStreams||{},e.getTracks().forEach((function(t){if(n.getSenders().find((function(e){return e.track===t})))throw new DOMException("Track already exists.","InvalidAccessError")})),!n._reverseStreams[e.id]){var i=new t.MediaStream(e.getTracks());n._streams[e.id]=i,n._reverseStreams[i.id]=e,e=i}r.apply(n,[e])};var a=t.RTCPeerConnection.prototype.removeStream;t.RTCPeerConnection.prototype.removeStream=function(t){var e=this;e._streams=e._streams||{},e._reverseStreams=e._reverseStreams||{},a.apply(e,[e._streams[t.id]||t]),delete e._reverseStreams[e._streams[t.id]?e._streams[t.id].id:t.id],delete e._streams[t.id]},t.RTCPeerConnection.prototype.addTrack=function(e,n){var i=this;if("closed"===i.signalingState)throw new DOMException("The RTCPeerConnection's signalingState is 'closed'.","InvalidStateError");var r=[].slice.call(arguments,1);if(1!==r.length||!r[0].getTracks().find((function(t){return t===e})))throw new DOMException("The adapter.js addTrack polyfill only supports a single  stream which is associated with the specified track.","NotSupportedError");if(i.getSenders().find((function(t){return t.track===e})))throw new DOMException("Track already exists.","InvalidAccessError");i._streams=i._streams||{},i._reverseStreams=i._reverseStreams||{};var o=i._streams[n.id];if(o)o.addTrack(e),Promise.resolve().then((function(){i.dispatchEvent(new Event("negotiationneeded"))}));else{var a=new t.MediaStream([e]);i._streams[n.id]=a,i._reverseStreams[a.id]=n,i.addStream(a)}return i.getSenders().find((function(t){return t.track===e}))},["createOffer","createAnswer"].forEach((function(n){var i=t.RTCPeerConnection.prototype[n];t.RTCPeerConnection.prototype[n]=function(){var t=this,n=arguments;return arguments.length&&"function"==typeof arguments[0]?i.apply(t,[function(i){var r=e(t,i);n[0].apply(null,[r])},function(t){n[1]&&n[1].apply(null,t)},arguments[2]]):i.apply(t,arguments).then((function(n){return e(t,n)}))}}));var s=t.RTCPeerConnection.prototype.setLocalDescription;t.RTCPeerConnection.prototype.setLocalDescription=function(){var t=this;return arguments.length&&arguments[0].type?(arguments[0]=function(t,e){var n=e.sdp;return Object.keys(t._reverseStreams||[]).forEach((function(e){var i=t._reverseStreams[e],r=t._streams[i.id];n=n.replace(new RegExp(i.id,"g"),r.id)})),new RTCSessionDescription({type:e.type,sdp:n})}(t,arguments[0]),s.apply(t,arguments)):s.apply(t,arguments)};var l=Object.getOwnPropertyDescriptor(t.RTCPeerConnection.prototype,"localDescription");Object.defineProperty(t.RTCPeerConnection.prototype,"localDescription",{get:function(){var t=l.get.apply(this);return""===t.type?t:e(this,t)}}),t.RTCPeerConnection.prototype.removeTrack=function(t){var e,n=this;if("closed"===n.signalingState)throw new DOMException("The RTCPeerConnection's signalingState is 'closed'.","InvalidStateError");if(!t._pc)throw new DOMException("Argument 1 of RTCPeerConnection.removeTrack does not implement interface RTCRtpSender.","TypeError");if(t._pc!==n)throw new DOMException("Sender was not created by this connection.","InvalidAccessError");n._streams=n._streams||{},Object.keys(n._streams).forEach((function(i){n._streams[i].getTracks().find((function(e){return t.track===e}))&&(e=n._streams[i])})),e&&(1===e.getTracks().length?n.removeStream(n._reverseStreams[e.id]):e.removeTrack(t.track),n.dispatchEvent(new Event("negotiationneeded")))}}},shimPeerConnection:function(t){var e=o.detectBrowser(t);if(!t.RTCPeerConnection&&t.webkitRTCPeerConnection&&(t.RTCPeerConnection=function(e,n){return a("PeerConnection"),e&&e.iceTransportPolicy&&(e.iceTransports=e.iceTransportPolicy),new t.webkitRTCPeerConnection(e,n)},t.RTCPeerConnection.prototype=t.webkitRTCPeerConnection.prototype,t.webkitRTCPeerConnection.generateCertificate&&Object.defineProperty(t.RTCPeerConnection,"generateCertificate",{get:function(){return t.webkitRTCPeerConnection.generateCertificate}})),t.RTCPeerConnection){var n=t.RTCPeerConnection.prototype.getStats;t.RTCPeerConnection.prototype.getStats=function(t,e,i){var r=this,o=arguments;if(arguments.length>0&&"function"==typeof t)return n.apply(this,arguments);if(0===n.length&&(0===arguments.length||"function"!=typeof arguments[0]))return n.apply(this,[]);var a=function(t){var e={};return t.result().forEach((function(t){var n={id:t.id,timestamp:t.timestamp,type:{localcandidate:"local-candidate",remotecandidate:"remote-candidate"}[t.type]||t.type};t.names().forEach((function(e){n[e]=t.stat(e)})),e[n.id]=n})),e},s=function(t){return new Map(Object.keys(t).map((function(e){return[e,t[e]]})))};if(arguments.length>=2){return n.apply(this,[function(t){o[1](s(a(t)))},arguments[0]])}return new Promise((function(t,e){n.apply(r,[function(e){t(s(a(e)))},e])})).then(e,i)},e.version<51&&["setLocalDescription","setRemoteDescription","addIceCandidate"].forEach((function(e){var n=t.RTCPeerConnection.prototype[e];t.RTCPeerConnection.prototype[e]=function(){var t=arguments,e=this,i=new Promise((function(i,r){n.apply(e,[t[0],i,r])}));return t.length<2?i:i.then((function(){t[1].apply(null,[])}),(function(e){t.length>=3&&t[2].apply(null,[e])}))}})),e.version<52&&["createOffer","createAnswer"].forEach((function(e){var n=t.RTCPeerConnection.prototype[e];t.RTCPeerConnection.prototype[e]=function(){var t=this;if(arguments.length<1||1===arguments.length&&"object"==typeof arguments[0]){var e=1===arguments.length?arguments[0]:void 0;return new Promise((function(i,r){n.apply(t,[i,r,e])}))}return n.apply(this,arguments)}})),["setLocalDescription","setRemoteDescription","addIceCandidate"].forEach((function(e){var n=t.RTCPeerConnection.prototype[e];t.RTCPeerConnection.prototype[e]=function(){return arguments[0]=new("addIceCandidate"===e?t.RTCIceCandidate:t.RTCSessionDescription)(arguments[0]),n.apply(this,arguments)}}));var i=t.RTCPeerConnection.prototype.addIceCandidate;t.RTCPeerConnection.prototype.addIceCandidate=function(){return arguments[0]?i.apply(this,arguments):(arguments[1]&&arguments[1].apply(null),Promise.resolve())}}},fixNegotiationNeeded:function(t){o.wrapPeerConnectionEvent(t,"negotiationneeded",(function(t){if("stable"===t.target.signalingState)return t}))},shimGetDisplayMedia:function(t,e){if(t.navigator&&t.navigator.mediaDevices&&!("getDisplayMedia"in t.navigator.mediaDevices)){if("function"!=typeof e)return void console.error("shimGetDisplayMedia: getSourceId argument is not a function");t.navigator.mediaDevices.getDisplayMedia=function(n){return e(n).then((function(e){var i=n.video&&n.video.width,r=n.video&&n.video.height,o=n.video&&n.video.frameRate;return n.video={mandatory:{chromeMediaSource:"desktop",chromeMediaSourceId:e,maxFrameRate:o||3}},i&&(n.video.mandatory.maxWidth=i),r&&(n.video.mandatory.maxHeight=r),t.navigator.mediaDevices.getUserMedia(n)}))},t.navigator.getDisplayMedia=function(e){return o.deprecated("navigator.getDisplayMedia","navigator.mediaDevices.getDisplayMedia"),t.navigator.mediaDevices.getDisplayMedia(e)}}}}},function(t,e,n){"use strict";var i=n(6),r=i.log;t.exports=function(t){var e=i.detectBrowser(t),n=t&&t.navigator,o=function(t){if("object"!=typeof t||t.mandatory||t.optional)return t;var e={};return Object.keys(t).forEach((function(n){if("require"!==n&&"advanced"!==n&&"mediaSource"!==n){var i="object"==typeof t[n]?t[n]:{ideal:t[n]};void 0!==i.exact&&"number"==typeof i.exact&&(i.min=i.max=i.exact);var r=function(t,e){return t?t+e.charAt(0).toUpperCase()+e.slice(1):"deviceId"===e?"sourceId":e};if(void 0!==i.ideal){e.optional=e.optional||[];var o={};"number"==typeof i.ideal?(o[r("min",n)]=i.ideal,e.optional.push(o),(o={})[r("max",n)]=i.ideal,e.optional.push(o)):(o[r("",n)]=i.ideal,e.optional.push(o))}void 0!==i.exact&&"number"!=typeof i.exact?(e.mandatory=e.mandatory||{},e.mandatory[r("",n)]=i.exact):["min","max"].forEach((function(t){void 0!==i[t]&&(e.mandatory=e.mandatory||{},e.mandatory[r(t,n)]=i[t])}))}})),t.advanced&&(e.optional=(e.optional||[]).concat(t.advanced)),e},a=function(t,i){if(e.version>=61)return i(t);if((t=JSON.parse(JSON.stringify(t)))&&"object"==typeof t.audio){var a=function(t,e,n){e in t&&!(n in t)&&(t[n]=t[e],delete t[e])};a((t=JSON.parse(JSON.stringify(t))).audio,"autoGainControl","googAutoGainControl"),a(t.audio,"noiseSuppression","googNoiseSuppression"),t.audio=o(t.audio)}if(t&&"object"==typeof t.video){var s=t.video.facingMode;s=s&&("object"==typeof s?s:{ideal:s});var l,c=e.version<66;if(s&&("user"===s.exact||"environment"===s.exact||"user"===s.ideal||"environment"===s.ideal)&&(!n.mediaDevices.getSupportedConstraints||!n.mediaDevices.getSupportedConstraints().facingMode||c))if(delete t.video.facingMode,"environment"===s.exact||"environment"===s.ideal?l=["back","rear"]:"user"!==s.exact&&"user"!==s.ideal||(l=["front"]),l)return n.mediaDevices.enumerateDevices().then((function(e){e=e.filter((function(t){return"videoinput"===t.kind}));var n=e.find((function(t){return l.some((function(e){return-1!==t.label.toLowerCase().indexOf(e)}))}));return!n&&e.length&&-1!==l.indexOf("back")&&(n=e[e.length-1]),n&&(t.video.deviceId=s.exact?{exact:n.deviceId}:{ideal:n.deviceId}),t.video=o(t.video),r("chrome: "+JSON.stringify(t)),i(t)}));t.video=o(t.video)}return r("chrome: "+JSON.stringify(t)),i(t)},s=function(t){return e.version>=64?t:{name:{PermissionDeniedError:"NotAllowedError",PermissionDismissedError:"NotAllowedError",InvalidStateError:"NotAllowedError",DevicesNotFoundError:"NotFoundError",ConstraintNotSatisfiedError:"OverconstrainedError",TrackStartError:"NotReadableError",MediaDeviceFailedDueToShutdown:"NotAllowedError",MediaDeviceKillSwitchOn:"NotAllowedError",TabCaptureError:"AbortError",ScreenCaptureError:"AbortError",DeviceCaptureError:"AbortError"}[t.name]||t.name,message:t.message,constraint:t.constraint||t.constraintName,toString:function(){return this.name+(this.message&&": ")+this.message}}};n.getUserMedia=function(t,e,i){a(t,(function(t){n.webkitGetUserMedia(t,e,(function(t){i&&i(s(t))}))}))};var l=function(t){return new Promise((function(e,i){n.getUserMedia(t,e,i)}))};if(n.mediaDevices||(n.mediaDevices={getUserMedia:l,enumerateDevices:function(){return new Promise((function(e){var n={audio:"audioinput",video:"videoinput"};return t.MediaStreamTrack.getSources((function(t){e(t.map((function(t){return{label:t.label,kind:n[t.kind],deviceId:t.id,groupId:""}})))}))}))},getSupportedConstraints:function(){return{deviceId:!0,echoCancellation:!0,facingMode:!0,frameRate:!0,height:!0,width:!0}}}),n.mediaDevices.getUserMedia){var c=n.mediaDevices.getUserMedia.bind(n.mediaDevices);n.mediaDevices.getUserMedia=function(t){return a(t,(function(t){return c(t).then((function(e){if(t.audio&&!e.getAudioTracks().length||t.video&&!e.getVideoTracks().length)throw e.getTracks().forEach((function(t){t.stop()})),new DOMException("","NotFoundError");return e}),(function(t){return Promise.reject(s(t))}))}))}}else n.mediaDevices.getUserMedia=function(t){return l(t)};void 0===n.mediaDevices.addEventListener&&(n.mediaDevices.addEventListener=function(){r("Dummy mediaDevices.addEventListener called.")}),void 0===n.mediaDevices.removeEventListener&&(n.mediaDevices.removeEventListener=function(){r("Dummy mediaDevices.removeEventListener called.")})}},function(t,e,n){"use strict";var i=n(6),r=n(114),o=n(115);t.exports={shimGetUserMedia:n(117),shimPeerConnection:function(t){var e=i.detectBrowser(t);if(t.RTCIceGatherer&&(t.RTCIceCandidate||(t.RTCIceCandidate=function(t){return t}),t.RTCSessionDescription||(t.RTCSessionDescription=function(t){return t}),e.version<15025)){var n=Object.getOwnPropertyDescriptor(t.MediaStreamTrack.prototype,"enabled");Object.defineProperty(t.MediaStreamTrack.prototype,"enabled",{set:function(t){n.set.call(this,t);var e=new Event("enabled");e.enabled=t,this.dispatchEvent(e)}})}!t.RTCRtpSender||"dtmf"in t.RTCRtpSender.prototype||Object.defineProperty(t.RTCRtpSender.prototype,"dtmf",{get:function(){return void 0===this._dtmf&&("audio"===this.track.kind?this._dtmf=new t.RTCDtmfSender(this):"video"===this.track.kind&&(this._dtmf=null)),this._dtmf}}),t.RTCDtmfSender&&!t.RTCDTMFSender&&(t.RTCDTMFSender=t.RTCDtmfSender);var a=o(t,e.version);t.RTCPeerConnection=function(t){return t&&t.iceServers&&(t.iceServers=r(t.iceServers)),new a(t)},t.RTCPeerConnection.prototype=a.prototype},shimReplaceTrack:function(t){!t.RTCRtpSender||"replaceTrack"in t.RTCRtpSender.prototype||(t.RTCRtpSender.prototype.replaceTrack=t.RTCRtpSender.prototype.setTrack)},shimGetDisplayMedia:function(t,e){if("getDisplayMedia"in t.navigator&&t.navigator.mediaDevices&&!("getDisplayMedia"in t.navigator.mediaDevices)){var n=t.navigator.getDisplayMedia;t.navigator.mediaDevices.getDisplayMedia=function(e){return n.call(t.navigator,e)},t.navigator.getDisplayMedia=function(e){return i.deprecated("navigator.getDisplayMedia","navigator.mediaDevices.getDisplayMedia"),n.call(t.navigator,e)}}}}},function(t,e,n){"use strict";var i=n(6);t.exports=function(t,e){var n=!1;return(t=JSON.parse(JSON.stringify(t))).filter((function(t){if(t&&(t.urls||t.url)){var r=t.urls||t.url;t.url&&!t.urls&&i.deprecated("RTCIceServer.url","RTCIceServer.urls");var o="string"==typeof r;return o&&(r=[r]),r=r.filter((function(t){return 0!==t.indexOf("turn:")||-1===t.indexOf("transport=udp")||-1!==t.indexOf("turn:[")||n?0===t.indexOf("stun:")&&e>=14393&&-1===t.indexOf("?transport=udp"):(n=!0,!0)})),delete t.url,t.urls=o?r[0]:r,!!r.length}}))}},function(t,e,n){"use strict";function i(t,e,n,i,r){var o=l.writeRtpDescription(t.kind,e);if(o+=l.writeIceParameters(t.iceGatherer.getLocalParameters()),o+=l.writeDtlsParameters(t.dtlsTransport.getLocalParameters(),"offer"===n?"actpass":r||"active"),o+="a=mid:"+t.mid+"\r\n",t.rtpSender&&t.rtpReceiver?o+="a=sendrecv\r\n":t.rtpSender?o+="a=sendonly\r\n":t.rtpReceiver?o+="a=recvonly\r\n":o+="a=inactive\r\n",t.rtpSender){var a=t.rtpSender._initialTrackId||t.rtpSender.track.id;t.rtpSender._initialTrackId=a;var s="msid:"+(i?i.id:"-")+" "+a+"\r\n";o+="a="+s,o+="a=ssrc:"+t.sendEncodingParameters[0].ssrc+" "+s,t.sendEncodingParameters[0].rtx&&(o+="a=ssrc:"+t.sendEncodingParameters[0].rtx.ssrc+" "+s,o+="a=ssrc-group:FID "+t.sendEncodingParameters[0].ssrc+" "+t.sendEncodingParameters[0].rtx.ssrc+"\r\n")}return o+="a=ssrc:"+t.sendEncodingParameters[0].ssrc+" cname:"+l.localCName+"\r\n",t.rtpSender&&t.sendEncodingParameters[0].rtx&&(o+="a=ssrc:"+t.sendEncodingParameters[0].rtx.ssrc+" cname:"+l.localCName+"\r\n"),o}function r(t,e){var n={codecs:[],headerExtensions:[],fecMechanisms:[]},i=function(t,e){t=parseInt(t,10);for(var n=0;n<e.length;n++)if(e[n].payloadType===t||e[n].preferredPayloadType===t)return e[n]},r=function(t,e,n,r){var o=i(t.parameters.apt,n),a=i(e.parameters.apt,r);return o&&a&&o.name.toLowerCase()===a.name.toLowerCase()};return t.codecs.forEach((function(i){for(var o=0;o<e.codecs.length;o++){var a=e.codecs[o];if(i.name.toLowerCase()===a.name.toLowerCase()&&i.clockRate===a.clockRate){if("rtx"===i.name.toLowerCase()&&i.parameters&&a.parameters.apt&&!r(i,a,t.codecs,e.codecs))continue;(a=JSON.parse(JSON.stringify(a))).numChannels=Math.min(i.numChannels,a.numChannels),n.codecs.push(a),a.rtcpFeedback=a.rtcpFeedback.filter((function(t){for(var e=0;e<i.rtcpFeedback.length;e++)if(i.rtcpFeedback[e].type===t.type&&i.rtcpFeedback[e].parameter===t.parameter)return!0;return!1}));break}}})),t.headerExtensions.forEach((function(t){for(var i=0;i<e.headerExtensions.length;i++){var r=e.headerExtensions[i];if(t.uri===r.uri){n.headerExtensions.push(r);break}}})),n}function o(t,e,n){return-1!=={offer:{setLocalDescription:["stable","have-local-offer"],setRemoteDescription:["stable","have-remote-offer"]},answer:{setLocalDescription:["have-remote-offer","have-local-pranswer"],setRemoteDescription:["have-local-offer","have-remote-pranswer"]}}[e][t].indexOf(n)}function a(t,e){var n=t.getRemoteCandidates().find((function(t){return e.foundation===t.foundation&&e.ip===t.ip&&e.port===t.port&&e.priority===t.priority&&e.protocol===t.protocol&&e.type===t.type}));return n||t.addRemoteCandidate(e),!n}function s(t,e){var n=new Error(e);return n.name=t,n.code={NotSupportedError:9,InvalidStateError:11,InvalidAccessError:15,TypeError:void 0,OperationError:void 0}[t],n}var l=n(116);t.exports=function(t,e){function n(e,n){n.addTrack(e),n.dispatchEvent(new t.MediaStreamTrackEvent("addtrack",{track:e}))}function c(e,n){n.removeTrack(e),n.dispatchEvent(new t.MediaStreamTrackEvent("removetrack",{track:e}))}function u(e,n,i,r){var o=new Event("track");o.track=n,o.receiver=i,o.transceiver={receiver:i},o.streams=r,t.setTimeout((function(){e._dispatchEvent("track",o)}))}var d=function(n){var i=this,r=document.createDocumentFragment();if(["addEventListener","removeEventListener","dispatchEvent"].forEach((function(t){i[t]=r[t].bind(r)})),this.canTrickleIceCandidates=null,this.needNegotiation=!1,this.localStreams=[],this.remoteStreams=[],this._localDescription=null,this._remoteDescription=null,this.signalingState="stable",this.iceConnectionState="new",this.connectionState="new",this.iceGatheringState="new",n=JSON.parse(JSON.stringify(n||{})),this.usingBundle="max-bundle"===n.bundlePolicy,"negotiate"===n.rtcpMuxPolicy)throw s("NotSupportedError","rtcpMuxPolicy 'negotiate' is not supported");switch(n.rtcpMuxPolicy||(n.rtcpMuxPolicy="require"),n.iceTransportPolicy){case"all":case"relay":break;default:n.iceTransportPolicy="all"}switch(n.bundlePolicy){case"balanced":case"max-compat":case"max-bundle":break;default:n.bundlePolicy="balanced"}if(n.iceServers=function(t,e){var n=!1;return(t=JSON.parse(JSON.stringify(t))).filter((function(t){if(t&&(t.urls||t.url)){var i=t.urls||t.url;t.url&&!t.urls&&console.warn("RTCIceServer.url is deprecated! Use urls instead.");var r="string"==typeof i;return r&&(i=[i]),i=i.filter((function(t){return 0!==t.indexOf("turn:")||-1===t.indexOf("transport=udp")||-1!==t.indexOf("turn:[")||n?0===t.indexOf("stun:")&&e>=14393&&-1===t.indexOf("?transport=udp"):(n=!0,!0)})),delete t.url,t.urls=r?i[0]:i,!!i.length}}))}(n.iceServers||[],e),this._iceGatherers=[],n.iceCandidatePoolSize)for(var o=n.iceCandidatePoolSize;o>0;o--)this._iceGatherers.push(new t.RTCIceGatherer({iceServers:n.iceServers,gatherPolicy:n.iceTransportPolicy}));else n.iceCandidatePoolSize=0;this._config=n,this.transceivers=[],this._sdpSessionId=l.generateSessionId(),this._sdpSessionVersion=0,this._dtlsRole=void 0,this._isClosed=!1};Object.defineProperty(d.prototype,"localDescription",{configurable:!0,get:function(){return this._localDescription}}),Object.defineProperty(d.prototype,"remoteDescription",{configurable:!0,get:function(){return this._remoteDescription}}),d.prototype.onicecandidate=null,d.prototype.onaddstream=null,d.prototype.ontrack=null,d.prototype.onremovestream=null,d.prototype.onsignalingstatechange=null,d.prototype.oniceconnectionstatechange=null,d.prototype.onconnectionstatechange=null,d.prototype.onicegatheringstatechange=null,d.prototype.onnegotiationneeded=null,d.prototype.ondatachannel=null,d.prototype._dispatchEvent=function(t,e){this._isClosed||(this.dispatchEvent(e),"function"==typeof this["on"+t]&&this["on"+t](e))},d.prototype._emitGatheringStateChange=function(){var t=new Event("icegatheringstatechange");this._dispatchEvent("icegatheringstatechange",t)},d.prototype.getConfiguration=function(){return this._config},d.prototype.getLocalStreams=function(){return this.localStreams},d.prototype.getRemoteStreams=function(){return this.remoteStreams},d.prototype._createTransceiver=function(t,e){var n=this.transceivers.length>0,i={track:null,iceGatherer:null,iceTransport:null,dtlsTransport:null,localCapabilities:null,remoteCapabilities:null,rtpSender:null,rtpReceiver:null,kind:t,mid:null,sendEncodingParameters:null,recvEncodingParameters:null,stream:null,associatedRemoteMediaStreams:[],wantReceive:!0};if(this.usingBundle&&n)i.iceTransport=this.transceivers[0].iceTransport,i.dtlsTransport=this.transceivers[0].dtlsTransport;else{var r=this._createIceAndDtlsTransports();i.iceTransport=r.iceTransport,i.dtlsTransport=r.dtlsTransport}return e||this.transceivers.push(i),i},d.prototype.addTrack=function(e,n){if(this._isClosed)throw s("InvalidStateError","Attempted to call addTrack on a closed peerconnection.");if(this.transceivers.find((function(t){return t.track===e})))throw s("InvalidAccessError","Track already exists.");for(var i,r=0;r<this.transceivers.length;r++)this.transceivers[r].track||this.transceivers[r].kind!==e.kind||(i=this.transceivers[r]);return i||(i=this._createTransceiver(e.kind)),this._maybeFireNegotiationNeeded(),-1===this.localStreams.indexOf(n)&&this.localStreams.push(n),i.track=e,i.stream=n,i.rtpSender=new t.RTCRtpSender(e,i.dtlsTransport),i.rtpSender},d.prototype.addStream=function(t){var n=this;if(e>=15025)t.getTracks().forEach((function(e){n.addTrack(e,t)}));else{var i=t.clone();t.getTracks().forEach((function(t,e){var n=i.getTracks()[e];t.addEventListener("enabled",(function(t){n.enabled=t.enabled}))})),i.getTracks().forEach((function(t){n.addTrack(t,i)}))}},d.prototype.removeTrack=function(e){if(this._isClosed)throw s("InvalidStateError","Attempted to call removeTrack on a closed peerconnection.");if(!(e instanceof t.RTCRtpSender))throw new TypeError("Argument 1 of RTCPeerConnection.removeTrack does not implement interface RTCRtpSender.");var n=this.transceivers.find((function(t){return t.rtpSender===e}));if(!n)throw s("InvalidAccessError","Sender was not created by this connection.");var i=n.stream;n.rtpSender.stop(),n.rtpSender=null,n.track=null,n.stream=null,-1===this.transceivers.map((function(t){return t.stream})).indexOf(i)&&this.localStreams.indexOf(i)>-1&&this.localStreams.splice(this.localStreams.indexOf(i),1),this._maybeFireNegotiationNeeded()},d.prototype.removeStream=function(t){var e=this;t.getTracks().forEach((function(t){var n=e.getSenders().find((function(e){return e.track===t}));n&&e.removeTrack(n)}))},d.prototype.getSenders=function(){return this.transceivers.filter((function(t){return!!t.rtpSender})).map((function(t){return t.rtpSender}))},d.prototype.getReceivers=function(){return this.transceivers.filter((function(t){return!!t.rtpReceiver})).map((function(t){return t.rtpReceiver}))},d.prototype._createIceGatherer=function(e,n){var i=this;if(n&&e>0)return this.transceivers[0].iceGatherer;if(this._iceGatherers.length)return this._iceGatherers.shift();var r=new t.RTCIceGatherer({iceServers:this._config.iceServers,gatherPolicy:this._config.iceTransportPolicy});return Object.defineProperty(r,"state",{value:"new",writable:!0}),this.transceivers[e].bufferedCandidateEvents=[],this.transceivers[e].bufferCandidates=function(t){var n=!t.candidate||0===Object.keys(t.candidate).length;r.state=n?"completed":"gathering",null!==i.transceivers[e].bufferedCandidateEvents&&i.transceivers[e].bufferedCandidateEvents.push(t)},r.addEventListener("localcandidate",this.transceivers[e].bufferCandidates),r},d.prototype._gather=function(e,n){var i=this,r=this.transceivers[n].iceGatherer;if(!r.onlocalcandidate){var o=this.transceivers[n].bufferedCandidateEvents;this.transceivers[n].bufferedCandidateEvents=null,r.removeEventListener("localcandidate",this.transceivers[n].bufferCandidates),r.onlocalcandidate=function(t){if(!(i.usingBundle&&n>0)){var o=new Event("icecandidate");o.candidate={sdpMid:e,sdpMLineIndex:n};var a=t.candidate,s=!a||0===Object.keys(a).length;if(s)"new"!==r.state&&"gathering"!==r.state||(r.state="completed");else{"new"===r.state&&(r.state="gathering"),a.component=1,a.ufrag=r.getLocalParameters().usernameFragment;var c=l.writeCandidate(a);o.candidate=Object.assign(o.candidate,l.parseCandidate(c)),o.candidate.candidate=c,o.candidate.toJSON=function(){return{candidate:o.candidate.candidate,sdpMid:o.candidate.sdpMid,sdpMLineIndex:o.candidate.sdpMLineIndex,usernameFragment:o.candidate.usernameFragment}}}var u=l.getMediaSections(i._localDescription.sdp);u[o.candidate.sdpMLineIndex]+=s?"a=end-of-candidates\r\n":"a="+o.candidate.candidate+"\r\n",i._localDescription.sdp=l.getDescription(i._localDescription.sdp)+u.join("");var d=i.transceivers.every((function(t){return t.iceGatherer&&"completed"===t.iceGatherer.state}));"gathering"!==i.iceGatheringState&&(i.iceGatheringState="gathering",i._emitGatheringStateChange()),s||i._dispatchEvent("icecandidate",o),d&&(i._dispatchEvent("icecandidate",new Event("icecandidate")),i.iceGatheringState="complete",i._emitGatheringStateChange())}},t.setTimeout((function(){o.forEach((function(t){r.onlocalcandidate(t)}))}),0)}},d.prototype._createIceAndDtlsTransports=function(){var e=this,n=new t.RTCIceTransport(null);n.onicestatechange=function(){e._updateIceConnectionState(),e._updateConnectionState()};var i=new t.RTCDtlsTransport(n);return i.ondtlsstatechange=function(){e._updateConnectionState()},i.onerror=function(){Object.defineProperty(i,"state",{value:"failed",writable:!0}),e._updateConnectionState()},{iceTransport:n,dtlsTransport:i}},d.prototype._disposeIceAndDtlsTransports=function(t){var e=this.transceivers[t].iceGatherer;e&&(delete e.onlocalcandidate,delete this.transceivers[t].iceGatherer);var n=this.transceivers[t].iceTransport;n&&(delete n.onicestatechange,delete this.transceivers[t].iceTransport);var i=this.transceivers[t].dtlsTransport;i&&(delete i.ondtlsstatechange,delete i.onerror,delete this.transceivers[t].dtlsTransport)},d.prototype._transceive=function(t,n,i){var o=r(t.localCapabilities,t.remoteCapabilities);n&&t.rtpSender&&(o.encodings=t.sendEncodingParameters,o.rtcp={cname:l.localCName,compound:t.rtcpParameters.compound},t.recvEncodingParameters.length&&(o.rtcp.ssrc=t.recvEncodingParameters[0].ssrc),t.rtpSender.send(o)),i&&t.rtpReceiver&&o.codecs.length>0&&("video"===t.kind&&t.recvEncodingParameters&&e<15019&&t.recvEncodingParameters.forEach((function(t){delete t.rtx})),t.recvEncodingParameters.length?o.encodings=t.recvEncodingParameters:o.encodings=[{}],o.rtcp={compound:t.rtcpParameters.compound},t.rtcpParameters.cname&&(o.rtcp.cname=t.rtcpParameters.cname),t.sendEncodingParameters.length&&(o.rtcp.ssrc=t.sendEncodingParameters[0].ssrc),t.rtpReceiver.receive(o))},d.prototype.setLocalDescription=function(t){var e,n,i=this;if(-1===["offer","answer"].indexOf(t.type))return Promise.reject(s("TypeError",'Unsupported type "'+t.type+'"'));if(!o("setLocalDescription",t.type,i.signalingState)||i._isClosed)return Promise.reject(s("InvalidStateError","Can not set local "+t.type+" in state "+i.signalingState));if("offer"===t.type)e=l.splitSections(t.sdp),n=e.shift(),e.forEach((function(t,e){var n=l.parseRtpParameters(t);i.transceivers[e].localCapabilities=n})),i.transceivers.forEach((function(t,e){i._gather(t.mid,e)}));else if("answer"===t.type){e=l.splitSections(i._remoteDescription.sdp),n=e.shift();var a=l.matchPrefix(n,"a=ice-lite").length>0;e.forEach((function(t,e){var o=i.transceivers[e],s=o.iceGatherer,c=o.iceTransport,u=o.dtlsTransport,d=o.localCapabilities,h=o.remoteCapabilities;if(!(l.isRejected(t)&&0===l.matchPrefix(t,"a=bundle-only").length||o.rejected)){var f=l.getIceParameters(t,n),p=l.getDtlsParameters(t,n);a&&(p.role="server"),i.usingBundle&&0!==e||(i._gather(o.mid,e),"new"===c.state&&c.start(s,f,a?"controlling":"controlled"),"new"===u.state&&u.start(p));var m=r(d,h);i._transceive(o,m.codecs.length>0,!1)}}))}return i._localDescription={type:t.type,sdp:t.sdp},"offer"===t.type?i._updateSignalingState("have-local-offer"):i._updateSignalingState("stable"),Promise.resolve()},d.prototype.setRemoteDescription=function(i){var d=this;if(-1===["offer","answer"].indexOf(i.type))return Promise.reject(s("TypeError",'Unsupported type "'+i.type+'"'));if(!o("setRemoteDescription",i.type,d.signalingState)||d._isClosed)return Promise.reject(s("InvalidStateError","Can not set remote "+i.type+" in state "+d.signalingState));var h={};d.remoteStreams.forEach((function(t){h[t.id]=t}));var f=[],p=l.splitSections(i.sdp),m=p.shift(),v=l.matchPrefix(m,"a=ice-lite").length>0,g=l.matchPrefix(m,"a=group:BUNDLE ").length>0;d.usingBundle=g;var y=l.matchPrefix(m,"a=ice-options:")[0];return d.canTrickleIceCandidates=!!y&&y.substr(14).split(" ").indexOf("trickle")>=0,p.forEach((function(o,s){var u=l.splitLines(o),p=l.getKind(o),y=l.isRejected(o)&&0===l.matchPrefix(o,"a=bundle-only").length,_=u[0].substr(2).split(" ")[2],b=l.getDirection(o,m),w=l.parseMsid(o),k=l.getMid(o)||l.generateIdentifier();if(y||"application"===p&&("DTLS/SCTP"===_||"UDP/DTLS/SCTP"===_))d.transceivers[s]={mid:k,kind:p,protocol:_,rejected:!0};else{!y&&d.transceivers[s]&&d.transceivers[s].rejected&&(d.transceivers[s]=d._createTransceiver(p,!0));var x,C,S,M,T,P,O,B,E,A,D,L=l.parseRtpParameters(o);y||(A=l.getIceParameters(o,m),(D=l.getDtlsParameters(o,m)).role="client"),O=l.parseRtpEncodingParameters(o);var q=l.parseRtcpParameters(o),R=l.matchPrefix(o,"a=end-of-candidates",m).length>0,I=l.matchPrefix(o,"a=candidate:").map((function(t){return l.parseCandidate(t)})).filter((function(t){return 1===t.component}));if(("offer"===i.type||"answer"===i.type)&&!y&&g&&s>0&&d.transceivers[s]&&(d._disposeIceAndDtlsTransports(s),d.transceivers[s].iceGatherer=d.transceivers[0].iceGatherer,d.transceivers[s].iceTransport=d.transceivers[0].iceTransport,d.transceivers[s].dtlsTransport=d.transceivers[0].dtlsTransport,d.transceivers[s].rtpSender&&d.transceivers[s].rtpSender.setTransport(d.transceivers[0].dtlsTransport),d.transceivers[s].rtpReceiver&&d.transceivers[s].rtpReceiver.setTransport(d.transceivers[0].dtlsTransport)),"offer"!==i.type||y){if("answer"===i.type&&!y){C=(x=d.transceivers[s]).iceGatherer,S=x.iceTransport,M=x.dtlsTransport,T=x.rtpReceiver,P=x.sendEncodingParameters,B=x.localCapabilities,d.transceivers[s].recvEncodingParameters=O,d.transceivers[s].remoteCapabilities=L,d.transceivers[s].rtcpParameters=q,I.length&&"new"===S.state&&(!v&&!R||g&&0!==s?I.forEach((function(t){a(x.iceTransport,t)})):S.setRemoteCandidates(I)),g&&0!==s||("new"===S.state&&S.start(C,A,"controlling"),"new"===M.state&&M.start(D));var N=r(x.localCapabilities,x.remoteCapabilities).codecs.filter((function(t){return"rtx"===t.name.toLowerCase()})).length;!N&&x.sendEncodingParameters[0].rtx&&delete x.sendEncodingParameters[0].rtx,d._transceive(x,"sendrecv"===b||"recvonly"===b,"sendrecv"===b||"sendonly"===b),!T||"sendrecv"!==b&&"sendonly"!==b?delete x.rtpReceiver:(E=T.track,w?(h[w.stream]||(h[w.stream]=new t.MediaStream),n(E,h[w.stream]),f.push([E,T,h[w.stream]])):(h.default||(h.default=new t.MediaStream),n(E,h.default),f.push([E,T,h.default])))}}else{(x=d.transceivers[s]||d._createTransceiver(p)).mid=k,x.iceGatherer||(x.iceGatherer=d._createIceGatherer(s,g)),I.length&&"new"===x.iceTransport.state&&(!R||g&&0!==s?I.forEach((function(t){a(x.iceTransport,t)})):x.iceTransport.setRemoteCandidates(I)),B=t.RTCRtpReceiver.getCapabilities(p),e<15019&&(B.codecs=B.codecs.filter((function(t){return"rtx"!==t.name}))),P=x.sendEncodingParameters||[{ssrc:1001*(2*s+2)}];var F,$=!1;if("sendrecv"===b||"sendonly"===b){if($=!x.rtpReceiver,T=x.rtpReceiver||new t.RTCRtpReceiver(x.dtlsTransport,p),$)E=T.track,w&&"-"===w.stream||(w?(h[w.stream]||(h[w.stream]=new t.MediaStream,Object.defineProperty(h[w.stream],"id",{get:function(){return w.stream}})),Object.defineProperty(E,"id",{get:function(){return w.track}}),F=h[w.stream]):(h.default||(h.default=new t.MediaStream),F=h.default)),F&&(n(E,F),x.associatedRemoteMediaStreams.push(F)),f.push([E,T,F])}else x.rtpReceiver&&x.rtpReceiver.track&&(x.associatedRemoteMediaStreams.forEach((function(t){var e=t.getTracks().find((function(t){return t.id===x.rtpReceiver.track.id}));e&&c(e,t)})),x.associatedRemoteMediaStreams=[]);x.localCapabilities=B,x.remoteCapabilities=L,x.rtpReceiver=T,x.rtcpParameters=q,x.sendEncodingParameters=P,x.recvEncodingParameters=O,d._transceive(d.transceivers[s],!1,$)}}})),void 0===d._dtlsRole&&(d._dtlsRole="offer"===i.type?"active":"passive"),d._remoteDescription={type:i.type,sdp:i.sdp},"offer"===i.type?d._updateSignalingState("have-remote-offer"):d._updateSignalingState("stable"),Object.keys(h).forEach((function(e){var n=h[e];if(n.getTracks().length){if(-1===d.remoteStreams.indexOf(n)){d.remoteStreams.push(n);var i=new Event("addstream");i.stream=n,t.setTimeout((function(){d._dispatchEvent("addstream",i)}))}f.forEach((function(t){var e=t[0],i=t[1];n.id===t[2].id&&u(d,e,i,[n])}))}})),f.forEach((function(t){t[2]||u(d,t[0],t[1],[])})),t.setTimeout((function(){d&&d.transceivers&&d.transceivers.forEach((function(t){t.iceTransport&&"new"===t.iceTransport.state&&t.iceTransport.getRemoteCandidates().length>0&&(console.warn("Timeout for addRemoteCandidate. Consider sending an end-of-candidates notification"),t.iceTransport.addRemoteCandidate({}))}))}),4e3),Promise.resolve()},d.prototype.close=function(){this.transceivers.forEach((function(t){t.iceTransport&&t.iceTransport.stop(),t.dtlsTransport&&t.dtlsTransport.stop(),t.rtpSender&&t.rtpSender.stop(),t.rtpReceiver&&t.rtpReceiver.stop()})),this._isClosed=!0,this._updateSignalingState("closed")},d.prototype._updateSignalingState=function(t){this.signalingState=t;var e=new Event("signalingstatechange");this._dispatchEvent("signalingstatechange",e)},d.prototype._maybeFireNegotiationNeeded=function(){var e=this;"stable"===this.signalingState&&!0!==this.needNegotiation&&(this.needNegotiation=!0,t.setTimeout((function(){if(e.needNegotiation){e.needNegotiation=!1;var t=new Event("negotiationneeded");e._dispatchEvent("negotiationneeded",t)}}),0))},d.prototype._updateIceConnectionState=function(){var t,e={new:0,closed:0,checking:0,connected:0,completed:0,disconnected:0,failed:0};if(this.transceivers.forEach((function(t){t.iceTransport&&!t.rejected&&e[t.iceTransport.state]++})),t="new",e.failed>0?t="failed":e.checking>0?t="checking":e.disconnected>0?t="disconnected":e.new>0?t="new":e.connected>0?t="connected":e.completed>0&&(t="completed"),t!==this.iceConnectionState){this.iceConnectionState=t;var n=new Event("iceconnectionstatechange");this._dispatchEvent("iceconnectionstatechange",n)}},d.prototype._updateConnectionState=function(){var t,e={new:0,closed:0,connecting:0,connected:0,completed:0,disconnected:0,failed:0};if(this.transceivers.forEach((function(t){t.iceTransport&&t.dtlsTransport&&!t.rejected&&(e[t.iceTransport.state]++,e[t.dtlsTransport.state]++)})),e.connected+=e.completed,t="new",e.failed>0?t="failed":e.connecting>0?t="connecting":e.disconnected>0?t="disconnected":e.new>0?t="new":e.connected>0&&(t="connected"),t!==this.connectionState){this.connectionState=t;var n=new Event("connectionstatechange");this._dispatchEvent("connectionstatechange",n)}},d.prototype.createOffer=function(){var n=this;if(n._isClosed)return Promise.reject(s("InvalidStateError","Can not call createOffer after close"));var r=n.transceivers.filter((function(t){return"audio"===t.kind})).length,o=n.transceivers.filter((function(t){return"video"===t.kind})).length,a=arguments[0];if(a){if(a.mandatory||a.optional)throw new TypeError("Legacy mandatory/optional constraints not supported.");void 0!==a.offerToReceiveAudio&&(r=!0===a.offerToReceiveAudio?1:!1===a.offerToReceiveAudio?0:a.offerToReceiveAudio),void 0!==a.offerToReceiveVideo&&(o=!0===a.offerToReceiveVideo?1:!1===a.offerToReceiveVideo?0:a.offerToReceiveVideo)}for(n.transceivers.forEach((function(t){"audio"===t.kind?--r<0&&(t.wantReceive=!1):"video"===t.kind&&--o<0&&(t.wantReceive=!1)}));r>0||o>0;)r>0&&(n._createTransceiver("audio"),r--),o>0&&(n._createTransceiver("video"),o--);var c=l.writeSessionBoilerplate(n._sdpSessionId,n._sdpSessionVersion++);n.transceivers.forEach((function(i,r){var o=i.track,a=i.kind,s=i.mid||l.generateIdentifier();i.mid=s,i.iceGatherer||(i.iceGatherer=n._createIceGatherer(r,n.usingBundle));var c=t.RTCRtpSender.getCapabilities(a);e<15019&&(c.codecs=c.codecs.filter((function(t){return"rtx"!==t.name}))),c.codecs.forEach((function(t){"H264"===t.name&&void 0===t.parameters["level-asymmetry-allowed"]&&(t.parameters["level-asymmetry-allowed"]="1"),i.remoteCapabilities&&i.remoteCapabilities.codecs&&i.remoteCapabilities.codecs.forEach((function(e){t.name.toLowerCase()===e.name.toLowerCase()&&t.clockRate===e.clockRate&&(t.preferredPayloadType=e.payloadType)}))})),c.headerExtensions.forEach((function(t){(i.remoteCapabilities&&i.remoteCapabilities.headerExtensions||[]).forEach((function(e){t.uri===e.uri&&(t.id=e.id)}))}));var u=i.sendEncodingParameters||[{ssrc:1001*(2*r+1)}];o&&e>=15019&&"video"===a&&!u[0].rtx&&(u[0].rtx={ssrc:u[0].ssrc+1}),i.wantReceive&&(i.rtpReceiver=new t.RTCRtpReceiver(i.dtlsTransport,a)),i.localCapabilities=c,i.sendEncodingParameters=u})),"max-compat"!==n._config.bundlePolicy&&(c+="a=group:BUNDLE "+n.transceivers.map((function(t){return t.mid})).join(" ")+"\r\n"),c+="a=ice-options:trickle\r\n",n.transceivers.forEach((function(t,e){c+=i(t,t.localCapabilities,"offer",t.stream,n._dtlsRole),c+="a=rtcp-rsize\r\n",!t.iceGatherer||"new"===n.iceGatheringState||0!==e&&n.usingBundle||(t.iceGatherer.getLocalCandidates().forEach((function(t){t.component=1,c+="a="+l.writeCandidate(t)+"\r\n"})),"completed"===t.iceGatherer.state&&(c+="a=end-of-candidates\r\n"))}));var u=new t.RTCSessionDescription({type:"offer",sdp:c});return Promise.resolve(u)},d.prototype.createAnswer=function(){var n=this;if(n._isClosed)return Promise.reject(s("InvalidStateError","Can not call createAnswer after close"));if("have-remote-offer"!==n.signalingState&&"have-local-pranswer"!==n.signalingState)return Promise.reject(s("InvalidStateError","Can not call createAnswer in signalingState "+n.signalingState));var o=l.writeSessionBoilerplate(n._sdpSessionId,n._sdpSessionVersion++);n.usingBundle&&(o+="a=group:BUNDLE "+n.transceivers.map((function(t){return t.mid})).join(" ")+"\r\n"),o+="a=ice-options:trickle\r\n";var a=l.getMediaSections(n._remoteDescription.sdp).length;n.transceivers.forEach((function(t,s){if(!(s+1>a)){if(t.rejected)return"application"===t.kind?"DTLS/SCTP"===t.protocol?o+="m=application 0 DTLS/SCTP 5000\r\n":o+="m=application 0 "+t.protocol+" webrtc-datachannel\r\n":"audio"===t.kind?o+="m=audio 0 UDP/TLS/RTP/SAVPF 0\r\na=rtpmap:0 PCMU/8000\r\n":"video"===t.kind&&(o+="m=video 0 UDP/TLS/RTP/SAVPF 120\r\na=rtpmap:120 VP8/90000\r\n"),void(o+="c=IN IP4 0.0.0.0\r\na=inactive\r\na=mid:"+t.mid+"\r\n");var l;if(t.stream)"audio"===t.kind?l=t.stream.getAudioTracks()[0]:"video"===t.kind&&(l=t.stream.getVideoTracks()[0]),l&&e>=15019&&"video"===t.kind&&!t.sendEncodingParameters[0].rtx&&(t.sendEncodingParameters[0].rtx={ssrc:t.sendEncodingParameters[0].ssrc+1});var c=r(t.localCapabilities,t.remoteCapabilities);!c.codecs.filter((function(t){return"rtx"===t.name.toLowerCase()})).length&&t.sendEncodingParameters[0].rtx&&delete t.sendEncodingParameters[0].rtx,o+=i(t,c,"answer",t.stream,n._dtlsRole),t.rtcpParameters&&t.rtcpParameters.reducedSize&&(o+="a=rtcp-rsize\r\n")}}));var c=new t.RTCSessionDescription({type:"answer",sdp:o});return Promise.resolve(c)},d.prototype.addIceCandidate=function(t){var e,n=this;return t&&void 0===t.sdpMLineIndex&&!t.sdpMid?Promise.reject(new TypeError("sdpMLineIndex or sdpMid required")):new Promise((function(i,r){if(!n._remoteDescription)return r(s("InvalidStateError","Can not add ICE candidate without a remote description"));if(t&&""!==t.candidate){var o=t.sdpMLineIndex;if(t.sdpMid)for(var c=0;c<n.transceivers.length;c++)if(n.transceivers[c].mid===t.sdpMid){o=c;break}var u=n.transceivers[o];if(!u)return r(s("OperationError","Can not add ICE candidate"));if(u.rejected)return i();var d=Object.keys(t.candidate).length>0?l.parseCandidate(t.candidate):{};if("tcp"===d.protocol&&(0===d.port||9===d.port))return i();if(d.component&&1!==d.component)return i();if((0===o||o>0&&u.iceTransport!==n.transceivers[0].iceTransport)&&!a(u.iceTransport,d))return r(s("OperationError","Can not add ICE candidate"));var h=t.candidate.trim();0===h.indexOf("a=")&&(h=h.substr(2)),(e=l.getMediaSections(n._remoteDescription.sdp))[o]+="a="+(d.type?h:"end-of-candidates")+"\r\n",n._remoteDescription.sdp=l.getDescription(n._remoteDescription.sdp)+e.join("")}else for(var f=0;f<n.transceivers.length&&(n.transceivers[f].rejected||(n.transceivers[f].iceTransport.addRemoteCandidate({}),(e=l.getMediaSections(n._remoteDescription.sdp))[f]+="a=end-of-candidates\r\n",n._remoteDescription.sdp=l.getDescription(n._remoteDescription.sdp)+e.join(""),!n.usingBundle));f++);i()}))},d.prototype.getStats=function(e){if(e&&e instanceof t.MediaStreamTrack){var n=null;if(this.transceivers.forEach((function(t){t.rtpSender&&t.rtpSender.track===e?n=t.rtpSender:t.rtpReceiver&&t.rtpReceiver.track===e&&(n=t.rtpReceiver)})),!n)throw s("InvalidAccessError","Invalid selector.");return n.getStats()}var i=[];return this.transceivers.forEach((function(t){["rtpSender","rtpReceiver","iceGatherer","iceTransport","dtlsTransport"].forEach((function(e){t[e]&&i.push(t[e].getStats())}))})),Promise.all(i).then((function(t){var e=new Map;return t.forEach((function(t){t.forEach((function(t){e.set(t.id,t)}))})),e}))},["RTCRtpSender","RTCRtpReceiver","RTCIceGatherer","RTCIceTransport","RTCDtlsTransport"].forEach((function(e){var n=t[e];if(n&&n.prototype&&n.prototype.getStats){var i=n.prototype.getStats;n.prototype.getStats=function(){return i.apply(this).then((function(t){var e=new Map;return Object.keys(t).forEach((function(n){t[n].type=function(t){return{inboundrtp:"inbound-rtp",outboundrtp:"outbound-rtp",candidatepair:"candidate-pair",localcandidate:"local-candidate",remotecandidate:"remote-candidate"}[t.type]||t.type}(t[n]),e.set(n,t[n])})),e}))}}}));var h=["createOffer","createAnswer"];return h.forEach((function(t){var e=d.prototype[t];d.prototype[t]=function(){var t=arguments;return"function"==typeof t[0]||"function"==typeof t[1]?e.apply(this,[arguments[2]]).then((function(e){"function"==typeof t[0]&&t[0].apply(null,[e])}),(function(e){"function"==typeof t[1]&&t[1].apply(null,[e])})):e.apply(this,arguments)}})),(h=["setLocalDescription","setRemoteDescription","addIceCandidate"]).forEach((function(t){var e=d.prototype[t];d.prototype[t]=function(){var t=arguments;return"function"==typeof t[1]||"function"==typeof t[2]?e.apply(this,arguments).then((function(){"function"==typeof t[1]&&t[1].apply(null)}),(function(e){"function"==typeof t[2]&&t[2].apply(null,[e])})):e.apply(this,arguments)}})),["getStats"].forEach((function(t){var e=d.prototype[t];d.prototype[t]=function(){var t=arguments;return"function"==typeof t[1]?e.apply(this,arguments).then((function(){"function"==typeof t[1]&&t[1].apply(null)})):e.apply(this,arguments)}})),d}},function(t,e,n){"use strict";var i={generateIdentifier:function(){return Math.random().toString(36).substr(2,10)}};i.localCName=i.generateIdentifier(),i.splitLines=function(t){return t.trim().split("\n").map((function(t){return t.trim()}))},i.splitSections=function(t){return t.split("\nm=").map((function(t,e){return(e>0?"m="+t:t).trim()+"\r\n"}))},i.getDescription=function(t){var e=i.splitSections(t);return e&&e[0]},i.getMediaSections=function(t){var e=i.splitSections(t);return e.shift(),e},i.matchPrefix=function(t,e){return i.splitLines(t).filter((function(t){return 0===t.indexOf(e)}))},i.parseCandidate=function(t){for(var e,n={foundation:(e=0===t.indexOf("a=candidate:")?t.substring(12).split(" "):t.substring(10).split(" "))[0],component:parseInt(e[1],10),protocol:e[2].toLowerCase(),priority:parseInt(e[3],10),ip:e[4],port:parseInt(e[5],10),type:e[7]},i=8;i<e.length;i+=2)switch(e[i]){case"raddr":n.relatedAddress=e[i+1];break;case"rport":n.relatedPort=parseInt(e[i+1],10);break;case"tcptype":n.tcpType=e[i+1];break;case"ufrag":n.ufrag=e[i+1],n.usernameFragment=e[i+1];break;default:n[e[i]]=e[i+1]}return n},i.writeCandidate=function(t){var e=[];e.push(t.foundation),e.push(t.component),e.push(t.protocol.toUpperCase()),e.push(t.priority),e.push(t.ip),e.push(t.port);var n=t.type;return e.push("typ"),e.push(n),"host"!==n&&t.relatedAddress&&t.relatedPort&&(e.push("raddr"),e.push(t.relatedAddress),e.push("rport"),e.push(t.relatedPort)),t.tcpType&&"tcp"===t.protocol.toLowerCase()&&(e.push("tcptype"),e.push(t.tcpType)),(t.usernameFragment||t.ufrag)&&(e.push("ufrag"),e.push(t.usernameFragment||t.ufrag)),"candidate:"+e.join(" ")},i.parseIceOptions=function(t){return t.substr(14).split(" ")},i.parseRtpMap=function(t){var e=t.substr(9).split(" "),n={payloadType:parseInt(e.shift(),10)};return e=e[0].split("/"),n.name=e[0],n.clockRate=parseInt(e[1],10),n.channels=3===e.length?parseInt(e[2],10):1,n.numChannels=n.channels,n},i.writeRtpMap=function(t){var e=t.payloadType;void 0!==t.preferredPayloadType&&(e=t.preferredPayloadType);var n=t.channels||t.numChannels||1;return"a=rtpmap:"+e+" "+t.name+"/"+t.clockRate+(1!==n?"/"+n:"")+"\r\n"},i.parseExtmap=function(t){var e=t.substr(9).split(" ");return{id:parseInt(e[0],10),direction:e[0].indexOf("/")>0?e[0].split("/")[1]:"sendrecv",uri:e[1]}},i.writeExtmap=function(t){return"a=extmap:"+(t.id||t.preferredId)+(t.direction&&"sendrecv"!==t.direction?"/"+t.direction:"")+" "+t.uri+"\r\n"},i.parseFmtp=function(t){for(var e,n={},i=t.substr(t.indexOf(" ")+1).split(";"),r=0;r<i.length;r++)n[(e=i[r].trim().split("="))[0].trim()]=e[1];return n},i.writeFmtp=function(t){var e="",n=t.payloadType;if(void 0!==t.preferredPayloadType&&(n=t.preferredPayloadType),t.parameters&&Object.keys(t.parameters).length){var i=[];Object.keys(t.parameters).forEach((function(e){t.parameters[e]?i.push(e+"="+t.parameters[e]):i.push(e)})),e+="a=fmtp:"+n+" "+i.join(";")+"\r\n"}return e},i.parseRtcpFb=function(t){var e=t.substr(t.indexOf(" ")+1).split(" ");return{type:e.shift(),parameter:e.join(" ")}},i.writeRtcpFb=function(t){var e="",n=t.payloadType;return void 0!==t.preferredPayloadType&&(n=t.preferredPayloadType),t.rtcpFeedback&&t.rtcpFeedback.length&&t.rtcpFeedback.forEach((function(t){e+="a=rtcp-fb:"+n+" "+t.type+(t.parameter&&t.parameter.length?" "+t.parameter:"")+"\r\n"})),e},i.parseSsrcMedia=function(t){var e=t.indexOf(" "),n={ssrc:parseInt(t.substr(7,e-7),10)},i=t.indexOf(":",e);return i>-1?(n.attribute=t.substr(e+1,i-e-1),n.value=t.substr(i+1)):n.attribute=t.substr(e+1),n},i.getMid=function(t){var e=i.matchPrefix(t,"a=mid:")[0];if(e)return e.substr(6)},i.parseFingerprint=function(t){var e=t.substr(14).split(" ");return{algorithm:e[0].toLowerCase(),value:e[1]}},i.getDtlsParameters=function(t,e){return{role:"auto",fingerprints:i.matchPrefix(t+e,"a=fingerprint:").map(i.parseFingerprint)}},i.writeDtlsParameters=function(t,e){var n="a=setup:"+e+"\r\n";return t.fingerprints.forEach((function(t){n+="a=fingerprint:"+t.algorithm+" "+t.value+"\r\n"})),n},i.getIceParameters=function(t,e){var n=i.splitLines(t);return{usernameFragment:(n=n.concat(i.splitLines(e))).filter((function(t){return 0===t.indexOf("a=ice-ufrag:")}))[0].substr(12),password:n.filter((function(t){return 0===t.indexOf("a=ice-pwd:")}))[0].substr(10)}},i.writeIceParameters=function(t){return"a=ice-ufrag:"+t.usernameFragment+"\r\na=ice-pwd:"+t.password+"\r\n"},i.parseRtpParameters=function(t){for(var e={codecs:[],headerExtensions:[],fecMechanisms:[],rtcp:[]},n=i.splitLines(t)[0].split(" "),r=3;r<n.length;r++){var o=n[r],a=i.matchPrefix(t,"a=rtpmap:"+o+" ")[0];if(a){var s=i.parseRtpMap(a),l=i.matchPrefix(t,"a=fmtp:"+o+" ");switch(s.parameters=l.length?i.parseFmtp(l[0]):{},s.rtcpFeedback=i.matchPrefix(t,"a=rtcp-fb:"+o+" ").map(i.parseRtcpFb),e.codecs.push(s),s.name.toUpperCase()){case"RED":case"ULPFEC":e.fecMechanisms.push(s.name.toUpperCase())}}}return i.matchPrefix(t,"a=extmap:").forEach((function(t){e.headerExtensions.push(i.parseExtmap(t))})),e},i.writeRtpDescription=function(t,e){var n="";n+="m="+t+" ",n+=e.codecs.length>0?"9":"0",n+=" UDP/TLS/RTP/SAVPF ",n+=e.codecs.map((function(t){return void 0!==t.preferredPayloadType?t.preferredPayloadType:t.payloadType})).join(" ")+"\r\n",n+="c=IN IP4 0.0.0.0\r\n",n+="a=rtcp:9 IN IP4 0.0.0.0\r\n",e.codecs.forEach((function(t){n+=i.writeRtpMap(t),n+=i.writeFmtp(t),n+=i.writeRtcpFb(t)}));var r=0;return e.codecs.forEach((function(t){t.maxptime>r&&(r=t.maxptime)})),r>0&&(n+="a=maxptime:"+r+"\r\n"),n+="a=rtcp-mux\r\n",e.headerExtensions&&e.headerExtensions.forEach((function(t){n+=i.writeExtmap(t)})),n},i.parseRtpEncodingParameters=function(t){var e,n=[],r=i.parseRtpParameters(t),o=-1!==r.fecMechanisms.indexOf("RED"),a=-1!==r.fecMechanisms.indexOf("ULPFEC"),s=i.matchPrefix(t,"a=ssrc:").map((function(t){return i.parseSsrcMedia(t)})).filter((function(t){return"cname"===t.attribute})),l=s.length>0&&s[0].ssrc,c=i.matchPrefix(t,"a=ssrc-group:FID").map((function(t){return t.substr(17).split(" ").map((function(t){return parseInt(t,10)}))}));c.length>0&&c[0].length>1&&c[0][0]===l&&(e=c[0][1]),r.codecs.forEach((function(t){if("RTX"===t.name.toUpperCase()&&t.parameters.apt){var i={ssrc:l,codecPayloadType:parseInt(t.parameters.apt,10)};l&&e&&(i.rtx={ssrc:e}),n.push(i),o&&((i=JSON.parse(JSON.stringify(i))).fec={ssrc:e,mechanism:a?"red+ulpfec":"red"},n.push(i))}})),0===n.length&&l&&n.push({ssrc:l});var u=i.matchPrefix(t,"b=");return u.length&&(u=0===u[0].indexOf("b=TIAS:")?parseInt(u[0].substr(7),10):0===u[0].indexOf("b=AS:")?1e3*parseInt(u[0].substr(5),10)*.95-16e3:void 0,n.forEach((function(t){t.maxBitrate=u}))),n},i.parseRtcpParameters=function(t){var e={},n=i.matchPrefix(t,"a=ssrc:").map((function(t){return i.parseSsrcMedia(t)})).filter((function(t){return"cname"===t.attribute}))[0];n&&(e.cname=n.value,e.ssrc=n.ssrc);var r=i.matchPrefix(t,"a=rtcp-rsize");e.reducedSize=r.length>0,e.compound=0===r.length;var o=i.matchPrefix(t,"a=rtcp-mux");return e.mux=o.length>0,e},i.parseMsid=function(t){var e,n=i.matchPrefix(t,"a=msid:");if(1===n.length)return{stream:(e=n[0].substr(7).split(" "))[0],track:e[1]};var r=i.matchPrefix(t,"a=ssrc:").map((function(t){return i.parseSsrcMedia(t)})).filter((function(t){return"msid"===t.attribute}));return r.length>0?{stream:(e=r[0].value.split(" "))[0],track:e[1]}:void 0},i.generateSessionId=function(){return Math.random().toString().substr(2,21)},i.writeSessionBoilerplate=function(t,e){var n=void 0!==e?e:2;return"v=0\r\no=thisisadapterortc "+(t||i.generateSessionId())+" "+n+" IN IP4 127.0.0.1\r\ns=-\r\nt=0 0\r\n"},i.writeMediaSection=function(t,e,n,r){var o=i.writeRtpDescription(t.kind,e);if(o+=i.writeIceParameters(t.iceGatherer.getLocalParameters()),o+=i.writeDtlsParameters(t.dtlsTransport.getLocalParameters(),"offer"===n?"actpass":"active"),o+="a=mid:"+t.mid+"\r\n",t.direction?o+="a="+t.direction+"\r\n":t.rtpSender&&t.rtpReceiver?o+="a=sendrecv\r\n":t.rtpSender?o+="a=sendonly\r\n":t.rtpReceiver?o+="a=recvonly\r\n":o+="a=inactive\r\n",t.rtpSender){var a="msid:"+r.id+" "+t.rtpSender.track.id+"\r\n";o+="a="+a,o+="a=ssrc:"+t.sendEncodingParameters[0].ssrc+" "+a,t.sendEncodingParameters[0].rtx&&(o+="a=ssrc:"+t.sendEncodingParameters[0].rtx.ssrc+" "+a,o+="a=ssrc-group:FID "+t.sendEncodingParameters[0].ssrc+" "+t.sendEncodingParameters[0].rtx.ssrc+"\r\n")}return o+="a=ssrc:"+t.sendEncodingParameters[0].ssrc+" cname:"+i.localCName+"\r\n",t.rtpSender&&t.sendEncodingParameters[0].rtx&&(o+="a=ssrc:"+t.sendEncodingParameters[0].rtx.ssrc+" cname:"+i.localCName+"\r\n"),o},i.getDirection=function(t,e){for(var n=i.splitLines(t),r=0;r<n.length;r++)switch(n[r]){case"a=sendrecv":case"a=sendonly":case"a=recvonly":case"a=inactive":return n[r].substr(2)}return e?i.getDirection(e):"sendrecv"},i.getKind=function(t){return i.splitLines(t)[0].split(" ")[0].substr(2)},i.isRejected=function(t){return"0"===t.split(" ",2)[1]},i.parseMLine=function(t){var e=i.splitLines(t)[0].substr(2).split(" ");return{kind:e[0],port:parseInt(e[1],10),protocol:e[2],fmt:e.slice(3).join(" ")}},i.parseOLine=function(t){var e=i.matchPrefix(t,"o=")[0].substr(2).split(" ");return{username:e[0],sessionId:e[1],sessionVersion:parseInt(e[2],10),netType:e[3],addressType:e[4],address:e[5]}},t.exports=i},function(t,e,n){"use strict";t.exports=function(t){var e=t&&t.navigator,n=e.mediaDevices.getUserMedia.bind(e.mediaDevices);e.mediaDevices.getUserMedia=function(t){return n(t).catch((function(t){return Promise.reject(function(t){return{name:{PermissionDeniedError:"NotAllowedError"}[t.name]||t.name,message:t.message,constraint:t.constraint,toString:function(){return this.name}}}(t))}))}}},function(t,e,n){"use strict";var i=n(6);t.exports={shimGetUserMedia:n(119),shimOnTrack:function(t){"object"!=typeof t||!t.RTCPeerConnection||"ontrack"in t.RTCPeerConnection.prototype||Object.defineProperty(t.RTCPeerConnection.prototype,"ontrack",{get:function(){return this._ontrack},set:function(t){this._ontrack&&(this.removeEventListener("track",this._ontrack),this.removeEventListener("addstream",this._ontrackpoly)),this.addEventListener("track",this._ontrack=t),this.addEventListener("addstream",this._ontrackpoly=function(t){t.stream.getTracks().forEach(function(e){var n=new Event("track");n.track=e,n.receiver={track:e},n.transceiver={receiver:n.receiver},n.streams=[t.stream],this.dispatchEvent(n)}.bind(this))}.bind(this))},enumerable:!0,configurable:!0}),"object"==typeof t&&t.RTCTrackEvent&&"receiver"in t.RTCTrackEvent.prototype&&!("transceiver"in t.RTCTrackEvent.prototype)&&Object.defineProperty(t.RTCTrackEvent.prototype,"transceiver",{get:function(){return{receiver:this.receiver}}})},shimSourceObject:function(t){"object"==typeof t&&(!t.HTMLMediaElement||"srcObject"in t.HTMLMediaElement.prototype||Object.defineProperty(t.HTMLMediaElement.prototype,"srcObject",{get:function(){return this.mozSrcObject},set:function(t){this.mozSrcObject=t}}))},shimPeerConnection:function(t){var e=i.detectBrowser(t);if("object"==typeof t&&(t.RTCPeerConnection||t.mozRTCPeerConnection)){t.RTCPeerConnection||(t.RTCPeerConnection=function(n,i){if(e.version<38&&n&&n.iceServers){for(var r=[],o=0;o<n.iceServers.length;o++){var a=n.iceServers[o];if(a.hasOwnProperty("urls"))for(var s=0;s<a.urls.length;s++){var l={url:a.urls[s]};0===a.urls[s].indexOf("turn")&&(l.username=a.username,l.credential=a.credential),r.push(l)}else r.push(n.iceServers[o])}n.iceServers=r}return new t.mozRTCPeerConnection(n,i)},t.RTCPeerConnection.prototype=t.mozRTCPeerConnection.prototype,t.mozRTCPeerConnection.generateCertificate&&Object.defineProperty(t.RTCPeerConnection,"generateCertificate",{get:function(){return t.mozRTCPeerConnection.generateCertificate}}),t.RTCSessionDescription=t.mozRTCSessionDescription,t.RTCIceCandidate=t.mozRTCIceCandidate),["setLocalDescription","setRemoteDescription","addIceCandidate"].forEach((function(e){var n=t.RTCPeerConnection.prototype[e];t.RTCPeerConnection.prototype[e]=function(){return arguments[0]=new("addIceCandidate"===e?t.RTCIceCandidate:t.RTCSessionDescription)(arguments[0]),n.apply(this,arguments)}}));var n=t.RTCPeerConnection.prototype.addIceCandidate;t.RTCPeerConnection.prototype.addIceCandidate=function(){return arguments[0]?n.apply(this,arguments):(arguments[1]&&arguments[1].apply(null),Promise.resolve())};var r={inboundrtp:"inbound-rtp",outboundrtp:"outbound-rtp",candidatepair:"candidate-pair",localcandidate:"local-candidate",remotecandidate:"remote-candidate"},o=t.RTCPeerConnection.prototype.getStats;t.RTCPeerConnection.prototype.getStats=function(t,n,i){return o.apply(this,[t||null]).then((function(t){if(e.version<48&&(t=function(t){var e=new Map;return Object.keys(t).forEach((function(n){e.set(n,t[n]),e[n]=t[n]})),e}(t)),e.version<53&&!n)try{t.forEach((function(t){t.type=r[t.type]||t.type}))}catch(e){if("TypeError"!==e.name)throw e;t.forEach((function(e,n){t.set(n,Object.assign({},e,{type:r[e.type]||e.type}))}))}return t})).then(n,i)}}},shimSenderGetStats:function(t){if("object"==typeof t&&t.RTCPeerConnection&&t.RTCRtpSender&&(!t.RTCRtpSender||!("getStats"in t.RTCRtpSender.prototype))){var e=t.RTCPeerConnection.prototype.getSenders;e&&(t.RTCPeerConnection.prototype.getSenders=function(){var t=this,n=e.apply(t,[]);return n.forEach((function(e){e._pc=t})),n});var n=t.RTCPeerConnection.prototype.addTrack;n&&(t.RTCPeerConnection.prototype.addTrack=function(){var t=n.apply(this,arguments);return t._pc=this,t}),t.RTCRtpSender.prototype.getStats=function(){return this.track?this._pc.getStats(this.track):Promise.resolve(new Map)}}},shimReceiverGetStats:function(t){if("object"==typeof t&&t.RTCPeerConnection&&t.RTCRtpSender&&(!t.RTCRtpSender||!("getStats"in t.RTCRtpReceiver.prototype))){var e=t.RTCPeerConnection.prototype.getReceivers;e&&(t.RTCPeerConnection.prototype.getReceivers=function(){var t=this,n=e.apply(t,[]);return n.forEach((function(e){e._pc=t})),n}),i.wrapPeerConnectionEvent(t,"track",(function(t){return t.receiver._pc=t.srcElement,t})),t.RTCRtpReceiver.prototype.getStats=function(){return this._pc.getStats(this.track)}}},shimRemoveStream:function(t){!t.RTCPeerConnection||"removeStream"in t.RTCPeerConnection.prototype||(t.RTCPeerConnection.prototype.removeStream=function(t){var e=this;i.deprecated("removeStream","removeTrack"),this.getSenders().forEach((function(n){n.track&&-1!==t.getTracks().indexOf(n.track)&&e.removeTrack(n)}))})},shimRTCDataChannel:function(t){t.DataChannel&&!t.RTCDataChannel&&(t.RTCDataChannel=t.DataChannel)},shimGetDisplayMedia:function(t,e){!t.navigator||!t.navigator.mediaDevices||"getDisplayMedia"in t.navigator.mediaDevices||(t.navigator.mediaDevices.getDisplayMedia=function(n){if(!n||!n.video){var i=new DOMException("getDisplayMedia without video constraints is undefined");return i.name="NotFoundError",i.code=8,Promise.reject(i)}return!0===n.video?n.video={mediaSource:e}:n.video.mediaSource=e,t.navigator.mediaDevices.getUserMedia(n)},t.navigator.getDisplayMedia=function(e){return i.deprecated("navigator.getDisplayMedia","navigator.mediaDevices.getDisplayMedia"),t.navigator.mediaDevices.getDisplayMedia(e)})}}},function(t,e,n){"use strict";var i=n(6),r=i.log;t.exports=function(t){var e=i.detectBrowser(t),n=t&&t.navigator,o=t&&t.MediaStreamTrack,a=function(t){return{name:{InternalError:"NotReadableError",NotSupportedError:"TypeError",PermissionDeniedError:"NotAllowedError",SecurityError:"NotAllowedError"}[t.name]||t.name,message:{"The operation is insecure.":"The request is not allowed by the user agent or the platform in the current context."}[t.message]||t.message,constraint:t.constraint,toString:function(){return this.name+(this.message&&": ")+this.message}}},s=function(t,i,o){var s=function(t){if("object"!=typeof t||t.require)return t;var e=[];return Object.keys(t).forEach((function(n){if("require"!==n&&"advanced"!==n&&"mediaSource"!==n){var i=t[n]="object"==typeof t[n]?t[n]:{ideal:t[n]};if(void 0===i.min&&void 0===i.max&&void 0===i.exact||e.push(n),void 0!==i.exact&&("number"==typeof i.exact?i.min=i.max=i.exact:t[n]=i.exact,delete i.exact),void 0!==i.ideal){t.advanced=t.advanced||[];var r={};"number"==typeof i.ideal?r[n]={min:i.ideal,max:i.ideal}:r[n]=i.ideal,t.advanced.push(r),delete i.ideal,Object.keys(i).length||delete t[n]}}})),e.length&&(t.require=e),t};return t=JSON.parse(JSON.stringify(t)),e.version<38&&(r("spec: "+JSON.stringify(t)),t.audio&&(t.audio=s(t.audio)),t.video&&(t.video=s(t.video)),r("ff37: "+JSON.stringify(t))),n.mozGetUserMedia(t,i,(function(t){o(a(t))}))};if(n.mediaDevices||(n.mediaDevices={getUserMedia:function(t){return new Promise((function(e,n){s(t,e,n)}))},addEventListener:function(){},removeEventListener:function(){}}),n.mediaDevices.enumerateDevices=n.mediaDevices.enumerateDevices||function(){return new Promise((function(t){t([{kind:"audioinput",deviceId:"default",label:"",groupId:""},{kind:"videoinput",deviceId:"default",label:"",groupId:""}])}))},e.version<41){var l=n.mediaDevices.enumerateDevices.bind(n.mediaDevices);n.mediaDevices.enumerateDevices=function(){return l().then(void 0,(function(t){if("NotFoundError"===t.name)return[];throw t}))}}if(e.version<49){var c=n.mediaDevices.getUserMedia.bind(n.mediaDevices);n.mediaDevices.getUserMedia=function(t){return c(t).then((function(e){if(t.audio&&!e.getAudioTracks().length||t.video&&!e.getVideoTracks().length)throw e.getTracks().forEach((function(t){t.stop()})),new DOMException("The object can not be found here.","NotFoundError");return e}),(function(t){return Promise.reject(a(t))}))}}if(!(e.version>55&&"autoGainControl"in n.mediaDevices.getSupportedConstraints())){var u=function(t,e,n){e in t&&!(n in t)&&(t[n]=t[e],delete t[e])},d=n.mediaDevices.getUserMedia.bind(n.mediaDevices);if(n.mediaDevices.getUserMedia=function(t){return"object"==typeof t&&"object"==typeof t.audio&&(t=JSON.parse(JSON.stringify(t)),u(t.audio,"autoGainControl","mozAutoGainControl"),u(t.audio,"noiseSuppression","mozNoiseSuppression")),d(t)},o&&o.prototype.getSettings){var h=o.prototype.getSettings;o.prototype.getSettings=function(){var t=h.apply(this,arguments);return u(t,"mozAutoGainControl","autoGainControl"),u(t,"mozNoiseSuppression","noiseSuppression"),t}}if(o&&o.prototype.applyConstraints){var f=o.prototype.applyConstraints;o.prototype.applyConstraints=function(t){return"audio"===this.kind&&"object"==typeof t&&(t=JSON.parse(JSON.stringify(t)),u(t,"autoGainControl","mozAutoGainControl"),u(t,"noiseSuppression","mozNoiseSuppression")),f.apply(this,[t])}}}n.getUserMedia=function(t,r,o){if(e.version<44)return s(t,r,o);i.deprecated("navigator.getUserMedia","navigator.mediaDevices.getUserMedia"),n.mediaDevices.getUserMedia(t).then(r,o)}}},function(t,e,n){"use strict";var i=n(6);t.exports={shimLocalStreamsAPI:function(t){if("object"==typeof t&&t.RTCPeerConnection){if("getLocalStreams"in t.RTCPeerConnection.prototype||(t.RTCPeerConnection.prototype.getLocalStreams=function(){return this._localStreams||(this._localStreams=[]),this._localStreams}),"getStreamById"in t.RTCPeerConnection.prototype||(t.RTCPeerConnection.prototype.getStreamById=function(t){var e=null;return this._localStreams&&this._localStreams.forEach((function(n){n.id===t&&(e=n)})),this._remoteStreams&&this._remoteStreams.forEach((function(n){n.id===t&&(e=n)})),e}),!("addStream"in t.RTCPeerConnection.prototype)){var e=t.RTCPeerConnection.prototype.addTrack;t.RTCPeerConnection.prototype.addStream=function(t){this._localStreams||(this._localStreams=[]),-1===this._localStreams.indexOf(t)&&this._localStreams.push(t);var n=this;t.getTracks().forEach((function(i){e.call(n,i,t)}))},t.RTCPeerConnection.prototype.addTrack=function(t,n){return n&&(this._localStreams?-1===this._localStreams.indexOf(n)&&this._localStreams.push(n):this._localStreams=[n]),e.call(this,t,n)}}"removeStream"in t.RTCPeerConnection.prototype||(t.RTCPeerConnection.prototype.removeStream=function(t){this._localStreams||(this._localStreams=[]);var e=this._localStreams.indexOf(t);if(-1!==e){this._localStreams.splice(e,1);var n=this,i=t.getTracks();this.getSenders().forEach((function(t){-1!==i.indexOf(t.track)&&n.removeTrack(t)}))}})}},shimRemoteStreamsAPI:function(t){if("object"==typeof t&&t.RTCPeerConnection&&("getRemoteStreams"in t.RTCPeerConnection.prototype||(t.RTCPeerConnection.prototype.getRemoteStreams=function(){return this._remoteStreams?this._remoteStreams:[]}),!("onaddstream"in t.RTCPeerConnection.prototype))){Object.defineProperty(t.RTCPeerConnection.prototype,"onaddstream",{get:function(){return this._onaddstream},set:function(t){this._onaddstream&&this.removeEventListener("addstream",this._onaddstream),this.addEventListener("addstream",this._onaddstream=t)}});var e=t.RTCPeerConnection.prototype.setRemoteDescription;t.RTCPeerConnection.prototype.setRemoteDescription=function(){var t=this;return this._onaddstreampoly||this.addEventListener("track",this._onaddstreampoly=function(e){e.streams.forEach((function(e){if(t._remoteStreams||(t._remoteStreams=[]),!(t._remoteStreams.indexOf(e)>=0)){t._remoteStreams.push(e);var n=new Event("addstream");n.stream=e,t.dispatchEvent(n)}}))}),e.apply(t,arguments)}}},shimCallbacksAPI:function(t){if("object"==typeof t&&t.RTCPeerConnection){var e=t.RTCPeerConnection.prototype,n=e.createOffer,i=e.createAnswer,r=e.setLocalDescription,o=e.setRemoteDescription,a=e.addIceCandidate;e.createOffer=function(t,e){var i=arguments.length>=2?arguments[2]:arguments[0],r=n.apply(this,[i]);return e?(r.then(t,e),Promise.resolve()):r},e.createAnswer=function(t,e){var n=arguments.length>=2?arguments[2]:arguments[0],r=i.apply(this,[n]);return e?(r.then(t,e),Promise.resolve()):r};var s=function(t,e,n){var i=r.apply(this,[t]);return n?(i.then(e,n),Promise.resolve()):i};e.setLocalDescription=s,s=function(t,e,n){var i=o.apply(this,[t]);return n?(i.then(e,n),Promise.resolve()):i},e.setRemoteDescription=s,s=function(t,e,n){var i=a.apply(this,[t]);return n?(i.then(e,n),Promise.resolve()):i},e.addIceCandidate=s}},shimGetUserMedia:function(t){var e=t&&t.navigator;e.getUserMedia||(e.webkitGetUserMedia?e.getUserMedia=e.webkitGetUserMedia.bind(e):e.mediaDevices&&e.mediaDevices.getUserMedia&&(e.getUserMedia=function(t,n,i){e.mediaDevices.getUserMedia(t).then(n,i)}.bind(e)))},shimRTCIceServerUrls:function(t){var e=t.RTCPeerConnection;t.RTCPeerConnection=function(t,n){if(t&&t.iceServers){for(var r=[],o=0;o<t.iceServers.length;o++){var a=t.iceServers[o];!a.hasOwnProperty("urls")&&a.hasOwnProperty("url")?(i.deprecated("RTCIceServer.url","RTCIceServer.urls"),(a=JSON.parse(JSON.stringify(a))).urls=a.url,delete a.url,r.push(a)):r.push(t.iceServers[o])}t.iceServers=r}return new e(t,n)},t.RTCPeerConnection.prototype=e.prototype,"generateCertificate"in t.RTCPeerConnection&&Object.defineProperty(t.RTCPeerConnection,"generateCertificate",{get:function(){return e.generateCertificate}})},shimTrackEventTransceiver:function(t){"object"==typeof t&&t.RTCPeerConnection&&"receiver"in t.RTCTrackEvent.prototype&&!t.RTCTransceiver&&Object.defineProperty(t.RTCTrackEvent.prototype,"transceiver",{get:function(){return{receiver:this.receiver}}})},shimCreateOfferLegacy:function(t){var e=t.RTCPeerConnection.prototype.createOffer;t.RTCPeerConnection.prototype.createOffer=function(t){var n=this;if(t){void 0!==t.offerToReceiveAudio&&(t.offerToReceiveAudio=!!t.offerToReceiveAudio);var i=n.getTransceivers().find((function(t){return t.sender.track&&"audio"===t.sender.track.kind}));!1===t.offerToReceiveAudio&&i?"sendrecv"===i.direction?i.setDirection?i.setDirection("sendonly"):i.direction="sendonly":"recvonly"===i.direction&&(i.setDirection?i.setDirection("inactive"):i.direction="inactive"):!0!==t.offerToReceiveAudio||i||n.addTransceiver("audio"),void 0!==t.offerToReceiveVideo&&(t.offerToReceiveVideo=!!t.offerToReceiveVideo);var r=n.getTransceivers().find((function(t){return t.sender.track&&"video"===t.sender.track.kind}));!1===t.offerToReceiveVideo&&r?"sendrecv"===r.direction?r.setDirection("sendonly"):"recvonly"===r.direction&&r.setDirection("inactive"):!0!==t.offerToReceiveVideo||r||n.addTransceiver("video")}return e.apply(n,arguments)}}}},function(t,e,n){"use strict";var i=n(122),r=n(6);t.exports={shimRTCIceCandidate:function(t){if(t.RTCIceCandidate&&(!t.RTCIceCandidate||!("foundation"in t.RTCIceCandidate.prototype))){var e=t.RTCIceCandidate;t.RTCIceCandidate=function(t){if("object"==typeof t&&t.candidate&&0===t.candidate.indexOf("a=")&&((t=JSON.parse(JSON.stringify(t))).candidate=t.candidate.substr(2)),t.candidate&&t.candidate.length){var n=new e(t),r=i.parseCandidate(t.candidate),o=Object.assign(n,r);return o.toJSON=function(){return{candidate:o.candidate,sdpMid:o.sdpMid,sdpMLineIndex:o.sdpMLineIndex,usernameFragment:o.usernameFragment}},o}return new e(t)},t.RTCIceCandidate.prototype=e.prototype,r.wrapPeerConnectionEvent(t,"icecandidate",(function(e){return e.candidate&&Object.defineProperty(e,"candidate",{value:new t.RTCIceCandidate(e.candidate),writable:"false"}),e}))}},shimCreateObjectURL:function(t){var e=t&&t.URL;if("object"==typeof t&&t.HTMLMediaElement&&"srcObject"in t.HTMLMediaElement.prototype&&e.createObjectURL&&e.revokeObjectURL){var n=e.createObjectURL.bind(e),i=e.revokeObjectURL.bind(e),o=new Map,a=0;e.createObjectURL=function(t){if("getTracks"in t){var e="polyblob:"+ ++a;return o.set(e,t),r.deprecated("URL.createObjectURL(stream)","elem.srcObject = stream"),e}return n(t)},e.revokeObjectURL=function(t){i(t),o.delete(t)};var s=Object.getOwnPropertyDescriptor(t.HTMLMediaElement.prototype,"src");Object.defineProperty(t.HTMLMediaElement.prototype,"src",{get:function(){return s.get.apply(this)},set:function(t){return this.srcObject=o.get(t)||null,s.set.apply(this,[t])}});var l=t.HTMLMediaElement.prototype.setAttribute;t.HTMLMediaElement.prototype.setAttribute=function(){return 2===arguments.length&&"src"===(""+arguments[0]).toLowerCase()&&(this.srcObject=o.get(arguments[1])||null),l.apply(this,arguments)}}},shimMaxMessageSize:function(t){if(!t.RTCSctpTransport&&t.RTCPeerConnection){var e=r.detectBrowser(t);"sctp"in t.RTCPeerConnection.prototype||Object.defineProperty(t.RTCPeerConnection.prototype,"sctp",{get:function(){return void 0===this._sctp?null:this._sctp}});var n=function(t){var e=i.splitSections(t.sdp);return e.shift(),e.some((function(t){var e=i.parseMLine(t);return e&&"application"===e.kind&&-1!==e.protocol.indexOf("SCTP")}))},o=function(t){var n=65536;return"firefox"===e.browser&&(n=e.version<57?-1===t?16384:2147483637:e.version<60?57===e.version?65535:65536:2147483637),n},a=function(t,n){var r=65536;"firefox"===e.browser&&57===e.version&&(r=65535);var o=i.matchPrefix(t.sdp,"a=max-message-size:");return o.length>0?r=parseInt(o[0].substr(19),10):"firefox"===e.browser&&-1!==n&&(r=2147483637),r},s=t.RTCPeerConnection.prototype.setRemoteDescription;t.RTCPeerConnection.prototype.setRemoteDescription=function(){var t=this;if(t._sctp=null,n(arguments[0])){var e,i=function(t){var e=t.sdp.match(/mozilla...THIS_IS_SDPARTA-(\d+)/);if(null===e||e.length<2)return-1;var n=parseInt(e[1],10);return n!=n?-1:n}(arguments[0]),r=o(i),l=a(arguments[0],i);e=0===r&&0===l?Number.POSITIVE_INFINITY:0===r||0===l?Math.max(r,l):Math.min(r,l);var c={};Object.defineProperty(c,"maxMessageSize",{get:function(){return e}}),t._sctp=c}return s.apply(t,arguments)}}},shimSendThrowTypeError:function(t){function e(t,e){var n=t.send;t.send=function(){var i=arguments[0],r=i.length||i.size||i.byteLength;if("open"===t.readyState&&e.sctp&&r>e.sctp.maxMessageSize)throw new TypeError("Message too large (can send a maximum of "+e.sctp.maxMessageSize+" bytes)");return n.apply(t,arguments)}}if(t.RTCPeerConnection&&"createDataChannel"in t.RTCPeerConnection.prototype){var n=t.RTCPeerConnection.prototype.createDataChannel;t.RTCPeerConnection.prototype.createDataChannel=function(){var t=n.apply(this,arguments);return e(t,this),t},r.wrapPeerConnectionEvent(t,"datachannel",(function(t){return e(t.channel,t.target),t}))}}}},function(t,e,n){"use strict";var i={generateIdentifier:function(){return Math.random().toString(36).substr(2,10)}};i.localCName=i.generateIdentifier(),i.splitLines=function(t){return t.trim().split("\n").map((function(t){return t.trim()}))},i.splitSections=function(t){return t.split("\nm=").map((function(t,e){return(e>0?"m="+t:t).trim()+"\r\n"}))},i.getDescription=function(t){var e=i.splitSections(t);return e&&e[0]},i.getMediaSections=function(t){var e=i.splitSections(t);return e.shift(),e},i.matchPrefix=function(t,e){return i.splitLines(t).filter((function(t){return 0===t.indexOf(e)}))},i.parseCandidate=function(t){for(var e,n={foundation:(e=0===t.indexOf("a=candidate:")?t.substring(12).split(" "):t.substring(10).split(" "))[0],component:parseInt(e[1],10),protocol:e[2].toLowerCase(),priority:parseInt(e[3],10),ip:e[4],address:e[4],port:parseInt(e[5],10),type:e[7]},i=8;i<e.length;i+=2)switch(e[i]){case"raddr":n.relatedAddress=e[i+1];break;case"rport":n.relatedPort=parseInt(e[i+1],10);break;case"tcptype":n.tcpType=e[i+1];break;case"ufrag":n.ufrag=e[i+1],n.usernameFragment=e[i+1];break;default:n[e[i]]=e[i+1]}return n},i.writeCandidate=function(t){var e=[];e.push(t.foundation),e.push(t.component),e.push(t.protocol.toUpperCase()),e.push(t.priority),e.push(t.address||t.ip),e.push(t.port);var n=t.type;return e.push("typ"),e.push(n),"host"!==n&&t.relatedAddress&&t.relatedPort&&(e.push("raddr"),e.push(t.relatedAddress),e.push("rport"),e.push(t.relatedPort)),t.tcpType&&"tcp"===t.protocol.toLowerCase()&&(e.push("tcptype"),e.push(t.tcpType)),(t.usernameFragment||t.ufrag)&&(e.push("ufrag"),e.push(t.usernameFragment||t.ufrag)),"candidate:"+e.join(" ")},i.parseIceOptions=function(t){return t.substr(14).split(" ")},i.parseRtpMap=function(t){var e=t.substr(9).split(" "),n={payloadType:parseInt(e.shift(),10)};return e=e[0].split("/"),n.name=e[0],n.clockRate=parseInt(e[1],10),n.channels=3===e.length?parseInt(e[2],10):1,n.numChannels=n.channels,n},i.writeRtpMap=function(t){var e=t.payloadType;void 0!==t.preferredPayloadType&&(e=t.preferredPayloadType);var n=t.channels||t.numChannels||1;return"a=rtpmap:"+e+" "+t.name+"/"+t.clockRate+(1!==n?"/"+n:"")+"\r\n"},i.parseExtmap=function(t){var e=t.substr(9).split(" ");return{id:parseInt(e[0],10),direction:e[0].indexOf("/")>0?e[0].split("/")[1]:"sendrecv",uri:e[1]}},i.writeExtmap=function(t){return"a=extmap:"+(t.id||t.preferredId)+(t.direction&&"sendrecv"!==t.direction?"/"+t.direction:"")+" "+t.uri+"\r\n"},i.parseFmtp=function(t){for(var e,n={},i=t.substr(t.indexOf(" ")+1).split(";"),r=0;r<i.length;r++)n[(e=i[r].trim().split("="))[0].trim()]=e[1];return n},i.writeFmtp=function(t){var e="",n=t.payloadType;if(void 0!==t.preferredPayloadType&&(n=t.preferredPayloadType),t.parameters&&Object.keys(t.parameters).length){var i=[];Object.keys(t.parameters).forEach((function(e){t.parameters[e]?i.push(e+"="+t.parameters[e]):i.push(e)})),e+="a=fmtp:"+n+" "+i.join(";")+"\r\n"}return e},i.parseRtcpFb=function(t){var e=t.substr(t.indexOf(" ")+1).split(" ");return{type:e.shift(),parameter:e.join(" ")}},i.writeRtcpFb=function(t){var e="",n=t.payloadType;return void 0!==t.preferredPayloadType&&(n=t.preferredPayloadType),t.rtcpFeedback&&t.rtcpFeedback.length&&t.rtcpFeedback.forEach((function(t){e+="a=rtcp-fb:"+n+" "+t.type+(t.parameter&&t.parameter.length?" "+t.parameter:"")+"\r\n"})),e},i.parseSsrcMedia=function(t){var e=t.indexOf(" "),n={ssrc:parseInt(t.substr(7,e-7),10)},i=t.indexOf(":",e);return i>-1?(n.attribute=t.substr(e+1,i-e-1),n.value=t.substr(i+1)):n.attribute=t.substr(e+1),n},i.parseSsrcGroup=function(t){var e=t.substr(13).split(" ");return{semantics:e.shift(),ssrcs:e.map((function(t){return parseInt(t,10)}))}},i.getMid=function(t){var e=i.matchPrefix(t,"a=mid:")[0];if(e)return e.substr(6)},i.parseFingerprint=function(t){var e=t.substr(14).split(" ");return{algorithm:e[0].toLowerCase(),value:e[1]}},i.getDtlsParameters=function(t,e){return{role:"auto",fingerprints:i.matchPrefix(t+e,"a=fingerprint:").map(i.parseFingerprint)}},i.writeDtlsParameters=function(t,e){var n="a=setup:"+e+"\r\n";return t.fingerprints.forEach((function(t){n+="a=fingerprint:"+t.algorithm+" "+t.value+"\r\n"})),n},i.getIceParameters=function(t,e){var n=i.splitLines(t);return{usernameFragment:(n=n.concat(i.splitLines(e))).filter((function(t){return 0===t.indexOf("a=ice-ufrag:")}))[0].substr(12),password:n.filter((function(t){return 0===t.indexOf("a=ice-pwd:")}))[0].substr(10)}},i.writeIceParameters=function(t){return"a=ice-ufrag:"+t.usernameFragment+"\r\na=ice-pwd:"+t.password+"\r\n"},i.parseRtpParameters=function(t){for(var e={codecs:[],headerExtensions:[],fecMechanisms:[],rtcp:[]},n=i.splitLines(t)[0].split(" "),r=3;r<n.length;r++){var o=n[r],a=i.matchPrefix(t,"a=rtpmap:"+o+" ")[0];if(a){var s=i.parseRtpMap(a),l=i.matchPrefix(t,"a=fmtp:"+o+" ");switch(s.parameters=l.length?i.parseFmtp(l[0]):{},s.rtcpFeedback=i.matchPrefix(t,"a=rtcp-fb:"+o+" ").map(i.parseRtcpFb),e.codecs.push(s),s.name.toUpperCase()){case"RED":case"ULPFEC":e.fecMechanisms.push(s.name.toUpperCase())}}}return i.matchPrefix(t,"a=extmap:").forEach((function(t){e.headerExtensions.push(i.parseExtmap(t))})),e},i.writeRtpDescription=function(t,e){var n="";n+="m="+t+" ",n+=e.codecs.length>0?"9":"0",n+=" UDP/TLS/RTP/SAVPF ",n+=e.codecs.map((function(t){return void 0!==t.preferredPayloadType?t.preferredPayloadType:t.payloadType})).join(" ")+"\r\n",n+="c=IN IP4 0.0.0.0\r\n",n+="a=rtcp:9 IN IP4 0.0.0.0\r\n",e.codecs.forEach((function(t){n+=i.writeRtpMap(t),n+=i.writeFmtp(t),n+=i.writeRtcpFb(t)}));var r=0;return e.codecs.forEach((function(t){t.maxptime>r&&(r=t.maxptime)})),r>0&&(n+="a=maxptime:"+r+"\r\n"),n+="a=rtcp-mux\r\n",e.headerExtensions&&e.headerExtensions.forEach((function(t){n+=i.writeExtmap(t)})),n},i.parseRtpEncodingParameters=function(t){var e,n=[],r=i.parseRtpParameters(t),o=-1!==r.fecMechanisms.indexOf("RED"),a=-1!==r.fecMechanisms.indexOf("ULPFEC"),s=i.matchPrefix(t,"a=ssrc:").map((function(t){return i.parseSsrcMedia(t)})).filter((function(t){return"cname"===t.attribute})),l=s.length>0&&s[0].ssrc,c=i.matchPrefix(t,"a=ssrc-group:FID").map((function(t){return t.substr(17).split(" ").map((function(t){return parseInt(t,10)}))}));c.length>0&&c[0].length>1&&c[0][0]===l&&(e=c[0][1]),r.codecs.forEach((function(t){if("RTX"===t.name.toUpperCase()&&t.parameters.apt){var i={ssrc:l,codecPayloadType:parseInt(t.parameters.apt,10)};l&&e&&(i.rtx={ssrc:e}),n.push(i),o&&((i=JSON.parse(JSON.stringify(i))).fec={ssrc:l,mechanism:a?"red+ulpfec":"red"},n.push(i))}})),0===n.length&&l&&n.push({ssrc:l});var u=i.matchPrefix(t,"b=");return u.length&&(u=0===u[0].indexOf("b=TIAS:")?parseInt(u[0].substr(7),10):0===u[0].indexOf("b=AS:")?1e3*parseInt(u[0].substr(5),10)*.95-16e3:void 0,n.forEach((function(t){t.maxBitrate=u}))),n},i.parseRtcpParameters=function(t){var e={},n=i.matchPrefix(t,"a=ssrc:").map((function(t){return i.parseSsrcMedia(t)})).filter((function(t){return"cname"===t.attribute}))[0];n&&(e.cname=n.value,e.ssrc=n.ssrc);var r=i.matchPrefix(t,"a=rtcp-rsize");e.reducedSize=r.length>0,e.compound=0===r.length;var o=i.matchPrefix(t,"a=rtcp-mux");return e.mux=o.length>0,e},i.parseMsid=function(t){var e,n=i.matchPrefix(t,"a=msid:");if(1===n.length)return{stream:(e=n[0].substr(7).split(" "))[0],track:e[1]};var r=i.matchPrefix(t,"a=ssrc:").map((function(t){return i.parseSsrcMedia(t)})).filter((function(t){return"msid"===t.attribute}));return r.length>0?{stream:(e=r[0].value.split(" "))[0],track:e[1]}:void 0},i.generateSessionId=function(){return Math.random().toString().substr(2,21)},i.writeSessionBoilerplate=function(t,e,n){var r=void 0!==e?e:2;return"v=0\r\no="+(n||"thisisadapterortc")+" "+(t||i.generateSessionId())+" "+r+" IN IP4 127.0.0.1\r\ns=-\r\nt=0 0\r\n"},i.writeMediaSection=function(t,e,n,r){var o=i.writeRtpDescription(t.kind,e);if(o+=i.writeIceParameters(t.iceGatherer.getLocalParameters()),o+=i.writeDtlsParameters(t.dtlsTransport.getLocalParameters(),"offer"===n?"actpass":"active"),o+="a=mid:"+t.mid+"\r\n",t.direction?o+="a="+t.direction+"\r\n":t.rtpSender&&t.rtpReceiver?o+="a=sendrecv\r\n":t.rtpSender?o+="a=sendonly\r\n":t.rtpReceiver?o+="a=recvonly\r\n":o+="a=inactive\r\n",t.rtpSender){var a="msid:"+r.id+" "+t.rtpSender.track.id+"\r\n";o+="a="+a,o+="a=ssrc:"+t.sendEncodingParameters[0].ssrc+" "+a,t.sendEncodingParameters[0].rtx&&(o+="a=ssrc:"+t.sendEncodingParameters[0].rtx.ssrc+" "+a,o+="a=ssrc-group:FID "+t.sendEncodingParameters[0].ssrc+" "+t.sendEncodingParameters[0].rtx.ssrc+"\r\n")}return o+="a=ssrc:"+t.sendEncodingParameters[0].ssrc+" cname:"+i.localCName+"\r\n",t.rtpSender&&t.sendEncodingParameters[0].rtx&&(o+="a=ssrc:"+t.sendEncodingParameters[0].rtx.ssrc+" cname:"+i.localCName+"\r\n"),o},i.getDirection=function(t,e){for(var n=i.splitLines(t),r=0;r<n.length;r++)switch(n[r]){case"a=sendrecv":case"a=sendonly":case"a=recvonly":case"a=inactive":return n[r].substr(2)}return e?i.getDirection(e):"sendrecv"},i.getKind=function(t){return i.splitLines(t)[0].split(" ")[0].substr(2)},i.isRejected=function(t){return"0"===t.split(" ",2)[1]},i.parseMLine=function(t){var e=i.splitLines(t)[0].substr(2).split(" ");return{kind:e[0],port:parseInt(e[1],10),protocol:e[2],fmt:e.slice(3).join(" ")}},i.parseOLine=function(t){var e=i.matchPrefix(t,"o=")[0].substr(2).split(" ");return{username:e[0],sessionId:e[1],sessionVersion:parseInt(e[2],10),netType:e[3],addressType:e[4],address:e[5]}},i.isValidSDP=function(t){if("string"!=typeof t||0===t.length)return!1;for(var e=i.splitLines(t),n=0;n<e.length;n++)if(e[n].length<2||"="!==e[n].charAt(1))return!1;return!0},t.exports=i},function(t,e,n){t.exports={default:n(124),__esModule:!0}},function(t,e,n){n(125),t.exports=n(0).Object.getPrototypeOf},function(t,e,n){var i=n(36),r=n(55);n(126)("getPrototypeOf",(function(){return function(t){return r(i(t))}}))},function(t,e,n){var i=n(3),r=n(0),o=n(18);t.exports=function(t,e){var n=(r.Object||{})[t]||Object[t],a={};a[t]=e(n),i(i.S+i.F*o((function(){n(1)})),"Object",a)}},function(t,e,n){"use strict";e.__esModule=!0;var i=function(t){return t&&t.__esModule?t:{default:t}}(n(65));e.default=function(t,e){if(!t)throw new ReferenceError("this hasn't been initialised - super() hasn't been called");return!e||"object"!==(void 0===e?"undefined":(0,i.default)(e))&&"function"!=typeof e?t:e}},function(t,e,n){t.exports={default:n(129),__esModule:!0}},function(t,e,n){n(16),n(25),t.exports=n(42).f("iterator")},function(t,e,n){t.exports={default:n(131),__esModule:!0}},function(t,e,n){n(132),n(49),n(137),n(138),t.exports=n(0).Symbol},function(t,e,n){"use strict";var i=n(1),r=n(10),o=n(8),a=n(3),s=n(52),l=n(133).KEY,c=n(18),u=n(34),d=n(24),h=n(23),f=n(2),p=n(42),m=n(43),v=n(134),g=n(135),y=n(4),_=n(7),b=n(15),w=n(29),k=n(19),x=n(30),C=n(136),S=n(68),M=n(5),T=n(31),P=S.f,O=M.f,B=C.f,E=i.Symbol,A=i.JSON,D=A&&A.stringify,L=f("_hidden"),q=f("toPrimitive"),R={}.propertyIsEnumerable,I=u("symbol-registry"),N=u("symbols"),F=u("op-symbols"),$=Object.prototype,j="function"==typeof E,z=i.QObject,V=!z||!z.prototype||!z.prototype.findChild,H=o&&c((function(){return 7!=x(O({},"a",{get:function(){return O(this,"a",{value:7}).a}})).a}))?function(t,e,n){var i=P($,e);i&&delete $[e],O(t,e,n),i&&t!==$&&O($,e,i)}:O,W=function(t){var e=N[t]=x(E.prototype);return e._k=t,e},U=j&&"symbol"==typeof E.iterator?function(t){return"symbol"==typeof t}:function(t){return t instanceof E},Y=function(t,e,n){return t===$&&Y(F,e,n),y(t),e=w(e,!0),y(n),r(N,e)?(n.enumerable?(r(t,L)&&t[L][e]&&(t[L][e]=!1),n=x(n,{enumerable:k(0,!1)})):(r(t,L)||O(t,L,k(1,{})),t[L][e]=!0),H(t,e,n)):O(t,e,n)},Q=function(t,e){y(t);for(var n,i=v(e=b(e)),r=0,o=i.length;o>r;)Y(t,n=i[r++],e[n]);return t},G=function(t){var e=R.call(this,t=w(t,!0));return!(this===$&&r(N,t)&&!r(F,t))&&(!(e||!r(this,t)||!r(N,t)||r(this,L)&&this[L][t])||e)},K=function(t,e){if(t=b(t),e=w(e,!0),t!==$||!r(N,e)||r(F,e)){var n=P(t,e);return!n||!r(N,e)||r(t,L)&&t[L][e]||(n.enumerable=!0),n}},J=function(t){for(var e,n=B(b(t)),i=[],o=0;n.length>o;)r(N,e=n[o++])||e==L||e==l||i.push(e);return i},Z=function(t){for(var e,n=t===$,i=B(n?F:b(t)),o=[],a=0;i.length>a;)!r(N,e=i[a++])||n&&!r($,e)||o.push(N[e]);return o};j||(E=function(){if(this instanceof E)throw TypeError("Symbol is not a constructor!");var t=h(arguments.length>0?arguments[0]:void 0),e=function(n){this===$&&e.call(F,n),r(this,L)&&r(this[L],t)&&(this[L][t]=!1),H(this,t,k(1,n))};return o&&V&&H($,t,{configurable:!0,set:e}),W(t)},s(E.prototype,"toString",(function(){return this._k})),S.f=K,M.f=Y,n(67).f=C.f=J,n(44).f=G,n(66).f=Z,o&&!n(17)&&s($,"propertyIsEnumerable",G,!0),p.f=function(t){return W(f(t))}),a(a.G+a.W+a.F*!j,{Symbol:E});for(var X="hasInstance,isConcatSpreadable,iterator,match,replace,search,species,split,toPrimitive,toStringTag,unscopables".split(","),tt=0;X.length>tt;)f(X[tt++]);for(var et=T(f.store),nt=0;et.length>nt;)m(et[nt++]);a(a.S+a.F*!j,"Symbol",{for:function(t){return r(I,t+="")?I[t]:I[t]=E(t)},keyFor:function(t){if(!U(t))throw TypeError(t+" is not a symbol!");for(var e in I)if(I[e]===t)return e},useSetter:function(){V=!0},useSimple:function(){V=!1}}),a(a.S+a.F*!j,"Object",{create:function(t,e){return void 0===e?x(t):Q(x(t),e)},defineProperty:Y,defineProperties:Q,getOwnPropertyDescriptor:K,getOwnPropertyNames:J,getOwnPropertySymbols:Z}),A&&a(a.S+a.F*(!j||c((function(){var t=E();return"[null]"!=D([t])||"{}"!=D({a:t})||"{}"!=D(Object(t))}))),"JSON",{stringify:function(t){for(var e,n,i=[t],r=1;arguments.length>r;)i.push(arguments[r++]);if(n=e=i[1],(_(e)||void 0!==t)&&!U(t))return g(e)||(e=function(t,e){if("function"==typeof n&&(e=n.call(this,t,e)),!U(e))return e}),i[1]=e,D.apply(A,i)}}),E.prototype[q]||n(9)(E.prototype,q,E.prototype.valueOf),d(E,"Symbol"),d(Math,"Math",!0),d(i.JSON,"JSON",!0)},function(t,e,n){var i=n(23)("meta"),r=n(7),o=n(10),a=n(5).f,s=0,l=Object.isExtensible||function(){return!0},c=!n(18)((function(){return l(Object.preventExtensions({}))})),u=function(t){a(t,i,{value:{i:"O"+ ++s,w:{}}})},d=t.exports={KEY:i,NEED:!1,fastKey:function(t,e){if(!r(t))return"symbol"==typeof t?t:("string"==typeof t?"S":"P")+t;if(!o(t,i)){if(!l(t))return"F";if(!e)return"E";u(t)}return t[i].i},getWeak:function(t,e){if(!o(t,i)){if(!l(t))return!0;if(!e)return!1;u(t)}return t[i].w},onFreeze:function(t){return c&&d.NEED&&l(t)&&!o(t,i)&&u(t),t}}},function(t,e,n){var i=n(31),r=n(66),o=n(44);t.exports=function(t){var e=i(t),n=r.f;if(n)for(var a,s=n(t),l=o.f,c=0;s.length>c;)l.call(t,a=s[c++])&&e.push(a);return e}},function(t,e,n){var i=n(20);t.exports=Array.isArray||function(t){return"Array"==i(t)}},function(t,e,n){var i=n(15),r=n(67).f,o={}.toString,a="object"==typeof window&&window&&Object.getOwnPropertyNames?Object.getOwnPropertyNames(window):[];t.exports.f=function(t){return a&&"[object Window]"==o.call(t)?function(t){try{return r(t)}catch(t){return a.slice()}}(t):r(i(t))}},function(t,e,n){n(43)("asyncIterator")},function(t,e,n){n(43)("observable")},function(t,e,n){"use strict";function i(t){return t&&t.__esModule?t:{default:t}}e.__esModule=!0;var r=i(n(140)),o=i(n(144)),a=i(n(65));e.default=function(t,e){if("function"!=typeof e&&null!==e)throw new TypeError("Super expression must either be null or a function, not "+(void 0===e?"undefined":(0,a.default)(e)));t.prototype=(0,o.default)(e&&e.prototype,{constructor:{value:t,enumerable:!1,writable:!0,configurable:!0}}),e&&(r.default?(0,r.default)(t,e):t.__proto__=e)}},function(t,e,n){t.exports={default:n(141),__esModule:!0}},function(t,e,n){n(142),t.exports=n(0).Object.setPrototypeOf},function(t,e,n){var i=n(3);i(i.S,"Object",{setPrototypeOf:n(143).set})},function(t,e,n){var i=n(7),r=n(4),o=function(t,e){if(r(t),!i(e)&&null!==e)throw TypeError(e+": can't set as prototype!")};t.exports={set:Object.setPrototypeOf||("__proto__"in{}?function(t,e,i){try{(i=n(13)(Function.call,n(68).f(Object.prototype,"__proto__").set,2))(t,[]),e=!(t instanceof Array)}catch(t){e=!0}return function(t,n){return o(t,n),e?t.__proto__=n:i(t,n),t}}({},!1):void 0),check:o}},function(t,e,n){t.exports={default:n(145),__esModule:!0}},function(t,e,n){n(146);var i=n(0).Object;t.exports=function(t,e){return i.create(t,e)}},function(t,e,n){var i=n(3);i(i.S,"Object",{create:n(30)})},function(t,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var i=n(11),r=n.n(i),o=n(12),a=n.n(o);e.default={methods:{onDetect:function(t){var e=this;return a()(r.a.mark((function n(){var i,o;return r.a.wrap((function(n){for(;;)switch(n.prev=n.next){case 0:return e.$emit("detect",t),n.prev=1,n.next=4,t;case 4:i=n.sent,null!==(o=i.content)&&e.$emit("decode",o),n.next=11;break;case 9:n.prev=9,n.t0=n.catch(1);case 11:case"end":return n.stop()}}),n,e,[[1,9]])})))()}}}},function(t,e,n){"use strict";var i=window.URL||window.webkitURL;t.exports=function(t,e){try{try{var n;try{(n=new(window.BlobBuilder||window.WebKitBlobBuilder||window.MozBlobBuilder||window.MSBlobBuilder)).append(t),n=n.getBlob()}catch(e){n=new Blob([t])}return new Worker(i.createObjectURL(n))}catch(e){return new Worker("data:application/javascript,"+encodeURIComponent(t))}}catch(t){if(!e)throw Error("Inline worker is not supported");return new Worker(e)}}},function(t,e){t.exports={render:function(){var t=this,e=t.$createElement,n=t._self._c||e;return n("div",{staticClass:"wrapper"},[n("video",{directives:[{name:"show",rawName:"v-show",value:t.shouldScan,expression:"shouldScan"}],ref:"video",staticClass:"camera",attrs:{autoplay:"",muted:"",playsinline:""},domProps:{muted:!0}}),t._v(" "),n("canvas",{directives:[{name:"show",rawName:"v-show",value:!t.shouldScan,expression:"!shouldScan"}],ref:"pauseFrame",staticClass:"pause-frame"}),t._v(" "),n("canvas",{ref:"trackingLayer",staticClass:"tracking-layer"}),t._v(" "),n("div",{staticClass:"overlay"},[t._t("default")],2)])},staticRenderFns:[]}},function(t,e,n){var i=n(21)(n(151),n(156),null,null);t.exports=i.exports},function(t,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var i=n(11),r=n.n(i),o=n(12),a=n.n(o),s=n(69),l=n.n(s),c=n(40),u=n(45),d=n(46),h=n.n(d),f=n(47),p=n.n(f);e.default={name:"qrcode-capture",mixins:[h.a],props:{worker:{type:Function,default:p.a}},methods:{onChangeInput:function(t){[].concat(l()(t.target.files)).map(this.processFile).forEach(this.onDetect)},processFile:function(t){var e=this;return a()(r.a.mark((function n(){var i,o;return r.a.wrap((function(n){for(;;)switch(n.prev=n.next){case 0:return n.next=2,Object(u.a)(t);case 2:return i=n.sent,n.next=5,Object(c.b)(e.worker,i);case 5:return o=n.sent,n.abrupt("return",o);case 7:case"end":return n.stop()}}),n,e)})))()}}}},function(t,e,n){t.exports={default:n(153),__esModule:!0}},function(t,e,n){n(16),n(154),t.exports=n(0).Array.from},function(t,e,n){"use strict";var i=n(13),r=n(3),o=n(36),a=n(56),s=n(57),l=n(32),c=n(155),u=n(38);r(r.S+r.F*!n(62)((function(t){Array.from(t)})),"Array",{from:function(t){var e,n,r,d,h=o(t),f="function"==typeof this?this:Array,p=arguments.length,m=p>1?arguments[1]:void 0,v=void 0!==m,g=0,y=u(h);if(v&&(m=i(m,p>2?arguments[2]:void 0,2)),null==y||f==Array&&s(y))for(n=new f(e=l(h.length));e>g;g++)c(n,g,v?m(h[g],g):h[g]);else for(d=y.call(h),n=new f;!(r=d.next()).done;g++)c(n,g,v?a(d,m,[r.value,g],!0):r.value);return n.length=g,n}})},function(t,e,n){"use strict";var i=n(5),r=n(19);t.exports=function(t,e,n){e in t?i.f(t,e,r(0,n)):t[e]=n}},function(t,e){t.exports={render:function(){var t=this,e=t.$createElement;return(t._self._c||e)("input",{attrs:{type:"file",name:"image",accept:"image/*",capture:"environment",multiple:""},on:{change:t.onChangeInput}})},staticRenderFns:[]}},function(t,e,n){var i=n(21)(n(158),n(159),null,null);t.exports=i.exports},function(t,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var i=n(11),r=n.n(i),o=n(12),a=n.n(o),s=n(69),l=n.n(s),c=n(40),u=n(45),d=n(46),h=n.n(d),f=n(47),p=n.n(f);e.default={name:"qrcode-drop-zone",mixins:[h.a],props:{worker:{type:Function,default:p.a}},methods:{onDragOver:function(t){this.$emit("dragover",t)},onDrop:function(t){var e=this,n=t.dataTransfer;this.onDragOver(!1);var i=[].concat(l()(n.files)),r=n.getData("text/uri-list");i.forEach((function(t){e.onDetect(e.processFile(t))})),""!==r&&this.onDetect(this.processUrl(r))},processFile:function(t){var e=this;return a()(r.a.mark((function n(){var i,o;return r.a.wrap((function(n){for(;;)switch(n.prev=n.next){case 0:return n.next=2,Object(u.a)(t);case 2:return i=n.sent,n.next=5,Object(c.b)(e.worker,i);case 5:return o=n.sent,n.abrupt("return",o);case 7:case"end":return n.stop()}}),n,e)})))()},processUrl:function(t){var e=this;return a()(r.a.mark((function n(){var i,o;return r.a.wrap((function(n){for(;;)switch(n.prev=n.next){case 0:return n.next=2,Object(u.b)(t);case 2:return i=n.sent,n.next=5,Object(c.b)(e.worker,i);case 5:return o=n.sent,n.abrupt("return",o);case 7:case"end":return n.stop()}}),n,e)})))()}}}},function(t,e){t.exports={render:function(){var t=this,e=t.$createElement;return(t._self._c||e)("div",{on:{drop:function(e){return e.preventDefault(),e.stopPropagation(),t.onDrop(e)},dragenter:function(e){return e.preventDefault(),e.stopPropagation(),t.onDragOver(!0)},dragleave:function(e){return e.preventDefault(),e.stopPropagation(),t.onDragOver(!1)},dragover:function(t){t.preventDefault(),t.stopPropagation()}}},[t._t("default")],2)},staticRenderFns:[]}}])})),
/*!
 * vue-qrcode v1.0.2
 * https://fengyuanchen.github.io/vue-qrcode
 *
 * Copyright 2018-present Chen Fengyuan
 * Released under the MIT license
 *
 * Date: 2020-01-18T06:04:33.222Z
 */
function(t,e){"object"==typeof exports&&"undefined"!=typeof module?module.exports=e():"function"==typeof define&&define.amd?define(e):(t=t||self).VueQrcode=e()}(this,(function(){"use strict";function t(){throw new Error("Dynamic requires are not currently supported by rollup-plugin-commonjs")}var e=function(t,e){return t(e={exports:{}},e.exports),e.exports}((function(e,n){e.exports=function(){function e(n,i,r){function o(s,l){if(!i[s]){if(!n[s]){if(!l&&t)return t();if(a)return a(s,!0);var c=new Error("Cannot find module '"+s+"'");throw c.code="MODULE_NOT_FOUND",c}var u=i[s]={exports:{}};n[s][0].call(u.exports,(function(t){return o(n[s][1][t]||t)}),u,u.exports,e,n,i,r)}return i[s].exports}for(var a=t,s=0;s<r.length;s++)o(r[s]);return o}return e}()({1:[function(t,e,n){e.exports=function(){return"function"==typeof Promise&&Promise.prototype&&Promise.prototype.then}},{}],2:[function(t,e,n){var i=t("./utils").getSymbolSize;n.getRowColCoords=function(t){if(1===t)return[];for(var e=Math.floor(t/7)+2,n=i(t),r=145===n?26:2*Math.ceil((n-13)/(2*e-2)),o=[n-7],a=1;a<e-1;a++)o[a]=o[a-1]-r;return o.push(6),o.reverse()},n.getPositions=function(t){for(var e=[],i=n.getRowColCoords(t),r=i.length,o=0;o<r;o++)for(var a=0;a<r;a++)0===o&&0===a||0===o&&a===r-1||o===r-1&&0===a||e.push([i[o],i[a]]);return e}},{"./utils":21}],3:[function(t,e,n){var i=t("./mode"),r=["0","1","2","3","4","5","6","7","8","9","A","B","C","D","E","F","G","H","I","J","K","L","M","N","O","P","Q","R","S","T","U","V","W","X","Y","Z"," ","$","%","*","+","-",".","/",":"];function o(t){this.mode=i.ALPHANUMERIC,this.data=t}o.getBitsLength=function(t){return 11*Math.floor(t/2)+t%2*6},o.prototype.getLength=function(){return this.data.length},o.prototype.getBitsLength=function(){return o.getBitsLength(this.data.length)},o.prototype.write=function(t){var e;for(e=0;e+2<=this.data.length;e+=2){var n=45*r.indexOf(this.data[e]);n+=r.indexOf(this.data[e+1]),t.put(n,11)}this.data.length%2&&t.put(r.indexOf(this.data[e]),6)},e.exports=o},{"./mode":14}],4:[function(t,e,n){function i(){this.buffer=[],this.length=0}i.prototype={get:function(t){var e=Math.floor(t/8);return 1==(this.buffer[e]>>>7-t%8&1)},put:function(t,e){for(var n=0;n<e;n++)this.putBit(1==(t>>>e-n-1&1))},getLengthInBits:function(){return this.length},putBit:function(t){var e=Math.floor(this.length/8);this.buffer.length<=e&&this.buffer.push(0),t&&(this.buffer[e]|=128>>>this.length%8),this.length++}},e.exports=i},{}],5:[function(t,e,n){var i=t("../utils/buffer");function r(t){if(!t||t<1)throw new Error("BitMatrix size must be defined and greater than 0");this.size=t,this.data=i.alloc(t*t),this.reservedBit=i.alloc(t*t)}r.prototype.set=function(t,e,n,i){var r=t*this.size+e;this.data[r]=n,i&&(this.reservedBit[r]=!0)},r.prototype.get=function(t,e){return this.data[t*this.size+e]},r.prototype.xor=function(t,e,n){this.data[t*this.size+e]^=n},r.prototype.isReserved=function(t,e){return this.reservedBit[t*this.size+e]},e.exports=r},{"../utils/buffer":28}],6:[function(t,e,n){var i=t("../utils/buffer"),r=t("./mode");function o(t){this.mode=r.BYTE,this.data=i.from(t)}o.getBitsLength=function(t){return 8*t},o.prototype.getLength=function(){return this.data.length},o.prototype.getBitsLength=function(){return o.getBitsLength(this.data.length)},o.prototype.write=function(t){for(var e=0,n=this.data.length;e<n;e++)t.put(this.data[e],8)},e.exports=o},{"../utils/buffer":28,"./mode":14}],7:[function(t,e,n){var i=t("./error-correction-level"),r=[1,1,1,1,1,1,1,1,1,1,2,2,1,2,2,4,1,2,4,4,2,4,4,4,2,4,6,5,2,4,6,6,2,5,8,8,4,5,8,8,4,5,8,11,4,8,10,11,4,9,12,16,4,9,16,16,6,10,12,18,6,10,17,16,6,11,16,19,6,13,18,21,7,14,21,25,8,16,20,25,8,17,23,25,9,17,23,34,9,18,25,30,10,20,27,32,12,21,29,35,12,23,34,37,12,25,34,40,13,26,35,42,14,28,38,45,15,29,40,48,16,31,43,51,17,33,45,54,18,35,48,57,19,37,51,60,19,38,53,63,20,40,56,66,21,43,59,70,22,45,62,74,24,47,65,77,25,49,68,81],o=[7,10,13,17,10,16,22,28,15,26,36,44,20,36,52,64,26,48,72,88,36,64,96,112,40,72,108,130,48,88,132,156,60,110,160,192,72,130,192,224,80,150,224,264,96,176,260,308,104,198,288,352,120,216,320,384,132,240,360,432,144,280,408,480,168,308,448,532,180,338,504,588,196,364,546,650,224,416,600,700,224,442,644,750,252,476,690,816,270,504,750,900,300,560,810,960,312,588,870,1050,336,644,952,1110,360,700,1020,1200,390,728,1050,1260,420,784,1140,1350,450,812,1200,1440,480,868,1290,1530,510,924,1350,1620,540,980,1440,1710,570,1036,1530,1800,570,1064,1590,1890,600,1120,1680,1980,630,1204,1770,2100,660,1260,1860,2220,720,1316,1950,2310,750,1372,2040,2430];n.getBlocksCount=function(t,e){switch(e){case i.L:return r[4*(t-1)+0];case i.M:return r[4*(t-1)+1];case i.Q:return r[4*(t-1)+2];case i.H:return r[4*(t-1)+3];default:return}},n.getTotalCodewordsCount=function(t,e){switch(e){case i.L:return o[4*(t-1)+0];case i.M:return o[4*(t-1)+1];case i.Q:return o[4*(t-1)+2];case i.H:return o[4*(t-1)+3];default:return}}},{"./error-correction-level":8}],8:[function(t,e,n){function i(t){if("string"!=typeof t)throw new Error("Param is not a string");switch(t.toLowerCase()){case"l":case"low":return n.L;case"m":case"medium":return n.M;case"q":case"quartile":return n.Q;case"h":case"high":return n.H;default:throw new Error("Unknown EC Level: "+t)}}n.L={bit:1},n.M={bit:0},n.Q={bit:3},n.H={bit:2},n.isValid=function(t){return t&&void 0!==t.bit&&t.bit>=0&&t.bit<4},n.from=function(t,e){if(n.isValid(t))return t;try{return i(t)}catch(t){return e}}},{}],9:[function(t,e,n){var i=t("./utils").getSymbolSize,r=7;n.getPositions=function(t){var e=i(t);return[[0,0],[e-r,0],[0,e-r]]}},{"./utils":21}],10:[function(t,e,n){var i=t("./utils"),r=1335,o=21522,a=i.getBCHDigit(r);n.getEncodedBits=function(t,e){for(var n=t.bit<<3|e,s=n<<10;i.getBCHDigit(s)-a>=0;)s^=r<<i.getBCHDigit(s)-a;return(n<<10|s)^o}},{"./utils":21}],11:[function(t,e,n){var i=t("../utils/buffer"),r=i.alloc(512),o=i.alloc(256);!function(){for(var t=1,e=0;e<255;e++)r[e]=t,o[t]=e,256&(t<<=1)&&(t^=285);for(e=255;e<512;e++)r[e]=r[e-255]}(),n.log=function(t){if(t<1)throw new Error("log("+t+")");return o[t]},n.exp=function(t){return r[t]},n.mul=function(t,e){return 0===t||0===e?0:r[o[t]+o[e]]}},{"../utils/buffer":28}],12:[function(t,e,n){var i=t("./mode"),r=t("./utils");function o(t){this.mode=i.KANJI,this.data=t}o.getBitsLength=function(t){return 13*t},o.prototype.getLength=function(){return this.data.length},o.prototype.getBitsLength=function(){return o.getBitsLength(this.data.length)},o.prototype.write=function(t){var e;for(e=0;e<this.data.length;e++){var n=r.toSJIS(this.data[e]);if(n>=33088&&n<=40956)n-=33088;else{if(!(n>=57408&&n<=60351))throw new Error("Invalid SJIS character: "+this.data[e]+"\nMake sure your charset is UTF-8");n-=49472}n=192*(n>>>8&255)+(255&n),t.put(n,13)}},e.exports=o},{"./mode":14,"./utils":21}],13:[function(t,e,n){n.Patterns={PATTERN000:0,PATTERN001:1,PATTERN010:2,PATTERN011:3,PATTERN100:4,PATTERN101:5,PATTERN110:6,PATTERN111:7};var i={N1:3,N2:3,N3:40,N4:10};function r(t,e,i){switch(t){case n.Patterns.PATTERN000:return(e+i)%2==0;case n.Patterns.PATTERN001:return e%2==0;case n.Patterns.PATTERN010:return i%3==0;case n.Patterns.PATTERN011:return(e+i)%3==0;case n.Patterns.PATTERN100:return(Math.floor(e/2)+Math.floor(i/3))%2==0;case n.Patterns.PATTERN101:return e*i%2+e*i%3==0;case n.Patterns.PATTERN110:return(e*i%2+e*i%3)%2==0;case n.Patterns.PATTERN111:return(e*i%3+(e+i)%2)%2==0;default:throw new Error("bad maskPattern:"+t)}}n.isValid=function(t){return null!=t&&""!==t&&!isNaN(t)&&t>=0&&t<=7},n.from=function(t){return n.isValid(t)?parseInt(t,10):void 0},n.getPenaltyN1=function(t){for(var e=t.size,n=0,r=0,o=0,a=null,s=null,l=0;l<e;l++){r=o=0,a=s=null;for(var c=0;c<e;c++){var u=t.get(l,c);u===a?r++:(r>=5&&(n+=i.N1+(r-5)),a=u,r=1),(u=t.get(c,l))===s?o++:(o>=5&&(n+=i.N1+(o-5)),s=u,o=1)}r>=5&&(n+=i.N1+(r-5)),o>=5&&(n+=i.N1+(o-5))}return n},n.getPenaltyN2=function(t){for(var e=t.size,n=0,r=0;r<e-1;r++)for(var o=0;o<e-1;o++){var a=t.get(r,o)+t.get(r,o+1)+t.get(r+1,o)+t.get(r+1,o+1);4!==a&&0!==a||n++}return n*i.N2},n.getPenaltyN3=function(t){for(var e=t.size,n=0,r=0,o=0,a=0;a<e;a++){r=o=0;for(var s=0;s<e;s++)r=r<<1&2047|t.get(a,s),s>=10&&(1488===r||93===r)&&n++,o=o<<1&2047|t.get(s,a),s>=10&&(1488===o||93===o)&&n++}return n*i.N3},n.getPenaltyN4=function(t){for(var e=0,n=t.data.length,r=0;r<n;r++)e+=t.data[r];return Math.abs(Math.ceil(100*e/n/5)-10)*i.N4},n.applyMask=function(t,e){for(var n=e.size,i=0;i<n;i++)for(var o=0;o<n;o++)e.isReserved(o,i)||e.xor(o,i,r(t,o,i))},n.getBestMask=function(t,e){for(var i=Object.keys(n.Patterns).length,r=0,o=1/0,a=0;a<i;a++){e(a),n.applyMask(a,t);var s=n.getPenaltyN1(t)+n.getPenaltyN2(t)+n.getPenaltyN3(t)+n.getPenaltyN4(t);n.applyMask(a,t),s<o&&(o=s,r=a)}return r}},{}],14:[function(t,e,n){var i=t("./version-check"),r=t("./regex");function o(t){if("string"!=typeof t)throw new Error("Param is not a string");switch(t.toLowerCase()){case"numeric":return n.NUMERIC;case"alphanumeric":return n.ALPHANUMERIC;case"kanji":return n.KANJI;case"byte":return n.BYTE;default:throw new Error("Unknown mode: "+t)}}n.NUMERIC={id:"Numeric",bit:1,ccBits:[10,12,14]},n.ALPHANUMERIC={id:"Alphanumeric",bit:2,ccBits:[9,11,13]},n.BYTE={id:"Byte",bit:4,ccBits:[8,16,16]},n.KANJI={id:"Kanji",bit:8,ccBits:[8,10,12]},n.MIXED={bit:-1},n.getCharCountIndicator=function(t,e){if(!t.ccBits)throw new Error("Invalid mode: "+t);if(!i.isValid(e))throw new Error("Invalid version: "+e);return e>=1&&e<10?t.ccBits[0]:e<27?t.ccBits[1]:t.ccBits[2]},n.getBestModeForData=function(t){return r.testNumeric(t)?n.NUMERIC:r.testAlphanumeric(t)?n.ALPHANUMERIC:r.testKanji(t)?n.KANJI:n.BYTE},n.toString=function(t){if(t&&t.id)return t.id;throw new Error("Invalid mode")},n.isValid=function(t){return t&&t.bit&&t.ccBits},n.from=function(t,e){if(n.isValid(t))return t;try{return o(t)}catch(t){return e}}},{"./regex":19,"./version-check":22}],15:[function(t,e,n){var i=t("./mode");function r(t){this.mode=i.NUMERIC,this.data=t.toString()}r.getBitsLength=function(t){return 10*Math.floor(t/3)+(t%3?t%3*3+1:0)},r.prototype.getLength=function(){return this.data.length},r.prototype.getBitsLength=function(){return r.getBitsLength(this.data.length)},r.prototype.write=function(t){var e,n,i;for(e=0;e+3<=this.data.length;e+=3)n=this.data.substr(e,3),i=parseInt(n,10),t.put(i,10);var r=this.data.length-e;r>0&&(n=this.data.substr(e),i=parseInt(n,10),t.put(i,3*r+1))},e.exports=r},{"./mode":14}],16:[function(t,e,n){var i=t("../utils/buffer"),r=t("./galois-field");n.mul=function(t,e){for(var n=i.alloc(t.length+e.length-1),o=0;o<t.length;o++)for(var a=0;a<e.length;a++)n[o+a]^=r.mul(t[o],e[a]);return n},n.mod=function(t,e){for(var n=i.from(t);n.length-e.length>=0;){for(var o=n[0],a=0;a<e.length;a++)n[a]^=r.mul(e[a],o);for(var s=0;s<n.length&&0===n[s];)s++;n=n.slice(s)}return n},n.generateECPolynomial=function(t){for(var e=i.from([1]),o=0;o<t;o++)e=n.mul(e,[1,r.exp(o)]);return e}},{"../utils/buffer":28,"./galois-field":11}],17:[function(t,e,n){var i=t("../utils/buffer"),r=t("./utils"),o=t("./error-correction-level"),a=t("./bit-buffer"),s=t("./bit-matrix"),l=t("./alignment-pattern"),c=t("./finder-pattern"),u=t("./mask-pattern"),d=t("./error-correction-code"),h=t("./reed-solomon-encoder"),f=t("./version"),p=t("./format-info"),m=t("./mode"),v=t("./segments"),g=t("isarray");function y(t,e){for(var n=t.size,i=c.getPositions(e),r=0;r<i.length;r++)for(var o=i[r][0],a=i[r][1],s=-1;s<=7;s++)if(!(o+s<=-1||n<=o+s))for(var l=-1;l<=7;l++)a+l<=-1||n<=a+l||(s>=0&&s<=6&&(0===l||6===l)||l>=0&&l<=6&&(0===s||6===s)||s>=2&&s<=4&&l>=2&&l<=4?t.set(o+s,a+l,!0,!0):t.set(o+s,a+l,!1,!0))}function _(t){for(var e=t.size,n=8;n<e-8;n++){var i=n%2==0;t.set(n,6,i,!0),t.set(6,n,i,!0)}}function b(t,e){for(var n=l.getPositions(e),i=0;i<n.length;i++)for(var r=n[i][0],o=n[i][1],a=-2;a<=2;a++)for(var s=-2;s<=2;s++)-2===a||2===a||-2===s||2===s||0===a&&0===s?t.set(r+a,o+s,!0,!0):t.set(r+a,o+s,!1,!0)}function w(t,e){for(var n,i,r,o=t.size,a=f.getEncodedBits(e),s=0;s<18;s++)n=Math.floor(s/3),i=s%3+o-8-3,r=1==(a>>s&1),t.set(n,i,r,!0),t.set(i,n,r,!0)}function k(t,e,n){var i,r,o=t.size,a=p.getEncodedBits(e,n);for(i=0;i<15;i++)r=1==(a>>i&1),i<6?t.set(i,8,r,!0):i<8?t.set(i+1,8,r,!0):t.set(o-15+i,8,r,!0),i<8?t.set(8,o-i-1,r,!0):i<9?t.set(8,15-i-1+1,r,!0):t.set(8,15-i-1,r,!0);t.set(o-8,8,1,!0)}function x(t,e){for(var n=t.size,i=-1,r=n-1,o=7,a=0,s=n-1;s>0;s-=2)for(6===s&&s--;;){for(var l=0;l<2;l++)if(!t.isReserved(r,s-l)){var c=!1;a<e.length&&(c=1==(e[a]>>>o&1)),t.set(r,s-l,c),-1==--o&&(a++,o=7)}if((r+=i)<0||n<=r){r-=i,i=-i;break}}}function C(t,e,n){var i=new a;n.forEach((function(e){i.put(e.mode.bit,4),i.put(e.getLength(),m.getCharCountIndicator(e.mode,t)),e.write(i)}));var o=8*(r.getSymbolTotalCodewords(t)-d.getTotalCodewordsCount(t,e));for(i.getLengthInBits()+4<=o&&i.put(0,4);i.getLengthInBits()%8!=0;)i.putBit(0);for(var s=(o-i.getLengthInBits())/8,l=0;l<s;l++)i.put(l%2?17:236,8);return S(i,t,e)}function S(t,e,n){for(var o=r.getSymbolTotalCodewords(e),a=o-d.getTotalCodewordsCount(e,n),s=d.getBlocksCount(e,n),l=s-o%s,c=Math.floor(o/s),u=Math.floor(a/s),f=u+1,p=c-u,m=new h(p),v=0,g=new Array(s),y=new Array(s),_=0,b=i.from(t.buffer),w=0;w<s;w++){var k=w<l?u:f;g[w]=b.slice(v,v+k),y[w]=m.encode(g[w]),v+=k,_=Math.max(_,k)}var x,C,S=i.alloc(o),M=0;for(x=0;x<_;x++)for(C=0;C<s;C++)x<g[C].length&&(S[M++]=g[C][x]);for(x=0;x<p;x++)for(C=0;C<s;C++)S[M++]=y[C][x];return S}function M(t,e,n,i){var o;if(g(t))o=v.fromArray(t);else{if("string"!=typeof t)throw new Error("Invalid data");var a=e;if(!a){var l=v.rawSplit(t);a=f.getBestVersionForData(l,n)}o=v.fromString(t,a||40)}var c=f.getBestVersionForData(o,n);if(!c)throw new Error("The amount of data is too big to be stored in a QR Code");if(e){if(e<c)throw new Error("\nThe chosen QR Code version cannot contain this amount of data.\nMinimum version required to store current data is: "+c+".\n")}else e=c;var d=C(e,n,o),h=r.getSymbolSize(e),p=new s(h);return y(p,e),_(p),b(p,e),k(p,n,0),e>=7&&w(p,e),x(p,d),isNaN(i)&&(i=u.getBestMask(p,k.bind(null,p,n))),u.applyMask(i,p),k(p,n,i),{modules:p,version:e,errorCorrectionLevel:n,maskPattern:i,segments:o}}n.create=function(t,e){if(void 0===t||""===t)throw new Error("No input text");var n,i,a=o.M;return void 0!==e&&(a=o.from(e.errorCorrectionLevel,o.M),n=f.from(e.version),i=u.from(e.maskPattern),e.toSJISFunc&&r.setToSJISFunction(e.toSJISFunc)),M(t,n,a,i)}},{"../utils/buffer":28,"./alignment-pattern":2,"./bit-buffer":4,"./bit-matrix":5,"./error-correction-code":7,"./error-correction-level":8,"./finder-pattern":9,"./format-info":10,"./mask-pattern":13,"./mode":14,"./reed-solomon-encoder":18,"./segments":20,"./utils":21,"./version":23,isarray:33}],18:[function(t,e,n){var i=t("../utils/buffer"),r=t("./polynomial"),o=t("buffer").Buffer;function a(t){this.genPoly=void 0,this.degree=t,this.degree&&this.initialize(this.degree)}a.prototype.initialize=function(t){this.degree=t,this.genPoly=r.generateECPolynomial(this.degree)},a.prototype.encode=function(t){if(!this.genPoly)throw new Error("Encoder not initialized");var e=i.alloc(this.degree),n=o.concat([t,e],t.length+this.degree),a=r.mod(n,this.genPoly),s=this.degree-a.length;if(s>0){var l=i.alloc(this.degree);return a.copy(l,s),l}return a},e.exports=a},{"../utils/buffer":28,"./polynomial":16,buffer:30}],19:[function(t,e,n){var i="[0-9]+",r="[A-Z $%*+\\-./:]+",o="(?:[u3000-u303F]|[u3040-u309F]|[u30A0-u30FF]|[uFF00-uFFEF]|[u4E00-u9FAF]|[u2605-u2606]|[u2190-u2195]|u203B|[u2010u2015u2018u2019u2025u2026u201Cu201Du2225u2260]|[u0391-u0451]|[u00A7u00A8u00B1u00B4u00D7u00F7])+",a="(?:(?![A-Z0-9 $%*+\\-./:]|"+(o=o.replace(/u/g,"\\u"))+")(?:.|[\r\n]))+";n.KANJI=new RegExp(o,"g"),n.BYTE_KANJI=new RegExp("[^A-Z0-9 $%*+\\-./:]+","g"),n.BYTE=new RegExp(a,"g"),n.NUMERIC=new RegExp(i,"g"),n.ALPHANUMERIC=new RegExp(r,"g");var s=new RegExp("^"+o+"$"),l=new RegExp("^"+i+"$"),c=new RegExp("^[A-Z0-9 $%*+\\-./:]+$");n.testKanji=function(t){return s.test(t)},n.testNumeric=function(t){return l.test(t)},n.testAlphanumeric=function(t){return c.test(t)}},{}],20:[function(t,e,n){var i=t("./mode"),r=t("./numeric-data"),o=t("./alphanumeric-data"),a=t("./byte-data"),s=t("./kanji-data"),l=t("./regex"),c=t("./utils"),u=t("dijkstrajs");function d(t){return unescape(encodeURIComponent(t)).length}function h(t,e,n){for(var i,r=[];null!==(i=t.exec(n));)r.push({data:i[0],index:i.index,mode:e,length:i[0].length});return r}function f(t){var e,n,r=h(l.NUMERIC,i.NUMERIC,t),o=h(l.ALPHANUMERIC,i.ALPHANUMERIC,t);return c.isKanjiModeEnabled()?(e=h(l.BYTE,i.BYTE,t),n=h(l.KANJI,i.KANJI,t)):(e=h(l.BYTE_KANJI,i.BYTE,t),n=[]),r.concat(o,e,n).sort((function(t,e){return t.index-e.index})).map((function(t){return{data:t.data,mode:t.mode,length:t.length}}))}function p(t,e){switch(e){case i.NUMERIC:return r.getBitsLength(t);case i.ALPHANUMERIC:return o.getBitsLength(t);case i.KANJI:return s.getBitsLength(t);case i.BYTE:return a.getBitsLength(t)}}function m(t){return t.reduce((function(t,e){var n=t.length-1>=0?t[t.length-1]:null;return n&&n.mode===e.mode?(t[t.length-1].data+=e.data,t):(t.push(e),t)}),[])}function v(t){for(var e=[],n=0;n<t.length;n++){var r=t[n];switch(r.mode){case i.NUMERIC:e.push([r,{data:r.data,mode:i.ALPHANUMERIC,length:r.length},{data:r.data,mode:i.BYTE,length:r.length}]);break;case i.ALPHANUMERIC:e.push([r,{data:r.data,mode:i.BYTE,length:r.length}]);break;case i.KANJI:e.push([r,{data:r.data,mode:i.BYTE,length:d(r.data)}]);break;case i.BYTE:e.push([{data:r.data,mode:i.BYTE,length:d(r.data)}])}}return e}function g(t,e){for(var n={},r={start:{}},o=["start"],a=0;a<t.length;a++){for(var s=t[a],l=[],c=0;c<s.length;c++){var u=s[c],d=""+a+c;l.push(d),n[d]={node:u,lastCount:0},r[d]={};for(var h=0;h<o.length;h++){var f=o[h];n[f]&&n[f].node.mode===u.mode?(r[f][d]=p(n[f].lastCount+u.length,u.mode)-p(n[f].lastCount,u.mode),n[f].lastCount+=u.length):(n[f]&&(n[f].lastCount=u.length),r[f][d]=p(u.length,u.mode)+4+i.getCharCountIndicator(u.mode,e))}}o=l}for(h=0;h<o.length;h++)r[o[h]].end=0;return{map:r,table:n}}function y(t,e){var n,l=i.getBestModeForData(t);if((n=i.from(e,l))!==i.BYTE&&n.bit<l.bit)throw new Error('"'+t+'" cannot be encoded with mode '+i.toString(n)+".\n Suggested mode is: "+i.toString(l));switch(n!==i.KANJI||c.isKanjiModeEnabled()||(n=i.BYTE),n){case i.NUMERIC:return new r(t);case i.ALPHANUMERIC:return new o(t);case i.KANJI:return new s(t);case i.BYTE:return new a(t)}}n.fromArray=function(t){return t.reduce((function(t,e){return"string"==typeof e?t.push(y(e,null)):e.data&&t.push(y(e.data,e.mode)),t}),[])},n.fromString=function(t,e){for(var i=g(v(f(t,c.isKanjiModeEnabled())),e),r=u.find_path(i.map,"start","end"),o=[],a=1;a<r.length-1;a++)o.push(i.table[r[a]].node);return n.fromArray(m(o))},n.rawSplit=function(t){return n.fromArray(f(t,c.isKanjiModeEnabled()))}},{"./alphanumeric-data":3,"./byte-data":6,"./kanji-data":12,"./mode":14,"./numeric-data":15,"./regex":19,"./utils":21,dijkstrajs:31}],21:[function(t,e,n){var i,r=[0,26,44,70,100,134,172,196,242,292,346,404,466,532,581,655,733,815,901,991,1085,1156,1258,1364,1474,1588,1706,1828,1921,2051,2185,2323,2465,2611,2761,2876,3034,3196,3362,3532,3706];n.getSymbolSize=function(t){if(!t)throw new Error('"version" cannot be null or undefined');if(t<1||t>40)throw new Error('"version" should be in range from 1 to 40');return 4*t+17},n.getSymbolTotalCodewords=function(t){return r[t]},n.getBCHDigit=function(t){for(var e=0;0!==t;)e++,t>>>=1;return e},n.setToSJISFunction=function(t){if("function"!=typeof t)throw new Error('"toSJISFunc" is not a valid function.');i=t},n.isKanjiModeEnabled=function(){return void 0!==i},n.toSJIS=function(t){return i(t)}},{}],22:[function(t,e,n){n.isValid=function(t){return!isNaN(t)&&t>=1&&t<=40}},{}],23:[function(t,e,n){var i=t("./utils"),r=t("./error-correction-code"),o=t("./error-correction-level"),a=t("./mode"),s=t("./version-check"),l=t("isarray"),c=7973,u=i.getBCHDigit(c);function d(t,e,i){for(var r=1;r<=40;r++)if(e<=n.getCapacity(r,i,t))return r}function h(t,e){return a.getCharCountIndicator(t,e)+4}function f(t,e){var n=0;return t.forEach((function(t){var i=h(t.mode,e);n+=i+t.getBitsLength()})),n}function p(t,e){for(var i=1;i<=40;i++)if(f(t,i)<=n.getCapacity(i,e,a.MIXED))return i}n.from=function(t,e){return s.isValid(t)?parseInt(t,10):e},n.getCapacity=function(t,e,n){if(!s.isValid(t))throw new Error("Invalid QR Code version");void 0===n&&(n=a.BYTE);var o=8*(i.getSymbolTotalCodewords(t)-r.getTotalCodewordsCount(t,e));if(n===a.MIXED)return o;var l=o-h(n,t);switch(n){case a.NUMERIC:return Math.floor(l/10*3);case a.ALPHANUMERIC:return Math.floor(l/11*2);case a.KANJI:return Math.floor(l/13);case a.BYTE:default:return Math.floor(l/8)}},n.getBestVersionForData=function(t,e){var n,i=o.from(e,o.M);if(l(t)){if(t.length>1)return p(t,i);if(0===t.length)return 1;n=t[0]}else n=t;return d(n.mode,n.getLength(),i)},n.getEncodedBits=function(t){if(!s.isValid(t)||t<7)throw new Error("Invalid QR Code version");for(var e=t<<12;i.getBCHDigit(e)-u>=0;)e^=c<<i.getBCHDigit(e)-u;return t<<12|e}},{"./error-correction-code":7,"./error-correction-level":8,"./mode":14,"./utils":21,"./version-check":22,isarray:33}],24:[function(t,e,n){var i=t("./can-promise"),r=t("./core/qrcode"),o=t("./renderer/canvas"),a=t("./renderer/svg-tag.js");function s(t,e,n,o,a){var s=[].slice.call(arguments,1),l=s.length,c="function"==typeof s[l-1];if(!c&&!i())throw new Error("Callback required as last argument");if(!c){if(l<1)throw new Error("Too few arguments provided");return 1===l?(n=e,e=o=void 0):2!==l||e.getContext||(o=n,n=e,e=void 0),new Promise((function(i,a){try{var s=r.create(n,o);i(t(s,e,o))}catch(t){a(t)}}))}if(l<2)throw new Error("Too few arguments provided");2===l?(a=n,n=e,e=o=void 0):3===l&&(e.getContext&&void 0===a?(a=o,o=void 0):(a=o,o=n,n=e,e=void 0));try{var u=r.create(n,o);a(null,t(u,e,o))}catch(t){a(t)}}n.create=r.create,n.toCanvas=s.bind(null,o.render),n.toDataURL=s.bind(null,o.renderToDataURL),n.toString=s.bind(null,(function(t,e,n){return a.render(t,n)}))},{"./can-promise":1,"./core/qrcode":17,"./renderer/canvas":25,"./renderer/svg-tag.js":26}],25:[function(t,e,n){var i=t("./utils");function r(t,e,n){t.clearRect(0,0,e.width,e.height),e.style||(e.style={}),e.height=n,e.width=n,e.style.height=n+"px",e.style.width=n+"px"}function o(){try{return document.createElement("canvas")}catch(t){throw new Error("You need to specify a canvas element")}}n.render=function(t,e,n){var a=n,s=e;void 0!==a||e&&e.getContext||(a=e,e=void 0),e||(s=o()),a=i.getOptions(a);var l=i.getImageWidth(t.modules.size,a),c=s.getContext("2d"),u=c.createImageData(l,l);return i.qrToImageData(u.data,t,a),r(c,s,l),c.putImageData(u,0,0),s},n.renderToDataURL=function(t,e,i){var r=i;void 0!==r||e&&e.getContext||(r=e,e=void 0),r||(r={});var o=n.render(t,e,r),a=r.type||"image/png",s=r.rendererOpts||{};return o.toDataURL(a,s.quality)}},{"./utils":27}],26:[function(t,e,n){var i=t("./utils");function r(t,e){var n=t.a/255,i=e+'="'+t.hex+'"';return n<1?i+" "+e+'-opacity="'+n.toFixed(2).slice(1)+'"':i}function o(t,e,n){var i=t+e;return void 0!==n&&(i+=" "+n),i}function a(t,e,n){for(var i="",r=0,a=!1,s=0,l=0;l<t.length;l++){var c=Math.floor(l%e),u=Math.floor(l/e);c||a||(a=!0),t[l]?(s++,l>0&&c>0&&t[l-1]||(i+=a?o("M",c+n,.5+u+n):o("m",r,0),r=0,a=!1),c+1<e&&t[l+1]||(i+=o("h",s),s=0)):r++}return i}n.render=function(t,e,n){var o=i.getOptions(e),s=t.modules.size,l=t.modules.data,c=s+2*o.margin,u=o.color.light.a?"<path "+r(o.color.light,"fill")+' d="M0 0h'+c+"v"+c+'H0z"/>':"",d="<path "+r(o.color.dark,"stroke")+' d="'+a(l,s,o.margin)+'"/>',h='viewBox="0 0 '+c+" "+c+'"',f='<svg xmlns="http://www.w3.org/2000/svg" '+(o.width?'width="'+o.width+'" height="'+o.width+'" ':"")+h+' shape-rendering="crispEdges">'+u+d+"</svg>\n";return"function"==typeof n&&n(null,f),f}},{"./utils":27}],27:[function(t,e,n){function i(t){if("number"==typeof t&&(t=t.toString()),"string"!=typeof t)throw new Error("Color should be defined as hex string");var e=t.slice().replace("#","").split("");if(e.length<3||5===e.length||e.length>8)throw new Error("Invalid hex color: "+t);3!==e.length&&4!==e.length||(e=Array.prototype.concat.apply([],e.map((function(t){return[t,t]})))),6===e.length&&e.push("F","F");var n=parseInt(e.join(""),16);return{r:n>>24&255,g:n>>16&255,b:n>>8&255,a:255&n,hex:"#"+e.slice(0,6).join("")}}n.getOptions=function(t){t||(t={}),t.color||(t.color={});var e=void 0===t.margin||null===t.margin||t.margin<0?4:t.margin,n=t.width&&t.width>=21?t.width:void 0,r=t.scale||4;return{width:n,scale:n?4:r,margin:e,color:{dark:i(t.color.dark||"#000000ff"),light:i(t.color.light||"#ffffffff")},type:t.type,rendererOpts:t.rendererOpts||{}}},n.getScale=function(t,e){return e.width&&e.width>=t+2*e.margin?e.width/(t+2*e.margin):e.scale},n.getImageWidth=function(t,e){var i=n.getScale(t,e);return Math.floor((t+2*e.margin)*i)},n.qrToImageData=function(t,e,i){for(var r=e.modules.size,o=e.modules.data,a=n.getScale(r,i),s=Math.floor((r+2*i.margin)*a),l=i.margin*a,c=[i.color.light,i.color.dark],u=0;u<s;u++)for(var d=0;d<s;d++){var h=4*(u*s+d),f=i.color.light;u>=l&&d>=l&&u<s-l&&d<s-l&&(f=c[o[Math.floor((u-l)/a)*r+Math.floor((d-l)/a)]?1:0]),t[h++]=f.r,t[h++]=f.g,t[h++]=f.b,t[h]=f.a}}},{}],28:[function(t,e,n){var i=t("isarray");function r(){try{var t=new Uint8Array(1);return t.__proto__={__proto__:Uint8Array.prototype,foo:function(){return 42}},42===t.foo()}catch(t){return!1}}a.TYPED_ARRAY_SUPPORT=r();var o=a.TYPED_ARRAY_SUPPORT?2147483647:1073741823;function a(t,e,n){return a.TYPED_ARRAY_SUPPORT||this instanceof a?"number"==typeof t?u(this,t):_(this,t,e,n):new a(t,e,n)}function s(t){if(t>=o)throw new RangeError("Attempt to allocate Buffer larger than maximum size: 0x"+o.toString(16)+" bytes");return 0|t}function l(t){return t!=t}function c(t,e){var n;return a.TYPED_ARRAY_SUPPORT?(n=new Uint8Array(e)).__proto__=a.prototype:(null===(n=t)&&(n=new a(e)),n.length=e),n}function u(t,e){var n=c(t,e<0?0:0|s(e));if(!a.TYPED_ARRAY_SUPPORT)for(var i=0;i<e;++i)n[i]=0;return n}function d(t,e){var n=0|v(e),i=c(t,n),r=i.write(e);return r!==n&&(i=i.slice(0,r)),i}function h(t,e){for(var n=e.length<0?0:0|s(e.length),i=c(t,n),r=0;r<n;r+=1)i[r]=255&e[r];return i}function f(t,e,n,i){if(n<0||e.byteLength<n)throw new RangeError("'offset' is out of bounds");if(e.byteLength<n+(i||0))throw new RangeError("'length' is out of bounds");var r;return r=void 0===n&&void 0===i?new Uint8Array(e):void 0===i?new Uint8Array(e,n):new Uint8Array(e,n,i),a.TYPED_ARRAY_SUPPORT?r.__proto__=a.prototype:r=h(t,r),r}function p(t,e){if(a.isBuffer(e)){var n=0|s(e.length),i=c(t,n);return 0===i.length||e.copy(i,0,0,n),i}if(e){if("undefined"!=typeof ArrayBuffer&&e.buffer instanceof ArrayBuffer||"length"in e)return"number"!=typeof e.length||l(e.length)?c(t,0):h(t,e);if("Buffer"===e.type&&Array.isArray(e.data))return h(t,e.data)}throw new TypeError("First argument must be a string, Buffer, ArrayBuffer, Array, or array-like object.")}function m(t,e){var n;e=e||1/0;for(var i=t.length,r=null,o=[],a=0;a<i;++a){if((n=t.charCodeAt(a))>55295&&n<57344){if(!r){if(n>56319){(e-=3)>-1&&o.push(239,191,189);continue}if(a+1===i){(e-=3)>-1&&o.push(239,191,189);continue}r=n;continue}if(n<56320){(e-=3)>-1&&o.push(239,191,189),r=n;continue}n=65536+(r-55296<<10|n-56320)}else r&&(e-=3)>-1&&o.push(239,191,189);if(r=null,n<128){if((e-=1)<0)break;o.push(n)}else if(n<2048){if((e-=2)<0)break;o.push(n>>6|192,63&n|128)}else if(n<65536){if((e-=3)<0)break;o.push(n>>12|224,n>>6&63|128,63&n|128)}else{if(!(n<1114112))throw new Error("Invalid code point");if((e-=4)<0)break;o.push(n>>18|240,n>>12&63|128,n>>6&63|128,63&n|128)}}return o}function v(t){return a.isBuffer(t)?t.length:"undefined"!=typeof ArrayBuffer&&"function"==typeof ArrayBuffer.isView&&(ArrayBuffer.isView(t)||t instanceof ArrayBuffer)?t.byteLength:("string"!=typeof t&&(t=""+t),0===t.length?0:m(t).length)}function g(t,e,n,i){for(var r=0;r<i&&!(r+n>=e.length||r>=t.length);++r)e[r+n]=t[r];return r}function y(t,e,n,i){return g(m(e,t.length-n),t,n,i)}function _(t,e,n,i){if("number"==typeof e)throw new TypeError('"value" argument must not be a number');return"undefined"!=typeof ArrayBuffer&&e instanceof ArrayBuffer?f(t,e,n,i):"string"==typeof e?d(t,e):p(t,e)}a.TYPED_ARRAY_SUPPORT&&(a.prototype.__proto__=Uint8Array.prototype,a.__proto__=Uint8Array,"undefined"!=typeof Symbol&&Symbol.species&&a[Symbol.species]===a&&Object.defineProperty(a,Symbol.species,{value:null,configurable:!0,enumerable:!1,writable:!1})),a.prototype.write=function(t,e,n){void 0===e||void 0===n&&"string"==typeof e?(n=this.length,e=0):isFinite(e)&&(e|=0,isFinite(n)?n|=0:n=void 0);var i=this.length-e;if((void 0===n||n>i)&&(n=i),t.length>0&&(n<0||e<0)||e>this.length)throw new RangeError("Attempt to write outside buffer bounds");return y(this,t,e,n)},a.prototype.slice=function(t,e){var n,i=this.length;if((t=~~t)<0?(t+=i)<0&&(t=0):t>i&&(t=i),(e=void 0===e?i:~~e)<0?(e+=i)<0&&(e=0):e>i&&(e=i),e<t&&(e=t),a.TYPED_ARRAY_SUPPORT)(n=this.subarray(t,e)).__proto__=a.prototype;else{var r=e-t;n=new a(r,void 0);for(var o=0;o<r;++o)n[o]=this[o+t]}return n},a.prototype.copy=function(t,e,n,i){if(n||(n=0),i||0===i||(i=this.length),e>=t.length&&(e=t.length),e||(e=0),i>0&&i<n&&(i=n),i===n)return 0;if(0===t.length||0===this.length)return 0;if(e<0)throw new RangeError("targetStart out of bounds");if(n<0||n>=this.length)throw new RangeError("sourceStart out of bounds");if(i<0)throw new RangeError("sourceEnd out of bounds");i>this.length&&(i=this.length),t.length-e<i-n&&(i=t.length-e+n);var r,o=i-n;if(this===t&&n<e&&e<i)for(r=o-1;r>=0;--r)t[r+e]=this[r+n];else if(o<1e3||!a.TYPED_ARRAY_SUPPORT)for(r=0;r<o;++r)t[r+e]=this[r+n];else Uint8Array.prototype.set.call(t,this.subarray(n,n+o),e);return o},a.prototype.fill=function(t,e,n){if("string"==typeof t){if("string"==typeof e?(e=0,n=this.length):"string"==typeof n&&(n=this.length),1===t.length){var i=t.charCodeAt(0);i<256&&(t=i)}}else"number"==typeof t&&(t&=255);if(e<0||this.length<e||this.length<n)throw new RangeError("Out of range index");if(n<=e)return this;var r;if(e>>>=0,n=void 0===n?this.length:n>>>0,t||(t=0),"number"==typeof t)for(r=e;r<n;++r)this[r]=t;else{var o=a.isBuffer(t)?t:new a(t),s=o.length;for(r=0;r<n-e;++r)this[r+e]=o[r%s]}return this},a.concat=function(t,e){if(!i(t))throw new TypeError('"list" argument must be an Array of Buffers');if(0===t.length)return c(null,0);var n;if(void 0===e)for(e=0,n=0;n<t.length;++n)e+=t[n].length;var r=u(null,e),o=0;for(n=0;n<t.length;++n){var s=t[n];if(!a.isBuffer(s))throw new TypeError('"list" argument must be an Array of Buffers');s.copy(r,o),o+=s.length}return r},a.byteLength=v,a.prototype._isBuffer=!0,a.isBuffer=function(t){return!(null==t||!t._isBuffer)},e.exports.alloc=function(t){var e=new a(t);return e.fill(0),e},e.exports.from=function(t){return new a(t)}},{isarray:33}],29:[function(t,e,n){n.byteLength=u,n.toByteArray=h,n.fromByteArray=m;for(var i=[],r=[],o="undefined"!=typeof Uint8Array?Uint8Array:Array,a="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",s=0,l=a.length;s<l;++s)i[s]=a[s],r[a.charCodeAt(s)]=s;function c(t){var e=t.length;if(e%4>0)throw new Error("Invalid string. Length must be a multiple of 4");var n=t.indexOf("=");return-1===n&&(n=e),[n,n===e?0:4-n%4]}function u(t){var e=c(t),n=e[0],i=e[1];return 3*(n+i)/4-i}function d(t,e,n){return 3*(e+n)/4-n}function h(t){var e,n,i=c(t),a=i[0],s=i[1],l=new o(d(t,a,s)),u=0,h=s>0?a-4:a;for(n=0;n<h;n+=4)e=r[t.charCodeAt(n)]<<18|r[t.charCodeAt(n+1)]<<12|r[t.charCodeAt(n+2)]<<6|r[t.charCodeAt(n+3)],l[u++]=e>>16&255,l[u++]=e>>8&255,l[u++]=255&e;return 2===s&&(e=r[t.charCodeAt(n)]<<2|r[t.charCodeAt(n+1)]>>4,l[u++]=255&e),1===s&&(e=r[t.charCodeAt(n)]<<10|r[t.charCodeAt(n+1)]<<4|r[t.charCodeAt(n+2)]>>2,l[u++]=e>>8&255,l[u++]=255&e),l}function f(t){return i[t>>18&63]+i[t>>12&63]+i[t>>6&63]+i[63&t]}function p(t,e,n){for(var i,r=[],o=e;o<n;o+=3)i=(t[o]<<16&16711680)+(t[o+1]<<8&65280)+(255&t[o+2]),r.push(f(i));return r.join("")}function m(t){for(var e,n=t.length,r=n%3,o=[],a=16383,s=0,l=n-r;s<l;s+=a)o.push(p(t,s,s+a>l?l:s+a));return 1===r?(e=t[n-1],o.push(i[e>>2]+i[e<<4&63]+"==")):2===r&&(e=(t[n-2]<<8)+t[n-1],o.push(i[e>>10]+i[e>>4&63]+i[e<<2&63]+"=")),o.join("")}r["-".charCodeAt(0)]=62,r["_".charCodeAt(0)]=63},{}],30:[function(t,e,n){var i=t("base64-js"),r=t("ieee754"),o="function"==typeof Symbol&&"function"==typeof Symbol.for?Symbol.for("nodejs.util.inspect.custom"):null;n.Buffer=c,n.SlowBuffer=_,n.INSPECT_MAX_BYTES=50;var a=2147483647;function s(){try{var t=new Uint8Array(1),e={foo:function(){return 42}};return Object.setPrototypeOf(e,Uint8Array.prototype),Object.setPrototypeOf(t,e),42===t.foo()}catch(t){return!1}}function l(t){if(t>a)throw new RangeError('The value "'+t+'" is invalid for option "size"');var e=new Uint8Array(t);return Object.setPrototypeOf(e,c.prototype),e}function c(t,e,n){if("number"==typeof t){if("string"==typeof e)throw new TypeError('The "string" argument must be of type string. Received type number');return f(t)}return u(t,e,n)}function u(t,e,n){if("string"==typeof t)return p(t,e);if(ArrayBuffer.isView(t))return m(t);if(null==t)throw new TypeError("The first argument must be one of type string, Buffer, ArrayBuffer, Array, or Array-like Object. Received type "+typeof t);if(J(t,ArrayBuffer)||t&&J(t.buffer,ArrayBuffer))return v(t,e,n);if("number"==typeof t)throw new TypeError('The "value" argument must not be of type number. Received type number');var i=t.valueOf&&t.valueOf();if(null!=i&&i!==t)return c.from(i,e,n);var r=g(t);if(r)return r;if("undefined"!=typeof Symbol&&null!=Symbol.toPrimitive&&"function"==typeof t[Symbol.toPrimitive])return c.from(t[Symbol.toPrimitive]("string"),e,n);throw new TypeError("The first argument must be one of type string, Buffer, ArrayBuffer, Array, or Array-like Object. Received type "+typeof t)}function d(t){if("number"!=typeof t)throw new TypeError('"size" argument must be of type number');if(t<0)throw new RangeError('The value "'+t+'" is invalid for option "size"')}function h(t,e,n){return d(t),t<=0?l(t):void 0!==e?"string"==typeof n?l(t).fill(e,n):l(t).fill(e):l(t)}function f(t){return d(t),l(t<0?0:0|y(t))}function p(t,e){if("string"==typeof e&&""!==e||(e="utf8"),!c.isEncoding(e))throw new TypeError("Unknown encoding: "+e);var n=0|b(t,e),i=l(n),r=i.write(t,e);return r!==n&&(i=i.slice(0,r)),i}function m(t){for(var e=t.length<0?0:0|y(t.length),n=l(e),i=0;i<e;i+=1)n[i]=255&t[i];return n}function v(t,e,n){if(e<0||t.byteLength<e)throw new RangeError('"offset" is outside of buffer bounds');if(t.byteLength<e+(n||0))throw new RangeError('"length" is outside of buffer bounds');var i;return i=void 0===e&&void 0===n?new Uint8Array(t):void 0===n?new Uint8Array(t,e):new Uint8Array(t,e,n),Object.setPrototypeOf(i,c.prototype),i}function g(t){if(c.isBuffer(t)){var e=0|y(t.length),n=l(e);return 0===n.length||t.copy(n,0,0,e),n}return void 0!==t.length?"number"!=typeof t.length||Z(t.length)?l(0):m(t):"Buffer"===t.type&&Array.isArray(t.data)?m(t.data):void 0}function y(t){if(t>=a)throw new RangeError("Attempt to allocate Buffer larger than maximum size: 0x"+a.toString(16)+" bytes");return 0|t}function _(t){return+t!=t&&(t=0),c.alloc(+t)}function b(t,e){if(c.isBuffer(t))return t.length;if(ArrayBuffer.isView(t)||J(t,ArrayBuffer))return t.byteLength;if("string"!=typeof t)throw new TypeError('The "string" argument must be one of type string, Buffer, or ArrayBuffer. Received type '+typeof t);var n=t.length,i=arguments.length>2&&!0===arguments[2];if(!i&&0===n)return 0;for(var r=!1;;)switch(e){case"ascii":case"latin1":case"binary":return n;case"utf8":case"utf-8":return U(t).length;case"ucs2":case"ucs-2":case"utf16le":case"utf-16le":return 2*n;case"hex":return n>>>1;case"base64":return G(t).length;default:if(r)return i?-1:U(t).length;e=(""+e).toLowerCase(),r=!0}}function w(t,e,n){var i=!1;if((void 0===e||e<0)&&(e=0),e>this.length)return"";if((void 0===n||n>this.length)&&(n=this.length),n<=0)return"";if((n>>>=0)<=(e>>>=0))return"";for(t||(t="utf8");;)switch(t){case"hex":return I(this,e,n);case"utf8":case"utf-8":return A(this,e,n);case"ascii":return q(this,e,n);case"latin1":case"binary":return R(this,e,n);case"base64":return E(this,e,n);case"ucs2":case"ucs-2":case"utf16le":case"utf-16le":return N(this,e,n);default:if(i)throw new TypeError("Unknown encoding: "+t);t=(t+"").toLowerCase(),i=!0}}function k(t,e,n){var i=t[e];t[e]=t[n],t[n]=i}function x(t,e,n,i,r){if(0===t.length)return-1;if("string"==typeof n?(i=n,n=0):n>2147483647?n=2147483647:n<-2147483648&&(n=-2147483648),Z(n=+n)&&(n=r?0:t.length-1),n<0&&(n=t.length+n),n>=t.length){if(r)return-1;n=t.length-1}else if(n<0){if(!r)return-1;n=0}if("string"==typeof e&&(e=c.from(e,i)),c.isBuffer(e))return 0===e.length?-1:C(t,e,n,i,r);if("number"==typeof e)return e&=255,"function"==typeof Uint8Array.prototype.indexOf?r?Uint8Array.prototype.indexOf.call(t,e,n):Uint8Array.prototype.lastIndexOf.call(t,e,n):C(t,[e],n,i,r);throw new TypeError("val must be string, number or Buffer")}function C(t,e,n,i,r){var o,a=1,s=t.length,l=e.length;if(void 0!==i&&("ucs2"===(i=String(i).toLowerCase())||"ucs-2"===i||"utf16le"===i||"utf-16le"===i)){if(t.length<2||e.length<2)return-1;a=2,s/=2,l/=2,n/=2}function c(t,e){return 1===a?t[e]:t.readUInt16BE(e*a)}if(r){var u=-1;for(o=n;o<s;o++)if(c(t,o)===c(e,-1===u?0:o-u)){if(-1===u&&(u=o),o-u+1===l)return u*a}else-1!==u&&(o-=o-u),u=-1}else for(n+l>s&&(n=s-l),o=n;o>=0;o--){for(var d=!0,h=0;h<l;h++)if(c(t,o+h)!==c(e,h)){d=!1;break}if(d)return o}return-1}function S(t,e,n,i){n=Number(n)||0;var r=t.length-n;i?(i=Number(i))>r&&(i=r):i=r;var o=e.length;i>o/2&&(i=o/2);for(var a=0;a<i;++a){var s=parseInt(e.substr(2*a,2),16);if(Z(s))return a;t[n+a]=s}return a}function M(t,e,n,i){return K(U(e,t.length-n),t,n,i)}function T(t,e,n,i){return K(Y(e),t,n,i)}function P(t,e,n,i){return T(t,e,n,i)}function O(t,e,n,i){return K(G(e),t,n,i)}function B(t,e,n,i){return K(Q(e,t.length-n),t,n,i)}function E(t,e,n){return 0===e&&n===t.length?i.fromByteArray(t):i.fromByteArray(t.slice(e,n))}function A(t,e,n){n=Math.min(t.length,n);for(var i=[],r=e;r<n;){var o,a,s,l,c=t[r],u=null,d=c>239?4:c>223?3:c>191?2:1;if(r+d<=n)switch(d){case 1:c<128&&(u=c);break;case 2:128==(192&(o=t[r+1]))&&(l=(31&c)<<6|63&o)>127&&(u=l);break;case 3:o=t[r+1],a=t[r+2],128==(192&o)&&128==(192&a)&&(l=(15&c)<<12|(63&o)<<6|63&a)>2047&&(l<55296||l>57343)&&(u=l);break;case 4:o=t[r+1],a=t[r+2],s=t[r+3],128==(192&o)&&128==(192&a)&&128==(192&s)&&(l=(15&c)<<18|(63&o)<<12|(63&a)<<6|63&s)>65535&&l<1114112&&(u=l)}null===u?(u=65533,d=1):u>65535&&(u-=65536,i.push(u>>>10&1023|55296),u=56320|1023&u),i.push(u),r+=d}return L(i)}n.kMaxLength=a,c.TYPED_ARRAY_SUPPORT=s(),c.TYPED_ARRAY_SUPPORT||"undefined"==typeof console||"function"!=typeof console.error||console.error("This browser lacks typed array (Uint8Array) support which is required by `buffer` v5.x. Use `buffer` v4.x if you require old browser support."),Object.defineProperty(c.prototype,"parent",{enumerable:!0,get:function(){if(c.isBuffer(this))return this.buffer}}),Object.defineProperty(c.prototype,"offset",{enumerable:!0,get:function(){if(c.isBuffer(this))return this.byteOffset}}),"undefined"!=typeof Symbol&&null!=Symbol.species&&c[Symbol.species]===c&&Object.defineProperty(c,Symbol.species,{value:null,configurable:!0,enumerable:!1,writable:!1}),c.poolSize=8192,c.from=function(t,e,n){return u(t,e,n)},Object.setPrototypeOf(c.prototype,Uint8Array.prototype),Object.setPrototypeOf(c,Uint8Array),c.alloc=function(t,e,n){return h(t,e,n)},c.allocUnsafe=function(t){return f(t)},c.allocUnsafeSlow=function(t){return f(t)},c.isBuffer=function(t){return null!=t&&!0===t._isBuffer&&t!==c.prototype},c.compare=function(t,e){if(J(t,Uint8Array)&&(t=c.from(t,t.offset,t.byteLength)),J(e,Uint8Array)&&(e=c.from(e,e.offset,e.byteLength)),!c.isBuffer(t)||!c.isBuffer(e))throw new TypeError('The "buf1", "buf2" arguments must be one of type Buffer or Uint8Array');if(t===e)return 0;for(var n=t.length,i=e.length,r=0,o=Math.min(n,i);r<o;++r)if(t[r]!==e[r]){n=t[r],i=e[r];break}return n<i?-1:i<n?1:0},c.isEncoding=function(t){switch(String(t).toLowerCase()){case"hex":case"utf8":case"utf-8":case"ascii":case"latin1":case"binary":case"base64":case"ucs2":case"ucs-2":case"utf16le":case"utf-16le":return!0;default:return!1}},c.concat=function(t,e){if(!Array.isArray(t))throw new TypeError('"list" argument must be an Array of Buffers');if(0===t.length)return c.alloc(0);var n;if(void 0===e)for(e=0,n=0;n<t.length;++n)e+=t[n].length;var i=c.allocUnsafe(e),r=0;for(n=0;n<t.length;++n){var o=t[n];if(J(o,Uint8Array)&&(o=c.from(o)),!c.isBuffer(o))throw new TypeError('"list" argument must be an Array of Buffers');o.copy(i,r),r+=o.length}return i},c.byteLength=b,c.prototype._isBuffer=!0,c.prototype.swap16=function(){var t=this.length;if(t%2!=0)throw new RangeError("Buffer size must be a multiple of 16-bits");for(var e=0;e<t;e+=2)k(this,e,e+1);return this},c.prototype.swap32=function(){var t=this.length;if(t%4!=0)throw new RangeError("Buffer size must be a multiple of 32-bits");for(var e=0;e<t;e+=4)k(this,e,e+3),k(this,e+1,e+2);return this},c.prototype.swap64=function(){var t=this.length;if(t%8!=0)throw new RangeError("Buffer size must be a multiple of 64-bits");for(var e=0;e<t;e+=8)k(this,e,e+7),k(this,e+1,e+6),k(this,e+2,e+5),k(this,e+3,e+4);return this},c.prototype.toString=function(){var t=this.length;return 0===t?"":0===arguments.length?A(this,0,t):w.apply(this,arguments)},c.prototype.toLocaleString=c.prototype.toString,c.prototype.equals=function(t){if(!c.isBuffer(t))throw new TypeError("Argument must be a Buffer");return this===t||0===c.compare(this,t)},c.prototype.inspect=function(){var t="",e=n.INSPECT_MAX_BYTES;return t=this.toString("hex",0,e).replace(/(.{2})/g,"$1 ").trim(),this.length>e&&(t+=" ... "),"<Buffer "+t+">"},o&&(c.prototype[o]=c.prototype.inspect),c.prototype.compare=function(t,e,n,i,r){if(J(t,Uint8Array)&&(t=c.from(t,t.offset,t.byteLength)),!c.isBuffer(t))throw new TypeError('The "target" argument must be one of type Buffer or Uint8Array. Received type '+typeof t);if(void 0===e&&(e=0),void 0===n&&(n=t?t.length:0),void 0===i&&(i=0),void 0===r&&(r=this.length),e<0||n>t.length||i<0||r>this.length)throw new RangeError("out of range index");if(i>=r&&e>=n)return 0;if(i>=r)return-1;if(e>=n)return 1;if(this===t)return 0;for(var o=(r>>>=0)-(i>>>=0),a=(n>>>=0)-(e>>>=0),s=Math.min(o,a),l=this.slice(i,r),u=t.slice(e,n),d=0;d<s;++d)if(l[d]!==u[d]){o=l[d],a=u[d];break}return o<a?-1:a<o?1:0},c.prototype.includes=function(t,e,n){return-1!==this.indexOf(t,e,n)},c.prototype.indexOf=function(t,e,n){return x(this,t,e,n,!0)},c.prototype.lastIndexOf=function(t,e,n){return x(this,t,e,n,!1)},c.prototype.write=function(t,e,n,i){if(void 0===e)i="utf8",n=this.length,e=0;else if(void 0===n&&"string"==typeof e)i=e,n=this.length,e=0;else{if(!isFinite(e))throw new Error("Buffer.write(string, encoding, offset[, length]) is no longer supported");e>>>=0,isFinite(n)?(n>>>=0,void 0===i&&(i="utf8")):(i=n,n=void 0)}var r=this.length-e;if((void 0===n||n>r)&&(n=r),t.length>0&&(n<0||e<0)||e>this.length)throw new RangeError("Attempt to write outside buffer bounds");i||(i="utf8");for(var o=!1;;)switch(i){case"hex":return S(this,t,e,n);case"utf8":case"utf-8":return M(this,t,e,n);case"ascii":return T(this,t,e,n);case"latin1":case"binary":return P(this,t,e,n);case"base64":return O(this,t,e,n);case"ucs2":case"ucs-2":case"utf16le":case"utf-16le":return B(this,t,e,n);default:if(o)throw new TypeError("Unknown encoding: "+i);i=(""+i).toLowerCase(),o=!0}},c.prototype.toJSON=function(){return{type:"Buffer",data:Array.prototype.slice.call(this._arr||this,0)}};var D=4096;function L(t){var e=t.length;if(e<=D)return String.fromCharCode.apply(String,t);for(var n="",i=0;i<e;)n+=String.fromCharCode.apply(String,t.slice(i,i+=D));return n}function q(t,e,n){var i="";n=Math.min(t.length,n);for(var r=e;r<n;++r)i+=String.fromCharCode(127&t[r]);return i}function R(t,e,n){var i="";n=Math.min(t.length,n);for(var r=e;r<n;++r)i+=String.fromCharCode(t[r]);return i}function I(t,e,n){var i=t.length;(!e||e<0)&&(e=0),(!n||n<0||n>i)&&(n=i);for(var r="",o=e;o<n;++o)r+=X[t[o]];return r}function N(t,e,n){for(var i=t.slice(e,n),r="",o=0;o<i.length;o+=2)r+=String.fromCharCode(i[o]+256*i[o+1]);return r}function F(t,e,n){if(t%1!=0||t<0)throw new RangeError("offset is not uint");if(t+e>n)throw new RangeError("Trying to access beyond buffer length")}function $(t,e,n,i,r,o){if(!c.isBuffer(t))throw new TypeError('"buffer" argument must be a Buffer instance');if(e>r||e<o)throw new RangeError('"value" argument is out of bounds');if(n+i>t.length)throw new RangeError("Index out of range")}function j(t,e,n,i,r,o){if(n+i>t.length)throw new RangeError("Index out of range");if(n<0)throw new RangeError("Index out of range")}function z(t,e,n,i,o){return e=+e,n>>>=0,o||j(t,e,n,4),r.write(t,e,n,i,23,4),n+4}function V(t,e,n,i,o){return e=+e,n>>>=0,o||j(t,e,n,8),r.write(t,e,n,i,52,8),n+8}c.prototype.slice=function(t,e){var n=this.length;(t=~~t)<0?(t+=n)<0&&(t=0):t>n&&(t=n),(e=void 0===e?n:~~e)<0?(e+=n)<0&&(e=0):e>n&&(e=n),e<t&&(e=t);var i=this.subarray(t,e);return Object.setPrototypeOf(i,c.prototype),i},c.prototype.readUIntLE=function(t,e,n){t>>>=0,e>>>=0,n||F(t,e,this.length);for(var i=this[t],r=1,o=0;++o<e&&(r*=256);)i+=this[t+o]*r;return i},c.prototype.readUIntBE=function(t,e,n){t>>>=0,e>>>=0,n||F(t,e,this.length);for(var i=this[t+--e],r=1;e>0&&(r*=256);)i+=this[t+--e]*r;return i},c.prototype.readUInt8=function(t,e){return t>>>=0,e||F(t,1,this.length),this[t]},c.prototype.readUInt16LE=function(t,e){return t>>>=0,e||F(t,2,this.length),this[t]|this[t+1]<<8},c.prototype.readUInt16BE=function(t,e){return t>>>=0,e||F(t,2,this.length),this[t]<<8|this[t+1]},c.prototype.readUInt32LE=function(t,e){return t>>>=0,e||F(t,4,this.length),(this[t]|this[t+1]<<8|this[t+2]<<16)+16777216*this[t+3]},c.prototype.readUInt32BE=function(t,e){return t>>>=0,e||F(t,4,this.length),16777216*this[t]+(this[t+1]<<16|this[t+2]<<8|this[t+3])},c.prototype.readIntLE=function(t,e,n){t>>>=0,e>>>=0,n||F(t,e,this.length);for(var i=this[t],r=1,o=0;++o<e&&(r*=256);)i+=this[t+o]*r;return i>=(r*=128)&&(i-=Math.pow(2,8*e)),i},c.prototype.readIntBE=function(t,e,n){t>>>=0,e>>>=0,n||F(t,e,this.length);for(var i=e,r=1,o=this[t+--i];i>0&&(r*=256);)o+=this[t+--i]*r;return o>=(r*=128)&&(o-=Math.pow(2,8*e)),o},c.prototype.readInt8=function(t,e){return t>>>=0,e||F(t,1,this.length),128&this[t]?-1*(255-this[t]+1):this[t]},c.prototype.readInt16LE=function(t,e){t>>>=0,e||F(t,2,this.length);var n=this[t]|this[t+1]<<8;return 32768&n?4294901760|n:n},c.prototype.readInt16BE=function(t,e){t>>>=0,e||F(t,2,this.length);var n=this[t+1]|this[t]<<8;return 32768&n?4294901760|n:n},c.prototype.readInt32LE=function(t,e){return t>>>=0,e||F(t,4,this.length),this[t]|this[t+1]<<8|this[t+2]<<16|this[t+3]<<24},c.prototype.readInt32BE=function(t,e){return t>>>=0,e||F(t,4,this.length),this[t]<<24|this[t+1]<<16|this[t+2]<<8|this[t+3]},c.prototype.readFloatLE=function(t,e){return t>>>=0,e||F(t,4,this.length),r.read(this,t,!0,23,4)},c.prototype.readFloatBE=function(t,e){return t>>>=0,e||F(t,4,this.length),r.read(this,t,!1,23,4)},c.prototype.readDoubleLE=function(t,e){return t>>>=0,e||F(t,8,this.length),r.read(this,t,!0,52,8)},c.prototype.readDoubleBE=function(t,e){return t>>>=0,e||F(t,8,this.length),r.read(this,t,!1,52,8)},c.prototype.writeUIntLE=function(t,e,n,i){t=+t,e>>>=0,n>>>=0,i||$(this,t,e,n,Math.pow(2,8*n)-1,0);var r=1,o=0;for(this[e]=255&t;++o<n&&(r*=256);)this[e+o]=t/r&255;return e+n},c.prototype.writeUIntBE=function(t,e,n,i){t=+t,e>>>=0,n>>>=0,i||$(this,t,e,n,Math.pow(2,8*n)-1,0);var r=n-1,o=1;for(this[e+r]=255&t;--r>=0&&(o*=256);)this[e+r]=t/o&255;return e+n},c.prototype.writeUInt8=function(t,e,n){return t=+t,e>>>=0,n||$(this,t,e,1,255,0),this[e]=255&t,e+1},c.prototype.writeUInt16LE=function(t,e,n){return t=+t,e>>>=0,n||$(this,t,e,2,65535,0),this[e]=255&t,this[e+1]=t>>>8,e+2},c.prototype.writeUInt16BE=function(t,e,n){return t=+t,e>>>=0,n||$(this,t,e,2,65535,0),this[e]=t>>>8,this[e+1]=255&t,e+2},c.prototype.writeUInt32LE=function(t,e,n){return t=+t,e>>>=0,n||$(this,t,e,4,4294967295,0),this[e+3]=t>>>24,this[e+2]=t>>>16,this[e+1]=t>>>8,this[e]=255&t,e+4},c.prototype.writeUInt32BE=function(t,e,n){return t=+t,e>>>=0,n||$(this,t,e,4,4294967295,0),this[e]=t>>>24,this[e+1]=t>>>16,this[e+2]=t>>>8,this[e+3]=255&t,e+4},c.prototype.writeIntLE=function(t,e,n,i){if(t=+t,e>>>=0,!i){var r=Math.pow(2,8*n-1);$(this,t,e,n,r-1,-r)}var o=0,a=1,s=0;for(this[e]=255&t;++o<n&&(a*=256);)t<0&&0===s&&0!==this[e+o-1]&&(s=1),this[e+o]=(t/a>>0)-s&255;return e+n},c.prototype.writeIntBE=function(t,e,n,i){if(t=+t,e>>>=0,!i){var r=Math.pow(2,8*n-1);$(this,t,e,n,r-1,-r)}var o=n-1,a=1,s=0;for(this[e+o]=255&t;--o>=0&&(a*=256);)t<0&&0===s&&0!==this[e+o+1]&&(s=1),this[e+o]=(t/a>>0)-s&255;return e+n},c.prototype.writeInt8=function(t,e,n){return t=+t,e>>>=0,n||$(this,t,e,1,127,-128),t<0&&(t=255+t+1),this[e]=255&t,e+1},c.prototype.writeInt16LE=function(t,e,n){return t=+t,e>>>=0,n||$(this,t,e,2,32767,-32768),this[e]=255&t,this[e+1]=t>>>8,e+2},c.prototype.writeInt16BE=function(t,e,n){return t=+t,e>>>=0,n||$(this,t,e,2,32767,-32768),this[e]=t>>>8,this[e+1]=255&t,e+2},c.prototype.writeInt32LE=function(t,e,n){return t=+t,e>>>=0,n||$(this,t,e,4,2147483647,-2147483648),this[e]=255&t,this[e+1]=t>>>8,this[e+2]=t>>>16,this[e+3]=t>>>24,e+4},c.prototype.writeInt32BE=function(t,e,n){return t=+t,e>>>=0,n||$(this,t,e,4,2147483647,-2147483648),t<0&&(t=4294967295+t+1),this[e]=t>>>24,this[e+1]=t>>>16,this[e+2]=t>>>8,this[e+3]=255&t,e+4},c.prototype.writeFloatLE=function(t,e,n){return z(this,t,e,!0,n)},c.prototype.writeFloatBE=function(t,e,n){return z(this,t,e,!1,n)},c.prototype.writeDoubleLE=function(t,e,n){return V(this,t,e,!0,n)},c.prototype.writeDoubleBE=function(t,e,n){return V(this,t,e,!1,n)},c.prototype.copy=function(t,e,n,i){if(!c.isBuffer(t))throw new TypeError("argument should be a Buffer");if(n||(n=0),i||0===i||(i=this.length),e>=t.length&&(e=t.length),e||(e=0),i>0&&i<n&&(i=n),i===n)return 0;if(0===t.length||0===this.length)return 0;if(e<0)throw new RangeError("targetStart out of bounds");if(n<0||n>=this.length)throw new RangeError("Index out of range");if(i<0)throw new RangeError("sourceEnd out of bounds");i>this.length&&(i=this.length),t.length-e<i-n&&(i=t.length-e+n);var r=i-n;if(this===t&&"function"==typeof Uint8Array.prototype.copyWithin)this.copyWithin(e,n,i);else if(this===t&&n<e&&e<i)for(var o=r-1;o>=0;--o)t[o+e]=this[o+n];else Uint8Array.prototype.set.call(t,this.subarray(n,i),e);return r},c.prototype.fill=function(t,e,n,i){if("string"==typeof t){if("string"==typeof e?(i=e,e=0,n=this.length):"string"==typeof n&&(i=n,n=this.length),void 0!==i&&"string"!=typeof i)throw new TypeError("encoding must be a string");if("string"==typeof i&&!c.isEncoding(i))throw new TypeError("Unknown encoding: "+i);if(1===t.length){var r=t.charCodeAt(0);("utf8"===i&&r<128||"latin1"===i)&&(t=r)}}else"number"==typeof t?t&=255:"boolean"==typeof t&&(t=Number(t));if(e<0||this.length<e||this.length<n)throw new RangeError("Out of range index");if(n<=e)return this;var o;if(e>>>=0,n=void 0===n?this.length:n>>>0,t||(t=0),"number"==typeof t)for(o=e;o<n;++o)this[o]=t;else{var a=c.isBuffer(t)?t:c.from(t,i),s=a.length;if(0===s)throw new TypeError('The value "'+t+'" is invalid for argument "value"');for(o=0;o<n-e;++o)this[o+e]=a[o%s]}return this};var H=/[^+/0-9A-Za-z-_]/g;function W(t){if((t=(t=t.split("=")[0]).trim().replace(H,"")).length<2)return"";for(;t.length%4!=0;)t+="=";return t}function U(t,e){var n;e=e||1/0;for(var i=t.length,r=null,o=[],a=0;a<i;++a){if((n=t.charCodeAt(a))>55295&&n<57344){if(!r){if(n>56319){(e-=3)>-1&&o.push(239,191,189);continue}if(a+1===i){(e-=3)>-1&&o.push(239,191,189);continue}r=n;continue}if(n<56320){(e-=3)>-1&&o.push(239,191,189),r=n;continue}n=65536+(r-55296<<10|n-56320)}else r&&(e-=3)>-1&&o.push(239,191,189);if(r=null,n<128){if((e-=1)<0)break;o.push(n)}else if(n<2048){if((e-=2)<0)break;o.push(n>>6|192,63&n|128)}else if(n<65536){if((e-=3)<0)break;o.push(n>>12|224,n>>6&63|128,63&n|128)}else{if(!(n<1114112))throw new Error("Invalid code point");if((e-=4)<0)break;o.push(n>>18|240,n>>12&63|128,n>>6&63|128,63&n|128)}}return o}function Y(t){for(var e=[],n=0;n<t.length;++n)e.push(255&t.charCodeAt(n));return e}function Q(t,e){for(var n,i,r,o=[],a=0;a<t.length&&!((e-=2)<0);++a)i=(n=t.charCodeAt(a))>>8,r=n%256,o.push(r),o.push(i);return o}function G(t){return i.toByteArray(W(t))}function K(t,e,n,i){for(var r=0;r<i&&!(r+n>=e.length||r>=t.length);++r)e[r+n]=t[r];return r}function J(t,e){return t instanceof e||null!=t&&null!=t.constructor&&null!=t.constructor.name&&t.constructor.name===e.name}function Z(t){return t!=t}var X=function(){for(var t="0123456789abcdef",e=new Array(256),n=0;n<16;++n)for(var i=16*n,r=0;r<16;++r)e[i+r]=t[n]+t[r];return e}()},{"base64-js":29,ieee754:32}],31:[function(t,e,n){var i={single_source_shortest_paths:function(t,e,n){var r={},o={};o[e]=0;var a,s,l,c,u,d,h,f=i.PriorityQueue.make();for(f.push(e,0);!f.empty();)for(l in s=(a=f.pop()).value,c=a.cost,u=t[s]||{})u.hasOwnProperty(l)&&(d=c+u[l],h=o[l],(void 0===o[l]||h>d)&&(o[l]=d,f.push(l,d),r[l]=s));if(void 0!==n&&void 0===o[n]){var p=["Could not find a path from ",e," to ",n,"."].join("");throw new Error(p)}return r},extract_shortest_path_from_predecessor_list:function(t,e){for(var n=[],i=e;i;)n.push(i),t[i],i=t[i];return n.reverse(),n},find_path:function(t,e,n){var r=i.single_source_shortest_paths(t,e,n);return i.extract_shortest_path_from_predecessor_list(r,n)},PriorityQueue:{make:function(t){var e,n=i.PriorityQueue,r={};for(e in t=t||{},n)n.hasOwnProperty(e)&&(r[e]=n[e]);return r.queue=[],r.sorter=t.sorter||n.default_sorter,r},default_sorter:function(t,e){return t.cost-e.cost},push:function(t,e){var n={value:t,cost:e};this.queue.push(n),this.queue.sort(this.sorter)},pop:function(){return this.queue.shift()},empty:function(){return 0===this.queue.length}}};void 0!==e&&(e.exports=i)},{}],32:[function(t,e,n){n.read=function(t,e,n,i,r){var o,a,s=8*r-i-1,l=(1<<s)-1,c=l>>1,u=-7,d=n?r-1:0,h=n?-1:1,f=t[e+d];for(d+=h,o=f&(1<<-u)-1,f>>=-u,u+=s;u>0;o=256*o+t[e+d],d+=h,u-=8);for(a=o&(1<<-u)-1,o>>=-u,u+=i;u>0;a=256*a+t[e+d],d+=h,u-=8);if(0===o)o=1-c;else{if(o===l)return a?NaN:1/0*(f?-1:1);a+=Math.pow(2,i),o-=c}return(f?-1:1)*a*Math.pow(2,o-i)},n.write=function(t,e,n,i,r,o){var a,s,l,c=8*o-r-1,u=(1<<c)-1,d=u>>1,h=23===r?Math.pow(2,-24)-Math.pow(2,-77):0,f=i?0:o-1,p=i?1:-1,m=e<0||0===e&&1/e<0?1:0;for(e=Math.abs(e),isNaN(e)||e===1/0?(s=isNaN(e)?1:0,a=u):(a=Math.floor(Math.log(e)/Math.LN2),e*(l=Math.pow(2,-a))<1&&(a--,l*=2),(e+=a+d>=1?h/l:h*Math.pow(2,1-d))*l>=2&&(a++,l/=2),a+d>=u?(s=0,a=u):a+d>=1?(s=(e*l-1)*Math.pow(2,r),a+=d):(s=e*Math.pow(2,d-1)*Math.pow(2,r),a=0));r>=8;t[n+f]=255&s,f+=p,s/=256,r-=8);for(a=a<<r|s,c+=r;c>0;t[n+f]=255&a,f+=p,a/=256,c-=8);t[n+f-p]|=128*m}},{}],33:[function(t,e,n){var i={}.toString;e.exports=Array.isArray||function(t){return"[object Array]"==i.call(t)}},{}]},{},[24])(24)}));return{name:"qrcode",props:{value:null,options:Object,tag:{type:String,default:"canvas"}},render:function(t){return t(this.tag,this.$slots.default)},watch:{$props:{deep:!0,immediate:!0,handler:function(){this.$el&&this.generate()}}},methods:{generate:function(){var t=this,n=this.options,i=this.tag,r=String(this.value);"canvas"===i?e.toCanvas(this.$el,r,n,(function(t){if(t)throw t})):"img"===i?e.toDataURL(r,n,(function(e,n){if(e)throw e;t.$el.src=n})):e.toString(r,n,(function(e,n){if(e)throw e;t.$el.innerHTML=n}))}},mounted:function(){this.generate()}}})),
/*!
 * vuex v3.5.1
 * (c) 2020 Evan You
 * @license MIT
 */
function(t,e){"object"==typeof exports&&"undefined"!=typeof module?module.exports=e():"function"==typeof define&&define.amd?define(e):(t=t||self).Vuex=e()}(this,(function(){"use strict";var t=("undefined"!=typeof window?window:"undefined"!=typeof global?global:{}).__VUE_DEVTOOLS_GLOBAL_HOOK__;function e(t,n){if(void 0===n&&(n=[]),null===t||"object"!=typeof t)return t;var i,r=(i=function(e){return e.original===t},n.filter(i)[0]);if(r)return r.copy;var o=Array.isArray(t)?[]:{};return n.push({original:t,copy:o}),Object.keys(t).forEach((function(i){o[i]=e(t[i],n)})),o}function n(t,e){Object.keys(t).forEach((function(n){return e(t[n],n)}))}function i(t){return null!==t&&"object"==typeof t}function r(t,e){if(!t)throw new Error("[vuex] "+e)}var o=function(t,e){this.runtime=e,this._children=Object.create(null),this._rawModule=t;var n=t.state;this.state=("function"==typeof n?n():n)||{}},a={namespaced:{configurable:!0}};a.namespaced.get=function(){return!!this._rawModule.namespaced},o.prototype.addChild=function(t,e){this._children[t]=e},o.prototype.removeChild=function(t){delete this._children[t]},o.prototype.getChild=function(t){return this._children[t]},o.prototype.hasChild=function(t){return t in this._children},o.prototype.update=function(t){this._rawModule.namespaced=t.namespaced,t.actions&&(this._rawModule.actions=t.actions),t.mutations&&(this._rawModule.mutations=t.mutations),t.getters&&(this._rawModule.getters=t.getters)},o.prototype.forEachChild=function(t){n(this._children,t)},o.prototype.forEachGetter=function(t){this._rawModule.getters&&n(this._rawModule.getters,t)},o.prototype.forEachAction=function(t){this._rawModule.actions&&n(this._rawModule.actions,t)},o.prototype.forEachMutation=function(t){this._rawModule.mutations&&n(this._rawModule.mutations,t)},Object.defineProperties(o.prototype,a);var s=function(t){this.register([],t,!1)};function l(t,e,n){if(h(t,n),e.update(n),n.modules)for(var i in n.modules){if(!e.getChild(i))return void console.warn("[vuex] trying to add a new module '"+i+"' on hot reloading, manual reload is needed");l(t.concat(i),e.getChild(i),n.modules[i])}}s.prototype.get=function(t){return t.reduce((function(t,e){return t.getChild(e)}),this.root)},s.prototype.getNamespace=function(t){var e=this.root;return t.reduce((function(t,n){return t+((e=e.getChild(n)).namespaced?n+"/":"")}),"")},s.prototype.update=function(t){l([],this.root,t)},s.prototype.register=function(t,e,i){var r=this;void 0===i&&(i=!0),h(t,e);var a=new o(e,i);0===t.length?this.root=a:this.get(t.slice(0,-1)).addChild(t[t.length-1],a);e.modules&&n(e.modules,(function(e,n){r.register(t.concat(n),e,i)}))},s.prototype.unregister=function(t){var e=this.get(t.slice(0,-1)),n=t[t.length-1],i=e.getChild(n);i?i.runtime&&e.removeChild(n):console.warn("[vuex] trying to unregister module '"+n+"', which is not registered")},s.prototype.isRegistered=function(t){var e=this.get(t.slice(0,-1)),n=t[t.length-1];return e.hasChild(n)};var c,u={assert:function(t){return"function"==typeof t},expected:"function"},d={getters:u,mutations:u,actions:{assert:function(t){return"function"==typeof t||"object"==typeof t&&"function"==typeof t.handler},expected:'function or object with "handler" function'}};function h(t,e){Object.keys(d).forEach((function(i){if(e[i]){var o=d[i];n(e[i],(function(e,n){r(o.assert(e),function(t,e,n,i,r){var o=e+" should be "+r+' but "'+e+"."+n+'"';t.length>0&&(o+=' in module "'+t.join(".")+'"');return o+=" is "+JSON.stringify(i)+".",o}(t,i,n,e,o.expected))}))}}))}var f=function e(n){var i=this;void 0===n&&(n={}),!c&&"undefined"!=typeof window&&window.Vue&&w(window.Vue),r(c,"must call Vue.use(Vuex) before creating a store instance."),r("undefined"!=typeof Promise,"vuex requires a Promise polyfill in this browser."),r(this instanceof e,"store must be called with the new operator.");var o=n.plugins;void 0===o&&(o=[]);var a=n.strict;void 0===a&&(a=!1),this._committing=!1,this._actions=Object.create(null),this._actionSubscribers=[],this._mutations=Object.create(null),this._wrappedGetters=Object.create(null),this._modules=new s(n),this._modulesNamespaceMap=Object.create(null),this._subscribers=[],this._watcherVM=new c,this._makeLocalGettersCache=Object.create(null);var l=this,u=this.dispatch,d=this.commit;this.dispatch=function(t,e){return u.call(l,t,e)},this.commit=function(t,e,n){return d.call(l,t,e,n)},this.strict=a;var h=this._modules.root.state;y(this,h,[],this._modules.root),g(this,h),o.forEach((function(t){return t(i)})),(void 0!==n.devtools?n.devtools:c.config.devtools)&&function(e){t&&(e._devtoolHook=t,t.emit("vuex:init",e),t.on("vuex:travel-to-state",(function(t){e.replaceState(t)})),e.subscribe((function(e,n){t.emit("vuex:mutation",e,n)}),{prepend:!0}),e.subscribeAction((function(e,n){t.emit("vuex:action",e,n)}),{prepend:!0}))}(this)},p={state:{configurable:!0}};function m(t,e,n){return e.indexOf(t)<0&&(n&&n.prepend?e.unshift(t):e.push(t)),function(){var n=e.indexOf(t);n>-1&&e.splice(n,1)}}function v(t,e){t._actions=Object.create(null),t._mutations=Object.create(null),t._wrappedGetters=Object.create(null),t._modulesNamespaceMap=Object.create(null);var n=t.state;y(t,n,[],t._modules.root,!0),g(t,n,e)}function g(t,e,i){var o=t._vm;t.getters={},t._makeLocalGettersCache=Object.create(null);var a=t._wrappedGetters,s={};n(a,(function(e,n){s[n]=function(t,e){return function(){return t(e)}}(e,t),Object.defineProperty(t.getters,n,{get:function(){return t._vm[n]},enumerable:!0})}));var l=c.config.silent;c.config.silent=!0,t._vm=new c({data:{$$state:e},computed:s}),c.config.silent=l,t.strict&&function(t){t._vm.$watch((function(){return this._data.$$state}),(function(){r(t._committing,"do not mutate vuex store state outside mutation handlers.")}),{deep:!0,sync:!0})}(t),o&&(i&&t._withCommit((function(){o._data.$$state=null})),c.nextTick((function(){return o.$destroy()})))}function y(t,e,n,i,r){var o=!n.length,a=t._modules.getNamespace(n);if(i.namespaced&&(t._modulesNamespaceMap[a]&&console.error("[vuex] duplicate namespace "+a+" for the namespaced module "+n.join("/")),t._modulesNamespaceMap[a]=i),!o&&!r){var s=_(e,n.slice(0,-1)),l=n[n.length-1];t._withCommit((function(){l in s&&console.warn('[vuex] state field "'+l+'" was overridden by a module with the same name at "'+n.join(".")+'"'),c.set(s,l,i.state)}))}var u=i.context=function(t,e,n){var i=""===e,r={dispatch:i?t.dispatch:function(n,i,r){var o=b(n,i,r),a=o.payload,s=o.options,l=o.type;if(s&&s.root||(l=e+l,t._actions[l]))return t.dispatch(l,a);console.error("[vuex] unknown local action type: "+o.type+", global type: "+l)},commit:i?t.commit:function(n,i,r){var o=b(n,i,r),a=o.payload,s=o.options,l=o.type;s&&s.root||(l=e+l,t._mutations[l])?t.commit(l,a,s):console.error("[vuex] unknown local mutation type: "+o.type+", global type: "+l)}};return Object.defineProperties(r,{getters:{get:i?function(){return t.getters}:function(){return function(t,e){if(!t._makeLocalGettersCache[e]){var n={},i=e.length;Object.keys(t.getters).forEach((function(r){if(r.slice(0,i)===e){var o=r.slice(i);Object.defineProperty(n,o,{get:function(){return t.getters[r]},enumerable:!0})}})),t._makeLocalGettersCache[e]=n}return t._makeLocalGettersCache[e]}(t,e)}},state:{get:function(){return _(t.state,n)}}}),r}(t,a,n);i.forEachMutation((function(e,n){!function(t,e,n,i){var r=t._mutations[e]||(t._mutations[e]=[]);r.push((function(e){n.call(t,i.state,e)}))}(t,a+n,e,u)})),i.forEachAction((function(e,n){var i=e.root?n:a+n,r=e.handler||e;!function(t,e,n,i){var r=t._actions[e]||(t._actions[e]=[]);r.push((function(e){var r,o=n.call(t,{dispatch:i.dispatch,commit:i.commit,getters:i.getters,state:i.state,rootGetters:t.getters,rootState:t.state},e);return(r=o)&&"function"==typeof r.then||(o=Promise.resolve(o)),t._devtoolHook?o.catch((function(e){throw t._devtoolHook.emit("vuex:error",e),e})):o}))}(t,i,r,u)})),i.forEachGetter((function(e,n){!function(t,e,n,i){if(t._wrappedGetters[e])return void console.error("[vuex] duplicate getter key: "+e);t._wrappedGetters[e]=function(t){return n(i.state,i.getters,t.state,t.getters)}}(t,a+n,e,u)})),i.forEachChild((function(i,o){y(t,e,n.concat(o),i,r)}))}function _(t,e){return e.reduce((function(t,e){return t[e]}),t)}function b(t,e,n){return i(t)&&t.type&&(n=e,e=t,t=t.type),r("string"==typeof t,"expects string as the type, but found "+typeof t+"."),{type:t,payload:e,options:n}}function w(t){c&&t===c?console.error("[vuex] already installed. Vue.use(Vuex) should be called only once."):function(t){if(Number(t.version.split(".")[0])>=2)t.mixin({beforeCreate:n});else{var e=t.prototype._init;t.prototype._init=function(t){void 0===t&&(t={}),t.init=t.init?[n].concat(t.init):n,e.call(this,t)}}function n(){var t=this.$options;t.store?this.$store="function"==typeof t.store?t.store():t.store:t.parent&&t.parent.$store&&(this.$store=t.parent.$store)}}(c=t)}p.state.get=function(){return this._vm._data.$$state},p.state.set=function(t){r(!1,"use store.replaceState() to explicit replace store state.")},f.prototype.commit=function(t,e,n){var i=this,r=b(t,e,n),o=r.type,a=r.payload,s=r.options,l={type:o,payload:a},c=this._mutations[o];c?(this._withCommit((function(){c.forEach((function(t){t(a)}))})),this._subscribers.slice().forEach((function(t){return t(l,i.state)})),s&&s.silent&&console.warn("[vuex] mutation type: "+o+". Silent option has been removed. Use the filter functionality in the vue-devtools")):console.error("[vuex] unknown mutation type: "+o)},f.prototype.dispatch=function(t,e){var n=this,i=b(t,e),r=i.type,o=i.payload,a={type:r,payload:o},s=this._actions[r];if(s){try{this._actionSubscribers.slice().filter((function(t){return t.before})).forEach((function(t){return t.before(a,n.state)}))}catch(t){console.warn("[vuex] error in before action subscribers: "),console.error(t)}var l=s.length>1?Promise.all(s.map((function(t){return t(o)}))):s[0](o);return new Promise((function(t,e){l.then((function(e){try{n._actionSubscribers.filter((function(t){return t.after})).forEach((function(t){return t.after(a,n.state)}))}catch(t){console.warn("[vuex] error in after action subscribers: "),console.error(t)}t(e)}),(function(t){try{n._actionSubscribers.filter((function(t){return t.error})).forEach((function(e){return e.error(a,n.state,t)}))}catch(t){console.warn("[vuex] error in error action subscribers: "),console.error(t)}e(t)}))}))}console.error("[vuex] unknown action type: "+r)},f.prototype.subscribe=function(t,e){return m(t,this._subscribers,e)},f.prototype.subscribeAction=function(t,e){return m("function"==typeof t?{before:t}:t,this._actionSubscribers,e)},f.prototype.watch=function(t,e,n){var i=this;return r("function"==typeof t,"store.watch only accepts a function."),this._watcherVM.$watch((function(){return t(i.state,i.getters)}),e,n)},f.prototype.replaceState=function(t){var e=this;this._withCommit((function(){e._vm._data.$$state=t}))},f.prototype.registerModule=function(t,e,n){void 0===n&&(n={}),"string"==typeof t&&(t=[t]),r(Array.isArray(t),"module path must be a string or an Array."),r(t.length>0,"cannot register the root module by using registerModule."),this._modules.register(t,e),y(this,this.state,t,this._modules.get(t),n.preserveState),g(this,this.state)},f.prototype.unregisterModule=function(t){var e=this;"string"==typeof t&&(t=[t]),r(Array.isArray(t),"module path must be a string or an Array."),this._modules.unregister(t),this._withCommit((function(){var n=_(e.state,t.slice(0,-1));c.delete(n,t[t.length-1])})),v(this)},f.prototype.hasModule=function(t){return"string"==typeof t&&(t=[t]),r(Array.isArray(t),"module path must be a string or an Array."),this._modules.isRegistered(t)},f.prototype.hotUpdate=function(t){this._modules.update(t),v(this,!0)},f.prototype._withCommit=function(t){var e=this._committing;this._committing=!0,t(),this._committing=e},Object.defineProperties(f.prototype,p);var k=P((function(t,e){var n={};return T(e)||console.error("[vuex] mapState: mapper parameter must be either an Array or an Object"),M(e).forEach((function(e){var i=e.key,r=e.val;n[i]=function(){var e=this.$store.state,n=this.$store.getters;if(t){var i=O(this.$store,"mapState",t);if(!i)return;e=i.context.state,n=i.context.getters}return"function"==typeof r?r.call(this,e,n):e[r]},n[i].vuex=!0})),n})),x=P((function(t,e){var n={};return T(e)||console.error("[vuex] mapMutations: mapper parameter must be either an Array or an Object"),M(e).forEach((function(e){var i=e.key,r=e.val;n[i]=function(){for(var e=[],n=arguments.length;n--;)e[n]=arguments[n];var i=this.$store.commit;if(t){var o=O(this.$store,"mapMutations",t);if(!o)return;i=o.context.commit}return"function"==typeof r?r.apply(this,[i].concat(e)):i.apply(this.$store,[r].concat(e))}})),n})),C=P((function(t,e){var n={};return T(e)||console.error("[vuex] mapGetters: mapper parameter must be either an Array or an Object"),M(e).forEach((function(e){var i=e.key,r=e.val;r=t+r,n[i]=function(){if(!t||O(this.$store,"mapGetters",t)){if(r in this.$store.getters)return this.$store.getters[r];console.error("[vuex] unknown getter: "+r)}},n[i].vuex=!0})),n})),S=P((function(t,e){var n={};return T(e)||console.error("[vuex] mapActions: mapper parameter must be either an Array or an Object"),M(e).forEach((function(e){var i=e.key,r=e.val;n[i]=function(){for(var e=[],n=arguments.length;n--;)e[n]=arguments[n];var i=this.$store.dispatch;if(t){var o=O(this.$store,"mapActions",t);if(!o)return;i=o.context.dispatch}return"function"==typeof r?r.apply(this,[i].concat(e)):i.apply(this.$store,[r].concat(e))}})),n}));function M(t){return T(t)?Array.isArray(t)?t.map((function(t){return{key:t,val:t}})):Object.keys(t).map((function(e){return{key:e,val:t[e]}})):[]}function T(t){return Array.isArray(t)||i(t)}function P(t){return function(e,n){return"string"!=typeof e?(n=e,e=""):"/"!==e.charAt(e.length-1)&&(e+="/"),t(e,n)}}function O(t,e,n){var i=t._modulesNamespaceMap[n];return i||console.error("[vuex] module namespace not found in "+e+"(): "+n),i}function B(t,e,n){var i=n?t.groupCollapsed:t.group;try{i.call(t,e)}catch(n){t.log(e)}}function E(t){try{t.groupEnd()}catch(e){t.log("—— log end ——")}}function A(){var t=new Date;return" @ "+D(t.getHours(),2)+":"+D(t.getMinutes(),2)+":"+D(t.getSeconds(),2)+"."+D(t.getMilliseconds(),3)}function D(t,e){return n="0",i=e-t.toString().length,new Array(i+1).join(n)+t;var n,i}return{Store:f,install:w,version:"3.5.1",mapState:k,mapMutations:x,mapGetters:C,mapActions:S,createNamespacedHelpers:function(t){return{mapState:k.bind(null,t),mapGetters:C.bind(null,t),mapMutations:x.bind(null,t),mapActions:S.bind(null,t)}},createLogger:function(t){void 0===t&&(t={});var n=t.collapsed;void 0===n&&(n=!0);var i=t.filter;void 0===i&&(i=function(t,e,n){return!0});var r=t.transformer;void 0===r&&(r=function(t){return t});var o=t.mutationTransformer;void 0===o&&(o=function(t){return t});var a=t.actionFilter;void 0===a&&(a=function(t,e){return!0});var s=t.actionTransformer;void 0===s&&(s=function(t){return t});var l=t.logMutations;void 0===l&&(l=!0);var c=t.logActions;void 0===c&&(c=!0);var u=t.logger;return void 0===u&&(u=console),function(t){var d=e(t.state);void 0!==u&&(l&&t.subscribe((function(t,a){var s=e(a);if(i(t,d,s)){var l=A(),c=o(t),h="mutation "+t.type+l;B(u,h,n),u.log("%c prev state","color: #9E9E9E; font-weight: bold",r(d)),u.log("%c mutation","color: #03A9F4; font-weight: bold",c),u.log("%c next state","color: #4CAF50; font-weight: bold",r(s)),E(u)}d=s})),c&&t.subscribeAction((function(t,e){if(a(t,e)){var i=A(),r=s(t),o="action "+t.type+i;B(u,o,n),u.log("%c action","color: #03A9F4; font-weight: bold",r),E(u)}})))}}}})),function(t){"function"==typeof define&&define.amd?define(t):t()}((function(){"use strict";function t(t){return"function"==typeof t}"undefined"!=typeof window&&function(t){[Element.prototype,CharacterData.prototype,DocumentType.prototype].forEach((function(t){t.hasOwnProperty("remove")||Object.defineProperty(t,"remove",{configurable:!0,enumerable:!0,writable:!0,value:function(){null!==this.parentNode&&this.parentNode.removeChild(this)}})}));try{new MouseEvent("test")}catch(n){var e=function(e,n){n=n||{bubbles:!1,cancelable:!1};var i=document.createEvent("MouseEvent");return i.initMouseEvent(e,n.bubbles,n.cancelable,t,0,n.screenX||0,n.screenY||0,n.clientX||0,n.clientY||0,n.ctrlKey||!1,n.altKey||!1,n.shiftKey||!1,n.metaKey||!1,n.button||0,n.relatedTarget||null),i};e.prototype=Event.prototype,t.MouseEvent=e}"function"!=typeof Object.assign&&Object.defineProperty(Object,"assign",{value:function(t,e){var n=arguments;if(null==t)throw new TypeError("Cannot convert undefined or null to object");for(var i=Object(t),r=1;r<arguments.length;r++){var o=n[r];if(null!=o)for(var a in o)Object.prototype.hasOwnProperty.call(o,a)&&(i[a]=o[a])}return i},writable:!0,configurable:!0}),String.prototype.startsWith||Object.defineProperty(String.prototype,"startsWith",{value:function(t,e){var n=e>0?0|e:0;return this.substring(n,n+t.length)===t}}),String.prototype.endsWith||(String.prototype.endsWith=function(t,e){return(void 0===e||e>this.length)&&(e=this.length),this.substring(e-t.length,e)===t}),Number.isInteger||(Number.isInteger=function(t){return"number"==typeof t&&isFinite(t)&&Math.floor(t)===t}),Array.prototype.includes||(Array.prototype.includes=function(t){return!!~this.indexOf(t)}),Element.prototype.matches||(Element.prototype.matches=Element.prototype.msMatchesSelector||Element.prototype.webkitMatchesSelector),Element.prototype.closest||(Element.prototype.closest=function(t){var e=this;do{if(e.matches(t))return e;e=e.parentElement||e.parentNode}while(null!==e&&1===e.nodeType);return null}),Array.prototype.find||Object.defineProperty(Array.prototype,"find",{value:function(t){if(null==this)throw TypeError('"this" is null or not defined');var e=Object(this),n=e.length>>>0;if("function"!=typeof t)throw TypeError("predicate must be a function");for(var i=arguments[1],r=0;r<n;){var o=e[r];if(t.call(i,o,r,e))return o;r++}},configurable:!0,writable:!0}),Array.prototype.findIndex||Object.defineProperty(Array.prototype,"findIndex",{value:function(t){if(null==this)throw new TypeError("Array.prototype.findIndex called on null or undefined");if("function"!=typeof t)throw new TypeError("predicate must be a function");for(var e=Object(this),n=e.length>>>0,i=arguments[1],r=0;r<n;r++)if(t.call(i,e[r],r,e))return r;return-1}}),"classList"in SVGElement.prototype||Object.defineProperty(SVGElement.prototype,"classList",{get:function(){var t=this;return{contains:function(e){return-1!==t.className.baseVal.split(" ").indexOf(e)},add:function(e){return t.setAttribute("class",t.getAttribute("class")+" "+e)},remove:function(e){var n=t.getAttribute("class").replace(new RegExp("(\\s|^)".concat(e,"(\\s|$)"),"g"),"$2");t.classList.contains(e)&&t.setAttribute("class",n)},toggle:function(t){this.contains(t)?this.remove(t):this.add(t)}}}})}(window);var e=Array.isArray?Array.isArray:function(t){return"[object Array]"===Object.prototype.toString.call(t)},n=0,i=void 0,r=void 0,o=function(t,e){h[n]=t,h[n+1]=e,2===(n+=2)&&(r?r(f):y())},a="undefined"!=typeof window?window:void 0,s=a||{},l=s.MutationObserver||s.WebKitMutationObserver,c="undefined"==typeof self&&"undefined"!=typeof process&&"[object process]"==={}.toString.call(process),u="undefined"!=typeof Uint8ClampedArray&&"undefined"!=typeof importScripts&&"undefined"!=typeof MessageChannel;function d(){var t=setTimeout;return function(){return t(f,1)}}var h=new Array(1e3);function f(){for(var t=0;t<n;t+=2)(0,h[t])(h[t+1]),h[t]=void 0,h[t+1]=void 0;n=0}var p,m,v,g,y=void 0;function _(t,e){var n=this,i=new this.constructor(k);void 0===i[w]&&I(i);var r=n._state;if(r){var a=arguments[r-1];o((function(){return q(r,i,a,n._result)}))}else D(n,i,t,e);return i}function b(t){if(t&&"object"==typeof t&&t.constructor===this)return t;var e=new this(k);return O(e,t),e}c?y=function(){return process.nextTick(f)}:l?(m=0,v=new l(f),g=document.createTextNode(""),v.observe(g,{characterData:!0}),y=function(){g.data=m=++m%2}):u?((p=new MessageChannel).port1.onmessage=f,y=function(){return p.port2.postMessage(0)}):y=void 0===a&&"function"==typeof require?function(){try{var t=Function("return this")().require("vertx");return void 0!==(i=t.runOnLoop||t.runOnContext)?function(){i(f)}:d()}catch(t){return d()}}():d();var w=Math.random().toString(36).substring(2);function k(){}var x=void 0,C=1,S=2,M={error:null};function T(t){try{return t.then}catch(t){return M.error=t,M}}function P(e,n,i){n.constructor===e.constructor&&i===_&&n.constructor.resolve===b?function(t,e){e._state===C?E(t,e._result):e._state===S?A(t,e._result):D(e,void 0,(function(e){return O(t,e)}),(function(e){return A(t,e)}))}(e,n):i===M?(A(e,M.error),M.error=null):void 0===i?E(e,n):t(i)?function(t,e,n){o((function(t){var i=!1,r=function(t,e,n,i){try{t.call(e,n,i)}catch(t){return t}}(n,e,(function(n){i||(i=!0,e!==n?O(t,n):E(t,n))}),(function(e){i||(i=!0,A(t,e))}),t._label);!i&&r&&(i=!0,A(t,r))}),t)}(e,n,i):E(e,n)}function O(t,e){var n,i;t===e?A(t,new TypeError("You cannot resolve a promise with itself")):(i=typeof(n=e),null===n||"object"!==i&&"function"!==i?E(t,e):P(t,e,T(e)))}function B(t){t._onerror&&t._onerror(t._result),L(t)}function E(t,e){t._state===x&&(t._result=e,t._state=C,0!==t._subscribers.length&&o(L,t))}function A(t,e){t._state===x&&(t._state=S,t._result=e,o(B,t))}function D(t,e,n,i){var r=t._subscribers,a=r.length;t._onerror=null,r[a]=e,r[a+C]=n,r[a+S]=i,0===a&&t._state&&o(L,t)}function L(t){var e=t._subscribers,n=t._state;if(0!==e.length){for(var i=void 0,r=void 0,o=t._result,a=0;a<e.length;a+=3)i=e[a],r=e[a+n],i?q(n,i,r,o):r(o);t._subscribers.length=0}}function q(e,n,i,r){var o=t(i),a=void 0,s=void 0,l=void 0,c=void 0;if(o){if((a=function(t,e){try{return t(e)}catch(t){return M.error=t,M}}(i,r))===M?(c=!0,s=a.error,a.error=null):l=!0,n===a)return void A(n,new TypeError("A promises callback cannot return that same promise."))}else a=r,l=!0;n._state!==x||(o&&l?O(n,a):c?A(n,s):e===C?E(n,a):e===S&&A(n,a))}var R=0;function I(t){t[w]=id++,t._state=void 0,t._result=void 0,t._subscribers=[]}var N=function(){function t(t,n){this._instanceConstructor=t,this.promise=new t(k),this.promise[w]||I(this.promise),e(n)?(this.length=n.length,this._remaining=n.length,this._result=new Array(this.length),0===this.length?E(this.promise,this._result):(this.length=this.length||0,this._enumerate(n),0===this._remaining&&E(this.promise,this._result))):A(this.promise,new Error("Array Methods must be provided an Array"))}return t.prototype._enumerate=function(t){for(var e=0;this._state===x&&e<t.length;e++)this._eachEntry(t[e],e)},t.prototype._eachEntry=function(t,e){var n=this._instanceConstructor,i=n.resolve;if(i===b){var r=T(t);if(r===_&&t._state!==x)this._settledAt(t._state,e,t._result);else if("function"!=typeof r)this._remaining--,this._result[e]=t;else if(n===F){var o=new n(k);P(o,t,r),this._willSettleAt(o,e)}else this._willSettleAt(new n((function(e){return e(t)})),e)}else this._willSettleAt(i(t),e)},t.prototype._settledAt=function(t,e,n){var i=this.promise;i._state===x&&(this._remaining--,t===S?A(i,n):this._result[e]=n),0===this._remaining&&E(i,this._result)},t.prototype._willSettleAt=function(t,e){var n=this;D(t,void 0,(function(t){return n._settledAt(C,e,t)}),(function(t){return n._settledAt(S,e,t)}))},t}(),F=function(){function t(e){this[w]=R++,this._result=this._state=void 0,this._subscribers=[],k!==e&&("function"!=typeof e&&function(){throw new TypeError("You must pass a resolver function as the first argument to the promise constructor")}(),this instanceof t?function(t,e){try{e((function(e){O(t,e)}),(function(e){A(t,e)}))}catch(e){A(t,e)}}(this,e):function(){throw new TypeError("Failed to construct 'Promise': Please use the 'new' operator, this object constructor cannot be called as a function.")}())}return t.prototype.catch=function(t){return this.then(null,t)},t.prototype.finally=function(t){var e=this.constructor;return this.then((function(n){return e.resolve(t()).then((function(){return n}))}),(function(n){return e.resolve(t()).then((function(){throw n}))}))},t}();F.prototype.then=_,F.all=function(t){return new N(this,t).promise},F.race=function(t){var n=this;return e(t)?new n((function(e,i){for(var r=t.length,o=0;o<r;o++)n.resolve(t[o]).then(e,i)})):new n((function(t,e){return e(new TypeError("You must pass an array to race."))}))},F.resolve=b,F.reject=function(t){var e=new this(k);return A(e,t),e},F._setScheduler=function(t){r=t},F._setAsap=function(t){o=t},F._asap=o,function(){var t=void 0;if("undefined"!=typeof global)t=global;else if("undefined"!=typeof self)t=self;else try{t=Function("return this")()}catch(t){throw new Error("polyfill failed because global object is unavailable in this environment")}var e=t.Promise;if(e){var n=null;try{n=Object.prototype.toString.call(e.resolve())}catch(t){}if("[object Promise]"===n&&!e.cast)return}t.Promise=F}()})),
/*!
 * Quasar Framework v1.13.2
 * (c) 2015-present Razvan Stoenescu
 * Released under the MIT License.
 */
function(t,e){"object"==typeof exports&&"undefined"!=typeof module?module.exports=e(require("vue")):"function"==typeof define&&define.amd?define(["vue"],e):(t=t||self).Quasar=e(t.Vue)}(this,(function(t){"use strict";t=t&&Object.prototype.hasOwnProperty.call(t,"default")?t.default:t;var e,n="1.13.2",i="undefined"==typeof window,r=!1,o=i,a=!1;var s=!1===i&&("ontouchstart"in window||window.navigator.maxTouchPoints>0);function l(t){var n=t.toLowerCase(),a=function(t){return/(ipad)/.exec(t)||/(ipod)/.exec(t)||/(windows phone)/.exec(t)||/(iphone)/.exec(t)||/(kindle)/.exec(t)||/(silk)/.exec(t)||/(android)/.exec(t)||/(win)/.exec(t)||/(mac)/.exec(t)||/(linux)/.exec(t)||/(cros)/.exec(t)||/(playbook)/.exec(t)||/(bb)/.exec(t)||/(blackberry)/.exec(t)||[]}(n),l=function(t,e){var n=/(edge|edga|edgios)\/([\w.]+)/.exec(t)||/(opr)[\/]([\w.]+)/.exec(t)||/(vivaldi)[\/]([\w.]+)/.exec(t)||/(chrome|crios)[\/]([\w.]+)/.exec(t)||/(iemobile)[\/]([\w.]+)/.exec(t)||/(version)(applewebkit)[\/]([\w.]+).*(safari)[\/]([\w.]+)/.exec(t)||/(webkit)[\/]([\w.]+).*(version)[\/]([\w.]+).*(safari)[\/]([\w.]+)/.exec(t)||/(firefox|fxios)[\/]([\w.]+)/.exec(t)||/(webkit)[\/]([\w.]+)/.exec(t)||/(opera)(?:.*version|)[\/]([\w.]+)/.exec(t)||/(msie) ([\w.]+)/.exec(t)||t.indexOf("trident")>=0&&/(rv)(?::| )([\w.]+)/.exec(t)||t.indexOf("compatible")<0&&/(mozilla)(?:.*? rv:([\w.]+)|)/.exec(t)||[];return{browser:n[5]||n[3]||n[1]||"",version:n[2]||n[4]||"0",versionNumber:n[4]||n[2]||"0",platform:e[0]||""}}(n,a),c={};l.browser&&(c[l.browser]=!0,c.version=l.version,c.versionNumber=parseInt(l.versionNumber,10)),l.platform&&(c[l.platform]=!0);var u=c.android||c.ios||c.bb||c.blackberry||c.ipad||c.iphone||c.ipod||c.kindle||c.playbook||c.silk||c["windows phone"];return!0===u||n.indexOf("mobile")>-1?(c.mobile=!0,c.edga||c.edgios?(c.edge=!0,l.browser="edge"):c.crios?(c.chrome=!0,l.browser="chrome"):c.fxios&&(c.firefox=!0,l.browser="firefox")):c.desktop=!0,(c.ipod||c.ipad||c.iphone)&&(c.ios=!0),c["windows phone"]&&(c.winphone=!0,delete c["windows phone"]),(c.chrome||c.opr||c.safari||c.vivaldi||!0===c.mobile&&!0!==c.ios&&!0!==u)&&(c.webkit=!0),(c.rv||c.iemobile)&&(l.browser="ie",c.ie=!0),(c.safari&&c.blackberry||c.bb)&&(l.browser="blackberry",c.blackberry=!0),c.safari&&c.playbook&&(l.browser="playbook",c.playbook=!0),c.opr&&(l.browser="opera",c.opera=!0),c.safari&&c.android&&(l.browser="android",c.android=!0),c.safari&&c.kindle&&(l.browser="kindle",c.kindle=!0),c.safari&&c.silk&&(l.browser="silk",c.silk=!0),c.vivaldi&&(l.browser="vivaldi",c.vivaldi=!0),c.name=l.browser,c.platform=l.platform,!1===i&&(n.indexOf("electron")>-1?c.electron=!0:document.location.href.indexOf("-extension://")>-1?c.bex=!0:(void 0!==window.Capacitor?(c.capacitor=!0,c.nativeMobile=!0,c.nativeMobileWrapper="capacitor"):void 0===window._cordovaNative&&void 0===window.cordova||(c.cordova=!0,c.nativeMobile=!0,c.nativeMobileWrapper="cordova"),!0===s&&!0===c.mac&&(!0===c.desktop&&!0===c.safari||!0===c.nativeMobile&&!0!==c.android&&!0!==c.ios&&!0!==c.ipad)&&function(t){var n;e={is:Object.assign({},t)},delete t.mac,delete t.desktop;var i=Math.min(window.innerHeight,window.innerWidth)>414?"ipad":"iphone";Object.assign(t,((n={mobile:!0,ios:!0,platform:i})[i]=!0,n))}(c)),!0===(r=void 0===c.nativeMobile&&void 0===c.electron&&null!==document.querySelector("[data-server-rendered]"))&&(o=!0)),c}var c=!0!==i?navigator.userAgent||navigator.vendor||window.opera:"",u={has:{touch:!1,webStorage:!1},within:{iframe:!1}},d=!1===i?{userAgent:c,is:l(c),has:{touch:s,webStorage:function(){try{if(window.localStorage)return!0}catch(t){}return!1}()},within:{iframe:window.self!==window.top}}:u,h={install:function(n,a){var s=this;!0===i?a.server.push((function(t,e){t.platform=s.parseSSR(e.ssr)})):!0===r?(Object.assign(this,d,e,u),a.takeover.push((function(t){o=r=!1,Object.assign(t.platform,d),e=void 0})),t.util.defineReactive(n,"platform",this)):(Object.assign(this,d),n.platform=this)}};!0===i?h.parseSSR=function(t){var e=t.req.headers["user-agent"]||t.req.headers["User-Agent"]||"";return Object.assign({},d,{userAgent:e,is:l(e)})}:a=!0===d.is.ios&&-1===window.navigator.vendor.toLowerCase().indexOf("apple");var f={hasPassive:!1,passiveCapture:!0,notPassiveCapture:!0};try{var p=Object.defineProperty({},"passive",{get:function(){Object.assign(f,{hasPassive:!0,passive:{passive:!0},notPassive:{passive:!1},passiveCapture:{passive:!0,capture:!0},notPassiveCapture:{passive:!1,capture:!0}})}});window.addEventListener("qtest",null,p),window.removeEventListener("qtest",null,p)}catch(t){}function m(){}function v(t){return 0===t.button}function g(t){return t.touches&&t.touches[0]?t=t.touches[0]:t.changedTouches&&t.changedTouches[0]?t=t.changedTouches[0]:t.targetTouches&&t.targetTouches[0]&&(t=t.targetTouches[0]),{top:t.clientY,left:t.clientX}}function y(t){if(t.path)return t.path;if(t.composedPath)return t.composedPath();for(var e=[],n=t.target;n;){if(e.push(n),"HTML"===n.tagName)return e.push(document),e.push(window),e;n=n.parentElement}}function _(t){t.stopPropagation()}function b(t){!1!==t.cancelable&&t.preventDefault()}function w(t){!1!==t.cancelable&&t.preventDefault(),t.stopPropagation()}function k(t,e){if(void 0!==t&&(!0!==e||!0!==t.__dragPrevented)){var n=!0===e?function(t){t.__dragPrevented=!0,t.addEventListener("dragstart",b,f.notPassiveCapture)}:function(t){delete t.__dragPrevented,t.removeEventListener("dragstart",b,f.notPassiveCapture)};t.querySelectorAll("a, img").forEach(n)}}function x(t,e){void 0===e&&(e={});var n=e.bubbles;void 0===n&&(n=!1);var i=e.cancelable;void 0===i&&(i=!1);try{return new Event(t,{bubbles:n,cancelable:i})}catch(e){var r=document.createEvent("Event");return r.initEvent(t,n,i),r}}function C(t,e,n){var i="__q_"+e+"_evt";t[i]=void 0!==t[i]?t[i].concat(n):n,n.forEach((function(e){e[0].addEventListener(e[1],t[e[2]],f[e[3]])}))}function S(t,e){var n="__q_"+e+"_evt";void 0!==t[n]&&(t[n].forEach((function(e){e[0].removeEventListener(e[1],t[e[2]],f[e[3]])})),t[n]=void 0)}var M={listenOpts:f,leftClick:v,middleClick:function(t){return 1===t.button},rightClick:function(t){return 2===t.button},position:g,getEventPath:y,getMouseWheelDistance:function(t){var e,n=t.deltaX,i=t.deltaY;if((n||i)&&t.deltaMode){var r=1===t.deltaMode?40:800;n*=r,i*=r}return t.shiftKey&&!n&&(i=(e=[n,i])[0],n=e[1]),{x:n,y:i}},stop:_,prevent:b,stopAndPrevent:w,preventDraggable:k,create:x};function T(t,e,n){var i;function r(){var r=this,o=arguments;clearTimeout(i),!0===n&&void 0===i&&t.apply(this,o),i=setTimeout((function(){i=void 0,!0!==n&&t.apply(r,o)}),e)}return void 0===e&&(e=250),r.cancel=function(){clearTimeout(i)},r}var P=["sm","md","lg","xl"],O=f.passive,B={width:0,height:0,name:"xs",sizes:{sm:600,md:1024,lg:1440,xl:1920},lt:{sm:!0,md:!0,lg:!0,xl:!0},gt:{xs:!1,sm:!1,md:!1,lg:!1},xs:!0,sm:!1,md:!1,lg:!1,xl:!1,setSizes:m,setDebounce:m,install:function(e,n,o){var a=this;if(!0!==i){var s,l=void 0!==o.screen&&!0===o.screen.bodyClasses,c=function(t){var e=window.innerWidth,n=window.innerHeight;if(n!==a.height&&(a.height=n),e!==a.width)a.width=e;else if(!0!==t)return;var i=a.sizes;a.gt.xs=e>=i.sm,a.gt.sm=e>=i.md,a.gt.md=e>=i.lg,a.gt.lg=e>=i.xl,a.lt.sm=e<i.sm,a.lt.md=e<i.md,a.lt.lg=e<i.lg,a.lt.xl=e<i.xl,a.xs=a.lt.sm,a.sm=!0===a.gt.xs&&!0===a.lt.md,a.md=!0===a.gt.sm&&!0===a.lt.lg,a.lg=!0===a.gt.md&&!0===a.lt.xl,a.xl=a.gt.lg,(i=(!0===a.xs?"xs":!0===a.sm&&"sm")||!0===a.md&&"md"||!0===a.lg&&"lg"||"xl")!==a.name&&(!0===l&&(document.body.classList.remove("screen--"+a.name),document.body.classList.add("screen--"+i)),a.name=i)},u={},d=16;this.setSizes=function(t){P.forEach((function(e){void 0!==t[e]&&(u[e]=t[e])}))},this.setDebounce=function(t){d=t};var h=function(){var t=getComputedStyle(document.body),e=void 0!==window.visualViewport?window.visualViewport:window;t.getPropertyValue("--q-size-sm")&&P.forEach((function(e){a.sizes[e]=parseInt(t.getPropertyValue("--q-size-"+e),10)})),a.setSizes=function(t){P.forEach((function(e){t[e]&&(a.sizes[e]=t[e])})),c(!0)},a.setDebounce=function(t){void 0!==s&&e.removeEventListener("resize",s,O),s=t>0?T(c,t):c,e.addEventListener("resize",s,O)},a.setDebounce(d),Object.keys(u).length>0?(a.setSizes(u),u=void 0):c(),!0===l&&"xs"===a.name&&document.body.classList.add("screen--xs")};!0===r?n.takeover.push(h):h(),t.util.defineReactive(e,"screen",this)}else e.screen=this}},E={isActive:!1,mode:!1,install:function(e,n,o){var a=this,s=o.dark;if(this.isActive=!0===s,!0===i)return n.server.push((function(t,e){t.dark={isActive:!1,mode:!1,set:function(n){e.ssr.Q_BODY_CLASSES=e.ssr.Q_BODY_CLASSES.replace(" body--light","").replace(" body--dark","")+" body--"+(!0===n?"dark":"light"),t.dark.isActive=!0===n,t.dark.mode=n},toggle:function(){t.dark.set(!1===t.dark.isActive)}},t.dark.set(s)})),void(this.set=m);var l=void 0!==s&&s;if(!0===r){var c=function(t){a.__fromSSR=t},u=this.set;this.set=c,c(l),n.takeover.push((function(){a.set=u,a.set(a.__fromSSR)}))}else this.set(l);t.util.defineReactive(this,"isActive",this.isActive),t.util.defineReactive(e,"dark",this)},set:function(t){var e=this;this.mode=t,"auto"===t?(void 0===this.__media&&(this.__media=window.matchMedia("(prefers-color-scheme: dark)"),this.__updateMedia=function(){e.set("auto")},this.__media.addListener(this.__updateMedia)),t=this.__media.matches):void 0!==this.__media&&(this.__media.removeListener(this.__updateMedia),this.__media=void 0),this.isActive=!0===t,document.body.classList.remove("body--"+(!0===t?"light":"dark")),document.body.classList.add("body--"+(!0===t?"dark":"light"))},toggle:function(){E.set(!1===E.isActive)},__media:void 0},A=function(){return!0};function D(t){return"string"==typeof t&&""!==t&&"/"!==t&&"#/"!==t}function L(t){return!0===t.startsWith("#")&&(t=t.substr(1)),!1===t.startsWith("/")&&(t="/"+t),!0===t.endsWith("/")&&(t=t.substr(0,t.length-1)),"#"+t}var q={__history:[],add:m,remove:m,install:function(t){var e=this;if(!0!==i){var n=d.is,r=n.cordova,o=n.capacitor;if(!0===r||!0===o){this.add=function(t){void 0===t.condition&&(t.condition=A),e.__history.push(t)},this.remove=function(t){var n=e.__history.indexOf(t);n>=0&&e.__history.splice(n,1)};var a=function(t){if(!1===t.backButtonExit)return function(){return!1};if("*"===t.backButtonExit)return A;var e=["#/"];return!0===Array.isArray(t.backButtonExit)&&e.push.apply(e,t.backButtonExit.filter(D).map(L)),function(){return e.includes(window.location.hash)}}(Object.assign({backButtonExit:!0},t[!0===r?"cordova":"capacitor"])),s=function(){if(e.__history.length){var t=e.__history[e.__history.length-1];!0===t.condition()&&(e.__history.pop(),t.handler())}else!0===a()?navigator.app.exitApp():window.history.back()};!0===r?document.addEventListener("deviceready",(function(){document.addEventListener("backbutton",s,!1)})):window.Capacitor.Plugins.App.addListener("backButton",s)}}}},R={isoName:"en-us",nativeName:"English (US)",label:{clear:"Clear",ok:"OK",cancel:"Cancel",close:"Close",set:"Set",select:"Select",reset:"Reset",remove:"Remove",update:"Update",create:"Create",search:"Search",filter:"Filter",refresh:"Refresh"},date:{days:"Sunday_Monday_Tuesday_Wednesday_Thursday_Friday_Saturday".split("_"),daysShort:"Sun_Mon_Tue_Wed_Thu_Fri_Sat".split("_"),months:"January_February_March_April_May_June_July_August_September_October_November_December".split("_"),monthsShort:"Jan_Feb_Mar_Apr_May_Jun_Jul_Aug_Sep_Oct_Nov_Dec".split("_"),firstDayOfWeek:0,format24h:!1,pluralDay:"days"},table:{noData:"No data available",noResults:"No matching records found",loading:"Loading...",selectedRecords:function(t){return 1===t?"1 record selected.":(0===t?"No":t)+" records selected."},recordsPerPage:"Records per page:",allRows:"All",pagination:function(t,e,n){return t+"-"+e+" of "+n},columns:"Columns"},editor:{url:"URL",bold:"Bold",italic:"Italic",strikethrough:"Strikethrough",underline:"Underline",unorderedList:"Unordered List",orderedList:"Ordered List",subscript:"Subscript",superscript:"Superscript",hyperlink:"Hyperlink",toggleFullscreen:"Toggle Fullscreen",quote:"Quote",left:"Left align",center:"Center align",right:"Right align",justify:"Justify align",print:"Print",outdent:"Decrease indentation",indent:"Increase indentation",removeFormat:"Remove formatting",formatting:"Formatting",fontSize:"Font Size",align:"Align",hr:"Insert Horizontal Rule",undo:"Undo",redo:"Redo",heading1:"Heading 1",heading2:"Heading 2",heading3:"Heading 3",heading4:"Heading 4",heading5:"Heading 5",heading6:"Heading 6",paragraph:"Paragraph",code:"Code",size1:"Very small",size2:"A bit small",size3:"Normal",size4:"Medium-large",size5:"Big",size6:"Very big",size7:"Maximum",defaultFont:"Default Font",viewSource:"View Source"},tree:{noNodes:"No nodes available",noResults:"No matching nodes found"}};function I(){if(!0!==i){var t=navigator.language||navigator.languages[0]||navigator.browserLanguage||navigator.userLanguage||navigator.systemLanguage;return t?t.toLowerCase():void 0}}var N={getLocale:I,install:function(e,n,o){var a=this,s=o||R;this.set=function(t,n){void 0===t&&(t=R);var o=Object.assign({},t,{rtl:!0===t.rtl,getLocale:I});if(!0===i){if(void 0===n)return void console.error("SSR ERROR: second param required: Quasar.lang.set(lang, ssrContext)");var s=!0===o.rtl?"rtl":"ltr",l="lang="+o.isoName+" dir="+s;o.set=n.$q.lang.set,n.Q_HTML_ATTRS=void 0!==n.Q_PREV_LANG?n.Q_HTML_ATTRS.replace(n.Q_PREV_LANG,l):l,n.Q_PREV_LANG=l,n.$q.lang=o}else{if(!1===r){var c=document.documentElement;c.setAttribute("dir",!0===o.rtl?"rtl":"ltr"),c.setAttribute("lang",o.isoName)}o.set=a.set,e.lang=a.props=o,a.isoName=o.isoName,a.nativeName=o.nativeName}},!0===i?(n.server.push((function(t,e){t.lang={},t.lang.set=function(t){a.set(t,e.ssr)},t.lang.set(s)})),this.isoName=s.isoName,this.nativeName=s.nativeName,this.props=s):(t.util.defineReactive(e,"lang",{}),this.set(s))}},F=/^rgb(a)?\((\d{1,3}),(\d{1,3}),(\d{1,3}),?([01]?\.?\d*?)?\)$/;function $(t){var e=t.r,n=t.g,i=t.b,r=t.a,o=void 0!==r;if(e=Math.round(e),n=Math.round(n),i=Math.round(i),e>255||n>255||i>255||o&&r>100)throw new TypeError("Expected 3 numbers below 256 (and optionally one below 100)");return r=o?(256|Math.round(255*r/100)).toString(16).slice(1):"","#"+(i|n<<8|e<<16|1<<24).toString(16).slice(1)+r}function j(t){var e=t.r,n=t.g,i=t.b,r=t.a;return"rgb"+(void 0!==r?"a":"")+"("+e+","+n+","+i+(void 0!==r?","+r/100:"")+")"}function z(t){if("string"!=typeof t)throw new TypeError("Expected a string");3===(t=t.replace(/^#/,"")).length?t=t[0]+t[0]+t[1]+t[1]+t[2]+t[2]:4===t.length&&(t=t[0]+t[0]+t[1]+t[1]+t[2]+t[2]+t[3]+t[3]);var e=parseInt(t,16);return t.length>6?{r:e>>24&255,g:e>>16&255,b:e>>8&255,a:Math.round((255&e)/2.55)}:{r:e>>16,g:e>>8&255,b:255&e}}function V(t){var e,n,i,r=t.h,o=t.s,a=t.v,s=t.a;o/=100,a/=100,r/=360;var l=Math.floor(6*r),c=6*r-l,u=a*(1-o),d=a*(1-c*o),h=a*(1-(1-c)*o);switch(l%6){case 0:e=a,n=h,i=u;break;case 1:e=d,n=a,i=u;break;case 2:e=u,n=a,i=h;break;case 3:e=u,n=d,i=a;break;case 4:e=h,n=u,i=a;break;case 5:e=a,n=u,i=d}return{r:Math.round(255*e),g:Math.round(255*n),b:Math.round(255*i),a:s}}function H(t){var e,n=t.r,i=t.g,r=t.b,o=t.a,a=Math.max(n,i,r),s=Math.min(n,i,r),l=a-s,c=0===a?0:l/a,u=a/255;switch(a){case s:e=0;break;case n:e=i-r+l*(i<r?6:0),e/=6*l;break;case i:e=r-n+2*l,e/=6*l;break;case r:e=n-i+4*l,e/=6*l}return{h:Math.round(360*e),s:Math.round(100*c),v:Math.round(100*u),a:o}}function W(t){if("string"!=typeof t)throw new TypeError("Expected a string");var e=t.replace(/ /g,""),n=F.exec(e);if(null===n)return z(e);var i={r:Math.min(255,parseInt(n[2],10)),g:Math.min(255,parseInt(n[3],10)),b:Math.min(255,parseInt(n[4],10))};if(n[1]){var r=parseFloat(n[5]);i.a=100*Math.min(1,!0===isNaN(r)?1:r)}return i}function U(t){if("string"!=typeof t&&(!t||void 0===t.r))throw new TypeError("Expected a string or a {r, g, b} object as color");var e="string"==typeof t?W(t):t,n=e.r/255,i=e.g/255,r=e.b/255;return.2126*(n<=.03928?n/12.92:Math.pow((n+.055)/1.055,2.4))+.7152*(i<=.03928?i/12.92:Math.pow((i+.055)/1.055,2.4))+.0722*(r<=.03928?r/12.92:Math.pow((r+.055)/1.055,2.4))}function Y(t,e,n){if(void 0===n&&(n=document.body),"string"!=typeof t)throw new TypeError("Expected a string as color");if("string"!=typeof e)throw new TypeError("Expected a string as value");if(!(n instanceof Element))throw new TypeError("Expected a DOM element");n.style.setProperty("--q-color-"+t,e)}function Q(t,e){if(void 0===e&&(e=document.body),"string"!=typeof t)throw new TypeError("Expected a string as color");if(!(e instanceof Element))throw new TypeError("Expected a DOM element");return getComputedStyle(e).getPropertyValue("--q-color-"+t).trim()||null}var G={rgbToHex:$,hexToRgb:z,hsvToRgb:V,rgbToHsv:H,textToRgb:W,lighten:function(t,e){if("string"!=typeof t)throw new TypeError("Expected a string as color");if("number"!=typeof e)throw new TypeError("Expected a numeric percent");var n=W(t),i=e<0?0:255,r=Math.abs(e)/100,o=n.r,a=n.g,s=n.b;return"#"+(16777216+65536*(Math.round((i-o)*r)+o)+256*(Math.round((i-a)*r)+a)+(Math.round((i-s)*r)+s)).toString(16).slice(1)},luminosity:U,brightness:function(t){if("string"!=typeof t&&(!t||void 0===t.r))throw new TypeError("Expected a string or a {r, g, b} object as color");var e="string"==typeof t?W(t):t;return(299*e.r+587*e.g+114*e.b)/1e3},blend:function(t,e){if("string"!=typeof t&&(!t||void 0===t.r))throw new TypeError("Expected a string or a {r, g, b[, a]} object as fgColor");if("string"!=typeof e&&(!e||void 0===e.r))throw new TypeError("Expected a string or a {r, g, b[, a]} object as bgColor");var n="string"==typeof t?W(t):t,i=n.r/255,r=n.g/255,o=n.b/255,a=void 0!==n.a?n.a/100:1,s="string"==typeof e?W(e):e,l=s.r/255,c=s.g/255,u=s.b/255,d=void 0!==s.a?s.a/100:1,h=a+d*(1-a),f={r:Math.round((i*a+l*d*(1-a))/h*255),g:Math.round((r*a+c*d*(1-a))/h*255),b:Math.round((o*a+u*d*(1-a))/h*255),a:Math.round(100*h)};return"string"==typeof t?$(f):f},changeAlpha:function(t,e){if("string"!=typeof t)throw new TypeError("Expected a string as color");if(void 0===e||e<-1||e>1)throw new TypeError("Expected offset to be between -1 and 1");var n=W(t),i=n.r,r=n.g,o=n.b,a=n.a,s=void 0!==a?a/100:0;return $({r:i,g:r,b:o,a:Math.round(100*Math.min(1,Math.max(0,s+e)))})},setBrand:Y,getBrand:Q,getPaletteColor:function(t){if("string"!=typeof t)throw new TypeError("Expected a string as color");var e=document.createElement("div");e.className="text-"+t+" invisible fixed no-pointer-events",document.body.appendChild(e);var n=getComputedStyle(e).getPropertyValue("color");return e.remove(),$(W(n))}},K=!1;function J(t){K=!0===t.isComposing}function Z(t){return!0===K||t!==Object(t)||!0===t.isComposing||!0===t.qKeyEvent}function X(t,e){return!0!==Z(t)&&[].concat(e).includes(t.keyCode)}function tt(t,e){var n=t.is,i=t.has,r=t.within,o=[!0===n.desktop?"desktop":"mobile",(!1===i.touch?"no-":"")+"touch"];if(!0===n.mobile){var a=function(t){return!0===t.ios?"ios":!0===t.android?"android":void 0}(n);void 0!==a&&o.push("platform-"+a)}if(!0===n.nativeMobile){var s=n.nativeMobileWrapper;o.push(s),o.push("native-mobile"),!0!==n.ios||void 0!==e[s]&&!1===e[s].iosStatusBarPadding||o.push("q-ios-padding")}else!0===n.electron?o.push("electron"):!0===n.bex&&o.push("bex");return!0===r.iframe&&o.push("within-iframe"),o}var et=function(t,n){if(!0!==i){if(!0===r)a=document.body.className,s=a,void 0!==e&&(s=s.replace("desktop","platform-ios mobile")),!0===d.has.touch&&(s=s.replace("no-touch","touch")),!0===d.within.iframe&&(s+=" within-iframe"),a!==s&&(document.body.className=s);else{var o=tt(d,n);!0===d.is.ie&&11===d.is.versionNumber?o.forEach((function(t){return document.body.classList.add(t)})):document.body.classList.add.apply(document.body.classList,o)}var a,s;void 0!==n.brand&&function(t){for(var e in t)Y(e,t[e])}(n.brand),!0===d.is.ios&&document.body.addEventListener("touchstart",m),window.addEventListener("keydown",J,!0)}else t.server.push((function(t,e){var i=tt(t.platform,n),r=e.ssr.setBodyClasses;void 0!==n.screen&&!0===n.screen.bodyClass&&i.push("screen--xs"),"function"==typeof r?r(i):e.ssr.Q_BODY_CLASSES=i.join(" ")}))},nt={name:"material-icons",type:{positive:"check_circle",negative:"warning",info:"info",warning:"priority_high"},arrow:{up:"arrow_upward",right:"arrow_forward",down:"arrow_downward",left:"arrow_back",dropdown:"arrow_drop_down"},chevron:{left:"chevron_left",right:"chevron_right"},colorPicker:{spectrum:"gradient",tune:"tune",palette:"style"},pullToRefresh:{icon:"refresh"},carousel:{left:"chevron_left",right:"chevron_right",up:"keyboard_arrow_up",down:"keyboard_arrow_down",navigationIcon:"lens"},chip:{remove:"cancel",selected:"check"},datetime:{arrowLeft:"chevron_left",arrowRight:"chevron_right",now:"access_time",today:"today"},editor:{bold:"format_bold",italic:"format_italic",strikethrough:"strikethrough_s",underline:"format_underlined",unorderedList:"format_list_bulleted",orderedList:"format_list_numbered",subscript:"vertical_align_bottom",superscript:"vertical_align_top",hyperlink:"link",toggleFullscreen:"fullscreen",quote:"format_quote",left:"format_align_left",center:"format_align_center",right:"format_align_right",justify:"format_align_justify",print:"print",outdent:"format_indent_decrease",indent:"format_indent_increase",removeFormat:"format_clear",formatting:"text_format",fontSize:"format_size",align:"format_align_left",hr:"remove",undo:"undo",redo:"redo",heading:"format_size",code:"code",size:"format_size",font:"font_download",viewSource:"code"},expansionItem:{icon:"keyboard_arrow_down",denseIcon:"arrow_drop_down"},fab:{icon:"add",activeIcon:"close"},field:{clear:"cancel",error:"error"},pagination:{first:"first_page",prev:"keyboard_arrow_left",next:"keyboard_arrow_right",last:"last_page"},rating:{icon:"grade"},stepper:{done:"check",active:"edit",error:"warning"},tabs:{left:"chevron_left",right:"chevron_right",up:"keyboard_arrow_up",down:"keyboard_arrow_down"},table:{arrowUp:"arrow_upward",warning:"warning",firstPage:"first_page",prevPage:"chevron_left",nextPage:"chevron_right",lastPage:"last_page"},tree:{icon:"play_arrow"},uploader:{done:"done",clear:"clear",add:"add_box",upload:"cloud_upload",removeQueue:"clear_all",removeUploaded:"done_all"}},it={install:function(e,n,r){var o=this,a=r||nt;this.set=function(t,n){var r=Object.assign({},t);if(!0===i){if(void 0===n)return void console.error("SSR ERROR: second param required: Quasar.iconSet.set(iconSet, ssrContext)");r.set=n.$q.iconSet.set,n.$q.iconSet=r}else r.set=o.set,e.iconSet=r},!0===i?n.server.push((function(t,e){t.iconSet={},t.iconSet.set=function(t){o.set(t,e.ssr)},t.iconSet.set(a)})):(t.util.defineReactive(e,"iconMapFn",void 0),t.util.defineReactive(e,"iconSet",{}),this.set(a))}},rt=[h,B,E],ot={server:[],takeover:[]},at={version:n,config:{}};var st=["B","KB","MB","GB","TB","PB"];function lt(t){for(var e=0;parseInt(t,10)>=1024&&e<st.length-1;)t/=1024,++e;return""+t.toFixed(1)+st[e]}function ct(t){return t.charAt(0).toUpperCase()+t.slice(1)}function ut(t,e,n){return n<=e?e:Math.min(n,Math.max(e,t))}function dt(t,e,n){if(n<=e)return e;var i=n-e+1,r=e+(t-e)%i;return r<e&&(r=i+r),0===r?0:r}function ht(t,e,n){if(void 0===e&&(e=2),void 0===n&&(n="0"),null==t)return t;var i=""+t;return i.length>=e?i:new Array(e-i.length+1).join(n)+i}var ft={humanStorageSize:lt,capitalize:ct,between:ut,normalizeToInterval:dt,pad:ht};function pt(t,e,n){if(!0===i)return n;var r="__qcache_"+e;return void 0===t[r]?t[r]=n:t[r]}function mt(t,e,n){if(!0===i)return n();var r="__qcache_"+e;return void 0===t[r]?t[r]=n():t[r]}function vt(t,e){var n;return{data:function(){var n,i={},r=this[t];for(var o in r)i[o]=r[o];return(n={})[e]=i,n},watch:(n={},n[t]=function(t,n){var i=this[e];if(void 0!==n)for(var r in n)void 0===t[r]&&this.$delete(i,r);for(var o in t)i[o]!==t[o]&&this.$set(i,o,t[o])},n)}}var gt={"aria-hidden":"true"},yt=vt("$attrs","qAttrs"),_t=i?null:XMLHttpRequest,bt=i?null:_t.prototype.send,wt=[],kt=[],xt=0;var Ct=t.extend({name:"QAjaxBar",props:{position:{type:String,default:"top",validator:function(t){return["top","right","bottom","left"].includes(t)}},size:{type:String,default:"2px"},color:String,skipHijack:Boolean,reverse:Boolean},data:function(){return{calls:0,progress:0,onScreen:!1,animate:!0}},computed:{classes:function(){return"q-loading-bar q-loading-bar--"+this.position+(void 0!==this.color?" bg-"+this.color:"")+(!0===this.animate?"":" no-transition")},style:function(){var t=this.onScreen,e=function(t){var e=t.p,n=t.pos,i=t.active,r=t.horiz,o=t.reverse,a=t.dir,s=1,l=1;return r?(o&&(s=-1),"bottom"===n&&(l=-1),{transform:"translate3d("+s*(e-100)+"%,"+(i?0:-200*l)+"%,0)"}):(o&&(l=-1),"right"===n&&(s=-1),{transform:"translate3d("+(i?0:a*s*-200)+"%,"+l*(e-100)+"%,0)"})}({p:this.progress,pos:this.position,active:t,horiz:this.horizontal,reverse:!0===this.$q.lang.rtl&&["top","bottom"].includes(this.position)?!this.reverse:this.reverse,dir:!0===this.$q.lang.rtl?-1:1});return e[this.sizeProp]=this.size,e.opacity=t?1:0,e},horizontal:function(){return"top"===this.position||"bottom"===this.position},sizeProp:function(){return this.horizontal?"height":"width"},attrs:function(){return!0===this.onScreen?{role:"progressbar","aria-valuemin":0,"aria-valuemax":100,"aria-valuenow":this.progress}:gt}},methods:{start:function(t){var e=this;void 0===t&&(t=300);var n=this.speed;this.speed=Math.max(0,t)||0,this.calls++,this.calls>1?0===n&&t>0?this.__work():n>0&&t<=0&&clearTimeout(this.timer):(clearTimeout(this.timer),this.$emit("start"),this.progress=0,!0!==this.onScreen&&(this.onScreen=!0,this.animate=!1,this.timer=setTimeout((function(){e.animate=!0,t>0&&e.__work()}),100)))},increment:function(t){this.calls>0&&(this.progress=function(t,e){return"number"!=typeof e&&(e=t<25?3*Math.random()+3:t<65?3*Math.random():t<85?2*Math.random():t<99?.6:0),ut(t+e,0,100)}(this.progress,t))},stop:function(){var t=this;if(this.calls=Math.max(0,this.calls-1),!(this.calls>0)){clearTimeout(this.timer),this.$emit("stop");var e=function(){t.animate=!0,t.progress=100,t.timer=setTimeout((function(){t.onScreen=!1}),1e3)};0===this.progress?this.timer=setTimeout(e,1):e()}},__work:function(){var t=this;this.progress<100&&(this.timer=setTimeout((function(){t.increment(),t.__work()}),this.speed))}},mounted:function(){!0!==this.skipHijack&&(this.hijacked=!0,function(t,e){function n(){kt.forEach((function(t){t()}))}wt.push(t),kt.push(e),++xt>1||(_t.prototype.send=function(){wt.forEach((function(t){t()})),this.addEventListener("loadend",n,!1),bt.apply(this,arguments)})}(this.start,this.stop))},beforeDestroy:function(){clearTimeout(this.timer),!0===this.hijacked&&function(t,e){wt.splice(wt.indexOf(t),1),kt.splice(kt.indexOf(e),1),(xt=Math.max(0,xt-1))||(_t.prototype.send=bt)}(this.start,this.stop)},render:function(t){return t("div",{class:this.classes,style:this.style,attrs:this.attrs})}}),St={xs:18,sm:24,md:32,lg:38,xl:46};function Mt(t){return{props:{size:String},computed:{sizeStyle:function(){if(void 0!==this.size)return{fontSize:this.size in t?t[this.size]+"px":this.size}}}}}var Tt=Mt(St),Pt={props:{tag:{type:String,default:"div"}}},Ot=vt("$listeners","qListeners");function Bt(t,e,n){return void 0!==t.$scopedSlots[e]?t.$scopedSlots[e]():n}function Et(t,e,n){return void 0!==t.$scopedSlots[e]?t.$scopedSlots[e]().slice():n}function At(t,e,n){return void 0!==e.$scopedSlots[n]?t.concat(e.$scopedSlots[n]()):t}function Dt(t,e,n){if(void 0===e.$scopedSlots[n])return t;var i=e.$scopedSlots[n]();return void 0!==t?t.concat(i):i}var Lt=t.extend({name:"QIcon",mixins:[Ot,Tt,Pt],props:{tag:{default:"i"},name:String,color:String,left:Boolean,right:Boolean},computed:{classes:function(){return"q-icon notranslate"+(!0===this.left?" on-left":"")+(!0===this.right?" on-right":"")+(void 0!==this.color?" text-"+this.color:"")},type:function(){var t,e=this,n=this.name;if(!n)return{none:!0,cls:this.classes};if(void 0!==this.$q.iconMapFn){var i=this.$q.iconMapFn(n);if(void 0!==i){if(void 0===i.icon)return{cls:i.cls+" "+this.classes,content:void 0!==i.content?i.content:" "};n=i.icon}}if(!0===n.startsWith("M")){var r=n.split("|"),o=r[0],a=r[1];return{svg:!0,cls:this.classes,nodes:o.split("&&").map((function(t){var n=t.split("@@"),i=n[0],r=n[1],o=n[2];return e.$createElement("path",{attrs:{d:i,transform:o},style:r})})),viewBox:void 0!==a?a:"0 0 24 24"}}if(!0===n.startsWith("img:"))return{img:!0,cls:this.classes,src:n.substring(4)};if(!0===n.startsWith("svguse:")){var s=n.split("|"),l=s[0],c=s[1];return{svguse:!0,cls:this.classes,src:l.substring(7),viewBox:void 0!==c?c:"0 0 24 24"}}var u=" ";return/^[l|f]a[s|r|l|b|d]{0,1} /.test(n)||!0===n.startsWith("icon-")?t=n:!0===n.startsWith("bt-")?t="bt "+n:!0===n.startsWith("eva-")?t="eva "+n:!0===/^ion-(md|ios|logo)/.test(n)?t="ionicons "+n:!0===n.startsWith("ion-")?t="ionicons ion-"+(!0===this.$q.platform.is.ios?"ios":"md")+n.substr(3):!0===n.startsWith("mdi-")?t="mdi "+n:!0===n.startsWith("iconfont ")?t=""+n:!0===n.startsWith("ti-")?t="themify-icon "+n:(t="material-icons",!0===n.startsWith("o_")?(n=n.substring(2),t+="-outlined"):!0===n.startsWith("r_")?(n=n.substring(2),t+="-round"):!0===n.startsWith("s_")&&(n=n.substring(2),t+="-sharp"),u=n),{cls:t+" "+this.classes,content:u}}},render:function(t){var e={class:this.type.cls,style:this.sizeStyle,on:Object.assign({},this.qListeners),attrs:{"aria-hidden":"true",role:"presentation"}};return!0===this.type.none?t(this.tag,e,Bt(this,"default")):!0===this.type.img?(e.attrs.src=this.type.src,t("img",e)):!0===this.type.svg?(e.attrs.focusable="false",e.attrs.viewBox=this.type.viewBox,t("svg",e,At(this.type.nodes,this,"default"))):!0===this.type.svguse?(e.attrs.focusable="false",e.attrs.viewBox=this.type.viewBox,t("svg",e,[t("use",{attrs:{"xlink:href":this.type.src}}),At(this.type.nodes,this,"default")])):t(this.tag,e,At([this.type.content],this,"default"))}}),qt=t.extend({name:"QAvatar",mixins:[Ot,Tt],props:{fontSize:String,color:String,textColor:String,icon:String,square:Boolean,rounded:Boolean},computed:{classes:function(){var t;return(t={})["bg-"+this.color]=this.color,t["text-"+this.textColor+" q-chip--colored"]=this.textColor,t["q-avatar--square"]=this.square,t["rounded-borders"]=this.rounded,t},contentStyle:function(){if(this.fontSize)return{fontSize:this.fontSize}}},render:function(t){var e=void 0!==this.icon?[t(Lt,{props:{name:this.icon}})]:void 0;return t("div",{staticClass:"q-avatar",style:this.sizeStyle,class:this.classes,on:Object.assign({},this.qListeners)},[t("div",{staticClass:"q-avatar__content row flex-center overflow-hidden",style:this.contentStyle},Dt(e,this,"default"))])}}),Rt=t.extend({name:"QBadge",mixins:[Ot],props:{color:String,textColor:String,floating:Boolean,transparent:Boolean,multiLine:Boolean,outline:Boolean,label:[Number,String],align:{type:String,validator:function(t){return["top","middle","bottom"].includes(t)}}},computed:{style:function(){if(void 0!==this.align)return{verticalAlign:this.align}},classes:function(){var t=!0===this.outline&&this.color||this.textColor;return"q-badge flex inline items-center no-wrap q-badge--"+(!0===this.multiLine?"multi":"single")+"-line"+(!0===this.outline?" q-badge--outline":void 0!==this.color?" bg-"+this.color:"")+(void 0!==t?" text-"+t:"")+(!0===this.floating?" q-badge--floating":"")+(!0===this.transparent?" q-badge--transparent":"")},attrs:function(){return{role:"alert","aria-label":this.label}}},render:function(t){return t("div",{style:this.style,class:this.classes,attrs:this.attrs,on:Object.assign({},this.qListeners)},void 0!==this.label?[this.label]:Bt(this,"default"))}}),It={props:{dark:{type:Boolean,default:null}},computed:{isDark:function(){return null===this.dark?this.$q.dark.isActive:this.dark}}},Nt={role:"alert"},Ft=t.extend({name:"QBanner",mixins:[Ot,It],props:{inlineActions:Boolean,dense:Boolean,rounded:Boolean},render:function(t){var e=Bt(this,"action"),n=[t("div",{staticClass:"q-banner__avatar col-auto row items-center self-start"},Bt(this,"avatar")),t("div",{staticClass:"q-banner__content col text-body2"},Bt(this,"default"))];return void 0!==e&&n.push(t("div",{staticClass:"q-banner__actions row items-center justify-end",class:"col-"+(!0===this.inlineActions?"auto":"all")},e)),t("div",{staticClass:"q-banner row items-center",class:{"q-banner--top-padding":void 0!==e&&!this.inlineActions,"q-banner--dense":this.dense,"q-banner--dark q-dark":this.isDark,"rounded-borders":this.rounded},attrs:Nt,on:Object.assign({},this.qListeners)},n)}}),$t={role:"toolbar"},jt=t.extend({name:"QBar",mixins:[Ot,It],props:{dense:Boolean},computed:{classes:function(){return"q-bar--"+(!0===this.dense?"dense":"standard")+" q-bar--"+(!0===this.isDark?"dark":"light")}},render:function(t){return t("div",{staticClass:"q-bar row no-wrap items-center",class:this.classes,attrs:$t,on:Object.assign({},this.qListeners)},Bt(this,"default"))}}),zt={left:"start",center:"center",right:"end",between:"between",around:"around",evenly:"evenly",stretch:"stretch"},Vt=Object.keys(zt),Ht={props:{align:{type:String,validator:function(t){return Vt.includes(t)}}},computed:{alignClass:function(){var t=void 0===this.align?!0===this.vertical?"stretch":"left":this.align;return(!0===this.vertical?"items":"justify")+"-"+zt[t]}}},Wt=t.extend({name:"QBreadcrumbs",mixins:[Ot,Ht],props:{separator:{type:String,default:"/"},separatorColor:String,activeColor:{type:String,default:"primary"},gutter:{type:String,validator:function(t){return["none","xs","sm","md","lg","xl"].includes(t)},default:"sm"}},computed:{classes:function(){return this.alignClass+("none"===this.gutter?"":" q-gutter-"+this.gutter)},sepClass:function(){if(this.separatorColor)return"text-"+this.separatorColor},activeClass:function(){return"text-"+this.activeColor}},render:function(t){var e=this,n=Bt(this,"default");if(void 0!==n){var i=1,r=[],o=n.filter((function(t){return void 0!==t.tag&&t.tag.endsWith("-QBreadcrumbsEl")})).length,a=void 0!==this.$scopedSlots.separator?this.$scopedSlots.separator:function(){return e.separator};return n.forEach((function(n){if(void 0!==n.tag&&n.tag.endsWith("-QBreadcrumbsEl")){var s=i<o;i++,r.push(t("div",{staticClass:"flex items-center",class:s?e.activeClass:"q-breadcrumbs--last"},[n])),s&&r.push(t("div",{staticClass:"q-breadcrumbs__separator",class:e.sepClass},a()))}else r.push(n)})),t("div",{staticClass:"q-breadcrumbs",on:Object.assign({},this.qListeners)},[t("div",{staticClass:"flex items-center",class:this.classes},r)])}}}),Ut={props:{to:[String,Object],exact:Boolean,append:Boolean,replace:Boolean,activeClass:String,exactActiveClass:String,disable:Boolean},computed:{hasRouterLink:function(){return!0!==this.disable&&void 0!==this.to&&null!==this.to&&""!==this.to},routerLinkProps:function(){return{to:this.to,exact:this.exact,append:this.append,replace:this.replace,activeClass:this.activeClass||"q-router-link--active",exactActiveClass:this.exactActiveClass||"q-router-link--exact-active",event:!0===this.disable?"":void 0}}}},Yt=t.extend({name:"QBreadcrumbsEl",mixins:[Ot,Ut],props:{label:String,icon:String},render:function(t){var e,n=[];return void 0!==this.icon&&n.push(t(Lt,{staticClass:"q-breadcrumbs__el-icon",class:void 0!==this.label?"q-breadcrumbs__el-icon--with-label":null,props:{name:this.icon}})),this.label&&n.push(this.label),t(!0===this.hasRouterLink?"router-link":"span",((e={staticClass:"q-breadcrumbs__el q-link flex inline items-center relative-position",props:!0===this.hasRouterLink?this.routerLinkProps:null})[!0===this.hasRouterLink?"nativeOn":"on"]=Object.assign({},this.qListeners),e),At(n,this,"default"))}}),Qt={mixins:[Ot],props:{color:String,size:{type:[Number,String],default:"1em"}},computed:{cSize:function(){return this.size in St?St[this.size]+"px":this.size},classes:function(){if(this.color)return"text-"+this.color}}},Gt=t.extend({name:"QSpinner",mixins:[Qt],props:{thickness:{type:Number,default:5}},render:function(t){return t("svg",{staticClass:"q-spinner q-spinner-mat",class:this.classes,on:Object.assign({},this.qListeners),attrs:{focusable:"false",width:this.cSize,height:this.cSize,viewBox:"25 25 50 50"}},[t("circle",{staticClass:"path",attrs:{cx:"50",cy:"50",r:"20",fill:"none",stroke:"currentColor","stroke-width":this.thickness,"stroke-miterlimit":"10"}})])}});function Kt(t){if(t===window)return{top:0,left:0};var e=t.getBoundingClientRect();return{top:e.top,left:e.left}}function Jt(t){return t===window?window.innerHeight:t.getBoundingClientRect().height}function Zt(t,e){var n=t.style;Object.keys(e).forEach((function(t){n[t]=e[t]}))}function Xt(t,e){return!0===t?e===document.documentElement||null===e?document.body:e:document.body}var te={offset:Kt,style:function(t,e){return window.getComputedStyle(t).getPropertyValue(e)},height:Jt,width:function(t){return t===window?window.innerWidth:t.getBoundingClientRect().width},css:Zt,cssBatch:function(t,e){t.forEach((function(t){return Zt(t,e)}))},ready:function(t){if("function"==typeof t)return"loading"!==document.readyState?t():void document.addEventListener("DOMContentLoaded",t,!1)}};function ee(t,e){void 0===e&&(e=250);var n,i=!1;return function(){return!1===i&&(i=!0,setTimeout((function(){i=!1}),e),n=t.apply(this,arguments)),n}}function ne(t,e,n,i){!0===n.modifiers.stop&&_(t);var r=n.modifiers.color,o=n.modifiers.center;o=!0===o||!0===i;var a=document.createElement("span"),s=document.createElement("span"),l=g(t),c=e.getBoundingClientRect(),u=c.left,d=c.top,h=c.width,f=c.height,p=Math.sqrt(h*h+f*f),m=p/2,v=(h-p)/2+"px",y=o?v:l.left-u-m+"px",b=(f-p)/2+"px",w=o?b:l.top-d-m+"px";s.className="q-ripple__inner",Zt(s,{height:p+"px",width:p+"px",transform:"translate3d("+y+","+w+",0) scale3d(.2,.2,1)",opacity:0}),a.className="q-ripple"+(r?" text-"+r:""),a.setAttribute("dir","ltr"),a.appendChild(s),e.appendChild(a);var k=function(){a.remove(),clearTimeout(x)};n.abort.push(k);var x=setTimeout((function(){s.classList.add("q-ripple__inner--enter"),s.style.transform="translate3d("+v+","+b+",0) scale3d(1,1,1)",s.style.opacity=.2,x=setTimeout((function(){s.classList.remove("q-ripple__inner--enter"),s.classList.add("q-ripple__inner--leave"),s.style.opacity=0,x=setTimeout((function(){a.remove(),n.abort.splice(n.abort.indexOf(k),1)}),275)}),250)}),50)}function ie(t,e){var n=e.modifiers,i=e.value,r=e.arg,o=Object.assign({},at.config.ripple,n,i);t.modifiers={early:!0===o.early,stop:!0===o.stop,center:!0===o.center,color:o.color||r,keyCodes:[].concat(o.keyCodes||13)}}function re(t){var e=t.__qripple;void 0!==e&&(e.abort.forEach((function(t){t()})),S(e,"main"),delete t._qripple)}var oe={name:"ripple",inserted:function(t,e){void 0!==t.__qripple&&(re(t),t.__qripple_destroyed=!0);var n={enabled:!1!==e.value,modifiers:{},abort:[],start:function(e){!0===n.enabled&&!0!==e.qSkipRipple&&(!0!==d.is.ie||e.clientX>=0)&&(!0===n.modifiers.early?!0===["mousedown","touchstart"].includes(e.type):"click"===e.type)&&ne(e,t,n,!0===e.qKeyEvent)},keystart:ee((function(e){!0===n.enabled&&!0!==e.qSkipRipple&&!0===X(e,n.modifiers.keyCodes)&&e.type==="key"+(!0===n.modifiers.early?"down":"up")&&ne(e,t,n,!0)}),300)};ie(n,e),t.__qripple=n,C(n,"main",[[t,"mousedown","start","passive"],[t,"touchstart","start","passive"],[t,"click","start","passive"],[t,"keydown","keystart","passive"],[t,"keyup","keystart","passive"]])},update:function(t,e){var n=t.__qripple;void 0!==n&&e.oldValue!==e.value&&(n.enabled=!1!==e.value,!0===n.enabled&&Object(e.value)===e.value&&ie(n,e))},unbind:function(t){void 0===t.__qripple_destroyed?re(t):delete t.__qripple_destroyed}},ae={directives:{Ripple:oe},props:{ripple:{type:[Boolean,Object],default:!0}}},se={none:0,xs:4,sm:8,md:16,lg:24,xl:32},le={mixins:[Ot,ae,Ht,Mt({xs:8,sm:10,md:14,lg:20,xl:24})],props:{type:String,to:[Object,String],replace:Boolean,append:Boolean,label:[Number,String],icon:String,iconRight:String,round:Boolean,outline:Boolean,flat:Boolean,unelevated:Boolean,rounded:Boolean,push:Boolean,glossy:Boolean,size:String,fab:Boolean,fabMini:Boolean,padding:String,color:String,textColor:String,noCaps:Boolean,noWrap:Boolean,dense:Boolean,tabindex:[Number,String],align:{default:"center"},stack:Boolean,stretch:Boolean,loading:{type:Boolean,default:null},disable:Boolean},computed:{style:function(){if(!1===this.fab&&!1===this.fabMini)return this.sizeStyle},isRounded:function(){return!0===this.rounded||!0===this.fab||!0===this.fabMini},isActionable:function(){return!0!==this.disable&&!0!==this.loading},computedTabIndex:function(){return!0===this.isActionable?this.tabindex||0:-1},hasRouterLink:function(){return!0!==this.disable&&void 0!==this.to&&null!==this.to&&""!==this.to},isLink:function(){return"a"===this.type||!0===this.hasRouterLink},design:function(){return!0===this.flat?"flat":!0===this.outline?"outline":!0===this.push?"push":!0===this.unelevated?"unelevated":"standard"},currentLocation:function(){if(!0===this.hasRouterLink)return!0===this.append?this.$router.resolve(this.to,this.$route,!0):this.$router.resolve(this.to)},attrs:function(){var t={tabindex:this.computedTabIndex};return"a"!==this.type&&(t.type=this.type||"button"),!0===this.hasRouterLink?(t.href=this.currentLocation.href,t.role="link"):t.role="a"===this.type?"link":"button",!0===this.loading&&void 0!==this.percentage&&(t.role="progressbar",t["aria-valuemin"]=0,t["aria-valuemax"]=100,t["aria-valuenow"]=this.percentage),!0===this.disable&&(t.disabled="",t["aria-disabled"]="true"),t},classes:function(){var t;return void 0!==this.color?t=!0===this.flat||!0===this.outline?"text-"+(this.textColor||this.color):"bg-"+this.color+" text-"+(this.textColor||"white"):this.textColor&&(t="text-"+this.textColor),"q-btn--"+this.design+" q-btn--"+(!0===this.round?"round":"rectangle"+(!0===this.isRounded?" q-btn--rounded":""))+(void 0!==t?" "+t:"")+(!0===this.isActionable?" q-btn--actionable q-focusable q-hoverable":!0===this.disable?" disabled":"")+(!0===this.fab?" q-btn--fab":!0===this.fabMini?" q-btn--fab-mini":"")+(!0===this.noCaps?" q-btn--no-uppercase":"")+(!0===this.noWrap?"":" q-btn--wrap")+(!0===this.dense?" q-btn--dense":"")+(!0===this.stretch?" no-border-radius self-stretch":"")+(!0===this.glossy?" glossy":"")},innerClasses:function(){return this.alignClass+(!0===this.stack?" column":" row")+(!0===this.noWrap?" no-wrap text-no-wrap":"")+(!0===this.loading?" q-btn__content--hidden":"")},wrapperStyle:function(){if(void 0!==this.padding)return{padding:this.padding.split(/\s+/).map((function(t){return t in se?se[t]+"px":t})).join(" "),minWidth:"0",minHeight:"0"}}}},ce=["left","right","up","down","horizontal","vertical"],ue={left:!0,right:!0,up:!0,down:!0,horizontal:!0,vertical:!0,all:!0};function de(t){var e={};return ce.forEach((function(n){t[n]&&(e[n]=!0)})),0===Object.keys(e).length?ue:(!0===e.horizontal&&(e.left=e.right=!0),!0===e.vertical&&(e.up=e.down=!0),!0===e.left&&!0===e.right&&(e.horizontal=!0),!0===e.up&&!0===e.down&&(e.vertical=!0),!0===e.horizontal&&!0===e.vertical&&(e.all=!0),e)}var he=!1===i&&!0!==a&&(!0===d.is.ios||window.navigator.vendor.toLowerCase().indexOf("apple")>-1)?function(){return document}:function(t){return t};function fe(t,e){return void 0===e.event&&void 0!==t.target&&!0!==t.target.draggable&&"function"==typeof e.handler&&"INPUT"!==t.target.nodeName.toUpperCase()&&(void 0===t.qClonedBy||-1===t.qClonedBy.indexOf(e.uid))}var pe=f.passiveCapture,me=void 0,ve=void 0,ge=void 0,ye={role:"img","aria-hidden":"true"},_e=t.extend({name:"QBtn",mixins:[le],props:{percentage:Number,darkPercentage:Boolean},computed:{hasLabel:function(){return void 0!==this.label&&null!==this.label&&""!==this.label},computedRipple:function(){return!1!==this.ripple&&Object.assign({},{keyCodes:!0===this.isLink?[13,32]:[13]},!0===this.ripple?{}:this.ripple)},percentageStyle:function(){var t=Math.max(0,Math.min(100,this.percentage));if(t>0)return{transition:"transform 0.6s",transform:"translateX("+(t-100)+"%)"}},onEvents:function(){if(!0===this.loading)return{mousedown:this.__onLoadingEvt,touchstart:this.__onLoadingEvt,click:this.__onLoadingEvt,keydown:this.__onLoadingEvt,keyup:this.__onLoadingEvt};if(!0===this.isActionable){var t=Object.assign({},this.qListeners,{click:this.click,keydown:this.__onKeydown,mousedown:this.__onMousedown});return!0===this.$q.platform.has.touch&&(t.touchstart=this.__onTouchstart),t}return{}},directives:function(){if(!0!==this.disable&&!1!==this.ripple)return[{name:"ripple",value:this.computedRipple,modifiers:{center:this.round}}]}},methods:{click:function(t){var e=this;if(void 0!==t){if(!0===t.defaultPrevented)return;var n=document.activeElement;if("submit"===this.type&&(!0===this.$q.platform.is.ie&&(t.clientX<0||t.clientY<0)||n!==document.body&&!1===this.$el.contains(n)&&!1===n.contains(this.$el))){this.$el.focus();var i=function(){document.removeEventListener("keydown",w,!0),document.removeEventListener("keyup",i,pe),void 0!==e.$el&&e.$el.removeEventListener("blur",i,pe)};document.addEventListener("keydown",w,!0),document.addEventListener("keyup",i,pe),this.$el.addEventListener("blur",i,pe)}if(!0===this.hasRouterLink){if(!0===t.ctrlKey||!0===t.shiftKey||!0===t.altKey||!0===t.metaKey)return;w(t)}}var r=function(){e.$router[!0===e.replace?"replace":"push"](e.currentLocation.route,void 0,m)};this.$emit("click",t,r),!0===this.hasRouterLink&&!1!==t.navigate&&r()},__onKeydown:function(t){!0===X(t,[13,32])&&(w(t),ve!==this.$el&&(void 0!==ve&&this.__cleanup(),this.$el.focus(),ve=this.$el,this.$el.classList.add("q-btn--active"),document.addEventListener("keyup",this.__onPressEnd,!0),this.$el.addEventListener("blur",this.__onPressEnd,pe))),this.$emit("keydown",t)},__onTouchstart:function(t){var e=this;if(me!==this.$el){void 0!==me&&this.__cleanup(),me=this.$el;var n=this.touchTargetEl=he(t.target);n.addEventListener("touchcancel",this.__onPressEnd,pe),n.addEventListener("touchend",this.__onPressEnd,pe)}this.avoidMouseRipple=!0,clearTimeout(this.mouseTimer),this.mouseTimer=setTimeout((function(){e.avoidMouseRipple=!1}),200),this.$emit("touchstart",t)},__onMousedown:function(t){ge!==this.$el&&(void 0!==ge&&this.__cleanup(),ge=this.$el,this.$el.classList.add("q-btn--active"),document.addEventListener("mouseup",this.__onPressEnd,pe)),t.qSkipRipple=!0===this.avoidMouseRipple,this.$emit("mousedown",t)},__onPressEnd:function(t){if(void 0===t||"blur"!==t.type||document.activeElement!==this.$el){if(void 0!==t&&"keyup"===t.type){if(ve===this.$el&&!0===X(t,[13,32])){var e=new MouseEvent("click",t);e.qKeyEvent=!0,!0===t.defaultPrevented&&b(e),!0===t.cancelBubble&&_(e),this.$el.dispatchEvent(e),w(t),t.qKeyEvent=!0}this.$emit("keyup",t)}this.__cleanup()}},__cleanup:function(t){var e=this.$refs.blurTarget;if(!0===t||me!==this.$el&&ge!==this.$el||void 0===e||e===document.activeElement||(e.setAttribute("tabindex",-1),e.focus()),me===this.$el){var n=this.touchTargetEl;n.removeEventListener("touchcancel",this.__onPressEnd,pe),n.removeEventListener("touchend",this.__onPressEnd,pe),me=this.touchTargetEl=void 0}ge===this.$el&&(document.removeEventListener("mouseup",this.__onPressEnd,pe),ge=void 0),ve===this.$el&&(document.removeEventListener("keyup",this.__onPressEnd,!0),void 0!==this.$el&&this.$el.removeEventListener("blur",this.__onPressEnd,pe),ve=void 0),void 0!==this.$el&&this.$el.classList.remove("q-btn--active")},__onLoadingEvt:function(t){w(t),t.qSkipRipple=!0}},beforeDestroy:function(){this.__cleanup(!0)},render:function(t){var e=[];void 0!==this.icon&&e.push(t(Lt,{attrs:ye,props:{name:this.icon,left:!1===this.stack&&!0===this.hasLabel}})),!0===this.hasLabel&&e.push(t("span",{staticClass:"block"},[this.label])),e=At(e,this,"default"),void 0!==this.iconRight&&!1===this.round&&e.push(t(Lt,{attrs:ye,props:{name:this.iconRight,right:!1===this.stack&&!0===this.hasLabel}}));var n=[t("span",{staticClass:"q-focus-helper",ref:"blurTarget"})];return!0===this.loading&&void 0!==this.percentage&&n.push(t("span",{staticClass:"q-btn__progress absolute-full overflow-hidden"},[t("span",{staticClass:"q-btn__progress-indicator fit block",class:!0===this.darkPercentage?"q-btn__progress--dark":"",style:this.percentageStyle})])),n.push(t("span",{staticClass:"q-btn__wrapper col row q-anchor--skip",style:this.wrapperStyle},[t("span",{staticClass:"q-btn__content text-center col items-center q-anchor--skip",class:this.innerClasses},e)])),null!==this.loading&&n.push(t("transition",{props:{name:"q-transition--fade"}},!0===this.loading?[t("span",{key:"loading",staticClass:"absolute-full flex flex-center"},void 0!==this.$scopedSlots.loading?this.$scopedSlots.loading():[t(Gt)])]:void 0)),t(!0===this.isLink?"a":"button",{staticClass:"q-btn q-btn-item non-selectable no-outline",class:this.classes,style:this.style,attrs:this.attrs,on:this.onEvents,directives:this.directives},n)}}),be=t.extend({name:"QBtnGroup",mixin:[Ot],props:{unelevated:Boolean,outline:Boolean,flat:Boolean,rounded:Boolean,push:Boolean,stretch:Boolean,glossy:Boolean,spread:Boolean},computed:{classes:function(){var t=this;return["unelevated","outline","flat","rounded","push","stretch","glossy"].filter((function(e){return!0===t[e]})).map((function(t){return"q-btn-group--"+t})).join(" ")}},render:function(t){return t("div",{staticClass:"q-btn-group row no-wrap "+(!0===this.spread?"q-btn-group--spread":"inline"),class:this.classes,on:Object.assign({},this.qListeners)},Bt(this,"default"))}});function we(){if(void 0!==window.getSelection){var t=window.getSelection();void 0!==t.empty?t.empty():void 0!==t.removeAllRanges&&(t.removeAllRanges(),!0!==h.is.mobile&&t.addRange(document.createRange()))}else void 0!==document.selection&&document.selection.empty()}var ke={props:{target:{default:!0},noParentEvent:Boolean,contextMenu:Boolean},watch:{contextMenu:function(t){void 0!==this.anchorEl&&(this.__unconfigureAnchorEl(),this.__configureAnchorEl(t))},target:function(){void 0!==this.anchorEl&&this.__unconfigureAnchorEl(),this.__pickAnchorEl()},noParentEvent:function(t){void 0!==this.anchorEl&&(!0===t?this.__unconfigureAnchorEl():this.__configureAnchorEl())}},methods:{__showCondition:function(t){return void 0!==this.anchorEl&&(void 0===t||(void 0===t.touches||t.touches.length<=1))},__contextClick:function(t){var e=this;this.hide(t),this.$nextTick((function(){e.show(t)})),b(t)},__toggleKey:function(t){!0===X(t,13)&&this.toggle(t)},__mobileCleanup:function(t){this.anchorEl.classList.remove("non-selectable"),clearTimeout(this.touchTimer),!0===this.showing&&void 0!==t&&we()},__mobilePrevent:b,__mobileTouch:function(t){var e=this;if(this.__mobileCleanup(t),!0===this.__showCondition(t)){this.hide(t),this.anchorEl.classList.add("non-selectable");var n=he(t.target);C(this,"anchor",[[n,"touchmove","__mobileCleanup","passive"],[n,"touchend","__mobileCleanup","passive"],[n,"touchcancel","__mobileCleanup","passive"],[this.anchorEl,"contextmenu","__mobilePrevent","notPassive"]]),this.touchTimer=setTimeout((function(){e.show(t)}),300)}},__unconfigureAnchorEl:function(){S(this,"anchor")},__configureAnchorEl:function(t){(void 0===t&&(t=this.contextMenu),!0!==this.noParentEvent&&void 0!==this.anchorEl)&&C(this,"anchor",!0===t?!0===this.$q.platform.is.mobile?[[this.anchorEl,"touchstart","__mobileTouch","passive"]]:[[this.anchorEl,"click","hide","passive"],[this.anchorEl,"contextmenu","__contextClick","notPassive"]]:[[this.anchorEl,"click","toggle","passive"],[this.anchorEl,"keyup","__toggleKey","passive"]])},__setAnchorEl:function(t){for(this.anchorEl=t;this.anchorEl.classList.contains("q-anchor--skip");)this.anchorEl=this.anchorEl.parentNode;this.__configureAnchorEl()},__pickAnchorEl:function(){if(!1===this.target||""===this.target)this.anchorEl=void 0;else if(!0===this.target)this.__setAnchorEl(this.parentEl);else{var t=this.target;if("string"==typeof this.target)try{t=document.querySelector(this.target)}catch(e){t=void 0}null!=t?(this.anchorEl=!0===t._isVue&&void 0!==t.$el?t.$el:t,this.__configureAnchorEl()):(this.anchorEl=void 0,console.error('Anchor: target "'+this.target+'" not found',this))}},__changeScrollEvent:function(t,e){var n=(void 0!==e?"add":"remove")+"EventListener",i=void 0!==e?e:this.__scrollFn;t!==window&&t[n]("scroll",i,f.passive),window[n]("scroll",i,f.passive),this.__scrollFn=e}},created:function(){var t=this;"function"==typeof this.__configureScrollTarget&&"function"==typeof this.__unconfigureScrollTarget&&(this.noParentEventWatcher=this.$watch("noParentEvent",(function(){void 0!==t.__scrollTarget&&(t.__unconfigureScrollTarget(),t.__configureScrollTarget())})))},mounted:function(){this.parentEl=this.$el.parentNode,this.__pickAnchorEl(),!0===this.value&&void 0===this.anchorEl&&this.$emit("input",!1)},beforeDestroy:function(){clearTimeout(this.touchTimer),void 0!==this.noParentEventWatcher&&this.noParentEventWatcher(),void 0!==this.__anchorCleanup&&this.__anchorCleanup(),this.__unconfigureAnchorEl()}},xe={methods:{__nextTick:function(t){this.__tickFn=t},__prepareTick:function(){var t=this;if(void 0!==this.__tickFn){var e=this.__tickFn;this.$nextTick((function(){t.__tickFn===e&&(t.__tickFn(),t.__tickFn=void 0)}))}},__clearTick:function(){this.__tickFn=void 0},__setTimeout:function(t,e){clearTimeout(this.__timer),this.__timer=setTimeout(t,e)},__clearTimeout:function(){clearTimeout(this.__timer)}},beforeDestroy:function(){this.__tickFn=void 0,clearTimeout(this.__timer)}},Ce={mixins:[xe,Ot],props:{value:{type:Boolean,default:void 0}},data:function(){return{showing:!1}},watch:{value:function(t){this.__processModelChange(t)},$route:function(){!0===this.hideOnRouteChange&&!0===this.showing&&this.hide()}},methods:{toggle:function(t){this[!0===this.showing?"hide":"show"](t)},show:function(t){var e=this;!0===this.disable||void 0!==this.__showCondition&&!0!==this.__showCondition(t)||(void 0!==this.qListeners.input&&!1===i&&(this.$emit("input",!0),this.payload=t,this.$nextTick((function(){e.payload===t&&(e.payload=void 0)}))),void 0!==this.value&&void 0!==this.qListeners.input&&!0!==i||this.__processShow(t))},__processShow:function(t){!0!==this.showing&&(void 0!==this.__preparePortal&&this.__preparePortal(),this.showing=!0,this.$emit("before-show",t),void 0!==this.__show?(this.__clearTick(),this.__show(t),this.__prepareTick()):this.$emit("show",t))},hide:function(t){var e=this;!0!==this.disable&&(void 0!==this.qListeners.input&&!1===i&&(this.$emit("input",!1),this.payload=t,this.$nextTick((function(){e.payload===t&&(e.payload=void 0)}))),void 0!==this.value&&void 0!==this.qListeners.input&&!0!==i||this.__processHide(t))},__processHide:function(t){!1!==this.showing&&(this.showing=!1,this.$emit("before-hide",t),void 0!==this.__hide?(this.__clearTick(),this.__hide(t),this.__prepareTick()):this.$emit("hide",t))},__processModelChange:function(t){!0===this.disable&&!0===t?void 0!==this.qListeners.input&&this.$emit("input",!1):!0===t!==this.showing&&this["__process"+(!0===t?"Show":"Hide")](this.payload)}}};function Se(t,e){do{if("QMenu"===t.$options.name){if(t.hide(e),!0===t.separateClosePopup)return t.$parent}else if(void 0!==t.__renderPortal)return void 0!==t.$parent&&"QPopupProxy"===t.$parent.$options.name?(t.hide(e),t.$parent):t;t=t.$parent}while(void 0!==t)}var Me={inheritAttrs:!1,props:{contentClass:[Array,String,Object],contentStyle:[Array,String,Object]},methods:{__showPortal:function(){var t=this;if(void 0!==this.$q.fullscreen&&!0===this.$q.fullscreen.isCapable){var e=function(e){if(void 0!==t.__portal){var n=Xt(e,t.$q.fullscreen.activeEl);t.__portal.$el.parentElement!==n&&n.contains(t.$el)===(!1===t.__onGlobalDialog)&&n.appendChild(t.__portal.$el)}};this.unwatchFullscreen=this.$watch("$q.fullscreen.isActive",e);var n=this.$q.fullscreen.isActive;!1!==this.__onGlobalDialog&&!0!==n||e(n)}else void 0!==this.__portal&&!1===this.__onGlobalDialog&&document.body.appendChild(this.__portal.$el)},__hidePortal:function(){void 0!==this.__portal&&(void 0!==this.unwatchFullscreen&&(this.unwatchFullscreen(),this.unwatchFullscreen=void 0),!1===this.__onGlobalDialog&&(this.__portal.$destroy(),this.__portal.$el.remove()),this.__portal=void 0)},__preparePortal:function(){var e=this;void 0===this.__portal&&(this.__portal=!0===this.__onGlobalDialog?{$el:this.$el,$refs:this.$refs}:new t({name:"QPortal",parent:this,inheritAttrs:!1,render:function(t){return e.__renderPortal(t)},components:this.$options.components,directives:this.$options.directives}).$mount())}},render:function(t){if(!0===this.__onGlobalDialog)return this.__renderPortal(t);void 0!==this.__portal&&this.__portal.$forceUpdate()},beforeDestroy:function(){this.__hidePortal()}};!1===i&&(Me.created=function(){this.__onGlobalDialog=function(t){for(;void 0!==t;){if("QGlobalDialog"===t.$options.name)return!0;if("QDialog"===t.$options.name)return!1;t=t.$parent}return!1}(this.$parent)});var Te,Pe={props:{transitionShow:{type:String,default:"fade"},transitionHide:{type:String,default:"fade"}},data:function(){return{transitionState:this.showing}},watch:{showing:function(t){var e=this;this.transitionShow!==this.transitionHide&&this.$nextTick((function(){e.transitionState=t}))}},computed:{transition:function(){return"q-transition--"+(!0===this.transitionState?this.transitionHide:this.transitionShow)}}};var Oe=f.notPassiveCapture,Be=f.passiveCapture,Ee={click:[],focus:[]};function Ae(t,e){for(var n=t.length-1;n>=0;n--)if(void 0===t[n](e))return}function De(t){clearTimeout(Te),"focusin"===t.type&&!0===t.target.hasAttribute("tabindex")?Te=setTimeout((function(){Ae(Ee.focus,t)}),200):Ae(Ee.click,t)}var Le,qe={name:"click-outside",bind:function(t,e,n){var i=e.value,r=e.arg,o=n.componentInstance||n.context,a={trigger:i,toggleEl:r,handler:function(t){var e=t.target;if(!(void 0===e||8===e.nodeType||e===document.documentElement||!1!==e.classList.contains("no-pointer-events")||void 0!==a.toggleEl&&!1!==a.toggleEl.contains(e)||e!==document.body&&!1!==function(t,e){for(var n=t;void 0!==n;n=n.$parent)if(n===e)return!0;return!1}(function(t){for(var e=t;null!==e;e=e.parentNode){if(null===e.__vue__)return;if(void 0!==e.__vue__)return e.__vue__}}(e),o)))return t.qClickOutside=!0,a.trigger(t)}};t.__qclickoutside&&(t.__qclickoutside_old=t.__qclickoutside),t.__qclickoutside=a,0===Ee.click.length&&(document.addEventListener("mousedown",De,Oe),document.addEventListener("touchstart",De,Oe),document.addEventListener("focusin",De,Be)),Ee.click.push(a.handler),a.timerFocusin=setTimeout((function(){Ee.focus.push(a.handler)}),500)},update:function(t,e){var n=e.value,i=e.oldValue,r=e.arg,o=t.__qclickoutside;n!==i&&(o.trigger=n),r!==o.arg&&(o.toggleEl=r)},unbind:function(t){var e=t.__qclickoutside_old||t.__qclickoutside;if(void 0!==e){clearTimeout(e.timerFocusin);var n=Ee.click.findIndex((function(t){return t===e.handler})),i=Ee.focus.findIndex((function(t){return t===e.handler}));n>-1&&Ee.click.splice(n,1),i>-1&&Ee.focus.splice(i,1),0===Ee.click.length&&(clearTimeout(Te),document.removeEventListener("mousedown",De,Oe),document.removeEventListener("touchstart",De,Oe),document.removeEventListener("focusin",De,Be)),delete t[t.__qclickoutside_old?"__qclickoutside_old":"__qclickoutside"]}}},Re=!1===i?[null,document,document.body,document.scrollingElement,document.documentElement]:[];function Ie(t,e){if("string"==typeof e)try{e=document.querySelector(e)}catch(t){e=void 0}return null==e?e=t.closest(".scroll,.scroll-y,.overflow-auto"):!0===e._isVue&&void 0!==e.$el&&(e=e.$el),Re.includes(e)?window:e}function Ne(t){return(t===window?document.body:t).scrollHeight}function Fe(t){return t===window?window.pageYOffset||window.scrollY||document.body.scrollTop||0:t.scrollTop}function $e(t){return t===window?window.pageXOffset||window.scrollX||document.body.scrollLeft||0:t.scrollLeft}function je(t,e,n){void 0===n&&(n=0);var i=Fe(t);n<=0?i!==e&&Ve(t,e):requestAnimationFrame((function(){var r=i+(e-i)/Math.max(16,n)*16;Ve(t,r),r!==e&&je(t,e,n-16)}))}function ze(t,e,n){void 0===n&&(n=0);var i=$e(t);n<=0?i!==e&&He(t,e):requestAnimationFrame((function(){var r=i+(e-i)/Math.max(16,n)*16;He(t,r),r!==e&&ze(t,e,n-16)}))}function Ve(t,e){t!==window?t.scrollTop=e:window.scrollTo(window.pageXOffset||window.scrollX||document.body.scrollLeft||0,e)}function He(t,e){t!==window?t.scrollLeft=e:window.scrollTo(e,window.pageYOffset||window.scrollY||document.body.scrollTop||0)}function We(t,e,n){n?je(t,e,n):Ve(t,e)}function Ue(t,e,n){n?ze(t,e,n):He(t,e)}function Ye(){if(void 0!==Le)return Le;var t=document.createElement("p"),e=document.createElement("div");Zt(t,{width:"100%",height:"200px"}),Zt(e,{position:"absolute",top:"0px",left:"0px",visibility:"hidden",width:"200px",height:"150px",overflow:"hidden"}),e.appendChild(t),document.body.appendChild(e);var n=t.offsetWidth;e.style.overflow="scroll";var i=t.offsetWidth;return n===i&&(i=e.clientWidth),e.remove(),Le=n-i}function Qe(t,e){return void 0===e&&(e=!0),!(!t||t.nodeType!==Node.ELEMENT_NODE)&&(e?t.scrollHeight>t.clientHeight&&(t.classList.contains("scroll")||t.classList.contains("overflow-auto")||["auto","scroll"].includes(window.getComputedStyle(t)["overflow-y"])):t.scrollWidth>t.clientWidth&&(t.classList.contains("scroll")||t.classList.contains("overflow-auto")||["auto","scroll"].includes(window.getComputedStyle(t)["overflow-x"])))}var Ge,Ke,Je={getScrollTarget:Ie,getScrollHeight:Ne,getScrollWidth:function(t){return(t===window?document.body:t).scrollWidth},getScrollPosition:Fe,getHorizontalScrollPosition:$e,animScrollTo:je,animHorizontalScrollTo:ze,setScrollPosition:We,setHorizontalScrollPosition:Ue,getScrollbarWidth:Ye,hasScrollbar:Qe},Ze=[],Xe=!1,tn={__install:function(){this.__installed=!0,window.addEventListener("keydown",(function(t){Xe=27===t.keyCode})),window.addEventListener("blur",(function(){!0===Xe&&(Xe=!1)})),window.addEventListener("keyup",(function(t){!0===Xe&&(Xe=!1,0!==Ze.length&&!0===X(t,27)&&Ze[Ze.length-1].fn(t))}))},register:function(t,e){!0===t.$q.platform.is.desktop&&(!0!==this.__installed&&this.__install(),Ze.push({comp:t,fn:e}))},pop:function(t){if(!0===t.$q.platform.is.desktop){var e=Ze.findIndex((function(e){return e.comp===t}));e>-1&&Ze.splice(e,1)}}};function en(t){var e=t.split(" ");return 2===e.length&&(["top","center","bottom"].includes(e[0])?!!["left","middle","right"].includes(e[1])||(console.error("Anchor/Self position must end with one of left/middle/right"),!1):(console.error("Anchor/Self position must start with one of top/center/bottom"),!1))}function nn(t){return!t||2===t.length&&("number"==typeof t[0]&&"number"==typeof t[1])}function rn(t){var e=t.split(" ");return{vertical:e[0],horizontal:e[1]}}function on(t){if(!0===d.is.ios&&void 0!==window.visualViewport){var e=document.body.style,n=window.visualViewport,i=n.offsetLeft,r=n.offsetTop;i!==Ge&&(e.setProperty("--q-pe-left",i+"px"),Ge=i),r!==Ke&&(e.setProperty("--q-pe-top",r+"px"),Ke=r)}var o,a=t.el,s=a.scrollLeft,l=a.scrollTop;if(void 0===t.absoluteOffset)o=function(t,e){var n=t.getBoundingClientRect(),i=n.top,r=n.left,o=n.right,a=n.bottom,s=n.width,l=n.height;return void 0!==e&&(i-=e[1],r-=e[0],a+=e[1],o+=e[0],s+=e[0],l+=e[1]),{top:i,left:r,right:o,bottom:a,width:s,height:l,middle:r+(o-r)/2,center:i+(a-i)/2}}(t.anchorEl,!0===t.cover?[0,0]:t.offset);else{var c=t.anchorEl.getBoundingClientRect(),u=c.top,h=c.left,f=u+t.absoluteOffset.top,p=h+t.absoluteOffset.left;o={top:f,left:p,width:1,height:1,right:p+1,center:f,middle:p,bottom:f+1}}var m={maxHeight:t.maxHeight,maxWidth:t.maxWidth,visibility:"visible"};!0!==t.fit&&!0!==t.cover||(m.minWidth=o.width+"px",!0===t.cover&&(m.minHeight=o.height+"px")),Object.assign(t.el.style,m);var v=function(t){return{top:0,center:t.offsetHeight/2,bottom:t.offsetHeight,left:0,middle:t.offsetWidth/2,right:t.offsetWidth}}(t.el),g={top:o[t.anchorOrigin.vertical]-v[t.selfOrigin.vertical],left:o[t.anchorOrigin.horizontal]-v[t.selfOrigin.horizontal]};!function(t,e,n,i,r){var o=n.bottom,a=n.right,s=Ye(),l=window.innerHeight-s,c=document.body.clientWidth;if(t.top<0||t.top+o>l)if("center"===r.vertical)t.top=e[i.vertical]>l/2?Math.max(0,l-o):0,t.maxHeight=Math.min(o,l);else if(e[i.vertical]>l/2){var u=Math.min(l,"center"===i.vertical?e.center:i.vertical===r.vertical?e.bottom:e.top);t.maxHeight=Math.min(o,u),t.top=Math.max(0,u-o)}else t.top=Math.max(0,"center"===i.vertical?e.center:i.vertical===r.vertical?e.top:e.bottom),t.maxHeight=Math.min(o,l-t.top);if(t.left<0||t.left+a>c)if(t.maxWidth=Math.min(a,c),"middle"===r.horizontal)t.left=e[i.horizontal]>c/2?Math.max(0,c-a):0;else if(e[i.horizontal]>c/2){var d=Math.min(c,"middle"===i.horizontal?e.middle:i.horizontal===r.horizontal?e.right:e.left);t.maxWidth=Math.min(a,d),t.left=Math.max(0,d-t.maxWidth)}else t.left=Math.max(0,"middle"===i.horizontal?e.middle:i.horizontal===r.horizontal?e.left:e.right),t.maxWidth=Math.min(a,c-t.left)}(g,o,v,t.anchorOrigin,t.selfOrigin),m={top:g.top+"px",left:g.left+"px"},void 0!==g.maxHeight&&(m.maxHeight=g.maxHeight+"px",o.height>g.maxHeight&&(m.minHeight=m.maxHeight)),void 0!==g.maxWidth&&(m.maxWidth=g.maxWidth+"px",o.width>g.maxWidth&&(m.minWidth=m.maxWidth)),Object.assign(t.el.style,m),t.el.scrollTop!==l&&(t.el.scrollTop=l),t.el.scrollLeft!==s&&(t.el.scrollLeft=s)}var an=t.extend({name:"QMenu",mixins:[yt,It,ke,Ce,Me,Pe],directives:{ClickOutside:qe},props:{persistent:Boolean,autoClose:Boolean,separateClosePopup:Boolean,noRouteDismiss:Boolean,noRefocus:Boolean,noFocus:Boolean,fit:Boolean,cover:Boolean,square:Boolean,anchor:{type:String,validator:en},self:{type:String,validator:en},offset:{type:Array,validator:nn},scrollTarget:{default:void 0},touchPosition:Boolean,maxHeight:{type:String,default:null},maxWidth:{type:String,default:null}},computed:{horizSide:function(){return!0===this.$q.lang.rtl?"right":"left"},anchorOrigin:function(){return rn(this.anchor||(!0===this.cover?"center middle":"bottom "+this.horizSide))},selfOrigin:function(){return!0===this.cover?this.anchorOrigin:rn(this.self||"top "+this.horizSide)},menuClass:function(){return(!0===this.square?" q-menu--square":"")+(!0===this.isDark?" q-menu--dark q-dark":"")},hideOnRouteChange:function(){return!0!==this.persistent&&!0!==this.noRouteDismiss},onEvents:function(){var t=Object.assign({},this.qListeners,{input:_,"popup-show":_,"popup-hide":_});return!0===this.autoClose&&(t.click=this.__onAutoClose),t},attrs:function(){return Object.assign({},{tabindex:-1},this.qAttrs)}},methods:{focus:function(){var t=void 0!==this.__portal&&void 0!==this.__portal.$refs?this.__portal.$refs.inner:void 0;void 0!==t&&!0!==t.contains(document.activeElement)&&(t=t.querySelector("[autofocus], [data-autofocus]")||t).focus()},__show:function(t){var e=this;if(this.__refocusTarget=!1===this.noRefocus&&null!==document.activeElement?document.activeElement:void 0,tn.register(this,(function(){!0!==e.persistent&&(e.$emit("escape-key"),e.hide())})),this.__showPortal(),this.__configureScrollTarget(),this.absoluteOffset=void 0,void 0!==t&&(this.touchPosition||this.contextMenu)){var n=g(t);if(void 0!==n.left){var i=this.anchorEl.getBoundingClientRect(),r=i.top,o=i.left;this.absoluteOffset={left:n.left-o,top:n.top-r}}}void 0===this.unwatch&&(this.unwatch=this.$watch((function(){return e.$q.screen.width+"|"+e.$q.screen.height+"|"+e.self+"|"+e.anchor}),this.updatePosition)),this.$el.dispatchEvent(x("popup-show",{bubbles:!0})),!0!==this.noFocus&&null!==document.activeElement&&document.activeElement.blur(),this.__nextTick((function(){e.updatePosition(),!0!==e.noFocus&&e.focus()})),this.__setTimeout((function(){!0===e.$q.platform.is.ios&&(e.__avoidAutoClose=e.autoClose,e.__portal.$el.click()),e.updatePosition(),e.$emit("show",t)}),300)},__hide:function(t){var e=this;this.__anchorCleanup(!0),void 0===this.__refocusTarget||null===this.__refocusTarget||void 0!==t&&!0===t.qClickOutside||this.__refocusTarget.focus(),this.$el.dispatchEvent(x("popup-hide",{bubbles:!0})),this.__setTimeout((function(){e.__hidePortal(),e.$emit("hide",t)}),300)},__anchorCleanup:function(t){this.absoluteOffset=void 0,void 0!==this.unwatch&&(this.unwatch(),this.unwatch=void 0),!0!==t&&!0!==this.showing||(tn.pop(this),this.__unconfigureScrollTarget())},__unconfigureScrollTarget:function(){void 0!==this.__scrollTarget&&(this.__changeScrollEvent(this.__scrollTarget),this.__scrollTarget=void 0)},__configureScrollTarget:function(){void 0===this.anchorEl&&void 0===this.scrollTarget||(this.__scrollTarget=Ie(this.anchorEl,this.scrollTarget),this.__changeScrollEvent(this.__scrollTarget,this.updatePosition))},__onAutoClose:function(t){!0!==this.__avoidAutoClose?(Se(this,t),void 0!==this.qListeners.click&&this.$emit("click",t)):this.__avoidAutoClose=!1},updatePosition:function(){if(void 0!==this.anchorEl&&void 0!==this.__portal){var t=this.__portal.$el;8!==t.nodeType?on({el:t,offset:this.offset,anchorEl:this.anchorEl,anchorOrigin:this.anchorOrigin,selfOrigin:this.selfOrigin,absoluteOffset:this.absoluteOffset,fit:this.fit,cover:this.cover,maxHeight:this.maxHeight,maxWidth:this.maxWidth}):setTimeout(this.updatePosition,25)}},__onClickOutside:function(t){if(!0!==this.persistent&&!0===this.showing){var e=t.target.classList;return this.hide(t),("touchstart"===t.type||e.contains("q-dialog__backdrop"))&&w(t),!0}},__renderPortal:function(t){return t("transition",{props:{name:this.transition}},[!0===this.showing?t("div",{ref:"inner",staticClass:"q-menu q-position-engine scroll"+this.menuClass,class:this.contentClass,style:this.contentStyle,attrs:this.attrs,on:this.onEvents,directives:[{name:"click-outside",value:this.__onClickOutside,arg:this.anchorEl}]},Bt(this,"default")):null])}},mounted:function(){this.__processModelChange(this.value)},beforeDestroy:function(){!0===this.showing&&void 0!==this.anchorEl&&this.anchorEl.dispatchEvent(x("popup-hide",{bubbles:!0}))}}),sn=t.extend({name:"QBtnDropdown",mixins:[le],props:{value:Boolean,split:Boolean,dropdownIcon:String,contentClass:[Array,String,Object],contentStyle:[Array,String,Object],cover:Boolean,persistent:Boolean,noRouteDismiss:Boolean,autoClose:Boolean,menuAnchor:{type:String,default:"bottom right"},menuSelf:{type:String,default:"top right"},menuOffset:Array,disableMainBtn:Boolean,disableDropdown:Boolean,noIconAnimation:Boolean},data:function(){return{showing:this.value}},watch:{value:function(t){void 0!==this.$refs.menu&&this.$refs.menu[t?"show":"hide"]()}},render:function(t){var e=this,n=Bt(this,"label",[]),i={"aria-expanded":!0===this.showing?"true":"false","aria-haspopup":"true"};(!0===this.disable||!1===this.split&&!0===this.disableMainBtn||!0===this.disableDropdown)&&(i["aria-disabled"]="true");var r=[t(Lt,{props:{name:this.dropdownIcon||this.$q.iconSet.arrow.dropdown},class:"q-btn-dropdown__arrow"+(!0===this.showing&&!1===this.noIconAnimation?" rotate-180":"")+(!1===this.split?" q-btn-dropdown__arrow-container":"")})];if(!0!==this.disableDropdown&&r.push(t(an,{ref:"menu",props:{cover:this.cover,fit:!0,persistent:this.persistent,noRouteDismiss:this.noRouteDismiss,autoClose:this.autoClose,anchor:this.menuAnchor,self:this.menuSelf,offset:this.menuOffset,contentClass:this.contentClass,contentStyle:this.contentStyle,separateClosePopup:!0},on:pt(this,"menu",{"before-show":function(t){e.showing=!0,e.$emit("before-show",t)},show:function(t){e.$emit("show",t),e.$emit("input",!0)},"before-hide":function(t){e.showing=!1,e.$emit("before-hide",t)},hide:function(t){e.$emit("hide",t),e.$emit("input",!1)}})},Bt(this,"default"))),!1===this.split)return t(_e,{class:"q-btn-dropdown q-btn-dropdown--simple",props:Object.assign({},this.$props,{disable:!0===this.disable||!0===this.disableMainBtn,noWrap:!0,round:!1}),attrs:i,on:pt(this,"nonSpl",{click:function(t){e.$emit("click",t)}})},n.concat(r));var o=t(_e,{class:"q-btn-dropdown--current",props:Object.assign({},this.$props,{disable:!0===this.disable||!0===this.disableMainBtn,noWrap:!0,iconRight:this.iconRight,round:!1}),on:pt(this,"spl",{click:function(t){e.hide(),e.$emit("click",t)}})},n);return t(be,{props:{outline:this.outline,flat:this.flat,rounded:this.rounded,push:this.push,unelevated:this.unelevated,glossy:this.glossy,stretch:this.stretch},staticClass:"q-btn-dropdown q-btn-dropdown--split no-wrap q-btn-item"},[o,t(_e,{staticClass:"q-btn-dropdown__arrow-container",attrs:i,props:{disable:!0===this.disable||!0===this.disableDropdown,outline:this.outline,flat:this.flat,rounded:this.rounded,push:this.push,size:this.size,color:this.color,textColor:this.textColor,dense:this.dense,ripple:this.ripple}},r)])},methods:{toggle:function(t){this.$refs.menu&&this.$refs.menu.toggle(t)},show:function(t){this.$refs.menu&&this.$refs.menu.show(t)},hide:function(t){this.$refs.menu&&this.$refs.menu.hide(t)}},mounted:function(){!0===this.value&&this.show()}}),ln={props:{name:String},computed:{formAttrs:function(){return{type:"hidden",name:this.name,value:this.value}}},methods:{__injectFormInput:function(t,e,n){t[e](this.$createElement("input",{staticClass:"hidden",class:n,attrs:this.formAttrs,domProps:this.formDomProps}))}}},cn={props:{name:String},computed:{nameProp:function(){return this.name||this.for}}},un=t.extend({name:"QBtnToggle",mixins:[Ot,ae,ln],props:{value:{required:!0},options:{type:Array,required:!0,validator:function(t){return t.every((function(t){return("label"in t||"icon"in t||"slot"in t)&&"value"in t}))}},color:String,textColor:String,toggleColor:{type:String,default:"primary"},toggleTextColor:String,outline:Boolean,flat:Boolean,unelevated:Boolean,rounded:Boolean,push:Boolean,glossy:Boolean,size:String,padding:String,noCaps:Boolean,noWrap:Boolean,dense:Boolean,readonly:Boolean,disable:Boolean,stack:Boolean,stretch:Boolean,spread:Boolean,clearable:Boolean},computed:{hasActiveValue:function(){var t=this;return void 0!==this.options.find((function(e){return e.value===t.value}))},formAttrs:function(){return{type:"hidden",name:this.name,value:this.value}},btnOptions:function(){var t=this,e=function(e,n){return void 0===e[n]?t[n]:e[n]};return this.options.map((function(n,i){return{slot:n.slot,options:{key:i,class:n.class,style:n.style,on:Object.assign({},t.qListeners,{click:function(e){return t.__set(n.value,n,e)}}),attrs:n.attrs,props:Object.assign({},n,{slot:void 0,class:void 0,style:void 0,value:void 0,attrs:void 0,outline:t.outline,flat:t.flat,rounded:t.rounded,push:t.push,unelevated:t.unelevated,dense:t.dense,disable:!0===t.disable||!0===n.disable,color:n.value===t.value?e(n,"toggleColor"):e(n,"color"),textColor:n.value===t.value?e(n,"toggleTextColor"):e(n,"textColor"),noCaps:!0===e(n,"noCaps"),noWrap:!0===e(n,"noWrap"),size:e(n,"size"),padding:e(n,"padding"),ripple:e(n,"ripple"),stack:!0===e(n,"stack"),stretch:!0===e(n,"stretch")})}}}))}},methods:{__set:function(t,e,n){!0!==this.readonly&&(this.value===t?!0===this.clearable&&(this.$emit("input",null,null),this.$emit("clear")):this.$emit("input",t,e),this.$emit("click",n))}},render:function(t){var e=this,n=this.btnOptions.map((function(n){return t(_e,n.options,void 0!==n.slot?Bt(e,n.slot):void 0)}));return void 0!==this.name&&!0!==this.disable&&!0===this.hasActiveValue&&this.__injectFormInput(n,"push"),t(be,{staticClass:"q-btn-toggle",props:{outline:this.outline,flat:this.flat,rounded:this.rounded,push:this.push,stretch:this.stretch,unelevated:this.unelevated,glossy:this.glossy,spread:this.spread}},At(n,this,"default"))}}),dn=t.extend({name:"QCard",mixins:[Ot,It,Pt],props:{square:Boolean,flat:Boolean,bordered:Boolean},computed:{classes:function(){return"q-card"+(!0===this.isDark?" q-card--dark q-dark":"")+(!0===this.bordered?" q-card--bordered":"")+(!0===this.square?" q-card--square no-border-radius":"")+(!0===this.flat?" q-card--flat no-shadow":"")}},render:function(t){return t(this.tag,{class:this.classes,on:Object.assign({},this.qListeners)},Bt(this,"default"))}}),hn=t.extend({name:"QCardSection",mixins:[Ot,Pt],props:{horizontal:Boolean},computed:{classes:function(){return"q-card__section q-card__section--"+(!0===this.horizontal?"horiz row no-wrap":"vert")}},render:function(t){return t(this.tag,{class:this.classes,on:Object.assign({},this.qListeners)},Bt(this,"default"))}}),fn=t.extend({name:"QCardActions",mixins:[Ot,Ht],props:{vertical:Boolean},computed:{classes:function(){return"q-card__actions--"+(!0===this.vertical?"vert column":"horiz row")+" "+this.alignClass}},render:function(t){return t("div",{staticClass:"q-card__actions",class:this.classes,on:Object.assign({},this.qListeners)},Bt(this,"default"))}});function pn(t){var e=[.06,6,50];return"string"==typeof t&&t.length&&t.split(":").forEach((function(t,n){var i=parseFloat(t);i&&(e[n]=i)})),e}function mn(t){var e=t.__qtouchswipe;void 0!==e&&(S(e,"main"),S(e,"temp"),!0===d.is.firefox&&k(t,!1),void 0!==e.styleCleanup&&e.styleCleanup(),delete t.__qtouchswipe)}var vn={name:"touch-swipe",bind:function(t,e){var n=e.value,i=e.arg,r=e.modifiers;if(void 0!==t.__qtouchswipe&&(mn(t),t.__qtouchswipe_destroyed=!0),!0===r.mouse||!0===d.has.touch){var o=!0===r.mouseCapture?"Capture":"",a={handler:n,sensitivity:pn(i),modifiers:r,direction:de(r),noop:m,mouseStart:function(t){fe(t,a)&&v(t)&&(C(a,"temp",[[document,"mousemove","move","notPassive"+o],[document,"mouseup","end","notPassiveCapture"]]),a.start(t,!0))},touchStart:function(t){if(fe(t,a)){var e=he(t.target);C(a,"temp",[[e,"touchmove","move","notPassiveCapture"],[e,"touchcancel","end","notPassiveCapture"],[e,"touchend","end","notPassiveCapture"]]),a.start(t)}},start:function(e,n){!0===d.is.firefox&&k(t,!0);var i=g(e);a.event={x:i.left,y:i.top,time:Date.now(),mouse:!0===n,dir:!1}},move:function(t){if(void 0!==a.event)if(!1===a.event.dir){var e=Date.now()-a.event.time;if(0!==e){var n=g(t),i=n.left-a.event.x,r=Math.abs(i),o=n.top-a.event.y,s=Math.abs(o);if(!0!==a.event.mouse){if(r<a.sensitivity[1]&&s<a.sensitivity[1])return void a.end(t)}else if(r<a.sensitivity[2]&&s<a.sensitivity[2])return;var l=r/e,c=s/e;!0===a.direction.vertical&&r<s&&r<100&&c>a.sensitivity[0]&&(a.event.dir=o<0?"up":"down"),!0===a.direction.horizontal&&r>s&&s<100&&l>a.sensitivity[0]&&(a.event.dir=i<0?"left":"right"),!0===a.direction.up&&r<s&&o<0&&r<100&&c>a.sensitivity[0]&&(a.event.dir="up"),!0===a.direction.down&&r<s&&o>0&&r<100&&c>a.sensitivity[0]&&(a.event.dir="down"),!0===a.direction.left&&r>s&&i<0&&s<100&&l>a.sensitivity[0]&&(a.event.dir="left"),!0===a.direction.right&&r>s&&i>0&&s<100&&l>a.sensitivity[0]&&(a.event.dir="right"),!1!==a.event.dir?(w(t),!0===a.event.mouse&&(document.body.classList.add("no-pointer-events--children"),document.body.classList.add("non-selectable"),we(),a.styleCleanup=function(t){a.styleCleanup=void 0,document.body.classList.remove("non-selectable");var e=function(){document.body.classList.remove("no-pointer-events--children")};!0===t?setTimeout(e,50):e()}),a.handler({evt:t,touch:!0!==a.event.mouse,mouse:a.event.mouse,direction:a.event.dir,duration:e,distance:{x:r,y:s}})):a.end(t)}}else w(t)},end:function(e){void 0!==a.event&&(S(a,"temp"),!0===d.is.firefox&&k(t,!1),void 0!==a.styleCleanup&&a.styleCleanup(!0),void 0!==e&&!1!==a.event.dir&&w(e),a.event=void 0)}};t.__qtouchswipe=a,!0===r.mouse&&C(a,"main",[[t,"mousedown","mouseStart","passive"+o]]),!0===d.has.touch&&C(a,"main",[[t,"touchstart","touchStart","passive"+(!0===r.capture?"Capture":"")],[t,"touchmove","noop","notPassiveCapture"]])}},update:function(t,e){var n=e.oldValue,i=e.value,r=t.__qtouchswipe;void 0!==r&&n!==i&&("function"!=typeof i&&r.end(),r.handler=i)},unbind:function(t){void 0===t.__qtouchswipe_destroyed?mn(t):delete t.__qtouchswipe_destroyed}},gn=t.extend({name:"QTabPanelWrapper",render:function(t){return t("div",{staticClass:"q-panel scroll",attrs:{role:"tabpanel"},on:pt(this,"stop",{input:_})},Bt(this,"default"))}}),yn={mixins:[Ot],directives:{TouchSwipe:vn},props:{value:{required:!0},animated:Boolean,infinite:Boolean,swipeable:Boolean,vertical:Boolean,transitionPrev:String,transitionNext:String,keepAlive:Boolean},data:function(){return{panelIndex:null,panelTransition:null}},computed:{panelDirectives:function(){if(!0===this.swipeable)return[{name:"touch-swipe",value:this.__swipe,modifiers:{horizontal:!0!==this.vertical,vertical:this.vertical,mouse:!0}}]},contentKey:function(){return"string"==typeof this.value||"number"==typeof this.value?this.value:String(this.value)},transitionPrevComputed:function(){return this.transitionPrev||"slide-"+(!0===this.vertical?"down":"right")},transitionNextComputed:function(){return this.transitionNext||"slide-"+(!0===this.vertical?"up":"left")}},watch:{value:function(t,e){var n=this,i=!0===this.__isValidPanelName(t)?this.__getPanelIndex(t):-1;!0!==this.__forcedPanelTransition&&this.__updatePanelTransition(-1===i?0:i<this.__getPanelIndex(e)?-1:1),this.panelIndex!==i&&(this.panelIndex=i,this.$emit("before-transition",t,e),this.$nextTick((function(){n.$emit("transition",t,e)})))}},methods:{next:function(){this.__go(1)},previous:function(){this.__go(-1)},goTo:function(t){this.$emit("input",t)},__isValidPanelName:function(t){return null!=t&&""!==t},__getPanelIndex:function(t){return this.panels.findIndex((function(e){var n=e.componentOptions;return n&&n.propsData.name===t&&""!==n.propsData.disable&&!0!==n.propsData.disable}))},__getAllPanels:function(){var t=this;return this.panels.filter((function(e){return void 0!==e.componentOptions&&t.__isValidPanelName(e.componentOptions.propsData.name)}))},__getAvailablePanels:function(){return this.panels.filter((function(t){var e=t.componentOptions;return e&&void 0!==e.propsData.name&&""!==e.propsData.disable&&!0!==e.propsData.disable}))},__updatePanelTransition:function(t){var e=0!==t&&!0===this.animated&&-1!==this.panelIndex?"q-transition--"+(-1===t?this.transitionPrevComputed:this.transitionNextComputed):null;this.panelTransition!==e&&(this.panelTransition=e)},__go:function(t,e){var n=this;void 0===e&&(e=this.panelIndex);for(var i=e+t,r=this.panels;i>-1&&i<r.length;){var o=r[i].componentOptions;if(void 0!==o&&""!==o.propsData.disable&&!0!==o.propsData.disable)return this.__updatePanelTransition(t),this.__forcedPanelTransition=!0,this.$emit("input",r[i].componentOptions.propsData.name),void setTimeout((function(){n.__forcedPanelTransition=!1}));i+=t}!0===this.infinite&&r.length>0&&-1!==e&&e!==r.length&&this.__go(t,-1===t?r.length:-1)},__swipe:function(t){var e=!0===this.vertical?"up":"left";this.__go((!0===this.$q.lang.rtl?-1:1)*(t.direction===e?1:-1))},__updatePanelIndex:function(){var t=this.__getPanelIndex(this.value);return this.panelIndex!==t&&(this.panelIndex=t),!0},__getPanelContent:function(t){if(0!==this.panels.length){var e=this.__isValidPanelName(this.value)&&this.__updatePanelIndex()&&this.panels[this.panelIndex],n=!0===this.keepAlive?[t("keep-alive",[t(gn,{key:this.contentKey},[e])])]:[t("div",{staticClass:"q-panel scroll",key:this.contentKey,attrs:{role:"tabpanel"},on:pt(this,"stop",{input:_})},[e])];return!0===this.animated?[t("transition",{props:{name:this.panelTransition}},n)]:n}}},render:function(t){return this.panels=Bt(this,"default",[]),this.__renderPanels(t)}},_n={mixins:[Ot],props:{name:{required:!0},disable:Boolean}},bn={props:{fullscreen:Boolean,noRouteFullscreenExit:Boolean},data:function(){return{inFullscreen:!1}},watch:{$route:function(){!0!==this.noRouteFullscreenExit&&this.exitFullscreen()},fullscreen:function(t){this.inFullscreen!==t&&this.toggleFullscreen()},inFullscreen:function(t){this.$emit("update:fullscreen",t),this.$emit("fullscreen",t)}},methods:{toggleFullscreen:function(){!0===this.inFullscreen?this.exitFullscreen():this.setFullscreen()},setFullscreen:function(){!0!==this.inFullscreen&&(this.inFullscreen=!0,this.container=this.$el.parentNode,this.container.replaceChild(this.fullscreenFillerNode,this.$el),document.body.appendChild(this.$el),document.body.classList.add("q-body--fullscreen-mixin"),this.__historyFullscreen={handler:this.exitFullscreen},q.add(this.__historyFullscreen))},exitFullscreen:function(){var t=this;!0===this.inFullscreen&&(void 0!==this.__historyFullscreen&&(q.remove(this.__historyFullscreen),this.__historyFullscreen=void 0),this.container.replaceChild(this.$el,this.fullscreenFillerNode),document.body.classList.remove("q-body--fullscreen-mixin"),this.inFullscreen=!1,void 0!==this.$el.scrollIntoView&&setTimeout((function(){t.$el.scrollIntoView()})))}},beforeMount:function(){this.fullscreenFillerNode=document.createElement("span")},mounted:function(){!0===this.fullscreen&&this.setFullscreen()},beforeDestroy:function(){this.exitFullscreen()}},wn="function"==typeof Map,kn="function"==typeof Set,xn="function"==typeof ArrayBuffer;function Cn(t,e){if(t===e)return!0;if(null!==t&&null!==e&&"object"==typeof t&&"object"==typeof e){if(t.constructor!==e.constructor)return!1;var n,i;if(t.constructor===Array){if((n=t.length)!==e.length)return!1;for(i=n;0!=i--;)if(!0!==Cn(t[i],e[i]))return!1;return!0}if(!0===wn&&t.constructor===Map){if(t.size!==e.size)return!1;for(i=t.entries().next();!0!==i.done;){if(!0!==e.has(i.value[0]))return!1;i=i.next()}for(i=t.entries().next();!0!==i.done;){if(!0!==Cn(i.value[1],e.get(i.value[0])))return!1;i=i.next()}return!0}if(!0===kn&&t.constructor===Set){if(t.size!==e.size)return!1;for(i=t.entries().next();!0!==i.done;){if(!0!==e.has(i.value[0]))return!1;i=i.next()}return!0}if(!0===xn&&null!=t.buffer&&t.buffer.constructor===ArrayBuffer){if((n=t.length)!==e.length)return!1;for(i=n;0!=i--;)if(t[i]!==e[i])return!1;return!0}if(t.constructor===RegExp)return t.source===e.source&&t.flags===e.flags;if(t.valueOf!==Object.prototype.valueOf)return t.valueOf()===e.valueOf();if(t.toString!==Object.prototype.toString)return t.toString()===e.toString();var r=Object.keys(t);if((n=r.length)!==Object.keys(e).length)return!1;for(i=n;0!=i--;){var o=r[i];if(!0!==Cn(t[o],e[o]))return!1}return!0}return t!=t&&e!=e}function Sn(t){return"[object Date]"===Object.prototype.toString.call(t)}function Mn(t){return"number"==typeof t&&isFinite(t)}var Tn=t.extend({name:"QCarousel",mixins:[It,yn,bn],props:{height:String,padding:Boolean,controlType:{type:String,validator:function(t){return["regular","flat","outline","push","unelevated"].includes(t)},default:"flat"},controlColor:String,controlTextColor:String,autoplay:[Number,Boolean],arrows:Boolean,prevIcon:String,nextIcon:String,navigation:Boolean,navigationPosition:{type:String,validator:function(t){return["top","right","bottom","left"].includes(t)}},navigationIcon:String,navigationActiveIcon:String,thumbnails:Boolean},computed:{style:function(){if(!0!==this.inFullscreen&&void 0!==this.height)return{height:this.height}},direction:function(){return!0===this.vertical?"vertical":"horizontal"},classes:function(){return"q-carousel q-panel-parent q-carousel--with"+(!0===this.padding?"":"out")+"-padding"+(!0===this.inFullscreen?" fullscreen":"")+(!0===this.isDark?" q-carousel--dark q-dark":"")+(!0===this.arrows?" q-carousel--arrows-"+this.direction:"")+(!0===this.navigation?" q-carousel--navigation-"+this.navigationPositionComputed:"")},arrowIcons:function(){var t=[this.prevIcon||this.$q.iconSet.carousel[!0===this.vertical?"up":"left"],this.nextIcon||this.$q.iconSet.carousel[!0===this.vertical?"down":"right"]];return!1===this.vertical&&!0===this.$q.lang.rtl?t.reverse():t},navIcon:function(){return this.navigationIcon||this.$q.iconSet.carousel.navigationIcon},navActiveIcon:function(){return this.navigationActiveIcon||this.navIcon},navigationPositionComputed:function(){return this.navigationPosition||(!0===this.vertical?"right":"bottom")},controlProps:function(){var t;return(t={color:this.controlColor,textColor:this.controlTextColor,round:!0})[this.controlType]=!0,t.dense=!0,t},transitionPrevComputed:function(){return this.transitionPrev||"fade"},transitionNextComputed:function(){return this.transitionNext||"fade"}},watch:{value:function(){this.autoplay&&(clearInterval(this.timer),this.__startTimer())},autoplay:function(t){t?this.__startTimer():clearInterval(this.timer)}},methods:{__startTimer:function(){this.timer=setTimeout(this.next,Mn(this.autoplay)?this.autoplay:5e3)},__getNavigationContainer:function(t,e,n){return t("div",{class:"q-carousel__control q-carousel__navigation no-wrap absolute flex q-carousel__navigation--"+e+" q-carousel__navigation--"+this.navigationPositionComputed+(void 0!==this.controlColor?" text-"+this.controlColor:"")},[t("div",{staticClass:"q-carousel__navigation-inner flex flex-center no-wrap"},this.__getAvailablePanels().map(n))])},__getContent:function(t){var e=this,n=[];if(!0===this.navigation){var i=void 0!==this.$scopedSlots["navigation-icon"]?this.$scopedSlots["navigation-icon"]:function(n){return t(_e,{key:"nav"+n.name,class:"q-carousel__navigation-icon q-carousel__navigation-icon--"+(!0===n.active?"":"in")+"active",props:n.btnProps,on:pt(e,"nav#"+n.name,{click:n.onClick})})},r=this.panels.length-1;n.push(this.__getNavigationContainer(t,"buttons",(function(t,n){var o=t.componentOptions.propsData.name,a=e.panelIndex===n;return i({index:n,maxIndex:r,name:o,active:a,btnProps:Object.assign({},{icon:!0===a?e.navActiveIcon:e.navIcon,size:"sm"},e.controlProps),onClick:function(){e.goTo(o)}})})))}else if(!0===this.thumbnails){var o=void 0!==this.controlColor?" text-"+this.controlColor:"";n.push(this.__getNavigationContainer(t,"thumbnails",(function(n){var i=n.componentOptions.propsData;return t("img",{class:"q-carousel__thumbnail q-carousel__thumbnail--"+(i.name===e.value?"":"in")+"active"+o,attrs:{src:i.imgSrc},key:"tmb#"+i.name,on:pt(e,"tmb#"+i.name,{click:function(){e.goTo(i.name)}})})})))}return!0===this.arrows&&this.panelIndex>=0&&((!0===this.infinite||this.panelIndex>0)&&n.push(t("div",{key:"prev",staticClass:"q-carousel__control q-carousel__arrow q-carousel__prev-arrow q-carousel__prev-arrow--"+this.direction+" absolute flex flex-center"},[t(_e,{props:Object.assign({},{icon:this.arrowIcons[0]},this.controlProps),on:pt(this,"prev",{click:this.previous})})])),(!0===this.infinite||this.panelIndex<this.panels.length-1)&&n.push(t("div",{key:"next",staticClass:"q-carousel__control q-carousel__arrow q-carousel__next-arrow q-carousel__next-arrow--"+this.direction+" absolute flex flex-center"},[t(_e,{props:Object.assign({},{icon:this.arrowIcons[1]},this.controlProps),on:pt(this,"next",{click:this.next})})]))),At(n,this,"control")},__renderPanels:function(t){return t("div",{style:this.style,class:this.classes,on:Object.assign({},this.qListeners)},[t("div",{staticClass:"q-carousel__slides-container",directives:this.panelDirectives},this.__getPanelContent(t))].concat(this.__getContent(t)))}},mounted:function(){this.autoplay&&this.__startTimer()},beforeDestroy:function(){clearInterval(this.timer)}}),Pn=t.extend({name:"QCarouselSlide",mixins:[_n],props:{imgSrc:String},computed:{style:function(){if(this.imgSrc)return{backgroundImage:'url("'+this.imgSrc+'")'}}},render:function(t){return t("div",{staticClass:"q-carousel__slide",style:this.style,on:Object.assign({},this.qListeners)},Bt(this,"default"))}}),On=t.extend({name:"QCarouselControl",mixins:[Ot],props:{position:{type:String,default:"bottom-right",validator:function(t){return["top-right","top-left","bottom-right","bottom-left","top","right","bottom","left"].includes(t)}},offset:{type:Array,default:function(){return[18,18]},validator:function(t){return 2===t.length}}},computed:{classes:function(){return"absolute-"+this.position},style:function(){return{margin:this.offset[1]+"px "+this.offset[0]+"px"}}},render:function(t){return t("div",{staticClass:"q-carousel__control absolute",style:this.style,class:this.classes,on:Object.assign({},this.qListeners)},Bt(this,"default"))}}),Bn=t.extend({name:"QChatMessage",mixins:[Ot],props:{sent:Boolean,label:String,bgColor:String,textColor:String,name:String,avatar:String,text:Array,stamp:String,size:String,labelSanitize:Boolean,nameSanitize:Boolean,textSanitize:Boolean,stampSanitize:Boolean},computed:{textClass:function(){return"q-message-text-content q-message-text-content--"+this.op+(void 0!==this.textColor?" text-"+this.textColor:"")},messageClass:function(){return"q-message-text q-message-text--"+this.op+(void 0!==this.bgColor?" text-"+this.bgColor:"")},containerClass:function(){return"q-message-container row items-end no-wrap"+(!0===this.sent?" reverse":"")},sizeClass:function(){if(void 0!==this.size)return"col-"+this.size},op:function(){return!0===this.sent?"sent":"received"}},methods:{__getText:function(t){var e=this,n=!0===this.textSanitize?"textContent":"innerHTML",i=!0===this.stampSanitize?"textContent":"innerHTML";return this.text.map((function(r,o){var a,s;return t("div",{key:o,class:e.messageClass},[t("div",{class:e.textClass},[t("div",{domProps:(a={},a[n]=r,a)}),e.stamp?t("div",{staticClass:"q-message-stamp",domProps:(s={},s[i]=e.stamp,s)}):null])])}))},__getMessage:function(t){var e,n=Et(this,"default",[]);return void 0!==this.stamp&&n.push(t("div",{staticClass:"q-message-stamp",domProps:(e={},e[!0===this.stampSanitize?"textContent":"innerHTML"]=this.stamp,e)})),t("div",{class:this.messageClass},[t("div",{staticClass:"q-message-text-content",class:this.textClass},n)])}},render:function(t){var e,n,i=[];void 0!==this.$scopedSlots.avatar?i.push(this.$scopedSlots.avatar()):void 0!==this.avatar&&i.push(t("img",{class:"q-message-avatar q-message-avatar--"+this.op,attrs:{src:this.avatar,"aria-hidden":"true"}}));var r=[];void 0!==this.name&&r.push(t("div",{class:"q-message-name q-message-name--"+this.op,domProps:(e={},e[!0===this.nameSanitize?"textContent":"innerHTML"]=this.name,e)})),void 0!==this.text&&r.push(this.__getText(t)),void 0!==this.$scopedSlots.default&&r.push(this.__getMessage(t)),i.push(t("div",{class:this.sizeClass},r));var o=[];return this.label&&o.push(t("div",{staticClass:"q-message-label text-center",domProps:(n={},n[!0===this.labelSanitize?"textContent":"innerHTML"]=this.label,n)})),o.push(t("div",{class:this.containerClass},i)),t("div",{class:"q-message q-message-"+this.op,on:Object.assign({},this.qListeners)},o)}}),En=Mt({xs:30,sm:35,md:40,lg:50,xl:60}),An={computed:{__refocusTargetEl:function(){if(!0!==this.disable)return this.$createElement("span",{ref:"refocusTarget",staticClass:"no-outline",attrs:{tabindex:-1}})}},methods:{__refocusTarget:function(t){void 0!==t&&0===t.type.indexOf("key")?document.activeElement!==this.$el&&!0===this.$el.contains(document.activeElement)&&this.$el.focus():void 0!==t&&!0!==this.$el.contains(t.target)||void 0===this.$refs.refocusTarget||this.$refs.refocusTarget.focus()}}},Dn={mixins:[It,En,ln,An],props:{value:{required:!0,default:null},val:{},trueValue:{default:!0},falseValue:{default:!1},indeterminateValue:{default:null},toggleOrder:{type:String,validator:function(t){return"tf"===t||"ft"===t}},toggleIndeterminate:Boolean,label:String,leftLabel:Boolean,fontSize:String,color:String,keepColor:Boolean,dense:Boolean,disable:Boolean,tabindex:[String,Number]},computed:{isTrue:function(){return!0===this.modelIsArray?this.index>-1:this.value===this.trueValue},isFalse:function(){return!0===this.modelIsArray?-1===this.index:this.value===this.falseValue},isIndeterminate:function(){return!1===this.isTrue&&!1===this.isFalse},index:function(){if(!0===this.modelIsArray)return this.value.indexOf(this.val)},modelIsArray:function(){return void 0!==this.val&&Array.isArray(this.value)},computedTabindex:function(){return!0===this.disable?-1:this.tabindex||0},labelStyle:function(){if(void 0!==this.fontSize)return{fontSize:this.fontSize}},classes:function(){return"q-"+this.type+" cursor-pointer no-outline row inline no-wrap items-center"+(!0===this.disable?" disabled":"")+(!0===this.isDark?" q-"+this.type+"--dark":"")+(!0===this.dense?" q-"+this.type+"--dense":"")+(!0===this.leftLabel?" reverse":"")},innerClass:function(){var t=!0===this.isTrue?"truthy":!0===this.isFalse?"falsy":"indet",e=void 0===this.color||!0!==this.keepColor&&("toggle"===this.type?!0!==this.isTrue:!0===this.isFalse)?"":" text-"+this.color;return"q-"+this.type+"__inner--"+t+e},formAttrs:function(){var t={type:"checkbox"};return void 0!==this.name&&Object.assign(t,{checked:this.isTrue,name:this.name,value:!0===this.modelIsArray?this.val:this.trueValue}),t},attrs:function(){var t={tabindex:this.computedTabindex,role:"checkbox","aria-label":this.label,"aria-checked":!0===this.isIndeterminate?"mixed":!0===this.isTrue?"true":"false"};return!0===this.disable&&(t["aria-disabled"]="true"),t}},methods:{toggle:function(t){void 0!==t&&(w(t),this.__refocusTarget(t)),!0!==this.disable&&this.$emit("input",this.__getNextValue(),t)},__getNextValue:function(){if(!0===this.modelIsArray){if(!0===this.isTrue){var t=this.value.slice();return t.splice(this.index,1),t}return this.value.concat([this.val])}if(!0===this.isTrue){if("ft"!==this.toggleOrder||!1===this.toggleIndeterminate)return this.falseValue}else{if(!0!==this.isFalse)return"ft"!==this.toggleOrder?this.trueValue:this.falseValue;if("ft"===this.toggleOrder||!1===this.toggleIndeterminate)return this.trueValue}return this.indeterminateValue},__onKeydown:function(t){13!==t.keyCode&&32!==t.keyCode||w(t)},__onKeyup:function(t){13!==t.keyCode&&32!==t.keyCode||this.toggle(t)}},render:function(t){var e=this.__getInner(t);!0!==this.disable&&this.__injectFormInput(e,"unshift","q-"+this.type+"__native absolute q-ma-none q-pa-none invisible");var n=[t("div",{staticClass:"q-"+this.type+"__inner relative-position no-pointer-events",class:this.innerClass,style:this.sizeStyle},e)];void 0!==this.__refocusTargetEl&&n.push(this.__refocusTargetEl);var i=void 0!==this.label?At([this.label],this,"default"):Bt(this,"default");return void 0!==i&&n.push(t("div",{staticClass:"q-"+this.type+"__label q-anchor--skip"},i)),t("div",{class:this.classes,attrs:this.attrs,on:pt(this,"inpExt",{click:this.toggle,keydown:this.__onKeydown,keyup:this.__onKeyup})},n)}},Ln=t.extend({name:"QCheckbox",mixins:[Dn],methods:{__getInner:function(t){return[t("div",{staticClass:"q-checkbox__bg absolute"},[t("svg",{staticClass:"q-checkbox__svg fit absolute-full",attrs:{focusable:"false",viewBox:"0 0 24 24","aria-hidden":"true"}},[t("path",{staticClass:"q-checkbox__truthy",attrs:{fill:"none",d:"M1.73,12.91 8.1,19.28 22.79,4.59"}}),t("path",{staticClass:"q-checkbox__indet",attrs:{d:"M4,14H20V10H4"}})])])]}},created:function(){this.type="checkbox"}}),qn=t.extend({name:"QChip",mixins:[ae,It,Mt({xs:8,sm:10,md:14,lg:20,xl:24})],model:{event:"remove"},props:{dense:Boolean,icon:String,iconRight:String,iconRemove:String,label:[String,Number],color:String,textColor:String,value:{type:Boolean,default:!0},selected:{type:Boolean,default:null},square:Boolean,outline:Boolean,clickable:Boolean,removable:Boolean,tabindex:[String,Number],disable:Boolean},computed:{classes:function(){var t,e=!0===this.outline&&this.color||this.textColor;return(t={})["bg-"+this.color]=!1===this.outline&&void 0!==this.color,t["text-"+e+" q-chip--colored"]=e,t.disabled=this.disable,t["q-chip--dense"]=this.dense,t["q-chip--outline"]=this.outline,t["q-chip--selected"]=this.selected,t["q-chip--clickable cursor-pointer non-selectable q-hoverable"]=this.isClickable,t["q-chip--square"]=this.square,t["q-chip--dark q-dark"]=this.isDark,t},hasLeftIcon:function(){return!0===this.selected||void 0!==this.icon},isClickable:function(){return!1===this.disable&&(!0===this.clickable||null!==this.selected)},attrs:function(){return!0===this.disable?{tabindex:-1,"aria-disabled":"true"}:{tabindex:this.tabindex||0}}},methods:{__onKeyup:function(t){13===t.keyCode&&this.__onClick(t)},__onClick:function(t){this.disable||(this.$emit("update:selected",!this.selected),this.$emit("click",t))},__onRemove:function(t){void 0!==t.keyCode&&13!==t.keyCode||(w(t),!this.disable&&this.$emit("remove",!1))},__getContent:function(t){var e=[];!0===this.isClickable&&e.push(t("div",{staticClass:"q-focus-helper"})),!0===this.hasLeftIcon&&e.push(t(Lt,{staticClass:"q-chip__icon q-chip__icon--left",props:{name:!0===this.selected?this.$q.iconSet.chip.selected:this.icon}}));var n=void 0!==this.label?[t("div",{staticClass:"ellipsis"},[this.label])]:void 0;return e.push(t("div",{staticClass:"q-chip__content col row no-wrap items-center q-anchor--skip"},Dt(n,this,"default"))),this.iconRight&&e.push(t(Lt,{staticClass:"q-chip__icon q-chip__icon--right",props:{name:this.iconRight}})),!0===this.removable&&e.push(t(Lt,{staticClass:"q-chip__icon q-chip__icon--remove cursor-pointer",props:{name:this.iconRemove||this.$q.iconSet.chip.remove},attrs:this.attrs,on:pt(this,"non",{click:this.__onRemove,keyup:this.__onRemove})})),e}},render:function(t){if(!1!==this.value){var e={staticClass:"q-chip row inline no-wrap items-center",class:this.classes,style:this.sizeStyle};return!0===this.isClickable&&Object.assign(e,{attrs:this.attrs,on:pt(this,"click",{click:this.__onClick,keyup:this.__onKeyup}),directives:pt(this,"dir#"+this.ripple,[{name:"ripple",value:this.ripple}])}),t("div",e,this.__getContent(t))}}}),Rn=100*Math.PI,In=Math.round(1e3*Rn)/1e3,Nn=t.extend({name:"QCircularProgress",mixins:[Ot,Tt],props:{value:{type:Number,default:0},min:{type:Number,default:0},max:{type:Number,default:100},color:String,centerColor:String,trackColor:String,fontSize:String,thickness:{type:Number,default:.2,validator:function(t){return t>=0&&t<=1}},angle:{type:Number,default:0},indeterminate:Boolean,showValue:Boolean,reverse:Boolean,instantFeedback:Boolean},computed:{normalizedValue:function(){return ut(this.value,this.min,this.max)},svgStyle:function(){return{transform:"rotate3d(0, 0, 1, "+(this.angle-90)+"deg)"}},circleStyle:function(){if(!0!==this.instantFeedback&&!0!==this.indeterminate)return{transition:"stroke-dashoffset 0.6s ease 0s, stroke 0.6s ease"}},dir:function(){return(!0===this.$q.lang.rtl?-1:1)*(this.reverse?-1:1)},viewBox:function(){return 100/(1-this.thickness/2)},viewBoxAttr:function(){return this.viewBox/2+" "+this.viewBox/2+" "+this.viewBox+" "+this.viewBox},strokeDashOffset:function(){var t=1-(this.normalizedValue-this.min)/(this.max-this.min);return this.dir*t*Rn},strokeWidth:function(){return this.thickness/2*this.viewBox},attrs:function(){return{role:"progressbar","aria-valuemin":this.min,"aria-valuemax":this.max,"aria-valuenow":!0===this.indeterminate?void 0:this.normalizedValue}}},methods:{__getCircle:function(t,e){var n=e.thickness,i=e.offset,r=e.color;return t("circle",{staticClass:"q-circular-progress__"+e.cls,class:void 0!==r?"text-"+r:null,style:this.circleStyle,attrs:{fill:"transparent",stroke:"currentColor","stroke-width":n,"stroke-dasharray":In,"stroke-dashoffset":i,cx:this.viewBox,cy:this.viewBox,r:50}})}},render:function(t){var e=[];void 0!==this.centerColor&&"transparent"!==this.centerColor&&e.push(t("circle",{staticClass:"q-circular-progress__center",class:"text-"+this.centerColor,attrs:{fill:"currentColor",r:50-this.strokeWidth/2,cx:this.viewBox,cy:this.viewBox}})),void 0!==this.trackColor&&"transparent"!==this.trackColor&&e.push(this.__getCircle(t,{cls:"track",thickness:this.strokeWidth,offset:0,color:this.trackColor})),e.push(this.__getCircle(t,{cls:"circle",thickness:this.strokeWidth,offset:this.strokeDashOffset,color:this.color}));var n=[t("svg",{staticClass:"q-circular-progress__svg",style:this.svgStyle,attrs:{focusable:"false",viewBox:this.viewBoxAttr,"aria-hidden":"true"}},e)];return!0===this.showValue&&n.push(t("div",{staticClass:"q-circular-progress__text absolute-full row flex-center content-center",style:{fontSize:this.fontSize}},void 0!==this.$scopedSlots.default?this.$scopedSlots.default():[t("div",[this.normalizedValue])])),t("div",{staticClass:"q-circular-progress",class:"q-circular-progress--"+(!0===this.indeterminate?"in":"")+"determinate",style:this.sizeStyle,on:Object.assign({},this.qListeners),attrs:this.attrs},Dt(n,this,"internal"))}}),Fn=/^#[0-9a-fA-F]{3}([0-9a-fA-F]{3})?$/,$n=/^#[0-9a-fA-F]{4}([0-9a-fA-F]{4})?$/,jn=/^#([0-9a-fA-F]{3}|[0-9a-fA-F]{4}|[0-9a-fA-F]{6}|[0-9a-fA-F]{8})$/,zn=/^rgb\(((0|[1-9][\d]?|1[\d]{0,2}|2[\d]?|2[0-4][\d]|25[0-5]),){2}(0|[1-9][\d]?|1[\d]{0,2}|2[\d]?|2[0-4][\d]|25[0-5])\)$/,Vn=/^rgba\(((0|[1-9][\d]?|1[\d]{0,2}|2[\d]?|2[0-4][\d]|25[0-5]),){2}(0|[1-9][\d]?|1[\d]{0,2}|2[\d]?|2[0-4][\d]|25[0-5]),(0|0\.[0-9]+[1-9]|0\.[1-9]+|1)\)$/,Hn={date:function(t){return/^-?[\d]+\/[0-1]\d\/[0-3]\d$/.test(t)},time:function(t){return/^([0-1]?\d|2[0-3]):[0-5]\d$/.test(t)},fulltime:function(t){return/^([0-1]?\d|2[0-3]):[0-5]\d:[0-5]\d$/.test(t)},timeOrFulltime:function(t){return/^([0-1]?\d|2[0-3]):[0-5]\d(:[0-5]\d)?$/.test(t)},hexColor:function(t){return Fn.test(t)},hexaColor:function(t){return $n.test(t)},hexOrHexaColor:function(t){return jn.test(t)},rgbColor:function(t){return zn.test(t)},rgbaColor:function(t){return Vn.test(t)},rgbOrRgbaColor:function(t){return zn.test(t)||Vn.test(t)},hexOrRgbColor:function(t){return Fn.test(t)||zn.test(t)},hexaOrRgbaColor:function(t){return $n.test(t)||Vn.test(t)},anyColor:function(t){return jn.test(t)||zn.test(t)||Vn.test(t)}},Wn={testPattern:Hn};function Un(t,e,n){var i,r=g(t),o=r.left-e.event.x,a=r.top-e.event.y,s=Math.abs(o),l=Math.abs(a),c=e.direction;!0===c.horizontal&&!0!==c.vertical?i=o<0?"left":"right":!0!==c.horizontal&&!0===c.vertical?i=a<0?"up":"down":!0===c.up&&a<0?(i="up",s>l&&(!0===c.left&&o<0?i="left":!0===c.right&&o>0&&(i="right"))):!0===c.down&&a>0?(i="down",s>l&&(!0===c.left&&o<0?i="left":!0===c.right&&o>0&&(i="right"))):!0===c.left&&o<0?(i="left",s<l&&(!0===c.up&&a<0?i="up":!0===c.down&&a>0&&(i="down"))):!0===c.right&&o>0&&(i="right",s<l&&(!0===c.up&&a<0?i="up":!0===c.down&&a>0&&(i="down")));var u=!1;if(void 0===i&&!1===n){if(!0===e.event.isFirst||void 0===e.event.lastDir)return{};u=!0,"left"===(i=e.event.lastDir)||"right"===i?(r.left-=o,s=0,o=0):(r.top-=a,l=0,a=0)}return{synthetic:u,payload:{evt:t,touch:!0!==e.event.mouse,mouse:!0===e.event.mouse,position:r,direction:i,isFirst:e.event.isFirst,isFinal:!0===n,duration:Date.now()-e.event.time,distance:{x:s,y:l},offset:{x:o,y:a},delta:{x:r.left-e.event.lastX,y:r.top-e.event.lastY}}}}function Yn(t){var e=t.__qtouchpan;void 0!==e&&(void 0!==e.event&&e.end(),S(e,"main"),S(e,"temp"),!0===d.is.firefox&&k(t,!1),void 0!==e.styleCleanup&&e.styleCleanup(),delete t.__qtouchpan)}var Qn=0,Gn={name:"touch-pan",bind:function(t,e){var n=e.value,i=e.modifiers;if(void 0!==t.__qtouchpan&&(Yn(t),t.__qtouchpan_destroyed=!0),!0===i.mouse||!0===d.has.touch){var r={uid:"qvtp_"+Qn++,handler:n,modifiers:i,direction:de(i),noop:m,mouseStart:function(t){fe(t,r)&&v(t)&&(C(r,"temp",[[document,"mousemove","move","notPassiveCapture"],[document,"mouseup","end","passiveCapture"]]),r.start(t,!0))},touchStart:function(t){if(fe(t,r)){var e=he(t.target);C(r,"temp",[[e,"touchmove","move","notPassiveCapture"],[e,"touchcancel","end","passiveCapture"],[e,"touchend","end","passiveCapture"]]),r.start(t)}},start:function(e,n){!0===d.is.firefox&&k(t,!0),r.lastEvt=e;var o=g(e);if(!0===n||!0===i.stop){if(!0!==r.direction.all&&(!0!==n||!0!==r.direction.mouseAllDir)){var a=e.type.indexOf("mouse")>-1?new MouseEvent(e.type,e):new TouchEvent(e.type,e);!0===e.defaultPrevented&&b(a),!0===e.cancelBubble&&_(a),a.qClonedBy=void 0===e.qClonedBy?[r.uid]:e.qClonedBy.concat(r.uid),a.qKeyEvent=e.qKeyEvent,a.qClickOutside=e.qClickOutside,r.initialEvent={target:e.target,event:a}}_(e)}r.event={x:o.left,y:o.top,time:Date.now(),mouse:!0===n,detected:!1,isFirst:!0,isFinal:!1,lastX:o.left,lastY:o.top}},move:function(t){if(void 0!==r.event){r.lastEvt=t;var e=!0===r.event.mouse,n=function(){o(t,e),!0!==i.preserveCursor&&(document.documentElement.style.cursor="grabbing"),!0===e&&document.body.classList.add("no-pointer-events--children"),document.body.classList.add("non-selectable"),we(),r.styleCleanup=function(t){if(r.styleCleanup=void 0,!0!==i.preserveCursor&&(document.documentElement.style.cursor=""),document.body.classList.remove("non-selectable"),!0===e){var n=function(){document.body.classList.remove("no-pointer-events--children")};void 0!==t?setTimeout((function(){n(),t()}),50):n()}else void 0!==t&&t()}};if(!0!==r.event.detected){if(!0===r.direction.all||!0===e&&!0===r.modifiers.mouseAllDir)return n(),r.event.detected=!0,void r.move(t);var a=g(t),s=a.left-r.event.x,l=a.top-r.event.y,c=Math.abs(s),u=Math.abs(l);c!==u&&(!0===r.direction.horizontal&&c>u||!0===r.direction.vertical&&c<u||!0===r.direction.up&&c<u&&l<0||!0===r.direction.down&&c<u&&l>0||!0===r.direction.left&&c>u&&s<0||!0===r.direction.right&&c>u&&s>0?(r.event.detected=!0,r.move(t)):r.end(t,!0))}else{!0!==r.event.isFirst&&o(t,r.event.mouse);var d=Un(t,r,!1),h=d.payload,f=d.synthetic;void 0!==h&&(!1===r.handler(h)?r.end(t):(void 0===r.styleCleanup&&!0===r.event.isFirst&&n(),r.event.lastX=h.position.left,r.event.lastY=h.position.top,r.event.lastDir=!0===f?void 0:h.direction,r.event.isFirst=!1))}}},end:function(e,n){if(void 0!==r.event){if(S(r,"temp"),!0===d.is.firefox&&k(t,!1),!0===n)void 0!==r.styleCleanup&&r.styleCleanup(),!0!==r.event.detected&&void 0!==r.initialEvent&&r.initialEvent.target.dispatchEvent(r.initialEvent.event);else if(!0===r.event.detected){!0===r.event.isFirst&&r.handler(Un(void 0===e?r.lastEvt:e,r).payload);var i=Un(void 0===e?r.lastEvt:e,r,!0).payload,o=function(){r.handler(i)};void 0!==r.styleCleanup?r.styleCleanup(o):o()}r.event=void 0,r.initialEvent=void 0,r.lastEvt=void 0}}};t.__qtouchpan=r,!0===i.mouse&&C(r,"main",[[t,"mousedown","mouseStart","passive"+(!0===i.mouseCapture?"Capture":"")]]),!0===d.has.touch&&C(r,"main",[[t,"touchstart","touchStart","passive"+(!0===i.capture?"Capture":"")],[t,"touchmove","noop","notPassiveCapture"]])}function o(t,e){!0===i.mouse&&!0===e?w(t):(!0===i.stop&&_(t),!0===i.prevent&&b(t))}},update:function(t,e){var n=e.oldValue,i=e.value,r=t.__qtouchpan;void 0!==r&&n!==i&&("function"!=typeof i&&r.end(),r.handler=i)},unbind:function(t){void 0===t.__qtouchpan_destroyed?Yn(t):delete t.__qtouchpan_destroyed}},Kn=[34,37,40,33,39,38];function Jn(t,e,n,i){var r=g(t),o=ut(!0===i?(r.top-e.top)/e.height:(r.left-e.left)/e.width,0,1);return!0===n?1-o:o}function Zn(t,e,n,i,r){var o=e+t*(n-e);if(i>0){var a=(o-e)%i;o+=(Math.abs(a)>=i/2?(a<0?-1:1)*i:0)-a}return r>0&&(o=parseFloat(o.toFixed(r))),ut(o,e,n)}var Xn={mixins:[It,ln],directives:{TouchPan:Gn},props:{min:{type:Number,default:0},max:{type:Number,default:100},step:{type:Number,default:1,validator:function(t){return t>=0}},color:String,labelColor:String,labelTextColor:String,dense:Boolean,label:Boolean,labelAlways:Boolean,markers:Boolean,snap:Boolean,vertical:Boolean,reverse:Boolean,disable:Boolean,readonly:Boolean,tabindex:[String,Number],thumbPath:{type:String,default:"M 4, 10 a 6,6 0 1,0 12,0 a 6,6 0 1,0 -12,0"}},data:function(){return{active:!1,preventFocus:!1,focus:!1}},computed:{axis:function(){return!0===this.vertical?"--v":"--h"},classes:function(){return"q-slider q-slider"+this.axis+" q-slider--"+(!0===this.active?"":"in")+"active"+(!0===this.isReversed?" q-slider--reversed":"")+(void 0!==this.color?" text-"+this.color:"")+(!0===this.disable?" disabled":" q-slider--enabled"+(!0===this.editable?" q-slider--editable":""))+("both"===this.focus?" q-slider--focus":"")+(this.label||!0===this.labelAlways?" q-slider--label":"")+(!0===this.labelAlways?" q-slider--label-always":"")+(!0===this.isDark?" q-slider--dark":"")+(!0===this.dense?" q-slider--dense q-slider--dense"+this.axis:"")},editable:function(){return!0!==this.disable&&!0!==this.readonly},decimals:function(){return(String(this.step).trim("0").split(".")[1]||"").length},computedStep:function(){return 0===this.step?1:this.step},markerStyle:function(){return{backgroundSize:!0===this.vertical?"2px "+100*this.computedStep/(this.max-this.min)+"%":100*this.computedStep/(this.max-this.min)+"% 2px"}},computedTabindex:function(){return!0===this.editable?this.tabindex||0:-1},isReversed:function(){return!0===this.vertical?!0===this.reverse:this.reverse!==(!0===this.$q.lang.rtl)},positionProp:function(){return!0===this.vertical?!0===this.isReversed?"bottom":"top":!0===this.isReversed?"right":"left"},sizeProp:function(){return!0===this.vertical?"height":"width"},orientation:function(){return!0===this.vertical?"vertical":"horizontal"},attrs:function(){var t={role:"slider","aria-valuemin":this.min,"aria-valuemax":this.max,"aria-orientation":this.orientation,"data-step":this.step};return!0===this.disable?t["aria-disabled"]="true":!0===this.readonly&&(t["aria-readonly"]="true"),t},panDirectives:function(){var t;return!0===this.editable?[{name:"touch-pan",value:this.__pan,modifiers:(t={},t[this.orientation]=!0,t.prevent=!0,t.stop=!0,t.mouse=!0,t.mouseAllDir=!0,t)}]:null}},methods:{__getThumbSvg:function(t){return t("svg",{staticClass:"q-slider__thumb absolute",attrs:{focusable:"false",viewBox:"0 0 20 20",width:"20",height:"20","aria-hidden":"true"}},[t("path",{attrs:{d:this.thumbPath}})])},__getPinStyle:function(t,e){var n;if(!0===this.vertical)return{};var i=Math.ceil(20*Math.abs(.5-e))+"px";return{pin:{transformOrigin:(!0===this.$q.lang.rtl?i:!0===this.$q.platform.is.ie?"100%":"calc(100% - "+i+")")+" 50%"},pinTextContainer:(n={},n[!0===this.$q.lang.rtl?"left":"right"]=100*t+"%",n.transform="translateX("+Math.ceil(20*(!0===this.$q.lang.rtl?-1:1)*t)+"px)",n)}},__pan:function(t){t.isFinal?(void 0!==this.dragging&&(this.__updatePosition(t.evt),!0===t.touch&&this.__updateValue(!0),this.dragging=void 0),this.active=!1):t.isFirst?(this.dragging=this.__getDragging(t.evt),this.__updatePosition(t.evt),this.__updateValue(),this.active=!0):(this.__updatePosition(t.evt),this.__updateValue())},__blur:function(){this.focus=!1},__activate:function(t){this.__updatePosition(t,this.__getDragging(t)),this.__updateValue(),this.preventFocus=!0,this.active=!0,document.addEventListener("mouseup",this.__deactivate,!0)},__deactivate:function(){this.preventFocus=!1,void 0===this.dragging&&(this.active=!1),this.__updateValue(!0),this.__blur(),document.removeEventListener("mouseup",this.__deactivate,!0)},__mobileClick:function(t){this.__updatePosition(t,this.__getDragging(t)),this.__updateValue(!0)},__keyup:function(t){Kn.includes(t.keyCode)&&this.__updateValue(!0)}},beforeDestroy:function(){document.removeEventListener("mouseup",this.__deactivate,!0)}},ti=t.extend({name:"QSlider",mixins:[Xn],props:{value:{required:!0,default:null,validator:function(t){return"number"==typeof t||null===t}},labelValue:[String,Number]},data:function(){return{model:null===this.value?this.min:this.value,curRatio:0}},watch:{value:function(t){this.model=null===t?0:ut(t,this.min,this.max)},min:function(t){this.model=ut(this.model,t,this.max)},max:function(t){this.model=ut(this.model,this.min,t)}},computed:{ratio:function(){return!0===this.active?this.curRatio:this.modelRatio},modelRatio:function(){return(this.model-this.min)/(this.max-this.min)},trackStyle:function(){var t;return(t={})[this.positionProp]=0,t[this.sizeProp]=100*this.ratio+"%",t},thumbStyle:function(){var t;return(t={})[this.positionProp]=100*this.ratio+"%",t},thumbClass:function(){if(!1===this.preventFocus&&!0===this.focus)return"q-slider--focus"},pinClass:function(){if(void 0!==this.labelColor)return"text-"+this.labelColor},pinTextClass:function(){return"q-slider__pin-value-marker-text"+(void 0!==this.labelTextColor?" text-"+this.labelTextColor:"")},events:function(){if(!0===this.editable)return!0===this.$q.platform.is.mobile?{click:this.__mobileClick}:{mousedown:this.__activate,focus:this.__focus,blur:this.__blur,keydown:this.__keydown,keyup:this.__keyup}},computedLabel:function(){return void 0!==this.labelValue?this.labelValue:this.model},pinStyle:function(){var t=!0===this.reverse?-this.ratio:this.ratio-1;return this.__getPinStyle(t,this.ratio)}},methods:{__updateValue:function(t){this.model!==this.value&&this.$emit("input",this.model),!0===t&&this.$emit("change",this.model)},__getDragging:function(){return this.$el.getBoundingClientRect()},__updatePosition:function(t,e){void 0===e&&(e=this.dragging);var n=Jn(t,e,this.isReversed,this.vertical);this.model=Zn(n,this.min,this.max,this.step,this.decimals),this.curRatio=!0!==this.snap||0===this.step?n:(this.model-this.min)/(this.max-this.min)},__focus:function(){this.focus=!0},__keydown:function(t){if(Kn.includes(t.keyCode)){w(t);var e=([34,33].includes(t.keyCode)?10:1)*this.computedStep,n=[34,37,40].includes(t.keyCode)?-e:e;this.model=ut(parseFloat((this.model+n).toFixed(this.decimals)),this.min,this.max),this.__updateValue()}}},render:function(t){var e=[this.__getThumbSvg(t),t("div",{staticClass:"q-slider__focus-ring"})];!0!==this.label&&!0!==this.labelAlways||e.push(t("div",{staticClass:"q-slider__pin q-slider__pin"+this.axis+" absolute",style:this.pinStyle.pin,class:this.pinClass},[t("div",{staticClass:"q-slider__pin-text-container q-slider__pin-text-container"+this.axis,style:this.pinStyle.pinTextContainer},[t("span",{staticClass:"q-slider__pin-text",class:this.pinTextClass},[this.computedLabel])])]),t("div",{staticClass:"q-slider__arrow q-slider__arrow"+this.axis,class:this.pinClass})),void 0!==this.name&&!0!==this.disable&&this.__injectFormInput(e,"push");var n=[t("div",{staticClass:"q-slider__track q-slider__track"+this.axis+" absolute",style:this.trackStyle})];return!0===this.markers&&n.push(t("div",{staticClass:"q-slider__track-markers q-slider__track-markers"+this.axis+" absolute-full fit",style:this.markerStyle})),t("div",{staticClass:null===this.value?" q-slider--no-value":"",attrs:Object.assign({},this.attrs,{"aria-valuenow":this.value,tabindex:this.computedTabindex}),class:this.classes,on:this.events,directives:this.panDirectives},[t("div",{staticClass:"q-slider__track-container q-slider__track-container"+this.axis+" absolute"},n),t("div",{staticClass:"q-slider__thumb-container q-slider__thumb-container"+this.axis+" absolute non-selectable",class:this.thumbClass,style:this.thumbStyle},e)])}}),ei={data:function(){return{canRender:!o}},mounted:function(){!1===this.canRender&&(this.canRender=!0)}},ni=t.extend({name:"QResizeObserver",mixins:[ei],props:{debounce:{type:[String,Number],default:100}},data:function(){return!0===this.hasObserver?{}:{url:!0===this.$q.platform.is.ie?null:"about:blank"}},methods:{trigger:function(t){!0===t||0===this.debounce||"0"===this.debounce?this.__onResize():this.timer||(this.timer=setTimeout(this.__onResize,this.debounce))},__onResize:function(){if(this.timer=null,this.$el&&this.$el.parentNode){var t=this.$el.parentNode,e={width:t.offsetWidth,height:t.offsetHeight};e.width===this.size.width&&e.height===this.size.height||(this.size=e,this.$emit("resize",this.size))}},__cleanup:function(){void 0!==this.curDocView&&(void 0!==this.curDocView.removeEventListener&&this.curDocView.removeEventListener("resize",this.trigger,f.passive),this.curDocView=void 0)},__onObjLoad:function(){this.__cleanup(),this.$el.contentDocument&&(this.curDocView=this.$el.contentDocument.defaultView,this.curDocView.addEventListener("resize",this.trigger,f.passive)),this.__onResize()}},render:function(t){if(!1!==this.canRender&&!0!==this.hasObserver)return t("object",{style:this.style,attrs:{tabindex:-1,type:"text/html",data:this.url,"aria-hidden":"true"},on:pt(this,"load",{load:this.__onObjLoad})})},beforeCreate:function(){this.size={width:-1,height:-1},!0!==i&&(this.hasObserver="undefined"!=typeof ResizeObserver,!0!==this.hasObserver&&(this.style=(this.$q.platform.is.ie?"visibility:hidden;":"")+"display:block;position:absolute;top:0;left:0;right:0;bottom:0;height:100%;width:100%;overflow:hidden;pointer-events:none;z-index:-1;"))},mounted:function(){if(!0===this.hasObserver)return this.observer=new ResizeObserver(this.trigger),this.observer.observe(this.$el.parentNode),void this.__onResize();!0===this.$q.platform.is.ie?(this.url="about:blank",this.__onResize()):this.__onObjLoad()},beforeDestroy:function(){clearTimeout(this.timer),!0!==this.hasObserver?this.__cleanup():void 0!==this.observer&&this.$el.parentNode&&this.observer.unobserve(this.$el.parentNode)}});function ii(t,e,n){var i=!0===n?["left","right"]:["top","bottom"];return"absolute-"+(!0===e?i[0]:i[1])+(t?" text-"+t:"")}function ri(t,e){return t.priorityMatched===e.priorityMatched?e.priorityHref-t.priorityHref:e.priorityMatched-t.priorityMatched}function oi(t){return t.selected=!1,t}var ai=[function(t){return!0===t.selected&&!0===t.exact&&!0!==t.redirected},function(t){return!0===t.selected&&!0===t.exact},function(t){return!0===t.selected&&!0!==t.redirected},function(t){return!0===t.selected},function(t){return!0===t.exact&&!0!==t.redirected},function(t){return!0!==t.redirected},function(t){return!0===t.exact},function(t){return!0}],si=ai.length,li=t.extend({name:"QTabs",mixins:[xe,Ot],provide:function(){return{tabs:this.tabs,__recalculateScroll:this.__recalculateScroll,__activateTab:this.__activateTab,__activateRoute:this.__activateRoute}},props:{value:[Number,String],align:{type:String,default:"center",validator:function(t){return["left","center","right","justify"].includes(t)}},breakpoint:{type:[String,Number],default:600},vertical:Boolean,shrink:Boolean,stretch:Boolean,activeColor:String,activeBgColor:String,indicatorColor:String,leftIcon:String,rightIcon:String,outsideArrows:Boolean,mobileArrows:Boolean,switchIndicator:Boolean,narrowIndicator:Boolean,inlineLabel:Boolean,noCaps:Boolean,dense:Boolean,contentClass:String},data:function(){return{tabs:{current:this.value,activeColor:this.activeColor,activeBgColor:this.activeBgColor,indicatorClass:ii(this.indicatorColor,this.switchIndicator,this.vertical),narrowIndicator:this.narrowIndicator,inlineLabel:this.inlineLabel,noCaps:this.noCaps},scrollable:!1,leftArrow:!0,rightArrow:!1,justify:!1}},watch:{value:function(t){this.__activateTab(t,!0,!0)},activeColor:function(t){this.tabs.activeColor=t},activeBgColor:function(t){this.tabs.activeBgColor=t},vertical:function(t){this.tabs.indicatorClass=ii(this.indicatorColor,this.switchIndicator,t)},indicatorColor:function(t){this.tabs.indicatorClass=ii(t,this.switchIndicator,this.vertical)},switchIndicator:function(t){this.tabs.indicatorClass=ii(this.indicatorColor,t,this.vertical)},narrowIndicator:function(t){this.tabs.narrowIndicator=t},inlineLabel:function(t){this.tabs.inlineLabel=t},noCaps:function(t){this.tabs.noCaps=t},outsideArrows:function(){this.$nextTick(this.__recalculateScroll())},arrowsEnabled:function(t){this.__updateArrows=!0===t?this.__updateArrowsFn:m,this.$nextTick(this.__recalculateScroll())}},computed:{arrowsEnabled:function(){return!0===this.$q.platform.is.desktop||!0===this.mobileArrows},alignClass:function(){return"q-tabs__content--align-"+(!0===this.scrollable?"left":!0===this.justify?"justify":this.align)},classes:function(){return"q-tabs--"+(!0===this.scrollable?"":"not-")+"scrollable q-tabs--"+(!0===this.vertical?"vertical":"horizontal")+" q-tabs__arrows--"+(!0===this.arrowsEnabled&&!0===this.outsideArrows?"outside":"inside")+(!0===this.dense?" q-tabs--dense":"")+(!0===this.shrink?" col-shrink":"")+(!0===this.stretch?" self-stretch":"")},innerClass:function(){return this.alignClass+(void 0!==this.contentClass?" "+this.contentClass:"")},domProps:function(){return!0===this.vertical?{container:"height",content:"scrollHeight",posLeft:"top",posRight:"bottom"}:{container:"width",content:"scrollWidth",posLeft:"left",posRight:"right"}},onEvents:function(){return Object.assign({},{input:_},this.qListeners)}},methods:{__activateTab:function(t,e,n){this.tabs.current!==t&&(!0!==n&&this.$emit("input",t),!0!==e&&void 0!==this.qListeners.input||(this.__animate(this.tabs.current,t),this.tabs.current=t))},__activateRoute:function(t){var e=this;this.bufferRoute!==this.$route&&this.buffer.length>0&&(clearTimeout(this.bufferTimer),this.bufferTimer=void 0,this.buffer.length=0),this.bufferRoute=this.$route,void 0!==t&&(!0===t.remove?this.buffer=this.buffer.filter((function(e){return e.name!==t.name})):this.buffer.push(t)),void 0===this.bufferTimer&&(this.bufferTimer=setTimeout((function(){for(var t=[],n=0;n<si&&0===t.length;n++)t=e.buffer.filter(ai[n]);t.sort(ri),e.__activateTab(0===t.length?null:t[0].name,!0),e.buffer=e.buffer.map(oi),e.bufferTimer=void 0}),1))},__recalculateScroll:function(){var t=this;this.__nextTick((function(){!0!==t._isDestroyed&&t.__updateContainer({width:t.$el.offsetWidth,height:t.$el.offsetHeight})})),this.__prepareTick()},__updateContainer:function(t){var e=this,n=t[this.domProps.container],i=this.$refs.content[this.domProps.content],r=n>0&&i>n;this.scrollable!==r&&(this.scrollable=r),!0===r&&this.$nextTick((function(){return e.__updateArrows()}));var o=n<parseInt(this.breakpoint,10);this.justify!==o&&(this.justify=o)},__animate:function(t,e){var n=this,i=null!=t&&""!==t?this.$children.find((function(e){return e.name===t})):null,r=null!=e&&""!==e?this.$children.find((function(t){return t.name===e})):null;if(i&&r){var o=i.$el.getElementsByClassName("q-tab__indicator")[0],a=r.$el.getElementsByClassName("q-tab__indicator")[0];clearTimeout(this.animateTimer),o.style.transition="none",o.style.transform="none",a.style.transition="none",a.style.transform="none";var s=o.getBoundingClientRect(),l=a.getBoundingClientRect();a.style.transform=!0===this.vertical?"translate3d(0,"+(s.top-l.top)+"px,0) scale3d(1,"+(l.height?s.height/l.height:1)+",1)":"translate3d("+(s.left-l.left)+"px,0,0) scale3d("+(l.width?s.width/l.width:1)+",1,1)",this.$nextTick((function(){n.animateTimer=setTimeout((function(){a.style.transition="transform .25s cubic-bezier(.4, 0, .2, 1)",a.style.transform="none"}),70)}))}if(r&&!0===this.scrollable){var c=this.$refs.content.getBoundingClientRect(),u=c.left,d=c.width,h=c.top,f=c.height,p=r.$el.getBoundingClientRect(),m=!0===this.vertical?p.top-h:p.left-u;if(m<0)return this.$refs.content[!0===this.vertical?"scrollTop":"scrollLeft"]+=Math.floor(m),void this.__updateArrows();(m+=!0===this.vertical?p.height-f:p.width-d)>0&&(this.$refs.content[!0===this.vertical?"scrollTop":"scrollLeft"]+=Math.ceil(m),this.__updateArrows())}},__updateArrowsFn:function(){var t=this.$refs.content,e=t.getBoundingClientRect(),n=!0===this.vertical?t.scrollTop:t.scrollLeft;this.leftArrow=n>0,this.rightArrow=!0===this.vertical?Math.ceil(n+e.height)<t.scrollHeight:Math.ceil(n+e.width)<t.scrollWidth},__animScrollTo:function(t){var e=this;this.__stopAnimScroll(),this.__scrollTowards(t),this.scrollTimer=setInterval((function(){e.__scrollTowards(t)&&e.__stopAnimScroll()}),5)},__scrollToStart:function(){this.__animScrollTo(0)},__scrollToEnd:function(){this.__animScrollTo(9999)},__stopAnimScroll:function(){clearInterval(this.scrollTimer)},__scrollTowards:function(t){var e=this.$refs.content,n=!0===this.vertical?e.scrollTop:e.scrollLeft,i=!1,r=t<n?-1:1;return(n+=5*r)<0?(i=!0,n=0):(-1===r&&n<=t||1===r&&n>=t)&&(i=!0,n=t),e[!0===this.vertical?"scrollTop":"scrollLeft"]=n,this.__updateArrows(),i}},created:function(){this.buffer=[],this.__updateArrows=!0===this.arrowsEnabled?this.__updateArrowsFn:m},beforeDestroy:function(){clearTimeout(this.bufferTimer),clearTimeout(this.animateTimer)},render:function(t){var e=[t(ni,{on:pt(this,"resize",{resize:this.__updateContainer})}),t("div",{ref:"content",staticClass:"q-tabs__content row no-wrap items-center self-stretch hide-scrollbar",class:this.innerClass},Bt(this,"default"))];return!0===this.arrowsEnabled&&e.push(t(Lt,{staticClass:"q-tabs__arrow q-tabs__arrow--left absolute q-tab__icon",class:!0===this.leftArrow?"":"q-tabs__arrow--faded",props:{name:this.leftIcon||(!0===this.vertical?this.$q.iconSet.tabs.up:this.$q.iconSet.tabs.left)},on:pt(this,"onL",{mousedown:this.__scrollToStart,touchstart:this.__scrollToStart,mouseup:this.__stopAnimScroll,mouseleave:this.__stopAnimScroll,touchend:this.__stopAnimScroll})}),t(Lt,{staticClass:"q-tabs__arrow q-tabs__arrow--right absolute q-tab__icon",class:!0===this.rightArrow?"":"q-tabs__arrow--faded",props:{name:this.rightIcon||(!0===this.vertical?this.$q.iconSet.tabs.down:this.$q.iconSet.tabs.right)},on:pt(this,"onR",{mousedown:this.__scrollToEnd,touchstart:this.__scrollToEnd,mouseup:this.__stopAnimScroll,mouseleave:this.__stopAnimScroll,touchend:this.__stopAnimScroll})})),t("div",{staticClass:"q-tabs row no-wrap items-center",class:this.classes,on:this.onEvents,attrs:{role:"tablist"}},e)}}),ci=0,ui=t.extend({name:"QTab",mixins:[ae,Ot],inject:{tabs:{default:function(){console.error("QTab/QRouteTab components need to be child of QTabs")}},__activateTab:{},__recalculateScroll:{}},props:{icon:String,label:[Number,String],alert:[Boolean,String],alertIcon:String,name:{type:[Number,String],default:function(){return"t_"+ci++}},noCaps:Boolean,tabindex:[String,Number],disable:Boolean,contentClass:String},computed:{isActive:function(){return this.tabs.current===this.name},classes:function(){var t;return(t={})["q-tab--"+(this.isActive?"":"in")+"active"]=!0,t["text-"+this.tabs.activeColor]=this.isActive&&this.tabs.activeColor,t["bg-"+this.tabs.activeBgColor]=this.isActive&&this.tabs.activeBgColor,t["q-tab--full"]=this.icon&&this.label&&!this.tabs.inlineLabel,t["q-tab--no-caps"]=!0===this.noCaps||!0===this.tabs.noCaps,t["q-focusable q-hoverable cursor-pointer"]=!this.disable,t.disabled=this.disable,t},innerClass:function(){return(!0===this.tabs.inlineLabel?"row no-wrap q-tab__content--inline":"column")+(void 0!==this.contentClass?" "+this.contentClass:"")},computedTabIndex:function(){return!0===this.disable||!0===this.isActive?-1:this.tabindex||0},onEvents:function(){return Object.assign({},{input:_},this.qListeners,{click:this.__activate,keyup:this.__onKeyup})},attrs:function(){var t={tabindex:this.computedTabIndex,role:"tab","aria-selected":this.isActive};return!0===this.disable&&(t["aria-disabled"]="true"),t}},methods:{__activate:function(t,e){!0!==e&&void 0!==this.$refs.blurTarget&&this.$refs.blurTarget.focus(),!0!==this.disable&&(void 0!==this.qListeners.click&&this.$emit("click",t),this.__activateTab(this.name))},__onKeyup:function(t){!0===X(t,13)&&this.__activate(t,!0)},__getContent:function(t){var e=this.tabs.narrowIndicator,n=[],i=t("div",{staticClass:"q-tab__indicator",class:this.tabs.indicatorClass});void 0!==this.icon&&n.push(t(Lt,{staticClass:"q-tab__icon",props:{name:this.icon}})),void 0!==this.label&&n.push(t("div",{staticClass:"q-tab__label"},[this.label])),!1!==this.alert&&n.push(void 0!==this.alertIcon?t(Lt,{staticClass:"q-tab__alert-icon",props:{color:!0!==this.alert?this.alert:void 0,name:this.alertIcon}}):t("div",{staticClass:"q-tab__alert",class:!0!==this.alert?"text-"+this.alert:null})),!0===e&&n.push(i);var r=[t("div",{staticClass:"q-focus-helper",attrs:{tabindex:-1},ref:"blurTarget"}),t("div",{staticClass:"q-tab__content self-stretch flex-center relative-position q-anchor--skip non-selectable",class:this.innerClass},At(n,this,"default"))];return!1===e&&r.push(i),r},__renderTab:function(t,e,n){var i={staticClass:"q-tab relative-position self-stretch flex flex-center text-center",class:this.classes,attrs:this.attrs,directives:!1!==this.ripple&&!0===this.disable?null:[{name:"ripple",value:this.ripple}]};return i["div"===e?"on":"nativeOn"]=this.onEvents,void 0!==n&&(i.props=n),t(e,i,this.__getContent(t))}},mounted:function(){this.__recalculateScroll()},beforeDestroy:function(){this.__recalculateScroll()},render:function(t){return this.__renderTab(t,"div")}}),di=t.extend({name:"QTabPanels",mixins:[It,yn],computed:{classes:function(){return"q-tab-panels q-panel-parent"+(!0===this.isDark?" q-tab-panels--dark q-dark":"")}},methods:{__renderPanels:function(t){return t("div",{class:this.classes,directives:this.panelDirectives,on:Object.assign({},this.qListeners)},this.__getPanelContent(t))}}}),hi=t.extend({name:"QTabPanel",mixins:[_n],render:function(t){return t("div",{staticClass:"q-tab-panel",on:Object.assign({},this.qListeners)},Bt(this,"default"))}}),fi=["rgb(255,204,204)","rgb(255,230,204)","rgb(255,255,204)","rgb(204,255,204)","rgb(204,255,230)","rgb(204,255,255)","rgb(204,230,255)","rgb(204,204,255)","rgb(230,204,255)","rgb(255,204,255)","rgb(255,153,153)","rgb(255,204,153)","rgb(255,255,153)","rgb(153,255,153)","rgb(153,255,204)","rgb(153,255,255)","rgb(153,204,255)","rgb(153,153,255)","rgb(204,153,255)","rgb(255,153,255)","rgb(255,102,102)","rgb(255,179,102)","rgb(255,255,102)","rgb(102,255,102)","rgb(102,255,179)","rgb(102,255,255)","rgb(102,179,255)","rgb(102,102,255)","rgb(179,102,255)","rgb(255,102,255)","rgb(255,51,51)","rgb(255,153,51)","rgb(255,255,51)","rgb(51,255,51)","rgb(51,255,153)","rgb(51,255,255)","rgb(51,153,255)","rgb(51,51,255)","rgb(153,51,255)","rgb(255,51,255)","rgb(255,0,0)","rgb(255,128,0)","rgb(255,255,0)","rgb(0,255,0)","rgb(0,255,128)","rgb(0,255,255)","rgb(0,128,255)","rgb(0,0,255)","rgb(128,0,255)","rgb(255,0,255)","rgb(245,0,0)","rgb(245,123,0)","rgb(245,245,0)","rgb(0,245,0)","rgb(0,245,123)","rgb(0,245,245)","rgb(0,123,245)","rgb(0,0,245)","rgb(123,0,245)","rgb(245,0,245)","rgb(214,0,0)","rgb(214,108,0)","rgb(214,214,0)","rgb(0,214,0)","rgb(0,214,108)","rgb(0,214,214)","rgb(0,108,214)","rgb(0,0,214)","rgb(108,0,214)","rgb(214,0,214)","rgb(163,0,0)","rgb(163,82,0)","rgb(163,163,0)","rgb(0,163,0)","rgb(0,163,82)","rgb(0,163,163)","rgb(0,82,163)","rgb(0,0,163)","rgb(82,0,163)","rgb(163,0,163)","rgb(92,0,0)","rgb(92,46,0)","rgb(92,92,0)","rgb(0,92,0)","rgb(0,92,46)","rgb(0,92,92)","rgb(0,46,92)","rgb(0,0,92)","rgb(46,0,92)","rgb(92,0,92)","rgb(255,255,255)","rgb(205,205,205)","rgb(178,178,178)","rgb(153,153,153)","rgb(127,127,127)","rgb(102,102,102)","rgb(76,76,76)","rgb(51,51,51)","rgb(25,25,25)","rgb(0,0,0)"],pi=t.extend({name:"QColor",mixins:[Ot,It,ln],directives:{TouchPan:Gn},props:{value:String,defaultValue:String,defaultView:{type:String,default:"spectrum",validator:function(t){return["spectrum","tune","palette"].includes(t)}},formatModel:{type:String,default:"auto",validator:function(t){return["auto","hex","rgb","hexa","rgba"].includes(t)}},palette:Array,noHeader:Boolean,noFooter:Boolean,square:Boolean,flat:Boolean,bordered:Boolean,disable:Boolean,readonly:Boolean},data:function(){return{topView:"auto"===this.formatModel?void 0===this.value||null===this.value||""===this.value||this.value.startsWith("#")?"hex":"rgb":this.formatModel.startsWith("hex")?"hex":"rgb",view:this.defaultView,model:this.__parseModel(this.value||this.defaultValue)}},watch:{value:function(t){var e=this.__parseModel(t||this.defaultValue);e.hex!==this.model.hex&&(this.model=e)},defaultValue:function(t){if(!this.value&&t){var e=this.__parseModel(t);e.hex!==this.model.hex&&(this.model=e)}}},computed:{editable:function(){return!0!==this.disable&&!0!==this.readonly},forceHex:function(){return"auto"===this.formatModel?null:this.formatModel.indexOf("hex")>-1},forceAlpha:function(){return"auto"===this.formatModel?null:this.formatModel.indexOf("a")>-1},isHex:function(){return void 0===this.value||null===this.value||""===this.value||this.value.startsWith("#")},isOutputHex:function(){return null!==this.forceHex?this.forceHex:this.isHex},formAttrs:function(){return{type:"hidden",name:this.name,value:this.model[!0===this.isOutputHex?"hex":"rgb"]}},hasAlpha:function(){return null!==this.forceAlpha?this.forceAlpha:void 0!==this.model.a},currentBgColor:function(){return{backgroundColor:this.model.rgb||"#000"}},headerClass:function(){return"q-color-picker__header-content--"+(void 0!==this.model.a&&this.model.a<65||U(this.model)>.4?"light":"dark")},spectrumStyle:function(){return{background:"hsl("+this.model.h+",100%,50%)"}},spectrumPointerStyle:function(){var t;return(t={top:100-this.model.v+"%"})[!0===this.$q.lang.rtl?"right":"left"]=this.model.s+"%",t},inputsArray:function(){var t=["r","g","b"];return!0===this.hasAlpha&&t.push("a"),t},computedPalette:function(){return void 0!==this.palette&&this.palette.length>0?this.palette:fi},classes:function(){return"q-color-picker"+(!0===this.bordered?" q-color-picker--bordered":"")+(!0===this.square?" q-color-picker--square no-border-radius":"")+(!0===this.flat?" q-color-picker--flat no-shadow":"")+(!0===this.disable?" disabled":"")+(!0===this.isDark?" q-color-picker--dark q-dark":"")},attrs:function(){return!0===this.disable?{"aria-disabled":"true"}:!0===this.readonly?{"aria-readonly":"true"}:void 0}},created:function(){this.__spectrumChange=ee(this.__spectrumChange,20)},render:function(t){var e=[this.__getContent(t)];return void 0!==this.name&&!0!==this.disable&&this.__injectFormInput(e,"push"),!0!==this.noHeader&&e.unshift(this.__getHeader(t)),!0!==this.noFooter&&e.push(this.__getFooter(t)),t("div",{class:this.classes,attrs:this.attrs,on:Object.assign({},this.qListeners)},e)},methods:{__getHeader:function(t){var e=this;return t("div",{staticClass:"q-color-picker__header relative-position overflow-hidden"},[t("div",{staticClass:"q-color-picker__header-bg absolute-full"}),t("div",{staticClass:"q-color-picker__header-content absolute-full",class:this.headerClass,style:this.currentBgColor},[t(li,{props:{value:this.topView,dense:!0,align:"justify"},on:pt(this,"topVTab",{input:function(t){e.topView=t}})},[t(ui,{props:{label:"HEX"+(!0===this.hasAlpha?"A":""),name:"hex",ripple:!1}}),t(ui,{props:{label:"RGB"+(!0===this.hasAlpha?"A":""),name:"rgb",ripple:!1}})]),t("div",{staticClass:"q-color-picker__header-banner row flex-center no-wrap"},[t("input",{staticClass:"fit",domProps:{value:this.model[this.topView]},attrs:!0!==this.editable?{readonly:!0}:null,on:pt(this,"topIn",{input:function(t){e.__updateErrorIcon(!0===e.__onEditorChange(t))},change:_,blur:function(t){!0===e.__onEditorChange(t,!0)&&e.$forceUpdate(),e.__updateErrorIcon(!1)}})}),t(Lt,{ref:"errorIcon",staticClass:"q-color-picker__error-icon absolute no-pointer-events",props:{name:this.$q.iconSet.type.negative}})])])])},__getContent:function(t){return t(di,{props:{value:this.view,animated:!0}},[t(hi,{staticClass:"q-color-picker__spectrum-tab overflow-hidden",props:{name:"spectrum"}},this.__getSpectrumTab(t)),t(hi,{staticClass:"q-pa-md q-color-picker__tune-tab",props:{name:"tune"}},this.__getTuneTab(t)),t(hi,{staticClass:"q-color-picker__palette-tab",props:{name:"palette"}},this.__getPaletteTab(t))])},__getFooter:function(t){var e=this;return t("div",{staticClass:"q-color-picker__footer relative-position overflow-hidden"},[t(li,{staticClass:"absolute-full",props:{value:this.view,dense:!0,align:"justify"},on:pt(this,"ftIn",{input:function(t){e.view=t}})},[t(ui,{props:{icon:this.$q.iconSet.colorPicker.spectrum,name:"spectrum",ripple:!1}}),t(ui,{props:{icon:this.$q.iconSet.colorPicker.tune,name:"tune",ripple:!1}}),t(ui,{props:{icon:this.$q.iconSet.colorPicker.palette,name:"palette",ripple:!1}})])])},__getSpectrumTab:function(t){var e=this,n="M5 5 h10 v10 h-10 v-10 z";return[t("div",{ref:"spectrum",staticClass:"q-color-picker__spectrum non-selectable relative-position cursor-pointer",style:this.spectrumStyle,class:{readonly:!0!==this.editable},on:!0===this.editable?pt(this,"spectrT",{click:this.__spectrumClick,mousedown:this.__activate}):null,directives:!0===this.editable?pt(this,"spectrDir",[{name:"touch-pan",modifiers:{prevent:!0,stop:!0,mouse:!0},value:this.__spectrumPan}]):null},[t("div",{style:{paddingBottom:"100%"}}),t("div",{staticClass:"q-color-picker__spectrum-white absolute-full"}),t("div",{staticClass:"q-color-picker__spectrum-black absolute-full"}),t("div",{staticClass:"absolute",style:this.spectrumPointerStyle},[void 0!==this.model.hex?t("div",{staticClass:"q-color-picker__spectrum-circle"}):null])]),t("div",{staticClass:"q-color-picker__sliders"},[t("div",{staticClass:"q-color-picker__hue non-selectable"},[t(ti,{props:{value:this.model.h,min:0,max:360,fillHandleAlways:!0,readonly:!0!==this.editable,thumbPath:n},on:pt(this,"hueSlide",{input:this.__onHueChange,change:function(t){return e.__onHueChange(t,!0)}})})]),!0===this.hasAlpha?t("div",{staticClass:"q-color-picker__alpha non-selectable"},[t(ti,{props:{value:this.model.a,min:0,max:100,fillHandleAlways:!0,readonly:!0!==this.editable,thumbPath:n},on:pt(this,"alphaSlide",{input:function(t){return e.__onNumericChange(t,"a",100)},change:function(t){return e.__onNumericChange(t,"a",100,void 0,!0)}})})]):null])]},__getTuneTab:function(t){var e=this;return[t("div",{staticClass:"row items-center no-wrap"},[t("div",["R"]),t(ti,{props:{value:this.model.r,min:0,max:255,color:"red",dark:this.isDark,readonly:!0!==this.editable},on:pt(this,"rSlide",{input:function(t){return e.__onNumericChange(t,"r",255)},change:function(t){return e.__onNumericChange(t,"r",255,void 0,!0)}})}),t("input",{domProps:{value:this.model.r},attrs:{maxlength:3,readonly:!0!==this.editable},on:pt(this,"rIn",{input:function(t){return e.__onNumericChange(t.target.value,"r",255,t)},change:_,blur:function(t){return e.__onNumericChange(t.target.value,"r",255,t,!0)}})})]),t("div",{staticClass:"row items-center no-wrap"},[t("div",["G"]),t(ti,{props:{value:this.model.g,min:0,max:255,color:"green",dark:this.isDark,readonly:!0!==this.editable},on:pt(this,"gSlide",{input:function(t){return e.__onNumericChange(t,"g",255)},change:function(t){return e.__onNumericChange(t,"g",255,void 0,!0)}})}),t("input",{domProps:{value:this.model.g},attrs:{maxlength:3,readonly:!0!==this.editable},on:pt(this,"gIn",{input:function(t){return e.__onNumericChange(t.target.value,"g",255,t)},change:_,blur:function(t){return e.__onNumericChange(t.target.value,"g",255,t,!0)}})})]),t("div",{staticClass:"row items-center no-wrap"},[t("div",["B"]),t(ti,{props:{value:this.model.b,min:0,max:255,color:"blue",readonly:!0!==this.editable,dark:this.isDark},on:pt(this,"bSlide",{input:function(t){return e.__onNumericChange(t,"b",255)},change:function(t){return e.__onNumericChange(t,"b",255,void 0,!0)}})}),t("input",{domProps:{value:this.model.b},attrs:{maxlength:3,readonly:!0!==this.editable},on:pt(this,"bIn",{input:function(t){return e.__onNumericChange(t.target.value,"b",255,t)},change:_,blur:function(t){return e.__onNumericChange(t.target.value,"b",255,t,!0)}})})]),!0===this.hasAlpha?t("div",{staticClass:"row items-center no-wrap"},[t("div",["A"]),t(ti,{props:{value:this.model.a,color:"grey",readonly:!0!==this.editable,dark:this.isDark},on:pt(this,"aSlide",{input:function(t){return e.__onNumericChange(t,"a",100)},change:function(t){return e.__onNumericChange(t,"a",100,void 0,!0)}})}),t("input",{domProps:{value:this.model.a},attrs:{maxlength:3,readonly:!0!==this.editable},on:pt(this,"aIn",{input:function(t){return e.__onNumericChange(t.target.value,"a",100,t)},change:_,blur:function(t){return e.__onNumericChange(t.target.value,"a",100,t,!0)}})})]):null]},__getPaletteTab:function(t){var e=this;return[t("div",{staticClass:"row items-center q-color-picker__palette-rows",class:!0===this.editable?"q-color-picker__palette-rows--editable":""},this.computedPalette.map((function(n){return t("div",{staticClass:"q-color-picker__cube col-auto",style:{backgroundColor:n},on:!0===e.editable?pt(e,"palette#"+n,{click:function(){e.__onPalettePick(n)}}):null})})))]},__onSpectrumChange:function(t,e,n){var i=this.$refs.spectrum;if(void 0!==i){var r=i.clientWidth,o=i.clientHeight,a=i.getBoundingClientRect(),s=Math.min(r,Math.max(0,t-a.left));!0===this.$q.lang.rtl&&(s=r-s);var l=Math.min(o,Math.max(0,e-a.top)),c=Math.round(100*s/r),u=Math.round(100*Math.max(0,Math.min(1,-l/o+1))),d=V({h:this.model.h,s:c,v:u,a:!0===this.hasAlpha?this.model.a:void 0});this.model.s=c,this.model.v=u,this.__update(d,n)}},__onHueChange:function(t,e){var n=V({h:t=Math.round(t),s:this.model.s,v:this.model.v,a:!0===this.hasAlpha?this.model.a:void 0});this.model.h=t,this.__update(n,e)},__onNumericChange:function(t,e,n,i,r){if(void 0!==i&&_(i),/^[0-9]+$/.test(t)){var o=Math.floor(Number(t));if(o<0||o>n)!0===r&&this.$forceUpdate();else{var a={r:"r"===e?o:this.model.r,g:"g"===e?o:this.model.g,b:"b"===e?o:this.model.b,a:!0===this.hasAlpha?"a"===e?o:this.model.a:void 0};if("a"!==e){var s=H(a);this.model.h=s.h,this.model.s=s.s,this.model.v=s.v}if(this.__update(a,r),void 0!==i&&!0!==r&&void 0!==i.target.selectionEnd){var l=i.target.selectionEnd;this.$nextTick((function(){i.target.setSelectionRange(l,l)}))}}}else r&&this.$forceUpdate()},__onEditorChange:function(t,e){var n,i=t.target.value;if(_(t),"hex"===this.topView){if(i.length!==(!0===this.hasAlpha?9:7)||!/^#[0-9A-Fa-f]+$/.test(i))return!0;n=z(i)}else{var r;if(!i.endsWith(")"))return!0;if(!0!==this.hasAlpha&&i.startsWith("rgb(")){if(3!==(r=i.substring(4,i.length-1).split(",").map((function(t){return parseInt(t,10)}))).length||!/^rgb\([0-9]{1,3},[0-9]{1,3},[0-9]{1,3}\)$/.test(i))return!0}else{if(!0!==this.hasAlpha||!i.startsWith("rgba("))return!0;if(4!==(r=i.substring(5,i.length-1).split(",")).length||!/^rgba\([0-9]{1,3},[0-9]{1,3},[0-9]{1,3},(0|0\.[0-9]+[1-9]|0\.[1-9]+|1)\)$/.test(i))return!0;for(var o=0;o<3;o++){var a=parseInt(r[o],10);if(a<0||a>255)return!0;r[o]=a}var s=parseFloat(r[3]);if(s<0||s>1)return!0;r[3]=s}if(r[0]<0||r[0]>255||r[1]<0||r[1]>255||r[2]<0||r[2]>255||!0===this.hasAlpha&&(r[3]<0||r[3]>1))return!0;n={r:r[0],g:r[1],b:r[2],a:!0===this.hasAlpha?100*r[3]:void 0}}var l=H(n);if(this.model.h=l.h,this.model.s=l.s,this.model.v=l.v,this.__update(n,e),!0!==e){var c=t.target.selectionEnd;this.$nextTick((function(){t.target.setSelectionRange(c,c)}))}},__onPalettePick:function(t){var e=this.__parseModel(t),n={r:e.r,g:e.g,b:e.b,a:e.a};void 0===n.a&&(n.a=this.model.a),this.model.h=e.h,this.model.s=e.s,this.model.v=e.v,this.__update(n,!0)},__update:function(t,e){this.model.hex=$(t),this.model.rgb=j(t),this.model.r=t.r,this.model.g=t.g,this.model.b=t.b,this.model.a=t.a;var n=this.model[!0===this.isOutputHex?"hex":"rgb"];this.$emit("input",n),!0===e&&this.$emit("change",n)},__updateErrorIcon:function(t){void 0!==this.$refs.errorIcon&&(this.$refs.errorIcon.$el.style.opacity=t?1:0)},__parseModel:function(t){var e=void 0!==this.forceAlpha?this.forceAlpha:"auto"===this.formatModel?null:this.formatModel.indexOf("a")>-1;if("string"!=typeof t||0===t.length||!0!==Hn.anyColor(t.replace(/ /g,"")))return{h:0,s:0,v:0,r:0,g:0,b:0,a:!0===e?100:void 0,hex:void 0,rgb:void 0};var n=W(t);return!0===e&&void 0===n.a&&(n.a=100),n.hex=$(n),n.rgb=j(n),Object.assign(n,H(n))},__spectrumPan:function(t){t.isFinal?this.__onSpectrumChange(t.position.left,t.position.top,!0):this.__spectrumChange(t)},__spectrumChange:function(t){this.__onSpectrumChange(t.position.left,t.position.top)},__spectrumClick:function(t){this.__onSpectrumChange(t.pageX-window.pageXOffset,t.pageY-window.pageYOffset,!0)},__activate:function(t){this.__onSpectrumChange(t.pageX-window.pageXOffset,t.pageY-window.pageYOffset)}}}),mi=[-61,9,38,199,426,686,756,818,1111,1181,1210,1635,2060,2097,2192,2262,2324,2394,2456,3178];function vi(t,e,n){return"[object Date]"===Object.prototype.toString.call(t)&&(n=t.getDate(),e=t.getMonth()+1,t=t.getFullYear()),function(t){var e,n,i,r=ki(t).gy,o=r-621,a=bi(o,!1),s=wi(r,3,a.march);if((i=t-s)>=0){if(i<=185)return{jy:o,jm:n=1+xi(i,31),jd:e=Ci(i,31)+1};i-=186}else o-=1,i+=179,1===a.leap&&(i+=1);return n=7+xi(i,30),e=Ci(i,30)+1,{jy:o,jm:n,jd:e}}(wi(t,e,n))}function gi(t,e,n){return ki(function(t,e,n){var i=bi(t,!0);return wi(i.gy,3,i.march)+31*(e-1)-xi(e,7)*(e-7)+n-1}(t,e,n))}function yi(t){return 0===function(t){var e,n,i,r,o,a=mi.length,s=mi[0];if(t<s||t>=mi[a-1])throw new Error("Invalid Jalaali year "+t);for(o=1;o<a&&(n=(e=mi[o])-s,!(t<e));o+=1)s=e;r=t-s,n-r<6&&(r=r-n+33*xi(n+4,33));-1===(i=Ci(Ci(r+1,33)-1,4))&&(i=4);return i}(t)}function _i(t,e){return e<=6?31:e<=11||yi(t)?30:29}function bi(t,e){var n,i,r,o,a,s=mi.length,l=t+621,c=-14,u=mi[0];if(t<u||t>=mi[s-1])throw new Error("Invalid Jalaali year "+t);for(a=1;a<s&&(i=(n=mi[a])-u,!(t<n));a+=1)c=c+8*xi(i,33)+xi(Ci(i,33),4),u=n;c=c+8*xi(o=t-u,33)+xi(Ci(o,33)+3,4),4===Ci(i,33)&&i-o==4&&(c+=1);var d=20+c-(xi(l,4)-xi(3*(xi(l,100)+1),4)-150);return e||(i-o<6&&(o=o-i+33*xi(i+4,33)),-1===(r=Ci(Ci(o+1,33)-1,4))&&(r=4)),{leap:r,gy:l,march:d}}function wi(t,e,n){var i=xi(1461*(t+xi(e-8,6)+100100),4)+xi(153*Ci(e+9,12)+2,5)+n-34840408;return i=i-xi(3*xi(t+100100+xi(e-8,6),100),4)+752}function ki(t){var e=4*t+139361631;e=e+4*xi(3*xi(4*t+183187720,146097),4)-3908;var n=5*xi(Ci(e,1461),4)+308,i=xi(Ci(n,153),5)+1,r=Ci(xi(n,153),12)+1;return{gy:xi(e,1461)-100100+xi(8-r,6),gm:r,gd:i}}function xi(t,e){return~~(t/e)}function Ci(t,e){return t-~~(t/e)*e}var Si=["gregorian","persian"],Mi={mixins:[It,ln,Ot],props:{value:{required:!0},mask:{type:String},locale:Object,calendar:{type:String,validator:function(t){return Si.includes(t)},default:"gregorian"},landscape:Boolean,color:String,textColor:String,square:Boolean,flat:Boolean,bordered:Boolean,readonly:Boolean,disable:Boolean},computed:{computedMask:function(){return this.__getMask()},computedLocale:function(){return this.__getLocale()},editable:function(){return!0!==this.disable&&!0!==this.readonly},computedColor:function(){return this.color||"primary"},computedTextColor:function(){return this.textColor||"white"},computedTabindex:function(){return!0===this.editable?0:-1},headerClass:function(){var t=[];return void 0!==this.color&&t.push("bg-"+this.color),void 0!==this.textColor&&t.push("text-"+this.textColor),t.join(" ")}},methods:{__getLocale:function(){return this.locale||this.$q.lang.date},__getCurrentDate:function(){var t=new Date;if("persian"===this.calendar){var e=vi(t);return{year:e.jy,month:e.jm,day:e.jd}}return{year:t.getFullYear(),month:t.getMonth()+1,day:t.getDate(),hour:0,minute:0,second:0,millisecond:0}},__getCurrentTime:function(){var t=new Date;return{hour:t.getHours(),minute:t.getMinutes(),second:t.getSeconds(),millisecond:t.getMilliseconds()}}}},Ti=864e5,Pi=36e5,Oi=6e4,Bi="YYYY-MM-DDTHH:mm:ss.SSSZ",Ei=/\[((?:[^\]\\]|\\]|\\)*)\]|d{1,4}|M{1,4}|m{1,2}|w{1,2}|Qo|Do|D{1,4}|YY(?:YY)?|H{1,2}|h{1,2}|s{1,2}|S{1,3}|Z{1,2}|a{1,2}|[AQExX]/g,Ai=/(\[[^\]]*\])|d{1,4}|M{1,4}|m{1,2}|w{1,2}|Qo|Do|D{1,4}|YY(?:YY)?|H{1,2}|h{1,2}|s{1,2}|S{1,3}|Z{1,2}|a{1,2}|[AQExX]|([.*+:?^,\s${}()|\\]+)/g,Di={};function Li(t,e,n,i,r){var o={year:null,month:null,day:null,hour:null,minute:null,second:null,millisecond:null,timezoneOffset:null,dateHash:null,timeHash:null};if(void 0!==r&&Object.assign(o,r),null==t||""===t||"string"!=typeof t)return o;void 0===e&&(e=Bi);var a=void 0!==n?n:N.props.date,s=a.months,l=a.monthsShort,c=function(t,e){var n="("+e.days.join("|")+")",i=t+n;if(void 0!==Di[i])return Di[i];var r="("+e.daysShort.join("|")+")",o="("+e.months.join("|")+")",a="("+e.monthsShort.join("|")+")",s={},l=0,c=t.replace(Ai,(function(t){switch(l++,t){case"YY":return s.YY=l,"(-?\\d{1,2})";case"YYYY":return s.YYYY=l,"(-?\\d{1,4})";case"M":return s.M=l,"(\\d{1,2})";case"MM":return s.M=l,"(\\d{2})";case"MMM":return s.MMM=l,a;case"MMMM":return s.MMMM=l,o;case"D":return s.D=l,"(\\d{1,2})";case"Do":return s.D=l++,"(\\d{1,2}(st|nd|rd|th))";case"DD":return s.D=l,"(\\d{2})";case"H":return s.H=l,"(\\d{1,2})";case"HH":return s.H=l,"(\\d{2})";case"h":return s.h=l,"(\\d{1,2})";case"hh":return s.h=l,"(\\d{2})";case"m":return s.m=l,"(\\d{1,2})";case"mm":return s.m=l,"(\\d{2})";case"s":return s.s=l,"(\\d{1,2})";case"ss":return s.s=l,"(\\d{2})";case"S":return s.S=l,"(\\d{1})";case"SS":return s.S=l,"(\\d{2})";case"SSS":return s.S=l,"(\\d{3})";case"A":return s.A=l,"(AM|PM)";case"a":return s.a=l,"(am|pm)";case"aa":return s.aa=l,"(a\\.m\\.|p\\.m\\.)";case"ddd":return r;case"dddd":return n;case"Q":case"d":case"E":return"(\\d{1})";case"Qo":return"(1st|2nd|3rd|4th)";case"DDD":case"DDDD":return"(\\d{1,3})";case"w":return"(\\d{1,2})";case"ww":return"(\\d{2})";case"Z":return s.Z=l,"(Z|[+-]\\d{2}:\\d{2})";case"ZZ":return s.ZZ=l,"(Z|[+-]\\d{2}\\d{2})";case"X":return s.X=l,"(-?\\d+)";case"x":return s.x=l,"(-?\\d{4,})";default:return l--,"["===t[0]&&(t=t.substring(1,t.length-1)),t.replace(/[.*+?^${}()|[\]\\]/g,"\\$&")}})),u={map:s,regex:new RegExp("^"+c)};return Di[i]=u,u}(e,a),u=c.regex,d=c.map,h=t.match(u);if(null===h)return o;var f="";if(void 0!==d.X||void 0!==d.x){var p=parseInt(h[void 0!==d.X?d.X:d.x],10);if(!0===isNaN(p)||p<0)return o;var m=new Date(p*(void 0!==d.X?1e3:1));o.year=m.getFullYear(),o.month=m.getMonth()+1,o.day=m.getDate(),o.hour=m.getHours(),o.minute=m.getMinutes(),o.second=m.getSeconds(),o.millisecond=m.getMilliseconds()}else{if(void 0!==d.YYYY)o.year=parseInt(h[d.YYYY],10);else if(void 0!==d.YY){var v=parseInt(h[d.YY],10);o.year=v<0?v:2e3+v}if(void 0!==d.M){if(o.month=parseInt(h[d.M],10),o.month<1||o.month>12)return o}else void 0!==d.MMM?o.month=l.indexOf(h[d.MMM])+1:void 0!==d.MMMM&&(o.month=s.indexOf(h[d.MMMM])+1);if(void 0!==d.D){if(o.day=parseInt(h[d.D],10),null===o.year||null===o.month||o.day<1)return o;var g="persian"!==i?new Date(o.year,o.month,0).getDate():_i(o.year,o.month);if(o.day>g)return o}void 0!==d.H?o.hour=parseInt(h[d.H],10)%24:void 0!==d.h&&(o.hour=parseInt(h[d.h],10)%12,(d.A&&"PM"===h[d.A]||d.a&&"pm"===h[d.a]||d.aa&&"p.m."===h[d.aa])&&(o.hour+=12),o.hour=o.hour%24),void 0!==d.m&&(o.minute=parseInt(h[d.m],10)%60),void 0!==d.s&&(o.second=parseInt(h[d.s],10)%60),void 0!==d.S&&(o.millisecond=parseInt(h[d.S],10)*Math.pow(10,3-h[d.S].length)),void 0===d.Z&&void 0===d.ZZ||(f=void 0!==d.Z?h[d.Z].replace(":",""):h[d.ZZ],o.timezoneOffset=("+"===f[0]?-1:1)*(60*f.slice(1,3)+1*f.slice(3,5)))}return o.dateHash=o.year+"/"+ht(o.month)+"/"+ht(o.day),o.timeHash=ht(o.hour)+":"+ht(o.minute)+":"+ht(o.second)+f,o}function qi(t,e){void 0===e&&(e="");var n=t>0?"-":"+",i=Math.abs(t),r=i%60;return n+ht(Math.floor(i/60))+e+ht(r)}function Ri(t,e){var n=new Date(t.getFullYear(),e,0,0,0,0,0).getDate();t.setMonth(e-1,Math.min(n,t.getDate()))}function Ii(t,e,n){var i=new Date(t),r=n?1:-1;return Object.keys(e).forEach((function(t){if("month"!==t){var n="year"===t?"FullYear":ct("days"===t?"date":t);i["set"+n](i["get"+n]()+r*e[t])}else Ri(i,i.getMonth()+1+r*e.month)})),i}function Ni(t){var e=new Date(t.getFullYear(),t.getMonth(),t.getDate());e.setDate(e.getDate()-(e.getDay()+6)%7+3);var n=new Date(e.getFullYear(),0,4);n.setDate(n.getDate()-(n.getDay()+6)%7+3);var i=e.getTimezoneOffset()-n.getTimezoneOffset();e.setHours(e.getHours()-i);var r=(e-n)/(7*Ti);return 1+Math.floor(r)}function Fi(t,e){var n=new Date(t);return!0===e?function(t){return 1e4*t.getFullYear()+100*t.getMonth()+t.getDate()}(n):n.getTime()}function $i(t,e,n){var i=new Date(t),r="set"+(n?"UTC":"");return Object.keys(e).forEach((function(t){if("month"!==t){var n="year"===t?"FullYear":t.charAt(0).toUpperCase()+t.slice(1);i[""+r+n](e[t])}else Ri(i,e.month)})),i}function ji(t,e){var n=new Date(t);switch(e){case"year":n.setMonth(0);case"month":n.setDate(1);case"day":n.setHours(0);case"hour":n.setMinutes(0);case"minute":n.setSeconds(0);case"second":n.setMilliseconds(0)}return n}function zi(t,e,n){return(t.getTime()-t.getTimezoneOffset()*Oi-(e.getTime()-e.getTimezoneOffset()*Oi))/n}function Vi(t,e,n){void 0===n&&(n="days");var i=new Date(t),r=new Date(e);switch(n){case"years":return i.getFullYear()-r.getFullYear();case"months":return 12*(i.getFullYear()-r.getFullYear())+i.getMonth()-r.getMonth();case"days":return zi(ji(i,"day"),ji(r,"day"),Ti);case"hours":return zi(ji(i,"hour"),ji(r,"hour"),Pi);case"minutes":return zi(ji(i,"minute"),ji(r,"minute"),Oi);case"seconds":return zi(ji(i,"second"),ji(r,"second"),1e3)}}function Hi(t){return Vi(t,ji(t,"year"),"days")+1}function Wi(t){return new Date(t.getFullYear(),t.getMonth()+1,0).getDate()}function Ui(t){if(t>=11&&t<=13)return t+"th";switch(t%10){case 1:return t+"st";case 2:return t+"nd";case 3:return t+"rd"}return t+"th"}var Yi={YY:function(t,e,n){var i=this.YYYY(t,e,n)%100;return i>0?ht(i):"-"+ht(Math.abs(i))},YYYY:function(t,e,n){return null!=n?n:t.getFullYear()},M:function(t){return t.getMonth()+1},MM:function(t){return ht(t.getMonth()+1)},MMM:function(t,e){return e.monthsShort[t.getMonth()]},MMMM:function(t,e){return e.months[t.getMonth()]},Q:function(t){return Math.ceil((t.getMonth()+1)/3)},Qo:function(t){return Ui(this.Q(t))},D:function(t){return t.getDate()},Do:function(t){return Ui(t.getDate())},DD:function(t){return ht(t.getDate())},DDD:function(t){return Hi(t)},DDDD:function(t){return ht(Hi(t),3)},d:function(t){return t.getDay()},dd:function(t,e){return this.dddd(t,e).slice(0,2)},ddd:function(t,e){return e.daysShort[t.getDay()]},dddd:function(t,e){return e.days[t.getDay()]},E:function(t){return t.getDay()||7},w:function(t){return Ni(t)},ww:function(t){return ht(Ni(t))},H:function(t){return t.getHours()},HH:function(t){return ht(t.getHours())},h:function(t){var e=t.getHours();return 0===e?12:e>12?e%12:e},hh:function(t){return ht(this.h(t))},m:function(t){return t.getMinutes()},mm:function(t){return ht(t.getMinutes())},s:function(t){return t.getSeconds()},ss:function(t){return ht(t.getSeconds())},S:function(t){return Math.floor(t.getMilliseconds()/100)},SS:function(t){return ht(Math.floor(t.getMilliseconds()/10))},SSS:function(t){return ht(t.getMilliseconds(),3)},A:function(t){return this.H(t)<12?"AM":"PM"},a:function(t){return this.H(t)<12?"am":"pm"},aa:function(t){return this.H(t)<12?"a.m.":"p.m."},Z:function(t,e,n,i){return qi(null==i?t.getTimezoneOffset():i,":")},ZZ:function(t,e,n,i){return qi(null==i?t.getTimezoneOffset():i)},X:function(t){return Math.floor(t.getTime()/1e3)},x:function(t){return t.getTime()}};function Qi(t,e,n,i,r){if((0===t||t)&&t!==1/0&&t!==-1/0){var o=new Date(t);if(!isNaN(o)){void 0===e&&(e=Bi);var a=void 0!==n?n:N.props.date;return e.replace(Ei,(function(t,e){return t in Yi?Yi[t](o,a,i,r):void 0===e?t:e.split("\\]").join("]")}))}}}var Gi,Ki,Ji,Zi,Xi,tr,er={isValid:function(t){return"number"==typeof t||!1===isNaN(Date.parse(t))},extractDate:function(t,e,n){var i=Li(t,e,n),r=new Date(i.year,null===i.month?null:i.month-1,i.day,i.hour,i.minute,i.second,i.millisecond),o=r.getTimezoneOffset();return null===i.timezoneOffset||i.timezoneOffset===o?r:Ii(r,{minutes:i.timezoneOffset-o},!0)},buildDate:function(t,e){return $i(new Date,t,e)},getDayOfWeek:function(t){var e=new Date(t).getDay();return 0===e?7:e},getWeekOfYear:Ni,isBetweenDates:function(t,e,n,i){void 0===i&&(i={});var r=Fi(e,i.onlyDate),o=Fi(n,i.onlyDate),a=Fi(t,i.onlyDate);return(a>r||!0===i.inclusiveFrom&&a===r)&&(a<o||!0===i.inclusiveTo&&a===o)},addToDate:function(t,e){return Ii(t,e,!0)},subtractFromDate:function(t,e){return Ii(t,e,!1)},adjustDate:$i,startOfDate:ji,endOfDate:function(t,e){var n=new Date(t);switch(e){case"year":n.setMonth(11);case"month":n.setDate(Wi(n));case"day":n.setHours(23);case"hour":n.setMinutes(59);case"minute":n.setSeconds(59);case"second":n.setMilliseconds(59)}return n},getMaxDate:function(t){var e=new Date(t);return Array.prototype.slice.call(arguments,1).forEach((function(t){e=Math.max(e,new Date(t))})),e},getMinDate:function(t){var e=new Date(t);return Array.prototype.slice.call(arguments,1).forEach((function(t){e=Math.min(e,new Date(t))})),e},getDateDiff:Vi,getDayOfYear:Hi,inferDateFormat:function(t){return!0===Sn(t)?"date":"number"==typeof t?"number":"string"},getDateBetween:function(t,e,n){var i=new Date(t);if(e){var r=new Date(e);if(i<r)return r}if(n){var o=new Date(n);if(i>o)return o}return i},isSameDate:function(t,e,n){var i=new Date(t),r=new Date(e);if(void 0===n)return i.getTime()===r.getTime();switch(n){case"second":if(i.getSeconds()!==r.getSeconds())return!1;case"minute":if(i.getMinutes()!==r.getMinutes())return!1;case"hour":if(i.getHours()!==r.getHours())return!1;case"day":if(i.getDate()!==r.getDate())return!1;case"month":if(i.getMonth()!==r.getMonth())return!1;case"year":if(i.getFullYear()!==r.getFullYear())return!1;break;default:throw new Error("date isSameDate unknown unit "+n)}return!0},daysInMonth:Wi,formatDate:Qi,clone:function(t){return!0===Sn(t)?new Date(t.getTime()):t}},nr=20,ir=["Calendar","Years","Months"],rr=function(t){return ir.includes(t)},or=function(t){return/^-?[\d]+\/[0-1]\d$/.test(t)},ar=" — ",sr=t.extend({name:"QDate",mixins:[Mi],props:{multiple:Boolean,range:Boolean,title:String,subtitle:String,mask:{default:"YYYY/MM/DD"},defaultYearMonth:{type:String,validator:or},yearsInMonthView:Boolean,events:[Array,Function],eventColor:[String,Function],emitImmediately:Boolean,options:[Array,Function],navigationMinYearMonth:{type:String,validator:or},navigationMaxYearMonth:{type:String,validator:or},noUnset:Boolean,firstDayOfWeek:[String,Number],todayBtn:Boolean,minimal:Boolean,defaultView:{type:String,default:"Calendar",validator:rr}},data:function(){var t=this.__getMask(),e=this.__getLocale(),n=this.__getViewModel(t,e),i=n.year,r=!0===this.$q.lang.rtl?"right":"left";return{view:this.defaultView,monthDirection:r,yearDirection:r,startYear:i-i%nr-(i<0?nr:0),editRange:void 0,innerMask:t,innerLocale:e,viewModel:n}},watch:{value:function(t){if(this.lastEmitValue===t)this.lastEmitValue=0;else{var e=this.__getViewModel(this.innerMask,this.innerLocale),n=e.year,i=e.month;this.__updateViewModel(n,i)}},view:function(){void 0!==this.$refs.blurTarget&&this.$refs.blurTarget.focus()},"viewModel.year":function(t){this.$emit("navigation",{year:t,month:this.viewModel.month})},"viewModel.month":function(t){this.$emit("navigation",{year:this.viewModel.year,month:t})},computedMask:function(t){this.__updateValue(t,this.innerLocale,"mask"),this.innerMask=t},computedLocale:function(t){this.__updateValue(this.innerMask,t,"locale"),this.innerLocale=t}},computed:{classes:function(){var t=!0===this.landscape?"landscape":"portrait";return"q-date q-date--"+t+" q-date--"+t+"-"+(!0===this.minimal?"minimal":"standard")+(!0===this.isDark?" q-date--dark q-dark":"")+(!0===this.bordered?" q-date--bordered":"")+(!0===this.square?" q-date--square no-border-radius":"")+(!0===this.flat?" q-date--flat no-shadow":"")+(!0===this.disable?" disabled":!0===this.readonly?" q-date--readonly":"")},isImmediate:function(){return!0===this.emitImmediately&&void 0!==this.daysModel[0]&&null!==this.daysModel[0].dateHash},normalizedModel:function(){return!0===Array.isArray(this.value)?this.value:null!==this.value&&void 0!==this.value?[this.value]:[]},daysModel:function(){var t=this;return this.normalizedModel.filter((function(t){return"string"==typeof t})).map((function(e){return t.__decodeString(e,t.innerMask,t.innerLocale)})).filter((function(t){return null!==t.dateHash}))},rangeModel:function(){var t=this,e=function(e){return t.__decodeString(e,t.innerMask,t.innerLocale)};return this.normalizedModel.filter((function(t){return Object(t)===t&&void 0!==t.from&&void 0!==t.to})).map((function(t){return{from:e(t.from),to:e(t.to)}})).filter((function(t){return null!==t.from.dateHash&&null!==t.to.dateHash&&t.from.dateHash<t.to.dateHash}))},getNativeDateFn:function(){return"persian"!==this.calendar?function(t){return new Date(t.year,t.month-1,t.day)}:function(t){var e=gi(t.year,t.month,t.day);return new Date(e.gy,e.gm-1,e.gd)}},encodeObjectFn:function(){var t=this;return"persian"===this.calendar?this.__getDayHash:function(e,n,i){return Qi(new Date(e.year,e.month-1,e.day,e.hour,e.minute,e.second,e.millisecond),void 0===n?t.innerMask:n,void 0===i?t.innerLocale:i,e.year,e.timezoneOffset)}},daysInModel:function(){var t=this;return this.daysModel.length+this.rangeModel.reduce((function(e,n){return e+1+Vi(t.getNativeDateFn(n.to),t.getNativeDateFn(n.from))}),0)},headerTitle:function(){if(void 0!==this.title&&null!==this.title&&this.title.length>0)return this.title;if(void 0!==this.editRange){var t=this.editRange.init,e=this.getNativeDateFn(t);return this.innerLocale.daysShort[e.getDay()]+", "+this.innerLocale.monthsShort[t.month-1]+" "+t.day+ar+"?"}if(0===this.daysInModel)return ar;if(this.daysInModel>1)return this.daysInModel+" "+this.innerLocale.pluralDay;var n=this.daysModel[0],i=this.getNativeDateFn(n);return!0===isNaN(i.valueOf())?ar:void 0!==this.innerLocale.headerTitle?this.innerLocale.headerTitle(i,n):this.innerLocale.daysShort[i.getDay()]+", "+this.innerLocale.monthsShort[n.month-1]+" "+n.day},headerSubtitle:function(){if(void 0!==this.subtitle&&null!==this.subtitle&&this.subtitle.length>0)return this.subtitle;if(0===this.daysInModel)return ar;if(this.daysInModel>1){var t=this.minSelectedModel,e=this.maxSelectedModel,n=this.innerLocale.monthsShort;return n[t.month-1]+(t.year!==e.year?" "+t.year+ar+n[e.month-1]+" ":t.month!==e.month?ar+n[e.month-1]:"")+" "+e.year}return this.daysModel[0].year},minSelectedModel:function(){return this.daysModel.concat(this.rangeModel.map((function(t){return t.from}))).sort((function(t,e){return t.year-e.year||t.month-e.month}))[0]},maxSelectedModel:function(){return this.daysModel.concat(this.rangeModel.map((function(t){return t.to}))).sort((function(t,e){return e.year-t.year||e.month-t.month}))[0]},dateArrow:function(){var t=[this.$q.iconSet.datetime.arrowLeft,this.$q.iconSet.datetime.arrowRight];return!0===this.$q.lang.rtl?t.reverse():t},computedFirstDayOfWeek:function(){return void 0!==this.firstDayOfWeek?Number(this.firstDayOfWeek):this.innerLocale.firstDayOfWeek},daysOfWeek:function(){var t=this.innerLocale.daysShort,e=this.computedFirstDayOfWeek;return e>0?t.slice(e,7).concat(t.slice(0,e)):t},daysInMonth:function(){var t=this.viewModel;return"persian"!==this.calendar?new Date(t.year,t.month,0).getDate():_i(t.year,t.month)},today:function(){return this.__getCurrentDate()},evtColor:function(){var t=this;return"function"==typeof this.eventColor?this.eventColor:function(){return t.eventColor}},minNav:function(){if(void 0!==this.navigationMinYearMonth){var t=this.navigationMinYearMonth.split("/");return{year:parseInt(t[0],10),month:parseInt(t[1],10)}}},maxNav:function(){if(void 0!==this.navigationMaxYearMonth){var t=this.navigationMaxYearMonth.split("/");return{year:parseInt(t[0],10),month:parseInt(t[1],10)}}},navBoundaries:function(){var t={month:{prev:!0,next:!0},year:{prev:!0,next:!0}};return void 0!==this.minNav&&this.minNav.year>=this.viewModel.year&&(t.year.prev=!1,this.minNav.year===this.viewModel.year&&this.minNav.month>=this.viewModel.month&&(t.month.prev=!1)),void 0!==this.maxNav&&this.maxNav.year<=this.viewModel.year&&(t.year.next=!1,this.maxNav.year===this.viewModel.year&&this.maxNav.month<=this.viewModel.month&&(t.month.next=!1)),t},daysMap:function(){var t=this,e={};return this.daysModel.forEach((function(n){var i=t.__getMonthHash(n);void 0===e[i]&&(e[i]=[]),e[i].push(n.day)})),e},rangeMap:function(){var t=this,e={};return this.rangeModel.forEach((function(n){var i=t.__getMonthHash(n.from),r=t.__getMonthHash(n.to);if(void 0===e[i]&&(e[i]=[]),e[i].push({from:n.from.day,to:i===r?n.to.day:void 0,range:n}),i<r)for(var o,a=n.from,s=a.year,l=a.month,c=l<12?{year:s,month:l+1}:{year:s+1,month:1};(o=t.__getMonthHash(c))<=r;)void 0===e[o]&&(e[o]=[]),e[o].push({from:void 0,to:o===r?n.to.day:void 0,range:n}),c.month++,c.month>12&&(c.year++,c.month=1)})),e},rangeView:function(){if(void 0!==this.editRange){var t=this.editRange,e=t.init,n=t.initHash,i=t.final,r=n<=t.finalHash?[e,i]:[i,e],o=r[0],a=r[1],s=this.__getMonthHash(o),l=this.__getMonthHash(a);if(s===this.viewMonthHash||l===this.viewMonthHash){var c={};return s===this.viewMonthHash?(c.from=o.day,c.includeFrom=!0):c.from=1,l===this.viewMonthHash?(c.to=a.day,c.includeTo=!0):c.to=this.daysInMonth,c}}},viewMonthHash:function(){return this.__getMonthHash(this.viewModel)},selectionDaysMap:function(){var t=this,e={};if(void 0===this.options){for(var n=1;n<=this.daysInMonth;n++)e[n]=!0;return e}for(var i="function"==typeof this.options?this.options:function(e){return t.options.includes(e)},r=1;r<=this.daysInMonth;r++){var o=this.viewMonthHash+"/"+ht(r);e[r]=i(o)}return e},eventDaysMap:function(){var t=this,e={};if(void 0===this.events)for(var n=1;n<=this.daysInMonth;n++)e[n]=!1;else for(var i="function"==typeof this.events?this.events:function(e){return t.events.includes(e)},r=1;r<=this.daysInMonth;r++){var o=this.viewMonthHash+"/"+ht(r);e[r]=!0===i(o)&&this.evtColor(o)}return e},viewDays:function(){var t,e,n=this.viewModel,i=n.year,r=n.month;if("persian"!==this.calendar)t=new Date(i,r-1,1),e=new Date(i,r-1,0).getDate();else{var o=gi(i,r,1);t=new Date(o.gy,o.gm-1,o.gd);var a=r-1,s=i;0===a&&(a=12,s--),e=_i(s,a)}return{days:t.getDay()-this.computedFirstDayOfWeek-1,endDay:e}},days:function(){var t=this,e=[],n=this.viewDays,i=n.days,r=n.endDay,o=i<0?i+7:i;if(o<6)for(var a=r-o;a<=r;a++)e.push({i:a,fill:!0});for(var s=e.length,l=1;l<=this.daysInMonth;l++){var c={i:l,event:this.eventDaysMap[l],classes:[]};!0===this.selectionDaysMap[l]&&(c.in=!0,c.flat=!0),e.push(c)}if(void 0!==this.daysMap[this.viewMonthHash]&&this.daysMap[this.viewMonthHash].forEach((function(n){var i=s+n-1;Object.assign(e[i],{selected:!0,unelevated:!0,flat:!1,color:t.computedColor,textColor:t.computedTextColor})})),void 0!==this.rangeMap[this.viewMonthHash]&&this.rangeMap[this.viewMonthHash].forEach((function(n){if(void 0!==n.from){for(var i=s+n.from-1,r=s+(n.to||t.daysInMonth)-1,o=i;o<=r;o++)Object.assign(e[o],{range:n.range,unelevated:!0,color:t.computedColor,textColor:t.computedTextColor});Object.assign(e[i],{rangeFrom:!0,flat:!1}),void 0!==n.to&&Object.assign(e[r],{rangeTo:!0,flat:!1})}else if(void 0!==n.to){for(var a=s+n.to-1,l=s;l<=a;l++)Object.assign(e[l],{range:n.range,unelevated:!0,color:t.computedColor,textColor:t.computedTextColor});Object.assign(e[a],{flat:!1,rangeTo:!0})}else for(var c=s+t.daysInMonth-1,u=s;u<=c;u++)Object.assign(e[u],{range:n.range,unelevated:!0,color:t.computedColor,textColor:t.computedTextColor})})),void 0!==this.rangeView){for(var u=s+this.rangeView.from-1,d=s+this.rangeView.to-1,h=u;h<=d;h++)e[h].color=this.computedColor,e[h].editRange=!0;!0===this.rangeView.includeFrom&&(e[u].editRangeFrom=!0),!0===this.rangeView.includeTo&&(e[d].editRangeTo=!0)}this.viewModel.year===this.today.year&&this.viewModel.month===this.today.month&&(e[s+this.today.day-1].today=!0);var f=e.length%7;if(f>0)for(var p=7-f,m=1;m<=p;m++)e.push({i:m,fill:!0});return e.forEach((function(t){var e="q-date__calendar-item ";!0===t.fill?e+="q-date__calendar-item--fill":(e+="q-date__calendar-item--"+(!0===t.in?"in":"out"),void 0!==t.range&&(e+=" q-date__range"+(!0===t.rangeTo?"-to":!0===t.rangeFrom?"-from":"")),!0===t.editRange&&(e+=" q-date__edit-range"+(!0===t.editRangeFrom?"-from":"")+(!0===t.editRangeTo?"-to":"")),void 0===t.range&&!0!==t.editRange||(e+=" text-"+t.color)),t.classes=e})),e},attrs:function(){return!0===this.disable?{"aria-disabled":"true"}:!0===this.readonly?{"aria-readonly":"true"}:void 0}},methods:{setToday:function(){this.__toggleDate(this.today,this.__getMonthHash(this.today)),this.setCalendarTo(this.today.year,this.today.month)},setView:function(t){!0===rr(t)&&(this.view=t)},offsetCalendar:function(t,e){["month","year"].includes(t)&&this["__goTo"+("month"===t?"Month":"Year")](!0===e?-1:1)},setCalendarTo:function(t,e){this.view="Calendar",this.__updateViewModel(t,e)},setEditingRange:function(t,e){if(!1!==this.range&&t){var n=Object.assign(Object.assign({},this.viewModel),t),i=void 0!==e?Object.assign(Object.assign({},this.viewModel),e):n;this.editRange={init:n,initHash:this.__getDayHash(n),final:i,finalHash:this.__getDayHash(i)},this.setCalendarTo(n.year,n.month)}else this.editRange=void 0},__getMask:function(){return"persian"===this.calendar?"YYYY/MM/DD":this.mask},__decodeString:function(t,e,n){return Li(t,e,n,this.calendar,{hour:0,minute:0,second:0,millisecond:0})},__getViewModel:function(t,e){var n=!0===Array.isArray(this.value)?this.value:this.value?[this.value]:[];if(0===n.length)return this.__getDefaultViewModel();var i=this.__decodeString(void 0!==n[0].from?n[0].from:n[0],t,e);return null===i.dateHash?this.__getDefaultViewModel():i},__getDefaultViewModel:function(){var t,e;if(void 0!==this.defaultYearMonth){var n=this.defaultYearMonth.split("/");t=parseInt(n[0],10),e=parseInt(n[1],10)}else{var i=void 0!==this.today?this.today:this.__getCurrentDate();t=i.year,e=i.month}return{year:t,month:e,day:1,hour:0,minute:0,second:0,millisecond:0,dateHash:t+"/"+ht(e)+"/01"}},__getHeader:function(t){var e=this;if(!0!==this.minimal)return t("div",{staticClass:"q-date__header",class:this.headerClass},[t("div",{staticClass:"relative-position"},[t("transition",{props:{name:"q-transition--fade"}},[t("div",{key:"h-yr-"+this.headerSubtitle,staticClass:"q-date__header-subtitle q-date__header-link",class:"Years"===this.view?"q-date__header-link--active":"cursor-pointer",attrs:{tabindex:this.computedTabindex},on:pt(this,"vY",{click:function(){e.view="Years"},keyup:function(t){13===t.keyCode&&(e.view="Years")}})},[this.headerSubtitle])])]),t("div",{staticClass:"q-date__header-title relative-position flex no-wrap"},[t("div",{staticClass:"relative-position col"},[t("transition",{props:{name:"q-transition--fade"}},[t("div",{key:"h-sub"+this.headerTitle,staticClass:"q-date__header-title-label q-date__header-link",class:"Calendar"===this.view?"q-date__header-link--active":"cursor-pointer",attrs:{tabindex:this.computedTabindex},on:pt(this,"vC",{click:function(){e.view="Calendar"},keyup:function(t){13===t.keyCode&&(e.view="Calendar")}})},[this.headerTitle])])]),!0===this.todayBtn?t(_e,{staticClass:"q-date__header-today self-start",props:{icon:this.$q.iconSet.datetime.today,flat:!0,size:"sm",round:!0,tabindex:this.computedTabindex},on:pt(this,"today",{click:this.setToday})}):null])])},__getNavigation:function(t,e){var n=this,i=e.label,r=e.view,o=e.key,a=e.dir,s=e.goTo,l=e.boundaries,c=e.cls;return[t("div",{staticClass:"row items-center q-date__arrow"},[t(_e,{props:{round:!0,dense:!0,size:"sm",flat:!0,icon:this.dateArrow[0],tabindex:this.computedTabindex,disable:!1===l.prev},on:pt(this,"go-#"+r,{click:function(){s(-1)}})})]),t("div",{staticClass:"relative-position overflow-hidden flex flex-center"+c},[t("transition",{props:{name:"q-transition--jump-"+a}},[t("div",{key:o},[t(_e,{props:{flat:!0,dense:!0,noCaps:!0,label:i,tabindex:this.computedTabindex},on:pt(this,"view#"+r,{click:function(){n.view=r}})})])])]),t("div",{staticClass:"row items-center q-date__arrow"},[t(_e,{props:{round:!0,dense:!0,size:"sm",flat:!0,icon:this.dateArrow[1],tabindex:this.computedTabindex,disable:!1===l.next},on:pt(this,"go+#"+r,{click:function(){s(1)}})})])]},__getCalendarView:function(t){var e=this;return[t("div",{key:"calendar-view",staticClass:"q-date__view q-date__calendar"},[t("div",{staticClass:"q-date__navigation row items-center no-wrap"},this.__getNavigation(t,{label:this.innerLocale.months[this.viewModel.month-1],view:"Months",key:this.viewModel.month,dir:this.monthDirection,goTo:this.__goToMonth,boundaries:this.navBoundaries.month,cls:" col"}).concat(this.__getNavigation(t,{label:this.viewModel.year,view:"Years",key:this.viewModel.year,dir:this.yearDirection,goTo:this.__goToYear,boundaries:this.navBoundaries.year,cls:""}))),t("div",{staticClass:"q-date__calendar-weekdays row items-center no-wrap"},this.daysOfWeek.map((function(e){return t("div",{staticClass:"q-date__calendar-item"},[t("div",[e])])}))),t("div",{staticClass:"q-date__calendar-days-container relative-position overflow-hidden"},[t("transition",{props:{name:"q-transition--slide-"+this.monthDirection}},[t("div",{key:this.viewMonthHash,staticClass:"q-date__calendar-days fit"},this.days.map((function(n){return t("div",{staticClass:n.classes},[!0===n.in?t(_e,{staticClass:!0===n.today?"q-date__today":null,props:{dense:!0,flat:n.flat,unelevated:n.unelevated,color:n.color,textColor:n.textColor,label:n.i,tabindex:e.computedTabindex},on:pt(e,"day#"+n.i,{click:function(){e.__onDayClick(n.i)},mouseover:function(){e.__onDayMouseover(n.i)}})},!1!==n.event?[t("div",{staticClass:"q-date__event bg-"+n.event})]:null):t("div",[n.i])])})))])])])]},__getMonthsView:function(t){var e=this,n=this.viewModel.year===this.today.year,i=function(t){return void 0!==e.minNav&&e.viewModel.year===e.minNav.year&&e.minNav.month>t||void 0!==e.maxNav&&e.viewModel.year===e.maxNav.year&&e.maxNav.month<t},r=this.innerLocale.monthsShort.map((function(r,o){var a=e.viewModel.month===o+1;return t("div",{staticClass:"q-date__months-item flex flex-center"},[t(_e,{staticClass:!0===n&&e.today.month===o+1?"q-date__today":null,props:{flat:!0!==a,label:r,unelevated:a,color:!0===a?e.computedColor:null,textColor:!0===a?e.computedTextColor:null,tabindex:e.computedTabindex,disable:i(o+1)},on:pt(e,"month#"+o,{click:function(){e.__setMonth(o+1)}})})])}));return!0===this.yearsInMonthView&&r.unshift(t("div",{staticClass:"row no-wrap full-width"},[this.__getNavigation(t,{label:this.viewModel.year,view:"Years",key:this.viewModel.year,dir:this.yearDirection,goTo:this.__goToYear,boundaries:this.navBoundaries.year,cls:" col"})])),t("div",{key:"months-view",staticClass:"q-date__view q-date__months flex flex-center"},r)},__getYearsView:function(t){for(var e=this,n=this.startYear,i=n+nr,r=[],o=function(t){return void 0!==e.minNav&&e.minNav.year>t||void 0!==e.maxNav&&e.maxNav.year<t},a=function(n){var i=e.viewModel.year===n;r.push(t("div",{staticClass:"q-date__years-item flex flex-center"},[t(_e,{key:"yr"+n,staticClass:e.today.year===n?"q-date__today":null,props:{flat:!i,label:n,dense:!0,unelevated:i,color:!0===i?e.computedColor:null,textColor:!0===i?e.computedTextColor:null,tabindex:e.computedTabindex,disable:o(n)},on:pt(e,"yr#"+n,{click:function(){e.__setYear(n)}})})]))},s=n;s<=i;s++)a(s);return t("div",{staticClass:"q-date__view q-date__years flex flex-center"},[t("div",{staticClass:"col-auto"},[t(_e,{props:{round:!0,dense:!0,flat:!0,icon:this.dateArrow[0],tabindex:this.computedTabindex,disable:o(n)},on:pt(this,"y-",{click:function(){e.startYear-=nr}})})]),t("div",{staticClass:"q-date__years-content col self-stretch row items-center"},r),t("div",{staticClass:"col-auto"},[t(_e,{props:{round:!0,dense:!0,flat:!0,icon:this.dateArrow[1],tabindex:this.computedTabindex,disable:o(i)},on:pt(this,"y+",{click:function(){e.startYear+=nr}})})])])},__goToMonth:function(t){var e=this.viewModel.year,n=Number(this.viewModel.month)+t;13===n?(n=1,e++):0===n&&(n=12,e--),this.__updateViewModel(e,n),!0===this.isImmediate&&this.__emitImmediately("month")},__goToYear:function(t){var e=Number(this.viewModel.year)+t;this.__updateViewModel(e,this.viewModel.month),!0===this.isImmediate&&this.__emitImmediately("year")},__setYear:function(t){this.__updateViewModel(t,this.viewModel.month),this.view="Years"===this.defaultView?"Months":"Calendar",!0===this.isImmediate&&this.__emitImmediately("year")},__setMonth:function(t){this.__updateViewModel(this.viewModel.year,t),this.view="Calendar",!0===this.isImmediate&&this.__emitImmediately("month")},__getMonthHash:function(t){return t.year+"/"+ht(t.month)},__getDayHash:function(t){return t.year+"/"+ht(t.month)+"/"+ht(t.day)},__toggleDate:function(t,e){var n=this.daysMap[e];(void 0!==n&&!0===n.includes(t.day)?this.__removeFromModel:this.__addToModel)(t)},__getShortDate:function(t){return{year:t.year,month:t.month,day:t.day}},__onDayClick:function(t){var e=Object.assign({},this.viewModel,{day:t});if(!1!==this.range)if(void 0===this.editRange){var n=this.days.find((function(e){return!0!==e.fill&&e.i===t}));if(void 0!==n.range)return void this.__removeFromModel({target:e,from:n.range.from,to:n.range.to});if(!0===n.selected)return void this.__removeFromModel(e);var i=this.__getDayHash(e);this.editRange={init:e,initHash:i,final:e,finalHash:i},this.$emit("range-start",this.__getShortDate(e))}else{var r=this.editRange.initHash,o=this.__getDayHash(e),a=r<=o?{from:this.editRange.init,to:e}:{from:e,to:this.editRange.init};this.editRange=void 0,this.__addToModel(r===o?e:Object.assign({},{target:e},a)),this.$emit("range-end",{from:this.__getShortDate(a.from),to:this.__getShortDate(a.to)})}else this.__toggleDate(e,this.viewMonthHash)},__onDayMouseover:function(t){if(void 0!==this.editRange){var e=Object.assign({},this.viewModel,{day:t});Object.assign(this.editRange,{final:e,finalHash:this.__getDayHash(e)})}},__updateViewModel:function(t,e){var n=this;void 0!==this.minNav&&t<=this.minNav.year&&(t=this.minNav.year,e<this.minNav.month&&(e=this.minNav.month)),void 0!==this.maxNav&&t>=this.maxNav.year&&(t=this.maxNav.year,e>this.maxNav.month&&(e=this.maxNav.month));var i=t+"/"+ht(e)+"/01";i!==this.viewModel.dateHash&&(this.monthDirection=this.viewModel.dateHash<i==(!0!==this.$q.lang.rtl)?"left":"right",t!==this.viewModel.year&&(this.yearDirection=this.monthDirection),this.$nextTick((function(){n.startYear=t-t%nr-(t<0?nr:0),Object.assign(n.viewModel,{year:t,month:e,day:1,dateHash:i})})))},__emitValue:function(t,e,n){var i=null!==t&&1===t.length&&!1===this.multiple?t[0]:t;this.lastEmitValue=i;var r=this.__getEmitParams(e,n),o=r.reason,a=r.details;this.$emit("input",i,o,a)},__emitImmediately:function(t){var e=this,n=this.daysModel[0];this.$nextTick((function(){n.year=e.viewModel.year,n.month=e.viewModel.month;var i="persian"!==e.calendar?new Date(n.year,n.month,0).getDate():_i(n.year,n.month);n.day=Math.min(Math.max(1,n.day),i);var r=e.__encodeEntry(n);e.lastEmitValue=r;var o=e.__getEmitParams("",n).details;e.$emit("input",r,t,o)}))},__getEmitParams:function(t,e){return void 0!==e.from?{reason:t+"-range",details:Object.assign({},this.__getShortDate(e.target),{from:this.__getShortDate(e.from),to:this.__getShortDate(e.to),changed:!0})}:{reason:t+"-day",details:Object.assign({},this.__getShortDate(e),{changed:!0})}},__encodeEntry:function(t,e,n){return void 0!==t.from?{from:this.encodeObjectFn(t.from,e,n),to:this.encodeObjectFn(t.to,e,n)}:this.encodeObjectFn(t,e,n)},__addToModel:function(t){var e,n=this;if(!0===this.multiple)if(void 0!==t.from){var i=this.__getDayHash(t.from),r=this.__getDayHash(t.to),o=this.daysModel.filter((function(t){return t.dateHash<i||t.dateHash>r})),a=this.rangeModel.filter((function(t){var e=t.from;return t.to.dateHash<i||e.dateHash>r}));e=o.concat(a).concat(t).map((function(t){return n.__encodeEntry(t)}))}else{var s=this.normalizedModel.slice();s.push(this.__encodeEntry(t)),e=s}else e=this.__encodeEntry(t);this.__emitValue(e,"add",t)},__removeFromModel:function(t){if(!0!==this.noUnset){var e=null;if(!0===this.multiple&&!0===Array.isArray(this.value)){var n=this.__encodeEntry(t);e=void 0!==t.from?this.value.filter((function(t){return void 0===t.from||t.from!==n.from&&t.to!==n.to})):this.value.filter((function(t){return t!==n})),0===e.length&&(e=null)}this.__emitValue(e,"remove",t)}},__updateValue:function(t,e,n){var i=this,r=this.daysModel.concat(this.rangeModel).map((function(n){return i.__encodeEntry(n,t,e)})).filter((function(t){return void 0!==t.from?null!==t.from.dateHash&&null!==t.to.dateHash:null!==t.dateHash}));this.$emit("input",(!0===this.multiple?r:r[0])||null,n)}},render:function(t){var e=[t("div",{staticClass:"q-date__content col relative-position"},[t("transition",{props:{name:"q-transition--fade"}},[this["__get"+this.view+"View"](t)])])],n=Bt(this,"default");return void 0!==n&&e.push(t("div",{staticClass:"q-date__actions"},n)),void 0!==this.name&&!0!==this.disable&&this.__injectFormInput(e,"push"),t("div",{class:this.classes,attrs:this.attrs,on:Object.assign({},this.qListeners)},[this.__getHeader(t),t("div",{staticClass:"q-date__main col column",attrs:{tabindex:-1},ref:"blurTarget"},e)])}}),lr={methods:{__addHistory:function(){var t=this;this.__historyEntry={condition:function(){return!0===t.hideOnRouteChange},handler:this.hide},q.add(this.__historyEntry)},__removeHistory:function(){void 0!==this.__historyEntry&&(q.remove(this.__historyEntry),this.__historyEntry=void 0)}},beforeDestroy:function(){!0===this.showing&&this.__removeHistory()}},cr=0,ur=!1;function dr(t){(function(t){if(t.target===document.body||t.target.classList.contains("q-layout__backdrop"))return!0;for(var e=y(t),n=t.shiftKey&&!t.deltaX,i=!n&&Math.abs(t.deltaX)<=Math.abs(t.deltaY),r=n||i?t.deltaY:t.deltaX,o=0;o<e.length;o++){var a=e[o];if(Qe(a,i))return i?r<0&&0===a.scrollTop||r>0&&a.scrollTop+a.clientHeight===a.scrollHeight:r<0&&0===a.scrollLeft||r>0&&a.scrollLeft+a.clientWidth===a.scrollWidth}return!0})(t)&&w(t)}function hr(t){t.target===document&&(document.scrollingElement.scrollTop=document.scrollingElement.scrollTop)}function fr(t){!0!==ur&&(ur=!0,requestAnimationFrame((function(){ur=!1;var e=t.target.height,n=document.scrollingElement,i=n.clientHeight,r=n.scrollTop;void 0!==Ji&&e===window.innerHeight||(Ji=i-e,document.scrollingElement.scrollTop=r),r>Ji&&(document.scrollingElement.scrollTop-=Math.ceil((r-Ji)/8))})))}function pr(t){var e=document.body,n=void 0!==window.visualViewport;if("add"===t){var i=window.getComputedStyle(e).overflowY;Gi=$e(window),Ki=Fe(window),Zi=e.style.left,Xi=e.style.top,e.style.left="-"+Gi+"px",e.style.top="-"+Ki+"px","hidden"!==i&&("scroll"===i||e.scrollHeight>window.innerHeight)&&e.classList.add("q-body--force-scrollbar"),e.classList.add("q-body--prevent-scroll"),document.qScrollPrevented=!0,!0===d.is.ios&&(!0===n?(window.scrollTo(0,0),window.visualViewport.addEventListener("resize",fr,f.passiveCapture),window.visualViewport.addEventListener("scroll",fr,f.passiveCapture),window.scrollTo(0,0)):window.addEventListener("scroll",hr,f.passiveCapture))}!0===d.is.desktop&&!0===d.is.mac&&window[t+"EventListener"]("wheel",dr,f.notPassive),"remove"===t&&(!0===d.is.ios&&(!0===n?(window.visualViewport.removeEventListener("resize",fr,f.passiveCapture),window.visualViewport.removeEventListener("scroll",fr,f.passiveCapture)):window.removeEventListener("scroll",hr,f.passiveCapture)),e.classList.remove("q-body--prevent-scroll"),e.classList.remove("q-body--force-scrollbar"),document.qScrollPrevented=!1,e.style.left=Zi,e.style.top=Xi,window.scrollTo(Gi,Ki),Ji=void 0)}function mr(t){var e="add";if(!0===t){if(cr++,void 0!==tr)return clearTimeout(tr),void(tr=void 0);if(cr>1)return}else{if(0===cr)return;if(--cr>0)return;if(e="remove",!0===d.is.ios&&!0===d.is.nativeMobile)return clearTimeout(tr),void(tr=setTimeout((function(){pr(e),tr=void 0}),100))}pr(e)}for(var vr,gr={methods:{__preventScroll:function(t){t===this.preventedScroll||void 0===this.preventedScroll&&!0!==t||(this.preventedScroll=t,mr(t))}}},yr=0,_r={standard:"fixed-full flex-center",top:"fixed-top justify-center",bottom:"fixed-bottom justify-center",right:"fixed-right items-center",left:"fixed-left items-center"},br={standard:["scale","scale"],top:["slide-down","slide-up"],bottom:["slide-up","slide-down"],right:["slide-left","slide-right"],left:["slide-right","slide-left"]},wr=t.extend({name:"QDialog",mixins:[yt,lr,Ce,Me,gr],props:{persistent:Boolean,autoClose:Boolean,noEscDismiss:Boolean,noBackdropDismiss:Boolean,noRouteDismiss:Boolean,noRefocus:Boolean,noFocus:Boolean,seamless:Boolean,maximized:Boolean,fullWidth:Boolean,fullHeight:Boolean,square:Boolean,position:{type:String,default:"standard",validator:function(t){return"standard"===t||["top","bottom","left","right"].includes(t)}},transitionShow:String,transitionHide:String},data:function(){return{transitionState:this.showing}},watch:{showing:function(t){var e=this;this.transitionShowComputed!==this.transitionHideComputed&&this.$nextTick((function(){e.transitionState=t}))},maximized:function(t){!0===this.showing&&this.__updateMaximized(t)},useBackdrop:function(t){this.__preventScroll(t),this.__preventFocusout(t)}},computed:{classes:function(){return"q-dialog__inner--"+(!0===this.maximized?"maximized":"minimized")+" q-dialog__inner--"+this.position+" "+_r[this.position]+(!0===this.fullWidth?" q-dialog__inner--fullwidth":"")+(!0===this.fullHeight?" q-dialog__inner--fullheight":"")+(!0===this.square?" q-dialog__inner--square":"")},transitionShowComputed:function(){return"q-transition--"+(void 0===this.transitionShow?br[this.position][0]:this.transitionShow)},transitionHideComputed:function(){return"q-transition--"+(void 0===this.transitionHide?br[this.position][1]:this.transitionHide)},transition:function(){return!0===this.transitionState?this.transitionHideComputed:this.transitionShowComputed},useBackdrop:function(){return!0===this.showing&&!0!==this.seamless},hideOnRouteChange:function(){return!0!==this.persistent&&!0!==this.noRouteDismiss&&!0!==this.seamless},onEvents:function(){var t=Object.assign({},this.qListeners,{input:_,"popup-show":_,"popup-hide":_});return!0===this.autoClose&&(t.click=this.__onAutoClose),t}},methods:{focus:function(){var t=this.__getInnerNode();void 0!==t&&!0!==t.contains(document.activeElement)&&(t=t.querySelector("[autofocus], [data-autofocus]")||t).focus()},shake:function(){this.focus(),this.$emit("shake");var t=this.__getInnerNode();void 0!==t&&(t.classList.remove("q-animate--scale"),t.classList.add("q-animate--scale"),clearTimeout(this.shakeTimeout),this.shakeTimeout=setTimeout((function(){t.classList.remove("q-animate--scale")}),170))},__getInnerNode:function(){return void 0!==this.__portal&&void 0!==this.__portal.$refs?this.__portal.$refs.inner:void 0},__show:function(t){var e=this;this.__addHistory(),this.__refocusTarget=!1===this.noRefocus&&null!==document.activeElement?document.activeElement:void 0,this.$el.dispatchEvent(x("popup-show",{bubbles:!0})),this.__updateMaximized(this.maximized),tn.register(this,(function(){!0!==e.seamless&&(!0===e.persistent||!0===e.noEscDismiss?!0!==e.maximized&&e.shake():(e.$emit("escape-key"),e.hide()))})),this.__showPortal(),!0!==this.noFocus&&(null!==document.activeElement&&document.activeElement.blur(),this.__nextTick(this.focus)),this.__setTimeout((function(){if(!0===e.$q.platform.is.ios){if(!0!==e.seamless&&document.activeElement){var n=document.activeElement.getBoundingClientRect(),i=n.top,r=n.bottom,o=window.innerHeight,a=void 0!==window.visualViewport?window.visualViewport.height:o;if(i>0&&r>a/2){var s=Math.min(document.scrollingElement.scrollHeight-a,r>=o?1/0:Math.ceil(document.scrollingElement.scrollTop+r-a/2)),l=function(){requestAnimationFrame((function(){document.scrollingElement.scrollTop+=Math.ceil((s-document.scrollingElement.scrollTop)/8),document.scrollingElement.scrollTop!==s&&l()}))};l()}document.activeElement.scrollIntoView()}e.__portal.$el.click()}e.$emit("show",t)}),300)},__hide:function(t){var e=this;this.__removeHistory(),this.__cleanup(!0),void 0!==this.__refocusTarget&&null!==this.__refocusTarget&&this.__refocusTarget.focus(),this.$el.dispatchEvent(x("popup-hide",{bubbles:!0})),this.__setTimeout((function(){e.__hidePortal(),e.$emit("hide",t)}),300)},__cleanup:function(t){clearTimeout(this.shakeTimeout),!0!==t&&!0!==this.showing||(tn.pop(this),this.__updateMaximized(!1),!0!==this.seamless&&(this.__preventScroll(!1),this.__preventFocusout(!1)))},__updateMaximized:function(t){!0===t?!0!==this.isMaximized&&(yr<1&&document.body.classList.add("q-body--dialog"),yr++,this.isMaximized=!0):!0===this.isMaximized&&(yr<2&&document.body.classList.remove("q-body--dialog"),yr--,this.isMaximized=!1)},__preventFocusout:function(t){if(!0===this.$q.platform.is.desktop){var e=(!0===t?"add":"remove")+"EventListener";document.body[e]("focusin",this.__onFocusChange)}},__onAutoClose:function(t){this.hide(t),void 0!==this.qListeners.click&&this.$emit("click",t)},__onBackdropClick:function(t){!0!==this.persistent&&!0!==this.noBackdropDismiss?this.hide(t):this.shake()},__onFocusChange:function(t){!0===this.showing&&void 0!==this.__portal&&!0!==function(t,e){if(void 0===t||!0===t.contains(e))return!0;for(var n=t.nextElementSibling;null!==n;n=n.nextElementSibling)if(n.contains(e))return!0;return!1}(this.__portal.$el,t.target)&&this.focus()},__renderPortal:function(t){return t("div",{staticClass:"q-dialog fullscreen no-pointer-events",class:this.contentClass,style:this.contentStyle,attrs:this.qAttrs},[t("transition",{props:{name:"q-transition--fade"}},!0===this.useBackdrop?[t("div",{staticClass:"q-dialog__backdrop fixed-full",attrs:gt,on:pt(this,"bkdrop",{click:this.__onBackdropClick})})]:null),t("transition",{props:{name:this.transition}},[!0===this.showing?t("div",{ref:"inner",staticClass:"q-dialog__inner flex no-pointer-events",class:this.classes,attrs:{tabindex:-1},on:this.onEvents},Bt(this,"default")):null])])}},mounted:function(){this.__processModelChange(this.value)},beforeDestroy:function(){this.__cleanup()}}),kr=["mouseover","mouseout","mouseenter","mouseleave"],xr=t.extend({name:"QDrawer",inject:{layout:{default:function(){console.error("QDrawer needs to be child of QLayout")}}},mixins:[It,lr,Ce,gr],directives:{TouchPan:Gn},props:{side:{type:String,default:"left",validator:function(t){return["left","right"].includes(t)}},width:{type:Number,default:300},mini:Boolean,miniToOverlay:Boolean,miniWidth:{type:Number,default:57},breakpoint:{type:Number,default:1023},showIfAbove:Boolean,behavior:{type:String,validator:function(t){return["default","desktop","mobile"].includes(t)},default:"default"},bordered:Boolean,elevated:Boolean,contentStyle:[String,Object,Array],contentClass:[String,Object,Array],overlay:Boolean,persistent:Boolean,noSwipeOpen:Boolean,noSwipeClose:Boolean,noSwipeBackdrop:Boolean},data:function(){var t="mobile"===this.behavior||"desktop"!==this.behavior&&this.layout.totalWidth<=this.breakpoint;return{belowBreakpoint:t,showing:!0===this.showIfAbove&&!1===t||!0===this.value}},watch:{belowBreakpoint:function(t){!0===t?(this.lastDesktopState=this.showing,!0===this.showing&&this.hide(!1)):!1===this.overlay&&"mobile"!==this.behavior&&!1!==this.lastDesktopState&&(!0===this.showing?(this.__applyPosition(0),this.__applyBackdrop(0),this.__cleanup()):this.show(!1))},"layout.totalWidth":function(t){this.__updateLocal("belowBreakpoint","mobile"===this.behavior||"desktop"!==this.behavior&&t<=this.breakpoint)},side:function(t,e){this.layout.instances[e]===this&&(this.layout.instances[e]=void 0,this.layout[e].space=!1,this.layout[e].offset=0),this.layout.instances[t]=this,this.layout[t].size=this.size,this.layout[t].space=this.onLayout,this.layout[t].offset=this.offset},behavior:function(t){this.__updateLocal("belowBreakpoint","mobile"===t||"desktop"!==t&&this.layout.totalWidth<=this.breakpoint)},breakpoint:function(t){this.__updateLocal("belowBreakpoint","mobile"===this.behavior||"desktop"!==this.behavior&&this.layout.totalWidth<=t)},"layout.container":function(t){!0===this.showing&&this.__preventScroll(!0!==t)},"layout.scrollbarWidth":function(){this.__applyPosition(!0===this.showing?0:void 0)},offset:function(t){this.__update("offset",t)},onLayout:function(t){this.$emit("on-layout",t),this.__update("space",t)},rightSide:function(){this.__applyPosition()},size:function(t){this.__applyPosition(),this.__updateSizeOnLayout(this.miniToOverlay,t)},miniToOverlay:function(t){this.__updateSizeOnLayout(t,this.size)},"$q.lang.rtl":function(){this.__applyPosition()},mini:function(){!0===this.value&&(this.__animateMini(),this.layout.__animate())},isMini:function(t){this.$emit("mini-state",t)}},computed:{rightSide:function(){return"right"===this.side},otherSide:function(){return!0===this.rightSide?"left":"right"},offset:function(){return!0===this.showing&&!1===this.belowBreakpoint&&!1===this.overlay?!0===this.miniToOverlay?this.miniWidth:this.size:0},size:function(){return!0===this.isMini?this.miniWidth:this.width},fixed:function(){return!0===this.overlay||!0===this.miniToOverlay||this.layout.view.indexOf(this.rightSide?"R":"L")>-1||this.$q.platform.is.ios&&!0===this.layout.container},onLayout:function(){return!0===this.showing&&!1===this.belowBreakpoint&&!1===this.overlay},onScreenOverlay:function(){return!0===this.showing&&!1===this.belowBreakpoint&&!0===this.overlay},backdropClass:function(){return!1===this.showing?"hidden":null},headerSlot:function(){return!0===this.rightSide?"r"===this.layout.rows.top[2]:"l"===this.layout.rows.top[0]},footerSlot:function(){return!0===this.rightSide?"r"===this.layout.rows.bottom[2]:"l"===this.layout.rows.bottom[0]},aboveStyle:function(){var t={};return!0===this.layout.header.space&&!1===this.headerSlot&&(!0===this.fixed?t.top=this.layout.header.offset+"px":!0===this.layout.header.space&&(t.top=this.layout.header.size+"px")),!0===this.layout.footer.space&&!1===this.footerSlot&&(!0===this.fixed?t.bottom=this.layout.footer.offset+"px":!0===this.layout.footer.space&&(t.bottom=this.layout.footer.size+"px")),t},style:function(){var t={width:this.size+"px"};return!0===this.belowBreakpoint?t:Object.assign(t,this.aboveStyle)},classes:function(){return"q-drawer--"+this.side+(!0===this.bordered?" q-drawer--bordered":"")+(!0===this.isDark?" q-drawer--dark q-dark":"")+(!0!==this.showing?" q-layout--prevent-focus":"")+(!0===this.belowBreakpoint?" fixed q-drawer--on-top q-drawer--mobile q-drawer--top-padding":" q-drawer--"+(!0===this.isMini?"mini":"standard")+(!0===this.fixed||!0!==this.onLayout?" fixed":"")+(!0===this.overlay||!0===this.miniToOverlay?" q-drawer--on-top":"")+(!0===this.headerSlot?" q-drawer--top-padding":""))},stateDirection:function(){return(!0===this.$q.lang.rtl?-1:1)*(!0===this.rightSide?1:-1)},isMini:function(){return!0===this.mini&&!0!==this.belowBreakpoint},onNativeEvents:function(){var t=this;if(!0!==this.belowBreakpoint){var e={"!click":function(e){t.$emit("click",e)}};return kr.forEach((function(n){e[n]=function(e){void 0!==t.qListeners[n]&&t.$emit(n,e)}})),e}},hideOnRouteChange:function(){return!0!==this.persistent&&(!0===this.belowBreakpoint||!0===this.onScreenOverlay)},openDirective:function(){var t,e=!0===this.$q.lang.rtl?this.side:this.otherSide;return[{name:"touch-pan",value:this.__openByTouch,modifiers:(t={},t[e]=!0,t.mouse=!0,t)}]},contentCloseDirective:function(){var t;if(!0!==this.noSwipeClose){var e=!0===this.$q.lang.rtl?this.otherSide:this.side;return[{name:"touch-pan",value:this.__closeByTouch,modifiers:(t={},t[e]=!0,t.mouse=!0,t)}]}},backdropCloseDirective:function(){var t;if(!0!==this.noSwipeBackdrop){var e=!0===this.$q.lang.rtl?this.otherSide:this.side;return[{name:"touch-pan",value:this.__closeByTouch,modifiers:(t={},t[e]=!0,t.mouse=!0,t.mouseAllDir=!0,t)}]}}},methods:{__applyPosition:function(t){var e=this;void 0===t?this.$nextTick((function(){t=!0===e.showing?0:e.size,e.__applyPosition(e.stateDirection*t)})):void 0!==this.$refs.content&&(!0!==this.layout.container||!0!==this.rightSide||!0!==this.belowBreakpoint&&Math.abs(t)!==this.size||(t+=this.stateDirection*this.layout.scrollbarWidth),this.__lastPosition!==t&&(this.$refs.content.style.transform="translateX("+t+"px)",this.__lastPosition=t))},__applyBackdrop:function(t,e){var n=this;void 0!==this.$refs.backdrop?this.$refs.backdrop.style.backgroundColor=this.lastBackdropBg="rgba(0,0,0,"+.4*t+")":!0!==e&&this.$nextTick((function(){n.__applyBackdrop(t,!0)}))},__setBackdropVisible:function(t){void 0!==this.$refs.backdrop&&this.$refs.backdrop.classList[!0===t?"remove":"add"]("hidden")},__setScrollable:function(t){var e=!0===t?"remove":!0!==this.layout.container?"add":"";""!==e&&document.body.classList[e]("q-body--drawer-toggle")},__animateMini:function(){var t=this;void 0!==this.timerMini?clearTimeout(this.timerMini):void 0!==this.$el&&this.$el.classList.add("q-drawer--mini-animate"),this.timerMini=setTimeout((function(){void 0!==t.$el&&t.$el.classList.remove("q-drawer--mini-animate"),t.timerMini=void 0}),150)},__openByTouch:function(t){if(!1===this.showing){var e=this.size,n=ut(t.distance.x,0,e);if(!0===t.isFinal){var i=this.$refs.content,r=n>=Math.min(75,e);return i.classList.remove("no-transition"),void(!0===r?this.show():(this.layout.__animate(),this.__applyBackdrop(0),this.__applyPosition(this.stateDirection*e),i.classList.remove("q-drawer--delimiter"),i.classList.add("q-layout--prevent-focus"),this.__setBackdropVisible(!1)))}if(this.__applyPosition((!0===this.$q.lang.rtl?!0!==this.rightSide:this.rightSide)?Math.max(e-n,0):Math.min(0,n-e)),this.__applyBackdrop(ut(n/e,0,1)),!0===t.isFirst){var o=this.$refs.content;o.classList.add("no-transition"),o.classList.add("q-drawer--delimiter"),o.classList.remove("q-layout--prevent-focus"),this.__setBackdropVisible(!0)}}},__closeByTouch:function(t){if(!0===this.showing){var e=this.size,n=t.direction===this.side,i=(!0===this.$q.lang.rtl?!0!==n:n)?ut(t.distance.x,0,e):0;if(!0===t.isFinal){var r=Math.abs(i)<Math.min(75,e);return this.$refs.content.classList.remove("no-transition"),void(!0===r?(this.layout.__animate(),this.__applyBackdrop(1),this.__applyPosition(0)):this.hide())}this.__applyPosition(this.stateDirection*i),this.__applyBackdrop(ut(1-i/e,0,1)),!0===t.isFirst&&this.$refs.content.classList.add("no-transition")}},__show:function(t,e){var n=this;if(this.__addHistory(),this.__setBackdropVisible(!0),!1!==t&&this.layout.__animate(),this.__applyPosition(0),!0===this.belowBreakpoint){var i=this.layout.instances[this.otherSide];void 0!==i&&!0===i.belowBreakpoint&&i.hide(!1),this.__applyBackdrop(1),!0!==this.layout.container&&this.__preventScroll(!0)}else this.__applyBackdrop(0),!1!==t&&this.__setScrollable(!1);this.__setTimeout((function(){!1!==t&&n.__setScrollable(!0),!0!==e&&n.$emit("show",t)}),150)},__hide:function(t,e){var n=this;this.__removeHistory(),!1!==t&&this.layout.__animate(),this.__applyBackdrop(0),this.__applyPosition(this.stateDirection*this.size),this.__setBackdropVisible(!1),this.__cleanup(),!0!==e&&this.__setTimeout((function(){n.$emit("hide",t)}),150)},__cleanup:function(){this.__preventScroll(!1),this.__setScrollable(!0)},__update:function(t,e){this.layout[this.side][t]!==e&&(this.layout[this.side][t]=e)},__updateLocal:function(t,e){this[t]!==e&&(this[t]=e)},__updateSizeOnLayout:function(t,e){this.__update("size",!0===t?this.miniWidth:e)}},created:function(){this.layout.instances[this.side]=this,this.__updateSizeOnLayout(this.miniToOverlay,this.size),this.__update("space",this.onLayout),this.__update("offset",this.offset),!0===this.showIfAbove&&!0!==this.value&&!0===this.showing&&void 0!==this.qListeners.input&&this.$emit("input",!0)},mounted:function(){var t=this;this.$emit("on-layout",this.onLayout),this.$emit("mini-state",this.isMini),this.lastDesktopState=!0===this.showIfAbove;var e=function(){var e=!0===t.showing?"show":"hide";t["__"+e](!1,!0)};0===this.layout.totalWidth?this.watcher=this.$watch("layout.totalWidth",(function(){t.watcher(),t.watcher=void 0,!1===t.showing&&!0===t.showIfAbove&&!1===t.belowBreakpoint?t.show(!1):e()})):this.$nextTick(e)},beforeDestroy:function(){void 0!==this.watcher&&this.watcher(),clearTimeout(this.timerMini),!0===this.showing&&this.__cleanup(),this.layout.instances[this.side]===this&&(this.layout.instances[this.side]=void 0,this.__update("size",0),this.__update("offset",0),this.__update("space",!1))},render:function(t){var e=[];!0===this.belowBreakpoint&&(!0!==this.noSwipeOpen&&e.push(t("div",{staticClass:"q-drawer__opener fixed-"+this.side,attrs:gt,directives:this.openDirective})),e.push(t("div",{ref:"backdrop",staticClass:"fullscreen q-drawer__backdrop",class:this.backdropClass,attrs:gt,style:void 0!==this.lastBackdropBg?{backgroundColor:this.lastBackdropBg}:null,on:pt(this,"bkdrop",{click:this.hide}),directives:!1===this.showing?void 0:this.backdropCloseDirective})));var n=[t("div",{staticClass:"q-drawer__content fit "+(!0===this.layout.container?"overflow-auto":"scroll"),class:this.contentClass,style:this.contentStyle},!0===this.isMini&&void 0!==this.$scopedSlots.mini?this.$scopedSlots.mini():Bt(this,"default"))];return!0===this.elevated&&!0===this.showing&&n.push(t("div",{staticClass:"q-layout__shadow absolute-full overflow-hidden no-pointer-events"})),e.push(t("aside",{ref:"content",staticClass:"q-drawer",class:this.classes,style:this.style,on:this.onNativeEvents,directives:!0===this.belowBreakpoint?this.contentCloseDirective:void 0},n)),t("div",{staticClass:"q-drawer-container"},e)}}),Cr=[!0,!1,"ondemand"],Sr={props:{value:{},error:{type:Boolean,default:null},errorMessage:String,noErrorIcon:Boolean,rules:Array,reactiveRules:Boolean,lazyRules:{type:[Boolean,String],validator:function(t){return Cr.includes(t)}}},data:function(){return{isDirty:null,innerError:!1,innerErrorMessage:void 0}},watch:{value:function(){this.__validateIfNeeded()},reactiveRules:{handler:function(t){var e=this;!0===t?void 0===this.unwatchRules&&(this.unwatchRules=this.$watch("rules",(function(){e.__validateIfNeeded(!0)}))):void 0!==this.unwatchRules&&(this.unwatchRules(),this.unwatchRules=void 0)},immediate:!0},focused:function(t){"ondemand"!==this.lazyRules&&(!0===t?null===this.isDirty&&(this.isDirty=!1):!1===this.isDirty&&!0===this.hasRules&&(this.isDirty=!0,this.validate()))}},computed:{hasRules:function(){return void 0!==this.rules&&null!==this.rules&&this.rules.length>0},hasError:function(){return!0===this.error||!0===this.innerError},computedErrorMessage:function(){return"string"==typeof this.errorMessage&&this.errorMessage.length>0?this.errorMessage:this.innerErrorMessage}},mounted:function(){this.validateIndex=0},beforeDestroy:function(){void 0!==this.unwatchRules&&this.unwatchRules()},methods:{resetValidation:function(){this.validateIndex++,this.innerLoading=!1,this.isDirty=null,this.innerError=!1,this.innerErrorMessage=void 0},validate:function(t){var e=this;if(void 0===t&&(t=this.value),!0!==this.hasRules)return!0;this.validateIndex++,!0!==this.innerLoading&&!0!==this.lazyRules&&(this.isDirty=!0);for(var n=function(t,n){e.innerError!==t&&(e.innerError=t);var i=n||void 0;e.innerErrorMessage!==i&&(e.innerErrorMessage=i),!1!==e.innerLoading&&(e.innerLoading=!1)},i=[],r=0;r<this.rules.length;r++){var o=this.rules[r],a=void 0;if("function"==typeof o?a=o(t):"string"==typeof o&&void 0!==Hn[o]&&(a=Hn[o](t)),!1===a||"string"==typeof a)return n(!0,a),!1;!0!==a&&void 0!==a&&i.push(a)}if(0===i.length)return n(!1),!0;!0!==this.innerLoading&&(this.innerLoading=!0);var s=this.validateIndex;return Promise.all(i).then((function(t){if(s!==e.validateIndex)return!0;if(void 0===t||!1===Array.isArray(t)||0===t.length)return n(!1),!0;var i=t.find((function(t){return!1===t||"string"==typeof t}));return n(void 0!==i,i),void 0===i}),(function(t){return s!==e.validateIndex||(console.error(t),n(!0),!1)}))},__validateIfNeeded:function(t){!0===this.hasRules&&"ondemand"!==this.lazyRules&&(!0===this.isDirty||!0!==this.lazyRules&&!0!==t)&&this.validate()}}},Mr=0,Tr=new Array(256),Pr=0;Pr<256;Pr++)Tr[Pr]=(Pr+256).toString(16).substr(1);var Or=function(){var t="undefined"!=typeof crypto?crypto:"undefined"!=typeof window?window.msCrypto:void 0;if(void 0!==t){if(void 0!==t.randomBytes)return t.randomBytes;if(void 0!==t.getRandomValues)return function(e){var n=new Uint8Array(e);return t.getRandomValues(n),n}}return function(t){for(var e=[],n=t;n>0;n--)e.push(Math.floor(256*Math.random()));return e}}(),Br=4096;function Er(){(void 0===vr||Mr+16>Br)&&(Mr=0,vr=Or(Br));var t=Array.prototype.slice.call(vr,Mr,Mr+=16);return t[6]=15&t[6]|64,t[8]=63&t[8]|128,Tr[t[0]]+Tr[t[1]]+Tr[t[2]]+Tr[t[3]]+"-"+Tr[t[4]]+Tr[t[5]]+"-"+Tr[t[6]]+Tr[t[7]]+"-"+Tr[t[8]]+Tr[t[9]]+"-"+Tr[t[10]]+Tr[t[11]]+Tr[t[12]]+Tr[t[13]]+Tr[t[14]]+Tr[t[15]]}function Ar(t){return void 0===t?"f_"+Er():t}var Dr=t.extend({name:"QField",mixins:[It,Sr,yt],inheritAttrs:!1,props:{label:String,stackLabel:Boolean,hint:String,hideHint:Boolean,prefix:String,suffix:String,labelColor:String,color:String,bgColor:String,filled:Boolean,outlined:Boolean,borderless:Boolean,standout:[Boolean,String],square:Boolean,loading:Boolean,labelSlot:Boolean,bottomSlots:Boolean,hideBottomSpace:Boolean,rounded:Boolean,dense:Boolean,itemAligned:Boolean,counter:Boolean,clearable:Boolean,clearIcon:String,disable:Boolean,readonly:Boolean,autofocus:Boolean,for:String,maxlength:[Number,String],maxValues:[Number,String]},data:function(){return{focused:!1,targetUid:Ar(this.for),innerLoading:!1}},watch:{for:function(t){this.targetUid=Ar(t)}},computed:{editable:function(){return!0!==this.disable&&!0!==this.readonly},hasValue:function(){var t=void 0===this.__getControl?this.value:this.innerValue;return null!=t&&(""+t).length>0},computedCounter:function(){if(!1!==this.counter){var t="string"==typeof this.value||"number"==typeof this.value?(""+this.value).length:!0===Array.isArray(this.value)?this.value.length:0,e=void 0!==this.maxlength?this.maxlength:this.maxValues;return t+(void 0!==e?" / "+e:"")}},floatingLabel:function(){return!0===this.stackLabel||!0===this.focused||(void 0!==this.inputValue&&!0===this.hideSelected?this.inputValue.length>0:!0===this.hasValue)||void 0!==this.displayValue&&null!==this.displayValue&&(""+this.displayValue).length>0},shouldRenderBottom:function(){return!0===this.bottomSlots||void 0!==this.hint||!0===this.hasRules||!0===this.counter||null!==this.error},classes:function(){var t;return(t={})[this.fieldClass]=void 0!==this.fieldClass,t["q-field--"+this.styleType]=!0,t["q-field--rounded"]=this.rounded,t["q-field--square"]=this.square,t["q-field--focused"]=!0===this.focused||!0===this.hasError,t["q-field--float"]=this.floatingLabel,t["q-field--labeled"]=this.hasLabel,t["q-field--dense"]=this.dense,t["q-field--item-aligned q-item-type"]=this.itemAligned,t["q-field--dark"]=this.isDark,t["q-field--auto-height"]=void 0===this.__getControl,t["q-field--with-bottom"]=!0!==this.hideBottomSpace&&!0===this.shouldRenderBottom,t["q-field--error"]=this.hasError,t["q-field--readonly"]=!0===this.readonly&&!0!==this.disable,t["q-field--disabled"]=this.disable,t},styleType:function(){return!0===this.filled?"filled":!0===this.outlined?"outlined":!0===this.borderless?"borderless":this.standout?"standout":"standard"},contentClass:function(){var t=[];if(!0===this.hasError)t.push("text-negative");else{if("string"==typeof this.standout&&this.standout.length>0&&!0===this.focused)return this.standout;void 0!==this.color&&t.push("text-"+this.color)}return void 0!==this.bgColor&&t.push("bg-"+this.bgColor),t},hasLabel:function(){return!0===this.labelSlot||void 0!==this.label},labelClass:function(){if(void 0!==this.labelColor&&!0!==this.hasError)return"text-"+this.labelColor},controlSlotScope:function(){return{id:this.targetUid,field:this.$el,editable:this.editable,focused:this.focused,floatingLabel:this.floatingLabel,value:this.value,emitValue:this.__emitValue}},attrs:function(){var t={for:this.targetUid};return!0===this.disable?t["aria-disabled"]="true":!0===this.readonly&&(t["aria-readonly"]="true"),t}},methods:{focus:function(){void 0===this.showPopup||!0!==this.hasDialog?this.__focus():this.showPopup()},blur:function(){var t=document.activeElement;null!==t&&this.$el.contains(t)&&t.blur()},__focus:function(){var t=document.activeElement,e=this.$refs.target;void 0===e||null!==t&&t.id===this.targetUid||(!0===e.hasAttribute("tabindex")||(e=e.querySelector("[tabindex]")),null!==e&&e!==t&&e.focus())},__getContent:function(t){var e=[];return void 0!==this.$scopedSlots.prepend&&e.push(t("div",{staticClass:"q-field__prepend q-field__marginal row no-wrap items-center",key:"prepend",on:this.slotsEvents},this.$scopedSlots.prepend())),e.push(t("div",{staticClass:"q-field__control-container col relative-position row no-wrap q-anchor--skip"},this.__getControlContainer(t))),void 0!==this.$scopedSlots.append&&e.push(t("div",{staticClass:"q-field__append q-field__marginal row no-wrap items-center",key:"append",on:this.slotsEvents},this.$scopedSlots.append())),!0===this.hasError&&!1===this.noErrorIcon&&e.push(this.__getInnerAppendNode(t,"error",[t(Lt,{props:{name:this.$q.iconSet.field.error,color:"negative"}})])),!0===this.loading||!0===this.innerLoading?e.push(this.__getInnerAppendNode(t,"inner-loading-append",void 0!==this.$scopedSlots.loading?this.$scopedSlots.loading():[t(Gt,{props:{color:this.color}})])):!0===this.clearable&&!0===this.hasValue&&!0===this.editable&&e.push(this.__getInnerAppendNode(t,"inner-clearable-append",[t(Lt,{staticClass:"q-field__focusable-action",props:{tag:"button",name:this.clearIcon||this.$q.iconSet.field.clear},attrs:{tabindex:0,type:"button"},on:this.clearableEvents})])),void 0!==this.__getInnerAppend&&e.push(this.__getInnerAppendNode(t,"inner-append",this.__getInnerAppend(t))),void 0!==this.__getControlChild&&e.push(this.__getControlChild(t)),e},__getControlContainer:function(t){var e=[];return void 0!==this.prefix&&null!==this.prefix&&e.push(t("div",{staticClass:"q-field__prefix no-pointer-events row items-center"},[this.prefix])),!0===this.hasShadow&&void 0!==this.__getShadowControl&&e.push(this.__getShadowControl(t)),void 0!==this.__getControl?e.push(this.__getControl(t)):void 0!==this.$scopedSlots.rawControl?e.push(this.$scopedSlots.rawControl()):void 0!==this.$scopedSlots.control&&e.push(t("div",{ref:"target",staticClass:"q-field__native row",attrs:Object.assign({},this.qAttrs,{"data-autofocus":this.autofocus})},this.$scopedSlots.control(this.controlSlotScope))),!0===this.hasLabel&&e.push(t("div",{staticClass:"q-field__label no-pointer-events absolute ellipsis",class:this.labelClass},[Bt(this,"label",this.label)])),void 0!==this.suffix&&null!==this.suffix&&e.push(t("div",{staticClass:"q-field__suffix no-pointer-events row items-center"},[this.suffix])),e.concat(void 0!==this.__getDefaultSlot?this.__getDefaultSlot(t):Bt(this,"default"))},__getBottom:function(t){var e,n;!0===this.hasError?void 0!==this.computedErrorMessage?(e=[t("div",[this.computedErrorMessage])],n=this.computedErrorMessage):(e=Bt(this,"error"),n="q--slot-error"):!0===this.hideHint&&!0!==this.focused||(void 0!==this.hint?(e=[t("div",[this.hint])],n=this.hint):(e=Bt(this,"hint"),n="q--slot-hint"));var i=!0===this.counter||void 0!==this.$scopedSlots.counter;if(!0!==this.hideBottomSpace||!1!==i||void 0!==e){var r=t("div",{key:n,staticClass:"q-field__messages col"},e);return t("div",{staticClass:"q-field__bottom row items-start q-field__bottom--"+(!0!==this.hideBottomSpace?"animated":"stale")},[!0===this.hideBottomSpace?r:t("transition",{props:{name:"q-transition--field-message"}},[r]),!0===i?t("div",{staticClass:"q-field__counter"},void 0!==this.$scopedSlots.counter?this.$scopedSlots.counter():[this.computedCounter]):null])}},__getInnerAppendNode:function(t,e,n){return null===n?null:t("div",{staticClass:"q-field__append q-field__marginal row no-wrap items-center q-anchor--skip",key:e},n)},__onControlPopupShow:function(t){void 0!==t&&_(t),this.$emit("popup-show",t),this.hasPopupOpen=!0,this.__onControlFocusin(t)},__onControlPopupHide:function(t){void 0!==t&&_(t),this.$emit("popup-hide",t),this.hasPopupOpen=!1,this.__onControlFocusout(t)},__onControlFocusin:function(t){!0===this.editable&&!1===this.focused&&(this.focused=!0,this.$emit("focus",t))},__onControlFocusout:function(t,e){var n=this;clearTimeout(this.focusoutTimer),this.focusoutTimer=setTimeout((function(){(!0!==document.hasFocus()||!0!==n.hasPopupOpen&&void 0!==n.$refs&&void 0!==n.$refs.control&&!1===n.$refs.control.contains(document.activeElement))&&(!0===n.focused&&(n.focused=!1,n.$emit("blur",t)),void 0!==e&&e())}))},__clearValue:function(t){w(t),(this.$refs.target||this.$el).focus(),"file"===this.type&&(this.$refs.input.value=null),this.$emit("input",null),this.$emit("clear",this.value)},__emitValue:function(t){this.$emit("input",t)}},render:function(t){return void 0!==this.__onPreRender&&this.__onPreRender(),void 0!==this.__onPostRender&&this.$nextTick(this.__onPostRender),t("label",{staticClass:"q-field q-validation-component row no-wrap items-start",class:this.classes,attrs:this.attrs},[void 0!==this.$scopedSlots.before?t("div",{staticClass:"q-field__before q-field__marginal row no-wrap items-center",on:this.slotsEvents},this.$scopedSlots.before()):null,t("div",{staticClass:"q-field__inner relative-position col self-stretch column justify-center"},[t("div",{ref:"control",staticClass:"q-field__control relative-position row no-wrap",class:this.contentClass,attrs:{tabindex:-1},on:this.controlEvents},this.__getContent(t)),!0===this.shouldRenderBottom?this.__getBottom(t):null]),void 0!==this.$scopedSlots.after?t("div",{staticClass:"q-field__after q-field__marginal row no-wrap items-center",on:this.slotsEvents},this.$scopedSlots.after()):null])},created:function(){void 0!==this.__onPreRender&&this.__onPreRender(),this.slotsEvents={click:b},this.clearableEvents={click:this.__clearValue},this.controlEvents=void 0!==this.__getControlEvents?this.__getControlEvents():{focusin:this.__onControlFocusin,focusout:this.__onControlFocusout,"popup-show":this.__onControlPopupShow,"popup-hide":this.__onControlPopupHide}},mounted:function(){!0===r&&void 0===this.for&&(this.targetUid=Ar()),!0===this.autofocus&&this.focus()},beforeDestroy:function(){clearTimeout(this.focusoutTimer)}});function Lr(t,e,n,i){var r=[];return t.forEach((function(t){!0===i(t)?r.push(t):e.push({failedPropValidation:n,file:t})})),r}var qr={props:{multiple:Boolean,accept:String,capture:String,maxFileSize:[Number,String],maxTotalSize:[Number,String],maxFiles:[Number,String],filter:Function},computed:{extensions:function(){if(void 0!==this.accept)return this.accept.split(",").map((function(t){return"*"===(t=t.trim())?"*/":(t.endsWith("/*")&&(t=t.slice(0,t.length-1)),t.toUpperCase())}))},maxFilesNumber:function(){return parseInt(this.maxFiles,10)},maxTotalSizeNumber:function(){return parseInt(this.maxTotalSize,10)}},methods:{pickFiles:function(t){if(this.editable){var e=this.__getFileInput();e&&e.click(t)}},addFiles:function(t){this.editable&&t&&this.__addFiles(null,t)},__processFiles:function(t,e,n,i){var r=this,o=Array.from(e||t.target.files),a=[],s=function(){a.length>0&&r.$emit("rejected",a)};if(void 0!==this.accept&&-1===this.extensions.indexOf("*/")&&0===(o=Lr(o,a,"accept",(function(t){return r.extensions.some((function(e){return t.type.toUpperCase().startsWith(e)||t.name.toUpperCase().endsWith(e)}))}))).length)return s();if(void 0!==this.maxFileSize){var l=parseInt(this.maxFileSize,10);if(0===(o=Lr(o,a,"max-file-size",(function(t){return t.size<=l}))).length)return s()}if(!0!==this.multiple&&(o=[o[0]]),void 0!==this.maxTotalSize){var c=!0===i?n.reduce((function(t,e){return t+e.size}),0):0;if(0===(o=Lr(o,a,"max-total-size",(function(t){return(c+=t.size)<=r.maxTotalSizeNumber}))).length)return s()}if("function"==typeof this.filter){var u=this.filter(o);o=Lr(o,a,"filter",(function(t){return u.includes(t)}))}if(void 0!==this.maxFiles){var d=!0===i?n.length:0;if(0===(o=Lr(o,a,"max-files",(function(){return++d<=r.maxFilesNumber}))).length)return s()}return s(),o.length>0?o:void 0},__onDragOver:function(t){w(t),this.dnd=!0},__onDragLeave:function(t){w(t),this.dnd=!1},__onDrop:function(t){w(t);var e=t.dataTransfer.files;e.length>0&&this.__addFiles(null,e),this.dnd=!1},__getDnd:function(t,e){if(!0===this.dnd)return t("div",{staticClass:"q-"+e+"__dnd absolute-full",on:pt(this,"dnd",{dragenter:w,dragover:w,dragleave:this.__onDragLeave,drop:this.__onDrop})})}}},Rr={computed:{formDomProps:function(){if("file"===this.type)try{var t="DataTransfer"in window?new DataTransfer:"ClipboardEvent"in window?new ClipboardEvent("").clipboardData:void 0;return Object(this.value)===this.value&&("length"in this.value?Array.from(this.value):[this.value]).forEach((function(e){t.items.add(e)})),{files:t.files}}catch(t){return{files:void 0}}}}},Ir={date:"####/##/##",datetime:"####/##/## ##:##",time:"##:##",fulltime:"##:##:##",phone:"(###) ### - ####",card:"#### #### #### ####"},Nr={"#":{pattern:"[\\d]",negate:"[^\\d]"},S:{pattern:"[a-zA-Z]",negate:"[^a-zA-Z]"},N:{pattern:"[0-9a-zA-Z]",negate:"[^0-9a-zA-Z]"},A:{pattern:"[a-zA-Z]",negate:"[^a-zA-Z]",transform:function(t){return t.toLocaleUpperCase()}},a:{pattern:"[a-zA-Z]",negate:"[^a-zA-Z]",transform:function(t){return t.toLocaleLowerCase()}},X:{pattern:"[0-9a-zA-Z]",negate:"[^0-9a-zA-Z]",transform:function(t){return t.toLocaleUpperCase()}},x:{pattern:"[0-9a-zA-Z]",negate:"[^0-9a-zA-Z]",transform:function(t){return t.toLocaleLowerCase()}}},Fr=Object.keys(Nr);Fr.forEach((function(t){Nr[t].regex=new RegExp(Nr[t].pattern)}));var $r=new RegExp("\\\\([^.*+?^${}()|([\\]])|([.*+?^${}()|[\\]])|(["+Fr.join("")+"])|(.)","g"),jr=/[.*+?^${}()|[\]\\]/g,zr=String.fromCharCode(1),Vr={props:{mask:String,reverseFillMask:Boolean,fillMask:[Boolean,String],unmaskedValue:Boolean},watch:{type:function(){this.__updateMaskInternals()},mask:function(t){if(void 0!==t)this.__updateMaskValue(this.innerValue,!0);else{var e=this.__unmask(this.innerValue);this.__updateMaskInternals(),this.value!==e&&this.$emit("input",e)}},fillMask:function(){!0===this.hasMask&&this.__updateMaskValue(this.innerValue,!0)},reverseFillMask:function(){!0===this.hasMask&&this.__updateMaskValue(this.innerValue,!0)},unmaskedValue:function(){!0===this.hasMask&&this.__updateMaskValue(this.innerValue)}},methods:{__getInitialMaskedValue:function(){if(this.__updateMaskInternals(),!0===this.hasMask){var t=this.__mask(this.__unmask(this.value));return!1!==this.fillMask?this.__fillWithMask(t):t}return this.value},__getPaddedMaskMarked:function(t){if(t<this.maskMarked.length)return this.maskMarked.slice(-t);var e=this.maskMarked,n="",i=e.indexOf(zr);if(i>-1){for(var r=t-e.length;r>0;r--)n+=zr;e=e.slice(0,i)+n+e.slice(i)}return e},__updateMaskInternals:function(){var t=this;if(this.hasMask=void 0!==this.mask&&this.mask.length>0&&["text","search","url","tel","password"].includes(this.type),!1===this.hasMask)return this.computedUnmask=void 0,this.maskMarked="",void(this.maskReplaced="");var e=void 0===Ir[this.mask]?this.mask:Ir[this.mask],n="string"==typeof this.fillMask&&this.fillMask.length>0?this.fillMask.slice(0,1):"_",i=n.replace(jr,"\\$&"),r=[],o=[],a=[],s=!0===this.reverseFillMask,l="",c="";e.replace($r,(function(t,e,n,i,u){if(void 0!==i){var d=Nr[i];a.push(d),c=d.negate,!0===s&&(o.push("(?:"+c+"+)?("+d.pattern+"+)?(?:"+c+"+)?("+d.pattern+"+)?"),s=!1),o.push("(?:"+c+"+)?("+d.pattern+")?")}else if(void 0!==n)l="\\"+("\\"===n?"":n),a.push(n),r.push("([^"+l+"]+)?"+l+"?");else{var h=void 0!==e?e:u;l="\\"===h?"\\\\\\\\":h.replace(jr,"\\\\$&"),a.push(h),r.push("([^"+l+"]+)?"+l+"?")}}));var u=new RegExp("^"+r.join("")+"("+(""===l?".":"[^"+l+"]")+"+)?$"),d=o.length-1,h=o.map((function(e,n){return 0===n&&!0===t.reverseFillMask?new RegExp("^"+i+"*"+e):n===d?new RegExp("^"+e+"("+(""===c?".":c)+"+)?"+(!0===t.reverseFillMask?"$":i+"*")):new RegExp("^"+e)}));this.computedMask=a,this.computedUnmask=function(t){var e=u.exec(t);null!==e&&(t=e.slice(1).join(""));for(var n=[],i=h.length,r=0,o=t;r<i;r++){var a=h[r].exec(o);if(null===a)break;o=o.slice(a.shift().length),n.push.apply(n,a)}return n.length>0?n.join(""):t},this.maskMarked=a.map((function(t){return"string"==typeof t?t:zr})).join(""),this.maskReplaced=this.maskMarked.split(zr).join(n)},__updateMaskValue:function(t,e,n){var i=this,r=this.$refs.input,o=r.selectionEnd,a=r.value.length-o,s=this.__unmask(t);!0===e&&this.__updateMaskInternals();var l=this.__mask(s),c=!1!==this.fillMask?this.__fillWithMask(l):l,u=this.innerValue!==c;r.value!==c&&(r.value=c),!0===u&&(this.innerValue=c),document.activeElement===r&&this.$nextTick((function(){if(c!==i.maskReplaced)if("insertFromPaste"!==n||!0===i.reverseFillMask)if(["deleteContentBackward","deleteContentForward"].indexOf(n)>-1){var t=!0===i.reverseFillMask?Math.max(0,c.length-(c===i.maskReplaced?0:Math.min(l.length,a)+1))+1:o;r.setSelectionRange(t,t,"forward")}else if(!0===i.reverseFillMask)if(!0===u){var e=Math.max(0,c.length-(c===i.maskReplaced?0:Math.min(l.length,a+1)));i.__moveCursorRightReverse(r,e,e)}else{var s=c.length-a;r.setSelectionRange(s,s,"backward")}else if(!0===u){var d=Math.max(0,i.maskMarked.indexOf(zr),Math.min(l.length,o)-1);i.__moveCursorRight(r,d,d)}else{var h=o-1;i.__moveCursorRight(r,h,h)}else{var f=o-1;i.__moveCursorRight(r,f,f)}else{var p=!0===i.reverseFillMask?i.maskReplaced.length:0;r.setSelectionRange(p,p,"forward")}}));var d=!0===this.unmaskedValue?this.__unmask(c):c;this.value!==d&&this.__emitValue(d,!0)},__moveCursorForPaste:function(t,e,n){var i=this.__mask(this.__unmask(t.value));e=Math.max(0,this.maskMarked.indexOf(zr),Math.min(i.length,e)),t.setSelectionRange(e,n,"forward")},__moveCursorLeft:function(t,e,n,i){for(var r=-1===this.maskMarked.slice(e-1).indexOf(zr),o=Math.max(0,e-1);o>=0;o--)if(this.maskMarked[o]===zr){e=o,!0===r&&e++;break}if(o<0&&void 0!==this.maskMarked[e]&&this.maskMarked[e]!==zr)return this.__moveCursorRight(t,0,0);e>=0&&t.setSelectionRange(e,!0===i?n:e,"backward")},__moveCursorRight:function(t,e,n,i){for(var r=t.value.length,o=Math.min(r,n+1);o<=r;o++){if(this.maskMarked[o]===zr){n=o;break}this.maskMarked[o-1]===zr&&(n=o)}if(o>r&&void 0!==this.maskMarked[n-1]&&this.maskMarked[n-1]!==zr)return this.__moveCursorLeft(t,r,r);t.setSelectionRange(i?e:n,n,"forward")},__moveCursorLeftReverse:function(t,e,n,i){for(var r=this.__getPaddedMaskMarked(t.value.length),o=Math.max(0,e-1);o>=0;o--){if(r[o-1]===zr){e=o;break}if(r[o]===zr&&(e=o,0===o))break}if(o<0&&void 0!==r[e]&&r[e]!==zr)return this.__moveCursorRightReverse(t,0,0);e>=0&&t.setSelectionRange(e,!0===i?n:e,"backward")},__moveCursorRightReverse:function(t,e,n,i){for(var r=t.value.length,o=this.__getPaddedMaskMarked(r),a=-1===o.slice(0,n+1).indexOf(zr),s=Math.min(r,n+1);s<=r;s++)if(o[s-1]===zr){(n=s)>0&&!0===a&&n--;break}if(s>r&&void 0!==o[n-1]&&o[n-1]!==zr)return this.__moveCursorLeftReverse(t,r,r);t.setSelectionRange(!0===i?e:n,n,"forward")},__onMaskedKeydown:function(t){if(!0!==Z(t)){var e=this.$refs.input,n=e.selectionStart,i=e.selectionEnd;if(37===t.keyCode||39===t.keyCode){var r=this["__moveCursor"+(39===t.keyCode?"Right":"Left")+(!0===this.reverseFillMask?"Reverse":"")];t.preventDefault(),r(e,n,i,t.shiftKey)}else 8===t.keyCode&&!0!==this.reverseFillMask&&n===i?this.__moveCursorLeft(e,n,i,!0):46===t.keyCode&&!0===this.reverseFillMask&&n===i&&this.__moveCursorRightReverse(e,n,i,!0);this.$emit("keydown",t)}},__mask:function(t){if(null==t||""===t)return"";if(!0===this.reverseFillMask)return this.__maskReverse(t);for(var e=this.computedMask,n=0,i="",r=0;r<e.length;r++){var o=t[n],a=e[r];if("string"==typeof a)i+=a,o===a&&n++;else{if(void 0===o||!a.regex.test(o))return i;i+=void 0!==a.transform?a.transform(o):o,n++}}return i},__maskReverse:function(t){for(var e=this.computedMask,n=this.maskMarked.indexOf(zr),i=t.length-1,r="",o=e.length-1;o>=0;o--){var a=e[o],s=t[i];if("string"==typeof a)r=a+r,s===a&&i--;else{if(void 0===s||!a.regex.test(s))return r;do{r=(void 0!==a.transform?a.transform(s):s)+r,s=t[--i]}while(n===o&&void 0!==s&&a.regex.test(s))}}return r},__unmask:function(t){return"string"!=typeof t||void 0===this.computedUnmask?"number"==typeof t?this.computedUnmask(""+t):t:this.computedUnmask(t)},__fillWithMask:function(t){return this.maskReplaced.length-t.length<=0?t:!0===this.reverseFillMask&&t.length>0?this.maskReplaced.slice(0,-t.length)+t:t+this.maskReplaced.slice(t.length)}}},Hr=/[\u3000-\u303f\u3040-\u309f\u30a0-\u30ff\uff00-\uff9f\u4e00-\u9faf\u3400-\u4dbf]/,Wr=/(?:[\u3300-\u4DBF\u4E00-\u9FFF\uF900-\uFAFF\uFE30-\uFE4F]|[\uD840-\uD868\uD86A-\uD872][\uDC00-\uDFFF]|\uD869[\uDC00-\uDEDF\uDF00-\uDFFF]|\uD873[\uDC00-\uDEAF]|\uD87E[\uDC00-\uDE1F])/,Ur=/[\u3131-\u314e\u314f-\u3163\uac00-\ud7a3]/,Yr={methods:{__onComposition:function(t){if("compositionend"===t.type||"change"===t.type){if(!0!==t.target.composing)return;t.target.composing=!1,this.__onInput(t)}else"compositionupdate"===t.type?"string"==typeof t.data&&!1===Hr.test(t.data)&&!1===Wr.test(t.data)&&!1===Ur.test(t.data)&&(t.target.composing=!1):t.target.composing=!0}}},Qr=t.extend({name:"QInput",mixins:[Dr,Vr,Yr,cn,Rr,Ot],props:{value:{required:!1},shadowText:String,type:{type:String,default:"text"},debounce:[String,Number],autogrow:Boolean,inputClass:[Array,String,Object],inputStyle:[Array,String,Object]},watch:{value:function(t){if(!0===this.hasMask){if(!0===this.stopValueWatcher)return void(this.stopValueWatcher=!1);this.__updateMaskValue(t)}else this.innerValue!==t&&(this.innerValue=t,"number"===this.type&&!0===this.hasOwnProperty("tempValue")&&(!0===this.typedNumber?this.typedNumber=!1:delete this.tempValue));!0===this.autogrow&&this.$nextTick(this.__adjustHeight)},autogrow:function(t){if(!0===t)this.$nextTick(this.__adjustHeight);else if(this.qAttrs.rows>0&&void 0!==this.$refs.input){this.$refs.input.style.height="auto"}},dense:function(){!0===this.autogrow&&this.$nextTick(this.__adjustHeight)}},data:function(){return{innerValue:this.__getInitialMaskedValue()}},computed:{isTextarea:function(){return"textarea"===this.type||!0===this.autogrow},fieldClass:function(){return"q-"+(!0===this.isTextarea?"textarea":"input")+(!0===this.autogrow?" q-textarea--autogrow":"")},hasShadow:function(){return"file"!==this.type&&"string"==typeof this.shadowText&&this.shadowText.length>0},onEvents:function(){var t=Object.assign({},this.qListeners,{input:this.__onInput,paste:this.__onPaste,change:this.__onChange,blur:this.__onFinishEditing,focus:_});return t.compositionstart=t.compositionupdate=t.compositionend=this.__onComposition,!0===this.hasMask&&(t.keydown=this.__onMaskedKeydown),!0===this.autogrow&&(t.animationend=this.__adjustHeight),t},inputAttrs:function(){var t=Object.assign({},{tabindex:0,"data-autofocus":this.autofocus,rows:"textarea"===this.type?6:void 0,"aria-label":this.label,name:this.nameProp},this.qAttrs,{id:this.targetUid,type:this.type,maxlength:this.maxlength,disabled:!0===this.disable,readonly:!0===this.readonly});return!0===this.autogrow&&(t.rows=1),t}},methods:{focus:function(){var t=document.activeElement;void 0===this.$refs.input||this.$refs.input===t||null!==t&&t.id===this.targetUid||this.$refs.input.focus()},select:function(){void 0!==this.$refs.input&&this.$refs.input.select()},__onPaste:function(t){if(!0===this.hasMask&&!0!==this.reverseFillMask){var e=t.target;this.__moveCursorForPaste(e,e.selectionStart,e.selectionEnd)}this.$emit("paste",t)},__onInput:function(t){if(!t||!t.target||!0!==t.target.composing)if("file"!==this.type){var e=t.target.value;!0===this.hasMask?this.__updateMaskValue(e,!1,t.inputType):this.__emitValue(e),!0===this.autogrow&&this.__adjustHeight()}else this.$emit("input",t.target.files)},__emitValue:function(t,e){var n=this;this.emitValueFn=function(){"number"!==n.type&&!0===n.hasOwnProperty("tempValue")&&delete n.tempValue,n.value!==t&&(!0===e&&(n.stopValueWatcher=!0),n.$emit("input",t)),n.emitValueFn=void 0},"number"===this.type&&(this.typedNumber=!0,this.tempValue=t),void 0!==this.debounce?(clearTimeout(this.emitTimer),this.tempValue=t,this.emitTimer=setTimeout(this.emitValueFn,this.debounce)):this.emitValueFn()},__adjustHeight:function(){var t=this.$refs.input;if(void 0!==t){var e=t.parentNode.style;e.marginBottom=t.scrollHeight-1+"px",t.style.height="1px",t.style.height=t.scrollHeight+"px",e.marginBottom=""}},__onChange:function(t){this.__onComposition(t),clearTimeout(this.emitTimer),void 0!==this.emitValueFn&&this.emitValueFn(),this.$emit("change",t)},__onFinishEditing:function(t){var e=this;void 0!==t&&_(t),clearTimeout(this.emitTimer),void 0!==this.emitValueFn&&this.emitValueFn(),this.typedNumber=!1,this.stopValueWatcher=!1,delete this.tempValue,"file"!==this.type&&this.$nextTick((function(){void 0!==e.$refs.input&&(e.$refs.input.value=void 0!==e.innerValue?e.innerValue:"")}))},__getCurValue:function(){return!0===this.hasOwnProperty("tempValue")?this.tempValue:void 0!==this.innerValue?this.innerValue:""},__getShadowControl:function(t){return t("div",{staticClass:"q-field__native q-field__shadow absolute-full no-pointer-events"},[t("span",{staticClass:"invisible"},this.__getCurValue()),t("span",this.shadowText)])},__getControl:function(t){return t(!0===this.isTextarea?"textarea":"input",{ref:"input",staticClass:"q-field__native q-placeholder",style:this.inputStyle,class:this.inputClass,attrs:this.inputAttrs,on:this.onEvents,domProps:"file"!==this.type?{value:this.__getCurValue()}:this.formDomProps})}},mounted:function(){!0===this.autogrow&&this.__adjustHeight()},beforeDestroy:function(){this.__onFinishEditing()}}),Gr=t.extend({name:"QTooltip",mixins:[ke,Ce,Me,Pe],props:{maxHeight:{type:String,default:null},maxWidth:{type:String,default:null},transitionShow:{default:"jump-down"},transitionHide:{default:"jump-up"},anchor:{type:String,default:"bottom middle",validator:en},self:{type:String,default:"top middle",validator:en},offset:{type:Array,default:function(){return[14,14]},validator:nn},scrollTarget:{default:void 0},delay:{type:Number,default:0},hideDelay:{type:Number,default:0}},computed:{anchorOrigin:function(){return rn(this.anchor)},selfOrigin:function(){return rn(this.self)},hideOnRouteChange:function(){return!0!==this.persistent}},methods:{__show:function(t){var e=this;this.__showPortal(),this.__nextTick((function(){e.observer=new MutationObserver((function(){return e.updatePosition()})),e.observer.observe(e.__portal.$el,{attributes:!1,childList:!0,characterData:!0,subtree:!0}),e.updatePosition(),e.__configureScrollTarget()})),this.__setTimeout((function(){e.$emit("show",t)}),300)},__hide:function(t){var e=this;this.__anchorCleanup(),this.__setTimeout((function(){e.__hidePortal(),e.$emit("hide",t)}),300)},__anchorCleanup:function(){void 0!==this.observer&&(this.observer.disconnect(),this.observer=void 0),this.__unconfigureScrollTarget(),S(this,"tooltipTemp")},updatePosition:function(){if(void 0!==this.anchorEl&&void 0!==this.__portal){var t=this.__portal.$el;8!==t.nodeType?on({el:t,offset:this.offset,anchorEl:this.anchorEl,anchorOrigin:this.anchorOrigin,selfOrigin:this.selfOrigin,maxHeight:this.maxHeight,maxWidth:this.maxWidth}):setTimeout(this.updatePosition,25)}},__delayShow:function(t){var e=this;if(!0===this.$q.platform.is.mobile){we(),document.body.classList.add("non-selectable");var n=he(this.anchorEl);C(this,"tooltipTemp",["touchmove","touchcancel","touchend","click"].map((function(t){return[n,t,"__delayHide","passiveCapture"]})))}this.__setTimeout((function(){e.show(t)}),this.delay)},__delayHide:function(t){var e=this;this.__clearTimeout(),!0===this.$q.platform.is.mobile&&(S(this,"tooltipTemp"),we(),setTimeout((function(){document.body.classList.remove("non-selectable")}),10)),this.__setTimeout((function(){e.hide(t)}),this.hideDelay)},__configureAnchorEl:function(){!0!==this.noParentEvent&&void 0!==this.anchorEl&&C(this,"anchor",!0===this.$q.platform.is.mobile?[[this.anchorEl,"touchstart","__delayShow","passive"]]:[[this.anchorEl,"mouseenter","__delayShow","passive"],[this.anchorEl,"mouseleave","__delayHide","passive"]])},__unconfigureScrollTarget:function(){void 0!==this.__scrollTarget&&(this.__changeScrollEvent(this.__scrollTarget),this.__scrollTarget=void 0)},__configureScrollTarget:function(){if(void 0!==this.anchorEl||void 0!==this.scrollTarget){this.__scrollTarget=Ie(this.anchorEl,this.scrollTarget);var t=!0===this.noParentEvent?this.updatePosition:this.hide;this.__changeScrollEvent(this.__scrollTarget,t)}},__renderPortal:function(t){return t("transition",{props:{name:this.transition}},[!0===this.showing?t("div",{staticClass:"q-tooltip q-tooltip--style q-position-engine no-pointer-events",class:this.contentClass,style:this.contentStyle,attrs:{role:"complementary"}},Bt(this,"default")):null])}},mounted:function(){this.__processModelChange(this.value)}}),Kr=t.extend({name:"QList",mixins:[Ot,It],props:{bordered:Boolean,dense:Boolean,separator:Boolean,padding:Boolean},computed:{classes:function(){return"q-list"+(!0===this.bordered?" q-list--bordered":"")+(!0===this.dense?" q-list--dense":"")+(!0===this.separator?" q-list--separator":"")+(!0===this.isDark?" q-list--dark":"")+(!0===this.padding?" q-list--padding":"")}},render:function(t){return t("div",{class:this.classes,on:Object.assign({},this.qListeners)},Bt(this,"default"))}}),Jr=t.extend({name:"QItem",mixins:[It,Ut,Pt,Ot],props:{active:Boolean,clickable:Boolean,dense:Boolean,insetLevel:Number,tabindex:[String,Number],focused:Boolean,manualFocus:Boolean},computed:{isActionable:function(){return!0===this.clickable||!0===this.hasRouterLink||"a"===this.tag||"label"===this.tag},isClickable:function(){return!0!==this.disable&&!0===this.isActionable},classes:function(){var t;return(t={"q-item--clickable q-link cursor-pointer":this.isClickable,"q-focusable q-hoverable":!0===this.isClickable&&!1===this.manualFocus,"q-manual-focusable":!0===this.isClickable&&!0===this.manualFocus,"q-manual-focusable--focused":!0===this.isClickable&&!0===this.focused,"q-item--dense":this.dense,"q-item--dark":this.isDark,"q-item--active":this.active})[this.activeClass]=!0===this.active&&!0!==this.hasRouterLink&&void 0!==this.activeClass,t.disabled=this.disable,t},style:function(){var t;if(void 0!==this.insetLevel)return(t={})["padding"+(!0===this.$q.lang.rtl?"Right":"Left")]=16+56*this.insetLevel+"px",t},onEvents:function(){return Object.assign({},this.qListeners,{click:this.__onClick,keyup:this.__onKeyup})}},methods:{__getContent:function(t){var e=Et(this,"default",[]);return!0===this.isClickable&&e.unshift(t("div",{staticClass:"q-focus-helper",attrs:{tabindex:-1},ref:"blurTarget"})),e},__onClick:function(t){!0===this.isClickable&&(void 0!==this.$refs.blurTarget&&(!0!==t.qKeyEvent&&document.activeElement===this.$el?this.$refs.blurTarget.focus():document.activeElement===this.$refs.blurTarget&&this.$el.focus()),this.$emit("click",t))},__onKeyup:function(t){if(!0===this.isClickable&&!0===X(t,13)){w(t),t.qKeyEvent=!0;var e=new MouseEvent("click",t);e.qKeyEvent=!0,this.$el.dispatchEvent(e)}this.$emit("keyup",t)}},render:function(t){var e={staticClass:"q-item q-item-type row no-wrap",class:this.classes,style:this.style};return e[!0===this.hasRouterLink?"nativeOn":"on"]=this.onEvents,!0===this.isClickable?e.attrs={tabindex:this.tabindex||"0"}:!0===this.isActionable&&(e.attrs={"aria-disabled":"true"}),!0===this.hasRouterLink?(e.tag="a",e.props=this.routerLinkProps,t("router-link",e,this.__getContent(t))):t(this.tag,e,this.__getContent(t))}}),Zr=t.extend({name:"QItemSection",mixins:[Ot],props:{avatar:Boolean,thumbnail:Boolean,side:Boolean,top:Boolean,noWrap:Boolean},computed:{classes:function(){var t,e=this.avatar||this.side||this.thumbnail;return(t={"q-item__section--top":this.top,"q-item__section--avatar":this.avatar,"q-item__section--thumbnail":this.thumbnail,"q-item__section--side":e,"q-item__section--nowrap":this.noWrap,"q-item__section--main":!e})["justify-"+(this.top?"start":"center")]=!0,t}},render:function(t){return t("div",{staticClass:"q-item__section column",class:this.classes,on:Object.assign({},this.qListeners)},Bt(this,"default"))}});function Xr(t,e,n){e.handler?e.handler(t,n,n.caret):n.runCmd(e.cmd,e.param)}function to(t,e){return t("div",{staticClass:"q-editor__toolbar-group"},e)}function eo(t,e,n,i,r){void 0===r&&(r=!1);var o=r||"toggle"===n.type&&(n.toggled?n.toggled(e):n.cmd&&e.caret.is(n.cmd,n.param)),a=[],s={click:function(t){i&&i(),Xr(t,n,e)}};if(n.tip&&e.$q.platform.is.desktop){var l=n.key?t("div",[t("small","(CTRL + "+String.fromCharCode(n.key)+")")]):null;a.push(t(Gr,{props:{delay:1e3}},[t("div",{domProps:{innerHTML:n.tip}}),l]))}return t(_e,{props:Object.assign({},e.buttonProps,{icon:n.icon,color:o?n.toggleColor||e.toolbarToggleColor:n.color||e.toolbarColor,textColor:o&&!e.toolbarPush?null:n.textColor||e.toolbarTextColor,label:n.label,disable:!!n.disable&&("function"!=typeof n.disable||n.disable(e)),size:"sm"}),on:s},a)}function no(t,e){if(e.caret)return e.buttons.filter((function(t){return!e.isViewingSource||t.find((function(t){return"viewsource"===t.cmd}))})).map((function(n){return to(t,n.map((function(n){return(!e.isViewingSource||"viewsource"===n.cmd)&&("slot"===n.type?Bt(e,n.slot):"dropdown"===n.type?function(t,e,n){var i,r,o="only-icons"===n.list,a=n.label,s=n.icon;function l(){h.componentInstance.hide()}if(o)r=n.options.map((function(n){var i=void 0===n.type&&e.caret.is(n.cmd,n.param);return i&&(a=n.tip,s=n.icon),eo(t,e,n,l,i)})),i=e.toolbarBackgroundClass,r=[to(t,r)];else{var c=void 0!==e.toolbarToggleColor?"text-"+e.toolbarToggleColor:null,u=void 0!==e.toolbarTextColor?"text-"+e.toolbarTextColor:null;r=n.options.map((function(n){var i=!!n.disable&&n.disable(e),r=void 0===n.type&&e.caret.is(n.cmd,n.param);r&&(a=n.tip,s=n.icon);var o=n.htmlTip;return t(Jr,{props:{active:r,activeClass:c,clickable:!0,disable:i,dense:!0},on:{click:function(t){l(),e.$refs.content&&e.$refs.content.focus(),e.caret.restore(),Xr(t,n,e)}}},["no-icons"===n.list?null:t(Zr,{class:r?c:u,props:{side:!0}},[t(Lt,{props:{name:n.icon}})]),t(Zr,[o?t("div",{domProps:{innerHTML:n.htmlTip}}):n.tip?t("div",[n.tip]):null])])})),i=[e.toolbarBackgroundClass,u],r=[t(Kr,[r])]}var d=n.highlight&&a!==n.label,h=t(sn,{props:Object.assign({},e.buttonProps,{noCaps:!0,noWrap:!0,color:d?e.toolbarToggleColor:e.toolbarColor,textColor:d&&!e.toolbarPush?null:e.toolbarTextColor,label:n.fixedLabel?n.label:a,icon:n.fixedIcon?n.icon:s,contentClass:i})},r);return h}(t,e,n):eo(t,e,n))})))}))}function io(t,e){if(e&&t===e)return null;var n=t.nodeName.toLowerCase();if(!0===["div","li","ul","ol","blockquote"].includes(n))return t;var i=(window.getComputedStyle?window.getComputedStyle(t):t.currentStyle).display;return"block"===i||"table"===i?t:io(t.parentNode)}function ro(t,e){return!(!t||t===document.body)&&(e===document?document.body:e).contains(t.parentNode)}function oo(t,e,n){if(n||((n=document.createRange()).selectNode(t),n.setStart(t,0)),0===e.count)n.setEnd(t,e.count);else if(e.count>0)if(t.nodeType===Node.TEXT_NODE)t.textContent.length<e.count?e.count-=t.textContent.length:(n.setEnd(t,e.count),e.count=0);else for(var i=0;0!==e.count&&i<t.childNodes.length;i++)n=oo(t.childNodes[i],e,n);return n}var ao=/^https?:\/\//,so=function(t,e){this.el=t,this.vm=e,this._range=null},lo={selection:{configurable:!0},hasSelection:{configurable:!0},range:{configurable:!0},parent:{configurable:!0},blockParent:{configurable:!0}};lo.selection.get=function(){if(this.el){var t=document.getSelection();if(ro(t.anchorNode,this.el)&&ro(t.focusNode,this.el))return t}return null},lo.hasSelection.get=function(){return null!==this.selection&&this.selection.toString().length>0},lo.range.get=function(){var t=this.selection;return null!==t&&t.rangeCount?t.getRangeAt(0):this._range},lo.parent.get=function(){var t=this.range;if(null!==t){var e=t.startContainer;return e.nodeType===document.ELEMENT_NODE?e:e.parentNode}return null},lo.blockParent.get=function(){var t=this.parent;return null!==t?io(t,this.el):null},so.prototype.save=function(t){void 0===t&&(t=this.range),null!==t&&(this._range=t)},so.prototype.restore=function(t){void 0===t&&(t=this._range);var e=document.createRange(),n=document.getSelection();null!==t?(e.setStart(t.startContainer,t.startOffset),e.setEnd(t.endContainer,t.endOffset),n.removeAllRanges(),n.addRange(e)):(n.selectAllChildren(this.el),n.collapseToEnd())},so.prototype.savePosition=function(){var t,e=-1,n=document.getSelection(),i=this.el.parentNode;if(n.focusNode&&ro(n.focusNode,i))for(t=n.focusNode,e=n.focusOffset;t&&t!==i;)t!==this.el&&t.previousSibling?e+=(t=t.previousSibling).textContent.length:t=t.parentNode;this.savedPos=e},so.prototype.restorePosition=function(){if(this.savedPos>=0){var t=window.getSelection(),e=oo(this.el,{count:this.savedPos});e&&(e.collapse(!1),t.removeAllRanges(),t.addRange(e))}},so.prototype.hasParent=function(t,e){var n=e?this.parent:this.blockParent;return null!==n&&n.nodeName.toLowerCase()===t.toLowerCase()},so.prototype.hasParents=function(t,e,n){return void 0===n&&(n=this.parent),null!==n&&(null!==n&&!0===t.includes(n.nodeName.toLowerCase())||!0===e&&this.hasParents(t,e,n.parentNode))},so.prototype.is=function(t,e){switch(t){case"formatBlock":return"DIV"===e&&this.parent===this.el||this.hasParent(e,"PRE"===e);case"link":return this.hasParent("A",!0);case"fontSize":return document.queryCommandValue(t)===e;case"fontName":var n=document.queryCommandValue(t);return n==='"'+e+'"'||n===e;case"fullscreen":return this.vm.inFullscreen;case"viewsource":return this.vm.isViewingSource;case void 0:return!1;default:var i=document.queryCommandState(t);return void 0!==e?i===e:i}},so.prototype.getParentAttribute=function(t){return null!==this.parent?this.parent.getAttribute(t):null},so.prototype.can=function(t){return"outdent"===t?this.hasParents(["blockquote","li"],!0):"indent"===t?this.hasParents(["li"],!0):"link"===t?null!==this.selection||this.is("link"):void 0},so.prototype.apply=function(t,e,n){if(void 0===n&&(n=m),"formatBlock"===t)["BLOCKQUOTE","H1","H2","H3","H4","H5","H6"].includes(e)&&this.is(t,e)&&(t="outdent",e=null),"PRE"===e&&this.is(t,"PRE")&&(e="P");else{if("print"===t){n();var i=window.open();return i.document.write("\n        <!doctype html>\n        <html>\n          <head>\n            <title>Print - "+document.title+"</title>\n          </head>\n          <body>\n            <div>"+this.el.innerHTML+"</div>\n          </body>\n        </html>\n      "),i.print(),void i.close()}if("link"===t){var r=this.getParentAttribute("href");if(null===r){var o=this.selectWord(this.selection),a=o?o.toString():"";if(!a.length)return;this.vm.editLinkUrl=ao.test(a)?a:"https://",document.execCommand("createLink",!1,this.vm.editLinkUrl),this.save(o.getRangeAt(0))}else this.vm.editLinkUrl=r,this.range.selectNodeContents(this.parent),this.save();return}if("fullscreen"===t)return this.vm.toggleFullscreen(),void n();if("viewsource"===t)return this.vm.isViewingSource=!1===this.vm.isViewingSource,this.vm.__setContent(this.vm.value),void n()}document.execCommand(t,!1,e),n()},so.prototype.selectWord=function(t){if(null===t||!0!==t.isCollapsed||void 0===t.modify)return t;var e=document.createRange();e.setStart(t.anchorNode,t.anchorOffset),e.setEnd(t.focusNode,t.focusOffset);var n=e.collapsed?["backward","forward"]:["forward","backward"];e.detach();var i=t.focusNode,r=t.focusOffset;return t.collapse(t.anchorNode,t.anchorOffset),t.modify("move",n[0],"character"),t.modify("move",n[1],"word"),t.extend(i,r),t.modify("extend",n[1],"character"),t.modify("extend",n[0],"word"),t},Object.defineProperties(so.prototype,lo);var co=Object.prototype.toString,uo=Object.prototype.hasOwnProperty,ho={};function fo(t){return null===t?String(t):ho[co.call(t)]||"object"}function po(t){if(!t||"object"!==fo(t))return!1;if(t.constructor&&!uo.call(t,"constructor")&&!uo.call(t.constructor.prototype,"isPrototypeOf"))return!1;var e;for(e in t);return void 0===e||uo.call(t,e)}function mo(){var t,e,n,i,r,o,a=arguments,s=arguments[0]||{},l=1,c=!1,u=arguments.length;for("boolean"==typeof s&&(c=s,s=arguments[1]||{},l=2),Object(s)!==s&&"function"!==fo(s)&&(s={}),u===l&&(s=this,l--);l<u;l++)if(null!==(t=a[l]))for(e in t)n=s[e],s!==(i=t[e])&&(c&&i&&(po(i)||(r="array"===fo(i)))?(r?(r=!1,o=n&&"array"===fo(n)?n:[]):o=n&&po(n)?n:{},s[e]=mo(c,o,i)):void 0!==i&&(s[e]=i));return s}"Boolean Number String Function Array Date RegExp Object".split(" ").forEach((function(t){ho["[object "+t+"]"]=t.toLowerCase()}));var vo=t.extend({name:"QEditor",mixins:[Ot,bn,It],props:{value:{type:String,required:!0},readonly:Boolean,disable:Boolean,minHeight:{type:String,default:"10rem"},maxHeight:String,height:String,definitions:Object,fonts:Object,placeholder:String,toolbar:{type:Array,validator:function(t){return 0===t.length||t.every((function(t){return t.length}))},default:function(){return[["left","center","right","justify"],["bold","italic","underline","strike"],["undo","redo"]]}},toolbarColor:String,toolbarBg:String,toolbarTextColor:String,toolbarToggleColor:{type:String,default:"primary"},toolbarOutline:Boolean,toolbarPush:Boolean,toolbarRounded:Boolean,contentStyle:Object,contentClass:[Object,Array,String],square:Boolean,flat:Boolean,dense:Boolean},computed:{editable:function(){return!this.readonly&&!this.disable},hasToolbar:function(){return this.toolbar&&this.toolbar.length>0},toolbarBackgroundClass:function(){if(this.toolbarBg)return"bg-"+this.toolbarBg},buttonProps:function(){return{type:"a",flat:!0!==this.toolbarOutline&&!0!==this.toolbarPush,noWrap:!0,outline:this.toolbarOutline,push:this.toolbarPush,rounded:this.toolbarRounded,dense:!0,color:this.toolbarColor,disable:!this.editable,size:"sm"}},buttonDef:function(){var t=this.$q.lang.editor,e=this.$q.iconSet.editor;return{bold:{cmd:"bold",icon:e.bold,tip:t.bold,key:66},italic:{cmd:"italic",icon:e.italic,tip:t.italic,key:73},strike:{cmd:"strikeThrough",icon:e.strikethrough,tip:t.strikethrough,key:83},underline:{cmd:"underline",icon:e.underline,tip:t.underline,key:85},unordered:{cmd:"insertUnorderedList",icon:e.unorderedList,tip:t.unorderedList},ordered:{cmd:"insertOrderedList",icon:e.orderedList,tip:t.orderedList},subscript:{cmd:"subscript",icon:e.subscript,tip:t.subscript,htmlTip:"x<subscript>2</subscript>"},superscript:{cmd:"superscript",icon:e.superscript,tip:t.superscript,htmlTip:"x<superscript>2</superscript>"},link:{cmd:"link",disable:function(t){return t.caret&&!t.caret.can("link")},icon:e.hyperlink,tip:t.hyperlink,key:76},fullscreen:{cmd:"fullscreen",icon:e.toggleFullscreen,tip:t.toggleFullscreen,key:70},viewsource:{cmd:"viewsource",icon:e.viewSource,tip:t.viewSource},quote:{cmd:"formatBlock",param:"BLOCKQUOTE",icon:e.quote,tip:t.quote,key:81},left:{cmd:"justifyLeft",icon:e.left,tip:t.left},center:{cmd:"justifyCenter",icon:e.center,tip:t.center},right:{cmd:"justifyRight",icon:e.right,tip:t.right},justify:{cmd:"justifyFull",icon:e.justify,tip:t.justify},print:{type:"no-state",cmd:"print",icon:e.print,tip:t.print,key:80},outdent:{type:"no-state",disable:function(t){return t.caret&&!t.caret.can("outdent")},cmd:"outdent",icon:e.outdent,tip:t.outdent},indent:{type:"no-state",disable:function(t){return t.caret&&!t.caret.can("indent")},cmd:"indent",icon:e.indent,tip:t.indent},removeFormat:{type:"no-state",cmd:"removeFormat",icon:e.removeFormat,tip:t.removeFormat},hr:{type:"no-state",cmd:"insertHorizontalRule",icon:e.hr,tip:t.hr},undo:{type:"no-state",cmd:"undo",icon:e.undo,tip:t.undo,key:90},redo:{type:"no-state",cmd:"redo",icon:e.redo,tip:t.redo,key:89},h1:{cmd:"formatBlock",param:"H1",icon:e.heading1||e.heading,tip:t.heading1,htmlTip:'<h1 class="q-ma-none">'+t.heading1+"</h1>"},h2:{cmd:"formatBlock",param:"H2",icon:e.heading2||e.heading,tip:t.heading2,htmlTip:'<h2 class="q-ma-none">'+t.heading2+"</h2>"},h3:{cmd:"formatBlock",param:"H3",icon:e.heading3||e.heading,tip:t.heading3,htmlTip:'<h3 class="q-ma-none">'+t.heading3+"</h3>"},h4:{cmd:"formatBlock",param:"H4",icon:e.heading4||e.heading,tip:t.heading4,htmlTip:'<h4 class="q-ma-none">'+t.heading4+"</h4>"},h5:{cmd:"formatBlock",param:"H5",icon:e.heading5||e.heading,tip:t.heading5,htmlTip:'<h5 class="q-ma-none">'+t.heading5+"</h5>"},h6:{cmd:"formatBlock",param:"H6",icon:e.heading6||e.heading,tip:t.heading6,htmlTip:'<h6 class="q-ma-none">'+t.heading6+"</h6>"},p:{cmd:"formatBlock",param:"DIV",icon:e.heading,tip:t.paragraph},code:{cmd:"formatBlock",param:"PRE",icon:e.code,htmlTip:"<code>"+t.code+"</code>"},"size-1":{cmd:"fontSize",param:"1",icon:e.size1||e.size,tip:t.size1,htmlTip:'<font size="1">'+t.size1+"</font>"},"size-2":{cmd:"fontSize",param:"2",icon:e.size2||e.size,tip:t.size2,htmlTip:'<font size="2">'+t.size2+"</font>"},"size-3":{cmd:"fontSize",param:"3",icon:e.size3||e.size,tip:t.size3,htmlTip:'<font size="3">'+t.size3+"</font>"},"size-4":{cmd:"fontSize",param:"4",icon:e.size4||e.size,tip:t.size4,htmlTip:'<font size="4">'+t.size4+"</font>"},"size-5":{cmd:"fontSize",param:"5",icon:e.size5||e.size,tip:t.size5,htmlTip:'<font size="5">'+t.size5+"</font>"},"size-6":{cmd:"fontSize",param:"6",icon:e.size6||e.size,tip:t.size6,htmlTip:'<font size="6">'+t.size6+"</font>"},"size-7":{cmd:"fontSize",param:"7",icon:e.size7||e.size,tip:t.size7,htmlTip:'<font size="7">'+t.size7+"</font>"}}},buttons:function(){var t=this,e=this.definitions||{},n=this.definitions||this.fonts?mo(!0,{},this.buttonDef,e,function(t,e,n,i){void 0===i&&(i={});var r=Object.keys(i);if(0===r.length)return{};var o={default_font:{cmd:"fontName",param:t,icon:n,tip:e}};return r.forEach((function(t){var e=i[t];o[t]={cmd:"fontName",param:e,icon:n,tip:e,htmlTip:'<font face="'+e+'">'+e+"</font>"}})),o}(this.defaultFont,this.$q.lang.editor.defaultFont,this.$q.iconSet.editor.font,this.fonts)):this.buttonDef;return this.toolbar.map((function(i){return i.map((function(i){if(i.options)return{type:"dropdown",icon:i.icon,label:i.label,size:"sm",dense:!0,fixedLabel:i.fixedLabel,fixedIcon:i.fixedIcon,highlight:i.highlight,list:i.list,options:i.options.map((function(t){return n[t]}))};var r=n[i];return r?"no-state"===r.type||e[i]&&(void 0===r.cmd||t.buttonDef[r.cmd]&&"no-state"===t.buttonDef[r.cmd].type)?r:Object.assign({type:"toggle"},r):{type:"slot",slot:i}}))}))},keys:function(){var t={},e=function(e){e.key&&(t[e.key]={cmd:e.cmd,param:e.param})};return this.buttons.forEach((function(t){t.forEach((function(t){t.options?t.options.forEach(e):e(t)}))})),t},innerStyle:function(){return this.inFullscreen?this.contentStyle:[{minHeight:this.minHeight,height:this.height,maxHeight:this.maxHeight},this.contentStyle]},classes:function(){return"q-editor q-editor--"+(!0===this.isViewingSource?"source":"default")+(!0===this.disable?" disabled":"")+(!0===this.inFullscreen?" fullscreen column":"")+(!0===this.square?" q-editor--square no-border-radius":"")+(!0===this.flat?" q-editor--flat":"")+(!0===this.dense?" q-editor--dense":"")+(!0===this.isDark?" q-editor--dark q-dark":"")},innerClass:function(){return[this.contentClass,{col:this.inFullscreen,"overflow-auto":this.inFullscreen||this.maxHeight}]},attrs:function(){return!0===this.disable?{"aria-disabled":"true"}:!0===this.readonly?{"aria-readonly":"true"}:void 0}},data:function(){return{lastEmit:this.value,editLinkUrl:null,isViewingSource:!1}},watch:{value:function(t){this.lastEmit!==t&&this.__setContent(t,!0)}},methods:{__onInput:function(){if(void 0!==this.$refs.content){var t=!0===this.isViewingSource?this.$refs.content.innerText:this.$refs.content.innerHTML;t!==this.value&&(this.lastEmit=t,this.$emit("input",t))}},__onKeydown:function(t){if(this.$emit("keydown",t),!0!==t.ctrlKey||!0===Z(t))return this.refreshToolbar(),void(this.$q.platform.is.ie&&this.$nextTick(this.__onInput));var e=t.keyCode,n=this.keys[e];if(void 0!==n){var i=n.cmd,r=n.param;w(t),this.runCmd(i,r,!1)}},__onClick:function(t){this.refreshToolbar(),this.$emit("click",t)},__onBlur:function(t){if(void 0!==this.$refs.content){var e=this.$refs.content,n=e.scrollTop,i=e.scrollHeight;this.__offsetBottom=i-n}!0!==this.$q.platform.is.ie&&this.caret.save(),this.$emit("blur",t)},__onFocus:function(t){var e=this;this.$nextTick((function(){void 0!==e.$refs.content&&void 0!==e.__offsetBottom&&(e.$refs.content.scrollTop=e.$refs.content.scrollHeight-e.__offsetBottom)})),this.$emit("focus",t)},__onMouseup:function(t){this.caret.save(),void 0!==this.qListeners.mouseup&&this.$emit("mouseup",t)},__onKeyup:function(t){this.caret.save(),void 0!==this.qListeners.keyup&&this.$emit("keyup",t)},__onTouchend:function(t){this.caret.save(),void 0!==this.qListeners.touchend&&this.$emit("touchend",t)},runCmd:function(t,e,n){var i=this;void 0===n&&(n=!0),this.focus(),this.caret.restore(),this.caret.apply(t,e,(function(){i.focus(),i.caret.save(),!0!==i.$q.platform.is.ie&&!0!==i.$q.platform.is.edge||i.$nextTick(i.__onInput),n&&i.refreshToolbar()}))},refreshToolbar:function(){var t=this;setTimeout((function(){t.editLinkUrl=null,t.$forceUpdate()}),1)},focus:function(){void 0!==this.$refs.content&&this.$refs.content.focus()},getContentEl:function(){return this.$refs.content},__setContent:function(t,e){if(void 0!==this.$refs.content){!0===e&&this.caret.savePosition();var n="inner"+(!0===this.isViewingSource?"Text":"HTML");this.$refs.content[n]=t,!0===e&&(this.caret.restorePosition(),this.refreshToolbar())}}},created:function(){!1===i&&(document.execCommand("defaultParagraphSeparator",!1,"div"),this.defaultFont=window.getComputedStyle(document.body).fontFamily)},mounted:function(){this.caret=new so(this.$refs.content,this),this.__setContent(this.value),this.refreshToolbar()},render:function(t){var e;if(this.hasToolbar){var n=[t("div",{key:"qedt_top",staticClass:"q-editor__toolbar row no-wrap scroll-x",class:this.toolbarBackgroundClass},no(t,this))];null!==this.editLinkUrl&&n.push(t("div",{key:"qedt_btm",staticClass:"q-editor__toolbar row no-wrap items-center scroll-x",class:this.toolbarBackgroundClass},function(t,e,n){if(e.caret){var i=e.toolbarColor||e.toolbarTextColor,r=e.editLinkUrl,o=function(){e.caret.restore(),r!==e.editLinkUrl&&document.execCommand("createLink",!1,""===r?" ":r),e.editLinkUrl=null,!0===n&&e.$nextTick(e.__onInput)};return[t("div",{staticClass:"q-mx-xs",class:"text-"+i},[e.$q.lang.editor.url+": "]),t(Qr,{key:"qedt_btm_input",staticClass:"q-ma-none q-pa-none col q-editor-input",props:{value:r,color:i,autofocus:!0,borderless:!0,dense:!0},on:{input:function(t){r=t},keydown:function(t){if(!0!==Z(t))switch(t.keyCode){case 13:return b(t),o();case 27:b(t),e.caret.restore(),e.editLinkUrl&&"https://"!==e.editLinkUrl||document.execCommand("unlink"),e.editLinkUrl=null}}}}),to(t,[t(_e,{key:"qedt_btm_rem",attrs:{tabindex:-1},props:Object.assign({},e.buttonProps,{label:e.$q.lang.label.remove,noCaps:!0}),on:{click:function(){e.caret.restore(),document.execCommand("unlink"),e.editLinkUrl=null,!0===n&&e.$nextTick(e.__onInput)}}}),t(_e,{key:"qedt_btm_upd",props:Object.assign({},e.buttonProps,{label:e.$q.lang.label.update,noCaps:!0}),on:{click:o}})])]}}(t,this,this.$q.platform.is.ie))),e=t("div",{key:"toolbar_ctainer",staticClass:"q-editor__toolbars-container"},n)}var r=Object.assign({},this.qListeners,{input:this.__onInput,keydown:this.__onKeydown,click:this.__onClick,blur:this.__onBlur,focus:this.__onFocus,mouseup:this.__onMouseup,keyup:this.__onKeyup,touchend:this.__onTouchend});return t("div",{style:{height:!0===this.inFullscreen?"100vh":null},class:this.classes,attrs:this.attrs},[e,t("div",{ref:"content",staticClass:"q-editor__content",style:this.innerStyle,class:this.innerClass,attrs:{contenteditable:this.editable,placeholder:this.placeholder},domProps:i?{innerHTML:this.value}:void 0,on:r})])}}),go=t.extend({name:"QItemLabel",mixins:[Ot],props:{overline:Boolean,caption:Boolean,header:Boolean,lines:[Number,String]},computed:{classes:function(){return{"q-item__label--overline text-overline":this.overline,"q-item__label--caption text-caption":this.caption,"q-item__label--header":this.header,ellipsis:1===parseInt(this.lines,10)}},style:function(){if(void 0!==this.lines&&parseInt(this.lines,10)>1)return{overflow:"hidden",display:"-webkit-box","-webkit-box-orient":"vertical","-webkit-line-clamp":this.lines}}},render:function(t){return t("div",{staticClass:"q-item__label",style:this.style,class:this.classes,on:Object.assign({},this.qListeners)},Bt(this,"default"))}}),yo=t.extend({name:"QSlideTransition",props:{appear:Boolean,duration:{type:Number,default:300}},methods:{__begin:function(t,e,n){t.style.overflowY="hidden",void 0!==e&&(t.style.height=e+"px"),t.style.transition="height "+this.duration+"ms cubic-bezier(.25, .8, .50, 1)",this.animating=!0,this.done=n},__end:function(t,e){t.style.overflowY=null,t.style.height=null,t.style.transition=null,this.__cleanup(),e!==this.lastEvent&&this.$emit(e)},__cleanup:function(){this.done&&this.done(),this.done=null,this.animating=!1,clearTimeout(this.timer),clearTimeout(this.timerFallback),void 0!==this.el&&this.el.removeEventListener("transitionend",this.animListener),this.animListener=null}},beforeDestroy:function(){this.animating&&this.__cleanup()},render:function(t){var e=this;return t("transition",{props:{css:!1,appear:this.appear},on:pt(this,"tr",{enter:function(t,n){var i=0;e.el=t,!0===e.animating?(e.__cleanup(),i=t.offsetHeight===t.scrollHeight?0:void 0):e.lastEvent="hide",e.__begin(t,i,n),e.timer=setTimeout((function(){t.style.height=t.scrollHeight+"px",e.animListener=function(n){Object(n)===n&&n.target!==t||e.__end(t,"show")},t.addEventListener("transitionend",e.animListener),e.timerFallback=setTimeout(e.animListener,1.1*e.duration)}),100)},leave:function(t,n){var i;e.el=t,!0===e.animating?e.__cleanup():(e.lastEvent="show",i=t.scrollHeight),e.__begin(t,i,n),e.timer=setTimeout((function(){t.style.height=0,e.animListener=function(n){Object(n)===n&&n.target!==t||e.__end(t,"hide")},t.addEventListener("transitionend",e.animListener),e.timerFallback=setTimeout(e.animListener,1.1*e.duration)}),100)}})},Bt(this,"default"))}}),_o={true:"inset",item:"item-inset","item-thumbnail":"item-thumbnail-inset"},bo={xs:2,sm:4,md:8,lg:16,xl:24},wo=t.extend({name:"QSeparator",mixins:[It,Ot],props:{spaced:[Boolean,String],inset:[Boolean,String],vertical:Boolean,color:String,size:String},computed:{orientation:function(){return!0===this.vertical?"vertical":"horizontal"},classPrefix:function(){return" q-separator--"+this.orientation},insetClass:function(){return!1!==this.inset?this.classPrefix+"-"+_o[this.inset]:""},classes:function(){return"q-separator"+this.classPrefix+this.insetClass+(void 0!==this.color?" bg-"+this.color:"")+(!0===this.isDark?" q-separator--dark":"")},style:function(){var t={};if(void 0!==this.size&&(t[!0===this.vertical?"width":"height"]=this.size),!1!==this.spaced){var e=!0===this.spaced?bo.md+"px":this.spaced in bo?bo[this.spaced]+"px":this.spaced,n=!0===this.vertical?["Left","Right"]:["Top","Bottom"];t["margin"+n[0]]=t["margin"+n[1]]=e}return t},attrs:function(){return{role:"separator","aria-orientation":this.orientation}}},render:function(t){return t("hr",{staticClass:"q-separator",class:this.classes,style:this.style,attrs:this.attrs,on:Object.assign({},this.qListeners)})}}),ko="q:expansion-item:close",xo=t.extend({name:"QExpansionItem",mixins:[It,Ut,Ce],props:{icon:String,label:String,labelLines:[Number,String],caption:String,captionLines:[Number,String],dense:Boolean,expandIcon:String,expandedIcon:String,expandIconClass:[Array,String,Object],duration:Number,headerInsetLevel:Number,contentInsetLevel:Number,expandSeparator:Boolean,defaultOpened:Boolean,expandIconToggle:Boolean,switchToggleSide:Boolean,denseToggle:Boolean,group:String,popup:Boolean,headerStyle:[Array,String,Object],headerClass:[Array,String,Object]},data:function(){return{showing:void 0!==this.value?this.value:this.defaultOpened}},watch:{showing:function(t){!0===t&&void 0!==this.group&&this.$root.$emit(ko,this)},group:function(t,e){void 0!==t&&void 0===e?this.$root.$on(ko,this.__eventHandler):void 0===t&&void 0!==e&&this.$root.$off(ko,this.__eventHandler)}},computed:{classes:function(){return"q-expansion-item--"+(!0===this.showing?"expanded":"collapsed")+" q-expansion-item--"+(!0===this.popup?"popup":"standard")},contentStyle:function(){var t;if(void 0!==this.contentInsetLevel)return(t={})["padding"+(!0===this.$q.lang.rtl?"Right":"Left")]=56*this.contentInsetLevel+"px",t},isClickable:function(){return!0===this.hasRouterLink||!0!==this.expandIconToggle},expansionIcon:function(){return void 0!==this.expandedIcon&&!0===this.showing?this.expandedIcon:this.expandIcon||this.$q.iconSet.expansionItem[!0===this.denseToggle?"denseIcon":"icon"]},activeToggleIcon:function(){return!0!==this.disable&&(!0===this.hasRouterLink||!0===this.expandIconToggle)}},methods:{__onHeaderClick:function(t){!0!==this.hasRouterLink&&this.toggle(t),this.$emit("click",t)},__toggleIconKeyboard:function(t){13===t.keyCode&&this.__toggleIcon(t,!0)},__toggleIcon:function(t,e){!0!==e&&void 0!==this.$refs.blurTarget&&this.$refs.blurTarget.focus(),this.toggle(t),w(t)},__eventHandler:function(t){this!==t&&this.group===t.group&&this.hide()},__getToggleIcon:function(t){var e={staticClass:"q-focusable relative-position cursor-pointer"+(!0===this.denseToggle&&!0===this.switchToggleSide?" items-end":""),class:this.expandIconClass,props:{side:!0!==this.switchToggleSide,avatar:this.switchToggleSide}},n=[t(Lt,{staticClass:"q-expansion-item__toggle-icon",class:void 0===this.expandedIcon&&!0===this.showing?"q-expansion-item__toggle-icon--rotated":void 0,props:{name:this.expansionIcon}})];return!0===this.activeToggleIcon&&(Object.assign(e,{attrs:{tabindex:0},on:pt(this,"inpExt",{click:this.__toggleIcon,keyup:this.__toggleIconKeyboard})}),n.unshift(t("div",{ref:"blurTarget",staticClass:"q-expansion-item__toggle-focus q-icon q-focus-helper q-focus-helper--rounded",attrs:{tabindex:-1}}))),t(Zr,e,n)},__getHeader:function(t){var e;void 0!==this.$scopedSlots.header?e=this.$scopedSlots.header().slice():(e=[t(Zr,[t(go,{props:{lines:this.labelLines}},[this.label||""]),this.caption?t(go,{props:{lines:this.captionLines,caption:!0}},[this.caption]):null])],this.icon&&e[!0===this.switchToggleSide?"push":"unshift"](t(Zr,{props:{side:!0===this.switchToggleSide,avatar:!0!==this.switchToggleSide}},[t(Lt,{props:{name:this.icon}})]))),!0!==this.disable&&e[!0===this.switchToggleSide?"unshift":"push"](this.__getToggleIcon(t));var n={ref:"item",style:this.headerStyle,class:this.headerClass,props:{dark:this.isDark,disable:this.disable,dense:this.dense,insetLevel:this.headerInsetLevel}};if(!0===this.isClickable){var i=!0===this.hasRouterLink?"nativeOn":"on";n.props.clickable=!0,n[i]=Object.assign({},this.qListeners,{click:this.__onHeaderClick}),!0===this.hasRouterLink&&Object.assign(n.props,this.routerLinkProps)}return t(Jr,n,e)},__getContent:function(t){var e=this,n=[this.__getHeader(t),t(yo,{props:{duration:this.duration},on:pt(this,"slide",{show:function(){e.$emit("after-show")},hide:function(){e.$emit("after-hide")}})},[t("div",{staticClass:"q-expansion-item__content relative-position",style:this.contentStyle,directives:[{name:"show",value:this.showing}]},Bt(this,"default"))])];return this.expandSeparator&&n.push(t(wo,{staticClass:"q-expansion-item__border q-expansion-item__border--top absolute-top",props:{dark:this.isDark}}),t(wo,{staticClass:"q-expansion-item__border q-expansion-item__border--bottom absolute-bottom",props:{dark:this.isDark}})),n}},render:function(t){return t("div",{staticClass:"q-expansion-item q-item-type",class:this.classes},[t("div",{staticClass:"q-expansion-item__container relative-position"},this.__getContent(t))])},created:function(){void 0!==this.group&&this.$root.$on(ko,this.__eventHandler)},beforeDestroy:function(){void 0!==this.group&&this.$root.$off(ko,this.__eventHandler)}}),Co=["top","right","bottom","left"],So={mixins:[Ot],props:{type:{type:String,default:"a"},outline:Boolean,push:Boolean,flat:Boolean,unelevated:Boolean,color:String,textColor:String,glossy:Boolean,square:Boolean,padding:String,label:{type:[String,Number],default:""},labelPosition:{type:String,default:"right",validator:function(t){return Co.includes(t)}},externalLabel:Boolean,hideLabel:{type:Boolean},labelClass:[Array,String,Object],labelStyle:[Array,String,Object],disable:Boolean,tabindex:[Number,String]},computed:{formClass:function(){return"q-fab--form-"+(!0===this.square?"square":"rounded")},stacked:function(){return!1===this.externalLabel&&["top","bottom"].includes(this.labelPosition)},labelProps:function(){if(!0===this.externalLabel){var t=null===this.hideLabel?!1===this.showing:this.hideLabel;return{action:"push",data:{staticClass:"q-fab__label q-tooltip--style q-fab__label--external q-fab__label--external-"+this.labelPosition+(!0===t?" q-fab__label--external-hidden":""),style:this.labelStyle,class:this.labelClass}}}return{action:["left","top"].includes(this.labelPosition)?"unshift":"push",data:{staticClass:"q-fab__label q-fab__label--internal q-fab__label--internal-"+this.labelPosition+(!0===this.hideLabel?" q-fab__label--internal-hidden":""),style:this.labelStyle,class:this.labelClass}}}}},Mo=["up","right","down","left"],To=["left","center","right"],Po=t.extend({name:"QFab",inheritAttrs:!1,mixins:[So,yt,Ce],provide:function(){return{__qFab:this}},props:{icon:String,activeIcon:String,hideIcon:Boolean,hideLabel:{default:null},direction:{type:String,default:"right",validator:function(t){return Mo.includes(t)}},persistent:Boolean,verticalActionsAlign:{type:String,default:"center",validator:function(t){return To.includes(t)}}},data:function(){return{showing:!0===this.value}},computed:{hideOnRouteChange:function(){return!0!==this.persistent},classes:function(){return"q-fab--align-"+this.verticalActionsAlign+" "+this.formClass+(!0===this.showing?" q-fab--opened":"")},attrs:function(){return Object.assign({},{"aria-expanded":!0===this.showing?"true":"false","aria-haspopup":"true"},this.qAttrs)}},methods:{__onChildClick:function(t){this.hide(t),this.$refs.trigger&&this.$refs.trigger.$el&&this.$refs.trigger.$el.focus()}},render:function(t){var e=[];return!0!==this.hideIcon&&e.push(t("div",{staticClass:"q-fab__icon-holder"},[t(Lt,{staticClass:"q-fab__icon absolute-full",props:{name:this.icon||this.$q.iconSet.fab.icon}}),t(Lt,{staticClass:"q-fab__active-icon absolute-full",props:{name:this.activeIcon||this.$q.iconSet.fab.activeIcon}})])),""!==this.label&&e[this.labelProps.action](t("div",this.labelProps.data,[this.label])),t("div",{staticClass:"q-fab z-fab row inline justify-center",class:this.classes,on:Object.assign({},this.qListeners)},[t(_e,{ref:"trigger",class:this.formClass,props:Object.assign({},this.$props,{noWrap:!0,stack:this.stacked,align:void 0,icon:void 0,label:void 0,noCaps:!0,fab:!0}),attrs:this.attrs,on:pt(this,"tog",{click:this.toggle})},At(e,this,"tooltip")),t("div",{staticClass:"q-fab__actions flex no-wrap inline",class:"q-fab__actions--"+this.direction},Bt(this,"default"))])}}),Oo={start:"self-end",center:"self-center",end:"self-start"},Bo=Object.keys(Oo),Eo=t.extend({name:"QFabAction",mixins:[So],props:{icon:{type:String,default:""},anchor:{type:String,validator:function(t){return Bo.includes(t)}},to:[String,Object],replace:Boolean},inject:{__qFab:{default:function(){console.error("QFabAction needs to be child of QFab")}}},computed:{classes:function(){var t=Oo[this.anchor];return this.formClass+(void 0!==t?" "+t:"")},onEvents:function(){return Object.assign({},this.qListeners,{click:this.click})},isDisabled:function(){return!0!==this.__qFab.showing||!0===this.disable}},methods:{click:function(t){this.__qFab.__onChildClick(t),this.$emit("click",t)}},render:function(t){var e=[];return""!==this.icon&&e.push(t(Lt,{props:{name:this.icon}})),""!==this.label&&e[this.labelProps.action](t("div",this.labelProps.data,[this.label])),t(_e,{class:this.classes,props:Object.assign({},this.$props,{noWrap:!0,stack:this.stacked,icon:void 0,label:void 0,noCaps:!0,fabMini:!0,disable:this.isDisabled}),on:this.onEvents},At(e,this,"default"))}}),Ao=t.extend({name:"QFile",mixins:[Dr,qr,cn,Rr],props:{value:!0===i?{}:[File,FileList,Array],append:Boolean,useChips:Boolean,displayValue:[String,Number],tabindex:{type:[String,Number],default:0},counterLabel:Function,inputClass:[Array,String,Object],inputStyle:[Array,String,Object]},data:function(){return{dnd:!1}},computed:{innerValue:function(){return Object(this.value)===this.value?"length"in this.value?Array.from(this.value):[this.value]:[]},selectedString:function(){return this.innerValue.map((function(t){return t.name})).join(", ")},totalSize:function(){return lt(this.innerValue.reduce((function(t,e){return t+e.size}),0))},counterProps:function(){return{totalSize:this.totalSize,filesNumber:this.innerValue.length,maxFiles:this.maxFiles}},computedCounter:function(){if(void 0!==this.counterLabel)return this.counterLabel(this.counterProps);var t=this.maxFiles;return this.innerValue.length+(void 0!==t?" / "+t:"")+" ("+this.totalSize+")"},inputAttrs:function(){return Object.assign({},{tabindex:-1,type:"file",title:"",accept:this.accept,capture:this.capture,name:this.nameProp},this.qAttrs,{id:this.targetUid,disabled:!0!==this.editable})},isAppending:function(){return!0===this.multiple&&!0===this.append}},methods:{removeAtIndex:function(t){var e=this.innerValue.slice();e.splice(t,1),this.__emitValue(e)},removeFile:function(t){var e=this.innerValue.findIndex(t);e>-1&&this.removeAtIndex(e)},__emitValue:function(t){this.$emit("input",!0===this.multiple?t:t[0])},__onKeyup:function(t){13===t.keyCode&&this.pickFiles(t)},__getFileInput:function(){return this.$refs.input},__addFiles:function(t,e){var n=this.__processFiles(t,e,this.innerValue,this.isAppending);void 0!==n&&this.__emitValue(!0===this.isAppending?this.innerValue.concat(n):n)},__getControl:function(t){var e={ref:"target",staticClass:"q-field__native row items-center cursor-pointer",attrs:{tabindex:this.tabindex}};return!0===this.editable&&(e.on=pt(this,"native",{dragover:this.__onDragOver,keyup:this.__onKeyup})),t("div",e,[this.__getInput(t)].concat(this.__getSelection(t)))},__getControlChild:function(t){return this.__getDnd(t,"file")},__getSelection:function(t){var e=this;return void 0!==this.$scopedSlots.file?this.innerValue.map((function(t,n){return e.$scopedSlots.file({index:n,file:t,ref:e})})):void 0!==this.$scopedSlots.selected?this.$scopedSlots.selected({files:this.innerValue,ref:this}):!0===this.useChips?this.innerValue.map((function(n,i){return t(qn,{key:"file-"+i,props:{removable:e.editable,dense:!0,textColor:e.color,tabindex:e.tabindex},on:pt(e,"rem#"+i,{remove:function(){e.removeAtIndex(i)}})},[t("span",{staticClass:"ellipsis",domProps:{textContent:n.name}})])})):[t("div",{style:this.inputStyle,class:this.inputClass,domProps:{textContent:void 0!==this.displayValue?this.displayValue:this.selectedString}})]},__getInput:function(t){var e={ref:"input",staticClass:"q-field__input fit absolute-full cursor-pointer",attrs:this.inputAttrs,domProps:this.formDomProps,on:pt(this,"input",{change:this.__addFiles})};return!0===this.multiple&&(e.attrs.multiple=!0),t("input",e)}},created:function(){this.fieldClass="q-file q-field--auto-height",this.type="file"}}),Do=t.extend({name:"QFooter",mixins:[Ot],inject:{layout:{default:function(){console.error("QFooter needs to be child of QLayout")}}},props:{value:{type:Boolean,default:!0},reveal:Boolean,bordered:Boolean,elevated:Boolean,heightHint:{type:[String,Number],default:50}},data:function(){return{size:parseInt(this.heightHint,10),revealed:!0,windowHeight:o||this.layout.container?0:window.innerHeight}},watch:{value:function(t){this.__update("space",t),this.__updateLocal("revealed",!0),this.layout.__animate()},offset:function(t){this.__update("offset",t)},reveal:function(t){!1===t&&this.__updateLocal("revealed",this.value)},revealed:function(t){this.layout.__animate(),this.$emit("reveal",t)},"layout.scroll":function(){this.__updateRevealed()},"layout.height":function(){this.__updateRevealed()},size:function(){this.__updateRevealed()},"$q.screen.height":function(t){!0!==this.layout.container&&this.__updateLocal("windowHeight",t)}},computed:{fixed:function(){return!0===this.reveal||this.layout.view.indexOf("F")>-1||!0===this.layout.container},containerHeight:function(){return!0===this.layout.container?this.layout.containerHeight:this.windowHeight},offset:function(){if(!0!==this.value)return 0;if(!0===this.fixed)return!0===this.revealed?this.size:0;var t=this.layout.scroll.position+this.containerHeight+this.size-this.layout.height;return t>0?t:0},hidden:function(){return!0!==this.value||!0===this.fixed&&!0!==this.revealed},revealOnFocus:function(){return!0===this.value&&!0===this.hidden&&!0===this.reveal},classes:function(){return(!0===this.fixed?"fixed":"absolute")+"-bottom"+(!0===this.bordered?" q-footer--bordered":"")+(!0===this.hidden?" q-footer--hidden":"")+(!0!==this.value?" q-layout--prevent-focus":"")+(!0!==this.value&&!0!==this.fixed?" hidden":"")},style:function(){var t=this.layout.rows.bottom,e={};return"l"===t[0]&&!0===this.layout.left.space&&(e[!0===this.$q.lang.rtl?"right":"left"]=this.layout.left.size+"px"),"r"===t[2]&&!0===this.layout.right.space&&(e[!0===this.$q.lang.rtl?"left":"right"]=this.layout.right.size+"px"),e},onEvents:function(){return Object.assign({},this.qListeners,{focusin:this.__onFocusin,input:_})}},render:function(t){var e=At([t(ni,{props:{debounce:0},on:pt(this,"resize",{resize:this.__onResize})})],this,"default");return!0===this.elevated&&e.push(t("div",{staticClass:"q-layout__shadow absolute-full overflow-hidden no-pointer-events"})),t("footer",{staticClass:"q-footer q-layout__section--marginal",class:this.classes,style:this.style,on:this.onEvents},e)},created:function(){this.layout.instances.footer=this,!0===this.value&&this.__update("size",this.size),this.__update("space",this.value),this.__update("offset",this.offset)},beforeDestroy:function(){this.layout.instances.footer===this&&(this.layout.instances.footer=void 0,this.__update("size",0),this.__update("offset",0),this.__update("space",!1))},methods:{__onResize:function(t){var e=t.height;this.__updateLocal("size",e),this.__update("size",e)},__update:function(t,e){this.layout.footer[t]!==e&&(this.layout.footer[t]=e)},__updateLocal:function(t,e){this[t]!==e&&(this[t]=e)},__updateRevealed:function(){if(!0===this.reveal){var t=this.layout.scroll,e=t.direction,n=t.position,i=t.inflexionPosition;this.__updateLocal("revealed","up"===e||n-i<100||this.layout.height-this.containerHeight-n-this.size<300)}},__onFocusin:function(t){!0===this.revealOnFocus&&this.__updateLocal("revealed",!0),this.$emit("focusin",t)}}}),Lo=t.extend({name:"QForm",mixins:[Ot],props:{autofocus:Boolean,noErrorFocus:Boolean,noResetFocus:Boolean,greedy:Boolean},computed:{onEvents:function(){return Object.assign({},this.qListeners,{submit:this.submit,reset:this.reset})}},mounted:function(){this.validateIndex=0,!0===this.autofocus&&this.focus()},methods:{validate:function(t){var e=this,n=[],i="boolean"==typeof t?t:!0!==this.noErrorFocus;this.validateIndex++;for(var r=this.getValidationComponents(),o=function(t,n){e.$emit("validation-"+(!0===t?"success":"error"),n)},a=function(t){var a=r[t],s=a.validate();if("function"==typeof s.then)n.push(s.then((function(t){return{valid:t,comp:a}}),(function(t){return{valid:!1,comp:a,error:t}})));else if(!0!==s){if(!1===e.greedy)return o(!1,a),!0===i&&"function"==typeof a.focus&&a.focus(),{v:Promise.resolve(!1)};n.push({valid:!1,comp:a})}},s=0;s<r.length;s++){var l=a(s);if(l)return l.v}if(0===n.length)return o(!0),Promise.resolve(!0);var c=this.validateIndex;return Promise.all(n).then((function(t){if(c===e.validateIndex){var n=t.filter((function(t){return!0!==t.valid}));if(0===n.length)return o(!0),!0;var r=n[0],a=r.valid,s=r.comp;return o(!1,s),!0===i&&!0!==a&&"function"==typeof s.focus&&s.focus(),!1}}))},resetValidation:function(){this.validateIndex++,this.getValidationComponents().forEach((function(t){t.resetValidation()}))},submit:function(t){var e=this;void 0!==t&&w(t),this.validate().then((function(n){!0===n&&(void 0!==e.qListeners.submit?e.$emit("submit",t):void 0!==t&&void 0!==t.target&&"function"==typeof t.target.submit&&t.target.submit())}))},reset:function(t){var e=this;void 0!==t&&w(t),this.$emit("reset"),this.$nextTick((function(){e.resetValidation(),!0===e.autofocus&&!0!==e.noResetFocus&&e.focus()}))},focus:function(){var t=this.$el.querySelector("[autofocus], [data-autofocus]")||Array.prototype.find.call(this.$el.querySelectorAll("[tabindex]"),(function(t){return t.tabIndex>-1}));null!=t&&t.focus()},getValidationComponents:function(){return Array.prototype.map.call(this.$el.getElementsByClassName("q-validation-component"),(function(t){return t.__vue__})).filter((function(t){return void 0!==t&&"function"==typeof t.validate}))}},render:function(t){return t("form",{staticClass:"q-form",on:this.onEvents},Bt(this,"default"))}}),qo=t.extend({name:"QHeader",mixins:[Ot],inject:{layout:{default:function(){console.error("QHeader needs to be child of QLayout")}}},props:{value:{type:Boolean,default:!0},reveal:Boolean,revealOffset:{type:Number,default:250},bordered:Boolean,elevated:Boolean,heightHint:{type:[String,Number],default:50}},data:function(){return{size:parseInt(this.heightHint,10),revealed:!0}},watch:{value:function(t){this.__update("space",t),this.__updateLocal("revealed",!0),this.layout.__animate()},offset:function(t){this.__update("offset",t)},reveal:function(t){!1===t&&this.__updateLocal("revealed",this.value)},revealed:function(t){this.layout.__animate(),this.$emit("reveal",t)},"layout.scroll":function(t){!0===this.reveal&&this.__updateLocal("revealed","up"===t.direction||t.position<=this.revealOffset||t.position-t.inflexionPosition<100)}},computed:{fixed:function(){return!0===this.reveal||this.layout.view.indexOf("H")>-1||!0===this.layout.container},offset:function(){if(!0!==this.value)return 0;if(!0===this.fixed)return!0===this.revealed?this.size:0;var t=this.size-this.layout.scroll.position;return t>0?t:0},hidden:function(){return!0!==this.value||!0===this.fixed&&!0!==this.revealed},revealOnFocus:function(){return!0===this.value&&!0===this.hidden&&!0===this.reveal},classes:function(){return(!0===this.fixed?"fixed":"absolute")+"-top"+(!0===this.bordered?" q-header--bordered":"")+(!0===this.hidden?" q-header--hidden":"")+(!0!==this.value?" q-layout--prevent-focus":"")},style:function(){var t=this.layout.rows.top,e={};return"l"===t[0]&&!0===this.layout.left.space&&(e[!0===this.$q.lang.rtl?"right":"left"]=this.layout.left.size+"px"),"r"===t[2]&&!0===this.layout.right.space&&(e[!0===this.$q.lang.rtl?"left":"right"]=this.layout.right.size+"px"),e},onEvents:function(){return Object.assign({},this.qListeners,{focusin:this.__onFocusin,input:_})}},render:function(t){var e=Et(this,"default",[]);return!0===this.elevated&&e.push(t("div",{staticClass:"q-layout__shadow absolute-full overflow-hidden no-pointer-events"})),e.push(t(ni,{props:{debounce:0},on:pt(this,"resize",{resize:this.__onResize})})),t("header",{staticClass:"q-header q-layout__section--marginal",class:this.classes,style:this.style,on:this.onEvents},e)},created:function(){this.layout.instances.header=this,!0===this.value&&this.__update("size",this.size),this.__update("space",this.value),this.__update("offset",this.offset)},beforeDestroy:function(){this.layout.instances.header===this&&(this.layout.instances.header=void 0,this.__update("size",0),this.__update("offset",0),this.__update("space",!1))},methods:{__onResize:function(t){var e=t.height;this.__updateLocal("size",e),this.__update("size",e)},__update:function(t,e){this.layout.header[t]!==e&&(this.layout.header[t]=e)},__updateLocal:function(t,e){this[t]!==e&&(this[t]=e)},__onFocusin:function(t){!0===this.revealOnFocus&&this.__updateLocal("revealed",!0),this.$emit("focusin",t)}}}),Ro={props:{ratio:[String,Number]},computed:{ratioStyle:function(){var t=this.ratio||this.naturalRatio;if(void 0!==t)return{paddingBottom:100/t+"%"}}}},Io=t.extend({name:"QImg",mixins:[Ot,Ro],props:{src:String,srcset:String,sizes:String,alt:String,width:String,height:String,placeholderSrc:String,basic:Boolean,contain:Boolean,position:{type:String,default:"50% 50%"},transition:{type:String,default:"fade"},imgClass:[Array,String,Object],imgStyle:Object,nativeContextMenu:Boolean,noDefaultSpinner:Boolean,spinnerColor:String,spinnerSize:String},data:function(){return{currentSrc:"",image:null,isLoading:!!this.src,hasError:!1,naturalRatio:void 0}},watch:{src:function(){this.__load()},srcset:function(t){this.__updateWatcher(t)}},computed:{url:function(){return this.currentSrc||this.placeholderSrc||void 0},attrs:function(){var t={role:"img"};return void 0!==this.alt&&(t["aria-label"]=this.alt),t},imgContainerStyle:function(){return Object.assign({backgroundSize:!0===this.contain?"contain":"cover",backgroundPosition:this.position},this.imgStyle,{backgroundImage:'url("'+this.url+'")'})},style:function(){return{width:this.width,height:this.height}},classes:function(){return"q-img overflow-hidden"+(!0===this.nativeContextMenu?" q-img--menu":"")}},methods:{__onLoad:function(t){this.isLoading=!1,this.hasError=!1,this.__computeRatio(t),this.__updateSrc(),this.__updateWatcher(this.srcset),this.$emit("load",this.currentSrc)},__onError:function(t){clearTimeout(this.ratioTimer),this.isLoading=!1,this.hasError=!0,this.currentSrc="",this.$emit("error",t)},__updateSrc:function(){if(void 0!==this.image&&!1===this.isLoading){var t=this.image.currentSrc||this.image.src;this.currentSrc!==t&&(this.currentSrc=t)}},__updateWatcher:function(t){t?void 0===this.unwatch&&(this.unwatch=this.$watch("$q.screen.width",this.__updateSrc)):void 0!==this.unwatch&&(this.unwatch(),this.unwatch=void 0)},__load:function(){var t=this;if(clearTimeout(this.ratioTimer),this.hasError=!1,!this.src)return this.isLoading=!1,this.image=void 0,void(this.currentSrc="");this.isLoading=!0;var e=new Image;this.image=e,e.onerror=function(n){t.image===e&&!0!==t.destroyed&&t.__onError(n)},e.onload=function(){!0!==t.destroyed&&t.image===e&&(void 0!==e.decode?e.decode().catch((function(n){t.image===e&&!0!==t.destroyed&&t.__onError(n)})).then((function(){t.image===e&&!0!==t.destroyed&&t.__onLoad(e)})):t.__onLoad(e))},e.src=this.src,this.srcset&&(e.srcset=this.srcset),void 0!==this.sizes?e.sizes=this.sizes:Object.assign(e,{height:this.height,width:this.width})},__computeRatio:function(t){var e=this,n=t.naturalHeight,i=t.naturalWidth;n||i?this.naturalRatio=0===n?1:i/n:this.ratioTimer=setTimeout((function(){e.image===t&&!0!==e.destroyed&&e.__computeRatio(t)}),100)},__getImage:function(t){var e=!0===this.nativeContextMenu?[t("img",{staticClass:"absolute-full fit",attrs:{src:this.url,"aria-hidden":"true"}})]:void 0,n=void 0!==this.url?t("div",{key:this.url,staticClass:"q-img__image absolute-full",class:this.imgClass,style:this.imgContainerStyle},e):null;return!0===this.basic?n:t("transition",{props:{name:"q-transition--"+this.transition}},[n])},__getContent:function(t){var e=Bt(this,!0===this.hasError?"error":"default");if(!0===this.basic)return t("div",{key:"content",staticClass:"q-img__content absolute-full"},e);var n=!0===this.isLoading?t("div",{key:"placeholder",staticClass:"q-img__loading absolute-full flex flex-center"},void 0!==this.$scopedSlots.loading?this.$scopedSlots.loading():!1===this.noDefaultSpinner?[t(Gt,{props:{color:this.spinnerColor,size:this.spinnerSize}})]:void 0):t("div",{key:"content",staticClass:"q-img__content absolute-full"},e);return t("transition",{props:{name:"q-transition--fade"}},[n])}},render:function(t){return t("div",{class:this.classes,style:this.style,attrs:this.attrs,on:Object.assign({},this.qListeners)},[t("div",{style:this.ratioStyle}),this.__getImage(t),this.__getContent(t)])},beforeMount:function(){if(void 0!==this.placeholderSrc&&void 0===this.ratio){var t=new Image;t.src=this.placeholderSrc,this.__computeRatio(t)}!0===this.isLoading&&this.__load()},beforeDestroy:function(){this.destroyed=!0,clearTimeout(this.ratioTimer),void 0!==this.unwatch&&this.unwatch()}}),No=t.extend({name:"QInfiniteScroll",mixins:[Ot],props:{offset:{type:Number,default:500},debounce:{type:[String,Number],default:100},scrollTarget:{default:void 0},initialIndex:Number,disable:Boolean,reverse:Boolean},data:function(){return{index:this.initialIndex||0,fetching:!1,working:!0}},watch:{disable:function(t){!0===t?this.stop():this.resume()},scrollTarget:function(){this.updateScrollTarget()},debounce:function(t){this.__setDebounce(t)}},methods:{poll:function(){if(!0!==this.disable&&!0!==this.fetching&&!1!==this.working){var t=Ne(this.__scrollTarget),e=Fe(this.__scrollTarget),n=Jt(this.__scrollTarget);!1===this.reverse?e+n+this.offset>=t&&this.trigger():e<this.offset&&this.trigger()}},trigger:function(){var t=this;if(!0!==this.disable&&!0!==this.fetching&&!1!==this.working){this.index++,this.fetching=!0;var e=Ne(this.__scrollTarget);this.$emit("load",this.index,(function(n){!0===t.working&&(t.fetching=!1,t.$nextTick((function(){if(!0===t.reverse){var i=Ne(t.__scrollTarget),r=Fe(t.__scrollTarget),o=i-e;We(t.__scrollTarget,r+o)}!0===n?t.stop():t.$el.closest("body")&&t.poll()})))}))}},reset:function(){this.index=0},resume:function(){!1===this.working&&(this.working=!0,this.__scrollTarget.addEventListener("scroll",this.poll,f.passive)),this.immediatePoll()},stop:function(){!0===this.working&&(this.working=!1,this.fetching=!1,this.__scrollTarget.removeEventListener("scroll",this.poll,f.passive))},updateScrollTarget:function(){this.__scrollTarget&&!0===this.working&&this.__scrollTarget.removeEventListener("scroll",this.poll,f.passive),this.__scrollTarget=Ie(this.$el,this.scrollTarget),!0===this.working&&this.__scrollTarget.addEventListener("scroll",this.poll,f.passive)},setIndex:function(t){this.index=t},__setDebounce:function(t){t=parseInt(t,10),this.poll=t<=0?this.immediatePoll:T(this.immediatePoll,!0===isNaN(t)?100:t)}},mounted:function(){if(this.immediatePoll=this.poll,this.__setDebounce(this.debounce),this.updateScrollTarget(),this.immediatePoll(),!0===this.reverse){var t=Ne(this.__scrollTarget),e=Jt(this.__scrollTarget);We(this.__scrollTarget,t-e)}},beforeDestroy:function(){!0===this.working&&this.__scrollTarget.removeEventListener("scroll",this.poll,f.passive)},render:function(t){var e=Et(this,"default",[]);return!0!==this.disable&&!0===this.working&&e[!1===this.reverse?"push":"unshift"](t("div",{staticClass:"q-infinite-scroll__loading",class:!0===this.fetching?"":"invisible"},Bt(this,"loading"))),t("div",{staticClass:"q-infinite-scroll",on:Object.assign({},this.qListeners)},e)}}),Fo=t.extend({name:"QInnerLoading",mixins:[Ot,It,Pe],props:{showing:Boolean,color:String,size:{type:[String,Number],default:42}},render:function(t){var e=!0===this.showing?[t("div",{staticClass:"q-inner-loading absolute-full column flex-center",class:!0===this.isDark?"q-inner-loading--dark":null,on:Object.assign({},this.qListeners)},void 0!==this.$scopedSlots.default?this.$scopedSlots.default():[t(Gt,{props:{size:this.size,color:this.color}})])]:void 0;return t("transition",{props:{name:this.transition,appear:!0}},e)}}),$o={threshold:0,root:null,rootMargin:"0px"};function jo(t,e,n){var i,r,o;"function"==typeof n?(i=n,r=$o,o=void 0===e.cfg):(i=n.handler,r=Object.assign({},$o,n.cfg),o=void 0===e.cfg||!1===Cn(e.cfg,r)),e.handler!==i&&(e.handler=i),!0===o&&(e.cfg=r,void 0!==e.observer&&e.observer.unobserve(t),e.observer=new IntersectionObserver((function(n){var i=n[0];if("function"==typeof e.handler){if(null===i.rootBounds&&(void 0!==t.__vue__?!0!==t.__vue__._inactive:!0===document.body.contains(t)))return e.observer.unobserve(t),void e.observer.observe(t);(!1===e.handler(i,e.observer)||!0===e.once&&!0===i.isIntersecting)&&zo(t)}}),r),e.observer.observe(t))}function zo(t){var e=t.__qvisible;void 0!==e&&(void 0!==e.observer&&e.observer.unobserve(t),delete t.__qvisible)}var Vo={name:"intersection",inserted:function(t,e){var n=e.modifiers,i=e.value;void 0!==t.__qvisible&&(zo(t),t.__qvisible_destroyed=!0);var r={once:!0===n.once};jo(t,r,i),t.__qvisible=r},update:function(t,e){var n=t.__qvisible;void 0!==n&&jo(t,n,e.value)},unbind:function(t){void 0===t.__qvisible_destroyed?zo(t):delete t.__qvisible_destroyed}},Ho=t.extend({name:"QIntersection",mixins:[Pt,Ot],directives:{Intersection:Vo},props:{once:Boolean,transition:String,ssrPrerender:Boolean,margin:String,threshold:[Number,Array],disable:Boolean},data:function(){return{showing:!0===o&&this.ssrPrerender}},computed:{value:function(){return void 0!==this.margin||void 0!==this.threshold?{handler:this.__trigger,cfg:{rootMargin:this.margin,threshold:this.threshold}}:this.__trigger},directives:function(){if(!0!==this.disable&&(!0!==o||!0!==this.once||!0!==this.ssrPrerender))return[{name:"intersection",value:this.value,modifiers:{once:this.once}}]}},methods:{__trigger:function(t){this.showing!==t.isIntersecting&&(this.showing=t.isIntersecting,void 0!==this.qListeners.visibility&&this.$emit("visibility",this.showing))}},render:function(t){var e=!0===this.showing?[t("div",{key:"content"},Bt(this,"default"))]:void 0;return t(this.tag,{staticClass:"q-intersection",on:Object.assign({},this.qListeners),directives:this.directives},this.transition?[t("transition",{props:{name:"q-transition--"+this.transition}},e)]:e)}}),Wo=[34,37,40,33,39,38],Uo=t.extend({name:"QKnob",mixins:[{props:Nn.options.props},ln],directives:{TouchPan:Gn},props:{step:{type:Number,default:1,validator:function(t){return t>=0}},tabindex:{type:[Number,String],default:0},disable:Boolean,readonly:Boolean},data:function(){return{model:this.value,dragging:!1}},watch:{value:function(t){if(t<this.min)this.model=this.min;else{if(!(t>this.max))return void(t!==this.model&&(this.model=t));this.model=this.max}this.model!==this.value&&(this.$emit("input",this.model),this.$emit("change",this.model))}},computed:{classes:function(){return"q-knob non-selectable"+(!0===this.editable?" q-knob--editable":!0===this.disable?" disabled":"")},editable:function(){return!1===this.disable&&!1===this.readonly},decimals:function(){return(String(this.step).trim("0").split(".")[1]||"").length},computedStep:function(){return 0===this.step?1:this.step},computedInstantFeedback:function(){return!0===this.instantFeedback||!0===this.dragging},onEvents:function(){return!0===this.$q.platform.is.mobile?{click:this.__click}:{mousedown:this.__activate,click:this.__click,keydown:this.__keydown,keyup:this.__keyup}},attrs:function(){var t={role:"slider","aria-valuemin":this.min,"aria-valuemax":this.max,"aria-valuenow":this.value};return!0===this.editable?t.tabindex=this.tabindex:t["aria-"+(!0===this.disable?"disabled":"readonly")]="",t}},methods:{__updateCenterPosition:function(){var t=this.$el.getBoundingClientRect(),e=t.top,n=t.left,i=t.width,r=t.height;this.centerPosition={top:e+r/2,left:n+i/2}},__pan:function(t){t.isFinal?(this.__updatePosition(t.evt,!0),this.dragging=!1):t.isFirst?(this.__updateCenterPosition(),this.dragging=!0,this.__updatePosition(t.evt)):this.__updatePosition(t.evt)},__click:function(t){this.__updateCenterPosition(),this.__updatePosition(t,!0)},__keydown:function(t){if(Wo.includes(t.keyCode)){w(t);var e=([34,33].includes(t.keyCode)?10:1)*this.computedStep,n=[34,37,40].includes(t.keyCode)?-e:e;this.model=ut(parseFloat((this.model+n).toFixed(this.decimals)),this.min,this.max),this.__updateValue()}},__keyup:function(t){Wo.includes(t.keyCode)&&this.__updateValue(!0)},__activate:function(t){this.__updateCenterPosition(),this.__updatePosition(t)},__updatePosition:function(t,e){var n=this.centerPosition,i=g(t),r=Math.abs(i.top-n.top),o=Math.sqrt(Math.pow(r,2)+Math.pow(Math.abs(i.left-n.left),2)),a=Math.asin(r/o)*(180/Math.PI);a=i.top<n.top?n.left<i.left?90-a:270+a:n.left<i.left?a+90:270-a,this.angle&&(a=dt(a-this.angle,0,360)),!0===this.$q.lang.rtl&&(a=360-a);var s=this.min+a/360*(this.max-this.min);if(0!==this.step){var l=this.computedStep,c=s%l;s=s-c+(Math.abs(c)>=l/2?(c<0?-1:1)*l:0),s=parseFloat(s.toFixed(this.decimals))}s=ut(s,this.min,this.max),this.$emit("drag-value",s),this.model!==s&&(this.model=s),this.__updateValue(e)},__updateValue:function(t){this.value!==this.model&&this.$emit("input",this.model),!0===t&&this.$emit("change",this.model)},__getNameInput:function(){return this.$createElement("input",{attrs:this.formAttrs})}},render:function(t){var e={class:this.classes,attrs:this.attrs,props:Object.assign({},this.$props,{value:this.model,instantFeedback:this.computedInstantFeedback})};return!0===this.editable&&(e.on=this.onEvents,e.directives=pt(this,"dir",[{name:"touch-pan",value:this.__pan,modifiers:{prevent:!0,stop:!0,mouse:!0}}]),void 0!==this.name&&(e.scopedSlots={internal:this.__getNameInput})),t(Nn,e,Bt(this,"default"))}}),Yo=f.passive,Qo=t.extend({name:"QScrollObserver",props:{debounce:[String,Number],horizontal:Boolean,scrollTarget:{default:void 0}},render:m,data:function(){return{pos:0,dir:!0===this.horizontal?"right":"down",dirChanged:!1,dirChangePos:0}},watch:{scrollTarget:function(){this.__unconfigureScrollTarget(),this.__configureScrollTarget()}},methods:{getPosition:function(){return{position:this.pos,direction:this.dir,directionChanged:this.dirChanged,inflexionPosition:this.dirChangePos}},trigger:function(t){!0===t||0===this.debounce||"0"===this.debounce?this.__emit():this.timer||(this.timer=this.debounce?setTimeout(this.__emit,this.debounce):requestAnimationFrame(this.__emit))},__emit:function(){var t=!0===this.horizontal?$e:Fe,e=Math.max(0,t(this.__scrollTarget)),n=e-this.pos,i=!0===this.horizontal?n<0?"left":"right":n<0?"up":"down";this.dirChanged=this.dir!==i,this.dirChanged&&(this.dir=i,this.dirChangePos=this.pos),this.timer=null,this.pos=e,this.$emit("scroll",this.getPosition())},__configureScrollTarget:function(){this.__scrollTarget=Ie(this.$el.parentNode,this.scrollTarget),this.__scrollTarget.addEventListener("scroll",this.trigger,Yo),this.trigger(!0)},__unconfigureScrollTarget:function(){void 0!==this.__scrollTarget&&(this.__scrollTarget.removeEventListener("scroll",this.trigger,Yo),this.__scrollTarget=void 0)}},mounted:function(){this.__configureScrollTarget()},beforeDestroy:function(){clearTimeout(this.timer),cancelAnimationFrame(this.timer),this.__unconfigureScrollTarget()}}),Go=t.extend({name:"QLayout",mixins:[Ot],provide:function(){return{layout:this}},props:{container:Boolean,view:{type:String,default:"hhh lpr fff",validator:function(t){return/^(h|l)h(h|r) lpr (f|l)f(f|r)$/.test(t.toLowerCase())}}},data:function(){return{height:this.$q.screen.height,width:!0===this.container?0:this.$q.screen.width,containerHeight:0,scrollbarWidth:!0===o?0:Ye(),header:{size:0,offset:0,space:!1},right:{size:300,offset:0,space:!1},footer:{size:0,offset:0,space:!1},left:{size:300,offset:0,space:!1},scroll:{position:0,direction:"down"}}},computed:{rows:function(){var t=this.view.toLowerCase().split(" ");return{top:t[0].split(""),middle:t[1].split(""),bottom:t[2].split("")}},style:function(){return!0===this.container?null:{minHeight:this.$q.screen.height+"px"}},targetStyle:function(){var t;if(0!==this.scrollbarWidth)return(t={})[!0===this.$q.lang.rtl?"left":"right"]=this.scrollbarWidth+"px",t},targetChildStyle:function(){var t;if(0!==this.scrollbarWidth)return(t={})[!0===this.$q.lang.rtl?"right":"left"]=0,t[!0===this.$q.lang.rtl?"left":"right"]="-"+this.scrollbarWidth+"px",t.width="calc(100% + "+this.scrollbarWidth+"px)",t},totalWidth:function(){return this.width+this.scrollbarWidth},classes:function(){return"q-layout q-layout--"+(!0===this.container?"containerized":"standard")}},created:function(){this.instances={}},render:function(t){var e=t("div",{class:this.classes,style:this.style,on:Object.assign({},this.qListeners)},At([t(Qo,{on:pt(this,"scroll",{scroll:this.__onPageScroll})}),t(ni,{on:pt(this,"resizeOut",{resize:this.__onPageResize})})],this,"default"));return!0===this.container?t("div",{staticClass:"q-layout-container overflow-hidden"},[t(ni,{on:pt(this,"resizeIn",{resize:this.__onContainerResize})}),t("div",{staticClass:"absolute-full",style:this.targetStyle},[t("div",{staticClass:"scroll",style:this.targetChildStyle},[e])])]):e},methods:{__animate:function(){var t=this;void 0!==this.timer?clearTimeout(this.timer):document.body.classList.add("q-body--layout-animate"),this.timer=setTimeout((function(){document.body.classList.remove("q-body--layout-animate"),t.timer=void 0}),150)},__onPageScroll:function(t){!0!==this.container&&!0===document.qScrollPrevented||(this.scroll=t),void 0!==this.qListeners.scroll&&this.$emit("scroll",t)},__onPageResize:function(t){var e=t.height,n=t.width,i=!1;this.height!==e&&(i=!0,this.height=e,void 0!==this.qListeners["scroll-height"]&&this.$emit("scroll-height",e),this.__updateScrollbarWidth()),this.width!==n&&(i=!0,this.width=n),!0===i&&void 0!==this.qListeners.resize&&this.$emit("resize",{height:e,width:n})},__onContainerResize:function(t){var e=t.height;this.containerHeight!==e&&(this.containerHeight=e,this.__updateScrollbarWidth())},__updateScrollbarWidth:function(){if(!0===this.container){var t=this.height>this.containerHeight?Ye():0;this.scrollbarWidth!==t&&(this.scrollbarWidth=t)}}}}),Ko=t.extend({name:"QMarkupTable",mixins:[It,Ot],props:{dense:Boolean,flat:Boolean,bordered:Boolean,square:Boolean,separator:{type:String,default:"horizontal",validator:function(t){return["horizontal","vertical","cell","none"].includes(t)}},wrapCells:Boolean},computed:{classes:function(){return"q-table--"+this.separator+"-separator"+(!0===this.isDark?" q-table--dark q-table__card--dark q-dark":"")+(!0===this.dense?" q-table--dense":"")+(!0===this.flat?" q-table--flat":"")+(!0===this.bordered?" q-table--bordered":"")+(!0===this.square?" q-table--square":"")+(!1===this.wrapCells?" q-table--no-wrap":"")}},render:function(t){return t("div",{staticClass:"q-markup-table q-table__container q-table__card",class:this.classes,on:Object.assign({},this.qListeners)},[t("table",{staticClass:"q-table"},Bt(this,"default"))])}}),Jo=t.extend({name:"QNoSsr",mixins:[ei,Pt,Ot],props:{placeholder:String},render:function(t){var e={on:Object.assign({},this.qListeners)};if(!0===this.canRender){var n=Bt(this,"default");return void 0===n?n:n.length>1?t(this.tag,e,n):n[0]}e.staticClass="q-no-ssr-placeholder";var i=Bt(this,"placeholder");return void 0!==i?i.length>1?t(this.tag,e,i):i[0]:void 0!==this.placeholder?t(this.tag,e,[this.placeholder]):void 0}}),Zo=t.extend({name:"QRadio",mixins:[It,En,ln,An],props:{value:{required:!0},val:{required:!0},label:String,leftLabel:Boolean,color:String,keepColor:Boolean,dense:Boolean,disable:Boolean,tabindex:[String,Number]},computed:{isTrue:function(){return this.value===this.val},classes:function(){return"q-radio cursor-pointer no-outline row inline no-wrap items-center"+(!0===this.disable?" disabled":"")+(!0===this.isDark?" q-radio--dark":"")+(!0===this.dense?" q-radio--dense":"")+(!0===this.leftLabel?" reverse":"")},innerClass:function(){var t=void 0===this.color||!0!==this.keepColor&&!0!==this.isTrue?"":" text-"+this.color;return"q-radio__inner--"+(!0===this.isTrue?"truthy":"falsy")+t},computedTabindex:function(){return!0===this.disable?-1:this.tabindex||0},formAttrs:function(){var t={type:"radio"};return void 0!==this.name&&Object.assign(t,{name:this.name,value:this.val}),t},formDomProps:function(){if(void 0!==this.name&&!0===this.isTrue)return{checked:!0}},attrs:function(){var t={tabindex:this.computedTabindex,role:"radio","aria-label":this.label,"aria-checked":!0===this.isTrue?"true":"false"};return!0===this.disable&&(t["aria-disabled"]="true"),t}},methods:{set:function(t){void 0!==t&&(w(t),this.__refocusTarget(t)),!0!==this.disable&&!0!==this.isTrue&&this.$emit("input",this.val,t)}},render:function(t){var e=this,n=[t("svg",{staticClass:"q-radio__bg absolute",attrs:{focusable:"false",viewBox:"0 0 24 24","aria-hidden":"true"}},[t("path",{attrs:{d:"M12,22a10,10 0 0 1 -10,-10a10,10 0 0 1 10,-10a10,10 0 0 1 10,10a10,10 0 0 1 -10,10m0,-22a12,12 0 0 0 -12,12a12,12 0 0 0 12,12a12,12 0 0 0 12,-12a12,12 0 0 0 -12,-12"}}),t("path",{staticClass:"q-radio__check",attrs:{d:"M12,6a6,6 0 0 0 -6,6a6,6 0 0 0 6,6a6,6 0 0 0 6,-6a6,6 0 0 0 -6,-6"}})])];!0!==this.disable&&this.__injectFormInput(n,"unshift","q-radio__native q-ma-none q-pa-none invisible");var i=[t("div",{staticClass:"q-radio__inner relative-position no-pointer-events",class:this.innerClass,style:this.sizeStyle},n)];void 0!==this.__refocusTargetEl&&i.push(this.__refocusTargetEl);var r=void 0!==this.label?At([this.label],this,"default"):Bt(this,"default");return void 0!==r&&i.push(t("div",{staticClass:"q-radio__label q-anchor--skip"},r)),t("div",{class:this.classes,attrs:this.attrs,on:pt(this,"inpExt",{click:this.set,keydown:function(t){13!==t.keyCode&&32!==t.keyCode||w(t)},keyup:function(t){13!==t.keyCode&&32!==t.keyCode||e.set(t)}})},i)}}),Xo=t.extend({name:"QToggle",mixins:[Dn],props:{icon:String,checkedIcon:String,uncheckedIcon:String,indeterminateIcon:String,iconColor:String},computed:{computedIcon:function(){return(!0===this.isTrue?this.checkedIcon:!0===this.isIndeterminate?this.indeterminateIcon:this.uncheckedIcon)||this.icon},computedIconColor:function(){if(!0===this.isTrue)return this.iconColor}},methods:{__getInner:function(t){return[t("div",{staticClass:"q-toggle__track"}),t("div",{staticClass:"q-toggle__thumb absolute flex flex-center no-wrap"},void 0!==this.computedIcon?[t(Lt,{props:{name:this.computedIcon,color:this.computedIconColor}})]:void 0)]}},created:function(){this.type="toggle"}}),ta={radio:Zo,checkbox:Ln,toggle:Xo},ea=Object.keys(ta),na=t.extend({name:"QOptionGroup",mixins:[It,Ot],props:{value:{required:!0},options:{type:Array,validator:function(t){return t.every((function(t){return"value"in t&&"label"in t}))}},name:String,type:{default:"radio",validator:function(t){return ea.includes(t)}},color:String,keepColor:Boolean,dense:Boolean,size:String,leftLabel:Boolean,inline:Boolean,disable:Boolean},computed:{component:function(){return ta[this.type]},model:function(){return Array.isArray(this.value)?this.value.slice():this.value},classes:function(){return"q-option-group q-gutter-x-sm"+(!0===this.inline?" q-option-group--inline":"")},attrs:function(){if("radio"===this.type){var t={role:"radiogroup"};return!0===this.disable&&(t["aria-disabled"]="true"),t}}},methods:{__update:function(t){this.$emit("input",t)}},created:function(){var t=Array.isArray(this.value);"radio"===this.type?t&&console.error("q-option-group: model should not be array"):!1===t&&console.error("q-option-group: model should be array in your case")},render:function(t){var e=this;return t("div",{class:this.classes,attrs:this.attrs,on:Object.assign({},this.qListeners)},this.options.map((function(n){return t("div",[t(e.component,{props:{value:e.value,val:n.value,name:e.name||n.name,disable:e.disable||n.disable,label:n.label,leftLabel:e.leftLabel||n.leftLabel,color:n.color||e.color,checkedIcon:n.checkedIcon,uncheckedIcon:n.uncheckedIcon,dark:n.dark||e.isDark,size:n.size||e.size,dense:e.dense,keepColor:n.keepColor||e.keepColor},on:pt(e,"inp",{input:e.__update})})])})))}}),ia=t.extend({name:"QPage",mixins:[Ot],inject:{pageContainer:{default:function(){console.error("QPage needs to be child of QPageContainer")}},layout:{}},props:{padding:Boolean,styleFn:Function},computed:{style:function(){var t=(!0===this.layout.header.space?this.layout.header.size:0)+(!0===this.layout.footer.space?this.layout.footer.size:0);if("function"==typeof this.styleFn){var e=!0===this.layout.container?this.layout.containerHeight:this.$q.screen.height;return this.styleFn(t,e)}return{minHeight:!0===this.layout.container?this.layout.containerHeight-t+"px":0===this.$q.screen.height?"calc(100vh - "+t+"px)":this.$q.screen.height-t+"px"}},classes:function(){if(!0===this.padding)return"q-layout-padding"}},render:function(t){return t("main",{staticClass:"q-page",style:this.style,class:this.classes,on:Object.assign({},this.qListeners)},Bt(this,"default"))}}),ra=t.extend({name:"QPageContainer",mixins:[Ot],inject:{layout:{default:function(){console.error("QPageContainer needs to be child of QLayout")}}},provide:{pageContainer:!0},computed:{style:function(){var t={};return!0===this.layout.header.space&&(t.paddingTop=this.layout.header.size+"px"),!0===this.layout.right.space&&(t["padding"+(!0===this.$q.lang.rtl?"Left":"Right")]=this.layout.right.size+"px"),!0===this.layout.footer.space&&(t.paddingBottom=this.layout.footer.size+"px"),!0===this.layout.left.space&&(t["padding"+(!0===this.$q.lang.rtl?"Right":"Left")]=this.layout.left.size+"px"),t}},render:function(t){return t("div",{staticClass:"q-page-container",style:this.style,on:Object.assign({},this.qListeners)},Bt(this,"default"))}}),oa=t.extend({name:"QPageSticky",mixins:[Ot],inject:{layout:{default:function(){console.error("QPageSticky needs to be child of QLayout")}}},props:{position:{type:String,default:"bottom-right",validator:function(t){return["top-right","top-left","bottom-right","bottom-left","top","right","bottom","left"].includes(t)}},offset:{type:Array,validator:function(t){return 2===t.length}},expand:Boolean},computed:{attach:function(){var t=this.position;return{top:t.indexOf("top")>-1,right:t.indexOf("right")>-1,bottom:t.indexOf("bottom")>-1,left:t.indexOf("left")>-1,vertical:"top"===t||"bottom"===t,horizontal:"left"===t||"right"===t}},top:function(){return this.layout.header.offset},right:function(){return this.layout.right.offset},bottom:function(){return this.layout.footer.offset},left:function(){return this.layout.left.offset},style:function(){var t=0,e=0,n=this.attach,i=!0===this.$q.lang.rtl?-1:1;!0===n.top&&0!==this.top?e=this.top+"px":!0===n.bottom&&0!==this.bottom&&(e=-this.bottom+"px"),!0===n.left&&0!==this.left?t=i*this.left+"px":!0===n.right&&0!==this.right&&(t=-i*this.right+"px");var r={transform:"translate("+t+", "+e+")"};return this.offset&&(r.margin=this.offset[1]+"px "+this.offset[0]+"px"),!0===n.vertical?(0!==this.left&&(r[!0===this.$q.lang.rtl?"right":"left"]=this.left+"px"),0!==this.right&&(r[!0===this.$q.lang.rtl?"left":"right"]=this.right+"px")):!0===n.horizontal&&(0!==this.top&&(r.top=this.top+"px"),0!==this.bottom&&(r.bottom=this.bottom+"px")),r},classes:function(){return"fixed-"+this.position+" q-page-sticky--"+(!0===this.expand?"expand":"shrink")}},render:function(t){var e=Bt(this,"default");return t("div",{staticClass:"q-page-sticky row flex-center",class:this.classes,style:this.style,on:Object.assign({},this.qListeners)},!0===this.expand?e:[t("div",e)])}}),aa=t.extend({name:"QPageScroller",mixins:[oa],props:{scrollOffset:{type:Number,default:1e3},reverse:Boolean,duration:{type:Number,default:300},offset:{default:function(){return[18,18]}}},inject:{layout:{default:function(){console.error("QPageScroller needs to be used within a QLayout")}}},data:function(){return{showing:this.__isVisible()}},computed:{height:function(){return!0===this.layout.container?this.layout.containerHeight:this.layout.height},onEvents:function(){return Object.assign({},this.qListeners,{click:this.__onClick})}},watch:{"layout.scroll.position":function(){this.__updateVisibility()},reverse:{handler:function(t){!0===t?void 0===this.heightWatcher&&(this.heightWatcher=this.$watch("height",this.__updateVisibility)):void 0!==this.heightWatcher&&this.__cleanup()},immediate:!0}},methods:{__isVisible:function(){return!0===this.reverse?this.height-this.layout.scroll.position>this.scrollOffset:this.layout.scroll.position>this.scrollOffset},__onClick:function(t){We(!0===this.layout.container?Ie(this.$el):Ie(this.layout.$el),!0===this.reverse?this.layout.height:0,this.duration),this.$emit("click",t)},__updateVisibility:function(){var t=this.__isVisible();this.showing!==t&&(this.showing=t)},__cleanup:function(){this.heightWatcher(),this.heightWatcher=void 0}},render:function(t){return t("transition",{props:{name:"q-transition--fade"}},!0===this.showing?[t("div",{staticClass:"q-page-scroller",on:this.onEvents},[oa.options.render.call(this,t)])]:null)},beforeDestroy:function(){void 0!==this.heightWatcher&&this.__cleanup()}}),sa=t.extend({name:"QPagination",mixins:[It,Ot],props:{value:{type:Number,required:!0},min:{type:Number,default:1},max:{type:Number,required:!0},color:{type:String,default:"primary"},textColor:String,inputStyle:[Array,String,Object],inputClass:[Array,String,Object],size:String,disable:Boolean,input:Boolean,iconPrev:String,iconNext:String,iconFirst:String,iconLast:String,toFn:Function,boundaryLinks:{type:Boolean,default:null},boundaryNumbers:{type:Boolean,default:null},directionLinks:{type:Boolean,default:null},ellipses:{type:Boolean,default:null},maxPages:{type:Number,default:0,validator:function(t){return t>=0}},ripple:{type:[Boolean,Object],default:null}},data:function(){return{newPage:null}},watch:{min:function(){this.model=this.value},max:function(){this.model=this.value}},computed:{model:{get:function(){return this.value},set:function(t){if(t=parseInt(t,10),!this.disable&&!isNaN(t)&&0!==t){var e=ut(t,this.min,this.max);this.$emit("input",e)}}},inputPlaceholder:function(){return this.model+" / "+this.max},__boundaryLinks:function(){return this.__getBool(this.boundaryLinks,this.input)},__boundaryNumbers:function(){return this.__getBool(this.boundaryNumbers,!this.input)},__directionLinks:function(){return this.__getBool(this.directionLinks,this.input)},__ellipses:function(){return this.__getBool(this.ellipses,!this.input)},icons:function(){var t=[this.iconFirst||this.$q.iconSet.pagination.first,this.iconPrev||this.$q.iconSet.pagination.prev,this.iconNext||this.$q.iconSet.pagination.next,this.iconLast||this.$q.iconSet.pagination.last];return!0===this.$q.lang.rtl?t.reverse():t},attrs:function(){if(!0===this.disable)return{"aria-disabled":"true"}},btnProps:function(){return{color:this.color,flat:!0,size:this.size,ripple:null===this.ripple||this.ripple}}},methods:{set:function(t){this.model=t},setByOffset:function(t){this.model=this.model+t},__update:function(){this.model=this.newPage,this.newPage=null},__getBool:function(t,e){return[!0,!1].includes(t)?t:e},__getBtn:function(t,e,n,i){var r=this;return e.props=Object.assign({},this.btnProps,n),void 0!==i&&(void 0!==this.toFn?e.props.to=this.toFn(i):e.on={click:function(){return r.set(i)}}),t(_e,e)}},render:function(t){var e=this,n=[],i=[],r=[];if(this.__boundaryLinks&&(n.push(this.__getBtn(t,{key:"bls"},{disable:this.disable||this.value<=this.min,icon:this.icons[0]},this.min)),i.unshift(this.__getBtn(t,{key:"ble"},{disable:this.disable||this.value>=this.max,icon:this.icons[3]},this.max))),this.__directionLinks&&(n.push(this.__getBtn(t,{key:"bdp"},{disable:this.disable||this.value<=this.min,icon:this.icons[1]},this.value-1)),i.unshift(this.__getBtn(t,{key:"bdn"},{disable:this.disable||this.value>=this.max,icon:this.icons[2]},this.value+1))),!0===this.input)r.push(t(Qr,{staticClass:"inline",style:{width:this.inputPlaceholder.length/1.5+"em"},props:{type:"number",dense:!0,value:this.newPage,disable:this.disable,dark:this.isDark,borderless:!0,inputClass:this.inputClass,inputStyle:this.inputStyle},attrs:{placeholder:this.inputPlaceholder,min:this.min,max:this.max},on:pt(this,"inp",{input:function(t){e.newPage=t},keyup:function(t){!0===X(t,13)&&e.__update()},blur:this.__update})}));else{var o=Math.max(this.maxPages,1+(this.__ellipses?2:0)+(this.__boundaryNumbers?2:0)),a=this.min,s=this.max,l=!1,c=!1,u=!1,d=!1;this.maxPages&&o<this.max-this.min+1&&(o=1+2*Math.floor(o/2),a=Math.max(this.min,Math.min(this.max-o+1,this.value-Math.floor(o/2))),s=Math.min(this.max,a+o-1),this.__boundaryNumbers&&(u=!0,a+=1),this.__ellipses&&a>this.min+(this.__boundaryNumbers?1:0)&&(l=!0,a+=1),this.__boundaryNumbers&&(d=!0,s-=1),this.__ellipses&&s<this.max-(this.__boundaryNumbers?1:0)&&(c=!0,s-=1));var h={minWidth:Math.max(2,String(this.max).length)+"em"};if(u){var f=this.min===this.value;n.push(this.__getBtn(t,{key:"bns",style:h},{disable:this.disable,flat:!f,textColor:f?this.textColor:null,label:this.min},this.min))}if(d){var p=this.max===this.value;i.unshift(this.__getBtn(t,{key:"bne",style:h},{disable:this.disable,flat:!p,textColor:p?this.textColor:null,label:this.max},this.max))}l&&n.push(this.__getBtn(t,{key:"bes",style:h},{disable:this.disable,label:"…",ripple:!1},a-1)),c&&i.unshift(this.__getBtn(t,{key:"bee",style:h},{disable:this.disable,label:"…",ripple:!1},s+1));for(var m=a;m<=s;m++){var v=m===this.value;r.push(this.__getBtn(t,{key:"bpg"+m,style:h},{disable:this.disable,flat:!v,textColor:v?this.textColor:null,label:m},m))}}return t("div",{staticClass:"q-pagination row no-wrap items-center",class:{disabled:this.disable},attrs:this.attrs,on:Object.assign({},this.qListeners)},[n,t("div",{staticClass:"row justify-center",on:!0===this.input?pt(this,"stop",{input:_}):null},[r]),i])}});function la(t){var e,n,i=!1;function r(){var r=this;n=arguments,!0!==i&&(i=!0,e=requestAnimationFrame((function(){t.apply(r,n),n=void 0,i=!1})))}return r.cancel=function(){window.cancelAnimationFrame(e),i=!1},r}var ca=f.passive,ua=t.extend({name:"QParallax",mixins:[Ot],props:{src:String,height:{type:Number,default:500},speed:{type:Number,default:1,validator:function(t){return t>=0&&t<=1}},scrollTarget:{default:void 0}},data:function(){return{scrolling:!1,percentScrolled:0}},watch:{height:function(){!0===this.working&&this.__updatePos()},scrollTarget:function(){!0===this.working&&(this.__stop(),this.__start())}},methods:{__update:function(t){this.percentScrolled=t,void 0!==this.qListeners.scroll&&this.$emit("scroll",t)},__updatePos:function(){var t,e,n;this.__scrollTarget===window?(t=0,n=e=window.innerHeight):n=(t=Kt(this.__scrollTarget).top)+(e=Jt(this.__scrollTarget));var i=Kt(this.$el).top,r=i+this.height;if(void 0!==this.observer||r>t&&i<n){var o=(n-i)/(this.height+e);this.__setPos((this.mediaHeight-this.height)*o*this.speed),this.__update(o)}},__setPos:function(t){this.media.style.transform="translate3D(-50%,"+Math.round(t)+"px, 0)"},__onResize:function(){this.mediaHeight=this.media.naturalHeight||this.media.videoHeight||Jt(this.media),!0===this.working&&this.__updatePos()},__start:function(){this.working=!0,this.__scrollTarget=Ie(this.$el,this.scrollTarget),this.__scrollTarget.addEventListener("scroll",this.__updatePos,ca),window.addEventListener("resize",this.__resizeHandler,ca),this.__updatePos()},__stop:function(){!0===this.working&&(this.working=!1,this.__scrollTarget.removeEventListener("scroll",this.__updatePos,ca),window.removeEventListener("resize",this.__resizeHandler,ca),this.__scrollTarget=void 0)}},render:function(t){return t("div",{staticClass:"q-parallax",style:{height:this.height+"px"},on:Object.assign({},this.qListeners)},[t("div",{ref:"mediaParent",staticClass:"q-parallax__media absolute-full"},void 0!==this.$scopedSlots.media?this.$scopedSlots.media():[t("img",{ref:"media",attrs:{src:this.src}})]),t("div",{staticClass:"q-parallax__content absolute-full column flex-center"},void 0!==this.$scopedSlots.content?this.$scopedSlots.content({percentScrolled:this.percentScrolled}):Bt(this,"default"))])},mounted:function(){var t=this;this.__setPos=la(this.__setPos),this.__update=la(this.__update),this.__resizeHandler=la(this.__onResize),this.media=void 0!==this.$scopedSlots.media?this.$refs.mediaParent.children[0]:this.$refs.media,this.media.onload=this.media.onloadstart=this.media.loadedmetadata=this.__onResize,this.__onResize(),this.media.style.display="initial",void 0!==window.IntersectionObserver?(this.observer=new IntersectionObserver((function(e){t[!0===e[0].isIntersecting?"__start":"__stop"]()})),this.observer.observe(this.$el)):this.__start()},beforeDestroy:function(){this.__stop(),void 0!==this.observer&&this.observer.disconnect(),this.media.onload=this.media.onloadstart=this.media.loadedmetadata=null}});function da(t){var e=JSON.stringify(t);if(e)return JSON.parse(e)}var ha=t.extend({name:"QPopupEdit",mixins:[yt],props:{value:{required:!0},title:String,buttons:Boolean,labelSet:String,labelCancel:String,color:{type:String,default:"primary"},validate:{type:Function,default:function(){return!0}},autoSave:Boolean,cover:{type:Boolean,default:!0},contentClass:String,disable:Boolean},data:function(){return{initialValue:""}},computed:{classes:function(){return"q-popup-edit"+(void 0!==this.contentClass?" "+this.contentClass:"")},defaultSlotScope:function(){return{initialValue:this.initialValue,value:this.value,emitValue:this.__emitValue,validate:this.validate,set:this.set,cancel:this.cancel}},menuProps:function(){return Object.assign({},this.qAttrs,{cover:this.cover,contentClass:this.classes})}},methods:{set:function(){if(!0===this.__hasChanged()){if(!1===this.validate(this.value))return;this.$emit("save",this.value,this.initialValue)}this.__close()},cancel:function(){!0===this.__hasChanged()&&(this.$emit("input",this.initialValue),this.$emit("cancel",this.value,this.initialValue)),this.__close()},show:function(t){void 0!==this.$refs.menu&&this.$refs.menu.show(t)},hide:function(t){void 0!==this.$refs.menu&&this.$refs.menu.hide(t)},__hasChanged:function(){return!1===Cn(this.value,this.initialValue)},__emitValue:function(t){!0!==this.disable&&this.$emit("input",t)},__close:function(){this.validated=!0,!0===this.$refs.menu.showing&&this.$refs.menu.hide()},__reposition:function(){var t=this;this.$nextTick((function(){t.$refs.menu.updatePosition()}))},__getContent:function(t){var e=Bt(this,"title",this.title),n=void 0===this.$scopedSlots.default?[]:this.$scopedSlots.default(this.defaultSlotScope).slice();return e&&n.unshift(t("div",{staticClass:"q-dialog__title q-mt-sm q-mb-sm"},[e])),!0===this.buttons&&n.push(t("div",{staticClass:"q-popup-edit__buttons row justify-center no-wrap"},[t(_e,{props:{flat:!0,color:this.color,label:this.labelCancel||this.$q.lang.label.cancel},on:pt(this,"cancel",{click:this.cancel})}),t(_e,{props:{flat:!0,color:this.color,label:this.labelSet||this.$q.lang.label.set},on:pt(this,"ok",{click:this.set})})])),n}},render:function(t){var e=this;if(!0!==this.disable)return t(an,{ref:"menu",props:this.menuProps,on:pt(this,"menu",{"before-show":function(){e.validated=!1,e.initialValue=da(e.value),e.watcher=e.$watch("value",e.__reposition),e.$emit("before-show")},show:function(){e.$emit("show")},"escape-key":this.cancel,"before-hide":function(){e.watcher(),!1===e.validated&&!0===e.__hasChanged()&&(!0===e.autoSave&&!0===e.validate(e.value)?e.$emit("save",e.value,e.initialValue):(e.$emit("cancel",e.value,e.initialValue),e.$emit("input",e.initialValue))),e.$emit("before-hide")},hide:function(){e.$emit("hide")},keyup:function(t){!0===X(t,13)&&e.set()}})},this.__getContent(t))}}),fa=t.extend({name:"QPopupProxy",mixins:[yt,Ot,ke],props:{breakpoint:{type:[String,Number],default:450}},data:function(){var t=parseInt(this.breakpoint,10);return{type:this.$q.screen.width<t||this.$q.screen.height<t?"dialog":"menu"}},computed:{parsedBreakpoint:function(){return parseInt(this.breakpoint,10)},onEvents:function(){return Object.assign({},this.qListeners,{hide:this.__onHide})}},watch:{"$q.screen.width":function(t){!0!==this.$refs.popup.showing&&this.__updateType(t,this.$q.screen.height,this.parsedBreakpoint)},"$q.screen.height":function(t){!0!==this.$refs.popup.showing&&this.__updateType(this.$q.screen.width,t,this.parsedBreakpoint)},breakpoint:function(t){!0!==this.$refs.popup.showing&&this.__updateType(this.$q.screen.width,this.$q.screen.height,parseInt(t,10))}},methods:{toggle:function(t){this.$refs.popup.toggle(t)},show:function(t){this.$refs.popup.show(t)},hide:function(t){this.$refs.popup.hide(t)},__onHide:function(t){this.__updateType(this.$q.screen.width,this.$q.screen.height,this.parsedBreakpoint),this.$emit("hide",t)},__updateType:function(t,e,n){var i=t<n||e<n?"dialog":"menu";this.type!==i&&(this.type=i)}},render:function(t){var e,n=Bt(this,"default"),i="menu"===this.type&&void 0!==n&&void 0!==n[0]&&void 0!==n[0].componentOptions&&void 0!==n[0].componentOptions.Ctor&&void 0!==n[0].componentOptions.Ctor.sealedOptions&&["QDate","QTime","QCarousel","QColor"].includes(n[0].componentOptions.Ctor.sealedOptions.name)?{cover:!0,maxHeight:"99vh"}:{},r={ref:"popup",props:Object.assign({},i,this.qAttrs),on:this.onEvents};return"dialog"===this.type?e=wr:(e=an,r.props.target=this.target,r.props.contextMenu=this.contextMenu,r.props.noParentEvent=!0,r.props.separateClosePopup=!0),t(e,r,n)}});function pa(t,e){return!0===e?{transform:"translateX(100%) scale3d("+-t+",1,1)"}:{transform:"scale3d("+t+",1,1)"}}var ma=t.extend({name:"QLinearProgress",mixins:[Ot,It,Mt({xs:2,sm:4,md:6,lg:10,xl:14})],props:{value:{type:Number,default:0},buffer:Number,color:String,trackColor:String,reverse:Boolean,stripe:Boolean,indeterminate:Boolean,query:Boolean,rounded:Boolean,instantFeedback:Boolean},computed:{motion:function(){return!0===this.indeterminate||!0===this.query},classes:function(){return"q-linear-progress"+(void 0!==this.color?" text-"+this.color:"")+(!0===this.reverse||!0===this.query?" q-linear-progress--reverse":"")+(!0===this.rounded?" rounded-borders":"")},trackStyle:function(){return pa(void 0!==this.buffer?this.buffer:1,this.reverse)},trackClass:function(){return"q-linear-progress__track--with"+(!0===this.instantFeedback?"out":"")+"-transition q-linear-progress__track--"+(!0===this.isDark?"dark":"light")+(void 0!==this.trackColor?" bg-"+this.trackColor:"")},modelStyle:function(){return pa(!0===this.motion?1:this.value,this.reverse)},modelClasses:function(){return"q-linear-progress__model--with"+(!0===this.instantFeedback?"out":"")+"-transition q-linear-progress__model--"+(!0===this.motion?"in":"")+"determinate"},stripeStyle:function(){return{width:100*this.value+"%"}},attrs:function(){return{role:"progressbar","aria-valuemin":0,"aria-valuemax":1,"aria-valuenow":!0===this.indeterminate?void 0:this.value}}},render:function(t){var e=[t("div",{staticClass:"q-linear-progress__track absolute-full",style:this.trackStyle,class:this.trackClass}),t("div",{staticClass:"q-linear-progress__model absolute-full",style:this.modelStyle,class:this.modelClasses})];return!0===this.stripe&&!1===this.motion&&e.push(t("div",{staticClass:"q-linear-progress__stripe absolute-full",style:this.stripeStyle})),t("div",{style:this.sizeStyle,class:this.classes,attrs:this.attrs,on:Object.assign({},this.qListeners)},At(e,this,"default"))}}),va=40,ga=t.extend({name:"QPullToRefresh",mixins:[Ot],directives:{TouchPan:Gn},props:{color:String,bgColor:String,icon:String,noMouse:Boolean,disable:Boolean,scrollTarget:{default:void 0}},data:function(){return{state:"pull",pullRatio:0,pulling:!1,pullPosition:-40,animating:!1,positionCSS:{}}},computed:{style:function(){return{opacity:this.pullRatio,transform:"translateY("+this.pullPosition+"px) rotate("+360*this.pullRatio+"deg)"}},classes:function(){return"q-pull-to-refresh__puller row flex-center"+(!0===this.animating?" q-pull-to-refresh__puller--animating":"")+(void 0!==this.bgColor?" bg-"+this.bgColor:"")},directives:function(){if(!0!==this.disable){var t={down:!0,mightPrevent:!0};return!0!==this.noMouse&&(t.mouse=!0),[{name:"touch-pan",modifiers:t,value:this.__pull}]}},contentClass:function(){return"q-pull-to-refresh__content"+(!0===this.pulling?" no-pointer-events":"")}},watch:{scrollTarget:function(){this.updateScrollTarget()}},methods:{trigger:function(){var t=this;this.$emit("refresh",(function(){t.__animateTo({pos:-40,ratio:0},(function(){t.state="pull"}))}))},updateScrollTarget:function(){this.__scrollTarget=Ie(this.$el,this.scrollTarget)},__pull:function(t){if(!0!==t.isFinal){if(!0===this.animating||"refreshing"===this.state)return!1;if(!0===t.isFirst){if(0!==Fe(this.__scrollTarget))return!0===this.pulling&&(this.pulling=!1,this.state="pull",this.__animateTo({pos:-40,ratio:0})),!1;this.pulling=!0;var e=this.$el.getBoundingClientRect(),n=e.top,i=e.left;this.positionCSS={top:n+"px",left:i+"px",width:window.getComputedStyle(this.$el).getPropertyValue("width")}}b(t.evt);var r=Math.min(140,Math.max(0,t.distance.y));this.pullPosition=r-va,this.pullRatio=ut(r/60,0,1);var o=this.pullPosition>20?"pulled":"pull";this.state!==o&&(this.state=o)}else!0===this.pulling&&(this.pulling=!1,"pulled"===this.state?(this.state="refreshing",this.__animateTo({pos:20}),this.trigger()):"pull"===this.state&&this.__animateTo({pos:-40,ratio:0}))},__animateTo:function(t,e){var n=this,i=t.pos,r=t.ratio;this.animating=!0,this.pullPosition=i,void 0!==r&&(this.pullRatio=r),clearTimeout(this.timer),this.timer=setTimeout((function(){n.animating=!1,e&&e()}),300)}},mounted:function(){this.updateScrollTarget()},beforeDestroy:function(){clearTimeout(this.timer)},render:function(t){return t("div",{staticClass:"q-pull-to-refresh",on:Object.assign({},this.qListeners),directives:this.directives},[t("div",{class:this.contentClass},Bt(this,"default")),t("div",{staticClass:"q-pull-to-refresh__puller-container fixed row flex-center no-pointer-events z-top",style:this.positionCSS},[t("div",{style:this.style,class:this.classes},["refreshing"!==this.state?t(Lt,{props:{name:this.icon||this.$q.iconSet.pullToRefresh.icon,color:this.color,size:"32px"}}):t(Gt,{props:{size:"24px",color:this.color}})])])])}}),ya=0,_a=1,ba=2,wa=t.extend({name:"QRange",mixins:[Xn],props:{value:{type:Object,default:function(){return{min:null,max:null}},validator:function(t){return"min"in t&&"max"in t}},name:String,dragRange:Boolean,dragOnlyRange:Boolean,leftLabelColor:String,leftLabelTextColor:String,rightLabelColor:String,rightLabelTextColor:String,leftLabelValue:[String,Number],rightLabelValue:[String,Number]},data:function(){return{model:{min:null===this.value.min?this.min:this.value.min,max:null===this.value.max?this.max:this.value.max},curMinRatio:0,curMaxRatio:0}},watch:{"value.min":function(t){this.model.min=null===t?this.min:t},"value.max":function(t){this.model.max=null===t?this.max:t},min:function(t){this.model.min<t&&(this.model.min=t),this.model.max<t&&(this.model.max=t)},max:function(t){this.model.min>t&&(this.model.min=t),this.model.max>t&&(this.model.max=t)}},computed:{ratioMin:function(){return!0===this.active?this.curMinRatio:this.modelMinRatio},ratioMax:function(){return!0===this.active?this.curMaxRatio:this.modelMaxRatio},modelMinRatio:function(){return(this.model.min-this.min)/(this.max-this.min)},modelMaxRatio:function(){return(this.model.max-this.min)/(this.max-this.min)},trackStyle:function(){var t;return(t={})[this.positionProp]=100*this.ratioMin+"%",t[this.sizeProp]=100*(this.ratioMax-this.ratioMin)+"%",t},minThumbStyle:function(){var t;return(t={})[this.positionProp]=100*this.ratioMin+"%",t["z-index"]="min"===this.__nextFocus?2:void 0,t},maxThumbStyle:function(){var t;return(t={})[this.positionProp]=100*this.ratioMax+"%",t},minThumbClass:function(){if(!1===this.preventFocus&&"min"===this.focus)return"q-slider--focus"},maxThumbClass:function(){if(!1===this.preventFocus&&"max"===this.focus)return"q-slider--focus"},events:function(){var t=this;if(!0===this.editable){if(!0===this.$q.platform.is.mobile)return{click:this.__mobileClick};var e={mousedown:this.__activate};return!0===this.dragOnlyRange&&Object.assign(e,{focus:function(){t.__focus("both")},blur:this.__blur,keydown:this.__keydown,keyup:this.__keyup}),e}},minEvents:function(){var t=this;if(!0===this.editable&&!0!==this.$q.platform.is.mobile&&!0!==this.dragOnlyRange)return{focus:function(){t.__focus("min")},blur:this.__blur,keydown:this.__keydown,keyup:this.__keyup}},maxEvents:function(){var t=this;if(!0===this.editable&&!0!==this.$q.platform.is.mobile&&!0!==this.dragOnlyRange)return{focus:function(){t.__focus("max")},blur:this.__blur,keydown:this.__keydown,keyup:this.__keyup}},minPinClass:function(){var t=this.leftLabelColor||this.labelColor;if(t)return"text-"+t},minPinTextClass:function(){var t=this.leftLabelTextColor||this.labelTextColor;if(t)return"text-"+t},maxPinClass:function(){var t=this.rightLabelColor||this.labelColor;if(t)return"text-"+t},maxPinTextClass:function(){var t=this.rightLabelTextColor||this.labelTextColor;if(t)return"text-"+t},minLabel:function(){return void 0!==this.leftLabelValue?this.leftLabelValue:this.model.min},maxLabel:function(){return void 0!==this.rightLabelValue?this.rightLabelValue:this.model.max},minPinStyle:function(){var t=!0===this.reverse?-this.ratioMin:this.ratioMin-1;return this.__getPinStyle(t,this.ratioMin)},maxPinStyle:function(){var t=!0===this.reverse?-this.ratioMax:this.ratioMax-1;return this.__getPinStyle(t,this.ratioMax)},formAttrs:function(){return{type:"hidden",name:this.name,value:this.value.min+"|"+this.value.max}}},methods:{__updateValue:function(t){this.model.min===this.value.min&&this.model.max===this.value.max||this.$emit("input",this.model),!0===t&&this.$emit("change",this.model)},__getDragging:function(t){var e,n=this.$el.getBoundingClientRect(),i=n.left,r=n.top,o=n.width,a=n.height,s=!0===this.dragOnlyRange?0:!0===this.vertical?this.$refs.minThumb.offsetHeight/(2*a):this.$refs.minThumb.offsetWidth/(2*o),l=this.max-this.min,c={left:i,top:r,width:o,height:a,valueMin:this.model.min,valueMax:this.model.max,ratioMin:(this.model.min-this.min)/l,ratioMax:(this.model.max-this.min)/l},u=Jn(t,c,this.isReversed,this.vertical);return!0!==this.dragOnlyRange&&u<c.ratioMin+s?e=ya:!0===this.dragOnlyRange||u<c.ratioMax-s?!0===this.dragRange||!0===this.dragOnlyRange?(e=_a,Object.assign(c,{offsetRatio:u,offsetModel:Zn(u,this.min,this.max,this.step,this.decimals),rangeValue:c.valueMax-c.valueMin,rangeRatio:c.ratioMax-c.ratioMin})):e=c.ratioMax-u<u-c.ratioMin?ba:ya:e=ba,c.type=e,this.__nextFocus=void 0,c},__updatePosition:function(t,e){void 0===e&&(e=this.dragging);var n,i=Jn(t,e,this.isReversed,this.vertical),r=Zn(i,this.min,this.max,this.step,this.decimals);switch(e.type){case ya:i<=e.ratioMax?(n={minR:i,maxR:e.ratioMax,min:r,max:e.valueMax},this.__nextFocus="min"):(n={minR:e.ratioMax,maxR:i,min:e.valueMax,max:r},this.__nextFocus="max");break;case ba:i>=e.ratioMin?(n={minR:e.ratioMin,maxR:i,min:e.valueMin,max:r},this.__nextFocus="max"):(n={minR:i,maxR:e.ratioMin,min:r,max:e.valueMin},this.__nextFocus="min");break;case _a:var o=i-e.offsetRatio,a=ut(e.ratioMin+o,0,1-e.rangeRatio),s=r-e.offsetModel,l=ut(e.valueMin+s,this.min,this.max-e.rangeValue);n={minR:a,maxR:a+e.rangeRatio,min:parseFloat(l.toFixed(this.decimals)),max:parseFloat((l+e.rangeValue).toFixed(this.decimals))}}if(this.model={min:n.min,max:n.max},null!==this.model.min&&null!==this.model.max||(this.model.min=n.min||this.min,this.model.max=n.max||this.max),!0!==this.snap||0===this.step)this.curMinRatio=n.minR,this.curMaxRatio=n.maxR;else{var c=this.max-this.min;this.curMinRatio=(this.model.min-this.min)/c,this.curMaxRatio=(this.model.max-this.min)/c}},__focus:function(t){this.focus=t},__keydown:function(t){var e;if(Kn.includes(t.keyCode)){w(t);var n=([34,33].includes(t.keyCode)?10:1)*this.computedStep,i=[34,37,40].includes(t.keyCode)?-n:n;if(this.dragOnlyRange){var r=this.dragOnlyRange?this.model.max-this.model.min:0,o=ut(parseFloat((this.model.min+i).toFixed(this.decimals)),this.min,this.max-r);this.model={min:o,max:parseFloat((o+r).toFixed(this.decimals))}}else{if(!1===this.focus)return;var a=this.focus;this.model=Object.assign({},this.model,((e={})[a]=ut(parseFloat((this.model[a]+i).toFixed(this.decimals)),"min"===a?this.min:this.model.min,"max"===a?this.max:this.model.max),e))}this.__updateValue()}},__getThumb:function(t,e){var n=[this.__getThumbSvg(t),t("div",{staticClass:"q-slider__focus-ring"})];return!0!==this.label&&!0!==this.labelAlways||n.push(t("div",{staticClass:"q-slider__pin q-slider__pin"+this.axis+" absolute",style:this[e+"PinStyle"].pin,class:this[e+"PinClass"]},[t("div",{staticClass:"q-slider__pin-text-container q-slider__pin-text-container"+this.axis,style:this[e+"PinStyle"].pinTextContainer},[t("span",{staticClass:"q-slider__pin-text",class:this[e+"PinTextClass"]},[this[e+"Label"]])])]),t("div",{staticClass:"q-slider__arrow q-slider__arrow"+this.axis,class:this[e+"PinClass"]})),t("div",{ref:e+"Thumb",staticClass:"q-slider__thumb-container q-slider__thumb-container"+this.axis+" absolute non-selectable",style:this[e+"ThumbStyle"],class:this[e+"ThumbClass"],on:this[e+"Events"],attrs:{tabindex:!0!==this.dragOnlyRange?this.computedTabindex:null}},n)}},render:function(t){var e=[t("div",{staticClass:"q-slider__track q-slider__track"+this.axis+" absolute",style:this.trackStyle})];!0===this.markers&&e.push(t("div",{staticClass:"q-slider__track-markers q-slider__track-markers"+this.axis+" absolute-full fit",style:this.markerStyle}));var n=[t("div",{staticClass:"q-slider__track-container q-slider__track-container"+this.axis+" absolute"},e),this.__getThumb(t,"min"),this.__getThumb(t,"max")];return void 0!==this.name&&!0!==this.disable&&this.__injectFormInput(n,"push"),t("div",{staticClass:null===this.value.min||null===this.value.max?"q-slider--no-value":void 0,attrs:Object.assign({},this.attrs,{"aria-valuenow":this.value.min+"|"+this.value.max,tabindex:!0===this.dragOnlyRange&&!0!==this.$q.platform.is.mobile?this.computedTabindex:null}),class:this.classes,on:this.events,directives:this.panDirectives},n)}}),ka=t.extend({name:"QRating",mixins:[Tt,ln,Ot],props:{value:{type:Number,required:!0},max:{type:[String,Number],default:5},icon:[String,Array],iconHalf:[String,Array],iconSelected:[String,Array],color:[String,Array],colorHalf:[String,Array],colorSelected:[String,Array],noReset:Boolean,noDimming:Boolean,readonly:Boolean,disable:Boolean},data:function(){return{mouseModel:0}},computed:{editable:function(){return!0!==this.readonly&&!0!==this.disable},classes:function(){return"q-rating--"+(!0===this.editable?"":"non-")+"editable"+(!0===this.noDimming?" q-rating--no-dimming":"")+(!0===this.disable?" disabled":"")+(void 0!==this.color&&!1===Array.isArray(this.color)?" text-"+this.color:"")},iconData:function(){var t=!0===Array.isArray(this.icon)?this.icon.length:0,e=!0===Array.isArray(this.iconSelected)?this.iconSelected.length:0,n=!0===Array.isArray(this.iconHalf)?this.iconHalf.length:0,i=!0===Array.isArray(this.color)?this.color.length:0,r=!0===Array.isArray(this.colorSelected)?this.colorSelected.length:0,o=!0===Array.isArray(this.colorHalf)?this.colorHalf.length:0;return{iconLen:t,icon:t>0?this.icon[t-1]:this.icon,selIconLen:e,selIcon:e>0?this.iconSelected[e-1]:this.iconSelected,halfIconLen:n,halfIcon:n>0?this.iconHalf[e-1]:this.iconHalf,colorLen:i,color:i>0?this.color[i-1]:this.color,selColorLen:r,selColor:r>0?this.colorSelected[r-1]:this.colorSelected,halfColorLen:o,halfColor:o>0?this.colorHalf[o-1]:this.colorHalf}},attrs:function(){return!0===this.disable?{"aria-disabled":"true"}:!0===this.readonly?{"aria-readonly":"true"}:void 0}},methods:{__set:function(t){if(!0===this.editable){var e=ut(parseInt(t,10),1,parseInt(this.max,10)),n=!0!==this.noReset&&this.value===e?0:e;n!==this.value&&this.$emit("input",n),this.mouseModel=0}},__setHoverValue:function(t){!0===this.editable&&(this.mouseModel=t)},__keyup:function(t,e){switch(t.keyCode){case 13:case 32:return this.__set(e),w(t);case 37:case 40:return this.$refs["rt"+(e-1)]&&this.$refs["rt"+(e-1)].focus(),w(t);case 39:case 38:return this.$refs["rt"+(e+1)]&&this.$refs["rt"+(e+1)].focus(),w(t)}}},render:function(t){for(var e,n=this,i=[],r=!0===this.editable?0:null,o=this.iconData,a=Math.ceil(this.value),s=void 0===this.iconHalf||a===this.value?-1:a,l=function(l){var c=0===n.mouseModel&&n.value>=l||n.mouseModel>0&&n.mouseModel>=l,u=s===l&&n.mouseModel<l,d=n.mouseModel>0&&(!0===u?a:n.value)>=l&&n.mouseModel<l,h=!0===u?l<=o.halfIconLen?n.iconHalf[l-1]:o.halfIcon:void 0===o.selIcon||!0!==c&&!0!==d?l<=o.iconLen?n.icon[l-1]:o.icon:l<=o.selIconLen?n.iconSelected[l-1]:o.selIcon,f=!0===u?l<=o.halfColorLen?n.colorHalf[l-1]:o.halfColor:void 0!==o.selColor&&!0===c?l<=o.selColorLen?n.colorSelected[l-1]:o.selColor:l<=o.colorLen?n.color[l-1]:o.color;i.push(t(Lt,{key:l,ref:"rt"+l,staticClass:"q-rating__icon",class:(e={"q-rating__icon--active":!0===c||!0===u,"q-rating__icon--exselected":d,"q-rating__icon--hovered":n.mouseModel===l},e["text-"+f]=void 0!==f,e),props:{name:h||n.$q.iconSet.rating.icon},attrs:{tabindex:r},on:pt(n,"i#"+l,{click:function(){n.__set(l)},mouseover:function(){n.__setHoverValue(l)},mouseout:function(){n.mouseModel=0},focus:function(){n.__setHoverValue(l)},blur:function(){n.mouseModel=0},keyup:function(t){n.__keyup(t,l)}})},Bt(n,"tip-"+l)))},c=1;c<=n.max;c++)l(c);return void 0!==this.name&&!0!==this.disable&&this.__injectFormInput(i,"push"),t("div",{staticClass:"q-rating row inline items-center",class:this.classes,style:this.sizeStyle,attrs:this.attrs,on:Object.assign({},this.qListeners)},i)}}),xa=t.extend({name:"QResponsive",mixins:[Ro,Ot],render:function(t){return t("div",{staticClass:"q-responsive",on:Object.assign({},this.qListeners)},[t("div",{staticClass:"q-responsive__filler overflow-hidden"},[t("div",{style:this.ratioStyle})]),t("div",{staticClass:"q-responsive__content absolute-full fit"},Bt(this,"default"))])}}),Ca=t.extend({name:"QScrollArea",mixins:[It],directives:{TouchPan:Gn},props:{barStyle:[Array,String,Object],thumbStyle:Object,contentStyle:[Array,String,Object],contentActiveStyle:[Array,String,Object],delay:{type:[String,Number],default:1e3},visible:{type:Boolean,default:null},horizontal:Boolean},data:function(){return{tempShowing:!1,panning:!1,hover:!1,containerWidth:0,containerHeight:0,scrollPosition:0,scrollSize:0}},computed:{classes:function(){return"q-scrollarea"+(!0===this.isDark?" q-scrollarea--dark":"")},thumbHidden:function(){return!0!==(null===this.visible?this.hover:this.visible)&&!1===this.tempShowing&&!1===this.panning||this.scrollSize<=this.containerSize},thumbSize:function(){return Math.round(ut(this.containerSize*this.containerSize/this.scrollSize,50,this.containerSize))},style:function(){var t=this.scrollPercentage*(this.containerSize-this.thumbSize);return Object.assign({},this.thumbStyle,!0===this.horizontal?{left:t+"px",width:this.thumbSize+"px"}:{top:t+"px",height:this.thumbSize+"px"})},mainStyle:function(){return!0===this.thumbHidden?this.contentStyle:this.contentActiveStyle},scrollPercentage:function(){var t=ut(this.scrollPosition/(this.scrollSize-this.containerSize),0,1);return Math.round(1e4*t)/1e4},containerSize:function(){return this["container"+this.dirProps.suffix]},dirProps:function(){return!0===this.horizontal?{prefix:"horizontal",suffix:"Width",scroll:"scrollLeft",classSuffix:"h absolute-bottom",dir:"right",dist:"x"}:{prefix:"vertical",suffix:"Height",scroll:"scrollTop",classSuffix:"v absolute-right",dir:"down",dist:"y"}},thumbClass:function(){return"q-scrollarea__thumb--"+this.dirProps.classSuffix+(!0===this.thumbHidden?" q-scrollarea__thumb--invisible":"")},barClass:function(){return"q-scrollarea__bar--"+this.dirProps.classSuffix+(!0===this.thumbHidden?" q-scrollarea__bar--invisible":"")},thumbDirectives:function(){var t;return[{name:"touch-pan",modifiers:(t={},t[!0===this.horizontal?"horizontal":"vertical"]=!0,t.prevent=!0,t.mouse=!0,t.mouseAllDir=!0,t),value:this.__panThumb}]}},methods:{getScrollTarget:function(){return this.$refs.target},getScrollPosition:function(){return this.scrollPosition},setScrollPosition:function(t,e){(!0===this.horizontal?Ue:We)(this.$refs.target,t,e)},setScrollPercentage:function(t,e){this.setScrollPosition(t*(this.scrollSize-this.containerSize),e)},__updateContainer:function(t){var e=t.height,n=t.width,i=!1;this.containerWidth!==n&&(this.containerWidth=n,i=!0),this.containerHeight!==e&&(this.containerHeight=e,i=!0),!0===i&&this.__startTimer()},__updateScroll:function(t){this.scrollPosition!==t.position&&(this.scrollPosition=t.position,this.__startTimer())},__updateScrollSize:function(t){var e=t.height,n=t.width;!0===this.horizontal?this.scrollSize!==n&&(this.scrollSize=n,this.__startTimer()):this.scrollSize!==e&&(this.scrollSize=e,this.__startTimer())},__panThumb:function(t){if(!0===t.isFirst){if(!0===this.thumbHidden)return;this.refPos=this.scrollPosition,this.panning=!0}else if(!0!==this.panning)return;!0===t.isFinal&&(this.panning=!1);var e=(this.scrollSize-this.containerSize)/(this.containerSize-this.thumbSize),n=t.distance[this.dirProps.dist],i=this.refPos+(t.direction===this.dirProps.dir?1:-1)*n*e;this.__setScroll(i)},__mouseDown:function(t){if(!0!==this.thumbHidden){var e=t["offset"+(!0===this.horizontal?"X":"Y")]-this.thumbSize/2;this.__setScroll(e/this.containerSize*this.scrollSize),void 0!==this.$refs.thumb&&this.$refs.thumb.dispatchEvent(new MouseEvent(t.type,t))}},__startTimer:function(){var t=this;!0===this.tempShowing?clearTimeout(this.timer):this.tempShowing=!0,this.timer=setTimeout((function(){t.tempShowing=!1}),this.delay),this.__emitScroll()},__setScroll:function(t){this.$refs.target[this.dirProps.scroll]=t}},render:function(t){var e=this;return t("div",{class:this.classes,on:pt(this,"desk",{mouseenter:function(){e.hover=!0},mouseleave:function(){e.hover=!1}})},[t("div",{ref:"target",staticClass:"scroll relative-position fit hide-scrollbar"},[t("div",{staticClass:"absolute",style:this.mainStyle,class:"full-"+(!0===this.horizontal?"height":"width")},At([t(ni,{on:pt(this,"resizeIn",{resize:this.__updateScrollSize})})],this,"default")),t(Qo,{props:{horizontal:this.horizontal},on:pt(this,"scroll",{scroll:this.__updateScroll})})]),t(ni,{on:pt(this,"resizeOut",{resize:this.__updateContainer})}),t("div",{staticClass:"q-scrollarea__bar",style:this.barStyle,class:this.barClass,attrs:gt,on:pt(this,"bar",{mousedown:this.__mouseDown})}),t("div",{ref:"thumb",staticClass:"q-scrollarea__thumb",style:this.style,class:this.thumbClass,attrs:gt,directives:this.thumbDirectives})])},created:function(){var t=this;this.__emitScroll=T((function(){if(void 0!==t.$listeners.scroll){var e={ref:t},n=t.dirProps.prefix;e[n+"Position"]=t.scrollPosition,e[n+"Percentage"]=t.scrollPercentage,e[n+"Size"]=t.scrollSize,e[n+"ContainerSize"]=t.containerSize,t.$emit("scroll",e)}}),0)}}),Sa=1e3,Ma=["start","center","end","start-force","center-force","end-force"],Ta=Array.prototype.slice,Pa=void 0;function Oa(t,e){return t+e}function Ba(t,e,n,i,r,o,a,s){var l=t===window?document.scrollingElement||document.documentElement:t,c=!0===r?"offsetWidth":"offsetHeight",u={scrollStart:0,scrollViewSize:-a-s,scrollMaxSize:0,offsetStart:-a,offsetEnd:-s};if(!0===r?(t===window?(u.scrollStart=window.pageXOffset||window.scrollX||document.body.scrollLeft||0,u.scrollViewSize+=window.innerWidth):(u.scrollStart=l.scrollLeft,u.scrollViewSize+=l.clientWidth),u.scrollMaxSize=l.scrollWidth,!0===o&&(u.scrollStart=(!0===Pa?u.scrollMaxSize-u.scrollViewSize:0)-u.scrollStart)):(t===window?(u.scrollStart=window.pageYOffset||window.scrollY||document.body.scrollTop||0,u.scrollViewSize+=window.innerHeight):(u.scrollStart=l.scrollTop,u.scrollViewSize+=l.clientHeight),u.scrollMaxSize=l.scrollHeight),void 0!==n)for(var d=n.previousElementSibling;null!==d;d=d.previousElementSibling)!1===d.classList.contains("q-virtual-scroll--skip")&&(u.offsetStart+=d[c]);if(void 0!==i)for(var h=i.nextElementSibling;null!==h;h=h.nextElementSibling)!1===h.classList.contains("q-virtual-scroll--skip")&&(u.offsetEnd+=h[c]);if(e!==t){var f=l.getBoundingClientRect(),p=e.getBoundingClientRect();!0===r?(u.offsetStart+=p.left-f.left,u.offsetEnd-=p.width):(u.offsetStart+=p.top-f.top,u.offsetEnd-=p.height),t!==window&&(u.offsetStart+=u.scrollStart),u.offsetEnd+=u.scrollMaxSize-u.offsetStart}return u}function Ea(t,e,n,i){if(n>=i)return 0;var r=e.length,o=Math.floor(n/Sa),a=Math.floor((i-1)/Sa)+1,s=t.slice(o,a).reduce(Oa,0);return n%Sa!=0&&(s-=e.slice(o*Sa,n).reduce(Oa,0)),i%Sa!=0&&i!==r&&(s-=e.slice(i,a*Sa).reduce(Oa,0)),s}var Aa={virtualScrollSliceSize:{type:Number,default:null},virtualScrollItemSize:{type:Number,default:24},virtualScrollStickySizeStart:{type:Number,default:0},virtualScrollStickySizeEnd:{type:Number,default:0},tableColspan:[Number,String]},Da=Object.keys(Aa),La={props:Object.assign({},{virtualScrollHorizontal:Boolean},Aa),data:function(){return{virtualScrollSliceRange:{from:0,to:0}}},watch:{virtualScrollHorizontal:function(){this.__setVirtualScrollSize()},needsReset:function(){this.reset()}},computed:{needsReset:function(){var t=this;return["virtualScrollItemSize","virtualScrollHorizontal"].map((function(e){return t[e]})).join(";")},colspanAttr:function(){return void 0!==this.tableColspan?{colspan:this.tableColspan}:{colspan:100}}},methods:{reset:function(){this.__resetVirtualScroll(this.prevToIndex,!0)},refresh:function(t){this.__resetVirtualScroll(void 0===t?this.prevToIndex:t)},scrollTo:function(t,e){var n=this.__getVirtualScrollTarget();if(null!=n&&8!==n.nodeType){var i=Ba(n,this.__getVirtualScrollEl(),this.$refs.before,this.$refs.after,this.virtualScrollHorizontal,this.$q.lang.rtl,this.virtualScrollStickySizeStart,this.virtualScrollStickySizeEnd);this.__scrollViewSize!==i.scrollViewSize&&this.__setVirtualScrollSize(i.scrollViewSize),this.__setVirtualScrollSliceRange(n,i,Math.min(this.virtualScrollLength-1,Math.max(0,parseInt(t,10)||0)),0,Ma.indexOf(e)>-1?e:this.prevToIndex>-1&&t>this.prevToIndex?"end":"start")}},__onVirtualScrollEvt:function(){var t=this.__getVirtualScrollTarget();if(null!=t&&8!==t.nodeType){var e=Ba(t,this.__getVirtualScrollEl(),this.$refs.before,this.$refs.after,this.virtualScrollHorizontal,this.$q.lang.rtl,this.virtualScrollStickySizeStart,this.virtualScrollStickySizeEnd),n=this.virtualScrollLength-1,i=e.scrollMaxSize-e.offsetStart-e.offsetEnd-this.virtualScrollPaddingAfter;if(this.prevScrollStart!==e.scrollStart)if(this.prevScrollStart=void 0,e.scrollMaxSize<=0)this.__setVirtualScrollSliceRange(t,e,0,0);else{this.__scrollViewSize!==e.scrollViewSize&&this.__setVirtualScrollSize(e.scrollViewSize),this.__updateVirtualScrollSizes(this.virtualScrollSliceRange.from);var r=e.scrollMaxSize-Math.max(e.scrollViewSize,e.offsetEnd)-this.virtualScrollSizes[n];if(r>0&&e.scrollStart>=r)this.__setVirtualScrollSliceRange(t,e,n,e.scrollMaxSize-e.offsetEnd-this.virtualScrollSizesAgg.reduce(Oa,0));else{var o=0,a=e.scrollStart-e.offsetStart,s=a;if(a<=i&&a+e.scrollViewSize>=this.virtualScrollPaddingBefore)a-=this.virtualScrollPaddingBefore,o=this.virtualScrollSliceRange.from,s=a;else for(var l=0;a>=this.virtualScrollSizesAgg[l]&&o<n;l++)a-=this.virtualScrollSizesAgg[l],o+=Sa;for(;a>0&&o<n;)(a-=this.virtualScrollSizes[o])>-e.scrollViewSize?(o++,s=a):s=this.virtualScrollSizes[o]+a;this.__setVirtualScrollSliceRange(t,e,o,s)}}}},__setVirtualScrollSliceRange:function(t,e,n,i,r){var o=this,a="string"==typeof r&&r.indexOf("-force")>-1,s=!0===a?r.replace("-force",""):r,l=Math.max(0,Math.ceil(n-this.virtualScrollSliceSizeComputed/(void 0===s||"center"===s?2:"start"===s?3:1.5))),c=l+this.virtualScrollSliceSizeComputed;c>this.virtualScrollLength&&(c=this.virtualScrollLength,l=Math.max(0,c-this.virtualScrollSliceSizeComputed));var u=l!==this.virtualScrollSliceRange.from||c!==this.virtualScrollSliceRange.to;if(!1!==u||void 0!==s){var d=!0===u&&"function"==typeof t.contains&&t.contains(document.activeElement),h=void 0!==s?this.virtualScrollSizes.slice(l,n).reduce(Oa,0):0;!0===u&&(this.virtualScrollSliceRange={from:l,to:c},this.virtualScrollPaddingBefore=Ea(this.virtualScrollSizesAgg,this.virtualScrollSizes,0,l),this.virtualScrollPaddingAfter=Ea(this.virtualScrollSizesAgg,this.virtualScrollSizes,c,this.virtualScrollLength)),this.__activeScrollStart=e.scrollStart,requestAnimationFrame((function(){if(!0===d&&!0!==t.contains(document.activeElement)&&t.focus(),o.__activeScrollStart===e.scrollStart){!0===u&&o.__updateVirtualScrollSizes(l);var r=o.virtualScrollSizes.slice(l,n).reduce(Oa,0),c=r+e.offsetStart+o.virtualScrollPaddingBefore,f=c+o.virtualScrollSizes[n],p=!0===o.$q.lang.rtl,m=c+i;if(void 0!==s){var v=r-h,g=e.scrollStart+v;m=!0!==a&&g<c&&f<g+e.scrollViewSize?g:"end"===s?f-e.scrollViewSize:c-("start"===s?0:Math.round((e.scrollViewSize-o.virtualScrollSizes[n])/2))}o.prevScrollStart=m,function(t,e,n,i){t===window?!0===n?(!0===i&&(e=(!0===Pa?document.body.scrollWidth-window.innerWidth:0)-e),window.scrollTo(e,window.pageYOffset||window.scrollY||document.body.scrollTop||0)):window.scrollTo(window.pageXOffset||window.scrollX||document.body.scrollLeft||0,e):!0===n?(!0===i&&(e=(!0===Pa?t.scrollWidth-t.offsetWidth:0)-e),t.scrollLeft=e):t.scrollTop=e}(t,m,o.virtualScrollHorizontal,p),o.__emitScroll(n)}}))}else this.__emitScroll(n)},__updateVirtualScrollSizes:function(t){var e=this.$refs.content;if(void 0!==e)for(var n,i,r=Ta.call(e.children).filter((function(t){return!1===t.classList.contains("q-virtual-scroll--skip")})),o=r.length,a=!0===this.virtualScrollHorizontal?function(t){return t.getBoundingClientRect().width}:function(t){return t.offsetHeight},s=t,l=0;l<o;){for(n=a(r[l]),l++;l<o&&!0===r[l].classList.contains("q-virtual-scroll--with-prev");)n+=a(r[l]),l++;0!==(i=n-this.virtualScrollSizes[s])&&(this.virtualScrollSizes[s]+=i,this.virtualScrollSizesAgg[Math.floor(s/Sa)]+=i),s++}},__resetVirtualScroll:function(t,e){var n=this,i=this.virtualScrollItemSize;!0!==e&&!1!==Array.isArray(this.virtualScrollSizes)||(this.virtualScrollSizes=[]);var r=this.virtualScrollSizes.length;this.virtualScrollSizes.length=this.virtualScrollLength;for(var o=this.virtualScrollLength-1;o>=r;o--)this.virtualScrollSizes[o]=i;var a=Math.floor((this.virtualScrollLength-1)/Sa);this.virtualScrollSizesAgg=[];for(var s=0;s<=a;s++){for(var l=0,c=Math.min((s+1)*Sa,this.virtualScrollLength),u=s*Sa;u<c;u++)l+=this.virtualScrollSizes[u];this.virtualScrollSizesAgg.push(l)}this.prevToIndex=-1,this.prevScrollStart=void 0,t>=0?(this.__updateVirtualScrollSizes(this.virtualScrollSliceRange.from),this.$nextTick((function(){n.scrollTo(t)}))):(this.virtualScrollPaddingBefore=Ea(this.virtualScrollSizesAgg,this.virtualScrollSizes,0,this.virtualScrollSliceRange.from),this.virtualScrollPaddingAfter=Ea(this.virtualScrollSizesAgg,this.virtualScrollSizes,this.virtualScrollSliceRange.to,this.virtualScrollLength),this.__onVirtualScrollEvt())},__setVirtualScrollSize:function(t){if(this.virtualScrollSliceSize>0)this.virtualScrollSliceSizeComputed=this.virtualScrollSliceSize;else{if(void 0===t&&"undefined"!=typeof window){var e=this.__getVirtualScrollTarget();null!=e&&8!==e.nodeType&&(t=Ba(e,this.__getVirtualScrollEl(),this.$refs.before,this.$refs.after,this.virtualScrollHorizontal,this.$q.lang.rtl,this.virtualScrollStickySizeStart,this.virtualScrollStickySizeEnd).scrollViewSize)}this.__scrollViewSize=t,this.virtualScrollSliceSizeComputed=void 0===t||t<=0?30:Math.ceil(t/this.virtualScrollItemSize*3)}},__padVirtualScroll:function(t,e,n){var i,r,o,a,s=!0===this.virtualScrollHorizontal?"width":"height";return["tbody"===e?t(e,{staticClass:"q-virtual-scroll__padding",key:"before",ref:"before"},[t("tr",[t("td",{style:(i={},i[s]=this.virtualScrollPaddingBefore+"px",i),attrs:this.colspanAttr})])]):t(e,{staticClass:"q-virtual-scroll__padding",key:"before",ref:"before",style:(r={},r[s]=this.virtualScrollPaddingBefore+"px",r)}),t(e,{staticClass:"q-virtual-scroll__content",key:"content",ref:"content"},n),"tbody"===e?t(e,{staticClass:"q-virtual-scroll__padding",key:"after",ref:"after"},[t("tr",[t("td",{style:(o={},o[s]=this.virtualScrollPaddingAfter+"px",o),attrs:this.colspanAttr})])]):t(e,{staticClass:"q-virtual-scroll__padding",key:"after",ref:"after",style:(a={},a[s]=this.virtualScrollPaddingAfter+"px",a)})]},__emitScroll:function(t){this.prevToIndex!==t&&(void 0!==this.qListeners["virtual-scroll"]&&this.$emit("virtual-scroll",{index:t,from:this.virtualScrollSliceRange.from,to:this.virtualScrollSliceRange.to-1,direction:t<this.prevToIndex?"decrease":"increase",ref:this}),this.prevToIndex=t)}},created:function(){this.__setVirtualScrollSize()},beforeMount:function(){var t,e;void 0===Pa&&(t=document.createElement("div"),e=document.createElement("div"),t.setAttribute("dir","rtl"),t.style.width="1px",t.style.height="1px",t.style.overflow="auto",e.style.width="1000px",e.style.height="1px",document.body.appendChild(t),t.appendChild(e),t.scrollLeft=-1e3,Pa=t.scrollLeft>=0,t.remove()),this.__onVirtualScrollEvt=T(this.__onVirtualScrollEvt,!0===this.$q.platform.is.ios?120:70),this.__setVirtualScrollSize()}},qa=function(t){return["add","add-unique","toggle"].includes(t)},Ra=t.extend({name:"QSelect",mixins:[Dr,La,Yr,cn,Ot],props:{value:{required:!0},multiple:Boolean,displayValue:[String,Number],displayValueSanitize:Boolean,dropdownIcon:String,options:{type:Array,default:function(){return[]}},optionValue:[Function,String],optionLabel:[Function,String],optionDisable:[Function,String],hideSelected:Boolean,hideDropdownIcon:Boolean,fillInput:Boolean,maxValues:[Number,String],optionsDense:Boolean,optionsDark:{type:Boolean,default:null},optionsSelectedClass:String,optionsSanitize:Boolean,optionsCover:Boolean,menuShrink:Boolean,menuAnchor:String,menuSelf:String,menuOffset:Array,popupContentClass:String,popupContentStyle:[String,Array,Object],useInput:Boolean,useChips:Boolean,newValueMode:{type:String,validator:qa},mapOptions:Boolean,emitValue:Boolean,inputDebounce:{type:[Number,String],default:500},inputClass:[Array,String,Object],inputStyle:[Array,String,Object],tabindex:{type:[String,Number],default:0},transitionShow:String,transitionHide:String,behavior:{type:String,validator:function(t){return["default","menu","dialog"].includes(t)},default:"default"}},data:function(){return{menu:!1,dialog:!1,optionIndex:-1,inputValue:"",dialogFieldFocused:!1}},watch:{innerValue:{handler:function(t){this.innerValueCache=t,!0===this.useInput&&!0===this.fillInput&&!0!==this.multiple&&!0!==this.innerLoading&&(!0!==this.dialog&&!0!==this.menu||!0!==this.hasValue)&&(!0!==this.userInputValue&&this.__resetInputValue(),!0!==this.dialog&&!0!==this.menu||this.filter(""))},immediate:!0},fillInput:function(){this.__resetInputValue()},menu:function(t){this.__updateMenu(t)}},computed:{isOptionsDark:function(){return null===this.optionsDark?this.isDark:this.optionsDark},virtualScrollLength:function(){return Array.isArray(this.options)?this.options.length:0},fieldClass:function(){return"q-select q-field--auto-height q-select--with"+(!0!==this.useInput?"out":"")+"-input q-select--with"+(!0!==this.useChips?"out":"")+"-chips q-select--"+(!0===this.multiple?"multiple":"single")},computedInputClass:function(){return!0===this.hideSelected||0===this.innerValue.length?this.inputClass:void 0===this.inputClass?"q-field__input--padding":[this.inputClass,"q-field__input--padding"]},menuContentClass:function(){return(!0===this.virtualScrollHorizontal?"q-virtual-scroll--horizontal":"")+(this.popupContentClass?" "+this.popupContentClass:"")},innerValue:function(){var t=this,e=!0===this.mapOptions&&!0!==this.multiple,n=void 0===this.value||null===this.value&&!0!==e?[]:!0===this.multiple&&Array.isArray(this.value)?this.value:[this.value];if(!0===this.mapOptions&&!0===Array.isArray(this.options)){var i=!0===this.mapOptions&&void 0!==this.innerValueCache?this.innerValueCache:[],r=n.map((function(e){return t.__getOption(e,i)}));return null===this.value&&!0===e?r.filter((function(t){return null!==t})):r}return n},noOptions:function(){return 0===this.virtualScrollLength},selectedString:function(){var t=this;return this.innerValue.map((function(e){return t.getOptionLabel(e)})).join(", ")},sanitizeFn:function(){return!0===this.optionsSanitize?function(){return!0}:function(t){return null!=t&&!0===t.sanitize}},displayAsText:function(){return!0===this.displayValueSanitize||void 0===this.displayValue&&(!0===this.optionsSanitize||this.innerValue.some(this.sanitizeFn))},computedTabindex:function(){return!0===this.focused?this.tabindex:-1},selectedScope:function(){var t=this;return this.innerValue.map((function(e,n){return{index:n,opt:e,sanitize:t.sanitizeFn(e),selected:!0,removeAtIndex:t.__removeAtIndexAndFocus,toggleOption:t.toggleOption,tabindex:t.computedTabindex}}))},optionScope:function(){var t=this;if(0===this.virtualScrollLength)return[];var e=this.virtualScrollSliceRange,n=e.from,i=e.to;return this.options.slice(n,i).map((function(e,i){var r=!0===t.isOptionDisabled(e),o=n+i,a={clickable:!0,active:!1,activeClass:t.computedOptionsSelectedClass,manualFocus:!0,focused:!1,disable:r,tabindex:-1,dense:t.optionsDense,dark:t.isOptionsDark};!0!==r&&(!0===t.isOptionSelected(e)&&(a.active=!0),t.optionIndex===o&&(a.focused=!0));var s={click:function(){t.toggleOption(e)}};return!0===t.$q.platform.is.desktop&&(s.mousemove=function(){t.setOptionIndex(o)}),{index:o,opt:e,sanitize:t.sanitizeFn(e),selected:a.active,focused:a.focused,toggleOption:t.toggleOption,setOptionIndex:t.setOptionIndex,itemProps:a,itemEvents:s}}))},dropdownArrowIcon:function(){return void 0!==this.dropdownIcon?this.dropdownIcon:this.$q.iconSet.arrow.dropdown},squaredMenu:function(){return!1===this.optionsCover&&!0!==this.outlined&&!0!==this.standout&&!0!==this.borderless&&!0!==this.rounded},computedOptionsSelectedClass:function(){return void 0!==this.optionsSelectedClass?this.optionsSelectedClass:void 0!==this.color?"text-"+this.color:""},innerOptionsValue:function(){var t=this;return this.innerValue.map((function(e){return t.getOptionValue(e)}))},getOptionValue:function(){return this.__getPropValueFn("optionValue","value")},getOptionLabel:function(){return this.__getPropValueFn("optionLabel","label")},isOptionDisabled:function(){return this.__getPropValueFn("optionDisable","disable")},inputControlEvents:function(){var t=this,e={input:this.__onInput,change:this.__onChange,keydown:this.__onTargetKeydown,keyup:this.__onTargetKeyup,keypress:this.__onTargetKeypress,focus:this.__selectInputText,click:function(e){!0===t.hasDialog&&_(e)}};return e.compositionstart=e.compositionupdate=e.compositionend=this.__onComposition,e}},methods:{getEmittingOptionValue:function(t){return!0===this.emitValue?this.getOptionValue(t):t},removeAtIndex:function(t){if(t>-1&&t<this.innerValue.length)if(!0===this.multiple){var e=this.value.slice();this.$emit("remove",{index:t,value:e.splice(t,1)[0]}),this.$emit("input",e)}else this.$emit("input",null)},__removeAtIndexAndFocus:function(t){this.removeAtIndex(t),this.__focus()},add:function(t,e){var n=this.getEmittingOptionValue(t);if(!0!==this.multiple)return!0===this.fillInput&&this.updateInputValue(this.getOptionLabel(t),!0,!0),void this.$emit("input",n);if(0===this.innerValue.length)return this.$emit("add",{index:0,value:n}),void this.$emit("input",!0===this.multiple?[n]:n);if(!(!0===e&&!0===this.isOptionSelected(t)||void 0!==this.maxValues&&this.value.length>=this.maxValues)){var i=this.value.slice();this.$emit("add",{index:i.length,value:n}),i.push(n),this.$emit("input",i)}},toggleOption:function(t,e){if(!0===this.editable&&void 0!==t&&!0!==this.isOptionDisabled(t)){var n=this.getOptionValue(t);if(!0!==this.multiple)return!0!==e&&(this.updateInputValue(!0===this.fillInput?this.getOptionLabel(t):"",!0,!0),this.hidePopup()),void 0!==this.$refs.target&&this.$refs.target.focus(),void(!0!==Cn(this.getOptionValue(this.innerValue[0]),n)&&this.$emit("input",!0===this.emitValue?n:t));if((!0!==this.hasDialog||!0===this.dialogFieldFocused)&&this.__focus(),this.__selectInputText(),0===this.innerValue.length){var i=!0===this.emitValue?n:t;return this.$emit("add",{index:0,value:i}),void this.$emit("input",!0===this.multiple?[i]:i)}var r=this.value.slice(),o=this.innerOptionsValue.findIndex((function(t){return Cn(t,n)}));if(o>-1)this.$emit("remove",{index:o,value:r.splice(o,1)[0]});else{if(void 0!==this.maxValues&&r.length>=this.maxValues)return;var a=!0===this.emitValue?n:t;this.$emit("add",{index:r.length,value:a}),r.push(a)}this.$emit("input",r)}},setOptionIndex:function(t){if(!0===this.$q.platform.is.desktop){var e=t>-1&&t<this.virtualScrollLength?t:-1;this.optionIndex!==e&&(this.optionIndex=e)}},moveOptionSelection:function(t,e){if(void 0===t&&(t=1),!0===this.menu){var n=this.optionIndex;do{n=dt(n+t,-1,this.virtualScrollLength-1)}while(-1!==n&&n!==this.optionIndex&&!0===this.isOptionDisabled(this.options[n]));this.optionIndex!==n&&(this.setOptionIndex(n),this.scrollTo(n),!0!==e&&!0===this.useInput&&!0===this.fillInput&&this.__setInputValue(n>=0?this.getOptionLabel(this.options[n]):this.defaultInputValue))}},__getOption:function(t,e){var n=this,i=function(e){return Cn(n.getOptionValue(e),t)};return this.options.find(i)||e.find(i)||t},__getPropValueFn:function(t,e){var n=void 0!==this[t]?this[t]:e;return"function"==typeof n?n:function(t){return Object(t)===t&&n in t?t[n]:t}},isOptionSelected:function(t){var e=this.getOptionValue(t);return void 0!==this.innerOptionsValue.find((function(t){return Cn(t,e)}))},__selectInputText:function(){!0===this.useInput&&void 0!==this.$refs.target&&this.$refs.target.select()},__onTargetKeyup:function(t){!0===X(t,27)&&!0===this.menu&&(_(t),this.hidePopup(),this.__resetInputValue()),this.$emit("keyup",t)},__onTargetAutocomplete:function(t){var e=this,n=t.target.value;if(t.target.value="",void 0===t.keyCode){if("string"==typeof n&&n.length>0){var i=n.toLocaleLowerCase(),r=function(t){return e.getOptionValue(t).toLocaleLowerCase()===i},o=this.options.find(r);null!==o?-1===this.innerValue.indexOf(o)&&this.toggleOption(o):(r=function(t){return e.getOptionLabel(t).toLocaleLowerCase()===i},null!==(o=this.options.find(r))&&-1===this.innerValue.indexOf(o)&&this.toggleOption(o))}}else this.__onTargetKeyup(t)},__onTargetKeypress:function(t){this.$emit("keypress",t)},__onTargetKeydown:function(t){var e=this;if(this.$emit("keydown",t),!0!==Z(t)){var n=this.inputValue.length>0&&(void 0!==this.newValueMode||void 0!==this.qListeners["new-value"]),i=!0!==t.shiftKey&&!0!==this.multiple&&(this.optionIndex>-1||!0===n);if(27!==t.keyCode)if(9!==t.keyCode||!1!==i){if(void 0!==t.target&&t.target.id===this.targetUid){if(40===t.keyCode&&!0!==this.innerLoading&&!1===this.menu)return w(t),void this.showPopup();if(8===t.keyCode&&!0===this.multiple&&!0!==this.hideSelected&&0===this.inputValue.length&&Array.isArray(this.value))this.removeAtIndex(this.value.length-1);else{38!==t.keyCode&&40!==t.keyCode||(w(t),this.moveOptionSelection(38===t.keyCode?-1:1,this.multiple));var r=this.virtualScrollLength;if((void 0===this.searchBuffer||this.searchBufferExp<Date.now())&&(this.searchBuffer=""),r>0&&!0!==this.useInput&&1===t.key.length&&t.altKey===t.ctrlKey&&(32!==t.keyCode||this.searchBuffer.length>0)){!0!==this.menu&&this.showPopup(t);var o=t.key.toLocaleLowerCase(),a=1===this.searchBuffer.length&&this.searchBuffer[0]===o;this.searchBufferExp=Date.now()+1500,!1===a&&(w(t),this.searchBuffer+=o);var s=new RegExp("^"+this.searchBuffer.split("").map((function(t){return".*+?^${}()|[]\\".indexOf(t)>-1?"\\"+t:t})).join(".*"),"i"),l=this.optionIndex;if(!0===a||l<0||!0!==s.test(this.getOptionLabel(this.options[l])))do{l=dt(l+1,-1,r-1)}while(l!==this.optionIndex&&(!0===this.isOptionDisabled(this.options[l])||!0!==s.test(this.getOptionLabel(this.options[l]))));this.optionIndex!==l&&this.$nextTick((function(){e.setOptionIndex(l),e.scrollTo(l),l>=0&&!0===e.useInput&&!0===e.fillInput&&e.__setInputValue(e.getOptionLabel(e.options[l]))}))}else if(13===t.keyCode||32===t.keyCode&&!0!==this.useInput&&""===this.searchBuffer||9===t.keyCode&&!1!==i)if(9!==t.keyCode&&w(t),this.optionIndex>-1&&this.optionIndex<r)this.toggleOption(this.options[this.optionIndex]);else{if(!0===n){var c=function(t,n){if(n){if(!0!==qa(n))return}else n=e.newValueMode;null!=t&&(e.updateInputValue("",!0!==e.multiple,!0),e["toggle"===n?"toggleOption":"add"](t,"add-unique"===n),!0!==e.multiple&&(void 0!==e.$refs.target&&e.$refs.target.focus(),e.hidePopup()))};if(void 0!==this.qListeners["new-value"]?this.$emit("new-value",this.inputValue,c):c(this.inputValue),!0!==this.multiple)return}!0===this.menu?this.__closeMenu():!0!==this.innerLoading&&this.showPopup()}}}}else this.__closeMenu();else b(t)}},__getVirtualScrollEl:function(){return!0===this.hasDialog?this.$refs.menuContent:void 0!==this.$refs.menu&&void 0!==this.$refs.menu.__portal?this.$refs.menu.__portal.$el:void 0},__getVirtualScrollTarget:function(){return this.__getVirtualScrollEl()},__getSelection:function(t,e){var n,i=this;return!0===this.hideSelected?!0===e||!0!==this.dialog||!0!==this.hasDialog?[]:[t("span",{domProps:{textContent:this.inputValue}})]:void 0!==this.$scopedSlots["selected-item"]?this.selectedScope.map((function(t){return i.$scopedSlots["selected-item"](t)})).slice():void 0!==this.$scopedSlots.selected?this.$scopedSlots.selected().slice():!0===this.useChips?this.selectedScope.map((function(e,n){var r;return t(qn,{key:"option-"+n,props:{removable:!0===i.editable&&!0!==i.isOptionDisabled(e.opt),dense:!0,textColor:i.color,tabindex:i.computedTabindex},on:pt(i,"rem#"+n,{remove:function(){e.removeAtIndex(n)}})},[t("span",{staticClass:"ellipsis",domProps:(r={},r[!0===e.sanitize?"textContent":"innerHTML"]=i.getOptionLabel(e.opt),r)})])})):[t("span",{domProps:(n={},n[this.displayAsText?"textContent":"innerHTML"]=void 0!==this.displayValue?this.displayValue:this.selectedString,n)})]},__getControl:function(t,e){var n=this.__getSelection(t,e),i=!0===e||!0!==this.dialog||!0!==this.hasDialog;if(!0===i&&!0===this.useInput?n.push(this.__getInput(t,e)):!0===this.editable&&(!0===i&&n.push(t("div",{ref:"target",key:"d_t",staticClass:"no-outline",attrs:{id:this.targetUid,tabindex:this.tabindex},on:pt(this,"f-tget",{keydown:this.__onTargetKeydown,keyup:this.__onTargetKeyup,keypress:this.__onTargetKeypress})})),void 0!==this.qAttrs.autocomplete&&n.push(t("input",{staticClass:"q-select__autocomplete-input no-outline",attrs:{autocomplete:this.qAttrs.autocomplete},on:pt(this,"autoinp",{keyup:this.__onTargetAutocomplete})}))),void 0!==this.nameProp&&!0!==this.disable&&this.innerOptionsValue.length>0){var r=this.innerOptionsValue.map((function(e){return t("option",{attrs:{value:e,selected:!0}})}));n.push(t("select",{staticClass:"hidden",attrs:{name:this.nameProp,multiple:this.multiple}},r))}return t("div",{staticClass:"q-field__native row items-center",attrs:this.qAttrs},n)},__getOptions:function(t){var e=this;if(!0===this.menu){var n=void 0!==this.$scopedSlots.option?this.$scopedSlots.option:function(n){var i;return t(Jr,{key:n.index,props:n.itemProps,on:n.itemEvents},[t(Zr,[t(go,{domProps:(i={},i[!0===n.sanitize?"textContent":"innerHTML"]=e.getOptionLabel(n.opt),i)})])])},i=this.__padVirtualScroll(t,"div",this.optionScope.map(n));return void 0!==this.$scopedSlots["before-options"]&&(i=this.$scopedSlots["before-options"]().concat(i)),At(i,this,"after-options")}},__getInnerAppend:function(t){return!0!==this.loading&&!0!==this.innerLoading&&!0!==this.hideDropdownIcon?[t(Lt,{staticClass:"q-select__dropdown-icon",props:{name:this.dropdownArrowIcon}})]:null},__getInput:function(t,e){var n={ref:"target",key:"i_t",staticClass:"q-field__input q-placeholder col",style:this.inputStyle,class:this.computedInputClass,domProps:{value:void 0!==this.inputValue?this.inputValue:""},attrs:Object.assign({},{type:"search"},this.qAttrs,{id:this.targetUid,maxlength:this.maxlength,tabindex:this.tabindex,"data-autofocus":!0!==e&&this.autofocus,disabled:!0===this.disable,readonly:!0===this.readonly}),on:this.inputControlEvents};return!0!==e&&!0===this.hasDialog&&(n.staticClass+=" no-pointer-events",n.attrs.readonly=!0),t("input",n)},__onChange:function(t){this.__onComposition(t)},__onInput:function(t){var e=this;clearTimeout(this.inputTimer),t&&t.target&&!0===t.target.composing||(this.__setInputValue(t.target.value||""),this.userInputValue=!0,this.defaultInputValue=this.inputValue,!0===this.focused||!0===this.hasDialog&&!0!==this.dialogFieldFocused||this.__focus(),void 0!==this.qListeners.filter&&(this.inputTimer=setTimeout((function(){e.filter(e.inputValue)}),this.inputDebounce)))},__setInputValue:function(t){this.inputValue!==t&&(this.inputValue=t,this.$emit("input-value",t))},updateInputValue:function(t,e,n){this.userInputValue=!0!==n,!0===this.useInput&&(this.__setInputValue(t),!0!==e&&!0===n||(this.defaultInputValue=t),!0!==e&&this.filter(t))},filter:function(t){var e=this;if(void 0!==this.qListeners.filter&&!0===this.focused){!0===this.innerLoading?this.$emit("filter-abort"):this.innerLoading=!0,""!==t&&!0!==this.multiple&&this.innerValue.length>0&&!0!==this.userInputValue&&t===this.getOptionLabel(this.innerValue[0])&&(t="");var n=setTimeout((function(){!0===e.menu&&(e.menu=!1)}),10);clearTimeout(this.filterId),this.filterId=n,this.$emit("filter",t,(function(t,i){!0===e.focused&&e.filterId===n&&(clearTimeout(e.filterId),"function"==typeof t&&t(),e.$nextTick((function(){e.innerLoading=!1,!0===e.editable&&(!0===e.menu?e.__updateMenu(!0):e.menu=!0),"function"==typeof i&&e.$nextTick((function(){i(e)}))})))}),(function(){!0===e.focused&&e.filterId===n&&(clearTimeout(e.filterId),e.innerLoading=!1),!0===e.menu&&(e.menu=!1)}))}},__getControlEvents:function(){var t=this,e=function(e){t.__onControlFocusout(e,(function(){t.__resetInputValue(),t.__closeMenu()}))};return{focusin:this.__onControlFocusin,focusout:e,"popup-show":this.__onControlPopupShow,"popup-hide":function(n){void 0!==n&&_(n),t.$emit("popup-hide",n),t.hasPopupOpen=!1,e(n)},click:function(e){if(!0!==t.hasDialog){if(!0===t.useInput&&!0!==e.target.classList.contains("q-field__input")||!0!==t.useInput&&!0===e.target.classList.contains("no-outline"))return;if(!0===t.menu)return t.__closeMenu(),void(void 0!==t.$refs.target&&t.$refs.target.focus())}t.showPopup(e)}}},__getControlChild:function(t){if(!1!==this.editable&&(!0===this.dialog||!0!==this.noOptions||void 0!==this.$scopedSlots["no-option"]))return this["__get"+(!0===this.hasDialog?"Dialog":"Menu")](t)},__getMenu:function(t){var e=!0===this.noOptions?void 0!==this.$scopedSlots["no-option"]?this.$scopedSlots["no-option"]({inputValue:this.inputValue}):null:this.__getOptions(t);return t(an,{ref:"menu",props:{value:this.menu,fit:!0!==this.menuShrink,cover:!0===this.optionsCover&&!0!==this.noOptions&&!0!==this.useInput,anchor:this.menuAnchor,self:this.menuSelf,offset:this.menuOffset,contentClass:this.menuContentClass,contentStyle:this.popupContentStyle,dark:this.isOptionsDark,noParentEvent:!0,noRefocus:!0,noFocus:!0,square:this.squaredMenu,transitionShow:this.transitionShow,transitionHide:this.transitionHide,separateClosePopup:!0},on:pt(this,"menu",{"&scroll":this.__onVirtualScrollEvt,"before-hide":this.__closeMenu})},e)},__onDialogFieldFocus:function(t){_(t),void 0!==this.$refs.target&&this.$refs.target.focus(),this.dialogFieldFocused=!0,window.scrollTo(window.pageXOffset||window.scrollX||document.body.scrollLeft||0,0)},__onDialogFieldBlur:function(t){var e=this;_(t),this.$nextTick((function(){e.dialogFieldFocused=!1}))},__getDialog:function(t){var e=this,n=[t(Dr,{staticClass:"col-auto "+this.fieldClass,props:Object.assign({},this.$props,{for:this.targetUid,dark:this.isOptionsDark,square:!0,loading:this.innerLoading,filled:!0,stackLabel:this.inputValue.length>0}),on:Object.assign({},this.qListeners,{focus:this.__onDialogFieldFocus,blur:this.__onDialogFieldBlur}),scopedSlots:Object.assign({},this.$scopedSlots,{rawControl:function(){return e.__getControl(t,!0)},before:void 0,after:void 0})})];return!0===this.menu&&n.push(t("div",{ref:"menuContent",staticClass:"scroll",class:this.menuContentClass,style:this.popupContentStyle,on:pt(this,"virtMenu",{click:b,"&scroll":this.__onVirtualScrollEvt})},!0===this.noOptions?void 0!==this.$scopedSlots["no-option"]?this.$scopedSlots["no-option"]({inputValue:this.inputValue}):null:this.__getOptions(t))),t(wr,{ref:"dialog",props:{value:this.dialog,dark:this.isOptionsDark,position:!0===this.useInput?"top":void 0,transitionShow:this.transitionShowComputed,transitionHide:this.transitionHide},on:pt(this,"dialog",{"before-hide":this.__onDialogBeforeHide,hide:this.__onDialogHide,show:this.__onDialogShow})},[t("div",{staticClass:"q-select__dialog"+(!0===this.isOptionsDark?" q-select__dialog--dark q-dark":"")+(!0===this.dialogFieldFocused?" q-select__dialog--focused":"")},n)])},__onDialogBeforeHide:function(){this.$refs.dialog.__refocusTarget=this.$el.querySelector(".q-field__native > [tabindex]:last-child"),this.focused=!1},__onDialogHide:function(t){this.hidePopup(),!1===this.focused&&this.$emit("blur",t),this.__resetInputValue()},__onDialogShow:function(){var t=document.activeElement;null!==t&&t.id===this.targetUid||this.$refs.target===t||void 0===this.$refs.target||this.$refs.target.focus()},__closeMenu:function(){!0!==this.dialog&&(this.optionIndex=-1,!0===this.menu&&(this.menu=!1),!1===this.focused&&(clearTimeout(this.filterId),this.filterId=void 0,!0===this.innerLoading&&(this.$emit("filter-abort"),this.innerLoading=!1)))},showPopup:function(t){var e=this;!0===this.editable&&(!0===this.hasDialog?(this.__onControlFocusin(t),this.dialog=!0,this.$nextTick((function(){e.__focus()}))):this.__focus(),void 0!==this.qListeners.filter?this.filter(this.inputValue):!0===this.noOptions&&void 0===this.$scopedSlots["no-option"]||(this.menu=!0))},hidePopup:function(){this.dialog=!1,this.__closeMenu()},__resetInputValue:function(){!0===this.useInput&&this.updateInputValue(!0!==this.multiple&&!0===this.fillInput&&this.innerValue.length>0&&this.getOptionLabel(this.innerValue[0])||"",!0,!0)},__updateMenu:function(t){var e=this,n=-1;if(!0===t){if(this.innerValue.length>0){var i=this.getOptionValue(this.innerValue[0]);n=this.options.findIndex((function(t){return Cn(e.getOptionValue(t),i)}))}this.__resetVirtualScroll(n)}this.setOptionIndex(n)},__onPreRender:function(){this.hasDialog=(!0===this.$q.platform.is.mobile||"dialog"===this.behavior)&&("menu"!==this.behavior&&(!0!==this.useInput||(void 0!==this.$scopedSlots["no-option"]||void 0!==this.qListeners.filter||!1===this.noOptions))),this.transitionShowComputed=!0===this.hasDialog&&!0===this.useInput&&!0===this.$q.platform.is.ios?"fade":this.transitionShow},__onPostRender:function(){!1===this.dialog&&void 0!==this.$refs.menu&&this.$refs.menu.updatePosition()},updateMenuPosition:function(){this.__onPostRender()}},beforeDestroy:function(){clearTimeout(this.inputTimer)}}),Ia=["text","rect","circle","QBtn","QBadge","QChip","QToolbar","QCheckbox","QRadio","QToggle","QSlider","QRange","QInput","QAvatar"],Na=["wave","pulse","pulse-x","pulse-y","fade","blink","none"],Fa=t.extend({name:"QSkeleton",mixins:[It,Pt,Ot],props:{type:{type:String,validator:function(t){return Ia.includes(t)},default:"rect"},animation:{type:String,validator:function(t){return Na.includes(t)},default:"wave"},square:Boolean,bordered:Boolean,size:String,width:String,height:String},computed:{style:function(){return void 0!==this.size?{width:this.size,height:this.size}:{width:this.width,height:this.height}},classes:function(){return"q-skeleton--"+(!0===this.isDark?"dark":"light")+" q-skeleton--type-"+this.type+("none"!==this.animation?" q-skeleton--anim q-skeleton--anim-"+this.animation:"")+(!0===this.square?" q-skeleton--square":"")+(!0===this.bordered?" q-skeleton--bordered":"")}},render:function(t){return t(this.tag,{staticClass:"q-skeleton",class:this.classes,style:this.style,on:Object.assign({},this.qListeners)},Bt(this,"default"))}}),$a=[["left","center","start","width"],["right","center","end","width"],["top","start","center","height"],["bottom","end","center","height"]],ja=t.extend({name:"QSlideItem",mixins:[It,Ot],props:{leftColor:String,rightColor:String,topColor:String,bottomColor:String},directives:{TouchPan:Gn},computed:{langDir:function(){return!0===this.$q.lang.rtl?{left:"right",right:"left"}:{left:"left",right:"right"}}},methods:{reset:function(){this.$refs.content.style.transform="translate(0,0)"},__pan:function(t){var e,n,i,r=this,o=this.$refs.content;if(t.isFirst)this.__dir=null,this.__size={left:0,right:0,top:0,bottom:0},this.__scale=0,o.classList.add("no-transition"),$a.forEach((function(t){if(void 0!==r.$scopedSlots[t[0]]){var e=r.$refs[t[0]+"Content"];e.style.transform="scale(1)",r.__size[t[0]]=e.getBoundingClientRect()[t[3]]}})),this.__axis="up"===t.direction||"down"===t.direction?"Y":"X";else{if(t.isFinal)return o.classList.remove("no-transition"),void(1===this.__scale?(o.style.transform="translate"+this.__axis+"("+100*this.__dir+"%)",this.timer=setTimeout((function(){r.$emit(r.__showing,{reset:r.reset}),r.$emit("action",{side:r.__showing,reset:r.reset})}),230)):o.style.transform="translate(0,0)");t.direction="X"===this.__axis?t.offset.x<0?"left":"right":t.offset.y<0?"up":"down"}void 0===this.$scopedSlots.left&&t.direction===this.langDir.right||void 0===this.$scopedSlots.right&&t.direction===this.langDir.left||void 0===this.$scopedSlots.top&&"down"===t.direction||void 0===this.$scopedSlots.bottom&&"up"===t.direction?o.style.transform="translate(0,0)":("X"===this.__axis?(n="left"===t.direction?-1:1,e=1===n?this.langDir.left:this.langDir.right,i=t.distance.x):(n="up"===t.direction?-2:2,e=2===n?"top":"bottom",i=t.distance.y),null!==this.__dir&&Math.abs(n)!==Math.abs(this.__dir)||(this.__dir!==n&&(["left","right","top","bottom"].forEach((function(t){void 0!==r.$refs[t]&&(r.$refs[t].style.visibility=e===t?"visible":"hidden")})),this.__showing=e,this.__dir=n),this.__scale=Math.max(0,Math.min(1,(i-40)/this.__size[e])),o.style.transform="translate"+this.__axis+"("+i*n/Math.abs(n)+"px)",this.$refs[e+"Content"].style.transform="scale("+this.__scale+")"))}},render:function(t){var e=this,n=[],i={left:void 0!==this.$scopedSlots[this.langDir.right],right:void 0!==this.$scopedSlots[this.langDir.left],up:void 0!==this.$scopedSlots.bottom,down:void 0!==this.$scopedSlots.top},r=Object.keys(i).filter((function(t){return!0===i[t]}));return $a.forEach((function(i){var r=i[0];void 0!==e.$scopedSlots[r]&&n.push(t("div",{ref:r,class:"q-slide-item__"+r+" absolute-full row no-wrap items-"+i[1]+" justify-"+i[2]+(void 0!==e[r+"Color"]?" bg-"+e[r+"Color"]:"")},[t("div",{ref:r+"Content"},e.$scopedSlots[r]())]))})),n.push(t("div",{ref:"content",key:"content",staticClass:"q-slide-item__content",directives:r.length>0?mt(this,"dir#"+r.join(""),(function(){var t={prevent:!0,stop:!0,mouse:!0};return r.forEach((function(e){t[e]=!0})),[{name:"touch-pan",value:e.__pan,modifiers:t}]})):null},Bt(this,"default"))),t("div",{staticClass:"q-slide-item q-item-type overflow-hidden",class:!0===this.isDark?"q-slide-item--dark q-dark":"",on:Object.assign({},this.qListeners)},n)},beforeDestroy:function(){clearTimeout(this.timer)}}),za=t.extend({name:"QSpace",mixins:[Ot],render:function(t){return t("div",{staticClass:"q-space",on:Object.assign({},this.qListeners)})}}),Va=t.extend({name:"QSpinnerAudio",mixins:[Qt],render:function(t){return t("svg",{staticClass:"q-spinner",class:this.classes,on:Object.assign({},this.qListeners),attrs:{focusable:"false",fill:"currentColor",width:this.cSize,height:this.cSize,viewBox:"0 0 55 80",xmlns:"http://www.w3.org/2000/svg"}},[t("g",{attrs:{transform:"matrix(1 0 0 -1 0 80)"}},[t("rect",{attrs:{width:"10",height:"20",rx:"3"}},[t("animate",{attrs:{attributeName:"height",begin:"0s",dur:"4.3s",values:"20;45;57;80;64;32;66;45;64;23;66;13;64;56;34;34;2;23;76;79;20",calcMode:"linear",repeatCount:"indefinite"}})]),t("rect",{attrs:{x:"15",width:"10",height:"80",rx:"3"}},[t("animate",{attrs:{attributeName:"height",begin:"0s",dur:"2s",values:"80;55;33;5;75;23;73;33;12;14;60;80",calcMode:"linear",repeatCount:"indefinite"}})]),t("rect",{attrs:{x:"30",width:"10",height:"50",rx:"3"}},[t("animate",{attrs:{attributeName:"height",begin:"0s",dur:"1.4s",values:"50;34;78;23;56;23;34;76;80;54;21;50",calcMode:"linear",repeatCount:"indefinite"}})]),t("rect",{attrs:{x:"45",width:"10",height:"30",rx:"3"}},[t("animate",{attrs:{attributeName:"height",begin:"0s",dur:"2s",values:"30;45;13;80;56;72;45;76;34;23;67;30",calcMode:"linear",repeatCount:"indefinite"}})])])])}}),Ha=t.extend({name:"QSpinnerBall",mixins:[Qt],render:function(t){return t("svg",{staticClass:"q-spinner",class:this.classes,on:Object.assign({},this.qListeners),attrs:{focusable:"false",stroke:"currentColor",width:this.cSize,height:this.cSize,viewBox:"0 0 57 57",xmlns:"http://www.w3.org/2000/svg"}},[t("g",{attrs:{transform:"translate(1 1)","stroke-width":"2",fill:"none","fill-rule":"evenodd"}},[t("circle",{attrs:{cx:"5",cy:"50",r:"5"}},[t("animate",{attrs:{attributeName:"cy",begin:"0s",dur:"2.2s",values:"50;5;50;50",calcMode:"linear",repeatCount:"indefinite"}}),t("animate",{attrs:{attributeName:"cx",begin:"0s",dur:"2.2s",values:"5;27;49;5",calcMode:"linear",repeatCount:"indefinite"}})]),t("circle",{attrs:{cx:"27",cy:"5",r:"5"}},[t("animate",{attrs:{attributeName:"cy",begin:"0s",dur:"2.2s",from:"5",to:"5",values:"5;50;50;5",calcMode:"linear",repeatCount:"indefinite"}}),t("animate",{attrs:{attributeName:"cx",begin:"0s",dur:"2.2s",from:"27",to:"27",values:"27;49;5;27",calcMode:"linear",repeatCount:"indefinite"}})]),t("circle",{attrs:{cx:"49",cy:"50",r:"5"}},[t("animate",{attrs:{attributeName:"cy",begin:"0s",dur:"2.2s",values:"50;50;5;50",calcMode:"linear",repeatCount:"indefinite"}}),t("animate",{attrs:{attributeName:"cx",from:"49",to:"49",begin:"0s",dur:"2.2s",values:"49;5;27;49",calcMode:"linear",repeatCount:"indefinite"}})])])])}}),Wa=t.extend({name:"QSpinnerBars",mixins:[Qt],render:function(t){return t("svg",{staticClass:"q-spinner",class:this.classes,on:Object.assign({},this.qListeners),attrs:{focusable:"false",fill:"currentColor",width:this.cSize,height:this.cSize,viewBox:"0 0 135 140",xmlns:"http://www.w3.org/2000/svg"}},[t("rect",{attrs:{y:"10",width:"15",height:"120",rx:"6"}},[t("animate",{attrs:{attributeName:"height",begin:"0.5s",dur:"1s",values:"120;110;100;90;80;70;60;50;40;140;120",calcMode:"linear",repeatCount:"indefinite"}}),t("animate",{attrs:{attributeName:"y",begin:"0.5s",dur:"1s",values:"10;15;20;25;30;35;40;45;50;0;10",calcMode:"linear",repeatCount:"indefinite"}})]),t("rect",{attrs:{x:"30",y:"10",width:"15",height:"120",rx:"6"}},[t("animate",{attrs:{attributeName:"height",begin:"0.25s",dur:"1s",values:"120;110;100;90;80;70;60;50;40;140;120",calcMode:"linear",repeatCount:"indefinite"}}),t("animate",{attrs:{attributeName:"y",begin:"0.25s",dur:"1s",values:"10;15;20;25;30;35;40;45;50;0;10",calcMode:"linear",repeatCount:"indefinite"}})]),t("rect",{attrs:{x:"60",width:"15",height:"140",rx:"6"}},[t("animate",{attrs:{attributeName:"height",begin:"0s",dur:"1s",values:"120;110;100;90;80;70;60;50;40;140;120",calcMode:"linear",repeatCount:"indefinite"}}),t("animate",{attrs:{attributeName:"y",begin:"0s",dur:"1s",values:"10;15;20;25;30;35;40;45;50;0;10",calcMode:"linear",repeatCount:"indefinite"}})]),t("rect",{attrs:{x:"90",y:"10",width:"15",height:"120",rx:"6"}},[t("animate",{attrs:{attributeName:"height",begin:"0.25s",dur:"1s",values:"120;110;100;90;80;70;60;50;40;140;120",calcMode:"linear",repeatCount:"indefinite"}}),t("animate",{attrs:{attributeName:"y",begin:"0.25s",dur:"1s",values:"10;15;20;25;30;35;40;45;50;0;10",calcMode:"linear",repeatCount:"indefinite"}})]),t("rect",{attrs:{x:"120",y:"10",width:"15",height:"120",rx:"6"}},[t("animate",{attrs:{attributeName:"height",begin:"0.5s",dur:"1s",values:"120;110;100;90;80;70;60;50;40;140;120",calcMode:"linear",repeatCount:"indefinite"}}),t("animate",{attrs:{attributeName:"y",begin:"0.5s",dur:"1s",values:"10;15;20;25;30;35;40;45;50;0;10",calcMode:"linear",repeatCount:"indefinite"}})])])}}),Ua=t.extend({name:"QSpinnerComment",mixins:[Qt],render:function(t){return t("svg",{staticClass:"q-spinner",class:this.classes,on:Object.assign({},this.qListeners),attrs:{focusable:"false",width:this.cSize,height:this.cSize,xmlns:"http://www.w3.org/2000/svg",viewBox:"0 0 100 100",preserveAspectRatio:"xMidYMid"}},[t("rect",{attrs:{x:"0",y:"0",width:"100",height:"100",fill:"none"}}),t("path",{attrs:{d:"M78,19H22c-6.6,0-12,5.4-12,12v31c0,6.6,5.4,12,12,12h37.2c0.4,3,1.8,5.6,3.7,7.6c2.4,2.5,5.1,4.1,9.1,4 c-1.4-2.1-2-7.2-2-10.3c0-0.4,0-0.8,0-1.3h8c6.6,0,12-5.4,12-12V31C90,24.4,84.6,19,78,19z",fill:"currentColor"}}),t("circle",{attrs:{cx:"30",cy:"47",r:"5",fill:"#fff"}},[t("animate",{attrs:{attributeName:"opacity",from:"0",to:"1",values:"0;1;1",keyTimes:"0;0.2;1",dur:"1s",repeatCount:"indefinite"}})]),t("circle",{attrs:{cx:"50",cy:"47",r:"5",fill:"#fff"}},[t("animate",{attrs:{attributeName:"opacity",from:"0",to:"1",values:"0;0;1;1",keyTimes:"0;0.2;0.4;1",dur:"1s",repeatCount:"indefinite"}})]),t("circle",{attrs:{cx:"70",cy:"47",r:"5",fill:"#fff"}},[t("animate",{attrs:{attributeName:"opacity",from:"0",to:"1",values:"0;0;1;1",keyTimes:"0;0.4;0.6;1",dur:"1s",repeatCount:"indefinite"}})])])}}),Ya=t.extend({name:"QSpinnerCube",mixins:[Qt],render:function(t){return t("svg",{staticClass:"q-spinner",class:this.classes,on:Object.assign({},this.qListeners),attrs:{focusable:"false",width:this.cSize,height:this.cSize,xmlns:"http://www.w3.org/2000/svg",viewBox:"0 0 100 100",preserveAspectRatio:"xMidYMid"}},[t("rect",{attrs:{x:"0",y:"0",width:"100",height:"100",fill:"none"}}),t("g",{attrs:{transform:"translate(25 25)"}},[t("rect",{attrs:{x:"-20",y:"-20",width:"40",height:"40",fill:"currentColor",opacity:"0.9"}},[t("animateTransform",{attrs:{attributeName:"transform",type:"scale",from:"1.5",to:"1",repeatCount:"indefinite",begin:"0s",dur:"1s",calcMode:"spline",keySplines:"0.2 0.8 0.2 0.8",keyTimes:"0;1"}})])]),t("g",{attrs:{transform:"translate(75 25)"}},[t("rect",{attrs:{x:"-20",y:"-20",width:"40",height:"40",fill:"currentColor",opacity:"0.8"}},[t("animateTransform",{attrs:{attributeName:"transform",type:"scale",from:"1.5",to:"1",repeatCount:"indefinite",begin:"0.1s",dur:"1s",calcMode:"spline",keySplines:"0.2 0.8 0.2 0.8",keyTimes:"0;1"}})])]),t("g",{attrs:{transform:"translate(25 75)"}},[t("rect",{staticClass:"cube",attrs:{x:"-20",y:"-20",width:"40",height:"40",fill:"currentColor",opacity:"0.7"}},[t("animateTransform",{attrs:{attributeName:"transform",type:"scale",from:"1.5",to:"1",repeatCount:"indefinite",begin:"0.3s",dur:"1s",calcMode:"spline",keySplines:"0.2 0.8 0.2 0.8",keyTimes:"0;1"}})])]),t("g",{attrs:{transform:"translate(75 75)"}},[t("rect",{staticClass:"cube",attrs:{x:"-20",y:"-20",width:"40",height:"40",fill:"currentColor",opacity:"0.6"}},[t("animateTransform",{attrs:{attributeName:"transform",type:"scale",from:"1.5",to:"1",repeatCount:"indefinite",begin:"0.2s",dur:"1s",calcMode:"spline",keySplines:"0.2 0.8 0.2 0.8",keyTimes:"0;1"}})])])])}}),Qa=t.extend({name:"QSpinnerDots",mixins:[Qt],render:function(t){return t("svg",{staticClass:"q-spinner",class:this.classes,on:Object.assign({},this.qListeners),attrs:{focusable:"false",fill:"currentColor",width:this.cSize,height:this.cSize,viewBox:"0 0 120 30",xmlns:"http://www.w3.org/2000/svg"}},[t("circle",{attrs:{cx:"15",cy:"15",r:"15"}},[t("animate",{attrs:{attributeName:"r",from:"15",to:"15",begin:"0s",dur:"0.8s",values:"15;9;15",calcMode:"linear",repeatCount:"indefinite"}}),t("animate",{attrs:{attributeName:"fill-opacity",from:"1",to:"1",begin:"0s",dur:"0.8s",values:"1;.5;1",calcMode:"linear",repeatCount:"indefinite"}})]),t("circle",{attrs:{cx:"60",cy:"15",r:"9","fill-opacity":".3"}},[t("animate",{attrs:{attributeName:"r",from:"9",to:"9",begin:"0s",dur:"0.8s",values:"9;15;9",calcMode:"linear",repeatCount:"indefinite"}}),t("animate",{attrs:{attributeName:"fill-opacity",from:".5",to:".5",begin:"0s",dur:"0.8s",values:".5;1;.5",calcMode:"linear",repeatCount:"indefinite"}})]),t("circle",{attrs:{cx:"105",cy:"15",r:"15"}},[t("animate",{attrs:{attributeName:"r",from:"15",to:"15",begin:"0s",dur:"0.8s",values:"15;9;15",calcMode:"linear",repeatCount:"indefinite"}}),t("animate",{attrs:{attributeName:"fill-opacity",from:"1",to:"1",begin:"0s",dur:"0.8s",values:"1;.5;1",calcMode:"linear",repeatCount:"indefinite"}})])])}}),Ga=t.extend({name:"QSpinnerFacebook",mixins:[Qt],render:function(t){return t("svg",{staticClass:"q-spinner",class:this.classes,on:Object.assign({},this.qListeners),attrs:{focusable:"false",width:this.cSize,height:this.cSize,viewBox:"0 0 100 100",xmlns:"http://www.w3.org/2000/svg",preserveAspectRatio:"xMidYMid"}},[t("g",{attrs:{transform:"translate(20 50)"}},[t("rect",{attrs:{x:"-10",y:"-30",width:"20",height:"60",fill:"currentColor",opacity:"0.6"}},[t("animateTransform",{attrs:{attributeName:"transform",type:"scale",from:"2",to:"1",begin:"0s",repeatCount:"indefinite",dur:"1s",calcMode:"spline",keySplines:"0.1 0.9 0.4 1",keyTimes:"0;1",values:"2;1"}})])]),t("g",{attrs:{transform:"translate(50 50)"}},[t("rect",{attrs:{x:"-10",y:"-30",width:"20",height:"60",fill:"currentColor",opacity:"0.8"}},[t("animateTransform",{attrs:{attributeName:"transform",type:"scale",from:"2",to:"1",begin:"0.1s",repeatCount:"indefinite",dur:"1s",calcMode:"spline",keySplines:"0.1 0.9 0.4 1",keyTimes:"0;1",values:"2;1"}})])]),t("g",{attrs:{transform:"translate(80 50)"}},[t("rect",{attrs:{x:"-10",y:"-30",width:"20",height:"60",fill:"currentColor",opacity:"0.9"}},[t("animateTransform",{attrs:{attributeName:"transform",type:"scale",from:"2",to:"1",begin:"0.2s",repeatCount:"indefinite",dur:"1s",calcMode:"spline",keySplines:"0.1 0.9 0.4 1",keyTimes:"0;1",values:"2;1"}})])])])}}),Ka=t.extend({name:"QSpinnerGears",mixins:[Qt],render:function(t){return t("svg",{staticClass:"q-spinner",class:this.classes,on:Object.assign({},this.qListeners),attrs:{focusable:"false",width:this.cSize,height:this.cSize,viewBox:"0 0 100 100",preserveAspectRatio:"xMidYMid",xmlns:"http://www.w3.org/2000/svg"}},[t("g",{attrs:{transform:"translate(-20,-20)"}},[t("path",{attrs:{d:"M79.9,52.6C80,51.8,80,50.9,80,50s0-1.8-0.1-2.6l-5.1-0.4c-0.3-2.4-0.9-4.6-1.8-6.7l4.2-2.9c-0.7-1.6-1.6-3.1-2.6-4.5 L70,35c-1.4-1.9-3.1-3.5-4.9-4.9l2.2-4.6c-1.4-1-2.9-1.9-4.5-2.6L59.8,27c-2.1-0.9-4.4-1.5-6.7-1.8l-0.4-5.1C51.8,20,50.9,20,50,20 s-1.8,0-2.6,0.1l-0.4,5.1c-2.4,0.3-4.6,0.9-6.7,1.8l-2.9-4.1c-1.6,0.7-3.1,1.6-4.5,2.6l2.1,4.6c-1.9,1.4-3.5,3.1-5,4.9l-4.5-2.1 c-1,1.4-1.9,2.9-2.6,4.5l4.1,2.9c-0.9,2.1-1.5,4.4-1.8,6.8l-5,0.4C20,48.2,20,49.1,20,50s0,1.8,0.1,2.6l5,0.4 c0.3,2.4,0.9,4.7,1.8,6.8l-4.1,2.9c0.7,1.6,1.6,3.1,2.6,4.5l4.5-2.1c1.4,1.9,3.1,3.5,5,4.9l-2.1,4.6c1.4,1,2.9,1.9,4.5,2.6l2.9-4.1 c2.1,0.9,4.4,1.5,6.7,1.8l0.4,5.1C48.2,80,49.1,80,50,80s1.8,0,2.6-0.1l0.4-5.1c2.3-0.3,4.6-0.9,6.7-1.8l2.9,4.2 c1.6-0.7,3.1-1.6,4.5-2.6L65,69.9c1.9-1.4,3.5-3,4.9-4.9l4.6,2.2c1-1.4,1.9-2.9,2.6-4.5L73,59.8c0.9-2.1,1.5-4.4,1.8-6.7L79.9,52.6 z M50,65c-8.3,0-15-6.7-15-15c0-8.3,6.7-15,15-15s15,6.7,15,15C65,58.3,58.3,65,50,65z",fill:"currentColor"}},[t("animateTransform",{attrs:{attributeName:"transform",type:"rotate",from:"90 50 50",to:"0 50 50",dur:"1s",repeatCount:"indefinite"}})])]),t("g",{attrs:{transform:"translate(20,20) rotate(15 50 50)"}},[t("path",{attrs:{d:"M79.9,52.6C80,51.8,80,50.9,80,50s0-1.8-0.1-2.6l-5.1-0.4c-0.3-2.4-0.9-4.6-1.8-6.7l4.2-2.9c-0.7-1.6-1.6-3.1-2.6-4.5 L70,35c-1.4-1.9-3.1-3.5-4.9-4.9l2.2-4.6c-1.4-1-2.9-1.9-4.5-2.6L59.8,27c-2.1-0.9-4.4-1.5-6.7-1.8l-0.4-5.1C51.8,20,50.9,20,50,20 s-1.8,0-2.6,0.1l-0.4,5.1c-2.4,0.3-4.6,0.9-6.7,1.8l-2.9-4.1c-1.6,0.7-3.1,1.6-4.5,2.6l2.1,4.6c-1.9,1.4-3.5,3.1-5,4.9l-4.5-2.1 c-1,1.4-1.9,2.9-2.6,4.5l4.1,2.9c-0.9,2.1-1.5,4.4-1.8,6.8l-5,0.4C20,48.2,20,49.1,20,50s0,1.8,0.1,2.6l5,0.4 c0.3,2.4,0.9,4.7,1.8,6.8l-4.1,2.9c0.7,1.6,1.6,3.1,2.6,4.5l4.5-2.1c1.4,1.9,3.1,3.5,5,4.9l-2.1,4.6c1.4,1,2.9,1.9,4.5,2.6l2.9-4.1 c2.1,0.9,4.4,1.5,6.7,1.8l0.4,5.1C48.2,80,49.1,80,50,80s1.8,0,2.6-0.1l0.4-5.1c2.3-0.3,4.6-0.9,6.7-1.8l2.9,4.2 c1.6-0.7,3.1-1.6,4.5-2.6L65,69.9c1.9-1.4,3.5-3,4.9-4.9l4.6,2.2c1-1.4,1.9-2.9,2.6-4.5L73,59.8c0.9-2.1,1.5-4.4,1.8-6.7L79.9,52.6 z M50,65c-8.3,0-15-6.7-15-15c0-8.3,6.7-15,15-15s15,6.7,15,15C65,58.3,58.3,65,50,65z",fill:"currentColor"}},[t("animateTransform",{attrs:{attributeName:"transform",type:"rotate",from:"0 50 50",to:"90 50 50",dur:"1s",repeatCount:"indefinite"}})])])])}}),Ja=t.extend({name:"QSpinnerGrid",mixins:[Qt],render:function(t){return t("svg",{staticClass:"q-spinner",class:this.classes,on:Object.assign({},this.qListeners),attrs:{focusable:"false",fill:"currentColor",width:this.cSize,height:this.cSize,viewBox:"0 0 105 105",xmlns:"http://www.w3.org/2000/svg"}},[t("circle",{attrs:{cx:"12.5",cy:"12.5",r:"12.5"}},[t("animate",{attrs:{attributeName:"fill-opacity",begin:"0s",dur:"1s",values:"1;.2;1",calcMode:"linear",repeatCount:"indefinite"}})]),t("circle",{attrs:{cx:"12.5",cy:"52.5",r:"12.5","fill-opacity":".5"}},[t("animate",{attrs:{attributeName:"fill-opacity",begin:"100ms",dur:"1s",values:"1;.2;1",calcMode:"linear",repeatCount:"indefinite"}})]),t("circle",{attrs:{cx:"52.5",cy:"12.5",r:"12.5"}},[t("animate",{attrs:{attributeName:"fill-opacity",begin:"300ms",dur:"1s",values:"1;.2;1",calcMode:"linear",repeatCount:"indefinite"}})]),t("circle",{attrs:{cx:"52.5",cy:"52.5",r:"12.5"}},[t("animate",{attrs:{attributeName:"fill-opacity",begin:"600ms",dur:"1s",values:"1;.2;1",calcMode:"linear",repeatCount:"indefinite"}})]),t("circle",{attrs:{cx:"92.5",cy:"12.5",r:"12.5"}},[t("animate",{attrs:{attributeName:"fill-opacity",begin:"800ms",dur:"1s",values:"1;.2;1",calcMode:"linear",repeatCount:"indefinite"}})]),t("circle",{attrs:{cx:"92.5",cy:"52.5",r:"12.5"}},[t("animate",{attrs:{attributeName:"fill-opacity",begin:"400ms",dur:"1s",values:"1;.2;1",calcMode:"linear",repeatCount:"indefinite"}})]),t("circle",{attrs:{cx:"12.5",cy:"92.5",r:"12.5"}},[t("animate",{attrs:{attributeName:"fill-opacity",begin:"700ms",dur:"1s",values:"1;.2;1",calcMode:"linear",repeatCount:"indefinite"}})]),t("circle",{attrs:{cx:"52.5",cy:"92.5",r:"12.5"}},[t("animate",{attrs:{attributeName:"fill-opacity",begin:"500ms",dur:"1s",values:"1;.2;1",calcMode:"linear",repeatCount:"indefinite"}})]),t("circle",{attrs:{cx:"92.5",cy:"92.5",r:"12.5"}},[t("animate",{attrs:{attributeName:"fill-opacity",begin:"200ms",dur:"1s",values:"1;.2;1",calcMode:"linear",repeatCount:"indefinite"}})])])}}),Za=t.extend({name:"QSpinnerHearts",mixins:[Qt],render:function(t){return t("svg",{staticClass:"q-spinner",class:this.classes,on:Object.assign({},this.qListeners),attrs:{focusable:"false",fill:"currentColor",width:this.cSize,height:this.cSize,viewBox:"0 0 140 64",xmlns:"http://www.w3.org/2000/svg"}},[t("path",{attrs:{d:"M30.262 57.02L7.195 40.723c-5.84-3.976-7.56-12.06-3.842-18.063 3.715-6 11.467-7.65 17.306-3.68l4.52 3.76 2.6-5.274c3.716-6.002 11.47-7.65 17.304-3.68 5.84 3.97 7.56 12.054 3.842 18.062L34.49 56.118c-.897 1.512-2.793 1.915-4.228.9z","fill-opacity":".5"}},[t("animate",{attrs:{attributeName:"fill-opacity",begin:"0s",dur:"1.4s",values:"0.5;1;0.5",calcMode:"linear",repeatCount:"indefinite"}})]),t("path",{attrs:{d:"M105.512 56.12l-14.44-24.272c-3.716-6.008-1.996-14.093 3.843-18.062 5.835-3.97 13.588-2.322 17.306 3.68l2.6 5.274 4.52-3.76c5.84-3.97 13.593-2.32 17.308 3.68 3.718 6.003 1.998 14.088-3.842 18.064L109.74 57.02c-1.434 1.014-3.33.61-4.228-.9z","fill-opacity":".5"}},[t("animate",{attrs:{attributeName:"fill-opacity",begin:"0.7s",dur:"1.4s",values:"0.5;1;0.5",calcMode:"linear",repeatCount:"indefinite"}})]),t("path",{attrs:{d:"M67.408 57.834l-23.01-24.98c-5.864-6.15-5.864-16.108 0-22.248 5.86-6.14 15.37-6.14 21.234 0L70 16.168l4.368-5.562c5.863-6.14 15.375-6.14 21.235 0 5.863 6.14 5.863 16.098 0 22.247l-23.007 24.98c-1.43 1.556-3.757 1.556-5.188 0z"}})])}}),Xa=t.extend({name:"QSpinnerHourglass",mixins:[Qt],render:function(t){return t("svg",{staticClass:"q-spinner",class:this.classes,on:Object.assign({},this.qListeners),attrs:{focusable:"false",width:this.cSize,height:this.cSize,viewBox:"0 0 100 100",preserveAspectRatio:"xMidYMid",xmlns:"http://www.w3.org/2000/svg"}},[t("g",[t("path",{staticClass:"glass",attrs:{fill:"none",stroke:"currentColor","stroke-width":"5","stroke-miterlimit":"10",d:"M58.4,51.7c-0.9-0.9-1.4-2-1.4-2.3s0.5-0.4,1.4-1.4 C70.8,43.8,79.8,30.5,80,15.5H70H30H20c0.2,15,9.2,28.1,21.6,32.3c0.9,0.9,1.4,1.2,1.4,1.5s-0.5,1.6-1.4,2.5 C29.2,56.1,20.2,69.5,20,85.5h10h40h10C79.8,69.5,70.8,55.9,58.4,51.7z"}}),t("clipPath",{attrs:{id:"uil-hourglass-clip1"}},[t("rect",{staticClass:"clip",attrs:{x:"15",y:"20",width:"70",height:"25"}},[t("animate",{attrs:{attributeName:"height",from:"25",to:"0",dur:"1s",repeatCount:"indefinite",values:"25;0;0",keyTimes:"0;0.5;1"}}),t("animate",{attrs:{attributeName:"y",from:"20",to:"45",dur:"1s",repeatCount:"indefinite",values:"20;45;45",keyTimes:"0;0.5;1"}})])]),t("clipPath",{attrs:{id:"uil-hourglass-clip2"}},[t("rect",{staticClass:"clip",attrs:{x:"15",y:"55",width:"70",height:"25"}},[t("animate",{attrs:{attributeName:"height",from:"0",to:"25",dur:"1s",repeatCount:"indefinite",values:"0;25;25",keyTimes:"0;0.5;1"}}),t("animate",{attrs:{attributeName:"y",from:"80",to:"55",dur:"1s",repeatCount:"indefinite",values:"80;55;55",keyTimes:"0;0.5;1"}})])]),t("path",{staticClass:"sand",attrs:{d:"M29,23c3.1,11.4,11.3,19.5,21,19.5S67.9,34.4,71,23H29z","clip-path":"url(#uil-hourglass-clip1)",fill:"currentColor"}}),t("path",{staticClass:"sand",attrs:{d:"M71.6,78c-3-11.6-11.5-20-21.5-20s-18.5,8.4-21.5,20H71.6z","clip-path":"url(#uil-hourglass-clip2)",fill:"currentColor"}}),t("animateTransform",{attrs:{attributeName:"transform",type:"rotate",from:"0 50 50",to:"180 50 50",repeatCount:"indefinite",dur:"1s",values:"0 50 50;0 50 50;180 50 50",keyTimes:"0;0.7;1"}})])])}}),ts=t.extend({name:"QSpinnerInfinity",mixins:[Qt],render:function(t){return t("svg",{staticClass:"q-spinner",class:this.classes,on:Object.assign({},this.qListeners),attrs:{focusable:"false",width:this.cSize,height:this.cSize,viewBox:"0 0 100 100",preserveAspectRatio:"xMidYMid"}},[t("path",{attrs:{d:"M24.3,30C11.4,30,5,43.3,5,50s6.4,20,19.3,20c19.3,0,32.1-40,51.4-40C88.6,30,95,43.3,95,50s-6.4,20-19.3,20C56.4,70,43.6,30,24.3,30z",fill:"none",stroke:"currentColor","stroke-width":"8","stroke-dasharray":"10.691205342610678 10.691205342610678","stroke-dashoffset":"0"}},[t("animate",{attrs:{attributeName:"stroke-dashoffset",from:"0",to:"21.382410685221355",begin:"0",dur:"2s",repeatCount:"indefinite",fill:"freeze"}})])])}}),es=t.extend({name:"QSpinnerIos",mixins:[Qt],render:function(t){return t("svg",{staticClass:"q-spinner",class:this.classes,on:Object.assign({},this.qListeners),attrs:{focusable:"false",width:this.cSize,height:this.cSize,stroke:"currentColor",fill:"currentColor",viewBox:"0 0 64 64"}},[t("g",{attrs:{"stroke-width":"4","stroke-linecap":"round"}},[t("line",{attrs:{y1:"17",y2:"29",transform:"translate(32,32) rotate(180)"}},[t("animate",{attrs:{attributeName:"stroke-opacity",dur:"750ms",values:"1;.85;.7;.65;.55;.45;.35;.25;.15;.1;0;1",repeatCount:"indefinite"}})]),t("line",{attrs:{y1:"17",y2:"29",transform:"translate(32,32) rotate(210)"}},[t("animate",{attrs:{attributeName:"stroke-opacity",dur:"750ms",values:"0;1;.85;.7;.65;.55;.45;.35;.25;.15;.1;0",repeatCount:"indefinite"}})]),t("line",{attrs:{y1:"17",y2:"29",transform:"translate(32,32) rotate(240)"}},[t("animate",{attrs:{attributeName:"stroke-opacity",dur:"750ms",values:".1;0;1;.85;.7;.65;.55;.45;.35;.25;.15;.1",repeatCount:"indefinite"}})]),t("line",{attrs:{y1:"17",y2:"29",transform:"translate(32,32) rotate(270)"}},[t("animate",{attrs:{attributeName:"stroke-opacity",dur:"750ms",values:".15;.1;0;1;.85;.7;.65;.55;.45;.35;.25;.15",repeatCount:"indefinite"}})]),t("line",{attrs:{y1:"17",y2:"29",transform:"translate(32,32) rotate(300)"}},[t("animate",{attrs:{attributeName:"stroke-opacity",dur:"750ms",values:".25;.15;.1;0;1;.85;.7;.65;.55;.45;.35;.25",repeatCount:"indefinite"}})]),t("line",{attrs:{y1:"17",y2:"29",transform:"translate(32,32) rotate(330)"}},[t("animate",{attrs:{attributeName:"stroke-opacity",dur:"750ms",values:".35;.25;.15;.1;0;1;.85;.7;.65;.55;.45;.35",repeatCount:"indefinite"}})]),t("line",{attrs:{y1:"17",y2:"29",transform:"translate(32,32) rotate(0)"}},[t("animate",{attrs:{attributeName:"stroke-opacity",dur:"750ms",values:".45;.35;.25;.15;.1;0;1;.85;.7;.65;.55;.45",repeatCount:"indefinite"}})]),t("line",{attrs:{y1:"17",y2:"29",transform:"translate(32,32) rotate(30)"}},[t("animate",{attrs:{attributeName:"stroke-opacity",dur:"750ms",values:".55;.45;.35;.25;.15;.1;0;1;.85;.7;.65;.55",repeatCount:"indefinite"}})]),t("line",{attrs:{y1:"17",y2:"29",transform:"translate(32,32) rotate(60)"}},[t("animate",{attrs:{attributeName:"stroke-opacity",dur:"750ms",values:".65;.55;.45;.35;.25;.15;.1;0;1;.85;.7;.65",repeatCount:"indefinite"}})]),t("line",{attrs:{y1:"17",y2:"29",transform:"translate(32,32) rotate(90)"}},[t("animate",{attrs:{attributeName:"stroke-opacity",dur:"750ms",values:".7;.65;.55;.45;.35;.25;.15;.1;0;1;.85;.7",repeatCount:"indefinite"}})]),t("line",{attrs:{y1:"17",y2:"29",transform:"translate(32,32) rotate(120)"}},[t("animate",{attrs:{attributeName:"stroke-opacity",dur:"750ms",values:".85;.7;.65;.55;.45;.35;.25;.15;.1;0;1;.85",repeatCount:"indefinite"}})]),t("line",{attrs:{y1:"17",y2:"29",transform:"translate(32,32) rotate(150)"}},[t("animate",{attrs:{attributeName:"stroke-opacity",dur:"750ms",values:"1;.85;.7;.65;.55;.45;.35;.25;.15;.1;0;1",repeatCount:"indefinite"}})])])])}}),ns=t.extend({name:"QSpinnerOval",mixins:[Qt],render:function(t){return t("svg",{staticClass:"q-spinner",class:this.classes,on:Object.assign({},this.qListeners),attrs:{focusable:"false",stroke:"currentColor",width:this.cSize,height:this.cSize,viewBox:"0 0 38 38",xmlns:"http://www.w3.org/2000/svg"}},[t("g",{attrs:{transform:"translate(1 1)","stroke-width":"2",fill:"none","fill-rule":"evenodd"}},[t("circle",{attrs:{"stroke-opacity":".5",cx:"18",cy:"18",r:"18"}}),t("path",{attrs:{d:"M36 18c0-9.94-8.06-18-18-18"}},[t("animateTransform",{attrs:{attributeName:"transform",type:"rotate",from:"0 18 18",to:"360 18 18",dur:"1s",repeatCount:"indefinite"}})])])])}}),is=t.extend({name:"QSpinnerPie",mixins:[Qt],render:function(t){return t("svg",{staticClass:"q-spinner",class:this.classes,on:Object.assign({},this.qListeners),attrs:{focusable:"false",width:this.cSize,height:this.cSize,viewBox:"0 0 100 100",preserveAspectRatio:"xMidYMid",xmlns:"http://www.w3.org/2000/svg"}},[t("path",{attrs:{d:"M0 50A50 50 0 0 1 50 0L50 50L0 50",fill:"currentColor",opacity:"0.5"}},[t("animateTransform",{attrs:{attributeName:"transform",type:"rotate",from:"0 50 50",to:"360 50 50",dur:"0.8s",repeatCount:"indefinite"}})]),t("path",{attrs:{d:"M50 0A50 50 0 0 1 100 50L50 50L50 0",fill:"currentColor",opacity:"0.5"}},[t("animateTransform",{attrs:{attributeName:"transform",type:"rotate",from:"0 50 50",to:"360 50 50",dur:"1.6s",repeatCount:"indefinite"}})]),t("path",{attrs:{d:"M100 50A50 50 0 0 1 50 100L50 50L100 50",fill:"currentColor",opacity:"0.5"}},[t("animateTransform",{attrs:{attributeName:"transform",type:"rotate",from:"0 50 50",to:"360 50 50",dur:"2.4s",repeatCount:"indefinite"}})]),t("path",{attrs:{d:"M50 100A50 50 0 0 1 0 50L50 50L50 100",fill:"currentColor",opacity:"0.5"}},[t("animateTransform",{attrs:{attributeName:"transform",type:"rotate",from:"0 50 50",to:"360 50 50",dur:"3.2s",repeatCount:"indefinite"}})])])}}),rs=t.extend({name:"QSpinnerPuff",mixins:[Qt],render:function(t){return t("svg",{staticClass:"q-spinner",class:this.classes,on:Object.assign({},this.qListeners),attrs:{focusable:"false",stroke:"currentColor",width:this.cSize,height:this.cSize,viewBox:"0 0 44 44",xmlns:"http://www.w3.org/2000/svg"}},[t("g",{attrs:{fill:"none","fill-rule":"evenodd","stroke-width":"2"}},[t("circle",{attrs:{cx:"22",cy:"22",r:"1"}},[t("animate",{attrs:{attributeName:"r",begin:"0s",dur:"1.8s",values:"1; 20",calcMode:"spline",keyTimes:"0; 1",keySplines:"0.165, 0.84, 0.44, 1",repeatCount:"indefinite"}}),t("animate",{attrs:{attributeName:"stroke-opacity",begin:"0s",dur:"1.8s",values:"1; 0",calcMode:"spline",keyTimes:"0; 1",keySplines:"0.3, 0.61, 0.355, 1",repeatCount:"indefinite"}})]),t("circle",{attrs:{cx:"22",cy:"22",r:"1"}},[t("animate",{attrs:{attributeName:"r",begin:"-0.9s",dur:"1.8s",values:"1; 20",calcMode:"spline",keyTimes:"0; 1",keySplines:"0.165, 0.84, 0.44, 1",repeatCount:"indefinite"}}),t("animate",{attrs:{attributeName:"stroke-opacity",begin:"-0.9s",dur:"1.8s",values:"1; 0",calcMode:"spline",keyTimes:"0; 1",keySplines:"0.3, 0.61, 0.355, 1",repeatCount:"indefinite"}})])])])}}),os=t.extend({name:"QSpinnerRadio",mixins:[Qt],render:function(t){return t("svg",{staticClass:"q-spinner",class:this.classes,on:Object.assign({},this.qListeners),attrs:{focusable:"false",width:this.cSize,height:this.cSize,viewBox:"0 0 100 100",preserveAspectRatio:"xMidYMid",xmlns:"http://www.w3.org/2000/svg"}},[t("g",{attrs:{transform:"scale(0.55)"}},[t("circle",{attrs:{cx:"30",cy:"150",r:"30",fill:"currentColor"}},[t("animate",{attrs:{attributeName:"opacity",from:"0",to:"1",dur:"1s",begin:"0",repeatCount:"indefinite",keyTimes:"0;0.5;1",values:"0;1;1"}})]),t("path",{attrs:{d:"M90,150h30c0-49.7-40.3-90-90-90v30C63.1,90,90,116.9,90,150z",fill:"currentColor"}},[t("animate",{attrs:{attributeName:"opacity",from:"0",to:"1",dur:"1s",begin:"0.1",repeatCount:"indefinite",keyTimes:"0;0.5;1",values:"0;1;1"}})]),t("path",{attrs:{d:"M150,150h30C180,67.2,112.8,0,30,0v30C96.3,30,150,83.7,150,150z",fill:"currentColor"}},[t("animate",{attrs:{attributeName:"opacity",from:"0",to:"1",dur:"1s",begin:"0.2",repeatCount:"indefinite",keyTimes:"0;0.5;1",values:"0;1;1"}})])])])}}),as=t.extend({name:"QSpinnerRings",mixins:[Qt],render:function(t){return t("svg",{staticClass:"q-spinner",class:this.classes,on:Object.assign({},this.qListeners),attrs:{focusable:"false",stroke:"currentColor",width:this.cSize,height:this.cSize,viewBox:"0 0 45 45",xmlns:"http://www.w3.org/2000/svg"}},[t("g",{attrs:{fill:"none","fill-rule":"evenodd",transform:"translate(1 1)","stroke-width":"2"}},[t("circle",{attrs:{cx:"22",cy:"22",r:"6"}},[t("animate",{attrs:{attributeName:"r",begin:"1.5s",dur:"3s",values:"6;22",calcMode:"linear",repeatCount:"indefinite"}}),t("animate",{attrs:{attributeName:"stroke-opacity",begin:"1.5s",dur:"3s",values:"1;0",calcMode:"linear",repeatCount:"indefinite"}}),t("animate",{attrs:{attributeName:"stroke-width",begin:"1.5s",dur:"3s",values:"2;0",calcMode:"linear",repeatCount:"indefinite"}})]),t("circle",{attrs:{cx:"22",cy:"22",r:"6"}},[t("animate",{attrs:{attributeName:"r",begin:"3s",dur:"3s",values:"6;22",calcMode:"linear",repeatCount:"indefinite"}}),t("animate",{attrs:{attributeName:"stroke-opacity",begin:"3s",dur:"3s",values:"1;0",calcMode:"linear",repeatCount:"indefinite"}}),t("animate",{attrs:{attributeName:"stroke-width",begin:"3s",dur:"3s",values:"2;0",calcMode:"linear",repeatCount:"indefinite"}})]),t("circle",{attrs:{cx:"22",cy:"22",r:"8"}},[t("animate",{attrs:{attributeName:"r",begin:"0s",dur:"1.5s",values:"6;1;2;3;4;5;6",calcMode:"linear",repeatCount:"indefinite"}})])])])}}),ss=t.extend({name:"QSpinnerTail",mixins:[Qt],render:function(t){return t("svg",{staticClass:"q-spinner",class:this.classes,on:Object.assign({},this.qListeners),attrs:{focusable:"false",width:this.cSize,height:this.cSize,viewBox:"0 0 38 38",xmlns:"http://www.w3.org/2000/svg"}},[t("defs",[t("linearGradient",{attrs:{x1:"8.042%",y1:"0%",x2:"65.682%",y2:"23.865%",id:"a"}},[t("stop",{attrs:{"stop-color":"currentColor","stop-opacity":"0",offset:"0%"}}),t("stop",{attrs:{"stop-color":"currentColor","stop-opacity":".631",offset:"63.146%"}}),t("stop",{attrs:{"stop-color":"currentColor",offset:"100%"}})])]),t("g",{attrs:{transform:"translate(1 1)",fill:"none","fill-rule":"evenodd"}},[t("path",{attrs:{d:"M36 18c0-9.94-8.06-18-18-18",stroke:"url(#a)","stroke-width":"2"}},[t("animateTransform",{attrs:{attributeName:"transform",type:"rotate",from:"0 18 18",to:"360 18 18",dur:"0.9s",repeatCount:"indefinite"}})]),t("circle",{attrs:{fill:"currentColor",cx:"36",cy:"18",r:"1"}},[t("animateTransform",{attrs:{attributeName:"transform",type:"rotate",from:"0 18 18",to:"360 18 18",dur:"0.9s",repeatCount:"indefinite"}})])])])}}),ls=t.extend({name:"QSplitter",mixins:[It,Ot],directives:{TouchPan:Gn},props:{value:{type:Number,required:!0},reverse:Boolean,unit:{type:String,default:"%",validator:function(t){return["%","px"].includes(t)}},limits:{type:Array,validator:function(t){return 2===t.length&&("number"==typeof t[0]&&"number"==typeof t[1]&&(t[0]>=0&&t[0]<=t[1]))}},emitImmediately:Boolean,horizontal:Boolean,disable:Boolean,beforeClass:[Array,String,Object],afterClass:[Array,String,Object],separatorClass:[Array,String,Object],separatorStyle:[Array,String,Object]},watch:{value:{immediate:!0,handler:function(t){this.__normalize(t,this.computedLimits)}},limits:{deep:!0,handler:function(){var t=this;this.$nextTick((function(){t.__normalize(t.value,t.computedLimits)}))}}},computed:{classes:function(){return(!0===this.horizontal?"column":"row")+" q-splitter--"+(!0===this.horizontal?"horizontal":"vertical")+" q-splitter--"+(!0===this.disable?"disabled":"workable")+(!0===this.isDark?" q-splitter--dark":"")},prop:function(){return!0===this.horizontal?"height":"width"},side:function(){return!0!==this.reverse?"before":"after"},computedLimits:function(){return void 0!==this.limits?this.limits:"%"===this.unit?[10,90]:[50,1/0]},styles:function(){var t,e;return(e={})[this.side]=((t={})[this.prop]=this.__getCSSValue(this.value),t),e},separatorDirectives:function(){var t;if(!0!==this.disable)return[{name:"touch-pan",value:this.__pan,modifiers:(t={},t[!0===this.horizontal?"vertical":"horizontal"]=!0,t.prevent=!0,t.stop=!0,t.mouse=!0,t.mouseAllDir=!0,t)}]}},methods:{__pan:function(t){if(!0===t.isFirst){var e=this.$el.getBoundingClientRect()[this.prop];return this.__dir=!0===this.horizontal?"up":"left",this.__maxValue="%"===this.unit?100:e,this.__value=Math.min(this.__maxValue,this.computedLimits[1],Math.max(this.computedLimits[0],this.value)),this.__multiplier=(!0!==this.reverse?1:-1)*(!0===this.horizontal?1:!0===this.$q.lang.rtl?-1:1)*("%"===this.unit?0===e?0:100/e:1),void this.$el.classList.add("q-splitter--active")}if(!0===t.isFinal)return this.__normalized!==this.value&&this.$emit("input",this.__normalized),void this.$el.classList.remove("q-splitter--active");var n=this.__value+this.__multiplier*(t.direction===this.__dir?-1:1)*t.distance[!0===this.horizontal?"y":"x"];this.__normalized=Math.min(this.__maxValue,this.computedLimits[1],Math.max(this.computedLimits[0],n)),this.$refs[this.side].style[this.prop]=this.__getCSSValue(this.__normalized),!0===this.emitImmediately&&this.value!==this.__normalized&&this.$emit("input",this.__normalized)},__normalize:function(t,e){t<e[0]?this.$emit("input",e[0]):t>e[1]&&this.$emit("input",e[1])},__getCSSValue:function(t){return("%"===this.unit?t:Math.round(t))+this.unit}},render:function(t){var e=!0===this.disable?{"aria-disabled":"true"}:void 0,n=[t("div",{ref:"before",staticClass:"q-splitter__panel q-splitter__before"+(!0===this.reverse?" col":""),style:this.styles.before,class:this.beforeClass,on:pt(this,"stop",{input:_})},Bt(this,"before")),t("div",{staticClass:"q-splitter__separator",style:this.separatorStyle,class:this.separatorClass,attrs:e},[t("div",{staticClass:"absolute-full q-splitter__separator-area",directives:this.separatorDirectives},Bt(this,"separator"))]),t("div",{ref:"after",staticClass:"q-splitter__panel q-splitter__after"+(!0===this.reverse?"":" col"),style:this.styles.after,class:this.afterClass,on:pt(this,"stop",{input:_})},Bt(this,"after"))];return t("div",{staticClass:"q-splitter no-wrap",class:this.classes,on:Object.assign({},this.qListeners)},At(n,this,"default"))}}),cs=t.extend({name:"StepHeader",mixins:[yt],directives:{Ripple:oe},props:{stepper:{},step:{}},computed:{isActive:function(){return this.stepper.value===this.step.name},isDisable:function(){var t=this.step.disable;return!0===t||""===t},isError:function(){var t=this.step.error;return!0===t||""===t},isDone:function(){var t=this.step.done;return!1===this.isDisable&&(!0===t||""===t)},headerNav:function(){var t=this.step.headerNav,e=!0===t||""===t||void 0===t;return!1===this.isDisable&&this.stepper.headerNav&&e},hasPrefix:function(){return this.step.prefix&&!1===this.isActive&&!1===this.isError&&!1===this.isDone},icon:function(){return!0===this.isActive?this.step.activeIcon||this.stepper.activeIcon||this.$q.iconSet.stepper.active:!0===this.isError?this.step.errorIcon||this.stepper.errorIcon||this.$q.iconSet.stepper.error:!1===this.isDisable&&!0===this.isDone?this.step.doneIcon||this.stepper.doneIcon||this.$q.iconSet.stepper.done:this.step.icon||this.stepper.inactiveIcon},color:function(){var t=!0===this.isError?this.step.errorColor||this.stepper.errorColor:void 0;if(!0===this.isActive){var e=this.step.activeColor||this.stepper.activeColor||this.step.color;return void 0!==e?e:t}return void 0!==t?t:!1===this.isDisable&&!0===this.isDone?this.step.doneColor||this.stepper.doneColor||this.step.color||this.stepper.inactiveColor:this.step.color||this.stepper.inactiveColor},classes:function(){return"q-stepper__tab col-grow flex items-center no-wrap relative-position"+(void 0!==this.color?" text-"+this.color:"")+(!0===this.isError?" q-stepper__tab--error":"")+(!0===this.isActive?" q-stepper__tab--active":"")+(!0===this.isDone?" q-stepper__tab--done":"")+(!0===this.headerNav?" q-stepper__tab--navigation q-focusable q-hoverable":"")+(!0===this.isDisable?" q-stepper__tab--disabled":"")}},methods:{activate:function(){void 0!==this.$refs.blurTarget&&this.$refs.blurTarget.focus(),!1===this.isActive&&this.stepper.goTo(this.step.name)},keyup:function(t){13===t.keyCode&&!1===this.isActive&&this.stepper.goTo(this.step.name)}},render:function(t){var e={class:this.classes};!0===this.stepper.headerNav&&(e.directives=[{name:"ripple",value:this.headerNav}]),!0===this.headerNav&&Object.assign(e,{on:pt(this,"headnavon",{click:this.activate,keyup:this.keyup}),attrs:!0===this.isDisable?{tabindex:-1,"aria-disabled":"true"}:{tabindex:this.qAttrs.tabindex||0}});var n=[t("div",{staticClass:"q-focus-helper",attrs:{tabindex:-1},ref:"blurTarget"}),t("div",{staticClass:"q-stepper__dot row flex-center q-stepper__line relative-position"},[t("span",{staticClass:"row flex-center"},[!0===this.hasPrefix?this.step.prefix:t(Lt,{props:{name:this.icon}})])])];if(void 0!==this.step.title&&null!==this.step.title){var i=[t("div",{staticClass:"q-stepper__title"},[this.step.title])];void 0!==this.step.caption&&null!==this.step.caption&&i.push(t("div",{staticClass:"q-stepper__caption"},[this.step.caption])),n.push(t("div",{staticClass:"q-stepper__label q-stepper__line relative-position"},i))}return t("div",e,n)}}),us=t.extend({name:"QStepWrapper",render:function(t){return t("div",{staticClass:"q-stepper__step-content"},[t("div",{staticClass:"q-stepper__step-inner"},Bt(this,"default"))])}}),ds=t.extend({name:"QStep",inject:{stepper:{default:function(){console.error("QStep needs to be child of QStepper")}}},mixins:[_n],props:{icon:String,color:String,title:{type:String,required:!0},caption:String,prefix:[String,Number],doneIcon:String,doneColor:String,activeIcon:String,activeColor:String,errorIcon:String,errorColor:String,headerNav:{type:Boolean,default:!0},done:Boolean,error:Boolean},computed:{isActive:function(){return this.stepper.value===this.name}},watch:{isActive:function(t){var e=this;!0===t&&!0===this.stepper.vertical&&this.$nextTick((function(){void 0!==e.$el&&(e.$el.scrollTop=0)}))}},render:function(t){var e=this.stepper.vertical,n=!0===e&&!0===this.stepper.keepAlive?t("keep-alive",!0===this.isActive?[t(us,{key:this.name},Bt(this,"default"))]:void 0):!0!==e||!0===this.isActive?us.options.render.call(this,t):void 0;return t("div",{staticClass:"q-stepper__step",on:Object.assign({},this.qListeners)},!0===e?[t(cs,{props:{stepper:this.stepper,step:this}}),!0===this.stepper.animated?t(yo,[n]):n]:[n])}}),hs=t.extend({name:"QStepper",provide:function(){return{stepper:this}},mixins:[It,yn],props:{flat:Boolean,bordered:Boolean,alternativeLabels:Boolean,headerNav:Boolean,contracted:Boolean,headerClass:String,inactiveColor:String,inactiveIcon:String,doneIcon:String,doneColor:String,activeIcon:String,activeColor:String,errorIcon:String,errorColor:String},computed:{classes:function(){return"q-stepper q-stepper--"+(!0===this.vertical?"vertical":"horizontal")+(!0===this.flat||!0===this.isDark?" q-stepper--flat no-shadow":"")+(!0===this.bordered||!0===this.isDark&&!1===this.flat?" q-stepper--bordered":"")+(!0===this.contracted?" q-stepper--contracted":"")+(!0===this.isDark?" q-stepper--dark q-dark":"")},headerClasses:function(){return"q-stepper__header row items-stretch justify-between q-stepper__header--"+(!0===this.alternativeLabels?"alternative":"standard")+"-labels"+(!1===this.flat||!0===this.bordered?" q-stepper__header--border":"")+(void 0!==this.headerClass?" "+this.headerClass:"")}},methods:{__getContent:function(t){var e=this,n=Bt(this,"message",[]);if(!0===this.vertical){this.__isValidPanelName(this.value)&&this.__updatePanelIndex();var i=t("div",{staticClass:"q-stepper__content",on:pt(this,"stop",{input:_})},Bt(this,"default"));return void 0===n?[i]:n.concat(i)}return[t("div",{class:this.headerClasses},this.__getAllPanels().map((function(n){var i=n.componentOptions.propsData;return t(cs,{key:i.name,props:{stepper:e,step:i}})})))].concat(n,t("div",{staticClass:"q-stepper__content q-panel-parent",directives:this.panelDirectives},this.__getPanelContent(t)))},__renderPanels:function(t){return t("div",{class:this.classes,on:Object.assign({},this.qListeners)},At(this.__getContent(t),this,"navigation"))}}}),fs=t.extend({name:"QStepperNavigation",mixins:[Ot],render:function(t){return t("div",{staticClass:"q-stepper__nav",on:Object.assign({},this.qListeners)},Bt(this,"default"))}}),ps=t.extend({name:"QTh",mixins:[Ot],props:{props:Object,autoWidth:Boolean},render:function(t){var e,n,i=this,r=Object.assign({},this.qListeners);if(void 0===this.props)return t("th",{on:r,class:!0===this.autoWidth?"q-table--col-auto-width":null},Bt(this,"default"));var o=this.$vnode.key;if(o){if(void 0===(e=this.props.colsMap[o]))return}else e=this.props.col;if(!0===e.sortable){var a="right"===e.align?"unshift":"push";(n=Et(this,"default",[]))[a](t(Lt,{props:{name:this.$q.iconSet.table.arrowUp},staticClass:e.__iconClass}))}else n=Bt(this,"default");var s=!0===e.sortable?{click:function(t){i.props.sort(e),i.$emit("click",t)}}:{};return t("th",{on:Object.assign({},r,s),style:e.headerStyle,class:e.__thClass+(!0===this.autoWidth?" q-table--col-auto-width":"")},n)}}),ms={methods:{getTableHeader:function(t){var e=this.getTableHeaderRow(t);return!0===this.loading&&void 0===this.$scopedSlots.loading&&e.push(t("tr",{staticClass:"q-table__progress"},[t("th",{staticClass:"relative-position",attrs:{colspan:this.computedColspan}},this.__getProgress(t))])),t("thead",e)},getTableHeaderRow:function(t){var e=this,n=this.$scopedSlots.header,i=this.$scopedSlots["header-cell"];if(void 0!==n)return n(this.addTableHeaderRowMeta({header:!0,cols:this.computedCols,sort:this.sort,colsMap:this.computedColsMap})).slice();var r=this.computedCols.map((function(n){var r=e.$scopedSlots["header-cell-"+n.name],o=void 0!==r?r:i,a={col:n,cols:e.computedCols,sort:e.sort,colsMap:e.computedColsMap};return void 0!==o?o(a):t(ps,{key:n.name,props:{props:a},style:n.headerStyle,class:n.headerClasses},n.label)}));return!0===this.singleSelection&&!0!==this.grid?r.unshift(t("th",{staticClass:"q-table--col-auto-width"},[" "])):!0===this.multipleSelection&&r.unshift(t("th",{staticClass:"q-table--col-auto-width"},[t(Ln,{props:{color:this.color,value:!0===this.someRowsSelected?null:this.allRowsSelected,dark:this.isDark,dense:this.dense},on:pt(this,"inp",{input:function(t){!0===e.someRowsSelected&&(t=!1),e.__updateSelection(e.computedRows.map(e.getRowKey),e.computedRows,t)}})})])),[t("tr",{style:this.tableHeaderStyle,class:this.tableHeaderClass},r)]},addTableHeaderRowMeta:function(t){var e=this;return!0===this.multipleSelection&&(Object.defineProperty(t,"selected",{get:function(){return!0===e.someRowsSelected?"some":e.allRowsSelected},set:function(t){!0===e.someRowsSelected&&(t=!1),e.__updateSelection(e.computedRows.map(e.getRowKey),e.computedRows,t)},configurable:!0,enumerable:!0}),t.partialSelected=this.someRowsSelected,t.multipleSelect=!0),t}}},vs={methods:{getTableRowBody:function(t,e,n){var i=this.getRowKey(t),r=this.isRowSelected(i);return e(this.addBodyRowMeta({key:i,row:t,pageIndex:n,cols:this.computedCols,colsMap:this.computedColsMap,__trClass:r?"selected":""}))},getTableRow:function(t,e,n){var i=this,r=this.$scopedSlots["body-cell"],o=this.getRowKey(e),a=this.isRowSelected(o),s=this.computedCols.map((function(o){var a=i.$scopedSlots["body-cell-"+o.name],s=void 0!==a?a:r;return void 0!==s?s(i.addBodyCellMetaData({row:e,pageIndex:n,col:o})):t("td",{class:o.__tdClass,style:o.style},i.getCellValue(o,e))}));!0===this.hasSelectionMode&&s.unshift(t("td",{staticClass:"q-table--col-auto-width"},[t(Ln,{props:{value:a,color:this.color,dark:this.isDark,dense:this.dense},on:{input:function(t,n){i.__updateSelection([o],[e],t,n)}}})]));var l={key:o,class:{selected:a},on:{}};return void 0!==this.qListeners["row-click"]&&(l.class["cursor-pointer"]=!0,l.on.click=function(t){i.$emit("row-click",t,e,n)}),void 0!==this.qListeners["row-dblclick"]&&(l.class["cursor-pointer"]=!0,l.on.dblclick=function(t){i.$emit("row-dblclick",t,e,n)}),t("tr",l,s)},getTableBody:function(t){var e=this,n=this.$scopedSlots.body,i=this.$scopedSlots["top-row"],r=this.$scopedSlots["bottom-row"],o=void 0!==n?function(t,i){return e.getTableRowBody(t,n,i)}:function(n,i){return e.getTableRow(t,n,i)},a=this.computedRows.map(o);return void 0!==i&&(a=i({cols:this.computedCols}).concat(a)),void 0!==r&&(a=a.concat(r({cols:this.computedCols}))),t("tbody",a)},getTableRowVirtual:function(t){var e=this,n=this.$scopedSlots.body;return void 0!==n?function(t){return e.getTableRowBody(t.item,n,t.index)}:function(n){return e.getTableRow(t,n.item,n.index)}},addBodyRowMeta:function(t){var e=this;return t.rowIndex=this.firstRowIndex+t.pageIndex,!0===this.hasSelectionMode&&Object.defineProperty(t,"selected",{get:function(){return e.isRowSelected(t.key)},set:function(n){e.__updateSelection([t.key],[t.row],n)},configurable:!0,enumerable:!0}),Object.defineProperty(t,"expand",{get:function(){return e.isRowExpanded(t.key)},set:function(n){e.__updateExpanded(t.key,n)},configurable:!0,enumerable:!0}),t.cols=t.cols.map((function(n){var i=Object.assign({},n);return Object.defineProperty(i,"value",{get:function(){return e.getCellValue(n,t.row)},configurable:!0,enumerable:!0}),i})),t},addBodyCellMetaData:function(t){var e=this;return t.rowIndex=this.firstRowIndex+t.pageIndex,Object.defineProperty(t,"value",{get:function(){return e.getCellValue(t.col,t.row)},configurable:!0,enumerable:!0}),t},getCellValue:function(t,e){var n="function"==typeof t.field?t.field(e):e[t.field];return void 0!==t.format?t.format(n,e):n}}},gs="q-table__bottom row items-center",ys={props:{hideBottom:Boolean,hideSelectedBanner:Boolean,hideNoData:Boolean,hidePagination:Boolean},computed:{navIcon:function(){var t=[this.iconFirstPage||this.$q.iconSet.table.firstPage,this.iconPrevPage||this.$q.iconSet.table.prevPage,this.iconNextPage||this.$q.iconSet.table.nextPage,this.iconLastPage||this.$q.iconSet.table.lastPage];return!0===this.$q.lang.rtl?t.reverse():t}},methods:{getBottom:function(t){if(!0!==this.hideBottom){if(!0===this.nothingToDisplay){if(!0===this.hideNoData)return;var e=!0===this.loading?this.loadingLabel||this.$q.lang.table.loading:this.filter?this.noResultsLabel||this.$q.lang.table.noResults:this.noDataLabel||this.$q.lang.table.noData,n=this.$scopedSlots["no-data"],i=void 0!==n?[n({message:e,icon:this.$q.iconSet.table.warning,filter:this.filter})]:[t(Lt,{staticClass:"q-table__bottom-nodata-icon",props:{name:this.$q.iconSet.table.warning}}),e];return t("div",{staticClass:gs+" q-table__bottom--nodata"},i)}var r=this.$scopedSlots.bottom;if(void 0!==r)return t("div",{staticClass:gs},[r(this.marginalsProps)]);var o=!0!==this.hideSelectedBanner&&!0===this.hasSelectionMode&&this.rowsSelectedNumber>0?[t("div",{staticClass:"q-table__control"},[t("div",[(this.selectedRowsLabel||this.$q.lang.table.selectedRecords)(this.rowsSelectedNumber)])])]:[];return!0!==this.hidePagination?t("div",{staticClass:gs+" justify-end"},this.getPaginationRow(t,o)):o.length>0?t("div",{staticClass:gs},o):void 0}},getPaginationRow:function(t,e){var n,i=this,r=this.computedPagination.rowsPerPage,o=this.paginationLabel||this.$q.lang.table.pagination,a=this.$scopedSlots.pagination,s=this.rowsPerPageOptions.length>1;if(e.push(t("div",{staticClass:"q-table__separator col"})),!0===s&&e.push(t("div",{staticClass:"q-table__control"},[t("span",{staticClass:"q-table__bottom-item"},[this.rowsPerPageLabel||this.$q.lang.table.recordsPerPage]),t(Ra,{staticClass:"q-table__select inline q-table__bottom-item",props:{color:this.color,value:r,options:this.computedRowsPerPageOptions,displayValue:0===r?this.$q.lang.table.allRows:r,dark:this.isDark,borderless:!0,dense:!0,optionsDense:!0,optionsCover:!0},on:pt(this,"pgSize",{input:function(t){i.setPagination({page:1,rowsPerPage:t.value})}})})])),void 0!==a)n=a(this.marginalsProps);else if(n=[t("span",0!==r?{staticClass:"q-table__bottom-item"}:{},[r?o(this.firstRowIndex+1,Math.min(this.lastRowIndex,this.computedRowsNumber),this.computedRowsNumber):o(1,this.filteredSortedRowsNumber,this.computedRowsNumber)])],0!==r&&this.pagesNumber>1){var l={color:this.color,round:!0,dense:!0,flat:!0};!0===this.dense&&(l.size="sm"),this.pagesNumber>2&&n.push(t(_e,{key:"pgFirst",props:Object.assign({},l,{icon:this.navIcon[0],disable:this.isFirstPage}),on:pt(this,"pgFirst",{click:this.firstPage})})),n.push(t(_e,{key:"pgPrev",props:Object.assign({},l,{icon:this.navIcon[1],disable:this.isFirstPage}),on:pt(this,"pgPrev",{click:this.prevPage})}),t(_e,{key:"pgNext",props:Object.assign({},l,{icon:this.navIcon[2],disable:this.isLastPage}),on:pt(this,"pgNext",{click:this.nextPage})})),this.pagesNumber>2&&n.push(t(_e,{key:"pgLast",props:Object.assign({},l,{icon:this.navIcon[3],disable:this.isLastPage}),on:pt(this,"pgLast",{click:this.lastPage})}))}return e.push(t("div",{staticClass:"q-table__control"},n)),e}}},_s={methods:{getGridBody:function(t){var e=this,n=void 0!==this.$scopedSlots.item?this.$scopedSlots.item:function(n){var i=n.cols.map((function(e){return t("div",{staticClass:"q-table__grid-item-row"},[t("div",{staticClass:"q-table__grid-item-title"},[e.label]),t("div",{staticClass:"q-table__grid-item-value"},[e.value])])}));!0===e.hasSelectionMode&&i.unshift(t("div",{staticClass:"q-table__grid-item-row"},[t(Ln,{props:{value:n.selected,color:e.color,dark:e.isDark,dense:!0},on:{input:function(t,i){e.__updateSelection([n.key],[n.row],t,i)}}})]),t(wo,{props:{dark:e.isDark}}));var r={staticClass:"q-table__grid-item-card"+e.cardDefaultClass,class:e.cardClass,style:e.cardStyle,on:{}};return void 0===e.qListeners["row-click"]&&void 0===e.qListeners["row-dblclick"]||(r.staticClass+=" cursor-pointer"),void 0!==e.qListeners["row-click"]&&(r.on.click=function(t){e.$emit("row-click",t,n.row,n.pageIndex)}),void 0!==e.qListeners["row-dblclick"]&&(r.on.dblclick=function(t){e.$emit("row-dblclick",t,n.row,n.pageIndex)}),t("div",{staticClass:"q-table__grid-item col-xs-12 col-sm-6 col-md-4 col-lg-3",class:!0===n.selected?"q-table__grid-item--selected":""},[t("div",r,i)])};return t("div",{staticClass:"q-table__grid-content row",class:this.cardContainerClass,style:this.cardContainerStyle},this.computedRows.map((function(t,i){var r=e.getRowKey(t),o=e.isRowSelected(r);return n(e.addBodyRowMeta({key:r,row:t,pageIndex:i,cols:e.computedCols,colsMap:e.computedColsMap,__trClass:o?"selected":""}))})))},getGridHeader:function(t){var e=!0===this.gridHeader?[t("table",{staticClass:"q-table"},[this.getTableHeader(t)])]:!0===this.loading&&void 0===this.$scopedSlots.loading?this.__getProgress(t):void 0;return t("div",{staticClass:"q-table__middle"},e)}}};function bs(t,e,n){return t("div",Object.assign({},e,{staticClass:"q-table__middle"+(void 0!==e.staticClass?" "+e.staticClass:"")}),[t("table",{staticClass:"q-table"},n)])}var ws={list:Kr,table:Ko},ks=t.extend({name:"QVirtualScroll",mixins:[yt,Ot,La],props:{type:{type:String,default:"list",validator:function(t){return["list","table","__qtable"].includes(t)}},items:{type:Array,default:function(){return[]}},itemsFn:Function,itemsSize:Number,scrollTarget:{default:void 0}},computed:{virtualScrollLength:function(){return this.itemsSize>=0&&void 0!==this.itemsFn?parseInt(this.itemsSize,10):Array.isArray(this.items)?this.items.length:0},virtualScrollScope:function(){var t=this;if(0===this.virtualScrollLength)return[];var e=function(e,n){return{index:t.virtualScrollSliceRange.from+n,item:e}};return void 0===this.itemsFn?this.items.slice(this.virtualScrollSliceRange.from,this.virtualScrollSliceRange.to).map(e):this.itemsFn(this.virtualScrollSliceRange.from,this.virtualScrollSliceRange.to-this.virtualScrollSliceRange.from).map(e)},classes:function(){return"q-virtual-scroll q-virtual-scroll"+(!0===this.virtualScrollHorizontal?"--horizontal":"--vertical")+(void 0!==this.scrollTarget?"":" scroll")},attrs:function(){return void 0!==this.scrollTarget?void 0:{tabindex:0}}},watch:{virtualScrollLength:function(){this.__resetVirtualScroll()},scrollTarget:function(){this.__unconfigureScrollTarget(),this.__configureScrollTarget()}},methods:{__getVirtualScrollEl:function(){return this.$el},__getVirtualScrollTarget:function(){return this.__scrollTarget},__configureScrollTarget:function(){this.__scrollTarget=Ie(this.$el,this.scrollTarget),this.__scrollTarget.addEventListener("scroll",this.__onVirtualScrollEvt,f.passive)},__unconfigureScrollTarget:function(){void 0!==this.__scrollTarget&&(this.__scrollTarget.removeEventListener("scroll",this.__onVirtualScrollEvt,f.passive),this.__scrollTarget=void 0)}},beforeMount:function(){this.__resetVirtualScroll()},mounted:function(){this.__configureScrollTarget()},beforeDestroy:function(){this.__unconfigureScrollTarget()},render:function(t){if(void 0!==this.$scopedSlots.default){var e=this.__padVirtualScroll(t,"list"===this.type?"div":"tbody",this.virtualScrollScope.map(this.$scopedSlots.default));return void 0!==this.$scopedSlots.before&&(e=this.$scopedSlots.before().concat(e)),e=At(e,this,"after"),"__qtable"===this.type?bs(t,{staticClass:this.classes},e):t(ws[this.type],{class:this.classes,attrs:this.attrs,props:this.qAttrs,on:Object.assign({},this.qListeners)},e)}console.error("QVirtualScroll: default scoped slot is required for rendering",this)}});var xs={props:{sortMethod:{type:Function,default:function(t,e,n){var i=this.colList.find((function(t){return t.name===e}));if(void 0===i||void 0===i.field)return t;var r=!0===n?-1:1,o="function"==typeof i.field?function(t){return i.field(t)}:function(t){return t[i.field]};return t.sort((function(t,e){var n,a=o(t),s=o(e);return null==a?-1*r:null==s?1*r:void 0!==i.sort?i.sort(a,s,t,e)*r:!0===Mn(a)&&!0===Mn(s)?(a-s)*r:!0===Sn(a)&&!0===Sn(s)?function(t,e){return new Date(t)-new Date(e)}(a,s)*r:"boolean"==typeof a&&"boolean"==typeof s?(a-s)*r:(n=[a,s].map((function(t){return(t+"").toLocaleString().toLowerCase()})),(a=n[0])<(s=n[1])?-1*r:a===s?0:r)}))}}},computed:{columnToSort:function(){var t=this.computedPagination.sortBy;if(t)return this.colList.find((function(e){return e.name===t}))||null}},methods:{sort:function(t){t===Object(t)&&(t=t.name);var e=this.computedPagination,n=e.sortBy,i=e.descending;n!==t?(n=t,i=!1):!0===this.binaryStateSort?i=!i:!0===i?n=null:i=!0,this.setPagination({sortBy:n,descending:i,page:1})}}},Cs={props:{filter:[String,Object],filterMethod:{type:Function,default:function(t,e,n,i){void 0===n&&(n=this.computedCols),void 0===i&&(i=this.getCellValue);var r=e?e.toLowerCase():"";return t.filter((function(t){return n.some((function(e){var n=i(e,t)+"";return-1!==("undefined"===n||"null"===n?"":n.toLowerCase()).indexOf(r)}))}))}}},watch:{filter:{handler:function(){var t=this;this.$nextTick((function(){t.setPagination({page:1},!0)}))},deep:!0}}};function Ss(t){return t.page<1&&(t.page=1),void 0!==t.rowsPerPage&&t.rowsPerPage<1&&(t.rowsPerPage=0),t}var Ms={props:{pagination:Object,rowsPerPageOptions:{type:Array,default:function(){return[5,7,10,15,20,25,50,0]}}},computed:{computedPagination:function(){return Ss(void 0!==this.qListeners["update:pagination"]?Object.assign({},this.innerPagination,this.pagination):this.innerPagination)},firstRowIndex:function(){var t=this.computedPagination;return(t.page-1)*t.rowsPerPage},lastRowIndex:function(){var t=this.computedPagination;return t.page*t.rowsPerPage},isFirstPage:function(){return 1===this.computedPagination.page},pagesNumber:function(){return 0===this.computedPagination.rowsPerPage?1:Math.max(1,Math.ceil(this.computedRowsNumber/this.computedPagination.rowsPerPage))},isLastPage:function(){return 0===this.lastRowIndex||this.computedPagination.page>=this.pagesNumber},computedRowsPerPageOptions:function(){var t=this;return(this.rowsPerPageOptions.includes(this.innerPagination.rowsPerPage)?this.rowsPerPageOptions:[this.innerPagination.rowsPerPage].concat(this.rowsPerPageOptions)).map((function(e){return{label:0===e?t.$q.lang.table.allRows:""+e,value:e}}))}},watch:{pagesNumber:function(t,e){if(t!==e){var n=this.computedPagination.page;t&&!n?this.setPagination({page:1}):t<n&&this.setPagination({page:t})}}},methods:{__sendServerRequest:function(t){this.requestServerInteraction({pagination:t,filter:this.filter})},setPagination:function(t,e){var n=Ss(Object.assign({},this.computedPagination,t));!function(t,e){for(var n in e)if(e[n]!==t[n])return!1;return!0}(this.computedPagination,n)?!0!==this.isServerSide?void 0!==this.pagination&&void 0!==this.qListeners["update:pagination"]?this.$emit("update:pagination",n):this.innerPagination=n:this.__sendServerRequest(n):!0===this.isServerSide&&!0===e&&this.__sendServerRequest(n)},firstPage:function(){this.setPagination({page:1})},prevPage:function(){var t=this.computedPagination.page;t>1&&this.setPagination({page:t-1})},nextPage:function(){var t=this.computedPagination,e=t.page,n=t.rowsPerPage;this.lastRowIndex>0&&e*n<this.computedRowsNumber&&this.setPagination({page:e+1})},lastPage:function(){this.setPagination({page:this.pagesNumber})}},created:function(){void 0!==this.qListeners["update:pagination"]&&this.$emit("update:pagination",Object.assign({},this.computedPagination))}},Ts={props:{selection:{type:String,default:"none",validator:function(t){return["single","multiple","none"].includes(t)}},selected:{type:Array,default:function(){return[]}}},computed:{selectedKeys:function(){var t={};return this.selected.map(this.getRowKey).forEach((function(e){t[e]=!0})),t},hasSelectionMode:function(){return"none"!==this.selection},singleSelection:function(){return"single"===this.selection},multipleSelection:function(){return"multiple"===this.selection},allRowsSelected:function(){var t=this;return this.computedRows.length>0&&this.computedRows.every((function(e){return!0===t.selectedKeys[t.getRowKey(e)]}))},someRowsSelected:function(){var t=this;return!0!==this.allRowsSelected&&this.computedRows.some((function(e){return!0===t.selectedKeys[t.getRowKey(e)]}))},rowsSelectedNumber:function(){return this.selected.length}},methods:{isRowSelected:function(t){return!0===this.selectedKeys[t]},clearSelection:function(){this.$emit("update:selected",[])},__updateSelection:function(t,e,n,i){var r=this;this.$emit("selection",{rows:e,added:n,keys:t,evt:i});var o=!0===this.singleSelection?!0===n?e:[]:!0===n?this.selected.concat(e):this.selected.filter((function(e){return!1===t.includes(r.getRowKey(e))}));this.$emit("update:selected",o)}}};function Ps(t){return Array.isArray(t)?t.slice():[]}var Os={props:{expanded:Array},data:function(){return{innerExpanded:Ps(this.expanded)}},watch:{expanded:function(t){this.innerExpanded=Ps(t)}},methods:{isRowExpanded:function(t){return this.innerExpanded.includes(t)},setExpanded:function(t){void 0!==this.expanded?this.$emit("update:expanded",t):this.innerExpanded=t},__updateExpanded:function(t,e){var n=this.innerExpanded.slice(),i=n.indexOf(t);!0===e?-1===i&&(n.push(t),this.setExpanded(n)):-1!==i&&(n.splice(i,1),this.setExpanded(n))}}},Bs={props:{visibleColumns:Array},computed:{colList:function(){if(void 0!==this.columns)return this.columns;var t=this.data[0];return void 0!==t?Object.keys(t).map((function(e){return{name:e,label:e.toUpperCase(),field:e,align:Mn(t[e])?"right":"left",sortable:!0}})):[]},computedCols:function(){var t=this,e=this.computedPagination,n=e.sortBy,i=e.descending;return(void 0!==this.visibleColumns?this.colList.filter((function(e){return!0===e.required||!0===t.visibleColumns.includes(e.name)})):this.colList).map((function(t){var e=t.align||"right";return Object.assign({},t,{align:e,__iconClass:"q-table__sort-icon q-table__sort-icon--"+e,__thClass:"text-"+e+(void 0!==t.headerClasses?" "+t.headerClasses:"")+(!0===t.sortable?" sortable":"")+(t.name===n?" sorted "+(!0===i?"sort-desc":""):""),__tdClass:"text-"+e+(void 0!==t.classes?" "+t.classes:"")})}))},computedColsMap:function(){var t={};return this.computedCols.forEach((function(e){t[e.name]=e})),t},computedColspan:function(){return void 0!==this.tableColspan?this.tableColspan:this.computedCols.length+(!0===this.hasSelectionMode?1:0)}}},Es={};Da.forEach((function(t){Es[t]={}}));var As=t.extend({name:"QTable",mixins:[It,Ot,bn,{computed:{marginalsProps:function(){return{pagination:this.computedPagination,pagesNumber:this.pagesNumber,isFirstPage:this.isFirstPage,isLastPage:this.isLastPage,firstPage:this.firstPage,prevPage:this.prevPage,nextPage:this.nextPage,lastPage:this.lastPage,inFullscreen:this.inFullscreen,toggleFullscreen:this.toggleFullscreen}}},methods:{getTop:function(t){var e,n=this.$scopedSlots.top,i=this.$scopedSlots["top-left"],r=this.$scopedSlots["top-right"],o=this.$scopedSlots["top-selection"],a=!0===this.hasSelectionMode&&void 0!==o&&this.rowsSelectedNumber>0,s="q-table__top relative-position row items-center";return void 0!==n?t("div",{staticClass:s},[n(this.marginalsProps)]):(!0===a?e=o(this.marginalsProps).slice():(e=[],void 0!==i?e.push(t("div",{staticClass:"q-table-control"},[i(this.marginalsProps)])):this.title&&e.push(t("div",{staticClass:"q-table__control"},[t("div",{staticClass:"q-table__title",class:this.titleClass},this.title)]))),void 0!==r&&(e.push(t("div",{staticClass:"q-table__separator col"})),e.push(t("div",{staticClass:"q-table__control"},[r(this.marginalsProps)]))),0!==e.length?t("div",{staticClass:s},e):void 0)}}},ms,vs,ys,_s,xs,Cs,Ms,Ts,Os,Bs],props:Object.assign({},{data:{type:Array,default:function(){return[]}},rowKey:{type:[String,Function],default:"id"},columns:Array,loading:Boolean,binaryStateSort:Boolean,iconFirstPage:String,iconPrevPage:String,iconNextPage:String,iconLastPage:String,title:String,hideHeader:Boolean,grid:Boolean,gridHeader:Boolean,dense:Boolean,flat:Boolean,bordered:Boolean,square:Boolean,separator:{type:String,default:"horizontal",validator:function(t){return["horizontal","vertical","cell","none"].includes(t)}},wrapCells:Boolean,virtualScroll:Boolean},Es,{noDataLabel:String,noResultsLabel:String,loadingLabel:String,selectedRowsLabel:Function,rowsPerPageLabel:String,paginationLabel:Function,color:{type:String,default:"grey-8"},titleClass:[String,Array,Object],tableStyle:[String,Array,Object],tableClass:[String,Array,Object],tableHeaderStyle:[String,Array,Object],tableHeaderClass:[String,Array,Object],cardContainerClass:[String,Array,Object],cardContainerStyle:[String,Array,Object],cardStyle:[String,Array,Object],cardClass:[String,Array,Object]}),data:function(){return{innerPagination:Object.assign({sortBy:null,descending:!1,page:1,rowsPerPage:this.rowsPerPageOptions.length>0?this.rowsPerPageOptions[0]:5},this.pagination)}},watch:{needsReset:function(){!0===this.hasVirtScroll&&void 0!==this.$refs.virtScroll&&this.$refs.virtScroll.reset()}},computed:{getRowKey:function(){var t=this;return"function"==typeof this.rowKey?this.rowKey:function(e){return e[t.rowKey]}},hasVirtScroll:function(){return!0!==this.grid&&!0===this.virtualScroll},needsReset:function(){var t=this;return["tableStyle","tableClass","tableHeaderStyle","tableHeaderClass","containerClass"].map((function(e){return t[e]})).join(";")},filteredSortedRows:function(){var t=this.data;if(!0===this.isServerSide||0===t.length)return t;var e=this.computedPagination,n=e.sortBy,i=e.descending;return this.filter&&(t=this.filterMethod(t,this.filter,this.computedCols,this.getCellValue)),void 0!==this.columnToSort&&(t=this.sortMethod(this.data===t?t.slice():t,n,i)),t},filteredSortedRowsNumber:function(){return this.filteredSortedRows.length},computedRows:function(){var t=this.filteredSortedRows;return!0===this.isServerSide||0!==this.computedPagination.rowsPerPage&&(0===this.firstRowIndex&&this.data!==t?t.length>this.lastRowIndex&&(t.length=this.lastRowIndex):t=t.slice(this.firstRowIndex,this.lastRowIndex)),t},computedRowsNumber:function(){return!0===this.isServerSide?this.computedPagination.rowsNumber||0:this.filteredSortedRowsNumber},nothingToDisplay:function(){return 0===this.computedRows.length},isServerSide:function(){return void 0!==this.computedPagination.rowsNumber},cardDefaultClass:function(){return" q-table__card"+(!0===this.isDark?" q-table__card--dark q-dark":"")+(!0===this.square?" q-table--square":"")+(!0===this.flat?" q-table--flat":"")+(!0===this.bordered?" q-table--bordered":"")},containerClass:function(){return"q-table__container q-table--"+this.separator+"-separator column no-wrap"+(!0===this.loading?" q-table--loading":"")+(!0===this.grid?" q-table--grid":this.cardDefaultClass)+(!0===this.isDark?" q-table--dark":"")+(!0===this.dense?" q-table--dense":"")+(!1===this.wrapCells?" q-table--no-wrap":"")+(!0===this.inFullscreen?" fullscreen scroll":"")},virtProps:function(){var t=this,e={};return Da.forEach((function(n){e[n]=t[n]})),void 0===e.virtualScrollItemSize&&(e.virtualScrollItemSize=!0===this.dense?28:48),e}},render:function(t){var e=[this.getTop(t)],n={staticClass:this.containerClass};return!0===this.grid?e.push(this.getGridHeader(t)):Object.assign(n,{class:this.cardClass,style:this.cardStyle}),e.push(this.getBody(t),this.getBottom(t)),!0===this.loading&&void 0!==this.$scopedSlots.loading&&e.push(this.$scopedSlots.loading()),t("div",n,e)},methods:{requestServerInteraction:function(t){var e=this;void 0===t&&(t={}),this.$nextTick((function(){e.$emit("request",{pagination:t.pagination||e.computedPagination,filter:t.filter||e.filter,getCellValue:e.getCellValue})}))},resetVirtualScroll:function(){!0===this.hasVirtScroll&&this.$refs.virtScroll.reset()},getBody:function(t){if(!0===this.grid)return this.getGridBody(t);var e=!0!==this.hideHeader?this.getTableHeader(t):null;return!0===this.hasVirtScroll?t(ks,{ref:"virtScroll",props:Object.assign({},this.virtProps,{items:this.computedRows,type:"__qtable",tableColspan:this.computedColspan}),on:pt(this,"vs",{"virtual-scroll":this.__onVScroll}),class:this.tableClass,style:this.tableStyle,scopedSlots:{before:null===e?void 0:function(){return e},default:this.getTableRowVirtual(t)}}):bs(t,{staticClass:"scroll",class:this.tableClass,style:this.tableStyle},[e,this.getTableBody(t)])},scrollTo:function(t){if(void 0===this.$refs.virtScroll){t=parseInt(t,10);var e=this.$el.querySelector("tbody tr:nth-of-type("+(t+1)+")");if(null!==e){var n=this.$el.querySelector(".q-table__middle.scroll"),i=e.offsetTop,r=i<n.scrollTop?"decrease":"increase";n.scrollTop=i,this.$emit("virtual-scroll",{index:t,from:0,to:this.pagination.rowsPerPage-1,direction:r})}}else this.$refs.virtScroll.scrollTo(t)},__onVScroll:function(t){this.$emit("virtual-scroll",t)},__getProgress:function(t){return[t(ma,{staticClass:"q-table__linear-progress",props:{color:this.color,dark:this.isDark,indeterminate:!0,trackColor:"transparent"}})]}}}),Ds=t.extend({name:"QTr",mixins:[Ot],props:{props:Object,noHover:Boolean},computed:{classes:function(){return"q-tr"+(void 0===this.props||!0===this.props.header?"":" "+this.props.__trClass)+(!0===this.noHover?" q-tr--no-hover":"")}},render:function(t){return t("tr",{on:Object.assign({},this.qListeners),class:this.classes},Bt(this,"default"))}}),Ls=t.extend({name:"QTd",mixins:[Ot],props:{props:Object,autoWidth:Boolean,noHover:Boolean},computed:{classes:function(){return"q-td"+(!0===this.autoWidth?" q-table--col-auto-width":"")+(!0===this.noHover?" q-td--no-hover":"")}},render:function(t){var e=this.qListeners;if(void 0===this.props)return t("td",{on:e,class:this.classes},Bt(this,"default"));var n=this.$vnode.key,i=void 0!==this.props.colsMap&&n?this.props.colsMap[n]:this.props.col;return void 0!==i?t("td",{on:e,style:i.style,class:this.classes+" "+i.__tdClass},Bt(this,"default")):void 0}}),qs=/\/?$/;function Rs(t,e){return!!e&&(t.path&&e.path?t.path.replace(qs,"")===e.path.replace(qs,"")&&t.hash===e.hash&&Cn(t.query,e.query):!(!t.name||!e.name)&&(t.name===e.name&&t.hash===e.hash&&Cn(t.query,e.query)&&Cn(t.params,e.params)))}function Is(t,e){return 0===t.path.replace(qs,"/").indexOf(e.path.replace(qs,"/"))&&(!e.hash||t.hash===e.hash)&&function(t,e){for(var n in e)if(!(n in t))return!1;return!0}(t.query,e.query)}var Ns=t.extend({name:"QRouteTab",mixins:[ui,Ut],props:{to:{required:!0}},inject:{__activateRoute:{},__recalculateScroll:{}},watch:{$route:function(){this.__checkActivation()}},computed:{onEvents:function(){return Object.assign({},{input:_},this.qListeners,{"!click":this.__activate,keyup:this.__onKeyup})}},methods:{__activate:function(t,e){var n=this;if(!0!==this.disable)if(void 0===t||!0!==t.ctrlKey&&!0!==t.shiftKey&&!0!==t.altKey&&!0!==t.metaKey){void 0!==t&&w(t);var i=function(t,e,i){void 0===t&&(t=n.to),void 0===e&&(e=n.append),void 0===i&&(i=n.replace);var r=n.$router.resolve(t,n.$route,e).route,o=t===n.to&&e===n.append&&i===n.replace?n.__checkActivation:m;n.$router[!0===i?"replace":"push"](r,(function(){o(!0)}),(function(t){t&&"NavigationDuplicated"===t.name&&o(!0)}))};void 0!==this.qListeners.click&&this.$emit("click",t,i),!1!==t.navigate&&i()}else this.__checkActivation(!0);!0===e?this.$el.focus(t):void 0!==this.$refs.blurTarget&&this.$refs.blurTarget.focus(t)},__checkActivation:function(t){void 0===t&&(t=!1);var e=this.$route,n=this.$router.resolve(this.to,e,this.append),i=n.href,r=n.location,o=n.route,a=void 0!==o.redirectedFrom,s=Rs(e,o),l=!0===this.exact?Rs:Is,c={name:this.name,selected:t,exact:this.exact,priorityMatched:o.matched.length,priorityHref:i.length};(!0===s||!0!==this.exact&&!0===Is(e,o))&&this.__activateRoute(Object.assign({},c,{redirected:a,exact:!0===this.exact||!0===s})),!0===a&&!0===l(e,Object.assign({},{path:o.redirectedFrom},r))&&this.__activateRoute(c),!0===this.isActive&&this.__activateRoute()}},mounted:function(){this.__recalculateScroll(),void 0!==this.$router&&this.__checkActivation()},beforeDestroy:function(){this.__recalculateScroll(),this.__activateRoute({remove:!0,name:this.name})},render:function(t){return this.__renderTab(t,"router-link",this.routerLinkProps)}}),Fs=t.extend({name:"QTime",mixins:[Mi],directives:{TouchPan:Gn},props:{mask:{default:null},format24h:{type:Boolean,default:null},defaultDate:{type:String,validator:function(t){return/^-?[\d]+\/[0-1]\d\/[0-3]\d$/.test(t)}},options:Function,hourOptions:Array,minuteOptions:Array,secondOptions:Array,withSeconds:Boolean,nowBtn:Boolean},data:function(){var t=Li(this.value,this.__getMask(),this.__getLocale(),this.calendar,this.__getDefaultDateModel()),e="Hour";return null!==t.hour&&(null===t.minute?e="Minute":!0===this.withSeconds&&null===t.second&&(e="Second")),{view:e,isAM:null===t.hour||t.hour<12,innerModel:t}},watch:{value:function(t){var e=Li(t,this.computedMask,this.computedLocale,this.calendar,this.defaultDateModel);e.dateHash===this.innerModel.dateHash&&e.timeHash===this.innerModel.timeHash||(this.innerModel=e,null===e.hour?this.view="Hour":this.isAM=e.hour<12)},computedMask:function(){var t=this;this.$nextTick((function(){t.__updateValue()}))},computedLocale:function(){var t=this;this.$nextTick((function(){t.__updateValue()}))}},computed:{classes:function(){return"q-time q-time--"+(!0===this.landscape?"landscape":"portrait")+(!0===this.isDark?" q-time--dark q-dark":"")+(!0===this.disable?" disabled":!0===this.readonly?" q-time--readonly":"")+(!0===this.bordered?" q-time--bordered":"")+(!0===this.square?" q-time--square no-border-radius":"")+(!0===this.flat?" q-time--flat no-shadow":"")},stringModel:function(){var t=this.innerModel;return{hour:null===t.hour?"--":!0===this.computedFormat24h?ht(t.hour):String(!0===this.isAM?0===t.hour?12:t.hour:t.hour>12?t.hour-12:t.hour),minute:null===t.minute?"--":ht(t.minute),second:null===t.second?"--":ht(t.second)}},defaultDateModel:function(){return this.__getDefaultDateModel()},computedFormat24h:function(){return null!==this.format24h?this.format24h:this.$q.lang.date.format24h},pointerStyle:function(){var t="Hour"===this.view,e=!0===t?12:60,n=this.innerModel[this.view.toLowerCase()],i="rotate("+(Math.round(n*(360/e))-180)+"deg) translateX(-50%)";return!0===t&&!0===this.computedFormat24h&&this.innerModel.hour>=12&&(i+=" scale(.7)"),{transform:i}},minLink:function(){return null!==this.innerModel.hour},secLink:function(){return!0===this.minLink&&null!==this.innerModel.minute},hourInSelection:function(){var t=this;return void 0!==this.hourOptions?function(e){return t.hourOptions.includes(e)}:void 0!==this.options?function(e){return t.options(e,null,null)}:void 0},minuteInSelection:function(){var t=this;return void 0!==this.minuteOptions?function(e){return t.minuteOptions.includes(e)}:void 0!==this.options?function(e){return t.options(t.innerModel.hour,e,null)}:void 0},secondInSelection:function(){var t=this;return void 0!==this.secondOptions?function(e){return t.secondOptions.includes(e)}:void 0!==this.options?function(e){return t.options(t.innerModel.hour,t.innerModel.minute,e)}:void 0},hourSnappingGrid:function(){return this.__getSnapGrid(this.hourInSelection,24)},minuteSnappingGrid:function(){return this.__getSnapGrid(this.minuteInSelection,60)},secondSnappingGrid:function(){return this.__getSnapGrid(this.secondInSelection,60)},positions:function(){var t,e,n,i=0,r=1;"Hour"===this.view?(n=this.hourInSelection,!0===this.computedFormat24h?(t=0,e=23):(t=0,e=11,!1===this.isAM&&(i=12))):(t=0,e=55,r=5,n="Minute"===this.view?this.minuteInSelection:this.secondInSelection);for(var o=[],a=t,s=t;a<=e;a+=r,s++){var l=a+i,c=void 0!==n&&!1===n(l),u="Hour"===this.view&&0===a?!0===this.format24h?"00":"12":a;o.push({val:l,index:s,disable:c,label:u})}return o}},methods:{setNow:function(){this.__updateValue(Object.assign({},this.__getCurrentDate(),this.__getCurrentTime())),this.view="Hour"},__getSnapGrid:function(t,e){if(void 0!==t){var n=[].concat(Array(e).keys()).map(t),i=e-1-n.lastIndexOf(!0);if(-1!==i){for(var r=0;r<e;r++)if(!0===n[r]){if(i){if(i>1){for(var o=Math.floor(i/2),a=(r-i-1+e)%e,s=(r-i+e)%e,l=0,c=s;l<o;c=(s+ ++l+e)%e)n[c]=a;for(var u=r,d=(r-o+e)%e,h=0,f=d;h<o;f=(d+ ++h+e)%e)n[f]=u}else{var p=(r-1+e)%e;n[p]=p}i=0}n[r]=r}else!1===n[r]&&i++;return n}}},__getMask:function(){return"persian"!==this.calendar&&null!==this.mask?this.mask:"HH:mm"+(!0===this.withSeconds?":ss":"")},__getDefaultDateModel:function(){if("string"!=typeof this.defaultDate){var t=this.__getCurrentDate();return t.dateHash=t.year+"/"+ht(t.month)+"/"+ht(t.day),t}return Li(this.defaultDate,"YYYY/MM/DD",void 0,this.calendar)},__click:function(t){!0!==this._isBeingDestroyed&&!0!==this._isDestroyed&&(!0!==this.$q.platform.is.desktop&&this.__updateClock(t,this.__getClockRect()),this.__goToNextView())},__activate:function(t){!0!==this._isBeingDestroyed&&!0!==this._isDestroyed&&this.__updateClock(t,this.__getClockRect())},__getClockRect:function(){var t=this.$refs.clock.getBoundingClientRect(),e=t.top,n=t.left,i=t.width/2;return{top:e+i,left:n+i,dist:.7*i}},__goToNextView:function(){"Hour"===this.view?this.view="Minute":this.withSeconds&&"Minute"===this.view&&(this.view="Second")},__drag:function(t){if(!0!==this._isBeingDestroyed&&!0!==this._isDestroyed){if(!0===t.isFirst)return this.draggingClockRect=this.__getClockRect(),void(this.dragCache=this.__updateClock(t.evt,this.draggingClockRect));this.dragCache=this.__updateClock(t.evt,this.draggingClockRect,this.dragCache),!0===t.isFinal&&(this.draggingClockRect=!1,this.dragCache=null,this.__goToNextView())}},__updateClock:function(t,e,n){var i,r=g(t),o=Math.abs(r.top-e.top),a=Math.sqrt(Math.pow(Math.abs(r.top-e.top),2)+Math.pow(Math.abs(r.left-e.left),2)),s=Math.asin(o/a)*(180/Math.PI);if(s=r.top<e.top?e.left<r.left?90-s:270+s:e.left<r.left?s+90:270-s,"Hour"===this.view?(i=Math.round(s/30),!0===this.computedFormat24h?(a<e.dist?i<12&&(i+=12):12===i&&(i=0),this.isAM=i<12):!0===this.isAM&&12===i?i=0:!1===this.isAM&&12!==i&&(i+=12),void 0!==this.hourSnappingGrid&&(i=this.hourSnappingGrid[i])):(i=Math.round(s/6)%60,"Minute"===this.view&&void 0!==this.minuteSnappingGrid?i=this.minuteSnappingGrid[i]:"Second"===this.view&&void 0!==this.secondSnappingGrid&&(i=this.secondSnappingGrid[i])),n===i)return i;var l=this[this.view.toLowerCase()+"InSelection"];return void 0===l||!0===l(i)?(this["__set"+this.view](i),i):void 0},__onKeyupHour:function(t){if(13===t.keyCode)this.view="Hour";else{var e=!0===this.computedFormat24h?24:12,n=!0!==this.computedFormat24h&&!1===this.isAM?12:0;37===t.keyCode?this.__setHour(n+(24+this.innerModel.hour-1)%e):39===t.keyCode&&this.__setHour(n+(24+this.innerModel.hour+1)%e)}},__onKeyupMinute:function(t){13===t.keyCode?this.view="Minute":37===t.keyCode?this.__setMinute((60+this.innerModel.minute-1)%60):39===t.keyCode&&this.__setMinute((60+this.innerModel.minute+1)%60)},__onKeyupSecond:function(t){13===t.keyCode?this.view="Second":37===t.keyCode?this.__setSecond((60+this.innerModel.second-1)%60):39===t.keyCode&&this.__setSecond((60+this.innerModel.second+1)%60)},__getHeader:function(t){var e=this,n=[t("div",{staticClass:"q-time__link",class:"Hour"===this.view?"q-time__link--active":"cursor-pointer",attrs:{tabindex:this.computedTabindex},on:pt(this,"vH",{click:function(){e.view="Hour"},keyup:this.__onKeyupHour})},[this.stringModel.hour]),t("div",[":"]),t("div",!0===this.minLink?{staticClass:"q-time__link",class:"Minute"===this.view?"q-time__link--active":"cursor-pointer",attrs:{tabindex:this.computedTabindex},on:pt(this,"vM",{click:function(){e.view="Minute"},keyup:this.__onKeyupMinute})}:{staticClass:"q-time__link"},[this.stringModel.minute])];return!0===this.withSeconds&&n.push(t("div",[":"]),t("div",!0===this.secLink?{staticClass:"q-time__link",class:"Second"===this.view?"q-time__link--active":"cursor-pointer",attrs:{tabindex:this.computedTabindex},on:pt(this,"vS",{click:function(){e.view="Second"},keyup:this.__onKeyupSecond})}:{staticClass:"q-time__link"},[this.stringModel.second])),t("div",{staticClass:"q-time__header flex flex-center no-wrap",class:this.headerClass},[t("div",{staticClass:"q-time__header-label row items-center no-wrap",attrs:{dir:"ltr"}},n),!1===this.computedFormat24h?t("div",{staticClass:"q-time__header-ampm column items-between no-wrap"},[t("div",{staticClass:"q-time__link",class:!0===this.isAM?"q-time__link--active":"cursor-pointer",attrs:{tabindex:this.computedTabindex},on:pt(this,"AM",{click:this.__setAm,keyup:function(t){13===t.keyCode&&e.__setAm()}})},["AM"]),t("div",{staticClass:"q-time__link",class:!0!==this.isAM?"q-time__link--active":"cursor-pointer",attrs:{tabindex:this.computedTabindex},on:pt(this,"PM",{click:this.__setPm,keyup:function(t){13===t.keyCode&&e.__setPm()}})},["PM"])]):null])},__getClock:function(t){var e=this,n=this.view.toLowerCase(),i=this.innerModel[n];return t("div",{staticClass:"q-time__content col relative-position"},[t("transition",{props:{name:"q-transition--scale"}},[t("div",{key:"clock"+this.view,staticClass:"q-time__container-parent absolute-full"},[t("div",{ref:"clock",staticClass:"q-time__container-child fit overflow-hidden"},[t("div",{staticClass:"q-time__clock cursor-pointer non-selectable",on:pt(this,"click",{click:this.__click,mousedown:this.__activate}),directives:pt(this,"touch",[{name:"touch-pan",value:this.__drag,modifiers:{stop:!0,prevent:!0,mouse:!0}}])},[t("div",{staticClass:"q-time__clock-circle fit"},[t("div",{staticClass:"q-time__clock-pointer",style:this.pointerStyle,class:null===this.innerModel[n]?"hidden":void 0!==this.color?"text-"+this.color:""}),this.positions.map((function(n){return t("div",{staticClass:"q-time__clock-position row flex-center q-time__clock-pos-"+n.index,class:n.val===i?e.headerClass.concat(" q-time__clock-position--active"):!0===n.disable?"q-time__clock-position--disable":null},[t("span",[n.label])])}))])])])])]),!0===this.nowBtn?t(_e,{staticClass:"q-time__now-button absolute",props:{icon:this.$q.iconSet.datetime.now,unelevated:!0,size:"sm",round:!0,color:this.color,textColor:this.textColor,tabindex:this.computedTabindex},on:pt(this,"now",{click:this.setNow})}):null])},__setHour:function(t){this.innerModel.hour!==t&&(this.innerModel.hour=t,this.innerModel.minute=null,this.innerModel.second=null)},__setMinute:function(t){this.innerModel.minute!==t&&(this.innerModel.minute=t,this.innerModel.second=null,!0!==this.withSeconds&&this.__updateValue({minute:t}))},__setSecond:function(t){this.innerModel.second!==t&&this.__updateValue({second:t})},__setAm:function(){this.isAM||(this.isAM=!0,null!==this.innerModel.hour&&(this.innerModel.hour-=12,this.__verifyAndUpdate()))},__setPm:function(){this.isAM&&(this.isAM=!1,null!==this.innerModel.hour&&(this.innerModel.hour+=12,this.__verifyAndUpdate()))},__verifyAndUpdate:function(){return void 0!==this.hourInSelection&&!0!==this.hourInSelection(this.innerModel.hour)?(this.innerModel=Li(),this.isAM=!0,void(this.view="Hour")):void 0!==this.minuteInSelection&&!0!==this.minuteInSelection(this.innerModel.minute)?(this.innerModel.minute=null,this.innerModel.second=null,void(this.view="Minute")):!0===this.withSeconds&&void 0!==this.secondInSelection&&!0!==this.secondInSelection(this.innerModel.second)?(this.innerModel.second=null,void(this.view="Second")):void(null===this.innerModel.hour||null===this.innerModel.minute||!0===this.withSeconds&&null===this.innerModel.second||this.__updateValue())},__updateValue:function(t){var e=Object.assign(Object.assign({},this.innerModel),t),n="persian"===this.calendar?ht(e.hour)+":"+ht(e.minute)+(!0===this.withSeconds?":"+ht(e.second):""):Qi(new Date(e.year,null===e.month?null:e.month-1,e.day,e.hour,e.minute,e.second,e.millisecond),this.computedMask,this.computedLocale,e.year,e.timezoneOffset);e.changed=n!==this.value,this.$emit("input",n,e)}},render:function(t){var e=[this.__getClock(t)],n=Bt(this,"default");return void 0!==n&&e.push(t("div",{staticClass:"q-time__actions"},n)),void 0!==this.name&&!0!==this.disable&&this.__injectFormInput(e,"push"),t("div",{class:this.classes,on:Object.assign({},this.qListeners),attrs:{tabindex:-1}},[this.__getHeader(t),t("div",{staticClass:"q-time__main col overflow-auto"},e)])}}),$s=t.extend({name:"QTimeline",mixins:[It,Ot],provide:function(){return{__timeline:this}},props:{color:{type:String,default:"primary"},side:{type:String,default:"right",validator:function(t){return["left","right"].includes(t)}},layout:{type:String,default:"dense",validator:function(t){return["dense","comfortable","loose"].includes(t)}}},computed:{classes:function(){return"q-timeline--"+this.layout+" q-timeline--"+this.layout+"--"+this.side+(!0===this.isDark?" q-timeline--dark":"")}},render:function(t){return t("ul",{staticClass:"q-timeline",class:this.classes,on:Object.assign({},this.qListeners)},Bt(this,"default"))}}),js=t.extend({name:"QTimelineEntry",inject:{__timeline:{default:function(){console.error("QTimelineEntry needs to be child of QTimeline")}}},mixins:[Ot],props:{heading:Boolean,tag:{type:String,default:"h3"},side:{type:String,default:"right",validator:function(t){return["left","right"].includes(t)}},icon:String,avatar:String,color:String,title:String,subtitle:String,body:String},computed:{colorClass:function(){return"text-"+(this.color||this.__timeline.color)},classes:function(){return"q-timeline__entry--"+this.side+(void 0!==this.icon||void 0!==this.avatar?" q-timeline__entry--icon":"")},reverse:function(){return"comfortable"===this.__timeline.layout&&"left"===this.__timeline.side}},render:function(t){var e,n=Et(this,"default",[]);if(void 0!==this.body&&n.unshift(this.body),!0===this.heading){var i=[t("div"),t("div"),t(this.tag,{staticClass:"q-timeline__heading-title"},n)];return t("div",{staticClass:"q-timeline__heading",on:Object.assign({},this.qListeners)},!0===this.reverse?i.reverse():i)}void 0!==this.icon?e=[t(Lt,{staticClass:"row items-center justify-center",props:{name:this.icon}})]:void 0!==this.avatar&&(e=[t("img",{staticClass:"q-timeline__dot-img",domProps:{src:this.avatar}})]);var r=[t("div",{staticClass:"q-timeline__subtitle"},[t("span",Bt(this,"subtitle",[this.subtitle]))]),t("div",{staticClass:"q-timeline__dot",class:this.colorClass},e),t("div",{staticClass:"q-timeline__content"},[t("h6",{staticClass:"q-timeline__title"},Bt(this,"title",[this.title]))].concat(n))];return t("li",{staticClass:"q-timeline__entry",class:this.classes,on:Object.assign({},this.qListeners)},!0===this.reverse?r.reverse():r)}}),zs=t.extend({name:"QToolbar",mixins:[Ot],props:{inset:Boolean},render:function(t){return t("div",{staticClass:"q-toolbar row no-wrap items-center",class:this.inset?"q-toolbar--inset":null,on:Object.assign({},this.qListeners)},Bt(this,"default"))}}),Vs=t.extend({name:"QToolbarTitle",mixins:[Ot],props:{shrink:Boolean},computed:{classes:function(){return"q-toolbar__title ellipsis"+(!0===this.shrink?" col-shrink":"")}},render:function(t){return t("div",{class:this.classes,on:Object.assign({},this.qListeners)},Bt(this,"default"))}}),Hs=t.extend({name:"QTree",mixins:[It],props:{nodes:{type:Array,required:!0},nodeKey:{type:String,required:!0},labelKey:{type:String,default:"label"},childrenKey:{type:String,default:"children"},color:String,controlColor:String,textColor:String,selectedColor:String,icon:String,tickStrategy:{type:String,default:"none",validator:function(t){return["none","strict","leaf","leaf-filtered"].includes(t)}},ticked:Array,expanded:Array,selected:{},defaultExpandAll:Boolean,accordion:Boolean,filter:String,filterMethod:{type:Function,default:function(t,e){var n=e.toLowerCase();return t[this.labelKey]&&t[this.labelKey].toLowerCase().indexOf(n)>-1}},duration:Number,noConnectors:Boolean,noNodesLabel:String,noResultsLabel:String},computed:{classes:function(){return"q-tree"+(!0===this.noConnectors?" q-tree--no-connectors":"")+(!0===this.isDark?" q-tree--dark":"")+(void 0!==this.color?" text-"+this.color:"")},hasSelection:function(){return void 0!==this.selected},computedIcon:function(){return this.icon||this.$q.iconSet.tree.icon},computedControlColor:function(){return this.controlColor||this.color},textColorClass:function(){if(void 0!==this.textColor)return"text-"+this.textColor},selectedColorClass:function(){var t=this.selectedColor||this.color;if(t)return"text-"+t},meta:function(){var t=this,e={},n=function(i,r){var o=i.tickStrategy||(r?r.tickStrategy:t.tickStrategy),a=i[t.nodeKey],s=i[t.childrenKey]&&i[t.childrenKey].length>0,l=!0!==s,c=!0!==i.disabled&&!0===t.hasSelection&&!1!==i.selectable,u=!0!==i.disabled&&!1!==i.expandable,d="none"!==o,h="strict"===o,f="leaf-filtered"===o,p="leaf"===o||"leaf-filtered"===o,m=!0!==i.disabled&&!1!==i.tickable;!0===p&&!0===m&&r&&!0!==r.tickable&&(m=!1);var v=i.lazy;v&&t.lazy[a]&&(v=t.lazy[a]);var g={key:a,parent:r,isParent:s,isLeaf:l,lazy:v,disabled:i.disabled,link:!0!==i.disabled&&(!0===c||!0===u&&(!0===s||!0===v)),children:[],matchesFilter:!t.filter||t.filterMethod(i,t.filter),selected:a===t.selected&&!0===c,selectable:c,expanded:!0===s&&t.innerExpanded.includes(a),expandable:u,noTick:!0===i.noTick||!0!==h&&v&&"loaded"!==v,tickable:m,tickStrategy:o,hasTicking:d,strictTicking:h,leafFilteredTicking:f,leafTicking:p,ticked:(!0===h||!0===l)&&t.innerTicked.includes(a)};if(e[a]=g,!0===s&&(g.children=i[t.childrenKey].map((function(t){return n(t,g)})),t.filter&&(!0!==g.matchesFilter?g.matchesFilter=g.children.some((function(t){return t.matchesFilter})):!0!==g.noTick&&!0!==g.disabled&&!0===g.tickable&&!0===f&&!0===g.children.every((function(t){return!0!==t.matchesFilter||!0===t.noTick||!0!==t.tickable}))&&(g.tickable=!1)),!0===g.matchesFilter&&(!0!==g.noTick&&!0!==h&&!0===g.children.every((function(t){return t.noTick}))&&(g.noTick=!0),p))){if(g.ticked=!1,g.indeterminate=g.children.some((function(t){return!0===t.indeterminate})),g.tickable=!0===g.tickable&&g.children.some((function(t){return t.tickable})),!0!==g.indeterminate){var y=g.children.reduce((function(t,e){return!0===e.ticked?t+1:t}),0);y===g.children.length?g.ticked=!0:y>0&&(g.indeterminate=!0)}!0===g.indeterminate&&(g.indeterminateNextState=g.children.every((function(t){return!0!==t.tickable||!0!==t.ticked})))}return g};return this.nodes.forEach((function(t){return n(t,null)})),e}},data:function(){return{lazy:{},innerTicked:this.ticked||[],innerExpanded:this.expanded||[]}},watch:{ticked:function(t){this.innerTicked=t},expanded:function(t){this.innerExpanded=t}},methods:{getNodeByKey:function(t){var e=this,n=[].reduce,i=function(r,o){return r||!o?r:!0===Array.isArray(o)?n.call(Object(o),i,r):o[e.nodeKey]===t?o:o[e.childrenKey]?i(null,o[e.childrenKey]):void 0};return i(null,this.nodes)},getTickedNodes:function(){var t=this;return this.innerTicked.map((function(e){return t.getNodeByKey(e)}))},getExpandedNodes:function(){var t=this;return this.innerExpanded.map((function(e){return t.getNodeByKey(e)}))},isExpanded:function(t){return!(!t||!this.meta[t])&&this.meta[t].expanded},collapseAll:function(){void 0!==this.expanded?this.$emit("update:expanded",[]):this.innerExpanded=[]},expandAll:function(){var t=this,e=this.innerExpanded,n=function(i){i[t.childrenKey]&&i[t.childrenKey].length>0&&!1!==i.expandable&&!0!==i.disabled&&(e.push(i[t.nodeKey]),i[t.childrenKey].forEach(n))};this.nodes.forEach(n),void 0!==this.expanded?this.$emit("update:expanded",e):this.innerExpanded=e},setExpanded:function(t,e,n,i){var r=this;if(void 0===n&&(n=this.getNodeByKey(t)),void 0===i&&(i=this.meta[t]),i.lazy&&"loaded"!==i.lazy){if("loading"===i.lazy)return;this.$set(this.lazy,t,"loading"),this.$emit("lazy-load",{node:n,key:t,done:function(e){r.lazy[t]="loaded",e&&r.$set(n,r.childrenKey,e),r.$nextTick((function(){var e=r.meta[t];e&&!0===e.isParent&&r.__setExpanded(t,!0)}))},fail:function(){r.$delete(r.lazy,t)}})}else!0===i.isParent&&!0===i.expandable&&this.__setExpanded(t,e)},__setExpanded:function(t,e){var n=this,i=this.innerExpanded,r=void 0!==this.expanded;if(!0===r&&(i=i.slice()),e){if(this.accordion&&this.meta[t]){var o=[];this.meta[t].parent?this.meta[t].parent.children.forEach((function(e){e.key!==t&&!0===e.expandable&&o.push(e.key)})):this.nodes.forEach((function(e){var i=e[n.nodeKey];i!==t&&o.push(i)})),o.length>0&&(i=i.filter((function(t){return!1===o.includes(t)})))}i=i.concat([t]).filter((function(t,e,n){return n.indexOf(t)===e}))}else i=i.filter((function(e){return e!==t}));!0===r?this.$emit("update:expanded",i):this.innerExpanded=i},isTicked:function(t){return!(!t||!this.meta[t])&&this.meta[t].ticked},setTicked:function(t,e){var n=this.innerTicked,i=void 0!==this.ticked;!0===i&&(n=n.slice()),n=e?n.concat(t).filter((function(t,e,n){return n.indexOf(t)===e})):n.filter((function(e){return!1===t.includes(e)})),!0===i&&this.$emit("update:ticked",n)},__getSlotScope:function(t,e,n){var i=this,r={tree:this,node:t,key:n,color:this.color,dark:this.isDark};return Object.defineProperty(r,"expanded",{get:function(){return e.expanded},set:function(t){t!==e.expanded&&i.setExpanded(n,t)},configurable:!0,enumerable:!0}),Object.defineProperty(r,"ticked",{get:function(){return e.ticked},set:function(t){t!==e.ticked&&i.setTicked([n],t)},configurable:!0,enumerable:!0}),r},__getChildren:function(t,e){var n=this;return(this.filter?e.filter((function(t){return n.meta[t[n.nodeKey]].matchesFilter})):e).map((function(e){return n.__getNode(t,e)}))},__getNodeMedia:function(t,e){if(void 0!==e.icon)return t(Lt,{staticClass:"q-tree__icon q-mr-sm",props:{name:e.icon,color:e.iconColor}});var n=e.img||e.avatar;return n?t("img",{staticClass:"q-tree__"+(e.img?"img":"avatar")+" q-mr-sm",attrs:{src:n}}):void 0},__getNode:function(t,e){var n=this,i=e[this.nodeKey],r=this.meta[i],o=e.header&&this.$scopedSlots["header-"+e.header]||this.$scopedSlots["default-header"],a=!0===r.isParent?this.__getChildren(t,e[this.childrenKey]):[],s=a.length>0||r.lazy&&"loaded"!==r.lazy,l=e.body&&this.$scopedSlots["body-"+e.body]||this.$scopedSlots["default-body"],c=void 0!==o||void 0!==l?this.__getSlotScope(e,r,i):null;return void 0!==l&&(l=t("div",{staticClass:"q-tree__node-body relative-position"},[t("div",{class:this.textColorClass},[l(c)])])),t("div",{key:i,staticClass:"q-tree__node relative-position",class:{"q-tree__node--parent":s,"q-tree__node--child":!s}},[t("div",{staticClass:"q-tree__node-header relative-position row no-wrap items-center",class:{"q-tree__node--link q-hoverable q-focusable":r.link,"q-tree__node--selected":r.selected,"q-tree__node--disabled":r.disabled},attrs:{tabindex:r.link?0:-1},on:{click:function(t){n.__onClick(e,r,t)},keypress:function(t){!0!==Z(t)&&(13===t.keyCode?n.__onClick(e,r,t,!0):32===t.keyCode&&n.__onExpandClick(e,r,t,!0))}}},[t("div",{staticClass:"q-focus-helper",attrs:{tabindex:-1},ref:"blurTarget_"+r.key}),"loading"===r.lazy?t(Gt,{staticClass:"q-tree__spinner q-mr-xs",props:{color:this.computedControlColor}}):!0===s?t(Lt,{staticClass:"q-tree__arrow q-mr-xs",class:{"q-tree__arrow--rotate":r.expanded},props:{name:this.computedIcon},on:{click:function(t){n.__onExpandClick(e,r,t)}}}):null,!0===r.hasTicking&&!0!==r.noTick?t(Ln,{staticClass:"q-mr-xs",props:{value:!0===r.indeterminate?null:r.ticked,color:this.computedControlColor,dark:this.isDark,dense:!0,keepColor:!0,disable:!0!==r.tickable},on:{keydown:w,input:function(t){n.__onTickedClick(r,t)}}}):null,t("div",{staticClass:"q-tree__node-header-content col row no-wrap items-center",class:r.selected?this.selectedColorClass:this.textColorClass},[o?o(c):[this.__getNodeMedia(t,e),t("div",e[this.labelKey])]])]),!0===s?t(yo,{props:{duration:this.duration},on:pt(this,"slide",{show:function(){n.$emit("after-show")},hide:function(){n.$emit("after-hide")}})},[t("div",{staticClass:"q-tree__node-collapsible",class:this.textColorClass,directives:[{name:"show",value:r.expanded}]},[l,t("div",{staticClass:"q-tree__children",class:{"q-tree__node--disabled":r.disabled}},a)])]):l])},__blur:function(t){var e=this.$refs["blurTarget_"+t];void 0!==e&&e.focus()},__onClick:function(t,e,n,i){!0!==i&&this.__blur(e.key),this.hasSelection?e.selectable&&this.$emit("update:selected",e.key!==this.selected?e.key:null):this.__onExpandClick(t,e,n,i),"function"==typeof t.handler&&t.handler(t)},__onExpandClick:function(t,e,n,i){void 0!==n&&w(n),!0!==i&&this.__blur(e.key),this.setExpanded(e.key,!e.expanded,t,e)},__onTickedClick:function(t,e){if(!0===t.indeterminate&&(e=t.indeterminateNextState),t.strictTicking)this.setTicked([t.key],e);else if(t.leafTicking){var n=[],i=function(t){t.isParent?(!0!==e&&!0!==t.noTick&&!0===t.tickable&&n.push(t.key),!0===t.leafTicking&&t.children.forEach(i)):!0===t.noTick||!0!==t.tickable||!0===t.leafFilteredTicking&&!0!==t.matchesFilter||n.push(t.key)};i(t),this.setTicked(n,e)}}},render:function(t){var e=this.__getChildren(t,this.nodes);return t("div",{class:this.classes},0===e.length?this.filter?this.noResultsLabel||this.$q.lang.tree.noResults:this.noNodesLabel||this.$q.lang.tree.noNodes:e)},created:function(){!0===this.defaultExpandAll&&this.expandAll()}}),Ws=t.extend({name:"QUploaderBase",mixins:[It,qr],props:{label:String,color:String,textColor:String,square:Boolean,flat:Boolean,bordered:Boolean,noThumbnails:Boolean,autoUpload:Boolean,hideUploadBtn:Boolean,disable:Boolean,readonly:Boolean},provide:function(){return{__qUploaderGetInput:this.__getInputControl}},data:function(){return{files:[],queuedFiles:[],uploadedFiles:[],dnd:!1,expanded:!1,uploadSize:0,uploadedSize:0}},watch:{isUploading:function(t,e){!1===e&&!0===t?this.$emit("start"):!0===e&&!1===t&&this.$emit("finish")}},computed:{canUpload:function(){return!0===this.editable&&!0!==this.isBusy&&!0!==this.isUploading&&this.queuedFiles.length>0},canAddFiles:function(){return!0===this.editable&&!0!==this.isUploading&&(!0===this.multiple||0===this.queuedFiles.length)&&(void 0===this.maxFiles||this.files.length<this.maxFilesNumber)&&(void 0===this.maxTotalSize||this.uploadSize<this.maxTotalSizeNumber)},uploadProgress:function(){return 0===this.uploadSize?0:this.uploadedSize/this.uploadSize},uploadProgressLabel:function(){return this.__getProgressLabel(this.uploadProgress)},uploadedSizeLabel:function(){return lt(this.uploadedSize)},uploadSizeLabel:function(){return lt(this.uploadSize)},colorClass:function(){var t=[];return void 0!==this.color&&t.push("bg-"+this.color),void 0!==this.textColor&&t.push("text-"+this.textColor),t.join(" ")},editable:function(){return!0!==this.disable&&!0!==this.readonly}},methods:{reset:function(){this.disable||(this.abort(),this.uploadedSize=0,this.uploadSize=0,this.__revokeImgURLs(),this.files=[],this.queuedFiles=[],this.uploadedFiles=[])},removeUploadedFiles:function(){this.disable||(this.files=this.files.filter((function(t){return"uploaded"!==t.__status||(void 0!==t._img&&window.URL.revokeObjectURL(t._img.src),!1)})),this.uploadedFiles=[])},removeQueuedFiles:function(){var t=this;if(!this.disable){var e=[],n=this.files.filter((function(n){return"idle"!==n.__status&&"failed"!==n.__status||(t.uploadSize-=n.size,e.push(n),void 0!==n._img&&window.URL.revokeObjectURL(n._img.src),!1)}));e.length>0&&(this.files=n,this.queuedFiles=[],this.$emit("removed",e))}},removeFile:function(t){this.disable||("uploaded"===t.__status?this.uploadedFiles=this.uploadedFiles.filter((function(e){return e.name!==t.name})):"uploading"===t.__status?t.__abort():this.uploadSize-=t.size,this.files=this.files.filter((function(e){return e.name!==t.name||(void 0!==e._img&&window.URL.revokeObjectURL(e._img.src),!1)})),this.queuedFiles=this.queuedFiles.filter((function(e){return e.name!==t.name})),this.$emit("removed",[t]))},__revokeImgURLs:function(){this.files.forEach((function(t){void 0!==t._img&&window.URL.revokeObjectURL(t._img.src)}))},__getFileInput:function(){return this.$refs.input||this.$el.getElementsByClassName("q-uploader__input")[0]},__getProgressLabel:function(t){return(100*t).toFixed(2)+"%"},__updateFile:function(t,e,n){if(t.__status=e,"idle"===e)return t.__uploaded=0,t.__progress=0,t.__sizeLabel=lt(t.size),void(t.__progressLabel="0.00%");"failed"!==e?(t.__uploaded="uploaded"===e?t.size:n,t.__progress="uploaded"===e?1:Math.min(.9999,t.__uploaded/t.size),t.__progressLabel=this.__getProgressLabel(t.__progress),this.$forceUpdate()):this.$forceUpdate()},__addFiles:function(t,e){var n=this,i=this.__processFiles(t,e,this.files,!0);if(void 0!==i){var r=i.filter((function(t){return-1===n.files.findIndex((function(e){return t.name===e.name}))}));this.__getFileInput().value="",void 0!==r&&(r.forEach((function(t){if(n.__updateFile(t,"idle"),n.uploadSize+=t.size,!0!==n.noThumbnails&&t.type.toUpperCase().startsWith("IMAGE")){var e=new Image;e.src=window.URL.createObjectURL(t),t.__img=e}})),this.files=this.files.concat(r),this.queuedFiles=this.queuedFiles.concat(r),this.$emit("added",r),!0===this.autoUpload&&this.upload())}},__getBtn:function(t,e,n,i){if(!0===e)return t(_e,{props:{type:"a",icon:this.$q.iconSet.uploader[n],flat:!0,dense:!0},on:"add"===n?null:{click:i}},"add"===n?this.__getInputControl(t):null)},__getInputControl:function(t){return[t("input",{ref:"input",staticClass:"q-uploader__input overflow-hidden absolute-full",attrs:Object.assign({},{tabindex:-1,type:"file",title:"",accept:this.accept,capture:this.capture},!0===this.multiple?{multiple:!0}:{}),on:pt(this,"input",{mousedown:_,change:this.__addFiles})})]},__getHeader:function(t){return void 0!==this.$scopedSlots.header?this.$scopedSlots.header(this):[t("div",{staticClass:"q-uploader__header-content flex flex-center no-wrap q-gutter-xs"},[this.__getBtn(t,this.queuedFiles.length>0,"removeQueue",this.removeQueuedFiles),this.__getBtn(t,this.uploadedFiles.length>0,"removeUploaded",this.removeUploadedFiles),!0===this.isUploading?t(Gt,{staticClass:"q-uploader__spinner"}):null,t("div",{staticClass:"col column justify-center"},[void 0!==this.label?t("div",{staticClass:"q-uploader__title"},[this.label]):null,t("div",{staticClass:"q-uploader__subtitle"},[this.uploadSizeLabel+" / "+this.uploadProgressLabel])]),this.__getBtn(t,this.canAddFiles,"add",this.pickFiles),this.__getBtn(t,!1===this.hideUploadBtn&&!0===this.canUpload,"upload",this.upload),this.__getBtn(t,this.isUploading,"clear",this.abort)])]},__getList:function(t){var e=this;return void 0!==this.$scopedSlots.list?this.$scopedSlots.list(this):this.files.map((function(n){return t("div",{key:n.name,staticClass:"q-uploader__file relative-position",class:{"q-uploader__file--img":!0!==e.noThumbnails&&void 0!==n.__img,"q-uploader__file--failed":"failed"===n.__status,"q-uploader__file--uploaded":"uploaded"===n.__status},style:!0!==e.noThumbnails&&void 0!==n.__img?{backgroundImage:'url("'+n.__img.src+'")'}:null},[t("div",{staticClass:"q-uploader__file-header row flex-center no-wrap"},["failed"===n.__status?t(Lt,{staticClass:"q-uploader__file-status",props:{name:e.$q.iconSet.type.negative,color:"negative"}}):null,t("div",{staticClass:"q-uploader__file-header-content col"},[t("div",{staticClass:"q-uploader__title"},[n.name]),t("div",{staticClass:"q-uploader__subtitle row items-center no-wrap"},[n.__sizeLabel+" / "+n.__progressLabel])]),"uploading"===n.__status?t(Nn,{props:{value:n.__progress,min:0,max:1,indeterminate:0===n.__progress}}):t(_e,{props:{round:!0,dense:!0,flat:!0,icon:e.$q.iconSet.uploader["uploaded"===n.__status?"done":"clear"]},on:{click:function(){e.removeFile(n)}}})])])}))}},beforeDestroy:function(){!0===this.isUploading&&this.abort(),this.files.length>0&&this.__revokeImgURLs()},render:function(t){var e=[t("div",{staticClass:"q-uploader__header",class:this.colorClass},this.__getHeader(t)),t("div",{staticClass:"q-uploader__list scroll"},this.__getList(t)),this.__getDnd(t,"uploader")];return!0===this.isBusy&&e.push(t("div",{staticClass:"q-uploader__overlay absolute-full flex flex-center"},[t(Gt)])),t("div",{staticClass:"q-uploader column no-wrap",class:{"q-uploader--dark q-dark":this.isDark,"q-uploader--bordered":this.bordered,"q-uploader--square no-border-radius":this.square,"q-uploader--flat no-shadow":this.flat,"disabled q-uploader--disable":this.disable},on:!0===this.canAddFiles?pt(this,"drag",{dragover:this.__onDragOver}):null},e)}});function Us(t){return"function"==typeof t?t:function(){return t}}var Ys={props:{url:[Function,String],method:{type:[Function,String],default:"POST"},fieldName:{type:[Function,String],default:function(t){return t.name}},headers:[Function,Array],formFields:[Function,Array],withCredentials:[Function,Boolean],sendRaw:[Function,Boolean],batch:[Function,Boolean],factory:Function},data:function(){return{xhrs:[],promises:[],workingThreads:0}},computed:{xhrProps:function(){return{url:Us(this.url),method:Us(this.method),headers:Us(this.headers),formFields:Us(this.formFields),fieldName:Us(this.fieldName),withCredentials:Us(this.withCredentials),sendRaw:Us(this.sendRaw),batch:Us(this.batch)}},isUploading:function(){return this.workingThreads>0},isBusy:function(){return this.promises.length>0}},methods:{abort:function(){this.xhrs.forEach((function(t){t.abort()})),this.promises.length>0&&(this.abortPromises=!0)},upload:function(){var t=this;if(!1!==this.canUpload){var e=this.queuedFiles.slice(0);this.queuedFiles=[],this.xhrProps.batch(e)?this.__runFactory(e):e.forEach((function(e){t.__runFactory([e])}))}},__runFactory:function(t){var e=this;if(this.workingThreads++,"function"==typeof this.factory){var n=this.factory(t);if(n)if("function"==typeof n.catch&&"function"==typeof n.then){this.promises.push(n);var i=function(i){!0!==e._isBeingDestroyed&&!0!==e._isDestroyed&&(e.promises=e.promises.filter((function(t){return t!==n})),0===e.promises.length&&(e.abortPromises=!1),e.queuedFiles=e.queuedFiles.concat(t),t.forEach((function(t){e.__updateFile(t,"failed")})),e.$emit("factory-failed",i,t),e.workingThreads--)};n.then((function(r){!0===e.abortPromises?i(new Error("Aborted")):!0!==e._isBeingDestroyed&&!0!==e._isDestroyed&&(e.promises=e.promises.filter((function(t){return t!==n})),e.__uploadFiles(t,r))})).catch(i)}else this.__uploadFiles(t,n||{});else this.$emit("factory-failed",new Error("QUploader: factory() does not return properly"),t),this.workingThreads--}else this.__uploadFiles(t,{})},__uploadFiles:function(t,e){var n=this,i=new FormData,r=new XMLHttpRequest,o=function(t,i){return void 0!==e[t]?Us(e[t])(i):n.xhrProps[t](i)},a=o("url",t);if(!a)return console.error("q-uploader: invalid or no URL specified"),void this.workingThreads--;var s=o("formFields",t);void 0!==s&&s.forEach((function(t){i.append(t.name,t.value)}));var l,c=0,u=0,d=0,h=0;r.upload.addEventListener("progress",(function(e){if(!0!==l){var i=Math.min(h,e.loaded);n.uploadedSize+=i-d;for(var r=(d=i)-u,o=c;r>0&&o<t.length;o++){var a=t[o];if(!(r>a.size))return void n.__updateFile(a,"uploading",r);r-=a.size,c++,u+=a.size,n.__updateFile(a,"uploading",a.size)}}}),!1),r.onreadystatechange=function(){r.readyState<4||(r.status&&r.status<400?(n.uploadedFiles=n.uploadedFiles.concat(t),t.forEach((function(t){n.__updateFile(t,"uploaded")})),n.$emit("uploaded",{files:t,xhr:r})):(l=!0,n.uploadedSize-=d,n.queuedFiles=n.queuedFiles.concat(t),t.forEach((function(t){n.__updateFile(t,"failed")})),n.$emit("failed",{files:t,xhr:r})),n.workingThreads--,n.xhrs=n.xhrs.filter((function(t){return t!==r})))},r.open(o("method",t),a),!0===o("withCredentials",t)&&(r.withCredentials=!0);var f=o("headers",t);void 0!==f&&f.forEach((function(t){r.setRequestHeader(t.name,t.value)}));var p=o("sendRaw",t);t.forEach((function(t){n.__updateFile(t,"uploading",0),!0!==p&&i.append(o("fieldName",t),t,t.name),t.xhr=r,t.__abort=function(){r.abort()},h+=t.size})),this.$emit("uploading",{files:t,xhr:r}),this.xhrs.push(r),!0===p?r.send(new Blob(t)):r.send(i)}}},Qs=t.extend({name:"QUploader",mixins:[Ws,Ys]}),Gs=t.extend({name:"QUploaderAddTrigger",inject:{__qUploaderGetInput:{default:function(){console.error("QUploaderAddTrigger needs to be child of QUploader")}}},render:function(t){return this.__qUploaderGetInput(t)}}),Ks=t.extend({name:"QVideo",mixins:[Ro,Ot],props:{src:{type:String,required:!0}},computed:{iframeData:function(){return{attrs:{src:this.src,frameborder:"0",allowfullscreen:!0}}},classes:function(){return"q-video"+(void 0!==this.ratio?" q-video--responsive":"")}},render:function(t){return t("div",{class:this.classes,style:this.ratioStyle,on:Object.assign({},this.qListeners)},[t("iframe",this.iframeData)])}}),Js=Object.freeze({__proto__:null,QAjaxBar:Ct,QAvatar:qt,QBadge:Rt,QBanner:Ft,QBar:jt,QBreadcrumbs:Wt,QBreadcrumbsEl:Yt,QBtn:_e,QBtnDropdown:sn,QBtnGroup:be,QBtnToggle:un,QCard:dn,QCardSection:hn,QCardActions:fn,QCarousel:Tn,QCarouselSlide:Pn,QCarouselControl:On,QChatMessage:Bn,QCheckbox:Ln,QChip:qn,QCircularProgress:Nn,QColor:pi,QDate:sr,QDialog:wr,QDrawer:xr,QEditor:vo,QExpansionItem:xo,QFab:Po,QFabAction:Eo,QField:Dr,QFile:Ao,QFooter:Do,QForm:Lo,QHeader:qo,QIcon:Lt,QImg:Io,QInfiniteScroll:No,QInnerLoading:Fo,QInput:Qr,QIntersection:Ho,QList:Kr,QItem:Jr,QItemSection:Zr,QItemLabel:go,QKnob:Uo,QLayout:Go,QMarkupTable:Ko,QMenu:an,QNoSsr:Jo,QOptionGroup:na,QPage:ia,QPageContainer:ra,QPageScroller:aa,QPageSticky:oa,QPagination:sa,QParallax:ua,QPopupEdit:ha,QPopupProxy:fa,QLinearProgress:ma,QPullToRefresh:ga,QRadio:Zo,QRange:wa,QRating:ka,QResizeObserver:ni,QResponsive:xa,QScrollArea:Ca,QScrollObserver:Qo,QSelect:Ra,QSeparator:wo,QSkeleton:Fa,QSlideItem:ja,QSlideTransition:yo,QSlider:ti,QSpace:za,QSpinner:Gt,QSpinnerAudio:Va,QSpinnerBall:Ha,QSpinnerBars:Wa,QSpinnerComment:Ua,QSpinnerCube:Ya,QSpinnerDots:Qa,QSpinnerFacebook:Ga,QSpinnerGears:Ka,QSpinnerGrid:Ja,QSpinnerHearts:Za,QSpinnerHourglass:Xa,QSpinnerInfinity:ts,QSpinnerIos:es,QSpinnerOval:ns,QSpinnerPie:is,QSpinnerPuff:rs,QSpinnerRadio:os,QSpinnerRings:as,QSpinnerTail:ss,QSplitter:ls,QStep:ds,QStepper:hs,QStepperNavigation:fs,QTabPanels:di,QTabPanel:hi,QTable:As,QTh:ps,QTr:Ds,QTd:Ls,QTabs:li,QTab:ui,QRouteTab:Ns,QTime:Fs,QTimeline:$s,QTimelineEntry:js,QToggle:Xo,QToolbar:zs,QToolbarTitle:Vs,QTooltip:Gr,QTree:Hs,QUploader:Qs,QUploaderBase:Ws,QUploaderAddTrigger:Gs,QVideo:Ks,QVirtualScroll:ks});function Zs(t){if(!1===t)return 0;if(!0===t||void 0===t)return 1;var e=parseInt(t,10);return isNaN(e)?0:e}function Xs(t){var e=t.__qclosepopup;void 0!==e&&(t.removeEventListener("click",e.handler),t.removeEventListener("keyup",e.handlerKey),delete t.__qclosepopup)}var tl={name:"close-popup",bind:function(t,e,n){var i=e.value;void 0!==t.__qclosepopup&&(Xs(t),t.__qclosepopup_destroyed=!0);var r={depth:Zs(i),handler:function(t){0!==r.depth&&setTimeout((function(){!function(t,e,n){for(;0!==n&&void 0!==t;){if(void 0!==t.__renderPortal){if(n--,"QMenu"===t.$options.name){t=Se(t,e);continue}t.hide(e)}t=t.$parent}}(n.componentInstance||n.context,t,r.depth)}))},handlerKey:function(t){!0===X(t,13)&&r.handler(t)}};t.__qclosepopup=r,t.addEventListener("click",r.handler),t.addEventListener("keyup",r.handlerKey)},update:function(t,e){var n=e.value,i=e.oldValue;void 0!==t.__qclosepopup&&n!==i&&(t.__qclosepopup.depth=Zs(n))},unbind:function(t){void 0===t.__qclosepopup_destroyed?Xs(t):delete t.__qclosepopup_destroyed}};function el(t){var e=t.__qgoback;void 0!==e&&(t.removeEventListener("click",e.goBack),t.removeEventListener("keyup",e.goBackKey),delete t.__qgoback)}var nl={name:"go-back",bind:function(t,e,n){var i=e.value,r=e.modifiers;void 0!==t.__qgoback&&(el(t),t.__qgoback_destroyed=!0);var o={value:i,position:window.history.length-1,single:r.single,goBack:function(){var t=n.context.$router;!0===o.single?t.go(-1):!0===d.is.nativeMobile?t.go(o.position-window.history.length):t.replace(o.value)},goBackKey:function(t){!0===X(t,13)&&o.goBack()}};t.__qgoback=o,t.addEventListener("click",o.goBack),t.addEventListener("keyup",o.goBackKey)},update:function(t,e){var n=e.value,i=e.oldValue,r=t.__qgoback;void 0!==r&&n!==i&&(r.value=n)},unbind:function(t){void 0===t.__qgoback_destroyed?el(t):delete t.__qgoback_destroyed}},il=0,rl=void 0;function ol(t,e){void 0===rl&&((rl=document.createElement("div")).style.cssText="position: absolute; left: 0; top: 0",document.body.appendChild(rl));var n=t.getBoundingClientRect(),i=rl.getBoundingClientRect(),r=window.getComputedStyle(t),o=r.marginLeft,a=r.marginRight,s=r.marginTop,l=r.marginBottom,c=parseInt(o,10)+parseInt(a,10),u=parseInt(s,10)+parseInt(l,10);return{left:n.left-i.left,top:n.top-i.top,width:n.right-n.left,height:n.bottom-n.top,widthM:n.right-n.left+(!0===e?0:c),heightM:n.bottom-n.top+(!0===e?0:u),marginH:!0===e?c:0,marginV:!0===e?u:0}}function al(t){return{width:t.scrollWidth,height:t.scrollHeight}}var sl=["Top","Right","Bottom","Left"],ll=["borderTopLeftRadius","borderTopRightRadius","borderBottomRightRadius","borderBottomLeftRadius"];function cl(t,e){for(var n=window.getComputedStyle(t),i={},r=0;r<e.length;r++){var o=e[r];if(""===n[o])if("cssText"===o){for(var a=n.length,s="",l=0;l<a;l++)s+=n[l]+": "+n[n[l]]+"; ";i[o]=s}else if(["borderWidth","borderStyle","borderColor"].indexOf(o)>-1){for(var c=o.replace("border",""),u="",d=0;d<sl.length;d++){u+=n["border"+sl[d]+c]+" "}i[o]=u}else if("borderRadius"===o){for(var h="",f="",p=0;p<ll.length;p++){var m=n[ll[p]].split(" ");h+=m[0]+" ",f+=(void 0===m[1]?m[0]:m[1])+" "}i[o]=h+"/ "+f}else i[o]=n[o];else i[o]=n[o]}return i}function ul(t){var e=typeof t;return"function"===e?t():"string"===e?document.querySelector(t):t}function dl(t){return t&&t.ownerDocument===document&&null!==t.parentNode}function hl(t){var e=function(){return!1},n=!1,i=!0,r=function(t){return{from:t.from,to:void 0!==t.to?t.to:t.from}}(t),o=function(t){return"number"==typeof t?t={duration:t}:"function"==typeof t&&(t={onEnd:t}),Object.assign({},t,{waitFor:void 0===t.waitFor?0:t.waitFor,duration:!0===isNaN(t.duration)?300:parseInt(t.duration,10),easing:"string"==typeof t.easing&&t.easing.length>0?t.easing:"ease-in-out",delay:!0===isNaN(t.delay)?0:parseInt(t.delay,10),fill:"string"==typeof t.fill&&t.fill.length>0?t.fill:"none",resize:!0===t.resize,useCSS:!0===t.useCSS,hideFromClone:!0===t.hideFromClone,keepToClone:!0===t.keepToClone,tween:!0===t.tween,tweenFromOpacity:!0===isNaN(t.tweenFromOpacity)?.6:parseFloat(t.tweenFromOpacity),tweenToOpacity:!0===isNaN(t.tweenToOpacity)?.5:parseFloat(t.tweenToOpacity)})}(t),a=ul(r.from);if(!0!==dl(a))return e;"function"==typeof a.qMorphCancel&&a.qMorphCancel();var s=void 0,l=void 0,c=void 0,u=void 0,d=a.parentNode,h=a.nextElementSibling,f=ol(a,o.resize),p=al(d),m=p.width,v=p.height,g=cl(a,["borderWidth","borderStyle","borderColor","borderRadius","backgroundColor","transform","position","cssText"]),y=g.borderWidth,_=g.borderStyle,b=g.borderColor,w=g.borderRadius,k=g.backgroundColor,x=g.transform,C=g.position,S=g.cssText,M=a.classList.toString(),T=a.style.cssText,P=a.cloneNode(!0),O=!0===o.tween?a.cloneNode(!0):void 0;void 0!==O&&(O.className=O.classList.toString().split(" ").filter((function(t){return!1===/^bg-/.test(t)})).join(" ")),!0===o.hideFromClone&&P.classList.add("q-morph--internal"),P.setAttribute("aria-hidden","true"),P.style.transition="none",P.style.animation="none",P.style.pointerEvents="none",d.insertBefore(P,h),a.qMorphCancel=function(){n=!0,P.remove(),void 0!==O&&O.remove(),!0===o.hideFromClone&&P.classList.remove("q-morph--internal"),a.qMorphCancel=void 0};return"function"==typeof t.onToggle&&t.onToggle(),requestAnimationFrame((function(){var t=ul(r.to);if(!0!==n&&!0===dl(t)){a!==t&&"function"==typeof t.qMorphCancel&&t.qMorphCancel(),!0!==o.keepToClone&&t.classList.add("q-morph--internal"),P.classList.add("q-morph--internal");var h=al(d),p=h.width,g=h.height,B=al(t.parentNode),E=B.width,A=B.height;!0!==o.hideFromClone&&P.classList.remove("q-morph--internal"),t.qMorphCancel=function(){n=!0,P.remove(),void 0!==O&&O.remove(),!0===o.hideFromClone&&P.classList.remove("q-morph--internal"),!0!==o.keepToClone&&t.classList.remove("q-morph--internal"),a.qMorphCancel=void 0,t.qMorphCancel=void 0};var D=function(){if(!0!==n){!0!==o.hideFromClone&&(P.classList.add("q-morph--internal"),P.innerHTML="",P.style.left=0,P.style.right="unset",P.style.top=0,P.style.bottom="unset",P.style.transform="none"),!0!==o.keepToClone&&t.classList.remove("q-morph--internal");var r=t.parentNode,h=al(r),B=h.width,D=h.height,L=t.cloneNode(o.keepToClone);L.setAttribute("aria-hidden","true"),!0!==o.keepToClone&&(L.style.left=0,L.style.right="unset",L.style.top=0,L.style.bottom="unset",L.style.transform="none",L.style.pointerEvents="none"),L.classList.add("q-morph--internal");var q=t===a&&d===r?P:t.nextElementSibling;r.insertBefore(L,q);var R=cl(t,["borderWidth","borderStyle","borderColor","borderRadius","backgroundColor","transform","position","cssText"]),I=R.borderWidth,N=R.borderStyle,F=R.borderColor,$=R.borderRadius,j=R.backgroundColor,z=R.transform,V=R.position,H=R.cssText,W=t.classList.toString(),U=t.style.cssText;t.style.cssText=H,t.style.transform="none",t.style.animation="none",t.style.transition="none",t.className=W.split(" ").filter((function(t){return!1===/^bg-/.test(t)})).join(" ");for(var Y=ol(t,o.resize),Q=f.left-Y.left,G=f.top-Y.top,K=f.width/(Y.width>0?Y.width:10),J=f.height/(Y.height>0?Y.height:100),Z=m-p,X=v-g,tt=B-E,et=D-A,nt=Math.max(f.widthM,Z),it=Math.max(f.heightM,X),rt=Math.max(Y.widthM,tt),ot=Math.max(Y.heightM,et),at=a===t&&!1===["absolute","fixed"].includes(V)&&!1===["absolute","fixed"].includes(C),st="fixed"===V,lt=r;!0!==st&&lt!==document;)st="fixed"===window.getComputedStyle(lt).position,lt=lt.parentNode;if(!0!==o.hideFromClone&&(P.style.display="block",P.style.flex="0 0 auto",P.style.opacity=0,P.style.minWidth="unset",P.style.maxWidth="unset",P.style.minHeight="unset",P.style.maxHeight="unset",P.classList.remove("q-morph--internal")),!0!==o.keepToClone&&(L.style.display="block",L.style.flex="0 0 auto",L.style.opacity=0,L.style.minWidth="unset",L.style.maxWidth="unset",L.style.minHeight="unset",L.style.maxHeight="unset"),L.classList.remove("q-morph--internal"),"string"==typeof o.classes&&(t.className+=" "+o.classes),"string"==typeof o.style)t.style.cssText+=" "+o.style;else if(o.style===Object(o.style))for(var ct in o.style)t.style[ct]=o.style[ct];var ut=!0===st?document.documentElement:{scrollLeft:0,scrollTop:0};t.style.position=!0===st?"fixed":"absolute",t.style.left=Y.left-ut.scrollLeft+"px",t.style.right="unset",t.style.top=Y.top-ut.scrollTop+"px",t.style.margin=0,!0===o.resize&&(t.style.minWidth="unset",t.style.maxWidth="unset",t.style.minHeight="unset",t.style.maxHeight="unset",t.style.overflow="hidden",t.style.overflowX="hidden",t.style.overflowY="hidden"),document.body.appendChild(t),void 0!==O&&(O.style.cssText=S,O.style.transform="none",O.style.animation="none",O.style.transition="none",O.style.position=t.style.position,O.style.left=f.left-ut.scrollLeft+"px",O.style.right="unset",O.style.top=f.top-ut.scrollTop+"px",O.style.margin=0,O.style.pointerEvents="none",!0===o.resize&&(O.style.minWidth="unset",O.style.maxWidth="unset",O.style.minHeight="unset",O.style.maxHeight="unset",O.style.overflow="hidden",O.style.overflowX="hidden",O.style.overflowY="hidden"),document.body.appendChild(O));var dt=function(n){a===t&&!0!==i?(t.style.cssText=T,t.className=M):(t.style.cssText=U,t.className=W),L.parentNode===r&&r.insertBefore(t,L),P.remove(),L.remove(),void 0!==O&&O.remove(),e=function(){return!1},a.qMorphCancel=void 0,t.qMorphCancel=void 0,"function"==typeof o.onEnd&&o.onEnd(!0===i?"to":"from",!0===n)};if(!0!==o.useCSS&&"function"==typeof t.animate){var ht=!0===o.resize?{transform:"translate("+Q+"px, "+G+"px)",width:nt+"px",height:it+"px"}:{transform:"translate("+Q+"px, "+G+"px) scale("+K+", "+J+")"},ft=!0===o.resize?{width:rt+"px",height:ot+"px"}:{},pt=!0===o.resize?{width:nt+"px",height:it+"px"}:{},mt=!0===o.resize?{transform:"translate("+-1*Q+"px, "+-1*G+"px)",width:rt+"px",height:ot+"px"}:{transform:"translate("+-1*Q+"px, "+-1*G+"px) scale("+1/K+", "+1/J+")"},vt=void 0!==O?{opacity:o.tweenToOpacity}:{backgroundColor:k},gt=void 0!==O?{opacity:1}:{backgroundColor:j};u=t.animate([Object.assign({},{margin:0,borderWidth:y,borderStyle:_,borderColor:b,borderRadius:w,transformOrigin:"0 0"},ht,vt),Object.assign({},{margin:0,borderWidth:I,borderStyle:N,borderColor:F,borderRadius:$,transformOrigin:"0 0",transform:z},ft,gt)],{duration:o.duration,easing:o.easing,fill:o.fill,delay:o.delay}),l=void 0===O?void 0:O.animate([Object.assign({},{opacity:o.tweenFromOpacity,margin:0,borderWidth:y,borderStyle:_,borderColor:b,borderRadius:w,transformOrigin:"0 0",transform:x},pt),Object.assign({},{opacity:0,margin:0,borderWidth:I,borderStyle:N,borderColor:F,borderRadius:$,transformOrigin:"0 0"},mt)],{duration:o.duration,easing:o.easing,fill:o.fill,delay:o.delay}),s=!0===o.hideFromClone||!0===at?void 0:P.animate([{margin:(X<0?X/2:0)+"px "+(Z<0?Z/2:0)+"px",width:nt+f.marginH+"px",height:it+f.marginV+"px"},{margin:0,width:0,height:0}],{duration:o.duration,easing:o.easing,fill:o.fill,delay:o.delay}),c=!0===o.keepToClone?void 0:L.animate([!0===at?{margin:(X<0?X/2:0)+"px "+(Z<0?Z/2:0)+"px",width:nt+f.marginH+"px",height:it+f.marginV+"px"}:{margin:0,width:0,height:0},{margin:(et<0?et/2:0)+"px "+(tt<0?tt/2:0)+"px",width:rt+Y.marginH+"px",height:ot+Y.marginV+"px"}],{duration:o.duration,easing:o.easing,fill:o.fill,delay:o.delay});var yt=function(t){void 0!==s&&s.cancel(),void 0!==l&&l.cancel(),void 0!==c&&c.cancel(),u.cancel(),u.removeEventListener("finish",yt),u.removeEventListener("cancel",yt),dt(t),s=void 0,l=void 0,c=void 0,u=void 0};a.qMorphCancel=function(){a.qMorphCancel=void 0,n=!0,yt()},t.qMorphCancel=function(){t.qMorphCancel=void 0,n=!0,yt()},u.addEventListener("finish",yt),u.addEventListener("cancel",yt),e=function(t){return!0!==n&&void 0!==u&&(!0===t?(yt(!0),!0):(i=!0!==i,void 0!==s&&s.reverse(),void 0!==l&&l.reverse(),void 0!==c&&c.reverse(),u.reverse(),!0))}}else{var _t="q-morph-anim-"+ ++il,bt=document.createElement("style"),wt=!0===o.resize?"\n            transform: translate("+Q+"px, "+G+"px);\n            width: "+nt+"px;\n            height: "+it+"px;\n          ":"transform: translate("+Q+"px, "+G+"px) scale("+K+", "+J+");",kt=!0===o.resize?"\n            width: "+rt+"px;\n            height: "+ot+"px;\n          ":"",xt=!0===o.resize?"\n            width: "+nt+"px;\n            height: "+it+"px;\n          ":"",Ct=!0===o.resize?"\n            transform: translate("+-1*Q+"px, "+-1*G+"px);\n            width: "+rt+"px;\n            height: "+ot+"px;\n          ":"transform: translate("+-1*Q+"px, "+-1*G+"px) scale("+1/K+", "+1/J+");",St=void 0!==O?"opacity: "+o.tweenToOpacity+";":"background-color: "+k+";",Mt=void 0!==O?"opacity: 1;":"background-color: "+j+";",Tt=void 0===O?"":"\n            @keyframes "+_t+"-from-tween {\n              0% {\n                opacity: "+o.tweenFromOpacity+";\n                margin: 0;\n                border-width: "+y+";\n                border-style: "+_+";\n                border-color: "+b+";\n                border-radius: "+w+";\n                transform-origin: 0 0;\n                transform: "+x+";\n                "+xt+"\n              }\n\n              100% {\n                opacity: 0;\n                margin: 0;\n                border-width: "+I+";\n                border-style: "+N+";\n                border-color: "+F+";\n                border-radius: "+$+";\n                transform-origin: 0 0;\n                "+Ct+"\n              }\n            }\n          ",Pt=!0===o.hideFromClone||!0===at?"":"\n            @keyframes "+_t+"-from {\n              0% {\n                margin: "+(X<0?X/2:0)+"px "+(Z<0?Z/2:0)+"px;\n                width: "+(nt+f.marginH)+"px;\n                height: "+(it+f.marginV)+"px;\n              }\n\n              100% {\n                margin: 0;\n                width: 0;\n                height: 0;\n              }\n            }\n          ",Ot=!0===at?"\n            margin: "+(X<0?X/2:0)+"px "+(Z<0?Z/2:0)+"px;\n            width: "+(nt+f.marginH)+"px;\n            height: "+(it+f.marginV)+"px;\n          ":"\n            margin: 0;\n            width: 0;\n            height: 0;\n          ",Bt=!0===o.keepToClone?"":"\n            @keyframes "+_t+"-to {\n              0% {\n                "+Ot+"\n              }\n\n              100% {\n                margin: "+(et<0?et/2:0)+"px "+(tt<0?tt/2:0)+"px;\n                width: "+(rt+Y.marginH)+"px;\n                height: "+(ot+Y.marginV)+"px;\n              }\n            }\n          ";bt.innerHTML="\n          @keyframes "+_t+" {\n            0% {\n              margin: 0;\n              border-width: "+y+";\n              border-style: "+_+";\n              border-color: "+b+";\n              border-radius: "+w+";\n              background-color: "+k+";\n              transform-origin: 0 0;\n              "+wt+"\n              "+St+"\n            }\n\n            100% {\n              margin: 0;\n              border-width: "+I+";\n              border-style: "+N+";\n              border-color: "+F+";\n              border-radius: "+$+";\n              background-color: "+j+";\n              transform-origin: 0 0;\n              transform: "+z+";\n              "+kt+"\n              "+Mt+"\n            }\n          }\n\n          "+Pt+"\n\n          "+Tt+"\n\n          "+Bt+"\n        ",document.head.appendChild(bt);var Et="normal";P.style.animation=o.duration+"ms "+o.easing+" "+o.delay+"ms "+Et+" "+o.fill+" "+_t+"-from",void 0!==O&&(O.style.animation=o.duration+"ms "+o.easing+" "+o.delay+"ms "+Et+" "+o.fill+" "+_t+"-from-tween"),L.style.animation=o.duration+"ms "+o.easing+" "+o.delay+"ms "+Et+" "+o.fill+" "+_t+"-to",t.style.animation=o.duration+"ms "+o.easing+" "+o.delay+"ms "+Et+" "+o.fill+" "+_t;var At=function(e){e===Object(e)&&e.animationName!==_t||(t.removeEventListener("animationend",At),t.removeEventListener("animationcancel",At),dt(),bt.remove())};a.qMorphCancel=function(){a.qMorphCancel=void 0,n=!0,At()},t.qMorphCancel=function(){t.qMorphCancel=void 0,n=!0,At()},t.addEventListener("animationend",At),t.addEventListener("animationcancel",At),e=function(e){return!!(!0!==n&&t&&P&&L)&&(!0===e?(At(),!0):(i=!0!==i,Et="normal"===Et?"reverse":"normal",P.style.animationDirection=Et,O.style.animationDirection=Et,L.style.animationDirection=Et,t.style.animationDirection=Et,!0))}}}else"function"==typeof t.qMorphCancel&&t.qMorphCancel()};if(o.waitFor>0||"transitionend"===o.waitFor||o.waitFor===Object(o.waitFor)&&"function"==typeof o.waitFor.then){var L=o.waitFor>0?new Promise((function(t){return setTimeout(t,o.waitFor)})):"transitionend"===o.waitFor?new Promise((function(e){var n=setTimeout((function(){i()}),400),i=function(r){clearTimeout(n),t&&(t.removeEventListener("transitionend",i),t.removeEventListener("transitioncancel",i)),e()};t.addEventListener("transitionend",i),t.addEventListener("transitioncancel",i)})):o.waitFor;L.then(D).catch((function(){"function"==typeof t.qMorphCancel&&t.qMorphCancel()}))}else D()}else"function"==typeof a.qMorphCancel&&a.qMorphCancel()})),function(t){return e(t)}}var fl={},pl=["duration","delay","easing","fill","classes","style","duration","resize","useCSS","hideFromClone","keepToClone","tween","tweenFromOpacity","tweenToOpacity","waitFor","onEnd"],ml=["resize","useCSS","hideFromClone","keepToClone","tween"];function vl(t,e){t.clsAction!==e&&(t.clsAction=e,t.el.classList[e]("q-morph--invisible"))}function gl(t){if(!(!0===t.animating||t.queue.length<2)){var e=t.queue,n=e[0],i=e[1];t.animating=!0,n.animating=!0,i.animating=!0,vl(n,"remove"),vl(i,"remove");var r=hl(Object.assign({},{from:n.el,to:i.el,onToggle:function(){vl(n,"add"),vl(i,"remove")}},i.opts,{onEnd:function(e,r){void 0!==i.opts.onEnd&&i.opts.onEnd(e,r),!0!==r&&(n.animating=!1,i.animating=!1,t.animating=!1,t.cancel=void 0,t.queue.shift(),gl(t))}}));t.cancel=function(){r(!0),t.cancel=void 0}}}function yl(t,e){var n=e.opts;ml.forEach((function(e){n[e]=!0===t[e]}))}function _l(t,e){if(e.name!==t)!1===e.animating&&vl(e,"add");else{var n=fl[e.group];void 0===n?(fl[e.group]={name:e.group,model:t,queue:[e],animating:!1},vl(e,"remove")):n.model!==t&&(n.model=t,n.queue.push(e),!1===n.animating&&2===n.queue.length&&gl(n))}}function bl(t,e){var n;Object(e)===e?(n=""+e.model,function(t,e){void 0!==t.group&&(e.group=t.group),void 0!==t.name&&(e.name=t.name);var n=e.opts;pl.forEach((function(e){void 0!==t[e]&&(n[e]=t[e])}))}(e,t),yl(e,t)):n=""+e,n!==t.model?(t.model=n,_l(n,t)):!1===t.animating&&void 0!==t.clsAction&&t.el.classList[t.clsAction]("q-morph--invisible")}function wl(t){var e=t.__qmorph;if(void 0!==e){var n=fl[e.group];if(void 0!==n)-1!==n.queue.indexOf(e)&&(n.queue=n.queue.filter((function(t){return t!==e})),0===n.queue.length&&(void 0!==n.cancel&&n.cancel(),delete fl[e.group]));"add"===e.clsAction&&t.classList.remove("q-morph--invisible"),delete t.__qmorph}}var kl={name:"morph",inserted:function(t,e){void 0!==t.__qmorph&&(wl(t),t.__qmorph_destroyed=!0);var n={el:t,animating:!1,opts:{}};yl(e.modifiers,n),function(t,e){var n="string"==typeof t&&t.length>0?t.split(":"):[];e.name=n[0],e.group=n[1],Object.assign(e.opts,{duration:!0===isNaN(n[2])?300:parseFloat(n[2]),waitFor:n[3]})}(e.arg,n),bl(n,e.value),t.__qmorph=n},update:function(t,e){var n=t.__qmorph;void 0!==n&&bl(n,e.value)},unbind:function(t){void 0===t.__qmorph_destroyed?wl(t):delete t.__qmorph_destroyed}};var xl={childList:!0,subtree:!0,attributes:!0,characterData:!0,attributeOldValue:!0,characterDataOldValue:!0};function Cl(t,e,n){e.handler=n,void 0!==e.observer&&e.observer.disconnect(),e.observer=new MutationObserver((function(n){"function"==typeof e.handler&&(!1!==e.handler(n)&&!0!==e.once||Sl(t))})),e.observer.observe(t,e.opts)}function Sl(t){var e=t.__qmutation;void 0!==e&&(void 0!==e.observer&&e.observer.disconnect(),delete t.__qmutation)}var Ml={name:"mutation",inserted:function(t,e){var n=e.modifiers,i=n.once,r=function(t,e){var n={};for(var i in t)Object.prototype.hasOwnProperty.call(t,i)&&-1===e.indexOf(i)&&(n[i]=t[i]);return n}(n,["once"]),o=e.value;void 0!==t.__qmutation&&(Sl(t),t.__qmutation_destroyed=!0);var a={once:i,opts:0===Object.keys(r).length?xl:r};Cl(t,a,o),t.__qmutation=a},update:function(t,e){var n=e.oldValue,i=e.value,r=t.__qmutation;void 0!==r&&n!==i&&Cl(t,r,i)},unbind:function(t){void 0===t.__qmutation_destroyed?Sl(t):delete t.__qmutation_destroyed}};function Tl(t,e){var n=e.value,i=e.oldValue;"function"==typeof n?(t.handler=n,"function"!=typeof i&&(t.scrollTarget.addEventListener("scroll",t.scroll,f.passive),t.scroll())):t.scrollTarget.removeEventListener("scroll",t.scroll)}function Pl(t){var e=t.__qscrollfire;void 0!==e&&(e.scrollTarget.removeEventListener("scroll",e.scroll,f.passive),delete t.__qscrollfire)}var Ol={name:"scroll-fire",inserted:function(t,e){void 0!==t.__qscrollfire&&(Pl(t),t.__qscrollfire_destroyed=!0);var n={scrollTarget:Ie(t),scroll:T((function(){var e,i;n.scrollTarget===window?(i=t.getBoundingClientRect().bottom,e=window.innerHeight):(i=Kt(t).top+Jt(t),e=Kt(n.scrollTarget).top+Jt(n.scrollTarget)),i>0&&i<e&&(n.scrollTarget.removeEventListener("scroll",n.scroll,f.passive),n.handler(t))}),25)};Tl(n,e),t.__qscrollfire=n},update:function(t,e){void 0!==t.__qscrollfire&&e.value!==e.oldValue&&Tl(t.__qscrollfire,e)},unbind:function(t){void 0===t.__qscrollfire_destroyed?Pl(t):delete t.__qscrollfire_destroyed}};function Bl(t,e){var n=e.value,i=e.oldValue;"function"==typeof n?(t.handler=n,"function"!=typeof i&&t.scrollTarget.addEventListener("scroll",t.scroll,f.passive)):t.scrollTarget.removeEventListener("scroll",t.scroll,f.passive)}function El(t){var e=t.__qscroll;void 0!==e&&(e.scrollTarget.removeEventListener("scroll",e.scroll,f.passive),delete t.__qscroll)}var Al={name:"scroll",inserted:function(t,e){void 0!==t.__qscroll&&(El(t),t.__qscroll_destroyed=!0);var n={scrollTarget:Ie(t),scroll:function(){n.handler(Fe(n.scrollTarget),$e(n.scrollTarget))}};Bl(n,e),t.__qscroll=n},update:function(t,e){void 0!==t.__qscroll&&e.oldValue!==e.value&&Bl(t.__qscroll,e)},unbind:function(t){void 0===t.__qscroll_destroyed?El(t):delete t.__qscroll_destroyed}};function Dl(t){var e=t.__qtouchhold;void 0!==e&&(S(e,"main"),S(e,"temp"),clearTimeout(e.timer),void 0!==e.styleCleanup&&e.styleCleanup(),delete t.__qtouchhold)}var Ll={name:"touch-hold",bind:function(t,e){var n;void 0!==t.__qtouchhold&&(Dl(t),t.__qtouchhold_destroyed=!0);var i=e.modifiers;if(!0===i.mouse||!0===d.has.touch){var r={handler:e.value,noop:m,mouseStart:function(t){"function"==typeof r.handler&&!0===v(t)&&(C(r,"temp",[[document,"mousemove","move","passiveCapture"],[document,"click","end","notPassiveCapture"]]),r.start(t,!0))},touchStart:function(t){if(void 0!==t.target&&"function"==typeof r.handler){var e=he(t.target);C(r,"temp",[[e,"touchmove","move","passiveCapture"],[e,"touchcancel","end","notPassiveCapture"],[e,"touchend","end","notPassiveCapture"]]),r.start(t)}},start:function(t,e){r.origin=g(t);var n=Date.now();!0===d.is.mobile&&(document.body.classList.add("non-selectable"),we(),r.styleCleanup=function(t){r.styleCleanup=void 0;var e=function(){document.body.classList.remove("non-selectable")};!0===t?(we(),setTimeout(e,10)):e()}),r.triggered=!1,r.sensitivity=!0===e?r.mouseSensitivity:r.touchSensitivity,r.timer=setTimeout((function(){we(),r.triggered=!0,r.handler({evt:t,touch:!0!==e,mouse:!0===e,position:r.origin,duration:Date.now()-n})}),r.duration)},move:function(t){var e=g(t),n=e.top,i=e.left;(Math.abs(i-r.origin.left)>=r.sensitivity||Math.abs(n-r.origin.top)>=r.sensitivity)&&clearTimeout(r.timer)},end:function(t){S(r,"temp"),void 0!==r.styleCleanup&&r.styleCleanup(r.triggered),!0===r.triggered?void 0!==t&&w(t):clearTimeout(r.timer)}},o=[600,5,7];"string"==typeof e.arg&&e.arg.length>0&&e.arg.split(":").forEach((function(t,e){var n=parseInt(t,10);n&&(o[e]=n)})),n=o,r.duration=n[0],r.touchSensitivity=n[1],r.mouseSensitivity=n[2],t.__qtouchhold=r,!0===i.mouse&&C(r,"main",[[t,"mousedown","mouseStart","passive"+(!0===i.mouseCapture?"Capture":"")]]),!0===d.has.touch&&C(r,"main",[[t,"touchstart","touchStart","passive"+(!0===i.capture?"Capture":"")],[t,"touchend","noop","notPassiveCapture"]])}},update:function(t,e){var n=t.__qtouchhold;void 0!==n&&e.oldValue!==e.value&&("function"!=typeof e.value&&n.end(),n.handler=e.value)},unbind:function(t){void 0===t.__qtouchhold_destroyed?Dl(t):delete t.__qtouchhold_destroyed}},ql={esc:27,tab:9,enter:13,space:32,up:38,left:37,right:39,down:40,delete:[8,46]},Rl=new RegExp("^([\\d+]+|"+Object.keys(ql).join("|")+")$","i");function Il(t){var e=t.__qtouchrepeat;void 0!==e&&(clearTimeout(e.timer),S(e,"main"),S(e,"temp"),void 0!==e.styleCleanup&&e.styleCleanup(),delete t.__qtouchrepeat)}var Nl,Fl={name:"touch-repeat",bind:function(t,e){var n=e.modifiers,i=e.value,r=e.arg;void 0!==t.__qtouchrepeat&&(Il(t),t.__qtouchrepeat_destroyed=!0);var o=Object.keys(n).reduce((function(t,e){if(!0===Rl.test(e)){var n=isNaN(parseInt(e,10))?ql[e.toLowerCase()]:parseInt(e,10);n>=0&&t.push(n)}return t}),[]);if(!0===n.mouse||!0===d.has.touch||0!==o.length){var a="string"==typeof r&&r.length>0?r.split(":").map((function(t){return parseInt(t,10)})):[0,600,300],s=a.length-1,l={keyboard:o,handler:i,noop:m,mouseStart:function(t){void 0===l.event&&"function"==typeof l.handler&&!0===v(t)&&(C(l,"temp",[[document,"mousemove","move","passiveCapture"],[document,"click","end","notPassiveCapture"]]),l.start(t,!0))},keyboardStart:function(e){if("function"==typeof l.handler&&!0===X(e,o)){if((0===a[0]||void 0!==l.event)&&(w(e),t.focus(),void 0!==l.event))return;C(l,"temp",[[document,"keyup","end","notPassiveCapture"],[document,"click","end","notPassiveCapture"]]),l.start(e,!1,!0)}},touchStart:function(t){if(void 0!==t.target&&"function"==typeof l.handler){var e=he(t.target);C(l,"temp",[[e,"touchmove","move","passiveCapture"],[e,"touchcancel","end","notPassiveCapture"],[e,"touchend","end","notPassiveCapture"]]),l.start(t)}},start:function(t,e,n){function i(t){l.styleCleanup=void 0,document.documentElement.style.cursor="";var e=function(){document.body.classList.remove("non-selectable")};!0===t?(we(),setTimeout(e,10)):e()}!0!==n&&(l.origin=g(t)),!0===d.is.mobile&&(document.body.classList.add("non-selectable"),we(),l.styleCleanup=i),l.event={touch:!0!==e&&!0!==n,mouse:!0===e,keyboard:!0===n,startTime:Date.now(),repeatCount:0};var r=function(){if(void 0!==l.event){0===l.event.repeatCount&&(l.event.evt=t,!0===n?l.event.keyCode=t.keyCode:l.event.position=g(t),!0!==d.is.mobile&&(document.documentElement.style.cursor="pointer",document.body.classList.add("non-selectable"),we(),l.styleCleanup=i)),l.event.duration=Date.now()-l.event.startTime,l.event.repeatCount+=1,l.handler(l.event);var e=s<l.event.repeatCount?s:l.event.repeatCount;l.timer=setTimeout(r,a[e])}};0===a[0]?r():l.timer=setTimeout(r,a[0])},move:function(t){void 0!==l.event&&!0===function(t,e){var n=g(t),i=n.top,r=n.left;return Math.abs(r-e.left)>=7||Math.abs(i-e.top)>=7}(t,l.origin)&&clearTimeout(l.timer)},end:function(t){void 0!==l.event&&(void 0!==l.styleCleanup&&l.styleCleanup(!0),void 0!==t&&l.event.repeatCount>0&&w(t),S(l,"temp"),clearTimeout(l.timer),l.event=void 0)}};t.__qtouchrepeat=l,!0===n.mouse&&C(l,"main",[[t,"mousedown","mouseStart","passive"+(!0===n.mouseCapture?"Capture":"")]]),!0===d.has.touch&&C(l,"main",[[t,"touchstart","touchStart","passive"+(!0===n.capture?"Capture":"")],[t,"touchend","noop","notPassiveCapture"]]),o.length>0&&C(l,"main",[[t,"keydown","keyboardStart","notPassive"+(!0===n.keyCapture?"Capture":"")]])}},update:function(t,e){var n=e.oldValue,i=e.value,r=t.__qtouchrepeat;void 0!==r&&n!==i&&("function"!=typeof i&&r.end(),r.handler=i)},unbind:function(t){void 0===t.__qtouchrepeat_destroyed?Il(t):delete t.__qtouchrepeat_destroyed}},$l=Object.freeze({__proto__:null,ClosePopup:tl,GoBack:nl,Intersection:Vo,Morph:kl,Mutation:Ml,Ripple:oe,ScrollFire:Ol,Scroll:Al,TouchHold:Ll,TouchPan:Gn,TouchRepeat:Fl,TouchSwipe:vn});function jl(t){void 0===Nl&&(Nl=h.is.winphone?"msapplication-navbutton-color":h.is.safari?"apple-mobile-web-app-status-bar-style":"theme-color");var e=function(t){var e=document.getElementsByTagName("META");for(var n in e)if(e[n].name===t)return e[n]}(Nl),n=void 0===e;n&&(e=document.createElement("meta")).setAttribute("name",Nl),e.setAttribute("content",t),n&&document.head.appendChild(e)}var zl={install:function(t){var e=t.$q,n=t.cfg;this.set=!1!==i||!0!==h.is.mobile||!0!==h.is.nativeMobile&&!0!==h.is.winphone&&!0!==h.is.safari&&!0!==h.is.webkit&&!0!==h.is.vivaldi?m:function(t){var e=t||Q("primary");!0===h.is.nativeMobile&&window.StatusBar?window.StatusBar.backgroundColorByHexString(e):jl(e)},e.addressbarColor=this,n.addressbarColor&&this.set(n.addressbarColor)}},Vl={};function Hl(t,e){try{var n=t[e]();return void 0===n?Promise.resolve():n}catch(t){return Promise.reject(t)}}var Wl={isCapable:!1,isActive:!1,activeEl:null,request:function(t){var e=this;if(!0===this.isCapable&&!1===this.isActive){var n=t||document.documentElement;return Hl(n,Vl.request).then((function(){e.activeEl=n}))}return this.__getErr()},exit:function(){var t=this;return!0===this.isCapable&&!0===this.isActive?Hl(document,Vl.exit).then((function(){t.activeEl=null})):this.__getErr()},toggle:function(t){return!0===this.isActive?this.exit():this.request(t)},install:function(e){var n=this;e.$q.fullscreen=this,!0!==i&&(Vl.request=["requestFullscreen","msRequestFullscreen","mozRequestFullScreen","webkitRequestFullscreen"].find((function(t){return void 0!==document.documentElement[t]})),this.isCapable=void 0!==Vl.request,!1!==this.isCapable?(this.__getErr=function(){return Promise.resolve()},Vl.exit=["exitFullscreen","msExitFullscreen","mozCancelFullScreen","webkitExitFullscreen"].find((function(t){return document[t]})),this.isActive=!!(document.fullscreenElement||document.mozFullScreenElement||document.webkitFullscreenElement||document.msFullscreenElement),["onfullscreenchange","onmsfullscreenchange","onwebkitfullscreenchange"].forEach((function(t){document[t]=function(){n.isActive=!1===n.isActive}})),t.util.defineReactive(this,"isActive",this.isActive),t.util.defineReactive(this,"activeEl",this.activeEl)):this.__getErr=function(){return Promise.reject("Not capable")})}},Ul={appVisible:!1,install:function(e){var n=this,r=e.$q;if(!0!==i){var o,a;void 0!==document.hidden?(o="hidden",a="visibilitychange"):void 0!==document.msHidden?(o="msHidden",a="msvisibilitychange"):void 0!==document.webkitHidden&&(o="webkitHidden",a="webkitvisibilitychange");var s=function(){n.appVisible=r.appVisible=!document[o]};s(),a&&void 0!==document[o]&&(t.util.defineReactive(r,"appVisible",this.appVisible),document.addEventListener(a,s,!1))}else this.appVisible=r.appVisible=!0}},Yl=t.extend({name:"BottomSheetPlugin",mixins:[It,yt],inheritAttrs:!1,props:{title:String,message:String,actions:Array,grid:Boolean,cardClass:[String,Array,Object],cardStyle:[String,Array,Object]},computed:{dialogProps:function(){return Object.assign({},this.qAttrs,{position:"bottom"})}},methods:{show:function(){this.$refs.dialog.show()},hide:function(){this.$refs.dialog.hide()},onOk:function(t){this.$emit("ok",t),this.hide()},__getGrid:function(t){var e=this;return this.actions.map((function(n){var i=n.avatar||n.img;return void 0===n.label?t(wo,{staticClass:"col-all",props:{dark:e.isDark}}):t("div",{staticClass:"q-bottom-sheet__item q-hoverable q-focusable cursor-pointer relative-position",class:n.classes,attrs:{tabindex:0},on:{click:function(){return e.onOk(n)},keyup:function(t){13===t.keyCode&&e.onOk(n)}}},[t("div",{staticClass:"q-focus-helper"}),n.icon?t(Lt,{props:{name:n.icon,color:n.color}}):i?t("img",{attrs:{src:i},staticClass:n.avatar?"q-bottom-sheet__avatar":null}):t("div",{staticClass:"q-bottom-sheet__empty-icon"}),t("div",[n.label])])}))},__getList:function(t){var e=this;return this.actions.map((function(n){var i=n.avatar||n.img;return void 0===n.label?t(wo,{props:{spaced:!0,dark:e.isDark}}):t(Jr,{staticClass:"q-bottom-sheet__item",class:n.classes,props:{tabindex:0,clickable:!0,dark:e.isDark},on:{click:function(){return e.onOk(n)},keyup:function(t){13===t.keyCode&&e.onOk(n)}}},[t(Zr,{props:{avatar:!0}},[n.icon?t(Lt,{props:{name:n.icon,color:n.color}}):i?t("img",{attrs:{src:i},staticClass:n.avatar?"q-bottom-sheet__avatar":null}):null]),t(Zr,[n.label])])}))}},render:function(t){var e=this,n=[];return this.title&&n.push(t(hn,{staticClass:"q-dialog__title"},[this.title])),this.message&&n.push(t(hn,{staticClass:"q-dialog__message"},[this.message])),n.push(!0===this.grid?t("div",{staticClass:"row items-stretch justify-start"},this.__getGrid(t)):t("div",this.__getList(t))),t(wr,{ref:"dialog",props:this.dialogProps,on:pt(this,"hide",{hide:function(){e.$emit("hide")}})},[t(dn,{staticClass:"q-bottom-sheet q-bottom-sheet--"+(!0===this.grid?"grid":"list")+(!0===this.isDark?" q-bottom-sheet--dark q-dark":""),style:this.cardStyle,class:this.cardClass},n)])}});var Ql={onOk:function(){return Ql},okCancel:function(){return Ql},hide:function(){return Ql}};function Gl(e){return function(n){n.className;var r=n.class,o=n.style,a=n.component,s=n.root,l=n.parent,c=function(t,e){var n={};for(var i in t)Object.prototype.hasOwnProperty.call(t,i)&&-1===e.indexOf(i)&&(n[i]=t[i]);return n}(n,["className","class","style","component","root","parent"]);if(!0===i)return Ql;void 0!==r&&(c.cardClass=r),void 0!==o&&(c.cardStyle=o);var u=[],d=[],h={onOk:function(t){return u.push(t),h},onCancel:function(t){return d.push(t),h},onDismiss:function(t){return u.push(t),d.push(t),h},hide:function(){return y.$refs.dialog.hide(),h}},f=document.createElement("div");document.body.appendChild(f);var p=!1,m={ok:function(t){p=!0,u.forEach((function(e){e(t)}))},hide:function(){y.$destroy(),y.$el.remove(),y=null,!0!==p&&d.forEach((function(t){t()}))}};t.observable(c);var v=void 0!==a?a:e,g=void 0===a?c:void 0,y=new t({name:"QGlobalDialog",el:f,parent:void 0===l?s:l,render:function(t){return t(v,{ref:"dialog",props:c,attrs:g,on:m})},mounted:function(){this.$refs.dialog.show()}});return h}}var Kl={install:function(t){var e=t.$q;this.create=e.bottomSheet=Gl(Yl)}};function Jl(t){return encodeURIComponent(t)}function Zl(t){return decodeURIComponent(t)}function Xl(t){if(""===t)return t;0===t.indexOf('"')&&(t=t.slice(1,-1).replace(/\\"/g,'"').replace(/\\\\/g,"\\")),t=Zl(t.replace(/\+/g," "));try{t=JSON.parse(t)}catch(t){}return t}function tc(t){var e=new Date;return e.setMilliseconds(e.getMilliseconds()+t),e.toUTCString()}function ec(t,e,n,i){var r,o,a,s,l,c,u,d;void 0===n&&(n={}),void 0!==n.expires&&("[object Date]"===Object.prototype.toString.call(n.expires)?r=n.expires.toUTCString():"string"==typeof n.expires?(a=n.expires,s=0,l=a.match(/(\d+)d/),c=a.match(/(\d+)h/),u=a.match(/(\d+)m/),d=a.match(/(\d+)s/),l&&(s+=864e5*l[1]),c&&(s+=36e5*c[1]),u&&(s+=6e4*u[1]),d&&(s+=1e3*d[1]),r=0===s?a:tc(s)):(o=parseFloat(n.expires),r=!1===isNaN(o)?tc(864e5*o):n.expires));var h,f=Jl(t)+"="+Jl((h=e)===Object(h)?JSON.stringify(h):""+h),p=[f,void 0!==r?"; Expires="+r:"",n.path?"; Path="+n.path:"",n.domain?"; Domain="+n.domain:"",n.sameSite?"; SameSite="+n.sameSite:"",n.httpOnly?"; HttpOnly":"",n.secure?"; Secure":"",n.other?"; "+n.other:""].join("");if(i){i.req.qCookies?i.req.qCookies.push(p):i.req.qCookies=[p],i.res.setHeader("Set-Cookie",i.req.qCookies);var m=i.req.headers.cookie||"";if(void 0!==r&&o<0){var v=nc(t,i);void 0!==v&&(m=m.replace(t+"="+v+"; ","").replace("; "+t+"="+v,"").replace(t+"="+v,""))}else m=m?f+"; "+m:p;i.req.headers.cookie=m}else document.cookie=p}function nc(t,e){for(var n,i,r,o=e?e.req.headers:document,a=o.cookie?o.cookie.split("; "):[],s=a.length,l=t?null:{},c=0;c<s;c++)if(i=Zl((n=a[c].split("=")).shift()),r=n.join("="),t){if(t===i){l=Xl(r);break}}else l[i]=r;return l}function ic(t){return{get:function(e){return nc(e,t)},set:function(e,n,i){return ec(e,n,i,t)},has:function(e){return function(t,e){return null!==nc(t,e)}(e,t)},remove:function(e,n){return function(t,e,n){ec(t,"",Object.assign({},{expires:-1},e),n)}(e,n,t)},getAll:function(){return nc(null,t)}}}var rc,oc,ac,sc,lc={parseSSR:function(t){return void 0!==t?ic(t):this},install:function(t){var e=t.$q,n=t.queues;!0===i?n.server.push((function(t,e){t.cookies=ic(e.ssr)})):(Object.assign(this,ic()),e.cookies=this)}},cc=t.extend({name:"DialogPlugin",mixins:[It,yt],inheritAttrs:!1,props:{title:String,message:String,prompt:Object,options:Object,html:Boolean,ok:{type:[String,Object,Boolean],default:!0},cancel:[String,Object,Boolean],focus:{type:String,default:"ok",validator:function(t){return["ok","cancel","none"].includes(t)}},stackButtons:Boolean,color:String,cardClass:[String,Array,Object],cardStyle:[String,Array,Object]},computed:{hasForm:function(){return void 0!==this.prompt||void 0!==this.options},okLabel:function(){return Object(this.ok)===this.ok||!0===this.ok?this.$q.lang.label.ok:this.ok},cancelLabel:function(){return Object(this.cancel)===this.cancel||!0===this.cancel?this.$q.lang.label.cancel:this.cancel},vmColor:function(){return this.color||(!0===this.isDark?"amber":"primary")},okDisabled:function(){return void 0!==this.prompt?void 0!==this.prompt.isValid&&!0!==this.prompt.isValid(this.prompt.model):void 0!==this.options?void 0!==this.options.isValid&&!0!==this.options.isValid(this.options.model):void 0},okProps:function(){return Object.assign({},{color:this.vmColor,label:this.okLabel,ripple:!1},Object(this.ok)===this.ok?this.ok:{flat:!0},{disable:this.okDisabled})},cancelProps:function(){return Object.assign({},{color:this.vmColor,label:this.cancelLabel,ripple:!1},Object(this.cancel)===this.cancel?this.cancel:{flat:!0})}},methods:{show:function(){this.$refs.dialog.show()},hide:function(){this.$refs.dialog.hide()},getPrompt:function(t){var e=this;return[t(Qr,{props:{value:this.prompt.model,type:this.prompt.type,label:this.prompt.label,stackLabel:this.prompt.stackLabel,outlined:this.prompt.outlined,filled:this.prompt.filled,standout:this.prompt.standout,rounded:this.prompt.rounded,square:this.prompt.square,counter:this.prompt.counter,maxlength:this.prompt.maxlength,prefix:this.prompt.prefix,suffix:this.prompt.suffix,color:this.vmColor,dense:!0,autofocus:!0,dark:this.isDark},attrs:this.prompt.attrs,on:pt(this,"prompt",{input:function(t){e.prompt.model=t},keyup:function(t){!0!==e.okDisabled&&"textarea"!==e.prompt.type&&!0===X(t,13)&&e.onOk()}})})]},getOptions:function(t){var e=this;return[t(na,{props:{value:this.options.model,type:this.options.type,color:this.vmColor,inline:this.options.inline,options:this.options.items,dark:this.isDark},on:pt(this,"opts",{input:function(t){e.options.model=t}})})]},getButtons:function(t){var e=[];if(this.cancel&&e.push(t(_e,{props:this.cancelProps,attrs:{"data-autofocus":"cancel"===this.focus&&!0!==this.hasForm},on:pt(this,"cancel",{click:this.onCancel})})),this.ok&&e.push(t(_e,{props:this.okProps,attrs:{"data-autofocus":"ok"===this.focus&&!0!==this.hasForm},on:pt(this,"ok",{click:this.onOk})})),e.length>0)return t(fn,{staticClass:!0===this.stackButtons?"items-end":null,props:{vertical:this.stackButtons,align:"right"}},e)},onOk:function(){this.$emit("ok",da(this.getData())),this.hide()},onCancel:function(){this.hide()},getData:function(){return void 0!==this.prompt?this.prompt.model:void 0!==this.options?this.options.model:void 0},getSection:function(t,e,n){return!0===this.html?t(hn,{staticClass:e,domProps:{innerHTML:n}}):t(hn,{staticClass:e},[n])}},render:function(t){var e=this,n=[];return this.title&&n.push(this.getSection(t,"q-dialog__title",this.title)),this.message&&n.push(this.getSection(t,"q-dialog__message",this.message)),void 0!==this.prompt?n.push(t(hn,{staticClass:"scroll q-dialog-plugin__form"},this.getPrompt(t))):void 0!==this.options&&n.push(t(wo,{props:{dark:this.isDark}}),t(hn,{staticClass:"scroll q-dialog-plugin__form"},this.getOptions(t)),t(wo,{props:{dark:this.isDark}})),(this.ok||this.cancel)&&n.push(this.getButtons(t)),t(wr,{ref:"dialog",props:Object.assign({},this.qAttrs,{value:this.value}),on:pt(this,"hide",{hide:function(){e.$emit("hide")}})},[t(dn,{staticClass:"q-dialog-plugin"+(!0===this.isDark?" q-dialog-plugin--dark q-dark":""),style:this.cardStyle,class:this.cardClass,props:{dark:this.isDark}},n)])}}),uc={install:function(t){var e=t.$q;this.create=e.dialog=Gl(cc)}},dc={isActive:!1,start:m,stop:m,increment:m,setDefaults:m,install:function(e){var n=this,r=e.$q,o=e.cfg;if(!0!==i){var a=void 0!==o.loadingBar?Object.assign({},o.loadingBar):{},s=r.loadingBar=new t({name:"LoadingBar",render:function(t){return t(Ct,{ref:"bar",props:a})}}).$mount().$refs.bar;Object.assign(this,{start:function(t){s.start(t),n.isActive=s.isActive=s.calls>0},stop:function(){s.stop(),n.isActive=s.isActive=s.calls>0},increment:s.increment,setDefaults:function(t){t===Object(t)&&Object.assign(a,t),s.$parent.$forceUpdate()}}),t.util.defineReactive(this,"isActive",this.isActive),t.util.defineReactive(s,"isActive",this.isActive),s.setDefaults=this.setDefaults,document.body.appendChild(s.$parent.$el)}else r.loadingBar=this}},hc=0,fc={},pc={delay:0,message:!1,spinnerSize:80,spinnerColor:"white",messageColor:"white",backgroundColor:"black",spinner:Gt,customClass:""},mc=Object.assign({},pc),vc={isActive:!1,show:function(e){var n=this;!0!==i&&((fc=e===Object(e)&&!0===e.ignoreDefaults?Object.assign({},pc,e):Object.assign({},mc,e)).customClass+=" text-"+fc.backgroundColor,fc.uid="l_"+hc++,this.isActive=!0,void 0===rc?(clearTimeout(oc),oc=setTimeout((function(){oc=void 0;var e=document.createElement("div");document.body.appendChild(e),rc=new t({name:"QLoading",el:e,mounted:function(){mr(!0)},render:function(t){var e;return t("transition",{props:{name:"q-transition--fade",appear:!0},on:pt(n,"tr",{"after-leave":function(){!0!==n.isActive&&void 0!==rc&&(mr(!1),rc.$destroy(),rc.$el.remove(),rc=void 0)}})},[!0===n.isActive?t("div",{staticClass:"q-loading fullscreen column flex-center z-max",key:fc.uid,class:fc.customClass.trim()},[t(fc.spinner,{props:{color:fc.spinnerColor,size:fc.spinnerSize}}),fc.message&&t("div",{class:"text-"+fc.messageColor,domProps:(e={},e[!0===fc.sanitize?"textContent":"innerHTML"]=fc.message,e)})||void 0]):null])}})}),fc.delay)):rc.$forceUpdate())},hide:function(){!0===this.isActive&&(void 0!==oc&&(clearTimeout(oc),oc=void 0),this.isActive=!1)},setDefaults:function(t){t===Object(t)&&Object.assign(mc,t)},install:function(t){var e=t.$q,n=t.cfg.loading;this.setDefaults(n),e.loading=this}};function gc(t){t.title&&(t.title=t.titleTemplate?t.titleTemplate(t.title):t.title,delete t.titleTemplate),[["meta","content"],["link","href"]].forEach((function(e){var n=t[e[0]],i=e[1];for(var r in n){var o=n[r];o.template&&(1===Object.keys(o).length?delete n[r]:(o[i]=o.template(o[i]||""),delete o.template))}}))}function yc(t,e){if(Object.keys(t).length!==Object.keys(e).length)return!0;for(var n in t)if(t[n]!==e[n])return!0}function _c(t){return!1===["class","style"].includes(t)}function bc(t){return!1===["lang","dir"].includes(t)}function wc(t,e){!0!==t._inactive&&(!0===Mc(t)&&(mo(!0,e,t.__qMeta),!0===t.$options.meta.stopPropagation)||t.$children.forEach((function(t){wc(t,e)})))}function kc(){!0===sc&&(sc=!1,this.$root.__currentMeta=window.__Q_META__);var t={title:"",titleTemplate:null,meta:{},link:{},script:{},htmlAttr:{},bodyAttr:{}};wc(this.$root,t),gc(t),function(t){var e=t.add,n=t.remove;e.title&&(document.title=e.title),Object.keys(n).length>0&&(["meta","link","script"].forEach((function(t){n[t].forEach((function(e){document.head.querySelector(t+'[data-qmeta="'+e+'"]').remove()}))})),n.htmlAttr.filter(bc).forEach((function(t){document.documentElement.removeAttribute(t)})),n.bodyAttr.filter(_c).forEach((function(t){document.body.removeAttribute(t)}))),["meta","link","script"].forEach((function(t){var n=e[t];for(var i in n){var r=document.createElement(t);for(var o in n[i])"innerHTML"!==o&&r.setAttribute(o,n[i][o]);r.setAttribute("data-qmeta",i),"script"===t&&(r.innerHTML=n[i].innerHTML||""),document.head.appendChild(r)}})),Object.keys(e.htmlAttr).filter(bc).forEach((function(t){document.documentElement.setAttribute(t,e.htmlAttr[t]||"")})),Object.keys(e.bodyAttr).filter(_c).forEach((function(t){document.body.setAttribute(t,e.bodyAttr[t]||"")}))}(function(t,e){var n={},i={};return void 0===t?{add:e,remove:i}:(t.title!==e.title&&(n.title=e.title),["meta","link","script","htmlAttr","bodyAttr"].forEach((function(r){var o=t[r],a=e[r];if(i[r]=[],null!=o){for(var s in n[r]={},o)!1===a.hasOwnProperty(s)&&i[r].push(s);for(var l in a)!1===o.hasOwnProperty(l)?n[r][l]=a[l]:!0===yc(o[l],a[l])&&(i[r].push(l),n[r][l]=a[l])}else n[r]=a})),{add:n,remove:i})}(this.$root.__currentMeta,t)),this.$root.__currentMeta=t}function xc(t){return function(e){var n=t[e];return e+(void 0!==n?'="'+n+'"':"")}}function Cc(t){var e="";return t.title&&(e+="<title>"+t.title+"</title>"),["meta","link","script"].forEach((function(n){var i=t[n];for(var r in i){var o=Object.keys(i[r]).filter((function(t){return"innerHTML"!==t})).map(xc(i[r]));e+="<"+n+" "+o.join(" ")+' data-qmeta="'+r+'">',"script"===n&&(e+=(i[r].innerHTML||"")+"<\/script>")}})),e}function Sc(){"function"==typeof this.$options.meta?(void 0===this.$options.computed&&(this.$options.computed={}),this.$options.computed.__qMeta=this.$options.meta):!0===Mc(this)&&(this.__qMeta=this.$options.meta)}function Mc(t){return void 0!==t.$options.meta&&null!==t.$options.meta}function Tc(){!0===Mc(this)&&this.__qMetaUpdate()}!1===i&&t.util.defineReactive(vc,"isActive",vc.isActive);var Pc={install:function(e){var n=e.queues;!0===i?(t.prototype.$getMetaHTML=function(t){return function(e,n){return function(t,e,n){var i={title:"",titleTemplate:null,meta:{},link:{},htmlAttr:{},bodyAttr:{},noscript:{}};wc(t,i),gc(i);var r=void 0!==n&&void 0!==n.nonce?' nonce="'+n.nonce+'"':"",o={"%%Q_HTML_ATTRS%%":Object.keys(i.htmlAttr).filter(bc).map(xc(i.htmlAttr)).join(" "),"%%Q_HEAD_TAGS%%":Cc(i),"%%Q_BODY_ATTRS%%":Object.keys(i.bodyAttr).filter(_c).map(xc(i.bodyAttr)).join(" "),"%%Q_BODY_TAGS%%":Object.keys(i.noscript).map((function(t){return'<noscript data-qmeta="'+t+'">'+i.noscript[t]+"</noscript>"})).join("")+"<script"+r+">window.__Q_META__="+(delete i.noscript&&JSON.stringify(i))+"<\/script>"};return Object.keys(o).forEach((function(t){e=e.replace(t,o[t])})),e}(t,e,n)}},t.mixin({beforeCreate:Sc}),n.server.push((function(t,e){e.ssr.Q_HTML_ATTRS+=" %%Q_HTML_ATTRS%%",Object.assign(e.ssr,{Q_HEAD_TAGS:"%%Q_HEAD_TAGS%%",Q_BODY_ATTRS:"%%Q_BODY_ATTRS%%",Q_BODY_TAGS:"%%Q_BODY_TAGS%%"})}))):(sc=r,t.mixin({beforeCreate:Sc,created:function(){!0===Mc(this)&&(this.__qMetaUnwatch=this.$watch("__qMeta",this.__qMetaUpdate))},activated:Tc,deactivated:Tc,beforeMount:Tc,destroyed:function(){!0===Mc(this)&&(this.__qMetaUnwatch(),this.__qMetaUpdate())},methods:{__qMetaUpdate:function(){clearTimeout(ac),ac=setTimeout(kc.bind(this),50)}}}))}};var Oc=0,Bc={},Ec=["top-left","top-right","bottom-left","bottom-right","top","bottom","left","right","center"],Ac=["top-left","top-right","bottom-left","bottom-right"],Dc={positive:{icon:function(){return this.$q.iconSet.type.positive},color:"positive"},negative:{icon:function(){return this.$q.iconSet.type.negative},color:"negative"},warning:{icon:function(){return this.$q.iconSet.type.warning},color:"warning",textColor:"dark"},info:{icon:function(){return this.$q.iconSet.type.info},color:"info"}},Lc={},qc={},Rc={name:"QNotifications",created:function(){var t=this;this.notifs={},Ec.forEach((function(e){t.notifs[e]=[];var n=!0===["left","center","right"].includes(e)?"center":e.indexOf("top")>-1?"top":"bottom",i=e.indexOf("left")>-1?"start":e.indexOf("right")>-1?"end":"center",r=["left","right"].includes(e)?"items-"+("left"===e?"start":"end")+" justify-center":"center"===e?"flex-center":"items-"+i;qc[e]="q-notifications__list q-notifications__list--"+n+" fixed column no-wrap "+r}))},methods:{add:function(t){var e=this;if(!t)return console.error("Notify: parameter required"),!1;var n={textColor:"white"};if("string"!=typeof t&&!0===t.ignoreDefaults||Object.assign(n,Bc),Object(t)===t?(Object.assign(n,Dc[t.type],t),"function"==typeof n.icon&&(n.icon=n.icon.call(this))):n.message=t,n.meta={hasMedia:Boolean(n.icon||n.avatar)},n.position){if(!1===Ec.includes(n.position))return console.error("Notify: wrong position: "+n.position),!1}else n.position="bottom";if(void 0===n.timeout)n.timeout=5e3;else{var i=parseInt(n.timeout,10);if(isNaN(i)||i<0)return console.error("Notify: wrong timeout: "+n.timeout),!1;n.timeout=i}0===n.timeout?n.progress=!1:!0===n.progress&&(n.meta.progressStyle={animationDuration:n.timeout+1e3+"ms"});var r=(!0===Array.isArray(t.actions)?t.actions:[]).concat(!0!==t.ignoreDefaults&&!0===Array.isArray(Bc.actions)?Bc.actions:[]).concat(void 0!==Dc[t.type]&&!0===Array.isArray(Dc[t.type].actions)?Dc[t.type].actions:[]);n.closeBtn&&r.push({label:"string"==typeof n.closeBtn?n.closeBtn:this.$q.lang.label.close}),n.actions=r.map((function(t){var e=t.handler,i=t.noDismiss,r=t.attrs,o=function(t,e){var n={};for(var i in t)Object.prototype.hasOwnProperty.call(t,i)&&-1===e.indexOf(i)&&(n[i]=t[i]);return n}(t,["handler","noDismiss","attrs"]);return{props:Object.assign({},{flat:!0},o),attrs:r,on:{click:"function"==typeof e?function(){e(),!0!==i&&n.meta.close()}:function(){n.meta.close()}}}})),void 0===n.multiLine&&(n.multiLine=n.actions.length>1),Object.assign(n.meta,{staticClass:"q-notification row items-stretch q-notification--"+(!0===n.multiLine?"multi-line":"standard")+(void 0!==n.color?" bg-"+n.color:"")+(void 0!==n.textColor?" text-"+n.textColor:"")+(void 0!==n.classes?" "+n.classes:""),wrapperClass:"q-notification__wrapper col relative-position border-radius-inherit "+(!0===n.multiLine?"column no-wrap justify-center":"row items-center"),contentClass:"q-notification__content row items-center"+(!0===n.multiLine?"":" col"),attrs:Object.assign({},{role:"alert"},n.attrs)}),!1===n.group?n.group=void 0:(void 0!==n.group&&!0!==n.group||(n.group=[n.message,n.caption,n.multiline].concat(n.actions.map((function(t){return t.props.label+"*"+t.props.icon}))).join("|")),n.group+="|"+n.position),0===n.actions.length?n.actions=void 0:n.meta.actionsClass="q-notification__actions row items-center "+(!0===n.multiLine?"justify-end":"col-auto")+(!0===n.meta.hasMedia?" q-notification__actions--with-media":"");var o=Lc[n.group];if(void 0===o){if(n.meta.uid=Oc++,n.meta.badge=1,-1!==["left","right","center"].indexOf(n.position))this.notifs[n.position].splice(Math.floor(this.notifs[n.position].length/2),0,n);else{var a=n.position.indexOf("top")>-1?"unshift":"push";this.notifs[n.position][a](n)}void 0!==n.group&&(Lc[n.group]=n)}else{void 0!==o.meta.timer&&clearTimeout(o.meta.timer);var s=Lc[n.group];if(void 0!==n.badgePosition){if(!1===Ac.includes(n.badgePosition))return console.error("Notify - wrong badgePosition specified: "+n.badgePosition),!1}else n.badgePosition="top-"+(n.position.indexOf("left")>-1?"right":"left");n.meta.uid=s.meta.uid,n.meta.badge=s.meta.badge+1,n.meta.badgeStaticClass="q-notification__badge q-notification__badge--"+n.badgePosition+(void 0!==n.badgeColor?" bg-"+n.badgeColor:"")+(void 0!==n.badgeTextColor?" text-"+n.badgeTextColor:"");var l=this.notifs[n.position].indexOf(s);this.notifs[n.position][l]=Lc[n.group]=n}return n.meta.close=function(){e.remove(n)},this.$forceUpdate(),n.timeout>0&&(n.meta.timer=setTimeout((function(){n.meta.close()}),n.timeout+1e3)),n.meta.close},remove:function(t){clearTimeout(t.meta.timer);var e=this.notifs[t.position].indexOf(t);if(-1!==e){void 0!==t.group&&delete Lc[t.group];var n=this.$refs["notif_"+t.meta.uid];if(n){var i=getComputedStyle(n),r=i.width,o=i.height;n.style.left=n.offsetLeft+"px",n.style.width=r,n.style.height=o}this.notifs[t.position].splice(e,1),this.$forceUpdate(),"function"==typeof t.onDismiss&&t.onDismiss()}}},render:function(t){var e=this;return t("div",{staticClass:"q-notifications"},Ec.map((function(n){return t("transition-group",{key:n,staticClass:qc[n],tag:"div",props:{name:"q-notification--"+n,mode:"out-in"}},e.notifs[n].map((function(e){var n,i=e.meta,r={staticClass:"q-notification__message col"};if(!0===e.html)r.domProps={innerHTML:e.caption?"<div>"+e.message+'</div><div class="q-notification__caption">'+e.caption+"</div>":e.message};else{var o=[e.message];n=e.caption?[t("div",o),t("div",{staticClass:"q-notification__caption"},[e.caption])]:o}var a=[];!0===i.hasMedia&&(e.icon?a.push(t(Lt,{staticClass:"q-notification__icon",attrs:{role:"img"},props:{name:e.icon}})):e.avatar&&a.push(t(qt,{staticClass:"q-notification__avatar col-auto"},[t("img",{attrs:{src:e.avatar,"aria-hidden":"true"}})]))),a.push(t("div",r,n));var s=[t("div",{staticClass:i.contentClass},a)];return!0===e.progress&&s.push(t("div",{key:i.uid+"|p|"+i.badge,staticClass:"q-notification__progress",style:i.progressStyle,class:e.progressClass})),void 0!==e.actions&&s.push(t("div",{staticClass:i.actionsClass},e.actions.map((function(e){return t(_e,{props:e.props,attrs:e.attrs,on:e.on})})))),i.badge>1&&s.push(t("div",{key:i.uid+"|"+i.badge,staticClass:i.badgeStaticClass,style:e.badgeStyle,class:e.badgeClass},[i.badge])),t("div",{ref:"notif_"+i.uid,key:i.uid,staticClass:i.staticClass,attrs:i.attrs},[t("div",{staticClass:i.wrapperClass},s)])})))})))},mounted:function(){var t=this;if(void 0!==this.$q.fullscreen&&!0===this.$q.fullscreen.isCapable){var e=function(e){var n=Xt(e,t.$q.fullscreen.activeEl);t.$el.parentElement!==n&&n.appendChild(t.$el)};this.unwatchFullscreen=this.$watch("$q.fullscreen.isActive",e),!0===this.$q.fullscreen.isActive&&e(!0)}},beforeDestroy:function(){void 0!==this.unwatchFullscreen&&this.unwatchFullscreen()}},Ic={create:function(t){return!0===i?m:this.__vm.add(t)},setDefaults:function(t){t===Object(t)&&Object.assign(Bc,t)},registerType:function(t,e){!0!==i&&e===Object(e)&&(Dc[t]=e)},install:function(e){var n=e.cfg,r=e.$q;if(!0===i)return r.notify=m,void(r.notify.setDefaults=m);this.setDefaults(n.notify),r.notify=this.create.bind(this),r.notify.setDefaults=this.setDefaults,r.notify.registerType=this.registerType;var o=document.createElement("div");document.body.appendChild(o),this.__vm=new t(Rc),this.__vm.$mount(o)}};function Nc(){return{has:m,getLength:m,getItem:m,getIndex:m,getAll:m,set:m,remove:m,clear:m,isEmpty:m}}function Fc(t){var e=window[t+"Storage"],n=function(t){var n=e.getItem(t);return n?function(t){if(t.length<9)return t;var e=t.substr(0,8),n=t.substring(9);switch(e){case"__q_date":return new Date(n);case"__q_expr":return new RegExp(n);case"__q_numb":return Number(n);case"__q_bool":return Boolean("1"===n);case"__q_strn":return""+n;case"__q_objt":return JSON.parse(n);default:return t}}(n):null};return{has:function(t){return null!==e.getItem(t)},getLength:function(){return e.length},getItem:n,getIndex:function(t){return t<e.length?n(e.key(t)):null},getKey:function(t){return t<e.length?e.key(t):null},getAll:function(){for(var t,i={},r=e.length,o=0;o<r;o++)i[t=e.key(o)]=n(t);return i},getAllKeys:function(){for(var t=[],n=e.length,i=0;i<n;i++)t.push(e.key(i));return t},set:function(t,n){e.setItem(t,function(t){return"[object Date]"===Object.prototype.toString.call(t)?"__q_date|"+t.toUTCString():"[object RegExp]"===Object.prototype.toString.call(t)?"__q_expr|"+t.source:"number"==typeof t?"__q_numb|"+t:"boolean"==typeof t?"__q_bool|"+(t?"1":"0"):"string"==typeof t?"__q_strn|"+t:"function"==typeof t?"__q_strn|"+t.toString():t===Object(t)?"__q_objt|"+JSON.stringify(t):t}(n))},remove:function(t){e.removeItem(t)},clear:function(){e.clear()},isEmpty:function(){return 0===e.length}}}var $c={install:function(t){var e=t.$q,n=!0===i||!1===d.has.webStorage?Nc():Fc("local");e.localStorage=n,Object.assign(this,n)}},jc={install:function(t){var e=t.$q,n=!0===i||!1===d.has.webStorage?Nc():Fc("session");e.sessionStorage=n,Object.assign(this,n)}},zc=Object.freeze({__proto__:null,AddressbarColor:zl,AppFullscreen:Wl,AppVisibility:Ul,BottomSheet:Kl,Cookies:lc,Dark:E,Dialog:uc,LoadingBar:dc,Loading:vc,Meta:Pc,Notify:Ic,Platform:h,Screen:B,LocalStorage:$c,SessionStorage:jc});function Vc(t){setTimeout((function(){window.URL.revokeObjectURL(t.href)}),1e4),t.remove()}function Hc(e,n,i){var r=window.open;if(!0===h.is.cordova){if(void 0!==cordova&&void 0!==cordova.InAppBrowser&&void 0!==cordova.InAppBrowser.open)r=cordova.InAppBrowser.open;else if(void 0!==navigator&&void 0!==navigator.app)return navigator.app.loadUrl(e,{openExternal:!0})}else if(void 0!==t.prototype.$q.electron)return t.prototype.$q.electron.shell.openExternal(e);var o,a,s,l=r(e,"_blank",(o=i,a=Object.assign({noopener:!0},o),s=[],Object.keys(a).forEach((function(t){!0===a[t]&&s.push(t)})),s.join(",")));if(l)return h.is.desktop&&l.focus(),l;n&&n()}var Wc=Object.freeze({__proto__:null,clone:da,colors:G,copyToClipboard:function(t){return void 0!==navigator.clipboard?navigator.clipboard.writeText(t):new Promise((function(e,n){var i=function(t){var e=document.createElement("textarea");e.value=t,e.contentEditable=!0,e.style.position="fixed",document.body.appendChild(e),e.focus(),e.select();var n=document.execCommand("copy");return e.remove(),n}(t);i?e(!0):n(i)}))},date:er,debounce:T,dom:te,event:M,exportFile:function(t,e,n){var i=new Blob([e],{type:n||"text/plain"});if(window.navigator.msSaveOrOpenBlob)return window.navigator.msSaveOrOpenBlob(i,t);var r=document.createElement("a");r.download=t,r.href=window.URL.createObjectURL(i),r.classList.add("hidden"),r.style.position="fixed",document.body.appendChild(r);try{return r.click(),Vc(r),!0}catch(t){return Vc(r),t}},extend:mo,format:ft,frameDebounce:la,noop:m,openURL:function(t,e,n){if(!0!==h.is.ios||void 0===window.SafariViewController)return Hc(t,e,n);window.SafariViewController.isAvailable((function(i){i?window.SafariViewController.show({url:t},m,e):Hc(t,e,n)}))},morph:hl,patterns:Wn,scroll:Je,throttle:ee,uid:Er});return t.use({install:function(t,e){if(void 0===e&&(e={}),!0!==this.__qInstalled){this.__qInstalled=!0;var n=at.config=Object.freeze(e.config||{});if(h.install(at,ot),et(ot,n),E.install(at,ot,n),B.install(at,ot,n),q.install(n),N.install(at,ot,e.lang),it.install(at,ot,e.iconSet),!0===i?t.mixin({beforeCreate:function(){this.$q=this.$root.$options.$q}}):t.prototype.$q=at,e.components&&Object.keys(e.components).forEach((function(n){var i=e.components[n];"function"==typeof i&&t.component(i.options.name,i)})),e.directives&&Object.keys(e.directives).forEach((function(n){var i=e.directives[n];void 0!==i.name&&void 0!==i.unbind&&t.directive(i.name,i)})),e.plugins){var r={$q:at,queues:ot,cfg:n};Object.keys(e.plugins).forEach((function(t){var n=e.plugins[t];"function"==typeof n.install&&!1===rt.includes(n)&&n.install(r)}))}}}},{components:Js,directives:$l,plugins:zc,config:window.quasarConfig||{}}),Object.assign({},{version:n,lang:N,iconSet:it,components:Js,directives:$l,plugins:zc,utils:Wc},Js,$l,zc,Wc)})),
/*!
 * Chart.js v2.9.4
 * https://www.chartjs.org
 * (c) 2020 Chart.js Contributors
 * Released under the MIT License
 */
function(t,e){"object"==typeof exports&&"undefined"!=typeof module?module.exports=e():"function"==typeof define&&define.amd?define(e):(t=t||self).Chart=e()}(this,(function(){"use strict";"undefined"!=typeof globalThis?globalThis:"undefined"!=typeof window?window:"undefined"!=typeof global?global:"undefined"!=typeof self&&self;function t(){throw new Error("Dynamic requires are not currently supported by rollup-plugin-commonjs")}function e(t,e){return t(e={exports:{}},e.exports),e.exports}var n={aliceblue:[240,248,255],antiquewhite:[250,235,215],aqua:[0,255,255],aquamarine:[127,255,212],azure:[240,255,255],beige:[245,245,220],bisque:[255,228,196],black:[0,0,0],blanchedalmond:[255,235,205],blue:[0,0,255],blueviolet:[138,43,226],brown:[165,42,42],burlywood:[222,184,135],cadetblue:[95,158,160],chartreuse:[127,255,0],chocolate:[210,105,30],coral:[255,127,80],cornflowerblue:[100,149,237],cornsilk:[255,248,220],crimson:[220,20,60],cyan:[0,255,255],darkblue:[0,0,139],darkcyan:[0,139,139],darkgoldenrod:[184,134,11],darkgray:[169,169,169],darkgreen:[0,100,0],darkgrey:[169,169,169],darkkhaki:[189,183,107],darkmagenta:[139,0,139],darkolivegreen:[85,107,47],darkorange:[255,140,0],darkorchid:[153,50,204],darkred:[139,0,0],darksalmon:[233,150,122],darkseagreen:[143,188,143],darkslateblue:[72,61,139],darkslategray:[47,79,79],darkslategrey:[47,79,79],darkturquoise:[0,206,209],darkviolet:[148,0,211],deeppink:[255,20,147],deepskyblue:[0,191,255],dimgray:[105,105,105],dimgrey:[105,105,105],dodgerblue:[30,144,255],firebrick:[178,34,34],floralwhite:[255,250,240],forestgreen:[34,139,34],fuchsia:[255,0,255],gainsboro:[220,220,220],ghostwhite:[248,248,255],gold:[255,215,0],goldenrod:[218,165,32],gray:[128,128,128],green:[0,128,0],greenyellow:[173,255,47],grey:[128,128,128],honeydew:[240,255,240],hotpink:[255,105,180],indianred:[205,92,92],indigo:[75,0,130],ivory:[255,255,240],khaki:[240,230,140],lavender:[230,230,250],lavenderblush:[255,240,245],lawngreen:[124,252,0],lemonchiffon:[255,250,205],lightblue:[173,216,230],lightcoral:[240,128,128],lightcyan:[224,255,255],lightgoldenrodyellow:[250,250,210],lightgray:[211,211,211],lightgreen:[144,238,144],lightgrey:[211,211,211],lightpink:[255,182,193],lightsalmon:[255,160,122],lightseagreen:[32,178,170],lightskyblue:[135,206,250],lightslategray:[119,136,153],lightslategrey:[119,136,153],lightsteelblue:[176,196,222],lightyellow:[255,255,224],lime:[0,255,0],limegreen:[50,205,50],linen:[250,240,230],magenta:[255,0,255],maroon:[128,0,0],mediumaquamarine:[102,205,170],mediumblue:[0,0,205],mediumorchid:[186,85,211],mediumpurple:[147,112,219],mediumseagreen:[60,179,113],mediumslateblue:[123,104,238],mediumspringgreen:[0,250,154],mediumturquoise:[72,209,204],mediumvioletred:[199,21,133],midnightblue:[25,25,112],mintcream:[245,255,250],mistyrose:[255,228,225],moccasin:[255,228,181],navajowhite:[255,222,173],navy:[0,0,128],oldlace:[253,245,230],olive:[128,128,0],olivedrab:[107,142,35],orange:[255,165,0],orangered:[255,69,0],orchid:[218,112,214],palegoldenrod:[238,232,170],palegreen:[152,251,152],paleturquoise:[175,238,238],palevioletred:[219,112,147],papayawhip:[255,239,213],peachpuff:[255,218,185],peru:[205,133,63],pink:[255,192,203],plum:[221,160,221],powderblue:[176,224,230],purple:[128,0,128],rebeccapurple:[102,51,153],red:[255,0,0],rosybrown:[188,143,143],royalblue:[65,105,225],saddlebrown:[139,69,19],salmon:[250,128,114],sandybrown:[244,164,96],seagreen:[46,139,87],seashell:[255,245,238],sienna:[160,82,45],silver:[192,192,192],skyblue:[135,206,235],slateblue:[106,90,205],slategray:[112,128,144],slategrey:[112,128,144],snow:[255,250,250],springgreen:[0,255,127],steelblue:[70,130,180],tan:[210,180,140],teal:[0,128,128],thistle:[216,191,216],tomato:[255,99,71],turquoise:[64,224,208],violet:[238,130,238],wheat:[245,222,179],white:[255,255,255],whitesmoke:[245,245,245],yellow:[255,255,0],yellowgreen:[154,205,50]},i=e((function(t){var e={};for(var i in n)n.hasOwnProperty(i)&&(e[n[i]]=i);var r=t.exports={rgb:{channels:3,labels:"rgb"},hsl:{channels:3,labels:"hsl"},hsv:{channels:3,labels:"hsv"},hwb:{channels:3,labels:"hwb"},cmyk:{channels:4,labels:"cmyk"},xyz:{channels:3,labels:"xyz"},lab:{channels:3,labels:"lab"},lch:{channels:3,labels:"lch"},hex:{channels:1,labels:["hex"]},keyword:{channels:1,labels:["keyword"]},ansi16:{channels:1,labels:["ansi16"]},ansi256:{channels:1,labels:["ansi256"]},hcg:{channels:3,labels:["h","c","g"]},apple:{channels:3,labels:["r16","g16","b16"]},gray:{channels:1,labels:["gray"]}};for(var o in r)if(r.hasOwnProperty(o)){if(!("channels"in r[o]))throw new Error("missing channels property: "+o);if(!("labels"in r[o]))throw new Error("missing channel labels property: "+o);if(r[o].labels.length!==r[o].channels)throw new Error("channel and label counts mismatch: "+o);var a=r[o].channels,s=r[o].labels;delete r[o].channels,delete r[o].labels,Object.defineProperty(r[o],"channels",{value:a}),Object.defineProperty(r[o],"labels",{value:s})}r.rgb.hsl=function(t){var e,n,i=t[0]/255,r=t[1]/255,o=t[2]/255,a=Math.min(i,r,o),s=Math.max(i,r,o),l=s-a;return s===a?e=0:i===s?e=(r-o)/l:r===s?e=2+(o-i)/l:o===s&&(e=4+(i-r)/l),(e=Math.min(60*e,360))<0&&(e+=360),n=(a+s)/2,[e,100*(s===a?0:n<=.5?l/(s+a):l/(2-s-a)),100*n]},r.rgb.hsv=function(t){var e,n,i,r,o,a=t[0]/255,s=t[1]/255,l=t[2]/255,c=Math.max(a,s,l),u=c-Math.min(a,s,l),d=function(t){return(c-t)/6/u+.5};return 0===u?r=o=0:(o=u/c,e=d(a),n=d(s),i=d(l),a===c?r=i-n:s===c?r=1/3+e-i:l===c&&(r=2/3+n-e),r<0?r+=1:r>1&&(r-=1)),[360*r,100*o,100*c]},r.rgb.hwb=function(t){var e=t[0],n=t[1],i=t[2];return[r.rgb.hsl(t)[0],100*(1/255*Math.min(e,Math.min(n,i))),100*(i=1-1/255*Math.max(e,Math.max(n,i)))]},r.rgb.cmyk=function(t){var e,n=t[0]/255,i=t[1]/255,r=t[2]/255;return[100*((1-n-(e=Math.min(1-n,1-i,1-r)))/(1-e)||0),100*((1-i-e)/(1-e)||0),100*((1-r-e)/(1-e)||0),100*e]},r.rgb.keyword=function(t){var i=e[t];if(i)return i;var r,o,a,s=1/0;for(var l in n)if(n.hasOwnProperty(l)){var c=n[l],u=(o=t,a=c,Math.pow(o[0]-a[0],2)+Math.pow(o[1]-a[1],2)+Math.pow(o[2]-a[2],2));u<s&&(s=u,r=l)}return r},r.keyword.rgb=function(t){return n[t]},r.rgb.xyz=function(t){var e=t[0]/255,n=t[1]/255,i=t[2]/255;return[100*(.4124*(e=e>.04045?Math.pow((e+.055)/1.055,2.4):e/12.92)+.3576*(n=n>.04045?Math.pow((n+.055)/1.055,2.4):n/12.92)+.1805*(i=i>.04045?Math.pow((i+.055)/1.055,2.4):i/12.92)),100*(.2126*e+.7152*n+.0722*i),100*(.0193*e+.1192*n+.9505*i)]},r.rgb.lab=function(t){var e=r.rgb.xyz(t),n=e[0],i=e[1],o=e[2];return i/=100,o/=108.883,n=(n/=95.047)>.008856?Math.pow(n,1/3):7.787*n+16/116,[116*(i=i>.008856?Math.pow(i,1/3):7.787*i+16/116)-16,500*(n-i),200*(i-(o=o>.008856?Math.pow(o,1/3):7.787*o+16/116))]},r.hsl.rgb=function(t){var e,n,i,r,o,a=t[0]/360,s=t[1]/100,l=t[2]/100;if(0===s)return[o=255*l,o,o];e=2*l-(n=l<.5?l*(1+s):l+s-l*s),r=[0,0,0];for(var c=0;c<3;c++)(i=a+1/3*-(c-1))<0&&i++,i>1&&i--,o=6*i<1?e+6*(n-e)*i:2*i<1?n:3*i<2?e+(n-e)*(2/3-i)*6:e,r[c]=255*o;return r},r.hsl.hsv=function(t){var e=t[0],n=t[1]/100,i=t[2]/100,r=n,o=Math.max(i,.01);return n*=(i*=2)<=1?i:2-i,r*=o<=1?o:2-o,[e,100*(0===i?2*r/(o+r):2*n/(i+n)),100*((i+n)/2)]},r.hsv.rgb=function(t){var e=t[0]/60,n=t[1]/100,i=t[2]/100,r=Math.floor(e)%6,o=e-Math.floor(e),a=255*i*(1-n),s=255*i*(1-n*o),l=255*i*(1-n*(1-o));switch(i*=255,r){case 0:return[i,l,a];case 1:return[s,i,a];case 2:return[a,i,l];case 3:return[a,s,i];case 4:return[l,a,i];case 5:return[i,a,s]}},r.hsv.hsl=function(t){var e,n,i,r=t[0],o=t[1]/100,a=t[2]/100,s=Math.max(a,.01);return i=(2-o)*a,n=o*s,[r,100*(n=(n/=(e=(2-o)*s)<=1?e:2-e)||0),100*(i/=2)]},r.hwb.rgb=function(t){var e,n,i,r,o,a,s,l=t[0]/360,c=t[1]/100,u=t[2]/100,d=c+u;switch(d>1&&(c/=d,u/=d),i=6*l-(e=Math.floor(6*l)),0!=(1&e)&&(i=1-i),r=c+i*((n=1-u)-c),e){default:case 6:case 0:o=n,a=r,s=c;break;case 1:o=r,a=n,s=c;break;case 2:o=c,a=n,s=r;break;case 3:o=c,a=r,s=n;break;case 4:o=r,a=c,s=n;break;case 5:o=n,a=c,s=r}return[255*o,255*a,255*s]},r.cmyk.rgb=function(t){var e=t[0]/100,n=t[1]/100,i=t[2]/100,r=t[3]/100;return[255*(1-Math.min(1,e*(1-r)+r)),255*(1-Math.min(1,n*(1-r)+r)),255*(1-Math.min(1,i*(1-r)+r))]},r.xyz.rgb=function(t){var e,n,i,r=t[0]/100,o=t[1]/100,a=t[2]/100;return n=-.9689*r+1.8758*o+.0415*a,i=.0557*r+-.204*o+1.057*a,e=(e=3.2406*r+-1.5372*o+-.4986*a)>.0031308?1.055*Math.pow(e,1/2.4)-.055:12.92*e,n=n>.0031308?1.055*Math.pow(n,1/2.4)-.055:12.92*n,i=i>.0031308?1.055*Math.pow(i,1/2.4)-.055:12.92*i,[255*(e=Math.min(Math.max(0,e),1)),255*(n=Math.min(Math.max(0,n),1)),255*(i=Math.min(Math.max(0,i),1))]},r.xyz.lab=function(t){var e=t[0],n=t[1],i=t[2];return n/=100,i/=108.883,e=(e/=95.047)>.008856?Math.pow(e,1/3):7.787*e+16/116,[116*(n=n>.008856?Math.pow(n,1/3):7.787*n+16/116)-16,500*(e-n),200*(n-(i=i>.008856?Math.pow(i,1/3):7.787*i+16/116))]},r.lab.xyz=function(t){var e,n,i,r=t[0];e=t[1]/500+(n=(r+16)/116),i=n-t[2]/200;var o=Math.pow(n,3),a=Math.pow(e,3),s=Math.pow(i,3);return n=o>.008856?o:(n-16/116)/7.787,e=a>.008856?a:(e-16/116)/7.787,i=s>.008856?s:(i-16/116)/7.787,[e*=95.047,n*=100,i*=108.883]},r.lab.lch=function(t){var e,n=t[0],i=t[1],r=t[2];return(e=360*Math.atan2(r,i)/2/Math.PI)<0&&(e+=360),[n,Math.sqrt(i*i+r*r),e]},r.lch.lab=function(t){var e,n=t[0],i=t[1];return e=t[2]/360*2*Math.PI,[n,i*Math.cos(e),i*Math.sin(e)]},r.rgb.ansi16=function(t){var e=t[0],n=t[1],i=t[2],o=1 in arguments?arguments[1]:r.rgb.hsv(t)[2];if(0===(o=Math.round(o/50)))return 30;var a=30+(Math.round(i/255)<<2|Math.round(n/255)<<1|Math.round(e/255));return 2===o&&(a+=60),a},r.hsv.ansi16=function(t){return r.rgb.ansi16(r.hsv.rgb(t),t[2])},r.rgb.ansi256=function(t){var e=t[0],n=t[1],i=t[2];return e===n&&n===i?e<8?16:e>248?231:Math.round((e-8)/247*24)+232:16+36*Math.round(e/255*5)+6*Math.round(n/255*5)+Math.round(i/255*5)},r.ansi16.rgb=function(t){var e=t%10;if(0===e||7===e)return t>50&&(e+=3.5),[e=e/10.5*255,e,e];var n=.5*(1+~~(t>50));return[(1&e)*n*255,(e>>1&1)*n*255,(e>>2&1)*n*255]},r.ansi256.rgb=function(t){if(t>=232){var e=10*(t-232)+8;return[e,e,e]}var n;return t-=16,[Math.floor(t/36)/5*255,Math.floor((n=t%36)/6)/5*255,n%6/5*255]},r.rgb.hex=function(t){var e=(((255&Math.round(t[0]))<<16)+((255&Math.round(t[1]))<<8)+(255&Math.round(t[2]))).toString(16).toUpperCase();return"000000".substring(e.length)+e},r.hex.rgb=function(t){var e=t.toString(16).match(/[a-f0-9]{6}|[a-f0-9]{3}/i);if(!e)return[0,0,0];var n=e[0];3===e[0].length&&(n=n.split("").map((function(t){return t+t})).join(""));var i=parseInt(n,16);return[i>>16&255,i>>8&255,255&i]},r.rgb.hcg=function(t){var e,n=t[0]/255,i=t[1]/255,r=t[2]/255,o=Math.max(Math.max(n,i),r),a=Math.min(Math.min(n,i),r),s=o-a;return e=s<=0?0:o===n?(i-r)/s%6:o===i?2+(r-n)/s:4+(n-i)/s+4,e/=6,[360*(e%=1),100*s,100*(s<1?a/(1-s):0)]},r.hsl.hcg=function(t){var e=t[1]/100,n=t[2]/100,i=1,r=0;return(i=n<.5?2*e*n:2*e*(1-n))<1&&(r=(n-.5*i)/(1-i)),[t[0],100*i,100*r]},r.hsv.hcg=function(t){var e=t[1]/100,n=t[2]/100,i=e*n,r=0;return i<1&&(r=(n-i)/(1-i)),[t[0],100*i,100*r]},r.hcg.rgb=function(t){var e=t[0]/360,n=t[1]/100,i=t[2]/100;if(0===n)return[255*i,255*i,255*i];var r,o=[0,0,0],a=e%1*6,s=a%1,l=1-s;switch(Math.floor(a)){case 0:o[0]=1,o[1]=s,o[2]=0;break;case 1:o[0]=l,o[1]=1,o[2]=0;break;case 2:o[0]=0,o[1]=1,o[2]=s;break;case 3:o[0]=0,o[1]=l,o[2]=1;break;case 4:o[0]=s,o[1]=0,o[2]=1;break;default:o[0]=1,o[1]=0,o[2]=l}return r=(1-n)*i,[255*(n*o[0]+r),255*(n*o[1]+r),255*(n*o[2]+r)]},r.hcg.hsv=function(t){var e=t[1]/100,n=e+t[2]/100*(1-e),i=0;return n>0&&(i=e/n),[t[0],100*i,100*n]},r.hcg.hsl=function(t){var e=t[1]/100,n=t[2]/100*(1-e)+.5*e,i=0;return n>0&&n<.5?i=e/(2*n):n>=.5&&n<1&&(i=e/(2*(1-n))),[t[0],100*i,100*n]},r.hcg.hwb=function(t){var e=t[1]/100,n=e+t[2]/100*(1-e);return[t[0],100*(n-e),100*(1-n)]},r.hwb.hcg=function(t){var e=t[1]/100,n=1-t[2]/100,i=n-e,r=0;return i<1&&(r=(n-i)/(1-i)),[t[0],100*i,100*r]},r.apple.rgb=function(t){return[t[0]/65535*255,t[1]/65535*255,t[2]/65535*255]},r.rgb.apple=function(t){return[t[0]/255*65535,t[1]/255*65535,t[2]/255*65535]},r.gray.rgb=function(t){return[t[0]/100*255,t[0]/100*255,t[0]/100*255]},r.gray.hsl=r.gray.hsv=function(t){return[0,0,t[0]]},r.gray.hwb=function(t){return[0,100,t[0]]},r.gray.cmyk=function(t){return[0,0,0,t[0]]},r.gray.lab=function(t){return[t[0],0,0]},r.gray.hex=function(t){var e=255&Math.round(t[0]/100*255),n=((e<<16)+(e<<8)+e).toString(16).toUpperCase();return"000000".substring(n.length)+n},r.rgb.gray=function(t){return[(t[0]+t[1]+t[2])/3/255*100]}}));i.rgb,i.hsl,i.hsv,i.hwb,i.cmyk,i.xyz,i.lab,i.lch,i.hex,i.keyword,i.ansi16,i.ansi256,i.hcg,i.apple,i.gray;function r(t){var e=function(){for(var t={},e=Object.keys(i),n=e.length,r=0;r<n;r++)t[e[r]]={distance:-1,parent:null};return t}(),n=[t];for(e[t].distance=0;n.length;)for(var r=n.pop(),o=Object.keys(i[r]),a=o.length,s=0;s<a;s++){var l=o[s],c=e[l];-1===c.distance&&(c.distance=e[r].distance+1,c.parent=r,n.unshift(l))}return e}function o(t,e){return function(n){return e(t(n))}}function a(t,e){for(var n=[e[t].parent,t],r=i[e[t].parent][t],a=e[t].parent;e[a].parent;)n.unshift(e[a].parent),r=o(i[e[a].parent][a],r),a=e[a].parent;return r.conversion=n,r}var s={};Object.keys(i).forEach((function(t){s[t]={},Object.defineProperty(s[t],"channels",{value:i[t].channels}),Object.defineProperty(s[t],"labels",{value:i[t].labels});var e=function(t){for(var e=r(t),n={},i=Object.keys(e),o=i.length,s=0;s<o;s++){var l=i[s];null!==e[l].parent&&(n[l]=a(l,e))}return n}(t);Object.keys(e).forEach((function(n){var i=e[n];s[t][n]=function(t){var e=function(e){if(null==e)return e;arguments.length>1&&(e=Array.prototype.slice.call(arguments));var n=t(e);if("object"==typeof n)for(var i=n.length,r=0;r<i;r++)n[r]=Math.round(n[r]);return n};return"conversion"in t&&(e.conversion=t.conversion),e}(i),s[t][n].raw=function(t){var e=function(e){return null==e?e:(arguments.length>1&&(e=Array.prototype.slice.call(arguments)),t(e))};return"conversion"in t&&(e.conversion=t.conversion),e}(i)}))}));var l=s,c={aliceblue:[240,248,255],antiquewhite:[250,235,215],aqua:[0,255,255],aquamarine:[127,255,212],azure:[240,255,255],beige:[245,245,220],bisque:[255,228,196],black:[0,0,0],blanchedalmond:[255,235,205],blue:[0,0,255],blueviolet:[138,43,226],brown:[165,42,42],burlywood:[222,184,135],cadetblue:[95,158,160],chartreuse:[127,255,0],chocolate:[210,105,30],coral:[255,127,80],cornflowerblue:[100,149,237],cornsilk:[255,248,220],crimson:[220,20,60],cyan:[0,255,255],darkblue:[0,0,139],darkcyan:[0,139,139],darkgoldenrod:[184,134,11],darkgray:[169,169,169],darkgreen:[0,100,0],darkgrey:[169,169,169],darkkhaki:[189,183,107],darkmagenta:[139,0,139],darkolivegreen:[85,107,47],darkorange:[255,140,0],darkorchid:[153,50,204],darkred:[139,0,0],darksalmon:[233,150,122],darkseagreen:[143,188,143],darkslateblue:[72,61,139],darkslategray:[47,79,79],darkslategrey:[47,79,79],darkturquoise:[0,206,209],darkviolet:[148,0,211],deeppink:[255,20,147],deepskyblue:[0,191,255],dimgray:[105,105,105],dimgrey:[105,105,105],dodgerblue:[30,144,255],firebrick:[178,34,34],floralwhite:[255,250,240],forestgreen:[34,139,34],fuchsia:[255,0,255],gainsboro:[220,220,220],ghostwhite:[248,248,255],gold:[255,215,0],goldenrod:[218,165,32],gray:[128,128,128],green:[0,128,0],greenyellow:[173,255,47],grey:[128,128,128],honeydew:[240,255,240],hotpink:[255,105,180],indianred:[205,92,92],indigo:[75,0,130],ivory:[255,255,240],khaki:[240,230,140],lavender:[230,230,250],lavenderblush:[255,240,245],lawngreen:[124,252,0],lemonchiffon:[255,250,205],lightblue:[173,216,230],lightcoral:[240,128,128],lightcyan:[224,255,255],lightgoldenrodyellow:[250,250,210],lightgray:[211,211,211],lightgreen:[144,238,144],lightgrey:[211,211,211],lightpink:[255,182,193],lightsalmon:[255,160,122],lightseagreen:[32,178,170],lightskyblue:[135,206,250],lightslategray:[119,136,153],lightslategrey:[119,136,153],lightsteelblue:[176,196,222],lightyellow:[255,255,224],lime:[0,255,0],limegreen:[50,205,50],linen:[250,240,230],magenta:[255,0,255],maroon:[128,0,0],mediumaquamarine:[102,205,170],mediumblue:[0,0,205],mediumorchid:[186,85,211],mediumpurple:[147,112,219],mediumseagreen:[60,179,113],mediumslateblue:[123,104,238],mediumspringgreen:[0,250,154],mediumturquoise:[72,209,204],mediumvioletred:[199,21,133],midnightblue:[25,25,112],mintcream:[245,255,250],mistyrose:[255,228,225],moccasin:[255,228,181],navajowhite:[255,222,173],navy:[0,0,128],oldlace:[253,245,230],olive:[128,128,0],olivedrab:[107,142,35],orange:[255,165,0],orangered:[255,69,0],orchid:[218,112,214],palegoldenrod:[238,232,170],palegreen:[152,251,152],paleturquoise:[175,238,238],palevioletred:[219,112,147],papayawhip:[255,239,213],peachpuff:[255,218,185],peru:[205,133,63],pink:[255,192,203],plum:[221,160,221],powderblue:[176,224,230],purple:[128,0,128],rebeccapurple:[102,51,153],red:[255,0,0],rosybrown:[188,143,143],royalblue:[65,105,225],saddlebrown:[139,69,19],salmon:[250,128,114],sandybrown:[244,164,96],seagreen:[46,139,87],seashell:[255,245,238],sienna:[160,82,45],silver:[192,192,192],skyblue:[135,206,235],slateblue:[106,90,205],slategray:[112,128,144],slategrey:[112,128,144],snow:[255,250,250],springgreen:[0,255,127],steelblue:[70,130,180],tan:[210,180,140],teal:[0,128,128],thistle:[216,191,216],tomato:[255,99,71],turquoise:[64,224,208],violet:[238,130,238],wheat:[245,222,179],white:[255,255,255],whitesmoke:[245,245,245],yellow:[255,255,0],yellowgreen:[154,205,50]},u={getRgba:d,getHsla:h,getRgb:function(t){var e=d(t);return e&&e.slice(0,3)},getHsl:function(t){var e=h(t);return e&&e.slice(0,3)},getHwb:f,getAlpha:function(t){var e=d(t);if(e)return e[3];if(e=h(t))return e[3];if(e=f(t))return e[3]},hexString:function(t,e){e=void 0!==e&&3===t.length?e:t[3];return"#"+y(t[0])+y(t[1])+y(t[2])+(e>=0&&e<1?y(Math.round(255*e)):"")},rgbString:function(t,e){if(e<1||t[3]&&t[3]<1)return p(t,e);return"rgb("+t[0]+", "+t[1]+", "+t[2]+")"},rgbaString:p,percentString:function(t,e){if(e<1||t[3]&&t[3]<1)return m(t,e);var n=Math.round(t[0]/255*100),i=Math.round(t[1]/255*100),r=Math.round(t[2]/255*100);return"rgb("+n+"%, "+i+"%, "+r+"%)"},percentaString:m,hslString:function(t,e){if(e<1||t[3]&&t[3]<1)return v(t,e);return"hsl("+t[0]+", "+t[1]+"%, "+t[2]+"%)"},hslaString:v,hwbString:function(t,e){void 0===e&&(e=void 0!==t[3]?t[3]:1);return"hwb("+t[0]+", "+t[1]+"%, "+t[2]+"%"+(void 0!==e&&1!==e?", "+e:"")+")"},keyword:function(t){return _[t.slice(0,3)]}};function d(t){if(t){var e=[0,0,0],n=1,i=t.match(/^#([a-fA-F0-9]{3,4})$/i),r="";if(i){r=(i=i[1])[3];for(var o=0;o<e.length;o++)e[o]=parseInt(i[o]+i[o],16);r&&(n=Math.round(parseInt(r+r,16)/255*100)/100)}else if(i=t.match(/^#([a-fA-F0-9]{6}([a-fA-F0-9]{2})?)$/i)){r=i[2],i=i[1];for(o=0;o<e.length;o++)e[o]=parseInt(i.slice(2*o,2*o+2),16);r&&(n=Math.round(parseInt(r,16)/255*100)/100)}else if(i=t.match(/^rgba?\(\s*([+-]?\d+)\s*,\s*([+-]?\d+)\s*,\s*([+-]?\d+)\s*(?:,\s*([+-]?[\d\.]+)\s*)?\)$/i)){for(o=0;o<e.length;o++)e[o]=parseInt(i[o+1]);n=parseFloat(i[4])}else if(i=t.match(/^rgba?\(\s*([+-]?[\d\.]+)\%\s*,\s*([+-]?[\d\.]+)\%\s*,\s*([+-]?[\d\.]+)\%\s*(?:,\s*([+-]?[\d\.]+)\s*)?\)$/i)){for(o=0;o<e.length;o++)e[o]=Math.round(2.55*parseFloat(i[o+1]));n=parseFloat(i[4])}else if(i=t.match(/(\w+)/)){if("transparent"==i[1])return[0,0,0,0];if(!(e=c[i[1]]))return}for(o=0;o<e.length;o++)e[o]=g(e[o],0,255);return n=n||0==n?g(n,0,1):1,e[3]=n,e}}function h(t){if(t){var e=t.match(/^hsla?\(\s*([+-]?\d+)(?:deg)?\s*,\s*([+-]?[\d\.]+)%\s*,\s*([+-]?[\d\.]+)%\s*(?:,\s*([+-]?[\d\.]+)\s*)?\)/);if(e){var n=parseFloat(e[4]);return[g(parseInt(e[1]),0,360),g(parseFloat(e[2]),0,100),g(parseFloat(e[3]),0,100),g(isNaN(n)?1:n,0,1)]}}}function f(t){if(t){var e=t.match(/^hwb\(\s*([+-]?\d+)(?:deg)?\s*,\s*([+-]?[\d\.]+)%\s*,\s*([+-]?[\d\.]+)%\s*(?:,\s*([+-]?[\d\.]+)\s*)?\)/);if(e){var n=parseFloat(e[4]);return[g(parseInt(e[1]),0,360),g(parseFloat(e[2]),0,100),g(parseFloat(e[3]),0,100),g(isNaN(n)?1:n,0,1)]}}}function p(t,e){return void 0===e&&(e=void 0!==t[3]?t[3]:1),"rgba("+t[0]+", "+t[1]+", "+t[2]+", "+e+")"}function m(t,e){return"rgba("+Math.round(t[0]/255*100)+"%, "+Math.round(t[1]/255*100)+"%, "+Math.round(t[2]/255*100)+"%, "+(e||t[3]||1)+")"}function v(t,e){return void 0===e&&(e=void 0!==t[3]?t[3]:1),"hsla("+t[0]+", "+t[1]+"%, "+t[2]+"%, "+e+")"}function g(t,e,n){return Math.min(Math.max(e,t),n)}function y(t){var e=t.toString(16).toUpperCase();return e.length<2?"0"+e:e}var _={};for(var b in c)_[c[b]]=b;var w=function(t){return t instanceof w?t:this instanceof w?(this.valid=!1,this.values={rgb:[0,0,0],hsl:[0,0,0],hsv:[0,0,0],hwb:[0,0,0],cmyk:[0,0,0,0],alpha:1},void("string"==typeof t?(e=u.getRgba(t))?this.setValues("rgb",e):(e=u.getHsla(t))?this.setValues("hsl",e):(e=u.getHwb(t))&&this.setValues("hwb",e):"object"==typeof t&&(void 0!==(e=t).r||void 0!==e.red?this.setValues("rgb",e):void 0!==e.l||void 0!==e.lightness?this.setValues("hsl",e):void 0!==e.v||void 0!==e.value?this.setValues("hsv",e):void 0!==e.w||void 0!==e.whiteness?this.setValues("hwb",e):void 0===e.c&&void 0===e.cyan||this.setValues("cmyk",e)))):new w(t);var e};w.prototype={isValid:function(){return this.valid},rgb:function(){return this.setSpace("rgb",arguments)},hsl:function(){return this.setSpace("hsl",arguments)},hsv:function(){return this.setSpace("hsv",arguments)},hwb:function(){return this.setSpace("hwb",arguments)},cmyk:function(){return this.setSpace("cmyk",arguments)},rgbArray:function(){return this.values.rgb},hslArray:function(){return this.values.hsl},hsvArray:function(){return this.values.hsv},hwbArray:function(){var t=this.values;return 1!==t.alpha?t.hwb.concat([t.alpha]):t.hwb},cmykArray:function(){return this.values.cmyk},rgbaArray:function(){var t=this.values;return t.rgb.concat([t.alpha])},hslaArray:function(){var t=this.values;return t.hsl.concat([t.alpha])},alpha:function(t){return void 0===t?this.values.alpha:(this.setValues("alpha",t),this)},red:function(t){return this.setChannel("rgb",0,t)},green:function(t){return this.setChannel("rgb",1,t)},blue:function(t){return this.setChannel("rgb",2,t)},hue:function(t){return t&&(t=(t%=360)<0?360+t:t),this.setChannel("hsl",0,t)},saturation:function(t){return this.setChannel("hsl",1,t)},lightness:function(t){return this.setChannel("hsl",2,t)},saturationv:function(t){return this.setChannel("hsv",1,t)},whiteness:function(t){return this.setChannel("hwb",1,t)},blackness:function(t){return this.setChannel("hwb",2,t)},value:function(t){return this.setChannel("hsv",2,t)},cyan:function(t){return this.setChannel("cmyk",0,t)},magenta:function(t){return this.setChannel("cmyk",1,t)},yellow:function(t){return this.setChannel("cmyk",2,t)},black:function(t){return this.setChannel("cmyk",3,t)},hexString:function(){return u.hexString(this.values.rgb)},rgbString:function(){return u.rgbString(this.values.rgb,this.values.alpha)},rgbaString:function(){return u.rgbaString(this.values.rgb,this.values.alpha)},percentString:function(){return u.percentString(this.values.rgb,this.values.alpha)},hslString:function(){return u.hslString(this.values.hsl,this.values.alpha)},hslaString:function(){return u.hslaString(this.values.hsl,this.values.alpha)},hwbString:function(){return u.hwbString(this.values.hwb,this.values.alpha)},keyword:function(){return u.keyword(this.values.rgb,this.values.alpha)},rgbNumber:function(){var t=this.values.rgb;return t[0]<<16|t[1]<<8|t[2]},luminosity:function(){for(var t=this.values.rgb,e=[],n=0;n<t.length;n++){var i=t[n]/255;e[n]=i<=.03928?i/12.92:Math.pow((i+.055)/1.055,2.4)}return.2126*e[0]+.7152*e[1]+.0722*e[2]},contrast:function(t){var e=this.luminosity(),n=t.luminosity();return e>n?(e+.05)/(n+.05):(n+.05)/(e+.05)},level:function(t){var e=this.contrast(t);return e>=7.1?"AAA":e>=4.5?"AA":""},dark:function(){var t=this.values.rgb;return(299*t[0]+587*t[1]+114*t[2])/1e3<128},light:function(){return!this.dark()},negate:function(){for(var t=[],e=0;e<3;e++)t[e]=255-this.values.rgb[e];return this.setValues("rgb",t),this},lighten:function(t){var e=this.values.hsl;return e[2]+=e[2]*t,this.setValues("hsl",e),this},darken:function(t){var e=this.values.hsl;return e[2]-=e[2]*t,this.setValues("hsl",e),this},saturate:function(t){var e=this.values.hsl;return e[1]+=e[1]*t,this.setValues("hsl",e),this},desaturate:function(t){var e=this.values.hsl;return e[1]-=e[1]*t,this.setValues("hsl",e),this},whiten:function(t){var e=this.values.hwb;return e[1]+=e[1]*t,this.setValues("hwb",e),this},blacken:function(t){var e=this.values.hwb;return e[2]+=e[2]*t,this.setValues("hwb",e),this},greyscale:function(){var t=this.values.rgb,e=.3*t[0]+.59*t[1]+.11*t[2];return this.setValues("rgb",[e,e,e]),this},clearer:function(t){var e=this.values.alpha;return this.setValues("alpha",e-e*t),this},opaquer:function(t){var e=this.values.alpha;return this.setValues("alpha",e+e*t),this},rotate:function(t){var e=this.values.hsl,n=(e[0]+t)%360;return e[0]=n<0?360+n:n,this.setValues("hsl",e),this},mix:function(t,e){var n=this,i=t,r=void 0===e?.5:e,o=2*r-1,a=n.alpha()-i.alpha(),s=((o*a==-1?o:(o+a)/(1+o*a))+1)/2,l=1-s;return this.rgb(s*n.red()+l*i.red(),s*n.green()+l*i.green(),s*n.blue()+l*i.blue()).alpha(n.alpha()*r+i.alpha()*(1-r))},toJSON:function(){return this.rgb()},clone:function(){var t,e,n=new w,i=this.values,r=n.values;for(var o in i)i.hasOwnProperty(o)&&(t=i[o],"[object Array]"===(e={}.toString.call(t))?r[o]=t.slice(0):"[object Number]"===e?r[o]=t:console.error("unexpected color value:",t));return n}},w.prototype.spaces={rgb:["red","green","blue"],hsl:["hue","saturation","lightness"],hsv:["hue","saturation","value"],hwb:["hue","whiteness","blackness"],cmyk:["cyan","magenta","yellow","black"]},w.prototype.maxes={rgb:[255,255,255],hsl:[360,100,100],hsv:[360,100,100],hwb:[360,100,100],cmyk:[100,100,100,100]},w.prototype.getValues=function(t){for(var e=this.values,n={},i=0;i<t.length;i++)n[t.charAt(i)]=e[t][i];return 1!==e.alpha&&(n.a=e.alpha),n},w.prototype.setValues=function(t,e){var n,i,r=this.values,o=this.spaces,a=this.maxes,s=1;if(this.valid=!0,"alpha"===t)s=e;else if(e.length)r[t]=e.slice(0,t.length),s=e[t.length];else if(void 0!==e[t.charAt(0)]){for(n=0;n<t.length;n++)r[t][n]=e[t.charAt(n)];s=e.a}else if(void 0!==e[o[t][0]]){var c=o[t];for(n=0;n<t.length;n++)r[t][n]=e[c[n]];s=e.alpha}if(r.alpha=Math.max(0,Math.min(1,void 0===s?r.alpha:s)),"alpha"===t)return!1;for(n=0;n<t.length;n++)i=Math.max(0,Math.min(a[t][n],r[t][n])),r[t][n]=Math.round(i);for(var u in o)u!==t&&(r[u]=l[t][u](r[t]));return!0},w.prototype.setSpace=function(t,e){var n=e[0];return void 0===n?this.getValues(t):("number"==typeof n&&(n=Array.prototype.slice.call(e)),this.setValues(t,n),this)},w.prototype.setChannel=function(t,e,n){var i=this.values[t];return void 0===n?i[e]:(n===i[e]||(i[e]=n,this.setValues(t,i)),this)},"undefined"!=typeof window&&(window.Color=w);var k=w;function x(t){return-1===["__proto__","prototype","constructor"].indexOf(t)}var C={noop:function(){},uid:function(){var t=0;return function(){return t++}}(),isNullOrUndef:function(t){return null==t},isArray:function(t){if(Array.isArray&&Array.isArray(t))return!0;var e=Object.prototype.toString.call(t);return"[object"===e.substr(0,7)&&"Array]"===e.substr(-6)},isObject:function(t){return null!==t&&"[object Object]"===Object.prototype.toString.call(t)},isFinite:function(t){return("number"==typeof t||t instanceof Number)&&isFinite(t)},valueOrDefault:function(t,e){return void 0===t?e:t},valueAtIndexOrDefault:function(t,e,n){return C.valueOrDefault(C.isArray(t)?t[e]:t,n)},callback:function(t,e,n){if(t&&"function"==typeof t.call)return t.apply(n,e)},each:function(t,e,n,i){var r,o,a;if(C.isArray(t))if(o=t.length,i)for(r=o-1;r>=0;r--)e.call(n,t[r],r);else for(r=0;r<o;r++)e.call(n,t[r],r);else if(C.isObject(t))for(o=(a=Object.keys(t)).length,r=0;r<o;r++)e.call(n,t[a[r]],a[r])},arrayEquals:function(t,e){var n,i,r,o;if(!t||!e||t.length!==e.length)return!1;for(n=0,i=t.length;n<i;++n)if(r=t[n],o=e[n],r instanceof Array&&o instanceof Array){if(!C.arrayEquals(r,o))return!1}else if(r!==o)return!1;return!0},clone:function(t){if(C.isArray(t))return t.map(C.clone);if(C.isObject(t)){for(var e=Object.create(t),n=Object.keys(t),i=n.length,r=0;r<i;++r)e[n[r]]=C.clone(t[n[r]]);return e}return t},_merger:function(t,e,n,i){if(x(t)){var r=e[t],o=n[t];C.isObject(r)&&C.isObject(o)?C.merge(r,o,i):e[t]=C.clone(o)}},_mergerIf:function(t,e,n){if(x(t)){var i=e[t],r=n[t];C.isObject(i)&&C.isObject(r)?C.mergeIf(i,r):e.hasOwnProperty(t)||(e[t]=C.clone(r))}},merge:function(t,e,n){var i,r,o,a,s,l=C.isArray(e)?e:[e],c=l.length;if(!C.isObject(t))return t;for(i=(n=n||{}).merger||C._merger,r=0;r<c;++r)if(e=l[r],C.isObject(e))for(s=0,a=(o=Object.keys(e)).length;s<a;++s)i(o[s],t,e,n);return t},mergeIf:function(t,e){return C.merge(t,e,{merger:C._mergerIf})},extend:Object.assign||function(t){return C.merge(t,[].slice.call(arguments,1),{merger:function(t,e,n){e[t]=n[t]}})},inherits:function(t){var e=this,n=t&&t.hasOwnProperty("constructor")?t.constructor:function(){return e.apply(this,arguments)},i=function(){this.constructor=n};return i.prototype=e.prototype,n.prototype=new i,n.extend=C.inherits,t&&C.extend(n.prototype,t),n.__super__=e.prototype,n},_deprecated:function(t,e,n,i){void 0!==e&&console.warn(t+': "'+n+'" is deprecated. Please use "'+i+'" instead')}},S=C;C.callCallback=C.callback,C.indexOf=function(t,e,n){return Array.prototype.indexOf.call(t,e,n)},C.getValueOrDefault=C.valueOrDefault,C.getValueAtIndexOrDefault=C.valueAtIndexOrDefault;var M={linear:function(t){return t},easeInQuad:function(t){return t*t},easeOutQuad:function(t){return-t*(t-2)},easeInOutQuad:function(t){return(t/=.5)<1?.5*t*t:-.5*(--t*(t-2)-1)},easeInCubic:function(t){return t*t*t},easeOutCubic:function(t){return(t-=1)*t*t+1},easeInOutCubic:function(t){return(t/=.5)<1?.5*t*t*t:.5*((t-=2)*t*t+2)},easeInQuart:function(t){return t*t*t*t},easeOutQuart:function(t){return-((t-=1)*t*t*t-1)},easeInOutQuart:function(t){return(t/=.5)<1?.5*t*t*t*t:-.5*((t-=2)*t*t*t-2)},easeInQuint:function(t){return t*t*t*t*t},easeOutQuint:function(t){return(t-=1)*t*t*t*t+1},easeInOutQuint:function(t){return(t/=.5)<1?.5*t*t*t*t*t:.5*((t-=2)*t*t*t*t+2)},easeInSine:function(t){return 1-Math.cos(t*(Math.PI/2))},easeOutSine:function(t){return Math.sin(t*(Math.PI/2))},easeInOutSine:function(t){return-.5*(Math.cos(Math.PI*t)-1)},easeInExpo:function(t){return 0===t?0:Math.pow(2,10*(t-1))},easeOutExpo:function(t){return 1===t?1:1-Math.pow(2,-10*t)},easeInOutExpo:function(t){return 0===t?0:1===t?1:(t/=.5)<1?.5*Math.pow(2,10*(t-1)):.5*(2-Math.pow(2,-10*--t))},easeInCirc:function(t){return t>=1?t:-(Math.sqrt(1-t*t)-1)},easeOutCirc:function(t){return Math.sqrt(1-(t-=1)*t)},easeInOutCirc:function(t){return(t/=.5)<1?-.5*(Math.sqrt(1-t*t)-1):.5*(Math.sqrt(1-(t-=2)*t)+1)},easeInElastic:function(t){var e=1.70158,n=0,i=1;return 0===t?0:1===t?1:(n||(n=.3),i<1?(i=1,e=n/4):e=n/(2*Math.PI)*Math.asin(1/i),-i*Math.pow(2,10*(t-=1))*Math.sin((t-e)*(2*Math.PI)/n))},easeOutElastic:function(t){var e=1.70158,n=0,i=1;return 0===t?0:1===t?1:(n||(n=.3),i<1?(i=1,e=n/4):e=n/(2*Math.PI)*Math.asin(1/i),i*Math.pow(2,-10*t)*Math.sin((t-e)*(2*Math.PI)/n)+1)},easeInOutElastic:function(t){var e=1.70158,n=0,i=1;return 0===t?0:2==(t/=.5)?1:(n||(n=.45),i<1?(i=1,e=n/4):e=n/(2*Math.PI)*Math.asin(1/i),t<1?i*Math.pow(2,10*(t-=1))*Math.sin((t-e)*(2*Math.PI)/n)*-.5:i*Math.pow(2,-10*(t-=1))*Math.sin((t-e)*(2*Math.PI)/n)*.5+1)},easeInBack:function(t){var e=1.70158;return t*t*((e+1)*t-e)},easeOutBack:function(t){var e=1.70158;return(t-=1)*t*((e+1)*t+e)+1},easeInOutBack:function(t){var e=1.70158;return(t/=.5)<1?t*t*((1+(e*=1.525))*t-e)*.5:.5*((t-=2)*t*((1+(e*=1.525))*t+e)+2)},easeInBounce:function(t){return 1-M.easeOutBounce(1-t)},easeOutBounce:function(t){return t<1/2.75?7.5625*t*t:t<2/2.75?7.5625*(t-=1.5/2.75)*t+.75:t<2.5/2.75?7.5625*(t-=2.25/2.75)*t+.9375:7.5625*(t-=2.625/2.75)*t+.984375},easeInOutBounce:function(t){return t<.5?.5*M.easeInBounce(2*t):.5*M.easeOutBounce(2*t-1)+.5}},T={effects:M};S.easingEffects=M;var P=Math.PI,O=P/180,B=2*P,E=P/2,A=P/4,D=2*P/3,L={clear:function(t){t.ctx.clearRect(0,0,t.width,t.height)},roundedRect:function(t,e,n,i,r,o){if(o){var a=Math.min(o,r/2,i/2),s=e+a,l=n+a,c=e+i-a,u=n+r-a;t.moveTo(e,l),s<c&&l<u?(t.arc(s,l,a,-P,-E),t.arc(c,l,a,-E,0),t.arc(c,u,a,0,E),t.arc(s,u,a,E,P)):s<c?(t.moveTo(s,n),t.arc(c,l,a,-E,E),t.arc(s,l,a,E,P+E)):l<u?(t.arc(s,l,a,-P,0),t.arc(s,u,a,0,P)):t.arc(s,l,a,-P,P),t.closePath(),t.moveTo(e,n)}else t.rect(e,n,i,r)},drawPoint:function(t,e,n,i,r,o){var a,s,l,c,u,d=(o||0)*O;if(e&&"object"==typeof e&&("[object HTMLImageElement]"===(a=e.toString())||"[object HTMLCanvasElement]"===a))return t.save(),t.translate(i,r),t.rotate(d),t.drawImage(e,-e.width/2,-e.height/2,e.width,e.height),void t.restore();if(!(isNaN(n)||n<=0)){switch(t.beginPath(),e){default:t.arc(i,r,n,0,B),t.closePath();break;case"triangle":t.moveTo(i+Math.sin(d)*n,r-Math.cos(d)*n),d+=D,t.lineTo(i+Math.sin(d)*n,r-Math.cos(d)*n),d+=D,t.lineTo(i+Math.sin(d)*n,r-Math.cos(d)*n),t.closePath();break;case"rectRounded":c=n-(u=.516*n),s=Math.cos(d+A)*c,l=Math.sin(d+A)*c,t.arc(i-s,r-l,u,d-P,d-E),t.arc(i+l,r-s,u,d-E,d),t.arc(i+s,r+l,u,d,d+E),t.arc(i-l,r+s,u,d+E,d+P),t.closePath();break;case"rect":if(!o){c=Math.SQRT1_2*n,t.rect(i-c,r-c,2*c,2*c);break}d+=A;case"rectRot":s=Math.cos(d)*n,l=Math.sin(d)*n,t.moveTo(i-s,r-l),t.lineTo(i+l,r-s),t.lineTo(i+s,r+l),t.lineTo(i-l,r+s),t.closePath();break;case"crossRot":d+=A;case"cross":s=Math.cos(d)*n,l=Math.sin(d)*n,t.moveTo(i-s,r-l),t.lineTo(i+s,r+l),t.moveTo(i+l,r-s),t.lineTo(i-l,r+s);break;case"star":s=Math.cos(d)*n,l=Math.sin(d)*n,t.moveTo(i-s,r-l),t.lineTo(i+s,r+l),t.moveTo(i+l,r-s),t.lineTo(i-l,r+s),d+=A,s=Math.cos(d)*n,l=Math.sin(d)*n,t.moveTo(i-s,r-l),t.lineTo(i+s,r+l),t.moveTo(i+l,r-s),t.lineTo(i-l,r+s);break;case"line":s=Math.cos(d)*n,l=Math.sin(d)*n,t.moveTo(i-s,r-l),t.lineTo(i+s,r+l);break;case"dash":t.moveTo(i,r),t.lineTo(i+Math.cos(d)*n,r+Math.sin(d)*n)}t.fill(),t.stroke()}},_isPointInArea:function(t,e){var n=1e-6;return t.x>e.left-n&&t.x<e.right+n&&t.y>e.top-n&&t.y<e.bottom+n},clipArea:function(t,e){t.save(),t.beginPath(),t.rect(e.left,e.top,e.right-e.left,e.bottom-e.top),t.clip()},unclipArea:function(t){t.restore()},lineTo:function(t,e,n,i){var r=n.steppedLine;if(r){if("middle"===r){var o=(e.x+n.x)/2;t.lineTo(o,i?n.y:e.y),t.lineTo(o,i?e.y:n.y)}else"after"===r&&!i||"after"!==r&&i?t.lineTo(e.x,n.y):t.lineTo(n.x,e.y);t.lineTo(n.x,n.y)}else n.tension?t.bezierCurveTo(i?e.controlPointPreviousX:e.controlPointNextX,i?e.controlPointPreviousY:e.controlPointNextY,i?n.controlPointNextX:n.controlPointPreviousX,i?n.controlPointNextY:n.controlPointPreviousY,n.x,n.y):t.lineTo(n.x,n.y)}},q=L;S.clear=L.clear,S.drawRoundedRectangle=function(t){t.beginPath(),L.roundedRect.apply(L,arguments)};var R={_set:function(t,e){return S.merge(this[t]||(this[t]={}),e)}};R._set("global",{defaultColor:"rgba(0,0,0,0.1)",defaultFontColor:"#666",defaultFontFamily:"'Helvetica Neue', 'Helvetica', 'Arial', sans-serif",defaultFontSize:12,defaultFontStyle:"normal",defaultLineHeight:1.2,showLines:!0});var I=R,N=S.valueOrDefault;var F={toLineHeight:function(t,e){var n=(""+t).match(/^(normal|(\d+(?:\.\d+)?)(px|em|%)?)$/);if(!n||"normal"===n[1])return 1.2*e;switch(t=+n[2],n[3]){case"px":return t;case"%":t/=100}return e*t},toPadding:function(t){var e,n,i,r;return S.isObject(t)?(e=+t.top||0,n=+t.right||0,i=+t.bottom||0,r=+t.left||0):e=n=i=r=+t||0,{top:e,right:n,bottom:i,left:r,height:e+i,width:r+n}},_parseFont:function(t){var e=I.global,n=N(t.fontSize,e.defaultFontSize),i={family:N(t.fontFamily,e.defaultFontFamily),lineHeight:S.options.toLineHeight(N(t.lineHeight,e.defaultLineHeight),n),size:n,style:N(t.fontStyle,e.defaultFontStyle),weight:null,string:""};return i.string=function(t){return!t||S.isNullOrUndef(t.size)||S.isNullOrUndef(t.family)?null:(t.style?t.style+" ":"")+(t.weight?t.weight+" ":"")+t.size+"px "+t.family}(i),i},resolve:function(t,e,n,i){var r,o,a,s=!0;for(r=0,o=t.length;r<o;++r)if(void 0!==(a=t[r])&&(void 0!==e&&"function"==typeof a&&(a=a(e),s=!1),void 0!==n&&S.isArray(a)&&(a=a[n],s=!1),void 0!==a))return i&&!s&&(i.cacheable=!1),a}},$={_factorize:function(t){var e,n=[],i=Math.sqrt(t);for(e=1;e<i;e++)t%e==0&&(n.push(e),n.push(t/e));return i===(0|i)&&n.push(i),n.sort((function(t,e){return t-e})).pop(),n},log10:Math.log10||function(t){var e=Math.log(t)*Math.LOG10E,n=Math.round(e);return t===Math.pow(10,n)?n:e}},j=$;S.log10=$.log10;var z={getRtlAdapter:function(t,e,n){return t?function(t,e){return{x:function(n){return t+t+e-n},setWidth:function(t){e=t},textAlign:function(t){return"center"===t?t:"right"===t?"left":"right"},xPlus:function(t,e){return t-e},leftForLtr:function(t,e){return t-e}}}(e,n):{x:function(t){return t},setWidth:function(t){},textAlign:function(t){return t},xPlus:function(t,e){return t+e},leftForLtr:function(t,e){return t}}},overrideTextDirection:function(t,e){var n,i;"ltr"!==e&&"rtl"!==e||(i=[(n=t.canvas.style).getPropertyValue("direction"),n.getPropertyPriority("direction")],n.setProperty("direction",e,"important"),t.prevTextDirection=i)},restoreTextDirection:function(t){var e=t.prevTextDirection;void 0!==e&&(delete t.prevTextDirection,t.canvas.style.setProperty("direction",e[0],e[1]))}},V=S,H=T,W=q,U=F,Y=j,Q=z;V.easing=H,V.canvas=W,V.options=U,V.math=Y,V.rtl=Q;var G=function(t){V.extend(this,t),this.initialize.apply(this,arguments)};V.extend(G.prototype,{_type:void 0,initialize:function(){this.hidden=!1},pivot:function(){var t=this;return t._view||(t._view=V.extend({},t._model)),t._start={},t},transition:function(t){var e=this,n=e._model,i=e._start,r=e._view;return n&&1!==t?(r||(r=e._view={}),i||(i=e._start={}),function(t,e,n,i){var r,o,a,s,l,c,u,d,h,f=Object.keys(n);for(r=0,o=f.length;r<o;++r)if(c=n[a=f[r]],e.hasOwnProperty(a)||(e[a]=c),(s=e[a])!==c&&"_"!==a[0]){if(t.hasOwnProperty(a)||(t[a]=s),(u=typeof c)==typeof(l=t[a]))if("string"===u){if((d=k(l)).valid&&(h=k(c)).valid){e[a]=h.mix(d,i).rgbString();continue}}else if(V.isFinite(l)&&V.isFinite(c)){e[a]=l+(c-l)*i;continue}e[a]=c}}(i,r,n,t),e):(e._view=V.extend({},n),e._start=null,e)},tooltipPosition:function(){return{x:this._model.x,y:this._model.y}},hasValue:function(){return V.isNumber(this._model.x)&&V.isNumber(this._model.y)}}),G.extend=V.inherits;var K=G,J=K.extend({chart:null,currentStep:0,numSteps:60,easing:"",render:null,onAnimationProgress:null,onAnimationComplete:null}),Z=J;Object.defineProperty(J.prototype,"animationObject",{get:function(){return this}}),Object.defineProperty(J.prototype,"chartInstance",{get:function(){return this.chart},set:function(t){this.chart=t}}),I._set("global",{animation:{duration:1e3,easing:"easeOutQuart",onProgress:V.noop,onComplete:V.noop}});var X={animations:[],request:null,addAnimation:function(t,e,n,i){var r,o,a=this.animations;for(e.chart=t,e.startTime=Date.now(),e.duration=n,i||(t.animating=!0),r=0,o=a.length;r<o;++r)if(a[r].chart===t)return void(a[r]=e);a.push(e),1===a.length&&this.requestAnimationFrame()},cancelAnimation:function(t){var e=V.findIndex(this.animations,(function(e){return e.chart===t}));-1!==e&&(this.animations.splice(e,1),t.animating=!1)},requestAnimationFrame:function(){var t=this;null===t.request&&(t.request=V.requestAnimFrame.call(window,(function(){t.request=null,t.startDigest()})))},startDigest:function(){var t=this;t.advance(),t.animations.length>0&&t.requestAnimationFrame()},advance:function(){for(var t,e,n,i,r=this.animations,o=0;o<r.length;)e=(t=r[o]).chart,n=t.numSteps,i=Math.floor((Date.now()-t.startTime)/t.duration*n)+1,t.currentStep=Math.min(i,n),V.callback(t.render,[e,t],e),V.callback(t.onAnimationProgress,[t],e),t.currentStep>=n?(V.callback(t.onAnimationComplete,[t],e),e.animating=!1,r.splice(o,1)):++o}},tt=V.options.resolve,et=["push","pop","shift","splice","unshift"];function nt(t,e){var n=t._chartjs;if(n){var i=n.listeners,r=i.indexOf(e);-1!==r&&i.splice(r,1),i.length>0||(et.forEach((function(e){delete t[e]})),delete t._chartjs)}}var it=function(t,e){this.initialize(t,e)};V.extend(it.prototype,{datasetElementType:null,dataElementType:null,_datasetElementOptions:["backgroundColor","borderCapStyle","borderColor","borderDash","borderDashOffset","borderJoinStyle","borderWidth"],_dataElementOptions:["backgroundColor","borderColor","borderWidth","pointStyle"],initialize:function(t,e){var n=this;n.chart=t,n.index=e,n.linkScales(),n.addElements(),n._type=n.getMeta().type},updateIndex:function(t){this.index=t},linkScales:function(){var t=this,e=t.getMeta(),n=t.chart,i=n.scales,r=t.getDataset(),o=n.options.scales;null!==e.xAxisID&&e.xAxisID in i&&!r.xAxisID||(e.xAxisID=r.xAxisID||o.xAxes[0].id),null!==e.yAxisID&&e.yAxisID in i&&!r.yAxisID||(e.yAxisID=r.yAxisID||o.yAxes[0].id)},getDataset:function(){return this.chart.data.datasets[this.index]},getMeta:function(){return this.chart.getDatasetMeta(this.index)},getScaleForId:function(t){return this.chart.scales[t]},_getValueScaleId:function(){return this.getMeta().yAxisID},_getIndexScaleId:function(){return this.getMeta().xAxisID},_getValueScale:function(){return this.getScaleForId(this._getValueScaleId())},_getIndexScale:function(){return this.getScaleForId(this._getIndexScaleId())},reset:function(){this._update(!0)},destroy:function(){this._data&&nt(this._data,this)},createMetaDataset:function(){var t=this,e=t.datasetElementType;return e&&new e({_chart:t.chart,_datasetIndex:t.index})},createMetaData:function(t){var e=this,n=e.dataElementType;return n&&new n({_chart:e.chart,_datasetIndex:e.index,_index:t})},addElements:function(){var t,e,n=this,i=n.getMeta(),r=n.getDataset().data||[],o=i.data;for(t=0,e=r.length;t<e;++t)o[t]=o[t]||n.createMetaData(t);i.dataset=i.dataset||n.createMetaDataset()},addElementAndReset:function(t){var e=this.createMetaData(t);this.getMeta().data.splice(t,0,e),this.updateElement(e,t,!0)},buildOrUpdateElements:function(){var t,e,n=this,i=n.getDataset(),r=i.data||(i.data=[]);n._data!==r&&(n._data&&nt(n._data,n),r&&Object.isExtensible(r)&&(e=n,(t=r)._chartjs?t._chartjs.listeners.push(e):(Object.defineProperty(t,"_chartjs",{configurable:!0,enumerable:!1,value:{listeners:[e]}}),et.forEach((function(e){var n="onData"+e.charAt(0).toUpperCase()+e.slice(1),i=t[e];Object.defineProperty(t,e,{configurable:!0,enumerable:!1,value:function(){var e=Array.prototype.slice.call(arguments),r=i.apply(this,e);return V.each(t._chartjs.listeners,(function(t){"function"==typeof t[n]&&t[n].apply(t,e)})),r}})})))),n._data=r),n.resyncElements()},_configure:function(){var t=this;t._config=V.merge(Object.create(null),[t.chart.options.datasets[t._type],t.getDataset()],{merger:function(t,e,n){"_meta"!==t&&"data"!==t&&V._merger(t,e,n)}})},_update:function(t){var e=this;e._configure(),e._cachedDataOpts=null,e.update(t)},update:V.noop,transition:function(t){for(var e=this.getMeta(),n=e.data||[],i=n.length,r=0;r<i;++r)n[r].transition(t);e.dataset&&e.dataset.transition(t)},draw:function(){var t=this.getMeta(),e=t.data||[],n=e.length,i=0;for(t.dataset&&t.dataset.draw();i<n;++i)e[i].draw()},getStyle:function(t){var e,n=this,i=n.getMeta(),r=i.dataset;return n._configure(),r&&void 0===t?e=n._resolveDatasetElementOptions(r||{}):(t=t||0,e=n._resolveDataElementOptions(i.data[t]||{},t)),!1!==e.fill&&null!==e.fill||(e.backgroundColor=e.borderColor),e},_resolveDatasetElementOptions:function(t,e){var n,i,r,o,a=this,s=a.chart,l=a._config,c=t.custom||{},u=s.options.elements[a.datasetElementType.prototype._type]||{},d=a._datasetElementOptions,h={},f={chart:s,dataset:a.getDataset(),datasetIndex:a.index,hover:e};for(n=0,i=d.length;n<i;++n)r=d[n],o=e?"hover"+r.charAt(0).toUpperCase()+r.slice(1):r,h[r]=tt([c[o],l[o],u[o]],f);return h},_resolveDataElementOptions:function(t,e){var n=this,i=t&&t.custom,r=n._cachedDataOpts;if(r&&!i)return r;var o,a,s,l,c=n.chart,u=n._config,d=c.options.elements[n.dataElementType.prototype._type]||{},h=n._dataElementOptions,f={},p={chart:c,dataIndex:e,dataset:n.getDataset(),datasetIndex:n.index},m={cacheable:!i};if(i=i||{},V.isArray(h))for(a=0,s=h.length;a<s;++a)f[l=h[a]]=tt([i[l],u[l],d[l]],p,e,m);else for(a=0,s=(o=Object.keys(h)).length;a<s;++a)f[l=o[a]]=tt([i[l],u[h[l]],u[l],d[l]],p,e,m);return m.cacheable&&(n._cachedDataOpts=Object.freeze(f)),f},removeHoverStyle:function(t){V.merge(t._model,t.$previousStyle||{}),delete t.$previousStyle},setHoverStyle:function(t){var e=this.chart.data.datasets[t._datasetIndex],n=t._index,i=t.custom||{},r=t._model,o=V.getHoverColor;t.$previousStyle={backgroundColor:r.backgroundColor,borderColor:r.borderColor,borderWidth:r.borderWidth},r.backgroundColor=tt([i.hoverBackgroundColor,e.hoverBackgroundColor,o(r.backgroundColor)],void 0,n),r.borderColor=tt([i.hoverBorderColor,e.hoverBorderColor,o(r.borderColor)],void 0,n),r.borderWidth=tt([i.hoverBorderWidth,e.hoverBorderWidth,r.borderWidth],void 0,n)},_removeDatasetHoverStyle:function(){var t=this.getMeta().dataset;t&&this.removeHoverStyle(t)},_setDatasetHoverStyle:function(){var t,e,n,i,r,o,a=this.getMeta().dataset,s={};if(a){for(o=a._model,r=this._resolveDatasetElementOptions(a,!0),t=0,e=(i=Object.keys(r)).length;t<e;++t)s[n=i[t]]=o[n],o[n]=r[n];a.$previousStyle=s}},resyncElements:function(){var t=this,e=t.getMeta(),n=t.getDataset().data,i=e.data.length,r=n.length;r<i?e.data.splice(r,i-r):r>i&&t.insertElements(i,r-i)},insertElements:function(t,e){for(var n=0;n<e;++n)this.addElementAndReset(t+n)},onDataPush:function(){var t=arguments.length;this.insertElements(this.getDataset().data.length-t,t)},onDataPop:function(){this.getMeta().data.pop()},onDataShift:function(){this.getMeta().data.shift()},onDataSplice:function(t,e){this.getMeta().data.splice(t,e),this.insertElements(t,arguments.length-2)},onDataUnshift:function(){this.insertElements(0,arguments.length)}}),it.extend=V.inherits;var rt=it,ot=2*Math.PI;function at(t,e){var n=e.startAngle,i=e.endAngle,r=e.pixelMargin,o=r/e.outerRadius,a=e.x,s=e.y;t.beginPath(),t.arc(a,s,e.outerRadius,n-o,i+o),e.innerRadius>r?(o=r/e.innerRadius,t.arc(a,s,e.innerRadius-r,i+o,n-o,!0)):t.arc(a,s,r,i+Math.PI/2,n-Math.PI/2),t.closePath(),t.clip()}function st(t,e,n){var i="inner"===e.borderAlign;i?(t.lineWidth=2*e.borderWidth,t.lineJoin="round"):(t.lineWidth=e.borderWidth,t.lineJoin="bevel"),n.fullCircles&&function(t,e,n,i){var r,o=n.endAngle;for(i&&(n.endAngle=n.startAngle+ot,at(t,n),n.endAngle=o,n.endAngle===n.startAngle&&n.fullCircles&&(n.endAngle+=ot,n.fullCircles--)),t.beginPath(),t.arc(n.x,n.y,n.innerRadius,n.startAngle+ot,n.startAngle,!0),r=0;r<n.fullCircles;++r)t.stroke();for(t.beginPath(),t.arc(n.x,n.y,e.outerRadius,n.startAngle,n.startAngle+ot),r=0;r<n.fullCircles;++r)t.stroke()}(t,e,n,i),i&&at(t,n),t.beginPath(),t.arc(n.x,n.y,e.outerRadius,n.startAngle,n.endAngle),t.arc(n.x,n.y,n.innerRadius,n.endAngle,n.startAngle,!0),t.closePath(),t.stroke()}I._set("global",{elements:{arc:{backgroundColor:I.global.defaultColor,borderColor:"#fff",borderWidth:2,borderAlign:"center"}}});var lt=K.extend({_type:"arc",inLabelRange:function(t){var e=this._view;return!!e&&Math.pow(t-e.x,2)<Math.pow(e.radius+e.hoverRadius,2)},inRange:function(t,e){var n=this._view;if(n){for(var i=V.getAngleFromPoint(n,{x:t,y:e}),r=i.angle,o=i.distance,a=n.startAngle,s=n.endAngle;s<a;)s+=ot;for(;r>s;)r-=ot;for(;r<a;)r+=ot;var l=r>=a&&r<=s,c=o>=n.innerRadius&&o<=n.outerRadius;return l&&c}return!1},getCenterPoint:function(){var t=this._view,e=(t.startAngle+t.endAngle)/2,n=(t.innerRadius+t.outerRadius)/2;return{x:t.x+Math.cos(e)*n,y:t.y+Math.sin(e)*n}},getArea:function(){var t=this._view;return Math.PI*((t.endAngle-t.startAngle)/(2*Math.PI))*(Math.pow(t.outerRadius,2)-Math.pow(t.innerRadius,2))},tooltipPosition:function(){var t=this._view,e=t.startAngle+(t.endAngle-t.startAngle)/2,n=(t.outerRadius-t.innerRadius)/2+t.innerRadius;return{x:t.x+Math.cos(e)*n,y:t.y+Math.sin(e)*n}},draw:function(){var t,e=this._chart.ctx,n=this._view,i="inner"===n.borderAlign?.33:0,r={x:n.x,y:n.y,innerRadius:n.innerRadius,outerRadius:Math.max(n.outerRadius-i,0),pixelMargin:i,startAngle:n.startAngle,endAngle:n.endAngle,fullCircles:Math.floor(n.circumference/ot)};if(e.save(),e.fillStyle=n.backgroundColor,e.strokeStyle=n.borderColor,r.fullCircles){for(r.endAngle=r.startAngle+ot,e.beginPath(),e.arc(r.x,r.y,r.outerRadius,r.startAngle,r.endAngle),e.arc(r.x,r.y,r.innerRadius,r.endAngle,r.startAngle,!0),e.closePath(),t=0;t<r.fullCircles;++t)e.fill();r.endAngle=r.startAngle+n.circumference%ot}e.beginPath(),e.arc(r.x,r.y,r.outerRadius,r.startAngle,r.endAngle),e.arc(r.x,r.y,r.innerRadius,r.endAngle,r.startAngle,!0),e.closePath(),e.fill(),n.borderWidth&&st(e,n,r),e.restore()}}),ct=V.valueOrDefault,ut=I.global.defaultColor;I._set("global",{elements:{line:{tension:.4,backgroundColor:ut,borderWidth:3,borderColor:ut,borderCapStyle:"butt",borderDash:[],borderDashOffset:0,borderJoinStyle:"miter",capBezierPoints:!0,fill:!0}}});var dt=K.extend({_type:"line",draw:function(){var t,e,n,i=this,r=i._view,o=i._chart.ctx,a=r.spanGaps,s=i._children.slice(),l=I.global,c=l.elements.line,u=-1,d=i._loop;if(s.length){if(i._loop){for(t=0;t<s.length;++t)if(e=V.previousItem(s,t),!s[t]._view.skip&&e._view.skip){s=s.slice(t).concat(s.slice(0,t)),d=a;break}d&&s.push(s[0])}for(o.save(),o.lineCap=r.borderCapStyle||c.borderCapStyle,o.setLineDash&&o.setLineDash(r.borderDash||c.borderDash),o.lineDashOffset=ct(r.borderDashOffset,c.borderDashOffset),o.lineJoin=r.borderJoinStyle||c.borderJoinStyle,o.lineWidth=ct(r.borderWidth,c.borderWidth),o.strokeStyle=r.borderColor||l.defaultColor,o.beginPath(),(n=s[0]._view).skip||(o.moveTo(n.x,n.y),u=0),t=1;t<s.length;++t)n=s[t]._view,e=-1===u?V.previousItem(s,t):s[u],n.skip||(u!==t-1&&!a||-1===u?o.moveTo(n.x,n.y):V.canvas.lineTo(o,e._view,n),u=t);d&&o.closePath(),o.stroke(),o.restore()}}}),ht=V.valueOrDefault,ft=I.global.defaultColor;function pt(t){var e=this._view;return!!e&&Math.abs(t-e.x)<e.radius+e.hitRadius}I._set("global",{elements:{point:{radius:3,pointStyle:"circle",backgroundColor:ft,borderColor:ft,borderWidth:1,hitRadius:1,hoverRadius:4,hoverBorderWidth:1}}});var mt=K.extend({_type:"point",inRange:function(t,e){var n=this._view;return!!n&&Math.pow(t-n.x,2)+Math.pow(e-n.y,2)<Math.pow(n.hitRadius+n.radius,2)},inLabelRange:pt,inXRange:pt,inYRange:function(t){var e=this._view;return!!e&&Math.abs(t-e.y)<e.radius+e.hitRadius},getCenterPoint:function(){var t=this._view;return{x:t.x,y:t.y}},getArea:function(){return Math.PI*Math.pow(this._view.radius,2)},tooltipPosition:function(){var t=this._view;return{x:t.x,y:t.y,padding:t.radius+t.borderWidth}},draw:function(t){var e=this._view,n=this._chart.ctx,i=e.pointStyle,r=e.rotation,o=e.radius,a=e.x,s=e.y,l=I.global,c=l.defaultColor;e.skip||(void 0===t||V.canvas._isPointInArea(e,t))&&(n.strokeStyle=e.borderColor||c,n.lineWidth=ht(e.borderWidth,l.elements.point.borderWidth),n.fillStyle=e.backgroundColor||c,V.canvas.drawPoint(n,i,o,a,s,r))}}),vt=I.global.defaultColor;function gt(t){return t&&void 0!==t.width}function yt(t){var e,n,i,r,o;return gt(t)?(o=t.width/2,e=t.x-o,n=t.x+o,i=Math.min(t.y,t.base),r=Math.max(t.y,t.base)):(o=t.height/2,e=Math.min(t.x,t.base),n=Math.max(t.x,t.base),i=t.y-o,r=t.y+o),{left:e,top:i,right:n,bottom:r}}function _t(t,e,n){return t===e?n:t===n?e:t}function bt(t,e,n){var i,r,o,a,s=t.borderWidth,l=function(t){var e=t.borderSkipped,n={};return e?(t.horizontal?t.base>t.x&&(e=_t(e,"left","right")):t.base<t.y&&(e=_t(e,"bottom","top")),n[e]=!0,n):n}(t);return V.isObject(s)?(i=+s.top||0,r=+s.right||0,o=+s.bottom||0,a=+s.left||0):i=r=o=a=+s||0,{t:l.top||i<0?0:i>n?n:i,r:l.right||r<0?0:r>e?e:r,b:l.bottom||o<0?0:o>n?n:o,l:l.left||a<0?0:a>e?e:a}}function wt(t,e,n){var i=null===e,r=null===n,o=!(!t||i&&r)&&yt(t);return o&&(i||e>=o.left&&e<=o.right)&&(r||n>=o.top&&n<=o.bottom)}I._set("global",{elements:{rectangle:{backgroundColor:vt,borderColor:vt,borderSkipped:"bottom",borderWidth:0}}});var kt=K.extend({_type:"rectangle",draw:function(){var t=this._chart.ctx,e=this._view,n=function(t){var e=yt(t),n=e.right-e.left,i=e.bottom-e.top,r=bt(t,n/2,i/2);return{outer:{x:e.left,y:e.top,w:n,h:i},inner:{x:e.left+r.l,y:e.top+r.t,w:n-r.l-r.r,h:i-r.t-r.b}}}(e),i=n.outer,r=n.inner;t.fillStyle=e.backgroundColor,t.fillRect(i.x,i.y,i.w,i.h),i.w===r.w&&i.h===r.h||(t.save(),t.beginPath(),t.rect(i.x,i.y,i.w,i.h),t.clip(),t.fillStyle=e.borderColor,t.rect(r.x,r.y,r.w,r.h),t.fill("evenodd"),t.restore())},height:function(){var t=this._view;return t.base-t.y},inRange:function(t,e){return wt(this._view,t,e)},inLabelRange:function(t,e){var n=this._view;return gt(n)?wt(n,t,null):wt(n,null,e)},inXRange:function(t){return wt(this._view,t,null)},inYRange:function(t){return wt(this._view,null,t)},getCenterPoint:function(){var t,e,n=this._view;return gt(n)?(t=n.x,e=(n.y+n.base)/2):(t=(n.x+n.base)/2,e=n.y),{x:t,y:e}},getArea:function(){var t=this._view;return gt(t)?t.width*Math.abs(t.y-t.base):t.height*Math.abs(t.x-t.base)},tooltipPosition:function(){var t=this._view;return{x:t.x,y:t.y}}}),xt={},Ct=lt,St=dt,Mt=mt,Tt=kt;xt.Arc=Ct,xt.Line=St,xt.Point=Mt,xt.Rectangle=Tt;var Pt=V._deprecated,Ot=V.valueOrDefault;function Bt(t,e,n){var i,r,o=n.barThickness,a=e.stackCount,s=e.pixels[t],l=V.isNullOrUndef(o)?function(t,e){var n,i,r,o,a=t._length;for(r=1,o=e.length;r<o;++r)a=Math.min(a,Math.abs(e[r]-e[r-1]));for(r=0,o=t.getTicks().length;r<o;++r)i=t.getPixelForTick(r),a=r>0?Math.min(a,Math.abs(i-n)):a,n=i;return a}(e.scale,e.pixels):-1;return V.isNullOrUndef(o)?(i=l*n.categoryPercentage,r=n.barPercentage):(i=o*a,r=1),{chunk:i/a,ratio:r,start:s-i/2}}I._set("bar",{hover:{mode:"label"},scales:{xAxes:[{type:"category",offset:!0,gridLines:{offsetGridLines:!0}}],yAxes:[{type:"linear"}]}}),I._set("global",{datasets:{bar:{categoryPercentage:.8,barPercentage:.9}}});var Et=rt.extend({dataElementType:xt.Rectangle,_dataElementOptions:["backgroundColor","borderColor","borderSkipped","borderWidth","barPercentage","barThickness","categoryPercentage","maxBarThickness","minBarLength"],initialize:function(){var t,e,n=this;rt.prototype.initialize.apply(n,arguments),(t=n.getMeta()).stack=n.getDataset().stack,t.bar=!0,e=n._getIndexScale().options,Pt("bar chart",e.barPercentage,"scales.[x/y]Axes.barPercentage","dataset.barPercentage"),Pt("bar chart",e.barThickness,"scales.[x/y]Axes.barThickness","dataset.barThickness"),Pt("bar chart",e.categoryPercentage,"scales.[x/y]Axes.categoryPercentage","dataset.categoryPercentage"),Pt("bar chart",n._getValueScale().options.minBarLength,"scales.[x/y]Axes.minBarLength","dataset.minBarLength"),Pt("bar chart",e.maxBarThickness,"scales.[x/y]Axes.maxBarThickness","dataset.maxBarThickness")},update:function(t){var e,n,i=this,r=i.getMeta().data;for(i._ruler=i.getRuler(),e=0,n=r.length;e<n;++e)i.updateElement(r[e],e,t)},updateElement:function(t,e,n){var i=this,r=i.getMeta(),o=i.getDataset(),a=i._resolveDataElementOptions(t,e);t._xScale=i.getScaleForId(r.xAxisID),t._yScale=i.getScaleForId(r.yAxisID),t._datasetIndex=i.index,t._index=e,t._model={backgroundColor:a.backgroundColor,borderColor:a.borderColor,borderSkipped:a.borderSkipped,borderWidth:a.borderWidth,datasetLabel:o.label,label:i.chart.data.labels[e]},V.isArray(o.data[e])&&(t._model.borderSkipped=null),i._updateElementGeometry(t,e,n,a),t.pivot()},_updateElementGeometry:function(t,e,n,i){var r=this,o=t._model,a=r._getValueScale(),s=a.getBasePixel(),l=a.isHorizontal(),c=r._ruler||r.getRuler(),u=r.calculateBarValuePixels(r.index,e,i),d=r.calculateBarIndexPixels(r.index,e,c,i);o.horizontal=l,o.base=n?s:u.base,o.x=l?n?s:u.head:d.center,o.y=l?d.center:n?s:u.head,o.height=l?d.size:void 0,o.width=l?void 0:d.size},_getStacks:function(t){var e,n,i=this._getIndexScale(),r=i._getMatchingVisibleMetas(this._type),o=i.options.stacked,a=r.length,s=[];for(e=0;e<a&&(n=r[e],(!1===o||-1===s.indexOf(n.stack)||void 0===o&&void 0===n.stack)&&s.push(n.stack),n.index!==t);++e);return s},getStackCount:function(){return this._getStacks().length},getStackIndex:function(t,e){var n=this._getStacks(t),i=void 0!==e?n.indexOf(e):-1;return-1===i?n.length-1:i},getRuler:function(){var t,e,n=this,i=n._getIndexScale(),r=[];for(t=0,e=n.getMeta().data.length;t<e;++t)r.push(i.getPixelForValue(null,t,n.index));return{pixels:r,start:i._startPixel,end:i._endPixel,stackCount:n.getStackCount(),scale:i}},calculateBarValuePixels:function(t,e,n){var i,r,o,a,s,l,c,u=this,d=u.chart,h=u._getValueScale(),f=h.isHorizontal(),p=d.data.datasets,m=h._getMatchingVisibleMetas(u._type),v=h._parseValue(p[t].data[e]),g=n.minBarLength,y=h.options.stacked,_=u.getMeta().stack,b=void 0===v.start?0:v.max>=0&&v.min>=0?v.min:v.max,w=void 0===v.start?v.end:v.max>=0&&v.min>=0?v.max-v.min:v.min-v.max,k=m.length;if(y||void 0===y&&void 0!==_)for(i=0;i<k&&(r=m[i]).index!==t;++i)r.stack===_&&(o=void 0===(c=h._parseValue(p[r.index].data[e])).start?c.end:c.min>=0&&c.max>=0?c.max:c.min,(v.min<0&&o<0||v.max>=0&&o>0)&&(b+=o));return a=h.getPixelForValue(b),l=(s=h.getPixelForValue(b+w))-a,void 0!==g&&Math.abs(l)<g&&(l=g,s=w>=0&&!f||w<0&&f?a-g:a+g),{size:l,base:a,head:s,center:s+l/2}},calculateBarIndexPixels:function(t,e,n,i){var r="flex"===i.barThickness?function(t,e,n){var i,r=e.pixels,o=r[t],a=t>0?r[t-1]:null,s=t<r.length-1?r[t+1]:null,l=n.categoryPercentage;return null===a&&(a=o-(null===s?e.end-e.start:s-o)),null===s&&(s=o+o-a),i=o-(o-Math.min(a,s))/2*l,{chunk:Math.abs(s-a)/2*l/e.stackCount,ratio:n.barPercentage,start:i}}(e,n,i):Bt(e,n,i),o=this.getStackIndex(t,this.getMeta().stack),a=r.start+r.chunk*o+r.chunk/2,s=Math.min(Ot(i.maxBarThickness,1/0),r.chunk*r.ratio);return{base:a-s/2,head:a+s/2,center:a,size:s}},draw:function(){var t=this,e=t.chart,n=t._getValueScale(),i=t.getMeta().data,r=t.getDataset(),o=i.length,a=0;for(V.canvas.clipArea(e.ctx,e.chartArea);a<o;++a){var s=n._parseValue(r.data[a]);isNaN(s.min)||isNaN(s.max)||i[a].draw()}V.canvas.unclipArea(e.ctx)},_resolveDataElementOptions:function(){var t=this,e=V.extend({},rt.prototype._resolveDataElementOptions.apply(t,arguments)),n=t._getIndexScale().options,i=t._getValueScale().options;return e.barPercentage=Ot(n.barPercentage,e.barPercentage),e.barThickness=Ot(n.barThickness,e.barThickness),e.categoryPercentage=Ot(n.categoryPercentage,e.categoryPercentage),e.maxBarThickness=Ot(n.maxBarThickness,e.maxBarThickness),e.minBarLength=Ot(i.minBarLength,e.minBarLength),e}}),At=V.valueOrDefault,Dt=V.options.resolve;I._set("bubble",{hover:{mode:"single"},scales:{xAxes:[{type:"linear",position:"bottom",id:"x-axis-0"}],yAxes:[{type:"linear",position:"left",id:"y-axis-0"}]},tooltips:{callbacks:{title:function(){return""},label:function(t,e){var n=e.datasets[t.datasetIndex].label||"",i=e.datasets[t.datasetIndex].data[t.index];return n+": ("+t.xLabel+", "+t.yLabel+", "+i.r+")"}}}});var Lt=rt.extend({dataElementType:xt.Point,_dataElementOptions:["backgroundColor","borderColor","borderWidth","hoverBackgroundColor","hoverBorderColor","hoverBorderWidth","hoverRadius","hitRadius","pointStyle","rotation"],update:function(t){var e=this,n=e.getMeta().data;V.each(n,(function(n,i){e.updateElement(n,i,t)}))},updateElement:function(t,e,n){var i=this,r=i.getMeta(),o=t.custom||{},a=i.getScaleForId(r.xAxisID),s=i.getScaleForId(r.yAxisID),l=i._resolveDataElementOptions(t,e),c=i.getDataset().data[e],u=i.index,d=n?a.getPixelForDecimal(.5):a.getPixelForValue("object"==typeof c?c:NaN,e,u),h=n?s.getBasePixel():s.getPixelForValue(c,e,u);t._xScale=a,t._yScale=s,t._options=l,t._datasetIndex=u,t._index=e,t._model={backgroundColor:l.backgroundColor,borderColor:l.borderColor,borderWidth:l.borderWidth,hitRadius:l.hitRadius,pointStyle:l.pointStyle,rotation:l.rotation,radius:n?0:l.radius,skip:o.skip||isNaN(d)||isNaN(h),x:d,y:h},t.pivot()},setHoverStyle:function(t){var e=t._model,n=t._options,i=V.getHoverColor;t.$previousStyle={backgroundColor:e.backgroundColor,borderColor:e.borderColor,borderWidth:e.borderWidth,radius:e.radius},e.backgroundColor=At(n.hoverBackgroundColor,i(n.backgroundColor)),e.borderColor=At(n.hoverBorderColor,i(n.borderColor)),e.borderWidth=At(n.hoverBorderWidth,n.borderWidth),e.radius=n.radius+n.hoverRadius},_resolveDataElementOptions:function(t,e){var n=this,i=n.chart,r=n.getDataset(),o=t.custom||{},a=r.data[e]||{},s=rt.prototype._resolveDataElementOptions.apply(n,arguments),l={chart:i,dataIndex:e,dataset:r,datasetIndex:n.index};return n._cachedDataOpts===s&&(s=V.extend({},s)),s.radius=Dt([o.radius,a.r,n._config.radius,i.options.elements.point.radius],l,e),s}}),qt=V.valueOrDefault,Rt=Math.PI,It=2*Rt,Nt=Rt/2;I._set("doughnut",{animation:{animateRotate:!0,animateScale:!1},hover:{mode:"single"},legendCallback:function(t){var e,n,i,r=document.createElement("ul"),o=t.data,a=o.datasets,s=o.labels;if(r.setAttribute("class",t.id+"-legend"),a.length)for(e=0,n=a[0].data.length;e<n;++e)(i=r.appendChild(document.createElement("li"))).appendChild(document.createElement("span")).style.backgroundColor=a[0].backgroundColor[e],s[e]&&i.appendChild(document.createTextNode(s[e]));return r.outerHTML},legend:{labels:{generateLabels:function(t){var e=t.data;return e.labels.length&&e.datasets.length?e.labels.map((function(n,i){var r=t.getDatasetMeta(0),o=r.controller.getStyle(i);return{text:n,fillStyle:o.backgroundColor,strokeStyle:o.borderColor,lineWidth:o.borderWidth,hidden:isNaN(e.datasets[0].data[i])||r.data[i].hidden,index:i}})):[]}},onClick:function(t,e){var n,i,r,o=e.index,a=this.chart;for(n=0,i=(a.data.datasets||[]).length;n<i;++n)(r=a.getDatasetMeta(n)).data[o]&&(r.data[o].hidden=!r.data[o].hidden);a.update()}},cutoutPercentage:50,rotation:-Nt,circumference:It,tooltips:{callbacks:{title:function(){return""},label:function(t,e){var n=e.labels[t.index],i=": "+e.datasets[t.datasetIndex].data[t.index];return V.isArray(n)?(n=n.slice())[0]+=i:n+=i,n}}}});var Ft=rt.extend({dataElementType:xt.Arc,linkScales:V.noop,_dataElementOptions:["backgroundColor","borderColor","borderWidth","borderAlign","hoverBackgroundColor","hoverBorderColor","hoverBorderWidth"],getRingIndex:function(t){for(var e=0,n=0;n<t;++n)this.chart.isDatasetVisible(n)&&++e;return e},update:function(t){var e,n,i,r,o=this,a=o.chart,s=a.chartArea,l=a.options,c=1,u=1,d=0,h=0,f=o.getMeta(),p=f.data,m=l.cutoutPercentage/100||0,v=l.circumference,g=o._getRingWeight(o.index);if(v<It){var y=l.rotation%It,_=(y+=y>=Rt?-It:y<-Rt?It:0)+v,b=Math.cos(y),w=Math.sin(y),k=Math.cos(_),x=Math.sin(_),C=y<=0&&_>=0||_>=It,S=y<=Nt&&_>=Nt||_>=It+Nt,M=y<=-Nt&&_>=-Nt||_>=Rt+Nt,T=y===-Rt||_>=Rt?-1:Math.min(b,b*m,k,k*m),P=M?-1:Math.min(w,w*m,x,x*m),O=C?1:Math.max(b,b*m,k,k*m),B=S?1:Math.max(w,w*m,x,x*m);c=(O-T)/2,u=(B-P)/2,d=-(O+T)/2,h=-(B+P)/2}for(i=0,r=p.length;i<r;++i)p[i]._options=o._resolveDataElementOptions(p[i],i);for(a.borderWidth=o.getMaxBorderWidth(),e=(s.right-s.left-a.borderWidth)/c,n=(s.bottom-s.top-a.borderWidth)/u,a.outerRadius=Math.max(Math.min(e,n)/2,0),a.innerRadius=Math.max(a.outerRadius*m,0),a.radiusLength=(a.outerRadius-a.innerRadius)/(o._getVisibleDatasetWeightTotal()||1),a.offsetX=d*a.outerRadius,a.offsetY=h*a.outerRadius,f.total=o.calculateTotal(),o.outerRadius=a.outerRadius-a.radiusLength*o._getRingWeightOffset(o.index),o.innerRadius=Math.max(o.outerRadius-a.radiusLength*g,0),i=0,r=p.length;i<r;++i)o.updateElement(p[i],i,t)},updateElement:function(t,e,n){var i=this,r=i.chart,o=r.chartArea,a=r.options,s=a.animation,l=(o.left+o.right)/2,c=(o.top+o.bottom)/2,u=a.rotation,d=a.rotation,h=i.getDataset(),f=n&&s.animateRotate||t.hidden?0:i.calculateCircumference(h.data[e])*(a.circumference/It),p=n&&s.animateScale?0:i.innerRadius,m=n&&s.animateScale?0:i.outerRadius,v=t._options||{};V.extend(t,{_datasetIndex:i.index,_index:e,_model:{backgroundColor:v.backgroundColor,borderColor:v.borderColor,borderWidth:v.borderWidth,borderAlign:v.borderAlign,x:l+r.offsetX,y:c+r.offsetY,startAngle:u,endAngle:d,circumference:f,outerRadius:m,innerRadius:p,label:V.valueAtIndexOrDefault(h.label,e,r.data.labels[e])}});var g=t._model;n&&s.animateRotate||(g.startAngle=0===e?a.rotation:i.getMeta().data[e-1]._model.endAngle,g.endAngle=g.startAngle+g.circumference),t.pivot()},calculateTotal:function(){var t,e=this.getDataset(),n=this.getMeta(),i=0;return V.each(n.data,(function(n,r){t=e.data[r],isNaN(t)||n.hidden||(i+=Math.abs(t))})),i},calculateCircumference:function(t){var e=this.getMeta().total;return e>0&&!isNaN(t)?It*(Math.abs(t)/e):0},getMaxBorderWidth:function(t){var e,n,i,r,o,a,s,l,c=0,u=this.chart;if(!t)for(e=0,n=u.data.datasets.length;e<n;++e)if(u.isDatasetVisible(e)){t=(i=u.getDatasetMeta(e)).data,e!==this.index&&(o=i.controller);break}if(!t)return 0;for(e=0,n=t.length;e<n;++e)r=t[e],o?(o._configure(),a=o._resolveDataElementOptions(r,e)):a=r._options,"inner"!==a.borderAlign&&(s=a.borderWidth,c=(l=a.hoverBorderWidth)>(c=s>c?s:c)?l:c);return c},setHoverStyle:function(t){var e=t._model,n=t._options,i=V.getHoverColor;t.$previousStyle={backgroundColor:e.backgroundColor,borderColor:e.borderColor,borderWidth:e.borderWidth},e.backgroundColor=qt(n.hoverBackgroundColor,i(n.backgroundColor)),e.borderColor=qt(n.hoverBorderColor,i(n.borderColor)),e.borderWidth=qt(n.hoverBorderWidth,n.borderWidth)},_getRingWeightOffset:function(t){for(var e=0,n=0;n<t;++n)this.chart.isDatasetVisible(n)&&(e+=this._getRingWeight(n));return e},_getRingWeight:function(t){return Math.max(qt(this.chart.data.datasets[t].weight,1),0)},_getVisibleDatasetWeightTotal:function(){return this._getRingWeightOffset(this.chart.data.datasets.length)}});I._set("horizontalBar",{hover:{mode:"index",axis:"y"},scales:{xAxes:[{type:"linear",position:"bottom"}],yAxes:[{type:"category",position:"left",offset:!0,gridLines:{offsetGridLines:!0}}]},elements:{rectangle:{borderSkipped:"left"}},tooltips:{mode:"index",axis:"y"}}),I._set("global",{datasets:{horizontalBar:{categoryPercentage:.8,barPercentage:.9}}});var $t=Et.extend({_getValueScaleId:function(){return this.getMeta().xAxisID},_getIndexScaleId:function(){return this.getMeta().yAxisID}}),jt=V.valueOrDefault,zt=V.options.resolve,Vt=V.canvas._isPointInArea;function Ht(t,e){var n=t&&t.options.ticks||{},i=n.reverse,r=void 0===n.min?e:0,o=void 0===n.max?e:0;return{start:i?o:r,end:i?r:o}}I._set("line",{showLines:!0,spanGaps:!1,hover:{mode:"label"},scales:{xAxes:[{type:"category",id:"x-axis-0"}],yAxes:[{type:"linear",id:"y-axis-0"}]}});var Wt=rt.extend({datasetElementType:xt.Line,dataElementType:xt.Point,_datasetElementOptions:["backgroundColor","borderCapStyle","borderColor","borderDash","borderDashOffset","borderJoinStyle","borderWidth","cubicInterpolationMode","fill"],_dataElementOptions:{backgroundColor:"pointBackgroundColor",borderColor:"pointBorderColor",borderWidth:"pointBorderWidth",hitRadius:"pointHitRadius",hoverBackgroundColor:"pointHoverBackgroundColor",hoverBorderColor:"pointHoverBorderColor",hoverBorderWidth:"pointHoverBorderWidth",hoverRadius:"pointHoverRadius",pointStyle:"pointStyle",radius:"pointRadius",rotation:"pointRotation"},update:function(t){var e,n,i=this,r=i.getMeta(),o=r.dataset,a=r.data||[],s=i.chart.options,l=i._config,c=i._showLine=jt(l.showLine,s.showLines);for(i._xScale=i.getScaleForId(r.xAxisID),i._yScale=i.getScaleForId(r.yAxisID),c&&(void 0!==l.tension&&void 0===l.lineTension&&(l.lineTension=l.tension),o._scale=i._yScale,o._datasetIndex=i.index,o._children=a,o._model=i._resolveDatasetElementOptions(o),o.pivot()),e=0,n=a.length;e<n;++e)i.updateElement(a[e],e,t);for(c&&0!==o._model.tension&&i.updateBezierControlPoints(),e=0,n=a.length;e<n;++e)a[e].pivot()},updateElement:function(t,e,n){var i,r,o=this,a=o.getMeta(),s=t.custom||{},l=o.getDataset(),c=o.index,u=l.data[e],d=o._xScale,h=o._yScale,f=a.dataset._model,p=o._resolveDataElementOptions(t,e);i=d.getPixelForValue("object"==typeof u?u:NaN,e,c),r=n?h.getBasePixel():o.calculatePointY(u,e,c),t._xScale=d,t._yScale=h,t._options=p,t._datasetIndex=c,t._index=e,t._model={x:i,y:r,skip:s.skip||isNaN(i)||isNaN(r),radius:p.radius,pointStyle:p.pointStyle,rotation:p.rotation,backgroundColor:p.backgroundColor,borderColor:p.borderColor,borderWidth:p.borderWidth,tension:jt(s.tension,f?f.tension:0),steppedLine:!!f&&f.steppedLine,hitRadius:p.hitRadius}},_resolveDatasetElementOptions:function(t){var e,n,i,r,o,a,s,l,c,u,d,h=this,f=h._config,p=t.custom||{},m=h.chart.options,v=m.elements.line,g=rt.prototype._resolveDatasetElementOptions.apply(h,arguments);return g.spanGaps=jt(f.spanGaps,m.spanGaps),g.tension=jt(f.lineTension,v.tension),g.steppedLine=zt([p.steppedLine,f.steppedLine,v.stepped]),g.clip=(e=jt(f.clip,(a=h._xScale,s=h._yScale,l=g.borderWidth,u=Ht(a,c=l/2),{top:(d=Ht(s,c)).end,right:u.end,bottom:d.start,left:u.start})),V.isObject(e)?(n=e.top,i=e.right,r=e.bottom,o=e.left):n=i=r=o=e,{top:n,right:i,bottom:r,left:o}),g},calculatePointY:function(t,e,n){var i,r,o,a,s,l,c,u=this.chart,d=this._yScale,h=0,f=0;if(d.options.stacked){for(s=+d.getRightValue(t),c=(l=u._getSortedVisibleDatasetMetas()).length,i=0;i<c&&(o=l[i]).index!==n;++i)r=u.data.datasets[o.index],"line"===o.type&&o.yAxisID===d.id&&((a=+d.getRightValue(r.data[e]))<0?f+=a||0:h+=a||0);return s<0?d.getPixelForValue(f+s):d.getPixelForValue(h+s)}return d.getPixelForValue(t)},updateBezierControlPoints:function(){var t,e,n,i,r=this.chart,o=this.getMeta(),a=o.dataset._model,s=r.chartArea,l=o.data||[];function c(t,e,n){return Math.max(Math.min(t,n),e)}if(a.spanGaps&&(l=l.filter((function(t){return!t._model.skip}))),"monotone"===a.cubicInterpolationMode)V.splineCurveMonotone(l);else for(t=0,e=l.length;t<e;++t)n=l[t]._model,i=V.splineCurve(V.previousItem(l,t)._model,n,V.nextItem(l,t)._model,a.tension),n.controlPointPreviousX=i.previous.x,n.controlPointPreviousY=i.previous.y,n.controlPointNextX=i.next.x,n.controlPointNextY=i.next.y;if(r.options.elements.line.capBezierPoints)for(t=0,e=l.length;t<e;++t)n=l[t]._model,Vt(n,s)&&(t>0&&Vt(l[t-1]._model,s)&&(n.controlPointPreviousX=c(n.controlPointPreviousX,s.left,s.right),n.controlPointPreviousY=c(n.controlPointPreviousY,s.top,s.bottom)),t<l.length-1&&Vt(l[t+1]._model,s)&&(n.controlPointNextX=c(n.controlPointNextX,s.left,s.right),n.controlPointNextY=c(n.controlPointNextY,s.top,s.bottom)))},draw:function(){var t,e=this,n=e.chart,i=e.getMeta(),r=i.data||[],o=n.chartArea,a=n.canvas,s=0,l=r.length;for(e._showLine&&(t=i.dataset._model.clip,V.canvas.clipArea(n.ctx,{left:!1===t.left?0:o.left-t.left,right:!1===t.right?a.width:o.right+t.right,top:!1===t.top?0:o.top-t.top,bottom:!1===t.bottom?a.height:o.bottom+t.bottom}),i.dataset.draw(),V.canvas.unclipArea(n.ctx));s<l;++s)r[s].draw(o)},setHoverStyle:function(t){var e=t._model,n=t._options,i=V.getHoverColor;t.$previousStyle={backgroundColor:e.backgroundColor,borderColor:e.borderColor,borderWidth:e.borderWidth,radius:e.radius},e.backgroundColor=jt(n.hoverBackgroundColor,i(n.backgroundColor)),e.borderColor=jt(n.hoverBorderColor,i(n.borderColor)),e.borderWidth=jt(n.hoverBorderWidth,n.borderWidth),e.radius=jt(n.hoverRadius,n.radius)}}),Ut=V.options.resolve;I._set("polarArea",{scale:{type:"radialLinear",angleLines:{display:!1},gridLines:{circular:!0},pointLabels:{display:!1},ticks:{beginAtZero:!0}},animation:{animateRotate:!0,animateScale:!0},startAngle:-.5*Math.PI,legendCallback:function(t){var e,n,i,r=document.createElement("ul"),o=t.data,a=o.datasets,s=o.labels;if(r.setAttribute("class",t.id+"-legend"),a.length)for(e=0,n=a[0].data.length;e<n;++e)(i=r.appendChild(document.createElement("li"))).appendChild(document.createElement("span")).style.backgroundColor=a[0].backgroundColor[e],s[e]&&i.appendChild(document.createTextNode(s[e]));return r.outerHTML},legend:{labels:{generateLabels:function(t){var e=t.data;return e.labels.length&&e.datasets.length?e.labels.map((function(n,i){var r=t.getDatasetMeta(0),o=r.controller.getStyle(i);return{text:n,fillStyle:o.backgroundColor,strokeStyle:o.borderColor,lineWidth:o.borderWidth,hidden:isNaN(e.datasets[0].data[i])||r.data[i].hidden,index:i}})):[]}},onClick:function(t,e){var n,i,r,o=e.index,a=this.chart;for(n=0,i=(a.data.datasets||[]).length;n<i;++n)(r=a.getDatasetMeta(n)).data[o].hidden=!r.data[o].hidden;a.update()}},tooltips:{callbacks:{title:function(){return""},label:function(t,e){return e.labels[t.index]+": "+t.yLabel}}}});var Yt=rt.extend({dataElementType:xt.Arc,linkScales:V.noop,_dataElementOptions:["backgroundColor","borderColor","borderWidth","borderAlign","hoverBackgroundColor","hoverBorderColor","hoverBorderWidth"],_getIndexScaleId:function(){return this.chart.scale.id},_getValueScaleId:function(){return this.chart.scale.id},update:function(t){var e,n,i,r=this,o=r.getDataset(),a=r.getMeta(),s=r.chart.options.startAngle||0,l=r._starts=[],c=r._angles=[],u=a.data;for(r._updateRadius(),a.count=r.countVisibleElements(),e=0,n=o.data.length;e<n;e++)l[e]=s,i=r._computeAngle(e),c[e]=i,s+=i;for(e=0,n=u.length;e<n;++e)u[e]._options=r._resolveDataElementOptions(u[e],e),r.updateElement(u[e],e,t)},_updateRadius:function(){var t=this,e=t.chart,n=e.chartArea,i=e.options,r=Math.min(n.right-n.left,n.bottom-n.top);e.outerRadius=Math.max(r/2,0),e.innerRadius=Math.max(i.cutoutPercentage?e.outerRadius/100*i.cutoutPercentage:1,0),e.radiusLength=(e.outerRadius-e.innerRadius)/e.getVisibleDatasetCount(),t.outerRadius=e.outerRadius-e.radiusLength*t.index,t.innerRadius=t.outerRadius-e.radiusLength},updateElement:function(t,e,n){var i=this,r=i.chart,o=i.getDataset(),a=r.options,s=a.animation,l=r.scale,c=r.data.labels,u=l.xCenter,d=l.yCenter,h=a.startAngle,f=t.hidden?0:l.getDistanceFromCenterForValue(o.data[e]),p=i._starts[e],m=p+(t.hidden?0:i._angles[e]),v=s.animateScale?0:l.getDistanceFromCenterForValue(o.data[e]),g=t._options||{};V.extend(t,{_datasetIndex:i.index,_index:e,_scale:l,_model:{backgroundColor:g.backgroundColor,borderColor:g.borderColor,borderWidth:g.borderWidth,borderAlign:g.borderAlign,x:u,y:d,innerRadius:0,outerRadius:n?v:f,startAngle:n&&s.animateRotate?h:p,endAngle:n&&s.animateRotate?h:m,label:V.valueAtIndexOrDefault(c,e,c[e])}}),t.pivot()},countVisibleElements:function(){var t=this.getDataset(),e=this.getMeta(),n=0;return V.each(e.data,(function(e,i){isNaN(t.data[i])||e.hidden||n++})),n},setHoverStyle:function(t){var e=t._model,n=t._options,i=V.getHoverColor,r=V.valueOrDefault;t.$previousStyle={backgroundColor:e.backgroundColor,borderColor:e.borderColor,borderWidth:e.borderWidth},e.backgroundColor=r(n.hoverBackgroundColor,i(n.backgroundColor)),e.borderColor=r(n.hoverBorderColor,i(n.borderColor)),e.borderWidth=r(n.hoverBorderWidth,n.borderWidth)},_computeAngle:function(t){var e=this,n=this.getMeta().count,i=e.getDataset(),r=e.getMeta();if(isNaN(i.data[t])||r.data[t].hidden)return 0;var o={chart:e.chart,dataIndex:t,dataset:i,datasetIndex:e.index};return Ut([e.chart.options.elements.arc.angle,2*Math.PI/n],o,t)}});I._set("pie",V.clone(I.doughnut)),I._set("pie",{cutoutPercentage:0});var Qt=Ft,Gt=V.valueOrDefault;I._set("radar",{spanGaps:!1,scale:{type:"radialLinear"},elements:{line:{fill:"start",tension:0}}});var Kt=rt.extend({datasetElementType:xt.Line,dataElementType:xt.Point,linkScales:V.noop,_datasetElementOptions:["backgroundColor","borderWidth","borderColor","borderCapStyle","borderDash","borderDashOffset","borderJoinStyle","fill"],_dataElementOptions:{backgroundColor:"pointBackgroundColor",borderColor:"pointBorderColor",borderWidth:"pointBorderWidth",hitRadius:"pointHitRadius",hoverBackgroundColor:"pointHoverBackgroundColor",hoverBorderColor:"pointHoverBorderColor",hoverBorderWidth:"pointHoverBorderWidth",hoverRadius:"pointHoverRadius",pointStyle:"pointStyle",radius:"pointRadius",rotation:"pointRotation"},_getIndexScaleId:function(){return this.chart.scale.id},_getValueScaleId:function(){return this.chart.scale.id},update:function(t){var e,n,i=this,r=i.getMeta(),o=r.dataset,a=r.data||[],s=i.chart.scale,l=i._config;for(void 0!==l.tension&&void 0===l.lineTension&&(l.lineTension=l.tension),o._scale=s,o._datasetIndex=i.index,o._children=a,o._loop=!0,o._model=i._resolveDatasetElementOptions(o),o.pivot(),e=0,n=a.length;e<n;++e)i.updateElement(a[e],e,t);for(i.updateBezierControlPoints(),e=0,n=a.length;e<n;++e)a[e].pivot()},updateElement:function(t,e,n){var i=this,r=t.custom||{},o=i.getDataset(),a=i.chart.scale,s=a.getPointPositionForValue(e,o.data[e]),l=i._resolveDataElementOptions(t,e),c=i.getMeta().dataset._model,u=n?a.xCenter:s.x,d=n?a.yCenter:s.y;t._scale=a,t._options=l,t._datasetIndex=i.index,t._index=e,t._model={x:u,y:d,skip:r.skip||isNaN(u)||isNaN(d),radius:l.radius,pointStyle:l.pointStyle,rotation:l.rotation,backgroundColor:l.backgroundColor,borderColor:l.borderColor,borderWidth:l.borderWidth,tension:Gt(r.tension,c?c.tension:0),hitRadius:l.hitRadius}},_resolveDatasetElementOptions:function(){var t=this,e=t._config,n=t.chart.options,i=rt.prototype._resolveDatasetElementOptions.apply(t,arguments);return i.spanGaps=Gt(e.spanGaps,n.spanGaps),i.tension=Gt(e.lineTension,n.elements.line.tension),i},updateBezierControlPoints:function(){var t,e,n,i,r=this.getMeta(),o=this.chart.chartArea,a=r.data||[];function s(t,e,n){return Math.max(Math.min(t,n),e)}for(r.dataset._model.spanGaps&&(a=a.filter((function(t){return!t._model.skip}))),t=0,e=a.length;t<e;++t)n=a[t]._model,i=V.splineCurve(V.previousItem(a,t,!0)._model,n,V.nextItem(a,t,!0)._model,n.tension),n.controlPointPreviousX=s(i.previous.x,o.left,o.right),n.controlPointPreviousY=s(i.previous.y,o.top,o.bottom),n.controlPointNextX=s(i.next.x,o.left,o.right),n.controlPointNextY=s(i.next.y,o.top,o.bottom)},setHoverStyle:function(t){var e=t._model,n=t._options,i=V.getHoverColor;t.$previousStyle={backgroundColor:e.backgroundColor,borderColor:e.borderColor,borderWidth:e.borderWidth,radius:e.radius},e.backgroundColor=Gt(n.hoverBackgroundColor,i(n.backgroundColor)),e.borderColor=Gt(n.hoverBorderColor,i(n.borderColor)),e.borderWidth=Gt(n.hoverBorderWidth,n.borderWidth),e.radius=Gt(n.hoverRadius,n.radius)}});I._set("scatter",{hover:{mode:"single"},scales:{xAxes:[{id:"x-axis-1",type:"linear",position:"bottom"}],yAxes:[{id:"y-axis-1",type:"linear",position:"left"}]},tooltips:{callbacks:{title:function(){return""},label:function(t){return"("+t.xLabel+", "+t.yLabel+")"}}}}),I._set("global",{datasets:{scatter:{showLine:!1}}});var Jt={bar:Et,bubble:Lt,doughnut:Ft,horizontalBar:$t,line:Wt,polarArea:Yt,pie:Qt,radar:Kt,scatter:Wt};function Zt(t,e){return t.native?{x:t.x,y:t.y}:V.getRelativePosition(t,e)}function Xt(t,e){var n,i,r,o,a,s,l=t._getSortedVisibleDatasetMetas();for(i=0,o=l.length;i<o;++i)for(r=0,a=(n=l[i].data).length;r<a;++r)(s=n[r])._view.skip||e(s)}function te(t,e){var n=[];return Xt(t,(function(t){t.inRange(e.x,e.y)&&n.push(t)})),n}function ee(t,e,n,i){var r=Number.POSITIVE_INFINITY,o=[];return Xt(t,(function(t){if(!n||t.inRange(e.x,e.y)){var a=t.getCenterPoint(),s=i(e,a);s<r?(o=[t],r=s):s===r&&o.push(t)}})),o}function ne(t){var e=-1!==t.indexOf("x"),n=-1!==t.indexOf("y");return function(t,i){var r=e?Math.abs(t.x-i.x):0,o=n?Math.abs(t.y-i.y):0;return Math.sqrt(Math.pow(r,2)+Math.pow(o,2))}}function ie(t,e,n){var i=Zt(e,t);n.axis=n.axis||"x";var r=ne(n.axis),o=n.intersect?te(t,i):ee(t,i,!1,r),a=[];return o.length?(t._getSortedVisibleDatasetMetas().forEach((function(t){var e=t.data[o[0]._index];e&&!e._view.skip&&a.push(e)})),a):[]}var re={modes:{single:function(t,e){var n=Zt(e,t),i=[];return Xt(t,(function(t){if(t.inRange(n.x,n.y))return i.push(t),i})),i.slice(0,1)},label:ie,index:ie,dataset:function(t,e,n){var i=Zt(e,t);n.axis=n.axis||"xy";var r=ne(n.axis),o=n.intersect?te(t,i):ee(t,i,!1,r);return o.length>0&&(o=t.getDatasetMeta(o[0]._datasetIndex).data),o},"x-axis":function(t,e){return ie(t,e,{intersect:!1})},point:function(t,e){return te(t,Zt(e,t))},nearest:function(t,e,n){var i=Zt(e,t);n.axis=n.axis||"xy";var r=ne(n.axis);return ee(t,i,n.intersect,r)},x:function(t,e,n){var i=Zt(e,t),r=[],o=!1;return Xt(t,(function(t){t.inXRange(i.x)&&r.push(t),t.inRange(i.x,i.y)&&(o=!0)})),n.intersect&&!o&&(r=[]),r},y:function(t,e,n){var i=Zt(e,t),r=[],o=!1;return Xt(t,(function(t){t.inYRange(i.y)&&r.push(t),t.inRange(i.x,i.y)&&(o=!0)})),n.intersect&&!o&&(r=[]),r}}},oe=V.extend;function ae(t,e){return V.where(t,(function(t){return t.pos===e}))}function se(t,e){return t.sort((function(t,n){var i=e?n:t,r=e?t:n;return i.weight===r.weight?i.index-r.index:i.weight-r.weight}))}function le(t,e,n,i){return Math.max(t[n],e[n])+Math.max(t[i],e[i])}function ce(t,e,n){var i,r,o=n.box,a=t.maxPadding;if(n.size&&(t[n.pos]-=n.size),n.size=n.horizontal?o.height:o.width,t[n.pos]+=n.size,o.getPadding){var s=o.getPadding();a.top=Math.max(a.top,s.top),a.left=Math.max(a.left,s.left),a.bottom=Math.max(a.bottom,s.bottom),a.right=Math.max(a.right,s.right)}if(i=e.outerWidth-le(a,t,"left","right"),r=e.outerHeight-le(a,t,"top","bottom"),i!==t.w||r!==t.h){t.w=i,t.h=r;var l=n.horizontal?[i,t.w]:[r,t.h];return!(l[0]===l[1]||isNaN(l[0])&&isNaN(l[1]))}}function ue(t,e){var n=e.maxPadding;function i(t){var i={left:0,top:0,right:0,bottom:0};return t.forEach((function(t){i[t]=Math.max(e[t],n[t])})),i}return i(t?["left","right"]:["top","bottom"])}function de(t,e,n){var i,r,o,a,s,l,c=[];for(i=0,r=t.length;i<r;++i)(a=(o=t[i]).box).update(o.width||e.w,o.height||e.h,ue(o.horizontal,e)),ce(e,n,o)&&(l=!0,c.length&&(s=!0)),a.fullWidth||c.push(o);return s&&de(c,e,n)||l}function he(t,e,n){var i,r,o,a,s=n.padding,l=e.x,c=e.y;for(i=0,r=t.length;i<r;++i)a=(o=t[i]).box,o.horizontal?(a.left=a.fullWidth?s.left:e.left,a.right=a.fullWidth?n.outerWidth-s.right:e.left+e.w,a.top=c,a.bottom=c+a.height,a.width=a.right-a.left,c=a.bottom):(a.left=l,a.right=l+a.width,a.top=e.top,a.bottom=e.top+e.h,a.height=a.bottom-a.top,l=a.right);e.x=l,e.y=c}I._set("global",{layout:{padding:{top:0,right:0,bottom:0,left:0}}});var fe,pe={defaults:{},addBox:function(t,e){t.boxes||(t.boxes=[]),e.fullWidth=e.fullWidth||!1,e.position=e.position||"top",e.weight=e.weight||0,e._layers=e._layers||function(){return[{z:0,draw:function(){e.draw.apply(e,arguments)}}]},t.boxes.push(e)},removeBox:function(t,e){var n=t.boxes?t.boxes.indexOf(e):-1;-1!==n&&t.boxes.splice(n,1)},configure:function(t,e,n){for(var i,r=["fullWidth","position","weight"],o=r.length,a=0;a<o;++a)i=r[a],n.hasOwnProperty(i)&&(e[i]=n[i])},update:function(t,e,n){if(t){var i=t.options.layout||{},r=V.options.toPadding(i.padding),o=e-r.width,a=n-r.height,s=function(t){var e=function(t){var e,n,i,r=[];for(e=0,n=(t||[]).length;e<n;++e)i=t[e],r.push({index:e,box:i,pos:i.position,horizontal:i.isHorizontal(),weight:i.weight});return r}(t),n=se(ae(e,"left"),!0),i=se(ae(e,"right")),r=se(ae(e,"top"),!0),o=se(ae(e,"bottom"));return{leftAndTop:n.concat(r),rightAndBottom:i.concat(o),chartArea:ae(e,"chartArea"),vertical:n.concat(i),horizontal:r.concat(o)}}(t.boxes),l=s.vertical,c=s.horizontal,u=Object.freeze({outerWidth:e,outerHeight:n,padding:r,availableWidth:o,vBoxMaxWidth:o/2/l.length,hBoxMaxHeight:a/2}),d=oe({maxPadding:oe({},r),w:o,h:a,x:r.left,y:r.top},r);!function(t,e){var n,i,r;for(n=0,i=t.length;n<i;++n)(r=t[n]).width=r.horizontal?r.box.fullWidth&&e.availableWidth:e.vBoxMaxWidth,r.height=r.horizontal&&e.hBoxMaxHeight}(l.concat(c),u),de(l,d,u),de(c,d,u)&&de(l,d,u),function(t){var e=t.maxPadding;function n(n){var i=Math.max(e[n]-t[n],0);return t[n]+=i,i}t.y+=n("top"),t.x+=n("left"),n("right"),n("bottom")}(d),he(s.leftAndTop,d,u),d.x+=d.w,d.y+=d.h,he(s.rightAndBottom,d,u),t.chartArea={left:d.left,top:d.top,right:d.left+d.w,bottom:d.top+d.h},V.each(s.chartArea,(function(e){var n=e.box;oe(n,t.chartArea),n.update(d.w,d.h)}))}}},me=(fe=Object.freeze({__proto__:null,default:"/*\r\n * DOM element rendering detection\r\n * https://davidwalsh.name/detect-node-insertion\r\n */\r\n@keyframes chartjs-render-animation {\r\n\tfrom { opacity: 0.99; }\r\n\tto { opacity: 1; }\r\n}\r\n\r\n.chartjs-render-monitor {\r\n\tanimation: chartjs-render-animation 0.001s;\r\n}\r\n\r\n/*\r\n * DOM element resizing detection\r\n * https://github.com/marcj/css-element-queries\r\n */\r\n.chartjs-size-monitor,\r\n.chartjs-size-monitor-expand,\r\n.chartjs-size-monitor-shrink {\r\n\tposition: absolute;\r\n\tdirection: ltr;\r\n\tleft: 0;\r\n\ttop: 0;\r\n\tright: 0;\r\n\tbottom: 0;\r\n\toverflow: hidden;\r\n\tpointer-events: none;\r\n\tvisibility: hidden;\r\n\tz-index: -1;\r\n}\r\n\r\n.chartjs-size-monitor-expand > div {\r\n\tposition: absolute;\r\n\twidth: 1000000px;\r\n\theight: 1000000px;\r\n\tleft: 0;\r\n\ttop: 0;\r\n}\r\n\r\n.chartjs-size-monitor-shrink > div {\r\n\tposition: absolute;\r\n\twidth: 200%;\r\n\theight: 200%;\r\n\tleft: 0;\r\n\ttop: 0;\r\n}\r\n"}))&&fe.default||fe,ve="$chartjs",ge="chartjs-",ye=ge+"size-monitor",_e=ge+"render-monitor",be=ge+"render-animation",we=["animationstart","webkitAnimationStart"],ke={touchstart:"mousedown",touchmove:"mousemove",touchend:"mouseup",pointerenter:"mouseenter",pointerdown:"mousedown",pointermove:"mousemove",pointerup:"mouseup",pointerleave:"mouseout",pointerout:"mouseout"};function xe(t,e){var n=V.getStyle(t,e),i=n&&n.match(/^(\d+)(\.\d+)?px$/);return i?Number(i[1]):void 0}var Ce=function(){var t=!1;try{var e=Object.defineProperty({},"passive",{get:function(){t=!0}});window.addEventListener("e",null,e)}catch(t){}return t}(),Se=!!Ce&&{passive:!0};function Me(t,e,n){t.addEventListener(e,n,Se)}function Te(t,e,n){t.removeEventListener(e,n,Se)}function Pe(t,e,n,i,r){return{type:t,chart:e,native:r||null,x:void 0!==n?n:null,y:void 0!==i?i:null}}function Oe(t){var e=document.createElement("div");return e.className=t||"",e}function Be(t,e,n){var i,r,o,a,s=t[ve]||(t[ve]={}),l=s.resizer=function(t){var e=1e6,n=Oe(ye),i=Oe(ye+"-expand"),r=Oe(ye+"-shrink");i.appendChild(Oe()),r.appendChild(Oe()),n.appendChild(i),n.appendChild(r),n._reset=function(){i.scrollLeft=e,i.scrollTop=e,r.scrollLeft=e,r.scrollTop=e};var o=function(){n._reset(),t()};return Me(i,"scroll",o.bind(i,"expand")),Me(r,"scroll",o.bind(r,"shrink")),n}((i=function(){if(s.resizer){var i=n.options.maintainAspectRatio&&t.parentNode,r=i?i.clientWidth:0;e(Pe("resize",n)),i&&i.clientWidth<r&&n.canvas&&e(Pe("resize",n))}},o=!1,a=[],function(){a=Array.prototype.slice.call(arguments),r=r||this,o||(o=!0,V.requestAnimFrame.call(window,(function(){o=!1,i.apply(r,a)})))}));!function(t,e){var n=t[ve]||(t[ve]={}),i=n.renderProxy=function(t){t.animationName===be&&e()};V.each(we,(function(e){Me(t,e,i)})),n.reflow=!!t.offsetParent,t.classList.add(_e)}(t,(function(){if(s.resizer){var e=t.parentNode;e&&e!==l.parentNode&&e.insertBefore(l,e.firstChild),l._reset()}}))}function Ee(t){var e=t[ve]||{},n=e.resizer;delete e.resizer,function(t){var e=t[ve]||{},n=e.renderProxy;n&&(V.each(we,(function(e){Te(t,e,n)})),delete e.renderProxy),t.classList.remove(_e)}(t),n&&n.parentNode&&n.parentNode.removeChild(n)}var Ae={disableCSSInjection:!1,_enabled:"undefined"!=typeof window&&"undefined"!=typeof document,_ensureLoaded:function(t){if(!this.disableCSSInjection){var e=t.getRootNode?t.getRootNode():document;!function(t,e){var n=t[ve]||(t[ve]={});if(!n.containsStyles){n.containsStyles=!0,e="/* Chart.js */\n"+e;var i=document.createElement("style");i.setAttribute("type","text/css"),i.appendChild(document.createTextNode(e)),t.appendChild(i)}}(e.host?e:document.head,me)}},acquireContext:function(t,e){"string"==typeof t?t=document.getElementById(t):t.length&&(t=t[0]),t&&t.canvas&&(t=t.canvas);var n=t&&t.getContext&&t.getContext("2d");return n&&n.canvas===t?(this._ensureLoaded(t),function(t,e){var n=t.style,i=t.getAttribute("height"),r=t.getAttribute("width");if(t[ve]={initial:{height:i,width:r,style:{display:n.display,height:n.height,width:n.width}}},n.display=n.display||"block",null===r||""===r){var o=xe(t,"width");void 0!==o&&(t.width=o)}if(null===i||""===i)if(""===t.style.height)t.height=t.width/(e.options.aspectRatio||2);else{var a=xe(t,"height");void 0!==o&&(t.height=a)}}(t,e),n):null},releaseContext:function(t){var e=t.canvas;if(e[ve]){var n=e[ve].initial;["height","width"].forEach((function(t){var i=n[t];V.isNullOrUndef(i)?e.removeAttribute(t):e.setAttribute(t,i)})),V.each(n.style||{},(function(t,n){e.style[n]=t})),e.width=e.width,delete e[ve]}},addEventListener:function(t,e,n){var i=t.canvas;if("resize"!==e){var r=n[ve]||(n[ve]={}),o=(r.proxies||(r.proxies={}))[t.id+"_"+e]=function(e){n(function(t,e){var n=ke[t.type]||t.type,i=V.getRelativePosition(t,e);return Pe(n,e,i.x,i.y,t)}(e,t))};Me(i,e,o)}else Be(i,n,t)},removeEventListener:function(t,e,n){var i=t.canvas;if("resize"!==e){var r=((n[ve]||{}).proxies||{})[t.id+"_"+e];r&&Te(i,e,r)}else Ee(i)}};V.addEvent=Me,V.removeEvent=Te;var De=Ae._enabled?Ae:{acquireContext:function(t){return t&&t.canvas&&(t=t.canvas),t&&t.getContext("2d")||null}},Le=V.extend({initialize:function(){},acquireContext:function(){},releaseContext:function(){},addEventListener:function(){},removeEventListener:function(){}},De);I._set("global",{plugins:{}});var qe={_plugins:[],_cacheId:0,register:function(t){var e=this._plugins;[].concat(t).forEach((function(t){-1===e.indexOf(t)&&e.push(t)})),this._cacheId++},unregister:function(t){var e=this._plugins;[].concat(t).forEach((function(t){var n=e.indexOf(t);-1!==n&&e.splice(n,1)})),this._cacheId++},clear:function(){this._plugins=[],this._cacheId++},count:function(){return this._plugins.length},getAll:function(){return this._plugins},notify:function(t,e,n){var i,r,o,a,s,l=this.descriptors(t),c=l.length;for(i=0;i<c;++i)if("function"==typeof(s=(o=(r=l[i]).plugin)[e])&&((a=[t].concat(n||[])).push(r.options),!1===s.apply(o,a)))return!1;return!0},descriptors:function(t){var e=t.$plugins||(t.$plugins={});if(e.id===this._cacheId)return e.descriptors;var n=[],i=[],r=t&&t.config||{},o=r.options&&r.options.plugins||{};return this._plugins.concat(r.plugins||[]).forEach((function(t){if(-1===n.indexOf(t)){var e=t.id,r=o[e];!1!==r&&(!0===r&&(r=V.clone(I.global.plugins[e])),n.push(t),i.push({plugin:t,options:r||{}}))}})),e.descriptors=i,e.id=this._cacheId,i},_invalidate:function(t){delete t.$plugins}},Re={constructors:{},defaults:{},registerScaleType:function(t,e,n){this.constructors[t]=e,this.defaults[t]=V.clone(n)},getScaleConstructor:function(t){return this.constructors.hasOwnProperty(t)?this.constructors[t]:void 0},getScaleDefaults:function(t){return this.defaults.hasOwnProperty(t)?V.merge(Object.create(null),[I.scale,this.defaults[t]]):{}},updateScaleDefaults:function(t,e){var n=this;n.defaults.hasOwnProperty(t)&&(n.defaults[t]=V.extend(n.defaults[t],e))},addScalesToLayout:function(t){V.each(t.scales,(function(e){e.fullWidth=e.options.fullWidth,e.position=e.options.position,e.weight=e.options.weight,pe.addBox(t,e)}))}},Ie=V.valueOrDefault,Ne=V.rtl.getRtlAdapter;I._set("global",{tooltips:{enabled:!0,custom:null,mode:"nearest",position:"average",intersect:!0,backgroundColor:"rgba(0,0,0,0.8)",titleFontStyle:"bold",titleSpacing:2,titleMarginBottom:6,titleFontColor:"#fff",titleAlign:"left",bodySpacing:2,bodyFontColor:"#fff",bodyAlign:"left",footerFontStyle:"bold",footerSpacing:2,footerMarginTop:6,footerFontColor:"#fff",footerAlign:"left",yPadding:6,xPadding:6,caretPadding:2,caretSize:5,cornerRadius:6,multiKeyBackground:"#fff",displayColors:!0,borderColor:"rgba(0,0,0,0)",borderWidth:0,callbacks:{beforeTitle:V.noop,title:function(t,e){var n="",i=e.labels,r=i?i.length:0;if(t.length>0){var o=t[0];o.label?n=o.label:o.xLabel?n=o.xLabel:r>0&&o.index<r&&(n=i[o.index])}return n},afterTitle:V.noop,beforeBody:V.noop,beforeLabel:V.noop,label:function(t,e){var n=e.datasets[t.datasetIndex].label||"";return n&&(n+=": "),V.isNullOrUndef(t.value)?n+=t.yLabel:n+=t.value,n},labelColor:function(t,e){var n=e.getDatasetMeta(t.datasetIndex).data[t.index]._view;return{borderColor:n.borderColor,backgroundColor:n.backgroundColor}},labelTextColor:function(){return this._options.bodyFontColor},afterLabel:V.noop,afterBody:V.noop,beforeFooter:V.noop,footer:V.noop,afterFooter:V.noop}}});var Fe={average:function(t){if(!t.length)return!1;var e,n,i=0,r=0,o=0;for(e=0,n=t.length;e<n;++e){var a=t[e];if(a&&a.hasValue()){var s=a.tooltipPosition();i+=s.x,r+=s.y,++o}}return{x:i/o,y:r/o}},nearest:function(t,e){var n,i,r,o=e.x,a=e.y,s=Number.POSITIVE_INFINITY;for(n=0,i=t.length;n<i;++n){var l=t[n];if(l&&l.hasValue()){var c=l.getCenterPoint(),u=V.distanceBetweenPoints(e,c);u<s&&(s=u,r=l)}}if(r){var d=r.tooltipPosition();o=d.x,a=d.y}return{x:o,y:a}}};function $e(t,e){return e&&(V.isArray(e)?Array.prototype.push.apply(t,e):t.push(e)),t}function je(t){return("string"==typeof t||t instanceof String)&&t.indexOf("\n")>-1?t.split("\n"):t}function ze(t){var e=I.global;return{xPadding:t.xPadding,yPadding:t.yPadding,xAlign:t.xAlign,yAlign:t.yAlign,rtl:t.rtl,textDirection:t.textDirection,bodyFontColor:t.bodyFontColor,_bodyFontFamily:Ie(t.bodyFontFamily,e.defaultFontFamily),_bodyFontStyle:Ie(t.bodyFontStyle,e.defaultFontStyle),_bodyAlign:t.bodyAlign,bodyFontSize:Ie(t.bodyFontSize,e.defaultFontSize),bodySpacing:t.bodySpacing,titleFontColor:t.titleFontColor,_titleFontFamily:Ie(t.titleFontFamily,e.defaultFontFamily),_titleFontStyle:Ie(t.titleFontStyle,e.defaultFontStyle),titleFontSize:Ie(t.titleFontSize,e.defaultFontSize),_titleAlign:t.titleAlign,titleSpacing:t.titleSpacing,titleMarginBottom:t.titleMarginBottom,footerFontColor:t.footerFontColor,_footerFontFamily:Ie(t.footerFontFamily,e.defaultFontFamily),_footerFontStyle:Ie(t.footerFontStyle,e.defaultFontStyle),footerFontSize:Ie(t.footerFontSize,e.defaultFontSize),_footerAlign:t.footerAlign,footerSpacing:t.footerSpacing,footerMarginTop:t.footerMarginTop,caretSize:t.caretSize,cornerRadius:t.cornerRadius,backgroundColor:t.backgroundColor,opacity:0,legendColorBackground:t.multiKeyBackground,displayColors:t.displayColors,borderColor:t.borderColor,borderWidth:t.borderWidth}}function Ve(t,e){return"center"===e?t.x+t.width/2:"right"===e?t.x+t.width-t.xPadding:t.x+t.xPadding}function He(t){return $e([],je(t))}var We=K.extend({initialize:function(){this._model=ze(this._options),this._lastActive=[]},getTitle:function(){var t=this,e=t._options.callbacks,n=e.beforeTitle.apply(t,arguments),i=e.title.apply(t,arguments),r=e.afterTitle.apply(t,arguments),o=[];return o=$e(o,je(n)),o=$e(o,je(i)),o=$e(o,je(r))},getBeforeBody:function(){return He(this._options.callbacks.beforeBody.apply(this,arguments))},getBody:function(t,e){var n=this,i=n._options.callbacks,r=[];return V.each(t,(function(t){var o={before:[],lines:[],after:[]};$e(o.before,je(i.beforeLabel.call(n,t,e))),$e(o.lines,i.label.call(n,t,e)),$e(o.after,je(i.afterLabel.call(n,t,e))),r.push(o)})),r},getAfterBody:function(){return He(this._options.callbacks.afterBody.apply(this,arguments))},getFooter:function(){var t=this,e=t._options.callbacks,n=e.beforeFooter.apply(t,arguments),i=e.footer.apply(t,arguments),r=e.afterFooter.apply(t,arguments),o=[];return o=$e(o,je(n)),o=$e(o,je(i)),o=$e(o,je(r))},update:function(t){var e,n,i,r,o,a,s,l,c,u,d=this,h=d._options,f=d._model,p=d._model=ze(h),m=d._active,v=d._data,g={xAlign:f.xAlign,yAlign:f.yAlign},y={x:f.x,y:f.y},_={width:f.width,height:f.height},b={x:f.caretX,y:f.caretY};if(m.length){p.opacity=1;var w=[],k=[];b=Fe[h.position].call(d,m,d._eventPosition);var x=[];for(e=0,n=m.length;e<n;++e)x.push((i=m[e],r=void 0,o=void 0,a=void 0,s=void 0,l=void 0,c=void 0,u=void 0,r=i._xScale,o=i._yScale||i._scale,a=i._index,s=i._datasetIndex,l=i._chart.getDatasetMeta(s).controller,c=l._getIndexScale(),u=l._getValueScale(),{xLabel:r?r.getLabelForIndex(a,s):"",yLabel:o?o.getLabelForIndex(a,s):"",label:c?""+c.getLabelForIndex(a,s):"",value:u?""+u.getLabelForIndex(a,s):"",index:a,datasetIndex:s,x:i._model.x,y:i._model.y}));h.filter&&(x=x.filter((function(t){return h.filter(t,v)}))),h.itemSort&&(x=x.sort((function(t,e){return h.itemSort(t,e,v)}))),V.each(x,(function(t){w.push(h.callbacks.labelColor.call(d,t,d._chart)),k.push(h.callbacks.labelTextColor.call(d,t,d._chart))})),p.title=d.getTitle(x,v),p.beforeBody=d.getBeforeBody(x,v),p.body=d.getBody(x,v),p.afterBody=d.getAfterBody(x,v),p.footer=d.getFooter(x,v),p.x=b.x,p.y=b.y,p.caretPadding=h.caretPadding,p.labelColors=w,p.labelTextColors=k,p.dataPoints=x,_=function(t,e){var n=t._chart.ctx,i=2*e.yPadding,r=0,o=e.body,a=o.reduce((function(t,e){return t+e.before.length+e.lines.length+e.after.length}),0);a+=e.beforeBody.length+e.afterBody.length;var s=e.title.length,l=e.footer.length,c=e.titleFontSize,u=e.bodyFontSize,d=e.footerFontSize;i+=s*c,i+=s?(s-1)*e.titleSpacing:0,i+=s?e.titleMarginBottom:0,i+=a*u,i+=a?(a-1)*e.bodySpacing:0,i+=l?e.footerMarginTop:0,i+=l*d,i+=l?(l-1)*e.footerSpacing:0;var h=0,f=function(t){r=Math.max(r,n.measureText(t).width+h)};return n.font=V.fontString(c,e._titleFontStyle,e._titleFontFamily),V.each(e.title,f),n.font=V.fontString(u,e._bodyFontStyle,e._bodyFontFamily),V.each(e.beforeBody.concat(e.afterBody),f),h=e.displayColors?u+2:0,V.each(o,(function(t){V.each(t.before,f),V.each(t.lines,f),V.each(t.after,f)})),h=0,n.font=V.fontString(d,e._footerFontStyle,e._footerFontFamily),V.each(e.footer,f),{width:r+=2*e.xPadding,height:i}}(this,p),g=function(t,e){var n,i,r,o,a,s=t._model,l=t._chart,c=t._chart.chartArea,u="center",d="center";s.y<e.height?d="top":s.y>l.height-e.height&&(d="bottom");var h=(c.left+c.right)/2,f=(c.top+c.bottom)/2;"center"===d?(n=function(t){return t<=h},i=function(t){return t>h}):(n=function(t){return t<=e.width/2},i=function(t){return t>=l.width-e.width/2}),r=function(t){return t+e.width+s.caretSize+s.caretPadding>l.width},o=function(t){return t-e.width-s.caretSize-s.caretPadding<0},a=function(t){return t<=f?"top":"bottom"},n(s.x)?(u="left",r(s.x)&&(u="center",d=a(s.y))):i(s.x)&&(u="right",o(s.x)&&(u="center",d=a(s.y)));var p=t._options;return{xAlign:p.xAlign?p.xAlign:u,yAlign:p.yAlign?p.yAlign:d}}(this,_),y=function(t,e,n,i){var r=t.x,o=t.y,a=t.caretSize,s=t.caretPadding,l=t.cornerRadius,c=n.xAlign,u=n.yAlign,d=a+s,h=l+s;return"right"===c?r-=e.width:"center"===c&&((r-=e.width/2)+e.width>i.width&&(r=i.width-e.width),r<0&&(r=0)),"top"===u?o+=d:o-="bottom"===u?e.height+d:e.height/2,"center"===u?"left"===c?r+=d:"right"===c&&(r-=d):"left"===c?r-=h:"right"===c&&(r+=h),{x:r,y:o}}(p,_,g,d._chart)}else p.opacity=0;return p.xAlign=g.xAlign,p.yAlign=g.yAlign,p.x=y.x,p.y=y.y,p.width=_.width,p.height=_.height,p.caretX=b.x,p.caretY=b.y,d._model=p,t&&h.custom&&h.custom.call(d,p),d},drawCaret:function(t,e){var n=this._chart.ctx,i=this._view,r=this.getCaretPosition(t,e,i);n.lineTo(r.x1,r.y1),n.lineTo(r.x2,r.y2),n.lineTo(r.x3,r.y3)},getCaretPosition:function(t,e,n){var i,r,o,a,s,l,c=n.caretSize,u=n.cornerRadius,d=n.xAlign,h=n.yAlign,f=t.x,p=t.y,m=e.width,v=e.height;if("center"===h)s=p+v/2,"left"===d?(r=(i=f)-c,o=i,a=s+c,l=s-c):(r=(i=f+m)+c,o=i,a=s-c,l=s+c);else if("left"===d?(i=(r=f+u+c)-c,o=r+c):"right"===d?(i=(r=f+m-u-c)-c,o=r+c):(i=(r=n.caretX)-c,o=r+c),"top"===h)s=(a=p)-c,l=a;else{s=(a=p+v)+c,l=a;var g=o;o=i,i=g}return{x1:i,x2:r,x3:o,y1:a,y2:s,y3:l}},drawTitle:function(t,e,n){var i,r,o,a=e.title,s=a.length;if(s){var l=Ne(e.rtl,e.x,e.width);for(t.x=Ve(e,e._titleAlign),n.textAlign=l.textAlign(e._titleAlign),n.textBaseline="middle",i=e.titleFontSize,r=e.titleSpacing,n.fillStyle=e.titleFontColor,n.font=V.fontString(i,e._titleFontStyle,e._titleFontFamily),o=0;o<s;++o)n.fillText(a[o],l.x(t.x),t.y+i/2),t.y+=i+r,o+1===s&&(t.y+=e.titleMarginBottom-r)}},drawBody:function(t,e,n){var i,r,o,a,s,l,c,u,d=e.bodyFontSize,h=e.bodySpacing,f=e._bodyAlign,p=e.body,m=e.displayColors,v=0,g=m?Ve(e,"left"):0,y=Ne(e.rtl,e.x,e.width),_=function(e){n.fillText(e,y.x(t.x+v),t.y+d/2),t.y+=d+h},b=y.textAlign(f);for(n.textAlign=f,n.textBaseline="middle",n.font=V.fontString(d,e._bodyFontStyle,e._bodyFontFamily),t.x=Ve(e,b),n.fillStyle=e.bodyFontColor,V.each(e.beforeBody,_),v=m&&"right"!==b?"center"===f?d/2+1:d+2:0,s=0,c=p.length;s<c;++s){for(i=p[s],r=e.labelTextColors[s],o=e.labelColors[s],n.fillStyle=r,V.each(i.before,_),l=0,u=(a=i.lines).length;l<u;++l){if(m){var w=y.x(g);n.fillStyle=e.legendColorBackground,n.fillRect(y.leftForLtr(w,d),t.y,d,d),n.lineWidth=1,n.strokeStyle=o.borderColor,n.strokeRect(y.leftForLtr(w,d),t.y,d,d),n.fillStyle=o.backgroundColor,n.fillRect(y.leftForLtr(y.xPlus(w,1),d-2),t.y+1,d-2,d-2),n.fillStyle=r}_(a[l])}V.each(i.after,_)}v=0,V.each(e.afterBody,_),t.y-=h},drawFooter:function(t,e,n){var i,r,o=e.footer,a=o.length;if(a){var s=Ne(e.rtl,e.x,e.width);for(t.x=Ve(e,e._footerAlign),t.y+=e.footerMarginTop,n.textAlign=s.textAlign(e._footerAlign),n.textBaseline="middle",i=e.footerFontSize,n.fillStyle=e.footerFontColor,n.font=V.fontString(i,e._footerFontStyle,e._footerFontFamily),r=0;r<a;++r)n.fillText(o[r],s.x(t.x),t.y+i/2),t.y+=i+e.footerSpacing}},drawBackground:function(t,e,n,i){n.fillStyle=e.backgroundColor,n.strokeStyle=e.borderColor,n.lineWidth=e.borderWidth;var r=e.xAlign,o=e.yAlign,a=t.x,s=t.y,l=i.width,c=i.height,u=e.cornerRadius;n.beginPath(),n.moveTo(a+u,s),"top"===o&&this.drawCaret(t,i),n.lineTo(a+l-u,s),n.quadraticCurveTo(a+l,s,a+l,s+u),"center"===o&&"right"===r&&this.drawCaret(t,i),n.lineTo(a+l,s+c-u),n.quadraticCurveTo(a+l,s+c,a+l-u,s+c),"bottom"===o&&this.drawCaret(t,i),n.lineTo(a+u,s+c),n.quadraticCurveTo(a,s+c,a,s+c-u),"center"===o&&"left"===r&&this.drawCaret(t,i),n.lineTo(a,s+u),n.quadraticCurveTo(a,s,a+u,s),n.closePath(),n.fill(),e.borderWidth>0&&n.stroke()},draw:function(){var t=this._chart.ctx,e=this._view;if(0!==e.opacity){var n={width:e.width,height:e.height},i={x:e.x,y:e.y},r=Math.abs(e.opacity<.001)?0:e.opacity,o=e.title.length||e.beforeBody.length||e.body.length||e.afterBody.length||e.footer.length;this._options.enabled&&o&&(t.save(),t.globalAlpha=r,this.drawBackground(i,e,t,n),i.y+=e.yPadding,V.rtl.overrideTextDirection(t,e.textDirection),this.drawTitle(i,e,t),this.drawBody(i,e,t),this.drawFooter(i,e,t),V.rtl.restoreTextDirection(t,e.textDirection),t.restore())}},handleEvent:function(t){var e,n=this,i=n._options;return n._lastActive=n._lastActive||[],"mouseout"===t.type?n._active=[]:(n._active=n._chart.getElementsAtEventForMode(t,i.mode,i),i.reverse&&n._active.reverse()),(e=!V.arrayEquals(n._active,n._lastActive))&&(n._lastActive=n._active,(i.enabled||i.custom)&&(n._eventPosition={x:t.x,y:t.y},n.update(!0),n.pivot())),e}}),Ue=Fe,Ye=We;Ye.positioners=Ue;var Qe=V.valueOrDefault;function Ge(){return V.merge(Object.create(null),[].slice.call(arguments),{merger:function(t,e,n,i){if("xAxes"===t||"yAxes"===t){var r,o,a,s=n[t].length;for(e[t]||(e[t]=[]),r=0;r<s;++r)a=n[t][r],o=Qe(a.type,"xAxes"===t?"category":"linear"),r>=e[t].length&&e[t].push({}),!e[t][r].type||a.type&&a.type!==e[t][r].type?V.merge(e[t][r],[Re.getScaleDefaults(o),a]):V.merge(e[t][r],a)}else V._merger(t,e,n,i)}})}function Ke(){return V.merge(Object.create(null),[].slice.call(arguments),{merger:function(t,e,n,i){var r=e[t]||Object.create(null),o=n[t];"scales"===t?e[t]=Ge(r,o):"scale"===t?e[t]=V.merge(r,[Re.getScaleDefaults(o.type),o]):V._merger(t,e,n,i)}})}function Je(t,e,n){var i,r=function(t){return t.id===i};do{i=e+n++}while(V.findIndex(t,r)>=0);return i}function Ze(t){return"top"===t||"bottom"===t}function Xe(t,e){return function(n,i){return n[t]===i[t]?n[e]-i[e]:n[t]-i[t]}}I._set("global",{elements:{},events:["mousemove","mouseout","click","touchstart","touchmove"],hover:{onHover:null,mode:"nearest",intersect:!0,animationDuration:400},onClick:null,maintainAspectRatio:!0,responsive:!0,responsiveAnimationDuration:0});var tn=function(t,e){return this.construct(t,e),this};V.extend(tn.prototype,{construct:function(t,e){var n=this;e=function(t){var e=(t=t||Object.create(null)).data=t.data||{};return e.datasets=e.datasets||[],e.labels=e.labels||[],t.options=Ke(I.global,I[t.type],t.options||{}),t}(e);var i=Le.acquireContext(t,e),r=i&&i.canvas,o=r&&r.height,a=r&&r.width;n.id=V.uid(),n.ctx=i,n.canvas=r,n.config=e,n.width=a,n.height=o,n.aspectRatio=o?a/o:null,n.options=e.options,n._bufferedRender=!1,n._layers=[],n.chart=n,n.controller=n,tn.instances[n.id]=n,Object.defineProperty(n,"data",{get:function(){return n.config.data},set:function(t){n.config.data=t}}),i&&r?(n.initialize(),n.update()):console.error("Failed to create chart: can't acquire context from the given item")},initialize:function(){var t=this;return qe.notify(t,"beforeInit"),V.retinaScale(t,t.options.devicePixelRatio),t.bindEvents(),t.options.responsive&&t.resize(!0),t.initToolTip(),qe.notify(t,"afterInit"),t},clear:function(){return V.canvas.clear(this),this},stop:function(){return X.cancelAnimation(this),this},resize:function(t){var e=this,n=e.options,i=e.canvas,r=n.maintainAspectRatio&&e.aspectRatio||null,o=Math.max(0,Math.floor(V.getMaximumWidth(i))),a=Math.max(0,Math.floor(r?o/r:V.getMaximumHeight(i)));if((e.width!==o||e.height!==a)&&(i.width=e.width=o,i.height=e.height=a,i.style.width=o+"px",i.style.height=a+"px",V.retinaScale(e,n.devicePixelRatio),!t)){var s={width:o,height:a};qe.notify(e,"resize",[s]),n.onResize&&n.onResize(e,s),e.stop(),e.update({duration:n.responsiveAnimationDuration})}},ensureScalesHaveIDs:function(){var t=this.options,e=t.scales||{},n=t.scale;V.each(e.xAxes,(function(t,n){t.id||(t.id=Je(e.xAxes,"x-axis-",n))})),V.each(e.yAxes,(function(t,n){t.id||(t.id=Je(e.yAxes,"y-axis-",n))})),n&&(n.id=n.id||"scale")},buildOrUpdateScales:function(){var t=this,e=t.options,n=t.scales||{},i=[],r=Object.keys(n).reduce((function(t,e){return t[e]=!1,t}),{});e.scales&&(i=i.concat((e.scales.xAxes||[]).map((function(t){return{options:t,dtype:"category",dposition:"bottom"}})),(e.scales.yAxes||[]).map((function(t){return{options:t,dtype:"linear",dposition:"left"}})))),e.scale&&i.push({options:e.scale,dtype:"radialLinear",isDefault:!0,dposition:"chartArea"}),V.each(i,(function(e){var i=e.options,o=i.id,a=Qe(i.type,e.dtype);Ze(i.position)!==Ze(e.dposition)&&(i.position=e.dposition),r[o]=!0;var s=null;if(o in n&&n[o].type===a)(s=n[o]).options=i,s.ctx=t.ctx,s.chart=t;else{var l=Re.getScaleConstructor(a);if(!l)return;s=new l({id:o,type:a,options:i,ctx:t.ctx,chart:t}),n[s.id]=s}s.mergeTicksOptions(),e.isDefault&&(t.scale=s)})),V.each(r,(function(t,e){t||delete n[e]})),t.scales=n,Re.addScalesToLayout(this)},buildOrUpdateControllers:function(){var t,e,n=this,i=[],r=n.data.datasets;for(t=0,e=r.length;t<e;t++){var o=r[t],a=n.getDatasetMeta(t),s=o.type||n.config.type;if(a.type&&a.type!==s&&(n.destroyDatasetMeta(t),a=n.getDatasetMeta(t)),a.type=s,a.order=o.order||0,a.index=t,a.controller)a.controller.updateIndex(t),a.controller.linkScales();else{var l=Jt[a.type];if(void 0===l)throw new Error('"'+a.type+'" is not a chart type.');a.controller=new l(n,t),i.push(a.controller)}}return i},resetElements:function(){var t=this;V.each(t.data.datasets,(function(e,n){t.getDatasetMeta(n).controller.reset()}),t)},reset:function(){this.resetElements(),this.tooltip.initialize()},update:function(t){var e,n,i,r,o=this;if(t&&"object"==typeof t||(t={duration:t,lazy:arguments[1]}),r=(i=o).options,V.each(i.scales,(function(t){pe.removeBox(i,t)})),r=Ke(I.global,I[i.config.type],r),i.options=i.config.options=r,i.ensureScalesHaveIDs(),i.buildOrUpdateScales(),i.tooltip._options=r.tooltips,i.tooltip.initialize(),qe._invalidate(o),!1!==qe.notify(o,"beforeUpdate")){o.tooltip._data=o.data;var a=o.buildOrUpdateControllers();for(e=0,n=o.data.datasets.length;e<n;e++)o.getDatasetMeta(e).controller.buildOrUpdateElements();o.updateLayout(),o.options.animation&&o.options.animation.duration&&V.each(a,(function(t){t.reset()})),o.updateDatasets(),o.tooltip.initialize(),o.lastActive=[],qe.notify(o,"afterUpdate"),o._layers.sort(Xe("z","_idx")),o._bufferedRender?o._bufferedRequest={duration:t.duration,easing:t.easing,lazy:t.lazy}:o.render(t)}},updateLayout:function(){var t=this;!1!==qe.notify(t,"beforeLayout")&&(pe.update(this,this.width,this.height),t._layers=[],V.each(t.boxes,(function(e){e._configure&&e._configure(),t._layers.push.apply(t._layers,e._layers())}),t),t._layers.forEach((function(t,e){t._idx=e})),qe.notify(t,"afterScaleUpdate"),qe.notify(t,"afterLayout"))},updateDatasets:function(){var t=this;if(!1!==qe.notify(t,"beforeDatasetsUpdate")){for(var e=0,n=t.data.datasets.length;e<n;++e)t.updateDataset(e);qe.notify(t,"afterDatasetsUpdate")}},updateDataset:function(t){var e=this,n=e.getDatasetMeta(t),i={meta:n,index:t};!1!==qe.notify(e,"beforeDatasetUpdate",[i])&&(n.controller._update(),qe.notify(e,"afterDatasetUpdate",[i]))},render:function(t){var e=this;t&&"object"==typeof t||(t={duration:t,lazy:arguments[1]});var n=e.options.animation,i=Qe(t.duration,n&&n.duration),r=t.lazy;if(!1!==qe.notify(e,"beforeRender")){var o=function(t){qe.notify(e,"afterRender"),V.callback(n&&n.onComplete,[t],e)};if(n&&i){var a=new Z({numSteps:i/16.66,easing:t.easing||n.easing,render:function(t,e){var n=V.easing.effects[e.easing],i=e.currentStep,r=i/e.numSteps;t.draw(n(r),r,i)},onAnimationProgress:n.onProgress,onAnimationComplete:o});X.addAnimation(e,a,i,r)}else e.draw(),o(new Z({numSteps:0,chart:e}));return e}},draw:function(t){var e,n,i=this;if(i.clear(),V.isNullOrUndef(t)&&(t=1),i.transition(t),!(i.width<=0||i.height<=0)&&!1!==qe.notify(i,"beforeDraw",[t])){for(n=i._layers,e=0;e<n.length&&n[e].z<=0;++e)n[e].draw(i.chartArea);for(i.drawDatasets(t);e<n.length;++e)n[e].draw(i.chartArea);i._drawTooltip(t),qe.notify(i,"afterDraw",[t])}},transition:function(t){for(var e=this,n=0,i=(e.data.datasets||[]).length;n<i;++n)e.isDatasetVisible(n)&&e.getDatasetMeta(n).controller.transition(t);e.tooltip.transition(t)},_getSortedDatasetMetas:function(t){var e,n,i=this,r=[];for(e=0,n=(i.data.datasets||[]).length;e<n;++e)t&&!i.isDatasetVisible(e)||r.push(i.getDatasetMeta(e));return r.sort(Xe("order","index")),r},_getSortedVisibleDatasetMetas:function(){return this._getSortedDatasetMetas(!0)},drawDatasets:function(t){var e,n,i=this;if(!1!==qe.notify(i,"beforeDatasetsDraw",[t])){for(n=(e=i._getSortedVisibleDatasetMetas()).length-1;n>=0;--n)i.drawDataset(e[n],t);qe.notify(i,"afterDatasetsDraw",[t])}},drawDataset:function(t,e){var n={meta:t,index:t.index,easingValue:e};!1!==qe.notify(this,"beforeDatasetDraw",[n])&&(t.controller.draw(e),qe.notify(this,"afterDatasetDraw",[n]))},_drawTooltip:function(t){var e=this,n=e.tooltip,i={tooltip:n,easingValue:t};!1!==qe.notify(e,"beforeTooltipDraw",[i])&&(n.draw(),qe.notify(e,"afterTooltipDraw",[i]))},getElementAtEvent:function(t){return re.modes.single(this,t)},getElementsAtEvent:function(t){return re.modes.label(this,t,{intersect:!0})},getElementsAtXAxis:function(t){return re.modes["x-axis"](this,t,{intersect:!0})},getElementsAtEventForMode:function(t,e,n){var i=re.modes[e];return"function"==typeof i?i(this,t,n):[]},getDatasetAtEvent:function(t){return re.modes.dataset(this,t,{intersect:!0})},getDatasetMeta:function(t){var e=this,n=e.data.datasets[t];n._meta||(n._meta={});var i=n._meta[e.id];return i||(i=n._meta[e.id]={type:null,data:[],dataset:null,controller:null,hidden:null,xAxisID:null,yAxisID:null,order:n.order||0,index:t}),i},getVisibleDatasetCount:function(){for(var t=0,e=0,n=this.data.datasets.length;e<n;++e)this.isDatasetVisible(e)&&t++;return t},isDatasetVisible:function(t){var e=this.getDatasetMeta(t);return"boolean"==typeof e.hidden?!e.hidden:!this.data.datasets[t].hidden},generateLegend:function(){return this.options.legendCallback(this)},destroyDatasetMeta:function(t){var e=this.id,n=this.data.datasets[t],i=n._meta&&n._meta[e];i&&(i.controller.destroy(),delete n._meta[e])},destroy:function(){var t,e,n=this,i=n.canvas;for(n.stop(),t=0,e=n.data.datasets.length;t<e;++t)n.destroyDatasetMeta(t);i&&(n.unbindEvents(),V.canvas.clear(n),Le.releaseContext(n.ctx),n.canvas=null,n.ctx=null),qe.notify(n,"destroy"),delete tn.instances[n.id]},toBase64Image:function(){return this.canvas.toDataURL.apply(this.canvas,arguments)},initToolTip:function(){var t=this;t.tooltip=new Ye({_chart:t,_chartInstance:t,_data:t.data,_options:t.options.tooltips},t)},bindEvents:function(){var t=this,e=t._listeners={},n=function(){t.eventHandler.apply(t,arguments)};V.each(t.options.events,(function(i){Le.addEventListener(t,i,n),e[i]=n})),t.options.responsive&&(n=function(){t.resize()},Le.addEventListener(t,"resize",n),e.resize=n)},unbindEvents:function(){var t=this,e=t._listeners;e&&(delete t._listeners,V.each(e,(function(e,n){Le.removeEventListener(t,n,e)})))},updateHoverStyle:function(t,e,n){var i,r,o,a=n?"set":"remove";for(r=0,o=t.length;r<o;++r)(i=t[r])&&this.getDatasetMeta(i._datasetIndex).controller[a+"HoverStyle"](i);"dataset"===e&&this.getDatasetMeta(t[0]._datasetIndex).controller["_"+a+"DatasetHoverStyle"]()},eventHandler:function(t){var e=this,n=e.tooltip;if(!1!==qe.notify(e,"beforeEvent",[t])){e._bufferedRender=!0,e._bufferedRequest=null;var i=e.handleEvent(t);n&&(i=n._start?n.handleEvent(t):i|n.handleEvent(t)),qe.notify(e,"afterEvent",[t]);var r=e._bufferedRequest;return r?e.render(r):i&&!e.animating&&(e.stop(),e.render({duration:e.options.hover.animationDuration,lazy:!0})),e._bufferedRender=!1,e._bufferedRequest=null,e}},handleEvent:function(t){var e,n=this,i=n.options||{},r=i.hover;return n.lastActive=n.lastActive||[],"mouseout"===t.type?n.active=[]:n.active=n.getElementsAtEventForMode(t,r.mode,r),V.callback(i.onHover||i.hover.onHover,[t.native,n.active],n),"mouseup"!==t.type&&"click"!==t.type||i.onClick&&i.onClick.call(n,t.native,n.active),n.lastActive.length&&n.updateHoverStyle(n.lastActive,r.mode,!1),n.active.length&&r.mode&&n.updateHoverStyle(n.active,r.mode,!0),e=!V.arrayEquals(n.active,n.lastActive),n.lastActive=n.active,e}}),tn.instances={};var en=tn;tn.Controller=tn,tn.types={},V.configMerge=Ke,V.scaleMerge=Ge;function nn(){throw new Error("This method is not implemented: either no adapter can be found or an incomplete integration was provided.")}function rn(t){this.options=t||{}}V.extend(rn.prototype,{formats:nn,parse:nn,format:nn,add:nn,diff:nn,startOf:nn,endOf:nn,_create:function(t){return t}}),rn.override=function(t){V.extend(rn.prototype,t)};var on={_date:rn},an={formatters:{values:function(t){return V.isArray(t)?t:""+t},linear:function(t,e,n){var i=n.length>3?n[2]-n[1]:n[1]-n[0];Math.abs(i)>1&&t!==Math.floor(t)&&(i=t-Math.floor(t));var r=V.log10(Math.abs(i)),o="";if(0!==t)if(Math.max(Math.abs(n[0]),Math.abs(n[n.length-1]))<1e-4){var a=V.log10(Math.abs(t)),s=Math.floor(a)-Math.floor(r);s=Math.max(Math.min(s,20),0),o=t.toExponential(s)}else{var l=-1*Math.floor(r);l=Math.max(Math.min(l,20),0),o=t.toFixed(l)}else o="0";return o},logarithmic:function(t,e,n){var i=t/Math.pow(10,Math.floor(V.log10(t)));return 0===t?"0":1===i||2===i||5===i||0===e||e===n.length-1?t.toExponential():""}}},sn=V.isArray,ln=V.isNullOrUndef,cn=V.valueOrDefault,un=V.valueAtIndexOrDefault;function dn(t,e,n){var i,r=t.getTicks().length,o=Math.min(e,r-1),a=t.getPixelForTick(o),s=t._startPixel,l=t._endPixel,c=1e-6;if(!(n&&(i=1===r?Math.max(a-s,l-a):0===e?(t.getPixelForTick(1)-a)/2:(a-t.getPixelForTick(o-1))/2,(a+=o<e?i:-i)<s-c||a>l+c)))return a}function hn(t,e,n,i){var r,o,a,s,l,c,u,d,h,f,p,m,v,g=n.length,y=[],_=[],b=[],w=0,k=0;for(r=0;r<g;++r){if(s=n[r].label,l=n[r].major?e.major:e.minor,t.font=c=l.string,u=i[c]=i[c]||{data:{},gc:[]},d=l.lineHeight,h=f=0,ln(s)||sn(s)){if(sn(s))for(o=0,a=s.length;o<a;++o)p=s[o],ln(p)||sn(p)||(h=V.measureText(t,u.data,u.gc,h,p),f+=d)}else h=V.measureText(t,u.data,u.gc,h,s),f=d;y.push(h),_.push(f),b.push(d/2),w=Math.max(h,w),k=Math.max(f,k)}function x(t){return{width:y[t]||0,height:_[t]||0,offset:b[t]||0}}return function(t,e){V.each(t,(function(t){var n,i=t.gc,r=i.length/2;if(r>e){for(n=0;n<r;++n)delete t.data[i[n]];i.splice(0,r)}}))}(i,g),m=y.indexOf(w),v=_.indexOf(k),{first:x(0),last:x(g-1),widest:x(m),highest:x(v)}}function fn(t){return t.drawTicks?t.tickMarkLength:0}function pn(t){var e,n;return t.display?(e=V.options._parseFont(t),n=V.options.toPadding(t.padding),e.lineHeight+n.height):0}function mn(t,e){return V.extend(V.options._parseFont({fontFamily:cn(e.fontFamily,t.fontFamily),fontSize:cn(e.fontSize,t.fontSize),fontStyle:cn(e.fontStyle,t.fontStyle),lineHeight:cn(e.lineHeight,t.lineHeight)}),{color:V.options.resolve([e.fontColor,t.fontColor,I.global.defaultFontColor])})}function vn(t){var e=mn(t,t.minor);return{minor:e,major:t.major.enabled?mn(t,t.major):e}}function gn(t){var e,n,i,r=[];for(n=0,i=t.length;n<i;++n)void 0!==(e=t[n])._index&&r.push(e);return r}function yn(t,e,n,i){var r,o,a,s,l=cn(n,0),c=Math.min(cn(i,t.length),t.length),u=0;for(e=Math.ceil(e),i&&(e=(r=i-n)/Math.floor(r/e)),s=l;s<0;)u++,s=Math.round(l+u*e);for(o=Math.max(l,0);o<c;o++)a=t[o],o===s?(a._index=o,u++,s=Math.round(l+u*e)):delete a.label}I._set("scale",{display:!0,position:"left",offset:!1,gridLines:{display:!0,color:"rgba(0,0,0,0.1)",lineWidth:1,drawBorder:!0,drawOnChartArea:!0,drawTicks:!0,tickMarkLength:10,zeroLineWidth:1,zeroLineColor:"rgba(0,0,0,0.25)",zeroLineBorderDash:[],zeroLineBorderDashOffset:0,offsetGridLines:!1,borderDash:[],borderDashOffset:0},scaleLabel:{display:!1,labelString:"",padding:{top:4,bottom:4}},ticks:{beginAtZero:!1,minRotation:0,maxRotation:50,mirror:!1,padding:0,reverse:!1,display:!0,autoSkip:!0,autoSkipPadding:0,labelOffset:0,callback:an.formatters.values,minor:{},major:{}}});var _n=K.extend({zeroLineIndex:0,getPadding:function(){var t=this;return{left:t.paddingLeft||0,top:t.paddingTop||0,right:t.paddingRight||0,bottom:t.paddingBottom||0}},getTicks:function(){return this._ticks},_getLabels:function(){var t=this.chart.data;return this.options.labels||(this.isHorizontal()?t.xLabels:t.yLabels)||t.labels||[]},mergeTicksOptions:function(){},beforeUpdate:function(){V.callback(this.options.beforeUpdate,[this])},update:function(t,e,n){var i,r,o,a,s,l=this,c=l.options.ticks,u=c.sampleSize;if(l.beforeUpdate(),l.maxWidth=t,l.maxHeight=e,l.margins=V.extend({left:0,right:0,top:0,bottom:0},n),l._ticks=null,l.ticks=null,l._labelSizes=null,l._maxLabelLines=0,l.longestLabelWidth=0,l.longestTextCache=l.longestTextCache||{},l._gridLineItems=null,l._labelItems=null,l.beforeSetDimensions(),l.setDimensions(),l.afterSetDimensions(),l.beforeDataLimits(),l.determineDataLimits(),l.afterDataLimits(),l.beforeBuildTicks(),a=l.buildTicks()||[],(!(a=l.afterBuildTicks(a)||a)||!a.length)&&l.ticks)for(a=[],i=0,r=l.ticks.length;i<r;++i)a.push({value:l.ticks[i],major:!1});return l._ticks=a,s=u<a.length,o=l._convertTicksToLabels(s?function(t,e){for(var n=[],i=t.length/e,r=0,o=t.length;r<o;r+=i)n.push(t[Math.floor(r)]);return n}(a,u):a),l._configure(),l.beforeCalculateTickRotation(),l.calculateTickRotation(),l.afterCalculateTickRotation(),l.beforeFit(),l.fit(),l.afterFit(),l._ticksToDraw=c.display&&(c.autoSkip||"auto"===c.source)?l._autoSkip(a):a,s&&(o=l._convertTicksToLabels(l._ticksToDraw)),l.ticks=o,l.afterUpdate(),l.minSize},_configure:function(){var t,e,n=this,i=n.options.ticks.reverse;n.isHorizontal()?(t=n.left,e=n.right):(t=n.top,e=n.bottom,i=!i),n._startPixel=t,n._endPixel=e,n._reversePixels=i,n._length=e-t},afterUpdate:function(){V.callback(this.options.afterUpdate,[this])},beforeSetDimensions:function(){V.callback(this.options.beforeSetDimensions,[this])},setDimensions:function(){var t=this;t.isHorizontal()?(t.width=t.maxWidth,t.left=0,t.right=t.width):(t.height=t.maxHeight,t.top=0,t.bottom=t.height),t.paddingLeft=0,t.paddingTop=0,t.paddingRight=0,t.paddingBottom=0},afterSetDimensions:function(){V.callback(this.options.afterSetDimensions,[this])},beforeDataLimits:function(){V.callback(this.options.beforeDataLimits,[this])},determineDataLimits:V.noop,afterDataLimits:function(){V.callback(this.options.afterDataLimits,[this])},beforeBuildTicks:function(){V.callback(this.options.beforeBuildTicks,[this])},buildTicks:V.noop,afterBuildTicks:function(t){var e=this;return sn(t)&&t.length?V.callback(e.options.afterBuildTicks,[e,t]):(e.ticks=V.callback(e.options.afterBuildTicks,[e,e.ticks])||e.ticks,t)},beforeTickToLabelConversion:function(){V.callback(this.options.beforeTickToLabelConversion,[this])},convertTicksToLabels:function(){var t=this,e=t.options.ticks;t.ticks=t.ticks.map(e.userCallback||e.callback,this)},afterTickToLabelConversion:function(){V.callback(this.options.afterTickToLabelConversion,[this])},beforeCalculateTickRotation:function(){V.callback(this.options.beforeCalculateTickRotation,[this])},calculateTickRotation:function(){var t,e,n,i,r,o,a,s=this,l=s.options,c=l.ticks,u=s.getTicks().length,d=c.minRotation||0,h=c.maxRotation,f=d;!s._isVisible()||!c.display||d>=h||u<=1||!s.isHorizontal()?s.labelRotation=d:(e=(t=s._getLabelSizes()).widest.width,n=t.highest.height-t.highest.offset,i=Math.min(s.maxWidth,s.chart.width-e),e+6>(r=l.offset?s.maxWidth/u:i/(u-1))&&(r=i/(u-(l.offset?.5:1)),o=s.maxHeight-fn(l.gridLines)-c.padding-pn(l.scaleLabel),a=Math.sqrt(e*e+n*n),f=V.toDegrees(Math.min(Math.asin(Math.min((t.highest.height+6)/r,1)),Math.asin(Math.min(o/a,1))-Math.asin(n/a))),f=Math.max(d,Math.min(h,f))),s.labelRotation=f)},afterCalculateTickRotation:function(){V.callback(this.options.afterCalculateTickRotation,[this])},beforeFit:function(){V.callback(this.options.beforeFit,[this])},fit:function(){var t=this,e=t.minSize={width:0,height:0},n=t.chart,i=t.options,r=i.ticks,o=i.scaleLabel,a=i.gridLines,s=t._isVisible(),l="bottom"===i.position,c=t.isHorizontal();if(c?e.width=t.maxWidth:s&&(e.width=fn(a)+pn(o)),c?s&&(e.height=fn(a)+pn(o)):e.height=t.maxHeight,r.display&&s){var u=vn(r),d=t._getLabelSizes(),h=d.first,f=d.last,p=d.widest,m=d.highest,v=.4*u.minor.lineHeight,g=r.padding;if(c){var y=0!==t.labelRotation,_=V.toRadians(t.labelRotation),b=Math.cos(_),w=Math.sin(_),k=w*p.width+b*(m.height-(y?m.offset:0))+(y?0:v);e.height=Math.min(t.maxHeight,e.height+k+g);var x,C,S=t.getPixelForTick(0)-t.left,M=t.right-t.getPixelForTick(t.getTicks().length-1);y?(x=l?b*h.width+w*h.offset:w*(h.height-h.offset),C=l?w*(f.height-f.offset):b*f.width+w*f.offset):(x=h.width/2,C=f.width/2),t.paddingLeft=Math.max((x-S)*t.width/(t.width-S),0)+3,t.paddingRight=Math.max((C-M)*t.width/(t.width-M),0)+3}else{var T=r.mirror?0:p.width+g+v;e.width=Math.min(t.maxWidth,e.width+T),t.paddingTop=h.height/2,t.paddingBottom=f.height/2}}t.handleMargins(),c?(t.width=t._length=n.width-t.margins.left-t.margins.right,t.height=e.height):(t.width=e.width,t.height=t._length=n.height-t.margins.top-t.margins.bottom)},handleMargins:function(){var t=this;t.margins&&(t.margins.left=Math.max(t.paddingLeft,t.margins.left),t.margins.top=Math.max(t.paddingTop,t.margins.top),t.margins.right=Math.max(t.paddingRight,t.margins.right),t.margins.bottom=Math.max(t.paddingBottom,t.margins.bottom))},afterFit:function(){V.callback(this.options.afterFit,[this])},isHorizontal:function(){var t=this.options.position;return"top"===t||"bottom"===t},isFullWidth:function(){return this.options.fullWidth},getRightValue:function(t){if(ln(t))return NaN;if(("number"==typeof t||t instanceof Number)&&!isFinite(t))return NaN;if(t)if(this.isHorizontal()){if(void 0!==t.x)return this.getRightValue(t.x)}else if(void 0!==t.y)return this.getRightValue(t.y);return t},_convertTicksToLabels:function(t){var e,n,i,r=this;for(r.ticks=t.map((function(t){return t.value})),r.beforeTickToLabelConversion(),e=r.convertTicksToLabels(t)||r.ticks,r.afterTickToLabelConversion(),n=0,i=t.length;n<i;++n)t[n].label=e[n];return e},_getLabelSizes:function(){var t=this,e=t._labelSizes;return e||(t._labelSizes=e=hn(t.ctx,vn(t.options.ticks),t.getTicks(),t.longestTextCache),t.longestLabelWidth=e.widest.width),e},_parseValue:function(t){var e,n,i,r;return sn(t)?(e=+this.getRightValue(t[0]),n=+this.getRightValue(t[1]),i=Math.min(e,n),r=Math.max(e,n)):(e=void 0,n=t=+this.getRightValue(t),i=t,r=t),{min:i,max:r,start:e,end:n}},_getScaleLabel:function(t){var e=this._parseValue(t);return void 0!==e.start?"["+e.start+", "+e.end+"]":+this.getRightValue(t)},getLabelForIndex:V.noop,getPixelForValue:V.noop,getValueForPixel:V.noop,getPixelForTick:function(t){var e=this,n=e.options.offset,i=e._ticks.length,r=1/Math.max(i-(n?0:1),1);return t<0||t>i-1?null:e.getPixelForDecimal(t*r+(n?r/2:0))},getPixelForDecimal:function(t){var e=this;return e._reversePixels&&(t=1-t),e._startPixel+t*e._length},getDecimalForPixel:function(t){var e=(t-this._startPixel)/this._length;return this._reversePixels?1-e:e},getBasePixel:function(){return this.getPixelForValue(this.getBaseValue())},getBaseValue:function(){var t=this,e=t.min,n=t.max;return t.beginAtZero?0:e<0&&n<0?n:e>0&&n>0?e:0},_autoSkip:function(t){var e,n,i,r,o=this,a=o.options.ticks,s=o._length,l=a.maxTicksLimit||s/o._tickSize()+1,c=a.major.enabled?function(t){var e,n,i=[];for(e=0,n=t.length;e<n;e++)t[e].major&&i.push(e);return i}(t):[],u=c.length,d=c[0],h=c[u-1];if(u>l)return function(t,e,n){var i,r,o=0,a=e[0];for(n=Math.ceil(n),i=0;i<t.length;i++)r=t[i],i===a?(r._index=i,a=e[++o*n]):delete r.label}(t,c,u/l),gn(t);if(i=function(t,e,n,i){var r,o,a,s,l=function(t){var e,n,i=t.length;if(i<2)return!1;for(n=t[0],e=1;e<i;++e)if(t[e]-t[e-1]!==n)return!1;return n}(t),c=(e.length-1)/i;if(!l)return Math.max(c,1);for(a=0,s=(r=V.math._factorize(l)).length-1;a<s;a++)if((o=r[a])>c)return o;return Math.max(c,1)}(c,t,0,l),u>0){for(e=0,n=u-1;e<n;e++)yn(t,i,c[e],c[e+1]);return r=u>1?(h-d)/(u-1):null,yn(t,i,V.isNullOrUndef(r)?0:d-r,d),yn(t,i,h,V.isNullOrUndef(r)?t.length:h+r),gn(t)}return yn(t,i),gn(t)},_tickSize:function(){var t=this,e=t.options.ticks,n=V.toRadians(t.labelRotation),i=Math.abs(Math.cos(n)),r=Math.abs(Math.sin(n)),o=t._getLabelSizes(),a=e.autoSkipPadding||0,s=o?o.widest.width+a:0,l=o?o.highest.height+a:0;return t.isHorizontal()?l*i>s*r?s/i:l/r:l*r<s*i?l/i:s/r},_isVisible:function(){var t,e,n,i=this,r=i.chart,o=i.options.display;if("auto"!==o)return!!o;for(t=0,e=r.data.datasets.length;t<e;++t)if(r.isDatasetVisible(t)&&((n=r.getDatasetMeta(t)).xAxisID===i.id||n.yAxisID===i.id))return!0;return!1},_computeGridLineItems:function(t){var e,n,i,r,o,a,s,l,c,u,d,h,f,p,m,v,g,y=this,_=y.chart,b=y.options,w=b.gridLines,k=b.position,x=w.offsetGridLines,C=y.isHorizontal(),S=y._ticksToDraw,M=S.length+(x?1:0),T=fn(w),P=[],O=w.drawBorder?un(w.lineWidth,0,0):0,B=O/2,E=V._alignPixel,A=function(t){return E(_,t,O)};for("top"===k?(e=A(y.bottom),s=y.bottom-T,c=e-B,d=A(t.top)+B,f=t.bottom):"bottom"===k?(e=A(y.top),d=t.top,f=A(t.bottom)-B,s=e+B,c=y.top+T):"left"===k?(e=A(y.right),a=y.right-T,l=e-B,u=A(t.left)+B,h=t.right):(e=A(y.left),u=t.left,h=A(t.right)-B,a=e+B,l=y.left+T),n=0;n<M;++n)i=S[n]||{},ln(i.label)&&n<S.length||(n===y.zeroLineIndex&&b.offset===x?(p=w.zeroLineWidth,m=w.zeroLineColor,v=w.zeroLineBorderDash||[],g=w.zeroLineBorderDashOffset||0):(p=un(w.lineWidth,n,1),m=un(w.color,n,"rgba(0,0,0,0.1)"),v=w.borderDash||[],g=w.borderDashOffset||0),void 0!==(r=dn(y,i._index||n,x))&&(o=E(_,r,p),C?a=l=u=h=o:s=c=d=f=o,P.push({tx1:a,ty1:s,tx2:l,ty2:c,x1:u,y1:d,x2:h,y2:f,width:p,color:m,borderDash:v,borderDashOffset:g})));return P.ticksLength=M,P.borderValue=e,P},_computeLabelItems:function(){var t,e,n,i,r,o,a,s,l,c,u,d,h=this,f=h.options,p=f.ticks,m=f.position,v=p.mirror,g=h.isHorizontal(),y=h._ticksToDraw,_=vn(p),b=p.padding,w=fn(f.gridLines),k=-V.toRadians(h.labelRotation),x=[];for("top"===m?(o=h.bottom-w-b,a=k?"left":"center"):"bottom"===m?(o=h.top+w+b,a=k?"right":"center"):"left"===m?(r=h.right-(v?0:w)-b,a=v?"left":"right"):(r=h.left+(v?0:w)+b,a=v?"right":"left"),t=0,e=y.length;t<e;++t)i=(n=y[t]).label,ln(i)||(s=h.getPixelForTick(n._index||t)+p.labelOffset,c=(l=n.major?_.major:_.minor).lineHeight,u=sn(i)?i.length:1,g?(r=s,d="top"===m?((k?1:.5)-u)*c:(k?0:.5)*c):(o=s,d=(1-u)*c/2),x.push({x:r,y:o,rotation:k,label:i,font:l,textOffset:d,textAlign:a}));return x},_drawGrid:function(t){var e=this,n=e.options.gridLines;if(n.display){var i,r,o,a,s,l=e.ctx,c=e.chart,u=V._alignPixel,d=n.drawBorder?un(n.lineWidth,0,0):0,h=e._gridLineItems||(e._gridLineItems=e._computeGridLineItems(t));for(o=0,a=h.length;o<a;++o)i=(s=h[o]).width,r=s.color,i&&r&&(l.save(),l.lineWidth=i,l.strokeStyle=r,l.setLineDash&&(l.setLineDash(s.borderDash),l.lineDashOffset=s.borderDashOffset),l.beginPath(),n.drawTicks&&(l.moveTo(s.tx1,s.ty1),l.lineTo(s.tx2,s.ty2)),n.drawOnChartArea&&(l.moveTo(s.x1,s.y1),l.lineTo(s.x2,s.y2)),l.stroke(),l.restore());if(d){var f,p,m,v,g=d,y=un(n.lineWidth,h.ticksLength-1,1),_=h.borderValue;e.isHorizontal()?(f=u(c,e.left,g)-g/2,p=u(c,e.right,y)+y/2,m=v=_):(m=u(c,e.top,g)-g/2,v=u(c,e.bottom,y)+y/2,f=p=_),l.lineWidth=d,l.strokeStyle=un(n.color,0),l.beginPath(),l.moveTo(f,m),l.lineTo(p,v),l.stroke()}}},_drawLabels:function(){var t=this;if(t.options.ticks.display){var e,n,i,r,o,a,s,l,c=t.ctx,u=t._labelItems||(t._labelItems=t._computeLabelItems());for(e=0,i=u.length;e<i;++e){if(a=(o=u[e]).font,c.save(),c.translate(o.x,o.y),c.rotate(o.rotation),c.font=a.string,c.fillStyle=a.color,c.textBaseline="middle",c.textAlign=o.textAlign,s=o.label,l=o.textOffset,sn(s))for(n=0,r=s.length;n<r;++n)c.fillText(""+s[n],0,l),l+=a.lineHeight;else c.fillText(s,0,l);c.restore()}}},_drawTitle:function(){var t=this,e=t.ctx,n=t.options,i=n.scaleLabel;if(i.display){var r,o,a=cn(i.fontColor,I.global.defaultFontColor),s=V.options._parseFont(i),l=V.options.toPadding(i.padding),c=s.lineHeight/2,u=n.position,d=0;if(t.isHorizontal())r=t.left+t.width/2,o="bottom"===u?t.bottom-c-l.bottom:t.top+c+l.top;else{var h="left"===u;r=h?t.left+c+l.top:t.right-c-l.top,o=t.top+t.height/2,d=h?-.5*Math.PI:.5*Math.PI}e.save(),e.translate(r,o),e.rotate(d),e.textAlign="center",e.textBaseline="middle",e.fillStyle=a,e.font=s.string,e.fillText(i.labelString,0,0),e.restore()}},draw:function(t){var e=this;e._isVisible()&&(e._drawGrid(t),e._drawTitle(),e._drawLabels())},_layers:function(){var t=this,e=t.options,n=e.ticks&&e.ticks.z||0,i=e.gridLines&&e.gridLines.z||0;return t._isVisible()&&n!==i&&t.draw===t._draw?[{z:i,draw:function(){t._drawGrid.apply(t,arguments),t._drawTitle.apply(t,arguments)}},{z:n,draw:function(){t._drawLabels.apply(t,arguments)}}]:[{z:n,draw:function(){t.draw.apply(t,arguments)}}]},_getMatchingVisibleMetas:function(t){var e=this,n=e.isHorizontal();return e.chart._getSortedVisibleDatasetMetas().filter((function(i){return(!t||i.type===t)&&(n?i.xAxisID===e.id:i.yAxisID===e.id)}))}});_n.prototype._draw=_n.prototype.draw;var bn=_n,wn=V.isNullOrUndef,kn=bn.extend({determineDataLimits:function(){var t,e=this,n=e._getLabels(),i=e.options.ticks,r=i.min,o=i.max,a=0,s=n.length-1;void 0!==r&&(t=n.indexOf(r))>=0&&(a=t),void 0!==o&&(t=n.indexOf(o))>=0&&(s=t),e.minIndex=a,e.maxIndex=s,e.min=n[a],e.max=n[s]},buildTicks:function(){var t=this,e=t._getLabels(),n=t.minIndex,i=t.maxIndex;t.ticks=0===n&&i===e.length-1?e:e.slice(n,i+1)},getLabelForIndex:function(t,e){var n=this,i=n.chart;return i.getDatasetMeta(e).controller._getValueScaleId()===n.id?n.getRightValue(i.data.datasets[e].data[t]):n._getLabels()[t]},_configure:function(){var t=this,e=t.options.offset,n=t.ticks;bn.prototype._configure.call(t),t.isHorizontal()||(t._reversePixels=!t._reversePixels),n&&(t._startValue=t.minIndex-(e?.5:0),t._valueRange=Math.max(n.length-(e?0:1),1))},getPixelForValue:function(t,e,n){var i,r,o,a=this;return wn(e)||wn(n)||(t=a.chart.data.datasets[n].data[e]),wn(t)||(i=a.isHorizontal()?t.x:t.y),(void 0!==i||void 0!==t&&isNaN(e))&&(r=a._getLabels(),t=V.valueOrDefault(i,t),e=-1!==(o=r.indexOf(t))?o:e,isNaN(e)&&(e=t)),a.getPixelForDecimal((e-a._startValue)/a._valueRange)},getPixelForTick:function(t){var e=this.ticks;return t<0||t>e.length-1?null:this.getPixelForValue(e[t],t+this.minIndex)},getValueForPixel:function(t){var e=this,n=Math.round(e._startValue+e.getDecimalForPixel(t)*e._valueRange);return Math.min(Math.max(n,0),e.ticks.length-1)},getBasePixel:function(){return this.bottom}}),xn={position:"bottom"};kn._defaults=xn;var Cn=V.noop,Sn=V.isNullOrUndef;var Mn=bn.extend({getRightValue:function(t){return"string"==typeof t?+t:bn.prototype.getRightValue.call(this,t)},handleTickRangeOptions:function(){var t=this,e=t.options.ticks;if(e.beginAtZero){var n=V.sign(t.min),i=V.sign(t.max);n<0&&i<0?t.max=0:n>0&&i>0&&(t.min=0)}var r=void 0!==e.min||void 0!==e.suggestedMin,o=void 0!==e.max||void 0!==e.suggestedMax;void 0!==e.min?t.min=e.min:void 0!==e.suggestedMin&&(null===t.min?t.min=e.suggestedMin:t.min=Math.min(t.min,e.suggestedMin)),void 0!==e.max?t.max=e.max:void 0!==e.suggestedMax&&(null===t.max?t.max=e.suggestedMax:t.max=Math.max(t.max,e.suggestedMax)),r!==o&&t.min>=t.max&&(r?t.max=t.min+1:t.min=t.max-1),t.min===t.max&&(t.max++,e.beginAtZero||t.min--)},getTickLimit:function(){var t,e=this,n=e.options.ticks,i=n.stepSize,r=n.maxTicksLimit;return i?t=Math.ceil(e.max/i)-Math.floor(e.min/i)+1:(t=e._computeTickLimit(),r=r||11),r&&(t=Math.min(r,t)),t},_computeTickLimit:function(){return Number.POSITIVE_INFINITY},handleDirectionalChanges:Cn,buildTicks:function(){var t=this,e=t.options.ticks,n=t.getTickLimit(),i={maxTicks:n=Math.max(2,n),min:e.min,max:e.max,precision:e.precision,stepSize:V.valueOrDefault(e.fixedStepSize,e.stepSize)},r=t.ticks=function(t,e){var n,i,r,o,a=[],s=t.stepSize,l=s||1,c=t.maxTicks-1,u=t.min,d=t.max,h=t.precision,f=e.min,p=e.max,m=V.niceNum((p-f)/c/l)*l;if(m<1e-14&&Sn(u)&&Sn(d))return[f,p];(o=Math.ceil(p/m)-Math.floor(f/m))>c&&(m=V.niceNum(o*m/c/l)*l),s||Sn(h)?n=Math.pow(10,V._decimalPlaces(m)):(n=Math.pow(10,h),m=Math.ceil(m*n)/n),i=Math.floor(f/m)*m,r=Math.ceil(p/m)*m,s&&(!Sn(u)&&V.almostWhole(u/m,m/1e3)&&(i=u),!Sn(d)&&V.almostWhole(d/m,m/1e3)&&(r=d)),o=(r-i)/m,o=V.almostEquals(o,Math.round(o),m/1e3)?Math.round(o):Math.ceil(o),i=Math.round(i*n)/n,r=Math.round(r*n)/n,a.push(Sn(u)?i:u);for(var v=1;v<o;++v)a.push(Math.round((i+v*m)*n)/n);return a.push(Sn(d)?r:d),a}(i,t);t.handleDirectionalChanges(),t.max=V.max(r),t.min=V.min(r),e.reverse?(r.reverse(),t.start=t.max,t.end=t.min):(t.start=t.min,t.end=t.max)},convertTicksToLabels:function(){var t=this;t.ticksAsNumbers=t.ticks.slice(),t.zeroLineIndex=t.ticks.indexOf(0),bn.prototype.convertTicksToLabels.call(t)},_configure:function(){var t,e=this,n=e.getTicks(),i=e.min,r=e.max;bn.prototype._configure.call(e),e.options.offset&&n.length&&(i-=t=(r-i)/Math.max(n.length-1,1)/2,r+=t),e._startValue=i,e._endValue=r,e._valueRange=r-i}}),Tn={position:"left",ticks:{callback:an.formatters.linear}};function Pn(t,e,n,i){var r,o,a=t.options,s=function(t,e,n){var i=[n.type,void 0===e&&void 0===n.stack?n.index:"",n.stack].join(".");return void 0===t[i]&&(t[i]={pos:[],neg:[]}),t[i]}(e,a.stacked,n),l=s.pos,c=s.neg,u=i.length;for(r=0;r<u;++r)o=t._parseValue(i[r]),isNaN(o.min)||isNaN(o.max)||n.data[r].hidden||(l[r]=l[r]||0,c[r]=c[r]||0,a.relativePoints?l[r]=100:o.min<0||o.max<0?c[r]+=o.min:l[r]+=o.max)}function On(t,e,n){var i,r,o=n.length;for(i=0;i<o;++i)r=t._parseValue(n[i]),isNaN(r.min)||isNaN(r.max)||e.data[i].hidden||(t.min=Math.min(t.min,r.min),t.max=Math.max(t.max,r.max))}var Bn=Mn.extend({determineDataLimits:function(){var t,e,n,i,r=this,o=r.options,a=r.chart.data.datasets,s=r._getMatchingVisibleMetas(),l=o.stacked,c={},u=s.length;if(r.min=Number.POSITIVE_INFINITY,r.max=Number.NEGATIVE_INFINITY,void 0===l)for(t=0;!l&&t<u;++t)l=void 0!==(e=s[t]).stack;for(t=0;t<u;++t)n=a[(e=s[t]).index].data,l?Pn(r,c,e,n):On(r,e,n);V.each(c,(function(t){i=t.pos.concat(t.neg),r.min=Math.min(r.min,V.min(i)),r.max=Math.max(r.max,V.max(i))})),r.min=V.isFinite(r.min)&&!isNaN(r.min)?r.min:0,r.max=V.isFinite(r.max)&&!isNaN(r.max)?r.max:1,r.handleTickRangeOptions()},_computeTickLimit:function(){var t,e=this;return e.isHorizontal()?Math.ceil(e.width/40):(t=V.options._parseFont(e.options.ticks),Math.ceil(e.height/t.lineHeight))},handleDirectionalChanges:function(){this.isHorizontal()||this.ticks.reverse()},getLabelForIndex:function(t,e){return this._getScaleLabel(this.chart.data.datasets[e].data[t])},getPixelForValue:function(t){var e=this;return e.getPixelForDecimal((+e.getRightValue(t)-e._startValue)/e._valueRange)},getValueForPixel:function(t){return this._startValue+this.getDecimalForPixel(t)*this._valueRange},getPixelForTick:function(t){var e=this.ticksAsNumbers;return t<0||t>e.length-1?null:this.getPixelForValue(e[t])}}),En=Tn;Bn._defaults=En;var An=V.valueOrDefault,Dn=V.math.log10;var Ln={position:"left",ticks:{callback:an.formatters.logarithmic}};function qn(t,e){return V.isFinite(t)&&t>=0?t:e}var Rn=bn.extend({determineDataLimits:function(){var t,e,n,i,r,o,a=this,s=a.options,l=a.chart,c=l.data.datasets,u=a.isHorizontal();function d(t){return u?t.xAxisID===a.id:t.yAxisID===a.id}a.min=Number.POSITIVE_INFINITY,a.max=Number.NEGATIVE_INFINITY,a.minNotZero=Number.POSITIVE_INFINITY;var h=s.stacked;if(void 0===h)for(t=0;t<c.length;t++)if(e=l.getDatasetMeta(t),l.isDatasetVisible(t)&&d(e)&&void 0!==e.stack){h=!0;break}if(s.stacked||h){var f={};for(t=0;t<c.length;t++){var p=[(e=l.getDatasetMeta(t)).type,void 0===s.stacked&&void 0===e.stack?t:"",e.stack].join(".");if(l.isDatasetVisible(t)&&d(e))for(void 0===f[p]&&(f[p]=[]),r=0,o=(i=c[t].data).length;r<o;r++){var m=f[p];n=a._parseValue(i[r]),isNaN(n.min)||isNaN(n.max)||e.data[r].hidden||n.min<0||n.max<0||(m[r]=m[r]||0,m[r]+=n.max)}}V.each(f,(function(t){if(t.length>0){var e=V.min(t),n=V.max(t);a.min=Math.min(a.min,e),a.max=Math.max(a.max,n)}}))}else for(t=0;t<c.length;t++)if(e=l.getDatasetMeta(t),l.isDatasetVisible(t)&&d(e))for(r=0,o=(i=c[t].data).length;r<o;r++)n=a._parseValue(i[r]),isNaN(n.min)||isNaN(n.max)||e.data[r].hidden||n.min<0||n.max<0||(a.min=Math.min(n.min,a.min),a.max=Math.max(n.max,a.max),0!==n.min&&(a.minNotZero=Math.min(n.min,a.minNotZero)));a.min=V.isFinite(a.min)?a.min:null,a.max=V.isFinite(a.max)?a.max:null,a.minNotZero=V.isFinite(a.minNotZero)?a.minNotZero:null,this.handleTickRangeOptions()},handleTickRangeOptions:function(){var t=this,e=t.options.ticks;t.min=qn(e.min,t.min),t.max=qn(e.max,t.max),t.min===t.max&&(0!==t.min&&null!==t.min?(t.min=Math.pow(10,Math.floor(Dn(t.min))-1),t.max=Math.pow(10,Math.floor(Dn(t.max))+1)):(t.min=1,t.max=10)),null===t.min&&(t.min=Math.pow(10,Math.floor(Dn(t.max))-1)),null===t.max&&(t.max=0!==t.min?Math.pow(10,Math.floor(Dn(t.min))+1):10),null===t.minNotZero&&(t.min>0?t.minNotZero=t.min:t.max<1?t.minNotZero=Math.pow(10,Math.floor(Dn(t.max))):t.minNotZero=1)},buildTicks:function(){var t=this,e=t.options.ticks,n=!t.isHorizontal(),i={min:qn(e.min),max:qn(e.max)},r=t.ticks=function(t,e){var n,i,r=[],o=An(t.min,Math.pow(10,Math.floor(Dn(e.min)))),a=Math.floor(Dn(e.max)),s=Math.ceil(e.max/Math.pow(10,a));0===o?(n=Math.floor(Dn(e.minNotZero)),i=Math.floor(e.minNotZero/Math.pow(10,n)),r.push(o),o=i*Math.pow(10,n)):(n=Math.floor(Dn(o)),i=Math.floor(o/Math.pow(10,n)));var l=n<0?Math.pow(10,Math.abs(n)):1;do{r.push(o),10==++i&&(i=1,l=++n>=0?1:l),o=Math.round(i*Math.pow(10,n)*l)/l}while(n<a||n===a&&i<s);var c=An(t.max,o);return r.push(c),r}(i,t);t.max=V.max(r),t.min=V.min(r),e.reverse?(n=!n,t.start=t.max,t.end=t.min):(t.start=t.min,t.end=t.max),n&&r.reverse()},convertTicksToLabels:function(){this.tickValues=this.ticks.slice(),bn.prototype.convertTicksToLabels.call(this)},getLabelForIndex:function(t,e){return this._getScaleLabel(this.chart.data.datasets[e].data[t])},getPixelForTick:function(t){var e=this.tickValues;return t<0||t>e.length-1?null:this.getPixelForValue(e[t])},_getFirstTickValue:function(t){var e=Math.floor(Dn(t));return Math.floor(t/Math.pow(10,e))*Math.pow(10,e)},_configure:function(){var t=this,e=t.min,n=0;bn.prototype._configure.call(t),0===e&&(e=t._getFirstTickValue(t.minNotZero),n=An(t.options.ticks.fontSize,I.global.defaultFontSize)/t._length),t._startValue=Dn(e),t._valueOffset=n,t._valueRange=(Dn(t.max)-Dn(e))/(1-n)},getPixelForValue:function(t){var e=this,n=0;return(t=+e.getRightValue(t))>e.min&&t>0&&(n=(Dn(t)-e._startValue)/e._valueRange+e._valueOffset),e.getPixelForDecimal(n)},getValueForPixel:function(t){var e=this,n=e.getDecimalForPixel(t);return 0===n&&0===e.min?0:Math.pow(10,e._startValue+(n-e._valueOffset)*e._valueRange)}}),In=Ln;Rn._defaults=In;var Nn=V.valueOrDefault,Fn=V.valueAtIndexOrDefault,$n=V.options.resolve,jn={display:!0,animate:!0,position:"chartArea",angleLines:{display:!0,color:"rgba(0,0,0,0.1)",lineWidth:1,borderDash:[],borderDashOffset:0},gridLines:{circular:!1},ticks:{showLabelBackdrop:!0,backdropColor:"rgba(255,255,255,0.75)",backdropPaddingY:2,backdropPaddingX:2,callback:an.formatters.linear},pointLabels:{display:!0,fontSize:10,callback:function(t){return t}}};function zn(t){var e=t.ticks;return e.display&&t.display?Nn(e.fontSize,I.global.defaultFontSize)+2*e.backdropPaddingY:0}function Vn(t,e,n,i,r){return t===i||t===r?{start:e-n/2,end:e+n/2}:t<i||t>r?{start:e-n,end:e}:{start:e,end:e+n}}function Hn(t){return 0===t||180===t?"center":t<180?"left":"right"}function Wn(t,e,n,i){var r,o,a=n.y+i/2;if(V.isArray(e))for(r=0,o=e.length;r<o;++r)t.fillText(e[r],n.x,a),a+=i;else t.fillText(e,n.x,a)}function Un(t,e,n){90===t||270===t?n.y-=e.h/2:(t>270||t<90)&&(n.y-=e.h)}function Yn(t){return V.isNumber(t)?t:0}var Qn=Mn.extend({setDimensions:function(){var t=this;t.width=t.maxWidth,t.height=t.maxHeight,t.paddingTop=zn(t.options)/2,t.xCenter=Math.floor(t.width/2),t.yCenter=Math.floor((t.height-t.paddingTop)/2),t.drawingArea=Math.min(t.height-t.paddingTop,t.width)/2},determineDataLimits:function(){var t=this,e=t.chart,n=Number.POSITIVE_INFINITY,i=Number.NEGATIVE_INFINITY;V.each(e.data.datasets,(function(r,o){if(e.isDatasetVisible(o)){var a=e.getDatasetMeta(o);V.each(r.data,(function(e,r){var o=+t.getRightValue(e);isNaN(o)||a.data[r].hidden||(n=Math.min(o,n),i=Math.max(o,i))}))}})),t.min=n===Number.POSITIVE_INFINITY?0:n,t.max=i===Number.NEGATIVE_INFINITY?0:i,t.handleTickRangeOptions()},_computeTickLimit:function(){return Math.ceil(this.drawingArea/zn(this.options))},convertTicksToLabels:function(){var t=this;Mn.prototype.convertTicksToLabels.call(t),t.pointLabels=t.chart.data.labels.map((function(){var e=V.callback(t.options.pointLabels.callback,arguments,t);return e||0===e?e:""}))},getLabelForIndex:function(t,e){return+this.getRightValue(this.chart.data.datasets[e].data[t])},fit:function(){var t=this,e=t.options;e.display&&e.pointLabels.display?function(t){var e,n,i,r=V.options._parseFont(t.options.pointLabels),o={l:0,r:t.width,t:0,b:t.height-t.paddingTop},a={};t.ctx.font=r.string,t._pointLabelSizes=[];var s,l,c,u=t.chart.data.labels.length;for(e=0;e<u;e++){i=t.getPointPosition(e,t.drawingArea+5),s=t.ctx,l=r.lineHeight,c=t.pointLabels[e],n=V.isArray(c)?{w:V.longestText(s,s.font,c),h:c.length*l}:{w:s.measureText(c).width,h:l},t._pointLabelSizes[e]=n;var d=t.getIndexAngle(e),h=V.toDegrees(d)%360,f=Vn(h,i.x,n.w,0,180),p=Vn(h,i.y,n.h,90,270);f.start<o.l&&(o.l=f.start,a.l=d),f.end>o.r&&(o.r=f.end,a.r=d),p.start<o.t&&(o.t=p.start,a.t=d),p.end>o.b&&(o.b=p.end,a.b=d)}t.setReductions(t.drawingArea,o,a)}(t):t.setCenterPoint(0,0,0,0)},setReductions:function(t,e,n){var i=this,r=e.l/Math.sin(n.l),o=Math.max(e.r-i.width,0)/Math.sin(n.r),a=-e.t/Math.cos(n.t),s=-Math.max(e.b-(i.height-i.paddingTop),0)/Math.cos(n.b);r=Yn(r),o=Yn(o),a=Yn(a),s=Yn(s),i.drawingArea=Math.min(Math.floor(t-(r+o)/2),Math.floor(t-(a+s)/2)),i.setCenterPoint(r,o,a,s)},setCenterPoint:function(t,e,n,i){var r=this,o=r.width-e-r.drawingArea,a=t+r.drawingArea,s=n+r.drawingArea,l=r.height-r.paddingTop-i-r.drawingArea;r.xCenter=Math.floor((a+o)/2+r.left),r.yCenter=Math.floor((s+l)/2+r.top+r.paddingTop)},getIndexAngle:function(t){var e=this.chart,n=(t*(360/e.data.labels.length)+((e.options||{}).startAngle||0))%360;return(n<0?n+360:n)*Math.PI*2/360},getDistanceFromCenterForValue:function(t){var e=this;if(V.isNullOrUndef(t))return NaN;var n=e.drawingArea/(e.max-e.min);return e.options.ticks.reverse?(e.max-t)*n:(t-e.min)*n},getPointPosition:function(t,e){var n=this,i=n.getIndexAngle(t)-Math.PI/2;return{x:Math.cos(i)*e+n.xCenter,y:Math.sin(i)*e+n.yCenter}},getPointPositionForValue:function(t,e){return this.getPointPosition(t,this.getDistanceFromCenterForValue(e))},getBasePosition:function(t){var e=this,n=e.min,i=e.max;return e.getPointPositionForValue(t||0,e.beginAtZero?0:n<0&&i<0?i:n>0&&i>0?n:0)},_drawGrid:function(){var t,e,n,i=this,r=i.ctx,o=i.options,a=o.gridLines,s=o.angleLines,l=Nn(s.lineWidth,a.lineWidth),c=Nn(s.color,a.color);if(o.pointLabels.display&&function(t){var e=t.ctx,n=t.options,i=n.pointLabels,r=zn(n),o=t.getDistanceFromCenterForValue(n.ticks.reverse?t.min:t.max),a=V.options._parseFont(i);e.save(),e.font=a.string,e.textBaseline="middle";for(var s=t.chart.data.labels.length-1;s>=0;s--){var l=0===s?r/2:0,c=t.getPointPosition(s,o+l+5),u=Fn(i.fontColor,s,I.global.defaultFontColor);e.fillStyle=u;var d=t.getIndexAngle(s),h=V.toDegrees(d);e.textAlign=Hn(h),Un(h,t._pointLabelSizes[s],c),Wn(e,t.pointLabels[s],c,a.lineHeight)}e.restore()}(i),a.display&&V.each(i.ticks,(function(t,n){0!==n&&(e=i.getDistanceFromCenterForValue(i.ticksAsNumbers[n]),function(t,e,n,i){var r,o=t.ctx,a=e.circular,s=t.chart.data.labels.length,l=Fn(e.color,i-1),c=Fn(e.lineWidth,i-1);if((a||s)&&l&&c){if(o.save(),o.strokeStyle=l,o.lineWidth=c,o.setLineDash&&(o.setLineDash(e.borderDash||[]),o.lineDashOffset=e.borderDashOffset||0),o.beginPath(),a)o.arc(t.xCenter,t.yCenter,n,0,2*Math.PI);else{r=t.getPointPosition(0,n),o.moveTo(r.x,r.y);for(var u=1;u<s;u++)r=t.getPointPosition(u,n),o.lineTo(r.x,r.y)}o.closePath(),o.stroke(),o.restore()}}(i,a,e,n))})),s.display&&l&&c){for(r.save(),r.lineWidth=l,r.strokeStyle=c,r.setLineDash&&(r.setLineDash($n([s.borderDash,a.borderDash,[]])),r.lineDashOffset=$n([s.borderDashOffset,a.borderDashOffset,0])),t=i.chart.data.labels.length-1;t>=0;t--)e=i.getDistanceFromCenterForValue(o.ticks.reverse?i.min:i.max),n=i.getPointPosition(t,e),r.beginPath(),r.moveTo(i.xCenter,i.yCenter),r.lineTo(n.x,n.y),r.stroke();r.restore()}},_drawLabels:function(){var t=this,e=t.ctx,n=t.options.ticks;if(n.display){var i,r,o=t.getIndexAngle(0),a=V.options._parseFont(n),s=Nn(n.fontColor,I.global.defaultFontColor);e.save(),e.font=a.string,e.translate(t.xCenter,t.yCenter),e.rotate(o),e.textAlign="center",e.textBaseline="middle",V.each(t.ticks,(function(o,l){(0!==l||n.reverse)&&(i=t.getDistanceFromCenterForValue(t.ticksAsNumbers[l]),n.showLabelBackdrop&&(r=e.measureText(o).width,e.fillStyle=n.backdropColor,e.fillRect(-r/2-n.backdropPaddingX,-i-a.size/2-n.backdropPaddingY,r+2*n.backdropPaddingX,a.size+2*n.backdropPaddingY)),e.fillStyle=s,e.fillText(o,0,-i))})),e.restore()}},_drawTitle:V.noop}),Gn=jn;Qn._defaults=Gn;var Kn=V._deprecated,Jn=V.options.resolve,Zn=V.valueOrDefault,Xn=Number.MIN_SAFE_INTEGER||-9007199254740991,ti=Number.MAX_SAFE_INTEGER||9007199254740991,ei={millisecond:{common:!0,size:1,steps:1e3},second:{common:!0,size:1e3,steps:60},minute:{common:!0,size:6e4,steps:60},hour:{common:!0,size:36e5,steps:24},day:{common:!0,size:864e5,steps:30},week:{common:!1,size:6048e5,steps:4},month:{common:!0,size:2628e6,steps:12},quarter:{common:!1,size:7884e6,steps:4},year:{common:!0,size:3154e7}},ni=Object.keys(ei);function ii(t,e){return t-e}function ri(t){return V.valueOrDefault(t.time.min,t.ticks.min)}function oi(t){return V.valueOrDefault(t.time.max,t.ticks.max)}function ai(t,e,n,i){var r=function(t,e,n){for(var i,r,o,a=0,s=t.length-1;a>=0&&a<=s;){if(r=t[(i=a+s>>1)-1]||null,o=t[i],!r)return{lo:null,hi:o};if(o[e]<n)a=i+1;else{if(!(r[e]>n))return{lo:r,hi:o};s=i-1}}return{lo:o,hi:null}}(t,e,n),o=r.lo?r.hi?r.lo:t[t.length-2]:t[0],a=r.lo?r.hi?r.hi:t[t.length-1]:t[1],s=a[e]-o[e],l=s?(n-o[e])/s:0,c=(a[i]-o[i])*l;return o[i]+c}function si(t,e){var n=t._adapter,i=t.options.time,r=i.parser,o=r||i.format,a=e;return"function"==typeof r&&(a=r(a)),V.isFinite(a)||(a="string"==typeof o?n.parse(a,o):n.parse(a)),null!==a?+a:(r||"function"!=typeof o||(a=o(e),V.isFinite(a)||(a=n.parse(a))),a)}function li(t,e){if(V.isNullOrUndef(e))return null;var n=t.options.time,i=si(t,t.getRightValue(e));return null===i||n.round&&(i=+t._adapter.startOf(i,n.round)),i}function ci(t,e,n,i){var r,o,a,s=ni.length;for(r=ni.indexOf(t);r<s-1;++r)if(a=(o=ei[ni[r]]).steps?o.steps:ti,o.common&&Math.ceil((n-e)/(a*o.size))<=i)return ni[r];return ni[s-1]}function ui(t,e,n){var i,r,o=[],a={},s=e.length;for(i=0;i<s;++i)a[r=e[i]]=i,o.push({value:r,major:!1});return 0!==s&&n?function(t,e,n,i){var r,o,a=t._adapter,s=+a.startOf(e[0].value,i),l=e[e.length-1].value;for(r=s;r<=l;r=+a.add(r,1,i))(o=n[r])>=0&&(e[o].major=!0);return e}(t,o,a,n):o}var di=bn.extend({initialize:function(){this.mergeTicksOptions(),bn.prototype.initialize.call(this)},update:function(){var t=this,e=t.options,n=e.time||(e.time={}),i=t._adapter=new on._date(e.adapters.date);return Kn("time scale",n.format,"time.format","time.parser"),Kn("time scale",n.min,"time.min","ticks.min"),Kn("time scale",n.max,"time.max","ticks.max"),V.mergeIf(n.displayFormats,i.formats()),bn.prototype.update.apply(t,arguments)},getRightValue:function(t){return t&&void 0!==t.t&&(t=t.t),bn.prototype.getRightValue.call(this,t)},determineDataLimits:function(){var t,e,n,i,r,o,a,s=this,l=s.chart,c=s._adapter,u=s.options,d=u.time.unit||"day",h=ti,f=Xn,p=[],m=[],v=[],g=s._getLabels();for(t=0,n=g.length;t<n;++t)v.push(li(s,g[t]));for(t=0,n=(l.data.datasets||[]).length;t<n;++t)if(l.isDatasetVisible(t))if(r=l.data.datasets[t].data,V.isObject(r[0]))for(m[t]=[],e=0,i=r.length;e<i;++e)o=li(s,r[e]),p.push(o),m[t][e]=o;else m[t]=v.slice(0),a||(p=p.concat(v),a=!0);else m[t]=[];v.length&&(h=Math.min(h,v[0]),f=Math.max(f,v[v.length-1])),p.length&&(p=n>1?function(t){var e,n,i,r={},o=[];for(e=0,n=t.length;e<n;++e)r[i=t[e]]||(r[i]=!0,o.push(i));return o}(p).sort(ii):p.sort(ii),h=Math.min(h,p[0]),f=Math.max(f,p[p.length-1])),h=li(s,ri(u))||h,f=li(s,oi(u))||f,h=h===ti?+c.startOf(Date.now(),d):h,f=f===Xn?+c.endOf(Date.now(),d)+1:f,s.min=Math.min(h,f),s.max=Math.max(h+1,f),s._table=[],s._timestamps={data:p,datasets:m,labels:v}},buildTicks:function(){var t,e,n,i=this,r=i.min,o=i.max,a=i.options,s=a.ticks,l=a.time,c=i._timestamps,u=[],d=i.getLabelCapacity(r),h=s.source,f=a.distribution;for(c="data"===h||"auto"===h&&"series"===f?c.data:"labels"===h?c.labels:function(t,e,n,i){var r,o=t._adapter,a=t.options,s=a.time,l=s.unit||ci(s.minUnit,e,n,i),c=Jn([s.stepSize,s.unitStepSize,1]),u="week"===l&&s.isoWeekday,d=e,h=[];if(u&&(d=+o.startOf(d,"isoWeek",u)),d=+o.startOf(d,u?"day":l),o.diff(n,e,l)>1e5*c)throw e+" and "+n+" are too far apart with stepSize of "+c+" "+l;for(r=d;r<n;r=+o.add(r,c,l))h.push(r);return r!==n&&"ticks"!==a.bounds||h.push(r),h}(i,r,o,d),"ticks"===a.bounds&&c.length&&(r=c[0],o=c[c.length-1]),r=li(i,ri(a))||r,o=li(i,oi(a))||o,t=0,e=c.length;t<e;++t)(n=c[t])>=r&&n<=o&&u.push(n);return i.min=r,i.max=o,i._unit=l.unit||(s.autoSkip?ci(l.minUnit,i.min,i.max,d):function(t,e,n,i,r){var o,a;for(o=ni.length-1;o>=ni.indexOf(n);o--)if(a=ni[o],ei[a].common&&t._adapter.diff(r,i,a)>=e-1)return a;return ni[n?ni.indexOf(n):0]}(i,u.length,l.minUnit,i.min,i.max)),i._majorUnit=s.major.enabled&&"year"!==i._unit?function(t){for(var e=ni.indexOf(t)+1,n=ni.length;e<n;++e)if(ei[ni[e]].common)return ni[e]}(i._unit):void 0,i._table=function(t,e,n,i){if("linear"===i||!t.length)return[{time:e,pos:0},{time:n,pos:1}];var r,o,a,s,l,c=[],u=[e];for(r=0,o=t.length;r<o;++r)(s=t[r])>e&&s<n&&u.push(s);for(u.push(n),r=0,o=u.length;r<o;++r)l=u[r+1],a=u[r-1],s=u[r],void 0!==a&&void 0!==l&&Math.round((l+a)/2)===s||c.push({time:s,pos:r/(o-1)});return c}(i._timestamps.data,r,o,f),i._offsets=function(t,e,n,i,r){var o,a,s=0,l=0;return r.offset&&e.length&&(o=ai(t,"time",e[0],"pos"),s=1===e.length?1-o:(ai(t,"time",e[1],"pos")-o)/2,a=ai(t,"time",e[e.length-1],"pos"),l=1===e.length?a:(a-ai(t,"time",e[e.length-2],"pos"))/2),{start:s,end:l,factor:1/(s+1+l)}}(i._table,u,0,0,a),s.reverse&&u.reverse(),ui(i,u,i._majorUnit)},getLabelForIndex:function(t,e){var n=this,i=n._adapter,r=n.chart.data,o=n.options.time,a=r.labels&&t<r.labels.length?r.labels[t]:"",s=r.datasets[e].data[t];return V.isObject(s)&&(a=n.getRightValue(s)),o.tooltipFormat?i.format(si(n,a),o.tooltipFormat):"string"==typeof a?a:i.format(si(n,a),o.displayFormats.datetime)},tickFormatFunction:function(t,e,n,i){var r=this,o=r._adapter,a=r.options,s=a.time.displayFormats,l=s[r._unit],c=r._majorUnit,u=s[c],d=n[e],h=a.ticks,f=c&&u&&d&&d.major,p=o.format(t,i||(f?u:l)),m=f?h.major:h.minor,v=Jn([m.callback,m.userCallback,h.callback,h.userCallback]);return v?v(p,e,n):p},convertTicksToLabels:function(t){var e,n,i=[];for(e=0,n=t.length;e<n;++e)i.push(this.tickFormatFunction(t[e].value,e,t));return i},getPixelForOffset:function(t){var e=this,n=e._offsets,i=ai(e._table,"time",t,"pos");return e.getPixelForDecimal((n.start+i)*n.factor)},getPixelForValue:function(t,e,n){var i=this,r=null;if(void 0!==e&&void 0!==n&&(r=i._timestamps.datasets[n][e]),null===r&&(r=li(i,t)),null!==r)return i.getPixelForOffset(r)},getPixelForTick:function(t){var e=this.getTicks();return t>=0&&t<e.length?this.getPixelForOffset(e[t].value):null},getValueForPixel:function(t){var e=this,n=e._offsets,i=e.getDecimalForPixel(t)/n.factor-n.end,r=ai(e._table,"pos",i,"time");return e._adapter._create(r)},_getLabelSize:function(t){var e=this,n=e.options.ticks,i=e.ctx.measureText(t).width,r=V.toRadians(e.isHorizontal()?n.maxRotation:n.minRotation),o=Math.cos(r),a=Math.sin(r),s=Zn(n.fontSize,I.global.defaultFontSize);return{w:i*o+s*a,h:i*a+s*o}},getLabelWidth:function(t){return this._getLabelSize(t).w},getLabelCapacity:function(t){var e=this,n=e.options.time,i=n.displayFormats,r=i[n.unit]||i.millisecond,o=e.tickFormatFunction(t,0,ui(e,[t],e._majorUnit),r),a=e._getLabelSize(o),s=Math.floor(e.isHorizontal()?e.width/a.w:e.height/a.h);return e.options.offset&&s--,s>0?s:1}}),hi={position:"bottom",distribution:"linear",bounds:"data",adapters:{},time:{parser:!1,unit:!1,round:!1,displayFormat:!1,isoWeekday:!1,minUnit:"millisecond",displayFormats:{}},ticks:{autoSkip:!1,source:"auto",major:{enabled:!1}}};di._defaults=hi;var fi={category:kn,linear:Bn,logarithmic:Rn,radialLinear:Qn,time:di},pi=e((function(e,n){e.exports=function(){var n,i;function r(){return n.apply(null,arguments)}function o(t){n=t}function a(t){return t instanceof Array||"[object Array]"===Object.prototype.toString.call(t)}function s(t){return null!=t&&"[object Object]"===Object.prototype.toString.call(t)}function l(t){if(Object.getOwnPropertyNames)return 0===Object.getOwnPropertyNames(t).length;var e;for(e in t)if(t.hasOwnProperty(e))return!1;return!0}function c(t){return void 0===t}function u(t){return"number"==typeof t||"[object Number]"===Object.prototype.toString.call(t)}function d(t){return t instanceof Date||"[object Date]"===Object.prototype.toString.call(t)}function h(t,e){var n,i=[];for(n=0;n<t.length;++n)i.push(e(t[n],n));return i}function f(t,e){return Object.prototype.hasOwnProperty.call(t,e)}function p(t,e){for(var n in e)f(e,n)&&(t[n]=e[n]);return f(e,"toString")&&(t.toString=e.toString),f(e,"valueOf")&&(t.valueOf=e.valueOf),t}function m(t,e,n,i){return Qn(t,e,n,i,!0).utc()}function v(){return{empty:!1,unusedTokens:[],unusedInput:[],overflow:-2,charsLeftOver:0,nullInput:!1,invalidMonth:null,invalidFormat:!1,userInvalidated:!1,iso:!1,parsedDateParts:[],meridiem:null,rfc2822:!1,weekdayMismatch:!1}}function g(t){return null==t._pf&&(t._pf=v()),t._pf}function y(t){if(null==t._isValid){var e=g(t),n=i.call(e.parsedDateParts,(function(t){return null!=t})),r=!isNaN(t._d.getTime())&&e.overflow<0&&!e.empty&&!e.invalidMonth&&!e.invalidWeekday&&!e.weekdayMismatch&&!e.nullInput&&!e.invalidFormat&&!e.userInvalidated&&(!e.meridiem||e.meridiem&&n);if(t._strict&&(r=r&&0===e.charsLeftOver&&0===e.unusedTokens.length&&void 0===e.bigHour),null!=Object.isFrozen&&Object.isFrozen(t))return r;t._isValid=r}return t._isValid}function _(t){var e=m(NaN);return null!=t?p(g(e),t):g(e).userInvalidated=!0,e}i=Array.prototype.some?Array.prototype.some:function(t){for(var e=Object(this),n=e.length>>>0,i=0;i<n;i++)if(i in e&&t.call(this,e[i],i,e))return!0;return!1};var b=r.momentProperties=[];function w(t,e){var n,i,r;if(c(e._isAMomentObject)||(t._isAMomentObject=e._isAMomentObject),c(e._i)||(t._i=e._i),c(e._f)||(t._f=e._f),c(e._l)||(t._l=e._l),c(e._strict)||(t._strict=e._strict),c(e._tzm)||(t._tzm=e._tzm),c(e._isUTC)||(t._isUTC=e._isUTC),c(e._offset)||(t._offset=e._offset),c(e._pf)||(t._pf=g(e)),c(e._locale)||(t._locale=e._locale),b.length>0)for(n=0;n<b.length;n++)c(r=e[i=b[n]])||(t[i]=r);return t}var k=!1;function x(t){w(this,t),this._d=new Date(null!=t._d?t._d.getTime():NaN),this.isValid()||(this._d=new Date(NaN)),!1===k&&(k=!0,r.updateOffset(this),k=!1)}function C(t){return t instanceof x||null!=t&&null!=t._isAMomentObject}function S(t){return t<0?Math.ceil(t)||0:Math.floor(t)}function M(t){var e=+t,n=0;return 0!==e&&isFinite(e)&&(n=S(e)),n}function T(t,e,n){var i,r=Math.min(t.length,e.length),o=Math.abs(t.length-e.length),a=0;for(i=0;i<r;i++)(n&&t[i]!==e[i]||!n&&M(t[i])!==M(e[i]))&&a++;return a+o}function P(t){!1===r.suppressDeprecationWarnings&&"undefined"!=typeof console&&console.warn&&console.warn("Deprecation warning: "+t)}function O(t,e){var n=!0;return p((function(){if(null!=r.deprecationHandler&&r.deprecationHandler(null,t),n){for(var i,o=[],a=0;a<arguments.length;a++){if(i="","object"==typeof arguments[a]){for(var s in i+="\n["+a+"] ",arguments[0])i+=s+": "+arguments[0][s]+", ";i=i.slice(0,-2)}else i=arguments[a];o.push(i)}P(t+"\nArguments: "+Array.prototype.slice.call(o).join("")+"\n"+(new Error).stack),n=!1}return e.apply(this,arguments)}),e)}var B,E={};function A(t,e){null!=r.deprecationHandler&&r.deprecationHandler(t,e),E[t]||(P(e),E[t]=!0)}function D(t){return t instanceof Function||"[object Function]"===Object.prototype.toString.call(t)}function L(t){var e,n;for(n in t)D(e=t[n])?this[n]=e:this["_"+n]=e;this._config=t,this._dayOfMonthOrdinalParseLenient=new RegExp((this._dayOfMonthOrdinalParse.source||this._ordinalParse.source)+"|"+/\d{1,2}/.source)}function q(t,e){var n,i=p({},t);for(n in e)f(e,n)&&(s(t[n])&&s(e[n])?(i[n]={},p(i[n],t[n]),p(i[n],e[n])):null!=e[n]?i[n]=e[n]:delete i[n]);for(n in t)f(t,n)&&!f(e,n)&&s(t[n])&&(i[n]=p({},i[n]));return i}function R(t){null!=t&&this.set(t)}r.suppressDeprecationWarnings=!1,r.deprecationHandler=null,B=Object.keys?Object.keys:function(t){var e,n=[];for(e in t)f(t,e)&&n.push(e);return n};var I={sameDay:"[Today at] LT",nextDay:"[Tomorrow at] LT",nextWeek:"dddd [at] LT",lastDay:"[Yesterday at] LT",lastWeek:"[Last] dddd [at] LT",sameElse:"L"};function N(t,e,n){var i=this._calendar[t]||this._calendar.sameElse;return D(i)?i.call(e,n):i}var F={LTS:"h:mm:ss A",LT:"h:mm A",L:"MM/DD/YYYY",LL:"MMMM D, YYYY",LLL:"MMMM D, YYYY h:mm A",LLLL:"dddd, MMMM D, YYYY h:mm A"};function $(t){var e=this._longDateFormat[t],n=this._longDateFormat[t.toUpperCase()];return e||!n?e:(this._longDateFormat[t]=n.replace(/MMMM|MM|DD|dddd/g,(function(t){return t.slice(1)})),this._longDateFormat[t])}var j="Invalid date";function z(){return this._invalidDate}var V="%d",H=/\d{1,2}/;function W(t){return this._ordinal.replace("%d",t)}var U={future:"in %s",past:"%s ago",s:"a few seconds",ss:"%d seconds",m:"a minute",mm:"%d minutes",h:"an hour",hh:"%d hours",d:"a day",dd:"%d days",M:"a month",MM:"%d months",y:"a year",yy:"%d years"};function Y(t,e,n,i){var r=this._relativeTime[n];return D(r)?r(t,e,n,i):r.replace(/%d/i,t)}function Q(t,e){var n=this._relativeTime[t>0?"future":"past"];return D(n)?n(e):n.replace(/%s/i,e)}var G={};function K(t,e){var n=t.toLowerCase();G[n]=G[n+"s"]=G[e]=t}function J(t){return"string"==typeof t?G[t]||G[t.toLowerCase()]:void 0}function Z(t){var e,n,i={};for(n in t)f(t,n)&&(e=J(n))&&(i[e]=t[n]);return i}var X={};function tt(t,e){X[t]=e}function et(t){var e=[];for(var n in t)e.push({unit:n,priority:X[n]});return e.sort((function(t,e){return t.priority-e.priority})),e}function nt(t,e,n){var i=""+Math.abs(t),r=e-i.length;return(t>=0?n?"+":"":"-")+Math.pow(10,Math.max(0,r)).toString().substr(1)+i}var it=/(\[[^\[]*\])|(\\)?([Hh]mm(ss)?|Mo|MM?M?M?|Do|DDDo|DD?D?D?|ddd?d?|do?|w[o|w]?|W[o|W]?|Qo?|YYYYYY|YYYYY|YYYY|YY|gg(ggg?)?|GG(GGG?)?|e|E|a|A|hh?|HH?|kk?|mm?|ss?|S{1,9}|x|X|zz?|ZZ?|.)/g,rt=/(\[[^\[]*\])|(\\)?(LTS|LT|LL?L?L?|l{1,4})/g,ot={},at={};function st(t,e,n,i){var r=i;"string"==typeof i&&(r=function(){return this[i]()}),t&&(at[t]=r),e&&(at[e[0]]=function(){return nt(r.apply(this,arguments),e[1],e[2])}),n&&(at[n]=function(){return this.localeData().ordinal(r.apply(this,arguments),t)})}function lt(t){return t.match(/\[[\s\S]/)?t.replace(/^\[|\]$/g,""):t.replace(/\\/g,"")}function ct(t){var e,n,i=t.match(it);for(e=0,n=i.length;e<n;e++)at[i[e]]?i[e]=at[i[e]]:i[e]=lt(i[e]);return function(e){var r,o="";for(r=0;r<n;r++)o+=D(i[r])?i[r].call(e,t):i[r];return o}}function ut(t,e){return t.isValid()?(e=dt(e,t.localeData()),ot[e]=ot[e]||ct(e),ot[e](t)):t.localeData().invalidDate()}function dt(t,e){var n=5;function i(t){return e.longDateFormat(t)||t}for(rt.lastIndex=0;n>=0&&rt.test(t);)t=t.replace(rt,i),rt.lastIndex=0,n-=1;return t}var ht=/\d/,ft=/\d\d/,pt=/\d{3}/,mt=/\d{4}/,vt=/[+-]?\d{6}/,gt=/\d\d?/,yt=/\d\d\d\d?/,_t=/\d\d\d\d\d\d?/,bt=/\d{1,3}/,wt=/\d{1,4}/,kt=/[+-]?\d{1,6}/,xt=/\d+/,Ct=/[+-]?\d+/,St=/Z|[+-]\d\d:?\d\d/gi,Mt=/Z|[+-]\d\d(?::?\d\d)?/gi,Tt=/[+-]?\d+(\.\d{1,3})?/,Pt=/[0-9]{0,256}['a-z\u00A0-\u05FF\u0700-\uD7FF\uF900-\uFDCF\uFDF0-\uFF07\uFF10-\uFFEF]{1,256}|[\u0600-\u06FF\/]{1,256}(\s*?[\u0600-\u06FF]{1,256}){1,2}/i,Ot={};function Bt(t,e,n){Ot[t]=D(e)?e:function(t,i){return t&&n?n:e}}function Et(t,e){return f(Ot,t)?Ot[t](e._strict,e._locale):new RegExp(At(t))}function At(t){return Dt(t.replace("\\","").replace(/\\(\[)|\\(\])|\[([^\]\[]*)\]|\\(.)/g,(function(t,e,n,i,r){return e||n||i||r})))}function Dt(t){return t.replace(/[-\/\\^$*+?.()|[\]{}]/g,"\\$&")}var Lt={};function qt(t,e){var n,i=e;for("string"==typeof t&&(t=[t]),u(e)&&(i=function(t,n){n[e]=M(t)}),n=0;n<t.length;n++)Lt[t[n]]=i}function Rt(t,e){qt(t,(function(t,n,i,r){i._w=i._w||{},e(t,i._w,i,r)}))}function It(t,e,n){null!=e&&f(Lt,t)&&Lt[t](e,n._a,n,t)}var Nt=0,Ft=1,$t=2,jt=3,zt=4,Vt=5,Ht=6,Wt=7,Ut=8;function Yt(t){return Qt(t)?366:365}function Qt(t){return t%4==0&&t%100!=0||t%400==0}st("Y",0,0,(function(){var t=this.year();return t<=9999?""+t:"+"+t})),st(0,["YY",2],0,(function(){return this.year()%100})),st(0,["YYYY",4],0,"year"),st(0,["YYYYY",5],0,"year"),st(0,["YYYYYY",6,!0],0,"year"),K("year","y"),tt("year",1),Bt("Y",Ct),Bt("YY",gt,ft),Bt("YYYY",wt,mt),Bt("YYYYY",kt,vt),Bt("YYYYYY",kt,vt),qt(["YYYYY","YYYYYY"],Nt),qt("YYYY",(function(t,e){e[Nt]=2===t.length?r.parseTwoDigitYear(t):M(t)})),qt("YY",(function(t,e){e[Nt]=r.parseTwoDigitYear(t)})),qt("Y",(function(t,e){e[Nt]=parseInt(t,10)})),r.parseTwoDigitYear=function(t){return M(t)+(M(t)>68?1900:2e3)};var Gt,Kt=Zt("FullYear",!0);function Jt(){return Qt(this.year())}function Zt(t,e){return function(n){return null!=n?(te(this,t,n),r.updateOffset(this,e),this):Xt(this,t)}}function Xt(t,e){return t.isValid()?t._d["get"+(t._isUTC?"UTC":"")+e]():NaN}function te(t,e,n){t.isValid()&&!isNaN(n)&&("FullYear"===e&&Qt(t.year())&&1===t.month()&&29===t.date()?t._d["set"+(t._isUTC?"UTC":"")+e](n,t.month(),re(n,t.month())):t._d["set"+(t._isUTC?"UTC":"")+e](n))}function ee(t){return D(this[t=J(t)])?this[t]():this}function ne(t,e){if("object"==typeof t)for(var n=et(t=Z(t)),i=0;i<n.length;i++)this[n[i].unit](t[n[i].unit]);else if(D(this[t=J(t)]))return this[t](e);return this}function ie(t,e){return(t%e+e)%e}function re(t,e){if(isNaN(t)||isNaN(e))return NaN;var n=ie(e,12);return t+=(e-n)/12,1===n?Qt(t)?29:28:31-n%7%2}Gt=Array.prototype.indexOf?Array.prototype.indexOf:function(t){var e;for(e=0;e<this.length;++e)if(this[e]===t)return e;return-1},st("M",["MM",2],"Mo",(function(){return this.month()+1})),st("MMM",0,0,(function(t){return this.localeData().monthsShort(this,t)})),st("MMMM",0,0,(function(t){return this.localeData().months(this,t)})),K("month","M"),tt("month",8),Bt("M",gt),Bt("MM",gt,ft),Bt("MMM",(function(t,e){return e.monthsShortRegex(t)})),Bt("MMMM",(function(t,e){return e.monthsRegex(t)})),qt(["M","MM"],(function(t,e){e[Ft]=M(t)-1})),qt(["MMM","MMMM"],(function(t,e,n,i){var r=n._locale.monthsParse(t,i,n._strict);null!=r?e[Ft]=r:g(n).invalidMonth=t}));var oe=/D[oD]?(\[[^\[\]]*\]|\s)+MMMM?/,ae="January_February_March_April_May_June_July_August_September_October_November_December".split("_");function se(t,e){return t?a(this._months)?this._months[t.month()]:this._months[(this._months.isFormat||oe).test(e)?"format":"standalone"][t.month()]:a(this._months)?this._months:this._months.standalone}var le="Jan_Feb_Mar_Apr_May_Jun_Jul_Aug_Sep_Oct_Nov_Dec".split("_");function ce(t,e){return t?a(this._monthsShort)?this._monthsShort[t.month()]:this._monthsShort[oe.test(e)?"format":"standalone"][t.month()]:a(this._monthsShort)?this._monthsShort:this._monthsShort.standalone}function ue(t,e,n){var i,r,o,a=t.toLocaleLowerCase();if(!this._monthsParse)for(this._monthsParse=[],this._longMonthsParse=[],this._shortMonthsParse=[],i=0;i<12;++i)o=m([2e3,i]),this._shortMonthsParse[i]=this.monthsShort(o,"").toLocaleLowerCase(),this._longMonthsParse[i]=this.months(o,"").toLocaleLowerCase();return n?"MMM"===e?-1!==(r=Gt.call(this._shortMonthsParse,a))?r:null:-1!==(r=Gt.call(this._longMonthsParse,a))?r:null:"MMM"===e?-1!==(r=Gt.call(this._shortMonthsParse,a))||-1!==(r=Gt.call(this._longMonthsParse,a))?r:null:-1!==(r=Gt.call(this._longMonthsParse,a))||-1!==(r=Gt.call(this._shortMonthsParse,a))?r:null}function de(t,e,n){var i,r,o;if(this._monthsParseExact)return ue.call(this,t,e,n);for(this._monthsParse||(this._monthsParse=[],this._longMonthsParse=[],this._shortMonthsParse=[]),i=0;i<12;i++){if(r=m([2e3,i]),n&&!this._longMonthsParse[i]&&(this._longMonthsParse[i]=new RegExp("^"+this.months(r,"").replace(".","")+"$","i"),this._shortMonthsParse[i]=new RegExp("^"+this.monthsShort(r,"").replace(".","")+"$","i")),n||this._monthsParse[i]||(o="^"+this.months(r,"")+"|^"+this.monthsShort(r,""),this._monthsParse[i]=new RegExp(o.replace(".",""),"i")),n&&"MMMM"===e&&this._longMonthsParse[i].test(t))return i;if(n&&"MMM"===e&&this._shortMonthsParse[i].test(t))return i;if(!n&&this._monthsParse[i].test(t))return i}}function he(t,e){var n;if(!t.isValid())return t;if("string"==typeof e)if(/^\d+$/.test(e))e=M(e);else if(!u(e=t.localeData().monthsParse(e)))return t;return n=Math.min(t.date(),re(t.year(),e)),t._d["set"+(t._isUTC?"UTC":"")+"Month"](e,n),t}function fe(t){return null!=t?(he(this,t),r.updateOffset(this,!0),this):Xt(this,"Month")}function pe(){return re(this.year(),this.month())}var me=Pt;function ve(t){return this._monthsParseExact?(f(this,"_monthsRegex")||_e.call(this),t?this._monthsShortStrictRegex:this._monthsShortRegex):(f(this,"_monthsShortRegex")||(this._monthsShortRegex=me),this._monthsShortStrictRegex&&t?this._monthsShortStrictRegex:this._monthsShortRegex)}var ge=Pt;function ye(t){return this._monthsParseExact?(f(this,"_monthsRegex")||_e.call(this),t?this._monthsStrictRegex:this._monthsRegex):(f(this,"_monthsRegex")||(this._monthsRegex=ge),this._monthsStrictRegex&&t?this._monthsStrictRegex:this._monthsRegex)}function _e(){function t(t,e){return e.length-t.length}var e,n,i=[],r=[],o=[];for(e=0;e<12;e++)n=m([2e3,e]),i.push(this.monthsShort(n,"")),r.push(this.months(n,"")),o.push(this.months(n,"")),o.push(this.monthsShort(n,""));for(i.sort(t),r.sort(t),o.sort(t),e=0;e<12;e++)i[e]=Dt(i[e]),r[e]=Dt(r[e]);for(e=0;e<24;e++)o[e]=Dt(o[e]);this._monthsRegex=new RegExp("^("+o.join("|")+")","i"),this._monthsShortRegex=this._monthsRegex,this._monthsStrictRegex=new RegExp("^("+r.join("|")+")","i"),this._monthsShortStrictRegex=new RegExp("^("+i.join("|")+")","i")}function be(t,e,n,i,r,o,a){var s;return t<100&&t>=0?(s=new Date(t+400,e,n,i,r,o,a),isFinite(s.getFullYear())&&s.setFullYear(t)):s=new Date(t,e,n,i,r,o,a),s}function we(t){var e;if(t<100&&t>=0){var n=Array.prototype.slice.call(arguments);n[0]=t+400,e=new Date(Date.UTC.apply(null,n)),isFinite(e.getUTCFullYear())&&e.setUTCFullYear(t)}else e=new Date(Date.UTC.apply(null,arguments));return e}function ke(t,e,n){var i=7+e-n;return-(7+we(t,0,i).getUTCDay()-e)%7+i-1}function xe(t,e,n,i,r){var o,a,s=1+7*(e-1)+(7+n-i)%7+ke(t,i,r);return s<=0?a=Yt(o=t-1)+s:s>Yt(t)?(o=t+1,a=s-Yt(t)):(o=t,a=s),{year:o,dayOfYear:a}}function Ce(t,e,n){var i,r,o=ke(t.year(),e,n),a=Math.floor((t.dayOfYear()-o-1)/7)+1;return a<1?i=a+Se(r=t.year()-1,e,n):a>Se(t.year(),e,n)?(i=a-Se(t.year(),e,n),r=t.year()+1):(r=t.year(),i=a),{week:i,year:r}}function Se(t,e,n){var i=ke(t,e,n),r=ke(t+1,e,n);return(Yt(t)-i+r)/7}function Me(t){return Ce(t,this._week.dow,this._week.doy).week}st("w",["ww",2],"wo","week"),st("W",["WW",2],"Wo","isoWeek"),K("week","w"),K("isoWeek","W"),tt("week",5),tt("isoWeek",5),Bt("w",gt),Bt("ww",gt,ft),Bt("W",gt),Bt("WW",gt,ft),Rt(["w","ww","W","WW"],(function(t,e,n,i){e[i.substr(0,1)]=M(t)}));var Te={dow:0,doy:6};function Pe(){return this._week.dow}function Oe(){return this._week.doy}function Be(t){var e=this.localeData().week(this);return null==t?e:this.add(7*(t-e),"d")}function Ee(t){var e=Ce(this,1,4).week;return null==t?e:this.add(7*(t-e),"d")}function Ae(t,e){return"string"!=typeof t?t:isNaN(t)?"number"==typeof(t=e.weekdaysParse(t))?t:null:parseInt(t,10)}function De(t,e){return"string"==typeof t?e.weekdaysParse(t)%7||7:isNaN(t)?null:t}function Le(t,e){return t.slice(e,7).concat(t.slice(0,e))}st("d",0,"do","day"),st("dd",0,0,(function(t){return this.localeData().weekdaysMin(this,t)})),st("ddd",0,0,(function(t){return this.localeData().weekdaysShort(this,t)})),st("dddd",0,0,(function(t){return this.localeData().weekdays(this,t)})),st("e",0,0,"weekday"),st("E",0,0,"isoWeekday"),K("day","d"),K("weekday","e"),K("isoWeekday","E"),tt("day",11),tt("weekday",11),tt("isoWeekday",11),Bt("d",gt),Bt("e",gt),Bt("E",gt),Bt("dd",(function(t,e){return e.weekdaysMinRegex(t)})),Bt("ddd",(function(t,e){return e.weekdaysShortRegex(t)})),Bt("dddd",(function(t,e){return e.weekdaysRegex(t)})),Rt(["dd","ddd","dddd"],(function(t,e,n,i){var r=n._locale.weekdaysParse(t,i,n._strict);null!=r?e.d=r:g(n).invalidWeekday=t})),Rt(["d","e","E"],(function(t,e,n,i){e[i]=M(t)}));var qe="Sunday_Monday_Tuesday_Wednesday_Thursday_Friday_Saturday".split("_");function Re(t,e){var n=a(this._weekdays)?this._weekdays:this._weekdays[t&&!0!==t&&this._weekdays.isFormat.test(e)?"format":"standalone"];return!0===t?Le(n,this._week.dow):t?n[t.day()]:n}var Ie="Sun_Mon_Tue_Wed_Thu_Fri_Sat".split("_");function Ne(t){return!0===t?Le(this._weekdaysShort,this._week.dow):t?this._weekdaysShort[t.day()]:this._weekdaysShort}var Fe="Su_Mo_Tu_We_Th_Fr_Sa".split("_");function $e(t){return!0===t?Le(this._weekdaysMin,this._week.dow):t?this._weekdaysMin[t.day()]:this._weekdaysMin}function je(t,e,n){var i,r,o,a=t.toLocaleLowerCase();if(!this._weekdaysParse)for(this._weekdaysParse=[],this._shortWeekdaysParse=[],this._minWeekdaysParse=[],i=0;i<7;++i)o=m([2e3,1]).day(i),this._minWeekdaysParse[i]=this.weekdaysMin(o,"").toLocaleLowerCase(),this._shortWeekdaysParse[i]=this.weekdaysShort(o,"").toLocaleLowerCase(),this._weekdaysParse[i]=this.weekdays(o,"").toLocaleLowerCase();return n?"dddd"===e?-1!==(r=Gt.call(this._weekdaysParse,a))?r:null:"ddd"===e?-1!==(r=Gt.call(this._shortWeekdaysParse,a))?r:null:-1!==(r=Gt.call(this._minWeekdaysParse,a))?r:null:"dddd"===e?-1!==(r=Gt.call(this._weekdaysParse,a))||-1!==(r=Gt.call(this._shortWeekdaysParse,a))||-1!==(r=Gt.call(this._minWeekdaysParse,a))?r:null:"ddd"===e?-1!==(r=Gt.call(this._shortWeekdaysParse,a))||-1!==(r=Gt.call(this._weekdaysParse,a))||-1!==(r=Gt.call(this._minWeekdaysParse,a))?r:null:-1!==(r=Gt.call(this._minWeekdaysParse,a))||-1!==(r=Gt.call(this._weekdaysParse,a))||-1!==(r=Gt.call(this._shortWeekdaysParse,a))?r:null}function ze(t,e,n){var i,r,o;if(this._weekdaysParseExact)return je.call(this,t,e,n);for(this._weekdaysParse||(this._weekdaysParse=[],this._minWeekdaysParse=[],this._shortWeekdaysParse=[],this._fullWeekdaysParse=[]),i=0;i<7;i++){if(r=m([2e3,1]).day(i),n&&!this._fullWeekdaysParse[i]&&(this._fullWeekdaysParse[i]=new RegExp("^"+this.weekdays(r,"").replace(".","\\.?")+"$","i"),this._shortWeekdaysParse[i]=new RegExp("^"+this.weekdaysShort(r,"").replace(".","\\.?")+"$","i"),this._minWeekdaysParse[i]=new RegExp("^"+this.weekdaysMin(r,"").replace(".","\\.?")+"$","i")),this._weekdaysParse[i]||(o="^"+this.weekdays(r,"")+"|^"+this.weekdaysShort(r,"")+"|^"+this.weekdaysMin(r,""),this._weekdaysParse[i]=new RegExp(o.replace(".",""),"i")),n&&"dddd"===e&&this._fullWeekdaysParse[i].test(t))return i;if(n&&"ddd"===e&&this._shortWeekdaysParse[i].test(t))return i;if(n&&"dd"===e&&this._minWeekdaysParse[i].test(t))return i;if(!n&&this._weekdaysParse[i].test(t))return i}}function Ve(t){if(!this.isValid())return null!=t?this:NaN;var e=this._isUTC?this._d.getUTCDay():this._d.getDay();return null!=t?(t=Ae(t,this.localeData()),this.add(t-e,"d")):e}function He(t){if(!this.isValid())return null!=t?this:NaN;var e=(this.day()+7-this.localeData()._week.dow)%7;return null==t?e:this.add(t-e,"d")}function We(t){if(!this.isValid())return null!=t?this:NaN;if(null!=t){var e=De(t,this.localeData());return this.day(this.day()%7?e:e-7)}return this.day()||7}var Ue=Pt;function Ye(t){return this._weekdaysParseExact?(f(this,"_weekdaysRegex")||Ze.call(this),t?this._weekdaysStrictRegex:this._weekdaysRegex):(f(this,"_weekdaysRegex")||(this._weekdaysRegex=Ue),this._weekdaysStrictRegex&&t?this._weekdaysStrictRegex:this._weekdaysRegex)}var Qe=Pt;function Ge(t){return this._weekdaysParseExact?(f(this,"_weekdaysRegex")||Ze.call(this),t?this._weekdaysShortStrictRegex:this._weekdaysShortRegex):(f(this,"_weekdaysShortRegex")||(this._weekdaysShortRegex=Qe),this._weekdaysShortStrictRegex&&t?this._weekdaysShortStrictRegex:this._weekdaysShortRegex)}var Ke=Pt;function Je(t){return this._weekdaysParseExact?(f(this,"_weekdaysRegex")||Ze.call(this),t?this._weekdaysMinStrictRegex:this._weekdaysMinRegex):(f(this,"_weekdaysMinRegex")||(this._weekdaysMinRegex=Ke),this._weekdaysMinStrictRegex&&t?this._weekdaysMinStrictRegex:this._weekdaysMinRegex)}function Ze(){function t(t,e){return e.length-t.length}var e,n,i,r,o,a=[],s=[],l=[],c=[];for(e=0;e<7;e++)n=m([2e3,1]).day(e),i=this.weekdaysMin(n,""),r=this.weekdaysShort(n,""),o=this.weekdays(n,""),a.push(i),s.push(r),l.push(o),c.push(i),c.push(r),c.push(o);for(a.sort(t),s.sort(t),l.sort(t),c.sort(t),e=0;e<7;e++)s[e]=Dt(s[e]),l[e]=Dt(l[e]),c[e]=Dt(c[e]);this._weekdaysRegex=new RegExp("^("+c.join("|")+")","i"),this._weekdaysShortRegex=this._weekdaysRegex,this._weekdaysMinRegex=this._weekdaysRegex,this._weekdaysStrictRegex=new RegExp("^("+l.join("|")+")","i"),this._weekdaysShortStrictRegex=new RegExp("^("+s.join("|")+")","i"),this._weekdaysMinStrictRegex=new RegExp("^("+a.join("|")+")","i")}function Xe(){return this.hours()%12||12}function tn(){return this.hours()||24}function en(t,e){st(t,0,0,(function(){return this.localeData().meridiem(this.hours(),this.minutes(),e)}))}function nn(t,e){return e._meridiemParse}function rn(t){return"p"===(t+"").toLowerCase().charAt(0)}st("H",["HH",2],0,"hour"),st("h",["hh",2],0,Xe),st("k",["kk",2],0,tn),st("hmm",0,0,(function(){return""+Xe.apply(this)+nt(this.minutes(),2)})),st("hmmss",0,0,(function(){return""+Xe.apply(this)+nt(this.minutes(),2)+nt(this.seconds(),2)})),st("Hmm",0,0,(function(){return""+this.hours()+nt(this.minutes(),2)})),st("Hmmss",0,0,(function(){return""+this.hours()+nt(this.minutes(),2)+nt(this.seconds(),2)})),en("a",!0),en("A",!1),K("hour","h"),tt("hour",13),Bt("a",nn),Bt("A",nn),Bt("H",gt),Bt("h",gt),Bt("k",gt),Bt("HH",gt,ft),Bt("hh",gt,ft),Bt("kk",gt,ft),Bt("hmm",yt),Bt("hmmss",_t),Bt("Hmm",yt),Bt("Hmmss",_t),qt(["H","HH"],jt),qt(["k","kk"],(function(t,e,n){var i=M(t);e[jt]=24===i?0:i})),qt(["a","A"],(function(t,e,n){n._isPm=n._locale.isPM(t),n._meridiem=t})),qt(["h","hh"],(function(t,e,n){e[jt]=M(t),g(n).bigHour=!0})),qt("hmm",(function(t,e,n){var i=t.length-2;e[jt]=M(t.substr(0,i)),e[zt]=M(t.substr(i)),g(n).bigHour=!0})),qt("hmmss",(function(t,e,n){var i=t.length-4,r=t.length-2;e[jt]=M(t.substr(0,i)),e[zt]=M(t.substr(i,2)),e[Vt]=M(t.substr(r)),g(n).bigHour=!0})),qt("Hmm",(function(t,e,n){var i=t.length-2;e[jt]=M(t.substr(0,i)),e[zt]=M(t.substr(i))})),qt("Hmmss",(function(t,e,n){var i=t.length-4,r=t.length-2;e[jt]=M(t.substr(0,i)),e[zt]=M(t.substr(i,2)),e[Vt]=M(t.substr(r))}));var on=/[ap]\.?m?\.?/i;function an(t,e,n){return t>11?n?"pm":"PM":n?"am":"AM"}var sn,ln=Zt("Hours",!0),cn={calendar:I,longDateFormat:F,invalidDate:j,ordinal:V,dayOfMonthOrdinalParse:H,relativeTime:U,months:ae,monthsShort:le,week:Te,weekdays:qe,weekdaysMin:Fe,weekdaysShort:Ie,meridiemParse:on},un={},dn={};function hn(t){return t?t.toLowerCase().replace("_","-"):t}function fn(t){for(var e,n,i,r,o=0;o<t.length;){for(e=(r=hn(t[o]).split("-")).length,n=(n=hn(t[o+1]))?n.split("-"):null;e>0;){if(i=pn(r.slice(0,e).join("-")))return i;if(n&&n.length>=e&&T(r,n,!0)>=e-1)break;e--}o++}return sn}function pn(n){var i=null;if(!un[n]&&e&&e.exports)try{i=sn._abbr,t(),mn(i)}catch(t){}return un[n]}function mn(t,e){var n;return t&&((n=c(e)?yn(t):vn(t,e))?sn=n:"undefined"!=typeof console&&console.warn&&console.warn("Locale "+t+" not found. Did you forget to load it?")),sn._abbr}function vn(t,e){if(null!==e){var n,i=cn;if(e.abbr=t,null!=un[t])A("defineLocaleOverride","use moment.updateLocale(localeName, config) to change an existing locale. moment.defineLocale(localeName, config) should only be used for creating a new locale See http://momentjs.com/guides/#/warnings/define-locale/ for more info."),i=un[t]._config;else if(null!=e.parentLocale)if(null!=un[e.parentLocale])i=un[e.parentLocale]._config;else{if(null==(n=pn(e.parentLocale)))return dn[e.parentLocale]||(dn[e.parentLocale]=[]),dn[e.parentLocale].push({name:t,config:e}),null;i=n._config}return un[t]=new R(q(i,e)),dn[t]&&dn[t].forEach((function(t){vn(t.name,t.config)})),mn(t),un[t]}return delete un[t],null}function gn(t,e){if(null!=e){var n,i,r=cn;null!=(i=pn(t))&&(r=i._config),(n=new R(e=q(r,e))).parentLocale=un[t],un[t]=n,mn(t)}else null!=un[t]&&(null!=un[t].parentLocale?un[t]=un[t].parentLocale:null!=un[t]&&delete un[t]);return un[t]}function yn(t){var e;if(t&&t._locale&&t._locale._abbr&&(t=t._locale._abbr),!t)return sn;if(!a(t)){if(e=pn(t))return e;t=[t]}return fn(t)}function _n(){return B(un)}function bn(t){var e,n=t._a;return n&&-2===g(t).overflow&&(e=n[Ft]<0||n[Ft]>11?Ft:n[$t]<1||n[$t]>re(n[Nt],n[Ft])?$t:n[jt]<0||n[jt]>24||24===n[jt]&&(0!==n[zt]||0!==n[Vt]||0!==n[Ht])?jt:n[zt]<0||n[zt]>59?zt:n[Vt]<0||n[Vt]>59?Vt:n[Ht]<0||n[Ht]>999?Ht:-1,g(t)._overflowDayOfYear&&(e<Nt||e>$t)&&(e=$t),g(t)._overflowWeeks&&-1===e&&(e=Wt),g(t)._overflowWeekday&&-1===e&&(e=Ut),g(t).overflow=e),t}function wn(t,e,n){return null!=t?t:null!=e?e:n}function kn(t){var e=new Date(r.now());return t._useUTC?[e.getUTCFullYear(),e.getUTCMonth(),e.getUTCDate()]:[e.getFullYear(),e.getMonth(),e.getDate()]}function xn(t){var e,n,i,r,o,a=[];if(!t._d){for(i=kn(t),t._w&&null==t._a[$t]&&null==t._a[Ft]&&Cn(t),null!=t._dayOfYear&&(o=wn(t._a[Nt],i[Nt]),(t._dayOfYear>Yt(o)||0===t._dayOfYear)&&(g(t)._overflowDayOfYear=!0),n=we(o,0,t._dayOfYear),t._a[Ft]=n.getUTCMonth(),t._a[$t]=n.getUTCDate()),e=0;e<3&&null==t._a[e];++e)t._a[e]=a[e]=i[e];for(;e<7;e++)t._a[e]=a[e]=null==t._a[e]?2===e?1:0:t._a[e];24===t._a[jt]&&0===t._a[zt]&&0===t._a[Vt]&&0===t._a[Ht]&&(t._nextDay=!0,t._a[jt]=0),t._d=(t._useUTC?we:be).apply(null,a),r=t._useUTC?t._d.getUTCDay():t._d.getDay(),null!=t._tzm&&t._d.setUTCMinutes(t._d.getUTCMinutes()-t._tzm),t._nextDay&&(t._a[jt]=24),t._w&&void 0!==t._w.d&&t._w.d!==r&&(g(t).weekdayMismatch=!0)}}function Cn(t){var e,n,i,r,o,a,s,l;if(null!=(e=t._w).GG||null!=e.W||null!=e.E)o=1,a=4,n=wn(e.GG,t._a[Nt],Ce(Gn(),1,4).year),i=wn(e.W,1),((r=wn(e.E,1))<1||r>7)&&(l=!0);else{o=t._locale._week.dow,a=t._locale._week.doy;var c=Ce(Gn(),o,a);n=wn(e.gg,t._a[Nt],c.year),i=wn(e.w,c.week),null!=e.d?((r=e.d)<0||r>6)&&(l=!0):null!=e.e?(r=e.e+o,(e.e<0||e.e>6)&&(l=!0)):r=o}i<1||i>Se(n,o,a)?g(t)._overflowWeeks=!0:null!=l?g(t)._overflowWeekday=!0:(s=xe(n,i,r,o,a),t._a[Nt]=s.year,t._dayOfYear=s.dayOfYear)}var Sn=/^\s*((?:[+-]\d{6}|\d{4})-(?:\d\d-\d\d|W\d\d-\d|W\d\d|\d\d\d|\d\d))(?:(T| )(\d\d(?::\d\d(?::\d\d(?:[.,]\d+)?)?)?)([\+\-]\d\d(?::?\d\d)?|\s*Z)?)?$/,Mn=/^\s*((?:[+-]\d{6}|\d{4})(?:\d\d\d\d|W\d\d\d|W\d\d|\d\d\d|\d\d))(?:(T| )(\d\d(?:\d\d(?:\d\d(?:[.,]\d+)?)?)?)([\+\-]\d\d(?::?\d\d)?|\s*Z)?)?$/,Tn=/Z|[+-]\d\d(?::?\d\d)?/,Pn=[["YYYYYY-MM-DD",/[+-]\d{6}-\d\d-\d\d/],["YYYY-MM-DD",/\d{4}-\d\d-\d\d/],["GGGG-[W]WW-E",/\d{4}-W\d\d-\d/],["GGGG-[W]WW",/\d{4}-W\d\d/,!1],["YYYY-DDD",/\d{4}-\d{3}/],["YYYY-MM",/\d{4}-\d\d/,!1],["YYYYYYMMDD",/[+-]\d{10}/],["YYYYMMDD",/\d{8}/],["GGGG[W]WWE",/\d{4}W\d{3}/],["GGGG[W]WW",/\d{4}W\d{2}/,!1],["YYYYDDD",/\d{7}/]],On=[["HH:mm:ss.SSSS",/\d\d:\d\d:\d\d\.\d+/],["HH:mm:ss,SSSS",/\d\d:\d\d:\d\d,\d+/],["HH:mm:ss",/\d\d:\d\d:\d\d/],["HH:mm",/\d\d:\d\d/],["HHmmss.SSSS",/\d\d\d\d\d\d\.\d+/],["HHmmss,SSSS",/\d\d\d\d\d\d,\d+/],["HHmmss",/\d\d\d\d\d\d/],["HHmm",/\d\d\d\d/],["HH",/\d\d/]],Bn=/^\/?Date\((\-?\d+)/i;function En(t){var e,n,i,r,o,a,s=t._i,l=Sn.exec(s)||Mn.exec(s);if(l){for(g(t).iso=!0,e=0,n=Pn.length;e<n;e++)if(Pn[e][1].exec(l[1])){r=Pn[e][0],i=!1!==Pn[e][2];break}if(null==r)return void(t._isValid=!1);if(l[3]){for(e=0,n=On.length;e<n;e++)if(On[e][1].exec(l[3])){o=(l[2]||" ")+On[e][0];break}if(null==o)return void(t._isValid=!1)}if(!i&&null!=o)return void(t._isValid=!1);if(l[4]){if(!Tn.exec(l[4]))return void(t._isValid=!1);a="Z"}t._f=r+(o||"")+(a||""),jn(t)}else t._isValid=!1}var An=/^(?:(Mon|Tue|Wed|Thu|Fri|Sat|Sun),?\s)?(\d{1,2})\s(Jan|Feb|Mar|Apr|May|Jun|Jul|Aug|Sep|Oct|Nov|Dec)\s(\d{2,4})\s(\d\d):(\d\d)(?::(\d\d))?\s(?:(UT|GMT|[ECMP][SD]T)|([Zz])|([+-]\d{4}))$/;function Dn(t,e,n,i,r,o){var a=[Ln(t),le.indexOf(e),parseInt(n,10),parseInt(i,10),parseInt(r,10)];return o&&a.push(parseInt(o,10)),a}function Ln(t){var e=parseInt(t,10);return e<=49?2e3+e:e<=999?1900+e:e}function qn(t){return t.replace(/\([^)]*\)|[\n\t]/g," ").replace(/(\s\s+)/g," ").replace(/^\s\s*/,"").replace(/\s\s*$/,"")}function Rn(t,e,n){return!t||Ie.indexOf(t)===new Date(e[0],e[1],e[2]).getDay()||(g(n).weekdayMismatch=!0,n._isValid=!1,!1)}var In={UT:0,GMT:0,EDT:-240,EST:-300,CDT:-300,CST:-360,MDT:-360,MST:-420,PDT:-420,PST:-480};function Nn(t,e,n){if(t)return In[t];if(e)return 0;var i=parseInt(n,10),r=i%100;return(i-r)/100*60+r}function Fn(t){var e=An.exec(qn(t._i));if(e){var n=Dn(e[4],e[3],e[2],e[5],e[6],e[7]);if(!Rn(e[1],n,t))return;t._a=n,t._tzm=Nn(e[8],e[9],e[10]),t._d=we.apply(null,t._a),t._d.setUTCMinutes(t._d.getUTCMinutes()-t._tzm),g(t).rfc2822=!0}else t._isValid=!1}function $n(t){var e=Bn.exec(t._i);null===e?(En(t),!1===t._isValid&&(delete t._isValid,Fn(t),!1===t._isValid&&(delete t._isValid,r.createFromInputFallback(t)))):t._d=new Date(+e[1])}function jn(t){if(t._f!==r.ISO_8601)if(t._f!==r.RFC_2822){t._a=[],g(t).empty=!0;var e,n,i,o,a,s=""+t._i,l=s.length,c=0;for(i=dt(t._f,t._locale).match(it)||[],e=0;e<i.length;e++)o=i[e],(n=(s.match(Et(o,t))||[])[0])&&((a=s.substr(0,s.indexOf(n))).length>0&&g(t).unusedInput.push(a),s=s.slice(s.indexOf(n)+n.length),c+=n.length),at[o]?(n?g(t).empty=!1:g(t).unusedTokens.push(o),It(o,n,t)):t._strict&&!n&&g(t).unusedTokens.push(o);g(t).charsLeftOver=l-c,s.length>0&&g(t).unusedInput.push(s),t._a[jt]<=12&&!0===g(t).bigHour&&t._a[jt]>0&&(g(t).bigHour=void 0),g(t).parsedDateParts=t._a.slice(0),g(t).meridiem=t._meridiem,t._a[jt]=zn(t._locale,t._a[jt],t._meridiem),xn(t),bn(t)}else Fn(t);else En(t)}function zn(t,e,n){var i;return null==n?e:null!=t.meridiemHour?t.meridiemHour(e,n):null!=t.isPM?((i=t.isPM(n))&&e<12&&(e+=12),i||12!==e||(e=0),e):e}function Vn(t){var e,n,i,r,o;if(0===t._f.length)return g(t).invalidFormat=!0,void(t._d=new Date(NaN));for(r=0;r<t._f.length;r++)o=0,e=w({},t),null!=t._useUTC&&(e._useUTC=t._useUTC),e._f=t._f[r],jn(e),y(e)&&(o+=g(e).charsLeftOver,o+=10*g(e).unusedTokens.length,g(e).score=o,(null==i||o<i)&&(i=o,n=e));p(t,n||e)}function Hn(t){if(!t._d){var e=Z(t._i);t._a=h([e.year,e.month,e.day||e.date,e.hour,e.minute,e.second,e.millisecond],(function(t){return t&&parseInt(t,10)})),xn(t)}}function Wn(t){var e=new x(bn(Un(t)));return e._nextDay&&(e.add(1,"d"),e._nextDay=void 0),e}function Un(t){var e=t._i,n=t._f;return t._locale=t._locale||yn(t._l),null===e||void 0===n&&""===e?_({nullInput:!0}):("string"==typeof e&&(t._i=e=t._locale.preparse(e)),C(e)?new x(bn(e)):(d(e)?t._d=e:a(n)?Vn(t):n?jn(t):Yn(t),y(t)||(t._d=null),t))}function Yn(t){var e=t._i;c(e)?t._d=new Date(r.now()):d(e)?t._d=new Date(e.valueOf()):"string"==typeof e?$n(t):a(e)?(t._a=h(e.slice(0),(function(t){return parseInt(t,10)})),xn(t)):s(e)?Hn(t):u(e)?t._d=new Date(e):r.createFromInputFallback(t)}function Qn(t,e,n,i,r){var o={};return!0!==n&&!1!==n||(i=n,n=void 0),(s(t)&&l(t)||a(t)&&0===t.length)&&(t=void 0),o._isAMomentObject=!0,o._useUTC=o._isUTC=r,o._l=n,o._i=t,o._f=e,o._strict=i,Wn(o)}function Gn(t,e,n,i){return Qn(t,e,n,i,!1)}r.createFromInputFallback=O("value provided is not in a recognized RFC2822 or ISO format. moment construction falls back to js Date(), which is not reliable across all browsers and versions. Non RFC2822/ISO date formats are discouraged and will be removed in an upcoming major release. Please refer to http://momentjs.com/guides/#/warnings/js-date/ for more info.",(function(t){t._d=new Date(t._i+(t._useUTC?" UTC":""))})),r.ISO_8601=function(){},r.RFC_2822=function(){};var Kn=O("moment().min is deprecated, use moment.max instead. http://momentjs.com/guides/#/warnings/min-max/",(function(){var t=Gn.apply(null,arguments);return this.isValid()&&t.isValid()?t<this?this:t:_()})),Jn=O("moment().max is deprecated, use moment.min instead. http://momentjs.com/guides/#/warnings/min-max/",(function(){var t=Gn.apply(null,arguments);return this.isValid()&&t.isValid()?t>this?this:t:_()}));function Zn(t,e){var n,i;if(1===e.length&&a(e[0])&&(e=e[0]),!e.length)return Gn();for(n=e[0],i=1;i<e.length;++i)e[i].isValid()&&!e[i][t](n)||(n=e[i]);return n}function Xn(){return Zn("isBefore",[].slice.call(arguments,0))}function ti(){return Zn("isAfter",[].slice.call(arguments,0))}var ei=function(){return Date.now?Date.now():+new Date},ni=["year","quarter","month","week","day","hour","minute","second","millisecond"];function ii(t){for(var e in t)if(-1===Gt.call(ni,e)||null!=t[e]&&isNaN(t[e]))return!1;for(var n=!1,i=0;i<ni.length;++i)if(t[ni[i]]){if(n)return!1;parseFloat(t[ni[i]])!==M(t[ni[i]])&&(n=!0)}return!0}function ri(){return this._isValid}function oi(){return Ti(NaN)}function ai(t){var e=Z(t),n=e.year||0,i=e.quarter||0,r=e.month||0,o=e.week||e.isoWeek||0,a=e.day||0,s=e.hour||0,l=e.minute||0,c=e.second||0,u=e.millisecond||0;this._isValid=ii(e),this._milliseconds=+u+1e3*c+6e4*l+1e3*s*60*60,this._days=+a+7*o,this._months=+r+3*i+12*n,this._data={},this._locale=yn(),this._bubble()}function si(t){return t instanceof ai}function li(t){return t<0?-1*Math.round(-1*t):Math.round(t)}function ci(t,e){st(t,0,0,(function(){var t=this.utcOffset(),n="+";return t<0&&(t=-t,n="-"),n+nt(~~(t/60),2)+e+nt(~~t%60,2)}))}ci("Z",":"),ci("ZZ",""),Bt("Z",Mt),Bt("ZZ",Mt),qt(["Z","ZZ"],(function(t,e,n){n._useUTC=!0,n._tzm=di(Mt,t)}));var ui=/([\+\-]|\d\d)/gi;function di(t,e){var n=(e||"").match(t);if(null===n)return null;var i=((n[n.length-1]||[])+"").match(ui)||["-",0,0],r=60*i[1]+M(i[2]);return 0===r?0:"+"===i[0]?r:-r}function hi(t,e){var n,i;return e._isUTC?(n=e.clone(),i=(C(t)||d(t)?t.valueOf():Gn(t).valueOf())-n.valueOf(),n._d.setTime(n._d.valueOf()+i),r.updateOffset(n,!1),n):Gn(t).local()}function fi(t){return 15*-Math.round(t._d.getTimezoneOffset()/15)}function pi(t,e,n){var i,o=this._offset||0;if(!this.isValid())return null!=t?this:NaN;if(null!=t){if("string"==typeof t){if(null===(t=di(Mt,t)))return this}else Math.abs(t)<16&&!n&&(t*=60);return!this._isUTC&&e&&(i=fi(this)),this._offset=t,this._isUTC=!0,null!=i&&this.add(i,"m"),o!==t&&(!e||this._changeInProgress?Ai(this,Ti(t-o,"m"),1,!1):this._changeInProgress||(this._changeInProgress=!0,r.updateOffset(this,!0),this._changeInProgress=null)),this}return this._isUTC?o:fi(this)}function mi(t,e){return null!=t?("string"!=typeof t&&(t=-t),this.utcOffset(t,e),this):-this.utcOffset()}function vi(t){return this.utcOffset(0,t)}function gi(t){return this._isUTC&&(this.utcOffset(0,t),this._isUTC=!1,t&&this.subtract(fi(this),"m")),this}function yi(){if(null!=this._tzm)this.utcOffset(this._tzm,!1,!0);else if("string"==typeof this._i){var t=di(St,this._i);null!=t?this.utcOffset(t):this.utcOffset(0,!0)}return this}function _i(t){return!!this.isValid()&&(t=t?Gn(t).utcOffset():0,(this.utcOffset()-t)%60==0)}function bi(){return this.utcOffset()>this.clone().month(0).utcOffset()||this.utcOffset()>this.clone().month(5).utcOffset()}function wi(){if(!c(this._isDSTShifted))return this._isDSTShifted;var t={};if(w(t,this),(t=Un(t))._a){var e=t._isUTC?m(t._a):Gn(t._a);this._isDSTShifted=this.isValid()&&T(t._a,e.toArray())>0}else this._isDSTShifted=!1;return this._isDSTShifted}function ki(){return!!this.isValid()&&!this._isUTC}function xi(){return!!this.isValid()&&this._isUTC}function Ci(){return!!this.isValid()&&this._isUTC&&0===this._offset}r.updateOffset=function(){};var Si=/^(\-|\+)?(?:(\d*)[. ])?(\d+)\:(\d+)(?:\:(\d+)(\.\d*)?)?$/,Mi=/^(-|\+)?P(?:([-+]?[0-9,.]*)Y)?(?:([-+]?[0-9,.]*)M)?(?:([-+]?[0-9,.]*)W)?(?:([-+]?[0-9,.]*)D)?(?:T(?:([-+]?[0-9,.]*)H)?(?:([-+]?[0-9,.]*)M)?(?:([-+]?[0-9,.]*)S)?)?$/;function Ti(t,e){var n,i,r,o=t,a=null;return si(t)?o={ms:t._milliseconds,d:t._days,M:t._months}:u(t)?(o={},e?o[e]=t:o.milliseconds=t):(a=Si.exec(t))?(n="-"===a[1]?-1:1,o={y:0,d:M(a[$t])*n,h:M(a[jt])*n,m:M(a[zt])*n,s:M(a[Vt])*n,ms:M(li(1e3*a[Ht]))*n}):(a=Mi.exec(t))?(n="-"===a[1]?-1:1,o={y:Pi(a[2],n),M:Pi(a[3],n),w:Pi(a[4],n),d:Pi(a[5],n),h:Pi(a[6],n),m:Pi(a[7],n),s:Pi(a[8],n)}):null==o?o={}:"object"==typeof o&&("from"in o||"to"in o)&&(r=Bi(Gn(o.from),Gn(o.to)),(o={}).ms=r.milliseconds,o.M=r.months),i=new ai(o),si(t)&&f(t,"_locale")&&(i._locale=t._locale),i}function Pi(t,e){var n=t&&parseFloat(t.replace(",","."));return(isNaN(n)?0:n)*e}function Oi(t,e){var n={};return n.months=e.month()-t.month()+12*(e.year()-t.year()),t.clone().add(n.months,"M").isAfter(e)&&--n.months,n.milliseconds=+e-+t.clone().add(n.months,"M"),n}function Bi(t,e){var n;return t.isValid()&&e.isValid()?(e=hi(e,t),t.isBefore(e)?n=Oi(t,e):((n=Oi(e,t)).milliseconds=-n.milliseconds,n.months=-n.months),n):{milliseconds:0,months:0}}function Ei(t,e){return function(n,i){var r;return null===i||isNaN(+i)||(A(e,"moment()."+e+"(period, number) is deprecated. Please use moment()."+e+"(number, period). See http://momentjs.com/guides/#/warnings/add-inverted-param/ for more info."),r=n,n=i,i=r),Ai(this,Ti(n="string"==typeof n?+n:n,i),t),this}}function Ai(t,e,n,i){var o=e._milliseconds,a=li(e._days),s=li(e._months);t.isValid()&&(i=null==i||i,s&&he(t,Xt(t,"Month")+s*n),a&&te(t,"Date",Xt(t,"Date")+a*n),o&&t._d.setTime(t._d.valueOf()+o*n),i&&r.updateOffset(t,a||s))}Ti.fn=ai.prototype,Ti.invalid=oi;var Di=Ei(1,"add"),Li=Ei(-1,"subtract");function qi(t,e){var n=t.diff(e,"days",!0);return n<-6?"sameElse":n<-1?"lastWeek":n<0?"lastDay":n<1?"sameDay":n<2?"nextDay":n<7?"nextWeek":"sameElse"}function Ri(t,e){var n=t||Gn(),i=hi(n,this).startOf("day"),o=r.calendarFormat(this,i)||"sameElse",a=e&&(D(e[o])?e[o].call(this,n):e[o]);return this.format(a||this.localeData().calendar(o,this,Gn(n)))}function Ii(){return new x(this)}function Ni(t,e){var n=C(t)?t:Gn(t);return!(!this.isValid()||!n.isValid())&&("millisecond"===(e=J(e)||"millisecond")?this.valueOf()>n.valueOf():n.valueOf()<this.clone().startOf(e).valueOf())}function Fi(t,e){var n=C(t)?t:Gn(t);return!(!this.isValid()||!n.isValid())&&("millisecond"===(e=J(e)||"millisecond")?this.valueOf()<n.valueOf():this.clone().endOf(e).valueOf()<n.valueOf())}function $i(t,e,n,i){var r=C(t)?t:Gn(t),o=C(e)?e:Gn(e);return!!(this.isValid()&&r.isValid()&&o.isValid())&&("("===(i=i||"()")[0]?this.isAfter(r,n):!this.isBefore(r,n))&&(")"===i[1]?this.isBefore(o,n):!this.isAfter(o,n))}function ji(t,e){var n,i=C(t)?t:Gn(t);return!(!this.isValid()||!i.isValid())&&("millisecond"===(e=J(e)||"millisecond")?this.valueOf()===i.valueOf():(n=i.valueOf(),this.clone().startOf(e).valueOf()<=n&&n<=this.clone().endOf(e).valueOf()))}function zi(t,e){return this.isSame(t,e)||this.isAfter(t,e)}function Vi(t,e){return this.isSame(t,e)||this.isBefore(t,e)}function Hi(t,e,n){var i,r,o;if(!this.isValid())return NaN;if(!(i=hi(t,this)).isValid())return NaN;switch(r=6e4*(i.utcOffset()-this.utcOffset()),e=J(e)){case"year":o=Wi(this,i)/12;break;case"month":o=Wi(this,i);break;case"quarter":o=Wi(this,i)/3;break;case"second":o=(this-i)/1e3;break;case"minute":o=(this-i)/6e4;break;case"hour":o=(this-i)/36e5;break;case"day":o=(this-i-r)/864e5;break;case"week":o=(this-i-r)/6048e5;break;default:o=this-i}return n?o:S(o)}function Wi(t,e){var n=12*(e.year()-t.year())+(e.month()-t.month()),i=t.clone().add(n,"months");return-(n+(e-i<0?(e-i)/(i-t.clone().add(n-1,"months")):(e-i)/(t.clone().add(n+1,"months")-i)))||0}function Ui(){return this.clone().locale("en").format("ddd MMM DD YYYY HH:mm:ss [GMT]ZZ")}function Yi(t){if(!this.isValid())return null;var e=!0!==t,n=e?this.clone().utc():this;return n.year()<0||n.year()>9999?ut(n,e?"YYYYYY-MM-DD[T]HH:mm:ss.SSS[Z]":"YYYYYY-MM-DD[T]HH:mm:ss.SSSZ"):D(Date.prototype.toISOString)?e?this.toDate().toISOString():new Date(this.valueOf()+60*this.utcOffset()*1e3).toISOString().replace("Z",ut(n,"Z")):ut(n,e?"YYYY-MM-DD[T]HH:mm:ss.SSS[Z]":"YYYY-MM-DD[T]HH:mm:ss.SSSZ")}function Qi(){if(!this.isValid())return"moment.invalid(/* "+this._i+" */)";var t="moment",e="";this.isLocal()||(t=0===this.utcOffset()?"moment.utc":"moment.parseZone",e="Z");var n="["+t+'("]',i=0<=this.year()&&this.year()<=9999?"YYYY":"YYYYYY",r="-MM-DD[T]HH:mm:ss.SSS",o=e+'[")]';return this.format(n+i+r+o)}function Gi(t){t||(t=this.isUtc()?r.defaultFormatUtc:r.defaultFormat);var e=ut(this,t);return this.localeData().postformat(e)}function Ki(t,e){return this.isValid()&&(C(t)&&t.isValid()||Gn(t).isValid())?Ti({to:this,from:t}).locale(this.locale()).humanize(!e):this.localeData().invalidDate()}function Ji(t){return this.from(Gn(),t)}function Zi(t,e){return this.isValid()&&(C(t)&&t.isValid()||Gn(t).isValid())?Ti({from:this,to:t}).locale(this.locale()).humanize(!e):this.localeData().invalidDate()}function Xi(t){return this.to(Gn(),t)}function tr(t){var e;return void 0===t?this._locale._abbr:(null!=(e=yn(t))&&(this._locale=e),this)}r.defaultFormat="YYYY-MM-DDTHH:mm:ssZ",r.defaultFormatUtc="YYYY-MM-DDTHH:mm:ss[Z]";var er=O("moment().lang() is deprecated. Instead, use moment().localeData() to get the language configuration. Use moment().locale() to change languages.",(function(t){return void 0===t?this.localeData():this.locale(t)}));function nr(){return this._locale}var ir=1e3,rr=60*ir,or=60*rr,ar=3506328*or;function sr(t,e){return(t%e+e)%e}function lr(t,e,n){return t<100&&t>=0?new Date(t+400,e,n)-ar:new Date(t,e,n).valueOf()}function cr(t,e,n){return t<100&&t>=0?Date.UTC(t+400,e,n)-ar:Date.UTC(t,e,n)}function ur(t){var e;if(void 0===(t=J(t))||"millisecond"===t||!this.isValid())return this;var n=this._isUTC?cr:lr;switch(t){case"year":e=n(this.year(),0,1);break;case"quarter":e=n(this.year(),this.month()-this.month()%3,1);break;case"month":e=n(this.year(),this.month(),1);break;case"week":e=n(this.year(),this.month(),this.date()-this.weekday());break;case"isoWeek":e=n(this.year(),this.month(),this.date()-(this.isoWeekday()-1));break;case"day":case"date":e=n(this.year(),this.month(),this.date());break;case"hour":e=this._d.valueOf(),e-=sr(e+(this._isUTC?0:this.utcOffset()*rr),or);break;case"minute":e=this._d.valueOf(),e-=sr(e,rr);break;case"second":e=this._d.valueOf(),e-=sr(e,ir)}return this._d.setTime(e),r.updateOffset(this,!0),this}function dr(t){var e;if(void 0===(t=J(t))||"millisecond"===t||!this.isValid())return this;var n=this._isUTC?cr:lr;switch(t){case"year":e=n(this.year()+1,0,1)-1;break;case"quarter":e=n(this.year(),this.month()-this.month()%3+3,1)-1;break;case"month":e=n(this.year(),this.month()+1,1)-1;break;case"week":e=n(this.year(),this.month(),this.date()-this.weekday()+7)-1;break;case"isoWeek":e=n(this.year(),this.month(),this.date()-(this.isoWeekday()-1)+7)-1;break;case"day":case"date":e=n(this.year(),this.month(),this.date()+1)-1;break;case"hour":e=this._d.valueOf(),e+=or-sr(e+(this._isUTC?0:this.utcOffset()*rr),or)-1;break;case"minute":e=this._d.valueOf(),e+=rr-sr(e,rr)-1;break;case"second":e=this._d.valueOf(),e+=ir-sr(e,ir)-1}return this._d.setTime(e),r.updateOffset(this,!0),this}function hr(){return this._d.valueOf()-6e4*(this._offset||0)}function fr(){return Math.floor(this.valueOf()/1e3)}function pr(){return new Date(this.valueOf())}function mr(){var t=this;return[t.year(),t.month(),t.date(),t.hour(),t.minute(),t.second(),t.millisecond()]}function vr(){var t=this;return{years:t.year(),months:t.month(),date:t.date(),hours:t.hours(),minutes:t.minutes(),seconds:t.seconds(),milliseconds:t.milliseconds()}}function gr(){return this.isValid()?this.toISOString():null}function yr(){return y(this)}function _r(){return p({},g(this))}function br(){return g(this).overflow}function wr(){return{input:this._i,format:this._f,locale:this._locale,isUTC:this._isUTC,strict:this._strict}}function kr(t,e){st(0,[t,t.length],0,e)}function xr(t){return Tr.call(this,t,this.week(),this.weekday(),this.localeData()._week.dow,this.localeData()._week.doy)}function Cr(t){return Tr.call(this,t,this.isoWeek(),this.isoWeekday(),1,4)}function Sr(){return Se(this.year(),1,4)}function Mr(){var t=this.localeData()._week;return Se(this.year(),t.dow,t.doy)}function Tr(t,e,n,i,r){var o;return null==t?Ce(this,i,r).year:(e>(o=Se(t,i,r))&&(e=o),Pr.call(this,t,e,n,i,r))}function Pr(t,e,n,i,r){var o=xe(t,e,n,i,r),a=we(o.year,0,o.dayOfYear);return this.year(a.getUTCFullYear()),this.month(a.getUTCMonth()),this.date(a.getUTCDate()),this}function Or(t){return null==t?Math.ceil((this.month()+1)/3):this.month(3*(t-1)+this.month()%3)}st(0,["gg",2],0,(function(){return this.weekYear()%100})),st(0,["GG",2],0,(function(){return this.isoWeekYear()%100})),kr("gggg","weekYear"),kr("ggggg","weekYear"),kr("GGGG","isoWeekYear"),kr("GGGGG","isoWeekYear"),K("weekYear","gg"),K("isoWeekYear","GG"),tt("weekYear",1),tt("isoWeekYear",1),Bt("G",Ct),Bt("g",Ct),Bt("GG",gt,ft),Bt("gg",gt,ft),Bt("GGGG",wt,mt),Bt("gggg",wt,mt),Bt("GGGGG",kt,vt),Bt("ggggg",kt,vt),Rt(["gggg","ggggg","GGGG","GGGGG"],(function(t,e,n,i){e[i.substr(0,2)]=M(t)})),Rt(["gg","GG"],(function(t,e,n,i){e[i]=r.parseTwoDigitYear(t)})),st("Q",0,"Qo","quarter"),K("quarter","Q"),tt("quarter",7),Bt("Q",ht),qt("Q",(function(t,e){e[Ft]=3*(M(t)-1)})),st("D",["DD",2],"Do","date"),K("date","D"),tt("date",9),Bt("D",gt),Bt("DD",gt,ft),Bt("Do",(function(t,e){return t?e._dayOfMonthOrdinalParse||e._ordinalParse:e._dayOfMonthOrdinalParseLenient})),qt(["D","DD"],$t),qt("Do",(function(t,e){e[$t]=M(t.match(gt)[0])}));var Br=Zt("Date",!0);function Er(t){var e=Math.round((this.clone().startOf("day")-this.clone().startOf("year"))/864e5)+1;return null==t?e:this.add(t-e,"d")}st("DDD",["DDDD",3],"DDDo","dayOfYear"),K("dayOfYear","DDD"),tt("dayOfYear",4),Bt("DDD",bt),Bt("DDDD",pt),qt(["DDD","DDDD"],(function(t,e,n){n._dayOfYear=M(t)})),st("m",["mm",2],0,"minute"),K("minute","m"),tt("minute",14),Bt("m",gt),Bt("mm",gt,ft),qt(["m","mm"],zt);var Ar=Zt("Minutes",!1);st("s",["ss",2],0,"second"),K("second","s"),tt("second",15),Bt("s",gt),Bt("ss",gt,ft),qt(["s","ss"],Vt);var Dr,Lr=Zt("Seconds",!1);for(st("S",0,0,(function(){return~~(this.millisecond()/100)})),st(0,["SS",2],0,(function(){return~~(this.millisecond()/10)})),st(0,["SSS",3],0,"millisecond"),st(0,["SSSS",4],0,(function(){return 10*this.millisecond()})),st(0,["SSSSS",5],0,(function(){return 100*this.millisecond()})),st(0,["SSSSSS",6],0,(function(){return 1e3*this.millisecond()})),st(0,["SSSSSSS",7],0,(function(){return 1e4*this.millisecond()})),st(0,["SSSSSSSS",8],0,(function(){return 1e5*this.millisecond()})),st(0,["SSSSSSSSS",9],0,(function(){return 1e6*this.millisecond()})),K("millisecond","ms"),tt("millisecond",16),Bt("S",bt,ht),Bt("SS",bt,ft),Bt("SSS",bt,pt),Dr="SSSS";Dr.length<=9;Dr+="S")Bt(Dr,xt);function qr(t,e){e[Ht]=M(1e3*("0."+t))}for(Dr="S";Dr.length<=9;Dr+="S")qt(Dr,qr);var Rr=Zt("Milliseconds",!1);function Ir(){return this._isUTC?"UTC":""}function Nr(){return this._isUTC?"Coordinated Universal Time":""}st("z",0,0,"zoneAbbr"),st("zz",0,0,"zoneName");var Fr=x.prototype;function $r(t){return Gn(1e3*t)}function jr(){return Gn.apply(null,arguments).parseZone()}function zr(t){return t}Fr.add=Di,Fr.calendar=Ri,Fr.clone=Ii,Fr.diff=Hi,Fr.endOf=dr,Fr.format=Gi,Fr.from=Ki,Fr.fromNow=Ji,Fr.to=Zi,Fr.toNow=Xi,Fr.get=ee,Fr.invalidAt=br,Fr.isAfter=Ni,Fr.isBefore=Fi,Fr.isBetween=$i,Fr.isSame=ji,Fr.isSameOrAfter=zi,Fr.isSameOrBefore=Vi,Fr.isValid=yr,Fr.lang=er,Fr.locale=tr,Fr.localeData=nr,Fr.max=Jn,Fr.min=Kn,Fr.parsingFlags=_r,Fr.set=ne,Fr.startOf=ur,Fr.subtract=Li,Fr.toArray=mr,Fr.toObject=vr,Fr.toDate=pr,Fr.toISOString=Yi,Fr.inspect=Qi,Fr.toJSON=gr,Fr.toString=Ui,Fr.unix=fr,Fr.valueOf=hr,Fr.creationData=wr,Fr.year=Kt,Fr.isLeapYear=Jt,Fr.weekYear=xr,Fr.isoWeekYear=Cr,Fr.quarter=Fr.quarters=Or,Fr.month=fe,Fr.daysInMonth=pe,Fr.week=Fr.weeks=Be,Fr.isoWeek=Fr.isoWeeks=Ee,Fr.weeksInYear=Mr,Fr.isoWeeksInYear=Sr,Fr.date=Br,Fr.day=Fr.days=Ve,Fr.weekday=He,Fr.isoWeekday=We,Fr.dayOfYear=Er,Fr.hour=Fr.hours=ln,Fr.minute=Fr.minutes=Ar,Fr.second=Fr.seconds=Lr,Fr.millisecond=Fr.milliseconds=Rr,Fr.utcOffset=pi,Fr.utc=vi,Fr.local=gi,Fr.parseZone=yi,Fr.hasAlignedHourOffset=_i,Fr.isDST=bi,Fr.isLocal=ki,Fr.isUtcOffset=xi,Fr.isUtc=Ci,Fr.isUTC=Ci,Fr.zoneAbbr=Ir,Fr.zoneName=Nr,Fr.dates=O("dates accessor is deprecated. Use date instead.",Br),Fr.months=O("months accessor is deprecated. Use month instead",fe),Fr.years=O("years accessor is deprecated. Use year instead",Kt),Fr.zone=O("moment().zone is deprecated, use moment().utcOffset instead. http://momentjs.com/guides/#/warnings/zone/",mi),Fr.isDSTShifted=O("isDSTShifted is deprecated. See http://momentjs.com/guides/#/warnings/dst-shifted/ for more information",wi);var Vr=R.prototype;function Hr(t,e,n,i){var r=yn(),o=m().set(i,e);return r[n](o,t)}function Wr(t,e,n){if(u(t)&&(e=t,t=void 0),t=t||"",null!=e)return Hr(t,e,n,"month");var i,r=[];for(i=0;i<12;i++)r[i]=Hr(t,i,n,"month");return r}function Ur(t,e,n,i){"boolean"==typeof t?(u(e)&&(n=e,e=void 0),e=e||""):(n=e=t,t=!1,u(e)&&(n=e,e=void 0),e=e||"");var r,o=yn(),a=t?o._week.dow:0;if(null!=n)return Hr(e,(n+a)%7,i,"day");var s=[];for(r=0;r<7;r++)s[r]=Hr(e,(r+a)%7,i,"day");return s}function Yr(t,e){return Wr(t,e,"months")}function Qr(t,e){return Wr(t,e,"monthsShort")}function Gr(t,e,n){return Ur(t,e,n,"weekdays")}function Kr(t,e,n){return Ur(t,e,n,"weekdaysShort")}function Jr(t,e,n){return Ur(t,e,n,"weekdaysMin")}Vr.calendar=N,Vr.longDateFormat=$,Vr.invalidDate=z,Vr.ordinal=W,Vr.preparse=zr,Vr.postformat=zr,Vr.relativeTime=Y,Vr.pastFuture=Q,Vr.set=L,Vr.months=se,Vr.monthsShort=ce,Vr.monthsParse=de,Vr.monthsRegex=ye,Vr.monthsShortRegex=ve,Vr.week=Me,Vr.firstDayOfYear=Oe,Vr.firstDayOfWeek=Pe,Vr.weekdays=Re,Vr.weekdaysMin=$e,Vr.weekdaysShort=Ne,Vr.weekdaysParse=ze,Vr.weekdaysRegex=Ye,Vr.weekdaysShortRegex=Ge,Vr.weekdaysMinRegex=Je,Vr.isPM=rn,Vr.meridiem=an,mn("en",{dayOfMonthOrdinalParse:/\d{1,2}(th|st|nd|rd)/,ordinal:function(t){var e=t%10;return t+(1===M(t%100/10)?"th":1===e?"st":2===e?"nd":3===e?"rd":"th")}}),r.lang=O("moment.lang is deprecated. Use moment.locale instead.",mn),r.langData=O("moment.langData is deprecated. Use moment.localeData instead.",yn);var Zr=Math.abs;function Xr(){var t=this._data;return this._milliseconds=Zr(this._milliseconds),this._days=Zr(this._days),this._months=Zr(this._months),t.milliseconds=Zr(t.milliseconds),t.seconds=Zr(t.seconds),t.minutes=Zr(t.minutes),t.hours=Zr(t.hours),t.months=Zr(t.months),t.years=Zr(t.years),this}function to(t,e,n,i){var r=Ti(e,n);return t._milliseconds+=i*r._milliseconds,t._days+=i*r._days,t._months+=i*r._months,t._bubble()}function eo(t,e){return to(this,t,e,1)}function no(t,e){return to(this,t,e,-1)}function io(t){return t<0?Math.floor(t):Math.ceil(t)}function ro(){var t,e,n,i,r,o=this._milliseconds,a=this._days,s=this._months,l=this._data;return o>=0&&a>=0&&s>=0||o<=0&&a<=0&&s<=0||(o+=864e5*io(ao(s)+a),a=0,s=0),l.milliseconds=o%1e3,t=S(o/1e3),l.seconds=t%60,e=S(t/60),l.minutes=e%60,n=S(e/60),l.hours=n%24,a+=S(n/24),s+=r=S(oo(a)),a-=io(ao(r)),i=S(s/12),s%=12,l.days=a,l.months=s,l.years=i,this}function oo(t){return 4800*t/146097}function ao(t){return 146097*t/4800}function so(t){if(!this.isValid())return NaN;var e,n,i=this._milliseconds;if("month"===(t=J(t))||"quarter"===t||"year"===t)switch(e=this._days+i/864e5,n=this._months+oo(e),t){case"month":return n;case"quarter":return n/3;case"year":return n/12}else switch(e=this._days+Math.round(ao(this._months)),t){case"week":return e/7+i/6048e5;case"day":return e+i/864e5;case"hour":return 24*e+i/36e5;case"minute":return 1440*e+i/6e4;case"second":return 86400*e+i/1e3;case"millisecond":return Math.floor(864e5*e)+i;default:throw new Error("Unknown unit "+t)}}function lo(){return this.isValid()?this._milliseconds+864e5*this._days+this._months%12*2592e6+31536e6*M(this._months/12):NaN}function co(t){return function(){return this.as(t)}}var uo=co("ms"),ho=co("s"),fo=co("m"),po=co("h"),mo=co("d"),vo=co("w"),go=co("M"),yo=co("Q"),_o=co("y");function bo(){return Ti(this)}function wo(t){return t=J(t),this.isValid()?this[t+"s"]():NaN}function ko(t){return function(){return this.isValid()?this._data[t]:NaN}}var xo=ko("milliseconds"),Co=ko("seconds"),So=ko("minutes"),Mo=ko("hours"),To=ko("days"),Po=ko("months"),Oo=ko("years");function Bo(){return S(this.days()/7)}var Eo=Math.round,Ao={ss:44,s:45,m:45,h:22,d:26,M:11};function Do(t,e,n,i,r){return r.relativeTime(e||1,!!n,t,i)}function Lo(t,e,n){var i=Ti(t).abs(),r=Eo(i.as("s")),o=Eo(i.as("m")),a=Eo(i.as("h")),s=Eo(i.as("d")),l=Eo(i.as("M")),c=Eo(i.as("y")),u=r<=Ao.ss&&["s",r]||r<Ao.s&&["ss",r]||o<=1&&["m"]||o<Ao.m&&["mm",o]||a<=1&&["h"]||a<Ao.h&&["hh",a]||s<=1&&["d"]||s<Ao.d&&["dd",s]||l<=1&&["M"]||l<Ao.M&&["MM",l]||c<=1&&["y"]||["yy",c];return u[2]=e,u[3]=+t>0,u[4]=n,Do.apply(null,u)}function qo(t){return void 0===t?Eo:"function"==typeof t&&(Eo=t,!0)}function Ro(t,e){return void 0!==Ao[t]&&(void 0===e?Ao[t]:(Ao[t]=e,"s"===t&&(Ao.ss=e-1),!0))}function Io(t){if(!this.isValid())return this.localeData().invalidDate();var e=this.localeData(),n=Lo(this,!t,e);return t&&(n=e.pastFuture(+this,n)),e.postformat(n)}var No=Math.abs;function Fo(t){return(t>0)-(t<0)||+t}function $o(){if(!this.isValid())return this.localeData().invalidDate();var t,e,n=No(this._milliseconds)/1e3,i=No(this._days),r=No(this._months);t=S(n/60),e=S(t/60),n%=60,t%=60;var o=S(r/12),a=r%=12,s=i,l=e,c=t,u=n?n.toFixed(3).replace(/\.?0+$/,""):"",d=this.asSeconds();if(!d)return"P0D";var h=d<0?"-":"",f=Fo(this._months)!==Fo(d)?"-":"",p=Fo(this._days)!==Fo(d)?"-":"",m=Fo(this._milliseconds)!==Fo(d)?"-":"";return h+"P"+(o?f+o+"Y":"")+(a?f+a+"M":"")+(s?p+s+"D":"")+(l||c||u?"T":"")+(l?m+l+"H":"")+(c?m+c+"M":"")+(u?m+u+"S":"")}var jo=ai.prototype;return jo.isValid=ri,jo.abs=Xr,jo.add=eo,jo.subtract=no,jo.as=so,jo.asMilliseconds=uo,jo.asSeconds=ho,jo.asMinutes=fo,jo.asHours=po,jo.asDays=mo,jo.asWeeks=vo,jo.asMonths=go,jo.asQuarters=yo,jo.asYears=_o,jo.valueOf=lo,jo._bubble=ro,jo.clone=bo,jo.get=wo,jo.milliseconds=xo,jo.seconds=Co,jo.minutes=So,jo.hours=Mo,jo.days=To,jo.weeks=Bo,jo.months=Po,jo.years=Oo,jo.humanize=Io,jo.toISOString=$o,jo.toString=$o,jo.toJSON=$o,jo.locale=tr,jo.localeData=nr,jo.toIsoString=O("toIsoString() is deprecated. Please use toISOString() instead (notice the capitals)",$o),jo.lang=er,st("X",0,0,"unix"),st("x",0,0,"valueOf"),Bt("x",Ct),Bt("X",Tt),qt("X",(function(t,e,n){n._d=new Date(1e3*parseFloat(t,10))})),qt("x",(function(t,e,n){n._d=new Date(M(t))})),r.version="2.24.0",o(Gn),r.fn=Fr,r.min=Xn,r.max=ti,r.now=ei,r.utc=m,r.unix=$r,r.months=Yr,r.isDate=d,r.locale=mn,r.invalid=_,r.duration=Ti,r.isMoment=C,r.weekdays=Gr,r.parseZone=jr,r.localeData=yn,r.isDuration=si,r.monthsShort=Qr,r.weekdaysMin=Jr,r.defineLocale=vn,r.updateLocale=gn,r.locales=_n,r.weekdaysShort=Kr,r.normalizeUnits=J,r.relativeTimeRounding=qo,r.relativeTimeThreshold=Ro,r.calendarFormat=qi,r.prototype=Fr,r.HTML5_FMT={DATETIME_LOCAL:"YYYY-MM-DDTHH:mm",DATETIME_LOCAL_SECONDS:"YYYY-MM-DDTHH:mm:ss",DATETIME_LOCAL_MS:"YYYY-MM-DDTHH:mm:ss.SSS",DATE:"YYYY-MM-DD",TIME:"HH:mm",TIME_SECONDS:"HH:mm:ss",TIME_MS:"HH:mm:ss.SSS",WEEK:"GGGG-[W]WW",MONTH:"YYYY-MM"},r}()})),mi={datetime:"MMM D, YYYY, h:mm:ss a",millisecond:"h:mm:ss.SSS a",second:"h:mm:ss a",minute:"h:mm a",hour:"hA",day:"MMM D",week:"ll",month:"MMM YYYY",quarter:"[Q]Q - YYYY",year:"YYYY"};on._date.override("function"==typeof pi?{_id:"moment",formats:function(){return mi},parse:function(t,e){return"string"==typeof t&&"string"==typeof e?t=pi(t,e):t instanceof pi||(t=pi(t)),t.isValid()?t.valueOf():null},format:function(t,e){return pi(t).format(e)},add:function(t,e,n){return pi(t).add(e,n).valueOf()},diff:function(t,e,n){return pi(t).diff(pi(e),n)},startOf:function(t,e,n){return t=pi(t),"isoWeek"===e?t.isoWeekday(n).valueOf():t.startOf(e).valueOf()},endOf:function(t,e){return pi(t).endOf(e).valueOf()},_create:function(t){return pi(t)}}:{}),I._set("global",{plugins:{filler:{propagate:!0}}});var vi={dataset:function(t){var e=t.fill,n=t.chart,i=n.getDatasetMeta(e),r=i&&n.isDatasetVisible(e)&&i.dataset._children||[],o=r.length||0;return o?function(t,e){return e<o&&r[e]._view||null}:null},boundary:function(t){var e=t.boundary,n=e?e.x:null,i=e?e.y:null;return V.isArray(e)?function(t,n){return e[n]}:function(t){return{x:null===n?t.x:n,y:null===i?t.y:i}}}};function gi(t,e,n){var i,r=t._model||{},o=r.fill;if(void 0===o&&(o=!!r.backgroundColor),!1===o||null===o)return!1;if(!0===o)return"origin";if(i=parseFloat(o,10),isFinite(i)&&Math.floor(i)===i)return"-"!==o[0]&&"+"!==o[0]||(i=e+i),!(i===e||i<0||i>=n)&&i;switch(o){case"bottom":return"start";case"top":return"end";case"zero":return"origin";case"origin":case"start":case"end":return o;default:return!1}}function yi(t){return(t.el._scale||{}).getPointPositionForValue?function(t){var e,n,i,r,o,a=t.el._scale,s=a.options,l=a.chart.data.labels.length,c=t.fill,u=[];if(!l)return null;for(e=s.ticks.reverse?a.max:a.min,n=s.ticks.reverse?a.min:a.max,i=a.getPointPositionForValue(0,e),r=0;r<l;++r)o="start"===c||"end"===c?a.getPointPositionForValue(r,"start"===c?e:n):a.getBasePosition(r),s.gridLines.circular&&(o.cx=i.x,o.cy=i.y,o.angle=a.getIndexAngle(r)-Math.PI/2),u.push(o);return u}(t):function(t){var e,n=t.el._model||{},i=t.el._scale||{},r=t.fill,o=null;if(isFinite(r))return null;if("start"===r?o=void 0===n.scaleBottom?i.bottom:n.scaleBottom:"end"===r?o=void 0===n.scaleTop?i.top:n.scaleTop:void 0!==n.scaleZero?o=n.scaleZero:i.getBasePixel&&(o=i.getBasePixel()),null!=o){if(void 0!==o.x&&void 0!==o.y)return o;if(V.isFinite(o))return{x:(e=i.isHorizontal())?o:null,y:e?null:o}}return null}(t)}function _i(t,e,n){var i,r=t[e].fill,o=[e];if(!n)return r;for(;!1!==r&&-1===o.indexOf(r);){if(!isFinite(r))return r;if(!(i=t[r]))return!1;if(i.visible)return r;o.push(r),r=i.fill}return!1}function bi(t){var e=t.fill,n="dataset";return!1===e?null:(isFinite(e)||(n="boundary"),vi[n](t))}function wi(t){return t&&!t.skip}function ki(t,e,n,i,r){var o,a,s,l;if(i&&r){for(t.moveTo(e[0].x,e[0].y),o=1;o<i;++o)V.canvas.lineTo(t,e[o-1],e[o]);if(void 0===n[0].angle)for(t.lineTo(n[r-1].x,n[r-1].y),o=r-1;o>0;--o)V.canvas.lineTo(t,n[o],n[o-1],!0);else for(a=n[0].cx,s=n[0].cy,l=Math.sqrt(Math.pow(n[0].x-a,2)+Math.pow(n[0].y-s,2)),o=r-1;o>0;--o)t.arc(a,s,l,n[o].angle,n[o-1].angle,!0)}}function xi(t,e,n,i,r,o){var a,s,l,c,u,d,h,f,p=e.length,m=i.spanGaps,v=[],g=[],y=0,_=0;for(t.beginPath(),a=0,s=p;a<s;++a)u=n(c=e[l=a%p]._view,l,i),d=wi(c),h=wi(u),o&&void 0===f&&d&&(s=p+(f=a+1)),d&&h?(y=v.push(c),_=g.push(u)):y&&_&&(m?(d&&v.push(c),h&&g.push(u)):(ki(t,v,g,y,_),y=_=0,v=[],g=[]));ki(t,v,g,y,_),t.closePath(),t.fillStyle=r,t.fill()}var Ci={id:"filler",afterDatasetsUpdate:function(t,e){var n,i,r,o,a=(t.data.datasets||[]).length,s=e.propagate,l=[];for(i=0;i<a;++i)o=null,(r=(n=t.getDatasetMeta(i)).dataset)&&r._model&&r instanceof xt.Line&&(o={visible:t.isDatasetVisible(i),fill:gi(r,i,a),chart:t,el:r}),n.$filler=o,l.push(o);for(i=0;i<a;++i)(o=l[i])&&(o.fill=_i(l,i,s),o.boundary=yi(o),o.mapper=bi(o))},beforeDatasetsDraw:function(t){var e,n,i,r,o,a,s,l=t._getSortedVisibleDatasetMetas(),c=t.ctx;for(n=l.length-1;n>=0;--n)(e=l[n].$filler)&&e.visible&&(r=(i=e.el)._view,o=i._children||[],a=e.mapper,s=r.backgroundColor||I.global.defaultColor,a&&s&&o.length&&(V.canvas.clipArea(c,t.chartArea),xi(c,o,a,r,s,i._loop),V.canvas.unclipArea(c)))}},Si=V.rtl.getRtlAdapter,Mi=V.noop,Ti=V.valueOrDefault;function Pi(t,e){return t.usePointStyle&&t.boxWidth>e?e:t.boxWidth}I._set("global",{legend:{display:!0,position:"top",align:"center",fullWidth:!0,reverse:!1,weight:1e3,onClick:function(t,e){var n=e.datasetIndex,i=this.chart,r=i.getDatasetMeta(n);r.hidden=null===r.hidden?!i.data.datasets[n].hidden:null,i.update()},onHover:null,onLeave:null,labels:{boxWidth:40,padding:10,generateLabels:function(t){var e=t.data.datasets,n=t.options.legend||{},i=n.labels&&n.labels.usePointStyle;return t._getSortedDatasetMetas().map((function(n){var r=n.controller.getStyle(i?0:void 0);return{text:e[n.index].label,fillStyle:r.backgroundColor,hidden:!t.isDatasetVisible(n.index),lineCap:r.borderCapStyle,lineDash:r.borderDash,lineDashOffset:r.borderDashOffset,lineJoin:r.borderJoinStyle,lineWidth:r.borderWidth,strokeStyle:r.borderColor,pointStyle:r.pointStyle,rotation:r.rotation,datasetIndex:n.index}}),this)}}},legendCallback:function(t){var e,n,i,r=document.createElement("ul"),o=t.data.datasets;for(r.setAttribute("class",t.id+"-legend"),e=0,n=o.length;e<n;e++)(i=r.appendChild(document.createElement("li"))).appendChild(document.createElement("span")).style.backgroundColor=o[e].backgroundColor,o[e].label&&i.appendChild(document.createTextNode(o[e].label));return r.outerHTML}});var Oi=K.extend({initialize:function(t){var e=this;V.extend(e,t),e.legendHitBoxes=[],e._hoveredItem=null,e.doughnutMode=!1},beforeUpdate:Mi,update:function(t,e,n){var i=this;return i.beforeUpdate(),i.maxWidth=t,i.maxHeight=e,i.margins=n,i.beforeSetDimensions(),i.setDimensions(),i.afterSetDimensions(),i.beforeBuildLabels(),i.buildLabels(),i.afterBuildLabels(),i.beforeFit(),i.fit(),i.afterFit(),i.afterUpdate(),i.minSize},afterUpdate:Mi,beforeSetDimensions:Mi,setDimensions:function(){var t=this;t.isHorizontal()?(t.width=t.maxWidth,t.left=0,t.right=t.width):(t.height=t.maxHeight,t.top=0,t.bottom=t.height),t.paddingLeft=0,t.paddingTop=0,t.paddingRight=0,t.paddingBottom=0,t.minSize={width:0,height:0}},afterSetDimensions:Mi,beforeBuildLabels:Mi,buildLabels:function(){var t=this,e=t.options.labels||{},n=V.callback(e.generateLabels,[t.chart],t)||[];e.filter&&(n=n.filter((function(n){return e.filter(n,t.chart.data)}))),t.options.reverse&&n.reverse(),t.legendItems=n},afterBuildLabels:Mi,beforeFit:Mi,fit:function(){var t=this,e=t.options,n=e.labels,i=e.display,r=t.ctx,o=V.options._parseFont(n),a=o.size,s=t.legendHitBoxes=[],l=t.minSize,c=t.isHorizontal();if(c?(l.width=t.maxWidth,l.height=i?10:0):(l.width=i?10:0,l.height=t.maxHeight),i){if(r.font=o.string,c){var u=t.lineWidths=[0],d=0;r.textAlign="left",r.textBaseline="middle",V.each(t.legendItems,(function(t,e){var i=Pi(n,a)+a/2+r.measureText(t.text).width;(0===e||u[u.length-1]+i+2*n.padding>l.width)&&(d+=a+n.padding,u[u.length-(e>0?0:1)]=0),s[e]={left:0,top:0,width:i,height:a},u[u.length-1]+=i+n.padding})),l.height+=d}else{var h=n.padding,f=t.columnWidths=[],p=t.columnHeights=[],m=n.padding,v=0,g=0;V.each(t.legendItems,(function(t,e){var i=Pi(n,a)+a/2+r.measureText(t.text).width;e>0&&g+a+2*h>l.height&&(m+=v+n.padding,f.push(v),p.push(g),v=0,g=0),v=Math.max(v,i),g+=a+h,s[e]={left:0,top:0,width:i,height:a}})),m+=v,f.push(v),p.push(g),l.width+=m}t.width=l.width,t.height=l.height}else t.width=l.width=t.height=l.height=0},afterFit:Mi,isHorizontal:function(){return"top"===this.options.position||"bottom"===this.options.position},draw:function(){var t=this,e=t.options,n=e.labels,i=I.global,r=i.defaultColor,o=i.elements.line,a=t.height,s=t.columnHeights,l=t.width,c=t.lineWidths;if(e.display){var u,d=Si(e.rtl,t.left,t.minSize.width),h=t.ctx,f=Ti(n.fontColor,i.defaultFontColor),p=V.options._parseFont(n),m=p.size;h.textAlign=d.textAlign("left"),h.textBaseline="middle",h.lineWidth=.5,h.strokeStyle=f,h.fillStyle=f,h.font=p.string;var v=Pi(n,m),g=t.legendHitBoxes,y=function(t,i){switch(e.align){case"start":return n.padding;case"end":return t-i;default:return(t-i+n.padding)/2}},_=t.isHorizontal();u=_?{x:t.left+y(l,c[0]),y:t.top+n.padding,line:0}:{x:t.left+n.padding,y:t.top+y(a,s[0]),line:0},V.rtl.overrideTextDirection(t.ctx,e.textDirection);var b=m+n.padding;V.each(t.legendItems,(function(e,i){var f=h.measureText(e.text).width,p=v+m/2+f,w=u.x,k=u.y;d.setWidth(t.minSize.width),_?i>0&&w+p+n.padding>t.left+t.minSize.width&&(k=u.y+=b,u.line++,w=u.x=t.left+y(l,c[u.line])):i>0&&k+b>t.top+t.minSize.height&&(w=u.x=w+t.columnWidths[u.line]+n.padding,u.line++,k=u.y=t.top+y(a,s[u.line]));var x=d.x(w);!function(t,e,i){if(!(isNaN(v)||v<=0)){h.save();var a=Ti(i.lineWidth,o.borderWidth);if(h.fillStyle=Ti(i.fillStyle,r),h.lineCap=Ti(i.lineCap,o.borderCapStyle),h.lineDashOffset=Ti(i.lineDashOffset,o.borderDashOffset),h.lineJoin=Ti(i.lineJoin,o.borderJoinStyle),h.lineWidth=a,h.strokeStyle=Ti(i.strokeStyle,r),h.setLineDash&&h.setLineDash(Ti(i.lineDash,o.borderDash)),n&&n.usePointStyle){var s=v*Math.SQRT2/2,l=d.xPlus(t,v/2),c=e+m/2;V.canvas.drawPoint(h,i.pointStyle,s,l,c,i.rotation)}else h.fillRect(d.leftForLtr(t,v),e,v,m),0!==a&&h.strokeRect(d.leftForLtr(t,v),e,v,m);h.restore()}}(x,k,e),g[i].left=d.leftForLtr(x,g[i].width),g[i].top=k,function(t,e,n,i){var r=m/2,o=d.xPlus(t,v+r),a=e+r;h.fillText(n.text,o,a),n.hidden&&(h.beginPath(),h.lineWidth=2,h.moveTo(o,a),h.lineTo(d.xPlus(o,i),a),h.stroke())}(x,k,e,f),_?u.x+=p+n.padding:u.y+=b})),V.rtl.restoreTextDirection(t.ctx,e.textDirection)}},_getLegendItemAt:function(t,e){var n,i,r,o=this;if(t>=o.left&&t<=o.right&&e>=o.top&&e<=o.bottom)for(r=o.legendHitBoxes,n=0;n<r.length;++n)if(t>=(i=r[n]).left&&t<=i.left+i.width&&e>=i.top&&e<=i.top+i.height)return o.legendItems[n];return null},handleEvent:function(t){var e,n=this,i=n.options,r="mouseup"===t.type?"click":t.type;if("mousemove"===r){if(!i.onHover&&!i.onLeave)return}else{if("click"!==r)return;if(!i.onClick)return}e=n._getLegendItemAt(t.x,t.y),"click"===r?e&&i.onClick&&i.onClick.call(n,t.native,e):(i.onLeave&&e!==n._hoveredItem&&(n._hoveredItem&&i.onLeave.call(n,t.native,n._hoveredItem),n._hoveredItem=e),i.onHover&&e&&i.onHover.call(n,t.native,e))}});function Bi(t,e){var n=new Oi({ctx:t.ctx,options:e,chart:t});pe.configure(t,n,e),pe.addBox(t,n),t.legend=n}var Ei={id:"legend",_element:Oi,beforeInit:function(t){var e=t.options.legend;e&&Bi(t,e)},beforeUpdate:function(t){var e=t.options.legend,n=t.legend;e?(V.mergeIf(e,I.global.legend),n?(pe.configure(t,n,e),n.options=e):Bi(t,e)):n&&(pe.removeBox(t,n),delete t.legend)},afterEvent:function(t,e){var n=t.legend;n&&n.handleEvent(e)}},Ai=V.noop;I._set("global",{title:{display:!1,fontStyle:"bold",fullWidth:!0,padding:10,position:"top",text:"",weight:2e3}});var Di=K.extend({initialize:function(t){V.extend(this,t),this.legendHitBoxes=[]},beforeUpdate:Ai,update:function(t,e,n){var i=this;return i.beforeUpdate(),i.maxWidth=t,i.maxHeight=e,i.margins=n,i.beforeSetDimensions(),i.setDimensions(),i.afterSetDimensions(),i.beforeBuildLabels(),i.buildLabels(),i.afterBuildLabels(),i.beforeFit(),i.fit(),i.afterFit(),i.afterUpdate(),i.minSize},afterUpdate:Ai,beforeSetDimensions:Ai,setDimensions:function(){var t=this;t.isHorizontal()?(t.width=t.maxWidth,t.left=0,t.right=t.width):(t.height=t.maxHeight,t.top=0,t.bottom=t.height),t.paddingLeft=0,t.paddingTop=0,t.paddingRight=0,t.paddingBottom=0,t.minSize={width:0,height:0}},afterSetDimensions:Ai,beforeBuildLabels:Ai,buildLabels:Ai,afterBuildLabels:Ai,beforeFit:Ai,fit:function(){var t,e=this,n=e.options,i=e.minSize={},r=e.isHorizontal();n.display?(t=(V.isArray(n.text)?n.text.length:1)*V.options._parseFont(n).lineHeight+2*n.padding,e.width=i.width=r?e.maxWidth:t,e.height=i.height=r?t:e.maxHeight):e.width=i.width=e.height=i.height=0},afterFit:Ai,isHorizontal:function(){var t=this.options.position;return"top"===t||"bottom"===t},draw:function(){var t=this,e=t.ctx,n=t.options;if(n.display){var i,r,o,a=V.options._parseFont(n),s=a.lineHeight,l=s/2+n.padding,c=0,u=t.top,d=t.left,h=t.bottom,f=t.right;e.fillStyle=V.valueOrDefault(n.fontColor,I.global.defaultFontColor),e.font=a.string,t.isHorizontal()?(r=d+(f-d)/2,o=u+l,i=f-d):(r="left"===n.position?d+l:f-l,o=u+(h-u)/2,i=h-u,c=Math.PI*("left"===n.position?-.5:.5)),e.save(),e.translate(r,o),e.rotate(c),e.textAlign="center",e.textBaseline="middle";var p=n.text;if(V.isArray(p))for(var m=0,v=0;v<p.length;++v)e.fillText(p[v],0,m,i),m+=s;else e.fillText(p,0,0,i);e.restore()}}});function Li(t,e){var n=new Di({ctx:t.ctx,options:e,chart:t});pe.configure(t,n,e),pe.addBox(t,n),t.titleBlock=n}var qi={},Ri=Ci,Ii=Ei,Ni={id:"title",_element:Di,beforeInit:function(t){var e=t.options.title;e&&Li(t,e)},beforeUpdate:function(t){var e=t.options.title,n=t.titleBlock;e?(V.mergeIf(e,I.global.title),n?(pe.configure(t,n,e),n.options=e):Li(t,e)):n&&(pe.removeBox(t,n),delete t.titleBlock)}};for(var Fi in qi.filler=Ri,qi.legend=Ii,qi.title=Ni,en.helpers=V,function(){function t(t,e,n){var i;return"string"==typeof t?(i=parseInt(t,10),-1!==t.indexOf("%")&&(i=i/100*e.parentNode[n])):i=t,i}function e(t){return null!=t&&"none"!==t}function n(n,i,r){var o=document.defaultView,a=V._getParentNode(n),s=o.getComputedStyle(n)[i],l=o.getComputedStyle(a)[i],c=e(s),u=e(l),d=Number.POSITIVE_INFINITY;return c||u?Math.min(c?t(s,n,r):d,u?t(l,a,r):d):"none"}V.where=function(t,e){if(V.isArray(t)&&Array.prototype.filter)return t.filter(e);var n=[];return V.each(t,(function(t){e(t)&&n.push(t)})),n},V.findIndex=Array.prototype.findIndex?function(t,e,n){return t.findIndex(e,n)}:function(t,e,n){n=void 0===n?t:n;for(var i=0,r=t.length;i<r;++i)if(e.call(n,t[i],i,t))return i;return-1},V.findNextWhere=function(t,e,n){V.isNullOrUndef(n)&&(n=-1);for(var i=n+1;i<t.length;i++){var r=t[i];if(e(r))return r}},V.findPreviousWhere=function(t,e,n){V.isNullOrUndef(n)&&(n=t.length);for(var i=n-1;i>=0;i--){var r=t[i];if(e(r))return r}},V.isNumber=function(t){return!isNaN(parseFloat(t))&&isFinite(t)},V.almostEquals=function(t,e,n){return Math.abs(t-e)<n},V.almostWhole=function(t,e){var n=Math.round(t);return n-e<=t&&n+e>=t},V.max=function(t){return t.reduce((function(t,e){return isNaN(e)?t:Math.max(t,e)}),Number.NEGATIVE_INFINITY)},V.min=function(t){return t.reduce((function(t,e){return isNaN(e)?t:Math.min(t,e)}),Number.POSITIVE_INFINITY)},V.sign=Math.sign?function(t){return Math.sign(t)}:function(t){return 0===(t=+t)||isNaN(t)?t:t>0?1:-1},V.toRadians=function(t){return t*(Math.PI/180)},V.toDegrees=function(t){return t*(180/Math.PI)},V._decimalPlaces=function(t){if(V.isFinite(t)){for(var e=1,n=0;Math.round(t*e)/e!==t;)e*=10,n++;return n}},V.getAngleFromPoint=function(t,e){var n=e.x-t.x,i=e.y-t.y,r=Math.sqrt(n*n+i*i),o=Math.atan2(i,n);return o<-.5*Math.PI&&(o+=2*Math.PI),{angle:o,distance:r}},V.distanceBetweenPoints=function(t,e){return Math.sqrt(Math.pow(e.x-t.x,2)+Math.pow(e.y-t.y,2))},V.aliasPixel=function(t){return t%2==0?0:.5},V._alignPixel=function(t,e,n){var i=t.currentDevicePixelRatio,r=n/2;return Math.round((e-r)*i)/i+r},V.splineCurve=function(t,e,n,i){var r=t.skip?e:t,o=e,a=n.skip?e:n,s=Math.sqrt(Math.pow(o.x-r.x,2)+Math.pow(o.y-r.y,2)),l=Math.sqrt(Math.pow(a.x-o.x,2)+Math.pow(a.y-o.y,2)),c=s/(s+l),u=l/(s+l),d=i*(c=isNaN(c)?0:c),h=i*(u=isNaN(u)?0:u);return{previous:{x:o.x-d*(a.x-r.x),y:o.y-d*(a.y-r.y)},next:{x:o.x+h*(a.x-r.x),y:o.y+h*(a.y-r.y)}}},V.EPSILON=Number.EPSILON||1e-14,V.splineCurveMonotone=function(t){var e,n,i,r,o,a,s,l,c,u=(t||[]).map((function(t){return{model:t._model,deltaK:0,mK:0}})),d=u.length;for(e=0;e<d;++e)if(!(i=u[e]).model.skip){if(n=e>0?u[e-1]:null,(r=e<d-1?u[e+1]:null)&&!r.model.skip){var h=r.model.x-i.model.x;i.deltaK=0!==h?(r.model.y-i.model.y)/h:0}!n||n.model.skip?i.mK=i.deltaK:!r||r.model.skip?i.mK=n.deltaK:this.sign(n.deltaK)!==this.sign(i.deltaK)?i.mK=0:i.mK=(n.deltaK+i.deltaK)/2}for(e=0;e<d-1;++e)i=u[e],r=u[e+1],i.model.skip||r.model.skip||(V.almostEquals(i.deltaK,0,this.EPSILON)?i.mK=r.mK=0:(o=i.mK/i.deltaK,a=r.mK/i.deltaK,(l=Math.pow(o,2)+Math.pow(a,2))<=9||(s=3/Math.sqrt(l),i.mK=o*s*i.deltaK,r.mK=a*s*i.deltaK)));for(e=0;e<d;++e)(i=u[e]).model.skip||(n=e>0?u[e-1]:null,r=e<d-1?u[e+1]:null,n&&!n.model.skip&&(c=(i.model.x-n.model.x)/3,i.model.controlPointPreviousX=i.model.x-c,i.model.controlPointPreviousY=i.model.y-c*i.mK),r&&!r.model.skip&&(c=(r.model.x-i.model.x)/3,i.model.controlPointNextX=i.model.x+c,i.model.controlPointNextY=i.model.y+c*i.mK))},V.nextItem=function(t,e,n){return n?e>=t.length-1?t[0]:t[e+1]:e>=t.length-1?t[t.length-1]:t[e+1]},V.previousItem=function(t,e,n){return n?e<=0?t[t.length-1]:t[e-1]:e<=0?t[0]:t[e-1]},V.niceNum=function(t,e){var n=Math.floor(V.log10(t)),i=t/Math.pow(10,n);return(e?i<1.5?1:i<3?2:i<7?5:10:i<=1?1:i<=2?2:i<=5?5:10)*Math.pow(10,n)},V.requestAnimFrame="undefined"==typeof window?function(t){t()}:window.requestAnimationFrame||window.webkitRequestAnimationFrame||window.mozRequestAnimationFrame||window.oRequestAnimationFrame||window.msRequestAnimationFrame||function(t){return window.setTimeout(t,1e3/60)},V.getRelativePosition=function(t,e){var n,i,r=t.originalEvent||t,o=t.target||t.srcElement,a=o.getBoundingClientRect(),s=r.touches;s&&s.length>0?(n=s[0].clientX,i=s[0].clientY):(n=r.clientX,i=r.clientY);var l=parseFloat(V.getStyle(o,"padding-left")),c=parseFloat(V.getStyle(o,"padding-top")),u=parseFloat(V.getStyle(o,"padding-right")),d=parseFloat(V.getStyle(o,"padding-bottom")),h=a.right-a.left-l-u,f=a.bottom-a.top-c-d;return{x:n=Math.round((n-a.left-l)/h*o.width/e.currentDevicePixelRatio),y:i=Math.round((i-a.top-c)/f*o.height/e.currentDevicePixelRatio)}},V.getConstraintWidth=function(t){return n(t,"max-width","clientWidth")},V.getConstraintHeight=function(t){return n(t,"max-height","clientHeight")},V._calculatePadding=function(t,e,n){return(e=V.getStyle(t,e)).indexOf("%")>-1?n*parseInt(e,10)/100:parseInt(e,10)},V._getParentNode=function(t){var e=t.parentNode;return e&&"[object ShadowRoot]"===e.toString()&&(e=e.host),e},V.getMaximumWidth=function(t){var e=V._getParentNode(t);if(!e)return t.clientWidth;var n=e.clientWidth,i=n-V._calculatePadding(e,"padding-left",n)-V._calculatePadding(e,"padding-right",n),r=V.getConstraintWidth(t);return isNaN(r)?i:Math.min(i,r)},V.getMaximumHeight=function(t){var e=V._getParentNode(t);if(!e)return t.clientHeight;var n=e.clientHeight,i=n-V._calculatePadding(e,"padding-top",n)-V._calculatePadding(e,"padding-bottom",n),r=V.getConstraintHeight(t);return isNaN(r)?i:Math.min(i,r)},V.getStyle=function(t,e){return t.currentStyle?t.currentStyle[e]:document.defaultView.getComputedStyle(t,null).getPropertyValue(e)},V.retinaScale=function(t,e){var n=t.currentDevicePixelRatio=e||"undefined"!=typeof window&&window.devicePixelRatio||1;if(1!==n){var i=t.canvas,r=t.height,o=t.width;i.height=r*n,i.width=o*n,t.ctx.scale(n,n),i.style.height||i.style.width||(i.style.height=r+"px",i.style.width=o+"px")}},V.fontString=function(t,e,n){return e+" "+t+"px "+n},V.longestText=function(t,e,n,i){var r=(i=i||{}).data=i.data||{},o=i.garbageCollect=i.garbageCollect||[];i.font!==e&&(r=i.data={},o=i.garbageCollect=[],i.font=e),t.font=e;var a,s,l,c,u,d=0,h=n.length;for(a=0;a<h;a++)if(null!=(c=n[a])&&!0!==V.isArray(c))d=V.measureText(t,r,o,d,c);else if(V.isArray(c))for(s=0,l=c.length;s<l;s++)null==(u=c[s])||V.isArray(u)||(d=V.measureText(t,r,o,d,u));var f=o.length/2;if(f>n.length){for(a=0;a<f;a++)delete r[o[a]];o.splice(0,f)}return d},V.measureText=function(t,e,n,i,r){var o=e[r];return o||(o=e[r]=t.measureText(r).width,n.push(r)),o>i&&(i=o),i},V.numberOfLabelLines=function(t){var e=1;return V.each(t,(function(t){V.isArray(t)&&t.length>e&&(e=t.length)})),e},V.color=k?function(t){return t instanceof CanvasGradient&&(t=I.global.defaultColor),k(t)}:function(t){return console.error("Color.js not found!"),t},V.getHoverColor=function(t){return t instanceof CanvasPattern||t instanceof CanvasGradient?t:V.color(t).saturate(.5).darken(.1).rgbString()}}(),en._adapters=on,en.Animation=Z,en.animationService=X,en.controllers=Jt,en.DatasetController=rt,en.defaults=I,en.Element=K,en.elements=xt,en.Interaction=re,en.layouts=pe,en.platform=Le,en.plugins=qe,en.Scale=bn,en.scaleService=Re,en.Ticks=an,en.Tooltip=Ye,en.helpers.each(fi,(function(t,e){en.scaleService.registerScaleType(e,t,t._defaults)})),qi)qi.hasOwnProperty(Fi)&&en.plugins.register(qi[Fi]);en.platform.initialize();var $i=en;return"undefined"!=typeof window&&(window.Chart=en),en.Chart=en,en.Legend=qi.legend._element,en.Title=qi.title._element,en.pluginService=en.plugins,en.PluginBase=en.Element.extend({}),en.canvasHelpers=en.helpers.canvas,en.layoutService=en.layouts,en.LinearScaleBase=Mn,en.helpers.each(["Bar","Bubble","Doughnut","Line","PolarArea","Radar","Scatter"],(function(t){en[t]=function(e,n){return new en(e,en.helpers.merge(n||{},{type:t.charAt(0).toLowerCase()+t.slice(1)}))}})),$i})),
/*!
 * vue-i18n v8.28.2 
 * (c) 2022 kazuya kawaguchi
 * Released under the MIT License.
 */
function(t,e){"object"==typeof exports&&"undefined"!=typeof module?module.exports=e():"function"==typeof define&&define.amd?define(e):t.VueI18n=e()}(this,(function(){"use strict";var t=["compactDisplay","currency","currencyDisplay","currencySign","localeMatcher","notation","numberingSystem","signDisplay","style","unit","unitDisplay","useGrouping","minimumIntegerDigits","minimumFractionDigits","maximumFractionDigits","minimumSignificantDigits","maximumSignificantDigits"],e=["dateStyle","timeStyle","calendar","localeMatcher","hour12","hourCycle","timeZone","formatMatcher","weekday","era","year","month","day","hour","minute","second","timeZoneName"];function n(t,e){"undefined"!=typeof console&&(console.warn("[vue-i18n] "+t),e&&console.warn(e.stack))}function i(t,e){"undefined"!=typeof console&&(console.error("[vue-i18n] "+t),e&&console.error(e.stack))}var r=Array.isArray;function o(t){return null!==t&&"object"==typeof t}function a(t){return"string"==typeof t}var s=Object.prototype.toString,l="[object Object]";function c(t){return s.call(t)===l}function u(t){return null==t}function d(t){return"function"==typeof t}function h(){for(var t=[],e=arguments.length;e--;)t[e]=arguments[e];var n=null,i=null;return 1===t.length?o(t[0])||r(t[0])?i=t[0]:"string"==typeof t[0]&&(n=t[0]):2===t.length&&("string"==typeof t[0]&&(n=t[0]),(o(t[1])||r(t[1]))&&(i=t[1])),{locale:n,params:i}}function f(t){return JSON.parse(JSON.stringify(t))}function p(t,e){return!!~t.indexOf(e)}var m=Object.prototype.hasOwnProperty;function v(t,e){return m.call(t,e)}function g(t){for(var e=arguments,n=Object(t),i=1;i<arguments.length;i++){var r=e[i];if(null!=r){var a=void 0;for(a in r)v(r,a)&&(o(r[a])?n[a]=g(n[a],r[a]):n[a]=r[a])}}return n}function y(t,e){if(t===e)return!0;var n=o(t),i=o(e);if(!n||!i)return!n&&!i&&String(t)===String(e);try{var a=r(t),s=r(e);if(a&&s)return t.length===e.length&&t.every((function(t,n){return y(t,e[n])}));if(a||s)return!1;var l=Object.keys(t),c=Object.keys(e);return l.length===c.length&&l.every((function(n){return y(t[n],e[n])}))}catch(t){return!1}}var _={name:"i18n",functional:!0,props:{tag:{type:[String,Boolean,Object],default:"span"},path:{type:String,required:!0},locale:{type:String},places:{type:[Array,Object]}},render:function(t,e){var i=e.data,r=e.parent,o=e.props,a=e.slots,s=r.$i18n;if(s){var l=o.path,c=o.locale,u=o.places,d=a(),h=s.i(l,c,function(t){var e;for(e in t)if("default"!==e)return!1;return Boolean(e)}(d)||u?function(t,e){var i=e?function(t){return n("`places` prop is deprecated in next major version. Please switch to Vue slots."),Array.isArray(t)?t.reduce(w,{}):Object.assign({},t)}(e):{};if(!t)return i;t=t.filter((function(t){return t.tag||""!==t.text.trim()}));var r=t.every(k);r&&n("`place` attribute is deprecated in next major version. Please switch to Vue slots.");return t.reduce(r?b:w,i)}(d.default,u):d),f=o.tag&&!0!==o.tag||!1===o.tag?o.tag:"span";return f?t(f,i,h):h}n("Cannot find VueI18n instance!")}};function b(t,e){return e.data&&e.data.attrs&&e.data.attrs.place&&(t[e.data.attrs.place]=e),t}function w(t,e,n){return t[n]=e,t}function k(t){return Boolean(t.data&&t.data.attrs&&t.data.attrs.place)}var x,C={name:"i18n-n",functional:!0,props:{tag:{type:[String,Boolean,Object],default:"span"},value:{type:Number,required:!0},format:{type:[String,Object]},locale:{type:String}},render:function(e,i){var r=i.props,s=i.parent,l=i.data,c=s.$i18n;if(!c)return n("Cannot find VueI18n instance!"),null;var u=null,d=null;a(r.format)?u=r.format:o(r.format)&&(r.format.key&&(u=r.format.key),d=Object.keys(r.format).reduce((function(e,n){var i;return p(t,n)?Object.assign({},e,((i={})[n]=r.format[n],i)):e}),null));var h=r.locale||c.locale,f=c._ntp(r.value,h,u,d),m=f.map((function(t,e){var n,i=l.scopedSlots&&l.scopedSlots[t.type];return i?i(((n={})[t.type]=t.value,n.index=e,n.parts=f,n)):t.value})),v=r.tag&&!0!==r.tag||!1===r.tag?r.tag:"span";return v?e(v,{attrs:l.attrs,class:l.class,staticClass:l.staticClass},m):m}};function S(t,e,n){P(t,n)&&O(t,e,n)}function M(t,e,n,i){if(P(t,n)){var r=n.context.$i18n;(function(t,e){var n=e.context;return t._locale===n.$i18n.locale})(t,n)&&y(e.value,e.oldValue)&&y(t._localeMessage,r.getLocaleMessage(r.locale))||O(t,e,n)}}function T(t,e,i,r){if(i.context){var o=i.context.$i18n||{};e.modifiers.preserve||o.preserveDirectiveContent||(t.textContent=""),t._vt=void 0,delete t._vt,t._locale=void 0,delete t._locale,t._localeMessage=void 0,delete t._localeMessage}else n("Vue instance does not exists in VNode context")}function P(t,e){var i=e.context;return i?!!i.$i18n||(n("VueI18n instance does not exists in Vue instance"),!1):(n("Vue instance does not exists in VNode context"),!1)}function O(t,e,i){var r,o,s=function(t){var e,n,i,r;a(t)?e=t:c(t)&&(e=t.path,n=t.locale,i=t.args,r=t.choice);return{path:e,locale:n,args:i,choice:r}}(e.value),l=s.path,u=s.locale,d=s.args,h=s.choice;if(l||u||d)if(l){var f=i.context;t._vt=t.textContent=null!=h?(r=f.$i18n).tc.apply(r,[l,h].concat(B(u,d))):(o=f.$i18n).t.apply(o,[l].concat(B(u,d))),t._locale=f.$i18n.locale,t._localeMessage=f.$i18n.getLocaleMessage(f.$i18n.locale)}else n("`path` is required in v-t directive");else n("value type not supported")}function B(t,e){var n=[];return t&&n.push(t),e&&(Array.isArray(e)||c(e))&&n.push(e),n}function E(t,e){(void 0===e&&(e={bridge:!1}),E.installed&&t===x)?n("already installed."):(E.installed=!0,((x=t).version&&Number(x.version.split(".")[0])||-1)<2?n("vue-i18n ("+E.version+") need to use Vue 2.0 or later (Vue: "+x.version+")."):(!function(t){t.prototype.hasOwnProperty("$i18n")||Object.defineProperty(t.prototype,"$i18n",{get:function(){return this._i18n}}),t.prototype.$t=function(t){for(var e=[],n=arguments.length-1;n-- >0;)e[n]=arguments[n+1];var i=this.$i18n;return i._t.apply(i,[t,i.locale,i._getMessages(),this].concat(e))},t.prototype.$tc=function(t,e){for(var n=[],i=arguments.length-2;i-- >0;)n[i]=arguments[i+2];var r=this.$i18n;return r._tc.apply(r,[t,r.locale,r._getMessages(),this,e].concat(n))},t.prototype.$te=function(t,e){var n=this.$i18n;return n._te(t,n.locale,n._getMessages(),e)},t.prototype.$d=function(t){for(var e,n=[],i=arguments.length-1;i-- >0;)n[i]=arguments[i+1];return(e=this.$i18n).d.apply(e,[t].concat(n))},t.prototype.$n=function(t){for(var e,n=[],i=arguments.length-1;i-- >0;)n[i]=arguments[i+1];return(e=this.$i18n).n.apply(e,[t].concat(n))}}(x),x.mixin(function(t){function e(){this!==this.$root&&this.$options.__INTLIFY_META__&&this.$el&&this.$el.setAttribute("data-intlify",this.$options.__INTLIFY_META__)}return void 0===t&&(t=!1),t?{mounted:e}:{beforeCreate:function(){var t=this.$options;if(t.i18n=t.i18n||(t.__i18nBridge||t.__i18n?{}:null),t.i18n)if(t.i18n instanceof Y){if(t.__i18nBridge||t.__i18n)try{var e=t.i18n&&t.i18n.messages?t.i18n.messages:{};(t.__i18nBridge||t.__i18n).forEach((function(t){e=g(e,JSON.parse(t))})),Object.keys(e).forEach((function(n){t.i18n.mergeLocaleMessage(n,e[n])}))}catch(t){i("Cannot parse locale messages via custom blocks.",t)}this._i18n=t.i18n,this._i18nWatcher=this._i18n.watchI18nData()}else if(c(t.i18n)){var r=this.$root&&this.$root.$i18n&&this.$root.$i18n instanceof Y?this.$root.$i18n:null;if(r&&(t.i18n.root=this.$root,t.i18n.formatter=r.formatter,t.i18n.fallbackLocale=r.fallbackLocale,t.i18n.formatFallbackMessages=r.formatFallbackMessages,t.i18n.silentTranslationWarn=r.silentTranslationWarn,t.i18n.silentFallbackWarn=r.silentFallbackWarn,t.i18n.pluralizationRules=r.pluralizationRules,t.i18n.preserveDirectiveContent=r.preserveDirectiveContent),t.__i18nBridge||t.__i18n)try{var o=t.i18n&&t.i18n.messages?t.i18n.messages:{};(t.__i18nBridge||t.__i18n).forEach((function(t){o=g(o,JSON.parse(t))})),t.i18n.messages=o}catch(t){n("Cannot parse locale messages via custom blocks.",t)}var a=t.i18n.sharedMessages;a&&c(a)&&(t.i18n.messages=g(t.i18n.messages,a)),this._i18n=new Y(t.i18n),this._i18nWatcher=this._i18n.watchI18nData(),(void 0===t.i18n.sync||t.i18n.sync)&&(this._localeWatcher=this.$i18n.watchLocale()),r&&r.onComponentInstanceCreated(this._i18n)}else n("Cannot be interpreted 'i18n' option.");else this.$root&&this.$root.$i18n&&this.$root.$i18n instanceof Y?this._i18n=this.$root.$i18n:t.parent&&t.parent.$i18n&&t.parent.$i18n instanceof Y&&(this._i18n=t.parent.$i18n)},beforeMount:function(){var t=this.$options;t.i18n=t.i18n||(t.__i18nBridge||t.__i18n?{}:null),t.i18n?t.i18n instanceof Y||c(t.i18n)?(this._i18n.subscribeDataChanging(this),this._subscribing=!0):n("Cannot be interpreted 'i18n' option."):(this.$root&&this.$root.$i18n&&this.$root.$i18n instanceof Y||t.parent&&t.parent.$i18n&&t.parent.$i18n instanceof Y)&&(this._i18n.subscribeDataChanging(this),this._subscribing=!0)},mounted:e,beforeDestroy:function(){if(this._i18n){var t=this;this.$nextTick((function(){t._subscribing&&(t._i18n.unsubscribeDataChanging(t),delete t._subscribing),t._i18nWatcher&&(t._i18nWatcher(),t._i18n.destroyVM(),delete t._i18nWatcher),t._localeWatcher&&(t._localeWatcher(),delete t._localeWatcher)}))}}}}(e.bridge)),x.directive("t",{bind:S,update:M,unbind:T}),x.component(_.name,_),x.component(C.name,C),x.config.optionMergeStrategies.i18n=function(t,e){return void 0===e?t:e}))}var A=function(){this._caches=Object.create(null)};A.prototype.interpolate=function(t,e){if(!e)return[t];var i=this._caches[t];return i||(i=function(t){var e=[],n=0,i="";for(;n<t.length;){var r=t[n++];if("{"===r){i&&e.push({type:"text",value:i}),i="";var o="";for(r=t[n++];void 0!==r&&"}"!==r;)o+=r,r=t[n++];var a="}"===r,s=D.test(o)?"list":a&&L.test(o)?"named":"unknown";e.push({value:o,type:s})}else"%"===r?"{"!==t[n]&&(i+=r):i+=r}return i&&e.push({type:"text",value:i}),e}(t),this._caches[t]=i),function(t,e){var i=[],r=0,a=Array.isArray(e)?"list":o(e)?"named":"unknown";if("unknown"===a)return i;for(;r<t.length;){var s=t[r];switch(s.type){case"text":i.push(s.value);break;case"list":i.push(e[parseInt(s.value,10)]);break;case"named":"named"===a?i.push(e[s.value]):n("Type of token '"+s.type+"' and format of value '"+a+"' don't match!");break;case"unknown":n("Detect 'unknown' type of token!")}r++}return i}(i,e)};var D=/^(?:\d)+/,L=/^(?:\w)+/;var q=[];q[0]={ws:[0],ident:[3,0],"[":[4],eof:[7]},q[1]={ws:[1],".":[2],"[":[4],eof:[7]},q[2]={ws:[2],ident:[3,0],0:[3,0],number:[3,0]},q[3]={ident:[3,0],0:[3,0],number:[3,0],ws:[1,1],".":[2,1],"[":[4,1],eof:[7,1]},q[4]={"'":[5,0],'"':[6,0],"[":[4,2],"]":[1,3],eof:8,else:[4,0]},q[5]={"'":[4,0],eof:8,else:[5,0]},q[6]={'"':[4,0],eof:8,else:[6,0]};var R=/^\s?(?:true|false|-?[\d.]+|'[^']*'|"[^"]*")\s?$/;function I(t){if(null==t)return"eof";switch(t.charCodeAt(0)){case 91:case 93:case 46:case 34:case 39:return t;case 95:case 36:case 45:return"ident";case 9:case 10:case 13:case 160:case 65279:case 8232:case 8233:return"ws"}return"ident"}function N(t){var e,n,i,r=t.trim();return("0"!==t.charAt(0)||!isNaN(t))&&(i=r,R.test(i)?(n=(e=r).charCodeAt(0))!==e.charCodeAt(e.length-1)||34!==n&&39!==n?e:e.slice(1,-1):"*"+r)}var F=function(){this._cache=Object.create(null)};F.prototype.parsePath=function(t){var e=this._cache[t];return e||(e=function(t){var e,n,i,r,o,a,s,l=[],c=-1,u=0,d=0,h=[];function f(){var e=t[c+1];if(5===u&&"'"===e||6===u&&'"'===e)return c++,i="\\"+e,h[0](),!0}for(h[1]=function(){void 0!==n&&(l.push(n),n=void 0)},h[0]=function(){void 0===n?n=i:n+=i},h[2]=function(){h[0](),d++},h[3]=function(){if(d>0)d--,u=4,h[0]();else{if(d=0,void 0===n)return!1;if(!1===(n=N(n)))return!1;h[1]()}};null!==u;)if(c++,"\\"!==(e=t[c])||!f()){if(r=I(e),8===(o=(s=q[u])[r]||s.else||8))return;if(u=o[0],(a=h[o[1]])&&(i=void 0===(i=o[2])?e:i,!1===a()))return;if(7===u)return l}}(t),e&&(this._cache[t]=e)),e||[]},F.prototype.getPathValue=function(t,e){if(!o(t))return null;var n=this.parsePath(e);if(0===n.length)return null;for(var i=n.length,r=t,a=0;a<i;){var s=r[n[a]];if(null==s)return null;r=s,a++}return r};var $,j=/<\/?[\w\s="/.':;#-\/]+>/,z=/(?:@(?:\.[a-zA-Z]+)?:(?:[\w\-_|./]+|\([\w\-_:|./]+\)))/g,V=/^@(?:\.([a-zA-Z]+))?:/,H=/[()]/g,W={upper:function(t){return t.toLocaleUpperCase()},lower:function(t){return t.toLocaleLowerCase()},capitalize:function(t){return""+t.charAt(0).toLocaleUpperCase()+t.substr(1)}},U=new A,Y=function(t){var e=this;void 0===t&&(t={}),!x&&"undefined"!=typeof window&&window.Vue&&E(window.Vue);var n=t.locale||"en-US",i=!1!==t.fallbackLocale&&(t.fallbackLocale||"en-US"),r=t.messages||{},o=t.dateTimeFormats||t.datetimeFormats||{},a=t.numberFormats||{};this._vm=null,this._formatter=t.formatter||U,this._modifiers=t.modifiers||{},this._missing=t.missing||null,this._root=t.root||null,this._sync=void 0===t.sync||!!t.sync,this._fallbackRoot=void 0===t.fallbackRoot||!!t.fallbackRoot,this._fallbackRootWithEmptyString=void 0===t.fallbackRootWithEmptyString||!!t.fallbackRootWithEmptyString,this._formatFallbackMessages=void 0!==t.formatFallbackMessages&&!!t.formatFallbackMessages,this._silentTranslationWarn=void 0!==t.silentTranslationWarn&&t.silentTranslationWarn,this._silentFallbackWarn=void 0!==t.silentFallbackWarn&&!!t.silentFallbackWarn,this._dateTimeFormatters={},this._numberFormatters={},this._path=new F,this._dataListeners=new Set,this._componentInstanceCreatedListener=t.componentInstanceCreatedListener||null,this._preserveDirectiveContent=void 0!==t.preserveDirectiveContent&&!!t.preserveDirectiveContent,this.pluralizationRules=t.pluralizationRules||{},this._warnHtmlInMessage=t.warnHtmlInMessage||"off",this._postTranslation=t.postTranslation||null,this._escapeParameterHtml=t.escapeParameterHtml||!1,"__VUE_I18N_BRIDGE__"in t&&(this.__VUE_I18N_BRIDGE__=t.__VUE_I18N_BRIDGE__),this.getChoiceIndex=function(t,n){var i=Object.getPrototypeOf(e);if(i&&i.getChoiceIndex)return i.getChoiceIndex.call(e,t,n);var r,o;return e.locale in e.pluralizationRules?e.pluralizationRules[e.locale].apply(e,[t,n]):(r=t,o=n,r=Math.abs(r),2===o?r?r>1?1:0:1:r?Math.min(r,2):0)},this._exist=function(t,n){return!(!t||!n)&&(!u(e._path.getPathValue(t,n))||!!t[n])},"warn"!==this._warnHtmlInMessage&&"error"!==this._warnHtmlInMessage||Object.keys(r).forEach((function(t){e._checkLocaleMessage(t,e._warnHtmlInMessage,r[t])})),this._initVM({locale:n,fallbackLocale:i,messages:r,dateTimeFormats:o,numberFormats:a})},Q={vm:{configurable:!0},messages:{configurable:!0},dateTimeFormats:{configurable:!0},numberFormats:{configurable:!0},availableLocales:{configurable:!0},locale:{configurable:!0},fallbackLocale:{configurable:!0},formatFallbackMessages:{configurable:!0},missing:{configurable:!0},formatter:{configurable:!0},silentTranslationWarn:{configurable:!0},silentFallbackWarn:{configurable:!0},preserveDirectiveContent:{configurable:!0},warnHtmlInMessage:{configurable:!0},postTranslation:{configurable:!0},sync:{configurable:!0}};return Y.prototype._checkLocaleMessage=function(t,e,o){var s=function(t,e,o,l){if(c(o))Object.keys(o).forEach((function(n){var i=o[n];c(i)?(l.push(n),l.push("."),s(t,e,i,l),l.pop(),l.pop()):(l.push(n),s(t,e,i,l),l.pop())}));else if(r(o))o.forEach((function(n,i){c(n)?(l.push("["+i+"]"),l.push("."),s(t,e,n,l),l.pop(),l.pop()):(l.push("["+i+"]"),s(t,e,n,l),l.pop())}));else if(a(o)){if(j.test(o)){var u="Detected HTML in message '"+o+"' of keypath '"+l.join("")+"' at '"+e+"'. Consider component interpolation with '<i18n>' to avoid XSS. See https://bit.ly/2ZqJzkp";"warn"===t?n(u):"error"===t&&i(u)}}};s(e,t,o,[])},Y.prototype._initVM=function(t){var e=x.config.silent;x.config.silent=!0,this._vm=new x({data:t,__VUE18N__INSTANCE__:!0}),x.config.silent=e},Y.prototype.destroyVM=function(){this._vm.$destroy()},Y.prototype.subscribeDataChanging=function(t){this._dataListeners.add(t)},Y.prototype.unsubscribeDataChanging=function(t){!function(t,e){if(t.delete(e));}(this._dataListeners,t)},Y.prototype.watchI18nData=function(){var t=this;return this._vm.$watch("$data",(function(){for(var e,n,i=(e=t._dataListeners,n=[],e.forEach((function(t){return n.push(t)})),n),r=i.length;r--;)x.nextTick((function(){i[r]&&i[r].$forceUpdate()}))}),{deep:!0})},Y.prototype.watchLocale=function(t){if(t){if(!this.__VUE_I18N_BRIDGE__)return null;var e=this,n=this._vm;return this.vm.$watch("locale",(function(i){n.$set(n,"locale",i),e.__VUE_I18N_BRIDGE__&&t&&(t.locale.value=i),n.$forceUpdate()}),{immediate:!0})}if(!this._sync||!this._root)return null;var i=this._vm;return this._root.$i18n.vm.$watch("locale",(function(t){i.$set(i,"locale",t),i.$forceUpdate()}),{immediate:!0})},Y.prototype.onComponentInstanceCreated=function(t){this._componentInstanceCreatedListener&&this._componentInstanceCreatedListener(t,this)},Q.vm.get=function(){return this._vm},Q.messages.get=function(){return f(this._getMessages())},Q.dateTimeFormats.get=function(){return f(this._getDateTimeFormats())},Q.numberFormats.get=function(){return f(this._getNumberFormats())},Q.availableLocales.get=function(){return Object.keys(this.messages).sort()},Q.locale.get=function(){return this._vm.locale},Q.locale.set=function(t){this._vm.$set(this._vm,"locale",t)},Q.fallbackLocale.get=function(){return this._vm.fallbackLocale},Q.fallbackLocale.set=function(t){this._localeChainCache={},this._vm.$set(this._vm,"fallbackLocale",t)},Q.formatFallbackMessages.get=function(){return this._formatFallbackMessages},Q.formatFallbackMessages.set=function(t){this._formatFallbackMessages=t},Q.missing.get=function(){return this._missing},Q.missing.set=function(t){this._missing=t},Q.formatter.get=function(){return this._formatter},Q.formatter.set=function(t){this._formatter=t},Q.silentTranslationWarn.get=function(){return this._silentTranslationWarn},Q.silentTranslationWarn.set=function(t){this._silentTranslationWarn=t},Q.silentFallbackWarn.get=function(){return this._silentFallbackWarn},Q.silentFallbackWarn.set=function(t){this._silentFallbackWarn=t},Q.preserveDirectiveContent.get=function(){return this._preserveDirectiveContent},Q.preserveDirectiveContent.set=function(t){this._preserveDirectiveContent=t},Q.warnHtmlInMessage.get=function(){return this._warnHtmlInMessage},Q.warnHtmlInMessage.set=function(t){var e=this,n=this._warnHtmlInMessage;if(this._warnHtmlInMessage=t,n!==t&&("warn"===t||"error"===t)){var i=this._getMessages();Object.keys(i).forEach((function(t){e._checkLocaleMessage(t,e._warnHtmlInMessage,i[t])}))}},Q.postTranslation.get=function(){return this._postTranslation},Q.postTranslation.set=function(t){this._postTranslation=t},Q.sync.get=function(){return this._sync},Q.sync.set=function(t){this._sync=t},Y.prototype._getMessages=function(){return this._vm.messages},Y.prototype._getDateTimeFormats=function(){return this._vm.dateTimeFormats},Y.prototype._getNumberFormats=function(){return this._vm.numberFormats},Y.prototype._warnDefault=function(t,e,i,r,o,s){if(!u(i))return i;if(this._missing){var l=this._missing.apply(null,[t,e,r,o]);if(a(l))return l}else this._isSilentTranslationWarn(e)||n("Cannot translate the value of keypath '"+e+"'. Use the value of keypath as default.");if(this._formatFallbackMessages){var c=h.apply(void 0,o);return this._render(e,s,c.params,e)}return e},Y.prototype._isFallbackRoot=function(t){return(this._fallbackRootWithEmptyString?!t:u(t))&&!u(this._root)&&this._fallbackRoot},Y.prototype._isSilentFallbackWarn=function(t){return this._silentFallbackWarn instanceof RegExp?this._silentFallbackWarn.test(t):this._silentFallbackWarn},Y.prototype._isSilentFallback=function(t,e){return this._isSilentFallbackWarn(e)&&(this._isFallbackRoot()||t!==this.fallbackLocale)},Y.prototype._isSilentTranslationWarn=function(t){return this._silentTranslationWarn instanceof RegExp?this._silentTranslationWarn.test(t):this._silentTranslationWarn},Y.prototype._interpolate=function(t,e,i,o,s,l,h){if(!e)return null;var f,p=this._path.getPathValue(e,i);if(r(p)||c(p))return p;if(u(p)){if(!c(e))return null;if(!a(f=e[i])&&!d(f))return this._isSilentTranslationWarn(i)||this._isSilentFallback(t,i)||n("Value of key '"+i+"' is not a string or function !"),null}else{if(!a(p)&&!d(p))return this._isSilentTranslationWarn(i)||this._isSilentFallback(t,i)||n("Value of key '"+i+"' is not a string or function!"),null;f=p}return a(f)&&(f.indexOf("@:")>=0||f.indexOf("@.")>=0)&&(f=this._link(t,e,f,o,"raw",l,h)),this._render(f,s,l,i)},Y.prototype._link=function(t,e,i,o,a,s,l){var c=i,u=c.match(z);for(var d in u)if(u.hasOwnProperty(d)){var h=u[d],f=h.match(V),m=f[0],v=f[1],g=h.replace(m,"").replace(H,"");if(p(l,g))return n('Circular reference found. "'+h+'" is already visited in the chain of '+l.reverse().join(" <- ")),c;l.push(g);var y=this._interpolate(t,e,g,o,"raw"===a?"string":a,"raw"===a?void 0:s,l);if(this._isFallbackRoot(y)){if(this._isSilentTranslationWarn(g)||n("Fall back to translate the link placeholder '"+g+"' with root locale."),!this._root)throw Error("unexpected error");var _=this._root.$i18n;y=_._translate(_._getMessages(),_.locale,_.fallbackLocale,g,o,a,s)}y=this._warnDefault(t,g,y,o,r(s)?s:[s],a),this._modifiers.hasOwnProperty(v)?y=this._modifiers[v](y):W.hasOwnProperty(v)&&(y=W[v](y)),l.pop(),c=y?c.replace(h,y):c}return c},Y.prototype._createMessageContext=function(t,e,n,i){var a=this,s=r(t)?t:[],l=o(t)?t:{},c=this._getMessages(),u=this.locale;return{list:function(t){return s[t]},named:function(t){return l[t]},values:t,formatter:e,path:n,messages:c,locale:u,linked:function(t){return a._interpolate(u,c[u]||{},t,null,i,void 0,[t])}}},Y.prototype._render=function(t,e,n,i){if(d(t))return t(this._createMessageContext(n,this._formatter||U,i,e));var r=this._formatter.interpolate(t,n,i);return r||(r=U.interpolate(t,n,i)),"string"!==e||a(r)?r:r.join("")},Y.prototype._appendItemToChain=function(t,e,n){var i=!1;return p(t,e)||(i=!0,e&&(i="!"!==e[e.length-1],e=e.replace(/!/g,""),t.push(e),n&&n[e]&&(i=n[e]))),i},Y.prototype._appendLocaleToChain=function(t,e,n){var i,r=e.split("-");do{var o=r.join("-");i=this._appendItemToChain(t,o,n),r.splice(-1,1)}while(r.length&&!0===i);return i},Y.prototype._appendBlockToChain=function(t,e,n){for(var i=!0,r=0;r<e.length&&"boolean"==typeof i;r++){var o=e[r];a(o)&&(i=this._appendLocaleToChain(t,o,n))}return i},Y.prototype._getLocaleChain=function(t,e){if(""===t)return[];this._localeChainCache||(this._localeChainCache={});var n=this._localeChainCache[t];if(!n){e||(e=this.fallbackLocale),n=[];for(var i,s=[t];r(s);)s=this._appendBlockToChain(n,s,e);(s=a(i=r(e)?e:o(e)?e.default?e.default:null:e)?[i]:i)&&this._appendBlockToChain(n,s,null),this._localeChainCache[t]=n}return n},Y.prototype._translate=function(t,e,i,r,o,a,s){for(var l,c=this._getLocaleChain(e,i),d=0;d<c.length;d++){var h=c[d];if(!u(l=this._interpolate(h,t[h],r,o,a,s,[r])))return h===e||this._isSilentTranslationWarn(r)||this._isSilentFallbackWarn(r)||n("Fall back to translate the keypath '"+r+"' with '"+h+"' locale."),l}return null},Y.prototype._t=function(t,e,i,r){for(var o,a=[],s=arguments.length-4;s-- >0;)a[s]=arguments[s+4];if(!t)return"";var l,c=h.apply(void 0,a);this._escapeParameterHtml&&(c.params=(null!=(l=c.params)&&Object.keys(l).forEach((function(t){"string"==typeof l[t]&&(l[t]=l[t].replace(/</g,"&lt;").replace(/>/g,"&gt;").replace(/"/g,"&quot;").replace(/'/g,"&apos;"))})),l));var u=c.locale||e,d=this._translate(i,u,this.fallbackLocale,t,r,"string",c.params);if(this._isFallbackRoot(d)){if(this._isSilentTranslationWarn(t)||this._isSilentFallbackWarn(t)||n("Fall back to translate the keypath '"+t+"' with root locale."),!this._root)throw Error("unexpected error");return(o=this._root).$t.apply(o,[t].concat(a))}return d=this._warnDefault(u,t,d,r,a,"string"),this._postTranslation&&null!=d&&(d=this._postTranslation(d,t)),d},Y.prototype.t=function(t){for(var e,n=[],i=arguments.length-1;i-- >0;)n[i]=arguments[i+1];return(e=this)._t.apply(e,[t,this.locale,this._getMessages(),null].concat(n))},Y.prototype._i=function(t,e,i,r,o){var a=this._translate(i,e,this.fallbackLocale,t,r,"raw",o);if(this._isFallbackRoot(a)){if(this._isSilentTranslationWarn(t)||n("Fall back to interpolate the keypath '"+t+"' with root locale."),!this._root)throw Error("unexpected error");return this._root.$i18n.i(t,e,o)}return this._warnDefault(e,t,a,r,[o],"raw")},Y.prototype.i=function(t,e,n){return t?(a(e)||(e=this.locale),this._i(t,e,this._getMessages(),null,n)):""},Y.prototype._tc=function(t,e,n,i,r){for(var o,a=[],s=arguments.length-5;s-- >0;)a[s]=arguments[s+5];if(!t)return"";void 0===r&&(r=1);var l={count:r,n:r},c=h.apply(void 0,a);return c.params=Object.assign(l,c.params),a=null===c.locale?[c.params]:[c.locale,c.params],this.fetchChoice((o=this)._t.apply(o,[t,e,n,i].concat(a)),r)},Y.prototype.fetchChoice=function(t,e){if(!t||!a(t))return null;var n=t.split("|");return n[e=this.getChoiceIndex(e,n.length)]?n[e].trim():t},Y.prototype.tc=function(t,e){for(var n,i=[],r=arguments.length-2;r-- >0;)i[r]=arguments[r+2];return(n=this)._tc.apply(n,[t,this.locale,this._getMessages(),null,e].concat(i))},Y.prototype._te=function(t,e,n){for(var i=[],r=arguments.length-3;r-- >0;)i[r]=arguments[r+3];var o=h.apply(void 0,i).locale||e;return this._exist(n[o],t)},Y.prototype.te=function(t,e){return this._te(t,this.locale,this._getMessages(),e)},Y.prototype.getLocaleMessage=function(t){return f(this._vm.messages[t]||{})},Y.prototype.setLocaleMessage=function(t,e){"warn"!==this._warnHtmlInMessage&&"error"!==this._warnHtmlInMessage||this._checkLocaleMessage(t,this._warnHtmlInMessage,e),this._vm.$set(this._vm.messages,t,e)},Y.prototype.mergeLocaleMessage=function(t,e){"warn"!==this._warnHtmlInMessage&&"error"!==this._warnHtmlInMessage||this._checkLocaleMessage(t,this._warnHtmlInMessage,e),this._vm.$set(this._vm.messages,t,g(void 0!==this._vm.messages[t]&&Object.keys(this._vm.messages[t]).length?Object.assign({},this._vm.messages[t]):{},e))},Y.prototype.getDateTimeFormat=function(t){return f(this._vm.dateTimeFormats[t]||{})},Y.prototype.setDateTimeFormat=function(t,e){this._vm.$set(this._vm.dateTimeFormats,t,e),this._clearDateTimeFormat(t,e)},Y.prototype.mergeDateTimeFormat=function(t,e){this._vm.$set(this._vm.dateTimeFormats,t,g(this._vm.dateTimeFormats[t]||{},e)),this._clearDateTimeFormat(t,e)},Y.prototype._clearDateTimeFormat=function(t,e){for(var n in e){var i=t+"__"+n;this._dateTimeFormatters.hasOwnProperty(i)&&delete this._dateTimeFormatters[i]}},Y.prototype._localizeDateTime=function(t,e,i,r,o,a){for(var s=e,l=r[s],c=this._getLocaleChain(e,i),d=0;d<c.length;d++){var h=s,f=c[d];if(s=f,!u(l=r[f])&&!u(l[o]))break;f===e||this._isSilentTranslationWarn(o)||this._isSilentFallbackWarn(o)||n("Fall back to '"+f+"' datetime formats from '"+h+"' datetime formats.")}if(u(l)||u(l[o]))return null;var p,m=l[o];if(a)p=new Intl.DateTimeFormat(s,Object.assign({},m,a));else{var v=s+"__"+o;(p=this._dateTimeFormatters[v])||(p=this._dateTimeFormatters[v]=new Intl.DateTimeFormat(s,m))}return p.format(t)},Y.prototype._d=function(t,e,i,r){if(!Y.availabilities.dateTimeFormat)return n("Cannot format a Date value due to not supported Intl.DateTimeFormat."),"";if(!i)return(r?new Intl.DateTimeFormat(e,r):new Intl.DateTimeFormat(e)).format(t);var o=this._localizeDateTime(t,e,this.fallbackLocale,this._getDateTimeFormats(),i,r);if(this._isFallbackRoot(o)){if(this._isSilentTranslationWarn(i)||this._isSilentFallbackWarn(i)||n("Fall back to datetime localization of root: key '"+i+"'."),!this._root)throw Error("unexpected error");return this._root.$i18n.d(t,i,e)}return o||""},Y.prototype.d=function(t){for(var n=[],i=arguments.length-1;i-- >0;)n[i]=arguments[i+1];var r=this.locale,s=null,l=null;return 1===n.length?(a(n[0])?s=n[0]:o(n[0])&&(n[0].locale&&(r=n[0].locale),n[0].key&&(s=n[0].key)),l=Object.keys(n[0]).reduce((function(t,i){var r;return p(e,i)?Object.assign({},t,((r={})[i]=n[0][i],r)):t}),null)):2===n.length&&(a(n[0])&&(s=n[0]),a(n[1])&&(r=n[1])),this._d(t,r,s,l)},Y.prototype.getNumberFormat=function(t){return f(this._vm.numberFormats[t]||{})},Y.prototype.setNumberFormat=function(t,e){this._vm.$set(this._vm.numberFormats,t,e),this._clearNumberFormat(t,e)},Y.prototype.mergeNumberFormat=function(t,e){this._vm.$set(this._vm.numberFormats,t,g(this._vm.numberFormats[t]||{},e)),this._clearNumberFormat(t,e)},Y.prototype._clearNumberFormat=function(t,e){for(var n in e){var i=t+"__"+n;this._numberFormatters.hasOwnProperty(i)&&delete this._numberFormatters[i]}},Y.prototype._getNumberFormatter=function(t,e,i,r,o,a){for(var s=e,l=r[s],c=this._getLocaleChain(e,i),d=0;d<c.length;d++){var h=s,f=c[d];if(s=f,!u(l=r[f])&&!u(l[o]))break;f===e||this._isSilentTranslationWarn(o)||this._isSilentFallbackWarn(o)||n("Fall back to '"+f+"' number formats from '"+h+"' number formats.")}if(u(l)||u(l[o]))return null;var p,m=l[o];if(a)p=new Intl.NumberFormat(s,Object.assign({},m,a));else{var v=s+"__"+o;(p=this._numberFormatters[v])||(p=this._numberFormatters[v]=new Intl.NumberFormat(s,m))}return p},Y.prototype._n=function(t,e,i,r){if(!Y.availabilities.numberFormat)return n("Cannot format a Number value due to not supported Intl.NumberFormat."),"";if(!i)return(r?new Intl.NumberFormat(e,r):new Intl.NumberFormat(e)).format(t);var o=this._getNumberFormatter(t,e,this.fallbackLocale,this._getNumberFormats(),i,r),a=o&&o.format(t);if(this._isFallbackRoot(a)){if(this._isSilentTranslationWarn(i)||this._isSilentFallbackWarn(i)||n("Fall back to number localization of root: key '"+i+"'."),!this._root)throw Error("unexpected error");return this._root.$i18n.n(t,Object.assign({},{key:i,locale:e},r))}return a||""},Y.prototype.n=function(e){for(var n=[],i=arguments.length-1;i-- >0;)n[i]=arguments[i+1];var r=this.locale,s=null,l=null;return 1===n.length?a(n[0])?s=n[0]:o(n[0])&&(n[0].locale&&(r=n[0].locale),n[0].key&&(s=n[0].key),l=Object.keys(n[0]).reduce((function(e,i){var r;return p(t,i)?Object.assign({},e,((r={})[i]=n[0][i],r)):e}),null)):2===n.length&&(a(n[0])&&(s=n[0]),a(n[1])&&(r=n[1])),this._n(e,r,s,l)},Y.prototype._ntp=function(t,e,i,r){if(!Y.availabilities.numberFormat)return n("Cannot format to parts a Number value due to not supported Intl.NumberFormat."),[];if(!i)return(r?new Intl.NumberFormat(e,r):new Intl.NumberFormat(e)).formatToParts(t);var o=this._getNumberFormatter(t,e,this.fallbackLocale,this._getNumberFormats(),i,r),a=o&&o.formatToParts(t);if(this._isFallbackRoot(a)){if(this._isSilentTranslationWarn(i)||n("Fall back to format number to parts of root: key '"+i+"' ."),!this._root)throw Error("unexpected error");return this._root.$i18n._ntp(t,e,i,r)}return a||[]},Object.defineProperties(Y.prototype,Q),Object.defineProperty(Y,"availabilities",{get:function(){if(!$){var t="undefined"!=typeof Intl;$={dateTimeFormat:t&&void 0!==Intl.DateTimeFormat,numberFormat:t&&void 0!==Intl.NumberFormat}}return $}}),Y.install=E,Y.version="8.28.2",Y})),window.localisation={},window.localisation.en={server:"Server",theme:"Theme",funding:"Funding",users:"Users",restart:"Restart server",save:"Save",save_tooltip:"Save your changes",topup:"Topup",topup_wallet:"Topup a wallet",topup_hint:"Use the wallet ID to topup any wallet",restart_tooltip:"Restart the server for changes to take effect",add_funds_tooltip:"Add funds to a wallet.",reset_defaults:"Reset to defaults",reset_defaults_tooltip:"Delete all settings and reset to defaults.",download_backup:"Download database backup",name_your_wallet:"Name your %{name} wallet",paste_invoice_label:"Paste an invoice, payment request or lnurl code *",lnbits_description:"Easy to set up and lightweight, LNbits can run on any lightning-network funding source, currently supporting LND, c-lightning, OpenNode, LNPay and even LNbits itself! You can run LNbits for yourself, or easily offer a custodian solution for others. Each wallet has its own API keys and there is no limit to the number of wallets you can make. Being able to partition funds makes LNbits a useful tool for money management and as a development tool. Extensions add extra functionality to LNbits so you can experiment with a range of cutting-edge technologies on the lightning network. We have made developing extensions as easy as possible, and as a free and open-source project, we encourage people to develop and submit their own.",export_to_phone:"Export to Phone with QR Code",export_to_phone_desc:"This QR code contains your wallet URL with full access. You can scan it from your phone to open your wallet from there.",wallets:"Wallets",add_wallet:"Add a new wallet",delete_wallet:"Delete wallet",delete_wallet_desc:"This whole wallet will be deleted, the funds will be UNRECOVERABLE.",rename_wallet:"Rename wallet",update_name:"Update name",press_to_claim:"Press to claim bitcoin",donate:"Donate",view_github:"View on GitHub",voidwallet_active:"VoidWallet is active! Payments disabled",use_with_caution:"USE WITH CAUTION - %{name} wallet is still in BETA",toggle_darkmode:"Toggle Dark Mode",view_swagger_docs:"View LNbits Swagger API docs",api_docs:"Api docs",commit_version:"Commit version",runs_on:"Runs on",credit_hint:"Press Enter to credit account",credit_label:"%{denomination} to credit",paste_request:"Paste Request",create_invoice:"Create Invoice",camera_tooltip:"Use camera to scan an invoice/QR",export_csv:"Export to CSV",transactions:"Transactions",chart_tooltip:"Show chart",pending:"Pending",copy_invoice:"Copy invoice",close:"Close",cancel:"Cancel",scan:"Scan",read:"Read",pay:"Pay",memo:"Memo",date:"Date",processing_payment:"Processing payment...",not_enough_funds:"Not enough funds!",search_by_tag_memo_amount:"Search by tag, memo, amount",invoice_waiting:"Invoice waiting to be paid",payment_received:"Payment Received",payment_sent:"Payment Sent",outgoing_payment_pending:"Outgoing payment pending",drain_funds:"Drain Funds",drain_funds_desc:"This is an LNURL-withdraw QR code for slurping everything from this wallet. Do not share with anyone. It is compatible with balanceCheck and balanceNotify so your wallet may keep pulling the funds continuously from here after the first withdraw.",i_understand:"I understand",copy_wallet_url:"Copy wallet URL",disclaimer_dialog:"Login functionality to be released in a future update, for now, make sure you bookmark this page for future access to your wallet! This service is in BETA, and we hold no responsibility for people losing access to funds.",no_transactions:"No transactions made yet",manage_extensions:"Manage Extensions",manage_server:"Manage Server",extensions:"Extensions",no_extensions:"You don't have any extensions installed :(",created:"Created",payment_hash:"Payment Hash",fee:"Fee",amount:"Amount",unit:"Unit",description:"Description",expiry:"Expiry",webhook:"Webhook",payment_proof:"Payment Proof"},window.localisation.de={server:"Server",theme:"Theme",funding:"Funding",users:"Benutzer",unit:"Einheit",restart:"Server neu starten",save:"Speichern",save_tooltip:"Änderungen speichern",topup:"Aufladen",topup_wallet:"Wallet aufladen",topup_hint:"Nutze die Wallet-ID um eine beliebige Wallet aufzuladen",restart_tooltip:"Starte den Server neu um die Änderungen zu übernehmen",add_funds_tooltip:"Füge Geld zu einer Wallet hinzu.",reset_defaults:"Zurücksetzen",reset_defaults_tooltip:"Lösche alle Einstellungen und setze auf die Standardeinstellungen zurück.",download_backup:"Datenbank-Backup herunterladen",name_your_wallet:"Benenne deine %{name} Wallet",paste_invoice_label:"Füge eine Rechnung, Zahlungsanforderung oder lnurl ein *",lnbits_description:"Einfach zu installieren und leichtgewichtig, LNbits kann auf jeder Lightning-Netzwerk-Funding-Quelle laufen, derzeit unterstützt LND, c-lightning, OpenNode, LNPay und sogar LNbits selbst! Du kannst LNbits für dich selbst laufen lassen oder anderen eine kundige Lösung anbieten. Jede Wallet hat ihre eigenen API-Schlüssel und es gibt keine Begrenzung für die Anzahl der Wallets, die du erstellen kannst. Die Möglichkeit, Gelder zu partitionieren, macht LNbits zu einem nützlichen Werkzeug für die Geldverwaltung und als Entwicklungswerkzeug. Erweiterungen fügen der LNbits zusätzliche Funktionalität hinzu, so dass du mit einer Reihe von vorderen Technologien auf dem Lightning-Netzwerk experimentieren kannst. Wir haben es so einfach wie möglich gemacht, Erweiterungen zu entwickeln, und als freies und Open-Source-Projekt ermutigen wir Menschen, sich selbst zu entwickeln und ihre eigenen Beiträge einzureichen.",export_to_phone:"Exportieren Sie auf das Telefon mit QR-Code",export_to_phone_desc:"Dieser QR-Code enthält Ihre Wallet-URL mit vollständigem Zugriff. Sie können es von Ihrem Telefon aus scannen, um Ihre Wallet dort zu öffnen.",wallets:"Wallets",add_wallet:"Füge eine neue Wallet hinzu",delete_wallet:"Wallet löschen",delete_wallet_desc:"Diese ganze Wallet wird gelöscht, die Mittel sind UNWIEDERBRINGLICH.",rename_wallet:"Wallet umbenennen",update_name:"Name aktualisieren",press_to_claim:"Drücken Sie, um Bitcoin zu beanspruchen",donate:"Spenden",view_github:"Auf GitHub anzeigen",voidwallet_active:"VoidWallet ist aktiv! Zahlungen deaktiviert",use_with_caution:"VERWENDEN SIE MIT VORSICHT - %{name} Wallet ist noch in der BETA",toggle_darkmode:"Dark Mode umschalten",view_swagger_docs:"LNbits Swagger API-Dokumente anzeigen",api_docs:"Api docs",commit_version:"Commit version",runs_on:"Läuft auf",credit_hint:"Drücken Sie Enter, um das Konto zu belasten",credit_label:"%{denomination} zu belasten",paste_request:"Anfrage einfügen",create_invoice:"Rechnung erstellen",camera_tooltip:"Verwenden Sie die Kamera, um eine Rechnung / QR-Code zu scannen",export_csv:"Exportieren Sie nach CSV",transactions:"Transaktionen",chart_tooltip:"Diagramm anzeigen",pending:"Ausstehend",copy_invoice:"Rechnung kopieren",close:"Schließen",cancel:"Stornieren",scan:"Scannen",read:"Lesen",pay:"Zahlen",memo:"Memo",date:"Datum",processing_payment:"Zahlung wird bearbeitet ...",not_enough_funds:"Nicht genug Geld!",search_by_tag_memo_amount:"Suche nach Tag, Memo, Betrag",invoice_waiting:"Rechnung wartet auf Zahlung",payment_received:"Zahlung erhalten",payment_sent:"Zahlung gesendet",outgoing_payment_pending:"Ausgehende Zahlung ausstehend",drain_funds:"Leeren Sie die Mittel",drain_funds_desc:"Dies ist ein LNURL-withdraw QR-Code zum Absaugen aller Mittel aus dieser Brieftasche. Teilen Sie es nicht mit jemandem. Es ist mit balanceCheck und balanceNotify kompatibel, so dass Ihre Brieftasche die Mittel nach dem ersten Abzug kontinuierlich von hier ziehen kann.",i_understand:"Ich verstehe",copy_wallet_url:"Wallet-URL kopieren",disclaimer_dialog:"Login-Funktionalität wird in einem zukünftigen Update veröffentlicht, für jetzt, stellen Sie sicher, dass Sie diese Seite als Lesezeichen speichern, um zukünftigen Zugriff auf Ihre Wallet zu erhalten! Dieser Service ist in BETA und wir übernehmen keine Verantwortung für Personen, die den Zugriff auf ihre Mittel verlieren.",no_transactions:"Noch keine Transaktionen",manage_extensions:"Erweiterungen verwalten",manage_server:"Server verwalten",extensions:"Erweiterungen",no_extensions:"Sie haben keine Erweiterungen installiert :(",created:"Erstellt",payment_hash:"Zahlungs-Hash",fee:"Gebühr",amount:"Menge",description:"Beschreibung",expiry:"Ablauf",webhook:"Webhook",payment_proof:"Zahlungsbeleg"},window.localisation.es={server:"Servidor",theme:"Tema",funding:"Financiación",unit:"Unidad",users:"Usuarios",restart:"Reiniciar el servidor",save:"Guardar",save_tooltip:"Guardar cambios",topup:"Recargar",topup_wallet:"Recargar billetera",topup_hint:"Utilice el ID de billetera para recargar cualquier billetera",restart_tooltip:"Reinicie el servidor para aplicar los cambios",add_funds_tooltip:"Agregue fondos a una billetera.",reset_defaults:"Restablecer",reset_defaults_tooltip:"Borrar todas las configuraciones y restablecer a los valores predeterminados.",download_backup:"Descargar copia de seguridad de la base de datos",name_your_wallet:"Nombre de su billetera %{name}",paste_invoice_label:"Pegue la factura aquí",lnbits_description:"Fácil de instalar y liviano, LNbits puede ejecutarse en cualquier fuente de financiación de la red Lightning, actualmente compatible con LND, c-lightning, OpenNode, LNPay y hasta LNbits mismo! Puede ejecutar LNbits para usted mismo o ofrecer una solución competente a otros. Cada billetera tiene su propia clave API y no hay límite para la cantidad de billeteras que puede crear. La capacidad de particionar fondos hace de LNbits una herramienta útil para la administración de fondos y como herramienta de desarrollo. Las extensiones agregan funcionalidad adicional a LNbits, por lo que puede experimentar con una variedad de tecnologías de vanguardia en la red Lightning. Lo hemos hecho lo más simple posible para desarrollar extensiones y, como un proyecto gratuito y de código abierto, animamos a las personas a que se desarrollen a sí mismas y envíen sus propios contribuciones.",export_to_phone:"Exportar a teléfono con código QR",export_to_phone_desc:"Este código QR contiene su URL de billetera con acceso completo. Puede escanearlo desde su teléfono para abrir su billetera allí.",wallets:"Billeteras",add_wallet:"Agregar nueva billetera",delete_wallet:"Eliminar billetera",delete_wallet_desc:"Esta billetera completa se eliminará, los fondos son IRREVERSIBLES.",rename_wallet:"Cambiar el nombre de la billetera",update_name:"Actualizar nombre",press_to_claim:"Presione para reclamar Bitcoin",donate:"Donar",view_github:"Ver en GitHub",voidwallet_active:"¡VoidWallet está activo! Pagos desactivados",use_with_caution:"USAR CON CUIDADO - %{name} Wallet aún está en BETA",toggle_darkmode:"Cambiar modo oscuro",view_swagger_docs:"Ver documentos de API de LNbits Swagger",api_docs:"Documentos de API",commit_version:"Versión de compromiso",runs_on:"Corre en",credit_hint:"Presione Enter para cargar la cuenta",credit_label:"Cargar %{denomination}",paste_request:"Pegar solicitud",create_invoice:"Crear factura",camera_tooltip:"Utilice la cámara para escanear una factura / código QR",export_csv:"Exportar a CSV",transactions:"Transacciones",chart_tooltip:"Mostrar gráfico",pending:"Pendiente",copy_invoice:"Copiar factura",close:"Cerrar",cancel:"Cancelar",scan:"Escanear",read:"Leer",pay:"Pagar",memo:"Memo",date:"Fecha",processing_payment:"Procesando pago ...",not_enough_funds:"¡No hay suficientes fondos!",search_by_tag_memo_amount:"Buscar por etiqueta, memo, cantidad",invoice_waiting:"Factura esperando pago",payment_received:"Pago recibido",payment_sent:"Pago enviado",outgoing_payment_pending:"Pago saliente pendiente",drain_funds:"Drenar fondos",drain_funds_desc:"Este es un código QR LNURL-withdraw para drenar todos los fondos de esta billetera. No lo comparta con nadie. Es compatible con balanceCheck y balanceNotify, por lo que su billetera puede continuar drenando los fondos de aquí después del primer drenaje.",i_understand:"Lo entiendo",copy_wallet_url:"Copiar URL de billetera",disclaimer_dialog:"La funcionalidad de inicio de sesión se lanzará en una actualización futura, por ahora, asegúrese de guardar esta página como marcador para acceder a su billetera en el futuro. Este servicio está en BETA y no asumimos ninguna responsabilidad por personas que pierdan el acceso a sus fondos.",no_transactions:"No hay transacciones todavía",manage_extensions:"Administrar extensiones",manage_server:"Administrar servidor",extensions:"Extensiones",no_extensions:"No tienes extensiones instaladas :(",created:"Creado",payment_hash:"Hash de pago",fee:"Cuota",amount:"Cantidad",description:"Descripción",expiry:"Expiración",webhook:"Webhook",payment_proof:"Prueba de pago"},window.localisation.jp={server:"サーバー",theme:"テーマ",funding:"資金調達",users:"ユーザー",restart:"サーバーを再起動する",save:"保存",unit:"単位",save_tooltip:"変更を保存する",topup:"トップアップ",topup_wallet:"ウォレットをトップアップする",topup_hint:"ウォレットIDを使用して、任意のウォレットをトップアップできます",restart_tooltip:"サーバーを再起動して変更を適用します",add_funds_tooltip:"ウォレットに資金を追加します。",reset_defaults:"リセット",reset_defaults_tooltip:"すべての設定を削除してデフォルトに戻します。",download_backup:"データベースのバックアップをダウンロードする",name_your_wallet:"あなたのウォレットの名前 %{name}",paste_invoice_label:"請求書を貼り付けてください",lnbits_description:"簡単にインストールでき、軽量で、LNbitsは現在LND、c-lightning、OpenNode、LNPay、さらにLNbits自身で動作する任意のLightningネットワークの資金源で実行できます！ LNbitsを自分で実行することも、他の人に優れたソリューションを提供することもできます。各ウォレットには独自のAPIキーがあり、作成できるウォレットの数に制限はありません。資金を分割する機能は、LNbitsを資金管理ツールとして使用したり、開発ツールとして使用したりするための便利なツールです。拡張機能は、LNbitsに追加の機能を追加します。そのため、LNbitsは最先端の技術をネットワークLightningで試すことができます。拡張機能を開発するのは簡単で、無料でオープンソースのプロジェクトであるため、人々が自分で開発し、自分の貢献を送信することを奨励しています。",export_to_phone:"電話にエクスポート",export_to_phone_desc:"ウォレットを電話にエクスポートすると、ウォレットを削除する前にウォレットを復元できます。ウォレットを削除すると、ウォレットの秘密鍵が削除され、ウォレットを復元することはできません。",wallets:"ウォレット",add_wallet:"ウォレットを追加",delete_wallet:"ウォレットを削除",delete_wallet_desc:"ウォレットを削除すると、ウォレットの秘密鍵が削除され、ウォレットを復元することはできません。",rename_wallet:"ウォレットの名前を変更",update_name:"名前を更新",press_to_claim:"クレームするには押してください",donate:"寄付",voidwallet_active:"Voidwalletアクティブ",use_with_caution:"注意して使用してください",toggle_dark_mode:"ダークモードを切り替える",view_swagger_docs:"Swaggerドキュメントを表示",api_docs:"APIドキュメント",commit_version:"コミットバージョン",runs_on:"で実行",credit_hint:"クレジットカードを使用して資金を追加するには、LNbitsを使用してください。",credit_label:"クレジットカード",paste_request:"リクエストを貼り付ける",create_invoice:"請求書を作成する",camera_tooltip:"QRコードを読み取る",export_csv:"CSVでエクスポート",transactions:"トランザクション",chart_tooltip:"チャートを表示するには、グラフの上にカーソルを合わせます",pending:"保留中",copy_invoice:"請求書をコピー",close:"閉じる",cancel:"キャンセル",scan:"スキャン",read:"読む",pay:"支払う",memo:"メモ",date:"日付",processing_payment:"支払い処理中",not_enough_funds:"資金が不足しています",search_by_tag_memo_amount:"タグ、メモ、金額で検索",invoice_waiting:"請求書を待っています",payment_received:"お支払いありがとうございます",payment_sent:"支払いが完了しました",outgoing_payment_pending:"支払い保留中",drain_funds:"資金を排出する",drain_funds_desc:"ウォレットの残高をすべて他のウォレットに送金します",i_understand:"理解した",copy_wallet_url:"ウォレットURLをコピー",disclaimer_dialog:"ウォレットを削除すると、ウォレットの秘密鍵が削除され、ウォレットを復元することはできません。ウォレットを削除する前に、ウォレットをエクスポートしてください。",no_transactions:"トランザクションはありません",manage_extensions:"拡張機能を管理する",manage_server:"サーバーを管理する",extensions:"拡張機能",no_extensions:"拡張機能はありません",created:"作成済み",payment_hash:"支払いハッシュ",fee:"料金",amount:"量",description:"説明",expiry:"有効期限",webhook:"ウェブフック",payment_proof:"支払い証明"},Vue.use(VueI18n),window.LOCALE="en",window.i18n=new VueI18n({locale:window.LOCALE,fallbackLocale:window.LOCALE,messages:window.localisation}),window.EventHub=new Vue,window.LNbits={api:{request:function(t,e,n,i){return axios({method:t,url:e,headers:{"X-Api-Key":n},data:i})},createInvoice:async function(t,e,n,i="sat",r=null){return this.request("post","/api/v1/payments",t.inkey,{out:!1,amount:e,memo:n,unit:i,lnurl_callback:r})},payInvoice:function(t,e){return this.request("post","/api/v1/payments",t.adminkey,{out:!0,bolt11:e})},payLnurl:function(t,e,n,i,r="",o=""){return this.request("post","/api/v1/payments/lnurl",t.adminkey,{callback:e,description_hash:n,amount:i,comment:o,description:r})},authLnurl:function(t,e){return this.request("post","/api/v1/lnurlauth",t.adminkey,{callback:e})},getWallet:function(t){return this.request("get","/api/v1/wallet",t.inkey)},getPayments:function(t){return this.request("get","/api/v1/payments",t.inkey)},getPayment:function(t,e){return this.request("get","/api/v1/payments/"+e,t.inkey)}},events:{onInvoicePaid:function(t,e){let n=t=>{e(JSON.parse(t.data))};return this.listenersCount=this.listenersCount||{[t.inkey]:0},this.listenersCount[t.inkey]++,this.listeners=this.listeners||{},t.inkey in this.listeners||(this.listeners[t.inkey]=new EventSource("/api/v1/payments/sse?api-key="+t.inkey)),this.listeners[t.inkey].addEventListener("payment-received",n),()=>{this.listeners[t.inkey].removeEventListener("payment-received",n),this.listenersCount[t.inkey]--,this.listenersCount[t.inkey]<=0&&(this.listeners[t.inkey].close(),delete this.listeners[t.inkey])}}},href:{createWallet:function(t,e){window.location.href="/wallet?"+(e?"usr="+e+"&":"")+"nme="+t},updateWallet:function(t,e,n){window.location.href=`/wallet?usr=${e}&wal=${n}&nme=${t}`},deleteWallet:function(t,e){window.location.href="/deletewallet?usr="+e+"&wal="+t}},map:{extension:function(t){var e=_.object(["code","isValid","isAdminOnly","name","shortDescription","tile","contributors","hidden"],t);return e.url=["/",e.code,"/"].join(""),e},user:function(t){var e={id:t.id,admin:t.admin,email:t.email,extensions:t.extensions,wallets:t.wallets,admin:t.admin},n=this.wallet;return e.wallets=e.wallets.map((function(t){return n(t)})).sort((function(t,e){return t.name.localeCompare(e.name)})),e.walletOptions=e.wallets.map((function(t){return{label:[t.name," - ",t.id].join(""),value:t.id}})),e},wallet:function(t){return newWallet={id:t.id,name:t.name,adminkey:t.adminkey,inkey:t.inkey},newWallet.msat=t.balance_msat,newWallet.sat=Math.round(t.balance_msat/1e3),newWallet.fsat=new Intl.NumberFormat(window.LOCALE).format(newWallet.sat),newWallet.url=["/wallet?usr=",t.user,"&wal=",t.id].join(""),newWallet},payment:function(t){return obj={checking_id:t.id,pending:t.pending,amount:t.amount,fee:t.fee,memo:t.memo,time:t.time,bolt11:t.bolt11,preimage:t.preimage,payment_hash:t.payment_hash,expiry:t.expiry,extra:t.extra,wallet_id:t.wallet_id,webhook:t.webhook,webhook_status:t.webhook_status},obj.date=Quasar.utils.date.formatDate(new Date(1e3*obj.time),"YYYY-MM-DD HH:mm"),obj.dateFrom=moment(obj.date).fromNow(),obj.expirydate=Quasar.utils.date.formatDate(new Date(1e3*obj.expiry),"YYYY-MM-DD HH:mm"),obj.expirydateFrom=moment(obj.expirydate).fromNow(),obj.msat=obj.amount,obj.sat=obj.msat/1e3,obj.tag=obj.extra.tag,obj.fsat=new Intl.NumberFormat(window.LOCALE).format(obj.sat),obj.isIn=obj.amount>0,obj.isOut=obj.amount<0,obj.isPaid=!obj.pending,obj._q=[obj.memo,obj.sat].join(" ").toLowerCase(),obj}},utils:{confirmDialog:function(t){return Quasar.plugins.Dialog.create({message:t,ok:{flat:!0,color:"orange"},cancel:{flat:!0,color:"grey"}})},formatCurrency:function(t,e){return new Intl.NumberFormat(window.LOCALE,{style:"currency",currency:e}).format(t)},formatSat:function(t){return new Intl.NumberFormat(window.LOCALE).format(t)},notifyApiError:function(t){Quasar.plugins.Notify.create({timeout:5e3,type:{400:"warning",401:"warning",500:"negative"}[t.response.status]||"warning",message:t.response.data.message||t.response.data.detail||null,caption:[t.response.status," ",t.response.statusText].join("").toUpperCase()||null,icon:null})},search:function(t,e,n,i){try{var r=e.toLowerCase().split(i||" ");return t.filter((function(t){var e=0;return _.each(r,(function(i){-1!==t[n].indexOf(i)&&e++})),e===r.length}))}catch(e){return t}},exportCSV:function(t,e,n){var i=function(t,e){var n=void 0!==e?e(t):t;return`"${n=(n=null==n?"":String(n)).split('"').join('""')}"`},r=[t.map((function(t){return i(t.label)}))].concat(e.map((function(e){return t.map((function(t){return i("function"==typeof t.field?t.field(e):e[void 0===t.field?t.name:t.field],t.format)})).join(",")}))).join("\r\n");!0!==Quasar.utils.exportFile(`${n||"table-export"}.csv`,r,"text/csv")&&Quasar.plugins.Notify.create({message:"Browser denied file download...",color:"negative",icon:null})}}},window.windowMixin={i18n:window.i18n,data:function(){return{g:{offline:!navigator.onLine,visibleDrawer:!1,extensions:[],user:null,wallet:null,payments:[],allowedThemes:null}}},methods:{changeLanguage:function(t){window.i18n.locale=t,this.$q.localStorage.set("lnbits.lang",t)},changeColor:function(t){document.body.setAttribute("data-theme",t),this.$q.localStorage.set("lnbits.theme",t)},toggleDarkMode:function(){this.$q.dark.toggle(),this.$q.localStorage.set("lnbits.darkMode",this.$q.dark.isActive)},copyText:function(t,e,n){var i=this.$q.notify;Quasar.utils.copyToClipboard(t).then((function(){i({message:e||"Copied to clipboard!",position:n||"bottom"})}))}},created:function(){1==this.$q.localStorage.getItem("lnbits.darkMode")||0==this.$q.localStorage.getItem("lnbits.darkMode")?this.$q.dark.set(this.$q.localStorage.getItem("lnbits.darkMode")):this.$q.dark.set(!0),this.g.allowedThemes=window.allowedThemes??["bitcoin"];let t=this.$q.localStorage.getItem("lnbits.lang");if(t&&(window.LOCALE=t,window.i18n.locale=t),addEventListener("offline",(t=>{this.g.offline=!0})),addEventListener("online",(t=>{this.g.offline=!1})),this.$q.localStorage.getItem("lnbits.theme")||this.changeColor(this.g.allowedThemes[0]),this.$q.localStorage.getItem("lnbits.theme")&&!this.g.allowedThemes.includes(this.$q.localStorage.getItem("lnbits.theme"))&&this.changeColor(this.g.allowedThemes[0]),this.$q.localStorage.getItem("lnbits.theme")&&document.body.setAttribute("data-theme",this.$q.localStorage.getItem("lnbits.theme")),window.user&&(this.g.user=Object.freeze(window.LNbits.map.user(window.user))),window.wallet&&(this.g.wallet=Object.freeze(window.LNbits.map.wallet(window.wallet))),window.extensions){var e=this.g.user;const t=Object.freeze(window.extensions.map((function(t){return window.LNbits.map.extension(t)})).filter((function(t){return!t.hidden})).filter((function(t){return window.user.admin?t:!t.isAdminOnly})).map((function(t){return t.isEnabled=!!e&&-1!==e.extensions.indexOf(t.code),t})).sort((function(t,e){const n=t.name.toUpperCase(),i=e.name.toUpperCase();return n<i?-1:n>i?1:0})));this.g.extensions=t}}},window.decryptLnurlPayAES=function(t,e){let n=new Uint8Array(e.match(/[\da-f]{2}/gi).map((t=>parseInt(t,16))));return crypto.subtle.importKey("raw",n,{name:"AES-CBC",length:256},!1,["decrypt"]).then((e=>{let n=Uint8Array.from(window.atob(t.iv),(t=>t.charCodeAt(0))),i=Uint8Array.from(window.atob(t.ciphertext),(t=>t.charCodeAt(0)));return crypto.subtle.decrypt({name:"AES-CBC",iv:n},e,i)})).then((t=>new TextDecoder("utf-8").decode(t)))},Vue.component("lnbits-fsat",{props:{amount:{type:Number,default:0}},template:"<span>{{ fsat }}</span>",computed:{fsat:function(){return LNbits.utils.formatSat(this.amount)}}}),Vue.component("lnbits-wallet-list",{data:function(){return{user:null,activeWallet:null,activeBalance:[],showForm:!1,walletName:"",LNBITS_DENOMINATION:LNBITS_DENOMINATION}},template:'\n    <q-list v-if="user && user.wallets.length" dense class="lnbits-drawer__q-list">\n      <q-item-label header v-text="$t(\'wallets\')"></q-item-label>\n      <q-item v-for="wallet in wallets" :key="wallet.id"\n        clickable\n        :active="activeWallet && activeWallet.id === wallet.id"\n        tag="a" :href="wallet.url">\n        <q-item-section side>\n          <q-avatar size="md"\n            :color="(activeWallet && activeWallet.id === wallet.id)\n              ? (($q.dark.isActive) ? \'primary\' : \'primary\')\n              : \'grey-5\'">\n            <q-icon name="flash_on" :size="($q.dark.isActive) ? \'21px\' : \'20px\'"\n              :color="($q.dark.isActive) ? \'blue-grey-10\' : \'grey-3\'"></q-icon>\n          </q-avatar>\n        </q-item-section>\n        <q-item-section>\n          <q-item-label lines="1">{{ wallet.name }}</q-item-label>\n          <q-item-label v-if="LNBITS_DENOMINATION != \'sats\'" caption>{{ parseFloat(String(wallet.live_fsat).replaceAll(",", "")) / 100  }} {{ LNBITS_DENOMINATION }}</q-item-label>\n          <q-item-label v-else caption>{{ wallet.live_fsat }} {{ LNBITS_DENOMINATION }}</q-item-label>\n        </q-item-section>\n        <q-item-section side v-show="activeWallet && activeWallet.id === wallet.id">\n          <q-icon name="chevron_right" color="grey-5" size="md"></q-icon>\n        </q-item-section>\n      </q-item>\n      <q-item clickable @click="showForm = !showForm">\n        <q-item-section side>\n          <q-icon :name="(showForm) ? \'remove\' : \'add\'" color="grey-5" size="md"></q-icon>\n        </q-item-section>\n        <q-item-section>\n          <q-item-label lines="1" class="text-caption" v-text="$t(\'add_wallet\')"></q-item-label>\n        </q-item-section>\n      </q-item>\n      <q-item v-if="showForm">\n        <q-item-section>\n          <q-form @submit="createWallet">\n            <q-input filled dense v-model="walletName" label="Name wallet *">\n              <template v-slot:append>\n                <q-btn round dense flat icon="send" size="sm" @click="createWallet" :disable="walletName === \'\'"></q-btn>\n              </template>\n            </q-input>\n          </q-form>\n        </q-item-section>\n      </q-item>\n    </q-list>\n  ',computed:{wallets:function(){var t=this.activeBalance;return this.user.wallets.map((function(e){return e.live_fsat=t.length&&t[0]===e.id?LNbits.utils.formatSat(t[1]):e.fsat,e}))}},methods:{createWallet:function(){LNbits.href.createWallet(this.walletName,this.user.id)},updateWalletBalance:function(t){this.activeBalance=t}},created:function(){window.user&&(this.user=LNbits.map.user(window.user)),window.wallet&&(this.activeWallet=LNbits.map.wallet(window.wallet)),EventHub.$on("update-wallet-balance",this.updateWalletBalance)}}),Vue.component("lnbits-extension-list",{data:function(){return{extensions:[],user:null}},template:'\n    <q-list v-if="user" dense class="lnbits-drawer__q-list">\n      <q-item-label header v-text="$t(\'extensions\')"></q-item-label>\n      <q-item v-for="extension in userExtensions" :key="extension.code"\n        clickable\n        :active="extension.isActive"\n        tag="a" :href="[extension.url, \'?usr=\', user.id].join(\'\')">\n        <q-item-section side>\n          <q-avatar size="md">\n            <q-img\n              :src="extension.tile"\n              style="max-width:20px"\n            ></q-img>\n          </q-avatar>\n        </q-item-section>\n        <q-item-section>\n          <q-item-label lines="1">{{ extension.name }} </q-item-label>\n        </q-item-section>\n        <q-item-section side v-show="extension.isActive">\n          <q-icon name="chevron_right" color="grey-5" size="md"></q-icon>\n        </q-item-section>\n      </q-item>\n      <q-item clickable tag="a" :href="[\'/extensions?usr=\', user.id].join(\'\')">\n        <q-item-section side>\n          <q-icon name="clear_all" color="grey-5" size="md"></q-icon>\n        </q-item-section>\n        <q-item-section>\n          <q-item-label lines="1" class="text-caption" v-text="$t(\'extensions\')"></q-item-label>\n        </q-item-section>\n      </q-item>\n      <q-item clickable tag="a" :href="[\'/install?usr=\', user.id].join(\'\')">\n        <q-item-section side>\n          <q-icon name="playlist_add" color="grey-5" size="md"></q-icon>\n        </q-item-section>\n        <q-item-section>\n          <q-item-label lines="1" class="text-caption" v-text="$t(\'manage_extensions\')"></q-item-label>\n        </q-item-section>\n      </q-item>\n    </q-list>\n  ',computed:{userExtensions:function(){if(!this.user)return[];var t=window.location.pathname,e=this.user.extensions;return this.extensions.filter((function(t){return-1!==e.indexOf(t.code)})).map((function(e){return e.isActive=t.startsWith(e.url),e}))}},created:function(){window.extensions&&(this.extensions=window.extensions.map((function(t){return LNbits.map.extension(t)})).sort((function(t,e){return t.name.localeCompare(e.name)}))),window.user&&(this.user=LNbits.map.user(window.user))}}),Vue.component("lnbits-admin-ui",{data:function(){return{extensions:[],user:null}},template:'\n    <q-list v-if="user && user.admin" dense class="lnbits-drawer__q-list">\n      <q-item-label header>Admin</q-item-label>\n      <q-item clickable tag="a" :href="[\'/admin?usr=\', user.id].join(\'\')">\n        <q-item-section side>\n          <q-icon name="admin_panel_settings" color="grey-5" size="md"></q-icon>\n        </q-item-section>\n        <q-item-section>\n          <q-item-label lines="1" class="text-caption" v-text="$t(\'manage_server\')"></q-item-label>\n        </q-item-section>\n      </q-item>\n    </q-list>\n  ',created:function(){window.user&&(this.user=LNbits.map.user(window.user))}}),Vue.component("lnbits-payment-details",{props:["payment"],mixins:[windowMixin],data:function(){return{LNBITS_DENOMINATION:LNBITS_DENOMINATION}},template:'\n    <div class="q-py-md" style="text-align: left">\n      <div class="row justify-center q-mb-md">\n        <q-badge v-if="hasTag" color="yellow" text-color="black">\n          #{{ payment.tag }}\n        </q-badge>\n      </div>\n      <div class="row">\n        <div class="col-3"><b v-text="$t(\'created\')"></b>:</div>\n        <div class="col-9">{{ payment.date }} ({{ payment.dateFrom }})</div>\n      </div>\n      <div class="row">\n        <div class="col-3"><b v-text="$t(\'expiry\')"></b>:</div>\n        <div class="col-9">{{ payment.expirydate }} ({{ payment.expirydateFrom }})</div>\n      </div>\n      <div class="row">\n        <div class="col-3"><b v-text="$t(\'description\')"></b>:</div>\n        <div class="col-9">{{ payment.memo }}</div>\n      </div>\n      <div class="row">\n        <div class="col-3"><b v-text="$t(\'amount\')"></b>:</div>\n        <div class="col-9">{{ (payment.amount / 1000).toFixed(3) }} {{LNBITS_DENOMINATION}}</div>\n      </div>\n      <div class="row">\n        <div class="col-3"><b v-text="$t(\'fee\')"></b>:</div>\n        <div class="col-9">{{ (payment.fee / 1000).toFixed(3) }} {{LNBITS_DENOMINATION}}</div>\n      </div>\n      <div class="row">\n        <div class="col-3"><b v-text="$t(\'payment_hash\')"></b>:</div>\n        <div class="col-9 text-wrap mono">\n            {{ payment.payment_hash }}\n            <q-icon name="content_copy" @click="copyText(payment.payment_hash)" size="1em" color="grey" class="q-mb-xs cursor-pointer" />\n      </div>\n      </div>\n      <div class="row" v-if="payment.webhook">\n        <div class="col-3"><b v-text="$t(\'webhook\')"></b>:</div>\n        <div class="col-9 text-wrap mono">\n          {{ payment.webhook }}\n          <q-badge :color="webhookStatusColor" text-color="white">\n            {{ webhookStatusText }}\n          </q-badge>\n        </div>\n      </div>\n      <div class="row" v-if="hasPreimage">\n        <div class="col-3"><b v-text="$t(\'payment_proof\')"></b>:</div>\n        <div class="col-9 text-wrap mono">{{ payment.preimage }}</div>\n      </div>\n      <div class="row" v-for="entry in extras">\n        <div class="col-3">\n          <q-badge v-if="hasTag" color="secondary" text-color="white">\n            extra\n          </q-badge>\n          <b>{{ entry.key }}</b>:\n        </div>\n        <div class="col-9 text-wrap mono">{{ entry.value }}</div>\n      </div>\n      <div class="row" v-if="hasSuccessAction">\n        <div class="col-3"><b>Success action</b>:</div>\n        <div class="col-9">\n          <lnbits-lnurlpay-success-action\n            :payment="payment"\n            :success_action="payment.extra.success_action"\n          ></lnbits-lnurlpay-success-action>\n        </div>\n      </div>\n    </div>\n  ',computed:{hasPreimage(){return this.payment.preimage&&"0000000000000000000000000000000000000000000000000000000000000000"!==this.payment.preimage},hasSuccessAction(){return this.hasPreimage&&this.payment.extra&&this.payment.extra.success_action},webhookStatusColor(){return this.payment.webhook_status>=300||this.payment.webhook_status<0?"red-10":this.payment.webhook_status?"green-10":"cyan-7"},webhookStatusText(){return this.payment.webhook_status?this.payment.webhook_status:"not sent yet"},hasTag(){return this.payment.extra&&!!this.payment.extra.tag},extras(){if(!this.payment.extra)return[];let t=_.omit(this.payment.extra,["tag","success_action"]);return Object.keys(t).map((e=>({key:e,value:t[e]})))}}}),Vue.component("lnbits-lnurlpay-success-action",{props:["payment","success_action"],data(){return{decryptedValue:this.success_action.ciphertext}},template:'\n    <div>\n      <p class="q-mb-sm">{{ success_action.message || success_action.description }}</p>\n      <code v-if="decryptedValue" class="text-h6 q-mt-sm q-mb-none">\n        {{ decryptedValue }}\n      </code>\n      <p v-else-if="success_action.url" class="text-h6 q-mt-sm q-mb-none">\n        <a target="_blank" style="color: inherit;" :href="success_action.url">{{ success_action.url }}</a>\n      </p>\n    </div>\n  ',mounted:function(){if("aes"!==this.success_action.tag)return null;decryptLnurlPayAES(this.success_action,this.payment.preimage).then((t=>{this.decryptedValue=t}))}});const bech32CharValues="qpzry9x8gf2tvdw0s3jn54khce6mua7l";function byteArrayToInt(t){let e=0;for(let n=0;n<t.length;++n)e=(e<<8)+t[n];return e}function bech32ToInt(t){let e=0;for(let n=0;n<t.length;n++)e*=32,e+=bech32CharValues.indexOf(t.charAt(n));return e}function bech32ToFiveBitArray(t){let e=[];for(let n=0;n<t.length;n++)e.push(bech32CharValues.indexOf(t.charAt(n)));return e}function fiveBitArrayTo8BitArray(t,e){let n=0,i=0,r=[];return t.forEach((t=>{i=(i<<5)+t,n+=5,n>=8&&(r.push(i>>n-8&255),n-=8)})),e&&n>0&&r.push(i<<8-n&255),r}function bech32ToUTF8String(t){let e=fiveBitArrayTo8BitArray(bech32ToFiveBitArray(t)),n="";for(let t=0;t<e.length;t++)n+="%"+("0"+e[t].toString(16)).slice(-2);return decodeURIComponent(n)}function byteArrayToHexString(t){return Array.prototype.map.call(t,(function(t){return("0"+(255&t).toString(16)).slice(-2)})).join("")}function textToHexString(t){let e="";for(let n=0;n<t.length;n++)e+=t.charCodeAt(n).toString(16);return e}function epochToDate(t){return new Date(1e3*t).toUTCString()}function isEmptyOrSpaces(t){return null===t||null!==t.match(/^ *$/)}function toFixed(t){var e;Math.abs(t)<1?(e=parseInt(t.toString().split("e-")[1]))&&(t*=Math.pow(10,e-1),t="0."+new Array(e).join("0")+t.toString().substring(2)):(e=parseInt(t.toString().split("+")[1]))>20&&(e-=20,t/=Math.pow(10,e),t+=new Array(e+1).join("0"));return t}
